var NS = Object.defineProperty;
var LS = (r, e, t) => e in r ? NS(r, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : r[e] = t;
var t0 = (r, e, t) => (LS(r, typeof e != "symbol" ? e + "" : e, t), t);
var RtmEventType;
(function(r) {
  r.READY = "READY", r.LOGGED_IN = "LOGGED_IN", r.LOGGED_OUT = "LOGGED_OUT", r.JOINED_CHANNEL = "JOINED_CHANNEL", r.LEFT_CHANNEL = "LEFT_CHANNEL", r.REJECT_SENDING_MESSAGE = "REJECT_SENDING_MESSAGE", r.SENDER_LIMIT = "SENDER_LIMIT", r.UPDATE_REMAINING_MUTED_TIME = "UPDATE_REMAINING_MUTED_TIME", r.UPDATE_TEXT_MESSAGES = "UPDATE_TEXT_MESSAGES", r.NEW_MESSAGE = "NEW_MESSAGE", r.SENT_MESSAGE = "SENT_MESSAGE";
})(RtmEventType || (RtmEventType = {}));
var RtmClientEventType;
(function(r) {
  r.ConnectionStateChanged = "ConnectionStateChanged", r.MessageFromPeer = "MessageFromPeer";
})(RtmClientEventType || (RtmClientEventType = {}));
var RtmChannelEventType;
(function(r) {
  r.ChannelMessage = "ChannelMessage";
})(RtmChannelEventType || (RtmChannelEventType = {}));
class EventEmitter {
  constructor() {
    t0(this, "listeners", {});
  }
  on(e, t) {
    return this.listeners[e] = this.listeners[e] || [], this.listeners[e].push(t), this;
  }
  emit(e, ...t) {
    var a;
    (a = this.listeners[e]) == null || a.forEach((n) => n(...t));
  }
  off(e, t) {
    return this.listeners[e] = this.listeners[e] || [], this.listeners[e] = this.listeners[e].filter((a) => a !== t), this;
  }
  removeAllListeners() {
    for (let e in this.listeners)
      delete this.listeners[e];
    this.listeners = {};
  }
}
const RTM_MESSAGE_TYPES = {
  MESSAGE: 1,
  LIKE: 3,
  USER_LEFT: 101,
  USER_JOIN: 100,
  STATISTICS: 2
}, RTM_CHANNEL_CONFIGS = {
  CHANNEL_EVENTS: [
    "ChannelMessage"
  ],
  USE_WORKER: !0
}, RTM_CLIENT_EVENTS = [
  "MessageFromPeer",
  "ConnectionStateChanged"
], DEFAULT_LIMIT_SENDER = {
  RANGE_TIME: 10,
  MAXIMUM_MESSAGES: 6,
  MUTE_TIME: 180
}, LIMIT_SENDER = {
  applyLimit: !1,
  rangeTime: DEFAULT_LIMIT_SENDER.RANGE_TIME,
  maximumMessages: DEFAULT_LIMIT_SENDER.MAXIMUM_MESSAGES,
  muteTime: DEFAULT_LIMIT_SENDER.MUTE_TIME,
  limitOnMessageTypes: [RTM_MESSAGE_TYPES.MESSAGE]
}, RTM_DEFAULT_CONFIGS = {
  useShouldReceiveMessage: !1,
  messageProp: "camel",
  addToTextMessages: [RTM_MESSAGE_TYPES.USER_JOIN],
  pushMessageToMainThread: [RTM_MESSAGE_TYPES.LIKE],
  allowRandomColor: !1,
  allowGuestJoinedMessage: !1,
  messageTypeKey: "messageType"
}, LIMIT_CHAT_CONFIGS = {
  waitingTime: 5,
  capTargetMessages: 50,
  thresholdSeconds: -1,
  intervalLimit: 1,
  maximumMessages: 100,
  isApplyLimit: !1
}, TYPE_WORKERS = {
  STATISTICS: 910,
  INITIAL_WORKER: 911,
  UPDATE_DATA_CONFIGS: 912,
  RECEIVED_NEW_MESSAGE: 913,
  NEW_CHANNEL_MESSAGES: 914,
  SENT_NEW_MESSAGE: 925,
  UPDATE_USER: 931,
  UPDATE_LIST_MESSAGES: 9998
}, REGEXS = {
  ANY_URL: /(((https?:(\/\/)?(www\.)?([a-zA-Z0-9\-]+?\.)?)([a-zA-Z0-9\-]+?)\.([a-zA-Z]+))(\/[A-Za-z0-9\-\._~:\/\?#\[\]@!$&'\(\)\*\+,;\=]*)?)/gi
};
var commonjsGlobal = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function getDefaultExportFromCjs(r) {
  return r && r.__esModule && Object.prototype.hasOwnProperty.call(r, "default") ? r.default : r;
}
function getAugmentedNamespace(r) {
  var e = r.default;
  if (typeof e == "function") {
    var t = function() {
      return e.apply(this, arguments);
    };
    t.prototype = e.prototype;
  } else
    t = {};
  return Object.defineProperty(t, "__esModule", { value: !0 }), Object.keys(r).forEach(function(a) {
    var n = Object.getOwnPropertyDescriptor(r, a);
    Object.defineProperty(t, a, n.get ? n : {
      enumerable: !0,
      get: function() {
        return r[a];
      }
    });
  }), t;
}
var agoraRtmSdk = { exports: {} };
/*
 @preserve
 AgoraRTM Web SDK 1.5.0 - commit: v1.5.0-0-g83bd874d
 Copyright (C) 2018-2022 Agora Lab.
 This file is licensed under the AGORA, INC. SDK LICENSE AGREEMENT
 A copy of this license may be found at https://www.agora.io/en/sdk-license-agreement/
*/
(function(module, exports) {
  (function(r, e) {
    module.exports = e();
  })(commonjsGlobal, function() {
    function ze(r, e) {
      var t = Object.keys(r);
      if (Object.getOwnPropertySymbols) {
        var a = Object.getOwnPropertySymbols(r);
        e && (a = a.filter(function(n) {
          return Object.getOwnPropertyDescriptor(r, n).enumerable;
        })), t.push.apply(t, a);
      }
      return t;
    }
    function jb(r) {
      for (var e = 1; e < arguments.length; e++) {
        var t = arguments[e] != null ? arguments[e] : {};
        e % 2 ? ze(Object(t), !0).forEach(function(a) {
          x(r, a, t[a]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(r, Object.getOwnPropertyDescriptors(t)) : ze(Object(t)).forEach(function(a) {
          Object.defineProperty(r, a, Object.getOwnPropertyDescriptor(t, a));
        });
      }
      return r;
    }
    function oa(r) {
      return (oa = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e) {
        return typeof e;
      } : function(e) {
        return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
      })(r);
    }
    function rm(r, e, t, a, n, s, o) {
      try {
        var u = r[s](o), l = u.value;
      } catch (f) {
        return void t(f);
      }
      u.done ? e(l) : Promise.resolve(l).then(a, n);
    }
    function ja(r) {
      return function() {
        var e = this, t = arguments;
        return new Promise(function(a, n) {
          function s(l) {
            rm(u, a, n, s, o, "next", l);
          }
          function o(l) {
            rm(u, a, n, s, o, "throw", l);
          }
          var u = r.apply(e, t);
          s(void 0);
        });
      };
    }
    function ua(r, e) {
      if (!(r instanceof e))
        throw new TypeError("Cannot call a class as a function");
    }
    function sm(r, e) {
      for (var t = 0; t < e.length; t++) {
        var a = e[t];
        a.enumerable = a.enumerable || !1, a.configurable = !0, "value" in a && (a.writable = !0), Object.defineProperty(r, a.key, a);
      }
    }
    function cb(r, e, t) {
      return e && sm(r.prototype, e), t && sm(r, t), r;
    }
    function x(r, e, t) {
      return e in r ? Object.defineProperty(r, e, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : r[e] = t, r;
    }
    function Ga(r, e) {
      if (typeof e != "function" && e !== null)
        throw new TypeError("Super expression must either be null or a function");
      r.prototype = Object.create(e && e.prototype, { constructor: { value: r, writable: !0, configurable: !0 } }), e && Hf(r, e);
    }
    function Sd(r) {
      return (Sd = Object.setPrototypeOf ? Object.getPrototypeOf : function(e) {
        return e.__proto__ || Object.getPrototypeOf(e);
      })(r);
    }
    function Hf(r, e) {
      return (Hf = Object.setPrototypeOf || function(t, a) {
        return t.__proto__ = a, t;
      })(r, e);
    }
    function tm() {
      if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
        return !1;
      if (typeof Proxy == "function")
        return !0;
      try {
        return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        })), !0;
      } catch {
        return !1;
      }
    }
    function Di(r, e, t) {
      return (Di = tm() ? Reflect.construct : function(a, n, s) {
        var o = [null];
        return o.push.apply(o, n), a = new (Function.bind.apply(a, o))(), s && Hf(a, s.prototype), a;
      }).apply(null, arguments);
    }
    function If(r) {
      var e = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
      return (If = function(t) {
        function a() {
          return Di(t, arguments, Sd(this).constructor);
        }
        if (t === null || Function.toString.call(t).indexOf("[native code]") === -1)
          return t;
        if (typeof t != "function")
          throw new TypeError("Super expression must either be null or a function");
        if (e !== void 0) {
          if (e.has(t))
            return e.get(t);
          e.set(t, a);
        }
        return a.prototype = Object.create(t.prototype, { constructor: { value: a, enumerable: !1, writable: !0, configurable: !0 } }), Hf(a, t);
      })(r);
    }
    function Ei(r, e) {
      if (r == null)
        return {};
      if (r == null)
        var t = {};
      else {
        t = {};
        var a, n = Object.keys(r);
        for (a = 0; a < n.length; a++) {
          var s = n[a];
          0 <= e.indexOf(s) || (t[s] = r[s]);
        }
      }
      if (Object.getOwnPropertySymbols)
        for (a = Object.getOwnPropertySymbols(r), s = 0; s < a.length; s++)
          n = a[s], 0 <= e.indexOf(n) || Object.prototype.propertyIsEnumerable.call(r, n) && (t[n] = r[n]);
      return t;
    }
    function z(r) {
      if (r === void 0)
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      return r;
    }
    function Ha(r) {
      var e = tm();
      return function() {
        var t = Sd(r);
        if (e) {
          var a = Sd(this).constructor;
          t = Reflect.construct(t, arguments, a);
        } else
          t = t.apply(this, arguments);
        return t = !t || typeof t != "object" && typeof t != "function" ? z(this) : t;
      };
    }
    function Fi(r, e, t) {
      return (Fi = typeof Reflect < "u" && Reflect.get ? Reflect.get : function(a, n, s) {
        for (; !Object.prototype.hasOwnProperty.call(a, n) && (a = Sd(a)) !== null; )
          ;
        if (a)
          return (n = Object.getOwnPropertyDescriptor(a, n)).get ? n.get.call(s) : n.value;
      })(r, e, t || r);
    }
    function Xa(r, e) {
      var t = Array.isArray(r) ? r : void 0;
      if (!t)
        if ((t = r && (typeof Symbol < "u" && r[Symbol.iterator] || r["@@iterator"])) == null)
          t = void 0;
        else {
          var a, n = [], s = !0, o = !1;
          try {
            for (t = t.call(r); !(s = (a = t.next()).done) && (n.push(a.value), !e || n.length !== e); s = !0)
              ;
          } catch (l) {
            o = !0;
            var u = l;
          } finally {
            try {
              s || t.return == null || t.return();
            } finally {
              if (o)
                throw u;
            }
          }
          t = n;
        }
      if (!(r = t || um(r, e)))
        throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      return r;
    }
    function W(r) {
      var e = Array.isArray(r) ? Gi(r) : void 0;
      if (e || (e = typeof Symbol < "u" && r[Symbol.iterator] != null || r["@@iterator"] != null ? Array.from(r) : void 0), !(r = e || um(r)))
        throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
      return r;
    }
    function um(r, e) {
      if (r) {
        if (typeof r == "string")
          return Gi(r, e);
        var t = Object.prototype.toString.call(r).slice(8, -1);
        if (t === "Object" && r.constructor && (t = r.constructor.name), t === "Map" || t === "Set")
          return Array.from(r);
        if (t === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))
          return Gi(r, e);
      }
    }
    function Gi(r, e) {
      (e == null || e > r.length) && (e = r.length);
      for (var t = 0, a = Array(e); t < e; t++)
        a[t] = r[t];
      return a;
    }
    function Ca(r, e, t, a, n) {
      var s = {};
      return Object.keys(a).forEach(function(o) {
        s[o] = a[o];
      }), s.enumerable = !!s.enumerable, s.configurable = !!s.configurable, ("value" in s || s.initializer) && (s.writable = !0), s = t.slice().reverse().reduce(function(o, u) {
        return u(r, e, o) || o;
      }, s), n && s.initializer !== void 0 && (s.value = s.initializer ? s.initializer.call(n) : void 0, s.initializer = void 0), s.initializer === void 0 && (Object.defineProperty(r, e, s), s = null), s;
    }
    function tb(r) {
      var e = { exports: {} };
      return r(e, e.exports), e.exports;
    }
    function Ae(r) {
      r || (r = {});
      var e = r.ua;
      if (e || typeof navigator > "u" || (e = navigator.userAgent), e && e.headers && typeof e.headers["user-agent"] == "string" && (e = e.headers["user-agent"]), typeof e != "string")
        return !1;
      var t = Rt.test(e) && !St.test(e) || !!r.tablet && Tt.test(e);
      return !t && r.tablet && r.featureDetect && navigator && 1 < navigator.maxTouchPoints && e.indexOf("Macintosh") !== -1 && e.indexOf("Safari") !== -1 && (t = !0), t;
    }
    function vm(r, e) {
      var t, a = 3 > arguments.length ? r : arguments[2];
      return Ia(r) === a ? r[e] : (t = Zb.f(r, e)) ? ha(t, "value") ? t.value : t.get === void 0 ? void 0 : t.get.call(a) : va(t = nc(r)) ? vm(t, e, a) : void 0;
    }
    function Ut(r) {
      var e = r.charCodeAt(0) << 24, t = 0 | Vt(~e), a = 0, n = 0 | r.length, s = "";
      if (5 > t && n >= t) {
        for (e = e << t >>> 24 + t, a = 1; a < t; a = a + 1 | 0)
          e = e << 6 | 63 & r.charCodeAt(a);
        65535 >= e ? s += Td(e) : 1114111 >= e ? s += Td(55296 + ((e = e - 65536 | 0) >> 10) | 0, 56320 + (1023 & e) | 0) : a = 0;
      }
      for (; a < n; a = a + 1 | 0)
        s += "\uFFFD";
      return s;
    }
    function wm() {
    }
    function Wt(r) {
      var e = 0 | r.charCodeAt(0);
      if (55296 <= e && 56319 >= e) {
        var t = 0 | r.charCodeAt(1);
        if (!(t == t && 56320 <= t && 57343 >= t))
          return Td(239, 191, 189);
        if (65535 < (e = (e - 55296 << 10) + t - 56320 + 65536 | 0))
          return Td(240 | e >>> 18, 128 | e >>> 12 & 63, 128 | e >>> 6 & 63, 128 | 63 & e);
      }
      return 127 >= e ? r : 2047 >= e ? Td(192 | e >>> 6, 128 | 63 & e) : Td(224 | e >>> 12, 128 | e >>> 6 & 63, 128 | 63 & e);
    }
    function xm() {
    }
    function ya() {
      ya.init.call(this);
    }
    function Ug(r) {
      if (typeof r != "function")
        throw new TypeError('The "listener" argument must be of type Function. Received type ' + oa(r));
    }
    function ym(r, e, t, a) {
      Ug(t);
      var n = r._events;
      if (n === void 0)
        n = r._events = /* @__PURE__ */ Object.create(null), r._eventsCount = 0;
      else {
        n.newListener !== void 0 && (r.emit("newListener", e, t.listener ? t.listener : t), n = r._events);
        var s = n[e];
      }
      return s === void 0 ? (n[e] = t, ++r._eventsCount) : (typeof s == "function" ? s = n[e] = a ? [t, s] : [s, t] : a ? s.unshift(t) : s.push(t), 0 < (t = r._maxListeners === void 0 ? ya.defaultMaxListeners : r._maxListeners) && s.length > t && !s.warned && (s.warned = !0, (t = Error("Possible EventEmitter memory leak detected. " + s.length + " " + String(e) + " listeners added. Use emitter.setMaxListeners() to increase limit")).name = "MaxListenersExceededWarning", t.emitter = r, t.type = e, t.count = s.length, console && console.warn && console.warn(t))), r;
    }
    function Xt() {
      if (!this.fired)
        return this.target.removeListener(this.type, this.wrapFn), this.fired = !0, arguments.length === 0 ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
    }
    function zm(r, e, t) {
      return r = { fired: !1, wrapFn: void 0, target: r, type: e, listener: t }, (e = Xt.bind(r)).listener = t, r.wrapFn = e;
    }
    function Am(r, e, t) {
      if ((r = r._events) === void 0)
        return [];
      if ((e = r[e]) === void 0)
        return [];
      if (typeof e == "function")
        return t ? [e.listener || e] : [e];
      if (t)
        for (t = Array(e.length), r = 0; r < t.length; ++r)
          t[r] = e[r].listener || e[r];
      else
        t = Bm(e, e.length);
      return t;
    }
    function Cm(r) {
      var e = this._events;
      if (e !== void 0) {
        if (typeof (r = e[r]) == "function")
          return 1;
        if (r !== void 0)
          return r.length;
      }
      return 0;
    }
    function Bm(r, e) {
      for (var t = Array(e), a = 0; a < e; ++a)
        t[a] = r[a];
      return t;
    }
    function Yt(r, e, t) {
      typeof r.on == "function" && Dm(r, "error", e, t);
    }
    function Dm(r, e, t, a) {
      if (typeof r.on == "function")
        a.once ? r.once(e, t) : r.on(e, t);
      else {
        if (typeof r.addEventListener != "function")
          throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type ' + oa(r));
        r.addEventListener(e, function n(s) {
          a.once && r.removeEventListener(e, n), t(s);
        });
      }
    }
    function Zt(r) {
      return r ? W(r) : $t(function() {
        return [];
      }, function(e, t) {
        return e.push(t), e;
      });
    }
    function Em(r, e) {
      var t, a, n, s;
      return M.wrap(function(o) {
        for (; ; )
          switch (o.prev = o.next) {
            case 0:
              t = Fm(r)([Gm, Gm, function(u, l) {
                return l;
              }])[2], a = 0;
            case 2:
              if (!(a < e.length)) {
                o.next = 17;
                break;
              }
              if (n = e[a], !((s = t(Hi, n)) instanceof Vg)) {
                o.next = 11;
                break;
              }
              if ((s = Ii(s.deref())) === Hi) {
                o.next = 10;
                break;
              }
              return o.next = 10, s;
            case 10:
              return o.abrupt("return");
            case 11:
              if (s === Hi) {
                o.next = 14;
                break;
              }
              return o.next = 14, s;
            case 14:
              a++, o.next = 2;
              break;
            case 17:
            case "end":
              return o.stop();
          }
      }, au);
    }
    function Wg(r, e) {
      return e != null && typeof e[Symbol.iterator] == "function" ? Em(Wg(r), e) : function(t) {
        var a = t[2];
        return bu(t, function(n, s) {
          return a(n, r(s));
        });
      };
    }
    function Xc(r) {
      return Object.prototype.toString.call(r).slice(8, -1);
    }
    function Be(r) {
      return Xc(r) === "Object" && r.constructor === Object && Object.getPrototypeOf(r) === Object.prototype;
    }
    function Hm(r) {
      var e;
      return (e = Xc(r) === "Boolean" || Xc(r) === "Null" || Xc(r) === "Undefined") || (e = Xc(r) === "Number" && !isNaN(r)), e || Xc(r) === "String" || Xc(r) === "Symbol";
    }
    function Ud(r) {
      var e = -1, t = r == null ? 0 : r.length;
      for (this.clear(); ++e < t; ) {
        var a = r[e];
        this.set(a[0], a[1]);
      }
    }
    function Ce(r) {
      var e = -1, t = r == null ? 0 : r.length;
      for (this.clear(); ++e < t; ) {
        var a = r[e];
        this.set(a[0], a[1]);
      }
    }
    function De(r) {
      var e = -1, t = r == null ? 0 : r.length;
      for (this.clear(); ++e < t; ) {
        var a = r[e];
        this.set(a[0], a[1]);
      }
    }
    function Jf(r) {
      var e = -1, t = r == null ? 0 : r.length;
      for (this.__data__ = new Xg(); ++e < t; )
        this.add(r[e]);
    }
    function Ee(r) {
      this.size = (this.__data__ = new Yg(r)).size;
    }
    function Fe(r, e, t, a, n, s) {
      var o, u = 1 & e, l = 2 & e, f = 4 & e;
      if (t && (o = n ? t(r, a, n, s) : t(r)), o !== void 0)
        return o;
      if (!Db(r))
        return r;
      if (a = pb(r)) {
        if (o = cu(r), !u)
          return Ji(r, o);
      } else {
        var d = Kf(r), h = d == "[object Function]" || d == "[object GeneratorFunction]";
        if (Lf(r))
          return Im(r, u);
        if (d == "[object Object]" || d == "[object Arguments]" || h && !n) {
          if (o = l || h ? {} : Jm(r), !u)
            return l ? du(r, eu(o, r)) : fu(r, gu(o, r));
        } else {
          if (!Na[d])
            return n ? r : {};
          o = hu(r, d, u);
        }
      }
      if (s || (s = new Ge()), n = s.get(r))
        return n;
      s.set(r, o), iu(r) ? r.forEach(function(m) {
        o.add(Fe(m, e, t, m, r, s));
      }) : ju(r) && r.forEach(function(m, _) {
        o.set(_, Fe(m, e, t, _, r, s));
      }), l = f ? l ? Km : Ki : l ? Mf : Vd;
      var p = a ? void 0 : l(r);
      return ku(p || r, function(m, _) {
        p && (m = r[_ = m]), Lm(o, _, Fe(m, e, t, _, r, s));
      }), o;
    }
    function Li(r, e) {
      if (typeof r != "function" || e != null && typeof e != "function")
        throw new TypeError("Expected a function");
      var t = function a() {
        var n = arguments, s = e ? e.apply(this, n) : n[0], o = a.cache;
        return o.has(s) ? o.get(s) : (n = r.apply(this, n), a.cache = o.set(s, n) || o, n);
      };
      return t.cache = new (Li.Cache || Xg)(), t;
    }
    function Mm(r) {
      if (typeof r == "string")
        return r;
      if (pb(r))
        return He(r, Mm) + "";
      if (Ie(r))
        return Nm ? Nm.call(r) : "";
      var e = r + "";
      return e == "0" && 1 / r == -lu ? "-0" : e;
    }
    function Mi(r, e, t, a, n) {
      var s = -1, o = r.length;
      for (t || (t = mu), n || (n = []); ++s < o; ) {
        var u = r[s];
        0 < e && t(u) ? 1 < e ? Mi(u, e - 1, t, a, n) : Ni(n, u) : a || (n[n.length] = u);
      }
      return n;
    }
    function Je(r, e, t, a, n) {
      if (r === e)
        e = !0;
      else if (r == null || e == null || !Bc(r) && !Bc(e))
        e = r != r && e != e;
      else
        e: {
          var s = pb(r), o = pb(e), u = s ? "[object Array]" : Kf(r), l = o ? "[object Array]" : Kf(e), f = (u = u == "[object Arguments]" ? "[object Object]" : u) == "[object Object]";
          if (o = (l = l == "[object Arguments]" ? "[object Object]" : l) == "[object Object]", (l = u == l) && Lf(r)) {
            if (!Lf(e)) {
              e = !1;
              break e;
            }
            s = !0, f = !1;
          }
          if (l && !f)
            n || (n = new Ge()), e = s || Oi(r) ? Om(r, e, t, a, Je, n) : nu(r, e, u, t, a, Je, n);
          else {
            if (!(1 & t) && (s = f && Pm.call(r, "__wrapped__"), u = o && Pm.call(e, "__wrapped__"), s || u)) {
              r = s ? r.value() : r, e = u ? e.value() : e, n || (n = new Ge()), e = Je(r, e, t, a, n);
              break e;
            }
            if (l)
              t:
                if (n || (n = new Ge()), s = 1 & t, u = Ki(r), o = u.length, l = Ki(e).length, o == l || s) {
                  for (l = o; l--; ) {
                    var d = u[l];
                    if (!(s ? d in e : ou.call(e, d))) {
                      e = !1;
                      break t;
                    }
                  }
                  if (f = n.get(r), d = n.get(e), f && d)
                    e = f == e && d == r;
                  else {
                    f = !0, n.set(r, e), n.set(e, r);
                    for (var h = s; ++l < o; ) {
                      var p = r[d = u[l]], m = e[d];
                      if (a)
                        var _ = s ? a(m, p, d, e, r, n) : a(p, m, d, r, e, n);
                      if (_ === void 0 ? p !== m && !Je(p, m, t, a, n) : !_) {
                        f = !1;
                        break;
                      }
                      h || (h = d == "constructor");
                    }
                    f && !h && (t = r.constructor) != (a = e.constructor) && "constructor" in r && "constructor" in e && !(typeof t == "function" && t instanceof t && typeof a == "function" && a instanceof a) && (f = !1), n.delete(r), n.delete(e), e = f;
                  }
                } else
                  e = !1;
            else
              e = !1;
          }
        }
      return e;
    }
    function Oa(r, e, t) {
      this.low = 0 | r, this.high = 0 | e, this.unsigned = !!t;
    }
    function Eb(r) {
      return (r && r.__isLong__) === !0;
    }
    function Wd(r, e) {
      var t;
      if (e) {
        if ((e = 0 <= (r >>>= 0) && 256 > r) && (t = Qm[r]))
          return t;
        t = Pa(r, 0 > (0 | r) ? -1 : 0, !0), e && (Qm[r] = t);
      } else {
        if ((e = -128 <= (r |= 0) && 128 > r) && (t = Rm[r]))
          return t;
        t = Pa(r, 0 > r ? -1 : 0, !1), e && (Rm[r] = t);
      }
      return t;
    }
    function $b(r, e) {
      if (isNaN(r))
        return e ? Xd : ac;
      if (e) {
        if (0 > r)
          return Xd;
        if (r >= Sm)
          return Tm;
      } else {
        if (r <= -Um)
          return Fb;
        if (r + 1 >= Um)
          return Vm;
      }
      return 0 > r ? $b(-r, e).neg() : Pa(r % Ke | 0, r / Ke | 0, e);
    }
    function Pa(r, e, t) {
      return new Oa(r, e, t);
    }
    function Pi(r, e, t) {
      if (r.length === 0)
        throw Error("empty string");
      if (r === "NaN" || r === "Infinity" || r === "+Infinity" || r === "-Infinity")
        return ac;
      if (typeof e == "number" ? (t = e, e = !1) : e = !!e, 2 > (t = t || 10) || 36 < t)
        throw RangeError("radix");
      var a;
      if (0 < (a = r.indexOf("-")))
        throw Error("interior hyphen");
      if (a === 0)
        return Pi(r.substring(1), e, t).neg();
      a = $b(Zg(t, 8));
      for (var n = ac, s = 0; s < r.length; s += 8) {
        var o = Math.min(8, r.length - s), u = parseInt(r.substring(s, s + o), t);
        8 > o ? (o = $b(Zg(t, o)), n = n.mul(o).add($b(u))) : n = (n = n.mul(a)).add($b(u));
      }
      return n.unsigned = e, n;
    }
    function oc(r, e) {
      return typeof r == "number" ? $b(r, e) : typeof r == "string" ? Pi(r, e) : Pa(r.low, r.high, typeof e == "boolean" ? e : r.unsigned);
    }
    function da(r, e) {
      function t() {
        this.constructor = r;
      }
      Qi(r, e), r.prototype = e === null ? Object.create(e) : (t.prototype = e.prototype, new t());
    }
    function Le(r) {
      return typeof r == "function";
    }
    function Me(r) {
      setTimeout(function() {
        throw r;
      }, 0);
    }
    function Ri(r) {
      return r !== null && oa(r) === "object";
    }
    function Wm(r) {
      return r.reduce(function(e, t) {
        return e.concat(t instanceof Nf ? t.errors : t);
      }, []);
    }
    function Si(r) {
      for (; r; ) {
        var e = r.destination, t = r.isStopped;
        if (r.closed || t)
          return !1;
        r = e && e instanceof za ? e : null;
      }
      return !0;
    }
    function td(r) {
      return r;
    }
    function Ti() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      return Xm(r);
    }
    function Xm(r) {
      return r.length === 0 ? td : r.length === 1 ? r[0] : function(e) {
        return r.reduce(function(t, a) {
          return a(t);
        }, e);
      };
    }
    function Ym(r) {
      if (r || (r = bc.Promise || Promise), !r)
        throw Error("no Promise impl found");
      return r;
    }
    function Zm() {
      return function(r) {
        return r.lift(new pu(r));
      };
    }
    function Of(r) {
      return r ? qu(r) : Nb;
    }
    function qu(r) {
      return new ra(function(e) {
        return r.schedule(function() {
          return e.complete();
        });
      });
    }
    function ud(r) {
      return r && typeof r.schedule == "function";
    }
    function Ui(r, e) {
      return new ra(function(t) {
        var a = new kb(), n = 0;
        return a.add(e.schedule(function() {
          n === r.length ? t.complete() : (t.next(r[n++]), t.closed || a.add(this.schedule()));
        })), a;
      });
    }
    function Pf(r, e) {
      return e ? Ui(r, e) : new ra($m(r));
    }
    function wb() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      return ud(e = r[r.length - 1]) ? (r.pop(), Ui(r, e)) : Pf(r);
    }
    function pa(r, e) {
      return new ra(e ? function(t) {
        return e.schedule(ru, 0, { error: r, subscriber: t });
      } : function(t) {
        return t.error(r);
      });
    }
    function ru(r) {
      r.subscriber.error(r.error);
    }
    function su(r, e) {
      return e === void 0 && (e = 0), function(t) {
        return t.lift(new tu(r, e));
      };
    }
    function an(r) {
      return r in Vi && (delete Vi[r], !0);
    }
    function Cc() {
    }
    function Da(r, e) {
      return function(t) {
        if (typeof r != "function")
          throw new TypeError("argument is not a function. Are you looking for `mapTo()`?");
        return t.lift(new uu(r, e));
      };
    }
    function bn(r, e, t) {
      if (e) {
        if (!ud(e))
          return function() {
            for (var a = [], n = 0; n < arguments.length; n++)
              a[n] = arguments[n];
            return bn(r, t).apply(void 0, a).pipe(Da(function(s) {
              return cc(s) ? e.apply(void 0, s) : e(s);
            }));
          };
        t = e;
      }
      return function() {
        for (var a = [], n = 0; n < arguments.length; n++)
          a[n] = arguments[n];
        var s, o = this, u = { context: o, subject: s, callbackFunc: r, scheduler: t };
        return new ra(function(l) {
          if (t)
            return t.schedule(vu, 0, { args: a, subscriber: l, params: u });
          if (!s) {
            s = new Qf();
            try {
              r.apply(o, a.concat([function() {
                for (var f = [], d = 0; d < arguments.length; d++)
                  f[d] = arguments[d];
                s.next(1 >= f.length ? f[0] : f), s.complete();
              }]));
            } catch (f) {
              Si(s) ? s.error(f) : console.warn(f);
            }
          }
          return s.subscribe(l);
        });
      };
    }
    function vu(r) {
      var e = this, t = r.args, a = r.subscriber, n = r.params;
      r = n.callbackFunc;
      var s = n.context, o = n.scheduler, u = n.subject;
      if (!u) {
        u = n.subject = new Qf(), n = function() {
          for (var l = [], f = 0; f < arguments.length; f++)
            l[f] = arguments[f];
          e.add(o.schedule(wu, 0, { value: 1 >= l.length ? l[0] : l, subject: u }));
        };
        try {
          r.apply(s, t.concat([n]));
        } catch (l) {
          u.error(l);
        }
      }
      this.add(u.subscribe(a));
    }
    function wu(r) {
      var e = r.subject;
      e.next(r.value), e.complete();
    }
    function cn(r, e, t) {
      if (e) {
        if (!ud(e))
          return function() {
            for (var a = [], n = 0; n < arguments.length; n++)
              a[n] = arguments[n];
            return cn(r, t).apply(void 0, a).pipe(Da(function(s) {
              return cc(s) ? e.apply(void 0, s) : e(s);
            }));
          };
        t = e;
      }
      return function() {
        for (var a = [], n = 0; n < arguments.length; n++)
          a[n] = arguments[n];
        var s = { subject: void 0, args: a, callbackFunc: r, scheduler: t, context: this };
        return new ra(function(o) {
          var u = s.context, l = s.subject;
          if (t)
            return t.schedule(xu, 0, { params: s, subscriber: o, context: u });
          if (!l) {
            l = s.subject = new Qf();
            try {
              r.apply(u, a.concat([function() {
                for (var f = [], d = 0; d < arguments.length; d++)
                  f[d] = arguments[d];
                (d = f.shift()) ? l.error(d) : (l.next(1 >= f.length ? f[0] : f), l.complete());
              }]));
            } catch (f) {
              Si(l) ? l.error(f) : console.warn(f);
            }
          }
          return l.subscribe(o);
        });
      };
    }
    function xu(r) {
      var e = this, t = r.params, a = r.subscriber;
      r = r.context;
      var n = t.callbackFunc, s = t.args, o = t.scheduler, u = t.subject;
      if (!u) {
        u = t.subject = new Qf(), t = function() {
          for (var l = [], f = 0; f < arguments.length; f++)
            l[f] = arguments[f];
          (f = l.shift()) ? e.add(o.schedule(dn, 0, { err: f, subject: u })) : e.add(o.schedule(yu, 0, { value: 1 >= l.length ? l[0] : l, subject: u }));
        };
        try {
          n.apply(r, s.concat([t]));
        } catch (l) {
          this.add(o.schedule(dn, 0, { err: l, subject: u }));
        }
      }
      this.add(u.subscribe(a));
    }
    function yu(r) {
      var e = r.subject;
      e.next(r.value), e.complete();
    }
    function dn(r) {
      r.subject.error(r.err);
    }
    function en(r) {
      return !!r && typeof r.subscribe != "function" && typeof r.then == "function";
    }
    function Wi(r, e, t, a, n) {
      if (n === void 0 && (n = new zu(r, t, a)), !n.closed)
        return e instanceof ra ? e.subscribe(n) : Rf(e)(n);
    }
    function Au(r, e) {
      return new ra(function(t) {
        var a = new kb();
        return a.add(e.schedule(function() {
          var n = r[Ne]();
          a.add(n.subscribe({ next: function(s) {
            a.add(e.schedule(function() {
              return t.next(s);
            }));
          }, error: function(s) {
            a.add(e.schedule(function() {
              return t.error(s);
            }));
          }, complete: function() {
            a.add(e.schedule(function() {
              return t.complete();
            }));
          } }));
        })), a;
      });
    }
    function Bu(r, e) {
      return new ra(function(t) {
        var a = new kb();
        return a.add(e.schedule(function() {
          return r.then(function(n) {
            a.add(e.schedule(function() {
              t.next(n), a.add(e.schedule(function() {
                return t.complete();
              }));
            }));
          }, function(n) {
            a.add(e.schedule(function() {
              return t.error(n);
            }));
          });
        })), a;
      });
    }
    function Cu(r, e) {
      if (!r)
        throw Error("Iterable cannot be null");
      return new ra(function(t) {
        var a, n = new kb();
        return n.add(function() {
          a && typeof a.return == "function" && a.return();
        }), n.add(e.schedule(function() {
          a = r[vd](), n.add(e.schedule(function() {
            if (!t.closed) {
              try {
                var s = a.next(), o = s.value, u = s.done;
              } catch (l) {
                return void t.error(l);
              }
              u ? t.complete() : (t.next(o), this.schedule());
            }
          }));
        })), n;
      });
    }
    function fn(r, e) {
      if (r != null) {
        if (r && typeof r[Ne] == "function")
          return Au(r, e);
        if (en(r))
          return Bu(r, e);
        if (gn(r))
          return Ui(r, e);
        if (r && typeof r[vd] == "function" || typeof r == "string")
          return Cu(r, e);
      }
      throw new TypeError((r !== null && oa(r) || r) + " is not observable");
    }
    function Dc(r, e) {
      return e ? fn(r, e) : r instanceof ra ? r : new ra(Rf(r));
    }
    function Yc(r, e) {
      if (!e.closed) {
        if (r instanceof ra)
          return r.subscribe(e);
        try {
          var t = Rf(r)(e);
        } catch (a) {
          e.error(a);
        }
        return t;
      }
    }
    function Ab(r, e, t) {
      return t === void 0 && (t = Number.POSITIVE_INFINITY), typeof e == "function" ? function(a) {
        return a.pipe(Ab(function(n, s) {
          return Dc(r(n, s)).pipe(Da(function(o, u) {
            return e(n, o, s, u);
          }));
        }, t));
      } : (typeof e == "number" && (t = e), function(a) {
        return a.lift(new Du(r, t));
      });
    }
    function $g(r) {
      return r === void 0 && (r = Number.POSITIVE_INFINITY), Ab(td, r);
    }
    function hn() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      return $g(1)(wb.apply(void 0, r));
    }
    function wd(r) {
      return new ra(function(e) {
        try {
          var t = r();
        } catch (a) {
          return void e.error(a);
        }
        return (t ? Dc(t) : Of()).subscribe(e);
      });
    }
    function ah(r, e) {
      return new ra(function(t) {
        var a = r.length;
        if (a === 0)
          t.complete();
        else
          for (var n = Array(a), s = 0, o = 0, u = function(f) {
            var d = Dc(r[f]), h = !1;
            t.add(d.subscribe({ next: function(p) {
              h || (h = !0, o++), n[f] = p;
            }, error: function(p) {
              return t.error(p);
            }, complete: function() {
              ++s !== a && h || (o === a && t.next(e ? e.reduce(function(p, m, _) {
                return p[m] = n[_], p;
              }, {}) : n), t.complete());
            } }));
          }, l = 0; l < a; l++)
            u(l);
      });
    }
    function Gb(r, e, t, a) {
      return Le(t) && (a = t, t = void 0), a ? Gb(r, e, t).pipe(Da(function(n) {
        return cc(n) ? a.apply(void 0, n) : a(n);
      })) : new ra(function(n) {
        jn(r, e, function(s) {
          1 < arguments.length ? n.next(Array.prototype.slice.call(arguments)) : n.next(s);
        }, n, t);
      });
    }
    function jn(r, e, t, a, n) {
      if (r && typeof r.addEventListener == "function" && typeof r.removeEventListener == "function") {
        r.addEventListener(e, t, n);
        var s = function() {
          return r.removeEventListener(e, t, n);
        };
      } else if (r && typeof r.on == "function" && typeof r.off == "function")
        r.on(e, t), s = function() {
          return r.off(e, t);
        };
      else if (r && typeof r.addListener == "function" && typeof r.removeListener == "function")
        r.addListener(e, t), s = function() {
          return r.removeListener(e, t);
        };
      else {
        if (!r || !r.length)
          throw new TypeError("Invalid event target");
        for (var o = 0, u = r.length; o < u; o++)
          jn(r[o], e, t, a, n);
      }
      a.add(s);
    }
    function kn(r, e, t) {
      return t ? kn(r, e).pipe(Da(function(a) {
        return cc(a) ? t.apply(void 0, a) : t(a);
      })) : new ra(function(a) {
        var n = function() {
          for (var o = [], u = 0; u < arguments.length; u++)
            o[u] = arguments[u];
          return a.next(o.length === 1 ? o[0] : o);
        };
        try {
          var s = r(n);
        } catch (o) {
          return void a.error(o);
        }
        if (Le(e))
          return function() {
            return e(n, s);
          };
      });
    }
    function Eu(r) {
      var e = r.subscriber, t = r.condition;
      if (!e.closed) {
        if (r.needIterate)
          try {
            r.state = r.iterate(r.state);
          } catch (s) {
            return void e.error(s);
          }
        else
          r.needIterate = !0;
        if (t) {
          var a = void 0;
          try {
            a = t(r.state);
          } catch (s) {
            return void e.error(s);
          }
          if (!a)
            return void e.complete();
          if (e.closed)
            return;
        }
        try {
          var n = r.resultSelector(r.state);
        } catch (s) {
          return void e.error(s);
        }
        if (!e.closed && (e.next(n), !e.closed))
          return this.schedule(r);
      }
    }
    function Xi(r) {
      return !cc(r) && 0 <= r - parseFloat(r) + 1;
    }
    function ln(r, e) {
      return r === void 0 && (r = 0), e === void 0 && (e = xd), (!Xi(r) || 0 > r) && (r = 0), e && typeof e.schedule == "function" || (e = xd), new ra(function(t) {
        return t.add(e.schedule(Fu, r, { subscriber: t, counter: 0, period: r })), t;
      });
    }
    function Fu(r) {
      var e = r.subscriber, t = r.counter;
      r = r.period, e.next(t), this.schedule({ subscriber: e, counter: t + 1, period: r }, r);
    }
    function Ec() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      e = Number.POSITIVE_INFINITY;
      var t = null, a = r[r.length - 1];
      return ud(a) ? (t = r.pop(), 1 < r.length && typeof r[r.length - 1] == "number" && (e = r.pop())) : typeof a == "number" && (e = r.pop()), t === null && r.length === 1 && r[0] instanceof ra ? r[0] : $g(e)(Pf(r, t));
    }
    function Yi() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      if (r.length === 0)
        return Nb;
      var t = r[0], a = r.slice(1);
      return r.length === 1 && cc(t) ? Yi.apply(void 0, t) : new ra(function(n) {
        var s = function() {
          return n.add(Yi.apply(void 0, a).subscribe(n));
        };
        return Dc(t).subscribe({ next: function(o) {
          n.next(o);
        }, error: s, complete: s });
      });
    }
    function Gu(r) {
      var e = r.keys, t = r.index, a = r.subscriber, n = r.subscription;
      if (r = r.obj, !a.closed)
        if (t < e.length) {
          var s = e[t];
          a.next([s, r[s]]), n.add(this.schedule({ keys: e, index: t + 1, subscriber: a, subscription: n, obj: r }));
        } else
          a.complete();
    }
    function Hu(r, e) {
      function t() {
        return !t.pred.apply(t.thisArg, arguments);
      }
      return t.pred = r, t.thisArg = e, t;
    }
    function Ob(r, e) {
      return function(t) {
        return t.lift(new Iu(r, e));
      };
    }
    function ab() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      if (r.length === 1) {
        if (!cc(r[0]))
          return r[0];
        r = r[0];
      }
      return Pf(r, void 0).lift(new Ju());
    }
    function Ku(r) {
      var e = r.start, t = r.index, a = r.subscriber;
      t >= r.count ? a.complete() : (a.next(e), a.closed || (r.index = t + 1, r.start = e + 1, this.schedule(r)));
    }
    function Zc(r, e, t) {
      r === void 0 && (r = 0);
      var a = -1;
      return Xi(e) ? a = 1 > Number(e) ? 1 : Number(e) : ud(e) && (t = e), ud(t) || (t = xd), new ra(function(n) {
        var s = Xi(r) ? r : +r - t.now();
        return t.schedule(Lu, s, { index: 0, period: a, subscriber: n });
      });
    }
    function Lu(r) {
      var e = r.index, t = r.period, a = r.subscriber;
      if (a.next(e), !a.closed) {
        if (t === -1)
          return a.complete();
        r.index = e + 1, this.schedule(r, t);
      }
    }
    function Zi() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      return typeof (e = r[r.length - 1]) == "function" && r.pop(), Pf(r, void 0).lift(new Mu(e));
    }
    function Ya(r) {
      return function(e) {
        var t = new Nu(r);
        return e = e.lift(t), t.caught = e;
      };
    }
    function $i(r, e) {
      return Ab(r, e, 1);
    }
    function mn(r) {
      return r === void 0 && (r = null), function(e) {
        return e.lift(new Ou(r));
      };
    }
    function Yd(r, e) {
      e === void 0 && (e = xd);
      var t = r instanceof Date && !isNaN(+r) ? +r - e.now() : Math.abs(r);
      return function(a) {
        return a.lift(new Pu(t, e));
      };
    }
    function nn(r, e) {
      return function(t) {
        return t.lift(new Qu(r, e));
      };
    }
    function Zd(r) {
      return r === void 0 && (r = Ru), function(e) {
        return e.lift(new Su(r));
      };
    }
    function Ru() {
      return new bh();
    }
    function db(r) {
      return function(e) {
        return r === 0 ? Of() : e.lift(new Tu(r));
      };
    }
    function ch(r) {
      return function(e) {
        return e.lift(new Uu(r));
      };
    }
    function Aa(r, e) {
      var t = 2 <= arguments.length;
      return function(a) {
        return a.pipe(r ? Ob(function(n, s) {
          return r(n, s, a);
        }) : td, db(1), t ? mn(e) : Zd(function() {
          return new bh();
        }));
      };
    }
    function Vu() {
      return function(r) {
        return r.lift(new Wu());
      };
    }
    function on(r) {
      return function(e) {
        return r === 0 ? Of() : e.lift(new Xu(r));
      };
    }
    function Sf(r) {
      return function(e) {
        return e.lift(new Yu(r));
      };
    }
    function dh(r, e) {
      var t = !1;
      return 2 <= arguments.length && (t = !0), function(a) {
        return a.lift(new Zu(r, e, t));
      };
    }
    function pn(r, e) {
      return 2 <= arguments.length ? function(t) {
        return Ti(dh(r, e), on(1), mn(e))(t);
      } : function(t) {
        return Ti(dh(function(a, n, s) {
          return r(a, n, s + 1);
        }), on(1))(t);
      };
    }
    function $u(r, e) {
      return function(t) {
        var a = typeof r == "function" ? r : function() {
          return r;
        };
        if (typeof e == "function")
          return t.lift(new av(a, e));
        var n = Object.create(t, bv);
        return n.source = t, n.subjectFactory = a, n;
      };
    }
    function Oe(r) {
      return function(e) {
        return e.lift(new cv(r, e));
      };
    }
    function dv() {
      return new nb();
    }
    function Pe() {
      return function(r) {
        return Zm()($u(dv)(r));
      };
    }
    function qn(r, e, t) {
      var a = r && oa(r) === "object" ? r : { bufferSize: r, windowTime: e, refCount: !1, scheduler: t };
      return function(n) {
        return n.lift(ev(a));
      };
    }
    function ev(r) {
      var e, t, a = r.bufferSize, n = a === void 0 ? Number.POSITIVE_INFINITY : a, s = (a = r.windowTime) === void 0 ? Number.POSITIVE_INFINITY : a, o = r.refCount, u = r.scheduler, l = 0, f = !1, d = !1;
      return function(h) {
        if (l++, !e || f) {
          f = !1;
          var p = (e = new Qe(n, s, u)).subscribe(this);
          t = h.subscribe({ next: function(m) {
            e.next(m);
          }, error: function(m) {
            f = !0, e.error(m);
          }, complete: function() {
            d = !0, t = void 0, e.complete();
          } }), d && (t = void 0);
        } else
          p = e.subscribe(this);
        this.add(function() {
          l--, p.unsubscribe(), p = void 0, t && !d && o && l === 0 && (t.unsubscribe(), e = t = void 0);
        });
      };
    }
    function Fc(r, e) {
      return typeof e == "function" ? function(t) {
        return t.pipe(Fc(function(a, n) {
          return Dc(r(a, n)).pipe(Da(function(s, o) {
            return e(a, s, n, o);
          }));
        }));
      } : function(t) {
        return t.lift(new fv(r));
      };
    }
    function Gc(r) {
      return function(e) {
        return e.lift(new gv(r));
      };
    }
    function sa(r, e, t) {
      return function(a) {
        return a.lift(new hv(r, e, t));
      };
    }
    function iv(r, e, t) {
      return e === void 0 && (e = xd), t === void 0 && (t = jv), function(a) {
        return a.lift(new kv(r, e, t.leading, t.trailing));
      };
    }
    function lv(r) {
      r.subscriber.clearThrottle();
    }
    function mv(r, e, t) {
      return t === void 0 && (t = xd), function(a) {
        var n = r instanceof Date && !isNaN(+r), s = n ? +r - t.now() : Math.abs(r);
        return a.lift(new nv(s, n, e, t));
      };
    }
    function Hb(r, e) {
      return e === void 0 && (e = xd), mv(r, pa(new Pb()), e);
    }
    function ov() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      return function(t) {
        var a;
        return typeof r[r.length - 1] == "function" && (a = r.pop()), t.lift(new pv(r, a));
      };
    }
    function rn(r) {
      (aj || r) && (sn.abort(), r && (sn = new AbortController()), aj = r);
    }
    function tn(r, e, t, a, n) {
      r !== e && un(e, function(s, o) {
        if (n || (n = new Ge()), Db(s)) {
          s = n;
          var u = bj(r, o), l = bj(e, o), f = s.get(l);
          if (f)
            cj(r, o, f);
          else {
            var d = (f = a ? a(u, l, o + "", r, e, s) : void 0) === void 0;
            if (d) {
              var h = pb(l), p = !h && Lf(l), m = !h && !p && Oi(l);
              f = l, h || p || m ? pb(u) ? f = u : Bc(u) && $d(u) ? f = Ji(u) : p ? (d = !1, f = Im(l, !0)) : m ? (d = !1, f = vn(l, !0)) : f = [] : wn(l) || Tf(l) ? (f = u, Tf(u) ? f = Re(u, Mf(u)) : Db(u) && !dj(u) || (f = Jm(l))) : d = !1;
            }
            d && (s.set(l, f), tn(f, l, t, a, s), s.delete(l)), cj(r, o, f);
          }
        } else
          (u = a ? a(bj(r, o), s, o + "", r, e, n) : void 0) === void 0 && (u = s), cj(r, o, u);
      }, Mf);
    }
    function qv(r) {
      var e = 1, t = ej;
      (1 >= arguments.length ? 0 : arguments.length - 1) == 1 ? typeof (1 >= arguments.length ? void 0 : arguments[1]) == "number" ? e = 1 >= arguments.length ? void 0 : arguments[1] : t = 1 >= arguments.length ? void 0 : arguments[1] : (1 >= arguments.length ? 0 : arguments.length - 1) == 2 && (e = 1 >= arguments.length ? void 0 : arguments[1], t = 2 >= arguments.length ? void 0 : arguments[2]);
      var a = e || 1;
      return function(n) {
        return n.pipe(dh(function(s, o) {
          var u = t.now(), l = u - r;
          if ((s = s.filter(function(h) {
            return h.until > l;
          })).length >= a) {
            var f = s[s.length - 1], d = s[0].until + r * Math.floor(s.length / a);
            s.push({ delay: f.until < u ? d - u : d - f.until, until: d, value: o });
          } else
            s.push({ delay: 0, until: u, value: o });
          return s;
        }, []), Da(function(s) {
          return s[s.length - 1];
        }), $i(function(s) {
          var o = wb(s.value);
          return s.delay ? o.pipe(Yd(s.delay, t)) : o;
        }));
      };
    }
    function rv(r, e) {
      var t = (e = e === void 0 ? { protocols: xn, makeWebSocket: yn } : e).protocols, a = t === void 0 ? xn : t, n = (e = e.makeWebSocket) === void 0 ? yn : e;
      return new ra(function(s) {
        var o, u = new nb(), l = n(r, a), f = !1, d = !1, h = !1, p = function(m) {
          if (o)
            throw f = !0, m = Error("Web socket message factory function called more than once"), s.error(m), m;
          return o = m.subscribe(function(_) {
            l.send(_);
          }), u;
        };
        return l.onopen = function() {
          h = !0, d ? (f = !0, l.close()) : s.next(p);
        }, l.onmessage = function(m) {
          u.next(m.data);
        }, l.onerror = function(m) {
          f = !0, s.error(Error(m.message));
        }, l.onclose = function(m) {
          f || (f = !0, d ? (s.complete(), u.complete()) : s.error(Error(m.code === 1e3 ? "Normal closure" : m.reason)));
        }, function() {
          d = !0, o && o.unsubscribe(), f || (f = !0, h && l.close());
        };
      });
    }
    function eh() {
      this._listeners = {};
    }
    function zn(r) {
      return typeof Float32Array < "u" ? function() {
        function e(l, f, d) {
          s[0] = l, f[d] = o[0], f[d + 1] = o[1], f[d + 2] = o[2], f[d + 3] = o[3];
        }
        function t(l, f, d) {
          s[0] = l, f[d] = o[3], f[d + 1] = o[2], f[d + 2] = o[1], f[d + 3] = o[0];
        }
        function a(l, f) {
          return o[0] = l[f], o[1] = l[f + 1], o[2] = l[f + 2], o[3] = l[f + 3], s[0];
        }
        function n(l, f) {
          return o[3] = l[f], o[2] = l[f + 1], o[1] = l[f + 2], o[0] = l[f + 3], s[0];
        }
        var s = new Float32Array([-0]), o = new Uint8Array(s.buffer), u = o[3] === 128;
        r.writeFloatLE = u ? e : t, r.writeFloatBE = u ? t : e, r.readFloatLE = u ? a : n, r.readFloatBE = u ? n : a;
      }() : function() {
        function e(a, n, s, o) {
          var u = 0 > n ? 1 : 0;
          if (u && (n = -n), n === 0)
            a(0 < 1 / n ? 0 : 2147483648, s, o);
          else if (isNaN(n))
            a(2143289344, s, o);
          else if (34028234663852886e22 < n)
            a((u << 31 | 2139095040) >>> 0, s, o);
          else if (11754943508222875e-54 > n)
            a((u << 31 | Math.round(n / 1401298464324817e-60)) >>> 0, s, o);
          else {
            var l = Math.floor(Math.log(n) / Math.LN2);
            a((u << 31 | l + 127 << 23 | 8388607 & Math.round(n * Math.pow(2, -l) * 8388608)) >>> 0, s, o);
          }
        }
        function t(a, n, s) {
          return s = a(n, s), a = 2 * (s >> 31) + 1, n = s >>> 23 & 255, s &= 8388607, n === 255 ? s ? NaN : 1 / 0 * a : n === 0 ? 1401298464324817e-60 * a * s : a * Math.pow(2, n - 150) * (s + 8388608);
        }
        r.writeFloatLE = e.bind(null, An), r.writeFloatBE = e.bind(null, Bn), r.readFloatLE = t.bind(null, Cn), r.readFloatBE = t.bind(null, Dn);
      }(), typeof Float64Array < "u" ? function() {
        function e(l, f, d) {
          s[0] = l, f[d] = o[0], f[d + 1] = o[1], f[d + 2] = o[2], f[d + 3] = o[3], f[d + 4] = o[4], f[d + 5] = o[5], f[d + 6] = o[6], f[d + 7] = o[7];
        }
        function t(l, f, d) {
          s[0] = l, f[d] = o[7], f[d + 1] = o[6], f[d + 2] = o[5], f[d + 3] = o[4], f[d + 4] = o[3], f[d + 5] = o[2], f[d + 6] = o[1], f[d + 7] = o[0];
        }
        function a(l, f) {
          return o[0] = l[f], o[1] = l[f + 1], o[2] = l[f + 2], o[3] = l[f + 3], o[4] = l[f + 4], o[5] = l[f + 5], o[6] = l[f + 6], o[7] = l[f + 7], s[0];
        }
        function n(l, f) {
          return o[7] = l[f], o[6] = l[f + 1], o[5] = l[f + 2], o[4] = l[f + 3], o[3] = l[f + 4], o[2] = l[f + 5], o[1] = l[f + 6], o[0] = l[f + 7], s[0];
        }
        var s = new Float64Array([-0]), o = new Uint8Array(s.buffer), u = o[7] === 128;
        r.writeDoubleLE = u ? e : t, r.writeDoubleBE = u ? t : e, r.readDoubleLE = u ? a : n, r.readDoubleBE = u ? n : a;
      }() : function() {
        function e(a, n, s, o, u, l) {
          var f = 0 > o ? 1 : 0;
          if (f && (o = -o), o === 0)
            a(0, u, l + n), a(0 < 1 / o ? 0 : 2147483648, u, l + s);
          else if (isNaN(o))
            a(0, u, l + n), a(2146959360, u, l + s);
          else if (17976931348623157e292 < o)
            a(0, u, l + n), a((f << 31 | 2146435072) >>> 0, u, l + s);
          else if (22250738585072014e-324 > o)
            a((o /= 5e-324) >>> 0, u, l + n), a((f << 31 | o / 4294967296) >>> 0, u, l + s);
          else {
            var d = Math.floor(Math.log(o) / Math.LN2);
            d === 1024 && (d = 1023), a(4503599627370496 * (o *= Math.pow(2, -d)) >>> 0, u, l + n), a((f << 31 | d + 1023 << 20 | 1048576 * o & 1048575) >>> 0, u, l + s);
          }
        }
        function t(a, n, s, o, u) {
          return n = a(o, u + n), o = a(o, u + s), a = 2 * (o >> 31) + 1, n = 4294967296 * (1048575 & o) + n, (s = o >>> 20 & 2047) === 2047 ? n ? NaN : 1 / 0 * a : s === 0 ? 5e-324 * a * n : a * Math.pow(2, s - 1075) * (n + 4503599627370496);
        }
        r.writeDoubleLE = e.bind(null, An, 0, 4), r.writeDoubleBE = e.bind(null, Bn, 4, 0), r.readDoubleLE = t.bind(null, Cn, 0, 4), r.readDoubleBE = t.bind(null, Dn, 4, 0);
      }(), r;
    }
    function An(r, e, t) {
      e[t] = 255 & r, e[t + 1] = r >>> 8 & 255, e[t + 2] = r >>> 16 & 255, e[t + 3] = r >>> 24;
    }
    function Bn(r, e, t) {
      e[t] = r >>> 24, e[t + 1] = r >>> 16 & 255, e[t + 2] = r >>> 8 & 255, e[t + 3] = 255 & r;
    }
    function Cn(r, e) {
      return (r[e] | r[e + 1] << 8 | r[e + 2] << 16 | r[e + 3] << 24) >>> 0;
    }
    function Dn(r, e) {
      return (r[e] << 24 | r[e + 1] << 16 | r[e + 2] << 8 | r[e + 3]) >>> 0;
    }
    function qb(r, e) {
      this.lo = r >>> 0, this.hi = e >>> 0;
    }
    function Uf(r, e, t) {
      this.fn = r, this.len = e, this.next = void 0, this.val = t;
    }
    function fj() {
    }
    function sv(r) {
      this.head = r.head, this.tail = r.tail, this.len = r.len, this.next = r.states;
    }
    function xa() {
      this.len = 0, this.tail = this.head = new Uf(fj, 0, 0), this.states = null;
    }
    function gj(r, e, t) {
      e[t] = 255 & r;
    }
    function hj(r, e) {
      this.len = r, this.next = void 0, this.val = e;
    }
    function ij(r, e, t) {
      for (; r.hi; )
        e[t++] = 127 & r.lo | 128, r.lo = (r.lo >>> 7 | r.hi << 25) >>> 0, r.hi >>>= 7;
      for (; 127 < r.lo; )
        e[t++] = 127 & r.lo | 128, r.lo >>>= 7;
      e[t++] = r.lo;
    }
    function jj(r, e, t) {
      e[t] = 255 & r, e[t + 1] = r >>> 8 & 255, e[t + 2] = r >>> 16 & 255, e[t + 3] = r >>> 24;
    }
    function Hc() {
      kj.call(this);
    }
    function tv(r, e, t) {
      40 > r.length ? na.utf8.write(r, e, t) : e.utf8Write ? e.utf8Write(r, t) : e.write(r, t);
    }
    function pc(r, e) {
      return RangeError("index out of range: " + r.pos + " + " + (e || 1) + " > " + r.len);
    }
    function eb(r) {
      this.buf = r, this.pos = 0, this.len = r.length;
    }
    function lj() {
      var r = new En(0, 0), e = 0;
      if (!(4 < this.len - this.pos)) {
        for (; 3 > e; ++e) {
          if (this.pos >= this.len)
            throw pc(this);
          if (r.lo = (r.lo | (127 & this.buf[this.pos]) << 7 * e) >>> 0, 128 > this.buf[this.pos++])
            return r;
        }
        return r.lo = (r.lo | (127 & this.buf[this.pos++]) << 7 * e) >>> 0, r;
      }
      for (; 4 > e; ++e)
        if (r.lo = (r.lo | (127 & this.buf[this.pos]) << 7 * e) >>> 0, 128 > this.buf[this.pos++])
          return r;
      if (r.lo = (r.lo | (127 & this.buf[this.pos]) << 28) >>> 0, r.hi = (r.hi | (127 & this.buf[this.pos]) >> 4) >>> 0, 128 > this.buf[this.pos++])
        return r;
      if (e = 0, 4 < this.len - this.pos) {
        for (; 5 > e; ++e)
          if (r.hi = (r.hi | (127 & this.buf[this.pos]) << 7 * e + 3) >>> 0, 128 > this.buf[this.pos++])
            return r;
      } else
        for (; 5 > e; ++e) {
          if (this.pos >= this.len)
            throw pc(this);
          if (r.hi = (r.hi | (127 & this.buf[this.pos]) << 7 * e + 3) >>> 0, 128 > this.buf[this.pos++])
            return r;
        }
      throw Error("invalid varint encoding");
    }
    function fh(r, e) {
      return (r[e - 4] | r[e - 3] << 8 | r[e - 2] << 16 | r[e - 1] << 24) >>> 0;
    }
    function Fn() {
      if (this.pos + 8 > this.len)
        throw pc(this, 8);
      return new En(fh(this.buf, this.pos += 4), fh(this.buf, this.pos += 4));
    }
    function ae(r) {
      mj.call(this, r);
    }
    function Vf(r, e, t) {
      if (typeof r != "function")
        throw TypeError("rpcImpl must be a function");
      na.EventEmitter.call(this), this.rpcImpl = r, this.requestDelimited = !!e, this.responseDelimited = !!t;
    }
    function Sa(r) {
      return typeof r == "string" && /^[\s\w!#$%&()+,.:;<=>?@[\]^{|}~-]{1,64}$/.test(r) && r !== "null";
    }
    function Gn(r) {
      try {
        var e = r.split(".").map(function(a) {
          return Number(a);
        });
      } catch {
        return !1;
      }
      if (e.length !== 4 || e[0] === 0)
        return !1;
      for (r = 0; r < e.length; r++) {
        var t = e[r];
        if (!Number.isInteger(t) || 0 > t || 255 < t)
          return !1;
      }
      return !0;
    }
    function Hn(r, e) {
      if (!Array.isArray(e) || e.length === 0 || 32 < e.length || e.some(function(t) {
        return t.length === 0 || 32 < t.length;
      }))
        throw new Z("arguments is not valid", bb);
      if (!Sa(r))
        throw new Z("ID is invalid", bb);
    }
    function Wf(r) {
      var e = r.attributes, t = r.attrSizeMap, a = r.maxAttrsCount, n = r.maxAttrValueSize;
      if (r = r.maxTotalSize, !Be(e))
        throw new Z("attributes must be an object", bb);
      if (Object.keys(e).length > a)
        throw new dc("Exceed the limit of ".concat(a, " attributes"), Se);
      if (Object.keys(e).length === 0)
        throw new Z("The attributes is an empty object", bb);
      var s = 0, o = 0;
      for (e = Object.entries(e); o < e.length; o++) {
        var u = Xa(e[o], 2), l = u[1];
        u = new Blob([u[0]]).size;
        var f = new Blob([l]).size;
        if (u === 0 || 32 < u)
          throw new Z("Invalid attribute key", bb);
        if (f > n)
          throw new dc("Invalid attribute value, over the limit of ".concat(n, " bytes"), Se);
        if (typeof l != "string" || l.length === 0)
          throw new Z("Invalid attribute value", bb);
        s += u, s += f;
      }
      if (s > r)
        throw new dc("The attributes size overflow", Se);
      if (t !== void 0) {
        if (Object.keys(t).length > a)
          throw new dc("Exceed the limit of ".concat(a, " attributes"), Se);
        for (s = a = 0, t = Object.entries(t); s < t.length; s++) {
          if (o = (e = Xa(t[s], 2))[1], (e = new Blob([e[0]]).size) === 0)
            throw new Z("Invalid attribute key", bb);
          if (o > n)
            throw new dc("Invalid attribute value, over the limit of ".concat(n, " bytes"), Se);
          a += e, a += o;
        }
        if (a > r)
          throw new dc("The attributes size overflow", Se);
      }
    }
    function gh(r, e) {
      return Math.floor(Math.random() * (Math.floor(e) - Math.ceil(r) + 1)) + r;
    }
    function hh() {
      var r = gh(0, 4294967295), e = gh(1, 4294967295);
      return new ma(r, e, !0);
    }
    function rb(r) {
      return r.toString().padEnd(32, "0");
    }
    function In(r, e) {
      return new TypeError("Unexpected ".concat(r, ": ").concat(e));
    }
    function Jn(r, e) {
      return r = r.split(".").map(function(t) {
        return Number(t);
      }), e = e.split(".").map(function(t) {
        return Number(t);
      }), Math.sqrt(1e3 * Math.pow(r[0] - e[0], 2) + 100 * Math.pow(r[1] - e[1], 2) + 10 * Math.pow(r[2] - e[2], 2) + 1 * Math.pow(r[3] - e[3], 2));
    }
    function Kn(r) {
      return r.lessThanOrEqual(Number.MAX_SAFE_INTEGER) ? r.toNumber() : r.toString();
    }
    function nj(r, e) {
      e = "".concat(r).concat(e || "");
      var t = Ln.get(e) || 1;
      return Ln.set(e, t + 1), "".concat(r).concat(t);
    }
    function Mn(r, e) {
      var t = typeof e == "number" ? e : e !== void 0 && typeof e != "string" ? e.code : void 0;
      return e = typeof e != "number" && typeof e != "string" && e !== void 0 && e.serverCode !== void 0 ? e.serverCode : void 0, t = "".concat(t !== void 0 ? " Error Code ".concat(t) : "").concat(e !== void 0 ? ", server Code ".concat(e) : ""), r = typeof r == "string" && r ? ih(r) : Array.isArray(r) && typeof r[0] == "string" && r[0] ? ih(Nn.apply(void 0, [r[0]].concat(W(r.slice(1))))) : "", "".concat(t === "" ? "" : "".concat(t, " - ")).concat(r);
    }
    function uv(r, e) {
      return oj.apply(this, arguments);
    }
    function oj() {
      return (oj = ja(M.mark(function r(e, t) {
        return M.wrap(function(a) {
          for (; ; )
            switch (a.prev = a.next) {
              case 0:
                if (!t || !t.aborted) {
                  a.next = 2;
                  break;
                }
                return a.abrupt("return");
              case 2:
                return a.abrupt("return", new Promise(function(n) {
                  setTimeout(n, e), t == null || t.addEventListener("abort", n);
                }));
              case 3:
              case "end":
                return a.stop();
            }
        }, r);
      }))).apply(this, arguments);
    }
    function jh(r, e, t) {
      return pj.apply(this, arguments);
    }
    function pj() {
      return (pj = ja(M.mark(function r(e, t, a) {
        var n, s, o, u, l, f, d, h, p, m, _, w, S, O, k, B, L, G, _r, ga, _n, Fa, N, _t, Y, _a;
        return M.wrap(function(X) {
          for (; ; )
            switch (X.prev = X.next) {
              case 0:
                if (n = t.body, s = t.headers, o = s === void 0 ? {} : s, u = t.timeout, l = u === void 0 ? 1e4 : u, f = t.signal, d = t.withCredentials, h = d !== void 0 && d, p = (a || {}).useBinaryResponse, m = p !== void 0 && p, (_ = new XMLHttpRequest()).open("POST", e, !0), _.responseType = m ? "arraybuffer" : "text", _.withCredentials = h, _.timeout = l, w = n instanceof FormData, S = n instanceof Uint8Array, !(1 < (O = Object.keys(o).filter(function(J) {
                  return J.toLowerCase() === "content-type";
                })).length)) {
                  X.next = 14;
                  break;
                }
                throw new RangeError("multiple content-type");
              case 14:
                O.length === 0 && (S ? o["Content-Type"] = "application/octet-stream" : w || (o["Content-Type"] = "application/json"));
              case 15:
                if ("setRequestHeader" in _) {
                  X.next = 46;
                  break;
                }
                return _.abort(), X.next = 19, fetch(e, { body: w || S ? n : JSON.stringify(n), cache: "no-cache", credentials: h ? "include" : "same-origin", headers: o, method: "POST", mode: "cors", referrer: "no-referrer", signal: f });
              case 19:
                if (k = X.sent, !(200 <= (B = k.status) && 300 > B || B === 304)) {
                  X.next = 31;
                  break;
                }
                if (!m) {
                  X.next = 27;
                  break;
                }
                return X.next = 25, k.arrayBuffer();
              case 25:
                return L = X.sent, X.abrupt("return", { status: B, responseData: L });
              case 27:
                return X.next = 29, k.text();
              case 29:
                return G = X.sent, X.abrupt("return", { status: B, responseText: G });
              case 31:
                return _r = new Ja(["Post XHR failure, status %d", B]), X.prev = 32, X.next = 35, k.text();
              case 35:
                throw ga = X.sent, _r.statusCode = B, _r.message = ga || "Request failed, status ".concat(B), _r;
              case 41:
                throw X.prev = 41, X.t0 = X.catch(32), _r.statusCode = B, _r.message = "Request failed, status ".concat(B), _r;
              case 46:
                if (Object.keys(o).length !== 0)
                  for (_n = 0, Fa = Object.entries(o); _n < Fa.length; _n++)
                    N = Xa(Fa[_n], 2), _t = N[0], Y = N[1], _.setRequestHeader(_t, Y);
                return f !== void 0 && (_a = function J() {
                  _.abort(), f.removeEventListener("abort", J);
                }, f.addEventListener("abort", _a)), w || S ? _.send(n) : _.send(JSON.stringify(n)), X.abrupt("return", new Promise(function(J, ea) {
                  _.onload = function() {
                    var wa = _.status;
                    if (200 <= wa && 300 > wa || wa === 304)
                      J(m ? { status: wa, responseData: _.response } : { status: wa, responseText: _.responseText });
                    else {
                      var _s = new Ja(["Post XHR failure, status %d", wa]);
                      _s.statusCode = wa, _s.message = _.response || "Request failed, status ".concat(_.status), ea(_s);
                    }
                  }, _.ontimeout = function(wa) {
                    ea(new Qb(["XHR request timed out after %d ms", l], { originalError: wa }));
                  }, _.onerror = function() {
                    var wa = new Ja(["Post XHR failure, status %d", _.status]);
                    wa.statusCode = _.status, wa.message = _.response || "Request failed, status ".concat(_.status), ea(wa);
                  }, _.onabort = function() {
                    try {
                      ea(new DOMException("The request aborted.", "AbortError"));
                    } catch {
                      var wa = Error("The request aborted.");
                      wa.name = "AbortError", ea(wa);
                    }
                  };
                }));
              case 50:
              case "end":
                return X.stop();
            }
        }, r, null, [[32, 41]]);
      }))).apply(this, arguments);
    }
    function On(r, e) {
      if (!Be(r))
        throw new Z("message object is not a plain object", e);
      if (r.messageType === void 0)
        if (r.rawMessage instanceof Uint8Array) {
          if (r.messageType = "RAW", r.text !== void 0)
            throw new Z("Raw messages cannot have text property. Use description instead", e);
        } else {
          if (typeof r.text != "string")
            throw new Z("messageType is undefined", e);
          if (r.messageType = "TEXT", r.rawMessage !== void 0)
            throw new Z("Text messages cannot have rawMessage property", e);
        }
    }
    function kh(r) {
      return qj.apply(this, arguments);
    }
    function qj() {
      return (qj = ja(M.mark(function r(e) {
        var t, a, n, s, o, u, l, f, d, h, p, m, _, w, S, O, k, B, L, G;
        return M.wrap(function(_r) {
          for (; ; )
            switch (_r.prev = _r.next) {
              case 0:
                if (t = e.message, a = e.peerId, n = e.toPeer, s = e.session, o = e.errorCodes, u = e.diff, l = e.logger, s !== void 0) {
                  _r.next = 3;
                  break;
                }
                throw new aa("The client is not logged in. Cannot do the operation", o.NOT_LOGGED_IN);
              case 3:
                if (f = !1, t.messageType !== "TEXT" || !t.text.startsWith("AgoraRTMLegacyEndcallCompatibleMessagePrefix") || !n) {
                  _r.next = 11;
                  break;
                }
                if (d = t.text.split("_"), h = Xa(d, 3), p = h[0], m = h[1], h[2] !== void 0 && Sa(m) && p === "AgoraRTMLegacyEndcallCompatibleMessagePrefix") {
                  _r.next = 10;
                  break;
                }
                throw new Z("Message is not valid", Xf);
              case 10:
                f = !0;
              case 11:
                if (_ = Date.now(), w = s.messageSentTimes.length - 1, !((S = s.messageSentTimes[w]) && S + 3e3 < _)) {
                  _r.next = 18;
                  break;
                }
                s.messageSentTimes = [_], _r.next = 29;
                break;
              case 18:
                O = w;
              case 19:
                if (!(0 <= O)) {
                  _r.next = 28;
                  break;
                }
                if (!(s.messageSentTimes[O] + 3e3 < _)) {
                  _r.next = 23;
                  break;
                }
                return s.messageSentTimes = s.messageSentTimes.slice(O + 1, w + 1), _r.abrupt("break", 28);
              case 23:
                if (!(180 <= w - O + 1)) {
                  _r.next = 25;
                  break;
                }
                throw new dc("Message sent failed, exceeded the 180 message in 3 seconds", o.TOO_OFTEN);
              case 25:
                O--, _r.next = 19;
                break;
              case 28:
                s.messageSentTimes.push(_);
              case 29:
                _r.t0 = t.messageType, _r.next = _r.t0 === "TEXT" ? 32 : _r.t0 === "RAW" ? 37 : 39;
                break;
              case 32:
                if (!f) {
                  _r.next = 36;
                  break;
                }
                return k = t.text.split("_"), B = Xa(k, 3), L = B[1], G = B[2], l.info("[rtm-API] EndCall message send api is called"), _r.abrupt("return", s.sendInvitationMessage({ peerId: a, type: "CallCancel", extra: G, channelId: L, callId: "0" }));
              case 36:
                return _r.abrupt("return", s.sendTextMessage(t.text, a, n, 1e4 - u));
              case 37:
                return t.description === void 0 && (t.description = ""), _r.abrupt("return", s.sendRawMessage(t.rawMessage, t.description, a, n, 1e4 - u));
              case 39:
                throw new Z("Invalid message type", Xf);
              case 40:
              case "end":
                return _r.stop();
            }
        }, r);
      }))).apply(this, arguments);
    }
    function vv(r) {
      var e = !(1 < arguments.length && arguments[1] !== void 0) || arguments[1], t = r.replace(/(https?:\/\/)?(www.)?/i, "");
      return e || (t = t.split(".").slice(r.length - 2).join(".")), t.indexOf("/") !== -1 ? t.split("/")[0] : t;
    }
    function Ka(r) {
      if (typeof r != "string")
        return "[Sensitive Info]";
      var e = Math.floor(0.7 * r.length), t = r.length;
      return Pn(r, e, t, "*".repeat(t - e));
    }
    function Qn(r, e, t) {
      function a(n) {
        if (r === void 0)
          return r;
        if (Hm(n))
          return n;
        if (Array.isArray(n))
          return n.map(a);
        var s = {}, o = 0;
        for (n = lh(n); o < n.length; o++) {
          var u = Xa(n[o], 2), l = u[0];
          if (typeof (u = u[1]) == "string" && t.includes(l)) {
            s[l] = typeof u == "string" ? Ka(u) : "[Sensitive Info]";
            break;
          }
          e.includes(l) ? s[l] = "[Hidden Info]" : s[l] = u == null ? u : t.includes(l) ? "[Sensitive Info]" : a(u);
        }
        return s;
      }
      return Array.isArray(r) ? r.map(a) : a(r);
    }
    function Rn(r) {
      return Object.getOwnPropertyNames(r).forEach(function(e) {
        oa(e = r[e]) == "object" && e !== null && Rn(e);
      }), Object.freeze(r);
    }
    function Yf(r) {
      return new TextDecoder("utf-8").decode(r.buffer.slice(r.byteOffset, r.byteOffset + r.byteLength));
    }
    function mh(r) {
      return new TextEncoder().encode(r).length;
    }
    function Sn() {
      for (var r = 0, e = arguments.length, t = Array(e), a = 0; a < e; a++)
        t[a] = arguments[a];
      for (e = 0; e < t.length; e++)
        r += t[e].length;
      for (r = new Uint8Array(r), a = e = 0; a < t.length; a++) {
        var n = t[a];
        r.set(n, e), e += n.length;
      }
      return r;
    }
    function Te(r, e, t) {
      var a = r.match(/([^?#]+)(\?[^#]*)?(#.*)?/);
      if (r = a == null ? void 0 : a[1], a = a == null ? void 0 : a[2]) {
        var n;
        for (a = a.substr(1).split("&"), n = 0; n < a.length; n++)
          if (a[n].split("=")[0] == e) {
            a[n] = e + "=" + encodeURIComponent(t);
            break;
          }
        return n == a.length && a.push(e + "=" + encodeURIComponent(t)), r + "?" + a.join("&");
      }
      return r + "?" + e + "=" + encodeURIComponent(t);
    }
    function Pn(r, e, t, a) {
      return typeof r != "string" ? "[Sensitive Info]" : r.substring(0, e) + a + r.substring(t);
    }
    function Zf(r) {
      return typeof r == "string" && r.length !== 0 && r !== "false" && r !== "null" && r !== "undefined";
    }
    function Tn(r) {
      var e = [];
      return function t(a) {
        if (a === null || oa(a) !== "object")
          return a;
        if (e.indexOf(a) !== -1)
          return "[Circular]";
        if (e.push(a), typeof a.toJSON == "function")
          try {
            var n = t(a.toJSON());
            return e.pop(), n;
          } catch (s) {
            return "[Throws: " + (s ? s.message : "?") + "]";
          }
        return Array.isArray(a) ? (n = a.map(t), e.pop(), n) : (n = Object.keys(a).reduce(function(s, o) {
          e: {
            if (wv.call(a, o))
              try {
                var u = a[o];
                break e;
              } catch (l) {
                u = "[Throws: " + (l ? l.message : "?") + "]";
                break e;
              }
            u = a[o];
          }
          return s[o] = t(u), s;
        }, {}), e.pop(), n);
      }(r);
    }
    function xv(r) {
      if (!(100 < (r = String(r)).length) && (r = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(r))) {
        var e = parseFloat(r[1]);
        switch ((r[2] || "ms").toLowerCase()) {
          case "years":
          case "year":
          case "yrs":
          case "yr":
          case "y":
            return 315576e5 * e;
          case "weeks":
          case "week":
          case "w":
            return 6048e5 * e;
          case "days":
          case "day":
          case "d":
            return 864e5 * e;
          case "hours":
          case "hour":
          case "hrs":
          case "hr":
          case "h":
            return 36e5 * e;
          case "minutes":
          case "minute":
          case "mins":
          case "min":
          case "m":
            return 6e4 * e;
          case "seconds":
          case "second":
          case "secs":
          case "sec":
          case "s":
            return 1e3 * e;
          case "milliseconds":
          case "millisecond":
          case "msecs":
          case "msec":
          case "ms":
            return e;
        }
      }
    }
    function nh(r, e, t, a) {
      return Math.round(r / t) + " " + a + (e >= 1.5 * t ? "s" : "");
    }
    function yv(r) {
      var e = r.areas, t = r.excludedArea;
      if (e.length === 1 && e[0] === R.GLOBAL && t === R.CHINA)
        return Ue([R.OVERSEA]);
      if (e.includes(R.GLOBAL)) {
        if (r = $f(oh).filter(function(s) {
          return s !== R.GLOBAL && s !== R.OVERSEA;
        }), t in ag) {
          e = ag[t];
          var a = [].concat(W(e != null ? e : []), [t]);
          return Ue(r.filter(function(s) {
            return !a.includes(s);
          }));
        }
        if (Un(t)) {
          var n = zv(t);
          return Ue(r.filter(function(s) {
            return s !== t && s !== n;
          }));
        }
      }
      if (Un(t) || t in ag)
        return Ue(e);
      throw new Z("Invalid excludedArea area config");
    }
    function fb(r, e, t) {
      t === void 0 && (t = Object.getOwnPropertyDescriptor(r, e));
      var a = t.value;
      return t.value = function() {
        for (var n = this, s = arguments.length, o = Array(s), u = 0; u < s; u++)
          o[u] = arguments[u];
        this.invokeTracker.apply(this, ["%s: ".concat(0 < o.length ? "%s with args: ".concat(o.map(function() {
          return "%o";
        })) : "%s"), this.name, e].concat(W(o.map(Ve))));
        try {
          var l = a.apply(this, o);
        } catch (d) {
          throw this.logError.apply(this, ["".concat(d.code !== void 0 ? "Error Code ".concat(d.code, ": ") : "", "%s failed").concat(0 < o.length ? " with args: ".concat(o.map(function() {
            return "%o";
          })) : ""), e].concat(W(o.map(Ve)))), d.originalError && this.logError(d.originalError), this.errorTracker(d), d;
        }
        var f = Date.now();
        return ja(M.mark(function d() {
          var h, p;
          return M.wrap(function(m) {
            for (; ; )
              switch (m.prev = m.next) {
                case 0:
                  return m.prev = 0, m.next = 3, l;
                case 3:
                  h = m.sent, m.next = 12;
                  break;
                case 6:
                  return m.prev = 6, m.t0 = m.catch(0), n.logError.apply(n, ["".concat(m.t0.code !== void 0 ? "Error Code ".concat(m.t0.code, ": ") : "", "%s failed").concat(0 < o.length ? " with args: ".concat(o.map(function() {
                    return "%o";
                  })) : ""), e].concat(W(o.map(Ve)))), m.t0.originalError && n.logError(m.t0.originalError), n.errorTracker(m.t0), m.abrupt("return");
                case 12:
                  h !== l ? h === void 0 ? n.resultTracker("%s promise resolves after %dms", e, Date.now() - f) : n.resultTracker("%s promise resolves after %dms, result is %o", e, Date.now() - f, Ve(h)) : Xc(h) !== "Object" || Be(h) ? n.resultTracker("%s result is %o", e, Ve(h)) : n.resultTracker("%s result is %s", e, h.name || ((p = h.constructor) === null || p === void 0 ? void 0 : p.name));
                case 13:
                case "end":
                  return m.stop();
              }
          }, d, null, [[0, 6]]);
        }))(), l;
      }, t;
    }
    function Ic(r, e, t) {
      t === void 0 && (t = Object.getOwnPropertyDescriptor(r, e));
      var a = t.value;
      return t.value = function() {
        for (var n = this, s = arguments.length, o = Array(s), u = 0; u < s; u++)
          o[u] = arguments[u];
        this.invokeTracker.apply(this, ["%s: ".concat(0 < o.length ? "%s with args: ".concat(o.map(function() {
          return "%o";
        })) : "%s"), this.name, e].concat(o));
        try {
          var l = a.apply(this, o);
        } catch (d) {
          throw this.logError.apply(this, ["".concat(d.code !== void 0 ? "Error Code ".concat(d.code, ": ") : "", "%s failed").concat(0 < o.length ? " with args: ".concat(o.map(function() {
            return "%o";
          })) : ""), e].concat(o)), d.originalError && this.logError(d.originalError), this.errorTracker(d), d;
        }
        var f = Date.now();
        return ja(M.mark(function d() {
          var h, p;
          return M.wrap(function(m) {
            for (; ; )
              switch (m.prev = m.next) {
                case 0:
                  return m.prev = 0, m.next = 3, l;
                case 3:
                  h = m.sent, m.next = 12;
                  break;
                case 6:
                  return m.prev = 6, m.t0 = m.catch(0), n.logError.apply(n, ["".concat(m.t0.code !== void 0 ? "Error Code ".concat(m.t0.code, ": ") : "", "%s failed").concat(0 < o.length ? " with args: ".concat(o.map(function() {
                    return "%o";
                  })) : ""), e].concat(o)), m.t0.originalError && n.logError(m.t0.originalError), n.errorTracker(m.t0), m.abrupt("return");
                case 12:
                  h !== l ? h === void 0 ? n.resultTracker("%s promise resolves after %dms", e, Date.now() - f) : n.resultTracker("%s promise resolves after %dms, result is %o", e, Date.now() - f, h) : Xc(h) !== "Object" || Be(h) ? n.resultTracker("%s result is %o", e, h) : n.resultTracker("%s result is %s", e, h.name || ((p = h.constructor) === null || p === void 0 ? void 0 : p.name));
                case 13:
                case "end":
                  return m.stop();
              }
          }, d, null, [[0, 6]]);
        }))(), l;
      }, t;
    }
    function Av(r, e) {
      var t = "".concat(r, "Uri");
      if (typeof (t = rj[t]) != "number" || t === 0)
        throw new TypeError("Got Unknown URI Name");
      return e = new (r = Vn[r])(e), e = r.encode(e).finish(), new Bv({ uri: t, data: e });
    }
    function Wn(r, e) {
      var t = Zf(null);
      return "".concat(r.split(".").join("-"), ".edge.").concat(t ? null : e ? "sd-rtn.com" : "agora.io");
    }
    function xb(r, e, t) {
      return sj.apply(this, arguments);
    }
    function sj() {
      return (sj = ja(M.mark(function r(e, t, a) {
        var n, s, o, u = arguments;
        return M.wrap(function(l) {
          for (; ; )
            switch (l.prev = l.next) {
              case 0:
                return n = 3 < u.length && u[3] !== void 0 && u[3], s = Cv[e].encode(t).finish(), o = function() {
                  var f = ja(M.mark(function d(h) {
                    var p, m, _, w = arguments;
                    return M.wrap(function(S) {
                      for (; ; )
                        switch (S.prev = S.next) {
                          case 0:
                            if (!(3 < (m = 1 < w.length && w[1] !== void 0 ? w[1] : 0))) {
                              S.next = 3;
                              break;
                            }
                            return S.abrupt("return");
                          case 3:
                            if (_ = Te(_ = a ? "https://".concat((p = ca == null ? void 0 : ca.PROXY_NGINX[0]) !== null && p !== void 0 ? p : "webrtc-cloud-proxy.sd-rtn.com", "/rs/?h=").concat(h, "&p=443&d=events/proto-raw") : "https://".concat(h, "/events/proto-raw"), "sentTs", Math.ceil(Date.now() / 1e3).toString()), _ = Te(_, "id", Dv[e].toString()), !n) {
                              S.next = 9;
                              break;
                            }
                            return S.next = 9, uv(1e4);
                          case 9:
                            return S.next = 11, jh(_, { body: s, timeout: 2e4, headers: { "Content-Type": "application/octet-stream" } }).catch(function(O) {
                              return o(h, m + 1);
                            });
                          case 11:
                          case "end":
                            return S.stop();
                        }
                    }, d);
                  }));
                  return function(d) {
                    return f.apply(this, arguments);
                  };
                }(), l.prev = 3, l.next = 6, o((ca == null ? void 0 : ca.EVENT_REPORT_DOMAIN[0]) || Zf(null) && null || "webcollector-rtm.agora.io");
              case 6:
                l.next = 12;
                break;
              case 8:
                return l.prev = 8, l.t0 = l.catch(3), l.next = 12, o(ca && Xn(1 < (ca == null ? void 0 : ca.EVENT_REPORT_DOMAIN.length) ? ca == null ? void 0 : ca.EVENT_REPORT_DOMAIN.slice(1) : ca == null ? void 0 : ca.EVENT_REPORT_DOMAIN) || "rtm.statscollector.sd-rtn.com");
              case 12:
              case "end":
                return l.stop();
            }
        }, r, null, [[3, 8]]);
      }))).apply(this, arguments);
    }
    function yb(r) {
      return r === void 0 ? ma.fromNumber(0) : ma.fromNumber(Date.now() - r);
    }
    function ph(r, e) {
      return ma.fromValue(r).eq(e);
    }
    function qh(r, e) {
      var t = e === void 0 ? r.val : e, a = r.isBoolean;
      e = r.isNumber;
      var n = r.oneof, s = r.len;
      if ([a, e, n].filter(function(o) {
        return !o;
      }).length !== 2)
        throw new TypeError("invalid field type");
      if (t !== void 0 && (r = !1, n !== void 0 && (n = tj(n), Ev(n, ph).length === n.length && Fv(n, function(o) {
        return ph(t, o);
      }) !== void 0 && (r = !0)), a = a !== void 0 && (t === 0 || t === 1) && s === 1, e = e !== void 0 && t.toString(2).length <= s, !(r || a || e)))
        throw Error("invalid field value");
    }
    function Yn(r) {
      return r.reduce(function(e, t) {
        return e.concat(t instanceof rh.UnsubscriptionError ? t.errors : t);
      }, []);
    }
    function Gv(r, e) {
      do
        bg == 2147483647 ? bg = 0 : bg++;
      while (We.hasOwnProperty(bg));
      var t = bg;
      return We[t] = { callback: r, parameters: Array.prototype.slice.call(arguments, 2) }, uj.postMessage({ name: "setInterval", fakeId: t, time: e }), t;
    }
    function Zn(r) {
      return function() {
        var e = r();
        if (!e)
          throw new aa("Client is not logged in. Cannot do the operation");
        return e;
      };
    }
    var Va = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof commonjsGlobal < "u" ? commonjsGlobal : typeof self < "u" ? self : {}, sh = function(r) {
      return r && r.Math == Math && r;
    }, Q = sh(typeof globalThis == "object" && globalThis) || sh(typeof window == "object" && window) || sh(typeof self == "object" && self) || sh(typeof Va == "object" && Va) || function() {
      return this;
    }() || Function("return this")(), ia = function(r) {
      try {
        return !!r();
      } catch {
        return !0;
      }
    }, ta = !ia(function() {
      return Object.defineProperty({}, 1, { get: function() {
        return 7;
      } })[1] != 7;
    }), $n = {}.propertyIsEnumerable, ao = Object.getOwnPropertyDescriptor, cg = ao && !$n.call({ 1: 2 }, 1) ? function(r) {
      return !!(r = ao(this, r)) && r.enumerable;
    } : $n, Jc = function(r, e) {
      return { enumerable: !(1 & r), configurable: !(2 & r), writable: !(4 & r), value: e };
    }, Hv = {}.toString, qc = function(r) {
      return Hv.call(r).slice(8, -1);
    }, Iv = "".split, dg = ia(function() {
      return !Object("z").propertyIsEnumerable(0);
    }) ? function(r) {
      return qc(r) == "String" ? Iv.call(r, "") : Object(r);
    } : Object, Bb = function(r) {
      if (r == null)
        throw TypeError("Can't call method on " + r);
      return r;
    }, Ib = function(r) {
      return dg(Bb(r));
    }, va = function(r) {
      return typeof r == "object" ? r !== null : typeof r == "function";
    }, Kc = function(r, e) {
      if (!va(r))
        return r;
      var t, a;
      if (e && typeof (t = r.toString) == "function" && !va(a = t.call(r)) || typeof (t = r.valueOf) == "function" && !va(a = t.call(r)) || !e && typeof (t = r.toString) == "function" && !va(a = t.call(r)))
        return a;
      throw TypeError("Can't convert object to primitive value");
    }, lb = function(r) {
      return Object(Bb(r));
    }, Jv = {}.hasOwnProperty, ha = function(r, e) {
      return Jv.call(lb(r), e);
    }, Xe = Q.document, th = va(Xe) && va(Xe.createElement), bo = !ta && !ia(function() {
      return Object.defineProperty(th ? Xe.createElement("div") : {}, "a", { get: function() {
        return 7;
      } }).a != 7;
    }), co = Object.getOwnPropertyDescriptor, Zb = { f: ta ? co : function(r, e) {
      if (r = Ib(r), e = Kc(e, !0), bo)
        try {
          return co(r, e);
        } catch {
        }
      if (ha(r, e))
        return Jc(!cg.call(r, e), r[e]);
    } }, Ia = function(r) {
      if (!va(r))
        throw TypeError(String(r) + " is not an object");
      return r;
    }, eo = Object.defineProperty, mb = { f: ta ? eo : function(r, e, t) {
      if (Ia(r), e = Kc(e, !0), Ia(t), bo)
        try {
          return eo(r, e, t);
        } catch {
        }
      if ("get" in t || "set" in t)
        throw TypeError("Accessors not supported");
      return "value" in t && (r[e] = t.value), r;
    } }, gb = ta ? function(r, e, t) {
      return mb.f(r, e, Jc(1, t));
    } : function(r, e, t) {
      return r[e] = t, r;
    }, vj = function(r, e) {
      try {
        gb(Q, r, e);
      } catch {
        Q[r] = e;
      }
      return e;
    }, yd = Q["__core-js_shared__"] || vj("__core-js_shared__", {}), Kv = Function.toString;
    typeof yd.inspectSource != "function" && (yd.inspectSource = function(r) {
      return Kv.call(r);
    });
    var wj = yd.inspectSource, fo = Q.WeakMap, Lv = typeof fo == "function" && /native code/.test(wj(fo)), zd = tb(function(r) {
      (r.exports = function(e, t) {
        return yd[e] || (yd[e] = t !== void 0 ? t : {});
      })("versions", []).push({ version: "3.12.1", mode: "global", copyright: "\xA9 2021 Denis Pushkarev (zloirock.ru)" });
    }), Mv = 0, Nv = Math.random(), Ye = function(r) {
      return "Symbol(" + String(r === void 0 ? "" : r) + ")_" + (++Mv + Nv).toString(36);
    }, go = zd("keys"), uh = function(r) {
      return go[r] || (go[r] = Ye(r));
    }, Ze = {}, Ov = Q.WeakMap;
    if (Lv || yd.state)
      var be = yd.state || (yd.state = new Ov()), Pv = be.get, ho = be.has, Qv = be.set, xj = function(r, e) {
        if (ho.call(be, r))
          throw new TypeError("Object already initialized");
        return e.facade = r, Qv.call(be, r, e), e;
      }, vh = function(r) {
        return Pv.call(be, r) || {};
      }, yj = function(r) {
        return ho.call(be, r);
      };
    else {
      var $e = uh("state");
      Ze[$e] = !0, xj = function(r, e) {
        if (ha(r, $e))
          throw new TypeError("Object already initialized");
        return e.facade = r, gb(r, $e, e), e;
      }, vh = function(r) {
        return ha(r, $e) ? r[$e] : {};
      }, yj = function(r) {
        return ha(r, $e);
      };
    }
    var Za = { set: xj, get: vh, has: yj, enforce: function(r) {
      return yj(r) ? vh(r) : xj(r, {});
    }, getterFor: function(r) {
      return function(e) {
        var t;
        if (!va(e) || (t = vh(e)).type !== r)
          throw TypeError("Incompatible receiver, " + r + " required");
        return t;
      };
    } }, Wa = tb(function(r) {
      var e = Za.get, t = Za.enforce, a = String(String).split("String");
      (r.exports = function(n, s, o, u) {
        var l = !!u && !!u.unsafe, f = !!u && !!u.enumerable;
        if (u = !!u && !!u.noTargetGet, typeof o == "function") {
          typeof s != "string" || ha(o, "name") || gb(o, "name", s);
          var d = t(o);
          d.source || (d.source = a.join(typeof s == "string" ? s : ""));
        }
        n === Q ? f ? n[s] = o : vj(s, o) : (l ? !u && n[s] && (f = !0) : delete n[s], f ? n[s] = o : gb(n, s, o));
      })(Function.prototype, "toString", function() {
        return typeof this == "function" && e(this).source || wj(this);
      });
    }), io = function(r) {
      return typeof r == "function" ? r : void 0;
    }, Lc = function(r, e) {
      return 2 > arguments.length ? io(Q[r]) || io(Q[r]) : Q[r] && Q[r][e] || Q[r] && Q[r][e];
    }, Rv = Math.ceil, Sv = Math.floor, rc = function(r) {
      return isNaN(r = +r) ? 0 : (0 < r ? Sv : Rv)(r);
    }, Tv = Math.min, La = function(r) {
      return 0 < r ? Tv(rc(r), 9007199254740991) : 0;
    }, Uv = Math.max, Vv = Math.min, Rb = function(r, e) {
      return 0 > (r = rc(r)) ? Uv(r + e, 0) : Vv(r, e);
    }, jo = function(r) {
      return function(e, t, a) {
        e = Ib(e);
        var n = La(e.length);
        if (a = Rb(a, n), r && t != t) {
          for (; n > a; )
            if ((t = e[a++]) != t)
              return !0;
        } else
          for (; n > a; a++)
            if ((r || a in e) && e[a] === t)
              return r || a || 0;
        return !r && -1;
      };
    }, ko = jo(!0), zj = jo(!1), lo = function(r, e) {
      r = Ib(r);
      var t, a = 0, n = [];
      for (t in r)
        !ha(Ze, t) && ha(r, t) && n.push(t);
      for (; e.length > a; )
        ha(r, t = e[a++]) && (~zj(n, t) || n.push(t));
      return n;
    }, wh = "constructor hasOwnProperty isPrototypeOf propertyIsEnumerable toLocaleString toString valueOf".split(" "), Wv = wh.concat("length", "prototype"), ce = { f: Object.getOwnPropertyNames || function(r) {
      return lo(r, Wv);
    } }, eg = { f: Object.getOwnPropertySymbols }, mo = Lc("Reflect", "ownKeys") || function(r) {
      var e = ce.f(Ia(r)), t = eg.f;
      return t ? e.concat(t(r)) : e;
    }, no = function(r, e) {
      for (var t = mo(e), a = mb.f, n = Zb.f, s = 0; s < t.length; s++) {
        var o = t[s];
        ha(r, o) || a(r, o, n(e, o));
      }
    }, Xv = /#|\.prototype\./, Mc = function(r, e) {
      return (r = Yv[Zv(r)]) == $v || r != aw && (typeof e == "function" ? ia(e) : !!e);
    }, Zv = Mc.normalize = function(r) {
      return String(r).replace(Xv, ".").toLowerCase();
    }, Yv = Mc.data = {}, aw = Mc.NATIVE = "N", $v = Mc.POLYFILL = "P", bw = Zb.f, ba = function(r, e) {
      var t, a, n, s = r.target, o = r.global, u = r.stat;
      if (a = o ? Q : u ? Q[s] || vj(s, {}) : (Q[s] || {}).prototype)
        for (n in e) {
          var l = e[n], f = r.noTargetGet ? (t = bw(a, n)) && t.value : a[n];
          if (!(t = Mc(o ? n : s + (u ? "." : "#") + n, r.forced)) && f !== void 0) {
            if (typeof l == typeof f)
              continue;
            no(l, f);
          }
          (r.sham || f && f.sham) && gb(l, "sham", !0);
          try {
            Wa(a, n, l, r);
          } catch {
          }
        }
    }, Aj = function() {
      var r = Ia(this), e = "";
      return r.global && (e += "g"), r.ignoreCase && (e += "i"), r.multiline && (e += "m"), r.dotAll && (e += "s"), r.unicode && (e += "u"), r.sticky && (e += "y"), e;
    }, Nc = ia(function() {
      var r = /a/y;
      return r.lastIndex = 2, r.exec("abcd") != null;
    }), cw = ia(function() {
      var r = /^r/gy;
      return r.lastIndex = 2, r.exec("str") != null;
    }), xh = RegExp.prototype.exec, dw = zd("native-string-replace", String.prototype.replace), oo = xh, Bj = (c = /a/, b = /b*/g, xh.call(c, "a"), xh.call(b, "a"), c.lastIndex !== 0 || b.lastIndex !== 0), po = Nc || cw, Cj = /()??/.exec("")[1] !== void 0, c, b;
    (Bj || Cj || po) && (oo = function(r) {
      var e, t = po && this.sticky, a = Aj.call(this), n = this.source, s = 0, o = r;
      if (t) {
        (a = a.replace("y", "")).indexOf("g") === -1 && (a += "g"), o = String(r).slice(this.lastIndex), 0 < this.lastIndex && (!this.multiline || this.multiline && r[this.lastIndex - 1] !== `
`) && (n = "(?: " + n + ")", o = " " + o, s++);
        var u = new RegExp("^(?:" + n + ")", a);
      }
      if (Cj && (u = new RegExp("^" + n + "$(?!\\s)", a)), Bj)
        var l = this.lastIndex;
      var f = xh.call(t ? u : this, o);
      return t ? f ? (f.input = f.input.slice(s), f[0] = f[0].slice(s), f.index = this.lastIndex, this.lastIndex += f[0].length) : this.lastIndex = 0 : Bj && f && (this.lastIndex = this.global ? f.index + f[0].length : l), Cj && f && 1 < f.length && dw.call(f[0], u, function() {
        for (e = 1; e < arguments.length - 2; e++)
          arguments[e] === void 0 && (f[e] = void 0);
      }), f;
    });
    var fg = oo;
    ba({ target: "RegExp", proto: !0, forced: /./.exec !== fg }, { exec: fg });
    var af = Lc("navigator", "userAgent") || "", qo = Q.process, ro = qo && qo.versions, so = ro && ro.v8;
    if (so)
      var Ad = so.split("."), Dj = 4 > Ad[0] ? 1 : Ad[0] + Ad[1];
    else
      af && (Ad = af.match(/Edge\/(\d+)/), (!Ad || 74 <= Ad[1]) && (Ad = af.match(/Chrome\/(\d+)/)) && (Dj = Ad[1]));
    var Bd = Dj && +Dj, Oc = !!Object.getOwnPropertySymbols && !ia(function() {
      return !String(Symbol()) || !Symbol.sham && Bd && 41 > Bd;
    }), to = Oc && !Symbol.sham && typeof Symbol.iterator == "symbol", gg = zd("wks"), hg = Q.Symbol, ew = to ? hg : hg && hg.withoutSetter || Ye, Ea = function(r) {
      return ha(gg, r) && (Oc || typeof gg[r] == "string") || (Oc && ha(hg, r) ? gg[r] = hg[r] : gg[r] = ew("Symbol." + r)), gg[r];
    }, fw = Ea("species"), Ej = RegExp.prototype, gw = !ia(function() {
      var r = /./;
      return r.exec = function() {
        var e = [];
        return e.groups = { a: "7" }, e;
      }, "".replace(r, "$<a>") !== "7";
    }), uo = "a".replace(/./, "$0") === "$0", vo = Ea("replace"), wo = !!/./[vo] && /./[vo]("a", "$0") === "", hw = !ia(function() {
      var r = /(?:)/, e = r.exec;
      return r.exec = function() {
        return e.apply(this, arguments);
      }, (r = "ab".split(r)).length !== 2 || r[0] !== "a" || r[1] !== "b";
    }), yh = function(r, e, t, a) {
      var n = Ea(r), s = !ia(function() {
        var f = {};
        return f[n] = function() {
          return 7;
        }, ""[r](f) != 7;
      }), o = s && !ia(function() {
        var f = !1, d = /a/;
        return r === "split" && ((d = { constructor: {} }).constructor[fw] = function() {
          return d;
        }, d.flags = "", d[n] = /./[n]), d.exec = function() {
          return f = !0, null;
        }, d[n](""), !f;
      });
      if (!s || !o || r === "replace" && (!gw || !uo || wo) || r === "split" && !hw) {
        var u = /./[n], l = (t = t(n, ""[r], function(f, d, h, p, m) {
          var _ = d.exec;
          return _ === fg || _ === Ej.exec ? s && !m ? { done: !0, value: u.call(d, h, p) } : { done: !0, value: f.call(h, d, p) } : { done: !1 };
        }, { REPLACE_KEEPS_$0: uo, REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE: wo }))[1];
        Wa(String.prototype, r, t[0]), Wa(Ej, n, e == 2 ? function(f, d) {
          return l.call(f, this, d);
        } : function(f) {
          return l.call(f, this);
        });
      }
      a && gb(Ej[n], "sham", !0);
    }, iw = Ea("match"), Fj = function(r) {
      var e;
      return va(r) && ((e = r[iw]) !== void 0 ? !!e : qc(r) == "RegExp");
    }, Sb = function(r) {
      if (typeof r != "function")
        throw TypeError(String(r) + " is not a function");
      return r;
    }, jw = Ea("species"), de = function(r, e) {
      var t;
      return (r = Ia(r).constructor) === void 0 || (t = Ia(r)[jw]) == null ? e : Sb(t);
    }, xo = function(r) {
      return function(e, t) {
        e = String(Bb(e)), t = rc(t);
        var a, n = e.length;
        if (0 > t || t >= n)
          return r ? "" : void 0;
        var s = e.charCodeAt(t);
        return 55296 > s || 56319 < s || t + 1 === n || 56320 > (a = e.charCodeAt(t + 1)) || 57343 < a ? r ? e.charAt(t) : s : r ? e.slice(t, t + 2) : a - 56320 + (s - 55296 << 10) + 65536;
      };
    }, kw = xo(!1), yo = xo(!0), Gj = function(r, e, t) {
      return e + (t ? yo(r, e).length : 1);
    }, bf = function(r, e) {
      var t = r.exec;
      if (typeof t == "function") {
        if (typeof (r = t.call(r, e)) != "object")
          throw TypeError("RegExp exec method returned something other than an Object or null");
        return r;
      }
      if (qc(r) !== "RegExp")
        throw TypeError("RegExp#exec called on incompatible receiver");
      return fg.call(r, e);
    }, lw = [].push, mw = Math.min;
    yh("split", 2, function(r, e, t) {
      var a = "abbc".split(/(b)*/)[1] == "c" || "test".split(/(?:)/, -1).length != 4 || "ab".split(/(?:ab)*/).length != 2 || ".".split(/(.?)(.?)/).length != 4 || 1 < ".".split(/()()/).length || "".split(/.?/).length ? function(n, s) {
        var o = String(Bb(this));
        if ((s = s === void 0 ? 4294967295 : s >>> 0) === 0)
          return [];
        if (n === void 0)
          return [o];
        if (!Fj(n))
          return e.call(o, n, s);
        var u, l, f, d = [], h = 0;
        for (n = new RegExp(n.source, (n.ignoreCase ? "i" : "") + (n.multiline ? "m" : "") + (n.unicode ? "u" : "") + (n.sticky ? "y" : "") + "g"); (u = fg.call(n, o)) && !((l = n.lastIndex) > h && (d.push(o.slice(h, u.index)), 1 < u.length && u.index < o.length && lw.apply(d, u.slice(1)), f = u[0].length, h = l, d.length >= s)); )
          n.lastIndex === u.index && n.lastIndex++;
        return h === o.length ? (f || !n.test("")) && d.push("") : d.push(o.slice(h)), d.length > s ? d.slice(0, s) : d;
      } : "0".split(void 0, 0).length ? function(n, s) {
        return n === void 0 && s === 0 ? [] : e.call(this, n, s);
      } : e;
      return [function(n, s) {
        var o = Bb(this), u = n == null ? void 0 : n[r];
        return u !== void 0 ? u.call(n, o, s) : a.call(String(o), n, s);
      }, function(n, s) {
        var o = t(a, n, this, s, a !== e);
        if (o.done)
          return o.value;
        var u = Ia(n);
        n = String(this);
        var l = de(u, RegExp);
        if (o = u.unicode, u = new l(Nc ? "^(?:" + u.source + ")" : u, (u.ignoreCase ? "i" : "") + (u.multiline ? "m" : "") + (u.unicode ? "u" : "") + (Nc ? "g" : "y")), (s = s === void 0 ? 4294967295 : s >>> 0) === 0)
          return [];
        if (n.length === 0)
          return bf(u, n) === null ? [n] : [];
        var f = 0, d = 0;
        for (l = []; d < n.length; ) {
          u.lastIndex = Nc ? 0 : d;
          var h, p = bf(u, Nc ? n.slice(d) : n);
          if (p === null || (h = mw(La(u.lastIndex + (Nc ? d : 0)), n.length)) === f)
            d = Gj(n, d, o);
          else {
            if (l.push(n.slice(f, d)), l.length === s)
              return l;
            for (f = 1; f <= p.length - 1; f++)
              if (l.push(p[f]), l.length === s)
                return l;
            d = f = h;
          }
        }
        return l.push(n.slice(f)), l;
      }];
    }, Nc);
    var nw = /^[\t\n\x0B\f\r \u00a0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029\ufeff][\t\n\x0B\f\r \u00a0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029\ufeff]*/, ow = /[\t\n\x0B\f\r \u00a0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029\ufeff][\t\n\x0B\f\r \u00a0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u202f\u205f\u3000\u2028\u2029\ufeff]*$/, Hj = function(r) {
      return function(e) {
        return e = String(Bb(e)), 1 & r && (e = e.replace(nw, "")), 2 & r && (e = e.replace(ow, "")), e;
      };
    }, Ij = Hj(3), zh = Q.parseInt, pw = /^[+-]?0[Xx]/, zo = zh(`	
\v\f\r \xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF08`) !== 8 || zh(`	
\v\f\r \xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF0x16`) !== 22 ? function(r, e) {
      return r = Ij(String(r)), zh(r, e >>> 0 || (pw.test(r) ? 16 : 10));
    } : zh;
    ba({ global: !0, forced: parseInt != zo }, { parseInt: zo });
    var Cd = function(r, e, t) {
      if (Sb(r), e === void 0)
        return r;
      switch (t) {
        case 0:
          return function() {
            return r.call(e);
          };
        case 1:
          return function(a) {
            return r.call(e, a);
          };
        case 2:
          return function(a, n) {
            return r.call(e, a, n);
          };
        case 3:
          return function(a, n, s) {
            return r.call(e, a, n, s);
          };
      }
      return function() {
        return r.apply(e, arguments);
      };
    }, Dd = Array.isArray || function(r) {
      return qc(r) == "Array";
    }, qw = Ea("species"), Ah = function(r, e) {
      if (Dd(r)) {
        var t = r.constructor;
        typeof t != "function" || t !== Array && !Dd(t.prototype) ? va(t) && (t = t[qw]) === null && (t = void 0) : t = void 0;
      }
      return new (t === void 0 ? Array : t)(e === 0 ? 0 : e);
    }, Ao = [].push, Ed = function(r) {
      var e = r == 1, t = r == 2, a = r == 3, n = r == 4, s = r == 6, o = r == 7, u = r == 5 || s;
      return function(l, f, d, h) {
        var p = lb(l), m = dg(p);
        f = Cd(f, d, 3), d = La(m.length);
        var _, w = 0;
        for (h = h || Ah, l = e ? h(l, d) : t || o ? h(l, 0) : void 0; d > w; w++)
          if ((u || w in m) && (_ = f(h = m[w], w, p), r))
            if (e)
              l[w] = _;
            else if (_)
              switch (r) {
                case 3:
                  return !0;
                case 5:
                  return h;
                case 6:
                  return w;
                case 2:
                  Ao.call(l, h);
              }
            else
              switch (r) {
                case 4:
                  return !1;
                case 7:
                  Ao.call(l, h);
              }
        return s ? -1 : a || n ? n : l;
      };
    }, ee = Ed(0), Bo = Ed(1), Co = Ed(2), rw = Ed(3), sw = Ed(4), Do = Ed(5), tw = Ed(6), uw = Ea("species"), ig = function(r) {
      return 51 <= Bd || !ia(function() {
        var e = [];
        return (e.constructor = {})[uw] = function() {
          return { foo: 1 };
        }, e[r](Boolean).foo !== 1;
      });
    }, vw = ig("filter");
    ba({ target: "Array", proto: !0, forced: !vw }, { filter: function(r) {
      return Co(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } });
    var $c = Object.keys || function(r) {
      return lo(r, wh);
    }, ww = ia(function() {
      $c(1);
    });
    ba({ target: "Object", stat: !0, forced: ww }, { keys: function(r) {
      return $c(lb(r));
    } });
    var cf = function(r, e) {
      var t = [][r];
      return !!t && ia(function() {
        t.call(null, e || function() {
          throw 1;
        }, 1);
      });
    }, xw = [].join, yw = dg != Object, zw = cf("join", ",");
    ba({ target: "Array", proto: !0, forced: yw || !zw }, { join: function(r) {
      return xw.call(Ib(this), r === void 0 ? "," : r);
    } });
    var Aw = ig("map");
    ba({ target: "Array", proto: !0, forced: !Aw }, { map: function(r) {
      return Bo(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } });
    var Jj = function(r) {
      var e = r.return;
      if (e !== void 0)
        return Ia(e.call(r)).value;
    }, df = {}, Bw = Ea("iterator"), Cw = Array.prototype, Kj = function(r) {
      return r !== void 0 && (df.Array === r || Cw[Bw] === r);
    }, ef = function(r, e, t) {
      (e = Kc(e)) in r ? mb.f(r, e, Jc(0, t)) : r[e] = t;
    }, Dw = Ea("toStringTag"), Eo = {};
    Eo[Dw] = "z";
    var Lj = String(Eo) === "[object z]", Ew = Ea("toStringTag"), Fw = qc(function() {
      return arguments;
    }()) == "Arguments", ff = Lj ? qc : function(r) {
      var e;
      if (r === void 0)
        var t = "Undefined";
      else {
        if (r === null)
          var a = "Null";
        else {
          e: {
            var n = r = Object(r);
            try {
              a = n[Ew];
              break e;
            } catch {
            }
            a = void 0;
          }
          a = typeof (t = a) == "string" ? t : Fw ? qc(r) : (e = qc(r)) == "Object" && typeof r.callee == "function" ? "Arguments" : e;
        }
        t = a;
      }
      return t;
    }, Gw = Ea("iterator"), jg = function(r) {
      if (r != null)
        return r[Gw] || r["@@iterator"] || df[ff(r)];
    }, fe = function(r) {
      var e, t = lb(r), a = typeof this == "function" ? this : Array, n = arguments.length, s = 1 < n ? arguments[1] : void 0, o = s !== void 0, u = jg(t), l = 0;
      if (o && (s = Cd(s, 2 < n ? arguments[2] : void 0, 2)), u == null || a == Array && Kj(u)) {
        var f = La(t.length);
        for (a = new a(f); f > l; l++)
          u = o ? s(t[l], l) : t[l], ef(a, l, u);
      } else
        for (n = (t = u.call(t)).next, a = new a(); !(e = n.call(t)).done; l++) {
          if (o) {
            u = t;
            var d = s;
            e = [e.value, l];
            try {
              f = d(Ia(e)[0], e[1]);
            } catch (h) {
              throw Jj(u), h;
            }
          } else
            f = e.value;
          ef(a, l, u = f);
        }
      return a.length = l, a;
    }, Fo = Ea("iterator"), Go = !1;
    try {
      var Hw = 0, Ho = { next: function() {
        return { done: !!Hw++ };
      }, return: function() {
        Go = !0;
      } };
      Ho[Fo] = function() {
        return this;
      }, Array.from(Ho, function() {
        throw 2;
      });
    } catch (r) {
    }
    var Bh = function(r, e) {
      if (!e && !Go)
        return !1;
      var t = !1;
      try {
        (e = {})[Fo] = function() {
          return { next: function() {
            return { done: t = !0 };
          } };
        }, r(e);
      } catch {
      }
      return t;
    }, Iw = !Bh(function(r) {
      Array.from(r);
    });
    ba({ target: "Array", stat: !0, forced: Iw }, { from: fe });
    var Io = !ia(function() {
      function r() {
      }
      return r.prototype.constructor = null, Object.getPrototypeOf(new r()) !== r.prototype;
    }), Jo = uh("IE_PROTO"), Jw = Object.prototype, nc = Io ? Object.getPrototypeOf : function(r) {
      return r = lb(r), ha(r, Jo) ? r[Jo] : typeof r.constructor == "function" && r instanceof r.constructor ? r.constructor.prototype : r instanceof Object ? Jw : null;
    }, Mj = Ea("iterator"), Ko = !1, Kw = function() {
      return this;
    }, ge;
    if ([].keys) {
      var Lo = [].keys();
      if ("next" in Lo) {
        var Mo = nc(nc(Lo));
        Mo !== Object.prototype && (ge = Mo);
      } else
        Ko = !0;
    }
    (ge == null || ia(function() {
      var r = {};
      return ge[Mj].call(r) !== r;
    })) && (ge = {}), ha(ge, Mj) || gb(ge, Mj, Kw);
    var Ch = ge, Dh = Ko, No = ta ? Object.defineProperties : function(r, e) {
      Ia(r);
      for (var t, a = $c(e), n = a.length, s = 0; n > s; )
        mb.f(r, t = a[s++], e[t]);
      return r;
    }, Nj = Lc("document", "documentElement"), Oo = uh("IE_PROTO"), Oj = function() {
    }, Pj, Eh = function() {
      try {
        Pj = document.domain && new ActiveXObject("htmlfile");
      } catch {
      }
      if (Pj) {
        var r = Pj;
        r.write("<script><\/script>"), r.close(), r = r.parentWindow.Object;
      } else
        (r = th ? Xe.createElement("iframe") : {}).style.display = "none", Nj.appendChild(r), r.src = "javascript:", (r = r.contentWindow.document).open(), r.write("<script>document.F=Object<\/script>"), r.close(), r = r.F;
      for (Eh = r, r = wh.length; r--; )
        delete Eh.prototype[wh[r]];
      return Eh();
    };
    Ze[Oo] = !0;
    var ec = Object.create || function(r, e) {
      if (r !== null) {
        Oj.prototype = Ia(r);
        var t = new Oj();
        Oj.prototype = null, t[Oo] = r;
      } else
        t = Eh();
      return e === void 0 ? t : No(t, e);
    }, Lw = mb.f, Po = Ea("toStringTag"), sc = function(r, e, t) {
      r && !ha(r = t ? r : r.prototype, Po) && Lw(r, Po, { configurable: !0, value: e });
    }, Mw = function() {
      return this;
    }, Qo = function(r, e, t) {
      return e += " Iterator", r.prototype = ec(Ch, { next: Jc(1, t) }), sc(r, e, !1), df[e] = Mw, r;
    }, ob = Object.setPrototypeOf || ("__proto__" in {} ? function() {
      var r = !1, e = {};
      try {
        var t = Object.getOwnPropertyDescriptor(Object.prototype, "__proto__").set;
        t.call(e, []), r = e instanceof Array;
      } catch {
      }
      return function(a, n) {
        if (Ia(a), !va(n) && n !== null)
          throw TypeError("Can't set " + String(n) + " as a prototype");
        return r ? t.call(a, n) : a.__proto__ = n, a;
      };
    }() : void 0), kg = Ea("iterator"), Nw = function() {
      return this;
    }, Qj = function(r, e, t, a, n, s, o) {
      Qo(t, e, a), a = function(w) {
        if (w === n && p)
          return p;
        if (!Dh && w in d)
          return d[w];
        switch (w) {
          case "keys":
          case "values":
          case "entries":
            return function() {
              return new t(this, w);
            };
        }
        return function() {
          return new t(this);
        };
      };
      var u, l = e + " Iterator", f = !1, d = r.prototype, h = d[kg] || d["@@iterator"] || n && d[n], p = !Dh && h || a(n), m = e == "Array" && d.entries || h;
      if (m && (r = nc(m.call(new r())), Ch !== Object.prototype && r.next && (nc(r) !== Ch && (ob ? ob(r, Ch) : typeof r[kg] != "function" && gb(r, kg, Nw)), sc(r, l, !0))), n == "values" && h && h.name !== "values" && (f = !0, p = function() {
        return h.call(this);
      }), d[kg] !== p && gb(d, kg, p), df[e] = p, n) {
        var _ = { values: a("values"), keys: s ? p : a("keys"), entries: a("entries") };
        if (o)
          for (u in _)
            !Dh && !f && u in d || Wa(d, u, _[u]);
        else
          ba({ target: e, proto: !0, forced: Dh || f }, _);
      }
      return _;
    }, Ow = Za.set, Pw = Za.getterFor("String Iterator");
    Qj(String, "String", function(r) {
      Ow(this, { type: "String Iterator", string: String(r), index: 0 });
    }, function() {
      var r = Pw(this), e = r.string, t = r.index;
      return t >= e.length ? { value: void 0, done: !0 } : (e = yo(e, t), r.index += e.length, { value: e, done: !1 });
    });
    var Rj = Ea("unscopables"), Sj = Array.prototype;
    Sj[Rj] == null && mb.f(Sj, Rj, { configurable: !0, value: ec(null) });
    var lg = function(r) {
      Sj[Rj][r] = !0;
    }, Ro = !0;
    "find" in [] && Array(1).find(function() {
      Ro = !1;
    }), ba({ target: "Array", proto: !0, forced: Ro }, { find: function(r) {
      return Do(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } }), lg("find");
    var So = function(r) {
      var e = String(Bb(this)), t = "";
      if (0 > (r = rc(r)) || 1 / 0 == r)
        throw RangeError("Wrong number of repetitions");
      for (; 0 < r; (r >>>= 1) && (e += e))
        1 & r && (t += e);
      return t;
    };
    ba({ target: "String", proto: !0 }, { repeat: So });
    var To = [].indexOf, Uo = !!To && 0 > 1 / [1].indexOf(1, -0), Qw = cf("indexOf");
    ba({ target: "Array", proto: !0, forced: Uo || !Qw }, { indexOf: function(r) {
      return Uo ? To.apply(this, arguments) || 0 : zj(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } });
    var Rt = /(android|bb\d+|meego).+mobile|armv7l|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series[46]0|samsungbrowser|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i, St = /CrOS/, Tt = /android|ipad|playbook|silk/i;
    Ae.isMobile = Ae, Ae.default = Ae, ba({ target: "Number", stat: !0 }, { MAX_SAFE_INTEGER: 9007199254740991 }), ba({ target: "Number", stat: !0 }, { isNaN: function(r) {
      return r != r;
    } }), Q.Number.isNaN;
    var Rw = Lj ? {}.toString : function() {
      return "[object " + ff(this) + "]";
    };
    Lj || Wa(Object.prototype, "toString", Rw, { unsafe: !0 });
    var Fh = Q.Promise, gf = function(r, e, t) {
      for (var a in e)
        Wa(r, a, e[a], t);
      return r;
    }, Vo = Ea("species"), mg = function(r) {
      r = Lc(r);
      var e = mb.f;
      ta && r && !r[Vo] && e(r, Vo, { configurable: !0, get: function() {
        return this;
      } });
    }, tc = function(r, e, t) {
      if (!(r instanceof e))
        throw TypeError("Incorrect " + (t ? t + " " : "") + "invocation");
      return r;
    }, ng = function(r, e) {
      this.stopped = r, this.result = e;
    }, Gh = function(r, e, t) {
      var a, n = !(!t || !t.AS_ENTRIES), s = !(!t || !t.IS_ITERATOR), o = !(!t || !t.INTERRUPTED), u = Cd(e, t && t.that, 1 + n + o), l = function(d) {
        return f && Jj(f), new ng(!0, d);
      };
      if (e = function(d) {
        return n ? (Ia(d), o ? u(d[0], d[1], l) : u(d[0], d[1])) : o ? u(d, l) : u(d);
      }, s)
        var f = r;
      else {
        if (typeof (s = jg(r)) != "function")
          throw TypeError("Target is not iterable");
        if (Kj(s)) {
          for (s = 0, t = La(r.length); t > s; s++)
            if ((a = e(r[s])) && a instanceof ng)
              return a;
          return new ng(!1);
        }
        f = s.call(r);
      }
      for (r = f.next; !(s = r.call(f)).done; ) {
        try {
          a = e(s.value);
        } catch (d) {
          throw Jj(f), d;
        }
        if (typeof a == "object" && a && a instanceof ng)
          return a;
      }
      return new ng(!1);
    }, Wo = /(?:iphone|ipod|ipad).*applewebkit/i.test(af), ad = qc(Q.process) == "process", Hh = Q.location, Tj = Q.setImmediate, Xo = Q.clearImmediate, Sw = Q.process, Yo = Q.MessageChannel, Uj = Q.Dispatch, Vj = 0, og = {}, Wj = function(r) {
      if (og.hasOwnProperty(r)) {
        var e = og[r];
        delete og[r], e();
      }
    }, Xj = function(r) {
      return function() {
        Wj(r);
      };
    }, Zo = function(r) {
      Wj(r.data);
    }, $o = function(r) {
      Q.postMessage(r + "", Hh.protocol + "//" + Hh.host);
    };
    if (!Tj || !Xo)
      if (Tj = function(r) {
        for (var e = [], t = 1; arguments.length > t; )
          e.push(arguments[t++]);
        return og[++Vj] = function() {
          (typeof r == "function" ? r : Function(r)).apply(void 0, e);
        }, pg(Vj), Vj;
      }, Xo = function(r) {
        delete og[r];
      }, ad)
        var pg = function(r) {
          Sw.nextTick(Xj(r));
        };
      else if (Uj && Uj.now)
        pg = function(r) {
          Uj.now(Xj(r));
        };
      else if (Yo && !Wo) {
        var ap = new Yo(), bp = ap.port2;
        ap.port1.onmessage = Zo, pg = Cd(bp.postMessage, bp, 1);
      } else
        Q.addEventListener && typeof postMessage == "function" && !Q.importScripts && Hh && Hh.protocol !== "file:" && !ia($o) ? (pg = $o, Q.addEventListener("message", Zo, !1)) : pg = "onreadystatechange" in (th ? Xe.createElement("script") : {}) ? function(r) {
          Nj.appendChild(th ? Xe.createElement("script") : {}).onreadystatechange = function() {
            Nj.removeChild(this), Wj(r);
          };
        } : function(r) {
          setTimeout(Xj(r), 0);
        };
    var Yj = Tj, Tw = /web0s(?!.*chrome)/i.test(af), Uw = Zb.f, cp = Q.MutationObserver || Q.WebKitMutationObserver, dp = Q.document, ep = Q.process, Ih = Q.Promise, fp = Uw(Q, "queueMicrotask"), gp = fp && fp.value, he, qg;
    if (!gp) {
      var Kh = function() {
        var r;
        for (ad && (r = ep.domain) && r.exit(); he; ) {
          var e = he.fn;
          he = he.next;
          try {
            e();
          } catch (t) {
            throw he ? Jh() : qg = void 0, t;
          }
        }
        qg = void 0, r && r.enter();
      };
      if (Wo || ad || Tw || !cp || !dp)
        if (Ih && Ih.resolve) {
          var Zj = Ih.resolve(void 0);
          Zj.constructor = Ih;
          var Vw = Zj.then, Jh = function() {
            Vw.call(Zj, Kh);
          };
        } else
          Jh = ad ? function() {
            ep.nextTick(Kh);
          } : function() {
            Yj.call(Q, Kh);
          };
      else {
        var hp = !0, ip = dp.createTextNode("");
        new cp(Kh).observe(ip, { characterData: !0 }), Jh = function() {
          ip.data = hp = !hp;
        };
      }
    }
    var jp = gp || function(r) {
      r = { fn: r, next: void 0 }, qg && (qg.next = r), he || (he = r, Jh()), qg = r;
    }, Ww = function(r) {
      var e, t;
      this.promise = new r(function(a, n) {
        if (e !== void 0 || t !== void 0)
          throw TypeError("Bad Promise constructor");
        e = a, t = n;
      }), this.resolve = Sb(e), this.reject = Sb(t);
    }, ak = { f: function(r) {
      return new Ww(r);
    } }, Xw = function(r, e) {
      var t = Q.console;
      t && t.error && (arguments.length === 1 ? t.error(r) : t.error(r, e));
    }, bk = function(r) {
      try {
        return { error: !1, value: r() };
      } catch (e) {
        return { error: !0, value: e };
      }
    }, Yw = typeof window == "object", Zw = Ea("species"), kp = Za.get, $w = Za.set, ax = Za.getterFor("Promise"), ie = Fh && Fh.prototype, Tb = Fh, Lh = ie, lp = Q.TypeError, ck = Q.document, dk = Q.process, hf = ak.f, bx = hf, cx = !!(ck && ck.createEvent && Q.dispatchEvent), mp = typeof PromiseRejectionEvent == "function", np = !1, rg = Mc("Promise", function() {
      var r = wj(Tb) !== String(Tb);
      if (!r && Bd === 66)
        return !0;
      if (51 <= Bd && /native code/.test(Tb))
        return !1;
      var e = new Tb(function(a) {
        a(1);
      }), t = function(a) {
        a(function() {
        }, function() {
        });
      };
      return (e.constructor = {})[Zw] = t, !(np = e.then(function() {
      }) instanceof t) || !r && Yw && !mp;
    }), dx = rg || !Bh(function(r) {
      Tb.all(r).catch(function() {
      });
    }), op = function(r) {
      var e;
      return !(!va(r) || typeof (e = r.then) != "function") && e;
    }, ek = function(r, e) {
      if (!r.notified) {
        r.notified = !0;
        var t = r.reactions;
        jp(function() {
          for (var a = r.value, n = r.state == 1, s = 0; t.length > s; ) {
            var o, u = t[s++], l = n ? u.ok : u.fail, f = u.resolve, d = u.reject, h = u.domain;
            try {
              if (l) {
                if (n || (r.rejection === 2 && ex(r), r.rejection = 1), l === !0)
                  var p = a;
                else if (h && h.enter(), p = l(a), h) {
                  h.exit();
                  var m = !0;
                }
                p === u.promise ? d(lp("Promise-chain cycle")) : (o = op(p)) ? o.call(p, f, d) : f(p);
              } else
                d(a);
            } catch (_) {
              h && !m && h.exit(), d(_);
            }
          }
          r.reactions = [], r.notified = !1, e && !r.rejection && fx(r);
        });
      }
    }, pp = function(r, e, t) {
      var a;
      if (cx) {
        var n = ck.createEvent("Event");
        n.promise = e, n.reason = t, n.initEvent(r, !1, !0), Q.dispatchEvent(n);
      } else
        n = { promise: e, reason: t };
      !mp && (a = Q["on" + r]) ? a(n) : r === "unhandledrejection" && Xw("Unhandled promise rejection", t);
    }, fx = function(r) {
      Yj.call(Q, function() {
        var e = r.facade, t = r.value;
        if (r.rejection !== 1 && !r.parent) {
          var a = bk(function() {
            ad ? dk.emit("unhandledRejection", t, e) : pp("unhandledrejection", e, t);
          });
          if (r.rejection = ad || r.rejection !== 1 && !r.parent ? 2 : 1, a.error)
            throw a.value;
        }
      });
    }, ex = function(r) {
      Yj.call(Q, function() {
        var e = r.facade;
        ad ? dk.emit("rejectionHandled", e) : pp("rejectionhandled", e, r.value);
      });
    }, jf = function(r, e, t) {
      return function(a) {
        r(e, a, t);
      };
    }, kf = function(r, e, t) {
      r.done || (r.done = !0, t && (r = t), r.value = e, r.state = 2, ek(r, !0));
    }, fk = function(r, e, t) {
      if (!r.done) {
        r.done = !0, t && (r = t);
        try {
          if (r.facade === e)
            throw lp("Promise can't be resolved itself");
          var a = op(e);
          a ? jp(function() {
            var n = { done: !1 };
            try {
              a.call(e, jf(fk, n, r), jf(kf, n, r));
            } catch (s) {
              kf(n, s, r);
            }
          }) : (r.value = e, r.state = 1, ek(r, !1));
        } catch (n) {
          kf({ done: !1 }, n, r);
        }
      }
    };
    if (rg) {
      Tb = function(r) {
        tc(this, Tb, "Promise"), Sb(r), gk.call(this);
        var e = kp(this);
        try {
          r(jf(fk, e), jf(kf, e));
        } catch (t) {
          kf(e, t);
        }
      }, Lh = Tb.prototype;
      var gk = function(r) {
        $w(this, { type: "Promise", done: !1, notified: !1, parent: !1, reactions: [], rejection: !1, state: 0, value: void 0 });
      };
      gk.prototype = gf(Lh, { then: function(r, e) {
        var t = ax(this), a = hf(de(this, Tb));
        return a.ok = typeof r != "function" || r, a.fail = typeof e == "function" && e, a.domain = ad ? dk.domain : void 0, t.parent = !0, t.reactions.push(a), t.state != 0 && ek(t, !1), a.promise;
      }, catch: function(r) {
        return this.then(void 0, r);
      } });
      var gx = function() {
        var r = new gk(), e = kp(r);
        this.promise = r, this.resolve = jf(fk, e), this.reject = jf(kf, e);
      };
      if (ak.f = hf = function(r) {
        return r === Tb || r === hx ? new gx(r) : bx(r);
      }, typeof Fh == "function" && ie !== Object.prototype) {
        var ix = ie.then;
        np || (Wa(ie, "then", function(r, e) {
          var t = this;
          return new Tb(function(a, n) {
            ix.call(t, a, n);
          }).then(r, e);
        }, { unsafe: !0 }), Wa(ie, "catch", Lh.catch, { unsafe: !0 }));
        try {
          delete ie.constructor;
        } catch {
        }
        ob && ob(ie, Lh);
      }
    }
    ba({ global: !0, wrap: !0, forced: rg }, { Promise: Tb }), sc(Tb, "Promise", !1), mg("Promise");
    var hx = Lc("Promise");
    ba({ target: "Promise", stat: !0, forced: rg }, { reject: function(r) {
      var e = hf(this);
      return e.reject.call(void 0, r), e.promise;
    } }), ba({ target: "Promise", stat: !0, forced: rg }, { resolve: function(r) {
      if (Ia(this), !va(r) || r.constructor !== this) {
        var e = ak.f(this);
        (0, e.resolve)(r), r = e.promise;
      }
      return r;
    } }), ba({ target: "Promise", stat: !0, forced: dx }, { all: function(r) {
      var e = this, t = hf(e), a = t.resolve, n = t.reject, s = bk(function() {
        var o = Sb(e.resolve), u = [], l = 0, f = 1;
        Gh(r, function(d) {
          var h = l++, p = !1;
          u.push(void 0), f++, o.call(e, d).then(function(m) {
            p || (p = !0, u[h] = m, --f || a(u));
          }, n);
        }), --f || a(u);
      });
      return s.error && n(s.value), t.promise;
    }, race: function(r) {
      var e = this, t = hf(e), a = t.reject, n = bk(function() {
        var s = Sb(e.resolve);
        Gh(r, function(o) {
          s.call(e, o).then(t.resolve, a);
        });
      });
      return n.error && a(n.value), t.promise;
    } });
    var jx = Math.floor, kx = "".replace, lx = /\$([$&'`]|\d{1,2}|<[^>]*>)/g, mx = /\$([$&'`]|\d{1,2})/g, nx = function(r, e, t, a, n, s) {
      var o = t + r.length, u = a.length, l = mx;
      return n !== void 0 && (n = lb(n), l = lx), kx.call(s, l, function(f, d) {
        switch (d.charAt(0)) {
          case "$":
            return "$";
          case "&":
            return r;
          case "`":
            return e.slice(0, t);
          case "'":
            return e.slice(o);
          case "<":
            f = n[d.slice(1, -1)];
            break;
          default:
            var h = +d;
            if (h === 0)
              return f;
            if (h > u)
              return (h = jx(h / 10)) === 0 ? f : h <= u ? a[h - 1] === void 0 ? d.charAt(1) : a[h - 1] + d.charAt(1) : f;
            f = a[h - 1];
        }
        return f === void 0 ? "" : f;
      });
    }, ox = Math.max, px = Math.min;
    yh("replace", 2, function(r, e, t, a) {
      var n = a.REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE, s = a.REPLACE_KEEPS_$0, o = n ? "$" : "$0";
      return [function(u, l) {
        var f = Bb(this), d = u == null ? void 0 : u[r];
        return d !== void 0 ? d.call(u, f, l) : e.call(String(f), u, l);
      }, function(u, l) {
        if (!n && s || typeof l == "string" && l.indexOf(o) === -1) {
          var f = t(e, u, this, l);
          if (f.done)
            return f.value;
        }
        var d = Ia(u);
        u = String(this), (f = typeof l == "function") || (l = String(l));
        var h = d.global;
        if (h) {
          var p = d.unicode;
          d.lastIndex = 0;
        }
        for (var m = []; ; ) {
          var _ = bf(d, u);
          if (_ === null || (m.push(_), !h))
            break;
          String(_[0]) === "" && (d.lastIndex = Gj(u, La(d.lastIndex), p));
        }
        for (p = "", h = d = 0; h < m.length; h++) {
          _ = m[h];
          for (var w = String(_[0]), S = ox(px(rc(_.index), u.length), 0), O = [], k = 1; k < _.length; k++) {
            var B = O, L = _[k];
            B.push.call(B, L === void 0 ? L : String(L));
          }
          _ = _.groups, f ? (O = [w].concat(O, S, u), _ !== void 0 && O.push(_), _ = String(l.apply(void 0, O))) : _ = nx(w, u, S, O, _, l), S >= d && (p += u.slice(d, S) + _, d = S + w.length);
        }
        return p + u.slice(d);
      }];
    });
    var qx = ig("slice"), rx = Ea("species"), sx = [].slice, tx = Math.max;
    ba({ target: "Array", proto: !0, forced: !qx }, { slice: function(r, e) {
      var t = Ib(this), a = La(t.length);
      if (r = Rb(r, a), e = Rb(e === void 0 ? a : e, a), Dd(t)) {
        var n = t.constructor;
        if (typeof n != "function" || n !== Array && !Dd(n.prototype) ? va(n) && (n = n[rx]) === null && (n = void 0) : n = void 0, n === Array || n === void 0)
          return sx.call(t, r, e);
      }
      for (n = new (n === void 0 ? Array : n)(tx(e - r, 0)), a = 0; r < e; r++, a++)
        r in t && ef(n, a, t[r]);
      return n.length = a, n;
    } });
    var ux = Za.set, vx = Za.getterFor("Array Iterator"), Fd = Qj(Array, "Array", function(r, e) {
      ux(this, { type: "Array Iterator", target: Ib(r), index: 0, kind: e });
    }, function() {
      var r = vx(this), e = r.target, t = r.kind, a = r.index++;
      return !e || a >= e.length ? (r.target = void 0, { value: void 0, done: !0 }) : t == "keys" ? { value: a, done: !1 } : t == "values" ? { value: e[a], done: !1 } : { value: [a, e[a]], done: !1 };
    }, "values");
    df.Arguments = df.Array, lg("keys"), lg("values"), lg("entries");
    var qp = typeof ArrayBuffer < "u" && typeof DataView < "u", lf = function(r) {
      if (r === void 0)
        return 0;
      r = rc(r);
      var e = La(r);
      if (r !== e)
        throw RangeError("Wrong length or index");
      return e;
    }, wx = Math.abs, bd = Math.pow, xx = Math.floor, yx = Math.log, zx = Math.LN2, rp = function(r) {
      var e = lb(this), t = La(e.length), a = arguments.length, n = Rb(1 < a ? arguments[1] : void 0, t);
      for (t = (a = 2 < a ? arguments[2] : void 0) === void 0 ? t : Rb(a, t); t > n; )
        e[n++] = r;
      return e;
    }, Ax = ce.f, Bx = mb.f, mf = Za.get, sp = Za.set, uc = Q.ArrayBuffer, Ub = uc, vc = Q.DataView, Mh = vc && vc.prototype, tp = Object.prototype, Nh = Q.RangeError, up = function(r, e, t) {
      var a, n = Array(t), s = (1 << (t = 8 * t - e - 1)) - 1, o = s >> 1, u = e === 23 ? bd(2, -24) - bd(2, -77) : 0, l = 0 > r || r === 0 && 0 > 1 / r ? 1 : 0, f = 0;
      if ((r = wx(r)) != r || 1 / 0 === r) {
        r = r != r ? 1 : 0;
        var d = s;
      } else
        d = xx(yx(r) / zx), 1 > r * (a = bd(2, -d)) && (d--, a *= 2), 2 <= (r = 1 <= d + o ? r + u / a : r + u * bd(2, 1 - o)) * a && (d++, a /= 2), d + o >= s ? (r = 0, d = s) : 1 <= d + o ? (r = (r * a - 1) * bd(2, e), d += o) : (r = r * bd(2, o - 1) * bd(2, e), d = 0);
      for (; 8 <= e; n[f++] = 255 & r, r /= 256, e -= 8)
        ;
      for (d = d << e | r, t += e; 0 < t; n[f++] = 255 & d, d /= 256, t -= 8)
        ;
      return n[--f] |= 128 * l, n;
    }, vp = function(r, e) {
      var t = r.length, a = 8 * t - e - 1, n = (1 << a) - 1, s = n >> 1;
      a -= 7, --t;
      var o = r[t--], u = 127 & o;
      for (o >>= 7; 0 < a; u = 256 * u + r[t], t--, a -= 8)
        ;
      var l = u & (1 << -a) - 1;
      for (u >>= -a, a += e; 0 < a; l = 256 * l + r[t], t--, a -= 8)
        ;
      if (u === 0)
        u = 1 - s;
      else {
        if (u === n)
          return l ? NaN : o ? -1 / 0 : 1 / 0;
        l += bd(2, e), u -= s;
      }
      return (o ? -1 : 1) * l * bd(2, u - e);
    }, wp = function(r) {
      return [255 & r];
    }, xp = function(r) {
      return [255 & r, r >> 8 & 255];
    }, yp = function(r) {
      return [255 & r, r >> 8 & 255, r >> 16 & 255, r >> 24 & 255];
    }, zp = function(r) {
      return r[3] << 24 | r[2] << 16 | r[1] << 8 | r[0];
    }, Cx = function(r) {
      return up(r, 23, 4);
    }, Dx = function(r) {
      return up(r, 52, 8);
    }, Oh = function(r, e) {
      Bx(r.prototype, e, { get: function() {
        return mf(this)[e];
      } });
    }, Gd = function(r, e, t, a) {
      t = lf(t);
      var n = mf(r);
      if (t + e > n.byteLength)
        throw Nh("Wrong index");
      return r = mf(n.buffer).bytes, t += n.byteOffset, e = r.slice(t, t + e), a ? e : e.reverse();
    }, Hd = function(r, e, t, a, n, s) {
      t = lf(t);
      var o = mf(r);
      if (t + e > o.byteLength)
        throw Nh("Wrong index");
      for (r = mf(o.buffer).bytes, t += o.byteOffset, a = a(+n), n = 0; n < e; n++)
        r[t + n] = a[s ? n : e - n - 1];
    };
    if (qp) {
      if (!ia(function() {
        uc(1);
      }) || !ia(function() {
        new uc(-1);
      }) || ia(function() {
        return new uc(), new uc(1.5), new uc(NaN), uc.name != "ArrayBuffer";
      })) {
        Ub = function(r) {
          return tc(this, Ub), new uc(lf(r));
        };
        for (var Ex = Ub.prototype = uc.prototype, Ap = Ax(uc), Bp = 0, hk; Ap.length > Bp; )
          (hk = Ap[Bp++]) in Ub || gb(Ub, hk, uc[hk]);
        Ex.constructor = Ub;
      }
      ob && nc(Mh) !== tp && ob(Mh, tp);
      var Ph = new vc(new Ub(2)), Cp = Mh.setInt8;
      Ph.setInt8(0, 2147483648), Ph.setInt8(1, 2147483649), !Ph.getInt8(0) && Ph.getInt8(1) || gf(Mh, { setInt8: function(r, e) {
        Cp.call(this, r, e << 24 >> 24);
      }, setUint8: function(r, e) {
        Cp.call(this, r, e << 24 >> 24);
      } }, { unsafe: !0 });
    } else
      Ub = function(r) {
        tc(this, Ub, "ArrayBuffer"), r = lf(r), sp(this, { bytes: rp.call(Array(r), 0), byteLength: r }), ta || (this.byteLength = r);
      }, vc = function(r, e, t) {
        tc(this, vc, "DataView"), tc(r, Ub, "DataView");
        var a = mf(r).byteLength;
        if (0 > (e = rc(e)) || e > a)
          throw Nh("Wrong offset");
        if (e + (t = t === void 0 ? a - e : La(t)) > a)
          throw Nh("Wrong length");
        sp(this, { buffer: r, byteLength: t, byteOffset: e }), ta || (this.buffer = r, this.byteLength = t, this.byteOffset = e);
      }, ta && (Oh(Ub, "byteLength"), Oh(vc, "buffer"), Oh(vc, "byteLength"), Oh(vc, "byteOffset")), gf(vc.prototype, { getInt8: function(r) {
        return Gd(this, 1, r)[0] << 24 >> 24;
      }, getUint8: function(r) {
        return Gd(this, 1, r)[0];
      }, getInt16: function(r) {
        var e = Gd(this, 2, r, 1 < arguments.length ? arguments[1] : void 0);
        return (e[1] << 8 | e[0]) << 16 >> 16;
      }, getUint16: function(r) {
        var e = Gd(this, 2, r, 1 < arguments.length ? arguments[1] : void 0);
        return e[1] << 8 | e[0];
      }, getInt32: function(r) {
        return zp(Gd(this, 4, r, 1 < arguments.length ? arguments[1] : void 0));
      }, getUint32: function(r) {
        return zp(Gd(this, 4, r, 1 < arguments.length ? arguments[1] : void 0)) >>> 0;
      }, getFloat32: function(r) {
        return vp(Gd(this, 4, r, 1 < arguments.length ? arguments[1] : void 0), 23);
      }, getFloat64: function(r) {
        return vp(Gd(this, 8, r, 1 < arguments.length ? arguments[1] : void 0), 52);
      }, setInt8: function(r, e) {
        Hd(this, 1, r, wp, e);
      }, setUint8: function(r, e) {
        Hd(this, 1, r, wp, e);
      }, setInt16: function(r, e) {
        Hd(this, 2, r, xp, e, 2 < arguments.length ? arguments[2] : void 0);
      }, setUint16: function(r, e) {
        Hd(this, 2, r, xp, e, 2 < arguments.length ? arguments[2] : void 0);
      }, setInt32: function(r, e) {
        Hd(this, 4, r, yp, e, 2 < arguments.length ? arguments[2] : void 0);
      }, setUint32: function(r, e) {
        Hd(this, 4, r, yp, e, 2 < arguments.length ? arguments[2] : void 0);
      }, setFloat32: function(r, e) {
        Hd(this, 4, r, Cx, e, 2 < arguments.length ? arguments[2] : void 0);
      }, setFloat64: function(r, e) {
        Hd(this, 8, r, Dx, e, 2 < arguments.length ? arguments[2] : void 0);
      } });
    sc(Ub, "ArrayBuffer"), sc(vc, "DataView");
    var sg = { ArrayBuffer: Ub, DataView: vc }, ik = sg.ArrayBuffer, Dp = sg.DataView, Ep = ik.prototype.slice, Fx = ia(function() {
      return !new ik(2).slice(1, void 0).byteLength;
    });
    ba({ target: "ArrayBuffer", proto: !0, unsafe: !0, forced: Fx }, { slice: function(r, e) {
      if (Ep !== void 0 && e === void 0)
        return Ep.call(Ia(this), r);
      var t = Ia(this).byteLength;
      r = Rb(r, t), e = Rb(e === void 0 ? t : e, t), t = new (de(this, ik))(La(e - r));
      for (var a = new Dp(this), n = new Dp(t), s = 0; r < e; )
        n.setUint8(s++, a.getUint8(r++));
      return t;
    } });
    var Gx = mb.f, Qh = Q.Int8Array, jk = Qh && Qh.prototype, Fp = Q.Uint8ClampedArray, Gp = Fp && Fp.prototype, Pc = Qh && nc(Qh), wc = jk && nc(jk), Hp = Object.prototype, Ip = Hp.isPrototypeOf, Jp = Ea("toStringTag"), kk = Ye("TYPED_ARRAY_TAG"), cd = qp && !!ob && ff(Q.opera) !== "Opera", Kp = !1, Vb, Qc = { Int8Array: 1, Uint8Array: 1, Uint8ClampedArray: 1, Int16Array: 2, Uint16Array: 2, Int32Array: 4, Uint32Array: 4, Float32Array: 4, Float64Array: 8 }, Hx = { BigInt64Array: 8, BigUint64Array: 8 }, Rh = function(r) {
      return !!va(r) && (r = ff(r), ha(Qc, r) || ha(Hx, r));
    };
    for (Vb in Qc)
      Q[Vb] || (cd = !1);
    if ((!cd || typeof Pc != "function" || Pc === Function.prototype) && (Pc = function() {
      throw TypeError("Incorrect invocation");
    }, cd))
      for (Vb in Qc)
        Q[Vb] && ob(Q[Vb], Pc);
    if ((!cd || !wc || wc === Hp) && (wc = Pc.prototype, cd))
      for (Vb in Qc)
        Q[Vb] && ob(Q[Vb].prototype, wc);
    if (cd && nc(Gp) !== wc && ob(Gp, wc), ta && !ha(wc, Jp))
      for (Vb in Kp = !0, Gx(wc, Jp, { get: function() {
        return va(this) ? this[kk] : void 0;
      } }), Qc)
        Q[Vb] && gb(Q[Vb], kk, Vb);
    var tg = cd, Lp = Kp && kk, Ta = function(r) {
      if (Rh(r))
        return r;
      throw TypeError("Target is not a typed array");
    }, nf = function(r) {
      if (ob) {
        if (Ip.call(Pc, r))
          return r;
      } else
        for (var e in Qc)
          if (ha(Qc, Vb)) {
            var t = Q[e];
            if (t && (r === t || Ip.call(t, r)))
              return r;
          }
      throw TypeError("Target is not a typed array constructor");
    }, Qa = function(r, e, t) {
      if (ta) {
        if (t)
          for (var a in Qc) {
            var n = Q[a];
            if (n && ha(n.prototype, r))
              try {
                delete n.prototype[r];
              } catch {
              }
          }
        wc[r] && !t || Wa(wc, r, t ? e : cd && jk[r] || e);
      }
    }, Mp = function(r, e, t) {
      var a, n;
      if (ta) {
        if (ob) {
          if (t) {
            for (a in Qc)
              if ((n = Q[a]) && ha(n, r))
                try {
                  delete n[r];
                } catch {
                }
          }
          if (Pc[r] && !t)
            return;
          try {
            return Wa(Pc, r, t ? e : cd && Pc[r] || e);
          } catch {
          }
        }
        for (a in Qc)
          !(n = Q[a]) || n[r] && !t || Wa(n, r, e);
      }
    }, Np = Pc, ug = wc, Ix = Q.ArrayBuffer, je = Q.Int8Array, lk = !tg || !ia(function() {
      je(1);
    }) || !ia(function() {
      new je(-1);
    }) || !Bh(function(r) {
      new je(), new je(null), new je(1.5), new je(r);
    }, !0) || ia(function() {
      return new je(new Ix(2), 1, void 0).length !== 1;
    }), Sh = function(r, e) {
      if (0 > (r = rc(r)))
        throw RangeError("The argument can't be less than 0");
      if (r % e)
        throw RangeError("Wrong offset");
      return r;
    }, mk = function(r) {
      var e = lb(r), t = arguments.length, a = 1 < t ? arguments[1] : void 0, n = a !== void 0, s = jg(e);
      if (s != null && !Kj(s)) {
        var o = s.call(e), u = o.next;
        for (e = []; !(s = u.call(o)).done; )
          e.push(s.value);
      }
      for (n && 2 < t && (a = Cd(a, arguments[2], 2)), s = La(e.length), o = new (nf(this))(s), t = 0; s > t; t++)
        o[t] = n ? a(e[t], t) : e[t];
      return o;
    }, Th = function(r, e, t) {
      var a, n;
      return ob && typeof (a = e.constructor) == "function" && a !== t && va(n = a.prototype) && n !== t.prototype && ob(r, n), r;
    }, vg = tb(function(r) {
      var e = ce.f, t = Za.get, a = Za.set, n = mb.f, s = Zb.f, o = Math.round, u = Q.RangeError, l = sg.ArrayBuffer, f = sg.DataView, d = function(S, O) {
        var k = 0, B = O.length;
        for (S = new (nf(S))(B); B > k; )
          S[k] = O[k++];
        return S;
      }, h = function(S, O) {
        n(S, O, { get: function() {
          return t(this)[O];
        } });
      }, p = function(S) {
        var O;
        return S instanceof l || (O = ff(S)) == "ArrayBuffer" || O == "SharedArrayBuffer";
      }, m = function(S, O) {
        return Rh(S) && typeof O != "symbol" && O in S && String(+O) == String(O);
      }, _ = function(S, O) {
        return m(S, O = Kc(O, !0)) ? Jc(2, S[O]) : s(S, O);
      }, w = function(S, O, k) {
        return !(m(S, O = Kc(O, !0)) && va(k) && ha(k, "value")) || ha(k, "get") || ha(k, "set") || k.configurable || ha(k, "writable") && !k.writable || ha(k, "enumerable") && !k.enumerable ? n(S, O, k) : (S[O] = k.value, S);
      };
      ta ? (tg || (Zb.f = _, mb.f = w, h(ug, "buffer"), h(ug, "byteOffset"), h(ug, "byteLength"), h(ug, "length")), ba({ target: "Object", stat: !0, forced: !tg }, { getOwnPropertyDescriptor: _, defineProperty: w }), r.exports = function(S, O, k) {
        var B = S.match(/\d+$/)[0] / 8, L = S + (k ? "Clamped" : "") + "Array", G = "get" + S, _r = "set" + S, ga = Q[L], _n = ga;
        S = _n && _n.prototype;
        var Fa = {}, N = function(_t, Y) {
          n(_t, Y, { get: function() {
            var _a = t(this);
            return _a.view[G](Y * B + _a.byteOffset, !0);
          }, set: function(_a) {
            var X = t(this);
            k && (_a = 0 > (_a = o(_a)) ? 0 : 255 < _a ? 255 : 255 & _a), X.view[_r](Y * B + X.byteOffset, _a, !0);
          }, enumerable: !0 });
        };
        tg ? lk && (_n = O(function(_t, Y, _a, X) {
          return tc(_t, _n, L), Th(va(Y) ? p(Y) ? X !== void 0 ? new ga(Y, Sh(_a, B), X) : _a !== void 0 ? new ga(Y, Sh(_a, B)) : new ga(Y) : Rh(Y) ? d(_n, Y) : mk.call(_n, Y) : new ga(lf(Y)), _t, _n);
        }), ob && ob(_n, Np), ee(e(ga), function(_t) {
          _t in _n || gb(_n, _t, ga[_t]);
        }), _n.prototype = S) : (_n = O(function(_t, Y, _a, X) {
          tc(_t, _n, L);
          var J = 0, ea = 0;
          if (va(Y)) {
            if (!p(Y))
              return Rh(Y) ? d(_n, Y) : mk.call(_n, Y);
            var wa = Y;
            if (ea = Sh(_a, B), Y = Y.byteLength, X === void 0) {
              if (Y % B || 0 > (X = Y - ea))
                throw u("Wrong length");
            } else if ((X = La(X) * B) + ea > Y)
              throw u("Wrong length");
            Y = X / B;
          } else
            Y = lf(Y), wa = new l(X = Y * B);
          for (a(_t, { buffer: wa, byteOffset: ea, byteLength: X, length: Y, view: new f(wa) }); J < Y; )
            N(_t, J++);
        }), ob && ob(_n, Np), S = _n.prototype = ec(ug)), S.constructor !== _n && gb(S, "constructor", _n), Lp && gb(S, Lp, L), Fa[L] = _n, ba({ global: !0, forced: _n != ga, sham: !tg }, Fa), "BYTES_PER_ELEMENT" in _n || gb(_n, "BYTES_PER_ELEMENT", B), "BYTES_PER_ELEMENT" in S || gb(S, "BYTES_PER_ELEMENT", B), mg(L);
      }) : r.exports = function() {
      };
    });
    vg("Uint8", function(r) {
      return function(e, t, a) {
        return r(this, e, t, a);
      };
    });
    var Jx = Math.min, Kx = [].copyWithin || function(r, e) {
      var t = lb(this), a = La(t.length), n = Rb(r, a), s = Rb(e, a), o = 2 < arguments.length ? arguments[2] : void 0;
      for (a = Jx((o === void 0 ? a : Rb(o, a)) - s, a - n), o = 1, s < n && n < s + a && (o = -1, s += a - 1, n += a - 1); 0 < a--; )
        s in t ? t[n] = t[s] : delete t[n], n += o, s += o;
      return t;
    };
    Qa("copyWithin", function(r, e) {
      return Kx.call(Ta(this), r, e, 2 < arguments.length ? arguments[2] : void 0);
    }), Qa("every", function(r) {
      return sw(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    }), Qa("fill", function(r) {
      return rp.apply(Ta(this), arguments);
    }), Qa("filter", function(r) {
      var e = Co(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0), t = de(this, this.constructor), a = 0, n = e.length;
      for (t = new (nf(t))(n); n > a; )
        t[a] = e[a++];
      return t;
    }), Qa("find", function(r) {
      return Do(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    }), Qa("findIndex", function(r) {
      return tw(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    }), Qa("forEach", function(r) {
      ee(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    }), Qa("includes", function(r) {
      return ko(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    }), Qa("indexOf", function(r) {
      return zj(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    });
    var Op = Ea("iterator"), Pp = Q.Uint8Array, Lx = Fd.values, Mx = Fd.keys, Nx = Fd.entries, nk = Pp && Pp.prototype[Op], Qp = !!nk && (nk.name == "values" || nk.name == null), Rp = function() {
      return Lx.call(Ta(this));
    };
    Qa("entries", function() {
      return Nx.call(Ta(this));
    }), Qa("keys", function() {
      return Mx.call(Ta(this));
    }), Qa("values", Rp, !Qp), Qa(Op, Rp, !Qp);
    var Ox = [].join;
    Qa("join", function(r) {
      return Ox.apply(Ta(this), arguments);
    });
    var Px = Math.min, ok = [].lastIndexOf, Sp = !!ok && 0 > 1 / [1].lastIndexOf(1, -0), Qx = cf("lastIndexOf"), Rx = Sp || !Qx ? function(r) {
      if (Sp)
        return ok.apply(this, arguments) || 0;
      var e = Ib(this), t = La(e.length), a = t - 1;
      for (1 < arguments.length && (a = Px(a, rc(arguments[1]))), 0 > a && (a = t + a); 0 <= a; a--)
        if (a in e && e[a] === r)
          return a || 0;
      return -1;
    } : ok;
    Qa("lastIndexOf", function(r) {
      return Rx.apply(Ta(this), arguments);
    }), Qa("map", function(r) {
      return Bo(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0, function(e, t) {
        return new (nf(de(e, e.constructor)))(t);
      });
    });
    var Tp = function(r) {
      return function(e, t, a, n) {
        Sb(t), e = lb(e);
        var s = dg(e), o = La(e.length), u = r ? o - 1 : 0, l = r ? -1 : 1;
        if (2 > a)
          for (; ; ) {
            if (u in s) {
              n = s[u], u += l;
              break;
            }
            if (u += l, r ? 0 > u : o <= u)
              throw TypeError("Reduce of empty array with no initial value");
          }
        for (; r ? 0 <= u : o > u; u += l)
          u in s && (n = t(n, s[u], u, e));
        return n;
      };
    }, Up = Tp(!1), Sx = Tp(!0);
    Qa("reduce", function(r) {
      return Up(Ta(this), r, arguments.length, 1 < arguments.length ? arguments[1] : void 0);
    }), Qa("reduceRight", function(r) {
      return Sx(Ta(this), r, arguments.length, 1 < arguments.length ? arguments[1] : void 0);
    });
    var Tx = Math.floor;
    Qa("reverse", function() {
      for (var r, e = Ta(this).length, t = Tx(e / 2), a = 0; a < t; )
        r = this[a], this[a++] = this[--e], this[e] = r;
      return this;
    });
    var Ux = ia(function() {
      new Int8Array(1).set({});
    });
    Qa("set", function(r) {
      Ta(this);
      var e = Sh(1 < arguments.length ? arguments[1] : void 0, 1), t = this.length, a = lb(r), n = La(a.length), s = 0;
      if (n + e > t)
        throw RangeError("Wrong length");
      for (; s < n; )
        this[e + s] = a[s++];
    }, Ux);
    var Vx = [].slice, Wx = ia(function() {
      new Int8Array(1).slice();
    });
    Qa("slice", function(r, e) {
      r = Vx.call(Ta(this), r, e);
      var t = de(this, this.constructor);
      e = 0;
      var a = r.length;
      for (t = new (nf(t))(a); a > e; )
        t[e] = r[e++];
      return t;
    }, Wx), Qa("some", function(r) {
      return rw(Ta(this), r, 1 < arguments.length ? arguments[1] : void 0);
    });
    var Xx = [].sort;
    Qa("sort", function(r) {
      return Xx.call(Ta(this), r);
    }), Qa("subarray", function(r, e) {
      var t = Ta(this), a = t.length;
      return r = Rb(r, a), new (de(t, t.constructor))(t.buffer, t.byteOffset + r * t.BYTES_PER_ELEMENT, La((e === void 0 ? a : Rb(e, a)) - r));
    });
    var Uh = Q.Int8Array, Vp = [].toLocaleString, Yx = [].slice, Zx = !!Uh && ia(function() {
      Vp.call(new Uh(1));
    }), $x = ia(function() {
      return [1, 2].toLocaleString() != new Uh([1, 2]).toLocaleString();
    }) || !ia(function() {
      Uh.prototype.toLocaleString.call([1, 2]);
    });
    Qa("toLocaleString", function() {
      return Vp.apply(Zx ? Yx.call(Ta(this)) : Ta(this), arguments);
    }, $x);
    var Wp = Q.Uint8Array, ay = Wp && Wp.prototype || {}, Vh = [].toString, by = [].join;
    ia(function() {
      Vh.call({});
    }) && (Vh = function() {
      return by.call(this);
    }), Qa("toString", Vh, ay.toString != Vh);
    var Xp = sg.ArrayBuffer;
    ba({ global: !0, forced: Q.ArrayBuffer !== Xp }, { ArrayBuffer: Xp }), mg("ArrayBuffer");
    var cy = mb.f, pk = Function.prototype, dy = pk.toString, ey = /^\s*function ([^ (]*)/;
    !ta || "name" in pk || cy(pk, "name", { configurable: !0, get: function() {
      try {
        return dy.call(this).match(ey)[1];
      } catch {
        return "";
      }
    } });
    var Yp = RegExp.prototype, Zp = Yp.toString, fy = ia(function() {
      return Zp.call({ source: "a", flags: "b" }) != "/a/b";
    }), gy = Zp.name != "toString";
    (fy || gy) && Wa(RegExp.prototype, "toString", function() {
      var r = Ia(this), e = String(r.source), t = r.flags;
      return "/" + e + "/" + (r = String(t === void 0 && r instanceof RegExp && !("flags" in Yp) ? Aj.call(r) : t));
    }, { unsafe: !0 });
    var hy = ig("splice"), iy = Math.max, jy = Math.min;
    ba({ target: "Array", proto: !0, forced: !hy }, { splice: function(r, e) {
      var t, a, n = lb(this), s = La(n.length), o = Rb(r, s), u = arguments.length;
      if (u === 0 ? u = t = 0 : u === 1 ? (u = 0, t = s - o) : (u -= 2, t = jy(iy(rc(e), 0), s - o)), 9007199254740991 < s + u - t)
        throw TypeError("Maximum allowed length exceeded");
      var l = Ah(n, t);
      for (a = 0; a < t; a++) {
        var f = o + a;
        f in n && ef(l, a, n[f]);
      }
      if (l.length = t, u < t) {
        for (a = o; a < s - t; a++) {
          var d = a + u;
          (f = a + t) in n ? n[d] = n[f] : delete n[d];
        }
        for (a = s; a > s - t + u; a--)
          delete n[a - 1];
      } else if (u > t)
        for (a = s - t; a > o; a--)
          d = a + u - 1, (f = a + t - 1) in n ? n[d] = n[f] : delete n[d];
      for (a = 0; a < u; a++)
        n[a + o] = arguments[a + 2];
      return n.length = s - t + u, l;
    } });
    var qk = { CSSRuleList: 0, CSSStyleDeclaration: 0, CSSValueList: 0, ClientRectList: 0, DOMRectList: 0, DOMStringList: 0, DOMTokenList: 1, DataTransferItemList: 0, FileList: 0, HTMLAllCollection: 0, HTMLCollection: 0, HTMLFormElement: 0, HTMLSelectElement: 0, MediaList: 0, MimeTypeArray: 0, NamedNodeMap: 0, NodeList: 1, PaintRequestList: 0, Plugin: 0, PluginArray: 0, SVGLengthList: 0, SVGNumberList: 0, SVGPathSegList: 0, SVGPointList: 0, SVGStringList: 0, SVGTransformList: 0, SourceBufferList: 0, StyleSheetList: 0, TextTrackCueList: 0, TextTrackList: 0, TouchList: 0 }, rk = Ea("iterator"), $p = Ea("toStringTag"), sk = Fd.values, Wh;
    for (Wh in qk) {
      var aq = Q[Wh], dd = aq && aq.prototype;
      if (dd) {
        if (dd[rk] !== sk)
          try {
            gb(dd, rk, sk);
          } catch {
            dd[rk] = sk;
          }
        if (dd[$p] || gb(dd, $p, Wh), qk[Wh]) {
          for (var of in Fd)
            if (dd[of] !== Fd[of])
              try {
                gb(dd, of, Fd[of]);
              } catch {
                dd[of] = Fd[of];
              }
        }
      }
    }
    var bq = Object.is || function(r, e) {
      return r === e ? r !== 0 || 1 / r == 1 / e : r != r && e != e;
    };
    yh("search", 1, function(r, e, t) {
      return [function(a) {
        var n = Bb(this), s = a == null ? void 0 : a[r];
        return s !== void 0 ? s.call(a, n) : new RegExp(a)[r](String(n));
      }, function(a) {
        var n = t(e, a, this);
        if (n.done)
          return n.value;
        a = Ia(a);
        var s = String(this);
        return n = a.lastIndex, bq(n, 0) || (a.lastIndex = 0), s = bf(a, s), bq(a.lastIndex, n) || (a.lastIndex = n), s === null ? -1 : s.index;
      }];
    }), tb(function(r) {
      (function(e, t) {
        r.exports ? r.exports = t(e) : t(e);
      })(typeof self < "u" ? self : Va, function(e) {
        function t(N) {
          return btoa(N).replace(/=+$/, "").replace(/\+/g, "-").replace(/\//g, "_");
        }
        function a(N) {
          return N = (N += "===").slice(0, -N.length % 4), atob(N.replace(/-/g, "+").replace(/_/g, "/"));
        }
        function n(N) {
          for (var _t = new Uint8Array(N.length), Y = 0; Y < N.length; Y++)
            _t[Y] = N.charCodeAt(Y);
          return _t;
        }
        function s(N) {
          return N instanceof ArrayBuffer && (N = new Uint8Array(N)), String.fromCharCode.apply(String, N);
        }
        function o(N) {
          var _t = { name: (N.name || N || "").toUpperCase().replace("V", "v") };
          switch (_t.name) {
            case "SHA-1":
            case "SHA-256":
            case "SHA-384":
            case "SHA-512":
              break;
            case "AES-CBC":
            case "AES-GCM":
            case "AES-KW":
              N.length && (_t.length = N.length);
              break;
            case "HMAC":
              N.hash && (_t.hash = o(N.hash)), N.length && (_t.length = N.length);
              break;
            case "RSAES-PKCS1-v1_5":
              N.publicExponent && (_t.publicExponent = new Uint8Array(N.publicExponent)), N.modulusLength && (_t.modulusLength = N.modulusLength);
              break;
            case "RSASSA-PKCS1-v1_5":
            case "RSA-OAEP":
              N.hash && (_t.hash = o(N.hash)), N.publicExponent && (_t.publicExponent = new Uint8Array(N.publicExponent)), N.modulusLength && (_t.modulusLength = N.modulusLength);
              break;
            default:
              throw new SyntaxError("Bad algorithm name");
          }
          return _t;
        }
        function u(N) {
          return { HMAC: { "SHA-1": "HS1", "SHA-256": "HS256", "SHA-384": "HS384", "SHA-512": "HS512" }, "RSASSA-PKCS1-v1_5": { "SHA-1": "RS1", "SHA-256": "RS256", "SHA-384": "RS384", "SHA-512": "RS512" }, "RSAES-PKCS1-v1_5": { "": "RSA1_5" }, "RSA-OAEP": { "SHA-1": "RSA-OAEP", "SHA-256": "RSA-OAEP-256" }, "AES-KW": { 128: "A128KW", 192: "A192KW", 256: "A256KW" }, "AES-GCM": { 128: "A128GCM", 192: "A192GCM", 256: "A256GCM" }, "AES-CBC": { 128: "A128CBC", 192: "A192CBC", 256: "A256CBC" } }[N.name][(N.hash || {}).name || N.length || ""];
        }
        function l(N) {
          (N instanceof ArrayBuffer || N instanceof Uint8Array) && (N = JSON.parse(decodeURIComponent(escape(s(N)))));
          var _t = { kty: N.kty, alg: N.alg, ext: N.ext || N.extractable };
          switch (_t.kty) {
            case "oct":
              _t.k = N.k;
            case "RSA":
              "n e d p q dp dq qi oth".split(" ").forEach(function(Y) {
                Y in N && (_t[Y] = N[Y]);
              });
              break;
            default:
              throw new TypeError("Unsupported key type");
          }
          return _t;
        }
        function f(N) {
          return N = l(N), G && (N.extractable = N.ext, delete N.ext), n(unescape(encodeURIComponent(JSON.stringify(N)))).buffer;
        }
        function d(N) {
          var _t = h(N), Y = !1;
          switch (2 < _t.length && (Y = !0, _t.shift()), N = { ext: !0 }, _t[0][0]) {
            case "1.2.840.113549.1.1.1":
              var _a = "n e d p q dp dq qi".split(" ");
              for (_t = h(_t[1]), Y && _t.shift(), Y = 0; Y < _t.length; Y++)
                _t[Y][0] || (_t[Y] = _t[Y].subarray(1)), N[_a[Y]] = t(s(_t[Y]));
              N.kty = "RSA";
              break;
            default:
              throw new TypeError("Unsupported key type");
          }
          return N;
        }
        function h(N, _t) {
          if (N instanceof ArrayBuffer && (N = new Uint8Array(N)), _t || (_t = { pos: 0, end: N.length }), 2 > _t.end - _t.pos || _t.end > N.length)
            throw new RangeError("Malformed DER");
          var Y = N[_t.pos++], _a = N[_t.pos++];
          if (128 <= _a) {
            if (_a &= 127, _t.end - _t.pos < _a)
              throw new RangeError("Malformed DER");
            for (var X = 0; _a--; )
              X <<= 8, X |= N[_t.pos++];
            _a = X;
          }
          if (_t.end - _t.pos < _a)
            throw new RangeError("Malformed DER");
          switch (Y) {
            case 2:
              Y = N.subarray(_t.pos, _t.pos += _a);
              break;
            case 3:
              if (N[_t.pos++])
                throw Error("Unsupported bit string");
              _a--;
            case 4:
              Y = new Uint8Array(N.subarray(_t.pos, _t.pos += _a)).buffer;
              break;
            case 5:
              Y = null;
              break;
            case 6:
              if (!((N = btoa(s(N.subarray(_t.pos, _t.pos += _a)))) in ga))
                throw Error("Unsupported OBJECT ID " + N);
              Y = ga[N];
              break;
            case 48:
              for (Y = [], _a = _t.pos + _a; _t.pos < _a; )
                Y.push(h(N, _t));
              break;
            default:
              throw Error("Unsupported DER tag 0x" + Y.toString(16));
          }
          return Y;
        }
        function p(N, _t) {
          _t || (_t = []);
          var Y = _t.length + 2;
          if (_t.push(0, 0), N instanceof Uint8Array)
            for (var _a = 2, X = N.length, J = 0; J < X; J++)
              _t.push(N[J]);
          else if (N instanceof ArrayBuffer)
            for (_a = 4, X = N.byteLength, N = new Uint8Array(N), J = 0; J < X; J++)
              _t.push(N[J]);
          else if (N === null)
            _a = 5, X = 0;
          else if (typeof N == "string" && N in _n)
            for (_a = 6, X = (N = n(atob(_n[N]))).length, J = 0; J < X; J++)
              _t.push(N[J]);
          else if (N instanceof Array) {
            for (J = 0; J < N.length; J++)
              p(N[J], _t);
            _a = 48, X = _t.length - Y;
          } else {
            if (!(oa(N) === "object" && N.tag === 3 && N.value instanceof ArrayBuffer))
              throw Error("Unsupported DER value " + N);
            for (_a = 3, X = (N = new Uint8Array(N.value)).byteLength, _t.push(0), J = 0; J < X; J++)
              _t.push(N[J]);
            X++;
          }
          if (128 <= X) {
            for (J = X, X = 4, _t.splice(Y, 0, J >> 24 & 255, J >> 16 & 255, J >> 8 & 255, 255 & J); 1 < X && !(J >> 24); )
              J <<= 8, X--;
            4 > X && _t.splice(Y, 4 - X), X |= 128;
          }
          return _t.splice(Y - 2, 2, _a, X), _t;
        }
        function m(N, _t, Y, _a) {
          Object.defineProperties(this, { _key: { value: N }, type: { value: N.type, enumerable: !0 }, extractable: { value: Y === void 0 ? N.extractable : Y, enumerable: !0 }, algorithm: { value: _t === void 0 ? N.algorithm : _t, enumerable: !0 }, usages: { value: _a === void 0 ? N.usages : _a, enumerable: !0 } });
        }
        function _(N) {
          return N === "verify" || N === "encrypt" || N === "wrapKey";
        }
        function w(N) {
          return N === "sign" || N === "decrypt" || N === "unwrapKey";
        }
        if (typeof Promise != "function")
          throw "Promise support required";
        var S = e.crypto || e.msCrypto;
        if (S) {
          var O = S.subtle || S.webkitSubtle;
          if (O) {
            var k = e.Crypto || S.constructor || Object, B = e.SubtleCrypto || O.constructor || Object;
            e.CryptoKey || e.Key;
            var L = -1 < e.navigator.userAgent.indexOf("Edge/"), G = !!e.msCrypto && !L, _r = !S.subtle && !!S.webkitSubtle;
            if (G || _r) {
              var ga = { KoZIhvcNAQEB: "1.2.840.113549.1.1.1" }, _n = { "1.2.840.113549.1.1.1": "KoZIhvcNAQEB" };
              if (["generateKey", "importKey", "unwrapKey"].forEach(function(N) {
                var _t = O[N];
                O[N] = function(Y, _a, X) {
                  var J = [].slice.call(arguments);
                  switch (N) {
                    case "generateKey":
                      var ea = o(Y), wa = _a, _s = X;
                      break;
                    case "importKey":
                      ea = o(X), wa = J[3], _s = J[4], Y === "jwk" && ((_a = l(_a)).alg || (_a.alg = u(ea)), _a.key_ops || (_a.key_ops = _a.kty !== "oct" ? "d" in _a ? _s.filter(w) : _s.filter(_) : _s.slice()), J[1] = f(_a));
                      break;
                    case "unwrapKey":
                      ea = J[4], wa = J[5], _s = J[6], J[2] = X._key;
                  }
                  if (N === "generateKey" && ea.name === "HMAC" && ea.hash)
                    return ea.length = ea.length || { "SHA-1": 512, "SHA-256": 512, "SHA-384": 1024, "SHA-512": 1024 }[ea.hash.name], O.importKey("raw", S.getRandomValues(new Uint8Array(ea.length + 7 >> 3)), ea, wa, _s);
                  if (_r && N === "generateKey" && ea.name === "RSASSA-PKCS1-v1_5" && (!ea.modulusLength || 2048 <= ea.modulusLength))
                    return (Y = o(Y)).name = "RSAES-PKCS1-v1_5", delete Y.hash, O.generateKey(Y, !0, ["encrypt", "decrypt"]).then(function(_o) {
                      return Promise.all([O.exportKey("jwk", _o.publicKey), O.exportKey("jwk", _o.privateKey)]);
                    }).then(function(_o) {
                      return _o[0].alg = _o[1].alg = u(ea), _o[0].key_ops = _s.filter(_), _o[1].key_ops = _s.filter(w), Promise.all([O.importKey("jwk", _o[0], ea, !0, _o[0].key_ops), O.importKey("jwk", _o[1], ea, wa, _o[1].key_ops)]);
                    }).then(function(_o) {
                      return { publicKey: _o[0], privateKey: _o[1] };
                    });
                  if ((_r || G && (ea.hash || {}).name === "SHA-1") && N === "importKey" && Y === "jwk" && ea.name === "HMAC" && _a.kty === "oct")
                    return O.importKey("raw", n(a(_a.k)), X, J[3], J[4]);
                  if (_r && N === "importKey" && (Y === "spki" || Y === "pkcs8"))
                    return O.importKey("jwk", d(_a), X, J[3], J[4]);
                  if (G && N === "unwrapKey")
                    return O.decrypt(J[3], X, _a).then(function(_o) {
                      return O.importKey(Y, _o, J[4], J[5], J[6]);
                    });
                  try {
                    var _d = _t.apply(O, J);
                  } catch (_o) {
                    return Promise.reject(_o);
                  }
                  return G && (_d = new Promise(function(_o, _p) {
                    _d.onabort = _d.onerror = function(_f) {
                      _p(_f);
                    }, _d.oncomplete = function(_f) {
                      _o(_f.target.result);
                    };
                  })), _d = _d.then(function(_o) {
                    return ea.name !== "HMAC" || ea.length || (ea.length = 8 * _o.algorithm.length), ea.name.search("RSA") == 0 && (ea.modulusLength || (ea.modulusLength = (_o.publicKey || _o).algorithm.modulusLength), ea.publicExponent || (ea.publicExponent = (_o.publicKey || _o).algorithm.publicExponent)), _o.publicKey && _o.privateKey ? { publicKey: new m(_o.publicKey, ea, wa, _s.filter(_)), privateKey: new m(_o.privateKey, ea, wa, _s.filter(w)) } : new m(_o, ea, wa, _s);
                  });
                };
              }), ["exportKey", "wrapKey"].forEach(function(N) {
                var _t = O[N];
                O[N] = function(Y, _a, X) {
                  var J = [].slice.call(arguments);
                  switch (N) {
                    case "exportKey":
                      J[1] = _a._key;
                      break;
                    case "wrapKey":
                      J[1] = _a._key, J[2] = X._key;
                  }
                  if ((_r || G && (_a.algorithm.hash || {}).name === "SHA-1") && N === "exportKey" && Y === "jwk" && _a.algorithm.name === "HMAC" && (J[0] = "raw"), !_r || N !== "exportKey" || Y !== "spki" && Y !== "pkcs8" || (J[0] = "jwk"), G && N === "wrapKey")
                    return O.exportKey(Y, _a).then(function(wa) {
                      return Y === "jwk" && (wa = n(unescape(encodeURIComponent(JSON.stringify(l(wa)))))), O.encrypt(J[3], X, wa);
                    });
                  try {
                    var ea = _t.apply(O, J);
                  } catch (wa) {
                    return Promise.reject(wa);
                  }
                  return G && (ea = new Promise(function(wa, _s) {
                    ea.onabort = ea.onerror = function(_d) {
                      _s(_d);
                    }, ea.oncomplete = function(_d) {
                      wa(_d.target.result);
                    };
                  })), N === "exportKey" && Y === "jwk" && (ea = ea.then(function(wa) {
                    return (_r || G && (_a.algorithm.hash || {}).name === "SHA-1") && _a.algorithm.name === "HMAC" ? { kty: "oct", alg: u(_a.algorithm), key_ops: _a.usages.slice(), ext: !0, k: t(s(wa)) } : ((wa = l(wa)).alg || (wa.alg = u(_a.algorithm)), wa.key_ops || (wa.key_ops = _a.type === "public" ? _a.usages.filter(_) : _a.type === "private" ? _a.usages.filter(w) : _a.usages.slice()), wa);
                  })), !_r || N !== "exportKey" || Y !== "spki" && Y !== "pkcs8" || (ea = ea.then(function(wa) {
                    var _s = [["", null]], _d = !1;
                    switch ((wa = l(wa)).kty) {
                      case "RSA":
                        for (var _o = "n e d p q dp dq qi".split(" "), _p = [], _f = 0; _f < _o.length && _o[_f] in wa; _f++) {
                          var _g = _p[_f] = n(a(wa[_o[_f]]));
                          128 & _g[0] && (_p[_f] = new Uint8Array(_g.length + 1), _p[_f].set(_g, 1));
                        }
                        2 < _p.length && (_d = !0, _p.unshift(new Uint8Array([0]))), _s[0][0] = "1.2.840.113549.1.1.1";
                        break;
                      default:
                        throw new TypeError("Unsupported key type");
                    }
                    return _s.push(new Uint8Array(p(_p)).buffer), _d ? _s.unshift(new Uint8Array([0])) : _s[1] = { tag: 3, value: _s[1] }, new Uint8Array(p(_s)).buffer;
                  })), ea;
                };
              }), ["encrypt", "decrypt", "sign", "verify"].forEach(function(N) {
                var _t = O[N];
                O[N] = function(Y, _a, X, J) {
                  if (G && (!X.byteLength || J && !J.byteLength))
                    throw Error("Empty input is not allowed");
                  var ea = [].slice.call(arguments), wa = o(Y);
                  if (!G || N !== "sign" && N !== "verify" || Y !== "RSASSA-PKCS1-v1_5" && Y !== "HMAC" || (ea[0] = { name: Y }), G && _a.algorithm.hash && (ea[0].hash = ea[0].hash || _a.algorithm.hash), G && N === "decrypt" && wa.name === "AES-GCM") {
                    var _s = Y.tagLength >> 3;
                    ea[2] = (X.buffer || X).slice(0, X.byteLength - _s), Y.tag = (X.buffer || X).slice(X.byteLength - _s);
                  }
                  G && wa.name === "AES-GCM" && ea[0].tagLength === void 0 && (ea[0].tagLength = 128), ea[1] = _a._key;
                  try {
                    var _d = _t.apply(O, ea);
                  } catch (_o) {
                    return Promise.reject(_o);
                  }
                  return G && (_d = new Promise(function(_o, _p) {
                    _d.onabort = _d.onerror = function(_f) {
                      _p(_f);
                    }, _d.oncomplete = function(_f) {
                      if (_f = _f.target.result, N === "encrypt" && _f instanceof AesGcmEncryptResult) {
                        var _g = _f.ciphertext, f0 = _f.tag;
                        (_f = new Uint8Array(_g.byteLength + f0.byteLength)).set(new Uint8Array(_g), 0), _f.set(new Uint8Array(f0), _g.byteLength), _f = _f.buffer;
                      }
                      _o(_f);
                    };
                  })), _d;
                };
              }), G) {
                var Fa = O.digest;
                O.digest = function(N, _t) {
                  if (!_t.byteLength)
                    throw Error("Empty input is not allowed");
                  try {
                    var Y = Fa.call(O, N, _t);
                  } catch (_a) {
                    return Promise.reject(_a);
                  }
                  return Y = new Promise(function(_a, X) {
                    Y.onabort = Y.onerror = function(J) {
                      X(J);
                    }, Y.oncomplete = function(J) {
                      _a(J.target.result);
                    };
                  });
                }, e.crypto = Object.create(S, { getRandomValues: { value: function(N) {
                  return S.getRandomValues(N);
                } }, subtle: { value: O } }), e.CryptoKey = m;
              }
              _r && (S.subtle = O, e.Crypto = k, e.SubtleCrypto = B, e.CryptoKey = m);
            }
          }
        }
      });
    }), function(r) {
      r.console || (r.console = {}), r = r.console;
      for (var e, t = function() {
      }, a = ["memory"], n = "assert clear count debug dir dirxml error exception group groupCollapsed groupEnd info log markTimeline profile profiles profileEnd show table time timeEnd timeline timelineEnd timeStamp trace warn".split(" "); e = a.pop(); )
        r[e] || (r[e] = {});
      for (; e = n.pop(); )
        r[e] || (r[e] = t);
    }(typeof window > "u" ? Va : window), ba({ target: "Object", stat: !0 }, { setPrototypeOf: ob });
    var ky = ia(function() {
      nc(1);
    });
    ba({ target: "Object", stat: !0, forced: ky, sham: !Io }, { getPrototypeOf: function(r) {
      return nc(lb(r));
    } });
    var cq = [].slice, tk = {}, ly = Function.bind || function(r) {
      var e = Sb(this), t = cq.call(arguments, 1), a = function() {
        var n = t.concat(cq.call(arguments));
        if (this instanceof a) {
          var s = n.length;
          if (!(s in tk)) {
            for (var o = [], u = 0; u < s; u++)
              o[u] = "a[" + u + "]";
            tk[s] = Function("C,a", "return new C(" + o.join(",") + ")");
          }
          n = tk[s](e, n);
        } else
          n = e.apply(r, n);
        return n;
      };
      return va(e.prototype) && (a.prototype = e.prototype), a;
    }, uk = Lc("Reflect", "construct"), dq = ia(function() {
      function r() {
      }
      return !(uk(function() {
      }, [], r) instanceof r);
    }), eq = !ia(function() {
      uk(function() {
      });
    }), fq = dq || eq;
    ba({ target: "Reflect", stat: !0, forced: fq, sham: fq }, { construct: function(r, e) {
      Sb(r), Ia(e);
      var t = 3 > arguments.length ? r : Sb(arguments[2]);
      if (eq && !dq)
        return uk(r, e, t);
      if (r == t) {
        switch (e.length) {
          case 0:
            return new r();
          case 1:
            return new r(e[0]);
          case 2:
            return new r(e[0], e[1]);
          case 3:
            return new r(e[0], e[1], e[2]);
          case 4:
            return new r(e[0], e[1], e[2], e[3]);
        }
        return (t = [null]).push.apply(t, e), new (ly.apply(r, t))();
      }
      t = t.prototype, t = ec(va(t) ? t : Object.prototype);
      var a = Function.apply.call(r, t, e);
      return va(a) ? a : t;
    } }), ba({ target: "Reflect", stat: !0 }, { get: vm });
    var gq = Zb.f, my = ia(function() {
      gq(1);
    });
    ba({ target: "Object", stat: !0, forced: !ta || my, sham: !ta }, { getOwnPropertyDescriptor: function(r, e) {
      return gq(Ib(r), e);
    } });
    var hq = ce.f, ny = {}.toString, iq = typeof window == "object" && window && Object.getOwnPropertyNames ? Object.getOwnPropertyNames(window) : [], vk = function(r) {
      if (iq && ny.call(r) == "[object Window]")
        try {
          var e = hq(r);
        } catch {
          e = iq.slice();
        }
      else
        e = hq(Ib(r));
      return e;
    }, jq = { f: Ea }, oy = mb.f, Xh = function(r) {
      var e = Q.Symbol || (Q.Symbol = {});
      ha(e, r) || oy(e, r, { value: jq.f(r) });
    }, Jb = uh("hidden"), kq = Ea("toPrimitive"), py = Za.set, lq = Za.getterFor("Symbol"), fc = Object.prototype, Kb = Q.Symbol, wg = Lc("JSON", "stringify"), mq = Zb.f, Id = mb.f, nq = vk, qy = cg, ed = zd("symbols"), xg = zd("op-symbols"), wk = zd("string-to-symbol-registry"), xk = zd("symbol-to-string-registry"), ry = zd("wks"), yk = Q.QObject, zk = !yk || !yk.prototype || !yk.prototype.findChild, Ak = ta && ia(function() {
      return ec(Id({}, "a", { get: function() {
        return Id(this, "a", { value: 7 }).a;
      } })).a != 7;
    }) ? function(r, e, t) {
      var a = mq(fc, e);
      a && delete fc[e], Id(r, e, t), a && r !== fc && Id(fc, e, a);
    } : Id, Bk = function(r, e) {
      var t = ed[r] = ec(Kb.prototype);
      return py(t, { type: "Symbol", tag: r, description: e }), ta || (t.description = e), t;
    }, Ck = to ? function(r) {
      return typeof r == "symbol";
    } : function(r) {
      return Object(r) instanceof Kb;
    }, Yh = function(r, e, t) {
      return r === fc && Yh(xg, e, t), Ia(r), e = Kc(e, !0), Ia(t), ha(ed, e) ? (t.enumerable ? (ha(r, Jb) && r[Jb][e] && (r[Jb][e] = !1), t = ec(t, { enumerable: Jc(0, !1) })) : (ha(r, Jb) || Id(r, Jb, Jc(1, {})), r[Jb][e] = !0), Ak(r, e, t)) : Id(r, e, t);
    }, oq = function(r, e) {
      Ia(r);
      var t = Ib(e);
      return e = $c(t).concat(Dk(t)), ee(e, function(a) {
        ta && !Ek.call(t, a) || Yh(r, a, t[a]);
      }), r;
    }, Ek = function(r) {
      r = Kc(r, !0);
      var e = qy.call(this, r);
      return !(this === fc && ha(ed, r) && !ha(xg, r)) && (!(e || !ha(this, r) || !ha(ed, r) || ha(this, Jb) && this[Jb][r]) || e);
    }, pq = function(r, e) {
      if (r = Ib(r), e = Kc(e, !0), r !== fc || !ha(ed, e) || ha(xg, e)) {
        var t = mq(r, e);
        return !t || !ha(ed, e) || ha(r, Jb) && r[Jb][e] || (t.enumerable = !0), t;
      }
    }, qq = function(r) {
      r = nq(Ib(r));
      var e = [];
      return ee(r, function(t) {
        ha(ed, t) || ha(Ze, t) || e.push(t);
      }), e;
    }, Dk = function(r) {
      var e = r === fc;
      r = nq(e ? xg : Ib(r));
      var t = [];
      return ee(r, function(a) {
        !ha(ed, a) || e && !ha(fc, a) || t.push(ed[a]);
      }), t;
    };
    if (Oc || (Kb = function() {
      if (this instanceof Kb)
        throw TypeError("Symbol is not a constructor");
      var r = arguments.length && arguments[0] !== void 0 ? String(arguments[0]) : void 0, e = Ye(r), t = function(a) {
        this === fc && t.call(xg, a), ha(this, Jb) && ha(this[Jb], e) && (this[Jb][e] = !1), Ak(this, e, Jc(1, a));
      };
      return ta && zk && Ak(fc, e, { configurable: !0, set: t }), Bk(e, r);
    }, Wa(Kb.prototype, "toString", function() {
      return lq(this).tag;
    }), Wa(Kb, "withoutSetter", function(r) {
      return Bk(Ye(r), r);
    }), cg = Ek, mb.f = Yh, Zb.f = pq, ce.f = vk = qq, eg.f = Dk, jq.f = function(r) {
      return Bk(Ea(r), r);
    }, ta && (Id(Kb.prototype, "description", { configurable: !0, get: function() {
      return lq(this).description;
    } }), Wa(fc, "propertyIsEnumerable", Ek, { unsafe: !0 }))), ba({ global: !0, wrap: !0, forced: !Oc, sham: !Oc }, { Symbol: Kb }), ee($c(ry), function(r) {
      Xh(r);
    }), ba({ target: "Symbol", stat: !0, forced: !Oc }, { for: function(r) {
      if (r = String(r), ha(wk, r))
        return wk[r];
      var e = Kb(r);
      return wk[r] = e, xk[e] = r, e;
    }, keyFor: function(r) {
      if (!Ck(r))
        throw TypeError(r + " is not a symbol");
      if (ha(xk, r))
        return xk[r];
    }, useSetter: function() {
      zk = !0;
    }, useSimple: function() {
      zk = !1;
    } }), ba({ target: "Object", stat: !0, forced: !Oc, sham: !ta }, { create: function(r, e) {
      return e === void 0 ? ec(r) : oq(ec(r), e);
    }, defineProperty: Yh, defineProperties: oq, getOwnPropertyDescriptor: pq }), ba({ target: "Object", stat: !0, forced: !Oc }, { getOwnPropertyNames: qq, getOwnPropertySymbols: Dk }), ba({ target: "Object", stat: !0, forced: ia(function() {
      eg.f(1);
    }) }, { getOwnPropertySymbols: function(r) {
      return eg.f(lb(r));
    } }), wg) {
      var sy = !Oc || ia(function() {
        var r = Kb();
        return wg([r]) != "[null]" || wg({ a: r }) != "{}" || wg(Object(r)) != "{}";
      });
      ba({ target: "JSON", stat: !0, forced: sy }, { stringify: function(r, e, t) {
        for (var a, n = [r], s = 1; arguments.length > s; )
          n.push(arguments[s++]);
        if (a = e, (va(e) || r !== void 0) && !Ck(r))
          return Dd(e) || (e = function(o, u) {
            if (typeof a == "function" && (u = a.call(this, o, u)), !Ck(u))
              return u;
          }), n[1] = e, wg.apply(null, n);
      } });
    }
    Kb.prototype[kq] || gb(Kb.prototype, kq, Kb.prototype.valueOf), sc(Kb, "Symbol"), Ze[Jb] = !0;
    var ty = mb.f, fd = Q.Symbol;
    if (ta && typeof fd == "function" && (!("description" in fd.prototype) || fd().description !== void 0)) {
      var rq = {}, yg = function() {
        var r = 1 > arguments.length || arguments[0] === void 0 ? void 0 : String(arguments[0]), e = this instanceof yg ? new fd(r) : r === void 0 ? fd() : fd(r);
        return r === "" && (rq[e] = !0), e;
      };
      no(yg, fd);
      var Fk = yg.prototype = fd.prototype;
      Fk.constructor = yg;
      var uy = Fk.toString, vy = String(fd("test")) == "Symbol(test)", wy = /^Symbol\((.*)\)[^)]+$/;
      ty(Fk, "description", { configurable: !0, get: function() {
        var r = va(this) ? this.valueOf() : this, e = uy.call(r);
        return ha(rq, r) ? "" : (r = vy ? e.slice(7, -1) : e.replace(wy, "$1")) === "" ? void 0 : r;
      } }), ba({ global: !0, forced: !0 }, { Symbol: yg });
    }
    Xh("toStringTag"), sc(Q.JSON, "JSON", !0), sc(Math, "Math", !0), function() {
      function r(h, p) {
        if (!(h instanceof p))
          throw new TypeError("Cannot call a class as a function");
      }
      function e(h, p) {
        for (var m = 0; m < p.length; m++) {
          var _ = p[m];
          _.enumerable = _.enumerable || !1, _.configurable = !0, "value" in _ && (_.writable = !0), Object.defineProperty(h, _.key, _);
        }
      }
      function t(h, p, m) {
        return p && e(h.prototype, p), m && e(h, m), h;
      }
      function a(h) {
        return (a = Object.setPrototypeOf ? Object.getPrototypeOf : function(p) {
          return p.__proto__ || Object.getPrototypeOf(p);
        })(h);
      }
      function n(h, p) {
        return (n = Object.setPrototypeOf || function(m, _) {
          return m.__proto__ = _, m;
        })(h, p);
      }
      function s(h) {
        if (h === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return h;
      }
      function o(h) {
        var p = function() {
          if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
            return !1;
          if (typeof Proxy == "function")
            return !0;
          try {
            return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
            })), !0;
          } catch {
            return !1;
          }
        }();
        return function() {
          var m = a(h);
          if (p) {
            var _ = a(this).constructor;
            m = Reflect.construct(m, arguments, _);
          } else
            m = m.apply(this, arguments);
          return m = !m || oa(m) !== "object" && typeof m != "function" ? s(this) : m;
        };
      }
      function u(h, p, m) {
        return (u = typeof Reflect < "u" && Reflect.get ? Reflect.get : function(_, w, S) {
          for (; !Object.prototype.hasOwnProperty.call(_, w) && (_ = a(_)) !== null; )
            ;
          if (_)
            return (w = Object.getOwnPropertyDescriptor(_, w)).get ? w.get.call(S) : w.value;
        })(h, p, m || h);
      }
      var l = function() {
        function h() {
          r(this, h), Object.defineProperty(this, "listeners", { value: {}, writable: !0, configurable: !0 });
        }
        return t(h, [{ key: "addEventListener", value: function(p, m, _) {
          p in this.listeners || (this.listeners[p] = []), this.listeners[p].push({ callback: m, options: _ });
        } }, { key: "removeEventListener", value: function(p, m) {
          if (p in this.listeners) {
            for (var _ = 0, w = (p = this.listeners[p]).length; _ < w; _++)
              if (p[_].callback === m) {
                p.splice(_, 1);
                break;
              }
          }
        } }, { key: "dispatchEvent", value: function(p) {
          if (p.type in this.listeners) {
            for (var m = this.listeners[p.type].slice(), _ = 0, w = m.length; _ < w; _++) {
              var S = m[_];
              try {
                S.callback.call(this, p);
              } catch (O) {
                Promise.resolve().then(function() {
                  throw O;
                });
              }
              S.options && S.options.once && this.removeEventListener(p.type, S.callback);
            }
            return !p.defaultPrevented;
          }
        } }]), h;
      }(), f = function(h) {
        function p() {
          r(this, p);
          var _ = m.call(this);
          return _.listeners || l.call(s(_)), Object.defineProperty(s(_), "aborted", { value: !1, writable: !0, configurable: !0 }), Object.defineProperty(s(_), "onabort", { value: null, writable: !0, configurable: !0 }), _;
        }
        (function(_, w) {
          if (typeof w != "function" && w !== null)
            throw new TypeError("Super expression must either be null or a function");
          _.prototype = Object.create(w && w.prototype, { constructor: { value: _, writable: !0, configurable: !0 } }), w && n(_, w);
        })(p, h);
        var m = o(p);
        return t(p, [{ key: "toString", value: function() {
          return "[object AbortSignal]";
        } }, { key: "dispatchEvent", value: function(_) {
          _.type === "abort" && (this.aborted = !0, typeof this.onabort == "function" && this.onabort.call(this, _)), u(a(p.prototype), "dispatchEvent", this).call(this, _);
        } }]), p;
      }(l), d = function() {
        function h() {
          r(this, h), Object.defineProperty(this, "signal", { value: new f(), writable: !0, configurable: !0 });
        }
        return t(h, [{ key: "abort", value: function() {
          try {
            var p = new Event("abort");
          } catch {
            typeof document < "u" ? document.createEvent ? (p = document.createEvent("Event")).initEvent("abort", !1, !1) : (p = document.createEventObject()).type = "abort" : p = { type: "abort", bubbles: !1, cancelable: !1 };
          }
          this.signal.dispatchEvent(p);
        } }, { key: "toString", value: function() {
          return "[object AbortController]";
        } }]), h;
      }();
      typeof Symbol < "u" && Symbol.toStringTag && (d.prototype[Symbol.toStringTag] = "AbortController", f.prototype[Symbol.toStringTag] = "AbortSignal"), function(h) {
        if (h.__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL) {
          console.log("__FORCE_INSTALL_ABORTCONTROLLER_POLYFILL=true is set, will force install polyfill");
          var p = !0;
        } else
          p = typeof h.Request == "function" && !h.Request.prototype.hasOwnProperty("signal") || !h.AbortController;
        p && (h.AbortController = d, h.AbortSignal = f);
      }(typeof self < "u" ? self : Va);
    }();
    var xy = Math.floor, yy = Math.log, zy = Math.LOG2E;
    ba({ target: "Math", stat: !0 }, { clz32: function(r) {
      return (r >>>= 0) ? 31 - xy(yy(r + 0.5) * zy) : 32;
    } });
    var Ay = Math.log, By = Math.LN2, Vt = Math.clz32 || function(r) {
      return 31 - Ay(r >>> 0) / By | 0;
    }, Td = String.fromCharCode, sq = {}.toString, Gk = window.Uint8Array, Hk = Gk || Array, Cy = sq.call((window.ArrayBuffer || Hk).prototype), Ik;
    wm.prototype.decode = function(r) {
      if (r = r && r.buffer || r, sq.call(r) !== Cy)
        throw Error("Failed to execute 'decode' on 'TextDecoder': The provided value is not of type '(ArrayBuffer or ArrayBufferView)'");
      for (var e = "", t = 0, a = 0 | (r = Gk ? new Hk(r) : r).length; t < a; t = t + 32768 | 0)
        e += Td.apply(0, r[Gk ? "slice" : "subarray"](t, t + 32768 | 0));
      return e.replace(/[\xc0-\xff][\x80-\xbf]*/g, Ut);
    }, window.TextDecoder || (window.TextDecoder = wm), xm.prototype.encode = function(r) {
      for (var e = 0 | (r = r === void 0 ? "" : ("" + r).replace(/[\x80-\uD7ff\uDC00-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]?/g, Wt)).length, t = new Hk(e), a = 0; a < e; a = a + 1 | 0)
        t[a] = r.charCodeAt(a);
      return t;
    }, window.TextEncoder || (window.TextEncoder = xm), function(r) {
      var e, t, a, n, s, o, u, l, f, d, h, p;
      (t = e || (e = {})).LOGIN = "LOGIN", t.LOGIN_SUCCESS = "LOGIN_SUCCESS", t.LOGIN_FAILURE = "LOGIN_FAILURE", t.LOGIN_TIMEOUT = "LOGIN_TIMEOUT", t.INTERRUPTED = "INTERRUPTED", t.LOGOUT = "LOGOUT", t.BANNED_BY_SERVER = "BANNED_BY_SERVER", t.REMOTE_LOGIN = "REMOTE_LOGIN", t.TOKEN_EXPIRED = "TOKEN_EXPIRED", r.ConnectionChangeReason = e, function(m) {
        m.DISCONNECTED = "DISCONNECTED", m.CONNECTING = "CONNECTING", m.CONNECTED = "CONNECTED", m.RECONNECTING = "RECONNECTING", m.ABORTED = "ABORTED";
      }(a || (a = {})), r.ConnectionState = a, function(m) {
        m.IDLE = "IDLE", m.SENT_TO_REMOTE = "SENT_TO_REMOTE", m.RECEIVED_BY_REMOTE = "RECEIVED_BY_REMOTE", m.ACCEPTED_BY_REMOTE = "ACCEPTED_BY_REMOTE", m.REFUSED_BY_REMOTE = "REFUSED_BY_REMOTE", m.CANCELED = "CANCELED", m.FAILURE = "FAILURE";
      }(n || (n = {})), r.LocalInvitationState = n, function(m) {
        m.INVITATION_RECEIVED = "INVITATION_RECEIVED", m.ACCEPT_SENT_TO_LOCAL = "ACCEPT_SENT_TO_LOCAL", m.REFUSED = "REFUSED", m.ACCEPTED = "ACCEPTED", m.CANCELED = "CANCELED", m.FAILURE = "FAILURE";
      }(s || (s = {})), r.RemoteInvitationState = s, function(m) {
        m.UNKNOWN = "UNKNOWN", m.PEER_NO_RESPONSE = "PEER_NO_RESPONSE", m.INVITATION_EXPIRE = "INVITATION_EXPIRE", m.PEER_OFFLINE = "PEER_OFFLINE", m.NOT_LOGGEDIN = "NOT_LOGGEDIN";
      }(o || (o = {})), r.LocalInvitationFailureReason = o, function(m) {
        m.UNKNOWN = "UNKNOWN", m.PEER_OFFLINE = "PEER_OFFLINE", m.ACCEPT_FAILURE = "ACCEPT_FAILURE", m.INVITATION_EXPIRE = "INVITATION_EXPIRE";
      }(u || (u = {})), r.RemoteInvitationFailureReason = u, function(m) {
        m.ONLINE = "ONLINE", m.UNREACHABLE = "UNREACHABLE", m.OFFLINE = "OFFLINE";
      }(l || (l = {})), r.PeerOnlineState = l, (f || (f = {})).ONLINE_STATUS = "ONLINE_STATUS", r.PeerSubscriptionOption = f, function(m) {
        m.TEXT = "TEXT", m.RAW = "RAW";
      }(d || (d = {})), r.MessageType = d, function(m) {
        m.CN = "CN", m.NA = "NA", m.EU = "EU", m.AS = "AS", m.JP = "JP", m.IN = "IN", m.GLOB = "GLOB", m.OC = "OC", m.SA = "SA", m.AF = "AF", m.OVS = "OVS";
      }(h || (h = {})), r.LegacyAreaCode = h, function(m) {
        m.GLOBAL = "GLOBAL", m.INDIA = "INDIA", m.JAPAN = "JAPAN", m.ASIA = "ASIA", m.EUROPE = "EUROPE", m.CHINA = "CHINA", m.NORTH_AMERICA = "NORTH_AMERICA";
      }(p || (p = {})), r.AreaCode = p;
    }(Ik || (Ik = {}));
    var qa = Ik;
    ba({ target: "Array", proto: !0 }, { includes: function(r) {
      return ko(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } }), lg("includes");
    var Jk = function(r) {
      if (Fj(r))
        throw TypeError("The method doesn't accept regular expressions");
      return r;
    }, Dy = Ea("match"), Kk = function(r) {
      var e = /./;
      try {
        "/./"[r](e);
      } catch {
        try {
          return e[Dy] = !1, "/./"[r](e);
        } catch {
        }
      }
      return !1;
    };
    ba({ target: "String", proto: !0, forced: !Kk("includes") }, { includes: function(r) {
      return !!~String(Bb(this)).indexOf(Jk(r), 1 < arguments.length ? arguments[1] : void 0);
    } });
    var xc = { RECONNECTING_AP_INTERVAL: 2500, RECONNECTING_AP_NUM: 2, DISABLE_MESSAGE_COMPRESSION: !1, LOG_UPLOAD_INTERVAL: 3e3, LOG_HANDLER: void 0, ENABLE_EDGE_AUTO_FALLBACK: !0 };
    Xh("iterator"), Xh("asyncIterator");
    var Lk = cf("forEach") ? [].forEach : function(r) {
      return ee(this, r, 1 < arguments.length ? arguments[1] : void 0);
    }, tq;
    for (tq in qk) {
      var uq = Q[tq], Zh = uq && uq.prototype;
      if (Zh && Zh.forEach !== Lk)
        try {
          gb(Zh, "forEach", Lk);
        } catch {
          Zh.forEach = Lk;
        }
    }
    var Ey = [].reverse, vq = [1, 2];
    ba({ target: "Array", proto: !0, forced: String(vq) === String(vq.reverse()) }, { reverse: function() {
      return Dd(this) && (this.length = this.length), Ey.call(this);
    } });
    var M = tb(function(r) {
      r = function(e) {
        function t(X, J, ea) {
          return Object.defineProperty(X, J, { value: ea, enumerable: !0, configurable: !0, writable: !0 }), X[J];
        }
        function a(X, J, ea, wa) {
          return J = Object.create((J && J.prototype instanceof s ? J : s).prototype), wa = new m(wa || []), J._invoke = function(_s, _d, _o) {
            var _p = ga;
            return function(_f, _g) {
              if (_p === Fa)
                throw Error("Generator is already running");
              if (_p === N) {
                if (_f === "throw")
                  throw _g;
                return w();
              }
              for (_o.method = _f, _o.arg = _g; ; ) {
                if ((_f = _o.delegate) && (_f = d(_f, _o))) {
                  if (_f === _t)
                    continue;
                  return _f;
                }
                if (_o.method === "next")
                  _o.sent = _o._sent = _o.arg;
                else if (_o.method === "throw") {
                  if (_p === ga)
                    throw _p = N, _o.arg;
                  _o.dispatchException(_o.arg);
                } else
                  _o.method === "return" && _o.abrupt("return", _o.arg);
                if (_p = Fa, (_f = n(_s, _d, _o)).type === "normal") {
                  if (_p = _o.done ? N : _n, _f.arg === _t)
                    continue;
                  return { value: _f.arg, done: _o.done };
                }
                _f.type === "throw" && (_p = N, _o.method = "throw", _o.arg = _f.arg);
              }
            };
          }(X, ea, wa), J;
        }
        function n(X, J, ea) {
          try {
            return { type: "normal", arg: X.call(J, ea) };
          } catch (wa) {
            return { type: "throw", arg: wa };
          }
        }
        function s() {
        }
        function o() {
        }
        function u() {
        }
        function l(X) {
          ["next", "throw", "return"].forEach(function(J) {
            t(X, J, function(ea) {
              return this._invoke(J, ea);
            });
          });
        }
        function f(X, J) {
          function ea(_s, _d, _o, _p) {
            if ((_s = n(X[_s], X, _d)).type !== "throw") {
              var _f = _s.arg;
              return (_s = _f.value) && oa(_s) === "object" && k.call(_s, "__await") ? J.resolve(_s.__await).then(function(_g) {
                ea("next", _g, _o, _p);
              }, function(_g) {
                ea("throw", _g, _o, _p);
              }) : J.resolve(_s).then(function(_g) {
                _f.value = _g, _o(_f);
              }, function(_g) {
                return ea("throw", _g, _o, _p);
              });
            }
            _p(_s.arg);
          }
          var wa;
          this._invoke = function(_s, _d) {
            function _o() {
              return new J(function(_p, _f) {
                ea(_s, _d, _p, _f);
              });
            }
            return wa = wa ? wa.then(_o, _o) : _o();
          };
        }
        function d(X, J) {
          var ea = X.iterator[J.method];
          if (ea === S) {
            if (J.delegate = null, J.method === "throw") {
              if (X.iterator.return && (J.method = "return", J.arg = S, d(X, J), J.method === "throw"))
                return _t;
              J.method = "throw", J.arg = new TypeError("The iterator does not provide a 'throw' method");
            }
            return _t;
          }
          return (ea = n(ea, X.iterator, J.arg)).type === "throw" ? (J.method = "throw", J.arg = ea.arg, J.delegate = null, _t) : (ea = ea.arg) ? ea.done ? (J[X.resultName] = ea.value, J.next = X.nextLoc, J.method !== "return" && (J.method = "next", J.arg = S), J.delegate = null, _t) : ea : (J.method = "throw", J.arg = new TypeError("iterator result is not an object"), J.delegate = null, _t);
        }
        function h(X) {
          var J = { tryLoc: X[0] };
          1 in X && (J.catchLoc = X[1]), 2 in X && (J.finallyLoc = X[2], J.afterLoc = X[3]), this.tryEntries.push(J);
        }
        function p(X) {
          var J = X.completion || {};
          J.type = "normal", delete J.arg, X.completion = J;
        }
        function m(X) {
          this.tryEntries = [{ tryLoc: "root" }], X.forEach(h, this), this.reset(!0);
        }
        function _(X) {
          if (X) {
            var J = X[L];
            if (J)
              return J.call(X);
            if (typeof X.next == "function")
              return X;
            if (!isNaN(X.length)) {
              var ea = -1;
              return (J = function wa() {
                for (; ++ea < X.length; )
                  if (k.call(X, ea))
                    return wa.value = X[ea], wa.done = !1, wa;
                return wa.value = S, wa.done = !0, wa;
              }).next = J;
            }
          }
          return { next: w };
        }
        function w() {
          return { value: S, done: !0 };
        }
        var S, O = Object.prototype, k = O.hasOwnProperty, B = typeof Symbol == "function" ? Symbol : {}, L = B.iterator || "@@iterator", G = B.asyncIterator || "@@asyncIterator", _r = B.toStringTag || "@@toStringTag";
        try {
          t({}, "");
        } catch {
          t = function(J, ea, wa) {
            return J[ea] = wa;
          };
        }
        e.wrap = a;
        var ga = "suspendedStart", _n = "suspendedYield", Fa = "executing", N = "completed", _t = {};
        t(B = {}, L, function() {
          return this;
        });
        var Y = Object.getPrototypeOf;
        (Y = Y && Y(Y(_([])))) && Y !== O && k.call(Y, L) && (B = Y);
        var _a = u.prototype = s.prototype = Object.create(B);
        return o.prototype = u, t(_a, "constructor", u), t(u, "constructor", o), o.displayName = t(u, _r, "GeneratorFunction"), e.isGeneratorFunction = function(X) {
          return !!(X = typeof X == "function" && X.constructor) && (X === o || (X.displayName || X.name) === "GeneratorFunction");
        }, e.mark = function(X) {
          return Object.setPrototypeOf ? Object.setPrototypeOf(X, u) : (X.__proto__ = u, t(X, _r, "GeneratorFunction")), X.prototype = Object.create(_a), X;
        }, e.awrap = function(X) {
          return { __await: X };
        }, l(f.prototype), t(f.prototype, G, function() {
          return this;
        }), e.AsyncIterator = f, e.async = function(X, J, ea, wa, _s) {
          _s === void 0 && (_s = Promise);
          var _d = new f(a(X, J, ea, wa), _s);
          return e.isGeneratorFunction(J) ? _d : _d.next().then(function(_o) {
            return _o.done ? _o.value : _d.next();
          });
        }, l(_a), t(_a, _r, "Generator"), t(_a, L, function() {
          return this;
        }), t(_a, "toString", function() {
          return "[object Generator]";
        }), e.keys = function(X) {
          var J, ea = [];
          for (J in X)
            ea.push(J);
          return ea.reverse(), function wa() {
            for (; ea.length; ) {
              var _s = ea.pop();
              if (_s in X)
                return wa.value = _s, wa.done = !1, wa;
            }
            return wa.done = !0, wa;
          };
        }, e.values = _, m.prototype = { constructor: m, reset: function(X) {
          if (this.next = this.prev = 0, this.sent = this._sent = S, this.done = !1, this.delegate = null, this.method = "next", this.arg = S, this.tryEntries.forEach(p), !X)
            for (var J in this)
              J.charAt(0) === "t" && k.call(this, J) && !isNaN(+J.slice(1)) && (this[J] = S);
        }, stop: function() {
          this.done = !0;
          var X = this.tryEntries[0].completion;
          if (X.type === "throw")
            throw X.arg;
          return this.rval;
        }, dispatchException: function(X) {
          function J(_f, _g) {
            return _d.type = "throw", _d.arg = X, ea.next = _f, _g && (ea.method = "next", ea.arg = S), !!_g;
          }
          if (this.done)
            throw X;
          for (var ea = this, wa = this.tryEntries.length - 1; 0 <= wa; --wa) {
            var _s = this.tryEntries[wa], _d = _s.completion;
            if (_s.tryLoc === "root")
              return J("end");
            if (_s.tryLoc <= this.prev) {
              var _o = k.call(_s, "catchLoc"), _p = k.call(_s, "finallyLoc");
              if (_o && _p) {
                if (this.prev < _s.catchLoc)
                  return J(_s.catchLoc, !0);
                if (this.prev < _s.finallyLoc)
                  return J(_s.finallyLoc);
              } else if (_o) {
                if (this.prev < _s.catchLoc)
                  return J(_s.catchLoc, !0);
              } else {
                if (!_p)
                  throw Error("try statement without catch or finally");
                if (this.prev < _s.finallyLoc)
                  return J(_s.finallyLoc);
              }
            }
          }
        }, abrupt: function(X, J) {
          for (var ea = this.tryEntries.length - 1; 0 <= ea; --ea) {
            var wa = this.tryEntries[ea];
            if (wa.tryLoc <= this.prev && k.call(wa, "finallyLoc") && this.prev < wa.finallyLoc) {
              var _s = wa;
              break;
            }
          }
          return _s && (X === "break" || X === "continue") && _s.tryLoc <= J && J <= _s.finallyLoc && (_s = null), (ea = _s ? _s.completion : {}).type = X, ea.arg = J, _s ? (this.method = "next", this.next = _s.finallyLoc, _t) : this.complete(ea);
        }, complete: function(X, J) {
          if (X.type === "throw")
            throw X.arg;
          return X.type === "break" || X.type === "continue" ? this.next = X.arg : X.type === "return" ? (this.rval = this.arg = X.arg, this.method = "return", this.next = "end") : X.type === "normal" && J && (this.next = J), _t;
        }, finish: function(X) {
          for (var J = this.tryEntries.length - 1; 0 <= J; --J) {
            var ea = this.tryEntries[J];
            if (ea.finallyLoc === X)
              return this.complete(ea.completion, ea.afterLoc), p(ea), _t;
          }
        }, catch: function(X) {
          for (var J = this.tryEntries.length - 1; 0 <= J; --J) {
            var ea = this.tryEntries[J];
            if (ea.tryLoc === X) {
              if ((X = ea.completion).type === "throw") {
                var wa = X.arg;
                p(ea);
              }
              return wa;
            }
          }
          throw Error("illegal catch attempt");
        }, delegateYield: function(X, J, ea) {
          return this.delegate = { iterator: _(X), resultName: J, nextLoc: ea }, this.method === "next" && (this.arg = S), _t;
        } }, e;
      }(r.exports);
      try {
        regeneratorRuntime = r;
      } catch {
        (typeof globalThis > "u" ? "undefined" : oa(globalThis)) === "object" ? globalThis.regeneratorRuntime = r : Function("r", "regeneratorRuntime = r")(r);
      }
    }), wq = !ia(function() {
      return Object.isExtensible(Object.preventExtensions({}));
    }), Mk = tb(function(r) {
      var e = mb.f, t = Ye("meta"), a = 0, n = Object.isExtensible || function() {
        return !0;
      }, s = function(u) {
        e(u, t, { value: { objectID: "O" + ++a, weakData: {} } });
      }, o = r.exports = { REQUIRED: !1, fastKey: function(u, l) {
        if (!va(u))
          return typeof u == "symbol" ? u : (typeof u == "string" ? "S" : "P") + u;
        if (!ha(u, t)) {
          if (!n(u))
            return "F";
          if (!l)
            return "E";
          s(u);
        }
        return u[t].objectID;
      }, getWeakData: function(u, l) {
        if (!ha(u, t)) {
          if (!n(u))
            return !0;
          if (!l)
            return !1;
          s(u);
        }
        return u[t].weakData;
      }, onFreeze: function(u) {
        return wq && o.REQUIRED && n(u) && !ha(u, t) && s(u), u;
      } };
      Ze[t] = !0;
    }), xq = function(r, e, t) {
      var a = r.indexOf("Map") !== -1, n = r.indexOf("Weak") !== -1, s = a ? "set" : "add", o = Q[r], u = o && o.prototype, l = o, f = {}, d = function(S) {
        var O = u[S];
        Wa(u, S, S == "add" ? function(k) {
          return O.call(this, k === 0 ? 0 : k), this;
        } : S == "delete" ? function(k) {
          return !(n && !va(k)) && O.call(this, k === 0 ? 0 : k);
        } : S == "get" ? function(k) {
          return n && !va(k) ? void 0 : O.call(this, k === 0 ? 0 : k);
        } : S == "has" ? function(k) {
          return !(n && !va(k)) && O.call(this, k === 0 ? 0 : k);
        } : function(k, B) {
          return O.call(this, k === 0 ? 0 : k, B), this;
        });
      };
      if (Mc(r, typeof o != "function" || !(n || u.forEach && !ia(function() {
        new o().entries().next();
      }))))
        l = t.getConstructor(e, r, a, s), Mk.REQUIRED = !0;
      else if (Mc(r, !0)) {
        var h = new l(), p = h[s](n ? {} : -0, 1) != h, m = ia(function() {
          h.has(1);
        }), _ = Bh(function(S) {
          new o(S);
        }), w = !n && ia(function() {
          for (var S = new o(), O = 5; O--; )
            S[s](O, O);
          return !S.has(-0);
        });
        _ || ((l = e(function(S, O) {
          return tc(S, l, r), S = Th(new o(), S, l), O != null && Gh(O, S[s], { that: S, AS_ENTRIES: a }), S;
        })).prototype = u, u.constructor = l), (m || w) && (d("delete"), d("has"), a && d("get")), (w || p) && d(s), n && u.clear && delete u.clear;
      }
      return f[r] = l, ba({ global: !0, forced: l != o }, f), sc(l, r), n || t.setStrong(l, r, a), l;
    }, Fy = mb.f, yq = Mk.fastKey, zq = Za.set, Nk = Za.getterFor, Aq = { getConstructor: function(r, e, t, a) {
      var n = r(function(l, f) {
        tc(l, n, e), zq(l, { type: e, index: ec(null), first: void 0, last: void 0, size: 0 }), ta || (l.size = 0), f != null && Gh(f, l[a], { that: l, AS_ENTRIES: t });
      }), s = Nk(e), o = function(l, f, d) {
        var h, p = s(l), m = u(l, f);
        return m ? m.value = d : (p.last = m = { index: h = yq(f, !0), key: f, value: d, previous: f = p.last, next: void 0, removed: !1 }, p.first || (p.first = m), f && (f.next = m), ta ? p.size++ : l.size++, h !== "F" && (p.index[h] = m)), l;
      }, u = function(l, f) {
        l = s(l);
        var d = yq(f);
        if (d !== "F")
          return l.index[d];
        for (l = l.first; l; l = l.next)
          if (l.key == f)
            return l;
      };
      return gf(n.prototype, { clear: function() {
        for (var l = s(this), f = l.index, d = l.first; d; )
          d.removed = !0, d.previous && (d.previous = d.previous.next = void 0), delete f[d.index], d = d.next;
        l.first = l.last = void 0, ta ? l.size = 0 : this.size = 0;
      }, delete: function(l) {
        var f = s(this);
        if (l = u(this, l)) {
          var d = l.next, h = l.previous;
          delete f.index[l.index], l.removed = !0, h && (h.next = d), d && (d.previous = h), f.first == l && (f.first = d), f.last == l && (f.last = h), ta ? f.size-- : this.size--;
        }
        return !!l;
      }, forEach: function(l) {
        for (var f, d = s(this), h = Cd(l, 1 < arguments.length ? arguments[1] : void 0, 3); f = f ? f.next : d.first; )
          for (h(f.value, f.key, this); f && f.removed; )
            f = f.previous;
      }, has: function(l) {
        return !!u(this, l);
      } }), gf(n.prototype, t ? { get: function(l) {
        return (l = u(this, l)) && l.value;
      }, set: function(l, f) {
        return o(this, l === 0 ? 0 : l, f);
      } } : { add: function(l) {
        return o(this, l = l === 0 ? 0 : l, l);
      } }), ta && Fy(n.prototype, "size", { get: function() {
        return s(this).size;
      } }), n;
    }, setStrong: function(r, e, t) {
      var a = e + " Iterator", n = Nk(e), s = Nk(a);
      Qj(r, e, function(o, u) {
        zq(this, { type: a, target: o, state: n(o), kind: u, last: void 0 });
      }, function() {
        for (var o = s(this), u = o.kind, l = o.last; l && l.removed; )
          l = l.previous;
        return o.target && (o.last = l = l ? l.next : o.state.first) ? u == "keys" ? { value: l.key, done: !1 } : u == "values" ? { value: l.value, done: !1 } : { value: [l.key, l.value], done: !1 } : (o.target = void 0, { value: void 0, done: !0 });
      }, t ? "entries" : "values", !t, !0), mg(e);
    } };
    xq("Set", function(r) {
      return function() {
        return r(this, arguments.length ? arguments[0] : void 0);
      };
    }, Aq);
    var Ok = Lc("Reflect", "apply"), Gy = Function.apply, Hy = !ia(function() {
      Ok(function() {
      });
    });
    ba({ target: "Reflect", stat: !0, forced: Hy }, { apply: function(r, e, t) {
      return Sb(r), Ia(t), Ok ? Ok(r, e, t) : Gy.call(r, e, t);
    } }), ba({ target: "Reflect", stat: !0 }, { ownKeys: mo });
    var Bq = Ea("isConcatSpreadable"), Iy = 51 <= Bd || !ia(function() {
      var r = [];
      return r[Bq] = !1, r.concat()[0] !== r;
    }), Jy = ig("concat");
    ba({ target: "Array", proto: !0, forced: !Iy || !Jy }, { concat: function(r) {
      var e, t = lb(this), a = Ah(t, 0), n = 0, s = -1;
      for (e = arguments.length; s < e; s++) {
        var o = s === -1 ? t : arguments[s], u = o;
        if (va(u)) {
          var l = u[Bq];
          u = l !== void 0 ? !!l : Dd(u);
        } else
          u = !1;
        if (u) {
          if (9007199254740991 < n + (l = La(o.length)))
            throw TypeError("Maximum allowed index exceeded");
          for (u = 0; u < l; u++, n++)
            u in o && ef(a, n, o[u]);
        } else {
          if (9007199254740991 <= n)
            throw TypeError("Maximum allowed index exceeded");
          ef(a, n++, o);
        }
      }
      return a.length = n, a;
    } });
    var Ky = vk, Ly = ia(function() {
      return !Object.getOwnPropertyNames(1);
    });
    ba({ target: "Object", stat: !0, forced: Ly }, { getOwnPropertyNames: Ky });
    var My = ce.f, Ny = Zb.f, Oy = mb.f, Jd = Q.Number, $h = Jd.prototype, Py = qc(ec($h)) == "Number", Cq = function(r) {
      var e, t = Kc(r, !1);
      if (typeof t == "string" && 2 < t.length) {
        if ((r = (t = Ij(t)).charCodeAt(0)) === 43 || r === 45) {
          if ((r = t.charCodeAt(2)) === 88 || r === 120)
            return NaN;
        } else if (r === 48) {
          switch (t.charCodeAt(1)) {
            case 66:
            case 98:
              r = 2;
              var a = 49;
              break;
            case 79:
            case 111:
              r = 8, a = 55;
              break;
            default:
              return +t;
          }
          var n = (t = t.slice(2)).length;
          for (e = 0; e < n; e++) {
            var s = t.charCodeAt(e);
            if (48 > s || s > a)
              return NaN;
          }
          return parseInt(t, r);
        }
      }
      return +t;
    };
    if (Mc("Number", !Jd(" 0o1") || !Jd("0b1") || Jd("+0x1"))) {
      for (var ke = function(r) {
        var e = 1 > arguments.length ? 0 : r, t = this;
        return t instanceof ke && (Py ? ia(function() {
          $h.valueOf.call(t);
        }) : qc(t) != "Number") ? Th(new Jd(Cq(e)), t, ke) : Cq(e);
      }, Dq = ta ? My(Jd) : "MAX_VALUE MIN_VALUE NaN NEGATIVE_INFINITY POSITIVE_INFINITY EPSILON isFinite isInteger isNaN isSafeInteger MAX_SAFE_INTEGER MIN_SAFE_INTEGER parseFloat parseInt isInteger fromString range".split(" "), Pk = 0, ai; Dq.length > Pk; Pk++)
        ha(Jd, ai = Dq[Pk]) && !ha(ke, ai) && Oy(ke, ai, Ny(Jd, ai));
      ke.prototype = $h, $h.constructor = ke, Wa(Q, "Number", ke);
    }
    var pf = (typeof Reflect > "u" ? "undefined" : oa(Reflect)) === "object" ? Reflect : null, Eq = pf && typeof pf.apply == "function" ? pf.apply : function(r, e, t) {
      return Function.prototype.apply.call(r, e, t);
    }, Qy = pf && typeof pf.ownKeys == "function" ? pf.ownKeys : Object.getOwnPropertySymbols ? function(r) {
      return Object.getOwnPropertyNames(r).concat(Object.getOwnPropertySymbols(r));
    } : function(r) {
      return Object.getOwnPropertyNames(r);
    }, Fq = Number.isNaN || function(r) {
      return r != r;
    };
    ya.EventEmitter = ya, ya.prototype._events = void 0, ya.prototype._eventsCount = 0, ya.prototype._maxListeners = void 0;
    var Gq = 10;
    Object.defineProperty(ya, "defaultMaxListeners", { enumerable: !0, get: function() {
      return Gq;
    }, set: function(r) {
      if (typeof r != "number" || 0 > r || Fq(r))
        throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + r + ".");
      Gq = r;
    } }), ya.init = function() {
      this._events !== void 0 && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
    }, ya.prototype.setMaxListeners = function(r) {
      if (typeof r != "number" || 0 > r || Fq(r))
        throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + r + ".");
      return this._maxListeners = r, this;
    }, ya.prototype.getMaxListeners = function() {
      return this._maxListeners === void 0 ? ya.defaultMaxListeners : this._maxListeners;
    }, ya.prototype.emit = function(r) {
      for (var e = [], t = 1; t < arguments.length; t++)
        e.push(arguments[t]);
      t = r === "error";
      var a = this._events;
      if (a !== void 0)
        t = t && a.error === void 0;
      else if (!t)
        return !1;
      if (t) {
        var n;
        throw 0 < e.length && (n = e[0]), n instanceof Error ? n : ((e = Error("Unhandled error." + (n ? " (" + n.message + ")" : ""))).context = n, e);
      }
      if ((t = a[r]) === void 0)
        return !1;
      if (typeof t == "function")
        Eq(t, this, e);
      else
        for (a = Bm(t, n = t.length), t = 0; t < n; ++t)
          Eq(a[t], this, e);
      return !0;
    }, ya.prototype.addListener = function(r, e) {
      return ym(this, r, e, !1);
    }, ya.prototype.on = ya.prototype.addListener, ya.prototype.prependListener = function(r, e) {
      return ym(this, r, e, !0);
    }, ya.prototype.once = function(r, e) {
      return Ug(e), this.on(r, zm(this, r, e)), this;
    }, ya.prototype.prependOnceListener = function(r, e) {
      return Ug(e), this.prependListener(r, zm(this, r, e)), this;
    }, ya.prototype.removeListener = function(r, e) {
      var t;
      Ug(e);
      var a = this._events;
      if (a === void 0)
        return this;
      var n = a[r];
      if (n === void 0)
        return this;
      if (n === e || n.listener === e)
        --this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : (delete a[r], a.removeListener && this.emit("removeListener", r, n.listener || e));
      else if (typeof n != "function") {
        var s = -1;
        for (t = n.length - 1; 0 <= t; t--)
          if (n[t] === e || n[t].listener === e) {
            var o = n[t].listener;
            s = t;
            break;
          }
        if (0 > s)
          return this;
        if (s === 0)
          n.shift();
        else {
          for (; s + 1 < n.length; s++)
            n[s] = n[s + 1];
          n.pop();
        }
        n.length === 1 && (a[r] = n[0]), a.removeListener !== void 0 && this.emit("removeListener", r, o || e);
      }
      return this;
    }, ya.prototype.off = ya.prototype.removeListener, ya.prototype.removeAllListeners = function(r) {
      var e = this._events;
      if (e === void 0)
        return this;
      if (e.removeListener === void 0)
        return arguments.length === 0 ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : e[r] !== void 0 && (--this._eventsCount == 0 ? this._events = /* @__PURE__ */ Object.create(null) : delete e[r]), this;
      if (arguments.length === 0) {
        var t = Object.keys(e);
        for (e = 0; e < t.length; ++e) {
          var a = t[e];
          a !== "removeListener" && this.removeAllListeners(a);
        }
        return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
      }
      if (typeof (t = e[r]) == "function")
        this.removeListener(r, t);
      else if (t !== void 0)
        for (e = t.length - 1; 0 <= e; e--)
          this.removeListener(r, t[e]);
      return this;
    }, ya.prototype.listeners = function(r) {
      return Am(this, r, !0);
    }, ya.prototype.rawListeners = function(r) {
      return Am(this, r, !1);
    }, ya.listenerCount = function(r, e) {
      return typeof r.listenerCount == "function" ? r.listenerCount(e) : Cm.call(r, e);
    }, ya.prototype.listenerCount = Cm, ya.prototype.eventNames = function() {
      return 0 < this._eventsCount ? Qy(this._events) : [];
    }, ya.once = function(r, e) {
      return new Promise(function(t, a) {
        function n(o) {
          r.removeListener(e, s), a(o);
        }
        function s() {
          typeof r.removeListener == "function" && r.removeListener("error", n), t([].slice.call(arguments));
        }
        Dm(r, e, s, { once: !0 }), e !== "error" && Yt(r, n, { once: !0 });
      });
    };
    var qf = Object.assign, Hq = Object.defineProperty, zg = !qf || ia(function() {
      if (ta && qf({ b: 1 }, qf(Hq({}, "a", { enumerable: !0, get: function() {
        Hq(this, "b", { value: 3, enumerable: !1 });
      } }), { b: 2 })).b !== 1)
        return !0;
      var r = {}, e = {}, t = Symbol();
      return r[t] = 7, "abcdefghijklmnopqrst".split("").forEach(function(a) {
        e[a] = a;
      }), qf({}, r)[t] != 7 || $c(qf({}, e)).join("") != "abcdefghijklmnopqrst";
    }) ? function(r, e) {
      for (var t = lb(r), a = arguments.length, n = 1, s = eg.f, o = cg; a > n; )
        for (var u, l = dg(arguments[n++]), f = s ? $c(l).concat(s(l)) : $c(l), d = f.length, h = 0; d > h; )
          u = f[h++], (!ta || o.call(l, u)) && (t[u] = l[u]);
      return t;
    } : qf;
    ba({ target: "Object", stat: !0, forced: Object.assign !== zg }, { assign: zg }), xq("Map", function(r) {
      return function() {
        return r(this, arguments.length ? arguments[0] : void 0);
      };
    }, Aq);
    var Ry = Math.log, Sy = Math.LN2;
    ba({ target: "Math", stat: !0 }, { log2: function(r) {
      return Ry(r) / Sy;
    } });
    var Ty = mb.f, Uy = ce.f, Vy = Za.enforce, Wy = Ea("match"), Rc = Q.RegExp, Qk = Rc.prototype, Ag = /a/g, Rk = /a/g, Sk = new Rc(Ag) !== Ag;
    if (ta && Mc("RegExp", !Sk || Nc || ia(function() {
      return Rk[Wy] = !1, Rc(Ag) != Ag || Rc(Rk) == Rk || Rc(Ag, "i") != "/a/i";
    }))) {
      for (var gd = function(r, e) {
        var t, a = this instanceof gd, n = Fj(r), s = e === void 0;
        return !a && n && r.constructor === gd && s || (Sk ? n && !s && (r = r.source) : r instanceof gd && (s && (e = Aj.call(r)), r = r.source), Nc && (t = !!e && -1 < e.indexOf("y")) && (e = e.replace(/y/g, "")), r = Th(Sk ? new Rc(r, e) : Rc(r, e), a ? this : Qk, gd), Nc && t && (Vy(r).sticky = !0)), r;
      }, Xy = function(r) {
        r in gd || Ty(gd, r, { configurable: !0, get: function() {
          return Rc[r];
        }, set: function(e) {
          Rc[r] = e;
        } });
      }, Iq = Uy(Rc), Jq = 0; Iq.length > Jq; )
        Xy(Iq[Jq++]);
      Qk.constructor = gd, gd.prototype = Qk, Wa(Q, "RegExp", gd);
    }
    mg("RegExp"), vg("Float32", function(r) {
      return function(e, t, a) {
        return r(this, e, t, a);
      };
    }), vg("Float64", function(r) {
      return function(e, t, a) {
        return r(this, e, t, a);
      };
    }), vg("Uint32", function(r) {
      return function(e, t, a) {
        return r(this, e, t, a);
      };
    }), vg("Uint16", function(r) {
      return function(e, t, a) {
        return r(this, e, t, a);
      };
    });
    var Tk = function(r, e) {
      return r === e ? 0 : r == null ? e == null ? 0 : -1 : e == null ? r == null ? 0 : 1 : typeof r.compare == "function" ? r.compare(e) : typeof e.compare == "function" ? -e.compare(r) : r < e ? -1 : r > e ? 1 : 0;
    }, Uk = [], Kq = Uk.sort, Yy = ia(function() {
      Uk.sort(void 0);
    }), Zy = ia(function() {
      Uk.sort(null);
    }), $y = cf("sort");
    ba({ target: "Array", proto: !0, forced: Yy || !Zy || !$y }, { sort: function(r) {
      return r === void 0 ? Kq.call(lb(this)) : Kq.call(lb(this), Sb(r));
    } });
    var Lq = Object.getPrototypeOf({}), Bg = function(r, e) {
      var t;
      return r === e || (r == null ? r == e : oa(r.equiv) === "function" ? r.equiv(e) : e == null ? r == e : oa(e.equiv) === "function" ? e.equiv(r) : oa(r) !== "string" && oa(e) !== "string" && ((t = Object.getPrototypeOf(r)) != null && t !== Lq || (t = Object.getPrototypeOf(e)) != null && t !== Lq ? oa(r) !== "function" && r.length !== void 0 && oa(e) !== "function" && e.length !== void 0 ? bz(r, e) : r instanceof Set && e instanceof Set ? cz(r, e) : r instanceof Map && e instanceof Map ? dz(r, e) : r instanceof Date && e instanceof Date ? r.getTime() === e.getTime() : r instanceof RegExp && e instanceof RegExp ? r.toString() === e.toString() : r != r && e != e : az(r, e)));
    }, bz = function(r, e) {
      var t = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : Bg, a = r.length;
      if (a === e.length)
        for (; 0 <= --a && t(r[a], e[a]); )
          ;
      return 0 > a;
    }, cz = function(r, e) {
      var t = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : Bg;
      return r.size === e.size && t(W(r.keys()).sort(), W(e.keys()).sort());
    }, dz = function(r, e) {
      var t = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : Bg;
      return r.size === e.size && t(W(r).sort(), W(e).sort());
    }, az = function(r, e) {
      var t = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : Bg;
      if (Object.keys(r).length !== Object.keys(e).length)
        return !1;
      for (var a in r)
        if (!e.hasOwnProperty(a) || !t(r[a], e[a]))
          return !1;
      return !0;
    }, Mq = function(r) {
      var e = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : function(t) {
        return t !== void 0 ? ": " + t : "";
      };
      return function(t) {
        function a(s) {
          return ua(this, a), n.call(this, r(s) + e(s));
        }
        Ga(a, t);
        var n = Ha(a);
        return a;
      }(If(Error));
    }, ez = Mq(function() {
      return "illegal argument(s)";
    }), bi = function(r) {
      throw new ez(r);
    }, Vk = Mq(function() {
      return "index out of bounds";
    }), Nq = 1 / 4294967295, fz = function() {
      function r() {
        ua(this, r);
      }
      return cb(r, [{ key: "float", value: function() {
        var e = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 1;
        return this.int() * Nq * e;
      } }, { key: "norm", value: function() {
        var e = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 1;
        return 2 * (this.int() * Nq - 0.5) * e;
      } }, { key: "minmax", value: function(e, t) {
        return this.float() * (t - e) + e;
      } }]), r;
    }(), Wk = Math.random, gz = new (function(r) {
      function e() {
        return ua(this, e), t.apply(this, arguments);
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "int", value: function() {
        return 4294967296 * Wk() >>> 0;
      } }, { key: "float", value: function() {
        var a = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 1;
        return Wk() * a;
      } }, { key: "norm", value: function() {
        var a = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 1;
        return 2 * (Wk() - 0.5) * a;
      } }]), e;
    }(fz))(), Hi = Symbol(), Gm = function() {
    }, hz = Mk.onFreeze, Xk = Object.freeze, iz = ia(function() {
      Xk(1);
    });
    ba({ target: "Object", stat: !0, forced: iz, sham: !wq }, { freeze: function(r) {
      return Xk && va(r) ? Xk(hz(r)) : r;
    } });
    var jz = cf("reduce"), kz = !ad && 79 < Bd && 83 > Bd;
    ba({ target: "Array", proto: !0, forced: !jz || kz }, { reduce: function(r) {
      return Up(this, r, arguments.length, 1 < arguments.length ? arguments[1] : void 0);
    } });
    var Fm = function(r) {
      return r != null && typeof r.xform == "function" ? r.xform() : r;
    }, Vg = function() {
      function r(e) {
        ua(this, r), this.value = e;
      }
      return cb(r, [{ key: "deref", value: function() {
        return this.value;
      } }]), r;
    }(), Ii = function(r) {
      return r instanceof Vg ? r.deref() : r;
    }, $t = function(r, e) {
      return [r, function(t) {
        return t;
      }, e];
    }, lz = M.mark(function(r, e) {
      var t, a, n, s, o, u;
      return M.wrap(function(l) {
        for (; ; )
          switch (l.prev = l.next) {
            case 0:
              t = Fm(r)(Zt()), a = t[1], n = t[2], s = 0;
            case 4:
              if (!(s < e.length)) {
                l.next = 15;
                break;
              }
              if (o = e[s], !((u = n([], o)) instanceof Vg)) {
                l.next = 10;
                break;
              }
              return l.delegateYield(Ii(a(u.deref())), "t0", 9);
            case 9:
              return l.abrupt("return");
            case 10:
              if (!u.length) {
                l.next = 12;
                break;
              }
              return l.delegateYield(u, "t1", 12);
            case 12:
              s++, l.next = 4;
              break;
            case 15:
              return l.delegateYield(Ii(a([])), "t2", 16);
            case 16:
            case "end":
              return l.stop();
          }
      }, lz);
    }), au = M.mark(Em), bu = function(r, e) {
      return [r[0], r[1], e];
    }, mz = function() {
      function r(e) {
        ua(this, r), this._length = 0, e && this.into(e);
      }
      return cb(r, [{ key: "length", get: function() {
        return this._length;
      } }, { key: "copy", value: function() {
        return new r(this);
      } }, { key: "empty", value: function() {
        return new r();
      } }, { key: "clear", value: function() {
        this.release();
      } }, { key: "release", value: function() {
        for (var e, t = this.head; t; )
          e = t.next, delete t.value, delete t.prev, delete t.next, t = e;
        return delete this.head, delete this.tail, this._length = 0, !0;
      } }, { key: "compare", value: function(e) {
        var t = this._length;
        if (t < e._length)
          return -1;
        if (t > e._length)
          return 1;
        if (t === 0)
          return 0;
        t = this.head, e = e.head;
        for (var a = 0; t && a == 0; )
          a = Tk(t.value, e.value), t = t.next, e = e.next;
        return a;
      } }, { key: "equiv", value: function(e) {
        if (!(e instanceof r || e != null && typeof e != "function" && e.length !== void 0) || this._length !== e.length)
          return !1;
        if (!this._length || this === e)
          return !0;
        for (var t = this.head, a = 0; a < e.length; a++) {
          if (!Bg(t.value, e[a]))
            return !1;
          t = t.next;
        }
        return !0;
      } }, { key: Symbol.iterator, value: M.mark(function e() {
        var t;
        return M.wrap(function(a) {
          for (; ; )
            switch (a.prev = a.next) {
              case 0:
                t = this.head;
              case 1:
                if (!t) {
                  a.next = 7;
                  break;
                }
                return a.next = 4, t.value;
              case 4:
                t = t.next, a.next = 1;
                break;
              case 7:
              case "end":
                return a.stop();
            }
        }, e, this);
      }) }, { key: "seq", value: function() {
        var e = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 0, t = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : this.length;
        if (!(e >= t || 0 > e)) {
          e = this.nthCell(e);
          var a = this.nthCell(t - 1);
          return t = function n(s) {
            return { first: function() {
              return s.value;
            }, next: function() {
              return s !== a && s.next ? n(s.next) : void 0;
            } };
          }, e ? t(e) : void 0;
        }
      } }, { key: "cycle", value: M.mark(function e() {
        return M.wrap(function(t) {
          for (; ; )
            switch (t.prev = t.next) {
              case 0:
                return t.delegateYield(this, "t0", 2);
              case 2:
                t.next = 0;
                break;
              case 4:
              case "end":
                return t.stop();
            }
        }, e, this);
      }) }, { key: "$reduce", value: function(e, t) {
        for (var a = this.head; a && !(t instanceof Vg); )
          t = e(t, a.value), a = a.next;
        return t;
      } }, { key: "drop", value: function() {
        var e = this.head;
        if (e)
          return (this.head = e.next) ? delete this.head.prev : delete this.tail, this._length--, e.value;
      } }, { key: "cons", value: function(e) {
        return e = { value: e, next: this.head }, this.head ? this.head.prev = e : this.tail = e, this.head = e, this._length++, this;
      } }, { key: "insertBefore", value: function(e, t) {
        return e || bi("cell is undefined"), t = { value: t, next: e, prev: e.prev }, e.prev ? e.prev.next = t : this.head = t, e.prev = t, this._length++, this;
      } }, { key: "insertAfter", value: function(e, t) {
        return e || bi("cell is undefined"), t = { value: t, next: e.next, prev: e }, e.next ? e.next.prev = t : this.tail = t, e.next = t, this._length++, this;
      } }, { key: "insertBeforeNth", value: function(e, t) {
        if (0 > e && (e += this._length), 0 >= e)
          return this.cons(t);
        if (0 > e || e >= this._length)
          throw new Vk(e);
        return this.insertBefore(this.nthCellUnsafe(e), t);
      } }, { key: "insertAfterNth", value: function(e, t) {
        if (0 > e && (e += this._length), e >= this._length - 1)
          return this.push(t);
        if (0 > e || e >= this._length)
          throw new Vk(e);
        return this.insertAfter(this.nthCellUnsafe(e), t);
      } }, { key: "insertSorted", value: function(e, t) {
        t = t || Tk;
        for (var a = this.head; a; ) {
          if (0 >= t(e, a.value))
            return this.insertBefore(a, e);
          a = a.next;
        }
        return this.push(e);
      } }, { key: "find", value: function(e) {
        for (var t = this.head; t; ) {
          if (t.value === e)
            return t;
          t = t.next;
        }
      } }, { key: "findWith", value: function(e) {
        for (var t = this.head; t; ) {
          if (e(t.value))
            return t;
          t = t.next;
        }
      } }, { key: "concat", value: function() {
        for (var e = this.copy(), t = arguments.length, a = Array(t), n = 0; n < t; n++)
          a[n] = arguments[n];
        for (t = 0; t < a.length; t++)
          e.into(a[t]);
        return e;
      } }, { key: "into", value: function(e) {
        for (var t = 0; t < e.length; t++)
          this.push(e[t]);
      } }, { key: "slice", value: function() {
        var e = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 0, t = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : this.length;
        e = 0 > e ? e + this._length : e, t = 0 > t ? t + this._length : t, (0 > e || 0 > t) && bi("invalid indices: ${from} / ${to}");
        for (var a = new r(), n = this.nthCell(e); n && ++e <= t; )
          a.push(n.value), n = n.next;
        return a;
      } }, { key: "splice", value: function(e) {
        var t = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : 0, a = 2 < arguments.length ? arguments[2] : void 0;
        if (typeof e == "number") {
          if (0 > e && (e += this._length), 0 > e || e >= this._length)
            throw new Vk(e);
          var n = this.nthCellUnsafe(e);
        } else
          n = e;
        var s = new r();
        if (0 < t)
          for (; n && 0 < t--; )
            this.remove(n), s.push(n.value), n = n.next;
        else
          n && (n = n.next);
        if (a)
          if (n)
            for (t = 0; t < a.length; t++)
              this.insertBefore(n, a[t]);
          else
            for (n = 0; n < a.length; n++)
              this.push(a[n]);
        return s;
      } }, { key: "remove", value: function(e) {
        return e.prev ? e.prev.next = e.next : this.head = e.next, e.next ? e.next.prev = e.prev : this.tail = e.prev, this._length--, this;
      } }, { key: "swap", value: function(e, t) {
        if (e !== t) {
          var a = e.value;
          e.value = t.value, t.value = a;
        }
        return this;
      } }, { key: "push", value: function(e) {
        return this.tail ? (e = { value: e, prev: this.tail }, this.tail = this.tail.next = e, this._length++, this) : this.cons(e);
      } }, { key: "pop", value: function() {
        var e = this.tail;
        if (e)
          return (this.tail = e.prev) ? delete this.tail.next : delete this.head, this._length--, e.value;
      } }, { key: "first", value: function() {
        return this.head && this.head.value;
      } }, { key: "peek", value: function() {
        return this.tail && this.tail.value;
      } }, { key: "setHead", value: function(e) {
        return this.head ? (this.head.value = e, this) : this.cons(e);
      } }, { key: "setTail", value: function(e) {
        return this.tail ? (this.tail.value = e, this) : this.push(e);
      } }, { key: "setNth", value: function(e, t) {
        var a = this.nthCell(e);
        return !a && bi("index out of bounds: ".concat(e)), a.value = t, this;
      } }, { key: "nth", value: function(e, t) {
        return (e = this.nthCell(e)) ? e.value : t;
      } }, { key: "nthCell", value: function(e) {
        if (0 > e && (e += this._length), !(0 > e || e >= this._length))
          return this.nthCellUnsafe(e);
      } }, { key: "rotateLeft", value: function() {
        switch (this._length) {
          case 0:
          case 1:
            return this;
          case 2:
            return this.swap(this.head, this.tail);
          default:
            return this.push(this.drop());
        }
      } }, { key: "rotateRight", value: function() {
        switch (this._length) {
          case 0:
          case 1:
            return this;
          case 2:
            return this.swap(this.head, this.tail);
          default:
            var e = this.peek();
            return this.pop(), this.cons(e);
        }
      } }, { key: "map", value: function(e) {
        for (var t = new r(), a = this.head; a; )
          t.push(e(a.value)), a = a.next;
        return t;
      } }, { key: "filter", value: function(e) {
        for (var t = new r(), a = this.head; a; )
          e(a.value) && t.push(a.value), a = a.next;
        return t;
      } }, { key: "reduce", value: function(e, t) {
        for (var a = this.head; a; )
          t = e(t, a.value), a = a.next;
        return t;
      } }, { key: "shuffle", value: function(e) {
        var t = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : gz;
        if (2 > this._length)
          return this;
        for (e = e != null ? e : Math.ceil(1.5 * Math.log2(this._length)); 0 < e; e--)
          for (var a = this.head; a; ) {
            var n = a.next;
            0.5 > t.float() ? this.asHead(a) : this.asTail(a), a = n;
          }
        return this;
      } }, { key: "sort", value: function() {
        var e = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : Tk;
        if (!this._length)
          return this;
        for (var t = 1; ; ) {
          var a = this.head;
          this.tail = this.head = void 0;
          for (var n = 0; a; ) {
            n++;
            for (var s = a, o = 0, u = 0; u < t && (o++, s = s.next); u++)
              ;
            for (u = t; 0 < o || 0 < u && s; ) {
              if (o === 0) {
                var l = s;
                s = s.next, u--;
              } else
                s && u !== 0 ? 0 >= e(a.value, s.value) ? (l = a, a = a.next, o--) : (l = s, s = s.next, u--) : (l = a, a = a.next, o--);
              this.tail ? this.tail.next = l : this.head = l, l.prev = this.tail, this.tail = l;
            }
            a = s;
          }
          if (this.tail.next = void 0, 1 >= n)
            return this;
          t *= 2;
        }
      } }, { key: "reverse", value: function() {
        for (var e = this.head, t = this.tail, a = (this._length >>> 1) + (1 & this._length); e && t && 0 < a; ) {
          var n = e.value;
          e.value = t.value, t.value = n, e = e.next, t = t.prev, a--;
        }
        return this;
      } }, { key: "asHead", value: function(e) {
        return e === this.head || (this.remove(e), this.head.prev = e, e.next = this.head, e.prev = void 0, this.head = e, this._length++), this;
      } }, { key: "asTail", value: function(e) {
        return e === this.tail || (this.remove(e), this.tail.next = e, e.prev = this.tail, e.next = void 0, this.tail = e, this._length++), this;
      } }, { key: "toString", value: function() {
        for (var e = [], t = this.head; t; )
          e.push(String(t.value)), t = t.next;
        return e.join(", ");
      } }, { key: "toJSON", value: function() {
        return W(this);
      } }, { key: "nthCellUnsafe", value: function(e) {
        if (e <= this._length >> 1)
          var t = this.head, a = "next";
        else
          t = this.tail, a = "prev", e = this._length - e - 1;
        for (; 0 < e-- && t; )
          t = t[a];
        return t;
      } }]), r;
    }(), Sc = function() {
      function r(e, t) {
        ua(this, r), t = Object.assign({ maxlen: 1 / 0, maxsize: 1 / 0, map: function() {
          return /* @__PURE__ */ new Map();
        }, ksize: function() {
          return 0;
        }, vsize: function() {
          return 0;
        } }, t), this.map = t.map(), this.items = new mz(), this._size = 0, this.opts = t, e && this.into(e);
      }
      return cb(r, [{ key: "length", get: function() {
        return this.items.length;
      } }, { key: "size", get: function() {
        return this._size;
      } }, { key: Symbol.iterator, value: function() {
        return this.entries();
      } }, { key: "entries", value: function() {
        return Wg(function(e) {
          return [e.k, e];
        }, this.items);
      } }, { key: "keys", value: function() {
        return Wg(function(e) {
          return e.k;
        }, this.items);
      } }, { key: "values", value: function() {
        return Wg(function(e) {
          return e.v;
        }, this.items);
      } }, { key: "copy", value: function() {
        var e = this.empty();
        e.items = this.items.copy();
        for (var t = e.items.head; t; )
          e.map.set(t.value.k, t), t = t.next;
        return e;
      } }, { key: "empty", value: function() {
        return new r(null, this.opts);
      } }, { key: "release", value: function() {
        this._size = 0, this.map.clear();
        var e = this.opts.release;
        if (e) {
          for (var t; t = this.items.drop(); )
            e(t.k, t.v);
          return !0;
        }
        return this.items.release();
      } }, { key: "has", value: function(e) {
        return this.map.has(e);
      } }, { key: "get", value: function(e, t) {
        return (e = this.map.get(e)) ? this.resetEntry(e) : t;
      } }, { key: "set", value: function(e, t) {
        var a = this.opts.ksize(e) + this.opts.vsize(t), n = this.map.get(e);
        return this._size += Math.max(0, a - (n ? n.value.s : 0)), this.ensureSize() && this.doSetEntry(n, e, t, a), t;
      } }, { key: "into", value: function(e) {
        for (var t = 0; t < e.length; t++) {
          var a = e[t];
          this.set(a[0], a[1]);
        }
        return this;
      } }, { key: "getSet", value: function(e, t) {
        var a = this, n = this.map.get(e);
        return n ? Promise.resolve(this.resetEntry(n)) : t().then(function(s) {
          return a.set(e, s);
        });
      } }, { key: "delete", value: function(e) {
        return !!(e = this.map.get(e)) && (this.removeEntry(e), !0);
      } }, { key: "resetEntry", value: function(e) {
        return this.items.asTail(e), e.value.v;
      } }, { key: "ensureSize", value: function() {
        for (var e = this.opts.release, t = this.opts.maxsize, a = this.opts.maxlen; this._size > t || this.length >= a; ) {
          var n = this.items.drop();
          if (!n)
            return !1;
          this.map.delete(n.k), e && e(n.k, n.v), this._size -= n.s;
        }
        return !0;
      } }, { key: "removeEntry", value: function(e) {
        var t = e.value;
        this.map.delete(t.k), this.items.remove(e), this.opts.release && this.opts.release(t.k, t.v), this._size -= t.s;
      } }, { key: "doSetEntry", value: function(e, t, a, n) {
        e ? (e.value.v = a, e.value.s = n, this.items.asTail(e)) : (this.items.push({ k: t, v: a, s: n }), this.map.set(t, this.items.tail));
      } }]), r;
    }(), nz = function(r) {
      function e(a, n) {
        return ua(this, e), n = Object.assign({ ttl: 36e5 }, n), t.call(this, a, n);
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "empty", value: function() {
        return new e(null, this.opts);
      } }, { key: "has", value: function(a) {
        return this.get(a) !== void 0;
      } }, { key: "get", value: function(a, n) {
        if (a = this.map.get(a)) {
          if (a.value.t >= Date.now())
            return this.resetEntry(a);
          this.removeEntry(a);
        }
        return n;
      } }, { key: "set", value: function(a, n) {
        var s = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : this.opts.ttl, o = this.opts.ksize(a) + this.opts.vsize(n), u = this.map.get(a);
        return this._size += Math.max(0, o - (u ? u.value.s : 0)), this.ensureSize() && (s = Date.now() + s, u ? (u.value.v = n, u.value.s = o, u.value.t = s, this.items.asTail(u)) : (this.items.push({ k: a, v: n, s: o, t: s }), this.map.set(a, this.items.tail))), n;
      } }, { key: "getSet", value: function(a, n) {
        var s = this, o = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : this.opts.ttl, u = this.get(a);
        return u ? Promise.resolve(u) : n().then(function(l) {
          return s.set(a, l, o);
        });
      } }, { key: "prune", value: function() {
        for (var a = Date.now(), n = this.items.head; n; )
          n.value.t < a && this.removeEntry(n), n = n.next;
      } }, { key: "ensureSize", value: function() {
        for (var a = this.opts.maxsize, n = this.opts.maxlen, s = Date.now(), o = this.items.head; o && (this._size > a || this.length >= n); )
          o.value.t < s && this.removeEntry(o), o = o.next;
        return Fi(Sd(e.prototype), "ensureSize", this).call(this);
      } }]), e;
    }(Sc), Oq = oa(Va) == "object" && Va && Va.Object === Object && Va, oz = (typeof self > "u" ? "undefined" : oa(self)) == "object" && self && self.Object === Object && self, Wb = Oq || oz || Function("return this")(), gc = Wb.Symbol, Pq = Object.prototype, pz = Pq.hasOwnProperty, qz = Pq.toString, Cg = gc ? gc.toStringTag : void 0, rz = Object.prototype.toString, Qq = gc ? gc.toStringTag : void 0, le = function(r) {
      if (r == null)
        r = r === void 0 ? "[object Undefined]" : "[object Null]";
      else if (Qq && Qq in Object(r)) {
        var e = pz.call(r, Cg), t = r[Cg];
        try {
          r[Cg] = void 0;
          var a = !0;
        } catch {
        }
        var n = qz.call(r);
        a && (e ? r[Cg] = t : delete r[Cg]), r = n;
      } else
        r = rz.call(r);
      return r;
    }, Db = function(r) {
      var e = oa(r);
      return r != null && (e == "object" || e == "function");
    }, dj = function(r) {
      return !!Db(r) && ((r = le(r)) == "[object Function]" || r == "[object GeneratorFunction]" || r == "[object AsyncFunction]" || r == "[object Proxy]");
    }, Yk = Wb["__core-js_shared__"], Rq = function() {
      var r = /[^.]+$/.exec(Yk && Yk.keys && Yk.keys.IE_PROTO || "");
      return r ? "Symbol(src)_1." + r : "";
    }(), sz = Function.prototype.toString, me = function(r) {
      if (r != null) {
        try {
          return sz.call(r);
        } catch {
        }
        return r + "";
      }
      return "";
    }, tz = /^\[object .+?Constructor\]$/, uz = RegExp("^" + Function.prototype.toString.call(Object.prototype.hasOwnProperty).replace(/[\\^$.*+?()[\]{}|]/g, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"), ne = function(r, e) {
      return r = r == null ? void 0 : r[e], !Db(r) || Rq && Rq in r || !(dj(r) ? uz : tz).test(me(r)) ? void 0 : r;
    }, Dg = ne(Object, "create"), vz = Object.prototype.hasOwnProperty, wz = Object.prototype.hasOwnProperty;
    Ud.prototype.clear = function() {
      this.__data__ = Dg ? Dg(null) : {}, this.size = 0;
    }, Ud.prototype.delete = function(r) {
      return r = this.has(r) && delete this.__data__[r], this.size -= r ? 1 : 0, r;
    }, Ud.prototype.get = function(r) {
      var e = this.__data__;
      return Dg ? (r = e[r]) === "__lodash_hash_undefined__" ? void 0 : r : vz.call(e, r) ? e[r] : void 0;
    }, Ud.prototype.has = function(r) {
      var e = this.__data__;
      return Dg ? e[r] !== void 0 : wz.call(e, r);
    }, Ud.prototype.set = function(r, e) {
      var t = this.__data__;
      return this.size += this.has(r) ? 0 : 1, t[r] = Dg && e === void 0 ? "__lodash_hash_undefined__" : e, this;
    };
    var Eg = function(r, e) {
      return r === e || r != r && e != e;
    }, ci = function(r, e) {
      for (var t = r.length; t--; )
        if (Eg(r[t][0], e))
          return t;
      return -1;
    }, xz = Array.prototype.splice;
    Ce.prototype.clear = function() {
      this.__data__ = [], this.size = 0;
    }, Ce.prototype.delete = function(r) {
      var e = this.__data__;
      return !(0 > (r = ci(e, r))) && (r == e.length - 1 ? e.pop() : xz.call(e, r, 1), --this.size, !0);
    }, Ce.prototype.get = function(r) {
      var e = this.__data__;
      return 0 > (r = ci(e, r)) ? void 0 : e[r][1];
    }, Ce.prototype.has = function(r) {
      return -1 < ci(this.__data__, r);
    }, Ce.prototype.set = function(r, e) {
      var t = this.__data__, a = ci(t, r);
      return 0 > a ? (++this.size, t.push([r, e])) : t[a][1] = e, this;
    };
    var Yg = Ce, Fg = ne(Wb, "Map"), di = function(r, e) {
      r = r.__data__;
      var t = oa(e);
      return (t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null) ? r[typeof e == "string" ? "string" : "hash"] : r.map;
    };
    De.prototype.clear = function() {
      this.size = 0, this.__data__ = { hash: new Ud(), map: new (Fg || Yg)(), string: new Ud() };
    }, De.prototype.delete = function(r) {
      return r = di(this, r).delete(r), this.size -= r ? 1 : 0, r;
    }, De.prototype.get = function(r) {
      return di(this, r).get(r);
    }, De.prototype.has = function(r) {
      return di(this, r).has(r);
    }, De.prototype.set = function(r, e) {
      var t = di(this, r), a = t.size;
      return t.set(r, e), this.size += t.size == a ? 0 : 1, this;
    };
    var Xg = De;
    Jf.prototype.add = Jf.prototype.push = function(r) {
      return this.__data__.set(r, "__lodash_hash_undefined__"), this;
    }, Jf.prototype.has = function(r) {
      return this.__data__.has(r);
    };
    var Sq = function(r, e, t, a) {
      var n = r.length;
      for (t += a ? 1 : -1; a ? t-- : ++t < n; )
        if (e(r[t], t, r))
          return t;
      return -1;
    }, yz = function(r) {
      return r != r;
    }, zz = function(r, e) {
      var t;
      if (t = !(r == null || !r.length)) {
        if (e == e)
          e: {
            t = -1;
            for (var a = r.length; ++t < a; )
              if (r[t] === e) {
                r = t;
                break e;
              }
            r = -1;
          }
        else
          r = Sq(r, yz, 0);
        t = -1 < r;
      }
      return t;
    }, Az = function(r, e, t) {
      for (var a = -1, n = r == null ? 0 : r.length; ++a < n; )
        if (t(e, r[a]))
          return !0;
      return !1;
    }, Bz = function(r, e) {
      return r.has(e);
    }, rf = ne(Wb, "Set"), Cz = function() {
    }, Zk = function(r) {
      var e = -1, t = Array(r.size);
      return r.forEach(function(a) {
        t[++e] = a;
      }), t;
    }, Dz = 1 / 0, Ez = rf && 1 / Zk(new rf([, -0]))[1] == Dz ? function(r) {
      return new rf(r);
    } : Cz, $k = function(r, e, t) {
      var a = -1, n = zz, s = r.length, o = !0, u = [], l = u;
      if (t)
        o = !1, n = Az;
      else if (200 <= s) {
        if (n = e ? null : Ez(r))
          return Zk(n);
        o = !1, n = Bz, l = new Jf();
      } else
        l = e ? [] : u;
      e:
        for (; ++a < s; ) {
          var f = r[a], d = e ? e(f) : f;
          if (f = t || f !== 0 ? f : 0, o && d == d) {
            for (var h = l.length; h--; )
              if (l[h] === d)
                continue e;
            e && l.push(d), u.push(f);
          } else
            n(l, d, t) || (l !== u && l.push(d), u.push(f));
        }
      return u;
    }, Tq = function(r) {
      for (var e = -1, t = r == null ? 0 : r.length, a = {}; ++e < t; ) {
        var n = r[e];
        a[n[0]] = n[1];
      }
      return a;
    }, He = function(r, e) {
      for (var t = -1, a = r == null ? 0 : r.length, n = Array(a); ++t < a; )
        n[t] = e(r[t], t, r);
      return n;
    };
    Ee.prototype.clear = function() {
      this.__data__ = new Yg(), this.size = 0;
    }, Ee.prototype.delete = function(r) {
      var e = this.__data__;
      return r = e.delete(r), this.size = e.size, r;
    }, Ee.prototype.get = function(r) {
      return this.__data__.get(r);
    }, Ee.prototype.has = function(r) {
      return this.__data__.has(r);
    }, Ee.prototype.set = function(r, e) {
      var t = this.__data__;
      if (t instanceof Yg) {
        var a = t.__data__;
        if (!Fg || 199 > a.length)
          return a.push([r, e]), this.size = ++t.size, this;
        t = this.__data__ = new Xg(a);
      }
      return t.set(r, e), this.size = t.size, this;
    };
    var Ge = Ee, ku = function(r, e) {
      for (var t = -1, a = r == null ? 0 : r.length; ++t < a && e(r[t], t, r) !== !1; )
        ;
      return r;
    }, ei = function() {
      try {
        var r = ne(Object, "defineProperty");
        return r({}, "", {}), r;
      } catch {
      }
    }(), Gg = function(r, e, t) {
      e == "__proto__" && ei ? ei(r, e, { configurable: !0, enumerable: !0, value: t, writable: !0 }) : r[e] = t;
    }, Fz = Object.prototype.hasOwnProperty, Lm = function(r, e, t) {
      var a = r[e];
      Fz.call(r, e) && Eg(a, t) && (t !== void 0 || e in r) || Gg(r, e, t);
    }, Re = function(r, e, t, a) {
      var n = !t;
      t || (t = {});
      for (var s = -1, o = e.length; ++s < o; ) {
        var u = e[s], l = a ? a(t[u], r[u], u, t, r) : void 0;
        l === void 0 && (l = r[u]), n ? Gg(t, u, l) : Lm(t, u, l);
      }
      return t;
    }, Bc = function(r) {
      return r != null && oa(r) == "object";
    }, Uq = function(r) {
      return Bc(r) && le(r) == "[object Arguments]";
    }, Vq = Object.prototype, Gz = Vq.hasOwnProperty, Hz = Vq.propertyIsEnumerable, Tf = Uq(function() {
      return arguments;
    }()) ? Uq : function(r) {
      return Bc(r) && Gz.call(r, "callee") && !Hz.call(r, "callee");
    }, pb = Array.isArray, Iz = function() {
      return !1;
    }, Lf = tb(function(r, e) {
      var t = (e = e && !e.nodeType && e) && r && !r.nodeType && r;
      e = t && t.exports === e ? Wb.Buffer : void 0, r.exports = (e ? e.isBuffer : void 0) || Iz;
    }), Jz = /^(?:0|[1-9]\d*)$/, al = function(r, e) {
      var t = oa(r);
      return !!(e = e == null ? 9007199254740991 : e) && (t == "number" || t != "symbol" && Jz.test(r)) && -1 < r && r % 1 == 0 && r < e;
    }, bl = function(r) {
      return typeof r == "number" && -1 < r && r % 1 == 0 && 9007199254740991 >= r;
    }, Ua = {};
    Ua["[object Float32Array]"] = Ua["[object Float64Array]"] = Ua["[object Int8Array]"] = Ua["[object Int16Array]"] = Ua["[object Int32Array]"] = Ua["[object Uint8Array]"] = Ua["[object Uint8ClampedArray]"] = Ua["[object Uint16Array]"] = Ua["[object Uint32Array]"] = !0, Ua["[object Arguments]"] = Ua["[object Array]"] = Ua["[object ArrayBuffer]"] = Ua["[object Boolean]"] = Ua["[object DataView]"] = Ua["[object Date]"] = Ua["[object Error]"] = Ua["[object Function]"] = Ua["[object Map]"] = Ua["[object Number]"] = Ua["[object Object]"] = Ua["[object RegExp]"] = Ua["[object Set]"] = Ua["[object String]"] = Ua["[object WeakMap]"] = !1;
    var Kz = function(r) {
      return Bc(r) && bl(r.length) && !!Ua[le(r)];
    }, fi = function(r) {
      return function(e) {
        return r(e);
      };
    }, sf = tb(function(r, e) {
      var t = e && !e.nodeType && e;
      t = (e = t && r && !r.nodeType && r) && e.exports === t && Oq.process;
      e: {
        try {
          var a = e && e.require && e.require("util").types;
          if (a) {
            var n = a;
            break e;
          }
          n = t && t.binding && t.binding("util");
          break e;
        } catch {
        }
        n = void 0;
      }
      r.exports = n;
    }), Wq = sf && sf.isTypedArray, Oi = Wq ? fi(Wq) : Kz, Lz = Object.prototype.hasOwnProperty, Xq = function(r, e) {
      var t = pb(r), a = !t && Tf(r), n = !t && !a && Lf(r), s = !t && !a && !n && Oi(r);
      if (t = t || a || n || s) {
        a = r.length;
        for (var o = String, u = -1, l = Array(a); ++u < a; )
          l[u] = o(u);
        a = l;
      } else
        a = [];
      for (var f in o = a.length, r)
        !e && !Lz.call(r, f) || t && (f == "length" || n && (f == "offset" || f == "parent") || s && (f == "buffer" || f == "byteLength" || f == "byteOffset") || al(f, o)) || a.push(f);
      return a;
    }, Mz = Object.prototype, cl = function(r) {
      var e = r && r.constructor;
      return r === (typeof e == "function" && e.prototype || Mz);
    }, Yq = function(r, e) {
      return function(t) {
        return r(e(t));
      };
    }, Nz = Yq(Object.keys, Object), Oz = Object.prototype.hasOwnProperty, $d = function(r) {
      return r != null && bl(r.length) && !dj(r);
    }, Vd = function(r) {
      if ($d(r))
        r = Xq(r);
      else if (cl(r)) {
        var e, t = [];
        for (e in Object(r))
          Oz.call(r, e) && e != "constructor" && t.push(e);
        r = t;
      } else
        r = Nz(r);
      return r;
    }, gu = function(r, e) {
      return r && Re(e, Vd(e), r);
    }, Pz = Object.prototype.hasOwnProperty, Mf = function(r) {
      if ($d(r))
        r = Xq(r, !0);
      else if (Db(r)) {
        var e = cl(r), t = [];
        for (a in r)
          (a != "constructor" || !e && Pz.call(r, a)) && t.push(a);
        r = t;
      } else {
        var a = [];
        if (r != null)
          for (e in Object(r))
            a.push(e);
        r = a;
      }
      return r;
    }, eu = function(r, e) {
      return r && Re(e, Mf(e), r);
    }, Im = tb(function(r, e) {
      var t = (e = e && !e.nodeType && e) && r && !r.nodeType && r, a = (e = t && t.exports === e ? Wb.Buffer : void 0) ? e.allocUnsafe : void 0;
      r.exports = function(n, s) {
        return s ? n.slice() : (s = n.length, s = a ? a(s) : new n.constructor(s), n.copy(s), s);
      };
    }), Ji = function(r, e) {
      var t = -1, a = r.length;
      for (e || (e = Array(a)); ++t < a; )
        e[t] = r[t];
      return e;
    }, Qz = function(r, e) {
      for (var t = -1, a = r == null ? 0 : r.length, n = 0, s = []; ++t < a; ) {
        var o = r[t];
        e(o, t, r) && (s[n++] = o);
      }
      return s;
    }, Zq = function() {
      return [];
    }, Rz = Object.prototype.propertyIsEnumerable, $q = Object.getOwnPropertySymbols, dl = $q ? function(r) {
      return r == null ? [] : (r = Object(r), Qz($q(r), function(e) {
        return Rz.call(r, e);
      }));
    } : Zq, fu = function(r, e) {
      return Re(r, dl(r), e);
    }, Ni = function(r, e) {
      for (var t = -1, a = e.length, n = r.length; ++t < a; )
        r[n + t] = e[t];
      return r;
    }, el = Yq(Object.getPrototypeOf, Object), ar = Object.getOwnPropertySymbols ? function(r) {
      for (var e = []; r; )
        Ni(e, dl(r)), r = el(r);
      return e;
    } : Zq, du = function(r, e) {
      return Re(r, ar(r), e);
    }, br = function(r, e, t) {
      return e = e(r), pb(r) ? e : Ni(e, t(r));
    }, Ki = function(r) {
      return br(r, Vd, dl);
    }, Km = function(r) {
      return br(r, Mf, ar);
    }, fl = ne(Wb, "DataView"), gl = ne(Wb, "Promise"), hl = ne(Wb, "WeakMap"), Sz = me(fl), Tz = me(Fg), Uz = me(gl), Vz = me(rf), Wz = me(hl), oe = le;
    (fl && oe(new fl(new ArrayBuffer(1))) != "[object DataView]" || Fg && oe(new Fg()) != "[object Map]" || gl && oe(gl.resolve()) != "[object Promise]" || rf && oe(new rf()) != "[object Set]" || hl && oe(new hl()) != "[object WeakMap]") && (oe = function(r) {
      var e = le(r);
      if (r = (r = e == "[object Object]" ? r.constructor : void 0) ? me(r) : "")
        switch (r) {
          case Sz:
            return "[object DataView]";
          case Tz:
            return "[object Map]";
          case Uz:
            return "[object Promise]";
          case Vz:
            return "[object Set]";
          case Wz:
            return "[object WeakMap]";
        }
      return e;
    });
    var Kf = oe, Xz = Object.prototype.hasOwnProperty, cu = function(r) {
      var e = r.length, t = new r.constructor(e);
      return e && typeof r[0] == "string" && Xz.call(r, "index") && (t.index = r.index, t.input = r.input), t;
    }, gi = Wb.Uint8Array, il = function(r) {
      var e = new r.constructor(r.byteLength);
      return new gi(e).set(new gi(r)), e;
    }, Yz = /\w*$/, cr = gc ? gc.prototype : void 0, dr = cr ? cr.valueOf : void 0, vn = function(r, e) {
      return e = e ? il(r.buffer) : r.buffer, new r.constructor(e, r.byteOffset, r.length);
    }, hu = function(r, e, t) {
      var a = r.constructor;
      switch (e) {
        case "[object ArrayBuffer]":
          return il(r);
        case "[object Boolean]":
        case "[object Date]":
          return new a(+r);
        case "[object DataView]":
          return e = t ? il(r.buffer) : r.buffer, new r.constructor(e, r.byteOffset, r.byteLength);
        case "[object Float32Array]":
        case "[object Float64Array]":
        case "[object Int8Array]":
        case "[object Int16Array]":
        case "[object Int32Array]":
        case "[object Uint8Array]":
        case "[object Uint8ClampedArray]":
        case "[object Uint16Array]":
        case "[object Uint32Array]":
          return vn(r, t);
        case "[object Map]":
          return new a();
        case "[object Number]":
        case "[object String]":
          return new a(r);
        case "[object RegExp]":
          return (e = new r.constructor(r.source, Yz.exec(r))).lastIndex = r.lastIndex, e;
        case "[object Set]":
          return new a();
        case "[object Symbol]":
          return dr ? Object(dr.call(r)) : {};
      }
    }, er = Object.create, Zz = function() {
      function r() {
      }
      return function(e) {
        return Db(e) ? er ? er(e) : (r.prototype = e, e = new r(), r.prototype = void 0, e) : {};
      };
    }(), Jm = function(r) {
      return typeof r.constructor != "function" || cl(r) ? {} : Zz(el(r));
    }, $z = function(r) {
      return Bc(r) && Kf(r) == "[object Map]";
    }, fr = sf && sf.isMap, ju = fr ? fi(fr) : $z, aA = function(r) {
      return Bc(r) && Kf(r) == "[object Set]";
    }, gr = sf && sf.isSet, iu = gr ? fi(gr) : aA, Na = {};
    Na["[object Arguments]"] = Na["[object Array]"] = Na["[object ArrayBuffer]"] = Na["[object DataView]"] = Na["[object Boolean]"] = Na["[object Date]"] = Na["[object Float32Array]"] = Na["[object Float64Array]"] = Na["[object Int8Array]"] = Na["[object Int16Array]"] = Na["[object Int32Array]"] = Na["[object Map]"] = Na["[object Number]"] = Na["[object Object]"] = Na["[object RegExp]"] = Na["[object Set]"] = Na["[object String]"] = Na["[object Symbol]"] = Na["[object Uint8Array]"] = Na["[object Uint8ClampedArray]"] = Na["[object Uint16Array]"] = Na["[object Uint32Array]"] = !0, Na["[object Error]"] = Na["[object Function]"] = Na["[object WeakMap]"] = !1;
    var Ie = function(r) {
      return oa(r) == "symbol" || Bc(r) && le(r) == "[object Symbol]";
    }, bA = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, cA = /^\w*$/, jl = function(r, e) {
      if (pb(r))
        return !1;
      var t = oa(r);
      return !(t != "number" && t != "symbol" && t != "boolean" && r != null && !Ie(r)) || cA.test(r) || !bA.test(r) || e != null && r in Object(e);
    };
    Li.Cache = Xg;
    var dA = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, eA = /\\(\\)?/g, fA = function(r) {
      var e = (r = Li(r, function(t) {
        return e.size === 500 && e.clear(), t;
      })).cache;
      return r;
    }(function(r) {
      var e = [];
      return r.charCodeAt(0) === 46 && e.push(""), r.replace(dA, function(t, a, n, s) {
        e.push(n ? s.replace(eA, "$1") : a || t);
      }), e;
    }), lu = 1 / 0, hr = gc ? gc.prototype : void 0, Nm = hr ? hr.toString : void 0, hi = function(r, e) {
      return pb(r) ? r : jl(r, e) ? [r] : fA(r == null ? "" : Mm(r));
    }, gA = 1 / 0, Hg = function(r) {
      if (typeof r == "string" || Ie(r))
        return r;
      var e = r + "";
      return e == "0" && 1 / r == -gA ? "-0" : e;
    }, ii = function(r, e) {
      for (var t = 0, a = (e = hi(e, r)).length; r != null && t < a; )
        r = r[Hg(e[t++])];
      return t && t == a ? r : void 0;
    }, hA = function(r, e) {
      if (!(2 > (e = hi(e, r)).length)) {
        var t = e, a = 0, n = -1, s = -1, o = t.length;
        for (0 > a && (a = -a > o ? 0 : o + a), 0 > (n = n > o ? o : n) && (n += o), o = a > n ? 0 : n - a >>> 0, a >>>= 0, n = Array(o); ++s < o; )
          n[s] = t[s + a];
        r = ii(r, n);
      }
      return (t = r == null) || (t = e == null ? 0 : e.length, t = delete r[Hg(t ? e[t - 1] : void 0)]), t;
    }, ir = Function.prototype.toString, iA = Object.prototype.hasOwnProperty, jA = ir.call(Object), wn = function(r) {
      return !(!Bc(r) || le(r) != "[object Object]") && ((r = el(r)) === null || typeof (r = iA.call(r, "constructor") && r.constructor) == "function" && r instanceof r && ir.call(r) == jA);
    }, kA = function(r) {
      return wn(r) ? void 0 : r;
    }, jr = gc ? gc.isConcatSpreadable : void 0, mu = function(r) {
      return pb(r) || Tf(r) || !!(jr && r && r[jr]);
    }, lA = function(r) {
      return r != null && r.length ? Mi(r, 1) : [];
    }, mA = function(r, e, t) {
      switch (t.length) {
        case 0:
          return r.call(e);
        case 1:
          return r.call(e, t[0]);
        case 2:
          return r.call(e, t[0], t[1]);
        case 3:
          return r.call(e, t[0], t[1], t[2]);
      }
      return r.apply(e, t);
    }, kr = Math.max, lr = function(r, e, t) {
      return e = kr(e === void 0 ? r.length - 1 : e, 0), function() {
        for (var a = arguments, n = -1, s = kr(a.length - e, 0), o = Array(s); ++n < s; )
          o[n] = a[e + n];
        for (n = -1, s = Array(e + 1); ++n < e; )
          s[n] = a[n];
        return s[e] = t(o), mA(r, this, s);
      };
    }, nA = function(r) {
      return function() {
        return r;
      };
    }, ji = function(r) {
      return r;
    }, oA = Date.now, mr = function(r) {
      var e = 0, t = 0;
      return function() {
        var a = oA(), n = 16 - (a - t);
        if (t = a, 0 < n) {
          if (800 <= ++e)
            return arguments[0];
        } else
          e = 0;
        return r.apply(void 0, arguments);
      };
    }(ei ? function(r, e) {
      return ei(r, "toString", { configurable: !0, enumerable: !1, value: nA(e), writable: !0 });
    } : ji), kl = function(r) {
      return mr(lr(r, void 0, lA), r + "");
    }(function(r, e) {
      var t = {};
      if (r == null)
        return t;
      var a = !1;
      e = He(e, function(s) {
        return s = hi(s, r), a || (a = 1 < s.length), s;
      }), Re(r, Km(r), t), a && (t = Fe(t, 7, kA));
      for (var n = e.length; n--; )
        hA(t, e[n]);
      return t;
    }), pA = function(r, e, t, a) {
      for (var n = -1, s = r == null ? 0 : r.length; ++n < s; ) {
        var o = r[n];
        e(a, o, t(o), r);
      }
      return a;
    }, un = function(r, e, t) {
      for (var a = -1, n = Object(r), s = (t = t(r)).length; s--; ) {
        var o = t[++a];
        if (e(n[o], o, n) === !1)
          break;
      }
      return r;
    }, nr = function(r, e) {
      return r && un(r, e, Vd);
    }, ll = function(r, e) {
      return function(t, a) {
        if (t == null)
          return t;
        if (!$d(t))
          return r(t, a);
        for (var n = t.length, s = -1, o = Object(t); ++s < n && a(o[s], s, o) !== !1; )
          ;
        return t;
      };
    }(nr), qA = function(r, e, t, a) {
      return ll(r, function(n, s, o) {
        e(a, n, t(n), o);
      }), a;
    }, or = function(r, e) {
      for (var t = -1, a = r == null ? 0 : r.length; ++t < a; )
        if (e(r[t], t, r))
          return !0;
      return !1;
    }, Om = function(r, e, t, a, n, s) {
      var o = 1 & t, u = r.length, l = e.length;
      if (u != l && !(o && l > u))
        return !1;
      l = s.get(r);
      var f = s.get(e);
      if (l && f)
        return l == e && f == r;
      l = -1, f = !0;
      var d = 2 & t ? new Jf() : void 0;
      for (s.set(r, e), s.set(e, r); ++l < u; ) {
        var h = r[l], p = e[l];
        if (a)
          var m = o ? a(p, h, l, e, r, s) : a(h, p, l, r, e, s);
        if (m !== void 0) {
          if (m)
            continue;
          f = !1;
          break;
        }
        if (d) {
          if (!or(e, function(_, w) {
            if (!d.has(w) && (h === _ || n(h, _, t, a, s)))
              return d.push(w);
          })) {
            f = !1;
            break;
          }
        } else if (h !== p && !n(h, p, t, a, s)) {
          f = !1;
          break;
        }
      }
      return s.delete(r), s.delete(e), f;
    }, rA = function(r) {
      var e = -1, t = Array(r.size);
      return r.forEach(function(a, n) {
        t[++e] = [n, a];
      }), t;
    }, pr = gc ? gc.prototype : void 0, ml = pr ? pr.valueOf : void 0, nu = function(r, e, t, a, n, s, o) {
      switch (t) {
        case "[object DataView]":
          if (r.byteLength != e.byteLength || r.byteOffset != e.byteOffset)
            break;
          r = r.buffer, e = e.buffer;
        case "[object ArrayBuffer]":
          if (r.byteLength != e.byteLength || !s(new gi(r), new gi(e)))
            break;
          return !0;
        case "[object Boolean]":
        case "[object Date]":
        case "[object Number]":
          return Eg(+r, +e);
        case "[object Error]":
          return r.name == e.name && r.message == e.message;
        case "[object RegExp]":
        case "[object String]":
          return r == e + "";
        case "[object Map]":
          var u = rA;
        case "[object Set]":
          if (u || (u = Zk), r.size != e.size && !(1 & a))
            break;
          return (t = o.get(r)) ? t == e : (a |= 2, o.set(r, e), e = Om(u(r), u(e), a, n, s, o), o.delete(r), e);
        case "[object Symbol]":
          if (ml)
            return ml.call(r) == ml.call(e);
      }
      return !1;
    }, ou = Object.prototype.hasOwnProperty, Pm = Object.prototype.hasOwnProperty, sA = function(r, e, t, a) {
      var n = t.length, s = n, o = !a;
      if (r == null)
        return !s;
      for (r = Object(r); n--; ) {
        var u = t[n];
        if (o && u[2] ? u[1] !== r[u[0]] : !(u[0] in r))
          return !1;
      }
      for (; ++n < s; ) {
        var l = (u = t[n])[0], f = r[l], d = u[1];
        if (o && u[2]) {
          if (f === void 0 && !(l in r))
            return !1;
        } else {
          if (u = new Ge(), a)
            var h = a(f, d, l, r, e, u);
          if (h === void 0 ? !Je(d, f, 3, a, u) : !h)
            return !1;
        }
      }
      return !0;
    }, tA = function(r) {
      for (var e = Vd(r), t = e.length; t--; ) {
        var a = e[t], n = r[a];
        e[t] = [a, n, n == n && !Db(n)];
      }
      return e;
    }, qr = function(r, e) {
      return function(t) {
        return t != null && t[r] === e && (e !== void 0 || r in Object(t));
      };
    }, uA = function(r) {
      var e = tA(r);
      return e.length == 1 && e[0][2] ? qr(e[0][0], e[0][1]) : function(t) {
        return t === r || sA(t, r, e);
      };
    }, vA = function(r, e) {
      return jl(r) && e == e && !Db(e) ? qr(Hg(r), e) : function(t) {
        var a = t == null ? void 0 : ii(t, r);
        if ((a = a === void 0 ? void 0 : a) === void 0 && a === e) {
          if (a = t != null) {
            for (var n = -1, s = (a = hi(a = r, t)).length, o = !1; ++n < s; ) {
              var u = Hg(a[n]);
              if (!(o = t != null && t != null && u in Object(t)))
                break;
              t = t[u];
            }
            o || ++n != s ? a = o : a = !!(s = t == null ? 0 : t.length) && bl(s) && al(u, s) && (pb(t) || Tf(t));
          }
          u = a;
        } else
          u = Je(e, a, 3);
        return u;
      };
    }, wA = function(r) {
      return function(e) {
        return e == null ? void 0 : e[r];
      };
    }, xA = function(r) {
      return function(e) {
        return ii(e, r);
      };
    }, tf = function(r) {
      return typeof r == "function" ? r : r == null ? ji : oa(r) == "object" ? pb(r) ? vA(r[0], r[1]) : uA(r) : jl(r) ? wA(Hg(r)) : xA(r);
    }, nl = function(r, e) {
      return function(t, a) {
        var n = {};
        return (pb(t) ? pA : qA)(t, r, tf(a), n);
      };
    }(function(r, e, t) {
      Gg(r, t, e);
    }), hd = function(r, e) {
      var t = {};
      return e = tf(e), nr(r, function(a, n, s) {
        Gg(t, n, e(a, n, s));
      }), t;
    };
    ba({ target: "String", proto: !0, forced: ia(function() {
      var r = "".sub('"');
      return r !== r.toLowerCase() || 3 < r.split('"').length;
    }) }, { sub: function() {
      return "<sub>" + String(Bb(this)) + "</sub>";
    } });
    var ma = Oa, hc = null;
    try {
      hc = new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0, 97, 115, 109, 1, 0, 0, 0, 1, 13, 2, 96, 0, 1, 127, 96, 4, 127, 127, 127, 127, 1, 127, 3, 7, 6, 0, 1, 1, 1, 1, 1, 6, 6, 1, 127, 1, 65, 0, 11, 7, 50, 6, 3, 109, 117, 108, 0, 1, 5, 100, 105, 118, 95, 115, 0, 2, 5, 100, 105, 118, 95, 117, 0, 3, 5, 114, 101, 109, 95, 115, 0, 4, 5, 114, 101, 109, 95, 117, 0, 5, 8, 103, 101, 116, 95, 104, 105, 103, 104, 0, 0, 10, 191, 1, 6, 4, 0, 35, 0, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 126, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 127, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 128, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 129, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 130, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11])), {}).exports;
    } catch (r) {
    }
    Oa.prototype.__isLong__, Object.defineProperty(Oa.prototype, "__isLong__", { value: !0 }), Oa.isLong = Eb;
    var Rm = {}, Qm = {};
    Oa.fromInt = Wd, Oa.fromNumber = $b, Oa.fromBits = Pa;
    var Zg = Math.pow;
    Oa.fromString = Pi, Oa.fromValue = oc;
    var Ke = 4294967296, Sm = Ke * Ke, Um = Sm / 2, rr = Wd(16777216), ac = Wd(0);
    Oa.ZERO = ac;
    var Xd = Wd(0, !0);
    Oa.UZERO = Xd;
    var uf = Wd(1);
    Oa.ONE = uf;
    var sr = Wd(1, !0);
    Oa.UONE = sr;
    var ol = Wd(-1);
    Oa.NEG_ONE = ol;
    var Vm = Pa(-1, 2147483647, !1);
    Oa.MAX_VALUE = Vm;
    var Tm = Pa(-1, -1, !0);
    Oa.MAX_UNSIGNED_VALUE = Tm;
    var Fb = Pa(0, -2147483648, !1);
    Oa.MIN_VALUE = Fb;
    var T = Oa.prototype;
    T.toInt = function() {
      return this.unsigned ? this.low >>> 0 : this.low;
    }, T.toNumber = function() {
      return this.unsigned ? (this.high >>> 0) * Ke + (this.low >>> 0) : this.high * Ke + (this.low >>> 0);
    }, T.toString = function(r) {
      if (2 > (r = r || 10) || 36 < r)
        throw RangeError("radix");
      if (this.isZero())
        return "0";
      if (this.isNegative()) {
        if (this.eq(Fb)) {
          var e = $b(r), t = this.div(e);
          return e = t.mul(e).sub(this), t.toString(r) + e.toInt().toString(r);
        }
        return "-" + this.neg().toString(r);
      }
      t = $b(Zg(r, 6), this.unsigned), e = this;
      for (var a = ""; ; ) {
        var n = e.div(t), s = (e.sub(n.mul(t)).toInt() >>> 0).toString(r);
        if ((e = n).isZero())
          return s + a;
        for (; 6 > s.length; )
          s = "0" + s;
        a = "" + s + a;
      }
    }, T.getHighBits = function() {
      return this.high;
    }, T.getHighBitsUnsigned = function() {
      return this.high >>> 0;
    }, T.getLowBits = function() {
      return this.low;
    }, T.getLowBitsUnsigned = function() {
      return this.low >>> 0;
    }, T.getNumBitsAbs = function() {
      if (this.isNegative())
        return this.eq(Fb) ? 64 : this.neg().getNumBitsAbs();
      for (var r = this.high != 0 ? this.high : this.low, e = 31; 0 < e && (r & 1 << e) == 0; e--)
        ;
      return this.high != 0 ? e + 33 : e + 1;
    }, T.isZero = function() {
      return this.high === 0 && this.low === 0;
    }, T.eqz = T.isZero, T.isNegative = function() {
      return !this.unsigned && 0 > this.high;
    }, T.isPositive = function() {
      return this.unsigned || 0 <= this.high;
    }, T.isOdd = function() {
      return (1 & this.low) == 1;
    }, T.isEven = function() {
      return (1 & this.low) == 0;
    }, T.equals = function(r) {
      return Eb(r) || (r = oc(r)), (this.unsigned === r.unsigned || this.high >>> 31 != 1 || r.high >>> 31 != 1) && this.high === r.high && this.low === r.low;
    }, T.eq = T.equals, T.notEquals = function(r) {
      return !this.eq(r);
    }, T.neq = T.notEquals, T.ne = T.notEquals, T.lessThan = function(r) {
      return 0 > this.comp(r);
    }, T.lt = T.lessThan, T.lessThanOrEqual = function(r) {
      return 0 >= this.comp(r);
    }, T.lte = T.lessThanOrEqual, T.le = T.lessThanOrEqual, T.greaterThan = function(r) {
      return 0 < this.comp(r);
    }, T.gt = T.greaterThan, T.greaterThanOrEqual = function(r) {
      return 0 <= this.comp(r);
    }, T.gte = T.greaterThanOrEqual, T.ge = T.greaterThanOrEqual, T.compare = function(r) {
      if (Eb(r) || (r = oc(r)), this.eq(r))
        return 0;
      var e = this.isNegative(), t = r.isNegative();
      return e && !t ? -1 : !e && t ? 1 : this.unsigned ? r.high >>> 0 > this.high >>> 0 || r.high === this.high && r.low >>> 0 > this.low >>> 0 ? -1 : 1 : this.sub(r).isNegative() ? -1 : 1;
    }, T.comp = T.compare, T.negate = function() {
      return !this.unsigned && this.eq(Fb) ? Fb : this.not().add(uf);
    }, T.neg = T.negate, T.add = function(r) {
      Eb(r) || (r = oc(r));
      var e = this.high >>> 16, t = 65535 & this.high, a = this.low >>> 16, n = r.high >>> 16, s = 65535 & r.high, o = r.low >>> 16;
      return a = (o = ((r = (65535 & this.low) + (65535 & r.low)) >>> 16) + (a + o)) >>> 16, Pa((65535 & o) << 16 | 65535 & r, (e = ((a += t + s) >>> 16) + (e + n) & 65535) << 16 | 65535 & a, this.unsigned);
    }, T.subtract = function(r) {
      return Eb(r) || (r = oc(r)), this.add(r.neg());
    }, T.sub = T.subtract, T.multiply = function(r) {
      if (this.isZero())
        return ac;
      if (Eb(r) || (r = oc(r)), hc) {
        var e = hc.mul(this.low, this.high, r.low, r.high);
        return Pa(e, hc.get_high(), this.unsigned);
      }
      if (r.isZero())
        return ac;
      if (this.eq(Fb))
        return r.isOdd() ? Fb : ac;
      if (r.eq(Fb))
        return this.isOdd() ? Fb : ac;
      if (this.isNegative())
        return r.isNegative() ? this.neg().mul(r.neg()) : this.neg().mul(r).neg();
      if (r.isNegative())
        return this.mul(r.neg()).neg();
      if (this.lt(rr) && r.lt(rr))
        return $b(this.toNumber() * r.toNumber(), this.unsigned);
      e = this.high >>> 16;
      var t = 65535 & this.high, a = this.low >>> 16, n = 65535 & this.low, s = r.high >>> 16, o = 65535 & r.high, u = r.low >>> 16, l = n * (r = 65535 & r.low), f = (l >>> 16) + a * r, d = f >>> 16;
      d += (f = (65535 & f) + n * u) >>> 16;
      var h = (d += t * r) >>> 16;
      return Pa((65535 & f) << 16 | 65535 & l, (h = (h += (d = (65535 & d) + a * u) >>> 16) + ((d = (65535 & d) + n * o) >>> 16) + (e * r + t * u + a * o + n * s) & 65535) << 16 | 65535 & d, this.unsigned);
    }, T.mul = T.multiply, T.divide = function(r) {
      if (Eb(r) || (r = oc(r)), r.isZero())
        throw Error("division by zero");
      if (hc)
        return this.unsigned || this.high !== -2147483648 || r.low !== -1 || r.high !== -1 ? Pa(r = (this.unsigned ? hc.div_u : hc.div_s)(this.low, this.high, r.low, r.high), hc.get_high(), this.unsigned) : this;
      if (this.isZero())
        return this.unsigned ? Xd : ac;
      if (this.unsigned) {
        if (r.unsigned || (r = r.toUnsigned()), r.gt(this))
          return Xd;
        if (r.gt(this.shru(1)))
          return sr;
        var e = Xd;
      } else {
        if (this.eq(Fb)) {
          if (r.eq(uf) || r.eq(ol))
            return Fb;
          if (r.eq(Fb))
            return uf;
          var t = this.shr(1).div(r).shl(1);
          if (t.eq(ac))
            return r.isNegative() ? uf : ol;
          var a = this.sub(r.mul(t));
          return t.add(a.div(r));
        }
        if (r.eq(Fb))
          return this.unsigned ? Xd : ac;
        if (this.isNegative())
          return r.isNegative() ? this.neg().div(r.neg()) : this.neg().div(r).neg();
        if (r.isNegative())
          return this.div(r.neg()).neg();
        e = ac;
      }
      for (a = this; a.gte(r); ) {
        t = Math.max(1, Math.floor(a.toNumber() / r.toNumber()));
        var n = Math.ceil(Math.log(t) / Math.LN2);
        n = 48 >= n ? 1 : Zg(2, n - 48);
        for (var s = $b(t), o = s.mul(r); o.isNegative() || o.gt(a); )
          o = (s = $b(t -= n, this.unsigned)).mul(r);
        s.isZero() && (s = uf), e = e.add(s), a = a.sub(o);
      }
      return e;
    }, T.div = T.divide, T.modulo = function(r) {
      return Eb(r) || (r = oc(r)), hc ? Pa(r = (this.unsigned ? hc.rem_u : hc.rem_s)(this.low, this.high, r.low, r.high), hc.get_high(), this.unsigned) : this.sub(this.div(r).mul(r));
    }, T.mod = T.modulo, T.rem = T.modulo, T.not = function() {
      return Pa(~this.low, ~this.high, this.unsigned);
    }, T.and = function(r) {
      return Eb(r) || (r = oc(r)), Pa(this.low & r.low, this.high & r.high, this.unsigned);
    }, T.or = function(r) {
      return Eb(r) || (r = oc(r)), Pa(this.low | r.low, this.high | r.high, this.unsigned);
    }, T.xor = function(r) {
      return Eb(r) || (r = oc(r)), Pa(this.low ^ r.low, this.high ^ r.high, this.unsigned);
    }, T.shiftLeft = function(r) {
      return Eb(r) && (r = r.toInt()), (r &= 63) == 0 ? this : 32 > r ? Pa(this.low << r, this.high << r | this.low >>> 32 - r, this.unsigned) : Pa(0, this.low << r - 32, this.unsigned);
    }, T.shl = T.shiftLeft, T.shiftRight = function(r) {
      return Eb(r) && (r = r.toInt()), (r &= 63) == 0 ? this : 32 > r ? Pa(this.low >>> r | this.high << 32 - r, this.high >> r, this.unsigned) : Pa(this.high >> r - 32, 0 <= this.high ? 0 : -1, this.unsigned);
    }, T.shr = T.shiftRight, T.shiftRightUnsigned = function(r) {
      if (Eb(r) && (r = r.toInt()), (r &= 63) === 0)
        return this;
      var e = this.high;
      return 32 > r ? Pa(this.low >>> r | e << 32 - r, e >>> r, this.unsigned) : Pa(r === 32 ? e : e >>> r - 32, 0, this.unsigned);
    }, T.shru = T.shiftRightUnsigned, T.shr_u = T.shiftRightUnsigned, T.toSigned = function() {
      return this.unsigned ? Pa(this.low, this.high, !1) : this;
    }, T.toUnsigned = function() {
      return this.unsigned ? this : Pa(this.low, this.high, !0);
    }, T.toBytes = function(r) {
      return r ? this.toBytesLE() : this.toBytesBE();
    }, T.toBytesLE = function() {
      var r = this.high, e = this.low;
      return [255 & e, e >>> 8 & 255, e >>> 16 & 255, e >>> 24, 255 & r, r >>> 8 & 255, r >>> 16 & 255, r >>> 24];
    }, T.toBytesBE = function() {
      var r = this.high, e = this.low;
      return [r >>> 24, r >>> 16 & 255, r >>> 8 & 255, 255 & r, e >>> 24, e >>> 16 & 255, e >>> 8 & 255, 255 & e];
    }, Oa.fromBytes = function(r, e, t) {
      return t ? Oa.fromBytesLE(r, e) : Oa.fromBytesBE(r, e);
    }, Oa.fromBytesLE = function(r, e) {
      return new Oa(r[0] | r[1] << 8 | r[2] << 16 | r[3] << 24, r[4] | r[5] << 8 | r[6] << 16 | r[7] << 24, e);
    }, Oa.fromBytesBE = function(r, e) {
      return new Oa(r[4] << 24 | r[5] << 16 | r[6] << 8 | r[7], r[0] << 24 | r[1] << 16 | r[2] << 8 | r[3], e);
    };
    var Qi = function(r, e) {
      return (Qi = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(t, a) {
        t.__proto__ = a;
      } || function(t, a) {
        for (var n in a)
          a.hasOwnProperty(n) && (t[n] = a[n]);
      })(r, e);
    }, pl = !1, bc = { Promise: void 0, set useDeprecatedSynchronousErrorHandling(r) {
      r ? console.warn(`DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: 
` + Error().stack) : pl && console.log("RxJS: Back to a better error behavior. Thank you. <3"), pl = r;
    }, get useDeprecatedSynchronousErrorHandling() {
      return pl;
    } }, ki = { closed: !0, next: function(r) {
    }, error: function(r) {
      if (bc.useDeprecatedSynchronousErrorHandling)
        throw r;
      Me(r);
    }, complete: function() {
    } }, cc = Array.isArray || function(r) {
      return r && typeof r.length == "number";
    }, Nf = function() {
      function r(e) {
        return Error.call(this), this.message = e ? e.length + ` errors occurred during unsubscription:
` + e.map(function(t, a) {
          return a + 1 + ") " + t.toString();
        }).join(`
  `) : "", this.name = "UnsubscriptionError", this.errors = e, this;
      }
      return r.prototype = Object.create(Error.prototype), r;
    }(), kb = function() {
      function r(e) {
        this.closed = !1, this._subscriptions = this._parentOrParents = null, e && (this._ctorUnsubscribe = !0, this._unsubscribe = e);
      }
      return r.prototype.unsubscribe = function() {
        if (!this.closed) {
          var e = this._parentOrParents, t = this._ctorUnsubscribe, a = this._unsubscribe, n = this._subscriptions;
          if (this.closed = !0, this._subscriptions = this._parentOrParents = null, e instanceof r)
            e.remove(this);
          else if (e !== null)
            for (var s = 0; s < e.length; ++s)
              e[s].remove(this);
          if (Le(a)) {
            t && (this._unsubscribe = void 0);
            try {
              a.call(this);
            } catch (u) {
              var o = u instanceof Nf ? Wm(u.errors) : [u];
            }
          }
          if (cc(n)) {
            for (s = -1, e = n.length; ++s < e; )
              if (Ri(t = n[s]))
                try {
                  t.unsubscribe();
                } catch (u) {
                  o = o || [], u instanceof Nf ? o = o.concat(Wm(u.errors)) : o.push(u);
                }
          }
          if (o)
            throw new Nf(o);
        }
      }, r.prototype.add = function(e) {
        var t = e;
        if (!e)
          return r.EMPTY;
        switch (oa(e)) {
          case "function":
            t = new r(e);
          case "object":
            if (t === this || t.closed || typeof t.unsubscribe != "function")
              return t;
            if (this.closed)
              return t.unsubscribe(), t;
            t instanceof r || (e = t, (t = new r())._subscriptions = [e]);
            break;
          default:
            throw Error("unrecognized teardown " + e + " added to Subscription.");
        }
        if ((e = t._parentOrParents) === null)
          t._parentOrParents = this;
        else if (e instanceof r) {
          if (e === this)
            return t;
          t._parentOrParents = [e, this];
        } else {
          if (e.indexOf(this) !== -1)
            return t;
          e.push(this);
        }
        return (e = this._subscriptions) === null ? this._subscriptions = [t] : e.push(t), t;
      }, r.prototype.remove = function(e) {
        var t = this._subscriptions;
        t && (e = t.indexOf(e)) !== -1 && t.splice(e, 1);
      }, r.EMPTY = function(e) {
        return e.closed = !0, e;
      }(new r()), r;
    }(), li = typeof Symbol == "function" ? Symbol("rxSubscriber") : "@@rxSubscriber_" + Math.random(), za = function(r) {
      function e(t, a, n) {
        var s = r.call(this) || this;
        switch (s.syncErrorValue = null, s.syncErrorThrown = !1, s.syncErrorThrowable = !1, s.isStopped = !1, arguments.length) {
          case 0:
            s.destination = ki;
            break;
          case 1:
            if (!t) {
              s.destination = ki;
              break;
            }
            if (oa(t) === "object") {
              t instanceof e ? (s.syncErrorThrowable = t.syncErrorThrowable, s.destination = t, t.add(s)) : (s.syncErrorThrowable = !0, s.destination = new tr(s, t));
              break;
            }
          default:
            s.syncErrorThrowable = !0, s.destination = new tr(s, t, a, n);
        }
        return s;
      }
      return da(e, r), e.prototype[li] = function() {
        return this;
      }, e.create = function(t, a, n) {
        return (t = new e(t, a, n)).syncErrorThrowable = !1, t;
      }, e.prototype.next = function(t) {
        this.isStopped || this._next(t);
      }, e.prototype.error = function(t) {
        this.isStopped || (this.isStopped = !0, this._error(t));
      }, e.prototype.complete = function() {
        this.isStopped || (this.isStopped = !0, this._complete());
      }, e.prototype.unsubscribe = function() {
        this.closed || (this.isStopped = !0, r.prototype.unsubscribe.call(this));
      }, e.prototype._next = function(t) {
        this.destination.next(t);
      }, e.prototype._error = function(t) {
        this.destination.error(t), this.unsubscribe();
      }, e.prototype._complete = function() {
        this.destination.complete(), this.unsubscribe();
      }, e.prototype._unsubscribeAndRecycle = function() {
        var t = this._parentOrParents;
        return this._parentOrParents = null, this.unsubscribe(), this.isStopped = this.closed = !1, this._parentOrParents = t, this;
      }, e;
    }(kb), tr = function(r) {
      function e(t, a, n, s) {
        var o = r.call(this) || this;
        if (o._parentSubscriber = t, t = o, Le(a))
          var u = a;
        else
          a && (u = a.next, n = a.error, s = a.complete, a !== ki && (Le((t = Object.create(a)).unsubscribe) && o.add(t.unsubscribe.bind(t)), t.unsubscribe = o.unsubscribe.bind(o)));
        return o._context = t, o._next = u, o._error = n, o._complete = s, o;
      }
      return da(e, r), e.prototype.next = function(t) {
        if (!this.isStopped && this._next) {
          var a = this._parentSubscriber;
          bc.useDeprecatedSynchronousErrorHandling && a.syncErrorThrowable ? this.__tryOrSetError(a, this._next, t) && this.unsubscribe() : this.__tryOrUnsub(this._next, t);
        }
      }, e.prototype.error = function(t) {
        if (!this.isStopped) {
          var a = this._parentSubscriber, n = bc.useDeprecatedSynchronousErrorHandling;
          if (this._error)
            n && a.syncErrorThrowable ? this.__tryOrSetError(a, this._error, t) : this.__tryOrUnsub(this._error, t), this.unsubscribe();
          else if (a.syncErrorThrowable)
            n ? (a.syncErrorValue = t, a.syncErrorThrown = !0) : Me(t), this.unsubscribe();
          else {
            if (this.unsubscribe(), n)
              throw t;
            Me(t);
          }
        }
      }, e.prototype.complete = function() {
        var t = this;
        if (!this.isStopped) {
          var a = this._parentSubscriber;
          if (this._complete) {
            var n = function() {
              return t._complete.call(t._context);
            };
            bc.useDeprecatedSynchronousErrorHandling && a.syncErrorThrowable ? this.__tryOrSetError(a, n) : this.__tryOrUnsub(n);
          }
          this.unsubscribe();
        }
      }, e.prototype.__tryOrUnsub = function(t, a) {
        try {
          t.call(this._context, a);
        } catch (n) {
          if (this.unsubscribe(), bc.useDeprecatedSynchronousErrorHandling)
            throw n;
          Me(n);
        }
      }, e.prototype.__tryOrSetError = function(t, a, n) {
        if (!bc.useDeprecatedSynchronousErrorHandling)
          throw Error("bad call");
        try {
          a.call(this._context, n);
        } catch (s) {
          return bc.useDeprecatedSynchronousErrorHandling ? (t.syncErrorValue = s, t.syncErrorThrown = !0) : Me(s), !0;
        }
        return !1;
      }, e.prototype._unsubscribe = function() {
        var t = this._parentSubscriber;
        this._parentSubscriber = this._context = null, t.unsubscribe();
      }, e;
    }(za), Ne = typeof Symbol == "function" && Symbol.observable || "@@observable", ra = function() {
      function r(e) {
        this._isScalar = !1, e && (this._subscribe = e);
      }
      return r.prototype.lift = function(e) {
        var t = new r();
        return t.source = this, t.operator = e, t;
      }, r.prototype.subscribe = function(e, t, a) {
        var n = this.operator;
        e: {
          if (e) {
            if (e instanceof za)
              break e;
            if (e[li]) {
              e = e[li]();
              break e;
            }
          }
          e = e || t || a ? new za(e, t, a) : new za(ki);
        }
        if (n ? e.add(n.call(e, this.source)) : e.add(this.source || bc.useDeprecatedSynchronousErrorHandling && !e.syncErrorThrowable ? this._subscribe(e) : this._trySubscribe(e)), bc.useDeprecatedSynchronousErrorHandling && e.syncErrorThrowable && (e.syncErrorThrowable = !1, e.syncErrorThrown))
          throw e.syncErrorValue;
        return e;
      }, r.prototype._trySubscribe = function(e) {
        try {
          return this._subscribe(e);
        } catch (t) {
          bc.useDeprecatedSynchronousErrorHandling && (e.syncErrorThrown = !0, e.syncErrorValue = t), Si(e) ? e.error(t) : console.warn(t);
        }
      }, r.prototype.forEach = function(e, t) {
        var a = this;
        return new (t = Ym(t))(function(n, s) {
          var o = a.subscribe(function(u) {
            try {
              e(u);
            } catch (l) {
              s(l), o && o.unsubscribe();
            }
          }, s, n);
        });
      }, r.prototype._subscribe = function(e) {
        var t = this.source;
        return t && t.subscribe(e);
      }, r.prototype[Ne] = function() {
        return this;
      }, r.prototype.pipe = function() {
        for (var e = [], t = 0; t < arguments.length; t++)
          e[t] = arguments[t];
        return e.length === 0 ? this : Xm(e)(this);
      }, r.prototype.toPromise = function(e) {
        var t = this;
        return new (e = Ym(e))(function(a, n) {
          var s;
          t.subscribe(function(o) {
            return s = o;
          }, function(o) {
            return n(o);
          }, function() {
            return a(s);
          });
        });
      }, r.create = function(e) {
        return new r(e);
      }, r;
    }(), Kd = function() {
      function r() {
        return Error.call(this), this.message = "object unsubscribed", this.name = "ObjectUnsubscribedError", this;
      }
      return r.prototype = Object.create(Error.prototype), r;
    }(), ur = function(r) {
      function e(t, a) {
        var n = r.call(this) || this;
        return n.subject = t, n.subscriber = a, n.closed = !1, n;
      }
      return da(e, r), e.prototype.unsubscribe = function() {
        if (!this.closed) {
          this.closed = !0;
          var t = this.subject, a = t.observers;
          this.subject = null, !a || a.length === 0 || t.isStopped || t.closed || (t = a.indexOf(this.subscriber)) !== -1 && a.splice(t, 1);
        }
      }, e;
    }(kb), vr = function(r) {
      function e(t) {
        var a = r.call(this, t) || this;
        return a.destination = t, a;
      }
      return da(e, r), e;
    }(za), nb = function(r) {
      function e() {
        var t = r.call(this) || this;
        return t.observers = [], t.closed = !1, t.isStopped = !1, t.hasError = !1, t.thrownError = null, t;
      }
      return da(e, r), e.prototype[li] = function() {
        return new vr(this);
      }, e.prototype.lift = function(t) {
        var a = new wr(this, this);
        return a.operator = t, a;
      }, e.prototype.next = function(t) {
        if (this.closed)
          throw new Kd();
        if (!this.isStopped) {
          var a = this.observers, n = a.length;
          a = a.slice();
          for (var s = 0; s < n; s++)
            a[s].next(t);
        }
      }, e.prototype.error = function(t) {
        if (this.closed)
          throw new Kd();
        this.hasError = !0, this.thrownError = t, this.isStopped = !0;
        var a = this.observers, n = a.length;
        a = a.slice();
        for (var s = 0; s < n; s++)
          a[s].error(t);
        this.observers.length = 0;
      }, e.prototype.complete = function() {
        if (this.closed)
          throw new Kd();
        this.isStopped = !0;
        var t = this.observers, a = t.length;
        t = t.slice();
        for (var n = 0; n < a; n++)
          t[n].complete();
        this.observers.length = 0;
      }, e.prototype.unsubscribe = function() {
        this.closed = this.isStopped = !0, this.observers = null;
      }, e.prototype._trySubscribe = function(t) {
        if (this.closed)
          throw new Kd();
        return r.prototype._trySubscribe.call(this, t);
      }, e.prototype._subscribe = function(t) {
        if (this.closed)
          throw new Kd();
        return this.hasError ? (t.error(this.thrownError), kb.EMPTY) : this.isStopped ? (t.complete(), kb.EMPTY) : (this.observers.push(t), new ur(this, t));
      }, e.prototype.asObservable = function() {
        var t = new ra();
        return t.source = this, t;
      }, e.create = function(t, a) {
        return new wr(t, a);
      }, e;
    }(ra), wr = function(r) {
      function e(t, a) {
        var n = r.call(this) || this;
        return n.destination = t, n.source = a, n;
      }
      return da(e, r), e.prototype.next = function(t) {
        var a = this.destination;
        a && a.next && a.next(t);
      }, e.prototype.error = function(t) {
        var a = this.destination;
        a && a.error && this.destination.error(t);
      }, e.prototype.complete = function() {
        var t = this.destination;
        t && t.complete && this.destination.complete();
      }, e.prototype._subscribe = function(t) {
        return this.source ? this.source.subscribe(t) : kb.EMPTY;
      }, e;
    }(nb), pu = function() {
      function r(e) {
        this.connectable = e;
      }
      return r.prototype.call = function(e, t) {
        var a = this.connectable;
        return a._refCount++, e = new yA(e, a), t = t.subscribe(e), e.closed || (e.connection = a.connect()), t;
      }, r;
    }(), yA = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).connectable = a, t;
      }
      return da(e, r), e.prototype._unsubscribe = function() {
        var t = this.connectable;
        if (t) {
          this.connectable = null;
          var a = t._refCount;
          0 >= a ? this.connection = null : (t._refCount = a - 1, 1 < a ? this.connection = null : (a = this.connection, t = t._connection, this.connection = null, !t || a && t !== a || t.unsubscribe()));
        } else
          this.connection = null;
      }, e;
    }(za), xr = function(r) {
      function e(t, a) {
        var n = r.call(this) || this;
        return n.source = t, n.subjectFactory = a, n._refCount = 0, n._isComplete = !1, n;
      }
      return da(e, r), e.prototype._subscribe = function(t) {
        return this.getSubject().subscribe(t);
      }, e.prototype.getSubject = function() {
        var t = this._subject;
        return t && !t.isStopped || (this._subject = this.subjectFactory()), this._subject;
      }, e.prototype.connect = function() {
        var t = this._connection;
        return t || (this._isComplete = !1, (t = this._connection = new kb()).add(this.source.subscribe(new zA(this.getSubject(), this))), t.closed && (this._connection = null, t = kb.EMPTY)), t;
      }, e.prototype.refCount = function() {
        return Zm()(this);
      }, e;
    }(ra), bv = function() {
      var r = xr.prototype;
      return { operator: { value: null }, _refCount: { value: 0, writable: !0 }, _subject: { value: null, writable: !0 }, _connection: { value: null, writable: !0 }, _subscribe: { value: r._subscribe }, _isComplete: { value: r._isComplete, writable: !0 }, getSubject: { value: r.getSubject }, connect: { value: r.connect }, refCount: { value: r.refCount } };
    }(), zA = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).connectable = a, t;
      }
      return da(e, r), e.prototype._error = function(t) {
        this._unsubscribe(), r.prototype._error.call(this, t);
      }, e.prototype._complete = function() {
        this.connectable._isComplete = !0, this._unsubscribe(), r.prototype._complete.call(this);
      }, e.prototype._unsubscribe = function() {
        var t = this.connectable;
        if (t) {
          this.connectable = null;
          var a = t._connection;
          t._refCount = 0, t._subject = null, t._connection = null, a && a.unsubscribe();
        }
      }, e;
    }(vr);
    (function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).connectable = a, t;
      }
      da(e, r), e.prototype._unsubscribe = function() {
        var t = this.connectable;
        if (t) {
          this.connectable = null;
          var a = t._refCount;
          0 >= a ? this.connection = null : (t._refCount = a - 1, 1 < a ? this.connection = null : (a = this.connection, t = t._connection, this.connection = null, !t || a && t !== a || t.unsubscribe()));
        } else
          this.connection = null;
      };
    })(za), function(r) {
      function e(t, a, n, s, o) {
        return (t = r.call(this, t) || this).keySelector = a, t.elementSelector = n, t.durationSelector = s, t.subjectSelector = o, t.groups = null, t.attemptedToUnsubscribe = !1, t.count = 0, t;
      }
      da(e, r), e.prototype._next = function(t) {
        try {
          var a = this.keySelector(t);
        } catch (n) {
          return void this.error(n);
        }
        this._group(t, a);
      }, e.prototype._group = function(t, a) {
        var n = this.groups;
        n || (n = this.groups = /* @__PURE__ */ new Map());
        var s = n.get(a);
        if (this.elementSelector)
          try {
            var o = this.elementSelector(t);
          } catch (u) {
            this.error(u);
          }
        else
          o = t;
        if (!s && (s = this.subjectSelector ? this.subjectSelector() : new nb(), n.set(a, s), t = new ql(a, s, this), this.destination.next(t), this.durationSelector)) {
          t = void 0;
          try {
            t = this.durationSelector(new ql(a, s));
          } catch (u) {
            return void this.error(u);
          }
          this.add(t.subscribe(new AA(a, s, this)));
        }
        s.closed || s.next(o);
      }, e.prototype._error = function(t) {
        var a = this.groups;
        a && (a.forEach(function(n, s) {
          n.error(t);
        }), a.clear()), this.destination.error(t);
      }, e.prototype._complete = function() {
        var t = this.groups;
        t && (t.forEach(function(a, n) {
          a.complete();
        }), t.clear()), this.destination.complete();
      }, e.prototype.removeGroup = function(t) {
        this.groups.delete(t);
      }, e.prototype.unsubscribe = function() {
        this.closed || (this.attemptedToUnsubscribe = !0, this.count === 0 && r.prototype.unsubscribe.call(this));
      };
    }(za);
    var AA = function(r) {
      function e(t, a, n) {
        var s = r.call(this, a) || this;
        return s.key = t, s.group = a, s.parent = n, s;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.complete();
      }, e.prototype._unsubscribe = function() {
        var t = this.parent, a = this.key;
        this.key = this.parent = null, t && t.removeGroup(a);
      }, e;
    }(za), ql = function(r) {
      function e(t, a, n) {
        var s = r.call(this) || this;
        return s.key = t, s.groupSubject = a, s.refCountSubscription = n, s;
      }
      return da(e, r), e.prototype._subscribe = function(t) {
        var a = new kb(), n = this.refCountSubscription, s = this.groupSubject;
        return n && !n.closed && a.add(new BA(n)), a.add(s.subscribe(t)), a;
      }, e;
    }(ra), BA = function(r) {
      function e(t) {
        var a = r.call(this) || this;
        return a.parent = t, t.count++, a;
      }
      return da(e, r), e.prototype.unsubscribe = function() {
        var t = this.parent;
        t.closed || this.closed || (r.prototype.unsubscribe.call(this), --t.count, t.count === 0 && t.attemptedToUnsubscribe && t.unsubscribe());
      }, e;
    }(kb), CA = function(r) {
      function e(t) {
        var a = r.call(this) || this;
        return a._value = t, a;
      }
      return da(e, r), Object.defineProperty(e.prototype, "value", { get: function() {
        return this.getValue();
      }, enumerable: !0, configurable: !0 }), e.prototype._subscribe = function(t) {
        var a = r.prototype._subscribe.call(this, t);
        return a && !a.closed && t.next(this._value), a;
      }, e.prototype.getValue = function() {
        if (this.hasError)
          throw this.thrownError;
        if (this.closed)
          throw new Kd();
        return this._value;
      }, e.prototype.next = function(t) {
        r.prototype.next.call(this, this._value = t);
      }, e;
    }(nb), Ig = function(r) {
      function e(t, a) {
        var n = r.call(this, t, a) || this;
        return n.scheduler = t, n.work = a, n.pending = !1, n;
      }
      return da(e, r), e.prototype.schedule = function(t, a) {
        if (a === void 0 && (a = 0), this.closed)
          return this;
        this.state = t, t = this.id;
        var n = this.scheduler;
        return t != null && (this.id = this.recycleAsyncId(n, t, a)), this.pending = !0, this.delay = a, this.id = this.id || this.requestAsyncId(n, this.id, a), this;
      }, e.prototype.requestAsyncId = function(t, a, n) {
        return n === void 0 && (n = 0), setInterval(t.flush.bind(t, this), n);
      }, e.prototype.recycleAsyncId = function(t, a, n) {
        if (n === void 0 && (n = 0), n !== null && this.delay === n && this.pending === !1)
          return a;
        clearInterval(a);
      }, e.prototype.execute = function(t, a) {
        return this.closed ? Error("executing a cancelled action") : (this.pending = !1, (t = this._execute(t, a)) ? t : void (this.pending === !1 && this.id != null && (this.id = this.recycleAsyncId(this.scheduler, this.id, null))));
      }, e.prototype._execute = function(t, a) {
        a = !1;
        var n = void 0;
        try {
          this.work(t);
        } catch (s) {
          a = !0, n = !!s && s || Error(s);
        }
        if (a)
          return this.unsubscribe(), n;
      }, e.prototype._unsubscribe = function() {
        var t = this.id, a = this.scheduler, n = a.actions, s = n.indexOf(this);
        this.state = this.work = null, this.pending = !1, this.scheduler = null, s !== -1 && n.splice(s, 1), t != null && (this.id = this.recycleAsyncId(a, t, null)), this.delay = null;
      }, e;
    }(function(r) {
      function e(t, a) {
        return r.call(this) || this;
      }
      return da(e, r), e.prototype.schedule = function(t, a) {
        return this;
      }, e;
    }(kb)), DA = function(r) {
      function e(t, a) {
        var n = r.call(this, t, a) || this;
        return n.scheduler = t, n.work = a, n;
      }
      return da(e, r), e.prototype.schedule = function(t, a) {
        return a === void 0 && (a = 0), 0 < a ? r.prototype.schedule.call(this, t, a) : (this.delay = a, this.state = t, this.scheduler.flush(this), this);
      }, e.prototype.execute = function(t, a) {
        return 0 < a || this.closed ? r.prototype.execute.call(this, t, a) : this._execute(t, a);
      }, e.prototype.requestAsyncId = function(t, a, n) {
        return n === void 0 && (n = 0), n !== null && 0 < n || n === null && 0 < this.delay ? r.prototype.requestAsyncId.call(this, t, a, n) : t.flush(this);
      }, e;
    }(Ig), rl = function() {
      function r(e, t) {
        t === void 0 && (t = r.now), this.SchedulerAction = e, this.now = t;
      }
      return r.prototype.schedule = function(e, t, a) {
        return t === void 0 && (t = 0), new this.SchedulerAction(this, e).schedule(a, t);
      }, r.now = function() {
        return Date.now();
      }, r;
    }(), Jg = function(r) {
      function e(t, a) {
        a === void 0 && (a = rl.now);
        var n = r.call(this, t, function() {
          return e.delegate && e.delegate !== n ? e.delegate.now() : a();
        }) || this;
        return n.actions = [], n.active = !1, n.scheduled = void 0, n;
      }
      return da(e, r), e.prototype.schedule = function(t, a, n) {
        return a === void 0 && (a = 0), e.delegate && e.delegate !== this ? e.delegate.schedule(t, a, n) : r.prototype.schedule.call(this, t, a, n);
      }, e.prototype.flush = function(t) {
        var a = this.actions;
        if (this.active)
          a.push(t);
        else {
          var n;
          this.active = !0;
          do
            if (n = t.execute(t.state, t.delay))
              break;
          while (t = a.shift());
          if (this.active = !1, n) {
            for (; t = a.shift(); )
              t.unsubscribe();
            throw n;
          }
        }
      }, e;
    }(rl), Kg = new (function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      return da(e, r), e;
    }(Jg))(DA), Nb = new ra(function(r) {
      return r.complete();
    }), $m = function(r) {
      return function(e) {
        for (var t = 0, a = r.length; t < a && !e.closed; t++)
          e.next(r[t]);
        e.complete();
      };
    }, sl;
    (function(r) {
      r.NEXT = "N", r.ERROR = "E", r.COMPLETE = "C";
    })(sl || (sl = {}));
    var vf = function() {
      function r(e, t, a) {
        this.kind = e, this.value = t, this.error = a, this.hasValue = e === "N";
      }
      return r.prototype.observe = function(e) {
        switch (this.kind) {
          case "N":
            return e.next && e.next(this.value);
          case "E":
            return e.error && e.error(this.error);
          case "C":
            return e.complete && e.complete();
        }
      }, r.prototype.do = function(e, t, a) {
        switch (this.kind) {
          case "N":
            return e && e(this.value);
          case "E":
            return t && t(this.error);
          case "C":
            return a && a();
        }
      }, r.prototype.accept = function(e, t, a) {
        return e && typeof e.next == "function" ? this.observe(e) : this.do(e, t, a);
      }, r.prototype.toObservable = function() {
        switch (this.kind) {
          case "N":
            return wb(this.value);
          case "E":
            return pa(this.error);
          case "C":
            return Of();
        }
        throw Error("unexpected notification kind value");
      }, r.createNext = function(e) {
        return e !== void 0 ? new r("N", e) : r.undefinedValueNotification;
      }, r.createError = function(e) {
        return new r("E", void 0, e);
      }, r.createComplete = function() {
        return r.completeNotification;
      }, r.completeNotification = new r("C"), r.undefinedValueNotification = new r("N", void 0), r;
    }(), tu = function() {
      function r(e, t) {
        t === void 0 && (t = 0), this.scheduler = e, this.delay = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new yr(e, this.scheduler, this.delay));
      }, r;
    }(), yr = function(r) {
      function e(t, a, n) {
        return n === void 0 && (n = 0), (t = r.call(this, t) || this).scheduler = a, t.delay = n, t;
      }
      return da(e, r), e.dispatch = function(t) {
        t.notification.observe(t.destination), this.unsubscribe();
      }, e.prototype.scheduleMessage = function(t) {
        this.destination.add(this.scheduler.schedule(e.dispatch, this.delay, new EA(t, this.destination)));
      }, e.prototype._next = function(t) {
        this.scheduleMessage(vf.createNext(t));
      }, e.prototype._error = function(t) {
        this.scheduleMessage(vf.createError(t)), this.unsubscribe();
      }, e.prototype._complete = function() {
        this.scheduleMessage(vf.createComplete()), this.unsubscribe();
      }, e;
    }(za), EA = function(r, e) {
      this.notification = r, this.destination = e;
    }, Qe = function(r) {
      function e(t, a, n) {
        t === void 0 && (t = Number.POSITIVE_INFINITY), a === void 0 && (a = Number.POSITIVE_INFINITY);
        var s = r.call(this) || this;
        return s.scheduler = n, s._events = [], s._infiniteTimeWindow = !1, s._bufferSize = 1 > t ? 1 : t, s._windowTime = 1 > a ? 1 : a, a === Number.POSITIVE_INFINITY ? (s._infiniteTimeWindow = !0, s.next = s.nextInfiniteTimeWindow) : s.next = s.nextTimeWindow, s;
      }
      return da(e, r), e.prototype.nextInfiniteTimeWindow = function(t) {
        if (!this.isStopped) {
          var a = this._events;
          a.push(t), a.length > this._bufferSize && a.shift();
        }
        r.prototype.next.call(this, t);
      }, e.prototype.nextTimeWindow = function(t) {
        this.isStopped || (this._events.push(new FA(this._getNow(), t)), this._trimBufferThenGetEvents()), r.prototype.next.call(this, t);
      }, e.prototype._subscribe = function(t) {
        var a = this._infiniteTimeWindow, n = a ? this._events : this._trimBufferThenGetEvents(), s = this.scheduler, o = n.length;
        if (this.closed)
          throw new Kd();
        if (this.isStopped || this.hasError)
          var u = kb.EMPTY;
        else
          this.observers.push(t), u = new ur(this, t);
        if (s && t.add(t = new yr(t, s)), a)
          for (a = 0; a < o && !t.closed; a++)
            t.next(n[a]);
        else
          for (a = 0; a < o && !t.closed; a++)
            t.next(n[a].value);
        return this.hasError ? t.error(this.thrownError) : this.isStopped && t.complete(), u;
      }, e.prototype._getNow = function() {
        return (this.scheduler || Kg).now();
      }, e.prototype._trimBufferThenGetEvents = function() {
        for (var t = this._getNow(), a = this._bufferSize, n = this._windowTime, s = this._events, o = s.length, u = 0; u < o && !(t - s[u].time < n); )
          u++;
        return o > a && (u = Math.max(u, o - a)), 0 < u && s.splice(0, u), s;
      }, e;
    }(nb), FA = function(r, e) {
      this.time = r, this.value = e;
    }, Qf = function(r) {
      function e() {
        var t = r !== null && r.apply(this, arguments) || this;
        return t.value = null, t.hasNext = !1, t.hasCompleted = !1, t;
      }
      return da(e, r), e.prototype._subscribe = function(t) {
        return this.hasError ? (t.error(this.thrownError), kb.EMPTY) : this.hasCompleted && this.hasNext ? (t.next(this.value), t.complete(), kb.EMPTY) : r.prototype._subscribe.call(this, t);
      }, e.prototype.next = function(t) {
        this.hasCompleted || (this.value = t, this.hasNext = !0);
      }, e.prototype.error = function(t) {
        this.hasCompleted || r.prototype.error.call(this, t);
      }, e.prototype.complete = function() {
        this.hasCompleted = !0, this.hasNext && r.prototype.next.call(this, this.value), r.prototype.complete.call(this);
      }, e;
    }(nb), GA = 1, HA = Promise.resolve(), Vi = {}, zr = { setImmediate: function(r) {
      var e = GA++;
      return Vi[e] = !0, HA.then(function() {
        return an(e) && r();
      }), e;
    }, clearImmediate: function(r) {
      an(r);
    } }, IA = function(r) {
      function e(t, a) {
        var n = r.call(this, t, a) || this;
        return n.scheduler = t, n.work = a, n;
      }
      return da(e, r), e.prototype.requestAsyncId = function(t, a, n) {
        return n === void 0 && (n = 0), n !== null && 0 < n ? r.prototype.requestAsyncId.call(this, t, a, n) : (t.actions.push(this), t.scheduled || (t.scheduled = zr.setImmediate(t.flush.bind(t, null))));
      }, e.prototype.recycleAsyncId = function(t, a, n) {
        if (n === void 0 && (n = 0), n !== null && 0 < n || n === null && 0 < this.delay)
          return r.prototype.recycleAsyncId.call(this, t, a, n);
        t.actions.length === 0 && (zr.clearImmediate(a), t.scheduled = void 0);
      }, e;
    }(Ig), ej = new (function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      return da(e, r), e.prototype.flush = function(t) {
        this.active = !0, this.scheduled = void 0;
        var a, n = this.actions, s = -1, o = n.length;
        t = t || n.shift();
        do
          if (a = t.execute(t.state, t.delay))
            break;
        while (++s < o && (t = n.shift()));
        if (this.active = !1, a) {
          for (; ++s < o && (t = n.shift()); )
            t.unsubscribe();
          throw a;
        }
      }, e;
    }(Jg))(IA), JA = ej, tl = new Jg(Ig), xd = tl, KA = function(r) {
      function e(t, a) {
        var n = r.call(this, t, a) || this;
        return n.scheduler = t, n.work = a, n;
      }
      return da(e, r), e.prototype.requestAsyncId = function(t, a, n) {
        return n === void 0 && (n = 0), n !== null && 0 < n ? r.prototype.requestAsyncId.call(this, t, a, n) : (t.actions.push(this), t.scheduled || (t.scheduled = requestAnimationFrame(function() {
          return t.flush(null);
        })));
      }, e.prototype.recycleAsyncId = function(t, a, n) {
        if (n === void 0 && (n = 0), n !== null && 0 < n || n === null && 0 < this.delay)
          return r.prototype.recycleAsyncId.call(this, t, a, n);
        t.actions.length === 0 && (cancelAnimationFrame(a), t.scheduled = void 0);
      }, e;
    }(Ig), Ar = new (function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      return da(e, r), e.prototype.flush = function(t) {
        this.active = !0, this.scheduled = void 0;
        var a, n = this.actions, s = -1, o = n.length;
        t = t || n.shift();
        do
          if (a = t.execute(t.state, t.delay))
            break;
        while (++s < o && (t = n.shift()));
        if (this.active = !1, a) {
          for (; ++s < o && (t = n.shift()); )
            t.unsubscribe();
          throw a;
        }
      }, e;
    }(Jg))(KA), LA = function(r) {
      function e(t, a) {
        t === void 0 && (t = Br), a === void 0 && (a = Number.POSITIVE_INFINITY);
        var n = r.call(this, t, function() {
          return n.frame;
        }) || this;
        return n.maxFrames = a, n.frame = 0, n.index = -1, n;
      }
      return da(e, r), e.prototype.flush = function() {
        for (var t, a, n = this.actions, s = this.maxFrames; (a = n[0]) && a.delay <= s && (n.shift(), this.frame = a.delay, !(t = a.execute(a.state, a.delay))); )
          ;
        if (t) {
          for (; a = n.shift(); )
            a.unsubscribe();
          throw t;
        }
      }, e.frameTimeFactor = 10, e;
    }(Jg), Br = function(r) {
      function e(t, a, n) {
        n === void 0 && (n = t.index += 1);
        var s = r.call(this, t, a) || this;
        return s.scheduler = t, s.work = a, s.index = n, s.active = !0, s.index = t.index = n, s;
      }
      return da(e, r), e.prototype.schedule = function(t, a) {
        if (a === void 0 && (a = 0), !this.id)
          return r.prototype.schedule.call(this, t, a);
        this.active = !1;
        var n = new e(this.scheduler, this.work);
        return this.add(n), n.schedule(t, a);
      }, e.prototype.requestAsyncId = function(t, a, n) {
        return n === void 0 && (n = 0), this.delay = t.frame + n, (t = t.actions).push(this), t.sort(e.sortActions), !0;
      }, e.prototype.recycleAsyncId = function(t, a, n) {
      }, e.prototype._execute = function(t, a) {
        if (this.active === !0)
          return r.prototype._execute.call(this, t, a);
      }, e.sortActions = function(t, a) {
        return t.delay === a.delay ? t.index === a.index ? 0 : t.index > a.index ? 1 : -1 : t.delay > a.delay ? 1 : -1;
      }, e;
    }(Ig), ul = function() {
      function r() {
        return Error.call(this), this.message = "argument out of range", this.name = "ArgumentOutOfRangeError", this;
      }
      return r.prototype = Object.create(Error.prototype), r;
    }(), bh = function() {
      function r() {
        return Error.call(this), this.message = "no elements in sequence", this.name = "EmptyError", this;
      }
      return r.prototype = Object.create(Error.prototype), r;
    }(), Pb = function() {
      function r() {
        return Error.call(this), this.message = "Timeout has occurred", this.name = "TimeoutError", this;
      }
      return r.prototype = Object.create(Error.prototype), r;
    }(), uu = function() {
      function r(e, t) {
        this.project = e, this.thisArg = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new MA(e, this.project, this.thisArg));
      }, r;
    }(), MA = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).project = a, t.count = 0, t.thisArg = n || t, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        try {
          var a = this.project.call(this.thisArg, t, this.count++);
        } catch (n) {
          return void this.destination.error(n);
        }
        this.destination.next(a);
      }, e;
    }(za), vl = function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      return da(e, r), e.prototype.notifyNext = function(t, a, n, s, o) {
        this.destination.next(a);
      }, e.prototype.notifyError = function(t, a) {
        this.destination.error(t);
      }, e.prototype.notifyComplete = function(t) {
        this.destination.complete();
      }, e;
    }(za), zu = function(r) {
      function e(t, a, n) {
        var s = r.call(this) || this;
        return s.parent = t, s.outerValue = a, s.outerIndex = n, s.index = 0, s;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.parent.notifyNext(this.outerValue, t, this.outerIndex, this.index++, this);
      }, e.prototype._error = function(t) {
        this.parent.notifyError(t, this), this.unsubscribe();
      }, e.prototype._complete = function() {
        this.parent.notifyComplete(this), this.unsubscribe();
      }, e;
    }(za), NA = function(r) {
      return function(e) {
        return r.then(function(t) {
          e.closed || (e.next(t), e.complete());
        }, function(t) {
          return e.error(t);
        }).then(null, Me), e;
      };
    }, vd = typeof Symbol == "function" && Symbol.iterator ? Symbol.iterator : "@@iterator", OA = function(r) {
      return function(e) {
        for (var t = r[vd](); ; ) {
          var a = void 0;
          try {
            a = t.next();
          } catch (n) {
            return e.error(n), e;
          }
          if (a.done) {
            e.complete();
            break;
          }
          if (e.next(a.value), e.closed)
            break;
        }
        return typeof t.return == "function" && e.add(function() {
          t.return && t.return();
        }), e;
      };
    }, PA = function(r) {
      return function(e) {
        var t = r[Ne]();
        if (typeof t.subscribe != "function")
          throw new TypeError("Provided object does not correctly implement Symbol.observable");
        return t.subscribe(e);
      };
    }, gn = function(r) {
      return r && typeof r.length == "number" && typeof r != "function";
    }, Rf = function(r) {
      if (r && typeof r[Ne] == "function")
        return PA(r);
      if (gn(r))
        return $m(r);
      if (en(r))
        return NA(r);
      if (r && typeof r[vd] == "function")
        return OA(r);
      throw r = Ri(r) ? "an invalid object" : "'" + r + "'", new TypeError("You provided " + r + " where a stream was expected. You can provide an Observable, Promise, Array, or Iterable.");
    }, Cr = {}, RA = function() {
      function r(e) {
        this.resultSelector = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new QA(e, this.resultSelector));
      }, r;
    }(), QA = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).resultSelector = a, t.active = 0, t.values = [], t.observables = [], t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.values.push(Cr), this.observables.push(t);
      }, e.prototype._complete = function() {
        var t = this.observables, a = t.length;
        if (a === 0)
          this.destination.complete();
        else {
          this.toRespond = this.active = a;
          for (var n = 0; n < a; n++)
            this.add(Wi(this, t[n], void 0, n));
        }
      }, e.prototype.notifyComplete = function(t) {
        --this.active == 0 && this.destination.complete();
      }, e.prototype.notifyNext = function(t, a, n) {
        var s = (t = this.values)[n];
        s = this.toRespond ? s === Cr ? --this.toRespond : this.toRespond : 0, t[n] = a, s === 0 && (this.resultSelector ? this._tryResultSelector(t) : this.destination.next(t.slice()));
      }, e.prototype._tryResultSelector = function(t) {
        try {
          var a = this.resultSelector.apply(this, t);
        } catch (n) {
          return void this.destination.error(n);
        }
        this.destination.next(a);
      }, e;
    }(vl), id = function(r) {
      function e(t) {
        var a = r.call(this) || this;
        return a.parent = t, a;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.parent.notifyNext(t);
      }, e.prototype._error = function(t) {
        this.parent.notifyError(t), this.unsubscribe();
      }, e.prototype._complete = function() {
        this.parent.notifyComplete(), this.unsubscribe();
      }, e;
    }(za);
    (function(r) {
      function e(t, a, n) {
        var s = r.call(this) || this;
        return s.parent = t, s.outerValue = a, s.outerIndex = n, s;
      }
      da(e, r), e.prototype._next = function(t) {
        this.parent.notifyNext(this.outerValue, t, this.outerIndex, this);
      }, e.prototype._error = function(t) {
        this.parent.notifyError(t), this.unsubscribe();
      }, e.prototype._complete = function() {
        this.parent.notifyComplete(this), this.unsubscribe();
      };
    })(za);
    var jd = function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      return da(e, r), e.prototype.notifyNext = function(t) {
        this.destination.next(t);
      }, e.prototype.notifyError = function(t) {
        this.destination.error(t);
      }, e.prototype.notifyComplete = function() {
        this.destination.complete();
      }, e;
    }(za);
    (function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      da(e, r), e.prototype.notifyNext = function(t, a, n, s) {
        this.destination.next(a);
      }, e.prototype.notifyError = function(t) {
        this.destination.error(t);
      }, e.prototype.notifyComplete = function(t) {
        this.destination.complete();
      };
    })(za);
    var Du = function() {
      function r(e, t) {
        t === void 0 && (t = Number.POSITIVE_INFINITY), this.project = e, this.concurrent = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new SA(e, this.project, this.concurrent));
      }, r;
    }(), SA = function(r) {
      function e(t, a, n) {
        return n === void 0 && (n = Number.POSITIVE_INFINITY), (t = r.call(this, t) || this).project = a, t.concurrent = n, t.hasCompleted = !1, t.buffer = [], t.active = 0, t.index = 0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.active < this.concurrent ? this._tryNext(t) : this.buffer.push(t);
      }, e.prototype._tryNext = function(t) {
        var a = this.index++;
        try {
          var n = this.project(t, a);
        } catch (s) {
          return void this.destination.error(s);
        }
        this.active++, this._innerSub(n);
      }, e.prototype._innerSub = function(t) {
        var a = new id(this), n = this.destination;
        n.add(a), (t = Yc(t, a)) !== a && n.add(t);
      }, e.prototype._complete = function() {
        this.hasCompleted = !0, this.active === 0 && this.buffer.length === 0 && this.destination.complete(), this.unsubscribe();
      }, e.prototype.notifyNext = function(t) {
        this.destination.next(t);
      }, e.prototype.notifyComplete = function() {
        var t = this.buffer;
        this.active--, 0 < t.length ? this._next(t.shift()) : this.active === 0 && this.hasCompleted && this.destination.complete();
      }, e;
    }(jd), wl = Q.parseFloat, Dr = -1 / 0 != 1 / wl(`	
\v\f\r \xA0\u1680\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF-0`) ? function(r) {
      r = Ij(String(r));
      var e = wl(r);
      return e === 0 && r.charAt(0) == "-" ? -0 : e;
    } : wl;
    ba({ global: !0, forced: parseFloat != Dr }, { parseFloat: Dr });
    var xl = new ra(Cc), Iu = function() {
      function r(e, t) {
        this.predicate = e, this.thisArg = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new TA(e, this.predicate, this.thisArg));
      }, r;
    }(), TA = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).predicate = a, t.thisArg = n, t.count = 0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        try {
          var a = this.predicate.call(this.thisArg, t, this.count++);
        } catch (n) {
          return void this.destination.error(n);
        }
        a && this.destination.next(t);
      }, e;
    }(za), Ju = function() {
      function r() {
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new UA(e));
      }, r;
    }(), UA = function(r) {
      function e(t) {
        return (t = r.call(this, t) || this).hasFirst = !1, t.observables = [], t.subscriptions = [], t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.observables.push(t);
      }, e.prototype._complete = function() {
        var t = this.observables, a = t.length;
        if (a === 0)
          this.destination.complete();
        else {
          for (var n = 0; n < a && !this.hasFirst; n++) {
            var s = Wi(this, t[n], void 0, n);
            this.subscriptions && this.subscriptions.push(s), this.add(s);
          }
          this.observables = null;
        }
      }, e.prototype.notifyNext = function(t, a, n) {
        if (!this.hasFirst) {
          for (this.hasFirst = !0, t = 0; t < this.subscriptions.length; t++)
            if (t !== n) {
              var s = this.subscriptions[t];
              s.unsubscribe(), this.remove(s);
            }
          this.subscriptions = null;
        }
        this.destination.next(a);
      }, e;
    }(vl), Mu = function() {
      function r(e) {
        this.resultSelector = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new VA(e, this.resultSelector));
      }, r;
    }(), VA = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).resultSelector = a, t.iterators = [], t.active = 0, t.resultSelector = typeof a == "function" ? a : void 0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        var a = this.iterators;
        cc(t) ? a.push(new WA(t)) : typeof t[vd] == "function" ? a.push(new XA(t[vd]())) : a.push(new YA(this.destination, this, t));
      }, e.prototype._complete = function() {
        var t = this.iterators, a = t.length;
        if (this.unsubscribe(), a === 0)
          this.destination.complete();
        else {
          this.active = a;
          for (var n = 0; n < a; n++) {
            var s = t[n];
            s.stillUnsubscribed ? this.destination.add(s.subscribe()) : this.active--;
          }
        }
      }, e.prototype.notifyInactive = function() {
        this.active--, this.active === 0 && this.destination.complete();
      }, e.prototype.checkIterators = function() {
        for (var t = this.iterators, a = t.length, n = this.destination, s = 0; s < a; s++) {
          var o = t[s];
          if (typeof o.hasValue == "function" && !o.hasValue())
            return;
        }
        var u = !1, l = [];
        for (s = 0; s < a; s++) {
          var f = (o = t[s]).next();
          if (o.hasCompleted() && (u = !0), f.done)
            return void n.complete();
          l.push(f.value);
        }
        this.resultSelector ? this._tryresultSelector(l) : n.next(l), u && n.complete();
      }, e.prototype._tryresultSelector = function(t) {
        try {
          var a = this.resultSelector.apply(this, t);
        } catch (n) {
          return void this.destination.error(n);
        }
        this.destination.next(a);
      }, e;
    }(za), XA = function() {
      function r(e) {
        this.iterator = e, this.nextResult = e.next();
      }
      return r.prototype.hasValue = function() {
        return !0;
      }, r.prototype.next = function() {
        var e = this.nextResult;
        return this.nextResult = this.iterator.next(), e;
      }, r.prototype.hasCompleted = function() {
        var e = this.nextResult;
        return !(!e || !e.done);
      }, r;
    }(), WA = function() {
      function r(e) {
        this.array = e, this.length = this.index = 0, this.length = e.length;
      }
      return r.prototype[vd] = function() {
        return this;
      }, r.prototype.next = function(e) {
        e = this.index++;
        var t = this.array;
        return e < this.length ? { value: t[e], done: !1 } : { value: null, done: !0 };
      }, r.prototype.hasValue = function() {
        return this.array.length > this.index;
      }, r.prototype.hasCompleted = function() {
        return this.array.length === this.index;
      }, r;
    }(), YA = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).parent = a, t.observable = n, t.stillUnsubscribed = !0, t.buffer = [], t.isComplete = !1, t;
      }
      return da(e, r), e.prototype[vd] = function() {
        return this;
      }, e.prototype.next = function() {
        var t = this.buffer;
        return t.length === 0 && this.isComplete ? { value: null, done: !0 } : { value: t.shift(), done: !1 };
      }, e.prototype.hasValue = function() {
        return 0 < this.buffer.length;
      }, e.prototype.hasCompleted = function() {
        return this.buffer.length === 0 && this.isComplete;
      }, e.prototype.notifyComplete = function() {
        0 < this.buffer.length ? (this.isComplete = !0, this.parent.notifyInactive()) : this.destination.complete();
      }, e.prototype.notifyNext = function(t) {
        this.buffer.push(t), this.parent.checkIterators();
      }, e.prototype.subscribe = function() {
        return Yc(this.observable, new id(this));
      }, e;
    }(jd), ZA = Object.freeze({ __proto__: null, Observable: ra, ConnectableObservable: xr, GroupedObservable: ql, observable: Ne, Subject: nb, BehaviorSubject: CA, ReplaySubject: Qe, AsyncSubject: Qf, asap: JA, asapScheduler: ej, async: xd, asyncScheduler: tl, queue: Kg, queueScheduler: Kg, animationFrame: Ar, animationFrameScheduler: Ar, VirtualTimeScheduler: LA, VirtualAction: Br, Scheduler: rl, Subscription: kb, Subscriber: za, Notification: vf, get NotificationKind() {
      return sl;
    }, pipe: Ti, noop: Cc, identity: td, isObservable: function(r) {
      return !!r && (r instanceof ra || typeof r.lift == "function" && typeof r.subscribe == "function");
    }, ArgumentOutOfRangeError: ul, EmptyError: bh, ObjectUnsubscribedError: Kd, UnsubscriptionError: Nf, TimeoutError: Pb, bindCallback: bn, bindNodeCallback: cn, combineLatest: function() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      var t = e = void 0;
      return ud(r[r.length - 1]) && (t = r.pop()), typeof r[r.length - 1] == "function" && (e = r.pop()), r.length === 1 && cc(r[0]) && (r = r[0]), Pf(r, t).lift(new RA(e));
    }, concat: hn, defer: wd, empty: Of, forkJoin: function() {
      for (var r = [], e = 0; e < arguments.length; e++)
        r[e] = arguments[e];
      if (r.length === 1) {
        var t = r[0];
        if (cc(t))
          return ah(t, null);
        if (Ri(t) && Object.getPrototypeOf(t) === Object.prototype)
          return ah((r = Object.keys(t)).map(function(n) {
            return t[n];
          }), r);
      }
      if (typeof r[r.length - 1] == "function") {
        var a = r.pop();
        return ah(r = r.length === 1 && cc(r[0]) ? r[0] : r, null).pipe(Da(function(n) {
          return a.apply(void 0, n);
        }));
      }
      return ah(r, null);
    }, from: Dc, fromEvent: Gb, fromEventPattern: kn, generate: function(r, e, t, a, n) {
      if (arguments.length == 1) {
        var s = r.initialState;
        e = r.condition, t = r.iterate;
        var o = r.resultSelector || td;
        n = r.scheduler;
      } else
        a === void 0 || ud(a) ? (s = r, o = td, n = a) : (s = r, o = a);
      return new ra(function(u) {
        var l = s;
        if (n)
          return n.schedule(Eu, 0, { subscriber: u, iterate: t, condition: e, resultSelector: o, state: l });
        for (; ; ) {
          if (e) {
            var f = void 0;
            try {
              f = e(l);
            } catch (d) {
              u.error(d);
              break;
            }
            if (!f) {
              u.complete();
              break;
            }
          }
          f = void 0;
          try {
            f = o(l);
          } catch (d) {
            u.error(d);
            break;
          }
          if (u.next(f), u.closed)
            break;
          try {
            l = t(l);
          } catch (d) {
            u.error(d);
            break;
          }
        }
      });
    }, iif: function(r, e, t) {
      return e === void 0 && (e = Nb), t === void 0 && (t = Nb), wd(function() {
        return r() ? e : t;
      });
    }, interval: ln, merge: Ec, never: function() {
      return xl;
    }, of: wb, onErrorResumeNext: Yi, pairs: function(r, e) {
      return new ra(e ? function(t) {
        var a = Object.keys(r), n = new kb();
        return n.add(e.schedule(Gu, 0, { keys: a, index: 0, subscriber: t, subscription: n, obj: r })), n;
      } : function(t) {
        for (var a = Object.keys(r), n = 0; n < a.length && !t.closed; n++) {
          var s = a[n];
          r.hasOwnProperty(s) && t.next([s, r[s]]);
        }
        t.complete();
      });
    }, partition: function(r, e, t) {
      return [Ob(e, t)(new ra(Rf(r))), Ob(Hu(e, t))(new ra(Rf(r)))];
    }, race: ab, range: function(r, e, t) {
      return r === void 0 && (r = 0), new ra(function(a) {
        e === void 0 && (e = r, r = 0);
        var n = 0, s = r;
        if (t)
          return t.schedule(Ku, 0, { index: n, count: e, start: r, subscriber: a });
        for (; ; ) {
          if (n++ >= e) {
            a.complete();
            break;
          }
          if (a.next(s++), a.closed)
            break;
        }
      });
    }, throwError: pa, timer: Zc, using: function(r, e) {
      return new ra(function(t) {
        try {
          var a = r();
        } catch (o) {
          return void t.error(o);
        }
        try {
          var n = e(a);
        } catch (o) {
          return void t.error(o);
        }
        var s = (n ? Dc(n) : Nb).subscribe(t);
        return function() {
          s.unsubscribe(), a && a.unsubscribe();
        };
      });
    }, zip: Zi, scheduled: fn, EMPTY: Nb, NEVER: xl, config: bc }), Nu = function() {
      function r(e) {
        this.selector = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new $A(e, this.selector, this.caught));
      }, r;
    }(), $A = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).selector = a, t.caught = n, t;
      }
      return da(e, r), e.prototype.error = function(t) {
        if (!this.isStopped) {
          var a = void 0;
          try {
            a = this.selector(t, this.caught);
          } catch (n) {
            return void r.prototype.error.call(this, n);
          }
          this._unsubscribeAndRecycle(), t = new id(this), this.add(t), (a = Yc(a, t)) !== t && this.add(a);
        }
      }, e;
    }(jd), Ou = function() {
      function r(e) {
        this.defaultValue = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new aB(e, this.defaultValue));
      }, r;
    }(), aB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).defaultValue = a, t.isEmpty = !0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.isEmpty = !1, this.destination.next(t);
      }, e.prototype._complete = function() {
        this.isEmpty && this.destination.next(this.defaultValue), this.destination.complete();
      }, e;
    }(za), Pu = function() {
      function r(e, t) {
        this.delay = e, this.scheduler = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new bB(e, this.delay, this.scheduler));
      }, r;
    }(), bB = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).delay = a, t.scheduler = n, t.queue = [], t.active = !1, t.errored = !1, t;
      }
      return da(e, r), e.dispatch = function(t) {
        for (var a = t.source, n = a.queue, s = t.scheduler, o = t.destination; 0 < n.length && 0 >= n[0].time - s.now(); )
          n.shift().notification.observe(o);
        0 < n.length ? (a = Math.max(0, n[0].time - s.now()), this.schedule(t, a)) : (this.unsubscribe(), a.active = !1);
      }, e.prototype._schedule = function(t) {
        this.active = !0, this.destination.add(t.schedule(e.dispatch, this.delay, { source: this, destination: this.destination, scheduler: t }));
      }, e.prototype.scheduleNotification = function(t) {
        if (this.errored !== !0) {
          var a = this.scheduler;
          t = new cB(a.now() + this.delay, t), this.queue.push(t), this.active === !1 && this._schedule(a);
        }
      }, e.prototype._next = function(t) {
        this.scheduleNotification(vf.createNext(t));
      }, e.prototype._error = function(t) {
        this.errored = !0, this.queue = [], this.destination.error(t), this.unsubscribe();
      }, e.prototype._complete = function() {
        this.scheduleNotification(vf.createComplete()), this.unsubscribe();
      }, e;
    }(za), cB = function(r, e) {
      this.time = r, this.notification = e;
    }, Qu = function() {
      function r(e, t) {
        this.keySelector = e, this.flushes = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new dB(e, this.keySelector, this.flushes));
      }, r;
    }(), dB = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).keySelector = a, t.values = /* @__PURE__ */ new Set(), n && t.add(Yc(n, new id(t))), t;
      }
      return da(e, r), e.prototype.notifyNext = function() {
        this.values.clear();
      }, e.prototype.notifyError = function(t) {
        this._error(t);
      }, e.prototype._next = function(t) {
        this.keySelector ? this._useKeySelector(t) : this._finalizeNext(t, t);
      }, e.prototype._useKeySelector = function(t) {
        var a = this.destination;
        try {
          var n = this.keySelector(t);
        } catch (s) {
          return void a.error(s);
        }
        this._finalizeNext(n, t);
      }, e.prototype._finalizeNext = function(t, a) {
        var n = this.values;
        n.has(t) || (n.add(t), this.destination.next(a));
      }, e;
    }(jd), Su = function() {
      function r(e) {
        this.errorFactory = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new eB(e, this.errorFactory));
      }, r;
    }(), eB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).errorFactory = a, t.hasValue = !1, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.hasValue = !0, this.destination.next(t);
      }, e.prototype._complete = function() {
        if (this.hasValue)
          return this.destination.complete();
        var t = void 0;
        try {
          t = this.errorFactory();
        } catch (a) {
          t = a;
        }
        this.destination.error(t);
      }, e;
    }(za), Tu = function() {
      function r(e) {
        if (this.total = e, 0 > this.total)
          throw new ul();
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new fB(e, this.total));
      }, r;
    }(), fB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).total = a, t.count = 0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        var a = this.total, n = ++this.count;
        n <= a && (this.destination.next(t), n === a && (this.destination.complete(), this.unsubscribe()));
      }, e;
    }(za), Uu = function() {
      function r(e) {
        this.callback = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new gB(e, this.callback));
      }, r;
    }(), gB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).add(new kb(a)), t;
      }
      return da(e, r), e;
    }(za), Wu = function() {
      function r() {
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new hB(e));
      }, r;
    }(), hB = function(r) {
      function e() {
        return r !== null && r.apply(this, arguments) || this;
      }
      return da(e, r), e.prototype._next = function(t) {
      }, e;
    }(za), Xu = function() {
      function r(e) {
        if (this.total = e, 0 > this.total)
          throw new ul();
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new iB(e, this.total));
      }, r;
    }(), iB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).total = a, t.ring = [], t.count = 0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        var a = this.ring, n = this.total, s = this.count++;
        a.length < n ? a.push(t) : a[s % n] = t;
      }, e.prototype._complete = function() {
        var t = this.destination, a = this.count;
        if (0 < a)
          for (var n = this.count >= this.total ? this.total : this.count, s = this.ring, o = 0; o < n; o++) {
            var u = a++ % n;
            t.next(s[u]);
          }
        t.complete();
      }, e;
    }(za), Yu = function() {
      function r(e) {
        this.value = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new jB(e, this.value));
      }, r;
    }(), jB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).value = a, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.destination.next(this.value);
      }, e;
    }(za), Zu = function() {
      function r(e, t, a) {
        a === void 0 && (a = !1), this.accumulator = e, this.seed = t, this.hasSeed = a;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new kB(e, this.accumulator, this.seed, this.hasSeed));
      }, r;
    }(), kB = function(r) {
      function e(t, a, n, s) {
        return (t = r.call(this, t) || this).accumulator = a, t._seed = n, t.hasSeed = s, t.index = 0, t;
      }
      return da(e, r), Object.defineProperty(e.prototype, "seed", { get: function() {
        return this._seed;
      }, set: function(t) {
        this.hasSeed = !0, this._seed = t;
      }, enumerable: !0, configurable: !0 }), e.prototype._next = function(t) {
        if (this.hasSeed)
          return this._tryNext(t);
        this.seed = t, this.destination.next(t);
      }, e.prototype._tryNext = function(t) {
        var a = this.index++;
        try {
          var n = this.accumulator(this.seed, t, a);
        } catch (s) {
          this.destination.error(s);
        }
        this.seed = n, this.destination.next(n);
      }, e;
    }(za), av = function() {
      function r(e, t) {
        this.subjectFactory = e, this.selector = t;
      }
      return r.prototype.call = function(e, t) {
        var a = this.selector, n = this.subjectFactory();
        return (e = a(n).subscribe(e)).add(t.subscribe(n)), e;
      }, r;
    }(), cv = function() {
      function r(e, t) {
        this.notifier = e, this.source = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new lB(e, this.notifier, this.source));
      }, r;
    }(), lB = function(r) {
      function e(t, a, n) {
        return (t = r.call(this, t) || this).notifier = a, t.source = n, t;
      }
      return da(e, r), e.prototype.error = function(t) {
        if (!this.isStopped) {
          var a = this.errors, n = this.retries, s = this.retriesSubscription;
          if (n)
            this.retriesSubscription = this.errors = void 0;
          else {
            a = new nb();
            try {
              n = (0, this.notifier)(a);
            } catch (o) {
              return r.prototype.error.call(this, o);
            }
            s = Yc(n, new id(this));
          }
          this._unsubscribeAndRecycle(), this.errors = a, this.retries = n, this.retriesSubscription = s, a.next(t);
        }
      }, e.prototype._unsubscribe = function() {
        var t = this.errors, a = this.retriesSubscription;
        t && (t.unsubscribe(), this.errors = void 0), a && (a.unsubscribe(), this.retriesSubscription = void 0), this.retries = void 0;
      }, e.prototype.notifyNext = function() {
        var t = this._unsubscribe;
        this._unsubscribe = null, this._unsubscribeAndRecycle(), this._unsubscribe = t, this.source.subscribe(this);
      }, e;
    }(jd), fv = function() {
      function r(e) {
        this.project = e;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new mB(e, this.project));
      }, r;
    }(), mB = function(r) {
      function e(t, a) {
        return (t = r.call(this, t) || this).project = a, t.index = 0, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        var a = this.index++;
        try {
          var n = this.project(t, a);
        } catch (s) {
          return void this.destination.error(s);
        }
        this._innerSub(n);
      }, e.prototype._innerSub = function(t) {
        var a = this.innerSubscription;
        a && a.unsubscribe(), a = new id(this);
        var n = this.destination;
        n.add(a), this.innerSubscription = Yc(t, a), this.innerSubscription !== a && n.add(this.innerSubscription);
      }, e.prototype._complete = function() {
        var t = this.innerSubscription;
        t && !t.closed || r.prototype._complete.call(this), this.unsubscribe();
      }, e.prototype._unsubscribe = function() {
        this.innerSubscription = void 0;
      }, e.prototype.notifyComplete = function() {
        this.innerSubscription = void 0, this.isStopped && r.prototype._complete.call(this);
      }, e.prototype.notifyNext = function(t) {
        this.destination.next(t);
      }, e;
    }(jd), gv = function() {
      function r(e) {
        this.notifier = e;
      }
      return r.prototype.call = function(e, t) {
        e = new nB(e);
        var a = Yc(this.notifier, new id(e));
        return a && !e.seenValue ? (e.add(a), t.subscribe(e)) : e;
      }, r;
    }(), nB = function(r) {
      function e(t) {
        return (t = r.call(this, t) || this).seenValue = !1, t;
      }
      return da(e, r), e.prototype.notifyNext = function() {
        this.seenValue = !0, this.complete();
      }, e.prototype.notifyComplete = function() {
      }, e;
    }(jd), hv = function() {
      function r(e, t, a) {
        this.nextOrObserver = e, this.error = t, this.complete = a;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new oB(e, this.nextOrObserver, this.error, this.complete));
      }, r;
    }(), oB = function(r) {
      function e(t, a, n, s) {
        return (t = r.call(this, t) || this)._tapNext = Cc, t._tapError = Cc, t._tapComplete = Cc, t._tapError = n || Cc, t._tapComplete = s || Cc, Le(a) ? (t._context = t, t._tapNext = a) : a && (t._context = a, t._tapNext = a.next || Cc, t._tapError = a.error || Cc, t._tapComplete = a.complete || Cc), t;
      }
      return da(e, r), e.prototype._next = function(t) {
        try {
          this._tapNext.call(this._context, t);
        } catch (a) {
          return void this.destination.error(a);
        }
        this.destination.next(t);
      }, e.prototype._error = function(t) {
        try {
          this._tapError.call(this._context, t);
        } catch (a) {
          return void this.destination.error(a);
        }
        this.destination.error(t);
      }, e.prototype._complete = function() {
        try {
          this._tapComplete.call(this._context);
        } catch (t) {
          return void this.destination.error(t);
        }
        return this.destination.complete();
      }, e;
    }(za), jv = { leading: !0, trailing: !1 };
    (function(r) {
      function e(t, a, n, s) {
        var o = r.call(this, t) || this;
        return o.destination = t, o.durationSelector = a, o._leading = n, o._trailing = s, o._hasValue = !1, o;
      }
      da(e, r), e.prototype._next = function(t) {
        this._hasValue = !0, this._sendValue = t, this._throttled || (this._leading ? this.send() : this.throttle(t));
      }, e.prototype.send = function() {
        var t = this._sendValue;
        this._hasValue && (this.destination.next(t), this.throttle(t)), this._hasValue = !1, this._sendValue = void 0;
      }, e.prototype.throttle = function(t) {
        (t = this.tryDurationSelector(t)) && this.add(this._throttled = Yc(t, new id(this)));
      }, e.prototype.tryDurationSelector = function(t) {
        try {
          return this.durationSelector(t);
        } catch (a) {
          return this.destination.error(a), null;
        }
      }, e.prototype.throttlingDone = function() {
        var t = this._throttled, a = this._trailing;
        t && t.unsubscribe(), this._throttled = void 0, a && this.send();
      }, e.prototype.notifyNext = function() {
        this.throttlingDone();
      }, e.prototype.notifyComplete = function() {
        this.throttlingDone();
      };
    })(jd);
    for (var kv = function() {
      function r(e, t, a, n) {
        this.duration = e, this.scheduler = t, this.leading = a, this.trailing = n;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new pB(e, this.duration, this.scheduler, this.leading, this.trailing));
      }, r;
    }(), pB = function(r) {
      function e(t, a, n, s, o) {
        return (t = r.call(this, t) || this).duration = a, t.scheduler = n, t.leading = s, t.trailing = o, t._hasTrailingValue = !1, t._trailingValue = null, t;
      }
      return da(e, r), e.prototype._next = function(t) {
        this.throttled ? this.trailing && (this._trailingValue = t, this._hasTrailingValue = !0) : (this.add(this.throttled = this.scheduler.schedule(lv, this.duration, { subscriber: this })), this.leading ? this.destination.next(t) : this.trailing && (this._trailingValue = t, this._hasTrailingValue = !0));
      }, e.prototype._complete = function() {
        this._hasTrailingValue && this.destination.next(this._trailingValue), this.destination.complete();
      }, e.prototype.clearThrottle = function() {
        var t = this.throttled;
        t && (this.trailing && this._hasTrailingValue && (this.destination.next(this._trailingValue), this._trailingValue = null, this._hasTrailingValue = !1), t.unsubscribe(), this.remove(t), this.throttled = null);
      }, e;
    }(za), nv = function() {
      function r(e, t, a, n) {
        this.waitFor = e, this.absoluteTimeout = t, this.withObservable = a, this.scheduler = n;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new qB(e, this.absoluteTimeout, this.waitFor, this.withObservable, this.scheduler));
      }, r;
    }(), qB = function(r) {
      function e(t, a, n, s, o) {
        return (t = r.call(this, t) || this).absoluteTimeout = a, t.waitFor = n, t.withObservable = s, t.scheduler = o, t.scheduleTimeout(), t;
      }
      return da(e, r), e.dispatchTimeout = function(t) {
        var a = t.withObservable;
        t._unsubscribeAndRecycle(), t.add(Yc(a, new id(t)));
      }, e.prototype.scheduleTimeout = function() {
        var t = this.action;
        t ? this.action = t.schedule(this, this.waitFor) : this.add(this.action = this.scheduler.schedule(e.dispatchTimeout, this.waitFor, this));
      }, e.prototype._next = function(t) {
        this.absoluteTimeout || this.scheduleTimeout(), r.prototype._next.call(this, t);
      }, e.prototype._unsubscribe = function() {
        this.action = void 0, this.withObservable = this.scheduler = null;
      }, e;
    }(jd), pv = function() {
      function r(e, t) {
        this.observables = e, this.project = t;
      }
      return r.prototype.call = function(e, t) {
        return t.subscribe(new rB(e, this.observables, this.project));
      }, r;
    }(), rB = function(r) {
      function e(t, a, n) {
        (t = r.call(this, t) || this).observables = a, t.project = n, t.toRespond = [], n = a.length, t.values = Array(n);
        for (var s = 0; s < n; s++)
          t.toRespond.push(s);
        for (s = 0; s < n; s++)
          t.add(Wi(t, a[s], void 0, s));
        return t;
      }
      return da(e, r), e.prototype.notifyNext = function(t, a, n) {
        this.values[n] = a, 0 < (t = this.toRespond).length && (n = t.indexOf(n)) !== -1 && t.splice(n, 1);
      }, e.prototype.notifyComplete = function() {
      }, e.prototype._next = function(t) {
        this.toRespond.length === 0 && (t = [t].concat(this.values), this.project ? this._tryProject(t) : this.destination.next(t));
      }, e.prototype._tryProject = function(t) {
        try {
          var a = this.project.apply(this, t);
        } catch (n) {
          return void this.destination.error(n);
        }
        this.destination.next(a);
      }, e;
    }(vl), Er = tb(function(r) {
      var e = typeof crypto < "u" && crypto.getRandomValues && crypto.getRandomValues.bind(crypto) || typeof msCrypto < "u" && typeof window.msCrypto.getRandomValues == "function" && msCrypto.getRandomValues.bind(msCrypto);
      if (e) {
        var t = new Uint8Array(16);
        r.exports = function() {
          return e(t), t;
        };
      } else {
        var a = Array(16);
        r.exports = function() {
          for (var n, s = 0; 16 > s; s++)
            (3 & s) == 0 && (n = 4294967296 * Math.random()), a[s] = n >>> ((3 & s) << 3) & 255;
          return a;
        };
      }
    }), ub = [], mi = 0; 256 > mi; ++mi)
      ub[mi] = (mi + 256).toString(16).substr(1);
    var Fr = function(r, e) {
      return e = e || 0, [ub[r[e++]], ub[r[e++]], ub[r[e++]], ub[r[e++]], "-", ub[r[e++]], ub[r[e++]], "-", ub[r[e++]], ub[r[e++]], "-", ub[r[e++]], ub[r[e++]], "-", ub[r[e++]], ub[r[e++]], ub[r[e++]], ub[r[e++]], ub[r[e++]], ub[r[e++]]].join("");
    }, Lg = function(r, e, t) {
      if (t = e && t || 0, typeof r == "string" && (e = r === "binary" ? Array(16) : null, r = null), (r = (r = r || {}).random || (r.rng || Er)())[6] = 15 & r[6] | 64, r[8] = 63 & r[8] | 128, e)
        for (var a = 0; 16 > a; ++a)
          e[t + a] = r[a];
      return e || Fr(r);
    }, Mg = Lg(), aj = !1, sn = new AbortController(), kd, Ld, yl, zl, Md, pe, yc, wf, ic, Al, ld, qe, md, nd, od, xf;
    (function(r) {
      r[r.ATTRIBUTE_OPERATION_ERR_FAILURE = 2] = "ATTRIBUTE_OPERATION_ERR_FAILURE", r[r.ATTRIBUTE_OPERATION_ERR_INVALID_ARGUMENT = 3] = "ATTRIBUTE_OPERATION_ERR_INVALID_ARGUMENT", r[r.ATTRIBUTE_OPERATION_ERR_SIZE_OVERFLOW = 4] = "ATTRIBUTE_OPERATION_ERR_SIZE_OVERFLOW", r[r.ATTRIBUTE_OPERATION_ERR_TOO_OFTEN = 5] = "ATTRIBUTE_OPERATION_ERR_TOO_OFTEN", r[r.ATTRIBUTE_OPERATION_ERR_USER_NOT_FOUND = 6] = "ATTRIBUTE_OPERATION_ERR_USER_NOT_FOUND", r[r.ATTRIBUTE_OPERATION_ERR_TIMEOUT = 7] = "ATTRIBUTE_OPERATION_ERR_TIMEOUT", r[r.ATTRIBUTE_OPERATION_ERR_USER_NOT_LOGGED_IN = 102] = "ATTRIBUTE_OPERATION_ERR_USER_NOT_LOGGED_IN";
    })(kd || (kd = {})), function(r) {
      r[r.CHANNEL_MESSAGE_ERR_FAILURE = 1] = "CHANNEL_MESSAGE_ERR_FAILURE", r[r.CHANNEL_MESSAGE_ERR_TIMEOUT = 2] = "CHANNEL_MESSAGE_ERR_TIMEOUT", r[r.CHANNEL_MESSAGE_ERR_TOO_OFTEN = 3] = "CHANNEL_MESSAGE_ERR_TOO_OFTEN", r[r.CHANNEL_MESSAGE_ERR_INVALID_MESSAGE = 4] = "CHANNEL_MESSAGE_ERR_INVALID_MESSAGE", r[r.CHANNEL_MESSAGE_ERR_NOT_IN_CHANNEL = 5] = "CHANNEL_MESSAGE_ERR_NOT_IN_CHANNEL", r[r.CHANNEL_MESSAGE_ERR_USER_NOT_LOGGED_IN = 102] = "CHANNEL_MESSAGE_ERR_USER_NOT_LOGGED_IN";
    }(Ld || (Ld = {})), function(r) {
      r[r.CREATE_CHANNEL_ERR_INVALID_ARGUMENT = 1] = "CREATE_CHANNEL_ERR_INVALID_ARGUMENT";
    }(yl || (yl = {})), function(r) {
      r[r.CREATE_INSTANCE_ERR_INVALID_ARGUMENT = 1] = "CREATE_INSTANCE_ERR_INVALID_ARGUMENT";
    }(zl || (zl = {})), function(r) {
      r[r.GET_MEMBERS_ERR_FAILURE = 1] = "GET_MEMBERS_ERR_FAILURE", r[r.GET_MEMBERS_ERR_REJECTED = 2] = "GET_MEMBERS_ERR_REJECTED", r[r.GET_MEMBERS_ERR_TIMEOUT = 3] = "GET_MEMBERS_ERR_TIMEOUT", r[r.GET_MEMBERS_ERR_TOO_OFTEN = 4] = "GET_MEMBERS_ERR_TOO_OFTEN", r[r.GET_MEMBERS_ERR_NOT_IN_CHANNEL = 5] = "GET_MEMBERS_ERR_NOT_IN_CHANNEL", r[r.GET_MEMBERS_ERR_USER_NOT_LOGGED_IN = 102] = "GET_MEMBERS_ERR_USER_NOT_LOGGED_IN";
    }(Md || (Md = {})), function(r) {
      r[r.INVITATION_API_CALL_ERR_INVALID_ARGUMENT = 1] = "INVITATION_API_CALL_ERR_INVALID_ARGUMENT", r[r.INVITATION_API_CALL_ERR_NOT_STARTED = 2] = "INVITATION_API_CALL_ERR_NOT_STARTED", r[r.INVITATION_API_CALL_ERR_ALREADY_END = 3] = "INVITATION_API_CALL_ERR_ALREADY_END", r[r.INVITATION_API_CALL_ERR_ALREADY_ACCEPT = 4] = "INVITATION_API_CALL_ERR_ALREADY_ACCEPT", r[r.INVITATION_API_CALL_ERR_ALREADY_SENT = 5] = "INVITATION_API_CALL_ERR_ALREADY_SENT";
    }(pe || (pe = {})), function(r) {
      r[r.JOIN_CHANNEL_ERR_FAILURE = 1] = "JOIN_CHANNEL_ERR_FAILURE", r[r.JOIN_CHANNEL_ERR_REJECTED = 2] = "JOIN_CHANNEL_ERR_REJECTED", r[r.JOIN_CHANNEL_ERR_INVALID_ARGUMENT = 3] = "JOIN_CHANNEL_ERR_INVALID_ARGUMENT", r[r.JOIN_CHANNEL_TIMEOUT = 4] = "JOIN_CHANNEL_TIMEOUT", r[r.JOIN_CHANNEL_ERR_EXCEED_LIMIT = 5] = "JOIN_CHANNEL_ERR_EXCEED_LIMIT", r[r.JOIN_CHANNEL_ERR_ALREADY_JOINED = 6] = "JOIN_CHANNEL_ERR_ALREADY_JOINED", r[r.JOIN_CHANNEL_ERR_TOO_OFTEN = 7] = "JOIN_CHANNEL_ERR_TOO_OFTEN", r[r.JOIN_CHANNEL_ERR_JOIN_SAME_CHANNEL_TOO_OFTEN = 8] = "JOIN_CHANNEL_ERR_JOIN_SAME_CHANNEL_TOO_OFTEN", r[r.JOIN_CHANNEL_ERR_USER_NOT_LOGGED_IN = 102] = "JOIN_CHANNEL_ERR_USER_NOT_LOGGED_IN", r[r.JOIN_CHANNEL_ERR_ABORTED_BY_LEAVE = 201] = "JOIN_CHANNEL_ERR_ABORTED_BY_LEAVE", r[r.JOIN_CHANNEL_ERR_ALREADY_JOINED_CHANNEL_OF_SAME_ID = 202] = "JOIN_CHANNEL_ERR_ALREADY_JOINED_CHANNEL_OF_SAME_ID";
    }(yc || (yc = {})), function(r) {
      r[r.LEAVE_CHANNEL_ERR_FAILURE = 1] = "LEAVE_CHANNEL_ERR_FAILURE", r[r.LEAVE_CHANNEL_ERR_REJECTED = 2] = "LEAVE_CHANNEL_ERR_REJECTED", r[r.LEAVE_CHANNEL_ERR_NOT_IN_CHANNEL = 3] = "LEAVE_CHANNEL_ERR_NOT_IN_CHANNEL", r[r.LEAVE_CHANNEL_ERR_USER_NOT_LOGGED_IN = 102] = "LEAVE_CHANNEL_ERR_USER_NOT_LOGGED_IN";
    }(wf || (wf = {})), function(r) {
      r[r.LOGIN_ERR_UNKNOWN = 1] = "LOGIN_ERR_UNKNOWN", r[r.LOGIN_ERR_REJECTED = 2] = "LOGIN_ERR_REJECTED", r[r.LOGIN_ERR_INVALID_ARGUMENT = 3] = "LOGIN_ERR_INVALID_ARGUMENT", r[r.LOGIN_ERR_INVALID_APP_ID = 4] = "LOGIN_ERR_INVALID_APP_ID", r[r.LOGIN_ERR_INVALID_TOKEN = 5] = "LOGIN_ERR_INVALID_TOKEN", r[r.LOGIN_ERR_TOKEN_EXPIRED = 6] = "LOGIN_ERR_TOKEN_EXPIRED", r[r.LOGIN_ERR_NOT_AUTHORIZED = 7] = "LOGIN_ERR_NOT_AUTHORIZED", r[r.LOGIN_ERR_ALREADY_LOGIN = 8] = "LOGIN_ERR_ALREADY_LOGIN", r[r.LOGIN_ERR_TIMEOUT = 9] = "LOGIN_ERR_TIMEOUT", r[r.LOGIN_ERR_TOO_OFTEN = 10] = "LOGIN_ERR_TOO_OFTEN", r[r.LOGIN_ERR_ABORTED_BY_LOGOUT = 201] = "LOGIN_ERR_ABORTED_BY_LOGOUT";
    }(ic || (ic = {})), function(r) {
      r[r.LOGOUT_ERR_USER_NOT_LOGGED_IN = 102] = "LOGOUT_ERR_USER_NOT_LOGGED_IN";
    }(Al || (Al = {})), function(r) {
      r[r.PEER_MESSAGE_ERR_FAILURE = 1] = "PEER_MESSAGE_ERR_FAILURE", r[r.PEER_MESSAGE_ERR_TIMEOUT = 2] = "PEER_MESSAGE_ERR_TIMEOUT", r[r.PEER_MESSAGE_ERR_TOO_OFTEN = 5] = "PEER_MESSAGE_ERR_TOO_OFTEN", r[r.PEER_MESSAGE_ERR_INVALID_USERID = 6] = "PEER_MESSAGE_ERR_INVALID_USERID", r[r.PEER_MESSAGE_ERR_INVALID_MESSAGE = 7] = "PEER_MESSAGE_ERR_INVALID_MESSAGE", r[r.PEER_MESSAGE_ERR_INCOMPATIBLE_MESSAGE = 8] = "PEER_MESSAGE_ERR_INCOMPATIBLE_MESSAGE", r[r.PEER_MESSAGE_ERR_USER_NOT_LOGGED_IN = 102] = "PEER_MESSAGE_ERR_USER_NOT_LOGGED_IN";
    }(ld || (ld = {})), function(r) {
      r[r.QUERY_PEERS_ONLINE_STATUS_ERR_INVALID_ARGUMENT = 2] = "QUERY_PEERS_ONLINE_STATUS_ERR_INVALID_ARGUMENT", r[r.QUERY_PEERS_ONLINE_STATUS_ERR_REJECTED = 3] = "QUERY_PEERS_ONLINE_STATUS_ERR_REJECTED", r[r.QUERY_PEERS_ONLINE_STATUS_ERR_TIMEOUT = 4] = "QUERY_PEERS_ONLINE_STATUS_ERR_TIMEOUT", r[r.QUERY_PEERS_ONLINE_STATUS_ERR_TOO_OFTEN = 5] = "QUERY_PEERS_ONLINE_STATUS_ERR_TOO_OFTEN", r[r.QUERY_PEERS_ONLINE_STATUS_ERR_USER_NOT_LOGGED_IN = 102] = "QUERY_PEERS_ONLINE_STATUS_ERR_USER_NOT_LOGGED_IN";
    }(qe || (qe = {})), function(r) {
      r[r.RENEW_TOKEN_ERR_FAILURE = 1] = "RENEW_TOKEN_ERR_FAILURE", r[r.RENEW_TOKEN_ERR_INVALID_ARGUMENT = 2] = "RENEW_TOKEN_ERR_INVALID_ARGUMENT", r[r.RENEW_TOKEN_ERR_REJECTED = 3] = "RENEW_TOKEN_ERR_REJECTED", r[r.RENEW_TOKEN_ERR_TOO_OFTEN = 4] = "RENEW_TOKEN_ERR_TOO_OFTEN", r[r.RENEW_TOKEN_ERR_TOKEN_EXPIRED = 5] = "RENEW_TOKEN_ERR_TOKEN_EXPIRED", r[r.RENEW_TOKEN_ERR_INVALID_TOKEN = 6] = "RENEW_TOKEN_ERR_INVALID_TOKEN", r[r.RENEW_TOKEN_ERR_USER_NOT_LOGGED_IN = 102] = "RENEW_TOKEN_ERR_USER_NOT_LOGGED_IN", r[r.RENEW_TOKEN_ERR_ABORTED_BY_LOGOUT = 201] = "RENEW_TOKEN_ERR_ABORTED_BY_LOGOUT";
    }(md || (md = {})), function(r) {
      r[r.GET_CHANNEL_MEMBER_COUNT_ERR_FAILURE = 1] = "GET_CHANNEL_MEMBER_COUNT_ERR_FAILURE", r[r.GET_CHANNEL_MEMBER_COUNT_ERR_INVALID_ARGUMENT = 2] = "GET_CHANNEL_MEMBER_COUNT_ERR_INVALID_ARGUMENT", r[r.GET_CHANNEL_MEMBER_COUNT_ERR_TOO_OFTEN = 3] = "GET_CHANNEL_MEMBER_COUNT_ERR_TOO_OFTEN", r[r.GET_CHANNEL_MEMBER_COUNT_ERR_TIMEOUT = 4] = "GET_CHANNEL_MEMBER_COUNT_ERR_TIMEOUT", r[r.GET_CHANNEL_MEMBER_COUNT_ERR_EXCEED_LIMIT = 5] = "GET_CHANNEL_MEMBER_COUNT_ERR_EXCEED_LIMIT", r[r.GET_CHANNEL_MEMBER_COUNT_ERR_NOT_INITIALIZED = 101] = "GET_CHANNEL_MEMBER_COUNT_ERR_NOT_INITIALIZED", r[r.GET_CHANNEL_MEMBER_COUNT_ERR_USER_NOT_LOGGED_IN = 102] = "GET_CHANNEL_MEMBER_COUNT_ERR_USER_NOT_LOGGED_IN";
    }(nd || (nd = {})), function(r) {
      r[r.PEER_SUBSCRIPTION_STATUS_ERR_FAILURE = 1] = "PEER_SUBSCRIPTION_STATUS_ERR_FAILURE", r[r.PEER_SUBSCRIPTION_STATUS_ERR_INVALID_ARGUMENT = 2] = "PEER_SUBSCRIPTION_STATUS_ERR_INVALID_ARGUMENT", r[r.PEER_SUBSCRIPTION_STATUS_ERR_REJECTED = 3] = "PEER_SUBSCRIPTION_STATUS_ERR_REJECTED", r[r.PEER_SUBSCRIPTION_STATUS_ERR_TIMEOUT = 4] = "PEER_SUBSCRIPTION_STATUS_ERR_TIMEOUT", r[r.PEER_SUBSCRIPTION_STATUS_ERR_TOO_OFTEN = 5] = "PEER_SUBSCRIPTION_STATUS_ERR_TOO_OFTEN", r[r.PEER_SUBSCRIPTION_STATUS_ERR_OVERFLOW = 6] = "PEER_SUBSCRIPTION_STATUS_ERR_OVERFLOW", r[r.PEER_SUBSCRIPTION_STATUS_ERR_USER_NOT_LOGGED_IN = 102] = "PEER_SUBSCRIPTION_STATUS_ERR_USER_NOT_LOGGED_IN";
    }(od || (od = {})), function(r) {
      r[r.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_FAILURE = 1] = "QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_FAILURE", r[r.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_TIMEOUT = 2] = "QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_TIMEOUT", r[r.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_TOO_OFTEN = 3] = "QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_TOO_OFTEN", r[r.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_USER_NOT_LOGGED_IN = 102] = "QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_USER_NOT_LOGGED_IN";
    }(xf || (xf = {}));
    var jc = kd.ATTRIBUTE_OPERATION_ERR_FAILURE, bb = kd.ATTRIBUTE_OPERATION_ERR_INVALID_ARGUMENT, Se = kd.ATTRIBUTE_OPERATION_ERR_SIZE_OVERFLOW;
    kd.ATTRIBUTE_OPERATION_ERR_TOO_OFTEN;
    var Gr = kd.ATTRIBUTE_OPERATION_ERR_USER_NOT_FOUND, kc = kd.ATTRIBUTE_OPERATION_ERR_TIMEOUT, lc = kd.ATTRIBUTE_OPERATION_ERR_USER_NOT_LOGGED_IN, ni = Ld.CHANNEL_MESSAGE_ERR_FAILURE, Bl = Ld.CHANNEL_MESSAGE_ERR_TIMEOUT, Hr = Ld.CHANNEL_MESSAGE_ERR_TOO_OFTEN, Cl = Ld.CHANNEL_MESSAGE_ERR_INVALID_MESSAGE, sB = Ld.CHANNEL_MESSAGE_ERR_NOT_IN_CHANNEL, Dl = Ld.CHANNEL_MESSAGE_ERR_USER_NOT_LOGGED_IN, tB = yl.CREATE_CHANNEL_ERR_INVALID_ARGUMENT, Ir = zl.CREATE_INSTANCE_ERR_INVALID_ARGUMENT;
    nd.GET_CHANNEL_MEMBER_COUNT_ERR_FAILURE;
    var Jr = nd.GET_CHANNEL_MEMBER_COUNT_ERR_INVALID_ARGUMENT;
    nd.GET_CHANNEL_MEMBER_COUNT_ERR_TOO_OFTEN;
    var Kr = nd.GET_CHANNEL_MEMBER_COUNT_ERR_TIMEOUT, uB = nd.GET_CHANNEL_MEMBER_COUNT_ERR_EXCEED_LIMIT;
    nd.GET_CHANNEL_MEMBER_COUNT_ERR_NOT_INITIALIZED;
    var vB = nd.GET_CHANNEL_MEMBER_COUNT_ERR_USER_NOT_LOGGED_IN, wB = Md.GET_MEMBERS_ERR_FAILURE, xB = Md.GET_MEMBERS_ERR_REJECTED;
    Md.GET_MEMBERS_ERR_TIMEOUT, Md.GET_MEMBERS_ERR_TOO_OFTEN;
    var yB = Md.GET_MEMBERS_ERR_NOT_IN_CHANNEL, zB = Md.GET_MEMBERS_ERR_USER_NOT_LOGGED_IN, Tc = pe.INVITATION_API_CALL_ERR_INVALID_ARGUMENT, AB = pe.INVITATION_API_CALL_ERR_NOT_STARTED, oi = pe.INVITATION_API_CALL_ERR_ALREADY_END, Lr = pe.INVITATION_API_CALL_ERR_ALREADY_ACCEPT, BB = pe.INVITATION_API_CALL_ERR_ALREADY_SENT, Mr = yc.JOIN_CHANNEL_ERR_FAILURE;
    yc.JOIN_CHANNEL_ERR_REJECTED;
    var CB = yc.JOIN_CHANNEL_ERR_INVALID_ARGUMENT, Nr = yc.JOIN_CHANNEL_TIMEOUT, Or = yc.JOIN_CHANNEL_ERR_EXCEED_LIMIT, Pr = yc.JOIN_CHANNEL_ERR_ALREADY_JOINED;
    yc.JOIN_CHANNEL_ERR_TOO_OFTEN;
    var Qr = yc.JOIN_CHANNEL_ERR_USER_NOT_LOGGED_IN, Rr = yc.JOIN_CHANNEL_ERR_ALREADY_JOINED_CHANNEL_OF_SAME_ID, Sr = wf.LEAVE_CHANNEL_ERR_FAILURE, Tr = wf.LEAVE_CHANNEL_ERR_REJECTED, DB = wf.LEAVE_CHANNEL_ERR_NOT_IN_CHANNEL, EB = wf.LEAVE_CHANNEL_ERR_USER_NOT_LOGGED_IN, Ur = ic.LOGIN_ERR_UNKNOWN, Ng = ic.LOGIN_ERR_REJECTED, pi = ic.LOGIN_ERR_INVALID_ARGUMENT, Vr = ic.LOGIN_ERR_INVALID_APP_ID, Wr = ic.LOGIN_ERR_INVALID_TOKEN, qi = ic.LOGIN_ERR_TOKEN_EXPIRED;
    ic.LOGIN_ERR_NOT_AUTHORIZED;
    var FB = ic.LOGIN_ERR_ALREADY_LOGIN, GB = ic.LOGIN_ERR_TIMEOUT, HB = ic.LOGIN_ERR_TOO_OFTEN, Xr = Al.LOGOUT_ERR_USER_NOT_LOGGED_IN, Yr = ld.PEER_MESSAGE_ERR_FAILURE, El = ld.PEER_MESSAGE_ERR_TIMEOUT, Zr = ld.PEER_MESSAGE_ERR_TOO_OFTEN, $r = ld.PEER_MESSAGE_ERR_INVALID_USERID, Xf = ld.PEER_MESSAGE_ERR_INVALID_MESSAGE, Fl = ld.PEER_MESSAGE_ERR_USER_NOT_LOGGED_IN;
    ld.PEER_MESSAGE_ERR_INCOMPATIBLE_MESSAGE;
    var as = qe.QUERY_PEERS_ONLINE_STATUS_ERR_INVALID_ARGUMENT;
    qe.QUERY_PEERS_ONLINE_STATUS_ERR_REJECTED;
    var IB = qe.QUERY_PEERS_ONLINE_STATUS_ERR_TIMEOUT;
    qe.QUERY_PEERS_ONLINE_STATUS_ERR_TOO_OFTEN;
    var JB = qe.QUERY_PEERS_ONLINE_STATUS_ERR_USER_NOT_LOGGED_IN, Gl = md.RENEW_TOKEN_ERR_FAILURE, KB = md.RENEW_TOKEN_ERR_INVALID_ARGUMENT;
    md.RENEW_TOKEN_ERR_REJECTED, md.RENEW_TOKEN_ERR_TOO_OFTEN;
    var LB = md.RENEW_TOKEN_ERR_TOKEN_EXPIRED, MB = md.RENEW_TOKEN_ERR_INVALID_TOKEN, bs = md.RENEW_TOKEN_ERR_USER_NOT_LOGGED_IN, cs = od.PEER_SUBSCRIPTION_STATUS_ERR_FAILURE, Og = od.PEER_SUBSCRIPTION_STATUS_ERR_INVALID_ARGUMENT;
    od.PEER_SUBSCRIPTION_STATUS_ERR_REJECTED;
    var NB = od.PEER_SUBSCRIPTION_STATUS_ERR_TIMEOUT;
    od.PEER_SUBSCRIPTION_STATUS_ERR_TOO_OFTEN;
    var ds = od.PEER_SUBSCRIPTION_STATUS_ERR_OVERFLOW, Hl = od.PEER_SUBSCRIPTION_STATUS_ERR_USER_NOT_LOGGED_IN;
    xf.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_FAILURE, xf.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_TIMEOUT, xf.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_TOO_OFTEN, xf.QUERY_PEERS_BY_SUBSCRIPTION_OPTION_ERR_USER_NOT_LOGGED_IN;
    var OB = function(r, e) {
      var t;
      return ll(r, function(a, n, s) {
        return !(t = e(a, n, s));
      }), !!t;
    }, ri = function(r, e, t) {
      if (!Db(t))
        return !1;
      var a = oa(e);
      return !!(a == "number" ? $d(t) && al(e, t.length) : a == "string" && e in t) && Eg(t[e], r);
    }, Il = function(r, e, t) {
      var a = pb(r) ? or : OB;
      return t && ri(r, e, t) && (e = void 0), a(r, tf(e));
    }, PB = function(r, e) {
      var t = -1, a = $d(r) ? Array(r.length) : [];
      return ll(r, function(n, s, o) {
        a[++t] = e(n, s, o);
      }), a;
    }, QB = function(r, e) {
      var t = r.length;
      for (r.sort(e); t--; )
        r[t] = r[t].value;
      return r;
    }, RB = function(r, e, t) {
      e = e.length ? He(e, function(n) {
        return pb(n) ? function(s) {
          return ii(s, n.length === 1 ? n[0] : n);
        } : n;
      }) : [ji];
      var a = -1;
      return e = He(e, fi(tf)), r = PB(r, function(n, s, o) {
        return { criteria: He(e, function(u) {
          return u(n);
        }), index: ++a, value: n };
      }), QB(r, function(n, s) {
        e: {
          for (var o = -1, u = n.criteria, l = s.criteria, f = u.length, d = t.length; ++o < f; ) {
            t: {
              var h = u[o], p = l[o];
              if (h !== p) {
                var m = h !== void 0, _ = h === null, w = h == h, S = Ie(h), O = p !== void 0, k = p === null, B = p == p, L = Ie(p);
                if (!k && !L && !S && h > p || S && O && B && !k && !L || _ && O && B || !m && B || !w) {
                  h = 1;
                  break t;
                }
                if (!_ && !S && !L && h < p || L && m && w && !_ && !S || k && m && w || !O && w || !B) {
                  h = -1;
                  break t;
                }
              }
              h = 0;
            }
            if (h) {
              n = o >= d ? h : h * (t[o] == "desc" ? -1 : 1);
              break e;
            }
          }
          n = n.index - s.index;
        }
        return n;
      });
    }, es = function(r, e) {
      return mr(lr(r, e, ji), r + "");
    }, fs = es(function(r, e) {
      if (r == null)
        return [];
      var t = e.length;
      return 1 < t && ri(r, e[0], e[1]) ? e = [] : 2 < t && ri(e[0], e[1], e[2]) && (e = [e[0]]), RB(r, Mi(e, 1), []);
    }), gs = function(r) {
      if (r.__esModule)
        return r;
      var e = Object.defineProperty({}, "__esModule", { value: !0 });
      return Object.keys(r).forEach(function(t) {
        var a = Object.getOwnPropertyDescriptor(r, t);
        Object.defineProperty(e, t, a.get ? a : { enumerable: !0, get: function() {
          return r[t];
        } });
      }), e;
    }(ZA), hs = tb(function(r, e) {
      Object.defineProperty(e, "__esModule", { value: !0 });
      var t = [], a = function(n, s) {
        return new WebSocket(n, s);
      };
      e.normalClosureMessage = "Normal closure", e.default = function(n, s) {
        var o = (s = s === void 0 ? { protocols: t, makeWebSocket: a } : s).protocols, u = o === void 0 ? t : o, l = (s = s.makeWebSocket) === void 0 ? a : s;
        return new gs.Observable(function(f) {
          var d, h = new gs.Subject(), p = l(n, u), m = !1, _ = !1, w = function(S) {
            if (d)
              throw m = !0, S = Error("Web socket message factory function called more than once"), f.error(S), S;
            return d = S.subscribe(function(O) {
              p.send(O);
            }), h;
          };
          return p.onopen = function() {
            _ ? (m = !0, p.close()) : f.next(w);
          }, p.onmessage = function(S) {
            h.next(S.data);
          }, p.onerror = function(S) {
            m = !0, f.error(Error(S.message));
          }, p.onclose = function(S) {
            m || (m = !0, _ ? (f.complete(), h.complete()) : f.error(Error(S.code === 1e3 ? e.normalClosureMessage : S.reason)));
          }, function() {
            _ = !0, d && d.unsubscribe(), m || (m = !0, p.close());
          };
        });
      };
    });
    (function(r) {
      r && r.__esModule && Object.prototype.hasOwnProperty.call(r, "default") && r.default;
    })(hs);
    var cj = function(r, e, t) {
      (t === void 0 || Eg(r[e], t)) && (t !== void 0 || e in r) || Gg(r, e, t);
    }, bj = function(r, e) {
      if ((e !== "constructor" || typeof r[e] != "function") && e != "__proto__")
        return r[e];
    }, SB = function(r) {
      return es(function(e, t) {
        var a = -1, n = t.length, s = 1 < n ? t[n - 1] : void 0, o = 2 < n ? t[2] : void 0;
        for (s = 3 < r.length && typeof s == "function" ? (n--, s) : void 0, o && ri(t[0], t[1], o) && (s = 3 > n ? void 0 : s, n = 1), e = Object(e); ++a < n; )
          (o = t[a]) && r(e, o, a, s);
        return e;
      });
    }(function(r, e, t, a) {
      tn(r, e, t, a);
    }), TB = Math.floor, UB = Math.random, is = function(r, e) {
      return r + TB(UB() * (e - r + 1));
    }, js = function(r) {
      var e = r.length;
      return e ? r[is(0, e - 1)] : void 0;
    }, VB = function(r, e) {
      return He(e, function(t) {
        return r[t];
      });
    }, tj = function(r) {
      return r == null ? [] : VB(r, Vd(r));
    }, WB = function(r) {
      return js(tj(r));
    }, Xn = function(r) {
      return (pb(r) ? js : WB)(r);
    }, xn = [], yn = function(r, e) {
      return new WebSocket(r, e);
    }, XB = Math.floor;
    ba({ target: "Number", stat: !0 }, { isInteger: function(r) {
      return !va(r) && isFinite(r) && XB(r) === r;
    } }), Mp("from", mk, lk);
    var YB = function(r, e) {
      for (var t = Array(arguments.length - 1), a = 0, n = 2, s = !0; n < arguments.length; )
        t[a++] = arguments[n++];
      return new Promise(function(o, u) {
        t[a] = function(l) {
          if (s)
            if (s = !1, l)
              u(l);
            else {
              for (var f = Array(arguments.length - 1), d = 0; d < f.length; )
                f[d++] = arguments[d];
              o.apply(null, f);
            }
        };
        try {
          r.apply(e || null, t);
        } catch (l) {
          s && (s = !1, u(l));
        }
      });
    }, ZB = tb(function(r, e) {
      e.length = function(n) {
        var s = n.length;
        if (!s)
          return 0;
        for (var o = 0; 1 < --s % 4 && n.charAt(s) === "="; )
          ++o;
        return Math.ceil(3 * n.length) / 4 - o;
      };
      var t = Array(64), a = Array(123);
      for (r = 0; 64 > r; )
        a[t[r] = 26 > r ? r + 65 : 52 > r ? r + 71 : 62 > r ? r - 4 : r - 59 | 43] = r++;
      e.encode = function(n, s, o) {
        for (var u, l = null, f = [], d = 0, h = 0; s < o; ) {
          var p = n[s++];
          switch (h) {
            case 0:
              f[d++] = t[p >> 2], u = (3 & p) << 4, h = 1;
              break;
            case 1:
              f[d++] = t[u | p >> 4], u = (15 & p) << 2, h = 2;
              break;
            case 2:
              f[d++] = t[u | p >> 6], f[d++] = t[63 & p], h = 0;
          }
          8191 < d && ((l || (l = [])).push(String.fromCharCode.apply(String, f)), d = 0);
        }
        return h && (f[d++] = t[u], f[d++] = 61, h === 1 && (f[d++] = 61)), l ? (d && l.push(String.fromCharCode.apply(String, f.slice(0, d))), l.join("")) : String.fromCharCode.apply(String, f.slice(0, d));
      }, e.decode = function(n, s, o) {
        for (var u, l = o, f = 0, d = 0; d < n.length; ) {
          var h = n.charCodeAt(d++);
          if (h === 61 && 1 < f)
            break;
          if ((h = a[h]) === void 0)
            throw Error("invalid encoding");
          switch (f) {
            case 0:
              u = h, f = 1;
              break;
            case 1:
              s[o++] = u << 2 | (48 & h) >> 4, u = h, f = 2;
              break;
            case 2:
              s[o++] = (15 & u) << 4 | (60 & h) >> 2, u = h, f = 3;
              break;
            case 3:
              s[o++] = (3 & u) << 6 | h, f = 0;
          }
        }
        if (f === 1)
          throw Error("invalid encoding");
        return o - l;
      }, e.test = function(n) {
        return /^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/.test(n);
      };
    });
    eh.prototype.on = function(r, e, t) {
      return (this._listeners[r] || (this._listeners[r] = [])).push({ fn: e, ctx: t || this }), this;
    }, eh.prototype.off = function(r, e) {
      if (r === void 0)
        this._listeners = {};
      else if (e === void 0)
        this._listeners[r] = [];
      else {
        r = this._listeners[r];
        for (var t = 0; t < r.length; )
          r[t].fn === e ? r.splice(t, 1) : ++t;
      }
      return this;
    }, eh.prototype.emit = function(r) {
      var e = this._listeners[r];
      if (e) {
        for (var t = [], a = 1; a < arguments.length; )
          t.push(arguments[a++]);
        for (a = 0; a < e.length; )
          e[a].fn.apply(e[a++].ctx, t);
      }
      return this;
    };
    var $B = zn(zn), aC = function(c) {
      try {
        var b = eval("quire".replace(/^/, "re"))(c);
        if (b && (b.length || Object.keys(b).length))
          return b;
      } catch (r) {
      }
      return null;
    }, bC = tb(function(r, e) {
      e.length = function(t) {
        for (var a, n = 0, s = 0; s < t.length; ++s)
          128 > (a = t.charCodeAt(s)) ? n += 1 : 2048 > a ? n += 2 : (64512 & a) == 55296 && (64512 & t.charCodeAt(s + 1)) == 56320 ? (++s, n += 4) : n += 3;
        return n;
      }, e.read = function(t, a, n) {
        if (1 > n - a)
          return "";
        for (var s, o = null, u = [], l = 0; a < n; )
          128 > (s = t[a++]) ? u[l++] = s : 191 < s && 224 > s ? u[l++] = (31 & s) << 6 | 63 & t[a++] : 239 < s && 365 > s ? (s = ((7 & s) << 18 | (63 & t[a++]) << 12 | (63 & t[a++]) << 6 | 63 & t[a++]) - 65536, u[l++] = 55296 + (s >> 10), u[l++] = 56320 + (1023 & s)) : u[l++] = (15 & s) << 12 | (63 & t[a++]) << 6 | 63 & t[a++], 8191 < l && ((o || (o = [])).push(String.fromCharCode.apply(String, u)), l = 0);
        return o ? (l && o.push(String.fromCharCode.apply(String, u.slice(0, l))), o.join("")) : String.fromCharCode.apply(String, u.slice(0, l));
      }, e.write = function(t, a, n) {
        for (var s, o, u = n, l = 0; l < t.length; ++l)
          128 > (s = t.charCodeAt(l)) ? a[n++] = s : (2048 > s ? a[n++] = s >> 6 | 192 : ((64512 & s) == 55296 && (64512 & (o = t.charCodeAt(l + 1))) == 56320 ? (s = 65536 + ((1023 & s) << 10) + (1023 & o), ++l, a[n++] = s >> 18 | 240, a[n++] = s >> 12 & 63 | 128) : a[n++] = s >> 12 | 224, a[n++] = s >> 6 & 63 | 128), a[n++] = 63 & s | 128);
        return n - u;
      };
    }), cC = function(r, e, t) {
      var a = t || 8192, n = a >>> 1, s = null, o = a;
      return function(u) {
        return 1 > u || u > n ? r(u) : (o + u > a && (s = r(a), o = 0), u = e.call(s, o, o += u), 7 & o && (o = 1 + (7 | o)), u);
      };
    }, re = qb.zero = new qb(0, 0);
    re.toNumber = function() {
      return 0;
    }, re.zzEncode = re.zzDecode = function() {
      return this;
    }, re.length = function() {
      return 1;
    };
    var dC = qb.zeroHash = "\0\0\0\0\0\0\0\0";
    qb.fromNumber = function(r) {
      if (r === 0)
        return re;
      var e = 0 > r;
      e && (r = -r);
      var t = r >>> 0;
      return r = (r - t) / 4294967296 >>> 0, e && (r = ~r >>> 0, t = ~t >>> 0, 4294967295 < ++t && (t = 0, 4294967295 < ++r && (r = 0))), new qb(t, r);
    }, qb.from = function(r) {
      if (typeof r == "number")
        return qb.fromNumber(r);
      if (na.isString(r)) {
        if (!na.Long)
          return qb.fromNumber(parseInt(r, 10));
        r = na.Long.fromString(r);
      }
      return r.low || r.high ? new qb(r.low >>> 0, r.high >>> 0) : re;
    }, qb.prototype.toNumber = function(r) {
      if (!r && this.hi >>> 31) {
        r = 1 + ~this.lo >>> 0;
        var e = ~this.hi >>> 0;
        return r || (e = e + 1 >>> 0), -(r + 4294967296 * e);
      }
      return this.lo + 4294967296 * this.hi;
    }, qb.prototype.toLong = function(r) {
      return na.Long ? new na.Long(0 | this.lo, 0 | this.hi, !!r) : { low: 0 | this.lo, high: 0 | this.hi, unsigned: !!r };
    };
    var Nd = String.prototype.charCodeAt;
    qb.fromHash = function(r) {
      return r === dC ? re : new qb((Nd.call(r, 0) | Nd.call(r, 1) << 8 | Nd.call(r, 2) << 16 | Nd.call(r, 3) << 24) >>> 0, (Nd.call(r, 4) | Nd.call(r, 5) << 8 | Nd.call(r, 6) << 16 | Nd.call(r, 7) << 24) >>> 0);
    }, qb.prototype.toHash = function() {
      return String.fromCharCode(255 & this.lo, this.lo >>> 8 & 255, this.lo >>> 16 & 255, this.lo >>> 24, 255 & this.hi, this.hi >>> 8 & 255, this.hi >>> 16 & 255, this.hi >>> 24);
    }, qb.prototype.zzEncode = function() {
      var r = this.hi >> 31;
      return this.hi = ((this.hi << 1 | this.lo >>> 31) ^ r) >>> 0, this.lo = (this.lo << 1 ^ r) >>> 0, this;
    }, qb.prototype.zzDecode = function() {
      var r = -(1 & this.lo);
      return this.lo = ((this.lo >>> 1 | this.hi << 31) ^ r) >>> 0, this.hi = (this.hi >>> 1 ^ r) >>> 0, this;
    }, qb.prototype.length = function() {
      var r = this.lo, e = (this.lo >>> 28 | this.hi << 4) >>> 0, t = this.hi >>> 24;
      return t === 0 ? e === 0 ? 16384 > r ? 128 > r ? 1 : 2 : 2097152 > r ? 3 : 4 : 16384 > e ? 128 > e ? 5 : 6 : 2097152 > e ? 7 : 8 : 128 > t ? 9 : 10;
    };
    var na = tb(function(r, e) {
      function t(n, s, o) {
        for (var u = Object.keys(s), l = 0; l < u.length; ++l)
          n[u[l]] !== void 0 && o || (n[u[l]] = s[u[l]]);
        return n;
      }
      function a(n) {
        function s(o, u) {
          if (!(this instanceof s))
            return new s(o, u);
          Object.defineProperty(this, "message", { get: function() {
            return o;
          } }), Error.captureStackTrace ? Error.captureStackTrace(this, s) : Object.defineProperty(this, "stack", { value: Error().stack || "" }), u && t(this, u);
        }
        return (s.prototype = Object.create(Error.prototype)).constructor = s, Object.defineProperty(s.prototype, "name", { get: function() {
          return n;
        } }), s.prototype.toString = function() {
          return this.name + ": " + this.message;
        }, s;
      }
      e.asPromise = YB, e.base64 = ZB, e.EventEmitter = eh, e.float = $B, e.inquire = aC, e.utf8 = bC, e.pool = cC, e.LongBits = qb, e.isNode = !!(Va !== void 0 && Va && Va.process && Va.process.versions && Va.process.versions.node), e.global = e.isNode && Va || typeof window < "u" && window || typeof self < "u" && self || Va, e.emptyArray = Object.freeze ? Object.freeze([]) : [], e.emptyObject = Object.freeze ? Object.freeze({}) : {}, e.isInteger = Number.isInteger || function(n) {
        return typeof n == "number" && isFinite(n) && Math.floor(n) === n;
      }, e.isString = function(n) {
        return typeof n == "string" || n instanceof String;
      }, e.isObject = function(n) {
        return n && oa(n) === "object";
      }, e.isset = e.isSet = function(n, s) {
        var o = n[s];
        return !(o == null || !n.hasOwnProperty(s)) && (oa(o) !== "object" || 0 < (Array.isArray(o) ? o.length : Object.keys(o).length));
      }, e.Buffer = function() {
        try {
          var n = e.inquire("buffer").Buffer;
          return n.prototype.utf8Write ? n : null;
        } catch {
          return null;
        }
      }(), e._Buffer_from = null, e._Buffer_allocUnsafe = null, e.newBuffer = function(n) {
        return typeof n == "number" ? e.Buffer ? e._Buffer_allocUnsafe(n) : new e.Array(n) : e.Buffer ? e._Buffer_from(n) : typeof Uint8Array > "u" ? n : new Uint8Array(n);
      }, e.Array = typeof Uint8Array < "u" ? Uint8Array : Array, e.Long = e.global.dcodeIO && e.global.dcodeIO.Long || e.global.Long || e.inquire("long"), e.key2Re = /^true|false|0|1$/, e.key32Re = /^-?(?:0|[1-9][0-9]*)$/, e.key64Re = /^(?:[\\x00-\\xff]{8}|-?(?:0|[1-9][0-9]*))$/, e.longToHash = function(n) {
        return n ? e.LongBits.from(n).toHash() : e.LongBits.zeroHash;
      }, e.longFromHash = function(n, s) {
        return n = e.LongBits.fromHash(n), e.Long ? e.Long.fromBits(n.lo, n.hi, s) : n.toNumber(!!s);
      }, e.merge = t, e.lcFirst = function(n) {
        return n.charAt(0).toLowerCase() + n.substring(1);
      }, e.newError = a, e.ProtocolError = a("ProtocolError"), e.oneOfGetter = function(n) {
        for (var s = {}, o = 0; o < n.length; ++o)
          s[n[o]] = 1;
        return function() {
          for (var u = Object.keys(this), l = u.length - 1; -1 < l; --l)
            if (s[u[l]] === 1 && this[u[l]] !== void 0 && this[u[l]] !== null)
              return u[l];
        };
      }, e.oneOfSetter = function(n) {
        return function(s) {
          for (var o = 0; o < n.length; ++o)
            n[o] !== s && delete this[n[o]];
        };
      }, e.toJSONOptions = { longs: String, enums: String, bytes: String, json: !0 }, e._configure = function() {
        var n = e.Buffer;
        n ? (e._Buffer_from = n.from !== Uint8Array.from && n.from || function(s, o) {
          return new n(s, o);
        }, e._Buffer_allocUnsafe = n.allocUnsafe || function(s) {
          return new n(s);
        }) : e._Buffer_from = e._Buffer_allocUnsafe = null;
      };
    }), kj = xa, Jl, si = na.LongBits, ks = na.base64, ls = na.utf8, ms = function() {
      return na.Buffer ? function() {
        return (xa.create = function() {
          return new Jl();
        })();
      } : function() {
        return new xa();
      };
    };
    xa.create = ms(), xa.alloc = function(r) {
      return new na.Array(r);
    }, na.Array !== Array && (xa.alloc = na.pool(xa.alloc, na.Array.prototype.subarray)), xa.prototype._push = function(r, e, t) {
      return this.tail = this.tail.next = new Uf(r, e, t), this.len += e, this;
    }, hj.prototype = Object.create(Uf.prototype), hj.prototype.fn = function(r, e, t) {
      for (; 127 < r; )
        e[t++] = 127 & r | 128, r >>>= 7;
      e[t] = r;
    }, xa.prototype.uint32 = function(r) {
      return this.len += (this.tail = this.tail.next = new hj(128 > (r >>>= 0) ? 1 : 16384 > r ? 2 : 2097152 > r ? 3 : 268435456 > r ? 4 : 5, r)).len, this;
    }, xa.prototype.int32 = function(r) {
      return 0 > r ? this._push(ij, 10, si.fromNumber(r)) : this.uint32(r);
    }, xa.prototype.sint32 = function(r) {
      return this.uint32((r << 1 ^ r >> 31) >>> 0);
    }, xa.prototype.uint64 = function(r) {
      return r = si.from(r), this._push(ij, r.length(), r);
    }, xa.prototype.int64 = xa.prototype.uint64, xa.prototype.sint64 = function(r) {
      return r = si.from(r).zzEncode(), this._push(ij, r.length(), r);
    }, xa.prototype.bool = function(r) {
      return this._push(gj, 1, r ? 1 : 0);
    }, xa.prototype.fixed32 = function(r) {
      return this._push(jj, 4, r >>> 0);
    }, xa.prototype.sfixed32 = xa.prototype.fixed32, xa.prototype.fixed64 = function(r) {
      return r = si.from(r), this._push(jj, 4, r.lo)._push(jj, 4, r.hi);
    }, xa.prototype.sfixed64 = xa.prototype.fixed64, xa.prototype.float = function(r) {
      return this._push(na.float.writeFloatLE, 4, r);
    }, xa.prototype.double = function(r) {
      return this._push(na.float.writeDoubleLE, 8, r);
    };
    var eC = na.Array.prototype.set ? function(r, e, t) {
      e.set(r, t);
    } : function(r, e, t) {
      for (var a = 0; a < r.length; ++a)
        e[t + a] = r[a];
    };
    xa.prototype.bytes = function(r) {
      var e = r.length >>> 0;
      if (!e)
        return this._push(gj, 1, 0);
      if (na.isString(r)) {
        var t = xa.alloc(e = ks.length(r));
        ks.decode(r, t, 0), r = t;
      }
      return this.uint32(e)._push(eC, e, r);
    }, xa.prototype.string = function(r) {
      var e = ls.length(r);
      return e ? this.uint32(e)._push(ls.write, e, r) : this._push(gj, 1, 0);
    }, xa.prototype.fork = function() {
      return this.states = new sv(this), this.head = this.tail = new Uf(fj, 0, 0), this.len = 0, this;
    }, xa.prototype.reset = function() {
      return this.states ? (this.head = this.states.head, this.tail = this.states.tail, this.len = this.states.len, this.states = this.states.next) : (this.head = this.tail = new Uf(fj, 0, 0), this.len = 0), this;
    }, xa.prototype.ldelim = function() {
      var r = this.head, e = this.tail, t = this.len;
      return this.reset().uint32(t), t && (this.tail.next = r.next, this.tail = e, this.len += t), this;
    }, xa.prototype.finish = function() {
      for (var r = this.head.next, e = this.constructor.alloc(this.len), t = 0; r; )
        r.fn(r.val, e, t), t += r.len, r = r.next;
      return e;
    }, xa._configure = function(r) {
      Jl = r, xa.create = ms(), Jl._configure();
    }, (Hc.prototype = Object.create(kj.prototype)).constructor = Hc, Hc._configure = function() {
      Hc.alloc = na._Buffer_allocUnsafe, Hc.writeBytesBuffer = na.Buffer && na.Buffer.prototype instanceof Uint8Array && na.Buffer.prototype.set.name === "set" ? function(r, e, t) {
        e.set(r, t);
      } : function(r, e, t) {
        if (r.copy)
          r.copy(e, t, 0, r.length);
        else
          for (var a = 0; a < r.length; )
            e[t++] = r[a++];
      };
    }, Hc.prototype.bytes = function(r) {
      na.isString(r) && (r = na._Buffer_from(r, "base64"));
      var e = r.length >>> 0;
      return this.uint32(e), e && this._push(Hc.writeBytesBuffer, e, r), this;
    }, Hc.prototype.string = function(r) {
      var e = na.Buffer.byteLength(r);
      return this.uint32(e), e && this._push(tv, e, r), this;
    }, Hc._configure();
    var mj = eb, Kl, En = na.LongBits, fC = na.utf8, ns = typeof Uint8Array < "u" ? function(r) {
      if (r instanceof Uint8Array || Array.isArray(r))
        return new eb(r);
      throw Error("illegal buffer");
    } : function(r) {
      if (Array.isArray(r))
        return new eb(r);
      throw Error("illegal buffer");
    }, os = function() {
      return na.Buffer ? function(r) {
        return (eb.create = function(e) {
          return na.Buffer.isBuffer(e) ? new Kl(e) : ns(e);
        })(r);
      } : ns;
    };
    eb.create = os(), eb.prototype._slice = na.Array.prototype.subarray || na.Array.prototype.slice, eb.prototype.uint32 = function() {
      var r = 4294967295;
      return function() {
        if (r = (127 & this.buf[this.pos]) >>> 0, 128 > this.buf[this.pos++] || (r = (r | (127 & this.buf[this.pos]) << 7) >>> 0, 128 > this.buf[this.pos++]) || (r = (r | (127 & this.buf[this.pos]) << 14) >>> 0, 128 > this.buf[this.pos++]) || (r = (r | (127 & this.buf[this.pos]) << 21) >>> 0, 128 > this.buf[this.pos++]) || (r = (r | (15 & this.buf[this.pos]) << 28) >>> 0, 128 > this.buf[this.pos++]))
          return r;
        if ((this.pos += 5) > this.len)
          throw this.pos = this.len, pc(this, 10);
        return r;
      };
    }(), eb.prototype.int32 = function() {
      return 0 | this.uint32();
    }, eb.prototype.sint32 = function() {
      var r = this.uint32();
      return r >>> 1 ^ -(1 & r) | 0;
    }, eb.prototype.bool = function() {
      return this.uint32() !== 0;
    }, eb.prototype.fixed32 = function() {
      if (this.pos + 4 > this.len)
        throw pc(this, 4);
      return fh(this.buf, this.pos += 4);
    }, eb.prototype.sfixed32 = function() {
      if (this.pos + 4 > this.len)
        throw pc(this, 4);
      return 0 | fh(this.buf, this.pos += 4);
    }, eb.prototype.float = function() {
      if (this.pos + 4 > this.len)
        throw pc(this, 4);
      var r = na.float.readFloatLE(this.buf, this.pos);
      return this.pos += 4, r;
    }, eb.prototype.double = function() {
      if (this.pos + 8 > this.len)
        throw pc(this, 4);
      var r = na.float.readDoubleLE(this.buf, this.pos);
      return this.pos += 8, r;
    }, eb.prototype.bytes = function() {
      var r = this.uint32(), e = this.pos, t = this.pos + r;
      if (t > this.len)
        throw pc(this, r);
      return this.pos += r, Array.isArray(this.buf) ? this.buf.slice(e, t) : e === t ? new this.buf.constructor(0) : this._slice.call(this.buf, e, t);
    }, eb.prototype.string = function() {
      var r = this.bytes();
      return fC.read(r, 0, r.length);
    }, eb.prototype.skip = function(r) {
      if (typeof r == "number") {
        if (this.pos + r > this.len)
          throw pc(this, r);
        this.pos += r;
      } else
        do
          if (this.pos >= this.len)
            throw pc(this);
        while (128 & this.buf[this.pos++]);
      return this;
    }, eb.prototype.skipType = function(r) {
      switch (r) {
        case 0:
          this.skip();
          break;
        case 1:
          this.skip(8);
          break;
        case 2:
          this.skip(this.uint32());
          break;
        case 3:
          for (; (r = 7 & this.uint32()) != 4; )
            this.skipType(r);
          break;
        case 5:
          this.skip(4);
          break;
        default:
          throw Error("invalid wire type " + r + " at offset " + this.pos);
      }
      return this;
    }, eb._configure = function(r) {
      Kl = r, eb.create = os(), Kl._configure();
      var e = na.Long ? "toLong" : "toNumber";
      na.merge(eb.prototype, { int64: function() {
        return lj.call(this)[e](!1);
      }, uint64: function() {
        return lj.call(this)[e](!0);
      }, sint64: function() {
        return lj.call(this).zzDecode()[e](!1);
      }, fixed64: function() {
        return Fn.call(this)[e](!0);
      }, sfixed64: function() {
        return Fn.call(this)[e](!1);
      } });
    }, (ae.prototype = Object.create(mj.prototype)).constructor = ae, ae._configure = function() {
      na.Buffer && (ae.prototype._slice = na.Buffer.prototype.slice);
    }, ae.prototype.string = function() {
      var r = this.uint32();
      return this.buf.utf8Slice ? this.buf.utf8Slice(this.pos, this.pos = Math.min(this.pos + r, this.len)) : this.buf.toString("utf-8", this.pos, this.pos = Math.min(this.pos + r, this.len));
    }, ae._configure(), (Vf.prototype = Object.create(na.EventEmitter.prototype)).constructor = Vf, Vf.prototype.rpcCall = function r(e, t, a, n, s) {
      if (!n)
        throw TypeError("request must be specified");
      var o = this;
      if (!s)
        return na.asPromise(r, o, e, t, a, n);
      if (o.rpcImpl)
        try {
          return o.rpcImpl(e, t[o.requestDelimited ? "encodeDelimited" : "encode"](n).finish(), function(u, l) {
            if (u)
              return o.emit("error", u, e), s(u);
            if (l !== null) {
              if (!(l instanceof a))
                try {
                  l = a[o.responseDelimited ? "decodeDelimited" : "decode"](l);
                } catch (f) {
                  return o.emit("error", f, e), s(f);
                }
              return o.emit("data", l, e), s(null, l);
            }
            o.end(!0);
          });
        } catch (u) {
          o.emit("error", u, e), setTimeout(function() {
            s(u);
          }, 0);
        }
      else
        setTimeout(function() {
          s(Error("already ended"));
        }, 0);
    }, Vf.prototype.end = function(r) {
      return this.rpcImpl && (r || this.rpcImpl(null, null, null), this.rpcImpl = null, this.emit("end").off()), this;
    };
    var gC = tb(function(r, e) {
      e.Service = Vf;
    }), hC = {}, zc = tb(function(r, e) {
      function t() {
        a.util._configure(), a.Writer._configure(a.BufferWriter), a.Reader._configure(a.BufferReader);
      }
      var a = e;
      a.build = "minimal", a.Writer = kj, a.BufferWriter = Hc, a.Reader = mj, a.BufferReader = ae, a.util = na, a.rpc = gC, a.roots = hC, a.configure = t, t();
    });
    zc.util.Long = ma, zc.configure();
    var K = zc.Reader, fa = zc.Writer, D = zc.util, H = zc.roots.default || (zc.roots.default = {}), iC = H.URI = function() {
      var r = {}, e = Object.create(r);
      return e[r[0] = "Unknown"] = 0, e[r[1] = "PingUri"] = 1, e[r[2] = "PongUri"] = 2, e[r[11] = "UserJoinUri"] = 11, e[r[12] = "UserRespUri"] = 12, e[r[15] = "UserTicketNearlyExpireUri"] = 15, e[r[16] = "UserRenewTokenReqUri"] = 16, e[r[17] = "UserRenewTokenRespUri"] = 17, e[r[21] = "UserQuitUri"] = 21, e[r[22] = "UserDropUri"] = 22, e[r[31] = "GroupEnterUri"] = 31, e[r[32] = "GroupLeaveUri"] = 32, e[r[33] = "GroupReplyUri"] = 33, e[r[36] = "GroupEnterNoticeUri"] = 36, e[r[37] = "GroupLeaveNoticeUri"] = 37, e[r[38] = "GroupEventNoticeUri"] = 38, e[r[39] = "GroupCountNoticeUri"] = 39, e[r[41] = "UserStatusListUri"] = 41, e[r[42] = "UserStatusResultUri"] = 42, e[r[51] = "GroupStatusListUri"] = 51, e[r[52] = "GroupStatusResultUri"] = 52, e[r[55] = "GroupAllUsersListUri"] = 55, e[r[56] = "GroupAllUsersResultUri"] = 56, e[r[100] = "MessageUri"] = 100, e[r[101] = "AckUri"] = 101, e[r[201] = "UserJoinNoticeUri"] = 201, e[r[202] = "UserQuitNoticeUri"] = 202, e[r[203] = "UserWaitNoticeUri"] = 203, e[r[301] = "UserAttributeGetUri"] = 301, e[r[302] = "UserAttributeRetUri"] = 302, e[r[303] = "UserAttributeSetUri"] = 303, e[r[304] = "UserAttributeModUri"] = 304, e[r[305] = "UserAttributeDelUri"] = 305, e[r[307] = "UserAttributeRspUri"] = 307, e[r[308] = "UserAttributeErrUri"] = 308, e[r[311] = "UserAttributeKeysGetUri"] = 311, e[r[312] = "UserAttributeKeysRetUri"] = 312, e[r[351] = "GroupAttributeGetUri"] = 351, e[r[352] = "GroupAttributeRetUri"] = 352, e[r[353] = "GroupAttributeSetUri"] = 353, e[r[354] = "GroupAttributeModUri"] = 354, e[r[355] = "GroupAttributeDelUri"] = 355, e[r[356] = "GroupAttributeAltUri"] = 356, e[r[357] = "GroupAttributeRspUri"] = 357, e[r[358] = "GroupAttributeErrUri"] = 358, e[r[361] = "GroupAttributeKeysGetUri"] = 361, e[r[362] = "GroupAttributeKeysRetUri"] = 362, e[r[401] = "SubscribeUserStatusUri"] = 401, e[r[402] = "UnsubscribeUserStatusUri"] = 402, e[r[499] = "SubscribeResponseUri"] = 499, e;
    }(), ti = H.Wrapper = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.uri = 0, r.prototype.data = D.newBuffer([]), r.encode = function(e, t) {
        return t || (t = fa.create()), e.uri != null && Object.hasOwnProperty.call(e, "uri") && t.uint32(8).int32(e.uri), e.data != null && Object.hasOwnProperty.call(e, "data") && t.uint32(18).bytes(e.data), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.Wrapper(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.uri = e.int32();
              break;
            case 2:
              a.data = e.bytes();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), jC = H.Ping = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.ms = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.ms != null && Object.hasOwnProperty.call(e, "ms") && t.uint32(16).uint64(e.ms), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.Ping(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.ms = e.uint64();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), kC = H.Pong = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.ms = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.ms != null && Object.hasOwnProperty.call(e, "ms") && t.uint32(16).uint64(e.ms), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.Pong(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.ms = e.uint64();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), lC = H.UserJoin = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.opt = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.ticket = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.opt != null && Object.hasOwnProperty.call(e, "opt") && t.uint32(16).uint64(e.opt), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(24).uint64(e.instance), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(34).string(e.account), e.ticket != null && Object.hasOwnProperty.call(e, "ticket") && t.uint32(42).string(e.ticket), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserJoin(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.opt = e.uint64();
              break;
            case 3:
              a.instance = e.uint64();
              break;
            case 4:
              a.account = e.string();
              break;
            case 5:
              a.ticket = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), mC = H.UserResp = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(24).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserResp(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            case 3:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), nC = H.UserQuit = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.encode = function(e, t) {
        return t || (t = fa.create()), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserQuit(); e.pos < t; ) {
          var n = e.uint32();
          e.skipType(7 & n);
        }
        return a;
      }, r;
    }(), oC = H.UserDrop = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(8).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserDrop(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), pC = H.UserTicketNearlyExpire = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.expireTs = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.ticket = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.expireTs != null && Object.hasOwnProperty.call(e, "expireTs") && t.uint32(8).uint64(e.expireTs), e.ticket != null && Object.hasOwnProperty.call(e, "ticket") && t.uint32(18).string(e.ticket), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserTicketNearlyExpire(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.expireTs = e.uint64();
              break;
            case 2:
              a.ticket = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), qC = H.UserRenewTokenReq = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.ticket = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(16).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(26).string(e.account), e.ticket != null && Object.hasOwnProperty.call(e, "ticket") && t.uint32(34).string(e.ticket), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserRenewTokenReq(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.instance = e.uint64();
              break;
            case 2:
              a.seq = e.uint64();
              break;
            case 3:
              a.account = e.string();
              break;
            case 4:
              a.ticket = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), rC = H.UserRenewTokenResp = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(16).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserRenewTokenResp(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), sC = H.GroupEnter = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupEnter(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), tC = H.GroupLeave = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.account = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(10).string(e.account), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupLeave(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.account = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), uC = H.GroupReply = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(24).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupReply(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            case 3:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), ps = H.GroupLeaveNotice = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.user = "", r.prototype.group = "", r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.size = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.user != null && Object.hasOwnProperty.call(e, "user") && t.uint32(18).string(e.user), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(26).string(e.group), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(32).uint64(e.instance), e.size != null && Object.hasOwnProperty.call(e, "size") && t.uint32(40).uint32(e.size), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupLeaveNotice(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.user = e.string();
              break;
            case 3:
              a.group = e.string();
              break;
            case 4:
              a.instance = e.uint64();
              break;
            case 5:
              a.size = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), qs = H.GroupEnterNotice = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.user = "", r.prototype.group = "", r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.size = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.user != null && Object.hasOwnProperty.call(e, "user") && t.uint32(18).string(e.user), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(26).string(e.group), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(32).uint64(e.instance), e.size != null && Object.hasOwnProperty.call(e, "size") && t.uint32(40).uint32(e.size), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupEnterNotice(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.user = e.string();
              break;
            case 3:
              a.group = e.string();
              break;
            case 4:
              a.instance = e.uint64();
              break;
            case 5:
              a.size = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), rs = H.Message = function() {
      function r(e) {
        if (this.MiscMap = {}, e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.dialogue = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.sequence = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.options = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.src = "", r.prototype.dst = "", r.prototype.payload = D.newBuffer([]), r.prototype.MiscMap = D.emptyObject, r.prototype.ms = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.dialogue != null && Object.hasOwnProperty.call(e, "dialogue") && t.uint32(16).uint64(e.dialogue), e.sequence != null && Object.hasOwnProperty.call(e, "sequence") && t.uint32(24).uint64(e.sequence), e.options != null && Object.hasOwnProperty.call(e, "options") && t.uint32(32).uint64(e.options), e.src != null && Object.hasOwnProperty.call(e, "src") && t.uint32(42).string(e.src), e.dst != null && Object.hasOwnProperty.call(e, "dst") && t.uint32(50).string(e.dst), e.payload != null && Object.hasOwnProperty.call(e, "payload") && t.uint32(58).bytes(e.payload), e.MiscMap != null && Object.hasOwnProperty.call(e, "MiscMap"))
          for (var a = Object.keys(e.MiscMap), n = 0; n < a.length; ++n)
            t.uint32(66).fork().uint32(10).string(a[n]).uint32(18).bytes(e.MiscMap[a[n]]).ldelim();
        return e.ms != null && Object.hasOwnProperty.call(e, "ms") && t.uint32(72).uint64(e.ms), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a, n, s = new H.Message(); e.pos < t; )
          switch (a = e.uint32(), a >>> 3) {
            case 1:
              s.instance = e.uint64();
              break;
            case 2:
              s.dialogue = e.uint64();
              break;
            case 3:
              s.sequence = e.uint64();
              break;
            case 4:
              s.options = e.uint64();
              break;
            case 5:
              s.src = e.string();
              break;
            case 6:
              s.dst = e.string();
              break;
            case 7:
              s.payload = e.bytes();
              break;
            case 8:
              s.MiscMap === D.emptyObject && (s.MiscMap = {});
              var o = e.uint32() + e.pos;
              for (a = "", n = []; e.pos < o; ) {
                var u = e.uint32();
                switch (u >>> 3) {
                  case 1:
                    a = e.string();
                    break;
                  case 2:
                    n = e.bytes();
                    break;
                  default:
                    e.skipType(7 & u);
                }
              }
              s.MiscMap[a] = n;
              break;
            case 9:
              s.ms = e.uint64();
              break;
            default:
              e.skipType(7 & a);
          }
        return s;
      }, r;
    }(), ss = H.Ack = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.dialogue = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.sequence = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.dialogue != null && Object.hasOwnProperty.call(e, "dialogue") && t.uint32(16).uint64(e.dialogue), e.sequence != null && Object.hasOwnProperty.call(e, "sequence") && t.uint32(24).uint64(e.sequence), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(32).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.Ack(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.instance = e.uint64();
              break;
            case 2:
              a.dialogue = e.uint64();
              break;
            case 3:
              a.sequence = e.uint64();
              break;
            case 4:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), vC = H.GroupAllUsersList = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.pageSize = 0, r.prototype.pageNumber = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.pageSize != null && Object.hasOwnProperty.call(e, "pageSize") && t.uint32(24).uint32(e.pageSize), e.pageNumber != null && Object.hasOwnProperty.call(e, "pageNumber") && t.uint32(32).uint32(e.pageNumber), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAllUsersList(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.pageSize = e.uint32();
              break;
            case 4:
              a.pageNumber = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), wC = H.GroupAllUsersResult = function() {
      function r(e) {
        if (this.memberInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.totalSize = 0, r.prototype.pageSize = 0, r.prototype.pageNumber = 0, r.prototype.memberInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.totalSize != null && Object.hasOwnProperty.call(e, "totalSize") && t.uint32(24).uint32(e.totalSize), e.pageSize != null && Object.hasOwnProperty.call(e, "pageSize") && t.uint32(32).uint32(e.pageSize), e.pageNumber != null && Object.hasOwnProperty.call(e, "pageNumber") && t.uint32(40).uint32(e.pageNumber), e.memberInfos != null && e.memberInfos.length)
          for (var a = 0; a < e.memberInfos.length; ++a)
            H.GroupAllUsersResult.MemberInfo.encode(e.memberInfos[a], t.uint32(50).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAllUsersResult(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.totalSize = e.uint32();
              break;
            case 4:
              a.pageSize = e.uint32();
              break;
            case 5:
              a.pageNumber = e.uint32();
              break;
            case 6:
              a.memberInfos && a.memberInfos.length || (a.memberInfos = []), a.memberInfos.push(H.GroupAllUsersResult.MemberInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.MemberInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.account = "", e.prototype.ts = 0, e.encode = function(t, a) {
          return a || (a = fa.create()), t.account != null && Object.hasOwnProperty.call(t, "account") && a.uint32(10).string(t.account), t.ts != null && Object.hasOwnProperty.call(t, "ts") && a.uint32(16).uint32(t.ts), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.GroupAllUsersResult.MemberInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.account = t.string();
                break;
              case 2:
                n.ts = t.uint32();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), xC = H.UserStatusList = function() {
      function r(e) {
        if (this.users = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.users = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.users != null && e.users.length)
          for (var a = 0; a < e.users.length; ++a)
            t.uint32(18).string(e.users[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserStatusList(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.users && a.users.length || (a.users = []), a.users.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), yC = H.UserStatusResult = function() {
      function r(e) {
        if (this.userInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.userInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.userInfos != null && e.userInfos.length)
          for (var a = 0; a < e.userInfos.length; ++a)
            H.UserStatusResult.UserStatusInfo.encode(e.userInfos[a], t.uint32(18).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserStatusResult(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.userInfos && a.userInfos.length || (a.userInfos = []), a.userInfos.push(H.UserStatusResult.UserStatusInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.UserStatusInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.account = "", e.prototype.ts = 0, e.encode = function(t, a) {
          return a || (a = fa.create()), t.account != null && Object.hasOwnProperty.call(t, "account") && a.uint32(10).string(t.account), t.ts != null && Object.hasOwnProperty.call(t, "ts") && a.uint32(16).uint32(t.ts), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.UserStatusResult.UserStatusInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.account = t.string();
                break;
              case 2:
                n.ts = t.uint32();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), zC = H.UserAttributeGet = function() {
      function r(e) {
        if (this.attributes = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.attributes = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), e.attributes != null && e.attributes.length)
          for (var a = 0; a < e.attributes.length; ++a)
            t.uint32(26).string(e.attributes[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeGet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            case 3:
              a.attributes && a.attributes.length || (a.attributes = []), a.attributes.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), AC = H.UserAttributeRet = function() {
      function r(e) {
        if (this.attributeInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.attributeInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.attributeInfos != null && e.attributeInfos.length)
          for (var a = 0; a < e.attributeInfos.length; ++a)
            H.UserAttributeRet.AttributeInfo.encode(e.attributeInfos[a], t.uint32(18).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeRet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.attributeInfos && a.attributeInfos.length || (a.attributeInfos = []), a.attributeInfos.push(H.UserAttributeRet.AttributeInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.UserAttributeRet.AttributeInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), BC = H.UserAttributeSet = function() {
      function r(e) {
        if (this.attributeInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.attributeInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), e.attributeInfos != null && e.attributeInfos.length)
          for (var a = 0; a < e.attributeInfos.length; ++a)
            H.UserAttributeSet.AttributeInfo.encode(e.attributeInfos[a], t.uint32(26).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeSet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            case 3:
              a.attributeInfos && a.attributeInfos.length || (a.attributeInfos = []), a.attributeInfos.push(H.UserAttributeSet.AttributeInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.UserAttributeSet.AttributeInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), CC = H.UserAttributeMod = function() {
      function r(e) {
        if (this.attributeInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.attributeInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), e.attributeInfos != null && e.attributeInfos.length)
          for (var a = 0; a < e.attributeInfos.length; ++a)
            H.UserAttributeMod.AttributeInfo.encode(e.attributeInfos[a], t.uint32(26).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeMod(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            case 3:
              a.attributeInfos && a.attributeInfos.length || (a.attributeInfos = []), a.attributeInfos.push(H.UserAttributeMod.AttributeInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.UserAttributeMod.AttributeInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), DC = H.UserAttributeDel = function() {
      function r(e) {
        if (this.attributes = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.prototype.attributes = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), e.attributes != null && e.attributes.length)
          for (var a = 0; a < e.attributes.length; ++a)
            t.uint32(26).string(e.attributes[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeDel(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            case 3:
              a.attributes && a.attributes.length || (a.attributes = []), a.attributes.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), EC = H.UserAttributeErr = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(16).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeErr(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), FC = H.UserAttributeKeysGet = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.account = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.account != null && Object.hasOwnProperty.call(e, "account") && t.uint32(18).string(e.account), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeKeysGet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.account = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), GC = H.UserAttributeKeysRet = function() {
      function r(e) {
        if (this.keys = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.keys = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.keys != null && e.keys.length)
          for (var a = 0; a < e.keys.length; ++a)
            t.uint32(18).string(e.keys[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeKeysRet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.keys && a.keys.length || (a.keys = []), a.keys.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), HC = H.UserAttributeRsp = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserAttributeRsp(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), IC = H.GroupStatusList = function() {
      function r(e) {
        if (this.groups = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.groups = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.groups != null && e.groups.length)
          for (var a = 0; a < e.groups.length; ++a)
            t.uint32(18).string(e.groups[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupStatusList(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.groups && a.groups.length || (a.groups = []), a.groups.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), JC = H.GroupStatusResult = function() {
      function r(e) {
        if (this.groupInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.groupInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.groupInfos != null && e.groupInfos.length)
          for (var a = 0; a < e.groupInfos.length; ++a)
            H.GroupStatusResult.GroupInfo.encode(e.groupInfos[a], t.uint32(18).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupStatusResult(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.groupInfos && a.groupInfos.length || (a.groupInfos = []), a.groupInfos.push(H.GroupStatusResult.GroupInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.GroupInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.group = "", e.prototype.memberCount = 0, e.encode = function(t, a) {
          return a || (a = fa.create()), t.group != null && Object.hasOwnProperty.call(t, "group") && a.uint32(10).string(t.group), t.memberCount != null && Object.hasOwnProperty.call(t, "memberCount") && a.uint32(16).uint32(t.memberCount), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.GroupStatusResult.GroupInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.group = t.string();
                break;
              case 2:
                n.memberCount = t.uint32();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), KC = H.GroupCountNotice = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.size = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(16).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(26).string(e.group), e.size != null && Object.hasOwnProperty.call(e, "size") && t.uint32(32).uint32(e.size), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupCountNotice(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.instance = e.uint64();
              break;
            case 2:
              a.seq = e.uint64();
              break;
            case 3:
              a.group = e.string();
              break;
            case 4:
              a.size = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), LC = H.GroupAttributeGet = function() {
      function r(e) {
        if (this.attributes = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.attributes = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.attributes != null && e.attributes.length)
          for (var a = 0; a < e.attributes.length; ++a)
            t.uint32(26).string(e.attributes[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeGet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.attributes && a.attributes.length || (a.attributes = []), a.attributes.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), MC = H.GroupAttributeRet = function() {
      function r(e) {
        if (this.attributeMaps = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.attributeMaps = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.attributeMaps != null && e.attributeMaps.length)
          for (var a = 0; a < e.attributeMaps.length; ++a)
            H.GroupAttributeRet.AttributeMap.encode(e.attributeMaps[a], t.uint32(18).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeRet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.attributeMaps && a.attributeMaps.length || (a.attributeMaps = []), a.attributeMaps.push(H.GroupAttributeRet.AttributeMap.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeMap = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.prototype.origin = "", e.prototype.ms = D.Long ? D.Long.fromBits(0, 0, !0) : 0, e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), t.origin != null && Object.hasOwnProperty.call(t, "origin") && a.uint32(26).string(t.origin), t.ms != null && Object.hasOwnProperty.call(t, "ms") && a.uint32(32).uint64(t.ms), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.GroupAttributeRet.AttributeMap(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              case 3:
                n.origin = t.string();
                break;
              case 4:
                n.ms = t.uint64();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), NC = H.GroupAttributeSet = function() {
      function r(e) {
        if (this.attributeInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.broadcast = !1, r.prototype.attributeInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.broadcast != null && Object.hasOwnProperty.call(e, "broadcast") && t.uint32(24).bool(e.broadcast), e.attributeInfos != null && e.attributeInfos.length)
          for (var a = 0; a < e.attributeInfos.length; ++a)
            H.GroupAttributeSet.AttributeInfo.encode(e.attributeInfos[a], t.uint32(34).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeSet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.broadcast = e.bool();
              break;
            case 4:
              a.attributeInfos && a.attributeInfos.length || (a.attributeInfos = []), a.attributeInfos.push(H.GroupAttributeSet.AttributeInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.GroupAttributeSet.AttributeInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), OC = H.GroupAttributeMod = function() {
      function r(e) {
        if (this.attributeInfos = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.broadcast = !1, r.prototype.attributeInfos = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.broadcast != null && Object.hasOwnProperty.call(e, "broadcast") && t.uint32(24).bool(e.broadcast), e.attributeInfos != null && e.attributeInfos.length)
          for (var a = 0; a < e.attributeInfos.length; ++a)
            H.GroupAttributeMod.AttributeInfo.encode(e.attributeInfos[a], t.uint32(34).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeMod(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.broadcast = e.bool();
              break;
            case 4:
              a.attributeInfos && a.attributeInfos.length || (a.attributeInfos = []), a.attributeInfos.push(H.GroupAttributeMod.AttributeInfo.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeInfo = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.GroupAttributeMod.AttributeInfo(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), PC = H.GroupAttributeDel = function() {
      function r(e) {
        if (this.attributes = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.broadcast = !1, r.prototype.attributes = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.broadcast != null && Object.hasOwnProperty.call(e, "broadcast") && t.uint32(24).bool(e.broadcast), e.attributes != null && e.attributes.length)
          for (var a = 0; a < e.attributes.length; ++a)
            t.uint32(34).string(e.attributes[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeDel(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.broadcast = e.bool();
              break;
            case 4:
              a.attributes && a.attributes.length || (a.attributes = []), a.attributes.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), QC = H.GroupAttributeAlt = function() {
      function r(e) {
        if (this.attributeMaps = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.attributeMaps = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(24).uint64(e.instance), e.attributeMaps != null && e.attributeMaps.length)
          for (var a = 0; a < e.attributeMaps.length; ++a)
            H.GroupAttributeAlt.AttributeMap.encode(e.attributeMaps[a], t.uint32(34).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeAlt(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            case 3:
              a.instance = e.uint64();
              break;
            case 4:
              a.attributeMaps && a.attributeMaps.length || (a.attributeMaps = []), a.attributeMaps.push(H.GroupAttributeAlt.AttributeMap.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.AttributeMap = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.key = "", e.prototype.value = "", e.prototype.origin = "", e.prototype.ms = D.Long ? D.Long.fromBits(0, 0, !0) : 0, e.encode = function(t, a) {
          return a || (a = fa.create()), t.key != null && Object.hasOwnProperty.call(t, "key") && a.uint32(10).string(t.key), t.value != null && Object.hasOwnProperty.call(t, "value") && a.uint32(18).string(t.value), t.origin != null && Object.hasOwnProperty.call(t, "origin") && a.uint32(26).string(t.origin), t.ms != null && Object.hasOwnProperty.call(t, "ms") && a.uint32(32).uint64(t.ms), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.GroupAttributeAlt.AttributeMap(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.key = t.string();
                break;
              case 2:
                n.value = t.string();
                break;
              case 3:
                n.origin = t.string();
                break;
              case 4:
                n.ms = t.uint64();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), RC = H.GroupAttributeRsp = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeRsp(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), SC = H.GroupAttributeErr = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.code = 0, r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(16).uint32(e.code), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeErr(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.code = e.uint32();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), TC = H.GroupAttributeKeysGet = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.group = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.group != null && Object.hasOwnProperty.call(e, "group") && t.uint32(18).string(e.group), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeKeysGet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.group = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), UC = H.GroupAttributeKeysRet = function() {
      function r(e) {
        if (this.keys = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.keys = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.keys != null && e.keys.length)
          for (var a = 0; a < e.keys.length; ++a)
            t.uint32(18).string(e.keys[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.GroupAttributeKeysRet(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.keys && a.keys.length || (a.keys = []), a.keys.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), VC = H.SubscribeUserStatus = function() {
      function r(e) {
        if (this.users = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.users = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.users != null && e.users.length)
          for (var a = 0; a < e.users.length; ++a)
            t.uint32(18).string(e.users[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.SubscribeUserStatus(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.users && a.users.length || (a.users = []), a.users.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), WC = H.UnsubscribeUserStatus = function() {
      function r(e) {
        if (this.users = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.users = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.users != null && e.users.length)
          for (var a = 0; a < e.users.length; ++a)
            t.uint32(18).string(e.users[a]);
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UnsubscribeUserStatus(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.users && a.users.length || (a.users = []), a.users.push(e.string());
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), XC = H.UserJoinNotice = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.user = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(16).uint64(e.seq), e.user != null && Object.hasOwnProperty.call(e, "user") && t.uint32(26).string(e.user), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserJoinNotice(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.instance = e.uint64();
              break;
            case 2:
              a.seq = e.uint64();
              break;
            case 3:
              a.user = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), YC = H.UserQuitNotice = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.user = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(16).uint64(e.seq), e.user != null && Object.hasOwnProperty.call(e, "user") && t.uint32(26).string(e.user), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserQuitNotice(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.instance = e.uint64();
              break;
            case 2:
              a.seq = e.uint64();
              break;
            case 3:
              a.user = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), ZC = H.UserWaitNotice = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.instance = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.user = "", r.encode = function(e, t) {
        return t || (t = fa.create()), e.instance != null && Object.hasOwnProperty.call(e, "instance") && t.uint32(8).uint64(e.instance), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(16).uint64(e.seq), e.user != null && Object.hasOwnProperty.call(e, "user") && t.uint32(26).string(e.user), t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.UserWaitNotice(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.instance = e.uint64();
              break;
            case 2:
              a.seq = e.uint64();
              break;
            case 3:
              a.user = e.string();
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r;
    }(), $C = H.SubscribeResponse = function() {
      function r(e) {
        if (this.errors = [], e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.seq = D.Long ? D.Long.fromBits(0, 0, !0) : 0, r.prototype.errors = D.emptyArray, r.encode = function(e, t) {
        if (t || (t = fa.create()), e.seq != null && Object.hasOwnProperty.call(e, "seq") && t.uint32(8).uint64(e.seq), e.errors != null && e.errors.length)
          for (var a = 0; a < e.errors.length; ++a)
            H.SubscribeResponse.SubscribeErrorsType.encode(e.errors[a], t.uint32(18).fork()).ldelim();
        return t;
      }, r.decode = function(e, t) {
        e instanceof K || (e = K.create(e)), t = t === void 0 ? e.len : e.pos + t;
        for (var a = new H.SubscribeResponse(); e.pos < t; ) {
          var n = e.uint32();
          switch (n >>> 3) {
            case 1:
              a.seq = e.uint64();
              break;
            case 2:
              a.errors && a.errors.length || (a.errors = []), a.errors.push(H.SubscribeResponse.SubscribeErrorsType.decode(e, e.uint32()));
              break;
            default:
              e.skipType(7 & n);
          }
        }
        return a;
      }, r.SubscribeErrorsType = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.account = "", e.prototype.code = 0, e.encode = function(t, a) {
          return a || (a = fa.create()), t.account != null && Object.hasOwnProperty.call(t, "account") && a.uint32(10).string(t.account), t.code != null && Object.hasOwnProperty.call(t, "code") && a.uint32(16).uint32(t.code), a;
        }, e.decode = function(t, a) {
          t instanceof K || (t = K.create(t)), a = a === void 0 ? t.len : t.pos + a;
          for (var n = new H.SubscribeResponse.SubscribeErrorsType(); t.pos < a; ) {
            var s = t.uint32();
            switch (s >>> 3) {
              case 1:
                n.account = t.string();
                break;
              case 2:
                n.code = t.uint32();
                break;
              default:
                t.skipType(7 & s);
            }
          }
          return n;
        }, e;
      }(), r;
    }(), aD = Object.freeze({ __proto__: null, URI: iC, Wrapper: ti, Ping: jC, Pong: kC, UserJoin: lC, UserResp: mC, UserQuit: nC, UserDrop: oC, UserTicketNearlyExpire: pC, UserRenewTokenReq: qC, UserRenewTokenResp: rC, GroupEnter: sC, GroupLeave: tC, GroupReply: uC, GroupLeaveNotice: ps, GroupEnterNotice: qs, Message: rs, Ack: ss, GroupAllUsersList: vC, GroupAllUsersResult: wC, UserStatusList: xC, UserStatusResult: yC, UserAttributeGet: zC, UserAttributeRet: AC, UserAttributeSet: BC, UserAttributeMod: CC, UserAttributeDel: DC, UserAttributeErr: EC, UserAttributeKeysGet: FC, UserAttributeKeysRet: GC, UserAttributeRsp: HC, GroupStatusList: IC, GroupStatusResult: JC, GroupCountNotice: KC, GroupAttributeGet: LC, GroupAttributeRet: MC, GroupAttributeSet: NC, GroupAttributeMod: OC, GroupAttributeDel: PC, GroupAttributeAlt: QC, GroupAttributeRsp: RC, GroupAttributeErr: SC, GroupAttributeKeysGet: TC, GroupAttributeKeysRet: UC, SubscribeUserStatus: VC, UnsubscribeUserStatus: WC, UserJoinNotice: XC, UserQuitNotice: YC, UserWaitNotice: ZC, SubscribeResponse: $C, default: H }), bD = Math.ceil, ts = function(r) {
      return function(e, t, a) {
        var n = (e = String(Bb(e))).length;
        return a = a === void 0 ? " " : String(a), (t = La(t)) <= n || a == "" ? e : (t -= n, (n = So.call(a, bD(t / a.length))).length > t && (n = n.slice(0, t)), r ? e + n : n + e);
      };
    }, cD = ts(!1), dD = ts(!0), us = /Version\/10(?:\.\d+){1,2}(?: [\w./]+)?(?: Mobile\/\w+)? Safari\//.test(af);
    ba({ target: "String", proto: !0, forced: us }, { padEnd: function(r) {
      return dD(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } });
    var eD = cg, vs = function(r) {
      return function(e) {
        e = Ib(e);
        for (var t, a = $c(e), n = a.length, s = 0, o = []; n > s; )
          t = a[s++], ta && !eD.call(e, t) || o.push(r ? [t, e[t]] : e[t]);
        return o;
      };
    }, fD = vs(!0), gD = vs(!1);
    ba({ target: "Object", stat: !0 }, { entries: function(r) {
      return fD(r);
    } });
    var hD = Zb.f, ws = "".endsWith, iD = Math.min, xs = Kk("endsWith"), jD = !xs && !!function() {
      var r = hD(String.prototype, "endsWith");
      return r && !r.writable;
    }();
    ba({ target: "String", proto: !0, forced: !jD && !xs }, { endsWith: function(r) {
      var e = String(Bb(this));
      Jk(r);
      var t = 1 < arguments.length ? arguments[1] : void 0, a = La(e.length);
      return t = t === void 0 ? a : iD(La(t), a), a = String(r), ws ? ws.call(e, a, t) : e.slice(t - a.length, t) === a;
    } }), yh("match", 1, function(r, e, t) {
      return [function(a) {
        var n = Bb(this), s = a == null ? void 0 : a[r];
        return s !== void 0 ? s.call(a, n) : new RegExp(a)[r](String(n));
      }, function(a) {
        var n = t(e, a, this);
        if (n.done)
          return n.value;
        if (a = Ia(a), n = String(this), !a.global)
          return bf(a, n);
        var s = a.unicode;
        a.lastIndex = 0;
        for (var o, u = [], l = 0; (o = bf(a, n)) !== null; )
          o = String(o[0]), u[l] = o, o === "" && (a.lastIndex = Gj(n, La(a.lastIndex), s)), l++;
        return l === 0 ? null : u;
      }];
    });
    var kD = Zb.f, ys = "".startsWith, lD = Math.min, zs = Kk("startsWith"), mD = !zs && !!function() {
      var r = kD(String.prototype, "startsWith");
      return r && !r.writable;
    }();
    ba({ target: "String", proto: !0, forced: !mD && !zs }, { startsWith: function(r) {
      var e = String(Bb(this));
      Jk(r);
      var t = La(lD(1 < arguments.length ? arguments[1] : void 0, e.length)), a = String(r);
      return ys ? ys.call(e, a, t) : e.slice(t, t + a.length) === a;
    } });
    var Nn = function(r) {
      var e = /(%?)(%([jds]))/g, t = Array.prototype.slice.call(arguments, 1);
      return t.length && (r = r.replace(e, function(a, n, s, o) {
        switch (s = t.shift(), o) {
          case "s":
            s = "" + s;
            break;
          case "d":
            s = Number(s);
            break;
          case "j":
            s = JSON.stringify(s);
        }
        return n ? (t.unshift(s), a) : s;
      })), t.length && (r += " " + t.join(" ")), "" + (r = r.replace(/%{2,2}/g, "%"));
    }, nD = /\s/, oD = /^\s+/, As = NaN, pD = /^[-+]0x[0-9a-f]+$/i, qD = /^0b[01]+$/i, rD = /^0o[0-7]+$/i, sD = parseInt, Ll = function(r) {
      if (typeof r == "number")
        return r;
      if (Ie(r))
        return As;
      if (Db(r) && (r = typeof r.valueOf == "function" ? r.valueOf() : r, r = Db(r) ? r + "" : r), typeof r != "string")
        return r === 0 ? r : +r;
      if (r) {
        for (var e = r.slice, t = r.length; t-- && nD.test(r.charAt(t)); )
          ;
        r = e.call(r, 0, t + 1).replace(oD, "");
      }
      return (e = qD.test(r)) || rD.test(r) ? sD(r.slice(2), e ? 2 : 8) : pD.test(r) ? As : +r;
    }, tD = Math.max, uD = Math.min, vD = function(r, e, t) {
      function a(k) {
        var B = l, L = f;
        return l = f = void 0, m = k, d = r.apply(L, B);
      }
      function n(k) {
        var B = k - p;
        return k -= m, p === void 0 || B >= e || 0 > B || w && k >= O;
      }
      function s() {
        var k = Wb.Date.now();
        if (n(k))
          return o(k);
        var B = setTimeout, L = k - m;
        k = e - (k - p), L = w ? uD(k, O - L) : k, h = B(s, L);
      }
      function o(k) {
        return h = void 0, S && l ? a(k) : (l = f = void 0, d);
      }
      function u() {
        var k = Wb.Date.now(), B = n(k);
        if (l = arguments, f = this, p = k, B) {
          if (h === void 0)
            return m = k = p, h = setTimeout(s, e), _ ? a(k) : d;
          if (w)
            return clearTimeout(h), h = setTimeout(s, e), a(p);
        }
        return h === void 0 && (h = setTimeout(s, e)), d;
      }
      var l, f, d, h, p, m = 0, _ = !1, w = !1, S = !0;
      if (typeof r != "function")
        throw new TypeError("Expected a function");
      if (e = Ll(e) || 0, Db(t)) {
        _ = !!t.leading;
        var O = (w = "maxWait" in t) ? tD(Ll(t.maxWait) || 0, e) : O;
        S = "trailing" in t ? !!t.trailing : S;
      }
      return u.cancel = function() {
        h !== void 0 && clearTimeout(h), m = 0, l = p = f = h = void 0;
      }, u.flush = function() {
        return h === void 0 ? d : o(Wb.Date.now());
      }, u;
    }, pd = function(r) {
      function e(a, n) {
        return ua(this, e), x(z(a = t.call(this, Mn(a, n))), "originalError", void 0), x(z(a), "code", void 0), x(z(a), "serverCode", void 0), typeof n == "number" ? a.code = n : typeof n == "string" ? a.name = n : n !== void 0 && (n.originalError && (a.originalError = n.originalError), n.code !== void 0 && (a.code = n.code), n.serverCode !== void 0 && (a.serverCode = n.serverCode)), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(If(Error)), qd = function(r) {
      function e(a, n) {
        return ua(this, e), x(z(a = t.call(this, Mn(a, n))), "name", "RtmInternalError"), x(z(a), "code", void 0), a.code = n, a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(If(Error)), ui = function() {
      return function(r) {
        function e(a) {
          ua(this, e);
          var n = Object.keys(a);
          return t.call(this, a[n[0]], n[0]);
        }
        Ga(e, r);
        var t = Ha(e);
        return e;
      }(qd);
    }, ib = ui(), Qb = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmTimeoutError"), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), Z = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmInvalidArgumentError"), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), aa = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmInvalidStatusError"), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), dc = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmLimitExceededError"), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), wD = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmInvokeTooOftenError"), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), Ja = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmUnavailableError"), x(z(a), "serverCode", void 0), x(z(a), "statusCode", void 0), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), yf = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmUnauthenticatedError"), x(z(a), "serverCode", void 0), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), se = function(r) {
      function e() {
        ua(this, e);
        for (var a = arguments.length, n = Array(a), s = 0; s < a; s++)
          n[s] = arguments[s];
        return x(z(a = t.call.apply(t, [this].concat(n))), "name", "RtmUnknownError"), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(pd), vb = function(r) {
      return r instanceof Qb || r instanceof Pb;
    }, Ma = function(r) {
      return r instanceof pd;
    }, te = function(r, e, t) {
      return ['Executing "%s.%s" timed out after %ds', r, e, t / 1e3];
    }, Ln = /* @__PURE__ */ new Map(), xD = function() {
      var r = new Date();
      return "".concat(r.toISOString().split("T")[1].replace(/\..+/, ""), ".").concat(r.getMilliseconds());
    }, $f = Object.keys, lh = Object.entries.bind(Object), ih = function(r) {
      return typeof r == "string" ? r.endsWith(".") ? r : "".concat(r, ".") : r;
    }, yD = ia(function() {
      return new Date(NaN).toJSON() !== null || Date.prototype.toJSON.call({ toISOString: function() {
        return 1;
      } }) !== 1;
    });
    ba({ target: "Date", proto: !0, forced: yD }, { toJSON: function(r) {
      r = lb(this);
      var e = Kc(r);
      return typeof e != "number" || isFinite(e) ? r.toISOString() : null;
    } }), ba({ target: "URL", proto: !0, enumerable: !0 }, { toJSON: function() {
      return URL.prototype.toString.call(this);
    } });
    var wv = Object.prototype.hasOwnProperty, Bs = function(r, e, t) {
      return JSON.stringify(Tn(r), e, t);
    };
    Bs.ensureProperties = Tn;
    var zD = function(r, e) {
      e = e || {};
      var t = oa(r);
      if (t === "string" && 0 < r.length)
        return xv(r);
      if (t === "number" && isFinite(r))
        return e.long ? r = 864e5 <= (e = Math.abs(r)) ? nh(r, e, 864e5, "day") : 36e5 <= e ? nh(r, e, 36e5, "hour") : 6e4 <= e ? nh(r, e, 6e4, "minute") : 1e3 <= e ? nh(r, e, 1e3, "second") : r + " ms" : r = 864e5 <= (e = Math.abs(r)) ? Math.round(r / 864e5) + "d" : 36e5 <= e ? Math.round(r / 36e5) + "h" : 6e4 <= e ? Math.round(r / 6e4) + "m" : 1e3 <= e ? Math.round(r / 1e3) + "s" : r + "ms", r;
      throw Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(r));
    }, AD = function(r) {
      function e(n) {
        function s() {
          for (var l = arguments.length, f = Array(l), d = 0; d < l; d++)
            f[d] = arguments[d];
          if (s.enabled) {
            l = Number(new Date()), s.diff = l - (o || l), s.prev = o, o = s.curr = l, f[0] = e.coerce(f[0]), typeof f[0] != "string" && f.unshift("%O");
            var h = 0;
            f[0] = f[0].replace(/%([a-zA-Z%])/g, function(p, m) {
              return p === "%%" ? "%" : (h++, typeof (m = e.formatters[m]) == "function" && (p = m.call(s, f[h]), f.splice(h, 1), h--), p);
            }), e.formatArgs.call(s, f), (s.log || e.log).apply(s, f);
          }
        }
        var o, u = null;
        return s.namespace = n, s.useColors = e.useColors(), s.color = e.selectColor(n), s.extend = t, s.destroy = e.destroy, Object.defineProperty(s, "enabled", { enumerable: !0, configurable: !1, get: function() {
          return u === null ? e.enabled(n) : u;
        }, set: function(l) {
          u = l;
        } }), typeof e.init == "function" && e.init(s), s;
      }
      function t(n, s) {
        return (n = e(this.namespace + (s === void 0 ? ":" : s) + n)).log = this.log, n;
      }
      function a(n) {
        return n.toString().substring(2, n.toString().length - 2).replace(/\.\*\?$/, "*");
      }
      return e.debug = e, e.default = e, e.coerce = function(n) {
        return n instanceof Error ? n.stack || n.message : n;
      }, e.disable = function() {
        var n = [].concat(W(e.names.map(a)), W(e.skips.map(a).map(function(s) {
          return "-" + s;
        }))).join(",");
        return e.enable(""), n;
      }, e.enable = function(n) {
        e.save(n), e.names = [], e.skips = [];
        var s, o = (typeof n == "string" ? n : "").split(/[\s,]+/), u = o.length;
        for (s = 0; s < u; s++)
          o[s] && ((n = o[s].replace(/\*/g, ".*?"))[0] === "-" ? e.skips.push(new RegExp("^" + n.substr(1) + "$")) : e.names.push(new RegExp("^" + n + "$")));
      }, e.enabled = function(n) {
        if (n[n.length - 1] === "*")
          return !0;
        var s, o = 0;
        for (s = e.skips.length; o < s; o++)
          if (e.skips[o].test(n))
            return !1;
        for (o = 0, s = e.names.length; o < s; o++)
          if (e.names[o].test(n))
            return !0;
        return !1;
      }, e.humanize = zD, e.destroy = function() {
        console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
      }, Object.keys(r).forEach(function(n) {
        e[n] = r[n];
      }), e.names = [], e.skips = [], e.formatters = {}, e.selectColor = function(n) {
        for (var s = 0, o = 0; o < n.length; o++)
          s = (s << 5) - s + n.charCodeAt(o), s |= 0;
        return e.colors[Math.abs(s) % e.colors.length];
      }, e.enable(e.load()), e;
    }, Cs = tb(function(r, e) {
      e.formatArgs = function(n) {
        if (n[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + n[0] + (this.useColors ? "%c " : " ") + "+" + r.exports.humanize(this.diff), this.useColors) {
          var s = "color: " + this.color;
          n.splice(1, 0, s, "color: inherit");
          var o = 0, u = 0;
          n[0].replace(/%[a-zA-Z%]/g, function(l) {
            l !== "%%" && (o++, l === "%c" && (u = o));
          }), n.splice(u, 0, s);
        }
      }, e.save = function(n) {
        try {
          n ? e.storage.setItem("debug", n) : e.storage.removeItem("debug");
        } catch {
        }
      }, e.load = function() {
        try {
          var n = e.storage.getItem("debug");
        } catch {
        }
        return !n && typeof process < "u" && "env" in process && (n = process.env.DEBUG), n;
      }, e.useColors = function() {
        return !(typeof window > "u" || !window.process || window.process.type !== "renderer" && !window.process.__nwjs) || (typeof navigator > "u" || !navigator.userAgent || !navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) && (typeof document < "u" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window < "u" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && 31 <= parseInt(RegExp.$1, 10) || typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
      };
      e: {
        try {
          var t = localStorage;
          break e;
        } catch {
        }
        t = void 0;
      }
      var a;
      e.storage = t, e.destroy = (a = !1, function() {
        a || (a = !0, console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."));
      }), e.colors = "#0000CC #0000FF #0033CC #0033FF #0066CC #0066FF #0099CC #0099FF #00CC00 #00CC33 #00CC66 #00CC99 #00CCCC #00CCFF #3300CC #3300FF #3333CC #3333FF #3366CC #3366FF #3399CC #3399FF #33CC00 #33CC33 #33CC66 #33CC99 #33CCCC #33CCFF #6600CC #6600FF #6633CC #6633FF #66CC00 #66CC33 #9900CC #9900FF #9933CC #9933FF #99CC00 #99CC33 #CC0000 #CC0033 #CC0066 #CC0099 #CC00CC #CC00FF #CC3300 #CC3333 #CC3366 #CC3399 #CC33CC #CC33FF #CC6600 #CC6633 #CC9900 #CC9933 #CCCC00 #CCCC33 #FF0000 #FF0033 #FF0066 #FF0099 #FF00CC #FF00FF #FF3300 #FF3333 #FF3366 #FF3399 #FF33CC #FF33FF #FF6600 #FF6633 #FF9900 #FF9933 #FFCC00 #FFCC33".split(" "), e.log = console.debug || console.log || function() {
      }, r.exports = AD(e), r.exports.formatters.j = function(n) {
        try {
          return JSON.stringify(n);
        } catch (s) {
          return "[UnexpectedJSONParseError]: " + s.message;
        }
      };
    }), Ds = Cs("RTM:DEBUG"), zf;
    Ds.enabled = !1, function(r) {
      r[r.Uploading = 0] = "Uploading", r[r.Free = 1] = "Free";
    }(zf || (zf = {}));
    var BD = function() {
      function r(e) {
        ua(this, r), x(this, "uploadRequest", void 0), x(this, "uploadState", void 0), x(this, "uploadResendCount", void 0), x(this, "LogCache", void 0), x(this, "LogsToPost", void 0), x(this, "processId", void 0), x(this, "sdkVersion", void 0), x(this, "logId", void 0), x(this, "rtmConfig", void 0), this.processId = e.processId, this.sdkVersion = e.sdkVersion, this.rtmConfig = e.rtmConfig, this.uploadRequest = e.uploadRequest, this.uploadState = zf.Free, this.uploadResendCount = 0, this.LogCache = [], this.LogsToPost = [], this.logId = 0;
      }
      return cb(r, [{ key: "upload", value: function(e) {
        this.LogCache.push(e), this.uploadState === zf.Free && (this.LogsToPost = 40 > this.LogCache.length ? this.LogCache.splice(0, this.LogCache.length) : this.LogCache.splice(0, 40), this.postLog(this.LogsToPost));
      } }, { key: "postLog", value: function(e) {
        var t = this;
        this.uploadState = zf.Uploading, setTimeout(ja(M.mark(function a() {
          var n, s, o;
          return M.wrap(function(u) {
            for (; ; )
              switch (u.prev = u.next) {
                case 0:
                  return n = { sdk_version: t.sdkVersion, process_id: t.processId, payload: JSON.stringify(e) }, u.prev = 1, u.next = 4, t.uploadRequest(n, (s = t.rtmConfig.enableCloudProxy) !== null && s !== void 0 && s);
                case 4:
                  if (!aj) {
                    u.next = 6;
                    break;
                  }
                  throw Error("RTM is busy");
                case 6:
                  u.next = 13;
                  break;
                case 8:
                  return u.prev = 8, u.t0 = u.catch(1), o = 2 > t.uploadResendCount++ ? 2e3 : 1e4, setTimeout(function() {
                    return t.postLog(t.LogsToPost);
                  }, o), u.abrupt("return");
                case 13:
                  if (Ds('The logs uploaded for "process-'.concat(Mg, '"')), t.LogCache.length !== 0) {
                    u.next = 17;
                    break;
                  }
                  return t.uploadState = zf.Free, u.abrupt("return");
                case 17:
                  t.uploadResendCount = 0, t.LogsToPost = 40 > t.LogCache.length ? t.LogCache.splice(0, t.LogCache.length) : t.LogCache.splice(0, 40), t.postLog(t.LogsToPost);
                case 20:
                case "end":
                  return u.stop();
              }
          }, a, null, [[1, 8]]);
        })), ue.getParameter("LOG_UPLOAD_INTERVAL"));
      } }]), r;
    }(), Es = function(r, e, t, a, n, s, o, u) {
      var l = 0;
      for (o = !!o && Cd(o, u, 3); l < a; ) {
        if (l in t) {
          if (u = o ? o(t[l], l, e) : t[l], 0 < s && Dd(u))
            n = Es(r, e, u, La(u.length), n, s - 1) - 1;
          else {
            if (9007199254740991 <= n)
              throw TypeError("Exceed the acceptable array length");
            r[n] = u;
          }
          n++;
        }
        l++;
      }
      return n;
    }, CD = Es;
    ba({ target: "Array", proto: !0 }, { flat: function() {
      var r = arguments.length ? arguments[0] : void 0, e = lb(this), t = La(e.length), a = Ah(e, 0);
      return a.length = CD(a, e, e, t, 0, r === void 0 ? 1 : rc(r)), a;
    } }), ba({ target: "Object", stat: !0 }, { values: function(r) {
      return gD(r);
    } });
    var DD = ["CODE"], Xb, Od, R;
    (function(r) {
      r.CHINA = "CN", r.ASIA = "AS", r.NORTH_AMERICA = "NA", r.EUROPE = "EU", r.JAPAN = "JP", r.INDIA = "IN", r.OCEANIA = "OC", r.SOUTH_AMERICA = "SA", r.AFRICA = "AF", r.OVERSEA = "OVERSEA", r.GLOBAL = "GLOBAL";
    })(R || (R = {}));
    var ED = { CN: R.CHINA, NA: R.NORTH_AMERICA, EU: R.EUROPE, AS: R.ASIA, JP: R.JAPAN, IN: R.INDIA, GLOB: R.GLOBAL, AF: R.AFRICA, OC: R.OVERSEA, OVS: R.OVERSEA, SA: R.SOUTH_AMERICA }, oh = Rn((Xb = {}, x(Xb, R.ASIA, { CODE: R.ASIA, AP_DOMAINS: ["ap-web-1-asia.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-asia.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-asia.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-asia.agora.io"], LOG_UPLOAD_SERVER: ["logservice-asia.agora.io"], PROXY_AP: ["proxy-ap-web-asia.agora.io"], PROXY_NGINX: ["southeast-asia.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.NORTH_AMERICA, { CODE: R.NORTH_AMERICA, AP_DOMAINS: ["ap-web-1-north-america.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-north-america.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-north-america.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-north-america.agora.io"], LOG_UPLOAD_SERVER: ["logservice-north-america.agora.io"], PROXY_AP: ["proxy-ap-web-america.agora.io"], PROXY_NGINX: ["east-usa.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.EUROPE, { CODE: R.EUROPE, AP_DOMAINS: ["ap-web-1-europe.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-europe.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-europe.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-europe.agora.io"], LOG_UPLOAD_SERVER: ["logservice-europe.agora.io"], PROXY_AP: ["proxy-ap-web-europe.agora.io"], PROXY_NGINX: ["europe.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.JAPAN, { CODE: R.JAPAN, AP_DOMAINS: ["ap-web-1-japan.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-japan.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-japan.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-japan.agora.io"], LOG_UPLOAD_SERVER: ["logservice-japan.agora.io"], PROXY_AP: ["proxy-ap-web-japan.agora.io"], PROXY_NGINX: ["japan.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.INDIA, { CODE: R.INDIA, AP_DOMAINS: ["ap-web-1-india.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-india.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-india.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-india.agora.io"], LOG_UPLOAD_SERVER: ["logservice-india.agora.io"], PROXY_AP: ["proxy-ap-web-india.agora.io"], PROXY_NGINX: ["india.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.OVERSEA, { CODE: R.OVERSEA, AP_DOMAINS: ["ap-web-1-oversea.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-oversea.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-oversea.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-oversea.agora.io"], LOG_UPLOAD_SERVER: ["logservice-oversea.agora.io"], PROXY_AP: ["proxy-ap-web-oversea.agora.io"], PROXY_NGINX: ["webrtc-cloud-proxy.agora.io"] }), x(Xb, R.GLOBAL, { CODE: R.GLOBAL, AP_DOMAINS: ["ap-web-1.agora.io", "ap-web-2.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-3.agora.io", "ap-web-4.agora.io"], EVENT_REPORT_DOMAIN: ["webcollector-rtm.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["webcollector-1.agora.io"], LOG_UPLOAD_SERVER: ["logservice-rtm.agora.io"], PROXY_AP: ["ap-proxy-1.agora.io", "ap-proxy-2.agora.io"], PROXY_NGINX: ["webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.OCEANIA, { CODE: R.OCEANIA, AP_DOMAINS: ["ap-web-1-oceania.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-oceania.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-oceania.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-oceania.agora.io"], LOG_UPLOAD_SERVER: ["logservice-oceania.agora.io"], PROXY_AP: ["proxy-ap-web-oceania.agora.io"], PROXY_NGINX: ["oceania.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.SOUTH_AMERICA, { CODE: R.SOUTH_AMERICA, AP_DOMAINS: ["ap-web-1-south-america.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-south-america.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-south-america.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-south-america.agora.io"], LOG_UPLOAD_SERVER: ["logservice-south-america.agora.io"], PROXY_AP: ["proxy-ap-web-south-america.agora.io"], PROXY_NGINX: ["south-america.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.AFRICA, { CODE: R.AFRICA, AP_DOMAINS: ["ap-web-1-africa.agora.io"], AP_BACKUP_DOMAINS: ["ap-web-2-africa.agora.io"], EVENT_REPORT_DOMAIN: ["statscollector-1-africa.agora.io"], EVENT_REPORT_BACKUP_DOMAIN: ["statscollector-2-africa.agora.io"], LOG_UPLOAD_SERVER: ["logservice-south-africa.agora.io"], PROXY_AP: ["proxy-ap-web-africa.agora.io"], PROXY_NGINX: ["africa.webrtc-cloud-proxy.sd-rtn.com"] }), x(Xb, R.CHINA, { CODE: R.CHINA, AP_DOMAINS: ["webrtc2-2.ap.sd-rtn.com"], AP_BACKUP_DOMAINS: ["webrtc2-4.ap.sd-rtn.com"], EVENT_REPORT_DOMAIN: ["web-3.statscollector.sd-rtn.com"], EVENT_REPORT_BACKUP_DOMAIN: ["web-4.statscollector.sd-rtn.com"], LOG_UPLOAD_SERVER: ["logservice-china.agora.io"], PROXY_AP: ["proxy-ap-web.agoraio.cn"], PROXY_NGINX: ["east-cn.webrtc-cloud-proxy.sd-rtn.com"] }), Xb)), ag = (Od = {}, x(Od, R.ASIA, [R.CHINA, R.JAPAN, R.INDIA]), x(Od, R.EUROPE, []), x(Od, R.NORTH_AMERICA, []), x(Od, R.SOUTH_AMERICA, []), x(Od, R.OCEANIA, []), x(Od, R.AFRICA, []), Od), Fs = [R.OVERSEA, R.GLOBAL, R.CHINA, R.NORTH_AMERICA, R.EUROPE, R.ASIA, R.JAPAN, R.INDIA, R.OCEANIA, R.SOUTH_AMERICA, R.AFRICA], Un = function(r) {
      return Object.values(ag).flat().includes(r);
    }, zv = function(r) {
      var e;
      return (e = lh(ag).find(function(t) {
        return (t = Xa(t, 2))[0], t[1].includes(r);
      })) === null || e === void 0 ? void 0 : e[0];
    }, FD = function(r) {
      return r.sort(function(e, t) {
        return Fs.indexOf(e) - Fs.indexOf(t);
      });
    }, Ue = function(r) {
      var e = /* @__PURE__ */ new Set();
      if ((r = FD(r).slice(0, 3).map(function(t) {
        var a = oh[t];
        if (a === void 0)
          throw new qd("invalid area key");
        return t = a.CODE, a = Ei(a, DD), e.add(t), a;
      })).length === 0)
        throw new qd("areas cannot be empty");
      return jb({ CODES: e }, r.reduce(function(t, a) {
        for (var n = 0, s = lh(t); n < s.length; n++) {
          var o = Xa(s[n], 2), u = o[0];
          o = o[1], t[u] = Array.from(new Set([].concat(W(a[u]), W(o))));
        }
        return t;
      }));
    }, ca, Gs = function() {
      var r = ja(M.mark(function e(t, a) {
        var n, s, o, u, l, f = arguments;
        return M.wrap(function(d) {
          for (; ; )
            switch (d.prev = d.next) {
              case 0:
                if (!(2 < (s = 2 < f.length && f[2] !== void 0 ? f[2] : 0))) {
                  d.next = 3;
                  break;
                }
                return d.abrupt("return");
              case 3:
                return o = { withCredentials: !0, body: t, timeout: 2e4 }, u = 0 < s ? (ca == null ? void 0 : ca.LOG_UPLOAD_SERVER[0]) || "rtm.logservice.sd-rtn.com" : (ca == null ? void 0 : ca.LOG_UPLOAD_SERVER[0]) || "logservice-rtm.agora.io", l = a ? "https://".concat((n = ca == null ? void 0 : ca.PROXY_NGINX[0]) !== null && n !== void 0 ? n : "webrtc-cloud-proxy.sd-rtn.com", "/ls/?h=").concat(u, "&p=443&d=upload/v1") : "https://".concat(u, "/upload/v1"), d.next = 8, jh(l, o).catch(function(h) {
                  return Gs(t, a, s + 1);
                });
              case 8:
              case "end":
                return d.stop();
            }
        }, e);
      }));
      return function(e, t) {
        return r.apply(this, arguments);
      };
    }(), Hs = new BD({ processId: "process-".concat(Mg), sdkVersion: "Agora_RTM_SDK_for_Web_".concat("v1.5.0-0-g83bd874d"), uploadRequest: Gs, rtmConfig: {} }), Ml = "text payload rawMessage thumbnail attributeInfos keys value extra".split(" "), Is = "account ticket uid detail token account fileName cname user group key origin users src dst lastUpdateUserId channel cert wan_ip".split(" "), Js = ["serverReceivedTs", "hasPeerReceived", "messageType", "enableNotificationToChannelMembers", "lastUpdateTs"], GD = "ChannelMessage MemberLeft MessageFromPeer LocalInvitationRefused LocalInvitationAccepted RemoteInvitationCanceled PeersOnlineStatusChanged AttributesUpdated MemberJoined".split(" "), Ve = function(r) {
      if (typeof r == "string")
        return Ka(r);
      if (Array.isArray(r) && r.every(function(s) {
        return typeof s == "string";
      }))
        return r.map(function(s) {
          return Ka(s);
        });
      if (!Hm(r)) {
        for (var e = {}, t = 0; t < Js.length; t++) {
          var a = Js[t];
          a in r && (e[a] = r[a]);
        }
        if (0 < Object.keys(e).length)
          return e;
        if (5 > Object.keys(r).length) {
          for (t = 0, r = Object.entries(r); t < r.length; t++) {
            var n = Xa(r[t], 2);
            a = n[0], n = n[1], Ml.includes(a) ? e[a] = "[Hidden Info]" : e[Ka(a)] = typeof n == "string" ? Ka(n) : "[Sensitive Info]";
          }
          return e;
        }
        return "[Sensitive Info]";
      }
      return r;
    }, Ks = function(r) {
      return oa(r) === "object" ? Be(r) ? Qn(Fe(r, 5), Ml, Is) : r.constructor && r.constructor.name : r;
    }, Ls = function(r, e) {
      return r instanceof Error ? r.message : typeof r != "string" ? JSON.stringify(Qn(Fe(r, 5), Ml, Is)) : (e = e.map(function(t) {
        return t instanceof Error ? t.message : oa(t) === "object" ? Bs(Array.isArray(t) ? t.map(Ks) : Ks(t)) : t;
      }), Nn.apply(void 0, [r.replace(/%[%Oo]/g, function(t) {
        return t === "%%" ? "%" : t === "%o" || t === "%O" ? "%s" : t;
      })].concat(W(e))));
    }, HD = 1, Ms = function(r, e, t) {
      var a = Cs(r);
      return a.enabled = !0, a.log = t, a.useColors = !1, function(n) {
        for (var s = arguments.length, o = Array(1 < s ? s - 1 : 0), u = 1; u < s; u++)
          o[u - 1] = arguments[u];
        if (e.enableLogUpload) {
          s = ih(n);
          var l = Ls(s, o);
          Hs.upload({ log_item_id: "".concat(HD++), log_level: r, payload_str: "[".concat(xD(), "] ").concat(r, " - ").concat(256 < l.length ? l.slice(0, 256) : l) });
        }
        switch (s = function(f) {
          var d = l || Ls(ih(n), o), h = xc.LOG_HANDLER;
          typeof h == "function" && h({ level: f, message: d }), a(d);
        }, r) {
          case "RTM:INFO":
            e.logFilter.info && s("log");
            break;
          case "RTM:WARN":
            e.logFilter.warn && s("warning");
            break;
          case "RTM:ERROR":
            e.logFilter.error && s("error");
            break;
          case "RTM:TRACK":
            e.logFilter.track && s("log");
            break;
          case "RTM:MSG:RECV":
          case "RTM:MSG:SEND":
            e.logFilter.debug && s("debug");
            break;
          case "RTM:DEBUG":
            e.logFilter.debug && s("debug");
        }
      };
    }, Nl, Ns = function(r) {
      return function(e) {
        var t = Nl === 1 || r === void 0 ? "" : "Ins#".concat(r, " ");
        return "".concat(t).concat(e);
      };
    }, Ol = function(r, e, t) {
      var a = Ns(Nl);
      return Ms("RTM:".concat(e), t, function(n) {
        return r(a(n));
      });
    }, Ac = function() {
      return function(r) {
        function e(a, n) {
          var s = 2 < arguments.length && arguments[2] !== void 0 && arguments[2];
          ua(this, e);
          var o = t.call(this);
          if (x(z(o), "logError", void 0), x(z(o), "invokeTracker", void 0), x(z(o), "resultTracker", void 0), x(z(o), "errorTracker", void 0), x(z(o), "eventTracker", void 0), x(z(o), "info", void 0), x(z(o), "warn", void 0), x(z(o), "log", void 0), x(z(o), "genLogger", void 0), x(z(o), "loggerId", void 0), x(z(o), "logger", void 0), x(z(o), "name", void 0), o.logger = a, o.name = n, o.loggerId = a.loggerId, o.info = a.info, o.warn = a.warn, o.logError = a.logError, o.genLogger = a.genLogger, o.log = a.genLogger("RTM:DEBUG", "<".concat(n, "> ")), o.invokeTracker = a.genTracker("Invoke"), o.eventTracker = a.genTracker("Event"), o.resultTracker = a.genTracker("Result"), o.errorTracker = a.genTracker("Error"), s) {
            var u = o.emit.bind(z(o));
            o.emit = function() {
              for (var l = arguments.length, f = Array(l), d = 0; d < l; d++)
                f[d] = arguments[d];
              l = f[0], d = f.slice(1);
              var h = GD.includes(l);
              o.eventTracker.apply(o, ["%s: ".concat(0 < d.length ? "%s emitted with args: ".concat(d.map(function() {
                return "%o";
              })) : "%s emitted"), n, l].concat(W(h ? d.map(Ve) : d)));
              try {
                u.apply(void 0, f);
              } catch (p) {
                o.logError("Caught in the callback function of the event %s", l, p);
              }
            };
          }
          return o;
        }
        Ga(e, r);
        var t = Ha(e);
        return e;
      }(ya);
    }, ID = function(r) {
      return Ol(console.log.bind(console), "INFO", r);
    }, JD = function(r) {
      return Ol(console.warn.bind(console), "WARN", r);
    }, KD = function(r) {
      return Ol(console.error.bind(console), "ERROR", r);
    }, Os = function(r, e) {
      return function(t) {
        var a = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : "", n = Ns(r), s = console.debug.bind(console), o = Ms(t, e, function(u) {
          return s(n(u));
        });
        return function(u) {
          for (var l = arguments.length, f = Array(1 < l ? l - 1 : 0), d = 1; d < l; d++)
            f[d - 1] = arguments[d];
          return o.apply(void 0, [a + u].concat(f));
        };
      };
    }, LD = function(r, e) {
      return function(t) {
        return Os(r, e)("RTM:TRACK", "[".concat(t, "] "));
      };
    }, rj = H.URI, Bv = ti, MD = Ei(aD, ["Wrapper"]), Vn = kl(MD, "URI"), Ps = function(r, e) {
      var t = -1, a = r.length, n = a - 1;
      for (e = e === void 0 ? a : e; ++t < e; ) {
        var s = r[a = is(t, n)];
        r[a] = r[t], r[t] = s;
      }
      return r.length = e, r;
    }, ND = function(r) {
      return Ps(Ji(r));
    }, OD = function(r) {
      return Ps(tj(r));
    }, Af = function(r) {
      return (pb(r) ? ND : OD)(r);
    }, Bf = { 0: 9591, 1: 9593 }, ve = function(r) {
      var e = Zf(null);
      return "https://".concat(e ? null : r, "/api/v1");
    }, PD = wb.apply(void 0, W(Af(["web-1.ap.sd-rtn.com", "web-2.ap.sd-rtn.com"].map(ve)))), QD = wb.apply(void 0, W(Af(["ap-web-1.agora.io", "ap-web-2.agora.io"].map(ve)))), RD = wb.apply(void 0, W(Af(["web-3.ap.sd-rtn.com", "web-4.ap.sd-rtn.com"].map(ve)))), SD = wb.apply(void 0, W(Af(["ap-web-3.agora.io", "ap-web-4.agora.io"].map(ve)))), Qs = ui(), Pl = function(r) {
      function e(a, n, s, o, u, l) {
        ua(this, e);
        var f = t.call(this, u, nj("Socket-", u.loggerId));
        if (x(z(f), "isActiveClose", !1), x(z(f), "loggedIn", !1), x(z(f), "useNewDomain", void 0), x(z(f), "receivedPacket", new nb()), x(z(f), "open$", void 0), x(z(f), "input$", new nb()), x(z(f), "userJoin$", new nb()), x(z(f), "attemptsSinceLastError", 0), x(z(f), "message$", new nb()), x(z(f), "socket$", void 0), x(z(f), "toClose", new nb()), x(z(f), "toReconnect", new nb()), x(z(f), "sendLogger", void 0), x(z(f), "receiveLogger", void 0), x(z(f), "ip", void 0), x(z(f), "env", void 0), x(z(f), "ticket", void 0), x(z(f), "context", void 0), x(z(f), "getDomain", function() {
          return Wn(f.ip, f.useNewDomain);
        }), x(z(f), "socketReconnector", function(p) {
          var m = function(_) {
            return f.attemptsSinceLastError += 1, f.warn("The %s of Env %d reconnecting %s", f.name, f.env, _.message), Zc(3e3);
          };
          return p.pipe(Ya(function(_) {
            return f.log("socket connection closed"), f.loggedIn = !1, 2 <= f.attemptsSinceLastError ? (f.warn("socket connection failure"), f.emit("connectionFailure"), f.close(), pa(_)) : f.isActiveClose ? Nb : (f.emit("reconnect"), f.useNewDomain = !f.useNewDomain, pa(_));
          }), Oe(function(_) {
            return _.pipe(Fc(m));
          }));
        }), f.ip = a, f.env = n, f.ticket = s, f.context = o, f.useNewDomain = l != null ? l : 0.5 <= Math.random(), f.sendLogger = f.genLogger("RTM:MSG:SEND"), f.receiveLogger = f.genLogger("RTM:MSG:RECV"), n !== 0 && n !== 1)
          throw new Qs({ ILLEGAL_RTM_ENV: "The env number is out of rtm env count" });
        var d = Bf[n];
        f.log("Opening websocket address %s for the Env %d", f.ip, f.env);
        var h = Ec(f.input$, f.userJoin$.pipe(qv(2)), f.message$).pipe(Da(function(p) {
          return ti.encode(p).finish();
        }));
        return a = Ec(rv("", { protocols: [], makeWebSocket: function() {
          if (f.context.config.enableCloudProxy || f.context.socketUseProxy) {
            if (f.context.cloudProxyServers.length === 0)
              throw f.logError("No cloud proxy server to connect"), new Ja();
            var p = Zf(null) ? JSON.parse(null.replace(/-/g, ".")) : f.context.cloudProxyServers;
            p = Te(p = "wss://".concat(Wn(Xn(p), !1), "/"), "sid", f.context.sid), p = Te(p, "remote_port", d.toString()), p = Te(p, "remote_ip", f.ip), p = Te(p, "token", f.context.key), p = new WebSocket(p);
          } else
            p = new WebSocket("wss://".concat(f.getDomain(), ":").concat(d));
          return p.binaryType = "arraybuffer", p;
        } }), f.toReconnect), f.socket$ = ab(a, xl.pipe(Hb(7e3), Ya(function(p) {
          return vb(p) && f.warn("socket open timed out"), pa(p);
        }))).pipe(Da(function(p) {
          if (p instanceof Error)
            throw f.warn("Env_%d: Force reconnect the socket", f.env), p;
          return p(h).pipe(Da(function(m) {
            return ti.decode(new Uint8Array(m));
          }));
        }), f.socketReconnector), f.open$ = f.socket$.pipe(sa(function(p) {
          f.log("Websocket opened", f.name), p.subscribe(function(m) {
            var _ = m.data;
            m = rj[m.uri].slice(0, -3), _ = Vn[m].decode(_);
            var w = SB({}, kl(_, "toJSON"), function(B, L) {
              return L instanceof ma ? Kn(L) : L;
            }), S = !1;
            if ((_ instanceof qs || _ instanceof ps) && _.instance.lessThanOrEqual(4294967295) && (S = !0), _ instanceof rs || _ instanceof ss) {
              var O = _.instance, k = _.sequence;
              (_.dialogue.lessThanOrEqual(4294967295) || O.lessThanOrEqual(4294967295) || k.lessThan(1)) && (S = !0);
            }
            S ? f.warn("Env_%d: Illegal %s, abandoned %o", f.env, m, w) : (m !== "Pong" && f.receiveLogger("Env_%d: %s %o", f.env, m, w), f.receivedPacket.next([m, _]));
          }, function() {
          });
        }), Sf(void 0), Gc(f.toClose), Pe()), f;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "address", get: function() {
        return "".concat(this.ip, ":").concat(Bf[this.env]);
      } }, { key: "sendPacket", value: function(a, n) {
        if (a !== "Ping") {
          var s = hd(n, function(o) {
            return o instanceof ma ? Kn(o) : o;
          });
          this.sendLogger("Env_%d: %s %o", this.env, a, s);
        }
        n = Av(a, n), a === "UserJoin" ? this.userJoin$.next(n) : a === "Message" ? this.message$.next(n) : this.input$.next(n);
      } }, { key: "close", value: function() {
        this.isActiveClose = !0, this.loggedIn = !1, this.toClose.next();
      } }, { key: "fromReceived", value: function(a) {
        return this.receivedPacket.pipe(Ob(function(n) {
          return Xa(n, 1)[0] === a;
        }), Da(function(n) {
          return Xa(n, 2)[1];
        }));
      } }, { key: "forceReconnect", value: function() {
        this.toReconnect.next(new Qs({ FORCE_RECONNECTING: "Connection seems broken, try force reconnecting" }));
      } }]), e;
    }(Ac());
    ba({ target: "String", proto: !0, forced: us }, { padStart: function(r) {
      return cD(this, r, 1 < arguments.length ? arguments[1] : void 0);
    } });
    var TD = function(r) {
      var e = $f(oh);
      r = vv(r);
      for (var t = 0; t < e.length; t++) {
        var a = oh[e[t]];
        if (a != null && a.AP_DOMAINS.includes(r) || a != null && a.AP_BACKUP_DOMAINS.includes(r) || a != null && a.PROXY_AP.includes(r))
          return [a.CODE];
      }
      return [R.CHINA, R.GLOBAL];
    }, UD = { INVALID_APP_ID: "Illegal App ID", NO_AUTHORIZED: "Signature verification failed", TOKEN_TIMEOUT: "Dynamic key expired", INVALID_TOKEN_UID: "UID in the security key(token) is not valid", APP_ID_NO_ACTIVATED: "The vendor is not activated", DYNAMIC_KEY_NOT_ENABLED: "The vendor did not enable the dynamic key, but uses the dynamic key", DYNAMIC_ENABLED_BUT_STATIC_KEY: "The vendor enabled the dynamic key, but uses the static key", TOKEN_EXPIRED: "The token has expired", INVALID_USER_ID: "The user ID to login does not match the token", FORBIDDEN_REGION: "Forbidden to access the request in this area", CANNOT_MEET_AREA_DEMAND: "Cannot allocate to meet the requirements of the given area limit" }, Rs = { 5: "INVALID_APP_ID", 7: "INVALID_USER_ID", 9: "NO_AUTHORIZED", 10: "TOKEN_TIMEOUT", 11: "APP_ID_NO_ACTIVATED", 12: "INVALID_TOKEN_UID", 13: "TOKEN_EXPIRED", 14: "DYNAMIC_KEY_NOT_ENABLED", 15: "DYNAMIC_ENABLED_BUT_STATIC_KEY", 18: "FORBIDDEN_REGION", 19: "CANNOT_MEET_AREA_DEMAND" }, VD = [100, 101, 102], vi = /web-(\d)/, Ss = function(r) {
      function e(a, n) {
        var s = 2 < arguments.length && arguments[2] !== void 0 && arguments[2];
        ua(this, e);
        var o = t.call(this, n, "AccessPoint");
        return x(z(o), "handleUniLbsError", function(u, l) {
          var f = u;
          if (4 < u.toString().length) {
            var d = u.toString().padStart(8, "0"), h = parseInt(d.slice(0, 4), 10);
            if (d = parseInt(d.slice(4, 8), 10), h === 201)
              f = d;
            else if (h === 101 && !VD.includes(d))
              return pa(Error("service is currently unavailable"));
          }
          if (h = f.toString(), !Object.keys(Rs).includes(h))
            return (u = new Ja(["Login is rejected by the server. The response code is %d", u], Ng)).serverCode = f, pa(u);
          switch (h = Rs[h], f = UD[h], h) {
            case "INVALID_APP_ID":
            case "APP_ID_NO_ACTIVATED":
              return (l = new yf(f, Vr)).serverCode = u, pa(l);
            case "INVALID_USER_ID":
              return (l = new yf(f, pi)).serverCode = u, pa(l);
            case "TOKEN_EXPIRED":
            case "TOKEN_TIMEOUT":
              return (l = new yf(f, qi)).serverCode = u, pa(l);
            case "NO_AUTHORIZED":
            case "INVALID_TOKEN_UID":
            case "DYNAMIC_KEY_NOT_ENABLED":
            case "DYNAMIC_ENABLED_BUT_STATIC_KEY":
              return (l = new yf(f, Wr)).serverCode = u, pa(l);
            case "CANNOT_MEET_AREA_DEMAND":
              return (l = TD(l)).forEach(function(p) {
                return o.failedAreas.add(p);
              }), o.failedAreas.size === (ca === void 0 ? 2 : ca.CODES.size) ? ((l = new Z(f, Ng)).serverCode = u, pa(l)) : pa(Error("ap ".concat(l.join(", "), " cannot meet requirement")));
            case "FORBIDDEN_REGION":
              return (l = new Ja(f, Ng)).serverCode = u, pa(l);
            default:
              return pa(In("ApResErrType", h));
          }
        }), x(z(o), "getApEdgeInfo$", void 0), x(z(o), "getApEdgeInfoEndFirst$", void 0), x(z(o), "apFinish$", new nb()), x(z(o), "retryCount", 0), x(z(o), "failedAreas", /* @__PURE__ */ new Set()), x(z(o), "usedUrl", []), x(z(o), "newDomainUsed", !1), x(z(o), "backupNewDomainUsed", !1), x(z(o), "genUrl", function() {
          return ca === void 0 ? Zi.apply(void 0, W(Af([PD, QD]))).pipe($i(function(u) {
            return wb.apply(void 0, W(u));
          })) : wb.apply(void 0, W(ca.AP_DOMAINS.slice(0, 3).map(ve)));
        }), x(z(o), "genBackupUrl", function() {
          return ca === void 0 ? Zi.apply(void 0, W(Af([RD, SD]))).pipe($i(function(u) {
            return wb.apply(void 0, W(u));
          })) : wb.apply(void 0, W(ca.AP_BACKUP_DOMAINS.slice(0, 3).map(ve)));
        }), x(z(o), "getApUrl$", function(u) {
          var l, f;
          return o.genUrl().pipe(Ob(function(d) {
            return (!o.newDomainUsed || !d.includes("sd-rtn.com")) && (d.includes("sd-rtn.com") && (o.newDomainUsed = !0), !Il(o.usedUrl, function(h) {
              var p;
              return h === ((p = d.match(vi)) === null || p === void 0 ? void 0 : p[1]);
            }));
          }), sa(function(d) {
            var h;
            ca === void 0 && typeof (d = (h = d.match(vi)) === null || h === void 0 ? void 0 : h[1]) == "string" && o.usedUrl.push(d);
          }), db(u ? Math.max(xc.RECONNECTING_AP_NUM, (l = ca == null ? void 0 : ca.CODES.size) !== null && l !== void 0 ? l : 0) : (f = ca == null ? void 0 : ca.CODES.size) !== null && f !== void 0 ? f : 2), Zd(function() {
            return e.runOutOfUrlSymbol;
          }), Ya(function(d, h) {
            return o.newDomainUsed = !1, d === e.runOutOfUrlSymbol ? (o.usedUrl = [], h) : pa(d);
          }));
        }), x(z(o), "getBackupApUrl$", function(u) {
          var l, f;
          return o.genBackupUrl().pipe(Ob(function(d) {
            return (!o.backupNewDomainUsed || !d.includes("sd-rtn.com")) && (d.includes("sd-rtn.com") && (o.backupNewDomainUsed = !0), !Il(o.usedUrl, function(h) {
              var p;
              return h === ((p = d.match(vi)) === null || p === void 0 ? void 0 : p[1]);
            }));
          }), sa(function(d) {
            var h;
            ca === void 0 && typeof (d = (h = d.match(vi)) === null || h === void 0 ? void 0 : h[1]) == "string" && o.usedUrl.push(d);
          }), db(u ? Math.max(xc.RECONNECTING_AP_NUM, (l = ca == null ? void 0 : ca.CODES.size) !== null && l !== void 0 ? l : 0) : (f = ca == null ? void 0 : ca.CODES.size) !== null && f !== void 0 ? f : 2), Zd(function() {
            return e.runOutOfUrlSymbol;
          }), Ya(function(d, h) {
            return o.backupNewDomainUsed = !1, d === e.runOutOfUrlSymbol ? (o.usedUrl = [], h) : pa(d);
          }));
        }), x(z(o), "getProxyApUrl$", function(u) {
          var l, f;
          return wb.apply(void 0, W(((ca == null ? void 0 : ca.PROXY_AP.slice(0, 3)) || ["ap-proxy-1.agora.io", "ap-proxy-2.agora.io"]).map(ve))).pipe(db(u ? Math.max(xc.RECONNECTING_AP_NUM, (l = ca == null ? void 0 : ca.CODES.size) !== null && l !== void 0 ? l : 0) : (f = ca == null ? void 0 : ca.CODES.size) !== null && f !== void 0 ? f : 2));
        }), x(z(o), "context", void 0), x(z(o), "fetchCloudProxy", function(u, l) {
          var f = nj("AP-", o.loggerId);
          o.log("The AccessPoint requests %s(%s)", u, f);
          var d, h = new AbortController();
          return o.apFinish$.pipe(db(1)).subscribe(function() {
            return h.abort();
          }), wd(ja(M.mark(function p() {
            var m;
            return M.wrap(function(_) {
              for (; ; )
                switch (_.prev = _.next) {
                  case 0:
                    return m = gh(0, Number.MAX_SAFE_INTEGER), o.log("%s request opid: %d", f, m), _.abrupt("return", jh(u, { headers: { "X-Packet-Service-Type": "0", "X-Packet-URI": "90", "Content-Type": "application/json" }, body: { sid: o.context.sid, opid: m, appid: o.context.appId, client_ts: Math.ceil(Date.now() / 1e3), request_bodies: [{ uri: 22, buffer: { service_ids: [7, 16], key: l != null ? l : o.context.key, cname: o.context.uid, uid: 0, detail: jb({}, ca === void 0 ? { 11: [R.CHINA, R.GLOBAL].join(), 12: "1" } : { 11: Array.from(ca.CODES).map(function(w) {
                      return w === R.OVERSEA ? "".concat(R.ASIA, ",").concat(R.EUROPE, ",").concat(R.AFRICA, ",").concat(R.NORTH_AMERICA, ",").concat(R.SOUTH_AMERICA, ",").concat(R.OCEANIA) : w;
                    }).join(","), 12: "1" }) } }] }, signal: h.signal }));
                  case 3:
                  case "end":
                    return _.stop();
                }
            }, p);
          }))).pipe(Ya(function(p) {
            return p.name !== "AbortError" && (o.logError(p), o.warn("The AP server %s request failure", u, p)), Nb;
          }), Ab((d = ja(M.mark(function p(m) {
            var _, w, S, O, k, B, L, G, _r, ga, _n, Fa, N, _t, Y, _a, X, J, ea;
            return M.wrap(function(wa) {
              for (; ; )
                switch (wa.prev = wa.next) {
                  case 0:
                    if (_ = m.responseText, w = JSON.parse(_), o.log("The %s response is %o", f, w), ((S = w.response_body) === void 0 || S.length === 0 || S.some(function(_s) {
                      var _d;
                      return ((_d = _s.buffer) === null || _d === void 0 ? void 0 : _d.code) === void 0 || _s.uri !== 23;
                    })) && pa(new Ja("cloud proxy response_body not valid", Ng)), (O = S.filter(function(_s) {
                      return _s.buffer.code !== 0;
                    })).length === 0) {
                      wa.next = 14;
                      break;
                    }
                    if ((k = O.find(function(_s) {
                      return _s.buffer.flag === 128;
                    })) === void 0) {
                      wa.next = 12;
                      break;
                    }
                    return wa.abrupt("return", o.handleUniLbsError(k.buffer.code, u));
                  case 12:
                    return o.logError("cloud proxy error response"), wa.abrupt("return", o.handleUniLbsError(O[0].buffer.code, u));
                  case 14:
                    for (B = [], L = 0; L < S.length; L++)
                      if (((ga = S[L]) == null || (G = ga.buffer) === null || G === void 0 ? void 0 : G.flag) === 262144)
                        (_n = ga.buffer) === null || _n === void 0 || (Fa = _n.edges_services) === null || Fa === void 0 || (N = Fa.forEach) === null || N === void 0 || N.call(Fa, function(_s) {
                          Gn(_s = _s.ip) && o.context.cloudProxyServers.indexOf(_s) === -1 && (o.log("got cloud proxy server: %s", _s), o.context.cloudProxyServers.push(_s));
                        });
                      else if ((ga == null || (_r = ga.buffer) === null || _r === void 0 ? void 0 : _r.flag) === 128) {
                        for (X = function(_s, _d) {
                          var _o = _d[_s];
                          B.some(function(_p) {
                            return _p.ip === _o.ip;
                          }) || B.push({ ip: _o.ip, ticket: ga.buffer.cert });
                        }, J = 0, ea = ga.buffer.edges_services; J < ea.length; J++)
                          X(J, ea);
                        o.context.rtmArea = (_t = (Y = ga.buffer) === null || Y === void 0 || (_a = Y.detail) === null || _a === void 0 ? void 0 : _a[9]) !== null && _t !== void 0 ? _t : "";
                      }
                    return wa.abrupt("return", wb.apply(void 0, W(B).concat([Kg])));
                  case 19:
                  case "end":
                    return wa.stop();
                }
            }, p);
          })), function(p) {
            return d.apply(this, arguments);
          })), Ya(function(p) {
            return Ma(p) ? pa(p) : Nb;
          }), $g(), Ob(function(p) {
            return p !== void 0 && typeof p.ip == "string" && typeof p.ticket == "string" && Gn(p.ip);
          }));
        }), x(z(o), "fetchAp", function(u, l) {
          var f = nj("AP-", o.loggerId);
          o.log("The AccessPoint requests %s(%s)", u, f);
          var d, h = new AbortController();
          return o.apFinish$.pipe(db(1)).subscribe(function() {
            return h.abort();
          }), wd(ja(M.mark(function p() {
            var m;
            return M.wrap(function(_) {
              for (; ; )
                switch (_.prev = _.next) {
                  case 0:
                    return m = gh(0, Number.MAX_SAFE_INTEGER), o.log("%s request opid: %d", f, m), _.abrupt("return", jh(u, { headers: { "X-Packet-Service-Type": "0", "X-Packet-URI": "69", "Content-Type": "application/json" }, body: { flag: 128, opid: m, key: l || o.context.key, cname: o.context.uid, detail: jb({}, ca === void 0 ? { 11: [R.CHINA, R.GLOBAL].join(), 12: "1" } : { 11: Array.from(ca.CODES).map(function(w) {
                      return w === R.OVERSEA ? "".concat(R.ASIA, ",").concat(R.EUROPE, ",").concat(R.AFRICA, ",").concat(R.NORTH_AMERICA, ",").concat(R.SOUTH_AMERICA, ",").concat(R.OCEANIA) : w;
                    }).join(","), 12: "1" }), uid: 0, sid: o.context.sid }, signal: h.signal }));
                  case 3:
                  case "end":
                    return _.stop();
                }
            }, p);
          }))).pipe(Ya(function(p) {
            return p.name !== "AbortError" && (o.logError(p), o.warn("The AP server %s request failure", u, p)), Nb;
          }), Ab((d = ja(M.mark(function p(m) {
            var _, w, S, O, k, B, L, G;
            return M.wrap(function(_r) {
              for (; ; )
                switch (_r.prev = _r.next) {
                  case 0:
                    if (_ = m.responseText, w = JSON.parse(_), o.log("The %s response is %o", f, w), O = (S = w).code, k = S.addresses, B = S.detail, o.info(w), O === 0) {
                      _r.next = 7;
                      break;
                    }
                    return _r.abrupt("return", o.handleUniLbsError(O, u));
                  case 7:
                    if (L = k, Zf(null) && (G = JSON.parse(null.replace(/-/g, ".")), L = G.map(function(ga) {
                      return { ip: ga, ticket: L[0].ticket };
                    })), L.length !== 0) {
                      _r.next = 12;
                      break;
                    }
                    return _r.abrupt("return", pa(Error("No available edge address to connect")));
                  case 12:
                    return o.context.rtmArea = B == null ? void 0 : B[9], _r.abrupt("return", wb.apply(void 0, W(L).concat([Kg])));
                  case 14:
                  case "end":
                    return _r.stop();
                }
            }, p);
          })), function(p) {
            return d.apply(this, arguments);
          })), $g(), Ya(function(p) {
            return Ma(p) ? pa(p) : Nb;
          }), Ob(function(p) {
            return p !== void 0 && typeof p.ip == "string" && typeof p.ticket == "string";
          }));
        }), o.context = a, o.getApEdgeInfoEndFirst$ = function() {
          var u = 0 < arguments.length && arguments[0] !== void 0 && arguments[0];
          return Zc(0, u || s ? xc.RECONNECTING_AP_INTERVAL : 2e3).pipe(db(1), sa(function() {
            o.retryCount += 1;
          }), Ab(function() {
            return o.context.config.enableCloudProxy || o.context.socketUseProxy ? o.getProxyApUrl$(u || s) : (4 <= o.retryCount && (o.retryCount = 0), 3 >= o.retryCount ? o.getApUrl$(u || s) : o.getBackupApUrl$(u || s));
          }), Ab(function(l) {
            return o.context.config.enableCloudProxy || o.context.socketUseProxy ? o.fetchCloudProxy(l) : o.fetchAp(l);
          }), Ya(function(l) {
            return l instanceof Pb && o.warn("AP request timeout"), pa(l);
          }), nn(function(l) {
            return l.ip;
          }), Gc(o.apFinish$));
        }, o.getApEdgeInfo$ = function(u) {
          return Zc(0, u || s ? xc.RECONNECTING_AP_INTERVAL : 2e3).pipe(db(8), sa(function() {
            o.retryCount += 1;
          }), Ab(function() {
            return o.context.config.enableCloudProxy || o.context.socketUseProxy ? o.getProxyApUrl$(u || s) : 3 >= o.retryCount ? o.getApUrl$(u || s) : o.getBackupApUrl$(u || s);
          }), Ab(function(l) {
            return (o.context.config.enableCloudProxy || o.context.socketUseProxy ? o.fetchCloudProxy(l) : o.fetchAp(l)).pipe();
          }), Ya(function(l) {
            return l instanceof Pb && o.warn("AP request timeout"), pa(l);
          }), nn(function(l) {
            return l.ip;
          }), Gc(o.apFinish$));
        }, o;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "clearUp", value: function() {
        this.failedAreas.clear(), this.retryCount = 0;
      } }]), e;
    }(Ac());
    x(Ss, "runOutOfUrlSymbol", Symbol("AP urls are used up"));
    var Ts = ui(), Us = function(r) {
      function e(a, n, s) {
        ua(this, e);
        var o = t.call(this, n, "Connection");
        x(z(o), "apClient", void 0), x(z(o), "lastOpenSockets", [new Qe(1), new Qe(1)]), x(z(o), "curOpenSockets", [void 0, void 0]), x(z(o), "ipIterator", 0), x(z(o), "loginSocketOpenFailureCount", 0), x(z(o), "firstEnv", 0.5 <= Math.random() ? 1 : 0), x(z(o), "firstSocketOpener", void 0), x(z(o), "secondSocketOpener", void 0), x(z(o), "firstOpenKeeperSubject", new nb()), x(z(o), "secondOpenKeeperSubject", new nb()), x(z(o), "blacklistedIP", {}), x(z(o), "edgeInfoReplayed", void 0), x(z(o), "firstEnvOpenSocket", void 0), x(z(o), "firstOpenKeeperSub", void 0), x(z(o), "secondOpenKeeperSub", void 0), x(z(o), "context", void 0), x(z(o), "logger", void 0), o.context = a, o.logger = n, o.apClient = new Ss(o.context, n), o.apClient.apFinish$.subscribe(function() {
          o.log("Ap client fetch finished");
        });
        var u, l = [];
        return o.edgeInfoReplayed = o.apClient.getApEdgeInfo$(s).pipe(Oe(function(f) {
          return f.pipe(sa(function(d) {
            if (Ma(d))
              throw d;
          }), Yd(s ? ue.getParameter("RECONNECTING_AP_INTERVAL") : 900), Gc(Zc(2e4)));
        }), Ob(function(f) {
          var d;
          return !Il(l, f) && 1 >= ((d = o.blacklistedIP[f.ip]) !== null && d !== void 0 ? d : 0);
        }), Zd(function() {
          return new Ts({ AP_NO_AVAILABLE_EDGE: "No available edge address to connect" });
        }), sa(function(f) {
          l.push(f), o.log("An edge info got %o", f);
        }), sa({ error: function(f) {
          o.emit("connectionInitFailure", f);
        } }), ch(function() {
          o.apClient.clearUp();
        }), qn()), o.firstEnvOpenSocket = o.edgeInfoReplayed.pipe(Ab(function(f) {
          if (f === void 0)
            return pa(Error("Invalid edge info"));
          var d = new Pl(f.ip, o.firstEnv, f.ticket, o.context, n, u);
          if (o.firstEnv = o.firstEnv === 1 ? 0 : 1, d.once("connectionFailure", function() {
            return o.onSocketConnectionFailure(d);
          }), !s && xc.ENABLE_EDGE_AUTO_FALLBACK && !o.context.config.enableCloudProxy) {
            var h, p = Date.now();
            d.on("reconnect", function() {
              var m;
              o.loginSocketOpenFailureCount += 1, (m = h) !== null && m !== void 0 || (h = Date.now() - p), 500 > h && 1 < o.loginSocketOpenFailureCount && (o.context.socketUseProxy = !0);
            });
          }
          return u = !d.useNewDomain, d.open$.pipe(Sf(d));
        }), sa(function(f) {
          o.log("The websocket of ENV_%d opened to %s:%d", f.env, f.ip, Bf[f.env]), o.curOpenSockets[f.env] = f, o.lastOpenSockets[f.env].next(f), o.firstEnv = f.env, o.openSecondSocket(f.env, f.ip, f.useNewDomain);
        }), db(1), Pe()), o.firstSocketOpener = o.firstEnvOpenSocket.pipe(Ab(function(f) {
          return f.open$.pipe(sa(function() {
            o.log("The websocket of first ENV_%d re-opened to %s:%d", f.env, f.ip, Bf[f.env]), o.curOpenSockets[f.env] = f, o.lastOpenSockets[f.env].next(f);
          }));
        })), a = o.firstOpenKeeperSubject.pipe(Fc(td)), o.firstOpenKeeperSub = a.subscribe({ error: o.logError }), o;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "initConnection", value: function() {
        this.firstOpenKeeperSubject.next(this.firstSocketOpener);
      } }, { key: "closeSocket", value: function(a, n) {
        if (![0, 1].includes(a))
          throw new ib({ INVALID_ENV: "The env argument is not 0 or 1" });
        var s = a === this.firstEnv ? this.firstOpenKeeperSub : this.secondOpenKeeperSub;
        this.firstOpenKeeperSub = void 0;
        var o = this.curOpenSockets[a];
        this.curOpenSockets[a] = void 0, o && (o.isActiveClose = !0, setTimeout(function() {
          o.close();
        }, n)), s !== void 0 && setTimeout(function() {
          s == null || s.unsubscribe();
        }, n);
      } }, { key: "waitClosing", value: function(a) {
        var n = this;
        return a.isActiveClose = !0, a.open$.pipe(Vu(), Ya(function(s) {
          return s.message === hs.normalClosureMessage ? Nb : pa(s);
        }), Hb(5e3), Ya(function(s) {
          return s instanceof Pb ? (n.warn("Force closing the ENV_%d connection", a.env), Nb) : pa(s);
        }));
      } }, { key: "onSocketConnectionFailure", value: function(a) {
        var n = [0, 1].filter(function(s) {
          return s !== a.env;
        })[0];
        (n = this.curOpenSockets[n]) && n.loggedIn ? this.reopenSocketWithApRequest(a.env) : this.emit("socketsFailure");
      } }, { key: "openSecondSocket", value: function(a, n, s) {
        var o = this, u = a === 1 ? 0 : 1;
        this.secondSocketOpener = this.edgeInfoReplayed.pipe(pn(function(l, f) {
          return [].concat(W(l), [f]);
        }, []), Da(function(l) {
          return fs(l, function(f) {
            return Jn(n, f.ip);
          }).slice(-1)[0];
        }), db(1), Ab(function(l) {
          if (l === void 0)
            return pa(Error("Invalid edge info"));
          var f = new Pl(l.ip, u, l.ticket, o.context, o.logger, s);
          return f.on("connectionFailure", function() {
            return o.onSocketConnectionFailure(f);
          }), f.open$.pipe(sa(function() {
            o.lastOpenSockets[u].next(f), o.curOpenSockets[u] = f;
          }));
        }), Pe()), this.secondOpenKeeperSub = this.secondOpenKeeperSubject.pipe(Fc(td)).subscribe({ error: this.logError }), this.secondOpenKeeperSubject.next(this.secondSocketOpener);
      } }, { key: "reopenSocketWithApRequest", value: function(a) {
        var n = this, s = [0, 1].filter(function(l) {
          return l !== a;
        })[0];
        if ((s = this.curOpenSockets[s]) !== void 0) {
          var o, u = s.ip;
          s = this.apClient.getApEdgeInfoEndFirst$(!0).pipe(Zd(function() {
            return new Ts({ AP_NO_AVAILABLE_EDGE: "No available edge address to connect" });
          }), Oe(function(l) {
            return l.pipe(sa(function(f) {
              if (f.code === qi)
                n.emit("tokenExpired"), n.apClient.apFinish$.next(void 0);
              else if (Ma(f))
                throw f;
            }), Yd(ue.getParameter("RECONNECTING_AP_INTERVAL")), Gc(Zc(15e3)));
          }), sa(function(l) {
            n.log("An edge info got %o", l);
          }), ch(function() {
            n.apClient.clearUp();
          })).pipe(pn(function(l, f) {
            return [].concat(W(l), [f]);
          }, []), Da(function(l) {
            return (l = fs(l, function(f) {
              return Jn(u, f.ip);
            })).length - 1 >= n.ipIterator ? l.slice(-n.ipIterator++ - 1)[0] : (n.ipIterator = 0, l.slice(-1)[0]);
          }), Zd(), Ab(function(l) {
            if (l === void 0)
              return pa(Error("Invalid edge info"));
            var f = new Pl(l.ip, a, l.ticket, n.context, n.logger, o);
            return f.on("connectionFailure", function() {
              return n.onSocketConnectionFailure(f);
            }), o = !f.useNewDomain, f.open$.pipe(Sf(f));
          }), sa(function(l) {
            n.log("The websocket of ENV_%d re-opened to %s:%d using ap", l.env, l.ip, Bf[l.env]), n.curOpenSockets[a] = l, n.lastOpenSockets[a].next(l);
          }), Ab(function(l) {
            return l.open$.pipe(sa(function() {
              n.log("The websocket of ENV_%d re-opened to %s:%d", l.env, l.ip, Bf[l.env]), n.curOpenSockets[a] = l, n.lastOpenSockets[a].next(l);
            }));
          }), Pe()), a === this.firstEnv ? this.firstOpenKeeperSubject.next(s) : this.secondOpenKeeperSubject.next(s);
        }
      } }]), e;
    }(Ac()), rd = zc.Writer, Ba = zc.util, Uc = zc.roots.default || (zc.roots.default = {}), XD = Uc.Session = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.appId = "", r.prototype.ver = "", r.prototype.buildno = 0, r.prototype.installId = "", r.prototype.os = 0, r.prototype.did = "", r.prototype.index = null, r.prototype.token = "", r.prototype.version = 0, r.prototype.subVersion = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.appId != null && Object.hasOwnProperty.call(e, "appId") && t.uint32(42).string(e.appId), e.ver != null && Object.hasOwnProperty.call(e, "ver") && t.uint32(50).string(e.ver), e.buildno != null && Object.hasOwnProperty.call(e, "buildno") && t.uint32(56).int32(e.buildno), e.installId != null && Object.hasOwnProperty.call(e, "installId") && t.uint32(66).string(e.installId), e.os != null && Object.hasOwnProperty.call(e, "os") && t.uint32(128).int32(e.os), e.did != null && Object.hasOwnProperty.call(e, "did") && t.uint32(138).string(e.did), e.index != null && Object.hasOwnProperty.call(e, "index") && Uc.Session.CommonIndex.encode(e.index, t.uint32(162).fork()).ldelim(), e.token != null && Object.hasOwnProperty.call(e, "token") && t.uint32(170).string(e.token), e.version != null && Object.hasOwnProperty.call(e, "version") && t.uint32(176).int32(e.version), e.subVersion != null && Object.hasOwnProperty.call(e, "subVersion") && t.uint32(184).int32(e.subVersion), t;
      }, r.CommonIndex = function() {
        function e(t) {
          if (t)
            for (var a = Object.keys(t), n = 0; n < a.length; ++n)
              t[a[n]] != null && (this[a[n]] = t[a[n]]);
        }
        return e.prototype.index1 = "", e.prototype.index2 = "", e.prototype.index3 = "", e.encode = function(t, a) {
          return a || (a = rd.create()), t.index1 != null && Object.hasOwnProperty.call(t, "index1") && a.uint32(10).string(t.index1), t.index2 != null && Object.hasOwnProperty.call(t, "index2") && a.uint32(18).string(t.index2), t.index3 != null && Object.hasOwnProperty.call(t, "index3") && a.uint32(26).string(t.index3), a;
        }, e;
      }(), r;
    }(), YD = Uc.Link = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.ec = 0, r.prototype.sc = 0, r.prototype.destServerIp = "", r.prototype.ackedServerIp = "", r.prototype.responseTime = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.ec != null && Object.hasOwnProperty.call(e, "ec") && t.uint32(40).int32(e.ec), e.sc != null && Object.hasOwnProperty.call(e, "sc") && t.uint32(48).int32(e.sc), e.destServerIp != null && Object.hasOwnProperty.call(e, "destServerIp") && t.uint32(58).string(e.destServerIp), e.ackedServerIp != null && Object.hasOwnProperty.call(e, "ackedServerIp") && t.uint32(66).string(e.ackedServerIp), e.responseTime != null && Object.hasOwnProperty.call(e, "responseTime") && t.uint32(72).int32(e.responseTime), t;
      }, r;
    }(), ZD = Uc.Logout = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), t;
      }, r;
    }(), $D = Uc.KickedOff = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.linkId = 0, r.prototype.code = 0, r.prototype.server = "", r.prototype.serverCode = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.linkId != null && Object.hasOwnProperty.call(e, "linkId") && t.uint32(48).int32(e.linkId), e.code != null && Object.hasOwnProperty.call(e, "code") && t.uint32(56).int32(e.code), e.server != null && Object.hasOwnProperty.call(e, "server") && t.uint32(66).string(e.server), e.serverCode != null && Object.hasOwnProperty.call(e, "serverCode") && t.uint32(72).int32(e.serverCode), t;
      }, r;
    }(), aE = Uc.ChnJoin = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.cname = "", r.prototype.errCode = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.cname != null && Object.hasOwnProperty.call(e, "cname") && t.uint32(50).string(e.cname), e.errCode != null && Object.hasOwnProperty.call(e, "errCode") && t.uint32(56).int32(e.errCode), t;
      }, r;
    }(), bE = Uc.ChnJoinRes = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.cname = "", r.prototype.errCode = 0, r.prototype.serverErrCode = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.cname != null && Object.hasOwnProperty.call(e, "cname") && t.uint32(50).string(e.cname), e.errCode != null && Object.hasOwnProperty.call(e, "errCode") && t.uint32(56).int32(e.errCode), e.serverErrCode != null && Object.hasOwnProperty.call(e, "serverErrCode") && t.uint32(64).int32(e.serverErrCode), t;
      }, r;
    }(), cE = Uc.ChnLeave = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.cname = "", r.prototype.errCode = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.cname != null && Object.hasOwnProperty.call(e, "cname") && t.uint32(50).string(e.cname), e.errCode != null && Object.hasOwnProperty.call(e, "errCode") && t.uint32(56).int32(e.errCode), t;
      }, r;
    }(), dE = Uc.ConnectionStateChange = function() {
      function r(e) {
        if (e)
          for (var t = Object.keys(e), a = 0; a < t.length; ++a)
            e[t[a]] != null && (this[t[a]] = e[t[a]]);
      }
      return r.prototype.sid = "", r.prototype.userId = "", r.prototype.lts = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.elapse = Ba.Long ? Ba.Long.fromBits(0, 0, !1) : 0, r.prototype.oldState = 0, r.prototype.newState = 0, r.prototype.reason = 0, r.prototype.reconnId = 0, r.encode = function(e, t) {
        return t || (t = rd.create()), e.sid != null && Object.hasOwnProperty.call(e, "sid") && t.uint32(10).string(e.sid), e.userId != null && Object.hasOwnProperty.call(e, "userId") && t.uint32(18).string(e.userId), e.lts != null && Object.hasOwnProperty.call(e, "lts") && t.uint32(24).int64(e.lts), e.elapse != null && Object.hasOwnProperty.call(e, "elapse") && t.uint32(32).int64(e.elapse), e.oldState != null && Object.hasOwnProperty.call(e, "oldState") && t.uint32(40).int32(e.oldState), e.newState != null && Object.hasOwnProperty.call(e, "newState") && t.uint32(48).int32(e.newState), e.reason != null && Object.hasOwnProperty.call(e, "reason") && t.uint32(56).int32(e.reason), e.reconnId != null && Object.hasOwnProperty.call(e, "reconnId") && t.uint32(64).int32(e.reconnId), t;
      }, r;
    }(), Cv = Object.freeze({ __proto__: null, Session: XD, Link: YD, Logout: ZD, KickedOff: $D, ChnJoin: aE, ChnJoinRes: bE, ChnLeave: cE, ConnectionStateChange: dE, default: Uc }), Dv = Object.freeze({ __proto__: null, Counter: 1, ApiExec: 154, Session: 164, ApEvent: 165, Link: 166, Logout: 167, TxMessage: 168, RxMessage: 169, KickedOff: 170, TxMessageRes: 171, ChnJoin: 172, ChnJoinRes: 173, ChnLeave: 174, ChnGetMembers: 175, ChnGetMembersRes: 176, ChnMemberJoined: 177, ChnMemberLeft: 178, QueryPeersOnlineStatus: 179, QueryPeersOnlineStatusRes: 180, RenewToken: 181, OperateAttribute: 186, OperateAttributeRes: 187, ApRequest: 188, LinkTcpEvent: 189, LinkLoginRequest: 190, ConnectionStateChange: 191, default: { Counter: 1, ApiExec: 154, Session: 164, ApEvent: 165, Link: 166, Logout: 167, TxMessage: 168, RxMessage: 169, KickedOff: 170, TxMessageRes: 171, ChnJoin: 172, ChnJoinRes: 173, ChnLeave: 174, ChnGetMembers: 175, ChnGetMembersRes: 176, ChnMemberJoined: 177, ChnMemberLeft: 178, QueryPeersOnlineStatus: 179, QueryPeersOnlineStatusRes: 180, RenewToken: 181, OperateAttribute: 186, OperateAttributeRes: 187, ApRequest: 188, LinkTcpEvent: 189, LinkLoginRequest: 190, ConnectionStateChange: 191 } }), eE = function(r) {
      function e(a, n, s) {
        return ua(this, e), x(z(s = t.call(this, s, "Context")), "_token", void 0), x(z(s), "config", void 0), x(z(s), "_uid", void 0), x(z(s), "_sid", void 0), x(z(s), "_area", "CN"), x(z(s), "_socketUseProxy", !1), x(z(s), "appId", void 0), x(z(s), "enableCloudProxy", !1), x(z(s), "cloudProxyServers", []), s.appId = a, s.config = n, s;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "socketUseProxy", get: function() {
        return this._socketUseProxy && xc.ENABLE_EDGE_AUTO_FALLBACK;
      }, set: function(a) {
        this.log("socketUseProxy is set to %s", a), this._socketUseProxy = a;
      } }, { key: "token", set: function(a) {
        this._token = typeof a == "string" && a ? a : void 0;
      } }, { key: "uid", get: function() {
        if (typeof this._uid == "string" && this._uid)
          return this._uid;
        throw new qd("Cannot get illegal uid");
      }, set: function(a) {
        if (this.log("The user ID is set to %s", Ka(a)), !Sa(a))
          throw new qd();
        this._uid = a;
      } }, { key: "key", get: function() {
        if (typeof this._token == "string" && this._token)
          return this._token;
        if (typeof this.appId == "string" && this.appId)
          return this.appId;
        throw new qd("Cannot get illegal key");
      } }, { key: "sid", get: function() {
        if (typeof this._sid == "string" && this._sid)
          return this._sid;
        throw new qd("Cannot get illegal sid");
      }, set: function(a) {
        if (this.log("sid is set to %s", a), typeof a != "string" || !a)
          throw new qd();
        this._sid = a;
      } }, { key: "rtmArea", get: function() {
        if (typeof this._area == "string" && this._area)
          return this._area;
        throw new qd("Cannot get illegal area");
      }, set: function(a) {
        this.log("area is set to %s", a), typeof a == "string" && a ? this._area = a : this.warn("set area failed");
      } }]), e;
    }(Ac());
    Mp("of", function() {
      for (var r = 0, e = arguments.length, t = new (nf(this))(e); e > r; )
        t[r] = arguments[r++];
      return t;
    }, lk);
    var Vs = 1 / 0, fE = Math.max, Fv = function(r, e, t) {
      var a = Object(r);
      if (!$d(r)) {
        var n = tf(e);
        r = Vd(r), e = function(s) {
          return n(a[s], s, a);
        };
      }
      return -1 < (e = function(s, o, u) {
        var l = s == null ? 0 : s.length;
        if (!l)
          return -1;
        if (u == null)
          u = 0;
        else {
          var f = (u = u ? (u = Ll(u)) === Vs || u === -Vs ? 17976931348623157e292 * (0 > u ? -1 : 1) : u == u ? u : 0 : u === 0 ? u : 0) % 1;
          u = u == u ? f ? u - f : u : 0;
        }
        return 0 > u && (u = fE(l + u, 0)), Sq(s, tf(o), u);
      }(r, e, t)) ? a[n ? r[e] : e] : void 0;
    }, Ev = function(r, e) {
      return r && r.length ? $k(r, void 0, typeof e == "function" ? e : void 0) : [];
    }, Ws = function() {
      function r() {
        ua(this, r), x(this, "size", 0), x(this, "fields", /* @__PURE__ */ new Map());
      }
      return cb(r, [{ key: "define", value: function(e, t, a) {
        if (this.size += a, 64 < this.size)
          throw new RangeError("the struct over 64 bits is not supported");
        qh(t = { val: 0, isNumber: t === "number", isBoolean: t === "boolean", oneof: t === "number" || t === "boolean" ? void 0 : t, len: a }), this.fields.set(e, t);
      } }, { key: "set", value: function(e, t) {
        if (!(e = this.fields.get(e)))
          throw Error("field not found");
        var a = e.oneof;
        if (!ma.isLong(t) && typeof t != "number")
          if (typeof t == "boolean")
            t = t ? 1 : 0;
          else {
            if (a === void 0)
              throw Error("invalid field type");
            if ((t = a[t]) === void 0)
              throw Error("field type not found");
          }
        qh(e, t), e.val = t;
      } }, { key: "toNumber", value: function() {
        for (var e = 0, t = 0, a = 0, n = Array.from(this.fields); a < n.length; a++) {
          var s = Xa(n[a], 2)[1], o = s.len;
          (s = s.val) !== void 0 && (e += ma.fromValue(s).shiftLeft(t).toNumber(), t += o);
        }
        return e;
      } }, { key: "toLong", value: function() {
        for (var e = ma.fromNumber(0, !0), t = 0, a = 0, n = Array.from(this.fields); a < n.length; a++) {
          var s = Xa(n[a], 2)[1], o = s.len;
          (s = s.val) !== void 0 && (e = ma.fromValue(s).shiftLeft(t).add(e), t += o);
        }
        return e;
      } }, { key: "assert", value: function(e, t) {
        function a(o) {
          if (!ma.isLong(o) && typeof o != "number")
            if (typeof o == "boolean")
              o = o ? 1 : 0;
            else {
              if (s === void 0)
                throw Error("invalid field type");
              if ((o = s[o]) === void 0)
                throw Error("field type not found");
            }
          return qh(n, o), ph(o, n.val);
        }
        var n = this.fields.get(e);
        if (!n)
          throw Error("field not found");
        var s = n.oneof;
        if (!Array.isArray(t))
          return a(t);
        if (t.length === 1)
          return a(t[0]);
        if (t.every(function(o) {
          return typeof o == "string";
        }) && s !== void 0)
          return t.some(function(o) {
            return a(o);
          });
        throw Error("invalid valueTypes");
      } }, { key: "from", value: function(e) {
        e = ma.fromValue(e);
        for (var t = 0, a = 0, n = Array.from(this.fields); a < n.length; a++) {
          var s = Xa(n[a], 2)[1], o = s.len, u = ma.fromNumber(Math.pow(2, o) - 1, !0).shiftLeft(t);
          qh(s, u = e.and(u).shiftRightUnsigned(t)), s.val = u, t += o;
        }
      } }, { key: "typeOf", value: function(e) {
        if ((e = this.fields.get(e)) !== void 0) {
          var t = e.oneof;
          if (e = e.val, t !== void 0) {
            var a = 0;
            for (t = Object.entries(t); a < t.length; a++) {
              var n = Xa(t[a], 2), s = n[0];
              if (ph(e, n[1]))
                return s;
            }
          }
        }
        throw new TypeError("can only get type of oneof type");
      } }]), r;
    }(), Xs = function(r) {
      function e(a) {
        ua(this, e);
        var n = t.call(this);
        return n.define("Rejoin", "boolean", 1), n.define("Unused", "number", 31), n.define("Platform", "number", 8), n.define("Version", "number", 12), n.define("Subversion", "number", 12), n.set("Platform", 7), n.set("Version", 4), n.set("Subversion", 17), n.set("Rejoin", a), n;
      }
      Ga(e, r);
      var t = Ha(e);
      return e;
    }(Ws), gE = jb(jb({}, { PeerTextMessage: 0, ChannelTextMessage: 1, VendorTextMessage: 2 }), { PeerRawMessage: 3, ChannelRawMessage: 4, VendorRawMessage: 5 }), Ys = { CallInvite: 101, CallAccept: 102, CallReject: 103, CallCancel: 104 }, hE = jb(jb({}, gE), Ys), iE = { Uncompressed: 0, Zlib: 1 }, Cf = function(r) {
      function e(a) {
        ua(this, e);
        var n = t.call(this);
        if (n.define("MessageType", hE, 8), n.define("BroadcastJumps", "number", 2), n.define("ToCache", "boolean", 1), n.define("FromCache", "boolean", 1), n.define("CompressionMethod", iE, 2), n.define("IterationNumber", "number", 4), n.define("BufferedMessage", "boolean", 1), n.define("ToArchive", "boolean", 1), n.define("FromArchive", "boolean", 1), typeof a == "number" || ma.isLong(a))
          n.from(a);
        else if (a !== void 0) {
          var s = 0;
          for (a = lh(a); s < a.length; s++) {
            var o = Xa(a[s], 2);
            n.set(o[0], o[1]);
          }
        }
        return n;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "isTextMessage", value: function() {
        return this.assert("MessageType", ["PeerTextMessage", "ChannelTextMessage", "VendorTextMessage"]);
      } }, { key: "isRawMessage", value: function() {
        return this.assert("MessageType", ["ChannelRawMessage", "PeerRawMessage", "VendorRawMessage"]);
      } }, { key: "isRawPeerMessage", value: function() {
        return this.assert("MessageType", "PeerRawMessage");
      } }, { key: "isRawChannelMessage", value: function() {
        return this.assert("MessageType", "ChannelRawMessage");
      } }, { key: "isPeerTextMessage", value: function() {
        return this.assert("MessageType", "PeerTextMessage");
      } }, { key: "isChannelTextMessage", value: function() {
        return this.assert("MessageType", "ChannelTextMessage");
      } }, { key: "isInvitation", value: function(a) {
        var n = this;
        return a !== void 0 ? this.assert("MessageType", a) : $f(Ys).some(function(s) {
          return n.assert("MessageType", s);
        });
      } }, { key: "isPeerMessage", value: function() {
        return this.assert("MessageType", ["PeerTextMessage", "PeerRawMessage"]);
      } }, { key: "isZlibCompressed", value: function() {
        return this.assert("CompressionMethod", "Zlib");
      } }, { key: "isFromCache", value: function() {
        return this.assert("FromCache", !0);
      } }, { key: "isBufferedMessage", value: function() {
        return this.assert("BufferedMessage", !0);
      } }, { key: "getInvitationType", value: function() {
        if (!this.isInvitation())
          throw new TypeError("cannot get InvitationType of a normal message type");
        return this.typeOf("MessageType");
      } }]), e;
    }(Ws), jE = function(r) {
      function e(a) {
        return ua(this, e), x(z(a = t.call(this, a, "ChatManager")), "dialogueLru", new nz(void 0, { maxlen: 1e4, ttl: 1e4 })), a;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "getChatInfo", value: function(a) {
        var n = this.dialogueLru.get(a);
        if (this.dialogueLru.prune(), n) {
          var s = n.dialogue, o = { dialogue: s, sequence: n = n.sequence.add(1) };
          return this.dialogueLru.set(a, { dialogue: s, sequence: n }), o;
        }
        return s = { dialogue: hh(), sequence: ma.fromNumber(1, !0) }, this.dialogueLru.set(a, s), s;
      } }]), e;
    }(Ac()), F = {};
    oa(module) == "object" && (module.exports = F), F.parse = function(r, e) {
      var t, a = F.bin.readUshort, n = F.bin.readUint, s = {};
      for (t = (r = new Uint8Array(r)).length - 4; n(r, t) != 101010256; )
        t--;
      var o = a(r, t = t + 4 + 4);
      a(r, t += 2), n(r, t += 2), t = n(r, t += 4);
      for (var u = 0; u < o; u++) {
        n(r, t), t += 4, t += 4, t += 4, n(r, t += 4);
        var l = n(r, t += 4), f = n(r, t += 4), d = a(r, t += 4), h = a(r, t + 2), p = a(r, t + 4);
        t += 6;
        var m = n(r, t += 8);
        t += 4, t += d + h + p, F._readLocal(r, m, s, l, f, e);
      }
      return s;
    }, F._readLocal = function(r, e, t, a, n, s) {
      var o = F.bin.readUshort, u = F.bin.readUint;
      u(r, e), o(r, e += 4), o(r, e += 2);
      var l = o(r, e += 2);
      u(r, e += 2), u(r, e += 4), u = o(r, e = e + 4 + 8);
      var f = o(r, e += 2);
      if (e += 2, o = F.bin.readUTF8(r, e, u), e = e + u + f, s)
        t[o] = { size: n, csize: a };
      else if (r = new Uint8Array(r.buffer, e), l == 0)
        t[o] = new Uint8Array(r.buffer.slice(e, e + a));
      else {
        if (l != 8)
          throw "unknown compression method: " + l;
        e = new Uint8Array(n), F.inflateRaw(r, e), t[o] = e;
      }
    }, F.inflateRaw = function(r, e) {
      return F.F.inflate(r, e);
    }, F.inflate = function(r, e) {
      return r[0], r[1], F.inflateRaw(new Uint8Array(r.buffer, r.byteOffset + 2, r.length - 2), e);
    }, F.deflate = function(r, e) {
      e == null && (e = { level: 6 });
      var t = 0, a = new Uint8Array(50 + Math.floor(1.1 * r.length));
      return a[t] = 120, a[t + 1] = 156, t = F.F.deflateRaw(r, a, t + 2, e.level), r = F.adler(r, 0, r.length), a[t + 0] = r >>> 24 & 255, a[t + 1] = r >>> 16 & 255, a[t + 2] = r >>> 8 & 255, a[t + 3] = r >>> 0 & 255, new Uint8Array(a.buffer, 0, t + 4);
    }, F.deflateRaw = function(r, e) {
      e == null && (e = { level: 6 });
      var t = new Uint8Array(50 + Math.floor(1.1 * r.length)), a = F.F.deflateRaw(r, t, a, e.level);
      return new Uint8Array(t.buffer, 0, a);
    }, F.encode = function(r, e) {
      e == null && (e = !1);
      var t, a = 0, n = F.bin.writeUint, s = F.bin.writeUshort, o = {};
      for (t in r) {
        var u = !F._noNeed(t) && !e, l = r[t], f = F.crc.crc(l, 0, l.length);
        o[t] = { cpr: u, usize: l.length, crc: f, file: u ? F.deflateRaw(l) : l };
      }
      for (t in o)
        a += o[t].file.length + 30 + 46 + 2 * F.bin.sizeUTF8(t);
      for (t in r = new Uint8Array(a + 22), e = 0, l = [], o)
        f = o[t], l.push(e), e = F._writeHeader(r, e, t, f, 0);
      for (t in a = 0, u = e, o)
        f = o[t], l.push(e), e = F._writeHeader(r, e, t, f, 1, l[a++]);
      return o = e - u, n(r, e, 101010256), s(r, e = e + 4 + 4, a), s(r, e += 2, a), n(r, e += 2, o), n(r, e + 4, u), r.buffer;
    }, F._noNeed = function(r) {
      return r = r.split(".").pop().toLowerCase(), "png,jpg,jpeg,zip".indexOf(r) != -1;
    }, F._writeHeader = function(r, e, t, a, n, s) {
      var o = F.bin.writeUint, u = F.bin.writeUshort, l = a.file;
      return o(r, e, n == 0 ? 67324752 : 33639248), e += 4, n == 1 && (e += 2), u(r, e, 20), u(r, e += 2, 0), u(r, e += 2, a.cpr ? 8 : 0), o(r, e += 2, 0), o(r, e += 4, a.crc), o(r, e += 4, l.length), o(r, e += 4, a.usize), u(r, e += 4, F.bin.sizeUTF8(t)), u(r, e += 2, 0), e += 2, n == 1 && (o(r, e = e + 2 + 2 + 6, s), e += 4), e += t = F.bin.writeUTF8(r, e, t), n == 0 && (r.set(l, e), e += l.length), e;
    }, F.crc = { table: function() {
      for (var r = new Uint32Array(256), e = 0; 256 > e; e++) {
        for (var t = e, a = 0; 8 > a; a++)
          t = 1 & t ? 3988292384 ^ t >>> 1 : t >>> 1;
        r[e] = t;
      }
      return r;
    }(), update: function(r, e, t, a) {
      for (var n = 0; n < a; n++)
        r = F.crc.table[255 & (r ^ e[t + n])] ^ r >>> 8;
      return r;
    }, crc: function(r, e, t) {
      return 4294967295 ^ F.crc.update(4294967295, r, e, t);
    } }, F.adler = function(r, e, t) {
      var a = 1, n = 0, s = e;
      for (e += t; s < e; ) {
        for (t = Math.min(s + 5552, e); s < t; )
          n += a += r[s++];
        a %= 65521, n %= 65521;
      }
      return n << 16 | a;
    }, F.bin = { readUshort: function(r, e) {
      return r[e] | r[e + 1] << 8;
    }, writeUshort: function(r, e, t) {
      r[e] = 255 & t, r[e + 1] = t >> 8 & 255;
    }, readUint: function(r, e) {
      return 16777216 * r[e + 3] + (r[e + 2] << 16 | r[e + 1] << 8 | r[e]);
    }, writeUint: function(r, e, t) {
      r[e] = 255 & t, r[e + 1] = t >> 8 & 255, r[e + 2] = t >> 16 & 255, r[e + 3] = t >> 24 & 255;
    }, readASCII: function(r, e, t) {
      for (var a = "", n = 0; n < t; n++)
        a += String.fromCharCode(r[e + n]);
      return a;
    }, writeASCII: function(r, e, t) {
      for (var a = 0; a < t.length; a++)
        r[e + a] = t.charCodeAt(a);
    }, pad: function(r) {
      return 2 > r.length ? "0" + r : r;
    }, readUTF8: function(r, e, t) {
      for (var a, n = "", s = 0; s < t; s++)
        n += "%" + F.bin.pad(r[e + s].toString(16));
      try {
        a = decodeURIComponent(n);
      } catch {
        return F.bin.readASCII(r, e, t);
      }
      return a;
    }, writeUTF8: function(r, e, t) {
      for (var a = t.length, n = 0, s = 0; s < a; s++) {
        var o = t.charCodeAt(s);
        if ((4294967168 & o) == 0)
          r[e + n] = o, n++;
        else if ((4294965248 & o) == 0)
          r[e + n] = 192 | o >> 6, r[e + n + 1] = 128 | o >> 0 & 63, n += 2;
        else if ((4294901760 & o) == 0)
          r[e + n] = 224 | o >> 12, r[e + n + 1] = 128 | o >> 6 & 63, r[e + n + 2] = 128 | o >> 0 & 63, n += 3;
        else {
          if ((4292870144 & o) != 0)
            throw "e";
          r[e + n] = 240 | o >> 18, r[e + n + 1] = 128 | o >> 12 & 63, r[e + n + 2] = 128 | o >> 6 & 63, r[e + n + 3] = 128 | o >> 0 & 63, n += 4;
        }
      }
      return n;
    }, sizeUTF8: function(r) {
      for (var e = r.length, t = 0, a = 0; a < e; a++) {
        var n = r.charCodeAt(a);
        if ((4294967168 & n) == 0)
          t++;
        else if ((4294965248 & n) == 0)
          t += 2;
        else if ((4294901760 & n) == 0)
          t += 3;
        else {
          if ((4292870144 & n) != 0)
            throw "e";
          t += 4;
        }
      }
      return t;
    } }, F.F = {}, F.F.deflateRaw = function(r, e, t, a) {
      var n = [[0, 0, 0, 0, 0], [4, 4, 8, 4, 0], [4, 5, 16, 8, 0], [4, 6, 16, 16, 0], [4, 10, 16, 32, 0], [8, 16, 32, 32, 0], [8, 16, 128, 128, 0], [8, 32, 128, 256, 0], [32, 128, 258, 1024, 1], [32, 258, 258, 4096, 1]][a], s = F.F.U, o = F.F._goodIndex;
      F.F._hash;
      var u = F.F._putsE, l = 0;
      t <<= 3;
      var f = 0, d = r.length;
      if (a == 0) {
        for (; l < d; ) {
          var h = Math.min(65535, d - l);
          u(e, t, l + h == d ? 1 : 0), t = F.F._copyExact(r, l, h, e, t + 8), l += h;
        }
        return t >>> 3;
      }
      u = s.lits, a = s.strt;
      var p = s.prev, m = 0, _ = 0, w = 0, S = 0, O = 0;
      for (2 < d && (a[O = F.F._hash(r, 0)] = 0), l = 0; l < d; l++) {
        if (h = O, l + 1 < d - 2) {
          O = F.F._hash(r, l + 1);
          var k = l + 1 & 32767;
          p[k] = a[O], a[O] = k;
        }
        if (f <= l) {
          if ((14e3 < m || 26697 < _) && 100 < d - l && (f < l && (u[m] = l - f, m += 2, f = l), t = F.F._writeBlock(l == d - 1 || f == d ? 1 : 0, u, m, S, r, w, l - w, e, t), m = _ = S = 0, w = l), k = 0, l < d - 2 && (k = F.F._bestMatch(r, l, p, h, Math.min(n[2], d - l), n[3])), k != 0) {
            h = k >>> 16, k &= 65535;
            var B = o(h, s.of0);
            s.lhst[257 + B]++;
            var L = o(k, s.df0);
            s.dhst[L]++, S += s.exb[B] + s.dxb[L], u[m] = h << 23 | l - f, u[m + 1] = k << 16 | B << 8 | L, m += 2, f = l + h;
          } else
            s.lhst[r[l]]++;
          _++;
        }
      }
      for (w == l && r.length != 0 || (f < l && (u[m] = l - f, m += 2), t = F.F._writeBlock(1, u, m, S, r, w, l - w, e, t)); (7 & t) != 0; )
        t++;
      return t >>> 3;
    }, F.F._bestMatch = function(r, e, t, a, n, s) {
      var o = 32767 & e, u = t[o], l = o - u + 32768 & 32767;
      if (u == o || a != F.F._hash(r, e - l))
        return 0;
      for (var f = a = 0, d = Math.min(32767, e); l <= d && --s != 0 && u != o; ) {
        if ((a == 0 || r[e + a] == r[e + a - l]) && (o = F.F._howLong(r, e, l)) > a) {
          if (f = l, (a = o) >= n)
            break;
          l + 2 < o && (o = l + 2);
          for (var h = 0, p = 0; p < o - 2; p++) {
            var m = e - l + p + 32768 & 32767, _ = m - t[m] + 32768 & 32767;
            _ > h && (h = _, u = m);
          }
        }
        l += (o = u) - (u = t[o]) + 32768 & 32767;
      }
      return a << 16 | f;
    }, F.F._howLong = function(r, e, t) {
      if (r[e] != r[e - t] || r[e + 1] != r[e + 1 - t] || r[e + 2] != r[e + 2 - t])
        return 0;
      var a = e, n = Math.min(r.length, e + 258);
      for (e += 3; e < n && r[e] == r[e - t]; )
        e++;
      return e - a;
    }, F.F._hash = function(r, e) {
      return (r[e] << 8 | r[e + 1]) + (r[e + 2] << 4) & 65535;
    }, F.saved = 0, F.F._writeBlock = function(r, e, t, a, n, s, o, u, l) {
      var f = F.F.U, d = F.F._putsF, h = F.F._putsE;
      f.lhst[256]++;
      var p = F.F.getTrees(), m = p[0], _ = p[1], w = p[2], S = p[3], O = p[4], k = p[5], B = p[6];
      p = p[7];
      var L = 32 + ((l + 3 & 7) == 0 ? 0 : 8 - (l + 3 & 7)) + (o << 3), G = a + F.F.contSize(f.fltree, f.lhst) + F.F.contSize(f.fdtree, f.dhst);
      a = a + F.F.contSize(f.ltree, f.lhst) + F.F.contSize(f.dtree, f.dhst), a += 14 + 3 * k + F.F.contSize(f.itree, f.ihst) + (2 * f.ihst[16] + 3 * f.ihst[17] + 7 * f.ihst[18]);
      for (var _r = 0; 286 > _r; _r++)
        f.lhst[_r] = 0;
      for (_r = 0; 30 > _r; _r++)
        f.dhst[_r] = 0;
      for (_r = 0; 19 > _r; _r++)
        f.ihst[_r] = 0;
      if (L = L < G && L < a ? 0 : G < a ? 1 : 2, d(u, l, r), d(u, l + 1, L), l += 3, L == 0) {
        for (; (7 & l) != 0; )
          l++;
        l = F.F._copyExact(n, s, o, u, l);
      } else {
        if (L == 1)
          var ga = f.fltree, _n = f.fdtree;
        if (L == 2) {
          for (F.F.makeCodes(f.ltree, m), F.F.revCodes(f.ltree, m), F.F.makeCodes(f.dtree, _), F.F.revCodes(f.dtree, _), F.F.makeCodes(f.itree, w), F.F.revCodes(f.itree, w), ga = f.ltree, _n = f.dtree, h(u, l, S - 257), h(u, l += 5, O - 1), h(u, l += 5, k - 4), l += 4, r = 0; r < k; r++)
            h(u, l + 3 * r, f.itree[1 + (f.ordr[r] << 1)]);
          l = F.F._codeTiny(B, f.itree, u, l + 3 * k), l = F.F._codeTiny(p, f.itree, u, l);
        }
        for (k = 0; k < t; k += 2) {
          for (B = (r = e[k]) >>> 23, r = s + (8388607 & r); s < r; )
            l = F.F._writeLit(n[s++], ga, u, l);
          B != 0 && (r = (m = e[k + 1]) >> 16, o = m >> 8 & 255, m &= 255, h(u, l = F.F._writeLit(257 + o, ga, u, l), B - f.of0[o]), l += f.exb[o], d(u, l = F.F._writeLit(m, _n, u, l), r - f.df0[m]), l += f.dxb[m], s += B);
        }
        l = F.F._writeLit(256, ga, u, l);
      }
      return l;
    }, F.F._copyExact = function(r, e, t, a, n) {
      var s = n >>> 3;
      return a[s] = t, a[s + 1] = t >>> 8, a[s + 2] = 255 - a[s], a[s + 3] = 255 - a[s + 1], s += 4, a.set(new Uint8Array(r.buffer, e, t), s), n + (t + 4 << 3);
    }, F.F.getTrees = function() {
      for (var r = F.F.U, e = F.F._hufTree(r.lhst, r.ltree, 15), t = F.F._hufTree(r.dhst, r.dtree, 15), a = [], n = F.F._lenCodes(r.ltree, a), s = [], o = F.F._lenCodes(r.dtree, s), u = 0; u < a.length; u += 2)
        r.ihst[a[u]]++;
      for (u = 0; u < s.length; u += 2)
        r.ihst[s[u]]++;
      u = F.F._hufTree(r.ihst, r.itree, 7);
      for (var l = 19; 4 < l && r.itree[1 + (r.ordr[l - 1] << 1)] == 0; )
        l--;
      return [e, t, u, n, o, l, a, s];
    }, F.F.getSecond = function(r) {
      for (var e = [], t = 0; t < r.length; t += 2)
        e.push(r[t + 1]);
      return e;
    }, F.F.nonZero = function(r) {
      for (var e = "", t = 0; t < r.length; t += 2)
        r[t + 1] != 0 && (e += (t >> 1) + ",");
      return e;
    }, F.F.contSize = function(r, e) {
      for (var t = 0, a = 0; a < e.length; a++)
        t += e[a] * r[1 + (a << 1)];
      return t;
    }, F.F._codeTiny = function(r, e, t, a) {
      for (var n = 0; n < r.length; n += 2) {
        var s = r[n], o = r[n + 1];
        a = F.F._writeLit(s, e, t, a);
        var u = s == 16 ? 2 : s == 17 ? 3 : 7;
        15 < s && (F.F._putsE(t, a, o, u), a += u);
      }
      return a;
    }, F.F._lenCodes = function(r, e) {
      for (var t = r.length; t != 2 && r[t - 1] == 0; )
        t -= 2;
      for (var a = 0; a < t; a += 2) {
        var n = r[a + 1], s = a + 3 < t ? r[a + 3] : -1, o = a + 5 < t ? r[a + 5] : -1, u = a == 0 ? -1 : r[a - 1];
        if (n == 0 && s == n && o == n) {
          for (s = a + 5; s + 2 < t && r[s + 2] == n; )
            s += 2;
          11 > (n = Math.min(s + 1 - a >>> 1, 138)) ? e.push(17, n - 3) : e.push(18, n - 11), a += 2 * n - 2;
        } else if (n == u && s == n && o == n) {
          for (s = a + 5; s + 2 < t && r[s + 2] == n; )
            s += 2;
          n = Math.min(s + 1 - a >>> 1, 6), e.push(16, n - 3), a += 2 * n - 2;
        } else
          e.push(n, 0);
      }
      return t >>> 1;
    }, F.F._hufTree = function(r, e, t) {
      var a = [], n = r.length, s = e.length, o = 0;
      for (o = 0; o < s; o += 2)
        e[o] = 0, e[o + 1] = 0;
      for (o = 0; o < n; o++)
        r[o] != 0 && a.push({ lit: o, f: r[o] });
      if (r = a.length, n = a.slice(0), r == 0)
        return 0;
      if (r == 1)
        return e[1 + ((t = a[0].lit) << 1)] = 1, e[1 + ((t == 0 ? 1 : 0) << 1)] = 1;
      a.sort(function(d, h) {
        return d.f - h.f;
      }), o = a[0], s = a[1];
      var u = 0, l = 1, f = 2;
      for (a[0] = { lit: -1, f: o.f + s.f, l: o, r: s, d: 0 }; l != r - 1; )
        o = u != l && (f == r || a[u].f < a[f].f) ? a[u++] : a[f++], s = u != l && (f == r || a[u].f < a[f].f) ? a[u++] : a[f++], a[l++] = { lit: -1, f: o.f + s.f, l: o, r: s };
      for ((a = F.F.setDepth(a[l - 1], 0)) > t && (F.F.restrictDepth(n, t, a), a = t), o = 0; o < r; o++)
        e[1 + (n[o].lit << 1)] = n[o].d;
      return a;
    }, F.F.setDepth = function(r, e) {
      return r.lit != -1 ? r.d = e : Math.max(F.F.setDepth(r.l, e + 1), F.F.setDepth(r.r, e + 1));
    }, F.F.restrictDepth = function(r, e, t) {
      var a = 0, n = 1 << t - e, s = 0;
      for (r.sort(function(u, l) {
        return l.d == u.d ? u.f - l.f : l.d - u.d;
      }), a = 0; a < r.length && r[a].d > e; a++) {
        var o = r[a].d;
        r[a].d = e, s += n - (1 << t - o);
      }
      for (s >>>= t - e; 0 < s; )
        (o = r[a].d) < e ? (r[a].d++, s -= 1 << e - o - 1) : a++;
      for (; 0 <= a; a--)
        r[a].d == e && 0 > s && (r[a].d--, s++);
      s != 0 && console.log("debt left");
    }, F.F._goodIndex = function(r, e) {
      var t = 0;
      return e[16 | t] <= r && (t |= 16), e[8 | t] <= r && (t |= 8), e[4 | t] <= r && (t |= 4), e[2 | t] <= r && (t |= 2), e[1 | t] <= r && (t |= 1), t;
    }, F.F._writeLit = function(r, e, t, a) {
      return F.F._putsF(t, a, e[r << 1]), a + e[1 + (r << 1)];
    }, F.F.inflate = function(r, e) {
      var t = Uint8Array;
      if (r[0] == 3 && r[1] == 0)
        return e || new t(0);
      var a = F.F, n = a._bitsF, s = a._bitsE, o = a._decodeTiny, u = a.makeCodes, l = a.codes2map, f = a._get17, d = a.U, h = e == null;
      h && (e = new t(r.length >>> 2 << 3));
      for (var p, m, _, w, S = 0, O = 0, k = m = 0, B = 0; S == 0; )
        if (S = n(r, B, 1), p = n(r, B + 1, 2), B += 3, p == 0)
          (7 & B) != 0 && (B += 8 - (7 & B)), p = r[(B = 4 + (B >>> 3)) - 4] | r[B - 3] << 8, h && (e = F.F._check(e, k + p)), e.set(new t(r.buffer, r.byteOffset + B, p), k), B = B + p << 3, k += p;
        else {
          if (h && (e = F.F._check(e, k + 131072)), p == 1 && (_ = d.flmap, w = d.fdmap, O = 511, m = 31), p == 2) {
            for (m = s(r, B, 5) + 257, p = s(r, B + 5, 5) + 1, _ = s(r, B + 10, 4) + 4, B += 14, w = 0; 38 > w; w += 2)
              d.itree[w] = 0, d.itree[w + 1] = 0;
            for (O = 1, w = 0; w < _; w++) {
              var L = s(r, B + 3 * w, 3);
              d.itree[1 + (d.ordr[w] << 1)] = L, L > O && (O = L);
            }
            B += 3 * _, u(d.itree, O), l(d.itree, O, d.imap), _ = d.lmap, w = d.dmap, B = o(d.imap, (1 << O) - 1, m + p, r, B, d.ttree), O = (1 << (L = a._copyOut(d.ttree, 0, m, d.ltree))) - 1, m = (1 << (p = a._copyOut(d.ttree, m, p, d.dtree))) - 1, u(d.ltree, L), l(d.ltree, L, _), u(d.dtree, p), l(d.dtree, p, w);
          }
          for (; ; )
            if (B += 15 & (p = _[f(r, B) & O]), (L = p >>> 4) >>> 8 == 0)
              e[k++] = L;
            else {
              if (L == 256)
                break;
              p = k + L - 254, 264 < L && (p = k + ((L = d.ldef[L - 257]) >>> 3) + s(r, B, 7 & L), B += 7 & L), B += 15 & (L = w[f(r, B) & m]);
              var G = ((L = d.ddef[L >>> 4]) >>> 4) + n(r, B, 15 & L);
              for (B += 15 & L, h && (e = F.F._check(e, k + 131072)); k < p; )
                e[k] = e[k++ - G], e[k] = e[k++ - G], e[k] = e[k++ - G], e[k] = e[k++ - G];
              k = p;
            }
        }
      return e.length == k ? e : e.slice(0, k);
    }, F.F._check = function(r, e) {
      var t = r.length;
      return e <= t ? r : ((e = new Uint8Array(Math.max(t << 1, e))).set(r, 0), e);
    }, F.F._decodeTiny = function(r, e, t, a, n, s) {
      for (var o = F.F._bitsE, u = F.F._get17, l = 0; l < t; ) {
        var f = r[u(a, n) & e];
        n += 15 & f;
        var d = f >>> 4;
        if (15 >= d)
          s[l] = d, l++;
        else {
          var h = f = 0;
          for (d == 16 ? (h = 3 + o(a, n, 2), n += 2, f = s[l - 1]) : d == 17 ? (h = 3 + o(a, n, 3), n += 3) : d == 18 && (h = 11 + o(a, n, 7), n += 7), d = l + h; l < d; )
            s[l] = f, l++;
        }
      }
      return n;
    }, F.F._copyOut = function(r, e, t, a) {
      for (var n = 0, s = 0, o = a.length >>> 1; s < t; ) {
        var u = r[s + e];
        a[s << 1] = 0, a[1 + (s << 1)] = u, u > n && (n = u), s++;
      }
      for (; s < o; )
        a[s << 1] = 0, a[1 + (s << 1)] = 0, s++;
      return n;
    }, F.F.makeCodes = function(r, e) {
      var t, a, n = F.F.U, s = r.length, o = n.bl_count;
      for (t = 0; t <= e; t++)
        o[t] = 0;
      for (t = 1; t < s; t += 2)
        o[r[t]]++;
      for (n = n.next_code, t = 0, o[0] = 0, a = 1; a <= e; a++)
        t = t + o[a - 1] << 1, n[a] = t;
      for (e = 0; e < s; e += 2)
        (o = r[e + 1]) != 0 && (r[e] = n[o], n[o]++);
    }, F.F.codes2map = function(r, e, t) {
      for (var a = r.length, n = F.F.U.rev15, s = 0; s < a; s += 2)
        if (r[s + 1] != 0) {
          var o = r[s + 1], u = s >> 1 << 4 | o, l = e - o;
          for (l = (o = r[s] << l) + (1 << l); o != l; )
            t[n[o] >>> 15 - e] = u, o++;
        }
    }, F.F.revCodes = function(r, e) {
      for (var t = F.F.U.rev15, a = 15 - e, n = 0; n < r.length; n += 2)
        r[n] = t[r[n] << e - r[n + 1]] >>> a;
    }, F.F._putsE = function(r, e, t) {
      t <<= 7 & e, r[e >>>= 3] |= t, r[e + 1] |= t >>> 8;
    }, F.F._putsF = function(r, e, t) {
      t <<= 7 & e, r[e >>>= 3] |= t, r[e + 1] |= t >>> 8, r[e + 2] |= t >>> 16;
    }, F.F._bitsE = function(r, e, t) {
      return (r[e >>> 3] | r[1 + (e >>> 3)] << 8) >>> (7 & e) & (1 << t) - 1;
    }, F.F._bitsF = function(r, e, t) {
      return (r[e >>> 3] | r[1 + (e >>> 3)] << 8 | r[2 + (e >>> 3)] << 16) >>> (7 & e) & (1 << t) - 1;
    }, F.F._get17 = function(r, e) {
      return (r[e >>> 3] | r[1 + (e >>> 3)] << 8 | r[2 + (e >>> 3)] << 16) >>> (7 & e);
    }, F.F._get25 = function(r, e) {
      return (r[e >>> 3] | r[1 + (e >>> 3)] << 8 | r[2 + (e >>> 3)] << 16 | r[3 + (e >>> 3)] << 24) >>> (7 & e);
    }, F.F.U = function() {
      var r = Uint16Array, e = Uint32Array;
      return { next_code: new r(16), bl_count: new r(16), ordr: [16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15], of0: [3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 999, 999, 999], exb: [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 0, 0, 0], ldef: new r(32), df0: [1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577, 65535, 65535], dxb: [0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 0, 0], ddef: new e(32), flmap: new r(512), fltree: [], fdmap: new r(32), fdtree: [], lmap: new r(32768), ltree: [], ttree: [], dmap: new r(32768), dtree: [], imap: new r(512), itree: [], rev15: new r(32768), lhst: new e(286), dhst: new e(30), ihst: new e(19), lits: new e(15e3), strt: new r(65536), prev: new r(32768) };
    }(), function() {
      function r(n, s, o) {
        for (; s-- != 0; )
          n.push(0, o);
      }
      for (var e = F.F.U, t = 0; 32768 > t; t++) {
        var a = t;
        a = (4278255360 & (a = (4042322160 & (a = (3435973836 & (a = (2863311530 & a) >>> 1 | (1431655765 & a) << 1)) >>> 2 | (858993459 & a) << 2)) >>> 4 | (252645135 & a) << 4)) >>> 8 | (16711935 & a) << 8, e.rev15[t] = (a >>> 16 | a << 16) >>> 17;
      }
      for (t = 0; 32 > t; t++)
        e.ldef[t] = e.of0[t] << 3 | e.exb[t], e.ddef[t] = e.df0[t] << 4 | e.dxb[t];
      r(e.fltree, 144, 8), r(e.fltree, 112, 9), r(e.fltree, 24, 7), r(e.fltree, 8, 8), F.F.makeCodes(e.fltree, 9), F.F.codes2map(e.fltree, 9, e.flmap), F.F.revCodes(e.fltree, 9), r(e.fdtree, 32, 5), F.F.makeCodes(e.fdtree, 5), F.F.codes2map(e.fdtree, 5, e.fdmap), F.F.revCodes(e.fdtree, 5), r(e.itree, 19, 0), r(e.ltree, 286, 0), r(e.dtree, 30, 0), r(e.ttree, 320, 0);
    }();
    var kE = Array.isArray || function(r) {
      return r && typeof r.length == "number";
    }, lE = Object.defineProperty({ isArray: kE }, "__esModule", { value: !0 }), mE = Object.defineProperty({ isObject: function(r) {
      return r !== null && oa(r) === "object";
    } }, "__esModule", { value: !0 }), nE = Object.defineProperty({ isFunction: function(r) {
      return typeof r == "function";
    } }, "__esModule", { value: !0 }), oE = function() {
      function r(e) {
        return Error.call(this), this.message = e ? e.length + ` errors occurred during unsubscription:
` + e.map(function(t, a) {
          return a + 1 + ") " + t.toString();
        }).join(`
  `) : "", this.name = "UnsubscriptionError", this.errors = e, this;
      }
      return r.prototype = Object.create(Error.prototype), r;
    }(), rh = Object.defineProperty({ UnsubscriptionError: oE }, "__esModule", { value: !0 }), pE = function() {
      function r(t) {
        this.closed = !1, this._subscriptions = this._parentOrParents = null, t && (this._ctorUnsubscribe = !0, this._unsubscribe = t);
      }
      var e;
      return r.prototype.unsubscribe = function() {
        if (!this.closed) {
          var t = this._parentOrParents, a = this._ctorUnsubscribe, n = this._unsubscribe, s = this._subscriptions;
          if (this.closed = !0, this._subscriptions = this._parentOrParents = null, t instanceof r)
            t.remove(this);
          else if (t !== null)
            for (var o = 0; o < t.length; ++o)
              t[o].remove(this);
          if (nE.isFunction(n)) {
            a && (this._unsubscribe = void 0);
            try {
              n.call(this);
            } catch (l) {
              var u = l instanceof rh.UnsubscriptionError ? Yn(l.errors) : [l];
            }
          }
          if (lE.isArray(s)) {
            for (o = -1, t = s.length; ++o < t; )
              if (a = s[o], mE.isObject(a))
                try {
                  a.unsubscribe();
                } catch (l) {
                  u = u || [], l instanceof rh.UnsubscriptionError ? u = u.concat(Yn(l.errors)) : u.push(l);
                }
          }
          if (u)
            throw new rh.UnsubscriptionError(u);
        }
      }, r.prototype.add = function(t) {
        var a = t;
        if (!t)
          return r.EMPTY;
        switch (oa(t)) {
          case "function":
            a = new r(t);
          case "object":
            if (a === this || a.closed || typeof a.unsubscribe != "function")
              return a;
            if (this.closed)
              return a.unsubscribe(), a;
            a instanceof r || (t = a, (a = new r())._subscriptions = [t]);
            break;
          default:
            throw Error("unrecognized teardown " + t + " added to Subscription.");
        }
        if ((t = a._parentOrParents) === null)
          a._parentOrParents = this;
        else if (t instanceof r) {
          if (t === this)
            return a;
          a._parentOrParents = [t, this];
        } else {
          if (t.indexOf(this) !== -1)
            return a;
          t.push(this);
        }
        return (t = this._subscriptions) === null ? this._subscriptions = [a] : t.push(a), a;
      }, r.prototype.remove = function(t) {
        var a = this._subscriptions;
        a && (t = a.indexOf(t)) !== -1 && a.splice(t, 1);
      }, r.EMPTY = ((e = new r()).closed = !0, e), r;
    }(), qE = Object.defineProperty({ Subscription: pE }, "__esModule", { value: !0 }), rE = Va && Va.__extends || function() {
      var r = function(e, t) {
        return (r = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(a, n) {
          a.__proto__ = n;
        } || function(a, n) {
          for (var s in n)
            n.hasOwnProperty(s) && (a[s] = n[s]);
        })(e, t);
      };
      return function(e, t) {
        function a() {
          this.constructor = e;
        }
        r(e, t), e.prototype = t === null ? Object.create(t) : (a.prototype = t.prototype, new a());
      };
    }(), sE = function(r) {
      function e(t, a) {
        return r.call(this) || this;
      }
      return rE(e, r), e.prototype.schedule = function(t, a) {
        return this;
      }, e;
    }(qE.Subscription), tE = Object.defineProperty({ Action: sE }, "__esModule", { value: !0 }), uE = Va && Va.__extends || function() {
      var r = function(e, t) {
        return (r = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(a, n) {
          a.__proto__ = n;
        } || function(a, n) {
          for (var s in n)
            n.hasOwnProperty(s) && (a[s] = n[s]);
        })(e, t);
      };
      return function(e, t) {
        function a() {
          this.constructor = e;
        }
        r(e, t), e.prototype = t === null ? Object.create(t) : (a.prototype = t.prototype, new a());
      };
    }(), Zs = function(r) {
      function e(t, a) {
        var n = r.call(this, t, a) || this;
        return n.scheduler = t, n.work = a, n.pending = !1, n;
      }
      return uE(e, r), e.prototype.schedule = function(t, a) {
        if (a === void 0 && (a = 0), this.closed)
          return this;
        this.state = t, t = this.id;
        var n = this.scheduler;
        return t != null && (this.id = this.recycleAsyncId(n, t, a)), this.pending = !0, this.delay = a, this.id = this.id || this.requestAsyncId(n, this.id, a), this;
      }, e.prototype.requestAsyncId = function(t, a, n) {
        return n === void 0 && (n = 0), setInterval(t.flush.bind(t, this), n);
      }, e.prototype.recycleAsyncId = function(t, a, n) {
        if (n === void 0 && (n = 0), n !== null && this.delay === n && this.pending === !1)
          return a;
        clearInterval(a);
      }, e.prototype.execute = function(t, a) {
        return this.closed ? Error("executing a cancelled action") : (this.pending = !1, (t = this._execute(t, a)) ? t : void (this.pending === !1 && this.id != null && (this.id = this.recycleAsyncId(this.scheduler, this.id, null))));
      }, e.prototype._execute = function(t, a) {
        a = !1;
        var n = void 0;
        try {
          this.work(t);
        } catch (s) {
          a = !0, n = !!s && s || Error(s);
        }
        if (a)
          return this.unsubscribe(), n;
      }, e.prototype._unsubscribe = function() {
        var t = this.id, a = this.scheduler, n = a.actions, s = n.indexOf(this);
        this.state = this.work = null, this.pending = !1, this.scheduler = null, s !== -1 && n.splice(s, 1), t != null && (this.id = this.recycleAsyncId(a, t, null)), this.delay = null;
      }, e;
    }(tE.Action), vE = function() {
      function r(e, t) {
        t === void 0 && (t = r.now), this.SchedulerAction = e, this.now = t;
      }
      return r.prototype.schedule = function(e, t, a) {
        return t === void 0 && (t = 0), new this.SchedulerAction(this, e).schedule(a, t);
      }, r.now = function() {
        return Date.now();
      }, r;
    }(), $s = Object.defineProperty({ Scheduler: vE }, "__esModule", { value: !0 }), wE = Va && Va.__extends || function() {
      var r = function(e, t) {
        return (r = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(a, n) {
          a.__proto__ = n;
        } || function(a, n) {
          for (var s in n)
            n.hasOwnProperty(s) && (a[s] = n[s]);
        })(e, t);
      };
      return function(e, t) {
        function a() {
          this.constructor = e;
        }
        r(e, t), e.prototype = t === null ? Object.create(t) : (a.prototype = t.prototype, new a());
      };
    }(), at = function(r) {
      function e(t, a) {
        a === void 0 && (a = $s.Scheduler.now);
        var n = r.call(this, t, function() {
          return e.delegate && e.delegate !== n ? e.delegate.now() : a();
        }) || this;
        return n.actions = [], n.active = !1, n.scheduled = void 0, n;
      }
      return wE(e, r), e.prototype.schedule = function(t, a, n) {
        return a === void 0 && (a = 0), e.delegate && e.delegate !== this ? e.delegate.schedule(t, a, n) : r.prototype.schedule.call(this, t, a, n);
      }, e.prototype.flush = function(t) {
        var a = this.actions;
        if (this.active)
          a.push(t);
        else {
          var n;
          this.active = !0;
          do
            if (n = t.execute(t.state, t.delay))
              break;
          while (t = a.shift());
          if (this.active = !1, n) {
            for (; t = a.shift(); )
              t.unsubscribe();
            throw n;
          }
        }
      }, e;
    }($s.Scheduler), xE = Ea("iterator"), Ql = !ia(function() {
      var r = new URL("b?a=1&b=2&c=3", "http://a"), e = r.searchParams, t = "";
      return r.pathname = "c%20d", e.forEach(function(a, n) {
        e.delete("b"), t += n + a;
      }), !e.sort || r.href !== "http://a/c%20d?a=1&c=3" || e.get("c") !== "3" || String(new URLSearchParams("?a=1")) !== "a=1" || !e[xE] || new URL("https://a@b").username !== "a" || new URLSearchParams(new URLSearchParams("a=b")).get("a") !== "b" || new URL("http://\u0442\u0435\u0441\u0442").host !== "xn--e1aybc" || new URL("http://a#\u0431").hash !== "#%D0%B1" || t !== "a1c3" || new URL("http://x", void 0).host !== "x";
    }), yE = /[^\0-\u007E]/, zE = /[.\u3002\uFF0E\uFF61]/g, Df = Math.floor, Rl = String.fromCharCode, bt = function(r) {
      var e = jg(r);
      if (typeof e != "function")
        throw TypeError(String(r) + " is not iterable");
      return Ia(e.call(r));
    }, ct = Lc("fetch"), Sl = Lc("Headers"), AE = Ea("iterator"), dt = Za.set, Yb = Za.getterFor("URLSearchParams"), BE = Za.getterFor("URLSearchParamsIterator"), CE = /\+/g, et = Array(4), DE = function(r) {
      try {
        return decodeURIComponent(r);
      } catch {
        return r;
      }
    }, ft = function(r) {
      var e = r.replace(CE, " ");
      r = 4;
      try {
        return decodeURIComponent(e);
      } catch {
        for (; r; ) {
          var t = e.replace, a = r--;
          a = et[a - 1] || (et[a - 1] = RegExp("((?:%[\\da-f]{2}){" + a + "})", "gi")), e = t.call(e, a, DE);
        }
        return e;
      }
    }, gt = /[!'()~]|%20/g, EE = { "!": "%21", "'": "%27", "(": "%28", ")": "%29", "~": "%7E", "%20": "+" }, ht = function(r) {
      return EE[r];
    }, it = function(r, e) {
      if (e) {
        e = e.split("&");
        for (var t, a = 0; a < e.length; )
          (t = e[a++]).length && (t = t.split("="), r.push({ key: ft(t.shift()), value: ft(t.join("=")) }));
      }
    }, FE = function(r) {
      this.entries.length = 0, it(this.entries, r);
    }, Ef = function(r, e) {
      if (r < e)
        throw TypeError("Not enough arguments");
    }, Tl = Qo(function(r, e) {
      dt(this, { type: "URLSearchParamsIterator", iterator: bt(Yb(r).entries), kind: e });
    }, "Iterator", function() {
      var r = BE(this), e = r.kind, t = (r = r.iterator.next()).value;
      return r.done || (r.value = e === "keys" ? t.key : e === "values" ? t.value : [t.key, t.value]), r;
    }), Pg = function() {
      tc(this, Pg, "URLSearchParams");
      var r, e, t, a = 0 < arguments.length ? arguments[0] : void 0, n = [];
      if (dt(this, { type: "URLSearchParams", entries: n, updateURL: function() {
      }, updateSearchParams: FE }), a !== void 0)
        if (va(a)) {
          var s = jg(a);
          if (typeof s == "function")
            for (a = s.call(a), s = a.next; !(r = s.call(a)).done; ) {
              var o = (r = bt(Ia(r.value))).next;
              if ((e = o.call(r)).done || (t = o.call(r)).done || !o.call(r).done)
                throw TypeError("Expected sequence with length 2");
              n.push({ key: e.value + "", value: t.value + "" });
            }
          else
            for (r in a)
              ha(a, r) && n.push({ key: r, value: a[r] + "" });
        } else
          it(n, typeof a == "string" ? a.charAt(0) === "?" ? a.slice(1) : a : a + "");
    }, wi = Pg.prototype;
    gf(wi, { append: function(r, e) {
      Ef(arguments.length, 2);
      var t = Yb(this);
      t.entries.push({ key: r + "", value: e + "" }), t.updateURL();
    }, delete: function(r) {
      Ef(arguments.length, 1);
      for (var e = Yb(this), t = e.entries, a = r + "", n = 0; n < t.length; )
        t[n].key === a ? t.splice(n, 1) : n++;
      e.updateURL();
    }, get: function(r) {
      Ef(arguments.length, 1);
      for (var e = Yb(this).entries, t = r + "", a = 0; a < e.length; a++)
        if (e[a].key === t)
          return e[a].value;
      return null;
    }, getAll: function(r) {
      Ef(arguments.length, 1);
      for (var e = Yb(this).entries, t = r + "", a = [], n = 0; n < e.length; n++)
        e[n].key === t && a.push(e[n].value);
      return a;
    }, has: function(r) {
      Ef(arguments.length, 1);
      for (var e = Yb(this).entries, t = r + "", a = 0; a < e.length; )
        if (e[a++].key === t)
          return !0;
      return !1;
    }, set: function(r, e) {
      Ef(arguments.length, 1);
      for (var t, a = Yb(this), n = a.entries, s = !1, o = r + "", u = e + "", l = 0; l < n.length; l++)
        (t = n[l]).key === o && (s ? n.splice(l--, 1) : (s = !0, t.value = u));
      s || n.push({ key: o, value: u }), a.updateURL();
    }, sort: function() {
      var r, e, t = Yb(this), a = t.entries, n = a.slice();
      for (e = a.length = 0; e < n.length; e++) {
        var s = n[e];
        for (r = 0; r < e; r++)
          if (a[r].key > s.key) {
            a.splice(r, 0, s);
            break;
          }
        r === e && a.push(s);
      }
      t.updateURL();
    }, forEach: function(r) {
      for (var e, t = Yb(this).entries, a = Cd(r, 1 < arguments.length ? arguments[1] : void 0, 3), n = 0; n < t.length; )
        a((e = t[n++]).value, e.key, this);
    }, keys: function() {
      return new Tl(this, "keys");
    }, values: function() {
      return new Tl(this, "values");
    }, entries: function() {
      return new Tl(this, "entries");
    } }, { enumerable: !0 }), Wa(wi, AE, wi.entries), Wa(wi, "toString", function() {
      for (var r, e = Yb(this).entries, t = [], a = 0; a < e.length; )
        r = e[a++], t.push(encodeURIComponent(r.key).replace(gt, ht) + "=" + encodeURIComponent(r.value).replace(gt, ht));
      return t.join("&");
    }, { enumerable: !0 }), sc(Pg, "URLSearchParams"), ba({ global: !0, forced: !Ql }, { URLSearchParams: Pg }), Ql || typeof ct != "function" || typeof Sl != "function" || ba({ global: !0, enumerable: !0, forced: !0 }, { fetch: function(r) {
      var e = [r];
      if (1 < arguments.length) {
        var t = arguments[1];
        if (va(t)) {
          var a = t.body;
          if (ff(a) === "URLSearchParams") {
            var n = t.headers ? new Sl(t.headers) : new Sl();
            n.has("content-type") || n.set("content-type", "application/x-www-form-urlencoded;charset=UTF-8"), t = ec(t, { body: Jc(0, String(a)), headers: Jc(0, n) });
          }
        }
        e.push(t);
      }
      return ct.apply(this, e);
    } });
    var Qg = Q.URL, GE = Pg, HE = Za.set, $a = Za.getterFor("URL"), IE = Math.floor, jt = Math.pow, kt = /[A-Za-z]/, JE = /[\d+-.A-Za-z]/, Ul = /\d/, KE = /^(0x|0X)/, LE = /^[0-7]+$/, ME = /^\d+$/, lt = /^[\dA-Fa-f]+$/, NE = /[\0\t\n\r #%/:?@[\\]]/, OE = /[\0\t\n\r #/:?@[\\]]/, PE = /^[\u0000-\u001F ]+|[\u0000-\u001F ]+$/g, QE = /[\t\n\r]/g, Vl = function(r, e) {
      var t;
      if (e.charAt(0) == "[") {
        if (e.charAt(e.length - 1) != "]")
          return "Invalid host";
        var a = RE(e.slice(1, -1));
        if (!a)
          return "Invalid host";
      } else if (sb(r)) {
        for (a = [], e = e.toLowerCase().replace(zE, ".").split("."), t = 0; t < e.length; t++) {
          var n = e[t], s = a, o = s.push;
          if (yE.test(n)) {
            var u = n;
            n = [];
            var l = u;
            u = [];
            for (var f = 0, d = l.length; f < d; ) {
              var h = l.charCodeAt(f++);
              if (55296 <= h && 56319 >= h && f < d) {
                var p = l.charCodeAt(f++);
                (64512 & p) == 56320 ? u.push(((1023 & h) << 10) + (1023 & p) + 65536) : (u.push(h), f--);
              } else
                u.push(h);
            }
            f = u.length, d = 128;
            var m = 0, _ = 72;
            for (l = 0; l < u.length; l++) {
              var w = u[l];
              128 > w && n.push(Rl(w));
            }
            for ((p = h = n.length) && n.push("-"); p < f; ) {
              var S = 2147483647;
              for (l = 0; l < u.length; l++)
                (w = u[l]) >= d && w < S && (S = w);
              var O = p + 1;
              if (S - d > Df((2147483647 - m) / O))
                throw RangeError("Overflow: input needs wider integers to process");
              for (m += (S - d) * O, d = S, l = 0; l < u.length; l++) {
                if ((w = u[l]) < d && 2147483647 < ++m)
                  throw RangeError("Overflow: input needs wider integers to process");
                if (w == d) {
                  var k = m;
                  for (w = 36; !(k < (S = w <= _ ? 1 : w >= _ + 26 ? 26 : w - _)); w += 36) {
                    var B = 36 - S, L = n;
                    S += (k -= S) % B, L.push.call(L, Rl(S + 22 + 75 * (26 > S))), k = Df(k / B);
                  }
                  for (n.push(Rl(k + 22 + 75 * (26 > k))), _ = O, w = 0, m = p == h ? Df(m / 700) : m >> 1, m += Df(m / _); 455 < m; w += 36)
                    m = Df(m / 35);
                  _ = Df(w + 36 * m / (m + 38)), m = 0, ++p;
                }
              }
              ++m, ++d;
            }
            n = "xn--" + n.join("");
          }
          o.call(s, n);
        }
        if (e = a.join("."), NE.test(e) || (a = SE(e)) === null)
          return "Invalid host";
      } else {
        if (OE.test(e))
          return "Invalid host";
        for (a = "", e = fe(e), t = 0; t < e.length; t++)
          a += Pd(e[t], xi);
      }
      r.host = a;
    }, SE = function(r) {
      var e, t = r.split(".");
      t.length && t[t.length - 1] == "" && t.pop();
      var a = t.length;
      if (4 < a)
        return r;
      var n = [];
      for (e = 0; e < a; e++) {
        var s = t[e];
        if (s == "")
          return r;
        var o = 10;
        if (1 < s.length && s.charAt(0) == "0" && (o = KE.test(s) ? 16 : 8, s = s.slice(o == 8 ? 1 : 2)), s === "")
          s = 0;
        else {
          if (!(o == 10 ? ME : o == 8 ? LE : lt).test(s))
            return r;
          s = parseInt(s, o);
        }
        n.push(s);
      }
      for (e = 0; e < a; e++)
        if (s = n[e], e == a - 1) {
          if (s >= jt(256, 5 - a))
            return null;
        } else if (255 < s)
          return null;
      for (r = n.pop(), e = 0; e < n.length; e++)
        r += n[e] * jt(256, 3 - e);
      return r;
    }, RE = function(r) {
      var e, t, a = [0, 0, 0, 0, 0, 0, 0, 0], n = 0, s = null, o = 0, u = function() {
        return r.charAt(o);
      };
      if (u() == ":") {
        if (r.charAt(1) != ":")
          return;
        o += 2, s = ++n;
      }
      for (; u(); ) {
        if (n == 8)
          return;
        if (u() == ":") {
          if (s !== null)
            return;
          o++, s = ++n;
        } else {
          for (e = t = 0; 4 > t && lt.test(u()); )
            e = 16 * e + parseInt(u(), 16), o++, t++;
          if (u() == ".") {
            if (t == 0 || (o -= t, 6 < n))
              return;
            for (e = 0; u(); ) {
              if (t = null, 0 < e) {
                if (!(u() == "." && 4 > e))
                  return;
                o++;
              }
              if (!Ul.test(u()))
                return;
              for (; Ul.test(u()); ) {
                var l = parseInt(u(), 10);
                if (t === null)
                  t = l;
                else {
                  if (t == 0)
                    return;
                  t = 10 * t + l;
                }
                if (255 < t)
                  return;
                o++;
              }
              a[n] = 256 * a[n] + t, ++e != 2 && e != 4 || n++;
            }
            if (e != 4)
              return;
            break;
          }
          if (u() == ":") {
            if (o++, !u())
              return;
          } else if (u())
            return;
          a[n++] = e;
        }
      }
      if (s !== null)
        for (u = n - s, n = 7; n != 0 && 0 < u; )
          e = a[n], a[n--] = a[s + u - 1], a[s + --u] = e;
      else if (n != 8)
        return;
      return a;
    }, Rg = function(r) {
      var e, t;
      if (typeof r == "number") {
        var a = [];
        for (e = 0; 4 > e; e++)
          a.unshift(r % 256), r = IE(r / 256);
        return a.join(".");
      }
      if (typeof r == "object") {
        a = "", e = null;
        for (var n = 1, s = null, o = 0, u = 0; 8 > u; u++)
          r[u] !== 0 ? (o > n && (e = s, n = o), s = null, o = 0) : (s === null && (s = u), ++o);
        for (o > n && (e = s), n = e, e = 0; 8 > e; e++)
          t && r[e] === 0 || (t && (t = !1), n === e ? (a += e ? ":" : "::", t = !0) : (a += r[e].toString(16), 7 > e && (a += ":")));
        return "[" + a + "]";
      }
      return r;
    }, xi = {}, mt = zg({}, xi, { " ": 1, '"': 1, "<": 1, ">": 1, "`": 1 }), nt = zg({}, mt, { "#": 1, "?": 1, "{": 1, "}": 1 }), Wl = zg({}, nt, { "/": 1, ":": 1, ";": 1, "=": 1, "@": 1, "[": 1, "\\": 1, "]": 1, "^": 1, "|": 1 }), Pd = function(r, e) {
      var t = kw(r, 0);
      return 32 < t && 127 > t && !ha(e, r) ? r : encodeURIComponent(r);
    }, yi = { ftp: 21, file: null, http: 80, https: 443, ws: 80, wss: 443 }, sb = function(r) {
      return ha(yi, r.scheme);
    }, Xl = function(r) {
      return !r.host || r.cannotBeABaseURL || r.scheme == "file";
    }, Sg = function(r, e) {
      var t;
      return r.length == 2 && kt.test(r.charAt(0)) && ((t = r.charAt(1)) == ":" || !e && t == "|");
    }, ot = function(r) {
      var e;
      return 1 < r.length && Sg(r.slice(0, 2)) && (r.length == 2 || (e = r.charAt(2)) === "/" || e === "\\" || e === "?" || e === "#");
    }, pt = function(r) {
      var e = r.path, t = e.length;
      !t || r.scheme == "file" && t == 1 && Sg(e[0], !0) || e.pop();
    }, Yl = {}, qt = {}, Zl = {}, rt = {}, st = {}, $l = {}, tt = {}, ut = {}, zi = {}, Ai = {}, am = {}, bm = {}, cm = {}, dm = {}, vt = {}, em = {}, Tg = {}, Vc = {}, wt = {}, we = {}, sd = {}, Wc = function(r, e, t, a) {
      var n = t || Yl, s = 0, o = "", u = !1, l = !1, f = !1;
      for (t || (r.scheme = "", r.username = "", r.password = "", r.host = null, r.port = null, r.path = [], r.query = null, r.fragment = null, r.cannotBeABaseURL = !1, e = e.replace(PE, "")), e = e.replace(QE, ""), e = fe(e); s <= e.length; ) {
        var d = e[s];
        switch (n) {
          case Yl:
            if (!d || !kt.test(d)) {
              if (t)
                return "Invalid scheme";
              n = Zl;
              continue;
            }
            o += d.toLowerCase(), n = qt;
            break;
          case qt:
            if (d && (JE.test(d) || d == "+" || d == "-" || d == "."))
              o += d.toLowerCase();
            else {
              if (d != ":") {
                if (t)
                  return "Invalid scheme";
                o = "", n = Zl, s = 0;
                continue;
              }
              if (t && (sb(r) != ha(yi, o) || o == "file" && (r.username != "" || r.password != "" || r.port !== null) || r.scheme == "file" && !r.host))
                return;
              if (r.scheme = o, t)
                return void (sb(r) && yi[r.scheme] == r.port && (r.port = null));
              o = "", r.scheme == "file" ? n = dm : sb(r) && a && a.scheme == r.scheme ? n = rt : sb(r) ? n = ut : e[s + 1] == "/" ? (n = st, s++) : (r.cannotBeABaseURL = !0, r.path.push(""), n = wt);
            }
            break;
          case Zl:
            if (!a || a.cannotBeABaseURL && d != "#")
              return "Invalid scheme";
            if (a.cannotBeABaseURL && d == "#") {
              r.scheme = a.scheme, r.path = a.path.slice(), r.query = a.query, r.fragment = "", r.cannotBeABaseURL = !0, n = sd;
              break;
            }
            n = a.scheme == "file" ? dm : $l;
            continue;
          case rt:
            if (d != "/" || e[s + 1] != "/") {
              n = $l;
              continue;
            }
            n = zi, s++;
            break;
          case st:
            if (d == "/") {
              n = Ai;
              break;
            }
            n = Vc;
            continue;
          case $l:
            if (r.scheme = a.scheme, d == null)
              r.username = a.username, r.password = a.password, r.host = a.host, r.port = a.port, r.path = a.path.slice(), r.query = a.query;
            else if (d == "/" || d == "\\" && sb(r))
              n = tt;
            else if (d == "?")
              r.username = a.username, r.password = a.password, r.host = a.host, r.port = a.port, r.path = a.path.slice(), r.query = "", n = we;
            else {
              if (d != "#") {
                r.username = a.username, r.password = a.password, r.host = a.host, r.port = a.port, r.path = a.path.slice(), r.path.pop(), n = Vc;
                continue;
              }
              r.username = a.username, r.password = a.password, r.host = a.host, r.port = a.port, r.path = a.path.slice(), r.query = a.query, r.fragment = "", n = sd;
            }
            break;
          case tt:
            if (!sb(r) || d != "/" && d != "\\") {
              if (d != "/") {
                r.username = a.username, r.password = a.password, r.host = a.host, r.port = a.port, n = Vc;
                continue;
              }
              n = Ai;
            } else
              n = zi;
            break;
          case ut:
            if (n = zi, d != "/" || o.charAt(s + 1) != "/")
              continue;
            s++;
            break;
          case zi:
            if (d != "/" && d != "\\") {
              n = Ai;
              continue;
            }
            break;
          case Ai:
            if (d == "@") {
              for (u && (o = "%40" + o), u = !0, o = fe(o), d = 0; d < o.length; d++) {
                var h = o[d];
                h != ":" || f ? (h = Pd(h, Wl), f ? r.password += h : r.username += h) : f = !0;
              }
              o = "";
            } else if (d == null || d == "/" || d == "?" || d == "#" || d == "\\" && sb(r)) {
              if (u && o == "")
                return "Invalid authority";
              s -= fe(o).length + 1, o = "", n = am;
            } else
              o += d;
            break;
          case am:
          case bm:
            if (t && r.scheme == "file") {
              n = em;
              continue;
            }
            if (d != ":" || l) {
              if (d == null || d == "/" || d == "?" || d == "#" || d == "\\" && sb(r)) {
                if (sb(r) && o == "")
                  return "Invalid host";
                if (t && o == "" && (r.username != "" || r.password != "" || r.port !== null))
                  return;
                if (n = Vl(r, o))
                  return n;
                if (o = "", n = Tg, t)
                  return;
                continue;
              }
              d == "[" ? l = !0 : d == "]" && (l = !1), o += d;
            } else {
              if (o == "")
                return "Invalid host";
              if (n = Vl(r, o))
                return n;
              if (o = "", n = cm, t == bm)
                return;
            }
            break;
          case cm:
            if (!Ul.test(d)) {
              if (d == null || d == "/" || d == "?" || d == "#" || d == "\\" && sb(r) || t) {
                if (o != "") {
                  if (65535 < (n = parseInt(o, 10)))
                    return "Invalid port";
                  r.port = sb(r) && n === yi[r.scheme] ? null : n, o = "";
                }
                if (t)
                  return;
                n = Tg;
                continue;
              }
              return "Invalid port";
            }
            o += d;
            break;
          case dm:
            if (r.scheme = "file", d == "/" || d == "\\")
              n = vt;
            else {
              if (!a || a.scheme != "file") {
                n = Vc;
                continue;
              }
              if (d == null)
                r.host = a.host, r.path = a.path.slice(), r.query = a.query;
              else if (d == "?")
                r.host = a.host, r.path = a.path.slice(), r.query = "", n = we;
              else {
                if (d != "#") {
                  ot(e.slice(s).join("")) || (r.host = a.host, r.path = a.path.slice(), pt(r)), n = Vc;
                  continue;
                }
                r.host = a.host, r.path = a.path.slice(), r.query = a.query, r.fragment = "", n = sd;
              }
            }
            break;
          case vt:
            if (d == "/" || d == "\\") {
              n = em;
              break;
            }
            a && a.scheme == "file" && !ot(e.slice(s).join("")) && (Sg(a.path[0], !0) ? r.path.push(a.path[0]) : r.host = a.host), n = Vc;
            continue;
          case em:
            if (d == null || d == "/" || d == "\\" || d == "?" || d == "#") {
              if (!t && Sg(o))
                n = Vc;
              else {
                if (o == "") {
                  if (r.host = "", t)
                    return;
                } else {
                  if (n = Vl(r, o))
                    return n;
                  if (r.host == "localhost" && (r.host = ""), t)
                    return;
                  o = "";
                }
                n = Tg;
              }
              continue;
            }
            o += d;
            break;
          case Tg:
            if (sb(r)) {
              if (n = Vc, d != "/" && d != "\\")
                continue;
            } else if (t || d != "?")
              if (t || d != "#") {
                if (d != null && (n = Vc, d != "/"))
                  continue;
              } else
                r.fragment = "", n = sd;
            else
              r.query = "", n = we;
            break;
          case Vc:
            if (d == null || d == "/" || d == "\\" && sb(r) || !t && (d == "?" || d == "#")) {
              if ((h = (h = o).toLowerCase()) === ".." || h === "%2e." || h === ".%2e" || h === "%2e%2e" ? (pt(r), d == "/" || d == "\\" && sb(r) || r.path.push("")) : o === "." || o.toLowerCase() === "%2e" ? d == "/" || d == "\\" && sb(r) || r.path.push("") : (r.scheme == "file" && !r.path.length && Sg(o) && (r.host && (r.host = ""), o = o.charAt(0) + ":"), r.path.push(o)), o = "", r.scheme == "file" && (d == null || d == "?" || d == "#"))
                for (; 1 < r.path.length && r.path[0] === ""; )
                  r.path.shift();
              d == "?" ? (r.query = "", n = we) : d == "#" && (r.fragment = "", n = sd);
            } else
              o += Pd(d, nt);
            break;
          case wt:
            d == "?" ? (r.query = "", n = we) : d == "#" ? (r.fragment = "", n = sd) : d != null && (r.path[0] += Pd(d, xi));
            break;
          case we:
            t || d != "#" ? d != null && (d == "'" && sb(r) ? r.query += "%27" : r.query = d == "#" ? r.query + "%23" : r.query + Pd(d, xi)) : (r.fragment = "", n = sd);
            break;
          case sd:
            d != null && (r.fragment += Pd(d, mt));
        }
        s++;
      }
    }, Qd = function(r) {
      var e = tc(this, Qd, "URL"), t = 1 < arguments.length ? arguments[1] : void 0, a = String(r), n = HE(e, { type: "URL" });
      if (t !== void 0) {
        if (t instanceof Qd)
          var s = $a(t);
        else if (t = Wc(s = {}, String(t)))
          throw TypeError(t);
      }
      if (t = Wc(n, a, null, s))
        throw TypeError(t);
      var o = n.searchParams = new GE();
      (a = Yb(o)).updateSearchParams(n.query), a.updateURL = function() {
        n.query = String(o) || null;
      }, ta || (e.href = Bi.call(e), e.origin = xt.call(e), e.protocol = yt.call(e), e.username = zt.call(e), e.password = At.call(e), e.host = Bt.call(e), e.hostname = Ct.call(e), e.port = Dt.call(e), e.pathname = Et.call(e), e.search = Ft.call(e), e.searchParams = Gt.call(e), e.hash = Ht.call(e));
    }, fm = Qd.prototype, Bi = function() {
      var r = $a(this), e = r.scheme, t = r.username, a = r.password, n = r.host, s = r.port, o = r.path, u = r.query, l = r.fragment, f = e + ":";
      return n !== null ? (f += "//", r.username == "" && r.password == "" || (f += t + (a ? ":" + a : "") + "@"), f += Rg(n), s !== null && (f += ":" + s)) : e == "file" && (f += "//"), f += r.cannotBeABaseURL ? o[0] : o.length ? "/" + o.join("/") : "", u !== null && (f += "?" + u), l !== null && (f += "#" + l), f;
    }, xt = function() {
      var r = $a(this), e = r.scheme, t = r.port;
      if (e == "blob")
        try {
          return new Qd(e.path[0]).origin;
        } catch {
          return "null";
        }
      return e != "file" && sb(r) ? e + "://" + Rg(r.host) + (t !== null ? ":" + t : "") : "null";
    }, yt = function() {
      return $a(this).scheme + ":";
    }, zt = function() {
      return $a(this).username;
    }, At = function() {
      return $a(this).password;
    }, Bt = function() {
      var r = $a(this), e = r.host;
      return r = r.port, e === null ? "" : r === null ? Rg(e) : Rg(e) + ":" + r;
    }, Ct = function() {
      var r = $a(this).host;
      return r === null ? "" : Rg(r);
    }, Dt = function() {
      var r = $a(this).port;
      return r === null ? "" : String(r);
    }, Et = function() {
      var r = $a(this), e = r.path;
      return r.cannotBeABaseURL ? e[0] : e.length ? "/" + e.join("/") : "";
    }, Ft = function() {
      var r = $a(this).query;
      return r ? "?" + r : "";
    }, Gt = function() {
      return $a(this).searchParams;
    }, Ht = function() {
      var r = $a(this).fragment;
      return r ? "#" + r : "";
    }, mc = function(r, e) {
      return { get: r, set: e, configurable: !0, enumerable: !0 };
    };
    if (ta && No(fm, { href: mc(Bi, function(r) {
      var e = $a(this);
      if (r = Wc(e, String(r)))
        throw TypeError(r);
      Yb(e.searchParams).updateSearchParams(e.query);
    }), origin: mc(xt), protocol: mc(yt, function(r) {
      var e = $a(this);
      Wc(e, String(r) + ":", Yl);
    }), username: mc(zt, function(r) {
      var e = $a(this);
      if (r = fe(String(r)), !Xl(e)) {
        e.username = "";
        for (var t = 0; t < r.length; t++)
          e.username += Pd(r[t], Wl);
      }
    }), password: mc(At, function(r) {
      var e = $a(this);
      if (r = fe(String(r)), !Xl(e)) {
        e.password = "";
        for (var t = 0; t < r.length; t++)
          e.password += Pd(r[t], Wl);
      }
    }), host: mc(Bt, function(r) {
      var e = $a(this);
      e.cannotBeABaseURL || Wc(e, String(r), am);
    }), hostname: mc(Ct, function(r) {
      var e = $a(this);
      e.cannotBeABaseURL || Wc(e, String(r), bm);
    }), port: mc(Dt, function(r) {
      var e = $a(this);
      Xl(e) || ((r = String(r)) == "" ? e.port = null : Wc(e, r, cm));
    }), pathname: mc(Et, function(r) {
      var e = $a(this);
      e.cannotBeABaseURL || (e.path = [], Wc(e, r + "", Tg));
    }), search: mc(Ft, function(r) {
      var e = $a(this);
      (r = String(r)) == "" ? e.query = null : (r.charAt(0) == "?" && (r = r.slice(1)), e.query = "", Wc(e, r, we)), Yb(e.searchParams).updateSearchParams(e.query);
    }), searchParams: mc(Gt), hash: mc(Ht, function(r) {
      var e = $a(this);
      (r = String(r)) == "" ? e.fragment = null : (r.charAt(0) == "#" && (r = r.slice(1)), e.fragment = "", Wc(e, r, sd));
    }) }), Wa(fm, "toJSON", function() {
      return Bi.call(this);
    }, { enumerable: !0 }), Wa(fm, "toString", function() {
      return Bi.call(this);
    }, { enumerable: !0 }), Qg) {
      var It = Qg.createObjectURL, Jt = Qg.revokeObjectURL;
      It && Wa(Qd, "createObjectURL", function(r) {
        return It.apply(Qg, arguments);
      }), Jt && Wa(Qd, "revokeObjectURL", function(r) {
        return Jt.apply(Qg, arguments);
      });
    }
    sc(Qd, "URL"), ba({ global: !0, forced: !Ql, sham: !ta }, { URL: Qd });
    var TE = new Blob(["var fakeIdToId = {};onmessage = function (event) {	var data = event.data,		name = data.name,		fakeId = data.fakeId,		time;	if(data.hasOwnProperty('time')) {		time = data.time;	}	switch (name) {		case 'setInterval':			fakeIdToId[fakeId] = setInterval(function () {				postMessage({fakeId: fakeId});			}, time);			break;		case 'clearInterval':			if (fakeIdToId.hasOwnProperty (fakeId)) {				clearInterval(fakeIdToId[fakeId]);				delete fakeIdToId[fakeId];			}			break;	}}"]), UE = window.URL.createObjectURL(TE), We = {}, bg = 0, uj = new Worker(UE);
    uj.onmessage = function(r) {
      if (r = r.data.fakeId, We.hasOwnProperty(r)) {
        var e = We[r];
        r = e.callback, e = e.parameters, r.apply(window, e);
      }
    };
    var VE = function(r) {
      function e() {
        return ua(this, e), t.apply(this, arguments);
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "requestAsyncId", value: function(a, n) {
        var s = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : 0;
        return Gv(a.flush.bind(a, this), s);
      } }, { key: "recycleAsyncId", value: function(a, n) {
        var s = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : 0;
        if (s !== null && this.delay === s && this.pending === !1)
          return n;
        We.hasOwnProperty(n) && (delete We[n], uj.postMessage({ name: "clearInterval", fakeId: n }));
      } }]), e;
    }(Zs), WE = new at(VE), XE = ["group"], gm = F.inflate, Kt = F.deflate, Lt = function(r) {
      function e(n, s, o, u) {
        ua(this, e);
        var l = a.call(this, u, "Session");
        return x(z(l), "lastNoticeTicket", ""), x(z(l), "chatManager", void 0), x(z(l), "usedChannelIds", []), x(z(l), "msgDedupLru", new Sc(void 0, { maxlen: 200 })), x(z(l), "startTime", Date.now()), x(z(l), "seq", ma.fromNumber(1, !0)), x(z(l), "userJoinOptions", new Xs(!1)), x(z(l), "seqSentStatuses", [!1, !1]), x(z(l), "dialogueSequenceLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "loggedOut", !1), x(z(l), "messageSentTimes", []), x(z(l), "curLoginSockets", [void 0, void 0]), x(z(l), "loginSocketSubs", [{ channels: /* @__PURE__ */ new Map(), receivers: [] }, { channels: /* @__PURE__ */ new Map(), receivers: [] }]), x(z(l), "lastLoginSockets", [new Qe(1), new Qe(1)]), x(z(l), "dialPendingMsgSubjectMap", /* @__PURE__ */ new Map()), x(z(l), "context", void 0), x(z(l), "connection", void 0), x(z(l), "instanceId", void 0), x(z(l), "lastPingTime", void 0), x(z(l), "registerSocketsFailureListener", function() {
          l.connection.once("socketsFailure", function() {
            l.log("socketsFailure, creating a new connection"), wd(function() {
              return l.connection.removeAllListeners(), l.connection = new Us(l.context, l.logger, !0), l.loginHandler(15e3, !0);
            }).pipe(Oe(function(f) {
              return f.pipe(Yd(ue.getParameter("RECONNECTING_AP_INTERVAL")));
            }), Gc(l.connection.apClient.apFinish$)).subscribe(function() {
              l.log("new connection connected");
            });
          }), l.connection.listenerCount("tokenExpired") === 0 && l.connection.on("tokenExpired", function() {
            l.emit("tokenExpired");
          });
        }), l.context = n, l.connection = s, l.instanceId = o, l.chatManager = new jE(u), l.lastPingTime = [0, 0], l.setMaxListeners(512), l.log("The instanceId is %s", l.instanceId.toString()), l;
      }
      Ga(e, r);
      var t, a = Ha(e);
      return cb(e, [{ key: "loginHandler", value: function() {
        var n = this, s = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 12e3, o = 1 < arguments.length && arguments[1] !== void 0 && arguments[1];
        if (this.loggedOut && o)
          throw new aa("Already logged out, request ignored");
        o && this.registerSocketsFailureListener(), this.connection.initConnection();
        var u = this.getSocketLoginObservables(this.connection.lastOpenSockets, this.seq), l = Date.now();
        return u.forEach(function(f, d) {
          var h = n.loginSocketSubs[d].login;
          h !== void 0 && h.unsubscribe(), n.loginSocketSubs[d].login = f.pipe(sa(function(p) {
            var m;
            n.curLoginSockets[d] = p;
            var _ = Date.now();
            xb("Link", { ackedServerIp: p.address, destServerIp: p.ip, ec: 0, sc: 0, elapse: yb(n.startTime), lts: ma.fromNumber(_), responseTime: _ - l, sid: rb(n.instanceId), userId: n.context.uid }, (m = n.context.config.enableCloudProxy) !== null && m !== void 0 && m), n.emit("userJoined", p.env), o && n.connection.apClient.apFinish$.next(void 0);
          })).subscribe(n.lastLoginSockets[d]);
        }), this.initKeepAliveSender(), this.initKeepAliveReconnector(), this.initLoginReceiver(), Ec.apply(void 0, W(u).concat([Gb(this.connection, "connectionInitFailure").pipe(sa(function(f) {
          throw Ma(f) || vb(f) ? f : new Ja("Login failure", { code: Ur, originalError: f });
        }))])).pipe(db(1), Hb(s), Ya(function(f) {
          return f instanceof Pb && n.warn("Client login timeout"), f && f.code === qi && (n.connection.emit("tokenExpired"), n.connection.apClient.apFinish$.next(void 0)), n.clearSockets(0, o), pa(f);
        }), sa(function() {
          o || n.registerSocketsFailureListener();
        }), ch(function() {
          o || n.connection.apClient.apFinish$.next(void 0);
        }));
      } }, { key: "logoutHandler", value: (t = ja(M.mark(function n() {
        var s, o, u, l = this;
        return M.wrap(function(f) {
          for (; ; )
            switch (f.prev = f.next) {
              case 0:
                return this.loggedOut = !0, this.connection.apClient.apFinish$.next(void 0), s = this.getLoginSockets(), o = s.map(function(d) {
                  return d.sendPacket("UserQuit", {}), l.connection.waitClosing(d);
                }), this.clearSockets(5e3), u = s.map(function(d) {
                  return d.env;
                }), [0, 1].filter(function(d) {
                  return !u.includes(d);
                }).forEach(function(d) {
                  l.connection.closeSocket(d, 0);
                }), f.abrupt("return", Ec.apply(void 0, W(o)).toPromise());
              case 9:
              case "end":
                return f.stop();
            }
        }, n, this);
      })), function() {
        return t.apply(this, arguments);
      }) }, { key: "requestChannelJoin", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d = this;
          return M.wrap(function(h) {
            for (; ; )
              switch (h.prev = h.next) {
                case 0:
                  if (this.getLoginSockets().length !== 0) {
                    h.next = 2;
                    break;
                  }
                  throw new aa("Client is not logged in. Cannot join the channel", Qr);
                case 2:
                  return u = Gb(this, "channelLeft").pipe(Ob(function(p) {
                    return o === p;
                  }), db(1)), l = this.incGetSeq(), (f = this.lastLoginSockets.map(function(p) {
                    return p.pipe(Fc(function(m, _) {
                      _ !== 0 && d.incSeqIfNeeded(m.env);
                      var w = _ === 0 ? l : d.seq;
                      return m.sendPacket("GroupEnter", { account: o, seq: w }), m.fromReceived("GroupReply").pipe(Aa(function(S) {
                        return w.eq(S.seq);
                      }), sa(function(S) {
                        if ((S = S.code) !== 0)
                          throw new Ja(["Channel join failure. The response code is %d", S], Mr);
                      }));
                    }), Gc(u), Pe());
                  })).forEach(function(p, m) {
                    var _ = function() {
                      return d.loginSocketSubs[m].channels.delete(o);
                    };
                    d.loginSocketSubs[m].channels.set(o, p.subscribe({ error: _, complete: _ }));
                  }), h.next = 8, Ec.apply(void 0, W(f)).pipe(db(1), Hb(1e4), Ya(function(p) {
                    return p instanceof Pb && d.warn("Channel join timeout"), pa(p);
                  })).toPromise();
                case 8:
                case "end":
                  return h.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "requestChannelLeave", value: function(n) {
        this.getLoginSockets().forEach(function(s) {
          s.sendPacket("GroupLeave", { account: n });
        });
      } }, { key: "requestUpdateEdgeTicket", value: function(n) {
        var s = this, o = this.getLoginSockets();
        if (o.length === 0)
          throw new aa("Client is not logged in. Cannot renew token", bs);
        var u = this.incGetSeq();
        return o.forEach(function(l) {
          l.sendPacket("UserRenewTokenReq", { instance: s.instanceId, seq: u, account: s.context.uid, ticket: n });
        }), ab.apply(void 0, [e.genTimeoutError(Gl)].concat(W(o.map(function(l) {
          return l.fromReceived("UserRenewTokenResp").pipe(Aa(function(f) {
            var d = f.code;
            return u.eq(f.seq) && d === 0;
          }));
        }))));
      } }, { key: "requestChannelMemberList", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in. Cannot get the channel members", xB);
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("GroupAllUsersList", { group: n, pageNumber: 0, pageSize: 200, seq: o });
        }), ab.apply(void 0, [e.genTimeoutError(Kr)].concat(W(s.map(function(u) {
          return u.fromReceived("GroupAllUsersResult").pipe(Aa(function(l) {
            var f = l.seq;
            return l.group === n && o.eq(f);
          }));
        }))));
      } }, { key: "requestPeersOnlineStatus", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("UserStatusList", { users: n, seq: o });
        }), ab.apply(void 0, [e.genTimeoutError(IB)].concat(W(s.map(function(u) {
          return u.fromReceived("UserStatusResult").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }));
        }))));
      } }, { key: "requestSetLocalUserAttributes", value: function(n, s) {
        var o = this, u = this.getLoginSockets();
        if (u.length === 0)
          throw new aa("Client is not logged in");
        var l = this.incGetSeq();
        return u.forEach(function(f, d) {
          s !== void 0 && d !== s || f.sendPacket("UserAttributeSet", { account: o.context.uid, attributeInfos: Object.entries(n).map(function(h) {
            return { key: (h = Xa(h, 2))[0], value: h[1] };
          }), seq: l });
        }), ab.apply(void 0, W(u.map(function(f) {
          return f.fromReceived("UserAttributeErr").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }), Da(function(d) {
            throw new Ja(["The user attributes set failure, code %d", d.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(u.map(function(f) {
          return f.fromReceived("UserAttributeRsp").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }));
        }))));
      } }, { key: "requestSetChannelAttributes", value: function(n, s, o) {
        var u = this.getLoginSockets();
        if (u.length === 0)
          throw new aa("Client is not logged in");
        var l = this.incGetSeq();
        return u.forEach(function(f) {
          f.sendPacket("GroupAttributeSet", { broadcast: o, group: n, attributeInfos: Object.entries(s).map(function(d) {
            return { key: (d = Xa(d, 2))[0], value: d[1] };
          }), seq: l });
        }), ab.apply(void 0, W(u.map(function(f) {
          return f.fromReceived("GroupAttributeErr").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }), Da(function(d) {
            throw new Ja(["The group attributes set failure, code %d", d.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(u.map(function(f) {
          return f.fromReceived("GroupAttributeRsp").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }));
        }))));
      } }, { key: "requestAddOrUpdateLocalUserAttributes", value: function(n) {
        var s = this, o = this.getLoginSockets();
        if (o.length === 0)
          throw new aa("Client is not logged in");
        var u = this.incGetSeq();
        return o.forEach(function(l) {
          l.sendPacket("UserAttributeMod", { account: s.context.uid, attributeInfos: Object.entries(n).map(function(f) {
            return { key: (f = Xa(f, 2))[0], value: f[1] };
          }), seq: u });
        }), ab.apply(void 0, W(o.map(function(l) {
          return l.fromReceived("UserAttributeErr").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }), Da(function(f) {
            throw new Ja(["The user attributes add or update failure, code %d", f.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(o.map(function(l) {
          return l.fromReceived("UserAttributeRsp").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }));
        }))));
      } }, { key: "requestAddOrUpdateChannelAttributes", value: function(n, s, o) {
        var u = this.getLoginSockets();
        if (u.length === 0)
          throw new aa("Client is not logged in");
        var l = this.incGetSeq();
        return u.forEach(function(f) {
          f.sendPacket("GroupAttributeMod", { broadcast: o, group: n, attributeInfos: Object.entries(s).map(function(d) {
            return { key: (d = Xa(d, 2))[0], value: d[1] };
          }), seq: l });
        }), ab.apply(void 0, W(u.map(function(f) {
          return f.fromReceived("GroupAttributeErr").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }), Da(function(d) {
            throw new Ja(["The group attributes add or update failure, code %d", d.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(u.map(function(f) {
          return f.fromReceived("GroupAttributeRsp").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }));
        }))));
      } }, { key: "requestDeleteLocalUserAttributesByKeys", value: function(n) {
        var s = this, o = this.getLoginSockets();
        if (o.length === 0)
          throw new aa("Client is not logged in");
        var u = this.incGetSeq();
        return o.forEach(function(l) {
          l.sendPacket("UserAttributeDel", { account: s.context.uid, attributes: n, seq: u });
        }), ab.apply(void 0, W(o.map(function(l) {
          return l.fromReceived("UserAttributeErr").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }), Da(function(f) {
            throw new Ja(["The user attributes delete failure, code %d", f.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(o.map(function(l) {
          return l.fromReceived("UserAttributeRsp").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }));
        }))));
      } }, { key: "requestDeleteChannelAttributesByKeys", value: function(n, s, o) {
        var u = this.getLoginSockets();
        if (u.length === 0)
          throw new aa("Client is not logged in");
        var l = this.incGetSeq();
        return u.forEach(function(f) {
          f.sendPacket("GroupAttributeDel", { group: n, broadcast: o, attributes: s, seq: l });
        }), ab.apply(void 0, W(u.map(function(f) {
          return f.fromReceived("GroupAttributeErr").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }), Da(function(d) {
            throw new Ja(["The channel attributes delete failure, code %d", d.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(u.map(function(f) {
          return f.fromReceived("GroupAttributeRsp").pipe(Aa(function(d) {
            return l.eq(d.seq);
          }));
        }))));
      } }, { key: "requestClearLocalUserAttributes", value: function() {
        var n = this, s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("UserAttributeSet", { account: n.context.uid, seq: o, attributeInfos: [] });
        }), ab.apply(void 0, W(s.map(function(u) {
          return u.fromReceived("UserAttributeErr").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }), Da(function(l) {
            throw new Ja(["The user attributes clear failure, code %d", l.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(s.map(function(u) {
          return u.fromReceived("UserAttributeRsp").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }));
        }))));
      } }, { key: "requestClearChannelAttributes", value: function(n, s) {
        var o = this.getLoginSockets();
        if (o.length === 0)
          throw new aa("Client is not logged in");
        var u = this.incGetSeq();
        return o.forEach(function(l) {
          l.sendPacket("GroupAttributeSet", { group: n, seq: u, attributeInfos: [], broadcast: s });
        }), ab.apply(void 0, W(o.map(function(l) {
          return l.fromReceived("GroupAttributeErr").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }), Da(function(f) {
            throw new Ja(["The channel attributes clear failure, code %d", f.code], jc);
          }));
        })).concat([e.genTimeoutError(kc)], W(o.map(function(l) {
          return l.fromReceived("GroupAttributeRsp").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }));
        }))));
      } }, { key: "requestGetUserAttributesByKeys", value: function(n, s) {
        var o = this.getLoginSockets();
        if (o.length === 0)
          throw new aa("Client is not logged in");
        var u = this.incGetSeq();
        return o.forEach(function(l) {
          l.sendPacket("UserAttributeGet", { account: n, seq: u, attributes: s });
        }), ab.apply(void 0, [e.genTimeoutError(kc)].concat(W(o.map(function(l) {
          return l.fromReceived("UserAttributeErr").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }), Da(function(f) {
            throw (f = f.code) === 10008 ? new Ja("The user requested is not online", Gr) : new se(["User attribute operation unknown error code: %d", f], jc);
          }));
        })), W(o.map(function(l) {
          return l.fromReceived("UserAttributeRet").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }));
        }))));
      } }, { key: "requestGetChannelAttributesByKeys", value: function(n, s) {
        var o = this.getLoginSockets();
        if (o.length === 0)
          throw new aa("Client is not logged in");
        var u = this.incGetSeq();
        return o.forEach(function(l) {
          l.sendPacket("GroupAttributeGet", { group: n, seq: u, attributes: s });
        }), ab.apply(void 0, [e.genTimeoutError(kc)].concat(W(o.map(function(l) {
          return l.fromReceived("GroupAttributeErr").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }), Da(function(f) {
            throw new Ja(["The channel attributes get failure, code %d", f.code], jc);
          }));
        })), W(o.map(function(l) {
          return l.fromReceived("GroupAttributeRet").pipe(Aa(function(f) {
            return u.eq(f.seq);
          }));
        }))));
      } }, { key: "requestGetUserAttributeKeys", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("UserAttributeKeysGet", { account: n, seq: o });
        }), ab.apply(void 0, [e.genTimeoutError(kc)].concat(W(s.map(function(u) {
          return u.fromReceived("UserAttributeErr").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }), Da(function(l) {
            throw (l = l.code) === 10008 ? new Ja("The user requested is not online", Gr) : new se(["User attribute operation unknown error code: %d", l], jc);
          }));
        })), W(s.map(function(u) {
          return u.fromReceived("UserAttributeKeysRet").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }));
        }))));
      } }, { key: "requestGetChannelAttributesKeys", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("GroupAttributeKeysGet", { group: n, seq: o });
        }), ab.apply(void 0, [e.genTimeoutError(kc)].concat(W(s.map(function(u) {
          return u.fromReceived("GroupAttributeErr").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }), Da(function(l) {
            throw new se(["Channel attribute operation unknown error code: %d", l.code], jc);
          }));
        })), W(s.map(function(u) {
          return u.fromReceived("GroupAttributeKeysRet").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }));
        }))));
      } }, { key: "requestGetChannelMemberCount", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("GroupStatusList", { groups: n, seq: o });
        }), ab.apply(void 0, [e.genTimeoutError(Kr)].concat(W(s.map(function(u) {
          return u.fromReceived("GroupStatusResult").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }));
        }))));
      } }, { key: "requestSubscribePeersOnlineStatus", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        return s.forEach(function(u) {
          u.sendPacket("SubscribeUserStatus", { seq: o, users: n });
        }), ab.apply(void 0, [e.genTimeoutError(NB)].concat(W(s.map(function(u) {
          return u.fromReceived("SubscribeResponse").pipe(Aa(function(l) {
            return o.eq(l.seq);
          }));
        }))));
      } }, { key: "requestUnsubscribePeersOnlineStatus", value: function(n) {
        var s = this.getLoginSockets();
        if (s.length === 0)
          throw new aa("Client is not logged in");
        var o = this.incGetSeq();
        s.forEach(function(u) {
          u.sendPacket("UnsubscribeUserStatus", { seq: o, users: n });
        });
      } }, { key: "sendInvitationMessage", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h, p, m, _, w, S, O, k, B = this;
          return M.wrap(function(L) {
            for (; ; )
              switch (L.prev = L.next) {
                case 0:
                  if (u = o.peerId, l = o.callId, f = o.extra, d = o.isAcceptAck, h = o.channelId, p = o.type, m = { callId: l }, d === void 0) {
                    L.next = 6;
                    break;
                  }
                  if (p === "CallAccept") {
                    L.next = 5;
                    break;
                  }
                  throw Error("invalid invitation type");
                case 5:
                  m.type = d ? "ack" : "request";
                case 6:
                  return m.channel = h, (p === "CallInvite" || p === "CallCancel" || p === "CallReject" || p === "CallAccept" && d === !1) && f !== void 0 && (m.extra = f), _ = hh(), this.log("The sent invitation body is %o", m), w = function(G) {
                    return { MiscMap: {}, sequence: ma.fromNumber(1), dialogue: _, instance: B.instanceId, dst: u, ms: ma.fromNumber(Date.now(), !0), options: new Cf({ IterationNumber: G, MessageType: p }).toLong(), payload: new TextEncoder().encode(JSON.stringify(m)), src: B.context.uid };
                  }, L.next = 14, Dc(this.sendMessageToRetry(w, !0)).pipe(Hb(1e4), Ya(function(G) {
                    return G instanceof Pb && B.warn("Send invitation timeout"), pa(G);
                  })).toPromise();
                case 14:
                  return S = L.sent, O = S.code, k = S.retryTimes, L.abrupt("return", { hasPeerReceived: O === 0, hasReSent: k !== 0 });
                case 18:
                case "end":
                  return L.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "sendRawMessage", value: function() {
        var n = ja(M.mark(function s(o, u, l, f, d) {
          var h, p, m, _, w, S, O, k, B = this;
          return M.wrap(function(L) {
            for (; ; )
              switch (L.prev = L.next) {
                case 0:
                  if (Sa(l) && o instanceof Uint8Array && typeof u == "string") {
                    L.next = 2;
                    break;
                  }
                  throw new Z("The send message arguments are not valid", f ? $r : ni);
                case 2:
                  if (!(32768 < o.byteLength + new Blob([u]).size)) {
                    L.next = 4;
                    break;
                  }
                  throw new dc("The message size is over the 32KB limit", f ? Xf : Cl);
                case 4:
                  return h = !ue.getParameter("DISABLE_MESSAGE_COMPRESSION") && 128 <= o.byteLength, p = this.chatManager.getChatInfo(l), m = p.dialogue, _ = p.sequence, w = this.instanceId, this.log('A%s %s raw message is sending to %s: "'.concat(w, "-").concat(m, "#").concat(_, '"'), h ? " compressed" : "", f ? "peer" : "channel", Ka(l)), S = function(G) {
                    return { MiscMap: { description: new TextEncoder().encode(u) }, sequence: _, dialogue: m, instance: w, dst: l, ms: ma.fromNumber(Date.now(), !0), options: new Cf({ IterationNumber: G, CompressionMethod: h ? "Zlib" : "Uncompressed", MessageType: f ? "PeerRawMessage" : "ChannelRawMessage", ToCache: !1, ToArchive: !1 }).toLong(), payload: h ? Kt(o) : o, src: B.context.uid };
                  }, L.next = 11, Dc(this.sendMessageToRetry(S, !0)).pipe(Hb(d === void 0 ? 1e4 : d), Ya(function(G) {
                    return G instanceof Pb && B.warn("Send message timeout"), pa(G);
                  })).toPromise();
                case 11:
                  return O = L.sent, k = O.code, L.abrupt("return", { hasPeerReceived: k === 0 });
                case 14:
                case "end":
                  return L.stop();
              }
          }, s, this);
        }));
        return function(s, o, u, l, f) {
          return n.apply(this, arguments);
        };
      }() }, { key: "sendTextMessage", value: function() {
        var n = ja(M.mark(function s(o, u, l, f) {
          var d, h, p, m, _, w, S, O, k, B = this;
          return M.wrap(function(L) {
            for (; ; )
              switch (L.prev = L.next) {
                case 0:
                  if (Sa(u)) {
                    L.next = 2;
                    break;
                  }
                  throw new Z("The send message arguments are not valid", l ? $r : ni);
                case 2:
                  if (!(32768 < new Blob([o]).size)) {
                    L.next = 4;
                    break;
                  }
                  throw new dc("The message size is over the 32KB limit", l ? Xf : Cl);
                case 4:
                  return d = !ue.getParameter("DISABLE_MESSAGE_COMPRESSION") && 128 <= new Blob([o]).size, h = this.chatManager.getChatInfo(u), p = h.dialogue, m = h.sequence, _ = this.instanceId, this.log('A%s %s message is sending to %s: "'.concat(_, "-").concat(p, "#").concat(m, '"'), d ? " compressed" : "", l ? "peer" : "channel", Ka(u)), w = new TextEncoder().encode(o), S = function(G) {
                    return { MiscMap: {}, sequence: m, dialogue: p, instance: _, dst: u, ms: ma.fromNumber(Date.now(), !0), options: new Cf({ IterationNumber: G, CompressionMethod: d ? "Zlib" : "Uncompressed", MessageType: l ? "PeerTextMessage" : "ChannelTextMessage", ToCache: !1, ToArchive: !1 }).toLong(), payload: d ? Kt(w) : w, src: B.context.uid };
                  }, L.next = 12, Dc(this.sendMessageToRetry(S, !0)).pipe(Hb(f === void 0 ? 1e4 : f), Ya(function(G) {
                    return G instanceof Pb && B.warn("Send message timeout"), pa(G);
                  })).toPromise();
                case 12:
                  return O = L.sent, k = O.code, L.abrupt("return", { hasPeerReceived: k === 0 });
                case 15:
                case "end":
                  return L.stop();
              }
          }, s, this);
        }));
        return function(s, o, u, l) {
          return n.apply(this, arguments);
        };
      }() }, { key: "cleanLoginSubs", value: function(n, s) {
        Object.entries(this.loginSocketSubs[n]).forEach(function(o) {
          var u = (o = Xa(o, 2))[1];
          o[0] === "channels" && s || (Array.isArray(u) || u instanceof Map ? u.forEach(function(l) {
            return l.unsubscribe();
          }) : u && u.unsubscribe());
        }), this.loginSocketSubs[n] = { channels: s ? this.loginSocketSubs[n].channels : /* @__PURE__ */ new Map(), receivers: [] };
      } }, { key: "sendMessageToRetry", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l, f, d, h, p, m, _, w, S, O = this, k = arguments;
          return M.wrap(function(B) {
            for (; ; )
              switch (B.prev = B.next) {
                case 0:
                  if (l = 2 < k.length && k[2] !== void 0 ? k[2] : 0, this.log("Attempt to send the message ".concat(u ? " with retrying, %o" : "without retrying"), { retryTimes: l }), (f = this.getLoginSockets()).length !== 0) {
                    B.next = 5;
                    break;
                  }
                  throw Error("no logged-in sockets");
                case 5:
                  return d = o(l), f.forEach(function(L) {
                    L.sendPacket("Message", d);
                  }), h = d.dialogue, p = d.sequence, m = d.instance, _ = f.map(function(L) {
                    return L.fromReceived("Ack").pipe(Ob(function(G) {
                      return h.eq(G.dialogue) && p.eq(G.sequence) && m.eq(G.instance);
                    }));
                  }), B.prev = 9, B.next = 12, Ec.apply(void 0, W(_)).pipe(Hb(6e3), Ya(function(L) {
                    return vb(L) && O.warn("Message send timeout, retry times %d", l), pa(L);
                  }), db(1)).toPromise();
                case 12:
                  return w = B.sent, S = w.code, this.log("The message has been acked, %o", { code: S }), B.abrupt("return", { code: S, retryTimes: l });
                case 18:
                  if (B.prev = 18, B.t0 = B.catch(9), !(B.t0 instanceof Pb && u)) {
                    B.next = 22;
                    break;
                  }
                  return B.abrupt("return", this.sendMessageToRetry(o, !1, l + 1));
                case 22:
                  throw B.t0;
                case 23:
                case "end":
                  return B.stop();
              }
          }, s, this, [[9, 18]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "initKeepAliveSender", value: function() {
        var n = this;
        this.lastLoginSockets.map(function(s) {
          return s.pipe(Fc(function(o) {
            return Zc(0, 2500, Ae() ? void 0 : WE).pipe(sa(function() {
              n.sendPing(o);
            }));
          }));
        }).forEach(function(s, o) {
          var u = n.loginSocketSubs[o].keepAlive;
          u !== void 0 && u.unsubscribe(), n.loginSocketSubs[o].keepAlive = s.subscribe({ error: function() {
          } });
        });
      } }, { key: "initKeepAliveReconnector", value: function() {
        var n = this;
        this.lastLoginSockets.map(function(s) {
          return s.pipe(Fc(function(o) {
            var u, l = !1, f = o.userJoin$.pipe(sa(function() {
              l = !0;
            })), d = o.input$.pipe(sa(function(h) {
              rj[h.uri].slice(0, -3) !== "Ping" && (l = !1);
            }));
            return Ec(Zc(6e3, 1e4).pipe(ov(o.receivedPacket), sa(function(h) {
              h = Xa(h, 2), h = Xa(h[1], 2)[1], u !== h || l || o.forceReconnect(), u = h;
            })), f, d);
          }));
        }).forEach(function(s, o) {
          var u = n.loginSocketSubs[o].keepAliveReconnector;
          u !== void 0 && u.unsubscribe(), n.loginSocketSubs[o].keepAliveReconnector = s.subscribe({ error: function() {
          } });
        });
      } }, { key: "initLoginReceiver", value: function() {
        var n = this;
        ab.apply(void 0, W(this.lastLoginSockets.map(function(s) {
          return s.pipe(Fc(function(o) {
            return o.fromReceived("UserTicketNearlyExpire").pipe(iv(5e3), sa(n.onUserTicketNearlyExpire(o)));
          }));
        }))).subscribe(), this.lastLoginSockets.map(function(s) {
          return s.pipe(Fc(function(o) {
            return Ec(Gb(o, "reconnect").pipe(sa(n.onSocketReconnect(o))), o.fromReceived("Message").pipe(sa(n.onMessage(o))), o.fromReceived("GroupEnterNotice").pipe(sa(n.onGroupEnterNotice())), o.fromReceived("GroupLeaveNotice").pipe(sa(n.onGroupLeaveNotice())), o.fromReceived("GroupCountNotice").pipe(sa(n.onGroupCountNotice())), o.fromReceived("GroupAttributeAlt").pipe(sa(n.onGroupAttributeAlt())), o.fromReceived("UserJoinNotice").pipe(sa(n.onUserNotice(qa.PeerOnlineState.ONLINE))), o.fromReceived("UserQuitNotice").pipe(sa(n.onUserNotice(qa.PeerOnlineState.OFFLINE))), o.fromReceived("UserWaitNotice").pipe(sa(n.onUserNotice(qa.PeerOnlineState.UNREACHABLE))), o.fromReceived("Pong").pipe(sa(n.onPong())), o.fromReceived("UserDrop").pipe(sa(n.onUserDrop(o)))).pipe(Sf(void 0));
          }));
        }).forEach(function(s, o) {
          n.loginSocketSubs[o].receivers.push(s.subscribe({ error: function() {
          } }));
        });
      } }, { key: "requestSocketLogin", value: function(n, s, o) {
        var u = this;
        return hn(wd(function() {
          u.userJoinOptions = new Xs(s), n.sendPacket("UserJoin", { account: u.context.uid, instance: u.instanceId, opt: u.userJoinOptions.toLong(), seq: o, ticket: n.ticket });
        }), n.fromReceived("UserResp").pipe(Aa(function(l) {
          return o.eq(l.seq);
        }), sa(function(l) {
          if ((l = l.code) !== 0)
            throw u.clearSockets(), u.logError("Connected to gateway success but the Rtm server rejected login"), new Ja(["Login failure. The response code from the RTM service is %d", l], Ng);
          n.attemptsSinceLastError = 0, n.loggedIn = !0, u.log("ENV_%d logged in", n.env);
        }), Sf(n), Hb(6e3))).pipe(Ob(function(l) {
          return l !== void 0;
        }), Ya(function(l) {
          return l instanceof Pb && u.warn("Login response timeout, rejoin: %s", s), u.clearSockets(), l.name = "loginRespTimeout", u.emit("banEdgeIP", n.ip), pa(l);
        }));
      } }, { key: "getSocketLoginObservables", value: function(n, s) {
        var o = this;
        return n.map(function(u) {
          return u.pipe(Fc(function(l, f) {
            return o.incSeqIfNeeded(l.env), o.requestSocketLogin(l, f !== 0, f === 0 ? s : o.seq);
          }), Pe());
        });
      } }, { key: "incSeqIfNeeded", value: function(n) {
        if (![0, 1].includes(n))
          throw new ib({ INVALID_ENV: "The env argument is not 0 or 1" });
        this.seqSentStatuses[n] && (this.seq = this.seq.add(1), this.seqSentStatuses = [!1, !1]), this.seqSentStatuses[n] = !0;
      } }, { key: "incGetSeq", value: function() {
        return this.seq = this.seq.add(1), this.seqSentStatuses = [!0, !0], this.seq;
      } }, { key: "getLoginSockets", value: function() {
        for (var n = this.curLoginSockets, s = -1, o = n == null ? 0 : n.length, u = 0, l = []; ++s < o; ) {
          var f = n[s];
          f && (l[u++] = f);
        }
        return l;
      } }, { key: "emitMessage", value: function(n, s) {
        var o, u = n.options, l = n.payload, f = n.src, d = n.dst, h = n.instance, p = n.dialogue, m = n.sequence, _ = n.ms, w = n.MiscMap;
        this.dialogueSequenceLru.set(p.toString(), m), h = "".concat(h, "-").concat(p, "#").concat(m), this.msgDedupLru.has(h) ? this.warn("Env_%d: Messages out-of-order or not start with 1: %s", s, h) : (this.msgDedupLru.set(h, void 0), u = new Cf(u), this.lastLoginSockets.forEach((o = ja(M.mark(function S(O) {
          var k;
          return M.wrap(function(B) {
            for (; ; )
              switch (B.prev = B.next) {
                case 0:
                  return B.next = 2, O.pipe(db(1)).toPromise();
                case 2:
                  k = B.sent, e.sendMessageAck(n, k);
                case 4:
                case "end":
                  return B.stop();
              }
          }, S);
        })), function(S) {
          return o.apply(this, arguments);
        })), s = u.isZlibCompressed(), u.isInvitation() ? (d = Yf(s ? gm(Sn(l, Uint8Array.of(0, 0, 0, 0))) : l), d = JSON.parse(d), this.log("The received invitation body is %o", d), this.emit("invitationMessage", { body: d, type: u.getInvitationType(), peerId: f, serverReceivedTs: _.toNumber() })) : u.isTextMessage() ? (w = u.isPeerTextMessage(), l = Yf(s ? gm(Sn(l, Uint8Array.of(0, 0, 0, 0))) : l), this.info("Received a %s %s text message from %s to %s, %s", s ? " compressed" : "", w ? "peer" : "channel", Ka(f), Ka(d), h), w ? (f = { text: l, peerId: f, properties: { serverReceivedTs: _.toNumber() } }, this.emit("peerTextMessage", f)) : this.emit("channelTextMessage", { channelId: d, memberId: f, text: l, properties: { serverReceivedTs: _.toNumber() } })) : u.isRawMessage() && (u = u.isRawPeerMessage(), w = (w = w.description) === void 0 ? "" : Yf(w), l = s ? gm(l) : l, this.info("Received a %s %s raw message from %s to %s, %s", s ? " compressed" : "", u ? "peer" : "channel", Ka(f), Ka(d), h), u ? (f = { desc: w, raw: l, peerId: f, properties: { serverReceivedTs: _.toNumber() } }, this.emit("peerRawMessage", f)) : this.emit("channelRawMessage", { desc: w, raw: l, channelId: d, memberId: f, properties: { serverReceivedTs: _.toNumber() } })));
      } }, { key: "onSocketReconnect", value: function(n) {
        var s = this;
        return function() {
          var o = [0, 1].filter(function(u) {
            return u !== n.env;
          })[0];
          (o = s.connection.curOpenSockets[o]) && !o.loggedIn && s.emit("connectionLost");
        };
      } }, { key: "onUserTicketNearlyExpire", value: function(n) {
        var s = this;
        return function(o) {
          (o = o.ticket) !== s.lastNoticeTicket && o === n.ticket ? (s.lastNoticeTicket = o, s.emit("TokenPrivilegeWillExpire")) : s.requestUpdateEdgeTicket(n.ticket).toPromise();
        };
      } }, { key: "onUserDrop", value: function(n) {
        var s = this;
        return function(o) {
          var u;
          o = o.code, xb("KickedOff", { code: 0, elapse: yb(s.startTime), linkId: parseInt(n.name.split("-")[1], 10), lts: ma.fromNumber(Date.now()), server: n.address, serverCode: o, sid: rb(s.instanceId), userId: s.context.uid }, (u = s.context.config.enableCloudProxy) !== null && u !== void 0 && u), o === 10006 || o === 10001 ? s.warn("Login too often and kicked off, reconnect and login") : o === 10009 ? (s.warn("The instance ID conflicts, reconnecting"), s.instanceId = hh(), s.context.sid = rb(s.instanceId), s.emit("instanceChanged", s.instanceId)) : [2, 11, 14, 15, 16].includes(o) && (s.emit("userDrop", o), s.clearSockets());
        };
      } }, { key: "clearSockets", value: function() {
        var n = this, s = 0 < arguments.length && arguments[0] !== void 0 ? arguments[0] : 0, o = 1 < arguments.length && arguments[1] !== void 0 && arguments[1];
        [0, 1].forEach(function(u) {
          n.cleanLoginSubs(u, o), n.connection.closeSocket(u, s);
        });
      } }, { key: "onMessage", value: function(n) {
        var s = this;
        return function(o) {
          var u = o.dialogue, l = o.instance, f = o.sequence, d = o.options;
          if (o.src === s.context.uid)
            s.log("The message is from the local account, ignored");
          else {
            var h = u.toString(), p = s.dialPendingMsgSubjectMap.get(h);
            if (u = "".concat(l, "-").concat(u, "#").concat(f), p)
              p.next(o), s.log("Env_%d: The dialogue has pending messages, next: %s", n.env, u);
            else {
              var m = s.dialogueSequenceLru.get(h);
              if (p = !m && f.eq(1), l = m !== void 0 && f.sub(m).eq(1), p || l)
                s.emitMessage(o, n.env);
              else {
                if (m) {
                  if (f.lte(m))
                    return;
                  s.log("Env_%d: The message pended, the sequence is not continuous with the last: %s", n.env, u);
                } else
                  s.log("Env_%d: The message pended, the first sequence is not equal to 1: %s", n.env, u);
                f = new nb(), s.dialPendingMsgSubjectMap.set(h, f);
                var _ = f.pipe(su(tl), dh(function(w, S) {
                  return [].concat(W(w), [S]);
                }, []), Da(function(w) {
                  return W(w).sort(function(S, O) {
                    return S = S.sequence, O = O.sequence, S.eq(O) ? 0 : S.gt(O) ? 1 : -1;
                  });
                }), qn(1));
                d = !(d = new Cf(d)).isFromCache() && !d.isBufferedMessage(), _.pipe(Gc(Zc(d ? 750 : 1500)), Aa(function(w) {
                  if (2 > w.length)
                    return !1;
                  for (var S = m === void 0 ? ma.fromNumber(1, !0) : m.add(1), O = 0; O < w.length; S = S.add(1), O++)
                    if (!w[O].sequence.eq(S))
                      return !1;
                  return !0;
                }), ch(function() {
                  s.dialPendingMsgSubjectMap.delete(h);
                })).subscribe(function(w) {
                  w.forEach(function(S) {
                    s.emitMessage(S, n.env), s.log("Env_%d: The message queue has fully ordered, emitting: %s", n.env, "".concat(S.instance, "-").concat(S.dialogue, "#").concat(S.sequence));
                  });
                }, function(w) {
                  w instanceof bh && _.pipe(db(1)).subscribe(function(S) {
                    return S.forEach(function(O) {
                      s.log("Env_%d: The message pending queue expired, emitting: %s", n.env, "".concat(O.instance, "-").concat(O.dialogue, "#").concat(O.sequence)), s.emitMessage(O, n.env);
                    });
                  });
                }), f.next(o);
              }
            }
          }
        };
      } }, { key: "onPong", value: function() {
        var n = this;
        return function() {
          document.hidden && n.getLoginSockets().forEach(function(s) {
            n.sendPing(s);
          });
        };
      } }, { key: "onGroupEnterNotice", value: function() {
        var n = this;
        return function(s) {
          n.emit("memberNotice", { channelId: s.group, seq: s.seq, instance: s.instance, memberId: s.user, type: "MemberJoined", size: s.size });
        };
      } }, { key: "onGroupLeaveNotice", value: function() {
        var n = this;
        return function(s) {
          n.emit("memberNotice", { channelId: s.group, seq: s.seq, instance: s.instance, memberId: s.user, type: "MemberLeft", size: s.size });
        };
      } }, { key: "onGroupCountNotice", value: function() {
        var n = this;
        return function(s) {
          n.emit("memberNotice", { channelId: s.group, seq: s.seq, instance: s.instance, type: "MemberCountUpdated", size: s.size });
        };
      } }, { key: "onGroupAttributeAlt", value: function() {
        var n = this;
        return function(s) {
          var o = s.group;
          s = Ei(s, XE), n.emit("channelAttributesUpdated", jb({ channelId: o }, s));
        };
      } }, { key: "onUserNotice", value: function(n) {
        var s = this;
        return function(o) {
          s.emit("peerOnlineStatusChanged", { peerId: o.user, instance: o.instance, seq: o.seq, state: n });
        };
      } }, { key: "sendPing", value: function(n) {
        2500 >= Date.now() - this.lastPingTime[n.env] || (this.incSeqIfNeeded(n.env), n.sendPacket("Ping", { ms: ma.fromNumber(Date.now(), !0), seq: this.seq }), this.lastPingTime[n.env] = Date.now());
      } }], [{ key: "sendMessageAck", value: function(n, s) {
        var o = new Cf(n.options);
        (o.isInvitation() || o.isPeerMessage()) && s.sendPacket("Ack", { code: 0, dialogue: n.dialogue, instance: n.instance, sequence: n.sequence });
      } }]), e;
    }(Ac());
    x(Lt, "genTimeoutError", function(r, e) {
      return wb(void 0).pipe(Yd(e === void 0 ? 1e4 : e), Da(function() {
        throw new Qb(["Request timed out after %ds", (e === void 0 ? 1e4 : e) / 1e3], r);
      }));
    });
    var Mt, hm, im = 0, jm = 0;
    Lg.v1 = function(r, e, t) {
      t = e && t || 0;
      var a = e || [], n = (r = r || {}).node || Mt, s = r.clockseq !== void 0 ? r.clockseq : hm;
      if (n == null || s == null) {
        var o = Er();
        n == null && (n = Mt = [1 | o[0], o[1], o[2], o[3], o[4], o[5]]), s == null && (s = hm = 16383 & (o[6] << 8 | o[7]));
      }
      o = r.msecs !== void 0 ? r.msecs : new Date().getTime();
      var u = r.nsecs !== void 0 ? r.nsecs : jm + 1, l = o - im + (u - jm) / 1e4;
      if (0 > l && r.clockseq === void 0 && (s = s + 1 & 16383), (0 > l || o > im) && r.nsecs === void 0 && (u = 0), 1e4 <= u)
        throw Error("uuid.v1(): Can't create more than 10M uuids/sec");
      for (im = o, jm = u, hm = s, r = (1e4 * (268435455 & (o += 122192928e5)) + u) % 4294967296, a[t++] = r >>> 24 & 255, a[t++] = r >>> 16 & 255, a[t++] = r >>> 8 & 255, a[t++] = 255 & r, r = o / 4294967296 * 1e4 & 268435455, a[t++] = r >>> 8 & 255, a[t++] = 255 & r, a[t++] = r >>> 24 & 15 | 16, a[t++] = r >>> 16 & 255, a[t++] = s >>> 8 | 128, a[t++] = 255 & s, s = 0; 6 > s; ++s)
        a[t + s] = n[s];
      return e || Fr(a);
    }, Lg.v4 = Lg;
    var km = ui(), Rd, Ff = qa.LocalInvitationFailureReason, Ra = qa.LocalInvitationState, YE = (Rd = function(r) {
      function e(a, n, s) {
        ua(this, e);
        var o = t.call(this, s, "RtmLocalInvitation", !0);
        return x(z(o), "state", Ra.IDLE), x(z(o), "localInvitationEnd$", ab(Gb(z(o), "LocalInvitationAccepted"), Gb(z(o), "LocalInvitationRefused"), Gb(z(o), "LocalInvitationFailure"), Gb(z(o), "LocalInvitationCanceled")).pipe(db(1))), x(z(o), "callId", Lg.v4()), x(z(o), "_content", ""), x(z(o), "_channelId", ""), x(z(o), "_response", ""), x(z(o), "calleeId", void 0), x(z(o), "logger", void 0), x(z(o), "getSession", void 0), o.calleeId = a, o.getSession = n, o.logger = s, o;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "channelId", get: function() {
        return this._channelId;
      }, set: function(a) {
        this.state !== Ra.IDLE ? this.info("set channelId only allow before invitation sent to remote") : (this.log("set channelId for %s", this.callId), this._channelId = a);
      } }, { key: "content", get: function() {
        return this._content;
      }, set: function(a) {
        this.log("set content for %s", this.callId), this._content = a;
      } }, { key: "response", get: function() {
        return this._response;
      }, set: function(a) {
        throw new Z('Cannot set the "response" of the LocalInvitation instance.', Tc);
      } }, { key: "send", value: function() {
        var a, n = this;
        if (this.state === Ra.SENT_TO_REMOTE || this.state === Ra.RECEIVED_BY_REMOTE)
          throw new aa("The local invitation send failure. The call invitation has already been sent.", BB);
        if (this.isLocalInvitationEnd())
          throw new aa("The local invitation send failure. The call invitation has ended.", oi);
        if (0 < this._channelId.length && !Sa(this._channelId))
          throw new Z("Illegal invitation channel ID", Tc);
        if (!Sa(this.calleeId))
          throw new Z("Illegal invitation callee user ID", Tc);
        if (8192 < mh(this._content))
          throw new Z('The length of the "content" overflows. The number of bytes representing content must not exceed 8 \xD7 1024 if encoded in UTF-8.', Tc);
        this.state = Ra.SENT_TO_REMOTE, wd(ja(M.mark(function s() {
          var o, u, l;
          return M.wrap(function(f) {
            for (; ; )
              switch (f.prev = f.next) {
                case 0:
                  return f.next = 2, n.getSession().sendInvitationMessage({ peerId: n.calleeId, callId: n.callId, extra: n._content, type: "CallInvite", channelId: n._channelId });
                case 2:
                  if (o = f.sent, u = o.hasPeerReceived, l = o.hasReSent, !n.isLocalInvitationEnd()) {
                    f.next = 7;
                    break;
                  }
                  throw new Qb("send invitation timeout");
                case 7:
                  if (n.log("The local invitation has sent to the callee"), u || l) {
                    f.next = 11;
                    break;
                  }
                  throw a = new km({ PEER_NOT_ONLINE: "The peer of the invitation is not online" });
                case 11:
                  if (u) {
                    f.next = 14;
                    break;
                  }
                  throw a = new km({ RESENT_AND_OFFLINE: "Resent and the peer of the invitation is not online" });
                case 14:
                case "end":
                  return f.stop();
              }
          }, s);
        }))).pipe(Oe(function(s) {
          return s.pipe(sa(function(o) {
            if (!(o instanceof km))
              throw o;
          }), Yd(2e3));
        }), Hb(3e4), Ya(function(s) {
          return vb(s) && n.warn("local invitation ack timed out"), pa(s);
        }), Gc(this.localInvitationEnd$)).subscribe({ next: function() {
          n.state === Ra.RECEIVED_BY_REMOTE ? n.log('The local invitation state is already "RECEIVED_BY_REMOTE", skipped emitting "LocalInvitationReceivedByPeer"') : n.state !== Ra.SENT_TO_REMOTE ? n.log("The invitation has ended, skipped emitting the %s event", "LocalInvitationReceivedByPeer") : (n.info("The peer received the local invitation %s.", n.callId), n.state = Ra.RECEIVED_BY_REMOTE, n.emit("LocalInvitationReceivedByPeer"), n.localInvitationEnd$.pipe(Hb(6e4), Ya(function(s) {
            return vb(s) && n.warn("local invitation expired"), pa(s);
          })).subscribe({ error: function() {
            n.state = Ra.FAILURE, n.emit("LocalInvitationFailure", Ff.INVITATION_EXPIRE);
          } }));
        }, error: function(s) {
          n.isLocalInvitationEnd() ? n.log("The invitation has ended, skipped emitting the %s event", "LocalInvitationFailure") : (n.state = Ra.FAILURE, vb(s) && a ? a.code === "PEER_NOT_ONLINE" ? n.emit("LocalInvitationFailure", Ff.PEER_OFFLINE) : a.code === "RESENT_AND_OFFLINE" && n.emit("LocalInvitationFailure", Ff.PEER_NO_RESPONSE) : vb(s) ? n.emit("LocalInvitationFailure", Ff.PEER_NO_RESPONSE) : s.name === "RtmInvalidStatusError" ? n.emit("LocalInvitationFailure", Ff.NOT_LOGGEDIN) : n.emit("LocalInvitationFailure", Ff.UNKNOWN));
        } });
      } }, { key: "cancel", value: function() {
        if (this.isLocalInvitationEnd())
          throw new aa("The local invitation cancel failure", oi);
        if (this.state === Ra.IDLE)
          throw new aa("The local invitation has not been sent", AB);
        if (8192 < mh(this._content))
          throw new Z('The length of the "content" overflows. The number of bytes representing content must not exceed 8 \xD7 1024 if encoded in UTF-8.', Tc);
        this.getSession().sendInvitationMessage({ callId: this.callId, peerId: this.calleeId, type: "CallCancel", channelId: this._channelId, extra: this._content }), this.state = Ra.CANCELED, this.emit("LocalInvitationCanceled");
      } }, { key: "onAcceptReceived", value: function(a) {
        if (this.isLocalInvitationEnd() && this.state !== Ra.ACCEPTED_BY_REMOTE)
          this.log("The invitation has ended, skipped emitting the %s event", "LocalInvitationAccepted");
        else {
          if (this.state === Ra.IDLE)
            throw new aa("the local have not sent the invitation, how can remote accept it?");
          this.getSession().sendInvitationMessage({ callId: this.callId, isAcceptAck: !0, type: "CallAccept", peerId: this.calleeId, channelId: this.channelId }), this.state === Ra.ACCEPTED_BY_REMOTE ? this.log("already in ACCEPTED_BY_REMOTE state, ignore emit ACCEPTED_BY_REMOTE") : (this.state === Ra.SENT_TO_REMOTE && (this.log("receive LocalInvitationAccepted before remote response to the invitation"), this.state = Ra.RECEIVED_BY_REMOTE, this.emit("LocalInvitationReceivedByPeer")), this.state = Ra.ACCEPTED_BY_REMOTE, this._response = a, this.emit("LocalInvitationAccepted", a));
        }
      } }, { key: "onRefuseReceived", value: function(a) {
        if (this.isLocalInvitationEnd())
          this.log("The invitation has ended, skipped emitting the %s event", "LocalInvitationRefused");
        else {
          if (this.state === Ra.IDLE)
            throw new aa("the local have not sent the invitation, how can remote refuse it?");
          this.state === Ra.SENT_TO_REMOTE && (this.log("receive LocalInvitationRefused before remote response to the invitation"), this.state = Ra.RECEIVED_BY_REMOTE, this.emit("LocalInvitationReceivedByPeer")), this._response = a, this.state = Ra.REFUSED_BY_REMOTE, this.emit("LocalInvitationRefused", a);
        }
      } }, { key: "isLocalInvitationEnd", value: function() {
        return [Ra.CANCELED, Ra.FAILURE, Ra.ACCEPTED_BY_REMOTE, Ra.REFUSED_BY_REMOTE].includes(this.state);
      } }]), e;
    }(Ac()), Ca(Rd.prototype, "send", [Ic], Object.getOwnPropertyDescriptor(Rd.prototype, "send"), Rd.prototype), Ca(Rd.prototype, "cancel", [Ic], Object.getOwnPropertyDescriptor(Rd.prototype, "cancel"), Rd.prototype), Rd), Ci = qa.RemoteInvitationFailureReason, Cb = qa.RemoteInvitationState, ZE = function(r) {
      function e(a) {
        var n = a.invitationChannel, s = a.extraContent, o = a.callId, u = a.callerId, l = a.logger;
        a = a.getSession, ua(this, e);
        var f = t.call(this, l, "RtmRemoteInvitation", !0);
        return x(z(f), "state", Cb.INVITATION_RECEIVED), x(z(f), "remoteInvitationEnd$", ab(Gb(z(f), "RemoteInvitationCanceled"), Gb(z(f), "RemoteInvitationRefused"), Gb(z(f), "RemoteInvitationAccepted"), Gb(z(f), "RemoteInvitationFailure")).pipe(db(1))), x(z(f), "callerId", void 0), x(z(f), "callId", void 0), x(z(f), "_getSession", void 0), x(z(f), "logger", void 0), x(z(f), "_content", void 0), x(z(f), "_channelId", void 0), x(z(f), "_response", ""), f._channelId = n, f._content = s, f.callId = o, f.callerId = u, f._getSession = a, f.logger = l, f.remoteInvitationEnd$.pipe(Hb(6e4), Ya(function(d) {
          return vb(d) && f.warn("Remote invitation expired"), pa(d);
        })).subscribe({ error: function() {
          f.state = Cb.FAILURE, f.emit("RemoteInvitationFailure", Ci.INVITATION_EXPIRE);
        } }), f;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "channelId", get: function() {
        return this._channelId;
      }, set: function(a) {
        throw new Z('Cannot set the "response" of the RemoteInvitation instance.', Tc);
      } }, { key: "content", get: function() {
        return this._content;
      }, set: function(a) {
        throw new Z('Cannot set the "content" of the RemoteInvitation instance.', Tc);
      } }, { key: "response", get: function() {
        return this._response;
      }, set: function(a) {
        this._response = a;
      } }, { key: "accept", value: function() {
        var a, n = this;
        if (this.isRemoteInvitationEnd())
          throw new aa("The local invitation has ended. Cannot accept.", oi);
        if (this.state === Cb.ACCEPT_SENT_TO_LOCAL)
          throw new aa("The remote invitation is accepting. Cannot do the operation.", Lr);
        if (8192 < mh(this._response))
          throw new Z('The length of the "response" overflows. The number of bytes representing content must not exceed 8 \xD7 1024 if encoded in UTF-8.', Tc);
        this.state = Cb.ACCEPT_SENT_TO_LOCAL, Ec(ln(1e3).pipe(Ab(function() {
          return wd(ja(M.mark(function s() {
            return M.wrap(function(o) {
              for (; ; )
                switch (o.prev = o.next) {
                  case 0:
                    return o.abrupt("return", n._getSession().sendInvitationMessage({ peerId: n.callerId, callId: n.callId, extra: n.response, type: "CallAccept", isAcceptAck: !1, channelId: n.channelId }));
                  case 1:
                  case "end":
                    return o.stop();
                }
            }, s);
          })));
        }), Ob(function(s) {
          return a = s.hasPeerReceived;
        }), db(1)), Gb(this, "RemoteInvitationAccepted")).pipe(Hb(5e3), Gc(this.remoteInvitationEnd$)).subscribe({ error: function(s) {
          if (n.logError(s), n.state = Cb.FAILURE, vb(s))
            switch (a) {
              case void 0:
              case !0:
                return void n.emit("RemoteInvitationFailure", Ci.ACCEPT_FAILURE);
              case !1:
                return void n.emit("RemoteInvitationFailure", Ci.PEER_OFFLINE);
            }
          n.emit("RemoteInvitationFailure", Ci.UNKNOWN);
        } });
      } }, { key: "refuse", value: function() {
        if (this.state === Cb.ACCEPT_SENT_TO_LOCAL)
          throw new aa("The remote invitation is accepting. Cannot do the operation.", Lr);
        if (this.isRemoteInvitationEnd())
          throw new aa("The invitation is end. Cannot refuse", oi);
        if (8192 < mh(this._response))
          throw new Z('The length of the "response" overflows. The number of bytes representing content must not exceed 8 \xD7 1024 if encoded in UTF-8.', Tc);
        this._getSession().sendInvitationMessage({ peerId: this.callerId, callId: this.callId, extra: this.response, type: "CallReject", channelId: this.channelId }), this.state = Cb.REFUSED, this.emit("RemoteInvitationRefused");
      } }, { key: "onCancelReceived", value: function(a) {
        this.isRemoteInvitationEnd() ? this.log("The invitation has ended, skipped emitting the %s event", "RemoteInvitationCanceled") : (this.state === Cb.ACCEPT_SENT_TO_LOCAL && this.log("caller canceled before receive accept"), this._content = a, this.state = Cb.CANCELED, this.emit("RemoteInvitationCanceled", a));
      } }, { key: "onAcceptAckReceived", value: function() {
        this.state !== Cb.ACCEPT_SENT_TO_LOCAL ? this.log("The invitation has ended, skipped emitting the %s event", "ori:".concat(this.state, ", to: RemoteInvitationAccepted")) : (this.state = Cb.ACCEPTED, this.emit("RemoteInvitationAccepted"));
      } }, { key: "isRemoteInvitationEnd", value: function() {
        return [Cb.ACCEPTED, Cb.REFUSED, Cb.CANCELED, Cb.FAILURE].includes(this.state);
      } }]), e;
    }(Ac()), $E = function(r) {
      function e(a, n) {
        ua(this, e);
        var s = t.call(this, n, "InvitationManager");
        return x(z(s), "getSession", void 0), x(z(s), "invitationDispatcher", new ya.EventEmitter()), x(z(s), "outgoingLocalInvitations", /* @__PURE__ */ new Map()), x(z(s), "receivedRemoteInvitations", new Sc(void 0, { maxlen: 1e4 })), x(z(s), "logger", void 0), s.getSession = Zn(a), s.logger = n, s.invitationDispatcher.on("remoteInvitationToManager", function(o) {
          var u = o.callId, l = o.extra, f = o.callerId;
          o = o.channelId, s.receivedRemoteInvitations.has(u) || ((l = new ZE({ callerId: f, callId: u, getSession: s.getSession, logger: n, extraContent: l, invitationChannel: o })).remoteInvitationEnd$.subscribe(function() {
            s.receivedRemoteInvitations.delete(u);
          }), s.receivedRemoteInvitations.set(u, l), s.emit("remoteInvitationInstance", l));
        }), s.invitationDispatcher.on("acceptAckToRemoteInvitation", function(o) {
          (o = s.receivedRemoteInvitations.get(o.callId)) && o.onAcceptAckReceived();
        }), s.invitationDispatcher.on("cancelToRemoteInvitation", function(o) {
          var u = o.extra;
          (o = s.receivedRemoteInvitations.get(o.callId)) && o.onCancelReceived(u);
        }), s.invitationDispatcher.on("acceptToLocalInvitation", function(o) {
          var u = o.extra;
          (o = s.outgoingLocalInvitations.get(o.callId)) && o.onAcceptReceived(u);
        }), s.invitationDispatcher.on("refuseToLocalInvitation", function(o) {
          var u = o.extra;
          (o = s.outgoingLocalInvitations.get(o.callId)) && o.onRefuseReceived(u);
        }), s;
      }
      Ga(e, r);
      var t = Ha(e);
      return cb(e, [{ key: "invitationMessageHandler", value: function(a) {
        var n = a.body, s = n.callId, o = n.extra;
        o = o === void 0 ? "" : o;
        var u = n.type, l = (n = n.channel) === void 0 ? "" : n, f = a.type;
        switch (n = a.peerId, a = a.serverReceivedTs, f) {
          case "CallAccept":
            u === "ack" ? this.invitationDispatcher.emit("acceptAckToRemoteInvitation", { callId: s }) : u === "request" && this.invitationDispatcher.emit("acceptToLocalInvitation", { callId: s, extra: o });
            break;
          case "CallInvite":
            this.invitationDispatcher.emit("remoteInvitationToManager", { callId: s, callerId: n, extra: o, channelId: l });
            break;
          case "CallCancel":
            if (s === "0") {
              s = "".concat("AgoraRTMLegacyEndcallCompatibleMessagePrefix", "_").concat(l, "_").concat(o), this.getSession().emit("peerTextMessage", { peerId: n, properties: { serverReceivedTs: a }, text: s });
              break;
            }
            this.invitationDispatcher.emit("cancelToRemoteInvitation", { callId: s, extra: o });
            break;
          case "CallReject":
            this.invitationDispatcher.emit("refuseToLocalInvitation", { callId: s, extra: o });
            break;
          default:
            throw In("invitationType", f);
        }
      } }, { key: "genLocalInvitation", value: function(a) {
        var n = this, s = new YE(a, this.getSession, this.logger);
        return s.localInvitationEnd$.subscribe(function() {
          n.outgoingLocalInvitations.delete(s.callId);
        }), this.outgoingLocalInvitations.set(s.callId, s), s;
      } }]), e;
    }(Ac()), aF = function(r, e, t) {
      var a = !0, n = !0;
      if (typeof r != "function")
        throw new TypeError("Expected a function");
      return Db(t) && (a = "leading" in t ? !!t.leading : a, n = "trailing" in t ? !!t.trailing : n), vD(r, e, { leading: a, maxWait: e, trailing: n });
    }, Lb, Gf;
    (function(r) {
      r[r.JOINED = 0] = "JOINED", r[r.LEFT = 1] = "LEFT";
    })(Gf || (Gf = {}));
    var lm = qa.ConnectionState, bF = (Lb = function(r) {
      function e(n, s, o, u) {
        ua(this, e);
        var l = a.call(this, u, "RtmChannel", !0);
        return x(z(l), "onMemberCountUpdated", aF(function(f) {
          f !== l.memberCount && (l.memberCount = f, l.emit("MemberCountUpdated", f));
        }, 1e3)), x(z(l), "getSession", void 0), x(z(l), "memberCount", 0), x(z(l), "joinState", "LEFT"), x(z(l), "joinPromise", void 0), x(z(l), "memberJoinedLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "memberLeftLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "memberJoinStateLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "attributesSeqLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "channelId", void 0), x(z(l), "client", void 0), x(z(l), "onChannelMemberCountUpdated", function(f, d) {
          l.channelId === f && l.onMemberCountUpdated(d);
        }), x(z(l), "onLogout", function() {
          try {
            l.clearChannel(l.getSession());
          } catch {
          }
        }), x(z(l), "onAttributesUpdated", function(f) {
          var d = f.channelId, h = f.attributeMaps, p = f.seq;
          f = f.instance.toString();
          var m = l.attributesSeqLru.get(f);
          if ((!m || p.greaterThan(m)) && (l.attributesSeqLru.set(f, p), d === l.channelId)) {
            for (d = {}, p = 0; p < h.length; p++) {
              var _ = h[p];
              f = _.key, m = _.ms;
              var w = _.value;
              if (_ = _.origin, typeof f != "string" || !ma.isLong(m) || typeof w != "string" || !Sa(_))
                break;
              d[f] = { value: w, lastUpdateUserId: _, lastUpdateTs: m.toNumber() };
            }
            l.emit("AttributesUpdated", d);
          }
        }), x(z(l), "onChannelTextMessage", function(f) {
          var d = f.memberId, h = f.text, p = f.properties;
          f.channelId === l.channelId && l.emit("ChannelMessage", { text: h, messageType: qa.MessageType.TEXT }, d, p);
        }), x(z(l), "onChannelRawMessage", function(f) {
          var d = f.desc, h = f.raw, p = f.memberId, m = f.properties;
          f.channelId === l.channelId && l.emit("ChannelMessage", { messageType: qa.MessageType.RAW, rawMessage: h, description: d }, p, m);
        }), x(z(l), "onMemberNotice", function(f) {
          var d = f.memberId, h = f.type, p = f.size;
          if (f.channelId === l.channelId) {
            var m = f.instance.toString();
            f = f.seq.toString();
            var _ = { MemberLeft: l.memberLeftLru, MemberJoined: l.memberJoinedLru, MemberCountUpdated: void 0 }[h];
            if (_) {
              if (_.has(m + f))
                return void l.log("received duplicated %s notice (seq: %s), channel '%s', member '%s'", h, f, Ka(l.channelId), Ka(d || ""));
              if (_.set(m + f, void 0), typeof d != "string")
                return;
              if (d !== l.getSession().context.uid && ((m = l.memberJoinStateLru.get(d)) === Gf.JOINED && h === "MemberJoined" || m === Gf.LEFT && h === "MemberLeft"))
                return void l.log("received duplicated %s state (seq: %s), channel '%s', member '%s'", h, f, Ka(l.channelId), Ka(d || ""));
              l.memberJoinStateLru.set(d, h === "MemberJoined" ? Gf.JOINED : Gf.LEFT);
            }
            l.info("Channel %s - %s, memberId: %s", h, Ka(l.channelId), h === "MemberCountUpdated" ? "[unknown]" : Ka(d || "")), m = d === l.getSession().context.uid, h === "MemberLeft" && Sa(d) || h === "MemberJoined" && Sa(d) ? (m || l.emit(h, d), l.onMemberCountUpdated(p)) : h === "MemberCountUpdated" && typeof p == "number" && l.onMemberCountUpdated(p);
          }
        }), l.getSession = Zn(s), l.channelId = n, l.client = o, l.info("A channel created, id %s", Ka(n)), l;
      }
      Ga(e, r);
      var t, a = Ha(e);
      return cb(e, [{ key: "join", value: (t = ja(M.mark(function n() {
        var s, o, u, l, f, d, h, p = this;
        return M.wrap(function(m) {
          for (; ; )
            switch (m.prev = m.next) {
              case 0:
                m.prev = 0, s = this.getSession(), m.next = 7;
                break;
              case 4:
                throw m.prev = 4, m.t0 = m.catch(0), new aa("The client is not logged in. Cannot do the operation", Qr);
              case 7:
                if (m.prev = 7, Sa(this.channelId)) {
                  m.next = 10;
                  break;
                }
                throw new Z(["The %s in the arguments is invalid", "channelId"], CB);
              case 10:
                if (this.joinState === "LEFT") {
                  m.next = 13;
                  break;
                }
                throw xb("ChnJoin", { cname: this.channelId, lts: ma.fromNumber(Date.now()), userId: s.context.uid, elapse: yb(s.startTime), errCode: Pr, sid: rb(s.instanceId) }, (l = this.client.context.config.enableCloudProxy) !== null && l !== void 0 && l), new aa("The channel has joined. Cannot rejoin", Pr);
              case 13:
                if (!s.usedChannelIds.includes(this.channelId)) {
                  m.next = 16;
                  break;
                }
                throw xb("ChnJoin", { cname: this.channelId, lts: ma.fromNumber(Date.now()), userId: s.context.uid, elapse: yb(s.startTime), errCode: Rr, sid: rb(s.instanceId) }, (f = this.client.context.config.enableCloudProxy) !== null && f !== void 0 && f), new aa("A channel of the same channel ID has already joined. Cannot rejoin", Rr);
              case 16:
                if (!(20 <= s.usedChannelIds.length)) {
                  m.next = 19;
                  break;
                }
                throw xb("ChnJoin", { cname: this.channelId, lts: ma.fromNumber(Date.now()), userId: s.context.uid, elapse: yb(s.startTime), errCode: Or, sid: rb(s.instanceId) }, (d = this.client.context.config.enableCloudProxy) !== null && d !== void 0 && d), new dc("The joined channels has exceeded the limit of 20", Or);
              case 19:
                return xb("ChnJoin", { cname: this.channelId, lts: ma.fromNumber(Date.now()), userId: s.context.uid, elapse: yb(s.startTime), errCode: 0, sid: rb(s.instanceId) }, (o = this.client.context.config.enableCloudProxy) !== null && o !== void 0 && o), this.log("Joining the channel %s", Ka(this.channelId)), this.joinState = "JOINING", s.usedChannelIds.push(this.channelId), this.joinPromise = s.requestChannelJoin(this.channelId).then(function() {
                  p.joinState = "JOINED";
                }), m.next = 26, this.joinPromise;
              case 26:
                xb("ChnJoinRes", { cname: this.channelId, lts: ma.fromNumber(Date.now()), elapse: yb(s.startTime), errCode: 0, sid: rb(s.instanceId), serverErrCode: 0, userId: s.context.uid }, (u = this.client.context.config.enableCloudProxy) !== null && u !== void 0 && u), this.info("The channel %s joined successfully", Ka(this.channelId)), s.on("channelTextMessage", this.onChannelTextMessage), s.on("channelRawMessage", this.onChannelRawMessage), s.on("memberNotice", this.onMemberNotice), s.on("channelAttributesUpdated", this.onAttributesUpdated), this.client.internalEmitter.on("channelMemberCountUpdated", this.onChannelMemberCountUpdated), this.client.internalEmitter.once("LOGOUT", this.onLogout), m.next = 46;
                break;
              case 36:
                if (m.prev = 36, m.t1 = m.catch(7), this.joinState === "JOINING" && (this.joinState = "LEFT"), this.logError(m.t1), !Ma(m.t1)) {
                  m.next = 42;
                  break;
                }
                throw m.t1;
              case 42:
                if (!vb(m.t1)) {
                  m.next = 45;
                  break;
                }
                throw xb("ChnJoinRes", { cname: this.channelId, lts: ma.fromNumber(Date.now()), elapse: yb(s.startTime), errCode: Nr, sid: rb(s.instanceId), serverErrCode: 0, userId: s.context.uid }, (h = this.client.context.config.enableCloudProxy) !== null && h !== void 0 && h), new Qb(["Join channel %s timed out", Ka(this.channelId)], Nr);
              case 45:
                throw new se(["The channel %s join failure", Ka(this.channelId)], { code: Mr, originalError: m.t1 });
              case 46:
              case "end":
                return m.stop();
            }
        }, n, this, [[0, 4], [7, 36]]);
      })), function() {
        return t.apply(this, arguments);
      }) }, { key: "leave", value: function() {
        var n = ja(M.mark(function s() {
          var o, u, l, f;
          return M.wrap(function(d) {
            for (; ; )
              switch (d.prev = d.next) {
                case 0:
                  d.prev = 0, u = this.getSession(), d.next = 7;
                  break;
                case 4:
                  throw d.prev = 4, d.t0 = d.catch(0), new aa("The client is not logged in. Cannot do the operation", EB);
                case 7:
                  if (this.joinState !== "LEFT") {
                    d.next = 9;
                    break;
                  }
                  throw new aa("The channel does not join. Cannot do the operation", DB);
                case 9:
                  return d.prev = 9, u.requestChannelLeave(this.channelId), d.next = 13, this.clearChannel(u);
                case 13:
                  d.next = 24;
                  break;
                case 15:
                  if (d.prev = 15, d.t1 = d.catch(9), this.logError(d.t1), !Ma(d.t1)) {
                    d.next = 22;
                    break;
                  }
                  throw d.t1.code === void 0 && (d.t1.code = Tr), xb("ChnLeave", { cname: this.channelId, lts: ma.fromNumber(Date.now()), elapse: yb(u.startTime), errCode: Tr, sid: rb(u.instanceId), userId: u.context.uid }, (f = this.client.context.config.enableCloudProxy) !== null && f !== void 0 && f), d.t1;
                case 22:
                  throw xb("ChnLeave", { cname: this.channelId, lts: ma.fromNumber(Date.now()), elapse: yb(u.startTime), errCode: Sr, sid: rb(u.instanceId), userId: u.context.uid }, (l = this.client.context.config.enableCloudProxy) !== null && l !== void 0 && l), new se("The channel leave failure", { code: Sr, originalError: d.t1 });
                case 24:
                  xb("ChnLeave", { cname: this.channelId, lts: ma.fromNumber(Date.now()), elapse: yb(u.startTime), errCode: 0, sid: rb(u.instanceId), userId: u.context.uid }, (o = this.client.context.config.enableCloudProxy) !== null && o !== void 0 && o);
                case 25:
                case "end":
                  return d.stop();
              }
          }, s, this, [[0, 4], [9, 15]]);
        }));
        return function() {
          return n.apply(this, arguments);
        };
      }() }, { key: "sendMessage", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l = this;
          return M.wrap(function(f) {
            for (; ; )
              switch (f.prev = f.next) {
                case 0:
                  if (On(o, Cl), this.joinState === "JOINED") {
                    f.next = 3;
                    break;
                  }
                  throw new aa("The channel does not join. Cannot do the operation", sB);
                case 3:
                  if (this.client.connectionState !== lm.RECONNECTING) {
                    f.next = 8;
                    break;
                  }
                  return u = Date.now(), f.next = 7, new Promise(function(d, h) {
                    var p, m = (p = ja(M.mark(function w() {
                      var S;
                      return M.wrap(function(O) {
                        for (; ; )
                          switch (O.prev = O.next) {
                            case 0:
                              return S = Date.now() - u, O.prev = 1, O.next = 4, kh({ message: o, peerId: l.channelId, toPeer: !1, session: l.getSession(), errorCodes: { NOT_LOGGED_IN: Dl, TOO_OFTEN: Hr }, diff: S, logger: l.logger });
                            case 4:
                              d(), O.next = 12;
                              break;
                            case 7:
                              O.prev = 7, O.t0 = O.catch(1), vb(O.t0) && h(new Qb(te(l.name, "sendMessageToPeer", 1e4), Bl)), Ma(O.t0) && h(O.t0), h(new Ja("Channel message send failure", { code: ni, originalError: O.t0 }));
                            case 12:
                              return O.prev = 12, clearTimeout(_), O.finish(12);
                            case 15:
                            case "end":
                              return O.stop();
                          }
                      }, w, null, [[1, 7, 12, 15]]);
                    })), function() {
                      return p.apply(this, arguments);
                    });
                    l.client.internalEmitter.once("RECONNECTED", m);
                    var _ = setTimeout(function() {
                      l.client.internalEmitter.off("RECONNECTED", m), h(new Qb(te(l.name, "sendMessageToPeer", 1e4), Bl));
                    }, 9e3);
                  });
                case 7:
                  return f.abrupt("return");
                case 8:
                  if (this.client.connectionState === lm.CONNECTED) {
                    f.next = 10;
                    break;
                  }
                  throw new aa("The client is not logged in. Cannot do the operation", Dl);
                case 10:
                  return f.prev = 10, f.next = 13, kh({ message: o, peerId: this.channelId, toPeer: !1, session: this.getSession(), errorCodes: { NOT_LOGGED_IN: Dl, TOO_OFTEN: Hr }, diff: 0, logger: this.logger });
                case 13:
                  f.next = 23;
                  break;
                case 15:
                  if (f.prev = 15, f.t0 = f.catch(10), !vb(f.t0)) {
                    f.next = 19;
                    break;
                  }
                  throw new Qb(te(this.name, "sendMessage", 1e4), Bl);
                case 19:
                  if (!Ma(f.t0)) {
                    f.next = 22;
                    break;
                  }
                  throw this.logError(f.t0), f.t0;
                case 22:
                  throw new se("The channel message send failure", ni);
                case 23:
                case "end":
                  return f.stop();
              }
          }, s, this, [[10, 15]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "getMembers", value: function() {
        var n = ja(M.mark(function s() {
          var o, u;
          return M.wrap(function(l) {
            for (; ; )
              switch (l.prev = l.next) {
                case 0:
                  if (l.prev = 0, this.client.connectionState === lm.CONNECTED) {
                    l.next = 3;
                    break;
                  }
                  throw new aa("The client is not logged in. Cannot do the operation", zB);
                case 3:
                  if (this.joinState === "JOINED") {
                    l.next = 5;
                    break;
                  }
                  throw new aa("The channel does not join. Cannot do the operation", yB);
                case 5:
                  return o = this.getSession().requestChannelMemberList(this.channelId), l.next = 8, o.pipe(Da(function(f) {
                    return f.memberInfos.map(function(d) {
                      return d.account;
                    });
                  })).toPromise();
                case 8:
                  return u = l.sent, this.info("Channel %s - get members success, %o", Ka(this.channelId), u.map(Ka)), l.abrupt("return", u);
                case 13:
                  if (l.prev = 13, l.t0 = l.catch(0), !Ma(l.t0)) {
                    l.next = 18;
                    break;
                  }
                  throw this.logError(l.t0), l.t0;
                case 18:
                  throw new se("The channel members get failure", wB);
                case 19:
                case "end":
                  return l.stop();
              }
          }, s, this, [[0, 13]]);
        }));
        return function() {
          return n.apply(this, arguments);
        };
      }() }, { key: "clearChannel", value: function() {
        var n = ja(M.mark(function s(o) {
          var u = this;
          return M.wrap(function(l) {
            for (; ; )
              switch (l.prev = l.next) {
                case 0:
                  if (o.emit("channelLeft", this.channelId), this.joinState !== "JOINING") {
                    l.next = 4;
                    break;
                  }
                  return l.next = 4, this.joinPromise;
                case 4:
                  this.joinState = "LEFT", this.memberLeftLru.empty(), this.memberJoinedLru.empty(), this.attributesSeqLru.empty(), this.memberJoinStateLru.empty(), this.memberCount = 0, o.removeListener("channelTextMessage", this.onChannelTextMessage), o.removeListener("channelRawMessage", this.onChannelRawMessage), o.removeListener("memberNotice", this.onMemberNotice), o.removeListener("channelAttributesUpdated", this.onAttributesUpdated), this.client.internalEmitter.removeListener("channelMemberCountUpdated", this.onChannelMemberCountUpdated), this.client.internalEmitter.removeListener("LOGOUT", this.onLogout), o.usedChannelIds = o.usedChannelIds.filter(function(f) {
                    return f !== u.channelId;
                  });
                case 17:
                case "end":
                  return l.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }]), e;
    }(Ac()), Ca(Lb.prototype, "join", [Ic], Object.getOwnPropertyDescriptor(Lb.prototype, "join"), Lb.prototype), Ca(Lb.prototype, "leave", [Ic], Object.getOwnPropertyDescriptor(Lb.prototype, "leave"), Lb.prototype), Ca(Lb.prototype, "sendMessage", [Ic], Object.getOwnPropertyDescriptor(Lb.prototype, "sendMessage"), Lb.prototype), Ca(Lb.prototype, "getMembers", [fb], Object.getOwnPropertyDescriptor(Lb.prototype, "getMembers"), Lb.prototype), Lb), U, Mb = qa.ConnectionChangeReason, la = qa.ConnectionState, Nt = { DISCONNECTED: 1, CONNECTING: 2, CONNECTED: 3, RECONNECTING: 4, ABORTED: 5 }, cF = { LOGIN: 1, LOGIN_SUCCESS: 2, LOGIN_FAILURE: 3, LOGIN_TIMEOUT: 4, INTERRUPTED: 5, LOGOUT: 6, BANNED_BY_SERVER: 7, REMOTE_LOGIN: 8, TOKEN_EXPIRED: 9 }, dF = (U = function(r) {
      function e(n, s, o, u) {
        ua(this, e);
        var l = a.call(this, s, "RtmClient", !0);
        return x(z(l), "connectionState", la.DISCONNECTED), x(z(l), "internalEmitter", new ya()), x(z(l), "context", void 0), x(z(l), "attributes", {}), x(z(l), "loginPromise", void 0), x(z(l), "attributeDrafts", /* @__PURE__ */ new Set()), x(z(l), "session", void 0), x(z(l), "lastLoginTime", void 0), x(z(l), "reconnId", 0), x(z(l), "channelAttributesCacheLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "invitationManager", void 0), x(z(l), "subscribedPeerStatusCache", {}), x(z(l), "pendingPeerStatusSubCount", 0), x(z(l), "peerStatusSeqLru", new Sc(void 0, { maxlen: 1e4 })), x(z(l), "peerUnreachableTimers", {}), x(z(l), "setParameters", void 0), x(z(l), "updateConfig", void 0), x(z(l), "blacklistedIP", {}), x(z(l), "TokenPrivilegeWillExpireHandler", function() {
          l.emit("TokenPrivilegeWillExpire");
        }), x(z(l), "userDropHandler", function(f) {
          if (l.connectionState !== la.ABORTED)
            switch (f) {
              case 2:
                l.logError("Server banned because of token is expired"), l.onConnectionStateChanged(la.ABORTED, Mb.TOKEN_EXPIRED), l.emit("TokenExpired");
                break;
              case 11:
                l.logError("Kicked off by remote session"), l.onConnectionStateChanged(la.ABORTED, Mb.REMOTE_LOGIN);
                break;
              case 14:
              case 15:
              case 16:
                l.logError("Server banned because of illegal ".concat({ 14: "User ID", 15: "IP", 16: "Channel Name" }[f])), l.onConnectionStateChanged(la.ABORTED, Mb.BANNED_BY_SERVER);
                break;
              default:
                l.logError("User kicked off for unknown code: ".concat(f)), l.onConnectionStateChanged(la.ABORTED, Mb.INTERRUPTED);
            }
        }), l.context = new eE(n, o, s), l.context.config = o, l.internalEmitter.setMaxListeners(512), l.setParameters = u.bind(z(l)), l.updateConfig = u.bind(z(l)), l.invitationManager = new $E(function() {
          return l.session;
        }, s), l.invitationManager.on("remoteInvitationInstance", function(f) {
          l.emit("RemoteInvitationReceived", f);
        }), l.setMaxListeners(512), l.internalEmitter.setMaxListeners(512), l;
      }
      Ga(e, r);
      var t, a = Ha(e);
      return cb(e, [{ key: "renewToken", value: (t = ja(M.mark(function n(s) {
        var o, u, l, f, d = this;
        return M.wrap(function(h) {
          for (; ; )
            switch (h.prev = h.next) {
              case 0:
                if (typeof s == "string" && s.length !== 0) {
                  h.next = 2;
                  break;
                }
                throw new Z("Invalid argument", KB);
              case 2:
                if (this.connectionState !== la.ABORTED) {
                  h.next = 5;
                  break;
                }
                return h.next = 5, new Promise(function() {
                });
              case 5:
                if (this.connectionState === la.CONNECTED || this.connectionState === la.RECONNECTING) {
                  h.next = 7;
                  break;
                }
                throw new aa("The client is not logged in", bs);
              case 7:
                if (this.session !== void 0) {
                  h.next = 9;
                  break;
                }
                throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
              case 9:
                return h.prev = 9, o = this.context.token, this.context.token = s, h.next = 14, this.session.connection.apClient.getApEdgeInfo$(!1).pipe(Zd(function() {
                  return Error("No available edge address to connect");
                }), Oe(function(p) {
                  return p.pipe(sa(function(m) {
                    if (Ma(m))
                      throw m;
                  }), Yd(2500), db(4));
                }), db(1), Hb(2e4), Ya(function(p) {
                  return vb(p) && d.warn("renewToken timed out"), pa(p);
                })).toPromise();
              case 14:
                u = h.sent, l = u.ticket, h.next = 27;
                break;
              case 18:
                if (h.prev = 18, h.t0 = h.catch(9), this.context.token = o, h.t0.code !== Vr && h.t0.code !== Wr) {
                  h.next = 23;
                  break;
                }
                throw new yf("Invalid token", MB);
              case 23:
                if (h.t0.code !== qi) {
                  h.next = 25;
                  break;
                }
                throw new yf("The token expired", LB);
              case 25:
                if (!vb(h.t0)) {
                  h.next = 27;
                  break;
                }
                throw new Qb("Renew token timed out", Gl);
              case 27:
                f = this.session, this.session.requestUpdateEdgeTicket(l).toPromise().then(function(p) {
                  if (p.code !== 0)
                    throw new Ja(["RenewToken failure. The response code is %d", p.code], Gl);
                  f.curLoginSockets.filter(function(m) {
                    return m !== void 0;
                  }).forEach(function(m) {
                    return m.ticket = l;
                  });
                });
              case 29:
              case "end":
                return h.stop();
            }
        }, n, this, [[9, 18]]);
      })), function(n) {
        return t.apply(this, arguments);
      }) }, { key: "queryPeersOnlineStatus", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f = this;
          return M.wrap(function(d) {
            for (; ; )
              switch (d.prev = d.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    d.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", JB);
                case 2:
                  if (this.session !== void 0) {
                    d.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  if (!(!Array.isArray(o) || o.length === 0 || o.some(function(h) {
                    return !Sa(h);
                  }) || 256 < o.length)) {
                    d.next = 6;
                    break;
                  }
                  throw new Z("invalid arguments", as);
                case 6:
                  return d.next = 8, this.session.requestPeersOnlineStatus(o).toPromise();
                case 8:
                  return u = d.sent, l = hd(nl(u.userInfos, "account"), function(h) {
                    return !!h.ts;
                  }), Object.keys(l).forEach(function(h) {
                    if (h in f.subscribedPeerStatusCache && f.subscribedPeerStatusCache[h] !== qa.PeerOnlineState.UNREACHABLE) {
                      var p = l[h] ? qa.PeerOnlineState.ONLINE : qa.PeerOnlineState.OFFLINE;
                      f.emit("PeersOnlineStatusChanged", x({}, h, p)), f.subscribedPeerStatusCache[h] = p;
                    }
                  }), d.abrupt("return", l);
                case 12:
                case "end":
                  return d.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "getChannelMemberCount", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h, p, m, _, w;
          return M.wrap(function(S) {
            for (; ; )
              switch (S.prev = S.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    S.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", vB);
                case 2:
                  if (this.session !== void 0) {
                    S.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  if (Array.isArray(o) && o.every(function(O) {
                    return typeof O == "string";
                  }) && o.length !== 0) {
                    S.next = 6;
                    break;
                  }
                  throw new Z("Invalid arguments: channelIds", Jr);
                case 6:
                  if (!(32 < o.length)) {
                    S.next = 8;
                    break;
                  }
                  throw new Z("getChannelMemberCount exceed limit of 32 channelIds", uB);
                case 8:
                  u = 0;
                case 9:
                  if (!(u < o.length)) {
                    S.next = 16;
                    break;
                  }
                  if (Sa(l = o[u])) {
                    S.next = 13;
                    break;
                  }
                  throw new Z(["getChannelMemberCount channel id %s is invalid", l], Jr);
                case 13:
                  u++, S.next = 9;
                  break;
                case 16:
                  return S.next = 18, this.session.requestGetChannelMemberCount(o).toPromise();
                case 18:
                  for (f = S.sent, d = f.groupInfos, h = {}, p = 0; p < d.length; p++)
                    m = d[p], _ = m.group, w = m.memberCount, Sa(_) && typeof w == "number" && (this.internalEmitter.emit("channelMemberCountUpdated", _, w), h[_] = w);
                  return S.abrupt("return", h);
                case 23:
                case "end":
                  return S.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "setLocalUserAttributes", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l;
          return M.wrap(function(f) {
            for (; ; )
              switch (f.prev = f.next) {
                case 0:
                  if (Wf({ attributes: o, maxAttrValueSize: 8192, maxAttrsCount: 32, maxTotalSize: 16384 }), this.connectionState === la.CONNECTED) {
                    f.next = 3;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 3:
                  if (this.session !== void 0) {
                    f.next = 5;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 5:
                  return u = this.session.requestSetLocalUserAttributes(o).toPromise(), l = { attribute: o, promise: u }, this.attributeDrafts.add(l), f.prev = 8, f.next = 11, u;
                case 11:
                  this.attributes = o, f.next = 19;
                  break;
                case 14:
                  if (f.prev = 14, f.t0 = f.catch(8), !Ma(f.t0)) {
                    f.next = 18;
                    break;
                  }
                  throw f.t0;
                case 18:
                  throw new Z("arguments is not valid", bb);
                case 19:
                  return f.prev = 19, this.attributeDrafts.delete(l), f.finish(19);
                case 22:
                case "end":
                  return f.stop();
              }
          }, s, this, [[8, 14, 19, 22]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "setChannelAttributes", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l, f, d, h, p, m = arguments;
          return M.wrap(function(_) {
            for (; ; )
              switch (_.prev = _.next) {
                case 0:
                  if (l = 2 < m.length && m[2] !== void 0 ? m[2] : {}, f = l.enableNotificationToChannelMembers, d = f !== void 0 && f, Wf({ attributes: u, maxAttrValueSize: 8192, maxAttrsCount: 32, maxTotalSize: 32768 }), this.connectionState === la.CONNECTED) {
                    _.next = 4;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 4:
                  if (this.session !== void 0) {
                    _.next = 6;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 6:
                  return h = this.session.requestSetChannelAttributes(o, u, d).toPromise(), _.prev = 7, _.next = 10, h;
                case 10:
                  p = hd(u, function(w) {
                    return new Blob([w]).size;
                  }), this.channelAttributesCacheLru.set(o, p), _.next = 19;
                  break;
                case 14:
                  if (_.prev = 14, _.t0 = _.catch(7), !Ma(_.t0)) {
                    _.next = 18;
                    break;
                  }
                  throw _.t0;
                case 18:
                  throw new Z("arguments is not valid", bb);
                case 19:
                case "end":
                  return _.stop();
              }
          }, s, this, [[7, 14]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "addOrUpdateLocalUserAttributes", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f;
          return M.wrap(function(d) {
            for (; ; )
              switch (d.prev = d.next) {
                case 0:
                  if (u = jb(jb({}, this.attributes), o), Wf({ attributes: o, maxAttrValueSize: 8192, maxAttrsCount: 32, maxTotalSize: 16384 }), Wf({ attributes: u, maxAttrValueSize: 8192, maxAttrsCount: 32, maxTotalSize: 16384 }), this.connectionState === la.CONNECTED) {
                    d.next = 5;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 5:
                  if (this.session !== void 0) {
                    d.next = 7;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 7:
                  return l = this.session.requestAddOrUpdateLocalUserAttributes(o).toPromise(), f = { attribute: u, promise: l }, this.attributeDrafts.add(f), d.prev = 10, d.next = 13, l;
                case 13:
                  this.attributes = u, d.next = 21;
                  break;
                case 16:
                  if (d.prev = 16, d.t0 = d.catch(10), !Ma(d.t0)) {
                    d.next = 20;
                    break;
                  }
                  throw d.t0;
                case 20:
                  throw new Z("arguments is not valid", as);
                case 21:
                  return d.prev = 21, this.attributeDrafts.delete(f), d.finish(21);
                case 24:
                case "end":
                  return d.stop();
              }
          }, s, this, [[10, 16, 21, 24]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "addOrUpdateChannelAttributes", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l, f, d, h, p, m, _, w = arguments;
          return M.wrap(function(S) {
            for (; ; )
              switch (S.prev = S.next) {
                case 0:
                  if (l = 2 < w.length && w[2] !== void 0 ? w[2] : {}, f = l.enableNotificationToChannelMembers, d = f !== void 0 && f, h = this.channelAttributesCacheLru.get(o, {}), p = hd(u, function(O) {
                    return new Blob([O]).size;
                  }), m = jb(jb({}, h), p), Wf({ attributes: u, attrSizeMap: m, maxAttrValueSize: 8192, maxAttrsCount: 32, maxTotalSize: 32768 }), this.connectionState === la.CONNECTED) {
                    S.next = 7;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 7:
                  if (this.session !== void 0) {
                    S.next = 9;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 9:
                  return _ = this.session.requestAddOrUpdateChannelAttributes(o, u, d).toPromise(), S.prev = 10, S.next = 13, _;
                case 13:
                  this.channelAttributesCacheLru.set(o, m), S.next = 21;
                  break;
                case 16:
                  if (S.prev = 16, S.t0 = S.catch(10), !Ma(S.t0)) {
                    S.next = 20;
                    break;
                  }
                  throw S.t0;
                case 20:
                  throw new Z("arguments is not valid", bb);
                case 21:
                case "end":
                  return S.stop();
              }
          }, s, this, [[10, 16]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "deleteLocalUserAttributesByKeys", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d;
          return M.wrap(function(h) {
            for (; ; )
              switch (h.prev = h.next) {
                case 0:
                  if (Array.isArray(o) && o.length !== 0 && !o.some(function(p) {
                    return p.length === 0;
                  })) {
                    h.next = 2;
                    break;
                  }
                  throw new aa("arguments is not valid", bb);
                case 2:
                  if (this.connectionState === la.CONNECTED) {
                    h.next = 4;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 4:
                  if (this.session !== void 0) {
                    h.next = 6;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 6:
                  return u = this.session.requestDeleteLocalUserAttributesByKeys(o).toPromise(), l = { attribute: kl(this.attributes, o), promise: u }, this.attributeDrafts.add(l), h.prev = 9, h.next = 12, u;
                case 12:
                  for (f = 0; f < o.length; f++)
                    d = o[f], delete this.attributes[d];
                  h.next = 20;
                  break;
                case 15:
                  if (h.prev = 15, h.t0 = h.catch(9), !Ma(h.t0)) {
                    h.next = 19;
                    break;
                  }
                  throw h.t0;
                case 19:
                  throw new Z("arguments is not valid", bb);
                case 20:
                  return h.prev = 20, this.attributeDrafts.delete(l), h.finish(20);
                case 23:
                case "end":
                  return h.stop();
              }
          }, s, this, [[9, 15, 20, 23]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "deleteChannelAttributesByKeys", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l, f, d, h, p, m, _, w = arguments;
          return M.wrap(function(S) {
            for (; ; )
              switch (S.prev = S.next) {
                case 0:
                  if (l = 2 < w.length && w[2] !== void 0 ? w[2] : {}, f = l.enableNotificationToChannelMembers, d = f !== void 0 && f, Array.isArray(u) && u.length !== 0 && Sa(o) && !u.some(function(O) {
                    return O.length === 0 || 512 < O.length;
                  })) {
                    S.next = 3;
                    break;
                  }
                  throw new aa("arguments is not valid", bb);
                case 3:
                  if (this.connectionState === la.CONNECTED) {
                    S.next = 5;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 5:
                  if (this.session !== void 0) {
                    S.next = 7;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 7:
                  return h = this.session.requestDeleteChannelAttributesByKeys(o, u, d).toPromise(), S.prev = 8, S.next = 11, h;
                case 11:
                  if (p = this.channelAttributesCacheLru.get(o))
                    for (m = 0; m < u.length; m++)
                      _ = u[m], delete p[_];
                  S.next = 20;
                  break;
                case 15:
                  if (S.prev = 15, S.t0 = S.catch(8), !Ma(S.t0)) {
                    S.next = 19;
                    break;
                  }
                  throw S.t0;
                case 19:
                  throw new Z("arguments is not valid", bb);
                case 20:
                case "end":
                  return S.stop();
              }
          }, s, this, [[8, 15]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "clearLocalUserAttributes", value: function() {
        var n = ja(M.mark(function s() {
          var o, u;
          return M.wrap(function(l) {
            for (; ; )
              switch (l.prev = l.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    l.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 2:
                  if (this.session !== void 0) {
                    l.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  return o = this.session.requestClearLocalUserAttributes().toPromise(), u = { attribute: {}, promise: o }, this.attributeDrafts.add(u), l.prev = 7, l.next = 10, o;
                case 10:
                  this.attributes = {}, l.next = 18;
                  break;
                case 13:
                  if (l.prev = 13, l.t0 = l.catch(7), !Ma(l.t0)) {
                    l.next = 17;
                    break;
                  }
                  throw l.t0;
                case 17:
                  throw new Z("arguments is not valid", bb);
                case 18:
                  return l.prev = 18, this.attributeDrafts.delete(u), l.finish(18);
                case 21:
                case "end":
                  return l.stop();
              }
          }, s, this, [[7, 13, 18, 21]]);
        }));
        return function() {
          return n.apply(this, arguments);
        };
      }() }, { key: "clearChannelAttributes", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h = arguments;
          return M.wrap(function(p) {
            for (; ; )
              switch (p.prev = p.next) {
                case 0:
                  if (u = 1 < h.length && h[1] !== void 0 ? h[1] : {}, l = u.enableNotificationToChannelMembers, f = l !== void 0 && l, this.connectionState === la.CONNECTED) {
                    p.next = 3;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 3:
                  if (this.session !== void 0) {
                    p.next = 5;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 5:
                  return d = this.session.requestClearChannelAttributes(o, f).toPromise(), p.prev = 6, p.next = 9, d;
                case 9:
                  this.channelAttributesCacheLru.delete(o), p.next = 17;
                  break;
                case 12:
                  if (p.prev = 12, p.t0 = p.catch(6), !Ma(p.t0)) {
                    p.next = 16;
                    break;
                  }
                  throw p.t0;
                case 16:
                  throw new Z("arguments is not valid", bb);
                case 17:
                case "end":
                  return p.stop();
              }
          }, s, this, [[6, 12]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "getUserAttributes", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f;
          return M.wrap(function(d) {
            for (; ; )
              switch (d.prev = d.next) {
                case 0:
                  if (Sa(o)) {
                    d.next = 2;
                    break;
                  }
                  throw new Z("Not a valid user ID", bb);
                case 2:
                  if (this.connectionState === la.CONNECTED) {
                    d.next = 4;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 4:
                  if (this.session !== void 0) {
                    d.next = 6;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 6:
                  return d.prev = 6, d.next = 9, this.session.requestGetUserAttributeKeys(o).toPromise();
                case 9:
                  return u = d.sent, l = u.keys, d.next = 13, this.session.requestGetUserAttributesByKeys(o, l.slice(0, 512)).toPromise();
                case 13:
                  f = d.sent, d.next = 21;
                  break;
                case 16:
                  if (d.prev = 16, d.t0 = d.catch(6), !Ma(d.t0)) {
                    d.next = 20;
                    break;
                  }
                  throw d.t0;
                case 20:
                  throw new Z("arguments is not valid", bb);
                case 21:
                  return d.abrupt("return", Tq(f.attributeInfos.map(function(h) {
                    return [h.key, h.value];
                  })));
                case 22:
                case "end":
                  return d.stop();
              }
          }, s, this, [[6, 16]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "getChannelAttributes", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h, p, m, _, w, S, O;
          return M.wrap(function(k) {
            for (; ; )
              switch (k.prev = k.next) {
                case 0:
                  if (Sa(o)) {
                    k.next = 2;
                    break;
                  }
                  throw new Z("Not a valid channel ID", bb);
                case 2:
                  if (this.connectionState === la.CONNECTED) {
                    k.next = 4;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 4:
                  if (this.session !== void 0) {
                    k.next = 6;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 6:
                  return k.prev = 6, k.next = 9, this.session.requestGetChannelAttributesKeys(o).toPromise();
                case 9:
                  return u = k.sent, l = u.keys, k.next = 13, this.session.requestGetChannelAttributesByKeys(o, l).toPromise();
                case 13:
                  f = k.sent, d = f.attributeMaps, k.next = 22;
                  break;
                case 17:
                  if (k.prev = 17, k.t0 = k.catch(6), !Ma(k.t0)) {
                    k.next = 21;
                    break;
                  }
                  throw k.t0;
                case 21:
                  throw new Z("arguments is not valid", bb);
                case 22:
                  h = {}, p = 0;
                case 24:
                  if (!(p < d.length)) {
                    k.next = 32;
                    break;
                  }
                  if (m = d[p], _ = m.key, w = m.ms, S = m.value, O = m.origin, typeof _ == "string" && ma.isLong(w) && typeof S == "string" && Sa(O)) {
                    k.next = 28;
                    break;
                  }
                  return k.abrupt("break", 32);
                case 28:
                  h[_] = { value: S, lastUpdateUserId: O, lastUpdateTs: w.toNumber() };
                case 29:
                  p++, k.next = 24;
                  break;
                case 32:
                  return this.channelAttributesCacheLru.set(o, hd(h, function(B) {
                    return new Blob([B.value]).size;
                  })), k.abrupt("return", h);
                case 34:
                case "end":
                  return k.stop();
              }
          }, s, this, [[6, 17]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "getChannelAttributesByKeys", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l, f, d, h, p, m, _, w, S, O;
          return M.wrap(function(k) {
            for (; ; )
              switch (k.prev = k.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    k.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 2:
                  if (this.session !== void 0) {
                    k.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  return Hn(o, u), k.prev = 5, k.next = 8, this.session.requestGetChannelAttributesByKeys(o, u).toPromise();
                case 8:
                  l = k.sent, f = l.attributeMaps, k.next = 17;
                  break;
                case 12:
                  if (k.prev = 12, k.t0 = k.catch(5), !Ma(k.t0)) {
                    k.next = 16;
                    break;
                  }
                  throw k.t0;
                case 16:
                  throw new Z("arguments is not valid", bb);
                case 17:
                  d = {}, h = this.channelAttributesCacheLru.get(o, {}), p = 0;
                case 20:
                  if (!(p < f.length)) {
                    k.next = 29;
                    break;
                  }
                  if (m = f[p], _ = m.key, w = m.ms, S = m.value, O = m.origin, typeof _ == "string" && ma.isLong(w) && typeof S == "string" && Sa(O)) {
                    k.next = 24;
                    break;
                  }
                  return k.abrupt("break", 29);
                case 24:
                  h[_] = new Blob([S]).size, d[_] = { value: S, lastUpdateUserId: O, lastUpdateTs: w.toNumber() };
                case 26:
                  p++, k.next = 20;
                  break;
                case 29:
                  return this.channelAttributesCacheLru.set(o, h), k.abrupt("return", d);
                case 31:
                case "end":
                  return k.stop();
              }
          }, s, this, [[5, 12]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "getUserAttributesByKeys", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l;
          return M.wrap(function(f) {
            for (; ; )
              switch (f.prev = f.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    f.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", lc);
                case 2:
                  if (this.session !== void 0) {
                    f.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  return Hn(o, u), f.prev = 5, f.next = 8, this.session.requestGetUserAttributesByKeys(o, u).toPromise();
                case 8:
                  l = f.sent, f.next = 16;
                  break;
                case 11:
                  if (f.prev = 11, f.t0 = f.catch(5), !Ma(f.t0)) {
                    f.next = 15;
                    break;
                  }
                  throw f.t0;
                case 15:
                  throw new Z("arguments is not valid", bb);
                case 16:
                  return f.abrupt("return", Tq(l.attributeInfos.map(function(d) {
                    return [d.key, d.value];
                  })));
                case 17:
                case "end":
                  return f.stop();
              }
          }, s, this, [[5, 11]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "login", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h;
          return M.wrap(function(p) {
            for (; ; )
              switch (p.prev = p.next) {
                case 0:
                  if (rn(!0), l = hh(), f = o.token, o.token === this.context.appId && (f = void 0), xb("Session", { appId: this.context.appId, did: navigator.userAgent, elapse: yb(this.session && this.session.startTime), index: { index1: o.uid, index2: this.context.appId, index3: "enableLogUpload=".concat(this.context.config.enableLogUpload) }, installId: Mg, lts: ma.fromNumber(Date.now()), os: 7, sid: rb(l), token: f || "", userId: o.uid, ver: "1.5.0", buildno: 417, subVersion: 17, version: 4 }, (u = this.context.config.enableCloudProxy) !== null && u !== void 0 && u, !0), Be(o) && Sa(o.uid)) {
                    p.next = 7;
                    break;
                  }
                  throw new Z("not a valid user id", pi);
                case 7:
                  if (typeof f != "string" || !f) {
                    p.next = 11;
                    break;
                  }
                  this.context.token = f, p.next = 13;
                  break;
                case 11:
                  if (typeof f == "string" || f == null) {
                    p.next = 13;
                    break;
                  }
                  throw new Z('The "token" is not a valid string.', pi);
                case 13:
                  return d = Date.now(), this.context.sid = rb(l), this.loginPromise = this.loginImpl({ uid: o.uid, instanceId: l }), this.info("RTM Client logging in as ".concat(Ka(o.uid))), p.prev = 17, p.next = 20, this.loginPromise;
                case 20:
                  p.next = 28;
                  break;
                case 22:
                  throw p.prev = 22, p.t0 = p.catch(17), Ma(p.t0) && xb("Link", { ackedServerIp: "", destServerIp: "", ec: p.t0.code || 1, sc: p.t0.serverCode, elapse: yb(this.session && this.session.startTime), lts: ma.fromNumber(Date.now()), responseTime: Date.now() - d, sid: rb(l), userId: o.uid }, (h = this.context.config.enableCloudProxy) !== null && h !== void 0 && h), this.context.token = void 0, this.context.socketUseProxy = !1, p.t0;
                case 28:
                  return p.prev = 28, this.loginPromise = void 0, p.finish(28);
                case 31:
                  this.context.socketUseProxy && this.emit("FallbackProxyConnected"), rn(!1);
                case 33:
                case "end":
                  return p.stop();
              }
          }, s, this, [[17, 22, 28, 31]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "logout", value: function() {
        var n = ja(M.mark(function s() {
          var o;
          return M.wrap(function(u) {
            for (; ; )
              switch (u.prev = u.next) {
                case 0:
                  if (!this.loginPromise) {
                    u.next = 3;
                    break;
                  }
                  return u.next = 3, this.loginPromise;
                case 3:
                  if (this.connectionState !== la.DISCONNECTED) {
                    u.next = 6;
                    break;
                  }
                  throw this.logError("Already in logout state"), new aa("Logout failure. The client has already been logged out", Xr);
                case 6:
                  if (this.internalEmitter.emit("LOGOUT"), this.connectionState !== la.ABORTED) {
                    u.next = 11;
                    break;
                  }
                  return this.info('Reset connection state from "ABORTED" to "DISCONNECTED"'), this.onConnectionStateChanged(la.DISCONNECTED, Mb.LOGOUT), u.abrupt("return");
                case 11:
                  if (this.session !== void 0) {
                    u.next = 14;
                    break;
                  }
                  return this.onConnectionStateChanged(la.DISCONNECTED, Mb.LOGOUT), u.abrupt("return");
                case 14:
                  return xb("Logout", { elapse: yb(this.session.startTime), lts: ma.fromNumber(Date.now()), sid: rb(this.session.instanceId), userId: this.context.uid }, (o = this.context.config.enableCloudProxy) !== null && o !== void 0 && o), u.next = 17, this.session.logoutHandler();
                case 17:
                  this.onConnectionStateChanged(la.DISCONNECTED, Mb.LOGOUT), this.log("Log out success");
                case 19:
                case "end":
                  return u.stop();
              }
          }, s, this);
        }));
        return function() {
          return n.apply(this, arguments);
        };
      }() }, { key: "logoutSync", value: function() {
        var n, s = this;
        if (this.connectionState === la.DISCONNECTED)
          throw this.logError("Already in logout state"), new aa("Logout failure. The client has already been logged out", Xr);
        this.connectionState === la.ABORTED ? this.info('Reset connection state from "ABORTED" to "DISCONNECTED"') : this.session !== void 0 && (xb("Logout", { elapse: yb(this.session.startTime), lts: ma.fromNumber(Date.now()), sid: rb(this.session.instanceId), userId: this.context.uid }, (n = this.context.config.enableCloudProxy) !== null && n !== void 0 && n), this.session.logoutHandler().then(function() {
          s.log("Log out success");
        })), this.onConnectionStateChanged(la.DISCONNECTED, Mb.LOGOUT);
      } }, { key: "sendMessageToPeer", value: function() {
        var n = ja(M.mark(function s(o, u) {
          var l, f = this;
          return M.wrap(function(d) {
            for (; ; )
              switch (d.prev = d.next) {
                case 0:
                  if (On(o, Xf), this.connectionState !== la.RECONNECTING) {
                    d.next = 4;
                    break;
                  }
                  return l = Date.now(), d.abrupt("return", new Promise(function(h, p) {
                    var m, _ = (m = ja(M.mark(function S() {
                      var O;
                      return M.wrap(function(k) {
                        for (; ; )
                          switch (k.prev = k.next) {
                            case 0:
                              if (f.session !== void 0) {
                                k.next = 2;
                                break;
                              }
                              throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                            case 2:
                              return O = Date.now() - l, k.prev = 3, k.t0 = h, k.next = 7, kh({ message: o, peerId: u, toPeer: !0, session: f.session, errorCodes: { NOT_LOGGED_IN: Fl, TOO_OFTEN: Zr }, diff: O, logger: f.logger });
                            case 7:
                              k.t1 = k.sent, (0, k.t0)(k.t1), k.next = 16;
                              break;
                            case 11:
                              k.prev = 11, k.t2 = k.catch(3), vb(k.t2) && p(new Qb(te(f.name, "sendMessageToPeer", 1e4), El)), Ma(k.t2) && p(k.t2), p(new Ja("Peer-to-peer message send failure", { code: Yr, originalError: k.t2 }));
                            case 16:
                              return k.prev = 16, clearTimeout(w), k.finish(16);
                            case 19:
                            case "end":
                              return k.stop();
                          }
                      }, S, null, [[3, 11, 16, 19]]);
                    })), function() {
                      return m.apply(this, arguments);
                    });
                    f.internalEmitter.once("RECONNECTED", _);
                    var w = setTimeout(function() {
                      f.internalEmitter.off("RECONNECTED", _), p(new Qb(te(f.name, "sendMessageToPeer", 1e4), El));
                    }, 9e3);
                  }));
                case 4:
                  if (this.connectionState === la.CONNECTED) {
                    d.next = 6;
                    break;
                  }
                  throw new aa("Failed to send the peer-to-peer message. The client is not logged in", Fl);
                case 6:
                  if (this.session !== void 0) {
                    d.next = 8;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 8:
                  return d.prev = 8, d.next = 11, kh({ message: o, peerId: u, toPeer: !0, session: this.session, errorCodes: { NOT_LOGGED_IN: Fl, TOO_OFTEN: Zr }, diff: 0, logger: this.logger });
                case 11:
                  return d.abrupt("return", d.sent);
                case 14:
                  if (d.prev = 14, d.t0 = d.catch(8), !vb(d.t0)) {
                    d.next = 18;
                    break;
                  }
                  throw new Qb(te(this.name, "sendMessageToPeer", 1e4), El);
                case 18:
                  if (!Ma(d.t0)) {
                    d.next = 20;
                    break;
                  }
                  throw d.t0;
                case 20:
                  throw new Ja("Peer-to-peer message send failure", { code: Yr, originalError: d.t0 });
                case 21:
                case "end":
                  return d.stop();
              }
          }, s, this, [[8, 14]]);
        }));
        return function(s, o) {
          return n.apply(this, arguments);
        };
      }() }, { key: "createChannel", value: function(n) {
        var s = this;
        if (!Sa(n))
          throw new Z(["The %s in the arguments is invalid", Object.keys({ channelId: n })[0]], tB);
        return new bF(n, function() {
          return s.session;
        }, this, this.logger);
      } }, { key: "createLocalInvitation", value: function(n) {
        if (!Sa(n))
          throw new Z(["The %s in the arguments is invalid", Object.keys({ calleeId: n })[0]], Tc);
        return this.invitationManager.genLocalInvitation(n);
      } }, { key: "subscribePeersOnlineStatus", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h, p, m, _, w, S, O, k, B, L = this;
          return M.wrap(function(G) {
            for (; ; )
              switch (G.prev = G.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    G.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", Hl);
                case 2:
                  if (this.session !== void 0) {
                    G.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  if (Array.isArray(o) && o.length !== 0) {
                    G.next = 6;
                    break;
                  }
                  throw new Z("Invalid arguments: peerIds", Og);
                case 6:
                  u = 0;
                case 7:
                  if (!(u < o.length)) {
                    G.next = 14;
                    break;
                  }
                  if (Sa(l = o[u])) {
                    G.next = 11;
                    break;
                  }
                  throw new Z(["subscribePeersOnlineStatus peer id %s is invalid", l], Og);
                case 11:
                  u++, G.next = 7;
                  break;
                case 14:
                  if (!(512 < (f = o && o.length ? $k(o) : []).length + Object.keys(this.subscribedPeerStatusCache).length + this.pendingPeerStatusSubCount)) {
                    G.next = 17;
                    break;
                  }
                  throw new dc("Subscribed peers overflows", ds);
                case 17:
                  return this.pendingPeerStatusSubCount += f.length, G.next = 20, this.session.requestSubscribePeersOnlineStatus(f).toPromise();
                case 20:
                  d = G.sent, h = d.errors, this.pendingPeerStatusSubCount -= f.length, p = [], m = [], _ = 0;
                case 26:
                  if (!(_ < h.length)) {
                    G.next = 34;
                    break;
                  }
                  if (w = h[_], S = w.code, typeof (O = w.account) == "string") {
                    G.next = 30;
                    break;
                  }
                  throw new Ja("Returned account is invalid", cs);
                case 30:
                  S !== 0 && p.push(O);
                case 31:
                  _++, G.next = 26;
                  break;
                case 34:
                  for (k = 0; k < f.length; k++)
                    B = f[k], p.includes(B) || (m.push(B), this.subscribedPeerStatusCache[B] = void 0);
                  if (this.session.requestPeersOnlineStatus(m).pipe(Da(function(_r) {
                    return hd(nl(_r.userInfos, "account"), function(ga) {
                      return !!ga.ts;
                    });
                  })).subscribe(function(_r) {
                    _r = hd(_r, function(ga, _n) {
                      return ga = ga ? qa.PeerOnlineState.ONLINE : qa.PeerOnlineState.OFFLINE, L.subscribedPeerStatusCache[_n] = ga;
                    }), L.emit("PeersOnlineStatusChanged", _r);
                  }), p.length === 0) {
                    G.next = 38;
                    break;
                  }
                  throw new Ja("Subscription failed", cs);
                case 38:
                case "end":
                  return G.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "unsubscribePeersOnlineStatus", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h;
          return M.wrap(function(p) {
            for (; ; )
              switch (p.prev = p.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    p.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", Hl);
                case 2:
                  if (this.session !== void 0) {
                    p.next = 4;
                    break;
                  }
                  throw new ib({ SESSION_NOT_FOUND: "Failed to get session of the client" });
                case 4:
                  if (Array.isArray(o) && o.length !== 0) {
                    p.next = 6;
                    break;
                  }
                  throw new Z("Invalid arguments: peerIds", Og);
                case 6:
                  u = 0;
                case 7:
                  if (!(u < o.length)) {
                    p.next = 14;
                    break;
                  }
                  if (Sa(l = o[u])) {
                    p.next = 11;
                    break;
                  }
                  throw new Z(["subscribePeersOnlineStatus peer id %s is invalid", l], Og);
                case 11:
                  u++, p.next = 7;
                  break;
                case 14:
                  if (!(512 < o.length)) {
                    p.next = 16;
                    break;
                  }
                  throw new dc("Unsubscribed peers overflows", ds);
                case 16:
                  for (f = o && o.length ? $k(o) : [], this.session.requestUnsubscribePeersOnlineStatus(f), d = 0; d < f.length; d++)
                    h = f[d], delete this.subscribedPeerStatusCache[h];
                case 19:
                case "end":
                  return p.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "queryPeersBySubscriptionOption", value: function() {
        var n = ja(M.mark(function s(o) {
          return M.wrap(function(u) {
            for (; ; )
              switch (u.prev = u.next) {
                case 0:
                  if (this.connectionState === la.CONNECTED) {
                    u.next = 2;
                    break;
                  }
                  throw new aa("The client is not logged in", Hl);
                case 2:
                  if (o !== qa.PeerSubscriptionOption.ONLINE_STATUS) {
                    u.next = 4;
                    break;
                  }
                  return u.abrupt("return", Object.keys(this.subscribedPeerStatusCache));
                case 4:
                  throw new Z("Subscription option not supported", Og);
                case 5:
                case "end":
                  return u.stop();
              }
          }, s, this);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "createMessage", value: function(n) {
        return n;
      } }, { key: "loginImpl", value: function() {
        var n = ja(M.mark(function s(o) {
          var u, l, f, d, h, p, m, _, w = this;
          return M.wrap(function(S) {
            for (; ; )
              switch (S.prev = S.next) {
                case 0:
                  if (u = o.uid, l = o.instanceId, f = o.forceLoginTime, d = f === void 0 ? 0 : f, h = l, !(this.lastLoginTime !== void 0 && 500 > Date.now() - this.lastLoginTime)) {
                    S.next = 4;
                    break;
                  }
                  throw new wD(["The frequency of login exceeded the limit of %d queries per second", 2], HB);
                case 4:
                  if (this.connectionState === la.DISCONNECTED || d !== 0) {
                    S.next = 6;
                    break;
                  }
                  throw new aa("The SDK is either logging in or has logged in the Agora RTM system", FB);
                case 6:
                  S.prev = 6, this.context.uid = u, S.next = 13;
                  break;
                case 10:
                  throw S.prev = 10, S.t0 = S.catch(6), new Z(["The %s in the arguments is invalid", Object.keys({ uid: u })[0]], pi);
                case 13:
                  return d === 0 && this.onConnectionStateChanged(la.CONNECTING, Mb.LOGIN), (p = new Us(this.context, this.logger, !1)).blacklistedIP = this.blacklistedIP, this.session = m = new Lt(this.context, p, h, this.logger), _ = function() {
                    w.connectionState === la.CONNECTED && (w.onConnectionStateChanged(la.RECONNECTING, Mb.INTERRUPTED), w.session) && w.session.once("userJoined", function() {
                      w.onConnectionStateChanged(la.CONNECTED, Mb.LOGIN_SUCCESS);
                    });
                  }, m.on("connectionLost", _), m.on("tokenExpired", function() {
                    w.emit("TokenExpired");
                  }), m.on("TokenPrivilegeWillExpire", this.TokenPrivilegeWillExpireHandler), m.once("userDrop", this.userDropHandler), this.session.on("peerTextMessage", function(O) {
                    w.emit("MessageFromPeer", { text: O.text, messageType: qa.MessageType.TEXT }, O.peerId, O.properties);
                  }), this.session.on("peerRawMessage", function(O) {
                    w.emit("MessageFromPeer", { rawMessage: O.raw, description: O.desc, messageType: qa.MessageType.RAW }, O.peerId, O.properties);
                  }), m.on("instanceChanged", function(O) {
                    return h = O;
                  }), m.on("peerOnlineStatusChanged", function(O) {
                    var k = O.instance.toString() + O.state, B = w.peerStatusSeqLru.get(k);
                    !B || O.seq.greaterThan(B) ? (w.peerStatusSeqLru.set(k, O.seq), O.state !== w.subscribedPeerStatusCache[O.peerId] && w.emit("PeersOnlineStatusChanged", x({}, O.peerId, O.state)), w.subscribedPeerStatusCache[O.peerId] = O.state, clearTimeout(w.peerUnreachableTimers[k]), O.state === qa.PeerOnlineState.UNREACHABLE && (w.peerUnreachableTimers[k] = setTimeout(function() {
                      w.subscribedPeerStatusCache[O.peerId] === qa.PeerOnlineState.UNREACHABLE && (w.subscribedPeerStatusCache[O.peerId] = qa.PeerOnlineState.ONLINE, w.emit("PeersOnlineStatusChanged", x({}, O.peerId, qa.PeerOnlineState.ONLINE)));
                    }, 3e4))) : w.log("peerOnlineStatusChanged dedup for %s, %d", k, O.seq.toNumber());
                  }), m.on("invitationMessage", this.invitationManager.invitationMessageHandler.bind(this.invitationManager)), m.on("channelAttributesUpdated", function(O) {
                    var k = O.channelId;
                    O = O.attributeMaps;
                    for (var B = {}, L = 0; L < O.length; L++) {
                      var G = O[L], _r = G.key, ga = G.ms, _n = G.value;
                      if (G = G.origin, typeof _r != "string" || !ma.isLong(ga) || typeof _n != "string" || !Sa(G))
                        break;
                      B[_r] = new Blob([_n]).size;
                    }
                    w.channelAttributesCacheLru.set(k, B);
                  }), m.on("userJoined", function(O) {
                    if (Object.keys(w.attributes).length !== 0) {
                      if (w.session === void 0)
                        return;
                      w.session.requestSetLocalUserAttributes(w.attributes, O).toPromise();
                    }
                    if (w.attributeDrafts.size !== 0)
                      for (var k = function(G, _r) {
                        var ga = (G = _r[G]).attribute;
                        G.promise.then(function() {
                          w.session !== void 0 && w.session.requestSetLocalUserAttributes(ga, O).toPromise();
                        });
                      }, B = 0, L = Array.from(w.attributeDrafts); B < L.length; B++)
                        k(B, L);
                    Object.keys(w.subscribedPeerStatusCache).length !== 0 && m.requestSubscribePeersOnlineStatus(Object.keys(w.subscribedPeerStatusCache));
                  }), m.on("banEdgeIP", function(O) {
                    w.banIP(O);
                  }), this.lastLoginTime = Date.now(), S.prev = 32, S.next = 35, m.loginHandler().toPromise();
                case 35:
                  S.next = 53;
                  break;
                case 37:
                  if (S.prev = 37, S.t1 = S.catch(32), !(S.t1.name === "loginRespTimeout" && 2 > d)) {
                    S.next = 46;
                    break;
                  }
                  return m.removeAllListeners(), S.next = 43, this.loginImpl({ uid: u, instanceId: l, forceLoginTime: d + 1 });
                case 43:
                  return S.abrupt("return");
                case 46:
                  if (!vb(S.t1)) {
                    S.next = 49;
                    break;
                  }
                  throw this.onConnectionStateChanged(la.DISCONNECTED, Mb.LOGIN_TIMEOUT), new Qb(te(this.name, "login", 12e3), GB);
                case 49:
                  if (this.onConnectionStateChanged(la.DISCONNECTED, Mb.LOGIN_FAILURE), !Ma(S.t1)) {
                    S.next = 52;
                    break;
                  }
                  throw S.t1;
                case 52:
                  throw new Ja("Login failure", { code: Ur, originalError: S.t1 });
                case 53:
                  this.onConnectionStateChanged(la.CONNECTED, Mb.LOGIN_SUCCESS);
                case 54:
                case "end":
                  return S.stop();
              }
          }, s, this, [[6, 10], [32, 37]]);
        }));
        return function(s) {
          return n.apply(this, arguments);
        };
      }() }, { key: "onConnectionStateChanged", value: function(n, s) {
        var o, u = this;
        n === la.RECONNECTING && (this.reconnId += 1), xb("ConnectionStateChange", { elapse: yb(this.session && this.session.startTime), lts: ma.fromNumber(Date.now()), newState: Nt[n], oldState: Nt[this.connectionState], reason: cF[s], sid: rb(this.session && this.session.instanceId || ma.fromNumber(0)), userId: this.context.uid, reconnId: this.reconnId }, (o = this.context.config.enableCloudProxy) !== null && o !== void 0 && o), this.connectionState === la.RECONNECTING && n === la.CONNECTED && (Object.keys(this.subscribedPeerStatusCache).length !== 0 && this.session !== void 0 && this.session.requestPeersOnlineStatus(Object.keys(this.subscribedPeerStatusCache)).pipe(Da(function(l) {
          return hd(nl(l.userInfos, "account"), function(f) {
            return !!f.ts;
          });
        })).subscribe(function(l) {
          l = hd(l, function(f, d) {
            return f = f ? qa.PeerOnlineState.ONLINE : qa.PeerOnlineState.OFFLINE, u.subscribedPeerStatusCache[d] = f;
          }), u.emit("PeersOnlineStatusChanged", l);
        }), this.internalEmitter.emit("RECONNECTED")), this.connectionState = n, n !== la.ABORTED && n !== la.DISCONNECTED || (this.pendingPeerStatusSubCount = this.reconnId = 0, this.attributes = {}, this.session && (this.session.removeAllListeners(), this.session.msgDedupLru.empty(), this.session.dialogueSequenceLru.empty(), this.session.dialPendingMsgSubjectMap.clear()), this.channelAttributesCacheLru.empty(), this.peerStatusSeqLru.empty(), this.peerUnreachableTimers = {}, this.subscribedPeerStatusCache = {}, this.attributeDrafts.clear(), this.context.token = void 0), this.emit("ConnectionStateChanged", n, s);
      } }, { key: "banIP", value: function(n) {
        var s;
        this.log("ip banned", n);
        var o = (s = this.blacklistedIP[n]) !== null && s !== void 0 ? s : 0;
        this.blacklistedIP[n] = o + 1;
      } }]), e;
    }(Ac()), Ca(U.prototype, "renewToken", [fb], Object.getOwnPropertyDescriptor(U.prototype, "renewToken"), U.prototype), Ca(U.prototype, "queryPeersOnlineStatus", [fb], Object.getOwnPropertyDescriptor(U.prototype, "queryPeersOnlineStatus"), U.prototype), Ca(U.prototype, "getChannelMemberCount", [fb], Object.getOwnPropertyDescriptor(U.prototype, "getChannelMemberCount"), U.prototype), Ca(U.prototype, "setLocalUserAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "setLocalUserAttributes"), U.prototype), Ca(U.prototype, "setChannelAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "setChannelAttributes"), U.prototype), Ca(U.prototype, "addOrUpdateLocalUserAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "addOrUpdateLocalUserAttributes"), U.prototype), Ca(U.prototype, "addOrUpdateChannelAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "addOrUpdateChannelAttributes"), U.prototype), Ca(U.prototype, "deleteLocalUserAttributesByKeys", [fb], Object.getOwnPropertyDescriptor(U.prototype, "deleteLocalUserAttributesByKeys"), U.prototype), Ca(U.prototype, "deleteChannelAttributesByKeys", [fb], Object.getOwnPropertyDescriptor(U.prototype, "deleteChannelAttributesByKeys"), U.prototype), Ca(U.prototype, "clearLocalUserAttributes", [Ic], Object.getOwnPropertyDescriptor(U.prototype, "clearLocalUserAttributes"), U.prototype), Ca(U.prototype, "clearChannelAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "clearChannelAttributes"), U.prototype), Ca(U.prototype, "getUserAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "getUserAttributes"), U.prototype), Ca(U.prototype, "getChannelAttributes", [fb], Object.getOwnPropertyDescriptor(U.prototype, "getChannelAttributes"), U.prototype), Ca(U.prototype, "getChannelAttributesByKeys", [fb], Object.getOwnPropertyDescriptor(U.prototype, "getChannelAttributesByKeys"), U.prototype), Ca(U.prototype, "getUserAttributesByKeys", [fb], Object.getOwnPropertyDescriptor(U.prototype, "getUserAttributesByKeys"), U.prototype), Ca(U.prototype, "login", [Ic], Object.getOwnPropertyDescriptor(U.prototype, "login"), U.prototype), Ca(U.prototype, "logout", [Ic], Object.getOwnPropertyDescriptor(U.prototype, "logout"), U.prototype), Ca(U.prototype, "logoutSync", [Ic], Object.getOwnPropertyDescriptor(U.prototype, "logoutSync"), U.prototype), Ca(U.prototype, "sendMessageToPeer", [fb], Object.getOwnPropertyDescriptor(U.prototype, "sendMessageToPeer"), U.prototype), Ca(U.prototype, "createChannel", [fb], Object.getOwnPropertyDescriptor(U.prototype, "createChannel"), U.prototype), Ca(U.prototype, "createLocalInvitation", [fb], Object.getOwnPropertyDescriptor(U.prototype, "createLocalInvitation"), U.prototype), Ca(U.prototype, "subscribePeersOnlineStatus", [fb], Object.getOwnPropertyDescriptor(U.prototype, "subscribePeersOnlineStatus"), U.prototype), Ca(U.prototype, "unsubscribePeersOnlineStatus", [fb], Object.getOwnPropertyDescriptor(U.prototype, "unsubscribePeersOnlineStatus"), U.prototype), Ca(U.prototype, "queryPeersBySubscriptionOption", [fb], Object.getOwnPropertyDescriptor(U.prototype, "queryPeersBySubscriptionOption"), U.prototype), Ca(U.prototype, "createMessage", [Ic], Object.getOwnPropertyDescriptor(U.prototype, "createMessage"), U.prototype), U), mm, nm, om, pm, Ot = (mm = /Chrome\/([0-9.]+)/.exec((om = window) === null || om === void 0 || (pm = om.navigator) === null || pm === void 0 ? void 0 : pm.userAgent)) === null || mm === void 0 || (nm = mm[1]) === null || nm === void 0 ? void 0 : nm.split(".")[0];
    if (Ot && 88 <= parseInt(Ot, 10) && !Ae()) {
      var qm, xe = document.createElement("video"), ye = document.createElement("canvas");
      xe.setAttribute("style", "display:none"), xe.setAttribute("muted", ""), xe.muted = !0, xe.setAttribute("autoplay", ""), xe.autoplay = !0, xe.setAttribute("playsinline", ""), ye.setAttribute("style", "display:none"), ye.setAttribute("width", "1"), ye.setAttribute("height", "1"), (qm = ye.getContext("2d")) === null || qm === void 0 || qm.fillRect(0, 0, 1, 1), xe.srcObject = ye == null ? void 0 : ye.captureStream();
    }
    var Pt = { LOG_FILTER_OFF: { error: !1, warn: !1, info: !1, track: !1, debug: !1 }, LOG_FILTER_ERROR: { error: !0, warn: !1, info: !1, track: !1, debug: !1 }, LOG_FILTER_WARNING: { error: !0, warn: !0, info: !1, track: !1, debug: !1 }, LOG_FILTER_INFO: { error: !0, warn: !0, info: !0, track: !1, debug: !1 }, LOG_FILTER_DEBUG: { error: !0, warn: !0, info: !0, track: !0, debug: !0 } }, Qt = { enableLogUpload: !1, logFilter: Pt.LOG_FILTER_INFO, enableCloudProxy: !1 }, ue = jb(jb({ createInstance: function(r) {
      var e = 1 < arguments.length && arguments[1] !== void 0 ? arguments[1] : {}, t = 2 < arguments.length ? arguments[2] : void 0;
      if (!/^[\dA-Za-z]{32}$/.test(r))
        throw new Z(["The %s in the arguments is invalid", Object.keys({ appId: r })[0]], Ir);
      var a = Object.keys(e).filter(function(d) {
        return !(d in Qt);
      });
      if (a.length !== 0)
        throw new Z("Invalid RTM config: ".concat(a.join(", ")), Ir);
      var n = jb(jb({}, Qt), e);
      if (t !== void 0 && (!Array.isArray(t) || t.length === 0))
        throw new Z("Invalid area config");
      if (t != null) {
        if (!t.every(function(d) {
          return d in qa.LegacyAreaCode;
        }))
          throw new Z("Invalid area codes: ".concat(t.filter(function(d) {
            return !(d in qa);
          }).join(", ")));
        ca = Ue(t.map(function(d) {
          return ED[d];
        }));
      }
      t = Nl = Va.__global_unique_id__ = (Va.__global_unique_id__ || 0) + 1;
      var s = ID(n);
      a = JD(n);
      var o = KD(n), u = LD(t, n), l = Os(t, n), f = l("RTM:DEBUG", "<Entry> ");
      return Hs.rtmConfig = n, s("The Agora RTM Web SDK version is %s", "1.5.0"), e.enableCloudProxy && s("RTM cloud proxy enabled"), e.enableLogUpload && s("Log upload enabled"), ca && f("Area is set to %s", Array.from(ca.CODES).map(function(d) {
        return $f(R).find(function(h) {
          return R[h] === d;
        });
      }).join(", ")), f("Creating an RtmClient instance"), f('The Git commit ID is "'.concat("v1.5.0-0-g83bd874d", '"')), f("The App ID is %s", Pn(r, 4, 10, "*".repeat(6))), s("The process ID is %s", Mg), f("The build is %s", "v1.5.0-0-g83bd874d"), f("NODE_ENV is %s", "production"), new dF(r, { genLogger: l, genTracker: u, info: s, warn: a, logError: o, loggerId: t }, n, function(d) {
        for (var h = 0, p = $f(d); h < p.length; h++) {
          var m = p[h];
          try {
            var _ = d[m];
            _ != null && (d.enableCloudProxy && s("RTM cloud proxy enabled"), d.enableLogUpload && s("Log upload enabled"), n[m] = _);
          } catch {
            throw new Z(["The %s in the arguments is invalid", m], void 0);
          }
        }
      });
    }, BUILD: "v1.5.0-0-g83bd874d", VERSION: "1.5.0", END_CALL_PREFIX: "AgoraRTMLegacyEndcallCompatibleMessagePrefix", processId: Mg, ConnectionChangeReason: qa.ConnectionChangeReason, ConnectionState: qa.ConnectionState, LocalInvitationFailureReason: qa.LocalInvitationFailureReason, LocalInvitationState: qa.LocalInvitationState, RemoteInvitationFailureReason: qa.RemoteInvitationFailureReason, RemoteInvitationState: qa.RemoteInvitationState, MessageType: qa.MessageType, PeerOnlineState: qa.PeerOnlineState, PeerSubscriptionOption: qa.PeerSubscriptionOption }, Pt), {}, { setParameter: function(r, e) {
      Object.keys(xc).includes(r) && (xc[r] = e);
    }, getParameter: function(r) {
      return xc[r];
    }, setArea: function(r) {
      var e = r.areaCodes;
      if (r = r.excludedArea, !Array.isArray(e) || e.length === 0 || !e.every(function(t) {
        return t in qa.AreaCode;
      }))
        throw new Z("Invalid area config");
      if (r !== void 0 && r === qa.AreaCode.GLOBAL)
        throw new Z("Excluded area cannot be global");
      if (r === void 0)
        ca = Ue(e.map(function(t) {
          return R[t];
        }));
      else {
        if (e.includes(r))
          throw new Z("Excluded area cannot be in areaCodes");
        if (!(r in R))
          throw new Z("Invalid excludedArea:", r);
        ca = yv({ areas: e.map(function(t) {
          return R[t];
        }), excludedArea: R[r] });
      }
    } });
    return ue;
  });
})(agoraRtmSdk);
const AgoraRtm = /* @__PURE__ */ getDefaultExportFromCjs(agoraRtmSdk.exports);
class AgoraRtmClient extends EventEmitter {
  constructor(t, a, n, s = RTM_DEFAULT_CONFIGS, o = LIMIT_SENDER, u = LIMIT_CHAT_CONFIGS, l = REGEXS.ANY_URL, f = RTM_MESSAGE_TYPES, d = !0) {
    super();
    t0(this, "client");
    t0(this, "channels");
    t0(this, "isLoggedInRtm");
    t0(this, "waitDuration");
    t0(this, "waitingTime");
    t0(this, "intervalLimitSenderId");
    t0(this, "setTimeoutMuteSenderId");
    t0(this, "currentTotalMessages");
    t0(this, "isMuting");
    t0(this, "remainingMutingTime");
    t0(this, "rtmWorker");
    t0(this, "appId");
    t0(this, "rtmConfig");
    t0(this, "user");
    t0(this, "options");
    t0(this, "limitSenderConfigs");
    t0(this, "limitChatConfigs");
    t0(this, "regexUrl");
    t0(this, "rtmMessageTypes");
    t0(this, "disableHtml");
    this.rtmWorker = new Worker("/assets/rtm.092067c7.js", { type: "module" }), this.user = a, this.options = s, this.appId = t, this.rtmConfig = n, this.client = this.createClient(this.appId, this.rtmConfig), this.isLoggedInRtm = !1, this.channels = {}, this.waitDuration = 0, this.waitingTime = !1, this.limitSenderConfigs = o, this.limitChatConfigs = u, this.intervalLimitSenderId = 0, this.setTimeoutMuteSenderId = 0, this.currentTotalMessages = 0, this.remainingMutingTime = 0, this.isMuting = !1, this.regexUrl = l, this.rtmMessageTypes = f, this.disableHtml = d;
  }
  initialRtmWorker() {
    this.rtmWorker.postMessage({
      type: TYPE_WORKERS.INITIAL_WORKER,
      data: {
        user: this.user,
        options: { ...RTM_DEFAULT_CONFIGS, ...this.options },
        limitChatConfigs: this.limitChatConfigs,
        regexUrl: this.regexUrl,
        rtmMessageTypes: this.rtmMessageTypes,
        disableHtml: this.disableHtml
      }
    }), this.rtmWorker.onmessage = (t) => {
      var s, o;
      let a = (s = t.data) == null ? void 0 : s.type, n = (o = t.data) == null ? void 0 : o.data;
      switch (a) {
        case TYPE_WORKERS.UPDATE_DATA_CONFIGS: {
          this.waitingTime || (this.waitDuration = n.waitDuration);
          break;
        }
        case TYPE_WORKERS.NEW_CHANNEL_MESSAGES: {
          requestAnimationFrame(() => {
            this.emit(RtmEventType.UPDATE_TEXT_MESSAGES, n);
          });
          break;
        }
        default: {
          this.emit(RtmEventType.NEW_MESSAGE, n);
          break;
        }
      }
    };
  }
  createClient(t, a) {
    return this.initialRtmWorker(), this.client = AgoraRtm.createInstance(t, a), this.client;
  }
  subscribeClientEvents(t = RTM_CLIENT_EVENTS) {
    t.forEach((a) => {
      this.client.on(a, (...n) => {
        const s = a;
        this.emit(RtmClientEventType[s], ...n);
      });
    });
  }
  async login(t) {
    this.client.login(t).then(() => {
      this.isLoggedInRtm = !0, this.emit(RtmEventType.LOGGED_IN);
    }).catch((a) => {
      console.log("AgoraRTM client login failure", a);
    });
  }
  async logout() {
    this.isLoggedInRtm && this.client && await this.client.logout().then(() => {
      this.isLoggedInRtm = !1, this.emit(RtmEventType.LOGGED_OUT);
    });
  }
  async joinChannel(t) {
    const a = this.client.createChannel(t);
    this.channels[t] = {
      channel: a,
      joined: !1
    }, this.subscribeChannelEvents(t), a.join().then(() => {
      this.channels[t].joined = !0, this.emit(RtmEventType.JOINED_CHANNEL, t);
    }).catch((n) => {
      console.error(n);
    });
  }
  async leaveChannel(t) {
    !this.channels[t] || this.channels[t] && !this.channels[t].joined || this.channels[t].channel.leave().then(() => {
      this.channels[t] && (this.channels[t].joined = !1, delete this.channels[t], this.emit(RtmEventType.LEFT_CHANNEL, t));
    }).catch((a) => {
      console.error(a);
    });
  }
  subscribeChannelEvents(t, a = RTM_CHANNEL_CONFIGS.CHANNEL_EVENTS, n = RTM_CHANNEL_CONFIGS.USE_WORKER) {
    a.forEach((s) => {
      this.channels[t].channel.on(s, async (...o) => {
        const u = s;
        if (this.emit(RtmChannelEventType[u], t, ...o), n) {
          const l = { channelName: t, args: o };
          this.rtmWorker.postMessage({
            type: TYPE_WORKERS.RECEIVED_NEW_MESSAGE,
            data: l
          });
        }
      });
    });
  }
  async sendMessageToChannel(t, a) {
    var s, o;
    let n = !1;
    return this.limitSenderConfigs.applyLimit && this.limitSenderConfigs.limitOnMessageTypes.includes(t[this.options.messageTypeKey]) && !this.intervalLimitSenderId && !this.isMuting && (this.intervalLimitSenderId = window.setInterval(() => {
      this.currentTotalMessages = 0, this.clearLimitSender();
    }, (this.limitSenderConfigs.rangeTime || DEFAULT_LIMIT_SENDER.RANGE_TIME) * 1e3)), this.limitSenderConfigs.applyLimit && this.limitSenderConfigs.limitOnMessageTypes.includes(t[this.options.messageTypeKey]) && this.isMuting ? this.emit(RtmEventType.SENDER_LIMIT, this.remainingMutingTime) : n = await this.sendChannelMessage(JSON.stringify(t), a || Object.keys(this.channels)[0]), n && (((s = this.limitSenderConfigs) == null ? void 0 : s.applyLimit) && ((o = this.limitSenderConfigs) == null ? void 0 : o.limitOnMessageTypes.includes(t[this.options.messageTypeKey])) && (this.currentTotalMessages++, this.currentTotalMessages >= this.limitSenderConfigs.maximumMessages && this.createMuteSenderJob()), this.rtmWorker.postMessage({
      type: TYPE_WORKERS.SENT_NEW_MESSAGE,
      data: t
    }), this.emit(RtmEventType.SENT_MESSAGE, t)), n;
  }
  async sendChannelMessage(t, a) {
    return !this.channels[a] || !this.channels[a].joined ? !1 : this.waitDuration < 0 ? (this.emit(RtmEventType.REJECT_SENDING_MESSAGE), !1) : this.waitDuration === 0 ? (this.channels[a].channel.sendMessage({ text: t }), !0) : (this.waitingTime = !0, this.emit(RtmEventType.REJECT_SENDING_MESSAGE), setTimeout(async () => {
      this.waitingTime = !1;
    }, this.waitDuration * 1e3), !1);
  }
  sendPeerMessage(t, a) {
    this.client.sendMessageToPeer({ text: t }, a);
  }
  queryPeersOnlineStatus(t) {
    this.client.queryPeersOnlineStatus([t]);
  }
  clearLimitSender() {
    clearInterval(this.intervalLimitSenderId), this.intervalLimitSenderId = 0;
  }
  createMuteSenderJob() {
    this.isMuting = !0, this.remainingMutingTime = this.limitSenderConfigs.muteTime || DEFAULT_LIMIT_SENDER.MUTE_TIME, this.emit(RtmEventType.UPDATE_REMAINING_MUTED_TIME, this.remainingMutingTime), this.emit(RtmEventType.SENDER_LIMIT, this.remainingMutingTime), this.setTimeoutMuteSenderId || (this.setTimeoutMuteSenderId = window.setInterval(() => {
      this.remainingMutingTime--, this.remainingMutingTime <= 0 && this.clearMuteSenderJob(), this.emit(RtmEventType.UPDATE_REMAINING_MUTED_TIME, this.remainingMutingTime);
    }, 1e3));
  }
  clearMuteSenderJob() {
    this.isMuting = !1, clearTimeout(this.setTimeoutMuteSenderId), this.setTimeoutMuteSenderId = 0;
  }
  async destroy() {
    if (this.clearMuteSenderJob(), this.clearLimitSender(), Object.keys(this.channels).forEach((t) => {
      this.leaveChannel(t);
    }), this.rtmWorker)
      try {
        await this.rtmWorker.terminate();
      } catch (t) {
        console.log(t);
      }
  }
}
var PlayerEventType;
(function(r) {
  r.READY = "READY", r.DURATION_CHANGED = "DURATION_CHANGED", r.CAN_PLAY = "CAN_PLAY", r.LOADED = "LOADED", r.TIME_UPDATE = "TIME_UPDATE", r.ENDED = "ENDED", r.STATE_CHANGED = "STATE_CHANGED", r.QUALITY_CHANGED = "QUALITY_CHANGED";
})(PlayerEventType || (PlayerEventType = {}));
var win;
typeof window < "u" ? win = window : typeof commonjsGlobal < "u" ? win = commonjsGlobal : typeof self < "u" ? win = self : win = {};
var window_1 = win;
const __viteBrowserExternal = {}, __viteBrowserExternal$1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: __viteBrowserExternal
}, Symbol.toStringTag, { value: "Module" })), require$$0 = /* @__PURE__ */ getAugmentedNamespace(__viteBrowserExternal$1);
var topLevel = typeof commonjsGlobal < "u" ? commonjsGlobal : typeof window < "u" ? window : {}, minDoc = require$$0, doccy;
typeof document < "u" ? doccy = document : (doccy = topLevel["__GLOBAL_DOCUMENT_CACHE@4"], doccy || (doccy = topLevel["__GLOBAL_DOCUMENT_CACHE@4"] = minDoc));
var document_1 = doccy;
function _extends$2() {
  return _extends$2 = Object.assign ? Object.assign.bind() : function(r) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var a in t)
        Object.prototype.hasOwnProperty.call(t, a) && (r[a] = t[a]);
    }
    return r;
  }, _extends$2.apply(this, arguments);
}
const _extends$3 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: _extends$2
}, Symbol.toStringTag, { value: "Module" }));
var keycode$1 = { exports: {} };
(function(r, e) {
  function t(l) {
    if (l && typeof l == "object") {
      var f = l.which || l.keyCode || l.charCode;
      f && (l = f);
    }
    if (typeof l == "number")
      return o[l];
    var d = String(l), h = a[d.toLowerCase()];
    if (h)
      return h;
    var h = n[d.toLowerCase()];
    if (h)
      return h;
    if (d.length === 1)
      return d.charCodeAt(0);
  }
  t.isEventKey = function(f, d) {
    if (f && typeof f == "object") {
      var h = f.which || f.keyCode || f.charCode;
      if (h == null)
        return !1;
      if (typeof d == "string") {
        var p = a[d.toLowerCase()];
        if (p)
          return p === h;
        var p = n[d.toLowerCase()];
        if (p)
          return p === h;
      } else if (typeof d == "number")
        return d === h;
      return !1;
    }
  }, e = r.exports = t;
  var a = e.code = e.codes = {
    backspace: 8,
    tab: 9,
    enter: 13,
    shift: 16,
    ctrl: 17,
    alt: 18,
    "pause/break": 19,
    "caps lock": 20,
    esc: 27,
    space: 32,
    "page up": 33,
    "page down": 34,
    end: 35,
    home: 36,
    left: 37,
    up: 38,
    right: 39,
    down: 40,
    insert: 45,
    delete: 46,
    command: 91,
    "left command": 91,
    "right command": 93,
    "numpad *": 106,
    "numpad +": 107,
    "numpad -": 109,
    "numpad .": 110,
    "numpad /": 111,
    "num lock": 144,
    "scroll lock": 145,
    "my computer": 182,
    "my calculator": 183,
    ";": 186,
    "=": 187,
    ",": 188,
    "-": 189,
    ".": 190,
    "/": 191,
    "`": 192,
    "[": 219,
    "\\": 220,
    "]": 221,
    "'": 222
  }, n = e.aliases = {
    windows: 91,
    "\u21E7": 16,
    "\u2325": 18,
    "\u2303": 17,
    "\u2318": 91,
    ctl: 17,
    control: 17,
    option: 18,
    pause: 19,
    break: 19,
    caps: 20,
    return: 13,
    escape: 27,
    spc: 32,
    spacebar: 32,
    pgup: 33,
    pgdn: 34,
    ins: 45,
    del: 46,
    cmd: 91
  };
  /*!
   * Programatically add the following
   */
  for (s = 97; s < 123; s++)
    a[String.fromCharCode(s)] = s - 32;
  for (var s = 48; s < 58; s++)
    a[s - 48] = s;
  for (s = 1; s < 13; s++)
    a["f" + s] = s + 111;
  for (s = 0; s < 10; s++)
    a["numpad " + s] = s + 96;
  var o = e.names = e.title = {};
  for (s in a)
    o[a[s]] = s;
  for (var u in n)
    a[u] = n[u];
})(keycode$1, keycode$1.exports);
const keycode = keycode$1.exports;
function _assertThisInitialized$1(r) {
  if (r === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return r;
}
function _setPrototypeOf(r, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(a, n) {
    return a.__proto__ = n, a;
  }, _setPrototypeOf(r, e);
}
function _inheritsLoose$1(r, e) {
  r.prototype = Object.create(e.prototype), r.prototype.constructor = r, _setPrototypeOf(r, e);
}
var tuple = SafeParseTuple;
function SafeParseTuple(r, e) {
  var t, a = null;
  try {
    t = JSON.parse(r, e);
  } catch (n) {
    a = n;
  }
  return [a, t];
}
var lib = { exports: {} };
const require$$1 = /* @__PURE__ */ getAugmentedNamespace(_extends$3);
var isFunction_1 = isFunction$1, toString$1 = Object.prototype.toString;
function isFunction$1(r) {
  if (!r)
    return !1;
  var e = toString$1.call(r);
  return e === "[object Function]" || typeof r == "function" && e !== "[object RegExp]" || typeof window < "u" && (r === window.setTimeout || r === window.alert || r === window.confirm || r === window.prompt);
}
var window$3 = window_1, httpResponseHandler = function r(e, t) {
  return t === void 0 && (t = !1), function(a, n, s) {
    if (a) {
      e(a);
      return;
    }
    if (n.statusCode >= 400 && n.statusCode <= 599) {
      var o = s;
      if (t)
        if (window$3.TextDecoder) {
          var u = getCharset(n.headers && n.headers["content-type"]);
          try {
            o = new TextDecoder(u).decode(s);
          } catch {
          }
        } else
          o = String.fromCharCode.apply(null, new Uint8Array(s));
      e({
        cause: o
      });
      return;
    }
    e(null, s);
  };
};
function getCharset(r) {
  return r === void 0 && (r = ""), r.toLowerCase().split(";").reduce(function(e, t) {
    var a = t.split("="), n = a[0], s = a[1];
    return n.trim() === "charset" ? s.trim() : e;
  }, "utf-8");
}
var httpHandler = httpResponseHandler, window$2 = window_1, _extends$1 = require$$1, isFunction = isFunction_1;
createXHR.httpHandler = httpHandler;
/**
 * @license
 * slighly modified parse-headers 2.0.2 <https://github.com/kesla/parse-headers/>
 * Copyright (c) 2014 David Björklund
 * Available under the MIT license
 * <https://github.com/kesla/parse-headers/blob/master/LICENCE>
 */
var parseHeaders = function r(e) {
  var t = {};
  return e && e.trim().split(`
`).forEach(function(a) {
    var n = a.indexOf(":"), s = a.slice(0, n).trim().toLowerCase(), o = a.slice(n + 1).trim();
    typeof t[s] > "u" ? t[s] = o : Array.isArray(t[s]) ? t[s].push(o) : t[s] = [t[s], o];
  }), t;
};
lib.exports = createXHR;
lib.exports.default = createXHR;
createXHR.XMLHttpRequest = window$2.XMLHttpRequest || noop$1;
createXHR.XDomainRequest = "withCredentials" in new createXHR.XMLHttpRequest() ? createXHR.XMLHttpRequest : window$2.XDomainRequest;
forEachArray(["get", "put", "post", "patch", "head", "delete"], function(r) {
  createXHR[r === "delete" ? "del" : r] = function(e, t, a) {
    return t = initParams(e, t, a), t.method = r.toUpperCase(), _createXHR(t);
  };
});
function forEachArray(r, e) {
  for (var t = 0; t < r.length; t++)
    e(r[t]);
}
function isEmpty(r) {
  for (var e in r)
    if (r.hasOwnProperty(e))
      return !1;
  return !0;
}
function initParams(r, e, t) {
  var a = r;
  return isFunction(e) ? (t = e, typeof r == "string" && (a = {
    uri: r
  })) : a = _extends$1({}, e, {
    uri: r
  }), a.callback = t, a;
}
function createXHR(r, e, t) {
  return e = initParams(r, e, t), _createXHR(e);
}
function _createXHR(r) {
  if (typeof r.callback > "u")
    throw new Error("callback argument missing");
  var e = !1, t = function(B, L, G) {
    e || (e = !0, r.callback(B, L, G));
  };
  function a() {
    u.readyState === 4 && setTimeout(o, 0);
  }
  function n() {
    var k = void 0;
    if (u.response ? k = u.response : k = u.responseText || getXml(u), w)
      try {
        k = JSON.parse(k);
      } catch {
      }
    return k;
  }
  function s(k) {
    return clearTimeout(S), k instanceof Error || (k = new Error("" + (k || "Unknown XMLHttpRequest Error"))), k.statusCode = 0, t(k, O);
  }
  function o() {
    if (!f) {
      var k;
      clearTimeout(S), r.useXDR && u.status === void 0 ? k = 200 : k = u.status === 1223 ? 204 : u.status;
      var B = O, L = null;
      return k !== 0 ? (B = {
        body: n(),
        statusCode: k,
        method: h,
        headers: {},
        url: d,
        rawRequest: u
      }, u.getAllResponseHeaders && (B.headers = parseHeaders(u.getAllResponseHeaders()))) : L = new Error("Internal XMLHttpRequest Error"), t(L, B, B.body);
    }
  }
  var u = r.xhr || null;
  u || (r.cors || r.useXDR ? u = new createXHR.XDomainRequest() : u = new createXHR.XMLHttpRequest());
  var l, f, d = u.url = r.uri || r.url, h = u.method = r.method || "GET", p = r.body || r.data, m = u.headers = r.headers || {}, _ = !!r.sync, w = !1, S, O = {
    body: void 0,
    headers: {},
    statusCode: 0,
    method: h,
    url: d,
    rawRequest: u
  };
  if ("json" in r && r.json !== !1 && (w = !0, m.accept || m.Accept || (m.Accept = "application/json"), h !== "GET" && h !== "HEAD" && (m["content-type"] || m["Content-Type"] || (m["Content-Type"] = "application/json"), p = JSON.stringify(r.json === !0 ? p : r.json))), u.onreadystatechange = a, u.onload = o, u.onerror = s, u.onprogress = function() {
  }, u.onabort = function() {
    f = !0;
  }, u.ontimeout = s, u.open(h, d, !_, r.username, r.password), _ || (u.withCredentials = !!r.withCredentials), !_ && r.timeout > 0 && (S = setTimeout(function() {
    if (!f) {
      f = !0, u.abort("timeout");
      var k = new Error("XMLHttpRequest timeout");
      k.code = "ETIMEDOUT", s(k);
    }
  }, r.timeout)), u.setRequestHeader)
    for (l in m)
      m.hasOwnProperty(l) && u.setRequestHeader(l, m[l]);
  else if (r.headers && !isEmpty(r.headers))
    throw new Error("Headers cannot be set on an XDomainRequest object");
  return "responseType" in r && (u.responseType = r.responseType), "beforeSend" in r && typeof r.beforeSend == "function" && r.beforeSend(u), u.send(p || null), u;
}
function getXml(r) {
  try {
    if (r.responseType === "document")
      return r.responseXML;
    var e = r.responseXML && r.responseXML.documentElement.nodeName === "parsererror";
    if (r.responseType === "" && !e)
      return r.responseXML;
  } catch {
  }
  return null;
}
function noop$1() {
}
var browserIndex = { exports: {} }, document$1 = document_1, _objCreate = Object.create || function() {
  function r() {
  }
  return function(e) {
    if (arguments.length !== 1)
      throw new Error("Object.create shim only accepts one parameter.");
    return r.prototype = e, new r();
  };
}();
function ParsingError(r, e) {
  this.name = "ParsingError", this.code = r.code, this.message = e || r.message;
}
ParsingError.prototype = _objCreate(Error.prototype);
ParsingError.prototype.constructor = ParsingError;
ParsingError.Errors = {
  BadSignature: {
    code: 0,
    message: "Malformed WebVTT signature."
  },
  BadTimeStamp: {
    code: 1,
    message: "Malformed time stamp."
  }
};
function parseTimeStamp(r) {
  function e(a, n, s, o) {
    return (a | 0) * 3600 + (n | 0) * 60 + (s | 0) + (o | 0) / 1e3;
  }
  var t = r.match(/^(\d+):(\d{1,2})(:\d{1,2})?\.(\d{3})/);
  return t ? t[3] ? e(t[1], t[2], t[3].replace(":", ""), t[4]) : t[1] > 59 ? e(t[1], t[2], 0, t[4]) : e(0, t[1], t[2], t[4]) : null;
}
function Settings() {
  this.values = _objCreate(null);
}
Settings.prototype = {
  set: function(r, e) {
    !this.get(r) && e !== "" && (this.values[r] = e);
  },
  get: function(r, e, t) {
    return t ? this.has(r) ? this.values[r] : e[t] : this.has(r) ? this.values[r] : e;
  },
  has: function(r) {
    return r in this.values;
  },
  alt: function(r, e, t) {
    for (var a = 0; a < t.length; ++a)
      if (e === t[a]) {
        this.set(r, e);
        break;
      }
  },
  integer: function(r, e) {
    /^-?\d+$/.test(e) && this.set(r, parseInt(e, 10));
  },
  percent: function(r, e) {
    return e.match(/^([\d]{1,3})(\.[\d]*)?%$/) && (e = parseFloat(e), e >= 0 && e <= 100) ? (this.set(r, e), !0) : !1;
  }
};
function parseOptions(r, e, t, a) {
  var n = a ? r.split(a) : [r];
  for (var s in n)
    if (typeof n[s] == "string") {
      var o = n[s].split(t);
      if (o.length === 2) {
        var u = o[0].trim(), l = o[1].trim();
        e(u, l);
      }
    }
}
function parseCue(r, e, t) {
  var a = r;
  function n() {
    var u = parseTimeStamp(r);
    if (u === null)
      throw new ParsingError(
        ParsingError.Errors.BadTimeStamp,
        "Malformed timestamp: " + a
      );
    return r = r.replace(/^[^\sa-zA-Z-]+/, ""), u;
  }
  function s(u, l) {
    var f = new Settings();
    parseOptions(u, function(d, h) {
      switch (d) {
        case "region":
          for (var p = t.length - 1; p >= 0; p--)
            if (t[p].id === h) {
              f.set(d, t[p].region);
              break;
            }
          break;
        case "vertical":
          f.alt(d, h, ["rl", "lr"]);
          break;
        case "line":
          var m = h.split(","), _ = m[0];
          f.integer(d, _), f.percent(d, _) && f.set("snapToLines", !1), f.alt(d, _, ["auto"]), m.length === 2 && f.alt("lineAlign", m[1], ["start", "center", "end"]);
          break;
        case "position":
          m = h.split(","), f.percent(d, m[0]), m.length === 2 && f.alt("positionAlign", m[1], ["start", "center", "end"]);
          break;
        case "size":
          f.percent(d, h);
          break;
        case "align":
          f.alt(d, h, ["start", "center", "end", "left", "right"]);
          break;
      }
    }, /:/, /\s/), l.region = f.get("region", null), l.vertical = f.get("vertical", "");
    try {
      l.line = f.get("line", "auto");
    } catch {
    }
    l.lineAlign = f.get("lineAlign", "start"), l.snapToLines = f.get("snapToLines", !0), l.size = f.get("size", 100);
    try {
      l.align = f.get("align", "center");
    } catch {
      l.align = f.get("align", "middle");
    }
    try {
      l.position = f.get("position", "auto");
    } catch {
      l.position = f.get("position", {
        start: 0,
        left: 0,
        center: 50,
        middle: 50,
        end: 100,
        right: 100
      }, l.align);
    }
    l.positionAlign = f.get("positionAlign", {
      start: "start",
      left: "start",
      center: "center",
      middle: "center",
      end: "end",
      right: "end"
    }, l.align);
  }
  function o() {
    r = r.replace(/^\s+/, "");
  }
  if (o(), e.startTime = n(), o(), r.substr(0, 3) !== "-->")
    throw new ParsingError(
      ParsingError.Errors.BadTimeStamp,
      "Malformed time stamp (time stamps must be separated by '-->'): " + a
    );
  r = r.substr(3), o(), e.endTime = n(), o(), s(r, e);
}
var TEXTAREA_ELEMENT = document$1.createElement && document$1.createElement("textarea"), TAG_NAME = {
  c: "span",
  i: "i",
  b: "b",
  u: "u",
  ruby: "ruby",
  rt: "rt",
  v: "span",
  lang: "span"
}, DEFAULT_COLOR_CLASS = {
  white: "rgba(255,255,255,1)",
  lime: "rgba(0,255,0,1)",
  cyan: "rgba(0,255,255,1)",
  red: "rgba(255,0,0,1)",
  yellow: "rgba(255,255,0,1)",
  magenta: "rgba(255,0,255,1)",
  blue: "rgba(0,0,255,1)",
  black: "rgba(0,0,0,1)"
}, TAG_ANNOTATION = {
  v: "title",
  lang: "lang"
}, NEEDS_PARENT = {
  rt: "ruby"
};
function parseContent(r, e) {
  function t() {
    if (!e)
      return null;
    function _(S) {
      return e = e.substr(S.length), S;
    }
    var w = e.match(/^([^<]*)(<[^>]*>?)?/);
    return _(w[1] ? w[1] : w[2]);
  }
  function a(_) {
    return TEXTAREA_ELEMENT.innerHTML = _, _ = TEXTAREA_ELEMENT.textContent, TEXTAREA_ELEMENT.textContent = "", _;
  }
  function n(_, w) {
    return !NEEDS_PARENT[w.localName] || NEEDS_PARENT[w.localName] === _.localName;
  }
  function s(_, w) {
    var S = TAG_NAME[_];
    if (!S)
      return null;
    var O = r.document.createElement(S), k = TAG_ANNOTATION[_];
    return k && w && (O[k] = w.trim()), O;
  }
  for (var o = r.document.createElement("div"), u = o, l, f = []; (l = t()) !== null; ) {
    if (l[0] === "<") {
      if (l[1] === "/") {
        f.length && f[f.length - 1] === l.substr(2).replace(">", "") && (f.pop(), u = u.parentNode);
        continue;
      }
      var d = parseTimeStamp(l.substr(1, l.length - 2)), h;
      if (d) {
        h = r.document.createProcessingInstruction("timestamp", d), u.appendChild(h);
        continue;
      }
      var p = l.match(/^<([^.\s/0-9>]+)(\.[^\s\\>]+)?([^>\\]+)?(\\?)>?$/);
      if (!p || (h = s(p[1], p[3]), !h) || !n(u, h))
        continue;
      if (p[2]) {
        var m = p[2].split(".");
        m.forEach(function(_) {
          var w = /^bg_/.test(_), S = w ? _.slice(3) : _;
          if (DEFAULT_COLOR_CLASS.hasOwnProperty(S)) {
            var O = w ? "background-color" : "color", k = DEFAULT_COLOR_CLASS[S];
            h.style[O] = k;
          }
        }), h.className = m.join(" ");
      }
      f.push(p[1]), u.appendChild(h), u = h;
      continue;
    }
    u.appendChild(r.document.createTextNode(a(l)));
  }
  return o;
}
var strongRTLRanges = [
  [1470, 1470],
  [1472, 1472],
  [1475, 1475],
  [1478, 1478],
  [1488, 1514],
  [1520, 1524],
  [1544, 1544],
  [1547, 1547],
  [1549, 1549],
  [1563, 1563],
  [1566, 1610],
  [1645, 1647],
  [1649, 1749],
  [1765, 1766],
  [1774, 1775],
  [1786, 1805],
  [1807, 1808],
  [1810, 1839],
  [1869, 1957],
  [1969, 1969],
  [1984, 2026],
  [2036, 2037],
  [2042, 2042],
  [2048, 2069],
  [2074, 2074],
  [2084, 2084],
  [2088, 2088],
  [2096, 2110],
  [2112, 2136],
  [2142, 2142],
  [2208, 2208],
  [2210, 2220],
  [8207, 8207],
  [64285, 64285],
  [64287, 64296],
  [64298, 64310],
  [64312, 64316],
  [64318, 64318],
  [64320, 64321],
  [64323, 64324],
  [64326, 64449],
  [64467, 64829],
  [64848, 64911],
  [64914, 64967],
  [65008, 65020],
  [65136, 65140],
  [65142, 65276],
  [67584, 67589],
  [67592, 67592],
  [67594, 67637],
  [67639, 67640],
  [67644, 67644],
  [67647, 67669],
  [67671, 67679],
  [67840, 67867],
  [67872, 67897],
  [67903, 67903],
  [67968, 68023],
  [68030, 68031],
  [68096, 68096],
  [68112, 68115],
  [68117, 68119],
  [68121, 68147],
  [68160, 68167],
  [68176, 68184],
  [68192, 68223],
  [68352, 68405],
  [68416, 68437],
  [68440, 68466],
  [68472, 68479],
  [68608, 68680],
  [126464, 126467],
  [126469, 126495],
  [126497, 126498],
  [126500, 126500],
  [126503, 126503],
  [126505, 126514],
  [126516, 126519],
  [126521, 126521],
  [126523, 126523],
  [126530, 126530],
  [126535, 126535],
  [126537, 126537],
  [126539, 126539],
  [126541, 126543],
  [126545, 126546],
  [126548, 126548],
  [126551, 126551],
  [126553, 126553],
  [126555, 126555],
  [126557, 126557],
  [126559, 126559],
  [126561, 126562],
  [126564, 126564],
  [126567, 126570],
  [126572, 126578],
  [126580, 126583],
  [126585, 126588],
  [126590, 126590],
  [126592, 126601],
  [126603, 126619],
  [126625, 126627],
  [126629, 126633],
  [126635, 126651],
  [1114109, 1114109]
];
function isStrongRTLChar(r) {
  for (var e = 0; e < strongRTLRanges.length; e++) {
    var t = strongRTLRanges[e];
    if (r >= t[0] && r <= t[1])
      return !0;
  }
  return !1;
}
function determineBidi(r) {
  var e = [], t = "", a;
  if (!r || !r.childNodes)
    return "ltr";
  function n(u, l) {
    for (var f = l.childNodes.length - 1; f >= 0; f--)
      u.push(l.childNodes[f]);
  }
  function s(u) {
    if (!u || !u.length)
      return null;
    var l = u.pop(), f = l.textContent || l.innerText;
    if (f) {
      var d = f.match(/^.*(\n|\r)/);
      return d ? (u.length = 0, d[0]) : f;
    }
    if (l.tagName === "ruby")
      return s(u);
    if (l.childNodes)
      return n(u, l), s(u);
  }
  for (n(e, r); t = s(e); )
    for (var o = 0; o < t.length; o++)
      if (a = t.charCodeAt(o), isStrongRTLChar(a))
        return "rtl";
  return "ltr";
}
function computeLinePos(r) {
  if (typeof r.line == "number" && (r.snapToLines || r.line >= 0 && r.line <= 100))
    return r.line;
  if (!r.track || !r.track.textTrackList || !r.track.textTrackList.mediaElement)
    return -1;
  for (var e = r.track, t = e.textTrackList, a = 0, n = 0; n < t.length && t[n] !== e; n++)
    t[n].mode === "showing" && a++;
  return ++a * -1;
}
function StyleBox() {
}
StyleBox.prototype.applyStyles = function(r, e) {
  e = e || this.div;
  for (var t in r)
    r.hasOwnProperty(t) && (e.style[t] = r[t]);
};
StyleBox.prototype.formatStyle = function(r, e) {
  return r === 0 ? 0 : r + e;
};
function CueStyleBox(r, e, t) {
  StyleBox.call(this), this.cue = e, this.cueDiv = parseContent(r, e.text);
  var a = {
    color: "rgba(255, 255, 255, 1)",
    backgroundColor: "rgba(0, 0, 0, 0.8)",
    position: "relative",
    left: 0,
    right: 0,
    top: 0,
    bottom: 0,
    display: "inline",
    writingMode: e.vertical === "" ? "horizontal-tb" : e.vertical === "lr" ? "vertical-lr" : "vertical-rl",
    unicodeBidi: "plaintext"
  };
  this.applyStyles(a, this.cueDiv), this.div = r.document.createElement("div"), a = {
    direction: determineBidi(this.cueDiv),
    writingMode: e.vertical === "" ? "horizontal-tb" : e.vertical === "lr" ? "vertical-lr" : "vertical-rl",
    unicodeBidi: "plaintext",
    textAlign: e.align === "middle" ? "center" : e.align,
    font: t.font,
    whiteSpace: "pre-line",
    position: "absolute"
  }, this.applyStyles(a), this.div.appendChild(this.cueDiv);
  var n = 0;
  switch (e.positionAlign) {
    case "start":
      n = e.position;
      break;
    case "center":
      n = e.position - e.size / 2;
      break;
    case "end":
      n = e.position - e.size;
      break;
  }
  e.vertical === "" ? this.applyStyles({
    left: this.formatStyle(n, "%"),
    width: this.formatStyle(e.size, "%")
  }) : this.applyStyles({
    top: this.formatStyle(n, "%"),
    height: this.formatStyle(e.size, "%")
  }), this.move = function(s) {
    this.applyStyles({
      top: this.formatStyle(s.top, "px"),
      bottom: this.formatStyle(s.bottom, "px"),
      left: this.formatStyle(s.left, "px"),
      right: this.formatStyle(s.right, "px"),
      height: this.formatStyle(s.height, "px"),
      width: this.formatStyle(s.width, "px")
    });
  };
}
CueStyleBox.prototype = _objCreate(StyleBox.prototype);
CueStyleBox.prototype.constructor = CueStyleBox;
function BoxPosition(r) {
  var e, t, a, n;
  if (r.div) {
    t = r.div.offsetHeight, a = r.div.offsetWidth, n = r.div.offsetTop;
    var s = (s = r.div.childNodes) && (s = s[0]) && s.getClientRects && s.getClientRects();
    r = r.div.getBoundingClientRect(), e = s ? Math.max(s[0] && s[0].height || 0, r.height / s.length) : 0;
  }
  this.left = r.left, this.right = r.right, this.top = r.top || n, this.height = r.height || t, this.bottom = r.bottom || n + (r.height || t), this.width = r.width || a, this.lineHeight = e !== void 0 ? e : r.lineHeight;
}
BoxPosition.prototype.move = function(r, e) {
  switch (e = e !== void 0 ? e : this.lineHeight, r) {
    case "+x":
      this.left += e, this.right += e;
      break;
    case "-x":
      this.left -= e, this.right -= e;
      break;
    case "+y":
      this.top += e, this.bottom += e;
      break;
    case "-y":
      this.top -= e, this.bottom -= e;
      break;
  }
};
BoxPosition.prototype.overlaps = function(r) {
  return this.left < r.right && this.right > r.left && this.top < r.bottom && this.bottom > r.top;
};
BoxPosition.prototype.overlapsAny = function(r) {
  for (var e = 0; e < r.length; e++)
    if (this.overlaps(r[e]))
      return !0;
  return !1;
};
BoxPosition.prototype.within = function(r) {
  return this.top >= r.top && this.bottom <= r.bottom && this.left >= r.left && this.right <= r.right;
};
BoxPosition.prototype.overlapsOppositeAxis = function(r, e) {
  switch (e) {
    case "+x":
      return this.left < r.left;
    case "-x":
      return this.right > r.right;
    case "+y":
      return this.top < r.top;
    case "-y":
      return this.bottom > r.bottom;
  }
};
BoxPosition.prototype.intersectPercentage = function(r) {
  var e = Math.max(0, Math.min(this.right, r.right) - Math.max(this.left, r.left)), t = Math.max(0, Math.min(this.bottom, r.bottom) - Math.max(this.top, r.top)), a = e * t;
  return a / (this.height * this.width);
};
BoxPosition.prototype.toCSSCompatValues = function(r) {
  return {
    top: this.top - r.top,
    bottom: r.bottom - this.bottom,
    left: this.left - r.left,
    right: r.right - this.right,
    height: this.height,
    width: this.width
  };
};
BoxPosition.getSimpleBoxPosition = function(r) {
  var e = r.div ? r.div.offsetHeight : r.tagName ? r.offsetHeight : 0, t = r.div ? r.div.offsetWidth : r.tagName ? r.offsetWidth : 0, a = r.div ? r.div.offsetTop : r.tagName ? r.offsetTop : 0;
  r = r.div ? r.div.getBoundingClientRect() : r.tagName ? r.getBoundingClientRect() : r;
  var n = {
    left: r.left,
    right: r.right,
    top: r.top || a,
    height: r.height || e,
    bottom: r.bottom || a + (r.height || e),
    width: r.width || t
  };
  return n;
};
function moveBoxToLinePosition(r, e, t, a) {
  function n(S, O) {
    for (var k, B = new BoxPosition(S), L = 1, G = 0; G < O.length; G++) {
      for (; S.overlapsOppositeAxis(t, O[G]) || S.within(t) && S.overlapsAny(a); )
        S.move(O[G]);
      if (S.within(t))
        return S;
      var _r = S.intersectPercentage(t);
      L > _r && (k = new BoxPosition(S), L = _r), S = new BoxPosition(B);
    }
    return k || B;
  }
  var s = new BoxPosition(e), o = e.cue, u = computeLinePos(o), l = [];
  if (o.snapToLines) {
    var f;
    switch (o.vertical) {
      case "":
        l = ["+y", "-y"], f = "height";
        break;
      case "rl":
        l = ["+x", "-x"], f = "width";
        break;
      case "lr":
        l = ["-x", "+x"], f = "width";
        break;
    }
    var d = s.lineHeight, h = d * Math.round(u), p = t[f] + d, m = l[0];
    Math.abs(h) > p && (h = h < 0 ? -1 : 1, h *= Math.ceil(p / d) * d), u < 0 && (h += o.vertical === "" ? t.height : t.width, l = l.reverse()), s.move(m, h);
  } else {
    var _ = s.lineHeight / t.height * 100;
    switch (o.lineAlign) {
      case "center":
        u -= _ / 2;
        break;
      case "end":
        u -= _;
        break;
    }
    switch (o.vertical) {
      case "":
        e.applyStyles({
          top: e.formatStyle(u, "%")
        });
        break;
      case "rl":
        e.applyStyles({
          left: e.formatStyle(u, "%")
        });
        break;
      case "lr":
        e.applyStyles({
          right: e.formatStyle(u, "%")
        });
        break;
    }
    l = ["+y", "-x", "+x", "-y"], s = new BoxPosition(e);
  }
  var w = n(s, l);
  e.move(w.toCSSCompatValues(t));
}
function WebVTT$1() {
}
WebVTT$1.StringDecoder = function() {
  return {
    decode: function(r) {
      if (!r)
        return "";
      if (typeof r != "string")
        throw new Error("Error - expected string data.");
      return decodeURIComponent(encodeURIComponent(r));
    }
  };
};
WebVTT$1.convertCueToDOMTree = function(r, e) {
  return !r || !e ? null : parseContent(r, e);
};
var FONT_SIZE_PERCENT = 0.05, FONT_STYLE = "sans-serif", CUE_BACKGROUND_PADDING = "1.5%";
WebVTT$1.processCues = function(r, e, t) {
  if (!r || !e || !t)
    return null;
  for (; t.firstChild; )
    t.removeChild(t.firstChild);
  var a = r.document.createElement("div");
  a.style.position = "absolute", a.style.left = "0", a.style.right = "0", a.style.top = "0", a.style.bottom = "0", a.style.margin = CUE_BACKGROUND_PADDING, t.appendChild(a);
  function n(d) {
    for (var h = 0; h < d.length; h++)
      if (d[h].hasBeenReset || !d[h].displayState)
        return !0;
    return !1;
  }
  if (!n(e)) {
    for (var s = 0; s < e.length; s++)
      a.appendChild(e[s].displayState);
    return;
  }
  var o = [], u = BoxPosition.getSimpleBoxPosition(a), l = Math.round(u.height * FONT_SIZE_PERCENT * 100) / 100, f = {
    font: l + "px " + FONT_STYLE
  };
  (function() {
    for (var d, h, p = 0; p < e.length; p++)
      h = e[p], d = new CueStyleBox(r, h, f), a.appendChild(d.div), moveBoxToLinePosition(r, d, u, o), h.displayState = d.div, o.push(BoxPosition.getSimpleBoxPosition(d));
  })();
};
WebVTT$1.Parser = function(r, e, t) {
  t || (t = e, e = {}), e || (e = {}), this.window = r, this.vttjs = e, this.state = "INITIAL", this.buffer = "", this.decoder = t || new TextDecoder("utf8"), this.regionList = [];
};
WebVTT$1.Parser.prototype = {
  reportOrThrowError: function(r) {
    if (r instanceof ParsingError)
      this.onparsingerror && this.onparsingerror(r);
    else
      throw r;
  },
  parse: function(r) {
    var e = this;
    r && (e.buffer += e.decoder.decode(r, { stream: !0 }));
    function t() {
      for (var d = e.buffer, h = 0; h < d.length && d[h] !== "\r" && d[h] !== `
`; )
        ++h;
      var p = d.substr(0, h);
      return d[h] === "\r" && ++h, d[h] === `
` && ++h, e.buffer = d.substr(h), p;
    }
    function a(d) {
      var h = new Settings();
      if (parseOptions(d, function(m, _) {
        switch (m) {
          case "id":
            h.set(m, _);
            break;
          case "width":
            h.percent(m, _);
            break;
          case "lines":
            h.integer(m, _);
            break;
          case "regionanchor":
          case "viewportanchor":
            var w = _.split(",");
            if (w.length !== 2)
              break;
            var S = new Settings();
            if (S.percent("x", w[0]), S.percent("y", w[1]), !S.has("x") || !S.has("y"))
              break;
            h.set(m + "X", S.get("x")), h.set(m + "Y", S.get("y"));
            break;
          case "scroll":
            h.alt(m, _, ["up"]);
            break;
        }
      }, /=/, /\s/), h.has("id")) {
        var p = new (e.vttjs.VTTRegion || e.window.VTTRegion)();
        p.width = h.get("width", 100), p.lines = h.get("lines", 3), p.regionAnchorX = h.get("regionanchorX", 0), p.regionAnchorY = h.get("regionanchorY", 100), p.viewportAnchorX = h.get("viewportanchorX", 0), p.viewportAnchorY = h.get("viewportanchorY", 100), p.scroll = h.get("scroll", ""), e.onregion && e.onregion(p), e.regionList.push({
          id: h.get("id"),
          region: p
        });
      }
    }
    function n(d) {
      var h = new Settings();
      parseOptions(d, function(p, m) {
        switch (p) {
          case "MPEGT":
            h.integer(p + "S", m);
            break;
          case "LOCA":
            h.set(p + "L", parseTimeStamp(m));
            break;
        }
      }, /[^\d]:/, /,/), e.ontimestampmap && e.ontimestampmap({
        MPEGTS: h.get("MPEGTS"),
        LOCAL: h.get("LOCAL")
      });
    }
    function s(d) {
      d.match(/X-TIMESTAMP-MAP/) ? parseOptions(d, function(h, p) {
        switch (h) {
          case "X-TIMESTAMP-MAP":
            n(p);
            break;
        }
      }, /=/) : parseOptions(d, function(h, p) {
        switch (h) {
          case "Region":
            a(p);
            break;
        }
      }, /:/);
    }
    try {
      var o;
      if (e.state === "INITIAL") {
        if (!/\r\n|\n/.test(e.buffer))
          return this;
        o = t();
        var u = o.match(/^WEBVTT([ \t].*)?$/);
        if (!u || !u[0])
          throw new ParsingError(ParsingError.Errors.BadSignature);
        e.state = "HEADER";
      }
      for (var l = !1; e.buffer; ) {
        if (!/\r\n|\n/.test(e.buffer))
          return this;
        switch (l ? l = !1 : o = t(), e.state) {
          case "HEADER":
            /:/.test(o) ? s(o) : o || (e.state = "ID");
            continue;
          case "NOTE":
            o || (e.state = "ID");
            continue;
          case "ID":
            if (/^NOTE($|[ \t])/.test(o)) {
              e.state = "NOTE";
              break;
            }
            if (!o)
              continue;
            e.cue = new (e.vttjs.VTTCue || e.window.VTTCue)(0, 0, "");
            try {
              e.cue.align = "center";
            } catch {
              e.cue.align = "middle";
            }
            if (e.state = "CUE", o.indexOf("-->") === -1) {
              e.cue.id = o;
              continue;
            }
          case "CUE":
            try {
              parseCue(o, e.cue, e.regionList);
            } catch (d) {
              e.reportOrThrowError(d), e.cue = null, e.state = "BADCUE";
              continue;
            }
            e.state = "CUETEXT";
            continue;
          case "CUETEXT":
            var f = o.indexOf("-->") !== -1;
            if (!o || f && (l = !0)) {
              e.oncue && e.oncue(e.cue), e.cue = null, e.state = "ID";
              continue;
            }
            e.cue.text && (e.cue.text += `
`), e.cue.text += o.replace(/\u2028/g, `
`).replace(/u2029/g, `
`);
            continue;
          case "BADCUE":
            o || (e.state = "ID");
            continue;
        }
      }
    } catch (d) {
      e.reportOrThrowError(d), e.state === "CUETEXT" && e.cue && e.oncue && e.oncue(e.cue), e.cue = null, e.state = e.state === "INITIAL" ? "BADWEBVTT" : "BADCUE";
    }
    return this;
  },
  flush: function() {
    var r = this;
    try {
      if (r.buffer += r.decoder.decode(), (r.cue || r.state === "HEADER") && (r.buffer += `

`, r.parse()), r.state === "INITIAL")
        throw new ParsingError(ParsingError.Errors.BadSignature);
    } catch (e) {
      r.reportOrThrowError(e);
    }
    return r.onflush && r.onflush(), this;
  }
};
var vtt = WebVTT$1, autoKeyword = "auto", directionSetting = {
  "": 1,
  lr: 1,
  rl: 1
}, alignSetting = {
  start: 1,
  center: 1,
  end: 1,
  left: 1,
  right: 1,
  auto: 1,
  "line-left": 1,
  "line-right": 1
};
function findDirectionSetting(r) {
  if (typeof r != "string")
    return !1;
  var e = directionSetting[r.toLowerCase()];
  return e ? r.toLowerCase() : !1;
}
function findAlignSetting(r) {
  if (typeof r != "string")
    return !1;
  var e = alignSetting[r.toLowerCase()];
  return e ? r.toLowerCase() : !1;
}
function VTTCue(r, e, t) {
  this.hasBeenReset = !1;
  var a = "", n = !1, s = r, o = e, u = t, l = null, f = "", d = !0, h = "auto", p = "start", m = "auto", _ = "auto", w = 100, S = "center";
  Object.defineProperties(this, {
    id: {
      enumerable: !0,
      get: function() {
        return a;
      },
      set: function(O) {
        a = "" + O;
      }
    },
    pauseOnExit: {
      enumerable: !0,
      get: function() {
        return n;
      },
      set: function(O) {
        n = !!O;
      }
    },
    startTime: {
      enumerable: !0,
      get: function() {
        return s;
      },
      set: function(O) {
        if (typeof O != "number")
          throw new TypeError("Start time must be set to a number.");
        s = O, this.hasBeenReset = !0;
      }
    },
    endTime: {
      enumerable: !0,
      get: function() {
        return o;
      },
      set: function(O) {
        if (typeof O != "number")
          throw new TypeError("End time must be set to a number.");
        o = O, this.hasBeenReset = !0;
      }
    },
    text: {
      enumerable: !0,
      get: function() {
        return u;
      },
      set: function(O) {
        u = "" + O, this.hasBeenReset = !0;
      }
    },
    region: {
      enumerable: !0,
      get: function() {
        return l;
      },
      set: function(O) {
        l = O, this.hasBeenReset = !0;
      }
    },
    vertical: {
      enumerable: !0,
      get: function() {
        return f;
      },
      set: function(O) {
        var k = findDirectionSetting(O);
        if (k === !1)
          throw new SyntaxError("Vertical: an invalid or illegal direction string was specified.");
        f = k, this.hasBeenReset = !0;
      }
    },
    snapToLines: {
      enumerable: !0,
      get: function() {
        return d;
      },
      set: function(O) {
        d = !!O, this.hasBeenReset = !0;
      }
    },
    line: {
      enumerable: !0,
      get: function() {
        return h;
      },
      set: function(O) {
        if (typeof O != "number" && O !== autoKeyword)
          throw new SyntaxError("Line: an invalid number or illegal string was specified.");
        h = O, this.hasBeenReset = !0;
      }
    },
    lineAlign: {
      enumerable: !0,
      get: function() {
        return p;
      },
      set: function(O) {
        var k = findAlignSetting(O);
        k ? (p = k, this.hasBeenReset = !0) : console.warn("lineAlign: an invalid or illegal string was specified.");
      }
    },
    position: {
      enumerable: !0,
      get: function() {
        return m;
      },
      set: function(O) {
        if (O < 0 || O > 100)
          throw new Error("Position must be between 0 and 100.");
        m = O, this.hasBeenReset = !0;
      }
    },
    positionAlign: {
      enumerable: !0,
      get: function() {
        return _;
      },
      set: function(O) {
        var k = findAlignSetting(O);
        k ? (_ = k, this.hasBeenReset = !0) : console.warn("positionAlign: an invalid or illegal string was specified.");
      }
    },
    size: {
      enumerable: !0,
      get: function() {
        return w;
      },
      set: function(O) {
        if (O < 0 || O > 100)
          throw new Error("Size must be between 0 and 100.");
        w = O, this.hasBeenReset = !0;
      }
    },
    align: {
      enumerable: !0,
      get: function() {
        return S;
      },
      set: function(O) {
        var k = findAlignSetting(O);
        if (!k)
          throw new SyntaxError("align: an invalid or illegal alignment string was specified.");
        S = k, this.hasBeenReset = !0;
      }
    }
  }), this.displayState = void 0;
}
VTTCue.prototype.getCueAsHTML = function() {
  return WebVTT.convertCueToDOMTree(window, this.text);
};
var vttcue = VTTCue, scrollSetting = {
  "": !0,
  up: !0
};
function findScrollSetting(r) {
  if (typeof r != "string")
    return !1;
  var e = scrollSetting[r.toLowerCase()];
  return e ? r.toLowerCase() : !1;
}
function isValidPercentValue(r) {
  return typeof r == "number" && r >= 0 && r <= 100;
}
function VTTRegion() {
  var r = 100, e = 3, t = 0, a = 100, n = 0, s = 100, o = "";
  Object.defineProperties(this, {
    width: {
      enumerable: !0,
      get: function() {
        return r;
      },
      set: function(u) {
        if (!isValidPercentValue(u))
          throw new Error("Width must be between 0 and 100.");
        r = u;
      }
    },
    lines: {
      enumerable: !0,
      get: function() {
        return e;
      },
      set: function(u) {
        if (typeof u != "number")
          throw new TypeError("Lines must be set to a number.");
        e = u;
      }
    },
    regionAnchorY: {
      enumerable: !0,
      get: function() {
        return a;
      },
      set: function(u) {
        if (!isValidPercentValue(u))
          throw new Error("RegionAnchorX must be between 0 and 100.");
        a = u;
      }
    },
    regionAnchorX: {
      enumerable: !0,
      get: function() {
        return t;
      },
      set: function(u) {
        if (!isValidPercentValue(u))
          throw new Error("RegionAnchorY must be between 0 and 100.");
        t = u;
      }
    },
    viewportAnchorY: {
      enumerable: !0,
      get: function() {
        return s;
      },
      set: function(u) {
        if (!isValidPercentValue(u))
          throw new Error("ViewportAnchorY must be between 0 and 100.");
        s = u;
      }
    },
    viewportAnchorX: {
      enumerable: !0,
      get: function() {
        return n;
      },
      set: function(u) {
        if (!isValidPercentValue(u))
          throw new Error("ViewportAnchorX must be between 0 and 100.");
        n = u;
      }
    },
    scroll: {
      enumerable: !0,
      get: function() {
        return o;
      },
      set: function(u) {
        var l = findScrollSetting(u);
        l === !1 ? console.warn("Scroll: an invalid or illegal string was specified.") : o = l;
      }
    }
  });
}
var vttregion = VTTRegion, window$1 = window_1, vttjs = browserIndex.exports = {
  WebVTT: vtt,
  VTTCue: vttcue,
  VTTRegion: vttregion
};
window$1.vttjs = vttjs;
window$1.WebVTT = vttjs.WebVTT;
var cueShim = vttjs.VTTCue, regionShim = vttjs.VTTRegion, nativeVTTCue = window$1.VTTCue, nativeVTTRegion = window$1.VTTRegion;
vttjs.shim = function() {
  window$1.VTTCue = cueShim, window$1.VTTRegion = regionShim;
};
vttjs.restore = function() {
  window$1.VTTCue = nativeVTTCue, window$1.VTTRegion = nativeVTTRegion;
};
window$1.VTTCue || vttjs.shim();
function _isNativeReflectConstruct() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function _construct(r, e, t) {
  return _isNativeReflectConstruct() ? _construct = Reflect.construct.bind() : _construct = function(n, s, o) {
    var u = [null];
    u.push.apply(u, s);
    var l = Function.bind.apply(n, u), f = new l();
    return o && _setPrototypeOf(f, o.prototype), f;
  }, _construct.apply(null, arguments);
}
function _inherits(r, e) {
  if (typeof e != "function" && e !== null)
    throw new TypeError("Super expression must either be null or a function");
  r.prototype = Object.create(e && e.prototype, {
    constructor: {
      value: r,
      writable: !0,
      configurable: !0
    }
  }), Object.defineProperty(r, "prototype", {
    writable: !1
  }), e && _setPrototypeOf(r, e);
}
var urlToolkit = { exports: {} };
(function(r, e) {
  (function(t) {
    var a = /^(?=((?:[a-zA-Z0-9+\-.]+:)?))\1(?=((?:\/\/[^\/?#]*)?))\2(?=((?:(?:[^?#\/]*\/)*[^;?#\/]*)?))\3((?:;[^?#]*)?)(\?[^#]*)?(#[^]*)?$/, n = /^(?=([^\/?#]*))\1([^]*)$/, s = /(?:\/|^)\.(?=\/)/g, o = /(?:\/|^)\.\.\/(?!\.\.\/)[^\/]*(?=\/)/g, u = {
      buildAbsoluteURL: function(l, f, d) {
        if (d = d || {}, l = l.trim(), f = f.trim(), !f) {
          if (!d.alwaysNormalize)
            return l;
          var h = u.parseURL(l);
          if (!h)
            throw new Error("Error trying to parse base URL.");
          return h.path = u.normalizePath(
            h.path
          ), u.buildURLFromParts(h);
        }
        var p = u.parseURL(f);
        if (!p)
          throw new Error("Error trying to parse relative URL.");
        if (p.scheme)
          return d.alwaysNormalize ? (p.path = u.normalizePath(p.path), u.buildURLFromParts(p)) : f;
        var m = u.parseURL(l);
        if (!m)
          throw new Error("Error trying to parse base URL.");
        if (!m.netLoc && m.path && m.path[0] !== "/") {
          var _ = n.exec(m.path);
          m.netLoc = _[1], m.path = _[2];
        }
        m.netLoc && !m.path && (m.path = "/");
        var w = {
          scheme: m.scheme,
          netLoc: p.netLoc,
          path: null,
          params: p.params,
          query: p.query,
          fragment: p.fragment
        };
        if (!p.netLoc && (w.netLoc = m.netLoc, p.path[0] !== "/"))
          if (!p.path)
            w.path = m.path, p.params || (w.params = m.params, p.query || (w.query = m.query));
          else {
            var S = m.path, O = S.substring(0, S.lastIndexOf("/") + 1) + p.path;
            w.path = u.normalizePath(O);
          }
        return w.path === null && (w.path = d.alwaysNormalize ? u.normalizePath(p.path) : p.path), u.buildURLFromParts(w);
      },
      parseURL: function(l) {
        var f = a.exec(l);
        return f ? {
          scheme: f[1] || "",
          netLoc: f[2] || "",
          path: f[3] || "",
          params: f[4] || "",
          query: f[5] || "",
          fragment: f[6] || ""
        } : null;
      },
      normalizePath: function(l) {
        for (l = l.split("").reverse().join("").replace(s, ""); l.length !== (l = l.replace(o, "")).length; )
          ;
        return l.split("").reverse().join("");
      },
      buildURLFromParts: function(l) {
        return l.scheme + l.netLoc + l.path + l.params + l.query + l.fragment;
      }
    };
    r.exports = u;
  })();
})(urlToolkit);
const URLToolkit = urlToolkit.exports;
var DEFAULT_LOCATION = "http://example.com", resolveUrl$1 = function r(e, t) {
  if (/^[a-z]+:/i.test(t))
    return t;
  /^data:/.test(e) && (e = window_1.location && window_1.location.href || "");
  var a = typeof window_1.URL == "function", n = /^\/\//.test(e), s = !window_1.location && !/\/\//i.test(e);
  if (a ? e = new window_1.URL(e, window_1.location || DEFAULT_LOCATION) : /\/\//i.test(e) || (e = URLToolkit.buildAbsoluteURL(window_1.location && window_1.location.href || "", e)), a) {
    var o = new URL(t, e);
    return s ? o.href.slice(DEFAULT_LOCATION.length) : n ? o.href.slice(o.protocol.length) : o.href;
  }
  return URLToolkit.buildAbsoluteURL(e, t);
}, Stream = /* @__PURE__ */ function() {
  function r() {
    this.listeners = {};
  }
  var e = r.prototype;
  return e.on = function(a, n) {
    this.listeners[a] || (this.listeners[a] = []), this.listeners[a].push(n);
  }, e.off = function(a, n) {
    if (!this.listeners[a])
      return !1;
    var s = this.listeners[a].indexOf(n);
    return this.listeners[a] = this.listeners[a].slice(0), this.listeners[a].splice(s, 1), s > -1;
  }, e.trigger = function(a) {
    var n = this.listeners[a];
    if (!!n)
      if (arguments.length === 2)
        for (var s = n.length, o = 0; o < s; ++o)
          n[o].call(this, arguments[1]);
      else
        for (var u = Array.prototype.slice.call(arguments, 1), l = n.length, f = 0; f < l; ++f)
          n[f].apply(this, u);
  }, e.dispose = function() {
    this.listeners = {};
  }, e.pipe = function(a) {
    this.on("data", function(n) {
      a.push(n);
    });
  }, r;
}(), atob$1 = function r(e) {
  return window_1.atob ? window_1.atob(e) : Buffer.from(e, "base64").toString("binary");
};
function decodeB64ToUint8Array(r) {
  for (var e = atob$1(r), t = new Uint8Array(e.length), a = 0; a < e.length; a++)
    t[a] = e.charCodeAt(a);
  return t;
}
/*! @name m3u8-parser @version 4.7.1 @license Apache-2.0 */
var LineStream = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    var a;
    return a = r.call(this) || this, a.buffer = "", a;
  }
  var t = e.prototype;
  return t.push = function(n) {
    var s;
    for (this.buffer += n, s = this.buffer.indexOf(`
`); s > -1; s = this.buffer.indexOf(`
`))
      this.trigger("data", this.buffer.substring(0, s)), this.buffer = this.buffer.substring(s + 1);
  }, e;
}(Stream), TAB = String.fromCharCode(9), parseByterange = function r(e) {
  var t = /([0-9.]*)?@?([0-9.]*)?/.exec(e || ""), a = {};
  return t[1] && (a.length = parseInt(t[1], 10)), t[2] && (a.offset = parseInt(t[2], 10)), a;
}, attributeSeparator = function r() {
  var e = "[^=]*", t = '"[^"]*"|[^,]*', a = "(?:" + e + ")=(?:" + t + ")";
  return new RegExp("(?:^|,)(" + a + ")");
}, parseAttributes$1 = function r(e) {
  for (var t = e.split(attributeSeparator()), a = {}, n = t.length, s; n--; )
    t[n] !== "" && (s = /([^=]*)=(.*)/.exec(t[n]).slice(1), s[0] = s[0].replace(/^\s+|\s+$/g, ""), s[1] = s[1].replace(/^\s+|\s+$/g, ""), s[1] = s[1].replace(/^['"](.*)['"]$/g, "$1"), a[s[0]] = s[1]);
  return a;
}, ParseStream = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    var a;
    return a = r.call(this) || this, a.customParsers = [], a.tagMappers = [], a;
  }
  var t = e.prototype;
  return t.push = function(n) {
    var s = this, o, u;
    if (n = n.trim(), n.length !== 0) {
      if (n[0] !== "#") {
        this.trigger("data", {
          type: "uri",
          uri: n
        });
        return;
      }
      var l = this.tagMappers.reduce(function(f, d) {
        var h = d(n);
        return h === n ? f : f.concat([h]);
      }, [n]);
      l.forEach(function(f) {
        for (var d = 0; d < s.customParsers.length; d++)
          if (s.customParsers[d].call(s, f))
            return;
        if (f.indexOf("#EXT") !== 0) {
          s.trigger("data", {
            type: "comment",
            text: f.slice(1)
          });
          return;
        }
        if (f = f.replace("\r", ""), o = /^#EXTM3U/.exec(f), o) {
          s.trigger("data", {
            type: "tag",
            tagType: "m3u"
          });
          return;
        }
        if (o = /^#EXTINF:?([0-9\.]*)?,?(.*)?$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "inf"
          }, o[1] && (u.duration = parseFloat(o[1])), o[2] && (u.title = o[2]), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-TARGETDURATION:?([0-9.]*)?/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "targetduration"
          }, o[1] && (u.duration = parseInt(o[1], 10)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-VERSION:?([0-9.]*)?/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "version"
          }, o[1] && (u.version = parseInt(o[1], 10)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-MEDIA-SEQUENCE:?(\-?[0-9.]*)?/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "media-sequence"
          }, o[1] && (u.number = parseInt(o[1], 10)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-DISCONTINUITY-SEQUENCE:?(\-?[0-9.]*)?/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "discontinuity-sequence"
          }, o[1] && (u.number = parseInt(o[1], 10)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-PLAYLIST-TYPE:?(.*)?$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "playlist-type"
          }, o[1] && (u.playlistType = o[1]), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-BYTERANGE:?(.*)?$/.exec(f), o) {
          u = _extends$2(parseByterange(o[1]), {
            type: "tag",
            tagType: "byterange"
          }), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-ALLOW-CACHE:?(YES|NO)?/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "allow-cache"
          }, o[1] && (u.allowed = !/NO/.test(o[1])), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-MAP:?(.*)$/.exec(f), o) {
          if (u = {
            type: "tag",
            tagType: "map"
          }, o[1]) {
            var h = parseAttributes$1(o[1]);
            h.URI && (u.uri = h.URI), h.BYTERANGE && (u.byterange = parseByterange(h.BYTERANGE));
          }
          s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-STREAM-INF:?(.*)$/.exec(f), o) {
          if (u = {
            type: "tag",
            tagType: "stream-inf"
          }, o[1]) {
            if (u.attributes = parseAttributes$1(o[1]), u.attributes.RESOLUTION) {
              var p = u.attributes.RESOLUTION.split("x"), m = {};
              p[0] && (m.width = parseInt(p[0], 10)), p[1] && (m.height = parseInt(p[1], 10)), u.attributes.RESOLUTION = m;
            }
            u.attributes.BANDWIDTH && (u.attributes.BANDWIDTH = parseInt(u.attributes.BANDWIDTH, 10)), u.attributes["PROGRAM-ID"] && (u.attributes["PROGRAM-ID"] = parseInt(u.attributes["PROGRAM-ID"], 10));
          }
          s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-MEDIA:?(.*)$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "media"
          }, o[1] && (u.attributes = parseAttributes$1(o[1])), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-ENDLIST/.exec(f), o) {
          s.trigger("data", {
            type: "tag",
            tagType: "endlist"
          });
          return;
        }
        if (o = /^#EXT-X-DISCONTINUITY/.exec(f), o) {
          s.trigger("data", {
            type: "tag",
            tagType: "discontinuity"
          });
          return;
        }
        if (o = /^#EXT-X-PROGRAM-DATE-TIME:?(.*)$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "program-date-time"
          }, o[1] && (u.dateTimeString = o[1], u.dateTimeObject = new Date(o[1])), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-KEY:?(.*)$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "key"
          }, o[1] && (u.attributes = parseAttributes$1(o[1]), u.attributes.IV && (u.attributes.IV.substring(0, 2).toLowerCase() === "0x" && (u.attributes.IV = u.attributes.IV.substring(2)), u.attributes.IV = u.attributes.IV.match(/.{8}/g), u.attributes.IV[0] = parseInt(u.attributes.IV[0], 16), u.attributes.IV[1] = parseInt(u.attributes.IV[1], 16), u.attributes.IV[2] = parseInt(u.attributes.IV[2], 16), u.attributes.IV[3] = parseInt(u.attributes.IV[3], 16), u.attributes.IV = new Uint32Array(u.attributes.IV))), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-START:?(.*)$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "start"
          }, o[1] && (u.attributes = parseAttributes$1(o[1]), u.attributes["TIME-OFFSET"] = parseFloat(u.attributes["TIME-OFFSET"]), u.attributes.PRECISE = /YES/.test(u.attributes.PRECISE)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-CUE-OUT-CONT:?(.*)?$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "cue-out-cont"
          }, o[1] ? u.data = o[1] : u.data = "", s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-CUE-OUT:?(.*)?$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "cue-out"
          }, o[1] ? u.data = o[1] : u.data = "", s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-CUE-IN:?(.*)?$/.exec(f), o) {
          u = {
            type: "tag",
            tagType: "cue-in"
          }, o[1] ? u.data = o[1] : u.data = "", s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-SKIP:(.*)$/.exec(f), o && o[1]) {
          u = {
            type: "tag",
            tagType: "skip"
          }, u.attributes = parseAttributes$1(o[1]), u.attributes.hasOwnProperty("SKIPPED-SEGMENTS") && (u.attributes["SKIPPED-SEGMENTS"] = parseInt(u.attributes["SKIPPED-SEGMENTS"], 10)), u.attributes.hasOwnProperty("RECENTLY-REMOVED-DATERANGES") && (u.attributes["RECENTLY-REMOVED-DATERANGES"] = u.attributes["RECENTLY-REMOVED-DATERANGES"].split(TAB)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-PART:(.*)$/.exec(f), o && o[1]) {
          u = {
            type: "tag",
            tagType: "part"
          }, u.attributes = parseAttributes$1(o[1]), ["DURATION"].forEach(function(_) {
            u.attributes.hasOwnProperty(_) && (u.attributes[_] = parseFloat(u.attributes[_]));
          }), ["INDEPENDENT", "GAP"].forEach(function(_) {
            u.attributes.hasOwnProperty(_) && (u.attributes[_] = /YES/.test(u.attributes[_]));
          }), u.attributes.hasOwnProperty("BYTERANGE") && (u.attributes.byterange = parseByterange(u.attributes.BYTERANGE)), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-SERVER-CONTROL:(.*)$/.exec(f), o && o[1]) {
          u = {
            type: "tag",
            tagType: "server-control"
          }, u.attributes = parseAttributes$1(o[1]), ["CAN-SKIP-UNTIL", "PART-HOLD-BACK", "HOLD-BACK"].forEach(function(_) {
            u.attributes.hasOwnProperty(_) && (u.attributes[_] = parseFloat(u.attributes[_]));
          }), ["CAN-SKIP-DATERANGES", "CAN-BLOCK-RELOAD"].forEach(function(_) {
            u.attributes.hasOwnProperty(_) && (u.attributes[_] = /YES/.test(u.attributes[_]));
          }), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-PART-INF:(.*)$/.exec(f), o && o[1]) {
          u = {
            type: "tag",
            tagType: "part-inf"
          }, u.attributes = parseAttributes$1(o[1]), ["PART-TARGET"].forEach(function(_) {
            u.attributes.hasOwnProperty(_) && (u.attributes[_] = parseFloat(u.attributes[_]));
          }), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-PRELOAD-HINT:(.*)$/.exec(f), o && o[1]) {
          u = {
            type: "tag",
            tagType: "preload-hint"
          }, u.attributes = parseAttributes$1(o[1]), ["BYTERANGE-START", "BYTERANGE-LENGTH"].forEach(function(_) {
            if (u.attributes.hasOwnProperty(_)) {
              u.attributes[_] = parseInt(u.attributes[_], 10);
              var w = _ === "BYTERANGE-LENGTH" ? "length" : "offset";
              u.attributes.byterange = u.attributes.byterange || {}, u.attributes.byterange[w] = u.attributes[_], delete u.attributes[_];
            }
          }), s.trigger("data", u);
          return;
        }
        if (o = /^#EXT-X-RENDITION-REPORT:(.*)$/.exec(f), o && o[1]) {
          u = {
            type: "tag",
            tagType: "rendition-report"
          }, u.attributes = parseAttributes$1(o[1]), ["LAST-MSN", "LAST-PART"].forEach(function(_) {
            u.attributes.hasOwnProperty(_) && (u.attributes[_] = parseInt(u.attributes[_], 10));
          }), s.trigger("data", u);
          return;
        }
        s.trigger("data", {
          type: "tag",
          data: f.slice(4)
        });
      });
    }
  }, t.addParser = function(n) {
    var s = this, o = n.expression, u = n.customType, l = n.dataParser, f = n.segment;
    typeof l != "function" && (l = function(h) {
      return h;
    }), this.customParsers.push(function(d) {
      var h = o.exec(d);
      if (h)
        return s.trigger("data", {
          type: "custom",
          data: l(d),
          customType: u,
          segment: f
        }), !0;
    });
  }, t.addTagMapper = function(n) {
    var s = n.expression, o = n.map, u = function(f) {
      return s.test(f) ? o(f) : f;
    };
    this.tagMappers.push(u);
  }, e;
}(Stream), camelCase = function r(e) {
  return e.toLowerCase().replace(/-(\w)/g, function(t) {
    return t[1].toUpperCase();
  });
}, camelCaseKeys = function r(e) {
  var t = {};
  return Object.keys(e).forEach(function(a) {
    t[camelCase(a)] = e[a];
  }), t;
}, setHoldBack = function r(e) {
  var t = e.serverControl, a = e.targetDuration, n = e.partTargetDuration;
  if (!!t) {
    var s = "#EXT-X-SERVER-CONTROL", o = "holdBack", u = "partHoldBack", l = a && a * 3, f = n && n * 2;
    a && !t.hasOwnProperty(o) && (t[o] = l, this.trigger("info", {
      message: s + " defaulting HOLD-BACK to targetDuration * 3 (" + l + ")."
    })), l && t[o] < l && (this.trigger("warn", {
      message: s + " clamping HOLD-BACK (" + t[o] + ") to targetDuration * 3 (" + l + ")"
    }), t[o] = l), n && !t.hasOwnProperty(u) && (t[u] = n * 3, this.trigger("info", {
      message: s + " defaulting PART-HOLD-BACK to partTargetDuration * 3 (" + t[u] + ")."
    })), n && t[u] < f && (this.trigger("warn", {
      message: s + " clamping PART-HOLD-BACK (" + t[u] + ") to partTargetDuration * 2 (" + f + ")."
    }), t[u] = f);
  }
}, Parser = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    var a;
    a = r.call(this) || this, a.lineStream = new LineStream(), a.parseStream = new ParseStream(), a.lineStream.pipe(a.parseStream);
    var n = _assertThisInitialized$1(a), s = [], o = {}, u, l, f = !1, d = function() {
    }, h = {
      AUDIO: {},
      VIDEO: {},
      "CLOSED-CAPTIONS": {},
      SUBTITLES: {}
    }, p = "urn:uuid:edef8ba9-79d6-4ace-a3c8-27dcd51d21ed", m = 0;
    a.manifest = {
      allowCache: !0,
      discontinuityStarts: [],
      segments: []
    };
    var _ = 0, w = 0;
    return a.on("end", function() {
      o.uri || !o.parts && !o.preloadHints || (!o.map && u && (o.map = u), !o.key && l && (o.key = l), !o.timeline && typeof m == "number" && (o.timeline = m), a.manifest.preloadSegment = o);
    }), a.parseStream.on("data", function(S) {
      var O, k;
      ({
        tag: function() {
          ({
            version: function() {
              S.version && (this.manifest.version = S.version);
            },
            "allow-cache": function() {
              this.manifest.allowCache = S.allowed, "allowed" in S || (this.trigger("info", {
                message: "defaulting allowCache to YES"
              }), this.manifest.allowCache = !0);
            },
            byterange: function() {
              var G = {};
              "length" in S && (o.byterange = G, G.length = S.length, "offset" in S || (S.offset = _)), "offset" in S && (o.byterange = G, G.offset = S.offset), _ = G.offset + G.length;
            },
            endlist: function() {
              this.manifest.endList = !0;
            },
            inf: function() {
              "mediaSequence" in this.manifest || (this.manifest.mediaSequence = 0, this.trigger("info", {
                message: "defaulting media sequence to zero"
              })), "discontinuitySequence" in this.manifest || (this.manifest.discontinuitySequence = 0, this.trigger("info", {
                message: "defaulting discontinuity sequence to zero"
              })), S.duration > 0 && (o.duration = S.duration), S.duration === 0 && (o.duration = 0.01, this.trigger("info", {
                message: "updating zero segment duration to a small value"
              })), this.manifest.segments = s;
            },
            key: function() {
              if (!S.attributes) {
                this.trigger("warn", {
                  message: "ignoring key declaration without attribute list"
                });
                return;
              }
              if (S.attributes.METHOD === "NONE") {
                l = null;
                return;
              }
              if (!S.attributes.URI) {
                this.trigger("warn", {
                  message: "ignoring key declaration without URI"
                });
                return;
              }
              if (S.attributes.KEYFORMAT === "com.apple.streamingkeydelivery") {
                this.manifest.contentProtection = this.manifest.contentProtection || {}, this.manifest.contentProtection["com.apple.fps.1_0"] = {
                  attributes: S.attributes
                };
                return;
              }
              if (S.attributes.KEYFORMAT === "com.microsoft.playready") {
                this.manifest.contentProtection = this.manifest.contentProtection || {}, this.manifest.contentProtection["com.microsoft.playready"] = {
                  uri: S.attributes.URI
                };
                return;
              }
              if (S.attributes.KEYFORMAT === p) {
                var G = ["SAMPLE-AES", "SAMPLE-AES-CTR", "SAMPLE-AES-CENC"];
                if (G.indexOf(S.attributes.METHOD) === -1) {
                  this.trigger("warn", {
                    message: "invalid key method provided for Widevine"
                  });
                  return;
                }
                if (S.attributes.METHOD === "SAMPLE-AES-CENC" && this.trigger("warn", {
                  message: "SAMPLE-AES-CENC is deprecated, please use SAMPLE-AES-CTR instead"
                }), S.attributes.URI.substring(0, 23) !== "data:text/plain;base64,") {
                  this.trigger("warn", {
                    message: "invalid key URI provided for Widevine"
                  });
                  return;
                }
                if (!(S.attributes.KEYID && S.attributes.KEYID.substring(0, 2) === "0x")) {
                  this.trigger("warn", {
                    message: "invalid key ID provided for Widevine"
                  });
                  return;
                }
                this.manifest.contentProtection = this.manifest.contentProtection || {}, this.manifest.contentProtection["com.widevine.alpha"] = {
                  attributes: {
                    schemeIdUri: S.attributes.KEYFORMAT,
                    keyId: S.attributes.KEYID.substring(2)
                  },
                  pssh: decodeB64ToUint8Array(S.attributes.URI.split(",")[1])
                };
                return;
              }
              S.attributes.METHOD || this.trigger("warn", {
                message: "defaulting key method to AES-128"
              }), l = {
                method: S.attributes.METHOD || "AES-128",
                uri: S.attributes.URI
              }, typeof S.attributes.IV < "u" && (l.iv = S.attributes.IV);
            },
            "media-sequence": function() {
              if (!isFinite(S.number)) {
                this.trigger("warn", {
                  message: "ignoring invalid media sequence: " + S.number
                });
                return;
              }
              this.manifest.mediaSequence = S.number;
            },
            "discontinuity-sequence": function() {
              if (!isFinite(S.number)) {
                this.trigger("warn", {
                  message: "ignoring invalid discontinuity sequence: " + S.number
                });
                return;
              }
              this.manifest.discontinuitySequence = S.number, m = S.number;
            },
            "playlist-type": function() {
              if (!/VOD|EVENT/.test(S.playlistType)) {
                this.trigger("warn", {
                  message: "ignoring unknown playlist type: " + S.playlist
                });
                return;
              }
              this.manifest.playlistType = S.playlistType;
            },
            map: function() {
              u = {}, S.uri && (u.uri = S.uri), S.byterange && (u.byterange = S.byterange), l && (u.key = l);
            },
            "stream-inf": function() {
              if (this.manifest.playlists = s, this.manifest.mediaGroups = this.manifest.mediaGroups || h, !S.attributes) {
                this.trigger("warn", {
                  message: "ignoring empty stream-inf attributes"
                });
                return;
              }
              o.attributes || (o.attributes = {}), _extends$2(o.attributes, S.attributes);
            },
            media: function() {
              if (this.manifest.mediaGroups = this.manifest.mediaGroups || h, !(S.attributes && S.attributes.TYPE && S.attributes["GROUP-ID"] && S.attributes.NAME)) {
                this.trigger("warn", {
                  message: "ignoring incomplete or missing media group"
                });
                return;
              }
              var G = this.manifest.mediaGroups[S.attributes.TYPE];
              G[S.attributes["GROUP-ID"]] = G[S.attributes["GROUP-ID"]] || {}, O = G[S.attributes["GROUP-ID"]], k = {
                default: /yes/i.test(S.attributes.DEFAULT)
              }, k.default ? k.autoselect = !0 : k.autoselect = /yes/i.test(S.attributes.AUTOSELECT), S.attributes.LANGUAGE && (k.language = S.attributes.LANGUAGE), S.attributes.URI && (k.uri = S.attributes.URI), S.attributes["INSTREAM-ID"] && (k.instreamId = S.attributes["INSTREAM-ID"]), S.attributes.CHARACTERISTICS && (k.characteristics = S.attributes.CHARACTERISTICS), S.attributes.FORCED && (k.forced = /yes/i.test(S.attributes.FORCED)), O[S.attributes.NAME] = k;
            },
            discontinuity: function() {
              m += 1, o.discontinuity = !0, this.manifest.discontinuityStarts.push(s.length);
            },
            "program-date-time": function() {
              typeof this.manifest.dateTimeString > "u" && (this.manifest.dateTimeString = S.dateTimeString, this.manifest.dateTimeObject = S.dateTimeObject), o.dateTimeString = S.dateTimeString, o.dateTimeObject = S.dateTimeObject;
            },
            targetduration: function() {
              if (!isFinite(S.duration) || S.duration < 0) {
                this.trigger("warn", {
                  message: "ignoring invalid target duration: " + S.duration
                });
                return;
              }
              this.manifest.targetDuration = S.duration, setHoldBack.call(this, this.manifest);
            },
            start: function() {
              if (!S.attributes || isNaN(S.attributes["TIME-OFFSET"])) {
                this.trigger("warn", {
                  message: "ignoring start declaration without appropriate attribute list"
                });
                return;
              }
              this.manifest.start = {
                timeOffset: S.attributes["TIME-OFFSET"],
                precise: S.attributes.PRECISE
              };
            },
            "cue-out": function() {
              o.cueOut = S.data;
            },
            "cue-out-cont": function() {
              o.cueOutCont = S.data;
            },
            "cue-in": function() {
              o.cueIn = S.data;
            },
            skip: function() {
              this.manifest.skip = camelCaseKeys(S.attributes), this.warnOnMissingAttributes_("#EXT-X-SKIP", S.attributes, ["SKIPPED-SEGMENTS"]);
            },
            part: function() {
              var G = this;
              f = !0;
              var _r = this.manifest.segments.length, ga = camelCaseKeys(S.attributes);
              o.parts = o.parts || [], o.parts.push(ga), ga.byterange && (ga.byterange.hasOwnProperty("offset") || (ga.byterange.offset = w), w = ga.byterange.offset + ga.byterange.length);
              var _n = o.parts.length - 1;
              this.warnOnMissingAttributes_("#EXT-X-PART #" + _n + " for segment #" + _r, S.attributes, ["URI", "DURATION"]), this.manifest.renditionReports && this.manifest.renditionReports.forEach(function(Fa, N) {
                Fa.hasOwnProperty("lastPart") || G.trigger("warn", {
                  message: "#EXT-X-RENDITION-REPORT #" + N + " lacks required attribute(s): LAST-PART"
                });
              });
            },
            "server-control": function() {
              var G = this.manifest.serverControl = camelCaseKeys(S.attributes);
              G.hasOwnProperty("canBlockReload") || (G.canBlockReload = !1, this.trigger("info", {
                message: "#EXT-X-SERVER-CONTROL defaulting CAN-BLOCK-RELOAD to false"
              })), setHoldBack.call(this, this.manifest), G.canSkipDateranges && !G.hasOwnProperty("canSkipUntil") && this.trigger("warn", {
                message: "#EXT-X-SERVER-CONTROL lacks required attribute CAN-SKIP-UNTIL which is required when CAN-SKIP-DATERANGES is set"
              });
            },
            "preload-hint": function() {
              var G = this.manifest.segments.length, _r = camelCaseKeys(S.attributes), ga = _r.type && _r.type === "PART";
              o.preloadHints = o.preloadHints || [], o.preloadHints.push(_r), _r.byterange && (_r.byterange.hasOwnProperty("offset") || (_r.byterange.offset = ga ? w : 0, ga && (w = _r.byterange.offset + _r.byterange.length)));
              var _n = o.preloadHints.length - 1;
              if (this.warnOnMissingAttributes_("#EXT-X-PRELOAD-HINT #" + _n + " for segment #" + G, S.attributes, ["TYPE", "URI"]), !!_r.type)
                for (var Fa = 0; Fa < o.preloadHints.length - 1; Fa++) {
                  var N = o.preloadHints[Fa];
                  !N.type || N.type === _r.type && this.trigger("warn", {
                    message: "#EXT-X-PRELOAD-HINT #" + _n + " for segment #" + G + " has the same TYPE " + _r.type + " as preload hint #" + Fa
                  });
                }
            },
            "rendition-report": function() {
              var G = camelCaseKeys(S.attributes);
              this.manifest.renditionReports = this.manifest.renditionReports || [], this.manifest.renditionReports.push(G);
              var _r = this.manifest.renditionReports.length - 1, ga = ["LAST-MSN", "URI"];
              f && ga.push("LAST-PART"), this.warnOnMissingAttributes_("#EXT-X-RENDITION-REPORT #" + _r, S.attributes, ga);
            },
            "part-inf": function() {
              this.manifest.partInf = camelCaseKeys(S.attributes), this.warnOnMissingAttributes_("#EXT-X-PART-INF", S.attributes, ["PART-TARGET"]), this.manifest.partInf.partTarget && (this.manifest.partTargetDuration = this.manifest.partInf.partTarget), setHoldBack.call(this, this.manifest);
            }
          }[S.tagType] || d).call(n);
        },
        uri: function() {
          o.uri = S.uri, s.push(o), this.manifest.targetDuration && !("duration" in o) && (this.trigger("warn", {
            message: "defaulting segment duration to the target duration"
          }), o.duration = this.manifest.targetDuration), l && (o.key = l), o.timeline = m, u && (o.map = u), w = 0, o = {};
        },
        comment: function() {
        },
        custom: function() {
          S.segment ? (o.custom = o.custom || {}, o.custom[S.customType] = S.data) : (this.manifest.custom = this.manifest.custom || {}, this.manifest.custom[S.customType] = S.data);
        }
      })[S.type].call(n);
    }), a;
  }
  var t = e.prototype;
  return t.warnOnMissingAttributes_ = function(n, s, o) {
    var u = [];
    o.forEach(function(l) {
      s.hasOwnProperty(l) || u.push(l);
    }), u.length && this.trigger("warn", {
      message: n + " lacks required attribute(s): " + u.join(", ")
    });
  }, t.push = function(n) {
    this.lineStream.push(n);
  }, t.end = function() {
    this.lineStream.push(`
`), this.trigger("end");
  }, t.addParser = function(n) {
    this.parseStream.addParser(n);
  }, t.addTagMapper = function(n) {
    this.parseStream.addTagMapper(n);
  }, e;
}(Stream), regexs = {
  mp4: /^(av0?1|avc0?[1234]|vp0?9|flac|opus|mp3|mp4a|mp4v|stpp.ttml.im1t)/,
  webm: /^(vp0?[89]|av0?1|opus|vorbis)/,
  ogg: /^(vp0?[89]|theora|flac|opus|vorbis)/,
  video: /^(av0?1|avc0?[1234]|vp0?[89]|hvc1|hev1|theora|mp4v)/,
  audio: /^(mp4a|flac|vorbis|opus|ac-[34]|ec-3|alac|mp3|speex|aac)/,
  text: /^(stpp.ttml.im1t)/,
  muxerVideo: /^(avc0?1)/,
  muxerAudio: /^(mp4a)/,
  muxerText: /a^/
}, mediaTypes = ["video", "audio", "text"], upperMediaTypes = ["Video", "Audio", "Text"], translateLegacyCodec = function r(e) {
  return e && e.replace(/avc1\.(\d+)\.(\d+)/i, function(t, a, n) {
    var s = ("00" + Number(a).toString(16)).slice(-2), o = ("00" + Number(n).toString(16)).slice(-2);
    return "avc1." + s + "00" + o;
  });
}, parseCodecs = function r(e) {
  e === void 0 && (e = "");
  var t = e.split(","), a = [];
  return t.forEach(function(n) {
    n = n.trim();
    var s;
    mediaTypes.forEach(function(o) {
      var u = regexs[o].exec(n.toLowerCase());
      if (!(!u || u.length <= 1)) {
        s = o;
        var l = n.substring(0, u[1].length), f = n.replace(l, "");
        a.push({
          type: l,
          details: f,
          mediaType: o
        });
      }
    }), s || a.push({
      type: n,
      details: "",
      mediaType: "unknown"
    });
  }), a;
}, codecsFromDefault = function r(e, t) {
  if (!e.mediaGroups.AUDIO || !t)
    return null;
  var a = e.mediaGroups.AUDIO[t];
  if (!a)
    return null;
  for (var n in a) {
    var s = a[n];
    if (s.default && s.playlists)
      return parseCodecs(s.playlists[0].attributes.CODECS);
  }
  return null;
}, isAudioCodec = function r(e) {
  return e === void 0 && (e = ""), regexs.audio.test(e.trim().toLowerCase());
}, isTextCodec = function r(e) {
  return e === void 0 && (e = ""), regexs.text.test(e.trim().toLowerCase());
}, getMimeForCodec = function r(e) {
  if (!(!e || typeof e != "string")) {
    var t = e.toLowerCase().split(",").map(function(s) {
      return translateLegacyCodec(s.trim());
    }), a = "video";
    t.length === 1 && isAudioCodec(t[0]) ? a = "audio" : t.length === 1 && isTextCodec(t[0]) && (a = "application");
    var n = "mp4";
    return t.every(function(s) {
      return regexs.mp4.test(s);
    }) ? n = "mp4" : t.every(function(s) {
      return regexs.webm.test(s);
    }) ? n = "webm" : t.every(function(s) {
      return regexs.ogg.test(s);
    }) && (n = "ogg"), a + "/" + n + ';codecs="' + e + '"';
  }
}, browserSupportsCodec = function r(e) {
  return e === void 0 && (e = ""), window_1.MediaSource && window_1.MediaSource.isTypeSupported && window_1.MediaSource.isTypeSupported(getMimeForCodec(e)) || !1;
}, muxerSupportsCodec = function r(e) {
  return e === void 0 && (e = ""), e.toLowerCase().split(",").every(function(t) {
    t = t.trim();
    for (var a = 0; a < upperMediaTypes.length; a++) {
      var n = upperMediaTypes[a];
      if (regexs["muxer" + n].test(t))
        return !0;
    }
    return !1;
  });
}, DEFAULT_AUDIO_CODEC = "mp4a.40.2", DEFAULT_VIDEO_CODEC = "avc1.4d400d", MPEGURL_REGEX = /^(audio|video|application)\/(x-|vnd\.apple\.)?mpegurl/i, DASH_REGEX = /^application\/dash\+xml/i, simpleTypeFromSourceType = function r(e) {
  return MPEGURL_REGEX.test(e) ? "hls" : DASH_REGEX.test(e) ? "dash" : e === "application/vnd.videojs.vhs+json" ? "vhs-json" : null;
}, countBits = function r(e) {
  return e.toString(2).length;
}, countBytes = function r(e) {
  return Math.ceil(countBits(e) / 8);
}, isArrayBufferView = function r(e) {
  return ArrayBuffer.isView === "function" ? ArrayBuffer.isView(e) : e && e.buffer instanceof ArrayBuffer;
}, isTypedArray = function r(e) {
  return isArrayBufferView(e);
}, toUint8 = function r(e) {
  return e instanceof Uint8Array ? e : (!Array.isArray(e) && !isTypedArray(e) && !(e instanceof ArrayBuffer) && (typeof e != "number" || typeof e == "number" && e !== e ? e = 0 : e = [e]), new Uint8Array(e && e.buffer || e, e && e.byteOffset || 0, e && e.byteLength || 0));
}, BigInt = window_1.BigInt || Number, BYTE_TABLE = [BigInt("0x1"), BigInt("0x100"), BigInt("0x10000"), BigInt("0x1000000"), BigInt("0x100000000"), BigInt("0x10000000000"), BigInt("0x1000000000000"), BigInt("0x100000000000000"), BigInt("0x10000000000000000")];
(function() {
  var r = new Uint16Array([65484]), e = new Uint8Array(r.buffer, r.byteOffset, r.byteLength);
  return e[0] === 255 ? "big" : e[0] === 204 ? "little" : "unknown";
})();
var bytesToNumber = function r(e, t) {
  var a = t === void 0 ? {} : t, n = a.signed, s = n === void 0 ? !1 : n, o = a.le, u = o === void 0 ? !1 : o;
  e = toUint8(e);
  var l = u ? "reduce" : "reduceRight", f = e[l] ? e[l] : Array.prototype[l], d = f.call(e, function(p, m, _) {
    var w = u ? _ : Math.abs(_ + 1 - e.length);
    return p + BigInt(m) * BYTE_TABLE[w];
  }, BigInt(0));
  if (s) {
    var h = BYTE_TABLE[e.length] / BigInt(2) - BigInt(1);
    d = BigInt(d), d > h && (d -= h, d -= h, d -= BigInt(2));
  }
  return Number(d);
}, numberToBytes = function r(e, t) {
  var a = t === void 0 ? {} : t, n = a.le, s = n === void 0 ? !1 : n;
  (typeof e != "bigint" && typeof e != "number" || typeof e == "number" && e !== e) && (e = 0), e = BigInt(e);
  for (var o = countBytes(e), u = new Uint8Array(new ArrayBuffer(o)), l = 0; l < o; l++) {
    var f = s ? l : Math.abs(l + 1 - u.length);
    u[f] = Number(e / BYTE_TABLE[l] & BigInt(255)), e < 0 && (u[f] = Math.abs(~u[f]), u[f] -= l === 0 ? 1 : 2);
  }
  return u;
}, stringToBytes = function r(e, t) {
  if (typeof e != "string" && e && typeof e.toString == "function" && (e = e.toString()), typeof e != "string")
    return new Uint8Array();
  t || (e = unescape(encodeURIComponent(e)));
  for (var a = new Uint8Array(e.length), n = 0; n < e.length; n++)
    a[n] = e.charCodeAt(n);
  return a;
}, concatTypedArrays = function r() {
  for (var e = arguments.length, t = new Array(e), a = 0; a < e; a++)
    t[a] = arguments[a];
  if (t = t.filter(function(u) {
    return u && (u.byteLength || u.length) && typeof u != "string";
  }), t.length <= 1)
    return toUint8(t[0]);
  var n = t.reduce(function(u, l, f) {
    return u + (l.byteLength || l.length);
  }, 0), s = new Uint8Array(n), o = 0;
  return t.forEach(function(u) {
    u = toUint8(u), s.set(u, o), o += u.byteLength;
  }), s;
}, bytesMatch = function r(e, t, a) {
  var n = a === void 0 ? {} : a, s = n.offset, o = s === void 0 ? 0 : s, u = n.mask, l = u === void 0 ? [] : u;
  e = toUint8(e), t = toUint8(t);
  var f = t.every ? t.every : Array.prototype.every;
  return t.length && e.length - o >= t.length && f.call(t, function(d, h) {
    var p = l[h] ? l[h] & e[o + h] : e[o + h];
    return d === p;
  });
}, forEachMediaGroup$1 = function r(e, t, a) {
  t.forEach(function(n) {
    for (var s in e.mediaGroups[n])
      for (var o in e.mediaGroups[n][s]) {
        var u = e.mediaGroups[n][s][o];
        a(u, n, s, o);
      }
  });
}, dom$1 = {}, conventions$2 = {};
function freeze(r, e) {
  return e === void 0 && (e = Object), e && typeof e.freeze == "function" ? e.freeze(r) : r;
}
var MIME_TYPE = freeze({
  HTML: "text/html",
  isHTML: function(r) {
    return r === MIME_TYPE.HTML;
  },
  XML_APPLICATION: "application/xml",
  XML_TEXT: "text/xml",
  XML_XHTML_APPLICATION: "application/xhtml+xml",
  XML_SVG_IMAGE: "image/svg+xml"
}), NAMESPACE$3 = freeze({
  HTML: "http://www.w3.org/1999/xhtml",
  isHTML: function(r) {
    return r === NAMESPACE$3.HTML;
  },
  SVG: "http://www.w3.org/2000/svg",
  XML: "http://www.w3.org/XML/1998/namespace",
  XMLNS: "http://www.w3.org/2000/xmlns/"
});
conventions$2.freeze = freeze;
conventions$2.MIME_TYPE = MIME_TYPE;
conventions$2.NAMESPACE = NAMESPACE$3;
var conventions$1 = conventions$2, NAMESPACE$2 = conventions$1.NAMESPACE;
function notEmptyString(r) {
  return r !== "";
}
function splitOnASCIIWhitespace(r) {
  return r ? r.split(/[\t\n\f\r ]+/).filter(notEmptyString) : [];
}
function orderedSetReducer(r, e) {
  return r.hasOwnProperty(e) || (r[e] = !0), r;
}
function toOrderedSet(r) {
  if (!r)
    return [];
  var e = splitOnASCIIWhitespace(r);
  return Object.keys(e.reduce(orderedSetReducer, {}));
}
function arrayIncludes(r) {
  return function(e) {
    return r && r.indexOf(e) !== -1;
  };
}
function copy(r, e) {
  for (var t in r)
    e[t] = r[t];
}
function _extends(r, e) {
  var t = r.prototype;
  if (!(t instanceof e)) {
    let a = function() {
    };
    a.prototype = e.prototype, a = new a(), copy(t, a), r.prototype = t = a;
  }
  t.constructor != r && (typeof r != "function" && console.error("unknown Class:" + r), t.constructor = r);
}
var NodeType = {}, ELEMENT_NODE = NodeType.ELEMENT_NODE = 1, ATTRIBUTE_NODE = NodeType.ATTRIBUTE_NODE = 2, TEXT_NODE = NodeType.TEXT_NODE = 3, CDATA_SECTION_NODE = NodeType.CDATA_SECTION_NODE = 4, ENTITY_REFERENCE_NODE = NodeType.ENTITY_REFERENCE_NODE = 5, ENTITY_NODE = NodeType.ENTITY_NODE = 6, PROCESSING_INSTRUCTION_NODE = NodeType.PROCESSING_INSTRUCTION_NODE = 7, COMMENT_NODE = NodeType.COMMENT_NODE = 8, DOCUMENT_NODE = NodeType.DOCUMENT_NODE = 9, DOCUMENT_TYPE_NODE = NodeType.DOCUMENT_TYPE_NODE = 10, DOCUMENT_FRAGMENT_NODE = NodeType.DOCUMENT_FRAGMENT_NODE = 11, NOTATION_NODE = NodeType.NOTATION_NODE = 12, ExceptionCode = {}, ExceptionMessage = {};
ExceptionCode.INDEX_SIZE_ERR = (ExceptionMessage[1] = "Index size error", 1);
ExceptionCode.DOMSTRING_SIZE_ERR = (ExceptionMessage[2] = "DOMString size error", 2);
var HIERARCHY_REQUEST_ERR = ExceptionCode.HIERARCHY_REQUEST_ERR = (ExceptionMessage[3] = "Hierarchy request error", 3);
ExceptionCode.WRONG_DOCUMENT_ERR = (ExceptionMessage[4] = "Wrong document", 4);
ExceptionCode.INVALID_CHARACTER_ERR = (ExceptionMessage[5] = "Invalid character", 5);
ExceptionCode.NO_DATA_ALLOWED_ERR = (ExceptionMessage[6] = "No data allowed", 6);
ExceptionCode.NO_MODIFICATION_ALLOWED_ERR = (ExceptionMessage[7] = "No modification allowed", 7);
var NOT_FOUND_ERR = ExceptionCode.NOT_FOUND_ERR = (ExceptionMessage[8] = "Not found", 8);
ExceptionCode.NOT_SUPPORTED_ERR = (ExceptionMessage[9] = "Not supported", 9);
var INUSE_ATTRIBUTE_ERR = ExceptionCode.INUSE_ATTRIBUTE_ERR = (ExceptionMessage[10] = "Attribute in use", 10);
ExceptionCode.INVALID_STATE_ERR = (ExceptionMessage[11] = "Invalid state", 11);
ExceptionCode.SYNTAX_ERR = (ExceptionMessage[12] = "Syntax error", 12);
ExceptionCode.INVALID_MODIFICATION_ERR = (ExceptionMessage[13] = "Invalid modification", 13);
ExceptionCode.NAMESPACE_ERR = (ExceptionMessage[14] = "Invalid namespace", 14);
ExceptionCode.INVALID_ACCESS_ERR = (ExceptionMessage[15] = "Invalid access", 15);
function DOMException$1(r, e) {
  if (e instanceof Error)
    var t = e;
  else
    t = this, Error.call(this, ExceptionMessage[r]), this.message = ExceptionMessage[r], Error.captureStackTrace && Error.captureStackTrace(this, DOMException$1);
  return t.code = r, e && (this.message = this.message + ": " + e), t;
}
DOMException$1.prototype = Error.prototype;
copy(ExceptionCode, DOMException$1);
function NodeList() {
}
NodeList.prototype = {
  length: 0,
  item: function(r) {
    return this[r] || null;
  },
  toString: function(r, e) {
    for (var t = [], a = 0; a < this.length; a++)
      serializeToString(this[a], t, r, e);
    return t.join("");
  }
};
function LiveNodeList(r, e) {
  this._node = r, this._refresh = e, _updateLiveList(this);
}
function _updateLiveList(r) {
  var e = r._node._inc || r._node.ownerDocument._inc;
  if (r._inc != e) {
    var t = r._refresh(r._node);
    __set__(r, "length", t.length), copy(t, r), r._inc = e;
  }
}
LiveNodeList.prototype.item = function(r) {
  return _updateLiveList(this), this[r];
};
_extends(LiveNodeList, NodeList);
function NamedNodeMap() {
}
function _findNodeIndex(r, e) {
  for (var t = r.length; t--; )
    if (r[t] === e)
      return t;
}
function _addNamedNode(r, e, t, a) {
  if (a ? e[_findNodeIndex(e, a)] = t : e[e.length++] = t, r) {
    t.ownerElement = r;
    var n = r.ownerDocument;
    n && (a && _onRemoveAttribute(n, r, a), _onAddAttribute(n, r, t));
  }
}
function _removeNamedNode(r, e, t) {
  var a = _findNodeIndex(e, t);
  if (a >= 0) {
    for (var n = e.length - 1; a < n; )
      e[a] = e[++a];
    if (e.length = n, r) {
      var s = r.ownerDocument;
      s && (_onRemoveAttribute(s, r, t), t.ownerElement = null);
    }
  } else
    throw DOMException$1(NOT_FOUND_ERR, new Error(r.tagName + "@" + t));
}
NamedNodeMap.prototype = {
  length: 0,
  item: NodeList.prototype.item,
  getNamedItem: function(r) {
    for (var e = this.length; e--; ) {
      var t = this[e];
      if (t.nodeName == r)
        return t;
    }
  },
  setNamedItem: function(r) {
    var e = r.ownerElement;
    if (e && e != this._ownerElement)
      throw new DOMException$1(INUSE_ATTRIBUTE_ERR);
    var t = this.getNamedItem(r.nodeName);
    return _addNamedNode(this._ownerElement, this, r, t), t;
  },
  setNamedItemNS: function(r) {
    var e = r.ownerElement, t;
    if (e && e != this._ownerElement)
      throw new DOMException$1(INUSE_ATTRIBUTE_ERR);
    return t = this.getNamedItemNS(r.namespaceURI, r.localName), _addNamedNode(this._ownerElement, this, r, t), t;
  },
  removeNamedItem: function(r) {
    var e = this.getNamedItem(r);
    return _removeNamedNode(this._ownerElement, this, e), e;
  },
  removeNamedItemNS: function(r, e) {
    var t = this.getNamedItemNS(r, e);
    return _removeNamedNode(this._ownerElement, this, t), t;
  },
  getNamedItemNS: function(r, e) {
    for (var t = this.length; t--; ) {
      var a = this[t];
      if (a.localName == e && a.namespaceURI == r)
        return a;
    }
    return null;
  }
};
function DOMImplementation$1() {
}
DOMImplementation$1.prototype = {
  hasFeature: function(r, e) {
    return !0;
  },
  createDocument: function(r, e, t) {
    var a = new Document();
    if (a.implementation = this, a.childNodes = new NodeList(), a.doctype = t || null, t && a.appendChild(t), e) {
      var n = a.createElementNS(r, e);
      a.appendChild(n);
    }
    return a;
  },
  createDocumentType: function(r, e, t) {
    var a = new DocumentType();
    return a.name = r, a.nodeName = r, a.publicId = e || "", a.systemId = t || "", a;
  }
};
function Node() {
}
Node.prototype = {
  firstChild: null,
  lastChild: null,
  previousSibling: null,
  nextSibling: null,
  attributes: null,
  parentNode: null,
  childNodes: null,
  ownerDocument: null,
  nodeValue: null,
  namespaceURI: null,
  prefix: null,
  localName: null,
  insertBefore: function(r, e) {
    return _insertBefore(this, r, e);
  },
  replaceChild: function(r, e) {
    this.insertBefore(r, e), e && this.removeChild(e);
  },
  removeChild: function(r) {
    return _removeChild(this, r);
  },
  appendChild: function(r) {
    return this.insertBefore(r, null);
  },
  hasChildNodes: function() {
    return this.firstChild != null;
  },
  cloneNode: function(r) {
    return cloneNode(this.ownerDocument || this, this, r);
  },
  normalize: function() {
    for (var r = this.firstChild; r; ) {
      var e = r.nextSibling;
      e && e.nodeType == TEXT_NODE && r.nodeType == TEXT_NODE ? (this.removeChild(e), r.appendData(e.data)) : (r.normalize(), r = e);
    }
  },
  isSupported: function(r, e) {
    return this.ownerDocument.implementation.hasFeature(r, e);
  },
  hasAttributes: function() {
    return this.attributes.length > 0;
  },
  lookupPrefix: function(r) {
    for (var e = this; e; ) {
      var t = e._nsMap;
      if (t) {
        for (var a in t)
          if (t[a] == r)
            return a;
      }
      e = e.nodeType == ATTRIBUTE_NODE ? e.ownerDocument : e.parentNode;
    }
    return null;
  },
  lookupNamespaceURI: function(r) {
    for (var e = this; e; ) {
      var t = e._nsMap;
      if (t && r in t)
        return t[r];
      e = e.nodeType == ATTRIBUTE_NODE ? e.ownerDocument : e.parentNode;
    }
    return null;
  },
  isDefaultNamespace: function(r) {
    var e = this.lookupPrefix(r);
    return e == null;
  }
};
function _xmlEncoder(r) {
  return r == "<" && "&lt;" || r == ">" && "&gt;" || r == "&" && "&amp;" || r == '"' && "&quot;" || "&#" + r.charCodeAt() + ";";
}
copy(NodeType, Node);
copy(NodeType, Node.prototype);
function _visitNode(r, e) {
  if (e(r))
    return !0;
  if (r = r.firstChild)
    do
      if (_visitNode(r, e))
        return !0;
    while (r = r.nextSibling);
}
function Document() {
}
function _onAddAttribute(r, e, t) {
  r && r._inc++;
  var a = t.namespaceURI;
  a === NAMESPACE$2.XMLNS && (e._nsMap[t.prefix ? t.localName : ""] = t.value);
}
function _onRemoveAttribute(r, e, t, a) {
  r && r._inc++;
  var n = t.namespaceURI;
  n === NAMESPACE$2.XMLNS && delete e._nsMap[t.prefix ? t.localName : ""];
}
function _onUpdateChild(r, e, t) {
  if (r && r._inc) {
    r._inc++;
    var a = e.childNodes;
    if (t)
      a[a.length++] = t;
    else {
      for (var n = e.firstChild, s = 0; n; )
        a[s++] = n, n = n.nextSibling;
      a.length = s;
    }
  }
}
function _removeChild(r, e) {
  var t = e.previousSibling, a = e.nextSibling;
  return t ? t.nextSibling = a : r.firstChild = a, a ? a.previousSibling = t : r.lastChild = t, _onUpdateChild(r.ownerDocument, r), e;
}
function _insertBefore(r, e, t) {
  var a = e.parentNode;
  if (a && a.removeChild(e), e.nodeType === DOCUMENT_FRAGMENT_NODE) {
    var n = e.firstChild;
    if (n == null)
      return e;
    var s = e.lastChild;
  } else
    n = s = e;
  var o = t ? t.previousSibling : r.lastChild;
  n.previousSibling = o, s.nextSibling = t, o ? o.nextSibling = n : r.firstChild = n, t == null ? r.lastChild = s : t.previousSibling = s;
  do
    n.parentNode = r;
  while (n !== s && (n = n.nextSibling));
  return _onUpdateChild(r.ownerDocument || r, r), e.nodeType == DOCUMENT_FRAGMENT_NODE && (e.firstChild = e.lastChild = null), e;
}
function _appendSingleChild(r, e) {
  var t = e.parentNode;
  if (t) {
    var a = r.lastChild;
    t.removeChild(e);
    var a = r.lastChild;
  }
  var a = r.lastChild;
  return e.parentNode = r, e.previousSibling = a, e.nextSibling = null, a ? a.nextSibling = e : r.firstChild = e, r.lastChild = e, _onUpdateChild(r.ownerDocument, r, e), e;
}
Document.prototype = {
  nodeName: "#document",
  nodeType: DOCUMENT_NODE,
  doctype: null,
  documentElement: null,
  _inc: 1,
  insertBefore: function(r, e) {
    if (r.nodeType == DOCUMENT_FRAGMENT_NODE) {
      for (var t = r.firstChild; t; ) {
        var a = t.nextSibling;
        this.insertBefore(t, e), t = a;
      }
      return r;
    }
    return this.documentElement == null && r.nodeType == ELEMENT_NODE && (this.documentElement = r), _insertBefore(this, r, e), r.ownerDocument = this, r;
  },
  removeChild: function(r) {
    return this.documentElement == r && (this.documentElement = null), _removeChild(this, r);
  },
  importNode: function(r, e) {
    return importNode(this, r, e);
  },
  getElementById: function(r) {
    var e = null;
    return _visitNode(this.documentElement, function(t) {
      if (t.nodeType == ELEMENT_NODE && t.getAttribute("id") == r)
        return e = t, !0;
    }), e;
  },
  getElementsByClassName: function(r) {
    var e = toOrderedSet(r);
    return new LiveNodeList(this, function(t) {
      var a = [];
      return e.length > 0 && _visitNode(t.documentElement, function(n) {
        if (n !== t && n.nodeType === ELEMENT_NODE) {
          var s = n.getAttribute("class");
          if (s) {
            var o = r === s;
            if (!o) {
              var u = toOrderedSet(s);
              o = e.every(arrayIncludes(u));
            }
            o && a.push(n);
          }
        }
      }), a;
    });
  },
  createElement: function(r) {
    var e = new Element();
    e.ownerDocument = this, e.nodeName = r, e.tagName = r, e.localName = r, e.childNodes = new NodeList();
    var t = e.attributes = new NamedNodeMap();
    return t._ownerElement = e, e;
  },
  createDocumentFragment: function() {
    var r = new DocumentFragment();
    return r.ownerDocument = this, r.childNodes = new NodeList(), r;
  },
  createTextNode: function(r) {
    var e = new Text();
    return e.ownerDocument = this, e.appendData(r), e;
  },
  createComment: function(r) {
    var e = new Comment();
    return e.ownerDocument = this, e.appendData(r), e;
  },
  createCDATASection: function(r) {
    var e = new CDATASection();
    return e.ownerDocument = this, e.appendData(r), e;
  },
  createProcessingInstruction: function(r, e) {
    var t = new ProcessingInstruction();
    return t.ownerDocument = this, t.tagName = t.target = r, t.nodeValue = t.data = e, t;
  },
  createAttribute: function(r) {
    var e = new Attr();
    return e.ownerDocument = this, e.name = r, e.nodeName = r, e.localName = r, e.specified = !0, e;
  },
  createEntityReference: function(r) {
    var e = new EntityReference();
    return e.ownerDocument = this, e.nodeName = r, e;
  },
  createElementNS: function(r, e) {
    var t = new Element(), a = e.split(":"), n = t.attributes = new NamedNodeMap();
    return t.childNodes = new NodeList(), t.ownerDocument = this, t.nodeName = e, t.tagName = e, t.namespaceURI = r, a.length == 2 ? (t.prefix = a[0], t.localName = a[1]) : t.localName = e, n._ownerElement = t, t;
  },
  createAttributeNS: function(r, e) {
    var t = new Attr(), a = e.split(":");
    return t.ownerDocument = this, t.nodeName = e, t.name = e, t.namespaceURI = r, t.specified = !0, a.length == 2 ? (t.prefix = a[0], t.localName = a[1]) : t.localName = e, t;
  }
};
_extends(Document, Node);
function Element() {
  this._nsMap = {};
}
Element.prototype = {
  nodeType: ELEMENT_NODE,
  hasAttribute: function(r) {
    return this.getAttributeNode(r) != null;
  },
  getAttribute: function(r) {
    var e = this.getAttributeNode(r);
    return e && e.value || "";
  },
  getAttributeNode: function(r) {
    return this.attributes.getNamedItem(r);
  },
  setAttribute: function(r, e) {
    var t = this.ownerDocument.createAttribute(r);
    t.value = t.nodeValue = "" + e, this.setAttributeNode(t);
  },
  removeAttribute: function(r) {
    var e = this.getAttributeNode(r);
    e && this.removeAttributeNode(e);
  },
  appendChild: function(r) {
    return r.nodeType === DOCUMENT_FRAGMENT_NODE ? this.insertBefore(r, null) : _appendSingleChild(this, r);
  },
  setAttributeNode: function(r) {
    return this.attributes.setNamedItem(r);
  },
  setAttributeNodeNS: function(r) {
    return this.attributes.setNamedItemNS(r);
  },
  removeAttributeNode: function(r) {
    return this.attributes.removeNamedItem(r.nodeName);
  },
  removeAttributeNS: function(r, e) {
    var t = this.getAttributeNodeNS(r, e);
    t && this.removeAttributeNode(t);
  },
  hasAttributeNS: function(r, e) {
    return this.getAttributeNodeNS(r, e) != null;
  },
  getAttributeNS: function(r, e) {
    var t = this.getAttributeNodeNS(r, e);
    return t && t.value || "";
  },
  setAttributeNS: function(r, e, t) {
    var a = this.ownerDocument.createAttributeNS(r, e);
    a.value = a.nodeValue = "" + t, this.setAttributeNode(a);
  },
  getAttributeNodeNS: function(r, e) {
    return this.attributes.getNamedItemNS(r, e);
  },
  getElementsByTagName: function(r) {
    return new LiveNodeList(this, function(e) {
      var t = [];
      return _visitNode(e, function(a) {
        a !== e && a.nodeType == ELEMENT_NODE && (r === "*" || a.tagName == r) && t.push(a);
      }), t;
    });
  },
  getElementsByTagNameNS: function(r, e) {
    return new LiveNodeList(this, function(t) {
      var a = [];
      return _visitNode(t, function(n) {
        n !== t && n.nodeType === ELEMENT_NODE && (r === "*" || n.namespaceURI === r) && (e === "*" || n.localName == e) && a.push(n);
      }), a;
    });
  }
};
Document.prototype.getElementsByTagName = Element.prototype.getElementsByTagName;
Document.prototype.getElementsByTagNameNS = Element.prototype.getElementsByTagNameNS;
_extends(Element, Node);
function Attr() {
}
Attr.prototype.nodeType = ATTRIBUTE_NODE;
_extends(Attr, Node);
function CharacterData() {
}
CharacterData.prototype = {
  data: "",
  substringData: function(r, e) {
    return this.data.substring(r, r + e);
  },
  appendData: function(r) {
    r = this.data + r, this.nodeValue = this.data = r, this.length = r.length;
  },
  insertData: function(r, e) {
    this.replaceData(r, 0, e);
  },
  appendChild: function(r) {
    throw new Error(ExceptionMessage[HIERARCHY_REQUEST_ERR]);
  },
  deleteData: function(r, e) {
    this.replaceData(r, e, "");
  },
  replaceData: function(r, e, t) {
    var a = this.data.substring(0, r), n = this.data.substring(r + e);
    t = a + t + n, this.nodeValue = this.data = t, this.length = t.length;
  }
};
_extends(CharacterData, Node);
function Text() {
}
Text.prototype = {
  nodeName: "#text",
  nodeType: TEXT_NODE,
  splitText: function(r) {
    var e = this.data, t = e.substring(r);
    e = e.substring(0, r), this.data = this.nodeValue = e, this.length = e.length;
    var a = this.ownerDocument.createTextNode(t);
    return this.parentNode && this.parentNode.insertBefore(a, this.nextSibling), a;
  }
};
_extends(Text, CharacterData);
function Comment() {
}
Comment.prototype = {
  nodeName: "#comment",
  nodeType: COMMENT_NODE
};
_extends(Comment, CharacterData);
function CDATASection() {
}
CDATASection.prototype = {
  nodeName: "#cdata-section",
  nodeType: CDATA_SECTION_NODE
};
_extends(CDATASection, CharacterData);
function DocumentType() {
}
DocumentType.prototype.nodeType = DOCUMENT_TYPE_NODE;
_extends(DocumentType, Node);
function Notation() {
}
Notation.prototype.nodeType = NOTATION_NODE;
_extends(Notation, Node);
function Entity() {
}
Entity.prototype.nodeType = ENTITY_NODE;
_extends(Entity, Node);
function EntityReference() {
}
EntityReference.prototype.nodeType = ENTITY_REFERENCE_NODE;
_extends(EntityReference, Node);
function DocumentFragment() {
}
DocumentFragment.prototype.nodeName = "#document-fragment";
DocumentFragment.prototype.nodeType = DOCUMENT_FRAGMENT_NODE;
_extends(DocumentFragment, Node);
function ProcessingInstruction() {
}
ProcessingInstruction.prototype.nodeType = PROCESSING_INSTRUCTION_NODE;
_extends(ProcessingInstruction, Node);
function XMLSerializer() {
}
XMLSerializer.prototype.serializeToString = function(r, e, t) {
  return nodeSerializeToString.call(r, e, t);
};
Node.prototype.toString = nodeSerializeToString;
function nodeSerializeToString(r, e) {
  var t = [], a = this.nodeType == 9 && this.documentElement || this, n = a.prefix, s = a.namespaceURI;
  if (s && n == null) {
    var n = a.lookupPrefix(s);
    if (n == null)
      var o = [
        { namespace: s, prefix: null }
      ];
  }
  return serializeToString(this, t, r, e, o), t.join("");
}
function needNamespaceDefine(r, e, t) {
  var a = r.prefix || "", n = r.namespaceURI;
  if (!n || a === "xml" && n === NAMESPACE$2.XML || n === NAMESPACE$2.XMLNS)
    return !1;
  for (var s = t.length; s--; ) {
    var o = t[s];
    if (o.prefix === a)
      return o.namespace !== n;
  }
  return !0;
}
function addSerializedAttribute(r, e, t) {
  r.push(" ", e, '="', t.replace(/[<&"]/g, _xmlEncoder), '"');
}
function serializeToString(r, e, t, a, n) {
  if (n || (n = []), a)
    if (r = a(r), r) {
      if (typeof r == "string") {
        e.push(r);
        return;
      }
    } else
      return;
  switch (r.nodeType) {
    case ELEMENT_NODE:
      var s = r.attributes, o = s.length, O = r.firstChild, u = r.tagName;
      t = NAMESPACE$2.isHTML(r.namespaceURI) || t;
      var l = u;
      if (!t && !r.prefix && r.namespaceURI) {
        for (var f, d = 0; d < s.length; d++)
          if (s.item(d).name === "xmlns") {
            f = s.item(d).value;
            break;
          }
        if (!f)
          for (var h = n.length - 1; h >= 0; h--) {
            var p = n[h];
            if (p.prefix === "" && p.namespace === r.namespaceURI) {
              f = p.namespace;
              break;
            }
          }
        if (f !== r.namespaceURI)
          for (var h = n.length - 1; h >= 0; h--) {
            var p = n[h];
            if (p.namespace === r.namespaceURI) {
              p.prefix && (l = p.prefix + ":" + u);
              break;
            }
          }
      }
      e.push("<", l);
      for (var m = 0; m < o; m++) {
        var _ = s.item(m);
        _.prefix == "xmlns" ? n.push({ prefix: _.localName, namespace: _.value }) : _.nodeName == "xmlns" && n.push({ prefix: "", namespace: _.value });
      }
      for (var m = 0; m < o; m++) {
        var _ = s.item(m);
        if (needNamespaceDefine(_, t, n)) {
          var w = _.prefix || "", S = _.namespaceURI;
          addSerializedAttribute(e, w ? "xmlns:" + w : "xmlns", S), n.push({ prefix: w, namespace: S });
        }
        serializeToString(_, e, t, a, n);
      }
      if (u === l && needNamespaceDefine(r, t, n)) {
        var w = r.prefix || "", S = r.namespaceURI;
        addSerializedAttribute(e, w ? "xmlns:" + w : "xmlns", S), n.push({ prefix: w, namespace: S });
      }
      if (O || t && !/^(?:meta|link|img|br|hr|input)$/i.test(u)) {
        if (e.push(">"), t && /^script$/i.test(u))
          for (; O; )
            O.data ? e.push(O.data) : serializeToString(O, e, t, a, n.slice()), O = O.nextSibling;
        else
          for (; O; )
            serializeToString(O, e, t, a, n.slice()), O = O.nextSibling;
        e.push("</", l, ">");
      } else
        e.push("/>");
      return;
    case DOCUMENT_NODE:
    case DOCUMENT_FRAGMENT_NODE:
      for (var O = r.firstChild; O; )
        serializeToString(O, e, t, a, n.slice()), O = O.nextSibling;
      return;
    case ATTRIBUTE_NODE:
      return addSerializedAttribute(e, r.name, r.value);
    case TEXT_NODE:
      return e.push(
        r.data.replace(/[<&]/g, _xmlEncoder).replace(/]]>/g, "]]&gt;")
      );
    case CDATA_SECTION_NODE:
      return e.push("<![CDATA[", r.data, "]]>");
    case COMMENT_NODE:
      return e.push("<!--", r.data, "-->");
    case DOCUMENT_TYPE_NODE:
      var k = r.publicId, B = r.systemId;
      if (e.push("<!DOCTYPE ", r.name), k)
        e.push(" PUBLIC ", k), B && B != "." && e.push(" ", B), e.push(">");
      else if (B && B != ".")
        e.push(" SYSTEM ", B, ">");
      else {
        var L = r.internalSubset;
        L && e.push(" [", L, "]"), e.push(">");
      }
      return;
    case PROCESSING_INSTRUCTION_NODE:
      return e.push("<?", r.target, " ", r.data, "?>");
    case ENTITY_REFERENCE_NODE:
      return e.push("&", r.nodeName, ";");
    default:
      e.push("??", r.nodeName);
  }
}
function importNode(r, e, t) {
  var a;
  switch (e.nodeType) {
    case ELEMENT_NODE:
      a = e.cloneNode(!1), a.ownerDocument = r;
    case DOCUMENT_FRAGMENT_NODE:
      break;
    case ATTRIBUTE_NODE:
      t = !0;
      break;
  }
  if (a || (a = e.cloneNode(!1)), a.ownerDocument = r, a.parentNode = null, t)
    for (var n = e.firstChild; n; )
      a.appendChild(importNode(r, n, t)), n = n.nextSibling;
  return a;
}
function cloneNode(r, e, t) {
  var a = new e.constructor();
  for (var n in e) {
    var s = e[n];
    typeof s != "object" && s != a[n] && (a[n] = s);
  }
  switch (e.childNodes && (a.childNodes = new NodeList()), a.ownerDocument = r, a.nodeType) {
    case ELEMENT_NODE:
      var o = e.attributes, u = a.attributes = new NamedNodeMap(), l = o.length;
      u._ownerElement = a;
      for (var f = 0; f < l; f++)
        a.setAttributeNode(cloneNode(r, o.item(f), !0));
      break;
    case ATTRIBUTE_NODE:
      t = !0;
  }
  if (t)
    for (var d = e.firstChild; d; )
      a.appendChild(cloneNode(r, d, t)), d = d.nextSibling;
  return a;
}
function __set__(r, e, t) {
  r[e] = t;
}
try {
  if (Object.defineProperty) {
    let r = function(e) {
      switch (e.nodeType) {
        case ELEMENT_NODE:
        case DOCUMENT_FRAGMENT_NODE:
          var t = [];
          for (e = e.firstChild; e; )
            e.nodeType !== 7 && e.nodeType !== 8 && t.push(r(e)), e = e.nextSibling;
          return t.join("");
        default:
          return e.nodeValue;
      }
    };
    Object.defineProperty(LiveNodeList.prototype, "length", {
      get: function() {
        return _updateLiveList(this), this.$$length;
      }
    }), Object.defineProperty(Node.prototype, "textContent", {
      get: function() {
        return r(this);
      },
      set: function(e) {
        switch (this.nodeType) {
          case ELEMENT_NODE:
          case DOCUMENT_FRAGMENT_NODE:
            for (; this.firstChild; )
              this.removeChild(this.firstChild);
            (e || String(e)) && this.appendChild(this.ownerDocument.createTextNode(e));
            break;
          default:
            this.data = e, this.value = e, this.nodeValue = e;
        }
      }
    }), __set__ = function(e, t, a) {
      e["$$" + t] = a;
    };
  }
} catch (r) {
}
dom$1.DocumentType = DocumentType;
dom$1.DOMException = DOMException$1;
dom$1.DOMImplementation = DOMImplementation$1;
dom$1.Element = Element;
dom$1.Node = Node;
dom$1.NodeList = NodeList;
dom$1.XMLSerializer = XMLSerializer;
var domParser = {}, entities$1 = {};
(function(r) {
  var e = conventions$2.freeze;
  r.XML_ENTITIES = e({ amp: "&", apos: "'", gt: ">", lt: "<", quot: '"' }), r.HTML_ENTITIES = e({
    lt: "<",
    gt: ">",
    amp: "&",
    quot: '"',
    apos: "'",
    Agrave: "\xC0",
    Aacute: "\xC1",
    Acirc: "\xC2",
    Atilde: "\xC3",
    Auml: "\xC4",
    Aring: "\xC5",
    AElig: "\xC6",
    Ccedil: "\xC7",
    Egrave: "\xC8",
    Eacute: "\xC9",
    Ecirc: "\xCA",
    Euml: "\xCB",
    Igrave: "\xCC",
    Iacute: "\xCD",
    Icirc: "\xCE",
    Iuml: "\xCF",
    ETH: "\xD0",
    Ntilde: "\xD1",
    Ograve: "\xD2",
    Oacute: "\xD3",
    Ocirc: "\xD4",
    Otilde: "\xD5",
    Ouml: "\xD6",
    Oslash: "\xD8",
    Ugrave: "\xD9",
    Uacute: "\xDA",
    Ucirc: "\xDB",
    Uuml: "\xDC",
    Yacute: "\xDD",
    THORN: "\xDE",
    szlig: "\xDF",
    agrave: "\xE0",
    aacute: "\xE1",
    acirc: "\xE2",
    atilde: "\xE3",
    auml: "\xE4",
    aring: "\xE5",
    aelig: "\xE6",
    ccedil: "\xE7",
    egrave: "\xE8",
    eacute: "\xE9",
    ecirc: "\xEA",
    euml: "\xEB",
    igrave: "\xEC",
    iacute: "\xED",
    icirc: "\xEE",
    iuml: "\xEF",
    eth: "\xF0",
    ntilde: "\xF1",
    ograve: "\xF2",
    oacute: "\xF3",
    ocirc: "\xF4",
    otilde: "\xF5",
    ouml: "\xF6",
    oslash: "\xF8",
    ugrave: "\xF9",
    uacute: "\xFA",
    ucirc: "\xFB",
    uuml: "\xFC",
    yacute: "\xFD",
    thorn: "\xFE",
    yuml: "\xFF",
    nbsp: "\xA0",
    iexcl: "\xA1",
    cent: "\xA2",
    pound: "\xA3",
    curren: "\xA4",
    yen: "\xA5",
    brvbar: "\xA6",
    sect: "\xA7",
    uml: "\xA8",
    copy: "\xA9",
    ordf: "\xAA",
    laquo: "\xAB",
    not: "\xAC",
    shy: "\xAD\xAD",
    reg: "\xAE",
    macr: "\xAF",
    deg: "\xB0",
    plusmn: "\xB1",
    sup2: "\xB2",
    sup3: "\xB3",
    acute: "\xB4",
    micro: "\xB5",
    para: "\xB6",
    middot: "\xB7",
    cedil: "\xB8",
    sup1: "\xB9",
    ordm: "\xBA",
    raquo: "\xBB",
    frac14: "\xBC",
    frac12: "\xBD",
    frac34: "\xBE",
    iquest: "\xBF",
    times: "\xD7",
    divide: "\xF7",
    forall: "\u2200",
    part: "\u2202",
    exist: "\u2203",
    empty: "\u2205",
    nabla: "\u2207",
    isin: "\u2208",
    notin: "\u2209",
    ni: "\u220B",
    prod: "\u220F",
    sum: "\u2211",
    minus: "\u2212",
    lowast: "\u2217",
    radic: "\u221A",
    prop: "\u221D",
    infin: "\u221E",
    ang: "\u2220",
    and: "\u2227",
    or: "\u2228",
    cap: "\u2229",
    cup: "\u222A",
    int: "\u222B",
    there4: "\u2234",
    sim: "\u223C",
    cong: "\u2245",
    asymp: "\u2248",
    ne: "\u2260",
    equiv: "\u2261",
    le: "\u2264",
    ge: "\u2265",
    sub: "\u2282",
    sup: "\u2283",
    nsub: "\u2284",
    sube: "\u2286",
    supe: "\u2287",
    oplus: "\u2295",
    otimes: "\u2297",
    perp: "\u22A5",
    sdot: "\u22C5",
    Alpha: "\u0391",
    Beta: "\u0392",
    Gamma: "\u0393",
    Delta: "\u0394",
    Epsilon: "\u0395",
    Zeta: "\u0396",
    Eta: "\u0397",
    Theta: "\u0398",
    Iota: "\u0399",
    Kappa: "\u039A",
    Lambda: "\u039B",
    Mu: "\u039C",
    Nu: "\u039D",
    Xi: "\u039E",
    Omicron: "\u039F",
    Pi: "\u03A0",
    Rho: "\u03A1",
    Sigma: "\u03A3",
    Tau: "\u03A4",
    Upsilon: "\u03A5",
    Phi: "\u03A6",
    Chi: "\u03A7",
    Psi: "\u03A8",
    Omega: "\u03A9",
    alpha: "\u03B1",
    beta: "\u03B2",
    gamma: "\u03B3",
    delta: "\u03B4",
    epsilon: "\u03B5",
    zeta: "\u03B6",
    eta: "\u03B7",
    theta: "\u03B8",
    iota: "\u03B9",
    kappa: "\u03BA",
    lambda: "\u03BB",
    mu: "\u03BC",
    nu: "\u03BD",
    xi: "\u03BE",
    omicron: "\u03BF",
    pi: "\u03C0",
    rho: "\u03C1",
    sigmaf: "\u03C2",
    sigma: "\u03C3",
    tau: "\u03C4",
    upsilon: "\u03C5",
    phi: "\u03C6",
    chi: "\u03C7",
    psi: "\u03C8",
    omega: "\u03C9",
    thetasym: "\u03D1",
    upsih: "\u03D2",
    piv: "\u03D6",
    OElig: "\u0152",
    oelig: "\u0153",
    Scaron: "\u0160",
    scaron: "\u0161",
    Yuml: "\u0178",
    fnof: "\u0192",
    circ: "\u02C6",
    tilde: "\u02DC",
    ensp: "\u2002",
    emsp: "\u2003",
    thinsp: "\u2009",
    zwnj: "\u200C",
    zwj: "\u200D",
    lrm: "\u200E",
    rlm: "\u200F",
    ndash: "\u2013",
    mdash: "\u2014",
    lsquo: "\u2018",
    rsquo: "\u2019",
    sbquo: "\u201A",
    ldquo: "\u201C",
    rdquo: "\u201D",
    bdquo: "\u201E",
    dagger: "\u2020",
    Dagger: "\u2021",
    bull: "\u2022",
    hellip: "\u2026",
    permil: "\u2030",
    prime: "\u2032",
    Prime: "\u2033",
    lsaquo: "\u2039",
    rsaquo: "\u203A",
    oline: "\u203E",
    euro: "\u20AC",
    trade: "\u2122",
    larr: "\u2190",
    uarr: "\u2191",
    rarr: "\u2192",
    darr: "\u2193",
    harr: "\u2194",
    crarr: "\u21B5",
    lceil: "\u2308",
    rceil: "\u2309",
    lfloor: "\u230A",
    rfloor: "\u230B",
    loz: "\u25CA",
    spades: "\u2660",
    clubs: "\u2663",
    hearts: "\u2665",
    diams: "\u2666"
  }), r.entityMap = r.HTML_ENTITIES;
})(entities$1);
var sax$1 = {}, NAMESPACE$1 = conventions$2.NAMESPACE, nameStartChar = /[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/, nameChar = new RegExp("[\\-\\.0-9" + nameStartChar.source.slice(1, -1) + "\\u00B7\\u0300-\\u036F\\u203F-\\u2040]"), tagNamePattern = new RegExp("^" + nameStartChar.source + nameChar.source + "*(?::" + nameStartChar.source + nameChar.source + "*)?$"), S_TAG = 0, S_ATTR = 1, S_ATTR_SPACE = 2, S_EQ = 3, S_ATTR_NOQUOT_VALUE = 4, S_ATTR_END = 5, S_TAG_SPACE = 6, S_TAG_CLOSE = 7;
function ParseError$1(r, e) {
  this.message = r, this.locator = e, Error.captureStackTrace && Error.captureStackTrace(this, ParseError$1);
}
ParseError$1.prototype = new Error();
ParseError$1.prototype.name = ParseError$1.name;
function XMLReader$1() {
}
XMLReader$1.prototype = {
  parse: function(r, e, t) {
    var a = this.domBuilder;
    a.startDocument(), _copy(e, e = {}), parse$1(
      r,
      e,
      t,
      a,
      this.errorHandler
    ), a.endDocument();
  }
};
function parse$1(r, e, t, a, n) {
  function s(ea) {
    if (ea > 65535) {
      ea -= 65536;
      var wa = 55296 + (ea >> 10), _s = 56320 + (ea & 1023);
      return String.fromCharCode(wa, _s);
    } else
      return String.fromCharCode(ea);
  }
  function o(ea) {
    var wa = ea.slice(1, -1);
    return wa in t ? t[wa] : wa.charAt(0) === "#" ? s(parseInt(wa.substr(1).replace("x", "0x"))) : (n.error("entity not found:" + ea), ea);
  }
  function u(ea) {
    if (ea > w) {
      var wa = r.substring(w, ea).replace(/&#?\w+;/g, o);
      p && l(w), a.characters(wa, 0, ea - w), w = ea;
    }
  }
  function l(ea, wa) {
    for (; ea >= d && (wa = h.exec(r)); )
      f = wa.index, d = f + wa[0].length, p.lineNumber++;
    p.columnNumber = ea - f + 1;
  }
  for (var f = 0, d = 0, h = /.*(?:\r\n?|\n)|.*$/g, p = a.locator, m = [{ currentNSMap: e }], _ = {}, w = 0; ; ) {
    try {
      var S = r.indexOf("<", w);
      if (S < 0) {
        if (!r.substr(w).match(/^\s*$/)) {
          var O = a.doc, k = O.createTextNode(r.substr(w));
          O.appendChild(k), a.currentElement = k;
        }
        return;
      }
      switch (S > w && u(S), r.charAt(S + 1)) {
        case "/":
          var _t = r.indexOf(">", S + 3), B = r.substring(S + 2, _t).replace(/[ \t\n\r]+$/g, ""), L = m.pop();
          _t < 0 ? (B = r.substring(S + 2).replace(/[\s<].*/, ""), n.error("end tag name: " + B + " is not complete:" + L.tagName), _t = S + 1 + B.length) : B.match(/\s</) && (B = B.replace(/[\s<].*/, ""), n.error("end tag name: " + B + " maybe not complete"), _t = S + 1 + B.length);
          var G = L.localNSMap, _r = L.tagName == B, ga = _r || L.tagName && L.tagName.toLowerCase() == B.toLowerCase();
          if (ga) {
            if (a.endElement(L.uri, L.localName, B), G)
              for (var _n in G)
                a.endPrefixMapping(_n);
            _r || n.fatalError("end tag name: " + B + " is not match the current start tagName:" + L.tagName);
          } else
            m.push(L);
          _t++;
          break;
        case "?":
          p && l(S), _t = parseInstruction(r, S, a);
          break;
        case "!":
          p && l(S), _t = parseDCC(r, S, a, n);
          break;
        default:
          p && l(S);
          var Fa = new ElementAttributes(), N = m[m.length - 1].currentNSMap, _t = parseElementStartPart(r, S, Fa, N, o, n), Y = Fa.length;
          if (!Fa.closed && fixSelfClosed(r, _t, Fa.tagName, _) && (Fa.closed = !0, t.nbsp || n.warning("unclosed xml attribute")), p && Y) {
            for (var _a = copyLocator(p, {}), X = 0; X < Y; X++) {
              var J = Fa[X];
              l(J.offset), J.locator = copyLocator(p, {});
            }
            a.locator = _a, appendElement$1(Fa, a, N) && m.push(Fa), a.locator = p;
          } else
            appendElement$1(Fa, a, N) && m.push(Fa);
          NAMESPACE$1.isHTML(Fa.uri) && !Fa.closed ? _t = parseHtmlSpecialContent(r, _t, Fa.tagName, o, a) : _t++;
      }
    } catch (ea) {
      if (ea instanceof ParseError$1)
        throw ea;
      n.error("element parse error: " + ea), _t = -1;
    }
    _t > w ? w = _t : u(Math.max(S, w) + 1);
  }
}
function copyLocator(r, e) {
  return e.lineNumber = r.lineNumber, e.columnNumber = r.columnNumber, e;
}
function parseElementStartPart(r, e, t, a, n, s) {
  function o(p, m, _) {
    t.attributeNames.hasOwnProperty(p) && s.fatalError("Attribute " + p + " redefined"), t.addValue(p, m, _);
  }
  for (var u, l, f = ++e, d = S_TAG; ; ) {
    var h = r.charAt(f);
    switch (h) {
      case "=":
        if (d === S_ATTR)
          u = r.slice(e, f), d = S_EQ;
        else if (d === S_ATTR_SPACE)
          d = S_EQ;
        else
          throw new Error("attribute equal must after attrName");
        break;
      case "'":
      case '"':
        if (d === S_EQ || d === S_ATTR)
          if (d === S_ATTR && (s.warning('attribute value must after "="'), u = r.slice(e, f)), e = f + 1, f = r.indexOf(h, e), f > 0)
            l = r.slice(e, f).replace(/&#?\w+;/g, n), o(u, l, e - 1), d = S_ATTR_END;
          else
            throw new Error("attribute value no end '" + h + "' match");
        else if (d == S_ATTR_NOQUOT_VALUE)
          l = r.slice(e, f).replace(/&#?\w+;/g, n), o(u, l, e), s.warning('attribute "' + u + '" missed start quot(' + h + ")!!"), e = f + 1, d = S_ATTR_END;
        else
          throw new Error('attribute value must after "="');
        break;
      case "/":
        switch (d) {
          case S_TAG:
            t.setTagName(r.slice(e, f));
          case S_ATTR_END:
          case S_TAG_SPACE:
          case S_TAG_CLOSE:
            d = S_TAG_CLOSE, t.closed = !0;
          case S_ATTR_NOQUOT_VALUE:
          case S_ATTR:
          case S_ATTR_SPACE:
            break;
          default:
            throw new Error("attribute invalid close char('/')");
        }
        break;
      case "":
        return s.error("unexpected end of input"), d == S_TAG && t.setTagName(r.slice(e, f)), f;
      case ">":
        switch (d) {
          case S_TAG:
            t.setTagName(r.slice(e, f));
          case S_ATTR_END:
          case S_TAG_SPACE:
          case S_TAG_CLOSE:
            break;
          case S_ATTR_NOQUOT_VALUE:
          case S_ATTR:
            l = r.slice(e, f), l.slice(-1) === "/" && (t.closed = !0, l = l.slice(0, -1));
          case S_ATTR_SPACE:
            d === S_ATTR_SPACE && (l = u), d == S_ATTR_NOQUOT_VALUE ? (s.warning('attribute "' + l + '" missed quot(")!'), o(u, l.replace(/&#?\w+;/g, n), e)) : ((!NAMESPACE$1.isHTML(a[""]) || !l.match(/^(?:disabled|checked|selected)$/i)) && s.warning('attribute "' + l + '" missed value!! "' + l + '" instead!!'), o(l, l, e));
            break;
          case S_EQ:
            throw new Error("attribute value missed!!");
        }
        return f;
      case "\x80":
        h = " ";
      default:
        if (h <= " ")
          switch (d) {
            case S_TAG:
              t.setTagName(r.slice(e, f)), d = S_TAG_SPACE;
              break;
            case S_ATTR:
              u = r.slice(e, f), d = S_ATTR_SPACE;
              break;
            case S_ATTR_NOQUOT_VALUE:
              var l = r.slice(e, f).replace(/&#?\w+;/g, n);
              s.warning('attribute "' + l + '" missed quot(")!!'), o(u, l, e);
            case S_ATTR_END:
              d = S_TAG_SPACE;
              break;
          }
        else
          switch (d) {
            case S_ATTR_SPACE:
              t.tagName, (!NAMESPACE$1.isHTML(a[""]) || !u.match(/^(?:disabled|checked|selected)$/i)) && s.warning('attribute "' + u + '" missed value!! "' + u + '" instead2!!'), o(u, u, e), e = f, d = S_ATTR;
              break;
            case S_ATTR_END:
              s.warning('attribute space is required"' + u + '"!!');
            case S_TAG_SPACE:
              d = S_ATTR, e = f;
              break;
            case S_EQ:
              d = S_ATTR_NOQUOT_VALUE, e = f;
              break;
            case S_TAG_CLOSE:
              throw new Error("elements closed character '/' and '>' must be connected to");
          }
    }
    f++;
  }
}
function appendElement$1(r, e, t) {
  for (var a = r.tagName, n = null, h = r.length; h--; ) {
    var s = r[h], o = s.qName, u = s.value, p = o.indexOf(":");
    if (p > 0)
      var l = s.prefix = o.slice(0, p), f = o.slice(p + 1), d = l === "xmlns" && f;
    else
      f = o, l = null, d = o === "xmlns" && "";
    s.localName = f, d !== !1 && (n == null && (n = {}, _copy(t, t = {})), t[d] = n[d] = u, s.uri = NAMESPACE$1.XMLNS, e.startPrefixMapping(d, u));
  }
  for (var h = r.length; h--; ) {
    s = r[h];
    var l = s.prefix;
    l && (l === "xml" && (s.uri = NAMESPACE$1.XML), l !== "xmlns" && (s.uri = t[l || ""]));
  }
  var p = a.indexOf(":");
  p > 0 ? (l = r.prefix = a.slice(0, p), f = r.localName = a.slice(p + 1)) : (l = null, f = r.localName = a);
  var m = r.uri = t[l || ""];
  if (e.startElement(m, f, a, r), r.closed) {
    if (e.endElement(m, f, a), n)
      for (l in n)
        e.endPrefixMapping(l);
  } else
    return r.currentNSMap = t, r.localNSMap = n, !0;
}
function parseHtmlSpecialContent(r, e, t, a, n) {
  if (/^(?:script|textarea)$/i.test(t)) {
    var s = r.indexOf("</" + t + ">", e), o = r.substring(e + 1, s);
    if (/[&<]/.test(o))
      return /^script$/i.test(t) ? (n.characters(o, 0, o.length), s) : (o = o.replace(/&#?\w+;/g, a), n.characters(o, 0, o.length), s);
  }
  return e + 1;
}
function fixSelfClosed(r, e, t, a) {
  var n = a[t];
  return n == null && (n = r.lastIndexOf("</" + t + ">"), n < e && (n = r.lastIndexOf("</" + t)), a[t] = n), n < e;
}
function _copy(r, e) {
  for (var t in r)
    e[t] = r[t];
}
function parseDCC(r, e, t, a) {
  var n = r.charAt(e + 2);
  switch (n) {
    case "-":
      if (r.charAt(e + 3) === "-") {
        var s = r.indexOf("-->", e + 4);
        return s > e ? (t.comment(r, e + 4, s - e - 4), s + 3) : (a.error("Unclosed comment"), -1);
      } else
        return -1;
    default:
      if (r.substr(e + 3, 6) == "CDATA[") {
        var s = r.indexOf("]]>", e + 9);
        return t.startCDATA(), t.characters(r, e + 9, s - e - 9), t.endCDATA(), s + 3;
      }
      var o = split(r, e), u = o.length;
      if (u > 1 && /!doctype/i.test(o[0][0])) {
        var l = o[1][0], f = !1, d = !1;
        u > 3 && (/^public$/i.test(o[2][0]) ? (f = o[3][0], d = u > 4 && o[4][0]) : /^system$/i.test(o[2][0]) && (d = o[3][0]));
        var h = o[u - 1];
        return t.startDTD(l, f, d), t.endDTD(), h.index + h[0].length;
      }
  }
  return -1;
}
function parseInstruction(r, e, t) {
  var a = r.indexOf("?>", e);
  if (a) {
    var n = r.substring(e, a).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);
    return n ? (n[0].length, t.processingInstruction(n[1], n[2]), a + 2) : -1;
  }
  return -1;
}
function ElementAttributes() {
  this.attributeNames = {};
}
ElementAttributes.prototype = {
  setTagName: function(r) {
    if (!tagNamePattern.test(r))
      throw new Error("invalid tagName:" + r);
    this.tagName = r;
  },
  addValue: function(r, e, t) {
    if (!tagNamePattern.test(r))
      throw new Error("invalid attribute:" + r);
    this.attributeNames[r] = this.length, this[this.length++] = { qName: r, value: e, offset: t };
  },
  length: 0,
  getLocalName: function(r) {
    return this[r].localName;
  },
  getLocator: function(r) {
    return this[r].locator;
  },
  getQName: function(r) {
    return this[r].qName;
  },
  getURI: function(r) {
    return this[r].uri;
  },
  getValue: function(r) {
    return this[r].value;
  }
};
function split(r, e) {
  var t, a = [], n = /'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;
  for (n.lastIndex = e, n.exec(r); t = n.exec(r); )
    if (a.push(t), t[1])
      return a;
}
sax$1.XMLReader = XMLReader$1;
sax$1.ParseError = ParseError$1;
var conventions = conventions$2, dom = dom$1, entities = entities$1, sax = sax$1, DOMImplementation = dom.DOMImplementation, NAMESPACE = conventions.NAMESPACE, ParseError = sax.ParseError, XMLReader = sax.XMLReader;
function DOMParser$1(r) {
  this.options = r || { locator: {} };
}
DOMParser$1.prototype.parseFromString = function(r, e) {
  var t = this.options, a = new XMLReader(), n = t.domBuilder || new DOMHandler(), s = t.errorHandler, o = t.locator, u = t.xmlns || {}, l = /\/x?html?$/.test(e), f = l ? entities.HTML_ENTITIES : entities.XML_ENTITIES;
  return o && n.setDocumentLocator(o), a.errorHandler = buildErrorHandler(s, n, o), a.domBuilder = t.domBuilder || n, l && (u[""] = NAMESPACE.HTML), u.xml = u.xml || NAMESPACE.XML, r && typeof r == "string" ? a.parse(r, u, f) : a.errorHandler.error("invalid doc source"), n.doc;
};
function buildErrorHandler(r, e, t) {
  if (!r) {
    if (e instanceof DOMHandler)
      return e;
    r = e;
  }
  var a = {}, n = r instanceof Function;
  t = t || {};
  function s(o) {
    var u = r[o];
    !u && n && (u = r.length == 2 ? function(l) {
      r(o, l);
    } : r), a[o] = u && function(l) {
      u("[xmldom " + o + "]	" + l + _locator(t));
    } || function() {
    };
  }
  return s("warning"), s("error"), s("fatalError"), a;
}
function DOMHandler() {
  this.cdata = !1;
}
function position(r, e) {
  e.lineNumber = r.lineNumber, e.columnNumber = r.columnNumber;
}
DOMHandler.prototype = {
  startDocument: function() {
    this.doc = new DOMImplementation().createDocument(null, null, null), this.locator && (this.doc.documentURI = this.locator.systemId);
  },
  startElement: function(r, e, t, a) {
    var n = this.doc, s = n.createElementNS(r, t || e), o = a.length;
    appendElement(this, s), this.currentElement = s, this.locator && position(this.locator, s);
    for (var u = 0; u < o; u++) {
      var r = a.getURI(u), l = a.getValue(u), t = a.getQName(u), f = n.createAttributeNS(r, t);
      this.locator && position(a.getLocator(u), f), f.value = f.nodeValue = l, s.setAttributeNode(f);
    }
  },
  endElement: function(r, e, t) {
    var a = this.currentElement;
    a.tagName, this.currentElement = a.parentNode;
  },
  startPrefixMapping: function(r, e) {
  },
  endPrefixMapping: function(r) {
  },
  processingInstruction: function(r, e) {
    var t = this.doc.createProcessingInstruction(r, e);
    this.locator && position(this.locator, t), appendElement(this, t);
  },
  ignorableWhitespace: function(r, e, t) {
  },
  characters: function(r, e, t) {
    if (r = _toString.apply(this, arguments), r) {
      if (this.cdata)
        var a = this.doc.createCDATASection(r);
      else
        var a = this.doc.createTextNode(r);
      this.currentElement ? this.currentElement.appendChild(a) : /^\s*$/.test(r) && this.doc.appendChild(a), this.locator && position(this.locator, a);
    }
  },
  skippedEntity: function(r) {
  },
  endDocument: function() {
    this.doc.normalize();
  },
  setDocumentLocator: function(r) {
    (this.locator = r) && (r.lineNumber = 0);
  },
  comment: function(r, e, t) {
    r = _toString.apply(this, arguments);
    var a = this.doc.createComment(r);
    this.locator && position(this.locator, a), appendElement(this, a);
  },
  startCDATA: function() {
    this.cdata = !0;
  },
  endCDATA: function() {
    this.cdata = !1;
  },
  startDTD: function(r, e, t) {
    var a = this.doc.implementation;
    if (a && a.createDocumentType) {
      var n = a.createDocumentType(r, e, t);
      this.locator && position(this.locator, n), appendElement(this, n), this.doc.doctype = n;
    }
  },
  warning: function(r) {
    console.warn("[xmldom warning]	" + r, _locator(this.locator));
  },
  error: function(r) {
    console.error("[xmldom error]	" + r, _locator(this.locator));
  },
  fatalError: function(r) {
    throw new ParseError(r, this.locator);
  }
};
function _locator(r) {
  if (r)
    return `
@` + (r.systemId || "") + "#[line:" + r.lineNumber + ",col:" + r.columnNumber + "]";
}
function _toString(r, e, t) {
  return typeof r == "string" ? r.substr(e, t) : r.length >= e + t || e ? new java.lang.String(r, e, t) + "" : r;
}
"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g, function(r) {
  DOMHandler.prototype[r] = function() {
    return null;
  };
});
function appendElement(r, e) {
  r.currentElement ? r.currentElement.appendChild(e) : r.doc.appendChild(e);
}
domParser.__DOMHandler = DOMHandler;
domParser.DOMParser = DOMParser$1;
domParser.DOMImplementation = dom.DOMImplementation;
domParser.XMLSerializer = dom.XMLSerializer;
var DOMParser = domParser.DOMParser;
/*! @name mpd-parser @version 0.21.1 @license Apache-2.0 */
var isObject$1 = function r(e) {
  return !!e && typeof e == "object";
}, merge = function r() {
  for (var e = arguments.length, t = new Array(e), a = 0; a < e; a++)
    t[a] = arguments[a];
  return t.reduce(function(n, s) {
    return typeof s != "object" || Object.keys(s).forEach(function(o) {
      Array.isArray(n[o]) && Array.isArray(s[o]) ? n[o] = n[o].concat(s[o]) : isObject$1(n[o]) && isObject$1(s[o]) ? n[o] = r(n[o], s[o]) : n[o] = s[o];
    }), n;
  }, {});
}, values = function r(e) {
  return Object.keys(e).map(function(t) {
    return e[t];
  });
}, range = function r(e, t) {
  for (var a = [], n = e; n < t; n++)
    a.push(n);
  return a;
}, flatten = function r(e) {
  return e.reduce(function(t, a) {
    return t.concat(a);
  }, []);
}, from = function r(e) {
  if (!e.length)
    return [];
  for (var t = [], a = 0; a < e.length; a++)
    t.push(e[a]);
  return t;
}, findIndexes = function r(e, t) {
  return e.reduce(function(a, n, s) {
    return n[t] && a.push(s), a;
  }, []);
}, findIndex = function r(e, t) {
  for (var a = 0; a < e.length; a++)
    if (t(e[a]))
      return a;
  return -1;
}, union = function r(e, t) {
  return values(e.reduce(function(a, n) {
    return n.forEach(function(s) {
      a[t(s)] = s;
    }), a;
  }, {}));
}, errors = {
  INVALID_NUMBER_OF_PERIOD: "INVALID_NUMBER_OF_PERIOD",
  DASH_EMPTY_MANIFEST: "DASH_EMPTY_MANIFEST",
  DASH_INVALID_XML: "DASH_INVALID_XML",
  NO_BASE_URL: "NO_BASE_URL",
  MISSING_SEGMENT_INFORMATION: "MISSING_SEGMENT_INFORMATION",
  SEGMENT_TIME_UNSPECIFIED: "SEGMENT_TIME_UNSPECIFIED",
  UNSUPPORTED_UTC_TIMING_SCHEME: "UNSUPPORTED_UTC_TIMING_SCHEME"
}, urlTypeToSegment = function r(e) {
  var t = e.baseUrl, a = t === void 0 ? "" : t, n = e.source, s = n === void 0 ? "" : n, o = e.range, u = o === void 0 ? "" : o, l = e.indexRange, f = l === void 0 ? "" : l, d = {
    uri: s,
    resolvedUri: resolveUrl$1(a || "", s)
  };
  if (u || f) {
    var h = u || f, p = h.split("-"), m = window_1.BigInt ? window_1.BigInt(p[0]) : parseInt(p[0], 10), _ = window_1.BigInt ? window_1.BigInt(p[1]) : parseInt(p[1], 10);
    m < Number.MAX_SAFE_INTEGER && typeof m == "bigint" && (m = Number(m)), _ < Number.MAX_SAFE_INTEGER && typeof _ == "bigint" && (_ = Number(_));
    var w;
    typeof _ == "bigint" || typeof m == "bigint" ? w = window_1.BigInt(_) - window_1.BigInt(m) + window_1.BigInt(1) : w = _ - m + 1, typeof w == "bigint" && w < Number.MAX_SAFE_INTEGER && (w = Number(w)), d.byterange = {
      length: w,
      offset: m
    };
  }
  return d;
}, byteRangeToString = function r(e) {
  var t;
  return typeof e.offset == "bigint" || typeof e.length == "bigint" ? t = window_1.BigInt(e.offset) + window_1.BigInt(e.length) - window_1.BigInt(1) : t = e.offset + e.length - 1, e.offset + "-" + t;
}, parseEndNumber = function r(e) {
  return e && typeof e != "number" && (e = parseInt(e, 10)), isNaN(e) ? null : e;
}, segmentRange = {
  static: function r(e) {
    var t = e.duration, a = e.timescale, n = a === void 0 ? 1 : a, s = e.sourceDuration, o = e.periodDuration, u = parseEndNumber(e.endNumber), l = t / n;
    return typeof u == "number" ? {
      start: 0,
      end: u
    } : typeof o == "number" ? {
      start: 0,
      end: o / l
    } : {
      start: 0,
      end: s / l
    };
  },
  dynamic: function r(e) {
    var t = e.NOW, a = e.clientOffset, n = e.availabilityStartTime, s = e.timescale, o = s === void 0 ? 1 : s, u = e.duration, l = e.periodStart, f = l === void 0 ? 0 : l, d = e.minimumUpdatePeriod, h = d === void 0 ? 0 : d, p = e.timeShiftBufferDepth, m = p === void 0 ? 1 / 0 : p, _ = parseEndNumber(e.endNumber), w = (t + a) / 1e3, S = n + f, O = w + h, k = O - S, B = Math.ceil(k * o / u), L = Math.floor((w - S - m) * o / u), G = Math.floor((w - S) * o / u);
    return {
      start: Math.max(0, L),
      end: typeof _ == "number" ? _ : Math.min(B, G)
    };
  }
}, toSegments = function r(e) {
  return function(t) {
    var a = e.duration, n = e.timescale, s = n === void 0 ? 1 : n, o = e.periodStart, u = e.startNumber, l = u === void 0 ? 1 : u;
    return {
      number: l + t,
      duration: a / s,
      timeline: o,
      time: t * a
    };
  };
}, parseByDuration = function r(e) {
  var t = e.type, a = e.duration, n = e.timescale, s = n === void 0 ? 1 : n, o = e.periodDuration, u = e.sourceDuration, l = segmentRange[t](e), f = l.start, d = l.end, h = range(f, d).map(toSegments(e));
  if (t === "static") {
    var p = h.length - 1, m = typeof o == "number" ? o : u;
    h[p].duration = m - a / s * p;
  }
  return h;
}, segmentsFromBase = function r(e) {
  var t = e.baseUrl, a = e.initialization, n = a === void 0 ? {} : a, s = e.sourceDuration, o = e.indexRange, u = o === void 0 ? "" : o, l = e.periodStart, f = e.presentationTime, d = e.number, h = d === void 0 ? 0 : d, p = e.duration;
  if (!t)
    throw new Error(errors.NO_BASE_URL);
  var m = urlTypeToSegment({
    baseUrl: t,
    source: n.sourceURL,
    range: n.range
  }), _ = urlTypeToSegment({
    baseUrl: t,
    source: t,
    indexRange: u
  });
  if (_.map = m, p) {
    var w = parseByDuration(e);
    w.length && (_.duration = w[0].duration, _.timeline = w[0].timeline);
  } else
    s && (_.duration = s, _.timeline = l);
  return _.presentationTime = f || l, _.number = h, [_];
}, addSidxSegmentsToPlaylist$1 = function r(e, t, a) {
  var n = e.sidx.map ? e.sidx.map : null, s = e.sidx.duration, o = e.timeline || 0, u = e.sidx.byterange, l = u.offset + u.length, f = t.timescale, d = t.references.filter(function(Fa) {
    return Fa.referenceType !== 1;
  }), h = [], p = e.endList ? "static" : "dynamic", m = e.sidx.timeline, _ = m, w = e.mediaSequence || 0, S;
  typeof t.firstOffset == "bigint" ? S = window_1.BigInt(l) + t.firstOffset : S = l + t.firstOffset;
  for (var O = 0; O < d.length; O++) {
    var k = t.references[O], B = k.referencedSize, L = k.subsegmentDuration, G = void 0;
    typeof S == "bigint" ? G = S + window_1.BigInt(B) - window_1.BigInt(1) : G = S + B - 1;
    var _r = S + "-" + G, ga = {
      baseUrl: a,
      timescale: f,
      timeline: o,
      periodStart: m,
      presentationTime: _,
      number: w,
      duration: L,
      sourceDuration: s,
      indexRange: _r,
      type: p
    }, _n = segmentsFromBase(ga)[0];
    n && (_n.map = n), h.push(_n), typeof S == "bigint" ? S += window_1.BigInt(B) : S += B, _ += L / f, w++;
  }
  return e.segments = h, e;
}, SUPPORTED_MEDIA_TYPES = ["AUDIO", "SUBTITLES"], TIME_FUDGE = 1 / 60, getUniqueTimelineStarts = function r(e) {
  return union(e, function(t) {
    var a = t.timeline;
    return a;
  }).sort(function(t, a) {
    return t.timeline > a.timeline ? 1 : -1;
  });
}, findPlaylistWithName = function r(e, t) {
  for (var a = 0; a < e.length; a++)
    if (e[a].attributes.NAME === t)
      return e[a];
  return null;
}, getMediaGroupPlaylists = function r(e) {
  var t = [];
  return forEachMediaGroup$1(e, SUPPORTED_MEDIA_TYPES, function(a, n, s, o) {
    t = t.concat(a.playlists || []);
  }), t;
}, updateMediaSequenceForPlaylist = function r(e) {
  var t = e.playlist, a = e.mediaSequence;
  t.mediaSequence = a, t.segments.forEach(function(n, s) {
    n.number = t.mediaSequence + s;
  });
}, updateSequenceNumbers = function r(e) {
  var t = e.oldPlaylists, a = e.newPlaylists, n = e.timelineStarts;
  a.forEach(function(s) {
    s.discontinuitySequence = findIndex(n, function(d) {
      var h = d.timeline;
      return h === s.timeline;
    });
    var o = findPlaylistWithName(t, s.attributes.NAME);
    if (!!o && !s.sidx) {
      var u = s.segments[0], l = findIndex(o.segments, function(d) {
        return Math.abs(d.presentationTime - u.presentationTime) < TIME_FUDGE;
      });
      if (l === -1) {
        updateMediaSequenceForPlaylist({
          playlist: s,
          mediaSequence: o.mediaSequence + o.segments.length
        }), s.segments[0].discontinuity = !0, s.discontinuityStarts.unshift(0), (!o.segments.length && s.timeline > o.timeline || o.segments.length && s.timeline > o.segments[o.segments.length - 1].timeline) && s.discontinuitySequence--;
        return;
      }
      var f = o.segments[l];
      f.discontinuity && !u.discontinuity && (u.discontinuity = !0, s.discontinuityStarts.unshift(0), s.discontinuitySequence--), updateMediaSequenceForPlaylist({
        playlist: s,
        mediaSequence: o.segments[l].number
      });
    }
  });
}, positionManifestOnTimeline = function r(e) {
  var t = e.oldManifest, a = e.newManifest, n = t.playlists.concat(getMediaGroupPlaylists(t)), s = a.playlists.concat(getMediaGroupPlaylists(a));
  return a.timelineStarts = getUniqueTimelineStarts([t.timelineStarts, a.timelineStarts]), updateSequenceNumbers({
    oldPlaylists: n,
    newPlaylists: s,
    timelineStarts: a.timelineStarts
  }), a;
}, generateSidxKey = function r(e) {
  return e && e.uri + "-" + byteRangeToString(e.byterange);
}, mergeDiscontiguousPlaylists = function r(e) {
  var t = values(e.reduce(function(a, n) {
    var s = n.attributes.id + (n.attributes.lang || "");
    if (!a[s])
      a[s] = n, a[s].attributes.timelineStarts = [];
    else {
      if (n.segments) {
        var o;
        n.segments[0] && (n.segments[0].discontinuity = !0), (o = a[s].segments).push.apply(o, n.segments);
      }
      n.attributes.contentProtection && (a[s].attributes.contentProtection = n.attributes.contentProtection);
    }
    return a[s].attributes.timelineStarts.push({
      start: n.attributes.periodStart,
      timeline: n.attributes.periodStart
    }), a;
  }, {}));
  return t.map(function(a) {
    return a.discontinuityStarts = findIndexes(a.segments || [], "discontinuity"), a;
  });
}, addSidxSegmentsToPlaylist = function r(e, t) {
  var a = generateSidxKey(e.sidx), n = a && t[a] && t[a].sidx;
  return n && addSidxSegmentsToPlaylist$1(e, n, e.sidx.resolvedUri), e;
}, addSidxSegmentsToPlaylists = function r(e, t) {
  if (t === void 0 && (t = {}), !Object.keys(t).length)
    return e;
  for (var a in e)
    e[a] = addSidxSegmentsToPlaylist(e[a], t);
  return e;
}, formatAudioPlaylist = function r(e, t) {
  var a, n = e.attributes, s = e.segments, o = e.sidx, u = e.mediaSequence, l = e.discontinuitySequence, f = e.discontinuityStarts, d = {
    attributes: (a = {
      NAME: n.id,
      BANDWIDTH: n.bandwidth,
      CODECS: n.codecs
    }, a["PROGRAM-ID"] = 1, a),
    uri: "",
    endList: n.type === "static",
    timeline: n.periodStart,
    resolvedUri: "",
    targetDuration: n.duration,
    discontinuitySequence: l,
    discontinuityStarts: f,
    timelineStarts: n.timelineStarts,
    mediaSequence: u,
    segments: s
  };
  return n.contentProtection && (d.contentProtection = n.contentProtection), o && (d.sidx = o), t && (d.attributes.AUDIO = "audio", d.attributes.SUBTITLES = "subs"), d;
}, formatVttPlaylist = function r(e) {
  var t, a = e.attributes, n = e.segments, s = e.mediaSequence, o = e.discontinuityStarts, u = e.discontinuitySequence;
  typeof n > "u" && (n = [{
    uri: a.baseUrl,
    timeline: a.periodStart,
    resolvedUri: a.baseUrl || "",
    duration: a.sourceDuration,
    number: 0
  }], a.duration = a.sourceDuration);
  var l = (t = {
    NAME: a.id,
    BANDWIDTH: a.bandwidth
  }, t["PROGRAM-ID"] = 1, t);
  return a.codecs && (l.CODECS = a.codecs), {
    attributes: l,
    uri: "",
    endList: a.type === "static",
    timeline: a.periodStart,
    resolvedUri: a.baseUrl || "",
    targetDuration: a.duration,
    timelineStarts: a.timelineStarts,
    discontinuityStarts: o,
    discontinuitySequence: u,
    mediaSequence: s,
    segments: n
  };
}, organizeAudioPlaylists = function r(e, t, a) {
  t === void 0 && (t = {}), a === void 0 && (a = !1);
  var n, s = e.reduce(function(u, l) {
    var f = l.attributes.role && l.attributes.role.value || "", d = l.attributes.lang || "", h = l.attributes.label || "main";
    if (d && !l.attributes.label) {
      var p = f ? " (" + f + ")" : "";
      h = "" + l.attributes.lang + p;
    }
    u[h] || (u[h] = {
      language: d,
      autoselect: !0,
      default: f === "main",
      playlists: [],
      uri: ""
    });
    var m = addSidxSegmentsToPlaylist(formatAudioPlaylist(l, a), t);
    return u[h].playlists.push(m), typeof n > "u" && f === "main" && (n = l, n.default = !0), u;
  }, {});
  if (!n) {
    var o = Object.keys(s)[0];
    s[o].default = !0;
  }
  return s;
}, organizeVttPlaylists = function r(e, t) {
  return t === void 0 && (t = {}), e.reduce(function(a, n) {
    var s = n.attributes.lang || "text";
    return a[s] || (a[s] = {
      language: s,
      default: !1,
      autoselect: !1,
      playlists: [],
      uri: ""
    }), a[s].playlists.push(addSidxSegmentsToPlaylist(formatVttPlaylist(n), t)), a;
  }, {});
}, organizeCaptionServices = function r(e) {
  return e.reduce(function(t, a) {
    return a && a.forEach(function(n) {
      var s = n.channel, o = n.language;
      t[o] = {
        autoselect: !1,
        default: !1,
        instreamId: s,
        language: o
      }, n.hasOwnProperty("aspectRatio") && (t[o].aspectRatio = n.aspectRatio), n.hasOwnProperty("easyReader") && (t[o].easyReader = n.easyReader), n.hasOwnProperty("3D") && (t[o]["3D"] = n["3D"]);
    }), t;
  }, {});
}, formatVideoPlaylist = function r(e) {
  var t, a = e.attributes, n = e.segments, s = e.sidx, o = e.discontinuityStarts, u = {
    attributes: (t = {
      NAME: a.id,
      AUDIO: "audio",
      SUBTITLES: "subs",
      RESOLUTION: {
        width: a.width,
        height: a.height
      },
      CODECS: a.codecs,
      BANDWIDTH: a.bandwidth
    }, t["PROGRAM-ID"] = 1, t),
    uri: "",
    endList: a.type === "static",
    timeline: a.periodStart,
    resolvedUri: "",
    targetDuration: a.duration,
    discontinuityStarts: o,
    timelineStarts: a.timelineStarts,
    segments: n
  };
  return a.contentProtection && (u.contentProtection = a.contentProtection), s && (u.sidx = s), u;
}, videoOnly = function r(e) {
  var t = e.attributes;
  return t.mimeType === "video/mp4" || t.mimeType === "video/webm" || t.contentType === "video";
}, audioOnly = function r(e) {
  var t = e.attributes;
  return t.mimeType === "audio/mp4" || t.mimeType === "audio/webm" || t.contentType === "audio";
}, vttOnly = function r(e) {
  var t = e.attributes;
  return t.mimeType === "text/vtt" || t.contentType === "text";
}, addMediaSequenceValues = function r(e, t) {
  e.forEach(function(a) {
    a.mediaSequence = 0, a.discontinuitySequence = findIndex(t, function(n) {
      var s = n.timeline;
      return s === a.timeline;
    }), a.segments && a.segments.forEach(function(n, s) {
      n.number = s;
    });
  });
}, flattenMediaGroupPlaylists = function r(e) {
  return e ? Object.keys(e).reduce(function(t, a) {
    var n = e[a];
    return t.concat(n.playlists);
  }, []) : [];
}, toM3u8 = function r(e) {
  var t, a = e.dashPlaylists, n = e.locations, s = e.sidxMapping, o = s === void 0 ? {} : s, u = e.previousManifest;
  if (!a.length)
    return {};
  var l = a[0].attributes, f = l.sourceDuration, d = l.type, h = l.suggestedPresentationDelay, p = l.minimumUpdatePeriod, m = mergeDiscontiguousPlaylists(a.filter(videoOnly)).map(formatVideoPlaylist), _ = mergeDiscontiguousPlaylists(a.filter(audioOnly)), w = mergeDiscontiguousPlaylists(a.filter(vttOnly)), S = a.map(function(ga) {
    return ga.attributes.captionServices;
  }).filter(Boolean), O = {
    allowCache: !0,
    discontinuityStarts: [],
    segments: [],
    endList: !0,
    mediaGroups: (t = {
      AUDIO: {},
      VIDEO: {}
    }, t["CLOSED-CAPTIONS"] = {}, t.SUBTITLES = {}, t),
    uri: "",
    duration: f,
    playlists: addSidxSegmentsToPlaylists(m, o)
  };
  p >= 0 && (O.minimumUpdatePeriod = p * 1e3), n && (O.locations = n), d === "dynamic" && (O.suggestedPresentationDelay = h);
  var k = O.playlists.length === 0, B = _.length ? organizeAudioPlaylists(_, o, k) : null, L = w.length ? organizeVttPlaylists(w, o) : null, G = m.concat(flattenMediaGroupPlaylists(B), flattenMediaGroupPlaylists(L)), _r = G.map(function(ga) {
    var _n = ga.timelineStarts;
    return _n;
  });
  return O.timelineStarts = getUniqueTimelineStarts(_r), addMediaSequenceValues(G, O.timelineStarts), B && (O.mediaGroups.AUDIO.audio = B), L && (O.mediaGroups.SUBTITLES.subs = L), S.length && (O.mediaGroups["CLOSED-CAPTIONS"].cc = organizeCaptionServices(S)), u ? positionManifestOnTimeline({
    oldManifest: u,
    newManifest: O
  }) : O;
}, getLiveRValue = function r(e, t, a) {
  var n = e.NOW, s = e.clientOffset, o = e.availabilityStartTime, u = e.timescale, l = u === void 0 ? 1 : u, f = e.periodStart, d = f === void 0 ? 0 : f, h = e.minimumUpdatePeriod, p = h === void 0 ? 0 : h, m = (n + s) / 1e3, _ = o + d, w = m + p, S = w - _;
  return Math.ceil((S * l - t) / a);
}, parseByTimeline = function r(e, t) {
  for (var a = e.type, n = e.minimumUpdatePeriod, s = n === void 0 ? 0 : n, o = e.media, u = o === void 0 ? "" : o, l = e.sourceDuration, f = e.timescale, d = f === void 0 ? 1 : f, h = e.startNumber, p = h === void 0 ? 1 : h, m = e.periodStart, _ = [], w = -1, S = 0; S < t.length; S++) {
    var O = t[S], k = O.d, B = O.r || 0, L = O.t || 0;
    w < 0 && (w = L), L && L > w && (w = L);
    var G = void 0;
    if (B < 0) {
      var _r = S + 1;
      _r === t.length ? a === "dynamic" && s > 0 && u.indexOf("$Number$") > 0 ? G = getLiveRValue(e, w, k) : G = (l * d - w) / k : G = (t[_r].t - w) / k;
    } else
      G = B + 1;
    for (var ga = p + _.length + G, _n = p + _.length; _n < ga; )
      _.push({
        number: _n,
        duration: k / d,
        time: w,
        timeline: m
      }), w += k, _n++;
  }
  return _;
}, identifierPattern = /\$([A-z]*)(?:(%0)([0-9]+)d)?\$/g, identifierReplacement = function r(e) {
  return function(t, a, n, s) {
    if (t === "$$")
      return "$";
    if (typeof e[a] > "u")
      return t;
    var o = "" + e[a];
    return a === "RepresentationID" || (n ? s = parseInt(s, 10) : s = 1, o.length >= s) ? o : "" + new Array(s - o.length + 1).join("0") + o;
  };
}, constructTemplateUrl = function r(e, t) {
  return e.replace(identifierPattern, identifierReplacement(t));
}, parseTemplateInfo = function r(e, t) {
  return !e.duration && !t ? [{
    number: e.startNumber || 1,
    duration: e.sourceDuration,
    time: 0,
    timeline: e.periodStart
  }] : e.duration ? parseByDuration(e) : parseByTimeline(e, t);
}, segmentsFromTemplate = function r(e, t) {
  var a = {
    RepresentationID: e.id,
    Bandwidth: e.bandwidth || 0
  }, n = e.initialization, s = n === void 0 ? {
    sourceURL: "",
    range: ""
  } : n, o = urlTypeToSegment({
    baseUrl: e.baseUrl,
    source: constructTemplateUrl(s.sourceURL, a),
    range: s.range
  }), u = parseTemplateInfo(e, t);
  return u.map(function(l) {
    a.Number = l.number, a.Time = l.time;
    var f = constructTemplateUrl(e.media || "", a), d = e.timescale || 1, h = e.presentationTimeOffset || 0, p = e.periodStart + (l.time - h) / d, m = {
      uri: f,
      timeline: l.timeline,
      duration: l.duration,
      resolvedUri: resolveUrl$1(e.baseUrl || "", f),
      map: o,
      number: l.number,
      presentationTime: p
    };
    return m;
  });
}, SegmentURLToSegmentObject = function r(e, t) {
  var a = e.baseUrl, n = e.initialization, s = n === void 0 ? {} : n, o = urlTypeToSegment({
    baseUrl: a,
    source: s.sourceURL,
    range: s.range
  }), u = urlTypeToSegment({
    baseUrl: a,
    source: t.media,
    range: t.mediaRange
  });
  return u.map = o, u;
}, segmentsFromList = function r(e, t) {
  var a = e.duration, n = e.segmentUrls, s = n === void 0 ? [] : n, o = e.periodStart;
  if (!a && !t || a && t)
    throw new Error(errors.SEGMENT_TIME_UNSPECIFIED);
  var u = s.map(function(d) {
    return SegmentURLToSegmentObject(e, d);
  }), l;
  a && (l = parseByDuration(e)), t && (l = parseByTimeline(e, t));
  var f = l.map(function(d, h) {
    if (u[h]) {
      var p = u[h], m = e.timescale || 1, _ = e.presentationTimeOffset || 0;
      return p.timeline = d.timeline, p.duration = d.duration, p.number = d.number, p.presentationTime = o + (d.time - _) / m, p;
    }
  }).filter(function(d) {
    return d;
  });
  return f;
}, generateSegments = function r(e) {
  var t = e.attributes, a = e.segmentInfo, n, s;
  a.template ? (s = segmentsFromTemplate, n = merge(t, a.template)) : a.base ? (s = segmentsFromBase, n = merge(t, a.base)) : a.list && (s = segmentsFromList, n = merge(t, a.list));
  var o = {
    attributes: t
  };
  if (!s)
    return o;
  var u = s(n, a.segmentTimeline);
  if (n.duration) {
    var l = n, f = l.duration, d = l.timescale, h = d === void 0 ? 1 : d;
    n.duration = f / h;
  } else
    u.length ? n.duration = u.reduce(function(p, m) {
      return Math.max(p, Math.ceil(m.duration));
    }, 0) : n.duration = 0;
  return o.attributes = n, o.segments = u, a.base && n.indexRange && (o.sidx = u[0], o.segments = []), o;
}, toPlaylists = function r(e) {
  return e.map(generateSegments);
}, findChildren = function r(e, t) {
  return from(e.childNodes).filter(function(a) {
    var n = a.tagName;
    return n === t;
  });
}, getContent = function r(e) {
  return e.textContent.trim();
}, parseDuration = function r(e) {
  var t = 31536e3, a = 30 * 24 * 60 * 60, n = 24 * 60 * 60, s = 60 * 60, o = 60, u = /P(?:(\d*)Y)?(?:(\d*)M)?(?:(\d*)D)?(?:T(?:(\d*)H)?(?:(\d*)M)?(?:([\d.]*)S)?)?/, l = u.exec(e);
  if (!l)
    return 0;
  var f = l.slice(1), d = f[0], h = f[1], p = f[2], m = f[3], _ = f[4], w = f[5];
  return parseFloat(d || 0) * t + parseFloat(h || 0) * a + parseFloat(p || 0) * n + parseFloat(m || 0) * s + parseFloat(_ || 0) * o + parseFloat(w || 0);
}, parseDate = function r(e) {
  var t = /^\d+-\d+-\d+T\d+:\d+:\d+(\.\d+)?$/;
  return t.test(e) && (e += "Z"), Date.parse(e);
}, parsers = {
  mediaPresentationDuration: function r(e) {
    return parseDuration(e);
  },
  availabilityStartTime: function r(e) {
    return parseDate(e) / 1e3;
  },
  minimumUpdatePeriod: function r(e) {
    return parseDuration(e);
  },
  suggestedPresentationDelay: function r(e) {
    return parseDuration(e);
  },
  type: function r(e) {
    return e;
  },
  timeShiftBufferDepth: function r(e) {
    return parseDuration(e);
  },
  start: function r(e) {
    return parseDuration(e);
  },
  width: function r(e) {
    return parseInt(e, 10);
  },
  height: function r(e) {
    return parseInt(e, 10);
  },
  bandwidth: function r(e) {
    return parseInt(e, 10);
  },
  startNumber: function r(e) {
    return parseInt(e, 10);
  },
  timescale: function r(e) {
    return parseInt(e, 10);
  },
  presentationTimeOffset: function r(e) {
    return parseInt(e, 10);
  },
  duration: function r(e) {
    var t = parseInt(e, 10);
    return isNaN(t) ? parseDuration(e) : t;
  },
  d: function r(e) {
    return parseInt(e, 10);
  },
  t: function r(e) {
    return parseInt(e, 10);
  },
  r: function r(e) {
    return parseInt(e, 10);
  },
  DEFAULT: function r(e) {
    return e;
  }
}, parseAttributes = function r(e) {
  return e && e.attributes ? from(e.attributes).reduce(function(t, a) {
    var n = parsers[a.name] || parsers.DEFAULT;
    return t[a.name] = n(a.value), t;
  }, {}) : {};
}, keySystemsMap = {
  "urn:uuid:1077efec-c0b2-4d02-ace3-3c1e52e2fb4b": "org.w3.clearkey",
  "urn:uuid:edef8ba9-79d6-4ace-a3c8-27dcd51d21ed": "com.widevine.alpha",
  "urn:uuid:9a04f079-9840-4286-ab92-e65be0885f95": "com.microsoft.playready",
  "urn:uuid:f239e769-efa3-4850-9c16-a903c6932efb": "com.adobe.primetime"
}, buildBaseUrls = function r(e, t) {
  return t.length ? flatten(e.map(function(a) {
    return t.map(function(n) {
      return resolveUrl$1(a, getContent(n));
    });
  })) : e;
}, getSegmentInformation = function r(e) {
  var t = findChildren(e, "SegmentTemplate")[0], a = findChildren(e, "SegmentList")[0], n = a && findChildren(a, "SegmentURL").map(function(p) {
    return merge({
      tag: "SegmentURL"
    }, parseAttributes(p));
  }), s = findChildren(e, "SegmentBase")[0], o = a || t, u = o && findChildren(o, "SegmentTimeline")[0], l = a || s || t, f = l && findChildren(l, "Initialization")[0], d = t && parseAttributes(t);
  d && f ? d.initialization = f && parseAttributes(f) : d && d.initialization && (d.initialization = {
    sourceURL: d.initialization
  });
  var h = {
    template: d,
    segmentTimeline: u && findChildren(u, "S").map(function(p) {
      return parseAttributes(p);
    }),
    list: a && merge(parseAttributes(a), {
      segmentUrls: n,
      initialization: parseAttributes(f)
    }),
    base: s && merge(parseAttributes(s), {
      initialization: parseAttributes(f)
    })
  };
  return Object.keys(h).forEach(function(p) {
    h[p] || delete h[p];
  }), h;
}, inheritBaseUrls = function r(e, t, a) {
  return function(n) {
    var s = findChildren(n, "BaseURL"), o = buildBaseUrls(t, s), u = merge(e, parseAttributes(n)), l = getSegmentInformation(n);
    return o.map(function(f) {
      return {
        segmentInfo: merge(a, l),
        attributes: merge(u, {
          baseUrl: f
        })
      };
    });
  };
}, generateKeySystemInformation = function r(e) {
  return e.reduce(function(t, a) {
    var n = parseAttributes(a);
    n.schemeIdUri && (n.schemeIdUri = n.schemeIdUri.toLowerCase());
    var s = keySystemsMap[n.schemeIdUri];
    if (s) {
      t[s] = {
        attributes: n
      };
      var o = findChildren(a, "cenc:pssh")[0];
      if (o) {
        var u = getContent(o);
        t[s].pssh = u && decodeB64ToUint8Array(u);
      }
    }
    return t;
  }, {});
}, parseCaptionServiceMetadata = function r(e) {
  if (e.schemeIdUri === "urn:scte:dash:cc:cea-608:2015") {
    var t = typeof e.value != "string" ? [] : e.value.split(";");
    return t.map(function(n) {
      var s, o;
      if (o = n, /^CC\d=/.test(n)) {
        var u = n.split("=");
        s = u[0], o = u[1];
      } else
        /^CC\d$/.test(n) && (s = n);
      return {
        channel: s,
        language: o
      };
    });
  } else if (e.schemeIdUri === "urn:scte:dash:cc:cea-708:2015") {
    var a = typeof e.value != "string" ? [] : e.value.split(";");
    return a.map(function(n) {
      var s = {
        channel: void 0,
        language: void 0,
        aspectRatio: 1,
        easyReader: 0,
        "3D": 0
      };
      if (/=/.test(n)) {
        var o = n.split("="), u = o[0], l = o[1], f = l === void 0 ? "" : l;
        s.channel = u, s.language = n, f.split(",").forEach(function(d) {
          var h = d.split(":"), p = h[0], m = h[1];
          p === "lang" ? s.language = m : p === "er" ? s.easyReader = Number(m) : p === "war" ? s.aspectRatio = Number(m) : p === "3D" && (s["3D"] = Number(m));
        });
      } else
        s.language = n;
      return s.channel && (s.channel = "SERVICE" + s.channel), s;
    });
  }
}, toRepresentations = function r(e, t, a) {
  return function(n) {
    var s = parseAttributes(n), o = buildBaseUrls(t, findChildren(n, "BaseURL")), u = findChildren(n, "Role")[0], l = {
      role: parseAttributes(u)
    }, f = merge(e, s, l), d = findChildren(n, "Accessibility")[0], h = parseCaptionServiceMetadata(parseAttributes(d));
    h && (f = merge(f, {
      captionServices: h
    }));
    var p = findChildren(n, "Label")[0];
    if (p && p.childNodes.length) {
      var m = p.childNodes[0].nodeValue.trim();
      f = merge(f, {
        label: m
      });
    }
    var _ = generateKeySystemInformation(findChildren(n, "ContentProtection"));
    Object.keys(_).length && (f = merge(f, {
      contentProtection: _
    }));
    var w = getSegmentInformation(n), S = findChildren(n, "Representation"), O = merge(a, w);
    return flatten(S.map(inheritBaseUrls(f, o, O)));
  };
}, toAdaptationSets = function r(e, t) {
  return function(a, n) {
    var s = buildBaseUrls(t, findChildren(a.node, "BaseURL")), o = merge(e, {
      periodStart: a.attributes.start
    });
    typeof a.attributes.duration == "number" && (o.periodDuration = a.attributes.duration);
    var u = findChildren(a.node, "AdaptationSet"), l = getSegmentInformation(a.node);
    return flatten(u.map(toRepresentations(o, s, l)));
  };
}, getPeriodStart = function r(e) {
  var t = e.attributes, a = e.priorPeriodAttributes, n = e.mpdType;
  return typeof t.start == "number" ? t.start : a && typeof a.start == "number" && typeof a.duration == "number" ? a.start + a.duration : !a && n === "static" ? 0 : null;
}, inheritAttributes = function r(e, t) {
  t === void 0 && (t = {});
  var a = t, n = a.manifestUri, s = n === void 0 ? "" : n, o = a.NOW, u = o === void 0 ? Date.now() : o, l = a.clientOffset, f = l === void 0 ? 0 : l, d = findChildren(e, "Period");
  if (!d.length)
    throw new Error(errors.INVALID_NUMBER_OF_PERIOD);
  var h = findChildren(e, "Location"), p = parseAttributes(e), m = buildBaseUrls([s], findChildren(e, "BaseURL"));
  p.type = p.type || "static", p.sourceDuration = p.mediaPresentationDuration || 0, p.NOW = u, p.clientOffset = f, h.length && (p.locations = h.map(getContent));
  var _ = [];
  return d.forEach(function(w, S) {
    var O = parseAttributes(w), k = _[S - 1];
    O.start = getPeriodStart({
      attributes: O,
      priorPeriodAttributes: k ? k.attributes : null,
      mpdType: p.type
    }), _.push({
      node: w,
      attributes: O
    });
  }), {
    locations: p.locations,
    representationInfo: flatten(_.map(toAdaptationSets(p, m)))
  };
}, stringToMpdXml = function r(e) {
  if (e === "")
    throw new Error(errors.DASH_EMPTY_MANIFEST);
  var t = new DOMParser(), a, n;
  try {
    a = t.parseFromString(e, "application/xml"), n = a && a.documentElement.tagName === "MPD" ? a.documentElement : null;
  } catch {
  }
  if (!n || n && n.getElementsByTagName("parsererror").length > 0)
    throw new Error(errors.DASH_INVALID_XML);
  return n;
}, parseUTCTimingScheme = function r(e) {
  var t = findChildren(e, "UTCTiming")[0];
  if (!t)
    return null;
  var a = parseAttributes(t);
  switch (a.schemeIdUri) {
    case "urn:mpeg:dash:utc:http-head:2014":
    case "urn:mpeg:dash:utc:http-head:2012":
      a.method = "HEAD";
      break;
    case "urn:mpeg:dash:utc:http-xsdate:2014":
    case "urn:mpeg:dash:utc:http-iso:2014":
    case "urn:mpeg:dash:utc:http-xsdate:2012":
    case "urn:mpeg:dash:utc:http-iso:2012":
      a.method = "GET";
      break;
    case "urn:mpeg:dash:utc:direct:2014":
    case "urn:mpeg:dash:utc:direct:2012":
      a.method = "DIRECT", a.value = Date.parse(a.value);
      break;
    case "urn:mpeg:dash:utc:http-ntp:2014":
    case "urn:mpeg:dash:utc:ntp:2014":
    case "urn:mpeg:dash:utc:sntp:2014":
    default:
      throw new Error(errors.UNSUPPORTED_UTC_TIMING_SCHEME);
  }
  return a;
}, parse = function r(e, t) {
  t === void 0 && (t = {});
  var a = inheritAttributes(stringToMpdXml(e), t), n = toPlaylists(a.representationInfo);
  return toM3u8({
    dashPlaylists: n,
    locations: a.locations,
    sidxMapping: t.sidxMapping,
    previousManifest: t.previousManifest
  });
}, parseUTCTiming = function r(e) {
  return parseUTCTimingScheme(stringToMpdXml(e));
}, MAX_UINT32 = Math.pow(2, 32), getUint64$1 = function(r) {
  var e = new DataView(r.buffer, r.byteOffset, r.byteLength), t;
  return e.getBigUint64 ? (t = e.getBigUint64(0), t < Number.MAX_SAFE_INTEGER ? Number(t) : t) : e.getUint32(0) * MAX_UINT32 + e.getUint32(4);
}, numbers = {
  getUint64: getUint64$1,
  MAX_UINT32
}, getUint64 = numbers.getUint64, parseSidx = function(r) {
  var e = new DataView(r.buffer, r.byteOffset, r.byteLength), t = {
    version: r[0],
    flags: new Uint8Array(r.subarray(1, 4)),
    references: [],
    referenceId: e.getUint32(4),
    timescale: e.getUint32(8)
  }, a = 12;
  t.version === 0 ? (t.earliestPresentationTime = e.getUint32(a), t.firstOffset = e.getUint32(a + 4), a += 8) : (t.earliestPresentationTime = getUint64(r.subarray(a)), t.firstOffset = getUint64(r.subarray(a + 8)), a += 16), a += 2;
  var n = e.getUint16(a);
  for (a += 2; n > 0; a += 12, n--)
    t.references.push({
      referenceType: (r[a] & 128) >>> 7,
      referencedSize: e.getUint32(a) & 2147483647,
      subsegmentDuration: e.getUint32(a + 4),
      startsWithSap: !!(r[a + 8] & 128),
      sapType: (r[a + 8] & 112) >>> 4,
      sapDeltaTime: e.getUint32(a + 8) & 268435455
    });
  return t;
}, parseSidx_1 = parseSidx, ID3 = toUint8([73, 68, 51]), getId3Size = function r(e, t) {
  t === void 0 && (t = 0), e = toUint8(e);
  var a = e[t + 5], n = e[t + 6] << 21 | e[t + 7] << 14 | e[t + 8] << 7 | e[t + 9], s = (a & 16) >> 4;
  return s ? n + 20 : n + 10;
}, getId3Offset = function r(e, t) {
  return t === void 0 && (t = 0), e = toUint8(e), e.length - t < 10 || !bytesMatch(e, ID3, {
    offset: t
  }) ? t : (t += getId3Size(e, t), r(e, t));
}, normalizePath$1 = function r(e) {
  return typeof e == "string" ? stringToBytes(e) : e;
}, normalizePaths$1 = function r(e) {
  return Array.isArray(e) ? e.map(function(t) {
    return normalizePath$1(t);
  }) : [normalizePath$1(e)];
}, findBox = function r(e, t, a) {
  a === void 0 && (a = !1), t = normalizePaths$1(t), e = toUint8(e);
  var n = [];
  if (!t.length)
    return n;
  for (var s = 0; s < e.length; ) {
    var o = (e[s] << 24 | e[s + 1] << 16 | e[s + 2] << 8 | e[s + 3]) >>> 0, u = e.subarray(s + 4, s + 8);
    if (o === 0)
      break;
    var l = s + o;
    if (l > e.length) {
      if (a)
        break;
      l = e.length;
    }
    var f = e.subarray(s + 8, l);
    bytesMatch(u, t[0]) && (t.length === 1 ? n.push(f) : n.push.apply(n, r(f, t.slice(1), a))), s = l;
  }
  return n;
}, EBML_TAGS = {
  EBML: toUint8([26, 69, 223, 163]),
  DocType: toUint8([66, 130]),
  Segment: toUint8([24, 83, 128, 103]),
  SegmentInfo: toUint8([21, 73, 169, 102]),
  Tracks: toUint8([22, 84, 174, 107]),
  Track: toUint8([174]),
  TrackNumber: toUint8([215]),
  DefaultDuration: toUint8([35, 227, 131]),
  TrackEntry: toUint8([174]),
  TrackType: toUint8([131]),
  FlagDefault: toUint8([136]),
  CodecID: toUint8([134]),
  CodecPrivate: toUint8([99, 162]),
  VideoTrack: toUint8([224]),
  AudioTrack: toUint8([225]),
  Cluster: toUint8([31, 67, 182, 117]),
  Timestamp: toUint8([231]),
  TimestampScale: toUint8([42, 215, 177]),
  BlockGroup: toUint8([160]),
  BlockDuration: toUint8([155]),
  Block: toUint8([161]),
  SimpleBlock: toUint8([163])
}, LENGTH_TABLE = [128, 64, 32, 16, 8, 4, 2, 1], getLength = function r(e) {
  for (var t = 1, a = 0; a < LENGTH_TABLE.length && !(e & LENGTH_TABLE[a]); a++)
    t++;
  return t;
}, getvint = function r(e, t, a, n) {
  a === void 0 && (a = !0), n === void 0 && (n = !1);
  var s = getLength(e[t]), o = e.subarray(t, t + s);
  return a && (o = Array.prototype.slice.call(e, t, t + s), o[0] ^= LENGTH_TABLE[s - 1]), {
    length: s,
    value: bytesToNumber(o, {
      signed: n
    }),
    bytes: o
  };
}, normalizePath = function r(e) {
  return typeof e == "string" ? e.match(/.{1,2}/g).map(function(t) {
    return r(t);
  }) : typeof e == "number" ? numberToBytes(e) : e;
}, normalizePaths = function r(e) {
  return Array.isArray(e) ? e.map(function(t) {
    return normalizePath(t);
  }) : [normalizePath(e)];
}, getInfinityDataSize = function r(e, t, a) {
  if (a >= t.length)
    return t.length;
  var n = getvint(t, a, !1);
  if (bytesMatch(e.bytes, n.bytes))
    return a;
  var s = getvint(t, a + n.length);
  return r(e, t, a + s.length + s.value + n.length);
}, findEbml = function r(e, t) {
  t = normalizePaths(t), e = toUint8(e);
  var a = [];
  if (!t.length)
    return a;
  for (var n = 0; n < e.length; ) {
    var s = getvint(e, n, !1), o = getvint(e, n + s.length), u = n + s.length + o.length;
    o.value === 127 && (o.value = getInfinityDataSize(s, e, u), o.value !== e.length && (o.value -= u));
    var l = u + o.value > e.length ? e.length : u + o.value, f = e.subarray(u, l);
    bytesMatch(t[0], s.bytes) && (t.length === 1 ? a.push(f) : a = a.concat(r(f, t.slice(1))));
    var d = s.length + o.length + f.length;
    n += d;
  }
  return a;
}, NAL_TYPE_ONE = toUint8([0, 0, 0, 1]), NAL_TYPE_TWO = toUint8([0, 0, 1]), EMULATION_PREVENTION = toUint8([0, 0, 3]), discardEmulationPreventionBytes = function r(e) {
  for (var t = [], a = 1; a < e.length - 2; )
    bytesMatch(e.subarray(a, a + 3), EMULATION_PREVENTION) && (t.push(a + 2), a++), a++;
  if (t.length === 0)
    return e;
  var n = e.length - t.length, s = new Uint8Array(n), o = 0;
  for (a = 0; a < n; o++, a++)
    o === t[0] && (o++, t.shift()), s[a] = e[o];
  return s;
}, findNal = function r(e, t, a, n) {
  n === void 0 && (n = 1 / 0), e = toUint8(e), a = [].concat(a);
  for (var s = 0, o, u = 0; s < e.length && (u < n || o); ) {
    var l = void 0;
    if (bytesMatch(e.subarray(s), NAL_TYPE_ONE) ? l = 4 : bytesMatch(e.subarray(s), NAL_TYPE_TWO) && (l = 3), !l) {
      s++;
      continue;
    }
    if (u++, o)
      return discardEmulationPreventionBytes(e.subarray(o, s));
    var f = void 0;
    t === "h264" ? f = e[s + l] & 31 : t === "h265" && (f = e[s + l] >> 1 & 63), a.indexOf(f) !== -1 && (o = s + l), s += l + (t === "h264" ? 1 : 2);
  }
  return e.subarray(0, 0);
}, findH264Nal = function r(e, t, a) {
  return findNal(e, "h264", t, a);
}, findH265Nal = function r(e, t, a) {
  return findNal(e, "h265", t, a);
}, CONSTANTS = {
  webm: toUint8([119, 101, 98, 109]),
  matroska: toUint8([109, 97, 116, 114, 111, 115, 107, 97]),
  flac: toUint8([102, 76, 97, 67]),
  ogg: toUint8([79, 103, 103, 83]),
  ac3: toUint8([11, 119]),
  riff: toUint8([82, 73, 70, 70]),
  avi: toUint8([65, 86, 73]),
  wav: toUint8([87, 65, 86, 69]),
  "3gp": toUint8([102, 116, 121, 112, 51, 103]),
  mp4: toUint8([102, 116, 121, 112]),
  fmp4: toUint8([115, 116, 121, 112]),
  mov: toUint8([102, 116, 121, 112, 113, 116]),
  moov: toUint8([109, 111, 111, 118]),
  moof: toUint8([109, 111, 111, 102])
}, _isLikely = {
  aac: function r(e) {
    var t = getId3Offset(e);
    return bytesMatch(e, [255, 16], {
      offset: t,
      mask: [255, 22]
    });
  },
  mp3: function r(e) {
    var t = getId3Offset(e);
    return bytesMatch(e, [255, 2], {
      offset: t,
      mask: [255, 6]
    });
  },
  webm: function r(e) {
    var t = findEbml(e, [EBML_TAGS.EBML, EBML_TAGS.DocType])[0];
    return bytesMatch(t, CONSTANTS.webm);
  },
  mkv: function r(e) {
    var t = findEbml(e, [EBML_TAGS.EBML, EBML_TAGS.DocType])[0];
    return bytesMatch(t, CONSTANTS.matroska);
  },
  mp4: function r(e) {
    if (_isLikely["3gp"](e) || _isLikely.mov(e))
      return !1;
    if (bytesMatch(e, CONSTANTS.mp4, {
      offset: 4
    }) || bytesMatch(e, CONSTANTS.fmp4, {
      offset: 4
    }) || bytesMatch(e, CONSTANTS.moof, {
      offset: 4
    }) || bytesMatch(e, CONSTANTS.moov, {
      offset: 4
    }))
      return !0;
  },
  mov: function r(e) {
    return bytesMatch(e, CONSTANTS.mov, {
      offset: 4
    });
  },
  "3gp": function r(e) {
    return bytesMatch(e, CONSTANTS["3gp"], {
      offset: 4
    });
  },
  ac3: function r(e) {
    var t = getId3Offset(e);
    return bytesMatch(e, CONSTANTS.ac3, {
      offset: t
    });
  },
  ts: function r(e) {
    if (e.length < 189 && e.length >= 1)
      return e[0] === 71;
    for (var t = 0; t + 188 < e.length && t < 188; ) {
      if (e[t] === 71 && e[t + 188] === 71)
        return !0;
      t += 1;
    }
    return !1;
  },
  flac: function r(e) {
    var t = getId3Offset(e);
    return bytesMatch(e, CONSTANTS.flac, {
      offset: t
    });
  },
  ogg: function r(e) {
    return bytesMatch(e, CONSTANTS.ogg);
  },
  avi: function r(e) {
    return bytesMatch(e, CONSTANTS.riff) && bytesMatch(e, CONSTANTS.avi, {
      offset: 8
    });
  },
  wav: function r(e) {
    return bytesMatch(e, CONSTANTS.riff) && bytesMatch(e, CONSTANTS.wav, {
      offset: 8
    });
  },
  h264: function r(e) {
    return findH264Nal(e, 7, 3).length;
  },
  h265: function r(e) {
    return findH265Nal(e, [32, 33], 3).length;
  }
}, isLikelyTypes = Object.keys(_isLikely).filter(function(r) {
  return r !== "ts" && r !== "h264" && r !== "h265";
}).concat(["ts", "h264", "h265"]);
isLikelyTypes.forEach(function(r) {
  var e = _isLikely[r];
  _isLikely[r] = function(t) {
    return e(toUint8(t));
  };
});
var isLikely = _isLikely, detectContainerForBytes = function r(e) {
  e = toUint8(e);
  for (var t = 0; t < isLikelyTypes.length; t++) {
    var a = isLikelyTypes[t];
    if (isLikely[a](e))
      return a;
  }
  return "";
}, isLikelyFmp4MediaSegment = function r(e) {
  return findBox(e, ["moof"]).length > 0;
}, ONE_SECOND_IN_TS = 9e4, secondsToVideoTs, secondsToAudioTs, videoTsToSeconds, audioTsToSeconds, audioTsToVideoTs, videoTsToAudioTs, metadataTsToSeconds;
secondsToVideoTs = function(r) {
  return r * ONE_SECOND_IN_TS;
};
secondsToAudioTs = function(r, e) {
  return r * e;
};
videoTsToSeconds = function(r) {
  return r / ONE_SECOND_IN_TS;
};
audioTsToSeconds = function(r, e) {
  return r / e;
};
audioTsToVideoTs = function(r, e) {
  return secondsToVideoTs(audioTsToSeconds(r, e));
};
videoTsToAudioTs = function(r, e) {
  return secondsToAudioTs(videoTsToSeconds(r), e);
};
metadataTsToSeconds = function(r, e, t) {
  return videoTsToSeconds(t ? r : r - e);
};
var clock = {
  ONE_SECOND_IN_TS,
  secondsToVideoTs,
  secondsToAudioTs,
  videoTsToSeconds,
  audioTsToSeconds,
  audioTsToVideoTs,
  videoTsToAudioTs,
  metadataTsToSeconds
};
/**
 * @license
 * Video.js 7.20.2 <http://videojs.com/>
 * Copyright Brightcove, Inc. <https://www.brightcove.com/>
 * Available under Apache License Version 2.0
 * <https://github.com/videojs/video.js/blob/main/LICENSE>
 *
 * Includes vtt.js <https://github.com/mozilla/vtt.js>
 * Available under Apache License Version 2.0
 * <https://github.com/mozilla/vtt.js/blob/main/LICENSE>
 */
var version$5 = "7.20.2", hooks_ = {}, hooks = function r(e, t) {
  return hooks_[e] = hooks_[e] || [], t && (hooks_[e] = hooks_[e].concat(t)), hooks_[e];
}, hook = function r(e, t) {
  hooks(e, t);
}, removeHook = function r(e, t) {
  var a = hooks(e).indexOf(t);
  return a <= -1 ? !1 : (hooks_[e] = hooks_[e].slice(), hooks_[e].splice(a, 1), !0);
}, hookOnce = function r(e, t) {
  hooks(e, [].concat(t).map(function(a) {
    var n = function s() {
      return removeHook(e, s), a.apply(void 0, arguments);
    };
    return n;
  }));
}, FullscreenApi = {
  prefixed: !0
}, apiMap = [
  ["requestFullscreen", "exitFullscreen", "fullscreenElement", "fullscreenEnabled", "fullscreenchange", "fullscreenerror", "fullscreen"],
  ["webkitRequestFullscreen", "webkitExitFullscreen", "webkitFullscreenElement", "webkitFullscreenEnabled", "webkitfullscreenchange", "webkitfullscreenerror", "-webkit-full-screen"],
  ["mozRequestFullScreen", "mozCancelFullScreen", "mozFullScreenElement", "mozFullScreenEnabled", "mozfullscreenchange", "mozfullscreenerror", "-moz-full-screen"],
  ["msRequestFullscreen", "msExitFullscreen", "msFullscreenElement", "msFullscreenEnabled", "MSFullscreenChange", "MSFullscreenError", "-ms-fullscreen"]
], specApi = apiMap[0], browserApi;
for (var i = 0; i < apiMap.length; i++)
  if (apiMap[i][1] in document_1) {
    browserApi = apiMap[i];
    break;
  }
if (browserApi) {
  for (var _i = 0; _i < browserApi.length; _i++)
    FullscreenApi[specApi[_i]] = browserApi[_i];
  FullscreenApi.prefixed = browserApi[0] !== specApi[0];
}
var history = [], LogByTypeFactory = function r(e, t) {
  return function(a, n, s) {
    var o = t.levels[n], u = new RegExp("^(" + o + ")$");
    if (a !== "log" && s.unshift(a.toUpperCase() + ":"), s.unshift(e + ":"), history) {
      history.push([].concat(s));
      var l = history.length - 1e3;
      history.splice(0, l > 0 ? l : 0);
    }
    if (!!window_1.console) {
      var f = window_1.console[a];
      !f && a === "debug" && (f = window_1.console.info || window_1.console.log), !(!f || !o || !u.test(a)) && f[Array.isArray(s) ? "apply" : "call"](window_1.console, s);
    }
  };
};
function createLogger$1(r) {
  var e = "info", t, a = function() {
    for (var s = arguments.length, o = new Array(s), u = 0; u < s; u++)
      o[u] = arguments[u];
    t("log", e, o);
  };
  return t = LogByTypeFactory(r, a), a.createLogger = function(n) {
    return createLogger$1(r + ": " + n);
  }, a.levels = {
    all: "debug|log|warn|error",
    off: "",
    debug: "debug|log|warn|error",
    info: "log|warn|error",
    warn: "warn|error",
    error: "error",
    DEFAULT: e
  }, a.level = function(n) {
    if (typeof n == "string") {
      if (!a.levels.hasOwnProperty(n))
        throw new Error('"' + n + '" in not a valid log level');
      e = n;
    }
    return e;
  }, a.history = function() {
    return history ? [].concat(history) : [];
  }, a.history.filter = function(n) {
    return (history || []).filter(function(s) {
      return new RegExp(".*" + n + ".*").test(s[0]);
    });
  }, a.history.clear = function() {
    history && (history.length = 0);
  }, a.history.disable = function() {
    history !== null && (history.length = 0, history = null);
  }, a.history.enable = function() {
    history === null && (history = []);
  }, a.error = function() {
    for (var n = arguments.length, s = new Array(n), o = 0; o < n; o++)
      s[o] = arguments[o];
    return t("error", e, s);
  }, a.warn = function() {
    for (var n = arguments.length, s = new Array(n), o = 0; o < n; o++)
      s[o] = arguments[o];
    return t("warn", e, s);
  }, a.debug = function() {
    for (var n = arguments.length, s = new Array(n), o = 0; o < n; o++)
      s[o] = arguments[o];
    return t("debug", e, s);
  }, a;
}
var log$1 = createLogger$1("VIDEOJS"), createLogger = log$1.createLogger, toString = Object.prototype.toString, keys = function r(e) {
  return isObject(e) ? Object.keys(e) : [];
};
function each(r, e) {
  keys(r).forEach(function(t) {
    return e(r[t], t);
  });
}
function reduce(r, e, t) {
  return t === void 0 && (t = 0), keys(r).reduce(function(a, n) {
    return e(a, r[n], n);
  }, t);
}
function assign(r) {
  for (var e = arguments.length, t = new Array(e > 1 ? e - 1 : 0), a = 1; a < e; a++)
    t[a - 1] = arguments[a];
  return Object.assign ? _extends$2.apply(void 0, [r].concat(t)) : (t.forEach(function(n) {
    !n || each(n, function(s, o) {
      r[o] = s;
    });
  }), r);
}
function isObject(r) {
  return !!r && typeof r == "object";
}
function isPlain(r) {
  return isObject(r) && toString.call(r) === "[object Object]" && r.constructor === Object;
}
function computedStyle(r, e) {
  if (!r || !e)
    return "";
  if (typeof window_1.getComputedStyle == "function") {
    var t;
    try {
      t = window_1.getComputedStyle(r);
    } catch {
      return "";
    }
    return t ? t.getPropertyValue(e) || t[e] : "";
  }
  return "";
}
var USER_AGENT = window_1.navigator && window_1.navigator.userAgent || "", webkitVersionMap = /AppleWebKit\/([\d.]+)/i.exec(USER_AGENT), appleWebkitVersion = webkitVersionMap ? parseFloat(webkitVersionMap.pop()) : null, IS_IPOD = /iPod/i.test(USER_AGENT), IOS_VERSION = function() {
  var r = USER_AGENT.match(/OS (\d+)_/i);
  return r && r[1] ? r[1] : null;
}(), IS_ANDROID = /Android/i.test(USER_AGENT), ANDROID_VERSION = function() {
  var r = USER_AGENT.match(/Android (\d+)(?:\.(\d+))?(?:\.(\d+))*/i);
  if (!r)
    return null;
  var e = r[1] && parseFloat(r[1]), t = r[2] && parseFloat(r[2]);
  return e && t ? parseFloat(r[1] + "." + r[2]) : e || null;
}(), IS_NATIVE_ANDROID = IS_ANDROID && ANDROID_VERSION < 5 && appleWebkitVersion < 537, IS_FIREFOX = /Firefox/i.test(USER_AGENT), IS_EDGE = /Edg/i.test(USER_AGENT), IS_CHROME = !IS_EDGE && (/Chrome/i.test(USER_AGENT) || /CriOS/i.test(USER_AGENT)), CHROME_VERSION = function() {
  var r = USER_AGENT.match(/(Chrome|CriOS)\/(\d+)/);
  return r && r[2] ? parseFloat(r[2]) : null;
}(), IE_VERSION = function() {
  var r = /MSIE\s(\d+)\.\d/.exec(USER_AGENT), e = r && parseFloat(r[1]);
  return !e && /Trident\/7.0/i.test(USER_AGENT) && /rv:11.0/.test(USER_AGENT) && (e = 11), e;
}(), IS_SAFARI = /Safari/i.test(USER_AGENT) && !IS_CHROME && !IS_ANDROID && !IS_EDGE, IS_WINDOWS = /Windows/i.test(USER_AGENT), TOUCH_ENABLED = Boolean(isReal() && ("ontouchstart" in window_1 || window_1.navigator.maxTouchPoints || window_1.DocumentTouch && window_1.document instanceof window_1.DocumentTouch)), IS_IPAD = /iPad/i.test(USER_AGENT) || IS_SAFARI && TOUCH_ENABLED && !/iPhone/i.test(USER_AGENT), IS_IPHONE = /iPhone/i.test(USER_AGENT) && !IS_IPAD, IS_IOS = IS_IPHONE || IS_IPAD || IS_IPOD, IS_ANY_SAFARI = (IS_SAFARI || IS_IOS) && !IS_CHROME, browser = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  IS_IPOD,
  IOS_VERSION,
  IS_ANDROID,
  ANDROID_VERSION,
  IS_NATIVE_ANDROID,
  IS_FIREFOX,
  IS_EDGE,
  IS_CHROME,
  CHROME_VERSION,
  IE_VERSION,
  IS_SAFARI,
  IS_WINDOWS,
  TOUCH_ENABLED,
  IS_IPAD,
  IS_IPHONE,
  IS_IOS,
  IS_ANY_SAFARI
});
function isNonBlankString(r) {
  return typeof r == "string" && Boolean(r.trim());
}
function throwIfWhitespace(r) {
  if (r.indexOf(" ") >= 0)
    throw new Error("class has illegal whitespace characters");
}
function classRegExp(r) {
  return new RegExp("(^|\\s)" + r + "($|\\s)");
}
function isReal() {
  return document_1 === window_1.document;
}
function isEl(r) {
  return isObject(r) && r.nodeType === 1;
}
function isInFrame() {
  try {
    return window_1.parent !== window_1.self;
  } catch {
    return !0;
  }
}
function createQuerier(r) {
  return function(e, t) {
    if (!isNonBlankString(e))
      return document_1[r](null);
    isNonBlankString(t) && (t = document_1.querySelector(t));
    var a = isEl(t) ? t : document_1;
    return a[r] && a[r](e);
  };
}
function createEl(r, e, t, a) {
  r === void 0 && (r = "div"), e === void 0 && (e = {}), t === void 0 && (t = {});
  var n = document_1.createElement(r);
  return Object.getOwnPropertyNames(e).forEach(function(s) {
    var o = e[s];
    s.indexOf("aria-") !== -1 || s === "role" || s === "type" ? (log$1.warn(`Setting attributes in the second argument of createEl()
has been deprecated. Use the third argument instead.
` + ("createEl(type, properties, attributes). Attempting to set " + s + " to " + o + ".")), n.setAttribute(s, o)) : s === "textContent" ? textContent(n, o) : (n[s] !== o || s === "tabIndex") && (n[s] = o);
  }), Object.getOwnPropertyNames(t).forEach(function(s) {
    n.setAttribute(s, t[s]);
  }), a && appendContent(n, a), n;
}
function textContent(r, e) {
  return typeof r.textContent > "u" ? r.innerText = e : r.textContent = e, r;
}
function prependTo(r, e) {
  e.firstChild ? e.insertBefore(r, e.firstChild) : e.appendChild(r);
}
function hasClass(r, e) {
  return throwIfWhitespace(e), r.classList ? r.classList.contains(e) : classRegExp(e).test(r.className);
}
function addClass(r, e) {
  return r.classList ? r.classList.add(e) : hasClass(r, e) || (r.className = (r.className + " " + e).trim()), r;
}
function removeClass(r, e) {
  return r ? (r.classList ? r.classList.remove(e) : (throwIfWhitespace(e), r.className = r.className.split(/\s+/).filter(function(t) {
    return t !== e;
  }).join(" ")), r) : (log$1.warn("removeClass was called with an element that doesn't exist"), null);
}
function toggleClass(r, e, t) {
  var a = hasClass(r, e);
  if (typeof t == "function" && (t = t(r, e)), typeof t != "boolean" && (t = !a), t !== a)
    return t ? addClass(r, e) : removeClass(r, e), r;
}
function setAttributes(r, e) {
  Object.getOwnPropertyNames(e).forEach(function(t) {
    var a = e[t];
    a === null || typeof a > "u" || a === !1 ? r.removeAttribute(t) : r.setAttribute(t, a === !0 ? "" : a);
  });
}
function getAttributes(r) {
  var e = {}, t = ",autoplay,controls,playsinline,loop,muted,default,defaultMuted,";
  if (r && r.attributes && r.attributes.length > 0)
    for (var a = r.attributes, n = a.length - 1; n >= 0; n--) {
      var s = a[n].name, o = a[n].value;
      (typeof r[s] == "boolean" || t.indexOf("," + s + ",") !== -1) && (o = o !== null), e[s] = o;
    }
  return e;
}
function getAttribute(r, e) {
  return r.getAttribute(e);
}
function setAttribute(r, e, t) {
  r.setAttribute(e, t);
}
function removeAttribute(r, e) {
  r.removeAttribute(e);
}
function blockTextSelection() {
  document_1.body.focus(), document_1.onselectstart = function() {
    return !1;
  };
}
function unblockTextSelection() {
  document_1.onselectstart = function() {
    return !0;
  };
}
function getBoundingClientRect(r) {
  if (r && r.getBoundingClientRect && r.parentNode) {
    var e = r.getBoundingClientRect(), t = {};
    return ["bottom", "height", "left", "right", "top", "width"].forEach(function(a) {
      e[a] !== void 0 && (t[a] = e[a]);
    }), t.height || (t.height = parseFloat(computedStyle(r, "height"))), t.width || (t.width = parseFloat(computedStyle(r, "width"))), t;
  }
}
function findPosition(r) {
  if (!r || r && !r.offsetParent)
    return {
      left: 0,
      top: 0,
      width: 0,
      height: 0
    };
  for (var e = r.offsetWidth, t = r.offsetHeight, a = 0, n = 0; r.offsetParent && r !== document_1[FullscreenApi.fullscreenElement]; )
    a += r.offsetLeft, n += r.offsetTop, r = r.offsetParent;
  return {
    left: a,
    top: n,
    width: e,
    height: t
  };
}
function getPointerPosition(r, e) {
  var t = {
    x: 0,
    y: 0
  };
  if (IS_IOS)
    for (var a = r; a && a.nodeName.toLowerCase() !== "html"; ) {
      var n = computedStyle(a, "transform");
      if (/^matrix/.test(n)) {
        var s = n.slice(7, -1).split(/,\s/).map(Number);
        t.x += s[4], t.y += s[5];
      } else if (/^matrix3d/.test(n)) {
        var o = n.slice(9, -1).split(/,\s/).map(Number);
        t.x += o[12], t.y += o[13];
      }
      a = a.parentNode;
    }
  var u = {}, l = findPosition(e.target), f = findPosition(r), d = f.width, h = f.height, p = e.offsetY - (f.top - l.top), m = e.offsetX - (f.left - l.left);
  return e.changedTouches && (m = e.changedTouches[0].pageX - f.left, p = e.changedTouches[0].pageY + f.top, IS_IOS && (m -= t.x, p -= t.y)), u.y = 1 - Math.max(0, Math.min(1, p / h)), u.x = Math.max(0, Math.min(1, m / d)), u;
}
function isTextNode(r) {
  return isObject(r) && r.nodeType === 3;
}
function emptyEl(r) {
  for (; r.firstChild; )
    r.removeChild(r.firstChild);
  return r;
}
function normalizeContent(r) {
  return typeof r == "function" && (r = r()), (Array.isArray(r) ? r : [r]).map(function(e) {
    if (typeof e == "function" && (e = e()), isEl(e) || isTextNode(e))
      return e;
    if (typeof e == "string" && /\S/.test(e))
      return document_1.createTextNode(e);
  }).filter(function(e) {
    return e;
  });
}
function appendContent(r, e) {
  return normalizeContent(e).forEach(function(t) {
    return r.appendChild(t);
  }), r;
}
function insertContent(r, e) {
  return appendContent(emptyEl(r), e);
}
function isSingleLeftClick(r) {
  return r.button === void 0 && r.buttons === void 0 || r.button === 0 && r.buttons === void 0 || r.type === "mouseup" && r.button === 0 && r.buttons === 0 ? !0 : !(r.button !== 0 || r.buttons !== 1);
}
var $ = createQuerier("querySelector"), $$ = createQuerier("querySelectorAll"), Dom = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  isReal,
  isEl,
  isInFrame,
  createEl,
  textContent,
  prependTo,
  hasClass,
  addClass,
  removeClass,
  toggleClass,
  setAttributes,
  getAttributes,
  getAttribute,
  setAttribute,
  removeAttribute,
  blockTextSelection,
  unblockTextSelection,
  getBoundingClientRect,
  findPosition,
  getPointerPosition,
  isTextNode,
  emptyEl,
  normalizeContent,
  appendContent,
  insertContent,
  isSingleLeftClick,
  $,
  $$
}), _windowLoaded = !1, videojs$1, autoSetup = function r() {
  if (videojs$1.options.autoSetup !== !1) {
    var e = Array.prototype.slice.call(document_1.getElementsByTagName("video")), t = Array.prototype.slice.call(document_1.getElementsByTagName("audio")), a = Array.prototype.slice.call(document_1.getElementsByTagName("video-js")), n = e.concat(t, a);
    if (n && n.length > 0)
      for (var s = 0, o = n.length; s < o; s++) {
        var u = n[s];
        if (u && u.getAttribute) {
          if (u.player === void 0) {
            var l = u.getAttribute("data-setup");
            l !== null && videojs$1(u);
          }
        } else {
          autoSetupTimeout(1);
          break;
        }
      }
    else
      _windowLoaded || autoSetupTimeout(1);
  }
};
function autoSetupTimeout(r, e) {
  !isReal() || (e && (videojs$1 = e), window_1.setTimeout(autoSetup, r));
}
function setWindowLoaded() {
  _windowLoaded = !0, window_1.removeEventListener("load", setWindowLoaded);
}
isReal() && (document_1.readyState === "complete" ? setWindowLoaded() : window_1.addEventListener("load", setWindowLoaded));
var createStyleElement = function r(e) {
  var t = document_1.createElement("style");
  return t.className = e, t;
}, setTextContent = function r(e, t) {
  e.styleSheet ? e.styleSheet.cssText = t : e.textContent = t;
}, _initialGuid = 3, _guid = _initialGuid;
function newGUID() {
  return _guid++;
}
var FakeWeakMap;
window_1.WeakMap || (FakeWeakMap = /* @__PURE__ */ function() {
  function r() {
    this.vdata = "vdata" + Math.floor(window_1.performance && window_1.performance.now() || Date.now()), this.data = {};
  }
  var e = r.prototype;
  return e.set = function(a, n) {
    var s = a[this.vdata] || newGUID();
    return a[this.vdata] || (a[this.vdata] = s), this.data[s] = n, this;
  }, e.get = function(a) {
    var n = a[this.vdata];
    if (n)
      return this.data[n];
    log$1("We have no data for this element", a);
  }, e.has = function(a) {
    var n = a[this.vdata];
    return n in this.data;
  }, e.delete = function(a) {
    var n = a[this.vdata];
    n && (delete this.data[n], delete a[this.vdata]);
  }, r;
}());
var DomData = window_1.WeakMap ? /* @__PURE__ */ new WeakMap() : new FakeWeakMap();
function _cleanUpEvents(r, e) {
  if (!!DomData.has(r)) {
    var t = DomData.get(r);
    t.handlers[e].length === 0 && (delete t.handlers[e], r.removeEventListener ? r.removeEventListener(e, t.dispatcher, !1) : r.detachEvent && r.detachEvent("on" + e, t.dispatcher)), Object.getOwnPropertyNames(t.handlers).length <= 0 && (delete t.handlers, delete t.dispatcher, delete t.disabled), Object.getOwnPropertyNames(t).length === 0 && DomData.delete(r);
  }
}
function _handleMultipleEvents(r, e, t, a) {
  t.forEach(function(n) {
    r(e, n, a);
  });
}
function fixEvent(r) {
  if (r.fixed_)
    return r;
  function e() {
    return !0;
  }
  function t() {
    return !1;
  }
  if (!r || !r.isPropagationStopped || !r.isImmediatePropagationStopped) {
    var a = r || window_1.event;
    r = {};
    for (var n in a)
      n !== "layerX" && n !== "layerY" && n !== "keyLocation" && n !== "webkitMovementX" && n !== "webkitMovementY" && n !== "path" && (n === "returnValue" && a.preventDefault || (r[n] = a[n]));
    if (r.target || (r.target = r.srcElement || document_1), r.relatedTarget || (r.relatedTarget = r.fromElement === r.target ? r.toElement : r.fromElement), r.preventDefault = function() {
      a.preventDefault && a.preventDefault(), r.returnValue = !1, a.returnValue = !1, r.defaultPrevented = !0;
    }, r.defaultPrevented = !1, r.stopPropagation = function() {
      a.stopPropagation && a.stopPropagation(), r.cancelBubble = !0, a.cancelBubble = !0, r.isPropagationStopped = e;
    }, r.isPropagationStopped = t, r.stopImmediatePropagation = function() {
      a.stopImmediatePropagation && a.stopImmediatePropagation(), r.isImmediatePropagationStopped = e, r.stopPropagation();
    }, r.isImmediatePropagationStopped = t, r.clientX !== null && r.clientX !== void 0) {
      var s = document_1.documentElement, o = document_1.body;
      r.pageX = r.clientX + (s && s.scrollLeft || o && o.scrollLeft || 0) - (s && s.clientLeft || o && o.clientLeft || 0), r.pageY = r.clientY + (s && s.scrollTop || o && o.scrollTop || 0) - (s && s.clientTop || o && o.clientTop || 0);
    }
    r.which = r.charCode || r.keyCode, r.button !== null && r.button !== void 0 && (r.button = r.button & 1 ? 0 : r.button & 4 ? 1 : r.button & 2 ? 2 : 0);
  }
  return r.fixed_ = !0, r;
}
var _supportsPassive, supportsPassive = function r() {
  if (typeof _supportsPassive != "boolean") {
    _supportsPassive = !1;
    try {
      var e = Object.defineProperty({}, "passive", {
        get: function() {
          _supportsPassive = !0;
        }
      });
      window_1.addEventListener("test", null, e), window_1.removeEventListener("test", null, e);
    } catch {
    }
  }
  return _supportsPassive;
}, passiveEvents = ["touchstart", "touchmove"];
function on(r, e, t) {
  if (Array.isArray(e))
    return _handleMultipleEvents(on, r, e, t);
  DomData.has(r) || DomData.set(r, {});
  var a = DomData.get(r);
  if (a.handlers || (a.handlers = {}), a.handlers[e] || (a.handlers[e] = []), t.guid || (t.guid = newGUID()), a.handlers[e].push(t), a.dispatcher || (a.disabled = !1, a.dispatcher = function(s, o) {
    if (!a.disabled) {
      s = fixEvent(s);
      var u = a.handlers[s.type];
      if (u)
        for (var l = u.slice(0), f = 0, d = l.length; f < d && !s.isImmediatePropagationStopped(); f++)
          try {
            l[f].call(r, s, o);
          } catch (h) {
            log$1.error(h);
          }
    }
  }), a.handlers[e].length === 1)
    if (r.addEventListener) {
      var n = !1;
      supportsPassive() && passiveEvents.indexOf(e) > -1 && (n = {
        passive: !0
      }), r.addEventListener(e, a.dispatcher, n);
    } else
      r.attachEvent && r.attachEvent("on" + e, a.dispatcher);
}
function off(r, e, t) {
  if (!!DomData.has(r)) {
    var a = DomData.get(r);
    if (!!a.handlers) {
      if (Array.isArray(e))
        return _handleMultipleEvents(off, r, e, t);
      var n = function(f, d) {
        a.handlers[d] = [], _cleanUpEvents(f, d);
      };
      if (e === void 0) {
        for (var s in a.handlers)
          Object.prototype.hasOwnProperty.call(a.handlers || {}, s) && n(r, s);
        return;
      }
      var o = a.handlers[e];
      if (!!o) {
        if (!t) {
          n(r, e);
          return;
        }
        if (t.guid)
          for (var u = 0; u < o.length; u++)
            o[u].guid === t.guid && o.splice(u--, 1);
        _cleanUpEvents(r, e);
      }
    }
  }
}
function trigger(r, e, t) {
  var a = DomData.has(r) ? DomData.get(r) : {}, n = r.parentNode || r.ownerDocument;
  if (typeof e == "string" ? e = {
    type: e,
    target: r
  } : e.target || (e.target = r), e = fixEvent(e), a.dispatcher && a.dispatcher.call(r, e, t), n && !e.isPropagationStopped() && e.bubbles === !0)
    trigger.call(null, n, e, t);
  else if (!n && !e.defaultPrevented && e.target && e.target[e.type]) {
    DomData.has(e.target) || DomData.set(e.target, {});
    var s = DomData.get(e.target);
    e.target[e.type] && (s.disabled = !0, typeof e.target[e.type] == "function" && e.target[e.type](), s.disabled = !1);
  }
  return !e.defaultPrevented;
}
function one(r, e, t) {
  if (Array.isArray(e))
    return _handleMultipleEvents(one, r, e, t);
  var a = function n() {
    off(r, e, n), t.apply(this, arguments);
  };
  a.guid = t.guid = t.guid || newGUID(), on(r, e, a);
}
function any(r, e, t) {
  var a = function n() {
    off(r, e, n), t.apply(this, arguments);
  };
  a.guid = t.guid = t.guid || newGUID(), on(r, e, a);
}
var Events = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  fixEvent,
  on,
  off,
  trigger,
  one,
  any
}), UPDATE_REFRESH_INTERVAL = 30, bind = function r(e, t, a) {
  t.guid || (t.guid = newGUID());
  var n = t.bind(e);
  return n.guid = a ? a + "_" + t.guid : t.guid, n;
}, throttle = function r(e, t) {
  var a = window_1.performance.now(), n = function() {
    var o = window_1.performance.now();
    o - a >= t && (e.apply(void 0, arguments), a = o);
  };
  return n;
}, debounce = function r(e, t, a, n) {
  n === void 0 && (n = window_1);
  var s, o = function() {
    n.clearTimeout(s), s = null;
  }, u = function() {
    var f = this, d = arguments, h = function() {
      s = null, h = null, a || e.apply(f, d);
    };
    !s && a && e.apply(f, d), n.clearTimeout(s), s = n.setTimeout(h, t);
  };
  return u.cancel = o, u;
}, EventTarget$2 = function r() {
};
EventTarget$2.prototype.allowedEvents_ = {};
EventTarget$2.prototype.on = function(r, e) {
  var t = this.addEventListener;
  this.addEventListener = function() {
  }, on(this, r, e), this.addEventListener = t;
};
EventTarget$2.prototype.addEventListener = EventTarget$2.prototype.on;
EventTarget$2.prototype.off = function(r, e) {
  off(this, r, e);
};
EventTarget$2.prototype.removeEventListener = EventTarget$2.prototype.off;
EventTarget$2.prototype.one = function(r, e) {
  var t = this.addEventListener;
  this.addEventListener = function() {
  }, one(this, r, e), this.addEventListener = t;
};
EventTarget$2.prototype.any = function(r, e) {
  var t = this.addEventListener;
  this.addEventListener = function() {
  }, any(this, r, e), this.addEventListener = t;
};
EventTarget$2.prototype.trigger = function(r) {
  var e = r.type || r;
  typeof r == "string" && (r = {
    type: e
  }), r = fixEvent(r), this.allowedEvents_[e] && this["on" + e] && this["on" + e](r), trigger(this, r);
};
EventTarget$2.prototype.dispatchEvent = EventTarget$2.prototype.trigger;
var EVENT_MAP;
EventTarget$2.prototype.queueTrigger = function(r) {
  var e = this;
  EVENT_MAP || (EVENT_MAP = /* @__PURE__ */ new Map());
  var t = r.type || r, a = EVENT_MAP.get(this);
  a || (a = /* @__PURE__ */ new Map(), EVENT_MAP.set(this, a));
  var n = a.get(t);
  a.delete(t), window_1.clearTimeout(n);
  var s = window_1.setTimeout(function() {
    a.size === 0 && (a = null, EVENT_MAP.delete(e)), e.trigger(r);
  }, 0);
  a.set(t, s);
};
var objName = function r(e) {
  return typeof e.name == "function" ? e.name() : typeof e.name == "string" ? e.name : e.name_ ? e.name_ : e.constructor && e.constructor.name ? e.constructor.name : typeof e;
}, isEvented = function r(e) {
  return e instanceof EventTarget$2 || !!e.eventBusEl_ && ["on", "one", "off", "trigger"].every(function(t) {
    return typeof e[t] == "function";
  });
}, addEventedCallback = function r(e, t) {
  isEvented(e) ? t() : (e.eventedCallbacks || (e.eventedCallbacks = []), e.eventedCallbacks.push(t));
}, isValidEventType = function r(e) {
  return typeof e == "string" && /\S/.test(e) || Array.isArray(e) && !!e.length;
}, validateTarget = function r(e, t, a) {
  if (!e || !e.nodeName && !isEvented(e))
    throw new Error("Invalid target for " + objName(t) + "#" + a + "; must be a DOM node or evented object.");
}, validateEventType = function r(e, t, a) {
  if (!isValidEventType(e))
    throw new Error("Invalid event type for " + objName(t) + "#" + a + "; must be a non-empty string or array.");
}, validateListener = function r(e, t, a) {
  if (typeof e != "function")
    throw new Error("Invalid listener for " + objName(t) + "#" + a + "; must be a function.");
}, normalizeListenArgs = function r(e, t, a) {
  var n = t.length < 3 || t[0] === e || t[0] === e.eventBusEl_, s, o, u;
  return n ? (s = e.eventBusEl_, t.length >= 3 && t.shift(), o = t[0], u = t[1]) : (s = t[0], o = t[1], u = t[2]), validateTarget(s, e, a), validateEventType(o, e, a), validateListener(u, e, a), u = bind(e, u), {
    isTargetingSelf: n,
    target: s,
    type: o,
    listener: u
  };
}, listen = function r(e, t, a, n) {
  validateTarget(e, e, t), e.nodeName ? Events[t](e, a, n) : e[t](a, n);
}, EventedMixin = {
  on: function r() {
    for (var e = this, t = arguments.length, a = new Array(t), n = 0; n < t; n++)
      a[n] = arguments[n];
    var s = normalizeListenArgs(this, a, "on"), o = s.isTargetingSelf, u = s.target, l = s.type, f = s.listener;
    if (listen(u, "on", l, f), !o) {
      var d = function() {
        return e.off(u, l, f);
      };
      d.guid = f.guid;
      var h = function() {
        return e.off("dispose", d);
      };
      h.guid = f.guid, listen(this, "on", "dispose", d), listen(u, "on", "dispose", h);
    }
  },
  one: function r() {
    for (var e = this, t = arguments.length, a = new Array(t), n = 0; n < t; n++)
      a[n] = arguments[n];
    var s = normalizeListenArgs(this, a, "one"), o = s.isTargetingSelf, u = s.target, l = s.type, f = s.listener;
    if (o)
      listen(u, "one", l, f);
    else {
      var d = function h() {
        e.off(u, l, h);
        for (var p = arguments.length, m = new Array(p), _ = 0; _ < p; _++)
          m[_] = arguments[_];
        f.apply(null, m);
      };
      d.guid = f.guid, listen(u, "one", l, d);
    }
  },
  any: function r() {
    for (var e = this, t = arguments.length, a = new Array(t), n = 0; n < t; n++)
      a[n] = arguments[n];
    var s = normalizeListenArgs(this, a, "any"), o = s.isTargetingSelf, u = s.target, l = s.type, f = s.listener;
    if (o)
      listen(u, "any", l, f);
    else {
      var d = function h() {
        e.off(u, l, h);
        for (var p = arguments.length, m = new Array(p), _ = 0; _ < p; _++)
          m[_] = arguments[_];
        f.apply(null, m);
      };
      d.guid = f.guid, listen(u, "any", l, d);
    }
  },
  off: function r(e, t, a) {
    if (!e || isValidEventType(e))
      off(this.eventBusEl_, e, t);
    else {
      var n = e, s = t;
      validateTarget(n, this, "off"), validateEventType(s, this, "off"), validateListener(a, this, "off"), a = bind(this, a), this.off("dispose", a), n.nodeName ? (off(n, s, a), off(n, "dispose", a)) : isEvented(n) && (n.off(s, a), n.off("dispose", a));
    }
  },
  trigger: function r(e, t) {
    validateTarget(this.eventBusEl_, this, "trigger");
    var a = e && typeof e != "string" ? e.type : e;
    if (!isValidEventType(a)) {
      var n = "Invalid event type for " + objName(this) + "#trigger; must be a non-empty string or object with a type key that has a non-empty value.";
      if (e)
        (this.log || log$1).error(n);
      else
        throw new Error(n);
    }
    return trigger(this.eventBusEl_, e, t);
  }
};
function evented(r, e) {
  e === void 0 && (e = {});
  var t = e, a = t.eventBusKey;
  if (a) {
    if (!r[a].nodeName)
      throw new Error('The eventBusKey "' + a + '" does not refer to an element.');
    r.eventBusEl_ = r[a];
  } else
    r.eventBusEl_ = createEl("span", {
      className: "vjs-event-bus"
    });
  return assign(r, EventedMixin), r.eventedCallbacks && r.eventedCallbacks.forEach(function(n) {
    n();
  }), r.on("dispose", function() {
    r.off(), [r, r.el_, r.eventBusEl_].forEach(function(n) {
      n && DomData.has(n) && DomData.delete(n);
    }), window_1.setTimeout(function() {
      r.eventBusEl_ = null;
    }, 0);
  }), r;
}
var StatefulMixin = {
  state: {},
  setState: function r(e) {
    var t = this;
    typeof e == "function" && (e = e());
    var a;
    return each(e, function(n, s) {
      t.state[s] !== n && (a = a || {}, a[s] = {
        from: t.state[s],
        to: n
      }), t.state[s] = n;
    }), a && isEvented(this) && this.trigger({
      changes: a,
      type: "statechanged"
    }), a;
  }
};
function stateful(r, e) {
  return assign(r, StatefulMixin), r.state = assign({}, r.state, e), typeof r.handleStateChanged == "function" && isEvented(r) && r.on("statechanged", r.handleStateChanged), r;
}
var toLowerCase = function r(e) {
  return typeof e != "string" ? e : e.replace(/./, function(t) {
    return t.toLowerCase();
  });
}, toTitleCase$1 = function r(e) {
  return typeof e != "string" ? e : e.replace(/./, function(t) {
    return t.toUpperCase();
  });
}, titleCaseEquals = function r(e, t) {
  return toTitleCase$1(e) === toTitleCase$1(t);
};
function mergeOptions$3() {
  for (var r = {}, e = arguments.length, t = new Array(e), a = 0; a < e; a++)
    t[a] = arguments[a];
  return t.forEach(function(n) {
    !n || each(n, function(s, o) {
      if (!isPlain(s)) {
        r[o] = s;
        return;
      }
      isPlain(r[o]) || (r[o] = {}), r[o] = mergeOptions$3(r[o], s);
    });
  }), r;
}
var MapSham = /* @__PURE__ */ function() {
  function r() {
    this.map_ = {};
  }
  var e = r.prototype;
  return e.has = function(a) {
    return a in this.map_;
  }, e.delete = function(a) {
    var n = this.has(a);
    return delete this.map_[a], n;
  }, e.set = function(a, n) {
    return this.map_[a] = n, this;
  }, e.forEach = function(a, n) {
    for (var s in this.map_)
      a.call(n, this.map_[s], s, this);
  }, r;
}(), Map$1 = window_1.Map ? window_1.Map : MapSham, SetSham = /* @__PURE__ */ function() {
  function r() {
    this.set_ = {};
  }
  var e = r.prototype;
  return e.has = function(a) {
    return a in this.set_;
  }, e.delete = function(a) {
    var n = this.has(a);
    return delete this.set_[a], n;
  }, e.add = function(a) {
    return this.set_[a] = 1, this;
  }, e.forEach = function(a, n) {
    for (var s in this.set_)
      a.call(n, s, s, this);
  }, r;
}(), Set$1 = window_1.Set ? window_1.Set : SetSham, Component$1 = /* @__PURE__ */ function() {
  function r(t, a, n) {
    var s = this;
    if (!t && this.play ? this.player_ = t = this : this.player_ = t, this.isDisposed_ = !1, this.parentComponent_ = null, this.options_ = mergeOptions$3({}, this.options_), a = this.options_ = mergeOptions$3(this.options_, a), this.id_ = a.id || a.el && a.el.id, !this.id_) {
      var o = t && t.id && t.id() || "no_player";
      this.id_ = o + "_component_" + newGUID();
    }
    this.name_ = a.name || null, a.el ? this.el_ = a.el : a.createEl !== !1 && (this.el_ = this.createEl()), a.className && this.el_ && a.className.split(" ").forEach(function(u) {
      return s.addClass(u);
    }), a.evented !== !1 && (evented(this, {
      eventBusKey: this.el_ ? "el_" : null
    }), this.handleLanguagechange = this.handleLanguagechange.bind(this), this.on(this.player_, "languagechange", this.handleLanguagechange)), stateful(this, this.constructor.defaultState), this.children_ = [], this.childIndex_ = {}, this.childNameIndex_ = {}, this.setTimeoutIds_ = new Set$1(), this.setIntervalIds_ = new Set$1(), this.rafIds_ = new Set$1(), this.namedRafs_ = new Map$1(), this.clearingTimersOnDispose_ = !1, a.initChildren !== !1 && this.initChildren(), this.ready(n), a.reportTouchActivity !== !1 && this.enableTouchActivity();
  }
  var e = r.prototype;
  return e.dispose = function(a) {
    if (a === void 0 && (a = {}), !this.isDisposed_) {
      if (this.readyQueue_ && (this.readyQueue_.length = 0), this.trigger({
        type: "dispose",
        bubbles: !1
      }), this.isDisposed_ = !0, this.children_)
        for (var n = this.children_.length - 1; n >= 0; n--)
          this.children_[n].dispose && this.children_[n].dispose();
      this.children_ = null, this.childIndex_ = null, this.childNameIndex_ = null, this.parentComponent_ = null, this.el_ && (this.el_.parentNode && (a.restoreEl ? this.el_.parentNode.replaceChild(a.restoreEl, this.el_) : this.el_.parentNode.removeChild(this.el_)), this.el_ = null), this.player_ = null;
    }
  }, e.isDisposed = function() {
    return Boolean(this.isDisposed_);
  }, e.player = function() {
    return this.player_;
  }, e.options = function(a) {
    return a ? (this.options_ = mergeOptions$3(this.options_, a), this.options_) : this.options_;
  }, e.el = function() {
    return this.el_;
  }, e.createEl = function(a, n, s) {
    return createEl(a, n, s);
  }, e.localize = function(a, n, s) {
    s === void 0 && (s = a);
    var o = this.player_.language && this.player_.language(), u = this.player_.languages && this.player_.languages(), l = u && u[o], f = o && o.split("-")[0], d = u && u[f], h = s;
    return l && l[a] ? h = l[a] : d && d[a] && (h = d[a]), n && (h = h.replace(/\{(\d+)\}/g, function(p, m) {
      var _ = n[m - 1], w = _;
      return typeof _ > "u" && (w = p), w;
    })), h;
  }, e.handleLanguagechange = function() {
  }, e.contentEl = function() {
    return this.contentEl_ || this.el_;
  }, e.id = function() {
    return this.id_;
  }, e.name = function() {
    return this.name_;
  }, e.children = function() {
    return this.children_;
  }, e.getChildById = function(a) {
    return this.childIndex_[a];
  }, e.getChild = function(a) {
    if (!!a)
      return this.childNameIndex_[a];
  }, e.getDescendant = function() {
    for (var a = arguments.length, n = new Array(a), s = 0; s < a; s++)
      n[s] = arguments[s];
    n = n.reduce(function(l, f) {
      return l.concat(f);
    }, []);
    for (var o = this, u = 0; u < n.length; u++)
      if (o = o.getChild(n[u]), !o || !o.getChild)
        return;
    return o;
  }, e.addChild = function(a, n, s) {
    n === void 0 && (n = {}), s === void 0 && (s = this.children_.length);
    var o, u;
    if (typeof a == "string") {
      u = toTitleCase$1(a);
      var l = n.componentClass || u;
      n.name = u;
      var f = r.getComponent(l);
      if (!f)
        throw new Error("Component " + l + " does not exist");
      if (typeof f != "function")
        return null;
      o = new f(this.player_ || this, n);
    } else
      o = a;
    if (o.parentComponent_ && o.parentComponent_.removeChild(o), this.children_.splice(s, 0, o), o.parentComponent_ = this, typeof o.id == "function" && (this.childIndex_[o.id()] = o), u = u || o.name && toTitleCase$1(o.name()), u && (this.childNameIndex_[u] = o, this.childNameIndex_[toLowerCase(u)] = o), typeof o.el == "function" && o.el()) {
      var d = null;
      this.children_[s + 1] && (this.children_[s + 1].el_ ? d = this.children_[s + 1].el_ : isEl(this.children_[s + 1]) && (d = this.children_[s + 1])), this.contentEl().insertBefore(o.el(), d);
    }
    return o;
  }, e.removeChild = function(a) {
    if (typeof a == "string" && (a = this.getChild(a)), !(!a || !this.children_)) {
      for (var n = !1, s = this.children_.length - 1; s >= 0; s--)
        if (this.children_[s] === a) {
          n = !0, this.children_.splice(s, 1);
          break;
        }
      if (!!n) {
        a.parentComponent_ = null, this.childIndex_[a.id()] = null, this.childNameIndex_[toTitleCase$1(a.name())] = null, this.childNameIndex_[toLowerCase(a.name())] = null;
        var o = a.el();
        o && o.parentNode === this.contentEl() && this.contentEl().removeChild(a.el());
      }
    }
  }, e.initChildren = function() {
    var a = this, n = this.options_.children;
    if (n) {
      var s = this.options_, o = function(d) {
        var h = d.name, p = d.opts;
        if (s[h] !== void 0 && (p = s[h]), p !== !1) {
          p === !0 && (p = {}), p.playerOptions = a.options_.playerOptions;
          var m = a.addChild(h, p);
          m && (a[h] = m);
        }
      }, u, l = r.getComponent("Tech");
      Array.isArray(n) ? u = n : u = Object.keys(n), u.concat(Object.keys(this.options_).filter(function(f) {
        return !u.some(function(d) {
          return typeof d == "string" ? f === d : f === d.name;
        });
      })).map(function(f) {
        var d, h;
        return typeof f == "string" ? (d = f, h = n[d] || a.options_[d] || {}) : (d = f.name, h = f), {
          name: d,
          opts: h
        };
      }).filter(function(f) {
        var d = r.getComponent(f.opts.componentClass || toTitleCase$1(f.name));
        return d && !l.isTech(d);
      }).forEach(o);
    }
  }, e.buildCSSClass = function() {
    return "";
  }, e.ready = function(a, n) {
    if (n === void 0 && (n = !1), !!a) {
      if (!this.isReady_) {
        this.readyQueue_ = this.readyQueue_ || [], this.readyQueue_.push(a);
        return;
      }
      n ? a.call(this) : this.setTimeout(a, 1);
    }
  }, e.triggerReady = function() {
    this.isReady_ = !0, this.setTimeout(function() {
      var a = this.readyQueue_;
      this.readyQueue_ = [], a && a.length > 0 && a.forEach(function(n) {
        n.call(this);
      }, this), this.trigger("ready");
    }, 1);
  }, e.$ = function(a, n) {
    return $(a, n || this.contentEl());
  }, e.$$ = function(a, n) {
    return $$(a, n || this.contentEl());
  }, e.hasClass = function(a) {
    return hasClass(this.el_, a);
  }, e.addClass = function(a) {
    addClass(this.el_, a);
  }, e.removeClass = function(a) {
    removeClass(this.el_, a);
  }, e.toggleClass = function(a, n) {
    toggleClass(this.el_, a, n);
  }, e.show = function() {
    this.removeClass("vjs-hidden");
  }, e.hide = function() {
    this.addClass("vjs-hidden");
  }, e.lockShowing = function() {
    this.addClass("vjs-lock-showing");
  }, e.unlockShowing = function() {
    this.removeClass("vjs-lock-showing");
  }, e.getAttribute = function(a) {
    return getAttribute(this.el_, a);
  }, e.setAttribute = function(a, n) {
    setAttribute(this.el_, a, n);
  }, e.removeAttribute = function(a) {
    removeAttribute(this.el_, a);
  }, e.width = function(a, n) {
    return this.dimension("width", a, n);
  }, e.height = function(a, n) {
    return this.dimension("height", a, n);
  }, e.dimensions = function(a, n) {
    this.width(a, !0), this.height(n);
  }, e.dimension = function(a, n, s) {
    if (n !== void 0) {
      (n === null || n !== n) && (n = 0), ("" + n).indexOf("%") !== -1 || ("" + n).indexOf("px") !== -1 ? this.el_.style[a] = n : n === "auto" ? this.el_.style[a] = "" : this.el_.style[a] = n + "px", s || this.trigger("componentresize");
      return;
    }
    if (!this.el_)
      return 0;
    var o = this.el_.style[a], u = o.indexOf("px");
    return parseInt(u !== -1 ? o.slice(0, u) : this.el_["offset" + toTitleCase$1(a)], 10);
  }, e.currentDimension = function(a) {
    var n = 0;
    if (a !== "width" && a !== "height")
      throw new Error("currentDimension only accepts width or height value");
    if (n = computedStyle(this.el_, a), n = parseFloat(n), n === 0 || isNaN(n)) {
      var s = "offset" + toTitleCase$1(a);
      n = this.el_[s];
    }
    return n;
  }, e.currentDimensions = function() {
    return {
      width: this.currentDimension("width"),
      height: this.currentDimension("height")
    };
  }, e.currentWidth = function() {
    return this.currentDimension("width");
  }, e.currentHeight = function() {
    return this.currentDimension("height");
  }, e.focus = function() {
    this.el_.focus();
  }, e.blur = function() {
    this.el_.blur();
  }, e.handleKeyDown = function(a) {
    this.player_ && (keycode.isEventKey(a, "Tab") || a.stopPropagation(), this.player_.handleKeyDown(a));
  }, e.handleKeyPress = function(a) {
    this.handleKeyDown(a);
  }, e.emitTapEvents = function() {
    var a = 0, n = null, s = 10, o = 200, u;
    this.on("touchstart", function(f) {
      f.touches.length === 1 && (n = {
        pageX: f.touches[0].pageX,
        pageY: f.touches[0].pageY
      }, a = window_1.performance.now(), u = !0);
    }), this.on("touchmove", function(f) {
      if (f.touches.length > 1)
        u = !1;
      else if (n) {
        var d = f.touches[0].pageX - n.pageX, h = f.touches[0].pageY - n.pageY, p = Math.sqrt(d * d + h * h);
        p > s && (u = !1);
      }
    });
    var l = function() {
      u = !1;
    };
    this.on("touchleave", l), this.on("touchcancel", l), this.on("touchend", function(f) {
      if (n = null, u === !0) {
        var d = window_1.performance.now() - a;
        d < o && (f.preventDefault(), this.trigger("tap"));
      }
    });
  }, e.enableTouchActivity = function() {
    if (!(!this.player() || !this.player().reportUserActivity)) {
      var a = bind(this.player(), this.player().reportUserActivity), n;
      this.on("touchstart", function() {
        a(), this.clearInterval(n), n = this.setInterval(a, 250);
      });
      var s = function(u) {
        a(), this.clearInterval(n);
      };
      this.on("touchmove", a), this.on("touchend", s), this.on("touchcancel", s);
    }
  }, e.setTimeout = function(a, n) {
    var s = this, o;
    return a = bind(this, a), this.clearTimersOnDispose_(), o = window_1.setTimeout(function() {
      s.setTimeoutIds_.has(o) && s.setTimeoutIds_.delete(o), a();
    }, n), this.setTimeoutIds_.add(o), o;
  }, e.clearTimeout = function(a) {
    return this.setTimeoutIds_.has(a) && (this.setTimeoutIds_.delete(a), window_1.clearTimeout(a)), a;
  }, e.setInterval = function(a, n) {
    a = bind(this, a), this.clearTimersOnDispose_();
    var s = window_1.setInterval(a, n);
    return this.setIntervalIds_.add(s), s;
  }, e.clearInterval = function(a) {
    return this.setIntervalIds_.has(a) && (this.setIntervalIds_.delete(a), window_1.clearInterval(a)), a;
  }, e.requestAnimationFrame = function(a) {
    var n = this;
    if (!this.supportsRaf_)
      return this.setTimeout(a, 1e3 / 60);
    this.clearTimersOnDispose_();
    var s;
    return a = bind(this, a), s = window_1.requestAnimationFrame(function() {
      n.rafIds_.has(s) && n.rafIds_.delete(s), a();
    }), this.rafIds_.add(s), s;
  }, e.requestNamedAnimationFrame = function(a, n) {
    var s = this;
    if (!this.namedRafs_.has(a)) {
      this.clearTimersOnDispose_(), n = bind(this, n);
      var o = this.requestAnimationFrame(function() {
        n(), s.namedRafs_.has(a) && s.namedRafs_.delete(a);
      });
      return this.namedRafs_.set(a, o), a;
    }
  }, e.cancelNamedAnimationFrame = function(a) {
    !this.namedRafs_.has(a) || (this.cancelAnimationFrame(this.namedRafs_.get(a)), this.namedRafs_.delete(a));
  }, e.cancelAnimationFrame = function(a) {
    return this.supportsRaf_ ? (this.rafIds_.has(a) && (this.rafIds_.delete(a), window_1.cancelAnimationFrame(a)), a) : this.clearTimeout(a);
  }, e.clearTimersOnDispose_ = function() {
    var a = this;
    this.clearingTimersOnDispose_ || (this.clearingTimersOnDispose_ = !0, this.one("dispose", function() {
      [["namedRafs_", "cancelNamedAnimationFrame"], ["rafIds_", "cancelAnimationFrame"], ["setTimeoutIds_", "clearTimeout"], ["setIntervalIds_", "clearInterval"]].forEach(function(n) {
        var s = n[0], o = n[1];
        a[s].forEach(function(u, l) {
          return a[o](l);
        });
      }), a.clearingTimersOnDispose_ = !1;
    }));
  }, r.registerComponent = function(a, n) {
    if (typeof a != "string" || !a)
      throw new Error('Illegal component name, "' + a + '"; must be a non-empty string.');
    var s = r.getComponent("Tech"), o = s && s.isTech(n), u = r === n || r.prototype.isPrototypeOf(n.prototype);
    if (o || !u) {
      var l;
      throw o ? l = "techs must be registered using Tech.registerTech()" : l = "must be a Component subclass", new Error('Illegal component, "' + a + '"; ' + l + ".");
    }
    a = toTitleCase$1(a), r.components_ || (r.components_ = {});
    var f = r.getComponent("Player");
    if (a === "Player" && f && f.players) {
      var d = f.players, h = Object.keys(d);
      if (d && h.length > 0 && h.map(function(p) {
        return d[p];
      }).every(Boolean))
        throw new Error("Can not register Player component after player has been created.");
    }
    return r.components_[a] = n, r.components_[toLowerCase(a)] = n, n;
  }, r.getComponent = function(a) {
    if (!(!a || !r.components_))
      return r.components_[a];
  }, r;
}();
Component$1.prototype.supportsRaf_ = typeof window_1.requestAnimationFrame == "function" && typeof window_1.cancelAnimationFrame == "function";
Component$1.registerComponent("Component", Component$1);
function rangeCheck(r, e, t) {
  if (typeof e != "number" || e < 0 || e > t)
    throw new Error("Failed to execute '" + r + "' on 'TimeRanges': The index provided (" + e + ") is non-numeric or out of bounds (0-" + t + ").");
}
function getRange(r, e, t, a) {
  return rangeCheck(r, a, t.length - 1), t[a][e];
}
function createTimeRangesObj(r) {
  var e;
  return r === void 0 || r.length === 0 ? e = {
    length: 0,
    start: function() {
      throw new Error("This TimeRanges object is empty");
    },
    end: function() {
      throw new Error("This TimeRanges object is empty");
    }
  } : e = {
    length: r.length,
    start: getRange.bind(null, "start", 0, r),
    end: getRange.bind(null, "end", 1, r)
  }, window_1.Symbol && window_1.Symbol.iterator && (e[window_1.Symbol.iterator] = function() {
    return (r || []).values();
  }), e;
}
function createTimeRanges(r, e) {
  return Array.isArray(r) ? createTimeRangesObj(r) : r === void 0 || e === void 0 ? createTimeRangesObj() : createTimeRangesObj([[r, e]]);
}
function bufferedPercent(r, e) {
  var t = 0, a, n;
  if (!e)
    return 0;
  (!r || !r.length) && (r = createTimeRanges(0, 0));
  for (var s = 0; s < r.length; s++)
    a = r.start(s), n = r.end(s), n > e && (n = e), t += n - a;
  return t / e;
}
function MediaError(r) {
  if (r instanceof MediaError)
    return r;
  typeof r == "number" ? this.code = r : typeof r == "string" ? this.message = r : isObject(r) && (typeof r.code == "number" && (this.code = r.code), assign(this, r)), this.message || (this.message = MediaError.defaultMessages[this.code] || "");
}
MediaError.prototype.code = 0;
MediaError.prototype.message = "";
MediaError.prototype.status = null;
MediaError.errorTypes = ["MEDIA_ERR_CUSTOM", "MEDIA_ERR_ABORTED", "MEDIA_ERR_NETWORK", "MEDIA_ERR_DECODE", "MEDIA_ERR_SRC_NOT_SUPPORTED", "MEDIA_ERR_ENCRYPTED"];
MediaError.defaultMessages = {
  1: "You aborted the media playback",
  2: "A network error caused the media download to fail part-way.",
  3: "The media playback was aborted due to a corruption problem or because the media used features your browser did not support.",
  4: "The media could not be loaded, either because the server or network failed or because the format is not supported.",
  5: "The media is encrypted and we do not have the keys to decrypt it."
};
for (var errNum = 0; errNum < MediaError.errorTypes.length; errNum++)
  MediaError[MediaError.errorTypes[errNum]] = errNum, MediaError.prototype[MediaError.errorTypes[errNum]] = errNum;
function isPromise(r) {
  return r != null && typeof r.then == "function";
}
function silencePromise(r) {
  isPromise(r) && r.then(null, function(e) {
  });
}
var trackToJson_ = function r(e) {
  var t = ["kind", "label", "language", "id", "inBandMetadataTrackDispatchType", "mode", "src"].reduce(function(a, n, s) {
    return e[n] && (a[n] = e[n]), a;
  }, {
    cues: e.cues && Array.prototype.map.call(e.cues, function(a) {
      return {
        startTime: a.startTime,
        endTime: a.endTime,
        text: a.text,
        id: a.id
      };
    })
  });
  return t;
}, textTracksToJson = function r(e) {
  var t = e.$$("track"), a = Array.prototype.map.call(t, function(s) {
    return s.track;
  }), n = Array.prototype.map.call(t, function(s) {
    var o = trackToJson_(s.track);
    return s.src && (o.src = s.src), o;
  });
  return n.concat(Array.prototype.filter.call(e.textTracks(), function(s) {
    return a.indexOf(s) === -1;
  }).map(trackToJson_));
}, jsonToTextTracks = function r(e, t) {
  return e.forEach(function(a) {
    var n = t.addRemoteTextTrack(a).track;
    !a.src && a.cues && a.cues.forEach(function(s) {
      return n.addCue(s);
    });
  }), t.textTracks();
}, textTrackConverter = {
  textTracksToJson,
  jsonToTextTracks,
  trackToJson_
}, MODAL_CLASS_NAME = "vjs-modal-dialog", ModalDialog = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.handleKeyDown_ = function(o) {
      return s.handleKeyDown(o);
    }, s.close_ = function(o) {
      return s.close(o);
    }, s.opened_ = s.hasBeenOpened_ = s.hasBeenFilled_ = !1, s.closeable(!s.options_.uncloseable), s.content(s.options_.content), s.contentEl_ = createEl("div", {
      className: MODAL_CLASS_NAME + "-content"
    }, {
      role: "document"
    }), s.descEl_ = createEl("p", {
      className: MODAL_CLASS_NAME + "-description vjs-control-text",
      id: s.el().getAttribute("aria-describedby")
    }), textContent(s.descEl_, s.description()), s.el_.appendChild(s.descEl_), s.el_.appendChild(s.contentEl_), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: this.buildCSSClass(),
      tabIndex: -1
    }, {
      "aria-describedby": this.id() + "_description",
      "aria-hidden": "true",
      "aria-label": this.label(),
      role: "dialog"
    });
  }, t.dispose = function() {
    this.contentEl_ = null, this.descEl_ = null, this.previouslyActiveEl_ = null, r.prototype.dispose.call(this);
  }, t.buildCSSClass = function() {
    return MODAL_CLASS_NAME + " vjs-hidden " + r.prototype.buildCSSClass.call(this);
  }, t.label = function() {
    return this.localize(this.options_.label || "Modal Window");
  }, t.description = function() {
    var n = this.options_.description || this.localize("This is a modal window.");
    return this.closeable() && (n += " " + this.localize("This modal can be closed by pressing the Escape key or activating the close button.")), n;
  }, t.open = function() {
    if (!this.opened_) {
      var n = this.player();
      this.trigger("beforemodalopen"), this.opened_ = !0, (this.options_.fillAlways || !this.hasBeenOpened_ && !this.hasBeenFilled_) && this.fill(), this.wasPlaying_ = !n.paused(), this.options_.pauseOnOpen && this.wasPlaying_ && n.pause(), this.on("keydown", this.handleKeyDown_), this.hadControls_ = n.controls(), n.controls(!1), this.show(), this.conditionalFocus_(), this.el().setAttribute("aria-hidden", "false"), this.trigger("modalopen"), this.hasBeenOpened_ = !0;
    }
  }, t.opened = function(n) {
    return typeof n == "boolean" && this[n ? "open" : "close"](), this.opened_;
  }, t.close = function() {
    if (!!this.opened_) {
      var n = this.player();
      this.trigger("beforemodalclose"), this.opened_ = !1, this.wasPlaying_ && this.options_.pauseOnOpen && n.play(), this.off("keydown", this.handleKeyDown_), this.hadControls_ && n.controls(!0), this.hide(), this.el().setAttribute("aria-hidden", "true"), this.trigger("modalclose"), this.conditionalBlur_(), this.options_.temporary && this.dispose();
    }
  }, t.closeable = function(n) {
    if (typeof n == "boolean") {
      var s = this.closeable_ = !!n, o = this.getChild("closeButton");
      if (s && !o) {
        var u = this.contentEl_;
        this.contentEl_ = this.el_, o = this.addChild("closeButton", {
          controlText: "Close Modal Dialog"
        }), this.contentEl_ = u, this.on(o, "close", this.close_);
      }
      !s && o && (this.off(o, "close", this.close_), this.removeChild(o), o.dispose());
    }
    return this.closeable_;
  }, t.fill = function() {
    this.fillWith(this.content());
  }, t.fillWith = function(n) {
    var s = this.contentEl(), o = s.parentNode, u = s.nextSibling;
    this.trigger("beforemodalfill"), this.hasBeenFilled_ = !0, o.removeChild(s), this.empty(), insertContent(s, n), this.trigger("modalfill"), u ? o.insertBefore(s, u) : o.appendChild(s);
    var l = this.getChild("closeButton");
    l && o.appendChild(l.el_);
  }, t.empty = function() {
    this.trigger("beforemodalempty"), emptyEl(this.contentEl()), this.trigger("modalempty");
  }, t.content = function(n) {
    return typeof n < "u" && (this.content_ = n), this.content_;
  }, t.conditionalFocus_ = function() {
    var n = document_1.activeElement, s = this.player_.el_;
    this.previouslyActiveEl_ = null, (s.contains(n) || s === n) && (this.previouslyActiveEl_ = n, this.focus());
  }, t.conditionalBlur_ = function() {
    this.previouslyActiveEl_ && (this.previouslyActiveEl_.focus(), this.previouslyActiveEl_ = null);
  }, t.handleKeyDown = function(n) {
    if (n.stopPropagation(), keycode.isEventKey(n, "Escape") && this.closeable()) {
      n.preventDefault(), this.close();
      return;
    }
    if (!!keycode.isEventKey(n, "Tab")) {
      for (var s = this.focusableEls_(), o = this.el_.querySelector(":focus"), u, l = 0; l < s.length; l++)
        if (o === s[l]) {
          u = l;
          break;
        }
      document_1.activeElement === this.el_ && (u = 0), n.shiftKey && u === 0 ? (s[s.length - 1].focus(), n.preventDefault()) : !n.shiftKey && u === s.length - 1 && (s[0].focus(), n.preventDefault());
    }
  }, t.focusableEls_ = function() {
    var n = this.el_.querySelectorAll("*");
    return Array.prototype.filter.call(n, function(s) {
      return (s instanceof window_1.HTMLAnchorElement || s instanceof window_1.HTMLAreaElement) && s.hasAttribute("href") || (s instanceof window_1.HTMLInputElement || s instanceof window_1.HTMLSelectElement || s instanceof window_1.HTMLTextAreaElement || s instanceof window_1.HTMLButtonElement) && !s.hasAttribute("disabled") || s instanceof window_1.HTMLIFrameElement || s instanceof window_1.HTMLObjectElement || s instanceof window_1.HTMLEmbedElement || s.hasAttribute("tabindex") && s.getAttribute("tabindex") !== -1 || s.hasAttribute("contenteditable");
    });
  }, e;
}(Component$1);
ModalDialog.prototype.options_ = {
  pauseOnOpen: !0,
  temporary: !0
};
Component$1.registerComponent("ModalDialog", ModalDialog);
var TrackList = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    a === void 0 && (a = []), n = r.call(this) || this, n.tracks_ = [], Object.defineProperty(_assertThisInitialized$1(n), "length", {
      get: function() {
        return this.tracks_.length;
      }
    });
    for (var s = 0; s < a.length; s++)
      n.addTrack(a[s]);
    return n;
  }
  var t = e.prototype;
  return t.addTrack = function(n) {
    var s = this, o = this.tracks_.length;
    "" + o in this || Object.defineProperty(this, o, {
      get: function() {
        return this.tracks_[o];
      }
    }), this.tracks_.indexOf(n) === -1 && (this.tracks_.push(n), this.trigger({
      track: n,
      type: "addtrack",
      target: this
    })), n.labelchange_ = function() {
      s.trigger({
        track: n,
        type: "labelchange",
        target: s
      });
    }, isEvented(n) && n.addEventListener("labelchange", n.labelchange_);
  }, t.removeTrack = function(n) {
    for (var s, o = 0, u = this.length; o < u; o++)
      if (this[o] === n) {
        s = this[o], s.off && s.off(), this.tracks_.splice(o, 1);
        break;
      }
    !s || this.trigger({
      track: s,
      type: "removetrack",
      target: this
    });
  }, t.getTrackById = function(n) {
    for (var s = null, o = 0, u = this.length; o < u; o++) {
      var l = this[o];
      if (l.id === n) {
        s = l;
        break;
      }
    }
    return s;
  }, e;
}(EventTarget$2);
TrackList.prototype.allowedEvents_ = {
  change: "change",
  addtrack: "addtrack",
  removetrack: "removetrack",
  labelchange: "labelchange"
};
for (var event$1 in TrackList.prototype.allowedEvents_)
  TrackList.prototype["on" + event$1] = null;
var disableOthers$1 = function r(e, t) {
  for (var a = 0; a < e.length; a++)
    !Object.keys(e[a]).length || t.id === e[a].id || (e[a].enabled = !1);
}, AudioTrackList = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    a === void 0 && (a = []);
    for (var s = a.length - 1; s >= 0; s--)
      if (a[s].enabled) {
        disableOthers$1(a, a[s]);
        break;
      }
    return n = r.call(this, a) || this, n.changing_ = !1, n;
  }
  var t = e.prototype;
  return t.addTrack = function(n) {
    var s = this;
    n.enabled && disableOthers$1(this, n), r.prototype.addTrack.call(this, n), n.addEventListener && (n.enabledChange_ = function() {
      s.changing_ || (s.changing_ = !0, disableOthers$1(s, n), s.changing_ = !1, s.trigger("change"));
    }, n.addEventListener("enabledchange", n.enabledChange_));
  }, t.removeTrack = function(n) {
    r.prototype.removeTrack.call(this, n), n.removeEventListener && n.enabledChange_ && (n.removeEventListener("enabledchange", n.enabledChange_), n.enabledChange_ = null);
  }, e;
}(TrackList), disableOthers = function r(e, t) {
  for (var a = 0; a < e.length; a++)
    !Object.keys(e[a]).length || t.id === e[a].id || (e[a].selected = !1);
}, VideoTrackList = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    a === void 0 && (a = []);
    for (var s = a.length - 1; s >= 0; s--)
      if (a[s].selected) {
        disableOthers(a, a[s]);
        break;
      }
    return n = r.call(this, a) || this, n.changing_ = !1, Object.defineProperty(_assertThisInitialized$1(n), "selectedIndex", {
      get: function() {
        for (var u = 0; u < this.length; u++)
          if (this[u].selected)
            return u;
        return -1;
      },
      set: function() {
      }
    }), n;
  }
  var t = e.prototype;
  return t.addTrack = function(n) {
    var s = this;
    n.selected && disableOthers(this, n), r.prototype.addTrack.call(this, n), n.addEventListener && (n.selectedChange_ = function() {
      s.changing_ || (s.changing_ = !0, disableOthers(s, n), s.changing_ = !1, s.trigger("change"));
    }, n.addEventListener("selectedchange", n.selectedChange_));
  }, t.removeTrack = function(n) {
    r.prototype.removeTrack.call(this, n), n.removeEventListener && n.selectedChange_ && (n.removeEventListener("selectedchange", n.selectedChange_), n.selectedChange_ = null);
  }, e;
}(TrackList), TextTrackList = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.addTrack = function(n) {
    var s = this;
    r.prototype.addTrack.call(this, n), this.queueChange_ || (this.queueChange_ = function() {
      return s.queueTrigger("change");
    }), this.triggerSelectedlanguagechange || (this.triggerSelectedlanguagechange_ = function() {
      return s.trigger("selectedlanguagechange");
    }), n.addEventListener("modechange", this.queueChange_);
    var o = ["metadata", "chapters"];
    o.indexOf(n.kind) === -1 && n.addEventListener("modechange", this.triggerSelectedlanguagechange_);
  }, t.removeTrack = function(n) {
    r.prototype.removeTrack.call(this, n), n.removeEventListener && (this.queueChange_ && n.removeEventListener("modechange", this.queueChange_), this.selectedlanguagechange_ && n.removeEventListener("modechange", this.triggerSelectedlanguagechange_));
  }, e;
}(TrackList), HtmlTrackElementList = /* @__PURE__ */ function() {
  function r(t) {
    t === void 0 && (t = []), this.trackElements_ = [], Object.defineProperty(this, "length", {
      get: function() {
        return this.trackElements_.length;
      }
    });
    for (var a = 0, n = t.length; a < n; a++)
      this.addTrackElement_(t[a]);
  }
  var e = r.prototype;
  return e.addTrackElement_ = function(a) {
    var n = this.trackElements_.length;
    "" + n in this || Object.defineProperty(this, n, {
      get: function() {
        return this.trackElements_[n];
      }
    }), this.trackElements_.indexOf(a) === -1 && this.trackElements_.push(a);
  }, e.getTrackElementByTrack_ = function(a) {
    for (var n, s = 0, o = this.trackElements_.length; s < o; s++)
      if (a === this.trackElements_[s].track) {
        n = this.trackElements_[s];
        break;
      }
    return n;
  }, e.removeTrackElement_ = function(a) {
    for (var n = 0, s = this.trackElements_.length; n < s; n++)
      if (a === this.trackElements_[n]) {
        this.trackElements_[n].track && typeof this.trackElements_[n].track.off == "function" && this.trackElements_[n].track.off(), typeof this.trackElements_[n].off == "function" && this.trackElements_[n].off(), this.trackElements_.splice(n, 1);
        break;
      }
  }, r;
}(), TextTrackCueList = /* @__PURE__ */ function() {
  function r(t) {
    r.prototype.setCues_.call(this, t), Object.defineProperty(this, "length", {
      get: function() {
        return this.length_;
      }
    });
  }
  var e = r.prototype;
  return e.setCues_ = function(a) {
    var n = this.length || 0, s = 0, o = a.length;
    this.cues_ = a, this.length_ = a.length;
    var u = function(f) {
      "" + f in this || Object.defineProperty(this, "" + f, {
        get: function() {
          return this.cues_[f];
        }
      });
    };
    if (n < o)
      for (s = n; s < o; s++)
        u.call(this, s);
  }, e.getCueById = function(a) {
    for (var n = null, s = 0, o = this.length; s < o; s++) {
      var u = this[s];
      if (u.id === a) {
        n = u;
        break;
      }
    }
    return n;
  }, r;
}(), VideoTrackKind = {
  alternative: "alternative",
  captions: "captions",
  main: "main",
  sign: "sign",
  subtitles: "subtitles",
  commentary: "commentary"
}, AudioTrackKind = {
  alternative: "alternative",
  descriptions: "descriptions",
  main: "main",
  "main-desc": "main-desc",
  translation: "translation",
  commentary: "commentary"
}, TextTrackKind = {
  subtitles: "subtitles",
  captions: "captions",
  descriptions: "descriptions",
  chapters: "chapters",
  metadata: "metadata"
}, TextTrackMode = {
  disabled: "disabled",
  hidden: "hidden",
  showing: "showing"
}, Track = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(t) {
    var a;
    t === void 0 && (t = {}), a = r.call(this) || this;
    var n = {
      id: t.id || "vjs_track_" + newGUID(),
      kind: t.kind || "",
      language: t.language || ""
    }, s = t.label || "", o = function(f) {
      Object.defineProperty(_assertThisInitialized$1(a), f, {
        get: function() {
          return n[f];
        },
        set: function() {
        }
      });
    };
    for (var u in n)
      o(u);
    return Object.defineProperty(_assertThisInitialized$1(a), "label", {
      get: function() {
        return s;
      },
      set: function(f) {
        f !== s && (s = f, this.trigger("labelchange"));
      }
    }), a;
  }
  return e;
}(EventTarget$2), parseUrl = function r(e) {
  var t = ["protocol", "hostname", "port", "pathname", "search", "hash", "host"], a = document_1.createElement("a");
  a.href = e;
  for (var n = {}, s = 0; s < t.length; s++)
    n[t[s]] = a[t[s]];
  return n.protocol === "http:" && (n.host = n.host.replace(/:80$/, "")), n.protocol === "https:" && (n.host = n.host.replace(/:443$/, "")), n.protocol || (n.protocol = window_1.location.protocol), n.host || (n.host = window_1.location.host), n;
}, getAbsoluteURL = function r(e) {
  if (!e.match(/^https?:\/\//)) {
    var t = document_1.createElement("a");
    t.href = e, e = t.href;
  }
  return e;
}, getFileExtension = function r(e) {
  if (typeof e == "string") {
    var t = /^(\/?)([\s\S]*?)((?:\.{1,2}|[^\/]+?)(\.([^\.\/\?]+)))(?:[\/]*|[\?].*)$/, a = t.exec(e);
    if (a)
      return a.pop().toLowerCase();
  }
  return "";
}, isCrossOrigin = function r(e, t) {
  t === void 0 && (t = window_1.location);
  var a = parseUrl(e), n = a.protocol === ":" ? t.protocol : a.protocol, s = n + a.host !== t.protocol + t.host;
  return s;
}, Url = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  parseUrl,
  getAbsoluteURL,
  getFileExtension,
  isCrossOrigin
}), parseCues = function r(e, t) {
  var a = new window_1.WebVTT.Parser(window_1, window_1.vttjs, window_1.WebVTT.StringDecoder()), n = [];
  a.oncue = function(s) {
    t.addCue(s);
  }, a.onparsingerror = function(s) {
    n.push(s);
  }, a.onflush = function() {
    t.trigger({
      type: "loadeddata",
      target: t
    });
  }, a.parse(e), n.length > 0 && (window_1.console && window_1.console.groupCollapsed && window_1.console.groupCollapsed("Text Track parsing errors for " + t.src), n.forEach(function(s) {
    return log$1.error(s);
  }), window_1.console && window_1.console.groupEnd && window_1.console.groupEnd()), a.flush();
}, loadTrack = function r(e, t) {
  var a = {
    uri: e
  }, n = isCrossOrigin(e);
  n && (a.cors = n);
  var s = t.tech_.crossOrigin() === "use-credentials";
  s && (a.withCredentials = s), lib.exports(a, bind(this, function(o, u, l) {
    if (o)
      return log$1.error(o, u);
    t.loaded_ = !0, typeof window_1.WebVTT != "function" ? t.tech_ && t.tech_.any(["vttjsloaded", "vttjserror"], function(f) {
      if (f.type === "vttjserror") {
        log$1.error("vttjs failed to load, stopping trying to process " + t.src);
        return;
      }
      return parseCues(l, t);
    }) : parseCues(l, t);
  }));
}, TextTrack = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    if (a === void 0 && (a = {}), !a.tech)
      throw new Error("A tech was not provided.");
    var s = mergeOptions$3(a, {
      kind: TextTrackKind[a.kind] || "subtitles",
      language: a.language || a.srclang || ""
    }), o = TextTrackMode[s.mode] || "disabled", u = s.default;
    (s.kind === "metadata" || s.kind === "chapters") && (o = "hidden"), n = r.call(this, s) || this, n.tech_ = s.tech, n.cues_ = [], n.activeCues_ = [], n.preload_ = n.tech_.preloadTextTracks !== !1;
    var l = new TextTrackCueList(n.cues_), f = new TextTrackCueList(n.activeCues_), d = !1;
    n.timeupdateHandler = bind(_assertThisInitialized$1(n), function() {
      if (!this.tech_.isDisposed()) {
        if (!this.tech_.isReady_) {
          this.rvf_ = this.tech_.requestVideoFrameCallback(this.timeupdateHandler);
          return;
        }
        this.activeCues = this.activeCues, d && (this.trigger("cuechange"), d = !1), this.rvf_ = this.tech_.requestVideoFrameCallback(this.timeupdateHandler);
      }
    });
    var h = function() {
      n.stopTracking();
    };
    return n.tech_.one("dispose", h), o !== "disabled" && n.startTracking(), Object.defineProperties(_assertThisInitialized$1(n), {
      default: {
        get: function() {
          return u;
        },
        set: function() {
        }
      },
      mode: {
        get: function() {
          return o;
        },
        set: function(m) {
          !TextTrackMode[m] || o !== m && (o = m, !this.preload_ && o !== "disabled" && this.cues.length === 0 && loadTrack(this.src, this), this.stopTracking(), o !== "disabled" && this.startTracking(), this.trigger("modechange"));
        }
      },
      cues: {
        get: function() {
          return this.loaded_ ? l : null;
        },
        set: function() {
        }
      },
      activeCues: {
        get: function() {
          if (!this.loaded_)
            return null;
          if (this.cues.length === 0)
            return f;
          for (var m = this.tech_.currentTime(), _ = [], w = 0, S = this.cues.length; w < S; w++) {
            var O = this.cues[w];
            (O.startTime <= m && O.endTime >= m || O.startTime === O.endTime && O.startTime <= m && O.startTime + 0.5 >= m) && _.push(O);
          }
          if (d = !1, _.length !== this.activeCues_.length)
            d = !0;
          else
            for (var k = 0; k < _.length; k++)
              this.activeCues_.indexOf(_[k]) === -1 && (d = !0);
          return this.activeCues_ = _, f.setCues_(this.activeCues_), f;
        },
        set: function() {
        }
      }
    }), s.src ? (n.src = s.src, n.preload_ || (n.loaded_ = !0), (n.preload_ || s.kind !== "subtitles" && s.kind !== "captions") && loadTrack(n.src, _assertThisInitialized$1(n))) : n.loaded_ = !0, n;
  }
  var t = e.prototype;
  return t.startTracking = function() {
    this.rvf_ = this.tech_.requestVideoFrameCallback(this.timeupdateHandler);
  }, t.stopTracking = function() {
    this.rvf_ && (this.tech_.cancelVideoFrameCallback(this.rvf_), this.rvf_ = void 0);
  }, t.addCue = function(n) {
    var s = n;
    if (window_1.vttjs && !(n instanceof window_1.vttjs.VTTCue)) {
      s = new window_1.vttjs.VTTCue(n.startTime, n.endTime, n.text);
      for (var o in n)
        o in s || (s[o] = n[o]);
      s.id = n.id, s.originalCue_ = n;
    }
    for (var u = this.tech_.textTracks(), l = 0; l < u.length; l++)
      u[l] !== this && u[l].removeCue(s);
    this.cues_.push(s), this.cues.setCues_(this.cues_);
  }, t.removeCue = function(n) {
    for (var s = this.cues_.length; s--; ) {
      var o = this.cues_[s];
      if (o === n || o.originalCue_ && o.originalCue_ === n) {
        this.cues_.splice(s, 1), this.cues.setCues_(this.cues_);
        break;
      }
    }
  }, e;
}(Track);
TextTrack.prototype.allowedEvents_ = {
  cuechange: "cuechange"
};
var AudioTrack = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(t) {
    var a;
    t === void 0 && (t = {});
    var n = mergeOptions$3(t, {
      kind: AudioTrackKind[t.kind] || ""
    });
    a = r.call(this, n) || this;
    var s = !1;
    return Object.defineProperty(_assertThisInitialized$1(a), "enabled", {
      get: function() {
        return s;
      },
      set: function(u) {
        typeof u != "boolean" || u === s || (s = u, this.trigger("enabledchange"));
      }
    }), n.enabled && (a.enabled = n.enabled), a.loaded_ = !0, a;
  }
  return e;
}(Track), VideoTrack = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(t) {
    var a;
    t === void 0 && (t = {});
    var n = mergeOptions$3(t, {
      kind: VideoTrackKind[t.kind] || ""
    });
    a = r.call(this, n) || this;
    var s = !1;
    return Object.defineProperty(_assertThisInitialized$1(a), "selected", {
      get: function() {
        return s;
      },
      set: function(u) {
        typeof u != "boolean" || u === s || (s = u, this.trigger("selectedchange"));
      }
    }), n.selected && (a.selected = n.selected), a;
  }
  return e;
}(Track), NONE = 0, LOADING = 1, LOADED = 2, ERROR = 3, HTMLTrackElement = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(t) {
    var a;
    t === void 0 && (t = {}), a = r.call(this) || this;
    var n, s = new TextTrack(t);
    return a.kind = s.kind, a.src = s.src, a.srclang = s.language, a.label = s.label, a.default = s.default, Object.defineProperties(_assertThisInitialized$1(a), {
      readyState: {
        get: function() {
          return n;
        }
      },
      track: {
        get: function() {
          return s;
        }
      }
    }), n = NONE, s.addEventListener("loadeddata", function() {
      n = LOADED, a.trigger({
        type: "load",
        target: _assertThisInitialized$1(a)
      });
    }), a;
  }
  return e;
}(EventTarget$2);
HTMLTrackElement.prototype.allowedEvents_ = {
  load: "load"
};
HTMLTrackElement.NONE = NONE;
HTMLTrackElement.LOADING = LOADING;
HTMLTrackElement.LOADED = LOADED;
HTMLTrackElement.ERROR = ERROR;
var NORMAL = {
  audio: {
    ListClass: AudioTrackList,
    TrackClass: AudioTrack,
    capitalName: "Audio"
  },
  video: {
    ListClass: VideoTrackList,
    TrackClass: VideoTrack,
    capitalName: "Video"
  },
  text: {
    ListClass: TextTrackList,
    TrackClass: TextTrack,
    capitalName: "Text"
  }
};
Object.keys(NORMAL).forEach(function(r) {
  NORMAL[r].getterName = r + "Tracks", NORMAL[r].privateName = r + "Tracks_";
});
var REMOTE = {
  remoteText: {
    ListClass: TextTrackList,
    TrackClass: TextTrack,
    capitalName: "RemoteText",
    getterName: "remoteTextTracks",
    privateName: "remoteTextTracks_"
  },
  remoteTextEl: {
    ListClass: HtmlTrackElementList,
    TrackClass: HTMLTrackElement,
    capitalName: "RemoteTextTrackEls",
    getterName: "remoteTextTrackEls",
    privateName: "remoteTextTrackEls_"
  }
}, ALL = _extends$2({}, NORMAL, REMOTE);
REMOTE.names = Object.keys(REMOTE);
NORMAL.names = Object.keys(NORMAL);
ALL.names = [].concat(REMOTE.names).concat(NORMAL.names);
function createTrackHelper(r, e, t, a, n) {
  n === void 0 && (n = {});
  var s = r.textTracks();
  n.kind = e, t && (n.label = t), a && (n.language = a), n.tech = r;
  var o = new ALL.text.TrackClass(n);
  return s.addTrack(o), o;
}
var Tech = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return a === void 0 && (a = {}), n === void 0 && (n = function() {
    }), a.reportTouchActivity = !1, s = r.call(this, null, a, n) || this, s.onDurationChange_ = function(o) {
      return s.onDurationChange(o);
    }, s.trackProgress_ = function(o) {
      return s.trackProgress(o);
    }, s.trackCurrentTime_ = function(o) {
      return s.trackCurrentTime(o);
    }, s.stopTrackingCurrentTime_ = function(o) {
      return s.stopTrackingCurrentTime(o);
    }, s.disposeSourceHandler_ = function(o) {
      return s.disposeSourceHandler(o);
    }, s.queuedHanders_ = /* @__PURE__ */ new Set(), s.hasStarted_ = !1, s.on("playing", function() {
      this.hasStarted_ = !0;
    }), s.on("loadstart", function() {
      this.hasStarted_ = !1;
    }), ALL.names.forEach(function(o) {
      var u = ALL[o];
      a && a[u.getterName] && (s[u.privateName] = a[u.getterName]);
    }), s.featuresProgressEvents || s.manualProgressOn(), s.featuresTimeupdateEvents || s.manualTimeUpdatesOn(), ["Text", "Audio", "Video"].forEach(function(o) {
      a["native" + o + "Tracks"] === !1 && (s["featuresNative" + o + "Tracks"] = !1);
    }), a.nativeCaptions === !1 || a.nativeTextTracks === !1 ? s.featuresNativeTextTracks = !1 : (a.nativeCaptions === !0 || a.nativeTextTracks === !0) && (s.featuresNativeTextTracks = !0), s.featuresNativeTextTracks || s.emulateTextTracks(), s.preloadTextTracks = a.preloadTextTracks !== !1, s.autoRemoteTextTracks_ = new ALL.text.ListClass(), s.initTrackListeners(), a.nativeControlsForTouch || s.emitTapEvents(), s.constructor && (s.name_ = s.constructor.name || "Unknown Tech"), s;
  }
  var t = e.prototype;
  return t.triggerSourceset = function(n) {
    var s = this;
    this.isReady_ || this.one("ready", function() {
      return s.setTimeout(function() {
        return s.triggerSourceset(n);
      }, 1);
    }), this.trigger({
      src: n,
      type: "sourceset"
    });
  }, t.manualProgressOn = function() {
    this.on("durationchange", this.onDurationChange_), this.manualProgress = !0, this.one("ready", this.trackProgress_);
  }, t.manualProgressOff = function() {
    this.manualProgress = !1, this.stopTrackingProgress(), this.off("durationchange", this.onDurationChange_);
  }, t.trackProgress = function(n) {
    this.stopTrackingProgress(), this.progressInterval = this.setInterval(bind(this, function() {
      var s = this.bufferedPercent();
      this.bufferedPercent_ !== s && this.trigger("progress"), this.bufferedPercent_ = s, s === 1 && this.stopTrackingProgress();
    }), 500);
  }, t.onDurationChange = function(n) {
    this.duration_ = this.duration();
  }, t.buffered = function() {
    return createTimeRanges(0, 0);
  }, t.bufferedPercent = function() {
    return bufferedPercent(this.buffered(), this.duration_);
  }, t.stopTrackingProgress = function() {
    this.clearInterval(this.progressInterval);
  }, t.manualTimeUpdatesOn = function() {
    this.manualTimeUpdates = !0, this.on("play", this.trackCurrentTime_), this.on("pause", this.stopTrackingCurrentTime_);
  }, t.manualTimeUpdatesOff = function() {
    this.manualTimeUpdates = !1, this.stopTrackingCurrentTime(), this.off("play", this.trackCurrentTime_), this.off("pause", this.stopTrackingCurrentTime_);
  }, t.trackCurrentTime = function() {
    this.currentTimeInterval && this.stopTrackingCurrentTime(), this.currentTimeInterval = this.setInterval(function() {
      this.trigger({
        type: "timeupdate",
        target: this,
        manuallyTriggered: !0
      });
    }, 250);
  }, t.stopTrackingCurrentTime = function() {
    this.clearInterval(this.currentTimeInterval), this.trigger({
      type: "timeupdate",
      target: this,
      manuallyTriggered: !0
    });
  }, t.dispose = function() {
    this.clearTracks(NORMAL.names), this.manualProgress && this.manualProgressOff(), this.manualTimeUpdates && this.manualTimeUpdatesOff(), r.prototype.dispose.call(this);
  }, t.clearTracks = function(n) {
    var s = this;
    n = [].concat(n), n.forEach(function(o) {
      for (var u = s[o + "Tracks"]() || [], l = u.length; l--; ) {
        var f = u[l];
        o === "text" && s.removeRemoteTextTrack(f), u.removeTrack(f);
      }
    });
  }, t.cleanupAutoTextTracks = function() {
    for (var n = this.autoRemoteTextTracks_ || [], s = n.length; s--; ) {
      var o = n[s];
      this.removeRemoteTextTrack(o);
    }
  }, t.reset = function() {
  }, t.crossOrigin = function() {
  }, t.setCrossOrigin = function() {
  }, t.error = function(n) {
    return n !== void 0 && (this.error_ = new MediaError(n), this.trigger("error")), this.error_;
  }, t.played = function() {
    return this.hasStarted_ ? createTimeRanges(0, 0) : createTimeRanges();
  }, t.play = function() {
  }, t.setScrubbing = function() {
  }, t.scrubbing = function() {
  }, t.setCurrentTime = function() {
    this.manualTimeUpdates && this.trigger({
      type: "timeupdate",
      target: this,
      manuallyTriggered: !0
    });
  }, t.initTrackListeners = function() {
    var n = this;
    NORMAL.names.forEach(function(s) {
      var o = NORMAL[s], u = function() {
        n.trigger(s + "trackchange");
      }, l = n[o.getterName]();
      l.addEventListener("removetrack", u), l.addEventListener("addtrack", u), n.on("dispose", function() {
        l.removeEventListener("removetrack", u), l.removeEventListener("addtrack", u);
      });
    });
  }, t.addWebVttScript_ = function() {
    var n = this;
    if (!window_1.WebVTT)
      if (document_1.body.contains(this.el())) {
        if (!this.options_["vtt.js"] && isPlain(browserIndex.exports) && Object.keys(browserIndex.exports).length > 0) {
          this.trigger("vttjsloaded");
          return;
        }
        var s = document_1.createElement("script");
        s.src = this.options_["vtt.js"] || "https://vjs.zencdn.net/vttjs/0.14.1/vtt.min.js", s.onload = function() {
          n.trigger("vttjsloaded");
        }, s.onerror = function() {
          n.trigger("vttjserror");
        }, this.on("dispose", function() {
          s.onload = null, s.onerror = null;
        }), window_1.WebVTT = !0, this.el().parentNode.appendChild(s);
      } else
        this.ready(this.addWebVttScript_);
  }, t.emulateTextTracks = function() {
    var n = this, s = this.textTracks(), o = this.remoteTextTracks(), u = function(p) {
      return s.addTrack(p.track);
    }, l = function(p) {
      return s.removeTrack(p.track);
    };
    o.on("addtrack", u), o.on("removetrack", l), this.addWebVttScript_();
    var f = function() {
      return n.trigger("texttrackchange");
    }, d = function() {
      f();
      for (var p = 0; p < s.length; p++) {
        var m = s[p];
        m.removeEventListener("cuechange", f), m.mode === "showing" && m.addEventListener("cuechange", f);
      }
    };
    d(), s.addEventListener("change", d), s.addEventListener("addtrack", d), s.addEventListener("removetrack", d), this.on("dispose", function() {
      o.off("addtrack", u), o.off("removetrack", l), s.removeEventListener("change", d), s.removeEventListener("addtrack", d), s.removeEventListener("removetrack", d);
      for (var h = 0; h < s.length; h++) {
        var p = s[h];
        p.removeEventListener("cuechange", f);
      }
    });
  }, t.addTextTrack = function(n, s, o) {
    if (!n)
      throw new Error("TextTrack kind is required but was not provided");
    return createTrackHelper(this, n, s, o);
  }, t.createRemoteTextTrack = function(n) {
    var s = mergeOptions$3(n, {
      tech: this
    });
    return new REMOTE.remoteTextEl.TrackClass(s);
  }, t.addRemoteTextTrack = function(n, s) {
    var o = this;
    n === void 0 && (n = {});
    var u = this.createRemoteTextTrack(n);
    return s !== !0 && s !== !1 && (log$1.warn('Calling addRemoteTextTrack without explicitly setting the "manualCleanup" parameter to `true` is deprecated and default to `false` in future version of video.js'), s = !0), this.remoteTextTrackEls().addTrackElement_(u), this.remoteTextTracks().addTrack(u.track), s !== !0 && this.ready(function() {
      return o.autoRemoteTextTracks_.addTrack(u.track);
    }), u;
  }, t.removeRemoteTextTrack = function(n) {
    var s = this.remoteTextTrackEls().getTrackElementByTrack_(n);
    this.remoteTextTrackEls().removeTrackElement_(s), this.remoteTextTracks().removeTrack(n), this.autoRemoteTextTracks_.removeTrack(n);
  }, t.getVideoPlaybackQuality = function() {
    return {};
  }, t.requestPictureInPicture = function() {
    var n = this.options_.Promise || window_1.Promise;
    if (n)
      return n.reject();
  }, t.disablePictureInPicture = function() {
    return !0;
  }, t.setDisablePictureInPicture = function() {
  }, t.requestVideoFrameCallback = function(n) {
    var s = this, o = newGUID();
    return this.paused() ? (this.queuedHanders_.add(o), this.one("playing", function() {
      s.queuedHanders_.has(o) && (s.queuedHanders_.delete(o), n());
    })) : this.requestNamedAnimationFrame(o, n), o;
  }, t.cancelVideoFrameCallback = function(n) {
    this.queuedHanders_.has(n) ? this.queuedHanders_.delete(n) : this.cancelNamedAnimationFrame(n);
  }, t.setPoster = function() {
  }, t.playsinline = function() {
  }, t.setPlaysinline = function() {
  }, t.overrideNativeAudioTracks = function() {
  }, t.overrideNativeVideoTracks = function() {
  }, t.canPlayType = function() {
    return "";
  }, e.canPlayType = function() {
    return "";
  }, e.canPlaySource = function(n, s) {
    return e.canPlayType(n.type);
  }, e.isTech = function(n) {
    return n.prototype instanceof e || n instanceof e || n === e;
  }, e.registerTech = function(n, s) {
    if (e.techs_ || (e.techs_ = {}), !e.isTech(s))
      throw new Error("Tech " + n + " must be a Tech");
    if (!e.canPlayType)
      throw new Error("Techs must have a static canPlayType method on them");
    if (!e.canPlaySource)
      throw new Error("Techs must have a static canPlaySource method on them");
    return n = toTitleCase$1(n), e.techs_[n] = s, e.techs_[toLowerCase(n)] = s, n !== "Tech" && e.defaultTechOrder_.push(n), s;
  }, e.getTech = function(n) {
    if (!!n) {
      if (e.techs_ && e.techs_[n])
        return e.techs_[n];
      if (n = toTitleCase$1(n), window_1 && window_1.videojs && window_1.videojs[n])
        return log$1.warn("The " + n + " tech was added to the videojs object when it should be registered using videojs.registerTech(name, tech)"), window_1.videojs[n];
    }
  }, e;
}(Component$1);
ALL.names.forEach(function(r) {
  var e = ALL[r];
  Tech.prototype[e.getterName] = function() {
    return this[e.privateName] = this[e.privateName] || new e.ListClass(), this[e.privateName];
  };
});
Tech.prototype.featuresVolumeControl = !0;
Tech.prototype.featuresMuteControl = !0;
Tech.prototype.featuresFullscreenResize = !1;
Tech.prototype.featuresPlaybackRate = !1;
Tech.prototype.featuresProgressEvents = !1;
Tech.prototype.featuresSourceset = !1;
Tech.prototype.featuresTimeupdateEvents = !1;
Tech.prototype.featuresNativeTextTracks = !1;
Tech.prototype.featuresVideoFrameCallback = !1;
Tech.withSourceHandlers = function(r) {
  r.registerSourceHandler = function(t, a) {
    var n = r.sourceHandlers;
    n || (n = r.sourceHandlers = []), a === void 0 && (a = n.length), n.splice(a, 0, t);
  }, r.canPlayType = function(t) {
    for (var a = r.sourceHandlers || [], n, s = 0; s < a.length; s++)
      if (n = a[s].canPlayType(t), n)
        return n;
    return "";
  }, r.selectSourceHandler = function(t, a) {
    for (var n = r.sourceHandlers || [], s, o = 0; o < n.length; o++)
      if (s = n[o].canHandleSource(t, a), s)
        return n[o];
    return null;
  }, r.canPlaySource = function(t, a) {
    var n = r.selectSourceHandler(t, a);
    return n ? n.canHandleSource(t, a) : "";
  };
  var e = ["seekable", "seeking", "duration"];
  e.forEach(function(t) {
    var a = this[t];
    typeof a == "function" && (this[t] = function() {
      return this.sourceHandler_ && this.sourceHandler_[t] ? this.sourceHandler_[t].apply(this.sourceHandler_, arguments) : a.apply(this, arguments);
    });
  }, r.prototype), r.prototype.setSource = function(t) {
    var a = r.selectSourceHandler(t, this.options_);
    a || (r.nativeSourceHandler ? a = r.nativeSourceHandler : log$1.error("No source handler found for the current source.")), this.disposeSourceHandler(), this.off("dispose", this.disposeSourceHandler_), a !== r.nativeSourceHandler && (this.currentSource_ = t), this.sourceHandler_ = a.handleSource(t, this, this.options_), this.one("dispose", this.disposeSourceHandler_);
  }, r.prototype.disposeSourceHandler = function() {
    this.currentSource_ && (this.clearTracks(["audio", "video"]), this.currentSource_ = null), this.cleanupAutoTextTracks(), this.sourceHandler_ && (this.sourceHandler_.dispose && this.sourceHandler_.dispose(), this.sourceHandler_ = null);
  };
};
Component$1.registerComponent("Tech", Tech);
Tech.registerTech("Tech", Tech);
Tech.defaultTechOrder_ = [];
var middlewares = {}, middlewareInstances = {}, TERMINATOR = {};
function use(r, e) {
  middlewares[r] = middlewares[r] || [], middlewares[r].push(e);
}
function setSource(r, e, t) {
  r.setTimeout(function() {
    return setSourceHelper(e, middlewares[e.type], t, r);
  }, 1);
}
function setTech(r, e) {
  r.forEach(function(t) {
    return t.setTech && t.setTech(e);
  });
}
function get(r, e, t) {
  return r.reduceRight(middlewareIterator(t), e[t]());
}
function set(r, e, t, a) {
  return e[t](r.reduce(middlewareIterator(t), a));
}
function mediate(r, e, t, a) {
  a === void 0 && (a = null);
  var n = "call" + toTitleCase$1(t), s = r.reduce(middlewareIterator(n), a), o = s === TERMINATOR, u = o ? null : e[t](s);
  return executeRight(r, t, u, o), u;
}
var allowedGetters = {
  buffered: 1,
  currentTime: 1,
  duration: 1,
  muted: 1,
  played: 1,
  paused: 1,
  seekable: 1,
  volume: 1,
  ended: 1
}, allowedSetters = {
  setCurrentTime: 1,
  setMuted: 1,
  setVolume: 1
}, allowedMediators = {
  play: 1,
  pause: 1
};
function middlewareIterator(r) {
  return function(e, t) {
    return e === TERMINATOR ? TERMINATOR : t[r] ? t[r](e) : e;
  };
}
function executeRight(r, e, t, a) {
  for (var n = r.length - 1; n >= 0; n--) {
    var s = r[n];
    s[e] && s[e](a, t);
  }
}
function clearCacheForPlayer(r) {
  middlewareInstances[r.id()] = null;
}
function getOrCreateFactory(r, e) {
  var t = middlewareInstances[r.id()], a = null;
  if (t == null)
    return a = e(r), middlewareInstances[r.id()] = [[e, a]], a;
  for (var n = 0; n < t.length; n++) {
    var s = t[n], o = s[0], u = s[1];
    o === e && (a = u);
  }
  return a === null && (a = e(r), t.push([e, a])), a;
}
function setSourceHelper(r, e, t, a, n, s) {
  r === void 0 && (r = {}), e === void 0 && (e = []), n === void 0 && (n = []), s === void 0 && (s = !1);
  var o = e, u = o[0], l = o.slice(1);
  if (typeof u == "string")
    setSourceHelper(r, middlewares[u], t, a, n, s);
  else if (u) {
    var f = getOrCreateFactory(a, u);
    if (!f.setSource)
      return n.push(f), setSourceHelper(r, l, t, a, n, s);
    f.setSource(assign({}, r), function(d, h) {
      if (d)
        return setSourceHelper(r, l, t, a, n, s);
      n.push(f), setSourceHelper(h, r.type === h.type ? l : middlewares[h.type], t, a, n, s);
    });
  } else
    l.length ? setSourceHelper(r, l, t, a, n, s) : s ? t(r, n) : setSourceHelper(r, middlewares["*"], t, a, n, !0);
}
var MimetypesKind = {
  opus: "video/ogg",
  ogv: "video/ogg",
  mp4: "video/mp4",
  mov: "video/mp4",
  m4v: "video/mp4",
  mkv: "video/x-matroska",
  m4a: "audio/mp4",
  mp3: "audio/mpeg",
  aac: "audio/aac",
  caf: "audio/x-caf",
  flac: "audio/flac",
  oga: "audio/ogg",
  wav: "audio/wav",
  m3u8: "application/x-mpegURL",
  mpd: "application/dash+xml",
  jpg: "image/jpeg",
  jpeg: "image/jpeg",
  gif: "image/gif",
  png: "image/png",
  svg: "image/svg+xml",
  webp: "image/webp"
}, getMimetype = function r(e) {
  e === void 0 && (e = "");
  var t = getFileExtension(e), a = MimetypesKind[t.toLowerCase()];
  return a || "";
}, findMimetype = function r(e, t) {
  if (!t)
    return "";
  if (e.cache_.source.src === t && e.cache_.source.type)
    return e.cache_.source.type;
  var a = e.cache_.sources.filter(function(u) {
    return u.src === t;
  });
  if (a.length)
    return a[0].type;
  for (var n = e.$$("source"), s = 0; s < n.length; s++) {
    var o = n[s];
    if (o.type && o.src && o.src === t)
      return o.type;
  }
  return getMimetype(t);
}, filterSource = function r(e) {
  if (Array.isArray(e)) {
    var t = [];
    e.forEach(function(a) {
      a = r(a), Array.isArray(a) ? t = t.concat(a) : isObject(a) && t.push(a);
    }), e = t;
  } else
    typeof e == "string" && e.trim() ? e = [fixSource({
      src: e
    })] : isObject(e) && typeof e.src == "string" && e.src && e.src.trim() ? e = [fixSource(e)] : e = [];
  return e;
};
function fixSource(r) {
  if (!r.type) {
    var e = getMimetype(r.src);
    e && (r.type = e);
  }
  return r;
}
var MediaLoader = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(t, a, n) {
    var s, o = mergeOptions$3({
      createEl: !1
    }, a);
    if (s = r.call(this, t, o, n) || this, !a.playerOptions.sources || a.playerOptions.sources.length === 0)
      for (var u = 0, l = a.playerOptions.techOrder; u < l.length; u++) {
        var f = toTitleCase$1(l[u]), d = Tech.getTech(f);
        if (f || (d = Component$1.getComponent(f)), d && d.isSupported()) {
          t.loadTech_(f);
          break;
        }
      }
    else
      t.src(a.playerOptions.sources);
    return s;
  }
  return e;
}(Component$1);
Component$1.registerComponent("MediaLoader", MediaLoader);
var ClickableComponent = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.options_.controlText && s.controlText(s.options_.controlText), s.handleMouseOver_ = function(o) {
      return s.handleMouseOver(o);
    }, s.handleMouseOut_ = function(o) {
      return s.handleMouseOut(o);
    }, s.handleClick_ = function(o) {
      return s.handleClick(o);
    }, s.handleKeyDown_ = function(o) {
      return s.handleKeyDown(o);
    }, s.emitTapEvents(), s.enable(), s;
  }
  var t = e.prototype;
  return t.createEl = function(n, s, o) {
    n === void 0 && (n = "div"), s === void 0 && (s = {}), o === void 0 && (o = {}), s = assign({
      className: this.buildCSSClass(),
      tabIndex: 0
    }, s), n === "button" && log$1.error("Creating a ClickableComponent with an HTML element of " + n + " is not supported; use a Button instead."), o = assign({
      role: "button"
    }, o), this.tabIndex_ = s.tabIndex;
    var u = createEl(n, s, o);
    return u.appendChild(createEl("span", {
      className: "vjs-icon-placeholder"
    }, {
      "aria-hidden": !0
    })), this.createControlTextEl(u), u;
  }, t.dispose = function() {
    this.controlTextEl_ = null, r.prototype.dispose.call(this);
  }, t.createControlTextEl = function(n) {
    return this.controlTextEl_ = createEl("span", {
      className: "vjs-control-text"
    }, {
      "aria-live": "polite"
    }), n && n.appendChild(this.controlTextEl_), this.controlText(this.controlText_, n), this.controlTextEl_;
  }, t.controlText = function(n, s) {
    if (s === void 0 && (s = this.el()), n === void 0)
      return this.controlText_ || "Need Text";
    var o = this.localize(n);
    this.controlText_ = n, textContent(this.controlTextEl_, o), !this.nonIconControl && !this.player_.options_.noUITitleAttributes && s.setAttribute("title", o);
  }, t.buildCSSClass = function() {
    return "vjs-control vjs-button " + r.prototype.buildCSSClass.call(this);
  }, t.enable = function() {
    this.enabled_ || (this.enabled_ = !0, this.removeClass("vjs-disabled"), this.el_.setAttribute("aria-disabled", "false"), typeof this.tabIndex_ < "u" && this.el_.setAttribute("tabIndex", this.tabIndex_), this.on(["tap", "click"], this.handleClick_), this.on("keydown", this.handleKeyDown_));
  }, t.disable = function() {
    this.enabled_ = !1, this.addClass("vjs-disabled"), this.el_.setAttribute("aria-disabled", "true"), typeof this.tabIndex_ < "u" && this.el_.removeAttribute("tabIndex"), this.off("mouseover", this.handleMouseOver_), this.off("mouseout", this.handleMouseOut_), this.off(["tap", "click"], this.handleClick_), this.off("keydown", this.handleKeyDown_);
  }, t.handleLanguagechange = function() {
    this.controlText(this.controlText_);
  }, t.handleClick = function(n) {
    this.options_.clickHandler && this.options_.clickHandler.call(this, arguments);
  }, t.handleKeyDown = function(n) {
    keycode.isEventKey(n, "Space") || keycode.isEventKey(n, "Enter") ? (n.preventDefault(), n.stopPropagation(), this.trigger("click")) : r.prototype.handleKeyDown.call(this, n);
  }, e;
}(Component$1);
Component$1.registerComponent("ClickableComponent", ClickableComponent);
var PosterImage = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.update(), s.update_ = function(o) {
      return s.update(o);
    }, a.on("posterchange", s.update_), s;
  }
  var t = e.prototype;
  return t.dispose = function() {
    this.player().off("posterchange", this.update_), r.prototype.dispose.call(this);
  }, t.createEl = function() {
    var n = createEl("div", {
      className: "vjs-poster",
      tabIndex: -1
    });
    return n;
  }, t.update = function(n) {
    var s = this.player().poster();
    this.setSrc(s), s ? this.show() : this.hide();
  }, t.setSrc = function(n) {
    var s = "";
    n && (s = 'url("' + n + '")'), this.el_.style.backgroundImage = s;
  }, t.handleClick = function(n) {
    if (!!this.player_.controls()) {
      var s = this.player_.usingPlugin("eme") && this.player_.eme.sessions && this.player_.eme.sessions.length > 0;
      this.player_.tech(!0) && !((IE_VERSION || IS_EDGE) && s) && this.player_.tech(!0).focus(), this.player_.paused() ? silencePromise(this.player_.play()) : this.player_.pause();
    }
  }, e;
}(ClickableComponent);
Component$1.registerComponent("PosterImage", PosterImage);
var darkGray = "#222", lightGray = "#ccc", fontMap = {
  monospace: "monospace",
  sansSerif: "sans-serif",
  serif: "serif",
  monospaceSansSerif: '"Andale Mono", "Lucida Console", monospace',
  monospaceSerif: '"Courier New", monospace',
  proportionalSansSerif: "sans-serif",
  proportionalSerif: "serif",
  casual: '"Comic Sans MS", Impact, fantasy',
  script: '"Monotype Corsiva", cursive',
  smallcaps: '"Andale Mono", "Lucida Console", monospace, sans-serif'
};
function constructColor(r, e) {
  var t;
  if (r.length === 4)
    t = r[1] + r[1] + r[2] + r[2] + r[3] + r[3];
  else if (r.length === 7)
    t = r.slice(1);
  else
    throw new Error("Invalid color code provided, " + r + "; must be formatted as e.g. #f0e or #f604e2.");
  return "rgba(" + parseInt(t.slice(0, 2), 16) + "," + parseInt(t.slice(2, 4), 16) + "," + parseInt(t.slice(4, 6), 16) + "," + e + ")";
}
function tryUpdateStyle(r, e, t) {
  try {
    r.style[e] = t;
  } catch {
    return;
  }
}
var TextTrackDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    var o;
    o = r.call(this, a, n, s) || this;
    var u = function(f) {
      return o.updateDisplay(f);
    };
    return a.on("loadstart", function(l) {
      return o.toggleDisplay(l);
    }), a.on("texttrackchange", u), a.on("loadedmetadata", function(l) {
      return o.preselectTrack(l);
    }), a.ready(bind(_assertThisInitialized$1(o), function() {
      if (a.tech_ && a.tech_.featuresNativeTextTracks) {
        this.hide();
        return;
      }
      a.on("fullscreenchange", u), a.on("playerresize", u), window_1.addEventListener("orientationchange", u), a.on("dispose", function() {
        return window_1.removeEventListener("orientationchange", u);
      });
      for (var l = this.options_.playerOptions.tracks || [], f = 0; f < l.length; f++)
        this.player_.addRemoteTextTrack(l[f], !0);
      this.preselectTrack();
    })), o;
  }
  var t = e.prototype;
  return t.preselectTrack = function() {
    for (var n = {
      captions: 1,
      subtitles: 1
    }, s = this.player_.textTracks(), o = this.player_.cache_.selectedLanguage, u, l, f, d = 0; d < s.length; d++) {
      var h = s[d];
      o && o.enabled && o.language && o.language === h.language && h.kind in n ? h.kind === o.kind ? f = h : f || (f = h) : o && !o.enabled ? (f = null, u = null, l = null) : h.default && (h.kind === "descriptions" && !u ? u = h : h.kind in n && !l && (l = h));
    }
    f ? f.mode = "showing" : l ? l.mode = "showing" : u && (u.mode = "showing");
  }, t.toggleDisplay = function() {
    this.player_.tech_ && this.player_.tech_.featuresNativeTextTracks ? this.hide() : this.show();
  }, t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-text-track-display"
    }, {
      translate: "yes",
      "aria-live": "off",
      "aria-atomic": "true"
    });
  }, t.clearDisplay = function() {
    typeof window_1.WebVTT == "function" && window_1.WebVTT.processCues(window_1, [], this.el_);
  }, t.updateDisplay = function() {
    var n = this.player_.textTracks(), s = this.options_.allowMultipleShowingTracks;
    if (this.clearDisplay(), s) {
      for (var o = [], u = 0; u < n.length; ++u) {
        var l = n[u];
        l.mode === "showing" && o.push(l);
      }
      this.updateForTrack(o);
      return;
    }
    for (var f = null, d = null, h = n.length; h--; ) {
      var p = n[h];
      p.mode === "showing" && (p.kind === "descriptions" ? f = p : d = p);
    }
    d ? (this.getAttribute("aria-live") !== "off" && this.setAttribute("aria-live", "off"), this.updateForTrack(d)) : f && (this.getAttribute("aria-live") !== "assertive" && this.setAttribute("aria-live", "assertive"), this.updateForTrack(f));
  }, t.updateDisplayState = function(n) {
    for (var s = this.player_.textTrackSettings.getValues(), o = n.activeCues, u = o.length; u--; ) {
      var l = o[u];
      if (!!l) {
        var f = l.displayState;
        if (s.color && (f.firstChild.style.color = s.color), s.textOpacity && tryUpdateStyle(f.firstChild, "color", constructColor(s.color || "#fff", s.textOpacity)), s.backgroundColor && (f.firstChild.style.backgroundColor = s.backgroundColor), s.backgroundOpacity && tryUpdateStyle(f.firstChild, "backgroundColor", constructColor(s.backgroundColor || "#000", s.backgroundOpacity)), s.windowColor && (s.windowOpacity ? tryUpdateStyle(f, "backgroundColor", constructColor(s.windowColor, s.windowOpacity)) : f.style.backgroundColor = s.windowColor), s.edgeStyle && (s.edgeStyle === "dropshadow" ? f.firstChild.style.textShadow = "2px 2px 3px " + darkGray + ", 2px 2px 4px " + darkGray + ", 2px 2px 5px " + darkGray : s.edgeStyle === "raised" ? f.firstChild.style.textShadow = "1px 1px " + darkGray + ", 2px 2px " + darkGray + ", 3px 3px " + darkGray : s.edgeStyle === "depressed" ? f.firstChild.style.textShadow = "1px 1px " + lightGray + ", 0 1px " + lightGray + ", -1px -1px " + darkGray + ", 0 -1px " + darkGray : s.edgeStyle === "uniform" && (f.firstChild.style.textShadow = "0 0 4px " + darkGray + ", 0 0 4px " + darkGray + ", 0 0 4px " + darkGray + ", 0 0 4px " + darkGray)), s.fontPercent && s.fontPercent !== 1) {
          var d = window_1.parseFloat(f.style.fontSize);
          f.style.fontSize = d * s.fontPercent + "px", f.style.height = "auto", f.style.top = "auto";
        }
        s.fontFamily && s.fontFamily !== "default" && (s.fontFamily === "small-caps" ? f.firstChild.style.fontVariant = "small-caps" : f.firstChild.style.fontFamily = fontMap[s.fontFamily]);
      }
    }
  }, t.updateForTrack = function(n) {
    if (Array.isArray(n) || (n = [n]), !(typeof window_1.WebVTT != "function" || n.every(function(m) {
      return !m.activeCues;
    }))) {
      for (var s = [], o = 0; o < n.length; ++o)
        for (var u = n[o], l = 0; l < u.activeCues.length; ++l)
          s.push(u.activeCues[l]);
      window_1.WebVTT.processCues(window_1, s, this.el_);
      for (var f = 0; f < n.length; ++f) {
        for (var d = n[f], h = 0; h < d.activeCues.length; ++h) {
          var p = d.activeCues[h].displayState;
          addClass(p, "vjs-text-track-cue"), addClass(p, "vjs-text-track-cue-" + (d.language ? d.language : f)), d.language && setAttribute(p, "lang", d.language);
        }
        this.player_.textTrackSettings && this.updateDisplayState(d);
      }
    }
  }, e;
}(Component$1);
Component$1.registerComponent("TextTrackDisplay", TextTrackDisplay);
var LoadingSpinner = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = this.player_.isAudio(), s = this.localize(n ? "Audio Player" : "Video Player"), o = createEl("span", {
      className: "vjs-control-text",
      textContent: this.localize("{1} is loading.", [s])
    }), u = r.prototype.createEl.call(this, "div", {
      className: "vjs-loading-spinner",
      dir: "ltr"
    });
    return u.appendChild(o), u;
  }, e;
}(Component$1);
Component$1.registerComponent("LoadingSpinner", LoadingSpinner);
var Button = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.createEl = function(n, s, o) {
    s === void 0 && (s = {}), o === void 0 && (o = {}), n = "button", s = assign({
      className: this.buildCSSClass()
    }, s), o = assign({
      type: "button"
    }, o);
    var u = createEl(n, s, o);
    return u.appendChild(createEl("span", {
      className: "vjs-icon-placeholder"
    }, {
      "aria-hidden": !0
    })), this.createControlTextEl(u), u;
  }, t.addChild = function(n, s) {
    s === void 0 && (s = {});
    var o = this.constructor.name;
    return log$1.warn("Adding an actionable (user controllable) child to a Button (" + o + ") is not supported; use a ClickableComponent instead."), Component$1.prototype.addChild.call(this, n, s);
  }, t.enable = function() {
    r.prototype.enable.call(this), this.el_.removeAttribute("disabled");
  }, t.disable = function() {
    r.prototype.disable.call(this), this.el_.setAttribute("disabled", "disabled");
  }, t.handleKeyDown = function(n) {
    if (keycode.isEventKey(n, "Space") || keycode.isEventKey(n, "Enter")) {
      n.stopPropagation();
      return;
    }
    r.prototype.handleKeyDown.call(this, n);
  }, e;
}(ClickableComponent);
Component$1.registerComponent("Button", Button);
var BigPlayButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.mouseused_ = !1, s.on("mousedown", function(o) {
      return s.handleMouseDown(o);
    }), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-big-play-button";
  }, t.handleClick = function(n) {
    var s = this.player_.play();
    if (this.mouseused_ && n.clientX && n.clientY) {
      var o = this.player_.usingPlugin("eme") && this.player_.eme.sessions && this.player_.eme.sessions.length > 0;
      silencePromise(s), this.player_.tech(!0) && !((IE_VERSION || IS_EDGE) && o) && this.player_.tech(!0).focus();
      return;
    }
    var u = this.player_.getChild("controlBar"), l = u && u.getChild("playToggle");
    if (!l) {
      this.player_.tech(!0).focus();
      return;
    }
    var f = function() {
      return l.focus();
    };
    isPromise(s) ? s.then(f, function() {
    }) : this.setTimeout(f, 1);
  }, t.handleKeyDown = function(n) {
    this.mouseused_ = !1, r.prototype.handleKeyDown.call(this, n);
  }, t.handleMouseDown = function(n) {
    this.mouseused_ = !0;
  }, e;
}(Button);
BigPlayButton.prototype.controlText_ = "Play Video";
Component$1.registerComponent("BigPlayButton", BigPlayButton);
var CloseButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.controlText(n && n.controlText || s.localize("Close")), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-close-button " + r.prototype.buildCSSClass.call(this);
  }, t.handleClick = function(n) {
    this.trigger({
      type: "close",
      bubbles: !1
    });
  }, t.handleKeyDown = function(n) {
    keycode.isEventKey(n, "Esc") ? (n.preventDefault(), n.stopPropagation(), this.trigger("click")) : r.prototype.handleKeyDown.call(this, n);
  }, e;
}(Button);
Component$1.registerComponent("CloseButton", CloseButton);
var PlayToggle = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n === void 0 && (n = {}), s = r.call(this, a, n) || this, n.replay = n.replay === void 0 || n.replay, s.on(a, "play", function(o) {
      return s.handlePlay(o);
    }), s.on(a, "pause", function(o) {
      return s.handlePause(o);
    }), n.replay && s.on(a, "ended", function(o) {
      return s.handleEnded(o);
    }), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-play-control " + r.prototype.buildCSSClass.call(this);
  }, t.handleClick = function(n) {
    this.player_.paused() ? silencePromise(this.player_.play()) : this.player_.pause();
  }, t.handleSeeked = function(n) {
    this.removeClass("vjs-ended"), this.player_.paused() ? this.handlePause(n) : this.handlePlay(n);
  }, t.handlePlay = function(n) {
    this.removeClass("vjs-ended"), this.removeClass("vjs-paused"), this.addClass("vjs-playing"), this.controlText("Pause");
  }, t.handlePause = function(n) {
    this.removeClass("vjs-playing"), this.addClass("vjs-paused"), this.controlText("Play");
  }, t.handleEnded = function(n) {
    var s = this;
    this.removeClass("vjs-playing"), this.addClass("vjs-ended"), this.controlText("Replay"), this.one(this.player_, "seeked", function(o) {
      return s.handleSeeked(o);
    });
  }, e;
}(Button);
PlayToggle.prototype.controlText_ = "Play";
Component$1.registerComponent("PlayToggle", PlayToggle);
var defaultImplementation = function r(e, t) {
  e = e < 0 ? 0 : e;
  var a = Math.floor(e % 60), n = Math.floor(e / 60 % 60), s = Math.floor(e / 3600), o = Math.floor(t / 60 % 60), u = Math.floor(t / 3600);
  return (isNaN(e) || e === 1 / 0) && (s = n = a = "-"), s = s > 0 || u > 0 ? s + ":" : "", n = ((s || o >= 10) && n < 10 ? "0" + n : n) + ":", a = a < 10 ? "0" + a : a, s + n + a;
}, implementation = defaultImplementation;
function setFormatTime(r) {
  implementation = r;
}
function resetFormatTime() {
  implementation = defaultImplementation;
}
function formatTime(r, e) {
  return e === void 0 && (e = r), implementation(r, e);
}
var TimeDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.on(a, ["timeupdate", "ended"], function(o) {
      return s.updateContent(o);
    }), s.updateTextNode_(), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = this.buildCSSClass(), s = r.prototype.createEl.call(this, "div", {
      className: n + " vjs-time-control vjs-control"
    }), o = createEl("span", {
      className: "vjs-control-text",
      textContent: this.localize(this.labelText_) + "\xA0"
    }, {
      role: "presentation"
    });
    return s.appendChild(o), this.contentEl_ = createEl("span", {
      className: n + "-display"
    }, {
      "aria-live": "off",
      role: "presentation"
    }), s.appendChild(this.contentEl_), s;
  }, t.dispose = function() {
    this.contentEl_ = null, this.textNode_ = null, r.prototype.dispose.call(this);
  }, t.updateTextNode_ = function(n) {
    var s = this;
    n === void 0 && (n = 0), n = formatTime(n), this.formattedTime_ !== n && (this.formattedTime_ = n, this.requestNamedAnimationFrame("TimeDisplay#updateTextNode_", function() {
      if (!!s.contentEl_) {
        var o = s.textNode_;
        o && s.contentEl_.firstChild !== o && (o = null, log$1.warn("TimeDisplay#updateTextnode_: Prevented replacement of text node element since it was no longer a child of this node. Appending a new node instead.")), s.textNode_ = document_1.createTextNode(s.formattedTime_), s.textNode_ && (o ? s.contentEl_.replaceChild(s.textNode_, o) : s.contentEl_.appendChild(s.textNode_));
      }
    }));
  }, t.updateContent = function(n) {
  }, e;
}(Component$1);
TimeDisplay.prototype.labelText_ = "Time";
TimeDisplay.prototype.controlText_ = "Time";
Component$1.registerComponent("TimeDisplay", TimeDisplay);
var CurrentTimeDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-current-time";
  }, t.updateContent = function(n) {
    var s;
    this.player_.ended() ? s = this.player_.duration() : s = this.player_.scrubbing() ? this.player_.getCache().currentTime : this.player_.currentTime(), this.updateTextNode_(s);
  }, e;
}(TimeDisplay);
CurrentTimeDisplay.prototype.labelText_ = "Current Time";
CurrentTimeDisplay.prototype.controlText_ = "Current Time";
Component$1.registerComponent("CurrentTimeDisplay", CurrentTimeDisplay);
var DurationDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    s = r.call(this, a, n) || this;
    var o = function(l) {
      return s.updateContent(l);
    };
    return s.on(a, "durationchange", o), s.on(a, "loadstart", o), s.on(a, "loadedmetadata", o), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-duration";
  }, t.updateContent = function(n) {
    var s = this.player_.duration();
    this.updateTextNode_(s);
  }, e;
}(TimeDisplay);
DurationDisplay.prototype.labelText_ = "Duration";
DurationDisplay.prototype.controlText_ = "Duration";
Component$1.registerComponent("DurationDisplay", DurationDisplay);
var TimeDivider = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = r.prototype.createEl.call(this, "div", {
      className: "vjs-time-control vjs-time-divider"
    }, {
      "aria-hidden": !0
    }), s = r.prototype.createEl.call(this, "div"), o = r.prototype.createEl.call(this, "span", {
      textContent: "/"
    });
    return s.appendChild(o), n.appendChild(s), n;
  }, e;
}(Component$1);
Component$1.registerComponent("TimeDivider", TimeDivider);
var RemainingTimeDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.on(a, "durationchange", function(o) {
      return s.updateContent(o);
    }), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-remaining-time";
  }, t.createEl = function() {
    var n = r.prototype.createEl.call(this);
    return this.options_.displayNegative !== !1 && n.insertBefore(createEl("span", {}, {
      "aria-hidden": !0
    }, "-"), this.contentEl_), n;
  }, t.updateContent = function(n) {
    if (typeof this.player_.duration() == "number") {
      var s;
      this.player_.ended() ? s = 0 : this.player_.remainingTimeDisplay ? s = this.player_.remainingTimeDisplay() : s = this.player_.remainingTime(), this.updateTextNode_(s);
    }
  }, e;
}(TimeDisplay);
RemainingTimeDisplay.prototype.labelText_ = "Remaining Time";
RemainingTimeDisplay.prototype.controlText_ = "Remaining Time";
Component$1.registerComponent("RemainingTimeDisplay", RemainingTimeDisplay);
var LiveDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.updateShowing(), s.on(s.player(), "durationchange", function(o) {
      return s.updateShowing(o);
    }), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = r.prototype.createEl.call(this, "div", {
      className: "vjs-live-control vjs-control"
    });
    return this.contentEl_ = createEl("div", {
      className: "vjs-live-display"
    }, {
      "aria-live": "off"
    }), this.contentEl_.appendChild(createEl("span", {
      className: "vjs-control-text",
      textContent: this.localize("Stream Type") + "\xA0"
    })), this.contentEl_.appendChild(document_1.createTextNode(this.localize("LIVE"))), n.appendChild(this.contentEl_), n;
  }, t.dispose = function() {
    this.contentEl_ = null, r.prototype.dispose.call(this);
  }, t.updateShowing = function(n) {
    this.player().duration() === 1 / 0 ? this.show() : this.hide();
  }, e;
}(Component$1);
Component$1.registerComponent("LiveDisplay", LiveDisplay);
var SeekToLive = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.updateLiveEdgeStatus(), s.player_.liveTracker && (s.updateLiveEdgeStatusHandler_ = function(o) {
      return s.updateLiveEdgeStatus(o);
    }, s.on(s.player_.liveTracker, "liveedgechange", s.updateLiveEdgeStatusHandler_)), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = r.prototype.createEl.call(this, "button", {
      className: "vjs-seek-to-live-control vjs-control"
    });
    return this.textEl_ = createEl("span", {
      className: "vjs-seek-to-live-text",
      textContent: this.localize("LIVE")
    }, {
      "aria-hidden": "true"
    }), n.appendChild(this.textEl_), n;
  }, t.updateLiveEdgeStatus = function() {
    !this.player_.liveTracker || this.player_.liveTracker.atLiveEdge() ? (this.setAttribute("aria-disabled", !0), this.addClass("vjs-at-live-edge"), this.controlText("Seek to live, currently playing live")) : (this.setAttribute("aria-disabled", !1), this.removeClass("vjs-at-live-edge"), this.controlText("Seek to live, currently behind live"));
  }, t.handleClick = function() {
    this.player_.liveTracker.seekToLiveEdge();
  }, t.dispose = function() {
    this.player_.liveTracker && this.off(this.player_.liveTracker, "liveedgechange", this.updateLiveEdgeStatusHandler_), this.textEl_ = null, r.prototype.dispose.call(this);
  }, e;
}(Button);
SeekToLive.prototype.controlText_ = "Seek to live, currently playing live";
Component$1.registerComponent("SeekToLive", SeekToLive);
var clamp = function r(e, t, a) {
  return e = Number(e), Math.min(a, Math.max(t, isNaN(e) ? t : e));
}, Slider = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.handleMouseDown_ = function(o) {
      return s.handleMouseDown(o);
    }, s.handleMouseUp_ = function(o) {
      return s.handleMouseUp(o);
    }, s.handleKeyDown_ = function(o) {
      return s.handleKeyDown(o);
    }, s.handleClick_ = function(o) {
      return s.handleClick(o);
    }, s.handleMouseMove_ = function(o) {
      return s.handleMouseMove(o);
    }, s.update_ = function(o) {
      return s.update(o);
    }, s.bar = s.getChild(s.options_.barName), s.vertical(!!s.options_.vertical), s.enable(), s;
  }
  var t = e.prototype;
  return t.enabled = function() {
    return this.enabled_;
  }, t.enable = function() {
    this.enabled() || (this.on("mousedown", this.handleMouseDown_), this.on("touchstart", this.handleMouseDown_), this.on("keydown", this.handleKeyDown_), this.on("click", this.handleClick_), this.on(this.player_, "controlsvisible", this.update), this.playerEvent && this.on(this.player_, this.playerEvent, this.update), this.removeClass("disabled"), this.setAttribute("tabindex", 0), this.enabled_ = !0);
  }, t.disable = function() {
    if (!!this.enabled()) {
      var n = this.bar.el_.ownerDocument;
      this.off("mousedown", this.handleMouseDown_), this.off("touchstart", this.handleMouseDown_), this.off("keydown", this.handleKeyDown_), this.off("click", this.handleClick_), this.off(this.player_, "controlsvisible", this.update_), this.off(n, "mousemove", this.handleMouseMove_), this.off(n, "mouseup", this.handleMouseUp_), this.off(n, "touchmove", this.handleMouseMove_), this.off(n, "touchend", this.handleMouseUp_), this.removeAttribute("tabindex"), this.addClass("disabled"), this.playerEvent && this.off(this.player_, this.playerEvent, this.update), this.enabled_ = !1;
    }
  }, t.createEl = function(n, s, o) {
    return s === void 0 && (s = {}), o === void 0 && (o = {}), s.className = s.className + " vjs-slider", s = assign({
      tabIndex: 0
    }, s), o = assign({
      role: "slider",
      "aria-valuenow": 0,
      "aria-valuemin": 0,
      "aria-valuemax": 100,
      tabIndex: 0
    }, o), r.prototype.createEl.call(this, n, s, o);
  }, t.handleMouseDown = function(n) {
    var s = this.bar.el_.ownerDocument;
    n.type === "mousedown" && n.preventDefault(), n.type === "touchstart" && !IS_CHROME && n.preventDefault(), blockTextSelection(), this.addClass("vjs-sliding"), this.trigger("slideractive"), this.on(s, "mousemove", this.handleMouseMove_), this.on(s, "mouseup", this.handleMouseUp_), this.on(s, "touchmove", this.handleMouseMove_), this.on(s, "touchend", this.handleMouseUp_), this.handleMouseMove(n, !0);
  }, t.handleMouseMove = function(n) {
  }, t.handleMouseUp = function() {
    var n = this.bar.el_.ownerDocument;
    unblockTextSelection(), this.removeClass("vjs-sliding"), this.trigger("sliderinactive"), this.off(n, "mousemove", this.handleMouseMove_), this.off(n, "mouseup", this.handleMouseUp_), this.off(n, "touchmove", this.handleMouseMove_), this.off(n, "touchend", this.handleMouseUp_), this.update();
  }, t.update = function() {
    var n = this;
    if (!(!this.el_ || !this.bar)) {
      var s = this.getProgress();
      return s === this.progress_ || (this.progress_ = s, this.requestNamedAnimationFrame("Slider#update", function() {
        var o = n.vertical() ? "height" : "width";
        n.bar.el().style[o] = (s * 100).toFixed(2) + "%";
      })), s;
    }
  }, t.getProgress = function() {
    return Number(clamp(this.getPercent(), 0, 1).toFixed(4));
  }, t.calculateDistance = function(n) {
    var s = getPointerPosition(this.el_, n);
    return this.vertical() ? s.y : s.x;
  }, t.handleKeyDown = function(n) {
    keycode.isEventKey(n, "Left") || keycode.isEventKey(n, "Down") ? (n.preventDefault(), n.stopPropagation(), this.stepBack()) : keycode.isEventKey(n, "Right") || keycode.isEventKey(n, "Up") ? (n.preventDefault(), n.stopPropagation(), this.stepForward()) : r.prototype.handleKeyDown.call(this, n);
  }, t.handleClick = function(n) {
    n.stopPropagation(), n.preventDefault();
  }, t.vertical = function(n) {
    if (n === void 0)
      return this.vertical_ || !1;
    this.vertical_ = !!n, this.vertical_ ? this.addClass("vjs-slider-vertical") : this.addClass("vjs-slider-horizontal");
  }, e;
}(Component$1);
Component$1.registerComponent("Slider", Slider);
var percentify = function r(e, t) {
  return clamp(e / t * 100, 0, 100).toFixed(2) + "%";
}, LoadProgressBar = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.partEls_ = [], s.on(a, "progress", function(o) {
      return s.update(o);
    }), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = r.prototype.createEl.call(this, "div", {
      className: "vjs-load-progress"
    }), s = createEl("span", {
      className: "vjs-control-text"
    }), o = createEl("span", {
      textContent: this.localize("Loaded")
    }), u = document_1.createTextNode(": ");
    return this.percentageEl_ = createEl("span", {
      className: "vjs-control-text-loaded-percentage",
      textContent: "0%"
    }), n.appendChild(s), s.appendChild(o), s.appendChild(u), s.appendChild(this.percentageEl_), n;
  }, t.dispose = function() {
    this.partEls_ = null, this.percentageEl_ = null, r.prototype.dispose.call(this);
  }, t.update = function(n) {
    var s = this;
    this.requestNamedAnimationFrame("LoadProgressBar#update", function() {
      var o = s.player_.liveTracker, u = s.player_.buffered(), l = o && o.isLive() ? o.seekableEnd() : s.player_.duration(), f = s.player_.bufferedEnd(), d = s.partEls_, h = percentify(f, l);
      s.percent_ !== h && (s.el_.style.width = h, textContent(s.percentageEl_, h), s.percent_ = h);
      for (var p = 0; p < u.length; p++) {
        var m = u.start(p), _ = u.end(p), w = d[p];
        w || (w = s.el_.appendChild(createEl()), d[p] = w), !(w.dataset.start === m && w.dataset.end === _) && (w.dataset.start = m, w.dataset.end = _, w.style.left = percentify(m, f), w.style.width = percentify(_ - m, f));
      }
      for (var S = d.length; S > u.length; S--)
        s.el_.removeChild(d[S - 1]);
      d.length = u.length;
    });
  }, e;
}(Component$1);
Component$1.registerComponent("LoadProgressBar", LoadProgressBar);
var TimeTooltip = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.update = throttle(bind(_assertThisInitialized$1(s), s.update), UPDATE_REFRESH_INTERVAL), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-time-tooltip"
    }, {
      "aria-hidden": "true"
    });
  }, t.update = function(n, s, o) {
    var u = findPosition(this.el_), l = getBoundingClientRect(this.player_.el()), f = n.width * s;
    if (!(!l || !u)) {
      var d = n.left - l.left + f, h = n.width - f + (l.right - n.right), p = u.width / 2;
      d < p ? p += p - d : h < p && (p = h), p < 0 ? p = 0 : p > u.width && (p = u.width), p = Math.round(p), this.el_.style.right = "-" + p + "px", this.write(o);
    }
  }, t.write = function(n) {
    textContent(this.el_, n);
  }, t.updateTime = function(n, s, o, u) {
    var l = this;
    this.requestNamedAnimationFrame("TimeTooltip#updateTime", function() {
      var f, d = l.player_.duration();
      if (l.player_.liveTracker && l.player_.liveTracker.isLive()) {
        var h = l.player_.liveTracker.liveWindow(), p = h - s * h;
        f = (p < 1 ? "" : "-") + formatTime(p, h);
      } else
        f = formatTime(o, d);
      l.update(n, s, f), u && u();
    });
  }, e;
}(Component$1);
Component$1.registerComponent("TimeTooltip", TimeTooltip);
var PlayProgressBar = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.update = throttle(bind(_assertThisInitialized$1(s), s.update), UPDATE_REFRESH_INTERVAL), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-play-progress vjs-slider-bar"
    }, {
      "aria-hidden": "true"
    });
  }, t.update = function(n, s) {
    var o = this.getChild("timeTooltip");
    if (!!o) {
      var u = this.player_.scrubbing() ? this.player_.getCache().currentTime : this.player_.currentTime();
      o.updateTime(n, s, u);
    }
  }, e;
}(Component$1);
PlayProgressBar.prototype.options_ = {
  children: []
};
!IS_IOS && !IS_ANDROID && PlayProgressBar.prototype.options_.children.push("timeTooltip");
Component$1.registerComponent("PlayProgressBar", PlayProgressBar);
var MouseTimeDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.update = throttle(bind(_assertThisInitialized$1(s), s.update), UPDATE_REFRESH_INTERVAL), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-mouse-display"
    });
  }, t.update = function(n, s) {
    var o = this, u = s * this.player_.duration();
    this.getChild("timeTooltip").updateTime(n, s, u, function() {
      o.el_.style.left = n.width * s + "px";
    });
  }, e;
}(Component$1);
MouseTimeDisplay.prototype.options_ = {
  children: ["timeTooltip"]
};
Component$1.registerComponent("MouseTimeDisplay", MouseTimeDisplay);
var STEP_SECONDS = 5, PAGE_KEY_MULTIPLIER = 12, SeekBar = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.setEventHandlers_(), s;
  }
  var t = e.prototype;
  return t.setEventHandlers_ = function() {
    var n = this;
    this.update_ = bind(this, this.update), this.update = throttle(this.update_, UPDATE_REFRESH_INTERVAL), this.on(this.player_, ["ended", "durationchange", "timeupdate"], this.update), this.player_.liveTracker && this.on(this.player_.liveTracker, "liveedgechange", this.update), this.updateInterval = null, this.enableIntervalHandler_ = function(s) {
      return n.enableInterval_(s);
    }, this.disableIntervalHandler_ = function(s) {
      return n.disableInterval_(s);
    }, this.on(this.player_, ["playing"], this.enableIntervalHandler_), this.on(this.player_, ["ended", "pause", "waiting"], this.disableIntervalHandler_), "hidden" in document_1 && "visibilityState" in document_1 && this.on(document_1, "visibilitychange", this.toggleVisibility_);
  }, t.toggleVisibility_ = function(n) {
    document_1.visibilityState === "hidden" ? (this.cancelNamedAnimationFrame("SeekBar#update"), this.cancelNamedAnimationFrame("Slider#update"), this.disableInterval_(n)) : (!this.player_.ended() && !this.player_.paused() && this.enableInterval_(), this.update());
  }, t.enableInterval_ = function() {
    this.updateInterval || (this.updateInterval = this.setInterval(this.update, UPDATE_REFRESH_INTERVAL));
  }, t.disableInterval_ = function(n) {
    this.player_.liveTracker && this.player_.liveTracker.isLive() && n && n.type !== "ended" || !this.updateInterval || (this.clearInterval(this.updateInterval), this.updateInterval = null);
  }, t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-progress-holder"
    }, {
      "aria-label": this.localize("Progress Bar")
    });
  }, t.update = function(n) {
    var s = this;
    if (document_1.visibilityState !== "hidden") {
      var o = r.prototype.update.call(this);
      return this.requestNamedAnimationFrame("SeekBar#update", function() {
        var u = s.player_.ended() ? s.player_.duration() : s.getCurrentTime_(), l = s.player_.liveTracker, f = s.player_.duration();
        l && l.isLive() && (f = s.player_.liveTracker.liveCurrentTime()), s.percent_ !== o && (s.el_.setAttribute("aria-valuenow", (o * 100).toFixed(2)), s.percent_ = o), (s.currentTime_ !== u || s.duration_ !== f) && (s.el_.setAttribute("aria-valuetext", s.localize("progress bar timing: currentTime={1} duration={2}", [formatTime(u, f), formatTime(f, f)], "{1} of {2}")), s.currentTime_ = u, s.duration_ = f), s.bar && s.bar.update(getBoundingClientRect(s.el()), s.getProgress());
      }), o;
    }
  }, t.userSeek_ = function(n) {
    this.player_.liveTracker && this.player_.liveTracker.isLive() && this.player_.liveTracker.nextSeekedFromUser(), this.player_.currentTime(n);
  }, t.getCurrentTime_ = function() {
    return this.player_.scrubbing() ? this.player_.getCache().currentTime : this.player_.currentTime();
  }, t.getPercent = function() {
    var n = this.getCurrentTime_(), s, o = this.player_.liveTracker;
    return o && o.isLive() ? (s = (n - o.seekableStart()) / o.liveWindow(), o.atLiveEdge() && (s = 1)) : s = n / this.player_.duration(), s;
  }, t.handleMouseDown = function(n) {
    !isSingleLeftClick(n) || (n.stopPropagation(), this.videoWasPlaying = !this.player_.paused(), this.player_.pause(), r.prototype.handleMouseDown.call(this, n));
  }, t.handleMouseMove = function(n, s) {
    if (s === void 0 && (s = !1), !!isSingleLeftClick(n)) {
      !s && !this.player_.scrubbing() && this.player_.scrubbing(!0);
      var o, u = this.calculateDistance(n), l = this.player_.liveTracker;
      if (!l || !l.isLive())
        o = u * this.player_.duration(), o === this.player_.duration() && (o = o - 0.1);
      else {
        if (u >= 0.99) {
          l.seekToLiveEdge();
          return;
        }
        var f = l.seekableStart(), d = l.liveCurrentTime();
        if (o = f + u * l.liveWindow(), o >= d && (o = d), o <= f && (o = f + 0.1), o === 1 / 0)
          return;
      }
      this.userSeek_(o);
    }
  }, t.enable = function() {
    r.prototype.enable.call(this);
    var n = this.getChild("mouseTimeDisplay");
    !n || n.show();
  }, t.disable = function() {
    r.prototype.disable.call(this);
    var n = this.getChild("mouseTimeDisplay");
    !n || n.hide();
  }, t.handleMouseUp = function(n) {
    r.prototype.handleMouseUp.call(this, n), n && n.stopPropagation(), this.player_.scrubbing(!1), this.player_.trigger({
      type: "timeupdate",
      target: this,
      manuallyTriggered: !0
    }), this.videoWasPlaying ? silencePromise(this.player_.play()) : this.update_();
  }, t.stepForward = function() {
    this.userSeek_(this.player_.currentTime() + STEP_SECONDS);
  }, t.stepBack = function() {
    this.userSeek_(this.player_.currentTime() - STEP_SECONDS);
  }, t.handleAction = function(n) {
    this.player_.paused() ? this.player_.play() : this.player_.pause();
  }, t.handleKeyDown = function(n) {
    var s = this.player_.liveTracker;
    if (keycode.isEventKey(n, "Space") || keycode.isEventKey(n, "Enter"))
      n.preventDefault(), n.stopPropagation(), this.handleAction(n);
    else if (keycode.isEventKey(n, "Home"))
      n.preventDefault(), n.stopPropagation(), this.userSeek_(0);
    else if (keycode.isEventKey(n, "End"))
      n.preventDefault(), n.stopPropagation(), s && s.isLive() ? this.userSeek_(s.liveCurrentTime()) : this.userSeek_(this.player_.duration());
    else if (/^[0-9]$/.test(keycode(n))) {
      n.preventDefault(), n.stopPropagation();
      var o = (keycode.codes[keycode(n)] - keycode.codes[0]) * 10 / 100;
      s && s.isLive() ? this.userSeek_(s.seekableStart() + s.liveWindow() * o) : this.userSeek_(this.player_.duration() * o);
    } else
      keycode.isEventKey(n, "PgDn") ? (n.preventDefault(), n.stopPropagation(), this.userSeek_(this.player_.currentTime() - STEP_SECONDS * PAGE_KEY_MULTIPLIER)) : keycode.isEventKey(n, "PgUp") ? (n.preventDefault(), n.stopPropagation(), this.userSeek_(this.player_.currentTime() + STEP_SECONDS * PAGE_KEY_MULTIPLIER)) : r.prototype.handleKeyDown.call(this, n);
  }, t.dispose = function() {
    this.disableInterval_(), this.off(this.player_, ["ended", "durationchange", "timeupdate"], this.update), this.player_.liveTracker && this.off(this.player_.liveTracker, "liveedgechange", this.update), this.off(this.player_, ["playing"], this.enableIntervalHandler_), this.off(this.player_, ["ended", "pause", "waiting"], this.disableIntervalHandler_), "hidden" in document_1 && "visibilityState" in document_1 && this.off(document_1, "visibilitychange", this.toggleVisibility_), r.prototype.dispose.call(this);
  }, e;
}(Slider);
SeekBar.prototype.options_ = {
  children: ["loadProgressBar", "playProgressBar"],
  barName: "playProgressBar"
};
!IS_IOS && !IS_ANDROID && SeekBar.prototype.options_.children.splice(1, 0, "mouseTimeDisplay");
Component$1.registerComponent("SeekBar", SeekBar);
var ProgressControl = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.handleMouseMove = throttle(bind(_assertThisInitialized$1(s), s.handleMouseMove), UPDATE_REFRESH_INTERVAL), s.throttledHandleMouseSeek = throttle(bind(_assertThisInitialized$1(s), s.handleMouseSeek), UPDATE_REFRESH_INTERVAL), s.handleMouseUpHandler_ = function(o) {
      return s.handleMouseUp(o);
    }, s.handleMouseDownHandler_ = function(o) {
      return s.handleMouseDown(o);
    }, s.enable(), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-progress-control vjs-control"
    });
  }, t.handleMouseMove = function(n) {
    var s = this.getChild("seekBar");
    if (!!s) {
      var o = s.getChild("playProgressBar"), u = s.getChild("mouseTimeDisplay");
      if (!(!o && !u)) {
        var l = s.el(), f = findPosition(l), d = getPointerPosition(l, n).x;
        d = clamp(d, 0, 1), u && u.update(f, d), o && o.update(f, s.getProgress());
      }
    }
  }, t.handleMouseSeek = function(n) {
    var s = this.getChild("seekBar");
    s && s.handleMouseMove(n);
  }, t.enabled = function() {
    return this.enabled_;
  }, t.disable = function() {
    if (this.children().forEach(function(s) {
      return s.disable && s.disable();
    }), !!this.enabled() && (this.off(["mousedown", "touchstart"], this.handleMouseDownHandler_), this.off(this.el_, "mousemove", this.handleMouseMove), this.removeListenersAddedOnMousedownAndTouchstart(), this.addClass("disabled"), this.enabled_ = !1, this.player_.scrubbing())) {
      var n = this.getChild("seekBar");
      this.player_.scrubbing(!1), n.videoWasPlaying && silencePromise(this.player_.play());
    }
  }, t.enable = function() {
    this.children().forEach(function(n) {
      return n.enable && n.enable();
    }), !this.enabled() && (this.on(["mousedown", "touchstart"], this.handleMouseDownHandler_), this.on(this.el_, "mousemove", this.handleMouseMove), this.removeClass("disabled"), this.enabled_ = !0);
  }, t.removeListenersAddedOnMousedownAndTouchstart = function() {
    var n = this.el_.ownerDocument;
    this.off(n, "mousemove", this.throttledHandleMouseSeek), this.off(n, "touchmove", this.throttledHandleMouseSeek), this.off(n, "mouseup", this.handleMouseUpHandler_), this.off(n, "touchend", this.handleMouseUpHandler_);
  }, t.handleMouseDown = function(n) {
    var s = this.el_.ownerDocument, o = this.getChild("seekBar");
    o && o.handleMouseDown(n), this.on(s, "mousemove", this.throttledHandleMouseSeek), this.on(s, "touchmove", this.throttledHandleMouseSeek), this.on(s, "mouseup", this.handleMouseUpHandler_), this.on(s, "touchend", this.handleMouseUpHandler_);
  }, t.handleMouseUp = function(n) {
    var s = this.getChild("seekBar");
    s && s.handleMouseUp(n), this.removeListenersAddedOnMousedownAndTouchstart();
  }, e;
}(Component$1);
ProgressControl.prototype.options_ = {
  children: ["seekBar"]
};
Component$1.registerComponent("ProgressControl", ProgressControl);
var PictureInPictureToggle = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.on(a, ["enterpictureinpicture", "leavepictureinpicture"], function(o) {
      return s.handlePictureInPictureChange(o);
    }), s.on(a, ["disablepictureinpicturechanged", "loadedmetadata"], function(o) {
      return s.handlePictureInPictureEnabledChange(o);
    }), s.on(a, ["loadedmetadata", "audioonlymodechange", "audiopostermodechange"], function() {
      var o = a.currentType().substring(0, 5) === "audio";
      o || a.audioPosterMode() || a.audioOnlyMode() ? (a.isInPictureInPicture() && a.exitPictureInPicture(), s.hide()) : s.show();
    }), s.disable(), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-picture-in-picture-control " + r.prototype.buildCSSClass.call(this);
  }, t.handlePictureInPictureEnabledChange = function() {
    document_1.pictureInPictureEnabled && this.player_.disablePictureInPicture() === !1 ? this.enable() : this.disable();
  }, t.handlePictureInPictureChange = function(n) {
    this.player_.isInPictureInPicture() ? this.controlText("Exit Picture-in-Picture") : this.controlText("Picture-in-Picture"), this.handlePictureInPictureEnabledChange();
  }, t.handleClick = function(n) {
    this.player_.isInPictureInPicture() ? this.player_.exitPictureInPicture() : this.player_.requestPictureInPicture();
  }, e;
}(Button);
PictureInPictureToggle.prototype.controlText_ = "Picture-in-Picture";
Component$1.registerComponent("PictureInPictureToggle", PictureInPictureToggle);
var FullscreenToggle = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.on(a, "fullscreenchange", function(o) {
      return s.handleFullscreenChange(o);
    }), document_1[a.fsApi_.fullscreenEnabled] === !1 && s.disable(), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-fullscreen-control " + r.prototype.buildCSSClass.call(this);
  }, t.handleFullscreenChange = function(n) {
    this.player_.isFullscreen() ? this.controlText("Non-Fullscreen") : this.controlText("Fullscreen");
  }, t.handleClick = function(n) {
    this.player_.isFullscreen() ? this.player_.exitFullscreen() : this.player_.requestFullscreen();
  }, e;
}(Button);
FullscreenToggle.prototype.controlText_ = "Fullscreen";
Component$1.registerComponent("FullscreenToggle", FullscreenToggle);
var checkVolumeSupport = function r(e, t) {
  t.tech_ && !t.tech_.featuresVolumeControl && e.addClass("vjs-hidden"), e.on(t, "loadstart", function() {
    t.tech_.featuresVolumeControl ? e.removeClass("vjs-hidden") : e.addClass("vjs-hidden");
  });
}, VolumeLevel = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = r.prototype.createEl.call(this, "div", {
      className: "vjs-volume-level"
    });
    return n.appendChild(r.prototype.createEl.call(this, "span", {
      className: "vjs-control-text"
    })), n;
  }, e;
}(Component$1);
Component$1.registerComponent("VolumeLevel", VolumeLevel);
var VolumeLevelTooltip = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.update = throttle(bind(_assertThisInitialized$1(s), s.update), UPDATE_REFRESH_INTERVAL), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-volume-tooltip"
    }, {
      "aria-hidden": "true"
    });
  }, t.update = function(n, s, o, u) {
    if (!o) {
      var l = getBoundingClientRect(this.el_), f = getBoundingClientRect(this.player_.el()), d = n.width * s;
      if (!f || !l)
        return;
      var h = n.left - f.left + d, p = n.width - d + (f.right - n.right), m = l.width / 2;
      h < m ? m += m - h : p < m && (m = p), m < 0 ? m = 0 : m > l.width && (m = l.width), this.el_.style.right = "-" + m + "px";
    }
    this.write(u + "%");
  }, t.write = function(n) {
    textContent(this.el_, n);
  }, t.updateVolume = function(n, s, o, u, l) {
    var f = this;
    this.requestNamedAnimationFrame("VolumeLevelTooltip#updateVolume", function() {
      f.update(n, s, o, u.toFixed(0)), l && l();
    });
  }, e;
}(Component$1);
Component$1.registerComponent("VolumeLevelTooltip", VolumeLevelTooltip);
var MouseVolumeLevelDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.update = throttle(bind(_assertThisInitialized$1(s), s.update), UPDATE_REFRESH_INTERVAL), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-mouse-display"
    });
  }, t.update = function(n, s, o) {
    var u = this, l = 100 * s;
    this.getChild("volumeLevelTooltip").updateVolume(n, s, o, l, function() {
      o ? u.el_.style.bottom = n.height * s + "px" : u.el_.style.left = n.width * s + "px";
    });
  }, e;
}(Component$1);
MouseVolumeLevelDisplay.prototype.options_ = {
  children: ["volumeLevelTooltip"]
};
Component$1.registerComponent("MouseVolumeLevelDisplay", MouseVolumeLevelDisplay);
var VolumeBar = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.on("slideractive", function(o) {
      return s.updateLastVolume_(o);
    }), s.on(a, "volumechange", function(o) {
      return s.updateARIAAttributes(o);
    }), a.ready(function() {
      return s.updateARIAAttributes();
    }), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-volume-bar vjs-slider-bar"
    }, {
      "aria-label": this.localize("Volume Level"),
      "aria-live": "polite"
    });
  }, t.handleMouseDown = function(n) {
    !isSingleLeftClick(n) || r.prototype.handleMouseDown.call(this, n);
  }, t.handleMouseMove = function(n) {
    var s = this.getChild("mouseVolumeLevelDisplay");
    if (s) {
      var o = this.el(), u = getBoundingClientRect(o), l = this.vertical(), f = getPointerPosition(o, n);
      f = l ? f.y : f.x, f = clamp(f, 0, 1), s.update(u, f, l);
    }
    !isSingleLeftClick(n) || (this.checkMuted(), this.player_.volume(this.calculateDistance(n)));
  }, t.checkMuted = function() {
    this.player_.muted() && this.player_.muted(!1);
  }, t.getPercent = function() {
    return this.player_.muted() ? 0 : this.player_.volume();
  }, t.stepForward = function() {
    this.checkMuted(), this.player_.volume(this.player_.volume() + 0.1);
  }, t.stepBack = function() {
    this.checkMuted(), this.player_.volume(this.player_.volume() - 0.1);
  }, t.updateARIAAttributes = function(n) {
    var s = this.player_.muted() ? 0 : this.volumeAsPercentage_();
    this.el_.setAttribute("aria-valuenow", s), this.el_.setAttribute("aria-valuetext", s + "%");
  }, t.volumeAsPercentage_ = function() {
    return Math.round(this.player_.volume() * 100);
  }, t.updateLastVolume_ = function() {
    var n = this, s = this.player_.volume();
    this.one("sliderinactive", function() {
      n.player_.volume() === 0 && n.player_.lastVolume_(s);
    });
  }, e;
}(Slider);
VolumeBar.prototype.options_ = {
  children: ["volumeLevel"],
  barName: "volumeLevel"
};
!IS_IOS && !IS_ANDROID && VolumeBar.prototype.options_.children.splice(0, 0, "mouseVolumeLevelDisplay");
VolumeBar.prototype.playerEvent = "volumechange";
Component$1.registerComponent("VolumeBar", VolumeBar);
var VolumeControl = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n === void 0 && (n = {}), n.vertical = n.vertical || !1, (typeof n.volumeBar > "u" || isPlain(n.volumeBar)) && (n.volumeBar = n.volumeBar || {}, n.volumeBar.vertical = n.vertical), s = r.call(this, a, n) || this, checkVolumeSupport(_assertThisInitialized$1(s), a), s.throttledHandleMouseMove = throttle(bind(_assertThisInitialized$1(s), s.handleMouseMove), UPDATE_REFRESH_INTERVAL), s.handleMouseUpHandler_ = function(o) {
      return s.handleMouseUp(o);
    }, s.on("mousedown", function(o) {
      return s.handleMouseDown(o);
    }), s.on("touchstart", function(o) {
      return s.handleMouseDown(o);
    }), s.on("mousemove", function(o) {
      return s.handleMouseMove(o);
    }), s.on(s.volumeBar, ["focus", "slideractive"], function() {
      s.volumeBar.addClass("vjs-slider-active"), s.addClass("vjs-slider-active"), s.trigger("slideractive");
    }), s.on(s.volumeBar, ["blur", "sliderinactive"], function() {
      s.volumeBar.removeClass("vjs-slider-active"), s.removeClass("vjs-slider-active"), s.trigger("sliderinactive");
    }), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = "vjs-volume-horizontal";
    return this.options_.vertical && (n = "vjs-volume-vertical"), r.prototype.createEl.call(this, "div", {
      className: "vjs-volume-control vjs-control " + n
    });
  }, t.handleMouseDown = function(n) {
    var s = this.el_.ownerDocument;
    this.on(s, "mousemove", this.throttledHandleMouseMove), this.on(s, "touchmove", this.throttledHandleMouseMove), this.on(s, "mouseup", this.handleMouseUpHandler_), this.on(s, "touchend", this.handleMouseUpHandler_);
  }, t.handleMouseUp = function(n) {
    var s = this.el_.ownerDocument;
    this.off(s, "mousemove", this.throttledHandleMouseMove), this.off(s, "touchmove", this.throttledHandleMouseMove), this.off(s, "mouseup", this.handleMouseUpHandler_), this.off(s, "touchend", this.handleMouseUpHandler_);
  }, t.handleMouseMove = function(n) {
    this.volumeBar.handleMouseMove(n);
  }, e;
}(Component$1);
VolumeControl.prototype.options_ = {
  children: ["volumeBar"]
};
Component$1.registerComponent("VolumeControl", VolumeControl);
var checkMuteSupport = function r(e, t) {
  t.tech_ && !t.tech_.featuresMuteControl && e.addClass("vjs-hidden"), e.on(t, "loadstart", function() {
    t.tech_.featuresMuteControl ? e.removeClass("vjs-hidden") : e.addClass("vjs-hidden");
  });
}, MuteToggle = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, checkMuteSupport(_assertThisInitialized$1(s), a), s.on(a, ["loadstart", "volumechange"], function(o) {
      return s.update(o);
    }), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-mute-control " + r.prototype.buildCSSClass.call(this);
  }, t.handleClick = function(n) {
    var s = this.player_.volume(), o = this.player_.lastVolume_();
    if (s === 0) {
      var u = o < 0.1 ? 0.1 : o;
      this.player_.volume(u), this.player_.muted(!1);
    } else
      this.player_.muted(!this.player_.muted());
  }, t.update = function(n) {
    this.updateIcon_(), this.updateControlText_();
  }, t.updateIcon_ = function() {
    var n = this.player_.volume(), s = 3;
    IS_IOS && this.player_.tech_ && this.player_.tech_.el_ && this.player_.muted(this.player_.tech_.el_.muted), n === 0 || this.player_.muted() ? s = 0 : n < 0.33 ? s = 1 : n < 0.67 && (s = 2);
    for (var o = 0; o < 4; o++)
      removeClass(this.el_, "vjs-vol-" + o);
    addClass(this.el_, "vjs-vol-" + s);
  }, t.updateControlText_ = function() {
    var n = this.player_.muted() || this.player_.volume() === 0, s = n ? "Unmute" : "Mute";
    this.controlText() !== s && this.controlText(s);
  }, e;
}(Button);
MuteToggle.prototype.controlText_ = "Mute";
Component$1.registerComponent("MuteToggle", MuteToggle);
var VolumePanel = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n === void 0 && (n = {}), typeof n.inline < "u" ? n.inline = n.inline : n.inline = !0, (typeof n.volumeControl > "u" || isPlain(n.volumeControl)) && (n.volumeControl = n.volumeControl || {}, n.volumeControl.vertical = !n.inline), s = r.call(this, a, n) || this, s.handleKeyPressHandler_ = function(o) {
      return s.handleKeyPress(o);
    }, s.on(a, ["loadstart"], function(o) {
      return s.volumePanelState_(o);
    }), s.on(s.muteToggle, "keyup", function(o) {
      return s.handleKeyPress(o);
    }), s.on(s.volumeControl, "keyup", function(o) {
      return s.handleVolumeControlKeyUp(o);
    }), s.on("keydown", function(o) {
      return s.handleKeyPress(o);
    }), s.on("mouseover", function(o) {
      return s.handleMouseOver(o);
    }), s.on("mouseout", function(o) {
      return s.handleMouseOut(o);
    }), s.on(s.volumeControl, ["slideractive"], s.sliderActive_), s.on(s.volumeControl, ["sliderinactive"], s.sliderInactive_), s;
  }
  var t = e.prototype;
  return t.sliderActive_ = function() {
    this.addClass("vjs-slider-active");
  }, t.sliderInactive_ = function() {
    this.removeClass("vjs-slider-active");
  }, t.volumePanelState_ = function() {
    this.volumeControl.hasClass("vjs-hidden") && this.muteToggle.hasClass("vjs-hidden") && this.addClass("vjs-hidden"), this.volumeControl.hasClass("vjs-hidden") && !this.muteToggle.hasClass("vjs-hidden") && this.addClass("vjs-mute-toggle-only");
  }, t.createEl = function() {
    var n = "vjs-volume-panel-horizontal";
    return this.options_.inline || (n = "vjs-volume-panel-vertical"), r.prototype.createEl.call(this, "div", {
      className: "vjs-volume-panel vjs-control " + n
    });
  }, t.dispose = function() {
    this.handleMouseOut(), r.prototype.dispose.call(this);
  }, t.handleVolumeControlKeyUp = function(n) {
    keycode.isEventKey(n, "Esc") && this.muteToggle.focus();
  }, t.handleMouseOver = function(n) {
    this.addClass("vjs-hover"), on(document_1, "keyup", this.handleKeyPressHandler_);
  }, t.handleMouseOut = function(n) {
    this.removeClass("vjs-hover"), off(document_1, "keyup", this.handleKeyPressHandler_);
  }, t.handleKeyPress = function(n) {
    keycode.isEventKey(n, "Esc") && this.handleMouseOut();
  }, e;
}(Component$1);
VolumePanel.prototype.options_ = {
  children: ["muteToggle", "volumeControl"]
};
Component$1.registerComponent("VolumePanel", VolumePanel);
var Menu = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, n && (s.menuButton_ = n.menuButton), s.focusedChild_ = -1, s.on("keydown", function(o) {
      return s.handleKeyDown(o);
    }), s.boundHandleBlur_ = function(o) {
      return s.handleBlur(o);
    }, s.boundHandleTapClick_ = function(o) {
      return s.handleTapClick(o);
    }, s;
  }
  var t = e.prototype;
  return t.addEventListenerForItem = function(n) {
    n instanceof Component$1 && (this.on(n, "blur", this.boundHandleBlur_), this.on(n, ["tap", "click"], this.boundHandleTapClick_));
  }, t.removeEventListenerForItem = function(n) {
    n instanceof Component$1 && (this.off(n, "blur", this.boundHandleBlur_), this.off(n, ["tap", "click"], this.boundHandleTapClick_));
  }, t.removeChild = function(n) {
    typeof n == "string" && (n = this.getChild(n)), this.removeEventListenerForItem(n), r.prototype.removeChild.call(this, n);
  }, t.addItem = function(n) {
    var s = this.addChild(n);
    s && this.addEventListenerForItem(s);
  }, t.createEl = function() {
    var n = this.options_.contentElType || "ul";
    this.contentEl_ = createEl(n, {
      className: "vjs-menu-content"
    }), this.contentEl_.setAttribute("role", "menu");
    var s = r.prototype.createEl.call(this, "div", {
      append: this.contentEl_,
      className: "vjs-menu"
    });
    return s.appendChild(this.contentEl_), on(s, "click", function(o) {
      o.preventDefault(), o.stopImmediatePropagation();
    }), s;
  }, t.dispose = function() {
    this.contentEl_ = null, this.boundHandleBlur_ = null, this.boundHandleTapClick_ = null, r.prototype.dispose.call(this);
  }, t.handleBlur = function(n) {
    var s = n.relatedTarget || document_1.activeElement;
    if (!this.children().some(function(u) {
      return u.el() === s;
    })) {
      var o = this.menuButton_;
      o && o.buttonPressed_ && s !== o.el().firstChild && o.unpressButton();
    }
  }, t.handleTapClick = function(n) {
    if (this.menuButton_) {
      this.menuButton_.unpressButton();
      var s = this.children();
      if (!Array.isArray(s))
        return;
      var o = s.filter(function(u) {
        return u.el() === n.target;
      })[0];
      if (!o)
        return;
      o.name() !== "CaptionSettingsMenuItem" && this.menuButton_.focus();
    }
  }, t.handleKeyDown = function(n) {
    keycode.isEventKey(n, "Left") || keycode.isEventKey(n, "Down") ? (n.preventDefault(), n.stopPropagation(), this.stepForward()) : (keycode.isEventKey(n, "Right") || keycode.isEventKey(n, "Up")) && (n.preventDefault(), n.stopPropagation(), this.stepBack());
  }, t.stepForward = function() {
    var n = 0;
    this.focusedChild_ !== void 0 && (n = this.focusedChild_ + 1), this.focus(n);
  }, t.stepBack = function() {
    var n = 0;
    this.focusedChild_ !== void 0 && (n = this.focusedChild_ - 1), this.focus(n);
  }, t.focus = function(n) {
    n === void 0 && (n = 0);
    var s = this.children().slice(), o = s.length && s[0].hasClass("vjs-menu-title");
    o && s.shift(), s.length > 0 && (n < 0 ? n = 0 : n >= s.length && (n = s.length - 1), this.focusedChild_ = n, s[n].el_.focus());
  }, e;
}(Component$1);
Component$1.registerComponent("Menu", Menu);
var MenuButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    n === void 0 && (n = {}), s = r.call(this, a, n) || this, s.menuButton_ = new Button(a, n), s.menuButton_.controlText(s.controlText_), s.menuButton_.el_.setAttribute("aria-haspopup", "true");
    var o = Button.prototype.buildCSSClass();
    s.menuButton_.el_.className = s.buildCSSClass() + " " + o, s.menuButton_.removeClass("vjs-control"), s.addChild(s.menuButton_), s.update(), s.enabled_ = !0;
    var u = function(f) {
      return s.handleClick(f);
    };
    return s.handleMenuKeyUp_ = function(l) {
      return s.handleMenuKeyUp(l);
    }, s.on(s.menuButton_, "tap", u), s.on(s.menuButton_, "click", u), s.on(s.menuButton_, "keydown", function(l) {
      return s.handleKeyDown(l);
    }), s.on(s.menuButton_, "mouseenter", function() {
      s.addClass("vjs-hover"), s.menu.show(), on(document_1, "keyup", s.handleMenuKeyUp_);
    }), s.on("mouseleave", function(l) {
      return s.handleMouseLeave(l);
    }), s.on("keydown", function(l) {
      return s.handleSubmenuKeyDown(l);
    }), s;
  }
  var t = e.prototype;
  return t.update = function() {
    var n = this.createMenu();
    this.menu && (this.menu.dispose(), this.removeChild(this.menu)), this.menu = n, this.addChild(n), this.buttonPressed_ = !1, this.menuButton_.el_.setAttribute("aria-expanded", "false"), this.items && this.items.length <= this.hideThreshold_ ? (this.hide(), this.menu.contentEl_.removeAttribute("role")) : (this.show(), this.menu.contentEl_.setAttribute("role", "menu"));
  }, t.createMenu = function() {
    var n = new Menu(this.player_, {
      menuButton: this
    });
    if (this.hideThreshold_ = 0, this.options_.title) {
      var s = createEl("li", {
        className: "vjs-menu-title",
        textContent: toTitleCase$1(this.options_.title),
        tabIndex: -1
      }), o = new Component$1(this.player_, {
        el: s
      });
      n.addItem(o);
    }
    if (this.items = this.createItems(), this.items)
      for (var u = 0; u < this.items.length; u++)
        n.addItem(this.items[u]);
    return n;
  }, t.createItems = function() {
  }, t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: this.buildWrapperCSSClass()
    }, {});
  }, t.buildWrapperCSSClass = function() {
    var n = "vjs-menu-button";
    this.options_.inline === !0 ? n += "-inline" : n += "-popup";
    var s = Button.prototype.buildCSSClass();
    return "vjs-menu-button " + n + " " + s + " " + r.prototype.buildCSSClass.call(this);
  }, t.buildCSSClass = function() {
    var n = "vjs-menu-button";
    return this.options_.inline === !0 ? n += "-inline" : n += "-popup", "vjs-menu-button " + n + " " + r.prototype.buildCSSClass.call(this);
  }, t.controlText = function(n, s) {
    return s === void 0 && (s = this.menuButton_.el()), this.menuButton_.controlText(n, s);
  }, t.dispose = function() {
    this.handleMouseLeave(), r.prototype.dispose.call(this);
  }, t.handleClick = function(n) {
    this.buttonPressed_ ? this.unpressButton() : this.pressButton();
  }, t.handleMouseLeave = function(n) {
    this.removeClass("vjs-hover"), off(document_1, "keyup", this.handleMenuKeyUp_);
  }, t.focus = function() {
    this.menuButton_.focus();
  }, t.blur = function() {
    this.menuButton_.blur();
  }, t.handleKeyDown = function(n) {
    keycode.isEventKey(n, "Esc") || keycode.isEventKey(n, "Tab") ? (this.buttonPressed_ && this.unpressButton(), keycode.isEventKey(n, "Tab") || (n.preventDefault(), this.menuButton_.focus())) : (keycode.isEventKey(n, "Up") || keycode.isEventKey(n, "Down")) && (this.buttonPressed_ || (n.preventDefault(), this.pressButton()));
  }, t.handleMenuKeyUp = function(n) {
    (keycode.isEventKey(n, "Esc") || keycode.isEventKey(n, "Tab")) && this.removeClass("vjs-hover");
  }, t.handleSubmenuKeyPress = function(n) {
    this.handleSubmenuKeyDown(n);
  }, t.handleSubmenuKeyDown = function(n) {
    (keycode.isEventKey(n, "Esc") || keycode.isEventKey(n, "Tab")) && (this.buttonPressed_ && this.unpressButton(), keycode.isEventKey(n, "Tab") || (n.preventDefault(), this.menuButton_.focus()));
  }, t.pressButton = function() {
    if (this.enabled_) {
      if (this.buttonPressed_ = !0, this.menu.show(), this.menu.lockShowing(), this.menuButton_.el_.setAttribute("aria-expanded", "true"), IS_IOS && isInFrame())
        return;
      this.menu.focus();
    }
  }, t.unpressButton = function() {
    this.enabled_ && (this.buttonPressed_ = !1, this.menu.unlockShowing(), this.menu.hide(), this.menuButton_.el_.setAttribute("aria-expanded", "false"));
  }, t.disable = function() {
    this.unpressButton(), this.enabled_ = !1, this.addClass("vjs-disabled"), this.menuButton_.disable();
  }, t.enable = function() {
    this.enabled_ = !0, this.removeClass("vjs-disabled"), this.menuButton_.enable();
  }, e;
}(Component$1);
Component$1.registerComponent("MenuButton", MenuButton);
var TrackButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(t, a) {
    var n, s = a.tracks;
    if (n = r.call(this, t, a) || this, n.items.length <= 1 && n.hide(), !s)
      return _assertThisInitialized$1(n);
    var o = bind(_assertThisInitialized$1(n), n.update);
    return s.addEventListener("removetrack", o), s.addEventListener("addtrack", o), s.addEventListener("labelchange", o), n.player_.on("ready", o), n.player_.on("dispose", function() {
      s.removeEventListener("removetrack", o), s.removeEventListener("addtrack", o), s.removeEventListener("labelchange", o);
    }), n;
  }
  return e;
}(MenuButton);
Component$1.registerComponent("TrackButton", TrackButton);
var MenuKeys = ["Tab", "Esc", "Up", "Down", "Right", "Left"], MenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.selectable = n.selectable, s.isSelected_ = n.selected || !1, s.multiSelectable = n.multiSelectable, s.selected(s.isSelected_), s.selectable ? s.multiSelectable ? s.el_.setAttribute("role", "menuitemcheckbox") : s.el_.setAttribute("role", "menuitemradio") : s.el_.setAttribute("role", "menuitem"), s;
  }
  var t = e.prototype;
  return t.createEl = function(n, s, o) {
    this.nonIconControl = !0;
    var u = r.prototype.createEl.call(this, "li", assign({
      className: "vjs-menu-item",
      tabIndex: -1
    }, s), o);
    return u.replaceChild(createEl("span", {
      className: "vjs-menu-item-text",
      textContent: this.localize(this.options_.label)
    }), u.querySelector(".vjs-icon-placeholder")), u;
  }, t.handleKeyDown = function(n) {
    MenuKeys.some(function(s) {
      return keycode.isEventKey(n, s);
    }) || r.prototype.handleKeyDown.call(this, n);
  }, t.handleClick = function(n) {
    this.selected(!0);
  }, t.selected = function(n) {
    this.selectable && (n ? (this.addClass("vjs-selected"), this.el_.setAttribute("aria-checked", "true"), this.controlText(", selected"), this.isSelected_ = !0) : (this.removeClass("vjs-selected"), this.el_.setAttribute("aria-checked", "false"), this.controlText(""), this.isSelected_ = !1));
  }, e;
}(ClickableComponent);
Component$1.registerComponent("MenuItem", MenuItem);
var TextTrackMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s, o = n.track, u = a.textTracks();
    n.label = o.label || o.language || "Unknown", n.selected = o.mode === "showing", s = r.call(this, a, n) || this, s.track = o, s.kinds = (n.kinds || [n.kind || s.track.kind]).filter(Boolean);
    var l = function() {
      for (var p = arguments.length, m = new Array(p), _ = 0; _ < p; _++)
        m[_] = arguments[_];
      s.handleTracksChange.apply(_assertThisInitialized$1(s), m);
    }, f = function() {
      for (var p = arguments.length, m = new Array(p), _ = 0; _ < p; _++)
        m[_] = arguments[_];
      s.handleSelectedLanguageChange.apply(_assertThisInitialized$1(s), m);
    };
    if (a.on(["loadstart", "texttrackchange"], l), u.addEventListener("change", l), u.addEventListener("selectedlanguagechange", f), s.on("dispose", function() {
      a.off(["loadstart", "texttrackchange"], l), u.removeEventListener("change", l), u.removeEventListener("selectedlanguagechange", f);
    }), u.onchange === void 0) {
      var d;
      s.on(["tap", "click"], function() {
        if (typeof window_1.Event != "object")
          try {
            d = new window_1.Event("change");
          } catch {
          }
        d || (d = document_1.createEvent("Event"), d.initEvent("change", !0, !0)), u.dispatchEvent(d);
      });
    }
    return s.handleTracksChange(), s;
  }
  var t = e.prototype;
  return t.handleClick = function(n) {
    var s = this.track, o = this.player_.textTracks();
    if (r.prototype.handleClick.call(this, n), !!o)
      for (var u = 0; u < o.length; u++) {
        var l = o[u];
        this.kinds.indexOf(l.kind) !== -1 && (l === s ? l.mode !== "showing" && (l.mode = "showing") : l.mode !== "disabled" && (l.mode = "disabled"));
      }
  }, t.handleTracksChange = function(n) {
    var s = this.track.mode === "showing";
    s !== this.isSelected_ && this.selected(s);
  }, t.handleSelectedLanguageChange = function(n) {
    if (this.track.mode === "showing") {
      var s = this.player_.cache_.selectedLanguage;
      if (s && s.enabled && s.language === this.track.language && s.kind !== this.track.kind)
        return;
      this.player_.cache_.selectedLanguage = {
        enabled: !0,
        language: this.track.language,
        kind: this.track.kind
      };
    }
  }, t.dispose = function() {
    this.track = null, r.prototype.dispose.call(this);
  }, e;
}(MenuItem);
Component$1.registerComponent("TextTrackMenuItem", TextTrackMenuItem);
var OffTextTrackMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    return n.track = {
      player: a,
      kind: n.kind,
      kinds: n.kinds,
      default: !1,
      mode: "disabled"
    }, n.kinds || (n.kinds = [n.kind]), n.label ? n.track.label = n.label : n.track.label = n.kinds.join(" and ") + " off", n.selectable = !0, n.multiSelectable = !1, r.call(this, a, n) || this;
  }
  var t = e.prototype;
  return t.handleTracksChange = function(n) {
    for (var s = this.player().textTracks(), o = !0, u = 0, l = s.length; u < l; u++) {
      var f = s[u];
      if (this.options_.kinds.indexOf(f.kind) > -1 && f.mode === "showing") {
        o = !1;
        break;
      }
    }
    o !== this.isSelected_ && this.selected(o);
  }, t.handleSelectedLanguageChange = function(n) {
    for (var s = this.player().textTracks(), o = !0, u = 0, l = s.length; u < l; u++) {
      var f = s[u];
      if (["captions", "descriptions", "subtitles"].indexOf(f.kind) > -1 && f.mode === "showing") {
        o = !1;
        break;
      }
    }
    o && (this.player_.cache_.selectedLanguage = {
      enabled: !1
    });
  }, e;
}(TextTrackMenuItem);
Component$1.registerComponent("OffTextTrackMenuItem", OffTextTrackMenuItem);
var TextTrackButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    return n === void 0 && (n = {}), n.tracks = a.textTracks(), r.call(this, a, n) || this;
  }
  var t = e.prototype;
  return t.createItems = function(n, s) {
    n === void 0 && (n = []), s === void 0 && (s = TextTrackMenuItem);
    var o;
    this.label_ && (o = this.label_ + " off"), n.push(new OffTextTrackMenuItem(this.player_, {
      kinds: this.kinds_,
      kind: this.kind_,
      label: o
    })), this.hideThreshold_ += 1;
    var u = this.player_.textTracks();
    Array.isArray(this.kinds_) || (this.kinds_ = [this.kind_]);
    for (var l = 0; l < u.length; l++) {
      var f = u[l];
      if (this.kinds_.indexOf(f.kind) > -1) {
        var d = new s(this.player_, {
          track: f,
          kinds: this.kinds_,
          kind: this.kind_,
          selectable: !0,
          multiSelectable: !1
        });
        d.addClass("vjs-" + f.kind + "-menu-item"), n.push(d);
      }
    }
    return n;
  }, e;
}(TrackButton);
Component$1.registerComponent("TextTrackButton", TextTrackButton);
var ChaptersTrackMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s, o = n.track, u = n.cue, l = a.currentTime();
    return n.selectable = !0, n.multiSelectable = !1, n.label = u.text, n.selected = u.startTime <= l && l < u.endTime, s = r.call(this, a, n) || this, s.track = o, s.cue = u, s;
  }
  var t = e.prototype;
  return t.handleClick = function(n) {
    r.prototype.handleClick.call(this), this.player_.currentTime(this.cue.startTime);
  }, e;
}(MenuItem);
Component$1.registerComponent("ChaptersTrackMenuItem", ChaptersTrackMenuItem);
var ChaptersButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    var o;
    return o = r.call(this, a, n, s) || this, o.selectCurrentItem_ = function() {
      o.items.forEach(function(u) {
        u.selected(o.track_.activeCues[0] === u.cue);
      });
    }, o;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-chapters-button " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-chapters-button " + r.prototype.buildWrapperCSSClass.call(this);
  }, t.update = function(n) {
    if (!(n && n.track && n.track.kind !== "chapters")) {
      var s = this.findChaptersTrack();
      s !== this.track_ ? (this.setTrack(s), r.prototype.update.call(this)) : (!this.items || s && s.cues && s.cues.length !== this.items.length) && r.prototype.update.call(this);
    }
  }, t.setTrack = function(n) {
    if (this.track_ !== n) {
      if (this.updateHandler_ || (this.updateHandler_ = this.update.bind(this)), this.track_) {
        var s = this.player_.remoteTextTrackEls().getTrackElementByTrack_(this.track_);
        s && s.removeEventListener("load", this.updateHandler_), this.track_.removeEventListener("cuechange", this.selectCurrentItem_), this.track_ = null;
      }
      if (this.track_ = n, this.track_) {
        this.track_.mode = "hidden";
        var o = this.player_.remoteTextTrackEls().getTrackElementByTrack_(this.track_);
        o && o.addEventListener("load", this.updateHandler_), this.track_.addEventListener("cuechange", this.selectCurrentItem_);
      }
    }
  }, t.findChaptersTrack = function() {
    for (var n = this.player_.textTracks() || [], s = n.length - 1; s >= 0; s--) {
      var o = n[s];
      if (o.kind === this.kind_)
        return o;
    }
  }, t.getMenuCaption = function() {
    return this.track_ && this.track_.label ? this.track_.label : this.localize(toTitleCase$1(this.kind_));
  }, t.createMenu = function() {
    return this.options_.title = this.getMenuCaption(), r.prototype.createMenu.call(this);
  }, t.createItems = function() {
    var n = [];
    if (!this.track_)
      return n;
    var s = this.track_.cues;
    if (!s)
      return n;
    for (var o = 0, u = s.length; o < u; o++) {
      var l = s[o], f = new ChaptersTrackMenuItem(this.player_, {
        track: this.track_,
        cue: l
      });
      n.push(f);
    }
    return n;
  }, e;
}(TextTrackButton);
ChaptersButton.prototype.kind_ = "chapters";
ChaptersButton.prototype.controlText_ = "Chapters";
Component$1.registerComponent("ChaptersButton", ChaptersButton);
var DescriptionsButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    var o;
    o = r.call(this, a, n, s) || this;
    var u = a.textTracks(), l = bind(_assertThisInitialized$1(o), o.handleTracksChange);
    return u.addEventListener("change", l), o.on("dispose", function() {
      u.removeEventListener("change", l);
    }), o;
  }
  var t = e.prototype;
  return t.handleTracksChange = function(n) {
    for (var s = this.player().textTracks(), o = !1, u = 0, l = s.length; u < l; u++) {
      var f = s[u];
      if (f.kind !== this.kind_ && f.mode === "showing") {
        o = !0;
        break;
      }
    }
    o ? this.disable() : this.enable();
  }, t.buildCSSClass = function() {
    return "vjs-descriptions-button " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-descriptions-button " + r.prototype.buildWrapperCSSClass.call(this);
  }, e;
}(TextTrackButton);
DescriptionsButton.prototype.kind_ = "descriptions";
DescriptionsButton.prototype.controlText_ = "Descriptions";
Component$1.registerComponent("DescriptionsButton", DescriptionsButton);
var SubtitlesButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    return r.call(this, a, n, s) || this;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-subtitles-button " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-subtitles-button " + r.prototype.buildWrapperCSSClass.call(this);
  }, e;
}(TextTrackButton);
SubtitlesButton.prototype.kind_ = "subtitles";
SubtitlesButton.prototype.controlText_ = "Subtitles";
Component$1.registerComponent("SubtitlesButton", SubtitlesButton);
var CaptionSettingsMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n.track = {
      player: a,
      kind: n.kind,
      label: n.kind + " settings",
      selectable: !1,
      default: !1,
      mode: "disabled"
    }, n.selectable = !1, n.name = "CaptionSettingsMenuItem", s = r.call(this, a, n) || this, s.addClass("vjs-texttrack-settings"), s.controlText(", opens " + n.kind + " settings dialog"), s;
  }
  var t = e.prototype;
  return t.handleClick = function(n) {
    this.player().getChild("textTrackSettings").open();
  }, e;
}(TextTrackMenuItem);
Component$1.registerComponent("CaptionSettingsMenuItem", CaptionSettingsMenuItem);
var CaptionsButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    return r.call(this, a, n, s) || this;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-captions-button " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-captions-button " + r.prototype.buildWrapperCSSClass.call(this);
  }, t.createItems = function() {
    var n = [];
    return !(this.player().tech_ && this.player().tech_.featuresNativeTextTracks) && this.player().getChild("textTrackSettings") && (n.push(new CaptionSettingsMenuItem(this.player_, {
      kind: this.kind_
    })), this.hideThreshold_ += 1), r.prototype.createItems.call(this, n);
  }, e;
}(TextTrackButton);
CaptionsButton.prototype.kind_ = "captions";
CaptionsButton.prototype.controlText_ = "Captions";
Component$1.registerComponent("CaptionsButton", CaptionsButton);
var SubsCapsMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.createEl = function(n, s, o) {
    var u = r.prototype.createEl.call(this, n, s, o), l = u.querySelector(".vjs-menu-item-text");
    return this.options_.track.kind === "captions" && (l.appendChild(createEl("span", {
      className: "vjs-icon-placeholder"
    }, {
      "aria-hidden": !0
    })), l.appendChild(createEl("span", {
      className: "vjs-control-text",
      textContent: " " + this.localize("Captions")
    }))), u;
  }, e;
}(TextTrackMenuItem);
Component$1.registerComponent("SubsCapsMenuItem", SubsCapsMenuItem);
var SubsCapsButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n === void 0 && (n = {}), s = r.call(this, a, n) || this, s.label_ = "subtitles", ["en", "en-us", "en-ca", "fr-ca"].indexOf(s.player_.language_) > -1 && (s.label_ = "captions"), s.menuButton_.controlText(toTitleCase$1(s.label_)), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-subs-caps-button " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-subs-caps-button " + r.prototype.buildWrapperCSSClass.call(this);
  }, t.createItems = function() {
    var n = [];
    return !(this.player().tech_ && this.player().tech_.featuresNativeTextTracks) && this.player().getChild("textTrackSettings") && (n.push(new CaptionSettingsMenuItem(this.player_, {
      kind: this.label_
    })), this.hideThreshold_ += 1), n = r.prototype.createItems.call(this, n, SubsCapsMenuItem), n;
  }, e;
}(TextTrackButton);
SubsCapsButton.prototype.kinds_ = ["captions", "subtitles"];
SubsCapsButton.prototype.controlText_ = "Subtitles";
Component$1.registerComponent("SubsCapsButton", SubsCapsButton);
var AudioTrackMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s, o = n.track, u = a.audioTracks();
    n.label = o.label || o.language || "Unknown", n.selected = o.enabled, s = r.call(this, a, n) || this, s.track = o, s.addClass("vjs-" + o.kind + "-menu-item");
    var l = function() {
      for (var d = arguments.length, h = new Array(d), p = 0; p < d; p++)
        h[p] = arguments[p];
      s.handleTracksChange.apply(_assertThisInitialized$1(s), h);
    };
    return u.addEventListener("change", l), s.on("dispose", function() {
      u.removeEventListener("change", l);
    }), s;
  }
  var t = e.prototype;
  return t.createEl = function(n, s, o) {
    var u = r.prototype.createEl.call(this, n, s, o), l = u.querySelector(".vjs-menu-item-text");
    return this.options_.track.kind === "main-desc" && (l.appendChild(createEl("span", {
      className: "vjs-icon-placeholder"
    }, {
      "aria-hidden": !0
    })), l.appendChild(createEl("span", {
      className: "vjs-control-text",
      textContent: " " + this.localize("Descriptions")
    }))), u;
  }, t.handleClick = function(n) {
    if (r.prototype.handleClick.call(this, n), this.track.enabled = !0, this.player_.tech_.featuresNativeAudioTracks)
      for (var s = this.player_.audioTracks(), o = 0; o < s.length; o++) {
        var u = s[o];
        u !== this.track && (u.enabled = u === this.track);
      }
  }, t.handleTracksChange = function(n) {
    this.selected(this.track.enabled);
  }, e;
}(MenuItem);
Component$1.registerComponent("AudioTrackMenuItem", AudioTrackMenuItem);
var AudioTrackButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    return n === void 0 && (n = {}), n.tracks = a.audioTracks(), r.call(this, a, n) || this;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-audio-button " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-audio-button " + r.prototype.buildWrapperCSSClass.call(this);
  }, t.createItems = function(n) {
    n === void 0 && (n = []), this.hideThreshold_ = 1;
    for (var s = this.player_.audioTracks(), o = 0; o < s.length; o++) {
      var u = s[o];
      n.push(new AudioTrackMenuItem(this.player_, {
        track: u,
        selectable: !0,
        multiSelectable: !1
      }));
    }
    return n;
  }, e;
}(TrackButton);
AudioTrackButton.prototype.controlText_ = "Audio Track";
Component$1.registerComponent("AudioTrackButton", AudioTrackButton);
var PlaybackRateMenuItem = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s, o = n.rate, u = parseFloat(o, 10);
    return n.label = o, n.selected = u === a.playbackRate(), n.selectable = !0, n.multiSelectable = !1, s = r.call(this, a, n) || this, s.label = o, s.rate = u, s.on(a, "ratechange", function(l) {
      return s.update(l);
    }), s;
  }
  var t = e.prototype;
  return t.handleClick = function(n) {
    r.prototype.handleClick.call(this), this.player().playbackRate(this.rate);
  }, t.update = function(n) {
    this.selected(this.player().playbackRate() === this.rate);
  }, e;
}(MenuItem);
PlaybackRateMenuItem.prototype.contentElType = "button";
Component$1.registerComponent("PlaybackRateMenuItem", PlaybackRateMenuItem);
var PlaybackRateMenuButton = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.menuButton_.el_.setAttribute("aria-describedby", s.labelElId_), s.updateVisibility(), s.updateLabel(), s.on(a, "loadstart", function(o) {
      return s.updateVisibility(o);
    }), s.on(a, "ratechange", function(o) {
      return s.updateLabel(o);
    }), s.on(a, "playbackrateschange", function(o) {
      return s.handlePlaybackRateschange(o);
    }), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    var n = r.prototype.createEl.call(this);
    return this.labelElId_ = "vjs-playback-rate-value-label-" + this.id_, this.labelEl_ = createEl("div", {
      className: "vjs-playback-rate-value",
      id: this.labelElId_,
      textContent: "1x"
    }), n.appendChild(this.labelEl_), n;
  }, t.dispose = function() {
    this.labelEl_ = null, r.prototype.dispose.call(this);
  }, t.buildCSSClass = function() {
    return "vjs-playback-rate " + r.prototype.buildCSSClass.call(this);
  }, t.buildWrapperCSSClass = function() {
    return "vjs-playback-rate " + r.prototype.buildWrapperCSSClass.call(this);
  }, t.createItems = function() {
    for (var n = this.playbackRates(), s = [], o = n.length - 1; o >= 0; o--)
      s.push(new PlaybackRateMenuItem(this.player(), {
        rate: n[o] + "x"
      }));
    return s;
  }, t.updateARIAAttributes = function() {
    this.el().setAttribute("aria-valuenow", this.player().playbackRate());
  }, t.handleClick = function(n) {
    var s = this.player().playbackRate(), o = this.playbackRates(), u = o.indexOf(s), l = (u + 1) % o.length;
    this.player().playbackRate(o[l]);
  }, t.handlePlaybackRateschange = function(n) {
    this.update();
  }, t.playbackRates = function() {
    var n = this.player();
    return n.playbackRates && n.playbackRates() || [];
  }, t.playbackRateSupported = function() {
    return this.player().tech_ && this.player().tech_.featuresPlaybackRate && this.playbackRates() && this.playbackRates().length > 0;
  }, t.updateVisibility = function(n) {
    this.playbackRateSupported() ? this.removeClass("vjs-hidden") : this.addClass("vjs-hidden");
  }, t.updateLabel = function(n) {
    this.playbackRateSupported() && (this.labelEl_.textContent = this.player().playbackRate() + "x");
  }, e;
}(MenuButton);
PlaybackRateMenuButton.prototype.controlText_ = "Playback Rate";
Component$1.registerComponent("PlaybackRateMenuButton", PlaybackRateMenuButton);
var Spacer = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-spacer " + r.prototype.buildCSSClass.call(this);
  }, t.createEl = function(n, s, o) {
    return n === void 0 && (n = "div"), s === void 0 && (s = {}), o === void 0 && (o = {}), s.className || (s.className = this.buildCSSClass()), r.prototype.createEl.call(this, n, s, o);
  }, e;
}(Component$1);
Component$1.registerComponent("Spacer", Spacer);
var CustomControlSpacer = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-custom-control-spacer " + r.prototype.buildCSSClass.call(this);
  }, t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: this.buildCSSClass(),
      textContent: "\xA0"
    });
  }, e;
}(Spacer);
Component$1.registerComponent("CustomControlSpacer", CustomControlSpacer);
var ControlBar = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    return r.apply(this, arguments) || this;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "div", {
      className: "vjs-control-bar",
      dir: "ltr"
    });
  }, e;
}(Component$1);
ControlBar.prototype.options_ = {
  children: ["playToggle", "volumePanel", "currentTimeDisplay", "timeDivider", "durationDisplay", "progressControl", "liveDisplay", "seekToLive", "remainingTimeDisplay", "customControlSpacer", "playbackRateMenuButton", "chaptersButton", "descriptionsButton", "subsCapsButton", "audioTrackButton", "fullscreenToggle"]
};
"exitPictureInPicture" in document_1 && ControlBar.prototype.options_.children.splice(ControlBar.prototype.options_.children.length - 1, 0, "pictureInPictureToggle");
Component$1.registerComponent("ControlBar", ControlBar);
var ErrorDisplay = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return s = r.call(this, a, n) || this, s.on(a, "error", function(o) {
      return s.open(o);
    }), s;
  }
  var t = e.prototype;
  return t.buildCSSClass = function() {
    return "vjs-error-display " + r.prototype.buildCSSClass.call(this);
  }, t.content = function() {
    var n = this.player().error();
    return n ? this.localize(n.message) : "";
  }, e;
}(ModalDialog);
ErrorDisplay.prototype.options_ = _extends$2({}, ModalDialog.prototype.options_, {
  pauseOnOpen: !1,
  fillAlways: !0,
  temporary: !1,
  uncloseable: !0
});
Component$1.registerComponent("ErrorDisplay", ErrorDisplay);
var LOCAL_STORAGE_KEY$1 = "vjs-text-track-settings", COLOR_BLACK = ["#000", "Black"], COLOR_BLUE = ["#00F", "Blue"], COLOR_CYAN = ["#0FF", "Cyan"], COLOR_GREEN = ["#0F0", "Green"], COLOR_MAGENTA = ["#F0F", "Magenta"], COLOR_RED = ["#F00", "Red"], COLOR_WHITE = ["#FFF", "White"], COLOR_YELLOW = ["#FF0", "Yellow"], OPACITY_OPAQUE = ["1", "Opaque"], OPACITY_SEMI = ["0.5", "Semi-Transparent"], OPACITY_TRANS = ["0", "Transparent"], selectConfigs = {
  backgroundColor: {
    selector: ".vjs-bg-color > select",
    id: "captions-background-color-%s",
    label: "Color",
    options: [COLOR_BLACK, COLOR_WHITE, COLOR_RED, COLOR_GREEN, COLOR_BLUE, COLOR_YELLOW, COLOR_MAGENTA, COLOR_CYAN]
  },
  backgroundOpacity: {
    selector: ".vjs-bg-opacity > select",
    id: "captions-background-opacity-%s",
    label: "Transparency",
    options: [OPACITY_OPAQUE, OPACITY_SEMI, OPACITY_TRANS]
  },
  color: {
    selector: ".vjs-fg-color > select",
    id: "captions-foreground-color-%s",
    label: "Color",
    options: [COLOR_WHITE, COLOR_BLACK, COLOR_RED, COLOR_GREEN, COLOR_BLUE, COLOR_YELLOW, COLOR_MAGENTA, COLOR_CYAN]
  },
  edgeStyle: {
    selector: ".vjs-edge-style > select",
    id: "%s",
    label: "Text Edge Style",
    options: [["none", "None"], ["raised", "Raised"], ["depressed", "Depressed"], ["uniform", "Uniform"], ["dropshadow", "Dropshadow"]]
  },
  fontFamily: {
    selector: ".vjs-font-family > select",
    id: "captions-font-family-%s",
    label: "Font Family",
    options: [["proportionalSansSerif", "Proportional Sans-Serif"], ["monospaceSansSerif", "Monospace Sans-Serif"], ["proportionalSerif", "Proportional Serif"], ["monospaceSerif", "Monospace Serif"], ["casual", "Casual"], ["script", "Script"], ["small-caps", "Small Caps"]]
  },
  fontPercent: {
    selector: ".vjs-font-percent > select",
    id: "captions-font-size-%s",
    label: "Font Size",
    options: [["0.50", "50%"], ["0.75", "75%"], ["1.00", "100%"], ["1.25", "125%"], ["1.50", "150%"], ["1.75", "175%"], ["2.00", "200%"], ["3.00", "300%"], ["4.00", "400%"]],
    default: 2,
    parser: function r(e) {
      return e === "1.00" ? null : Number(e);
    }
  },
  textOpacity: {
    selector: ".vjs-text-opacity > select",
    id: "captions-foreground-opacity-%s",
    label: "Transparency",
    options: [OPACITY_OPAQUE, OPACITY_SEMI]
  },
  windowColor: {
    selector: ".vjs-window-color > select",
    id: "captions-window-color-%s",
    label: "Color"
  },
  windowOpacity: {
    selector: ".vjs-window-opacity > select",
    id: "captions-window-opacity-%s",
    label: "Transparency",
    options: [OPACITY_TRANS, OPACITY_SEMI, OPACITY_OPAQUE]
  }
};
selectConfigs.windowColor.options = selectConfigs.backgroundColor.options;
function parseOptionValue(r, e) {
  if (e && (r = e(r)), r && r !== "none")
    return r;
}
function getSelectedOptionValue(r, e) {
  var t = r.options[r.options.selectedIndex].value;
  return parseOptionValue(t, e);
}
function setSelectedOption(r, e, t) {
  if (!!e) {
    for (var a = 0; a < r.options.length; a++)
      if (parseOptionValue(r.options[a].value, t) === e) {
        r.selectedIndex = a;
        break;
      }
  }
}
var TextTrackSettings = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n.temporary = !1, s = r.call(this, a, n) || this, s.updateDisplay = s.updateDisplay.bind(_assertThisInitialized$1(s)), s.fill(), s.hasBeenOpened_ = s.hasBeenFilled_ = !0, s.endDialog = createEl("p", {
      className: "vjs-control-text",
      textContent: s.localize("End of dialog window.")
    }), s.el().appendChild(s.endDialog), s.setDefaults(), n.persistTextTrackSettings === void 0 && (s.options_.persistTextTrackSettings = s.options_.playerOptions.persistTextTrackSettings), s.on(s.$(".vjs-done-button"), "click", function() {
      s.saveSettings(), s.close();
    }), s.on(s.$(".vjs-default-button"), "click", function() {
      s.setDefaults(), s.updateDisplay();
    }), each(selectConfigs, function(o) {
      s.on(s.$(o.selector), "change", s.updateDisplay);
    }), s.options_.persistTextTrackSettings && s.restoreSettings(), s;
  }
  var t = e.prototype;
  return t.dispose = function() {
    this.endDialog = null, r.prototype.dispose.call(this);
  }, t.createElSelect_ = function(n, s, o) {
    var u = this;
    s === void 0 && (s = ""), o === void 0 && (o = "label");
    var l = selectConfigs[n], f = l.id.replace("%s", this.id_), d = [s, f].join(" ").trim();
    return ["<" + o + ' id="' + f + '" class="' + (o === "label" ? "vjs-label" : "") + '">', this.localize(l.label), "</" + o + ">", '<select aria-labelledby="' + d + '">'].concat(l.options.map(function(h) {
      var p = f + "-" + h[1].replace(/\W+/g, "");
      return ['<option id="' + p + '" value="' + h[0] + '" ', 'aria-labelledby="' + d + " " + p + '">', u.localize(h[1]), "</option>"].join("");
    })).concat("</select>").join("");
  }, t.createElFgColor_ = function() {
    var n = "captions-text-legend-" + this.id_;
    return ['<fieldset class="vjs-fg-color vjs-track-setting">', '<legend id="' + n + '">', this.localize("Text"), "</legend>", this.createElSelect_("color", n), '<span class="vjs-text-opacity vjs-opacity">', this.createElSelect_("textOpacity", n), "</span>", "</fieldset>"].join("");
  }, t.createElBgColor_ = function() {
    var n = "captions-background-" + this.id_;
    return ['<fieldset class="vjs-bg-color vjs-track-setting">', '<legend id="' + n + '">', this.localize("Background"), "</legend>", this.createElSelect_("backgroundColor", n), '<span class="vjs-bg-opacity vjs-opacity">', this.createElSelect_("backgroundOpacity", n), "</span>", "</fieldset>"].join("");
  }, t.createElWinColor_ = function() {
    var n = "captions-window-" + this.id_;
    return ['<fieldset class="vjs-window-color vjs-track-setting">', '<legend id="' + n + '">', this.localize("Window"), "</legend>", this.createElSelect_("windowColor", n), '<span class="vjs-window-opacity vjs-opacity">', this.createElSelect_("windowOpacity", n), "</span>", "</fieldset>"].join("");
  }, t.createElColors_ = function() {
    return createEl("div", {
      className: "vjs-track-settings-colors",
      innerHTML: [this.createElFgColor_(), this.createElBgColor_(), this.createElWinColor_()].join("")
    });
  }, t.createElFont_ = function() {
    return createEl("div", {
      className: "vjs-track-settings-font",
      innerHTML: ['<fieldset class="vjs-font-percent vjs-track-setting">', this.createElSelect_("fontPercent", "", "legend"), "</fieldset>", '<fieldset class="vjs-edge-style vjs-track-setting">', this.createElSelect_("edgeStyle", "", "legend"), "</fieldset>", '<fieldset class="vjs-font-family vjs-track-setting">', this.createElSelect_("fontFamily", "", "legend"), "</fieldset>"].join("")
    });
  }, t.createElControls_ = function() {
    var n = this.localize("restore all settings to the default values");
    return createEl("div", {
      className: "vjs-track-settings-controls",
      innerHTML: ['<button type="button" class="vjs-default-button" title="' + n + '">', this.localize("Reset"), '<span class="vjs-control-text"> ' + n + "</span>", "</button>", '<button type="button" class="vjs-done-button">' + this.localize("Done") + "</button>"].join("")
    });
  }, t.content = function() {
    return [this.createElColors_(), this.createElFont_(), this.createElControls_()];
  }, t.label = function() {
    return this.localize("Caption Settings Dialog");
  }, t.description = function() {
    return this.localize("Beginning of dialog window. Escape will cancel and close the window.");
  }, t.buildCSSClass = function() {
    return r.prototype.buildCSSClass.call(this) + " vjs-text-track-settings";
  }, t.getValues = function() {
    var n = this;
    return reduce(selectConfigs, function(s, o, u) {
      var l = getSelectedOptionValue(n.$(o.selector), o.parser);
      return l !== void 0 && (s[u] = l), s;
    }, {});
  }, t.setValues = function(n) {
    var s = this;
    each(selectConfigs, function(o, u) {
      setSelectedOption(s.$(o.selector), n[u], o.parser);
    });
  }, t.setDefaults = function() {
    var n = this;
    each(selectConfigs, function(s) {
      var o = s.hasOwnProperty("default") ? s.default : 0;
      n.$(s.selector).selectedIndex = o;
    });
  }, t.restoreSettings = function() {
    var n;
    try {
      n = JSON.parse(window_1.localStorage.getItem(LOCAL_STORAGE_KEY$1));
    } catch (s) {
      log$1.warn(s);
    }
    n && this.setValues(n);
  }, t.saveSettings = function() {
    if (!!this.options_.persistTextTrackSettings) {
      var n = this.getValues();
      try {
        Object.keys(n).length ? window_1.localStorage.setItem(LOCAL_STORAGE_KEY$1, JSON.stringify(n)) : window_1.localStorage.removeItem(LOCAL_STORAGE_KEY$1);
      } catch (s) {
        log$1.warn(s);
      }
    }
  }, t.updateDisplay = function() {
    var n = this.player_.getChild("textTrackDisplay");
    n && n.updateDisplay();
  }, t.conditionalBlur_ = function() {
    this.previouslyActiveEl_ = null;
    var n = this.player_.controlBar, s = n && n.subsCapsButton, o = n && n.captionsButton;
    s ? s.focus() : o && o.focus();
  }, e;
}(ModalDialog);
Component$1.registerComponent("TextTrackSettings", TextTrackSettings);
var ResizeManager = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s, o = n.ResizeObserver || window_1.ResizeObserver;
    n.ResizeObserver === null && (o = !1);
    var u = mergeOptions$3({
      createEl: !o,
      reportTouchActivity: !1
    }, n);
    return s = r.call(this, a, u) || this, s.ResizeObserver = n.ResizeObserver || window_1.ResizeObserver, s.loadListener_ = null, s.resizeObserver_ = null, s.debouncedHandler_ = debounce(function() {
      s.resizeHandler();
    }, 100, !1, _assertThisInitialized$1(s)), o ? (s.resizeObserver_ = new s.ResizeObserver(s.debouncedHandler_), s.resizeObserver_.observe(a.el())) : (s.loadListener_ = function() {
      if (!(!s.el_ || !s.el_.contentWindow)) {
        var l = s.debouncedHandler_, f = s.unloadListener_ = function() {
          off(this, "resize", l), off(this, "unload", f), f = null;
        };
        on(s.el_.contentWindow, "unload", f), on(s.el_.contentWindow, "resize", l);
      }
    }, s.one("load", s.loadListener_)), s;
  }
  var t = e.prototype;
  return t.createEl = function() {
    return r.prototype.createEl.call(this, "iframe", {
      className: "vjs-resize-manager",
      tabIndex: -1,
      title: this.localize("No content")
    }, {
      "aria-hidden": "true"
    });
  }, t.resizeHandler = function() {
    !this.player_ || !this.player_.trigger || this.player_.trigger("playerresize");
  }, t.dispose = function() {
    this.debouncedHandler_ && this.debouncedHandler_.cancel(), this.resizeObserver_ && (this.player_.el() && this.resizeObserver_.unobserve(this.player_.el()), this.resizeObserver_.disconnect()), this.loadListener_ && this.off("load", this.loadListener_), this.el_ && this.el_.contentWindow && this.unloadListener_ && this.unloadListener_.call(this.el_.contentWindow), this.ResizeObserver = null, this.resizeObserver = null, this.debouncedHandler_ = null, this.loadListener_ = null, r.prototype.dispose.call(this);
  }, e;
}(Component$1);
Component$1.registerComponent("ResizeManager", ResizeManager);
var defaults = {
  trackingThreshold: 20,
  liveTolerance: 15
}, LiveTracker = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s, o = mergeOptions$3(defaults, n, {
      createEl: !1
    });
    return s = r.call(this, a, o) || this, s.handleVisibilityChange_ = function(u) {
      return s.handleVisibilityChange(u);
    }, s.trackLiveHandler_ = function() {
      return s.trackLive_();
    }, s.handlePlay_ = function(u) {
      return s.handlePlay(u);
    }, s.handleFirstTimeupdate_ = function(u) {
      return s.handleFirstTimeupdate(u);
    }, s.handleSeeked_ = function(u) {
      return s.handleSeeked(u);
    }, s.seekToLiveEdge_ = function(u) {
      return s.seekToLiveEdge(u);
    }, s.reset_(), s.on(s.player_, "durationchange", function(u) {
      return s.handleDurationchange(u);
    }), s.on(s.player_, "canplay", function() {
      return s.toggleTracking();
    }), IE_VERSION && "hidden" in document_1 && "visibilityState" in document_1 && s.on(document_1, "visibilitychange", s.handleVisibilityChange_), s;
  }
  var t = e.prototype;
  return t.handleVisibilityChange = function() {
    this.player_.duration() === 1 / 0 && (document_1.hidden ? this.stopTracking() : this.startTracking());
  }, t.trackLive_ = function() {
    var n = this.player_.seekable();
    if (!(!n || !n.length)) {
      var s = Number(window_1.performance.now().toFixed(4)), o = this.lastTime_ === -1 ? 0 : (s - this.lastTime_) / 1e3;
      this.lastTime_ = s, this.pastSeekEnd_ = this.pastSeekEnd() + o;
      var u = this.liveCurrentTime(), l = this.player_.currentTime(), f = this.player_.paused() || this.seekedBehindLive_ || Math.abs(u - l) > this.options_.liveTolerance;
      (!this.timeupdateSeen_ || u === 1 / 0) && (f = !1), f !== this.behindLiveEdge_ && (this.behindLiveEdge_ = f, this.trigger("liveedgechange"));
    }
  }, t.handleDurationchange = function() {
    this.toggleTracking();
  }, t.toggleTracking = function() {
    this.player_.duration() === 1 / 0 && this.liveWindow() >= this.options_.trackingThreshold ? (this.player_.options_.liveui && this.player_.addClass("vjs-liveui"), this.startTracking()) : (this.player_.removeClass("vjs-liveui"), this.stopTracking());
  }, t.startTracking = function() {
    this.isTracking() || (this.timeupdateSeen_ || (this.timeupdateSeen_ = this.player_.hasStarted()), this.trackingInterval_ = this.setInterval(this.trackLiveHandler_, UPDATE_REFRESH_INTERVAL), this.trackLive_(), this.on(this.player_, ["play", "pause"], this.trackLiveHandler_), this.timeupdateSeen_ ? this.on(this.player_, "seeked", this.handleSeeked_) : (this.one(this.player_, "play", this.handlePlay_), this.one(this.player_, "timeupdate", this.handleFirstTimeupdate_)));
  }, t.handleFirstTimeupdate = function() {
    this.timeupdateSeen_ = !0, this.on(this.player_, "seeked", this.handleSeeked_);
  }, t.handleSeeked = function() {
    var n = Math.abs(this.liveCurrentTime() - this.player_.currentTime());
    this.seekedBehindLive_ = this.nextSeekedFromUser_ && n > 2, this.nextSeekedFromUser_ = !1, this.trackLive_();
  }, t.handlePlay = function() {
    this.one(this.player_, "timeupdate", this.seekToLiveEdge_);
  }, t.reset_ = function() {
    this.lastTime_ = -1, this.pastSeekEnd_ = 0, this.lastSeekEnd_ = -1, this.behindLiveEdge_ = !0, this.timeupdateSeen_ = !1, this.seekedBehindLive_ = !1, this.nextSeekedFromUser_ = !1, this.clearInterval(this.trackingInterval_), this.trackingInterval_ = null, this.off(this.player_, ["play", "pause"], this.trackLiveHandler_), this.off(this.player_, "seeked", this.handleSeeked_), this.off(this.player_, "play", this.handlePlay_), this.off(this.player_, "timeupdate", this.handleFirstTimeupdate_), this.off(this.player_, "timeupdate", this.seekToLiveEdge_);
  }, t.nextSeekedFromUser = function() {
    this.nextSeekedFromUser_ = !0;
  }, t.stopTracking = function() {
    !this.isTracking() || (this.reset_(), this.trigger("liveedgechange"));
  }, t.seekableEnd = function() {
    for (var n = this.player_.seekable(), s = [], o = n ? n.length : 0; o--; )
      s.push(n.end(o));
    return s.length ? s.sort()[s.length - 1] : 1 / 0;
  }, t.seekableStart = function() {
    for (var n = this.player_.seekable(), s = [], o = n ? n.length : 0; o--; )
      s.push(n.start(o));
    return s.length ? s.sort()[0] : 0;
  }, t.liveWindow = function() {
    var n = this.liveCurrentTime();
    return n === 1 / 0 ? 0 : n - this.seekableStart();
  }, t.isLive = function() {
    return this.isTracking();
  }, t.atLiveEdge = function() {
    return !this.behindLiveEdge();
  }, t.liveCurrentTime = function() {
    return this.pastSeekEnd() + this.seekableEnd();
  }, t.pastSeekEnd = function() {
    var n = this.seekableEnd();
    return this.lastSeekEnd_ !== -1 && n !== this.lastSeekEnd_ && (this.pastSeekEnd_ = 0), this.lastSeekEnd_ = n, this.pastSeekEnd_;
  }, t.behindLiveEdge = function() {
    return this.behindLiveEdge_;
  }, t.isTracking = function() {
    return typeof this.trackingInterval_ == "number";
  }, t.seekToLiveEdge = function() {
    this.seekedBehindLive_ = !1, !this.atLiveEdge() && (this.nextSeekedFromUser_ = !1, this.player_.currentTime(this.liveCurrentTime()));
  }, t.dispose = function() {
    this.off(document_1, "visibilitychange", this.handleVisibilityChange_), this.stopTracking(), r.prototype.dispose.call(this);
  }, e;
}(Component$1);
Component$1.registerComponent("LiveTracker", LiveTracker);
var sourcesetLoad = function r(e) {
  var t = e.el();
  if (t.hasAttribute("src"))
    return e.triggerSourceset(t.src), !0;
  var a = e.$$("source"), n = [], s = "";
  if (!a.length)
    return !1;
  for (var o = 0; o < a.length; o++) {
    var u = a[o].src;
    u && n.indexOf(u) === -1 && n.push(u);
  }
  return n.length ? (n.length === 1 && (s = n[0]), e.triggerSourceset(s), !0) : !1;
}, innerHTMLDescriptorPolyfill = Object.defineProperty({}, "innerHTML", {
  get: function r() {
    return this.cloneNode(!0).innerHTML;
  },
  set: function r(e) {
    var t = document_1.createElement(this.nodeName.toLowerCase());
    t.innerHTML = e;
    for (var a = document_1.createDocumentFragment(); t.childNodes.length; )
      a.appendChild(t.childNodes[0]);
    return this.innerText = "", window_1.Element.prototype.appendChild.call(this, a), this.innerHTML;
  }
}), getDescriptor = function r(e, t) {
  for (var a = {}, n = 0; n < e.length && (a = Object.getOwnPropertyDescriptor(e[n], t), !(a && a.set && a.get)); n++)
    ;
  return a.enumerable = !0, a.configurable = !0, a;
}, getInnerHTMLDescriptor = function r(e) {
  return getDescriptor([e.el(), window_1.HTMLMediaElement.prototype, window_1.Element.prototype, innerHTMLDescriptorPolyfill], "innerHTML");
}, firstSourceWatch = function r(e) {
  var t = e.el();
  if (!t.resetSourceWatch_) {
    var a = {}, n = getInnerHTMLDescriptor(e), s = function(u) {
      return function() {
        for (var l = arguments.length, f = new Array(l), d = 0; d < l; d++)
          f[d] = arguments[d];
        var h = u.apply(t, f);
        return sourcesetLoad(e), h;
      };
    };
    ["append", "appendChild", "insertAdjacentHTML"].forEach(function(o) {
      !t[o] || (a[o] = t[o], t[o] = s(a[o]));
    }), Object.defineProperty(t, "innerHTML", mergeOptions$3(n, {
      set: s(n.set)
    })), t.resetSourceWatch_ = function() {
      t.resetSourceWatch_ = null, Object.keys(a).forEach(function(o) {
        t[o] = a[o];
      }), Object.defineProperty(t, "innerHTML", n);
    }, e.one("sourceset", t.resetSourceWatch_);
  }
}, srcDescriptorPolyfill = Object.defineProperty({}, "src", {
  get: function r() {
    return this.hasAttribute("src") ? getAbsoluteURL(window_1.Element.prototype.getAttribute.call(this, "src")) : "";
  },
  set: function r(e) {
    return window_1.Element.prototype.setAttribute.call(this, "src", e), e;
  }
}), getSrcDescriptor = function r(e) {
  return getDescriptor([e.el(), window_1.HTMLMediaElement.prototype, srcDescriptorPolyfill], "src");
}, setupSourceset = function r(e) {
  if (!!e.featuresSourceset) {
    var t = e.el();
    if (!t.resetSourceset_) {
      var a = getSrcDescriptor(e), n = t.setAttribute, s = t.load;
      Object.defineProperty(t, "src", mergeOptions$3(a, {
        set: function(u) {
          var l = a.set.call(t, u);
          return e.triggerSourceset(t.src), l;
        }
      })), t.setAttribute = function(o, u) {
        var l = n.call(t, o, u);
        return /src/i.test(o) && e.triggerSourceset(t.src), l;
      }, t.load = function() {
        var o = s.call(t);
        return sourcesetLoad(e) || (e.triggerSourceset(""), firstSourceWatch(e)), o;
      }, t.currentSrc ? e.triggerSourceset(t.currentSrc) : sourcesetLoad(e) || firstSourceWatch(e), t.resetSourceset_ = function() {
        t.resetSourceset_ = null, t.load = s, t.setAttribute = n, Object.defineProperty(t, "src", a), t.resetSourceWatch_ && t.resetSourceWatch_();
      };
    }
  }
}, defineLazyProperty = function r(e, t, a, n) {
  n === void 0 && (n = !0);
  var s = function(l) {
    return Object.defineProperty(e, t, {
      value: l,
      enumerable: !0,
      writable: !0
    });
  }, o = {
    configurable: !0,
    enumerable: !0,
    get: function() {
      var l = a();
      return s(l), l;
    }
  };
  return n && (o.set = s), Object.defineProperty(e, t, o);
}, Html5 = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    s = r.call(this, a, n) || this;
    var o = a.source, u = !1;
    if (s.featuresVideoFrameCallback = s.featuresVideoFrameCallback && s.el_.tagName === "VIDEO", o && (s.el_.currentSrc !== o.src || a.tag && a.tag.initNetworkState_ === 3) ? s.setSource(o) : s.handleLateInit_(s.el_), a.enableSourceset && s.setupSourcesetHandling_(), s.isScrubbing_ = !1, s.el_.hasChildNodes()) {
      for (var l = s.el_.childNodes, f = l.length, d = []; f--; ) {
        var h = l[f], p = h.nodeName.toLowerCase();
        p === "track" && (s.featuresNativeTextTracks ? (s.remoteTextTrackEls().addTrackElement_(h), s.remoteTextTracks().addTrack(h.track), s.textTracks().addTrack(h.track), !u && !s.el_.hasAttribute("crossorigin") && isCrossOrigin(h.src) && (u = !0)) : d.push(h));
      }
      for (var m = 0; m < d.length; m++)
        s.el_.removeChild(d[m]);
    }
    return s.proxyNativeTracks_(), s.featuresNativeTextTracks && u && log$1.warn(`Text Tracks are being loaded from another origin but the crossorigin attribute isn't used.
This may prevent text tracks from loading.`), s.restoreMetadataTracksInIOSNativePlayer_(), (TOUCH_ENABLED || IS_IPHONE || IS_NATIVE_ANDROID) && a.nativeControlsForTouch === !0 && s.setControls(!0), s.proxyWebkitFullscreen_(), s.triggerReady(), s;
  }
  var t = e.prototype;
  return t.dispose = function() {
    this.el_ && this.el_.resetSourceset_ && this.el_.resetSourceset_(), e.disposeMediaElement(this.el_), this.options_ = null, r.prototype.dispose.call(this);
  }, t.setupSourcesetHandling_ = function() {
    setupSourceset(this);
  }, t.restoreMetadataTracksInIOSNativePlayer_ = function() {
    var n = this.textTracks(), s, o = function() {
      s = [];
      for (var f = 0; f < n.length; f++) {
        var d = n[f];
        d.kind === "metadata" && s.push({
          track: d,
          storedMode: d.mode
        });
      }
    };
    o(), n.addEventListener("change", o), this.on("dispose", function() {
      return n.removeEventListener("change", o);
    });
    var u = function l() {
      for (var f = 0; f < s.length; f++) {
        var d = s[f];
        d.track.mode === "disabled" && d.track.mode !== d.storedMode && (d.track.mode = d.storedMode);
      }
      n.removeEventListener("change", l);
    };
    this.on("webkitbeginfullscreen", function() {
      n.removeEventListener("change", o), n.removeEventListener("change", u), n.addEventListener("change", u);
    }), this.on("webkitendfullscreen", function() {
      n.removeEventListener("change", o), n.addEventListener("change", o), n.removeEventListener("change", u);
    });
  }, t.overrideNative_ = function(n, s) {
    var o = this;
    if (s === this["featuresNative" + n + "Tracks"]) {
      var u = n.toLowerCase();
      this[u + "TracksListeners_"] && Object.keys(this[u + "TracksListeners_"]).forEach(function(l) {
        var f = o.el()[u + "Tracks"];
        f.removeEventListener(l, o[u + "TracksListeners_"][l]);
      }), this["featuresNative" + n + "Tracks"] = !s, this[u + "TracksListeners_"] = null, this.proxyNativeTracksForType_(u);
    }
  }, t.overrideNativeAudioTracks = function(n) {
    this.overrideNative_("Audio", n);
  }, t.overrideNativeVideoTracks = function(n) {
    this.overrideNative_("Video", n);
  }, t.proxyNativeTracksForType_ = function(n) {
    var s = this, o = NORMAL[n], u = this.el()[o.getterName], l = this[o.getterName]();
    if (!(!this["featuresNative" + o.capitalName + "Tracks"] || !u || !u.addEventListener)) {
      var f = {
        change: function(p) {
          var m = {
            type: "change",
            target: l,
            currentTarget: l,
            srcElement: l
          };
          l.trigger(m), n === "text" && s[REMOTE.remoteText.getterName]().trigger(m);
        },
        addtrack: function(p) {
          l.addTrack(p.track);
        },
        removetrack: function(p) {
          l.removeTrack(p.track);
        }
      }, d = function() {
        for (var p = [], m = 0; m < l.length; m++) {
          for (var _ = !1, w = 0; w < u.length; w++)
            if (u[w] === l[m]) {
              _ = !0;
              break;
            }
          _ || p.push(l[m]);
        }
        for (; p.length; )
          l.removeTrack(p.shift());
      };
      this[o.getterName + "Listeners_"] = f, Object.keys(f).forEach(function(h) {
        var p = f[h];
        u.addEventListener(h, p), s.on("dispose", function(m) {
          return u.removeEventListener(h, p);
        });
      }), this.on("loadstart", d), this.on("dispose", function(h) {
        return s.off("loadstart", d);
      });
    }
  }, t.proxyNativeTracks_ = function() {
    var n = this;
    NORMAL.names.forEach(function(s) {
      n.proxyNativeTracksForType_(s);
    });
  }, t.createEl = function() {
    var n = this.options_.tag;
    if (!n || !(this.options_.playerElIngest || this.movingMediaElementInDOM)) {
      if (n) {
        var s = n.cloneNode(!0);
        n.parentNode && n.parentNode.insertBefore(s, n), e.disposeMediaElement(n), n = s;
      } else {
        n = document_1.createElement("video");
        var o = this.options_.tag && getAttributes(this.options_.tag), u = mergeOptions$3({}, o);
        (!TOUCH_ENABLED || this.options_.nativeControlsForTouch !== !0) && delete u.controls, setAttributes(n, assign(u, {
          id: this.options_.techId,
          class: "vjs-tech"
        }));
      }
      n.playerId = this.options_.playerId;
    }
    typeof this.options_.preload < "u" && setAttribute(n, "preload", this.options_.preload), this.options_.disablePictureInPicture !== void 0 && (n.disablePictureInPicture = this.options_.disablePictureInPicture);
    for (var l = ["loop", "muted", "playsinline", "autoplay"], f = 0; f < l.length; f++) {
      var d = l[f], h = this.options_[d];
      typeof h < "u" && (h ? setAttribute(n, d, d) : removeAttribute(n, d), n[d] = h);
    }
    return n;
  }, t.handleLateInit_ = function(n) {
    if (!(n.networkState === 0 || n.networkState === 3)) {
      if (n.readyState === 0) {
        var s = !1, o = function() {
          s = !0;
        };
        this.on("loadstart", o);
        var u = function() {
          s || this.trigger("loadstart");
        };
        this.on("loadedmetadata", u), this.ready(function() {
          this.off("loadstart", o), this.off("loadedmetadata", u), s || this.trigger("loadstart");
        });
        return;
      }
      var l = ["loadstart"];
      l.push("loadedmetadata"), n.readyState >= 2 && l.push("loadeddata"), n.readyState >= 3 && l.push("canplay"), n.readyState >= 4 && l.push("canplaythrough"), this.ready(function() {
        l.forEach(function(f) {
          this.trigger(f);
        }, this);
      });
    }
  }, t.setScrubbing = function(n) {
    this.isScrubbing_ = n;
  }, t.scrubbing = function() {
    return this.isScrubbing_;
  }, t.setCurrentTime = function(n) {
    try {
      this.isScrubbing_ && this.el_.fastSeek && IS_ANY_SAFARI ? this.el_.fastSeek(n) : this.el_.currentTime = n;
    } catch (s) {
      log$1(s, "Video is not ready. (Video.js)");
    }
  }, t.duration = function() {
    var n = this;
    if (this.el_.duration === 1 / 0 && IS_ANDROID && IS_CHROME && this.el_.currentTime === 0) {
      var s = function o() {
        n.el_.currentTime > 0 && (n.el_.duration === 1 / 0 && n.trigger("durationchange"), n.off("timeupdate", o));
      };
      return this.on("timeupdate", s), NaN;
    }
    return this.el_.duration || NaN;
  }, t.width = function() {
    return this.el_.offsetWidth;
  }, t.height = function() {
    return this.el_.offsetHeight;
  }, t.proxyWebkitFullscreen_ = function() {
    var n = this;
    if ("webkitDisplayingFullscreen" in this.el_) {
      var s = function() {
        this.trigger("fullscreenchange", {
          isFullscreen: !1
        }), this.el_.controls && !this.options_.nativeControlsForTouch && this.controls() && (this.el_.controls = !1);
      }, o = function() {
        "webkitPresentationMode" in this.el_ && this.el_.webkitPresentationMode !== "picture-in-picture" && (this.one("webkitendfullscreen", s), this.trigger("fullscreenchange", {
          isFullscreen: !0,
          nativeIOSFullscreen: !0
        }));
      };
      this.on("webkitbeginfullscreen", o), this.on("dispose", function() {
        n.off("webkitbeginfullscreen", o), n.off("webkitendfullscreen", s);
      });
    }
  }, t.supportsFullScreen = function() {
    if (typeof this.el_.webkitEnterFullScreen == "function") {
      var n = window_1.navigator && window_1.navigator.userAgent || "";
      if (/Android/.test(n) || !/Chrome|Mac OS X 10.5/.test(n))
        return !0;
    }
    return !1;
  }, t.enterFullScreen = function() {
    var n = this.el_;
    if (n.paused && n.networkState <= n.HAVE_METADATA)
      silencePromise(this.el_.play()), this.setTimeout(function() {
        n.pause();
        try {
          n.webkitEnterFullScreen();
        } catch (s) {
          this.trigger("fullscreenerror", s);
        }
      }, 0);
    else
      try {
        n.webkitEnterFullScreen();
      } catch (s) {
        this.trigger("fullscreenerror", s);
      }
  }, t.exitFullScreen = function() {
    if (!this.el_.webkitDisplayingFullscreen) {
      this.trigger("fullscreenerror", new Error("The video is not fullscreen"));
      return;
    }
    this.el_.webkitExitFullScreen();
  }, t.requestPictureInPicture = function() {
    return this.el_.requestPictureInPicture();
  }, t.requestVideoFrameCallback = function(n) {
    return this.featuresVideoFrameCallback && !this.el_.webkitKeys ? this.el_.requestVideoFrameCallback(n) : r.prototype.requestVideoFrameCallback.call(this, n);
  }, t.cancelVideoFrameCallback = function(n) {
    this.featuresVideoFrameCallback && !this.el_.webkitKeys ? this.el_.cancelVideoFrameCallback(n) : r.prototype.cancelVideoFrameCallback.call(this, n);
  }, t.src = function(n) {
    if (n === void 0)
      return this.el_.src;
    this.setSrc(n);
  }, t.reset = function() {
    e.resetMediaElement(this.el_);
  }, t.currentSrc = function() {
    return this.currentSource_ ? this.currentSource_.src : this.el_.currentSrc;
  }, t.setControls = function(n) {
    this.el_.controls = !!n;
  }, t.addTextTrack = function(n, s, o) {
    return this.featuresNativeTextTracks ? this.el_.addTextTrack(n, s, o) : r.prototype.addTextTrack.call(this, n, s, o);
  }, t.createRemoteTextTrack = function(n) {
    if (!this.featuresNativeTextTracks)
      return r.prototype.createRemoteTextTrack.call(this, n);
    var s = document_1.createElement("track");
    return n.kind && (s.kind = n.kind), n.label && (s.label = n.label), (n.language || n.srclang) && (s.srclang = n.language || n.srclang), n.default && (s.default = n.default), n.id && (s.id = n.id), n.src && (s.src = n.src), s;
  }, t.addRemoteTextTrack = function(n, s) {
    var o = r.prototype.addRemoteTextTrack.call(this, n, s);
    return this.featuresNativeTextTracks && this.el().appendChild(o), o;
  }, t.removeRemoteTextTrack = function(n) {
    if (r.prototype.removeRemoteTextTrack.call(this, n), this.featuresNativeTextTracks)
      for (var s = this.$$("track"), o = s.length; o--; )
        (n === s[o] || n === s[o].track) && this.el().removeChild(s[o]);
  }, t.getVideoPlaybackQuality = function() {
    if (typeof this.el().getVideoPlaybackQuality == "function")
      return this.el().getVideoPlaybackQuality();
    var n = {};
    return typeof this.el().webkitDroppedFrameCount < "u" && typeof this.el().webkitDecodedFrameCount < "u" && (n.droppedVideoFrames = this.el().webkitDroppedFrameCount, n.totalVideoFrames = this.el().webkitDecodedFrameCount), window_1.performance && typeof window_1.performance.now == "function" ? n.creationTime = window_1.performance.now() : window_1.performance && window_1.performance.timing && typeof window_1.performance.timing.navigationStart == "number" && (n.creationTime = window_1.Date.now() - window_1.performance.timing.navigationStart), n;
  }, e;
}(Tech);
defineLazyProperty(Html5, "TEST_VID", function() {
  if (!!isReal()) {
    var r = document_1.createElement("video"), e = document_1.createElement("track");
    return e.kind = "captions", e.srclang = "en", e.label = "English", r.appendChild(e), r;
  }
});
Html5.isSupported = function() {
  try {
    Html5.TEST_VID.volume = 0.5;
  } catch {
    return !1;
  }
  return !!(Html5.TEST_VID && Html5.TEST_VID.canPlayType);
};
Html5.canPlayType = function(r) {
  return Html5.TEST_VID.canPlayType(r);
};
Html5.canPlaySource = function(r, e) {
  return Html5.canPlayType(r.type);
};
Html5.canControlVolume = function() {
  try {
    var r = Html5.TEST_VID.volume;
    Html5.TEST_VID.volume = r / 2 + 0.1;
    var e = r !== Html5.TEST_VID.volume;
    return e && IS_IOS ? (window_1.setTimeout(function() {
      Html5 && Html5.prototype && (Html5.prototype.featuresVolumeControl = r !== Html5.TEST_VID.volume);
    }), !1) : e;
  } catch {
    return !1;
  }
};
Html5.canMuteVolume = function() {
  try {
    var r = Html5.TEST_VID.muted;
    return Html5.TEST_VID.muted = !r, Html5.TEST_VID.muted ? setAttribute(Html5.TEST_VID, "muted", "muted") : removeAttribute(Html5.TEST_VID, "muted", "muted"), r !== Html5.TEST_VID.muted;
  } catch {
    return !1;
  }
};
Html5.canControlPlaybackRate = function() {
  if (IS_ANDROID && IS_CHROME && CHROME_VERSION < 58)
    return !1;
  try {
    var r = Html5.TEST_VID.playbackRate;
    return Html5.TEST_VID.playbackRate = r / 2 + 0.1, r !== Html5.TEST_VID.playbackRate;
  } catch {
    return !1;
  }
};
Html5.canOverrideAttributes = function() {
  try {
    var r = function() {
    };
    Object.defineProperty(document_1.createElement("video"), "src", {
      get: r,
      set: r
    }), Object.defineProperty(document_1.createElement("audio"), "src", {
      get: r,
      set: r
    }), Object.defineProperty(document_1.createElement("video"), "innerHTML", {
      get: r,
      set: r
    }), Object.defineProperty(document_1.createElement("audio"), "innerHTML", {
      get: r,
      set: r
    });
  } catch {
    return !1;
  }
  return !0;
};
Html5.supportsNativeTextTracks = function() {
  return IS_ANY_SAFARI || IS_IOS && IS_CHROME;
};
Html5.supportsNativeVideoTracks = function() {
  return !!(Html5.TEST_VID && Html5.TEST_VID.videoTracks);
};
Html5.supportsNativeAudioTracks = function() {
  return !!(Html5.TEST_VID && Html5.TEST_VID.audioTracks);
};
Html5.Events = ["loadstart", "suspend", "abort", "error", "emptied", "stalled", "loadedmetadata", "loadeddata", "canplay", "canplaythrough", "playing", "waiting", "seeking", "seeked", "ended", "durationchange", "timeupdate", "progress", "play", "pause", "ratechange", "resize", "volumechange"];
[["featuresMuteControl", "canMuteVolume"], ["featuresPlaybackRate", "canControlPlaybackRate"], ["featuresSourceset", "canOverrideAttributes"], ["featuresNativeTextTracks", "supportsNativeTextTracks"], ["featuresNativeVideoTracks", "supportsNativeVideoTracks"], ["featuresNativeAudioTracks", "supportsNativeAudioTracks"]].forEach(function(r) {
  var e = r[0], t = r[1];
  defineLazyProperty(Html5.prototype, e, function() {
    return Html5[t]();
  }, !0);
});
Html5.prototype.featuresVolumeControl = Html5.canControlVolume();
Html5.prototype.movingMediaElementInDOM = !IS_IOS;
Html5.prototype.featuresFullscreenResize = !0;
Html5.prototype.featuresProgressEvents = !0;
Html5.prototype.featuresTimeupdateEvents = !0;
Html5.prototype.featuresVideoFrameCallback = !!(Html5.TEST_VID && Html5.TEST_VID.requestVideoFrameCallback);
var canPlayType;
Html5.patchCanPlayType = function() {
  ANDROID_VERSION >= 4 && !IS_FIREFOX && !IS_CHROME && (canPlayType = Html5.TEST_VID && Html5.TEST_VID.constructor.prototype.canPlayType, Html5.TEST_VID.constructor.prototype.canPlayType = function(r) {
    var e = /^application\/(?:x-|vnd\.apple\.)mpegurl/i;
    return r && e.test(r) ? "maybe" : canPlayType.call(this, r);
  });
};
Html5.unpatchCanPlayType = function() {
  var r = Html5.TEST_VID.constructor.prototype.canPlayType;
  return canPlayType && (Html5.TEST_VID.constructor.prototype.canPlayType = canPlayType), r;
};
Html5.patchCanPlayType();
Html5.disposeMediaElement = function(r) {
  if (!!r) {
    for (r.parentNode && r.parentNode.removeChild(r); r.hasChildNodes(); )
      r.removeChild(r.firstChild);
    r.removeAttribute("src"), typeof r.load == "function" && function() {
      try {
        r.load();
      } catch {
      }
    }();
  }
};
Html5.resetMediaElement = function(r) {
  if (!!r) {
    for (var e = r.querySelectorAll("source"), t = e.length; t--; )
      r.removeChild(e[t]);
    r.removeAttribute("src"), typeof r.load == "function" && function() {
      try {
        r.load();
      } catch {
      }
    }();
  }
};
[
  "muted",
  "defaultMuted",
  "autoplay",
  "controls",
  "loop",
  "playsinline"
].forEach(function(r) {
  Html5.prototype[r] = function() {
    return this.el_[r] || this.el_.hasAttribute(r);
  };
});
[
  "muted",
  "defaultMuted",
  "autoplay",
  "loop",
  "playsinline"
].forEach(function(r) {
  Html5.prototype["set" + toTitleCase$1(r)] = function(e) {
    this.el_[r] = e, e ? this.el_.setAttribute(r, r) : this.el_.removeAttribute(r);
  };
});
[
  "paused",
  "currentTime",
  "buffered",
  "volume",
  "poster",
  "preload",
  "error",
  "seeking",
  "seekable",
  "ended",
  "playbackRate",
  "defaultPlaybackRate",
  "disablePictureInPicture",
  "played",
  "networkState",
  "readyState",
  "videoWidth",
  "videoHeight",
  "crossOrigin"
].forEach(function(r) {
  Html5.prototype[r] = function() {
    return this.el_[r];
  };
});
[
  "volume",
  "src",
  "poster",
  "preload",
  "playbackRate",
  "defaultPlaybackRate",
  "disablePictureInPicture",
  "crossOrigin"
].forEach(function(r) {
  Html5.prototype["set" + toTitleCase$1(r)] = function(e) {
    this.el_[r] = e;
  };
});
[
  "pause",
  "load",
  "play"
].forEach(function(r) {
  Html5.prototype[r] = function() {
    return this.el_[r]();
  };
});
Tech.withSourceHandlers(Html5);
Html5.nativeSourceHandler = {};
Html5.nativeSourceHandler.canPlayType = function(r) {
  try {
    return Html5.TEST_VID.canPlayType(r);
  } catch {
    return "";
  }
};
Html5.nativeSourceHandler.canHandleSource = function(r, e) {
  if (r.type)
    return Html5.nativeSourceHandler.canPlayType(r.type);
  if (r.src) {
    var t = getFileExtension(r.src);
    return Html5.nativeSourceHandler.canPlayType("video/" + t);
  }
  return "";
};
Html5.nativeSourceHandler.handleSource = function(r, e, t) {
  e.setSrc(r.src);
};
Html5.nativeSourceHandler.dispose = function() {
};
Html5.registerSourceHandler(Html5.nativeSourceHandler);
Tech.registerTech("Html5", Html5);
var TECH_EVENTS_RETRIGGER = [
  "progress",
  "abort",
  "suspend",
  "emptied",
  "stalled",
  "loadedmetadata",
  "loadeddata",
  "timeupdate",
  "resize",
  "volumechange",
  "texttrackchange"
], TECH_EVENTS_QUEUE = {
  canplay: "CanPlay",
  canplaythrough: "CanPlayThrough",
  playing: "Playing",
  seeked: "Seeked"
}, BREAKPOINT_ORDER = ["tiny", "xsmall", "small", "medium", "large", "xlarge", "huge"], BREAKPOINT_CLASSES = {};
BREAKPOINT_ORDER.forEach(function(r) {
  var e = r.charAt(0) === "x" ? "x-" + r.substring(1) : r;
  BREAKPOINT_CLASSES[r] = "vjs-layout-" + e;
});
var DEFAULT_BREAKPOINTS = {
  tiny: 210,
  xsmall: 320,
  small: 425,
  medium: 768,
  large: 1440,
  xlarge: 2560,
  huge: 1 / 0
}, Player = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    var o;
    if (a.id = a.id || n.id || "vjs_video_" + newGUID(), n = assign(e.getTagSettings(a), n), n.initChildren = !1, n.createEl = !1, n.evented = !1, n.reportTouchActivity = !1, !n.language)
      if (typeof a.closest == "function") {
        var u = a.closest("[lang]");
        u && u.getAttribute && (n.language = u.getAttribute("lang"));
      } else
        for (var l = a; l && l.nodeType === 1; ) {
          if (getAttributes(l).hasOwnProperty("lang")) {
            n.language = l.getAttribute("lang");
            break;
          }
          l = l.parentNode;
        }
    if (o = r.call(this, null, n, s) || this, o.boundDocumentFullscreenChange_ = function(p) {
      return o.documentFullscreenChange_(p);
    }, o.boundFullWindowOnEscKey_ = function(p) {
      return o.fullWindowOnEscKey(p);
    }, o.boundUpdateStyleEl_ = function(p) {
      return o.updateStyleEl_(p);
    }, o.boundApplyInitTime_ = function(p) {
      return o.applyInitTime_(p);
    }, o.boundUpdateCurrentBreakpoint_ = function(p) {
      return o.updateCurrentBreakpoint_(p);
    }, o.boundHandleTechClick_ = function(p) {
      return o.handleTechClick_(p);
    }, o.boundHandleTechDoubleClick_ = function(p) {
      return o.handleTechDoubleClick_(p);
    }, o.boundHandleTechTouchStart_ = function(p) {
      return o.handleTechTouchStart_(p);
    }, o.boundHandleTechTouchMove_ = function(p) {
      return o.handleTechTouchMove_(p);
    }, o.boundHandleTechTouchEnd_ = function(p) {
      return o.handleTechTouchEnd_(p);
    }, o.boundHandleTechTap_ = function(p) {
      return o.handleTechTap_(p);
    }, o.isFullscreen_ = !1, o.log = createLogger(o.id_), o.fsApi_ = FullscreenApi, o.isPosterFromTech_ = !1, o.queuedCallbacks_ = [], o.isReady_ = !1, o.hasStarted_ = !1, o.userActive_ = !1, o.debugEnabled_ = !1, o.audioOnlyMode_ = !1, o.audioPosterMode_ = !1, o.audioOnlyCache_ = {
      playerHeight: null,
      hiddenChildren: []
    }, !o.options_ || !o.options_.techOrder || !o.options_.techOrder.length)
      throw new Error("No techOrder specified. Did you overwrite videojs.options instead of just changing the properties you want to override?");
    if (o.tag = a, o.tagAttributes = a && getAttributes(a), o.language(o.options_.language), n.languages) {
      var f = {};
      Object.getOwnPropertyNames(n.languages).forEach(function(p) {
        f[p.toLowerCase()] = n.languages[p];
      }), o.languages_ = f;
    } else
      o.languages_ = e.prototype.options_.languages;
    o.resetCache_(), o.poster_ = n.poster || "", o.controls_ = !!n.controls, a.controls = !1, a.removeAttribute("controls"), o.changingSrc_ = !1, o.playCallbacks_ = [], o.playTerminatedQueue_ = [], a.hasAttribute("autoplay") ? o.autoplay(!0) : o.autoplay(o.options_.autoplay), n.plugins && Object.keys(n.plugins).forEach(function(p) {
      if (typeof o[p] != "function")
        throw new Error('plugin "' + p + '" does not exist');
    }), o.scrubbing_ = !1, o.el_ = o.createEl(), evented(_assertThisInitialized$1(o), {
      eventBusKey: "el_"
    }), o.fsApi_.requestFullscreen && (on(document_1, o.fsApi_.fullscreenchange, o.boundDocumentFullscreenChange_), o.on(o.fsApi_.fullscreenchange, o.boundDocumentFullscreenChange_)), o.fluid_ && o.on(["playerreset", "resize"], o.boundUpdateStyleEl_);
    var d = mergeOptions$3(o.options_);
    n.plugins && Object.keys(n.plugins).forEach(function(p) {
      o[p](n.plugins[p]);
    }), n.debug && o.debug(!0), o.options_.playerOptions = d, o.middleware_ = [], o.playbackRates(n.playbackRates), o.initChildren(), o.isAudio(a.nodeName.toLowerCase() === "audio"), o.controls() ? o.addClass("vjs-controls-enabled") : o.addClass("vjs-controls-disabled"), o.el_.setAttribute("role", "region"), o.isAudio() ? o.el_.setAttribute("aria-label", o.localize("Audio Player")) : o.el_.setAttribute("aria-label", o.localize("Video Player")), o.isAudio() && o.addClass("vjs-audio"), o.flexNotSupported_() && o.addClass("vjs-no-flex"), TOUCH_ENABLED && o.addClass("vjs-touch-enabled"), IS_IOS || o.addClass("vjs-workinghover"), e.players[o.id_] = _assertThisInitialized$1(o);
    var h = version$5.split(".")[0];
    return o.addClass("vjs-v" + h), o.userActive(!0), o.reportUserActivity(), o.one("play", function(p) {
      return o.listenForUserActivity_(p);
    }), o.on("stageclick", function(p) {
      return o.handleStageClick_(p);
    }), o.on("keydown", function(p) {
      return o.handleKeyDown(p);
    }), o.on("languagechange", function(p) {
      return o.handleLanguagechange(p);
    }), o.breakpoints(o.options_.breakpoints), o.responsive(o.options_.responsive), o.on("ready", function() {
      o.audioPosterMode(o.options_.audioPosterMode), o.audioOnlyMode(o.options_.audioOnlyMode);
    }), o;
  }
  var t = e.prototype;
  return t.dispose = function() {
    var n = this;
    this.trigger("dispose"), this.off("dispose"), off(document_1, this.fsApi_.fullscreenchange, this.boundDocumentFullscreenChange_), off(document_1, "keydown", this.boundFullWindowOnEscKey_), this.styleEl_ && this.styleEl_.parentNode && (this.styleEl_.parentNode.removeChild(this.styleEl_), this.styleEl_ = null), e.players[this.id_] = null, this.tag && this.tag.player && (this.tag.player = null), this.el_ && this.el_.player && (this.el_.player = null), this.tech_ && (this.tech_.dispose(), this.isPosterFromTech_ = !1, this.poster_ = ""), this.playerElIngest_ && (this.playerElIngest_ = null), this.tag && (this.tag = null), clearCacheForPlayer(this), ALL.names.forEach(function(s) {
      var o = ALL[s], u = n[o.getterName]();
      u && u.off && u.off();
    }), r.prototype.dispose.call(this, {
      restoreEl: this.options_.restoreEl
    });
  }, t.createEl = function() {
    var n = this.tag, s, o = this.playerElIngest_ = n.parentNode && n.parentNode.hasAttribute && n.parentNode.hasAttribute("data-vjs-player"), u = this.tag.tagName.toLowerCase() === "video-js";
    o ? s = this.el_ = n.parentNode : u || (s = this.el_ = r.prototype.createEl.call(this, "div"));
    var l = getAttributes(n);
    if (u) {
      for (s = this.el_ = n, n = this.tag = document_1.createElement("video"); s.children.length; )
        n.appendChild(s.firstChild);
      hasClass(s, "video-js") || addClass(s, "video-js"), s.appendChild(n), o = this.playerElIngest_ = s, Object.keys(s).forEach(function(_) {
        try {
          n[_] = s[_];
        } catch {
        }
      });
    }
    if (n.setAttribute("tabindex", "-1"), l.tabindex = "-1", (IE_VERSION || IS_CHROME && IS_WINDOWS) && (n.setAttribute("role", "application"), l.role = "application"), n.removeAttribute("width"), n.removeAttribute("height"), "width" in l && delete l.width, "height" in l && delete l.height, Object.getOwnPropertyNames(l).forEach(function(_) {
      u && _ === "class" || s.setAttribute(_, l[_]), u && n.setAttribute(_, l[_]);
    }), n.playerId = n.id, n.id += "_html5_api", n.className = "vjs-tech", n.player = s.player = this, this.addClass("vjs-paused"), window_1.VIDEOJS_NO_DYNAMIC_STYLE !== !0) {
      this.styleEl_ = createStyleElement("vjs-styles-dimensions");
      var f = $(".vjs-styles-defaults"), d = $("head");
      d.insertBefore(this.styleEl_, f ? f.nextSibling : d.firstChild);
    }
    this.fill_ = !1, this.fluid_ = !1, this.width(this.options_.width), this.height(this.options_.height), this.fill(this.options_.fill), this.fluid(this.options_.fluid), this.aspectRatio(this.options_.aspectRatio), this.crossOrigin(this.options_.crossOrigin || this.options_.crossorigin);
    for (var h = n.getElementsByTagName("a"), p = 0; p < h.length; p++) {
      var m = h.item(p);
      addClass(m, "vjs-hidden"), m.setAttribute("hidden", "hidden");
    }
    return n.initNetworkState_ = n.networkState, n.parentNode && !o && n.parentNode.insertBefore(s, n), prependTo(n, s), this.children_.unshift(n), this.el_.setAttribute("lang", this.language_), this.el_.setAttribute("translate", "no"), this.el_ = s, s;
  }, t.crossOrigin = function(n) {
    if (!n)
      return this.techGet_("crossOrigin");
    if (n !== "anonymous" && n !== "use-credentials") {
      log$1.warn('crossOrigin must be "anonymous" or "use-credentials", given "' + n + '"');
      return;
    }
    this.techCall_("setCrossOrigin", n);
  }, t.width = function(n) {
    return this.dimension("width", n);
  }, t.height = function(n) {
    return this.dimension("height", n);
  }, t.dimension = function(n, s) {
    var o = n + "_";
    if (s === void 0)
      return this[o] || 0;
    if (s === "" || s === "auto") {
      this[o] = void 0, this.updateStyleEl_();
      return;
    }
    var u = parseFloat(s);
    if (isNaN(u)) {
      log$1.error('Improper value "' + s + '" supplied for for ' + n);
      return;
    }
    this[o] = u, this.updateStyleEl_();
  }, t.fluid = function(n) {
    var s = this;
    if (n === void 0)
      return !!this.fluid_;
    this.fluid_ = !!n, isEvented(this) && this.off(["playerreset", "resize"], this.boundUpdateStyleEl_), n ? (this.addClass("vjs-fluid"), this.fill(!1), addEventedCallback(this, function() {
      s.on(["playerreset", "resize"], s.boundUpdateStyleEl_);
    })) : this.removeClass("vjs-fluid"), this.updateStyleEl_();
  }, t.fill = function(n) {
    if (n === void 0)
      return !!this.fill_;
    this.fill_ = !!n, n ? (this.addClass("vjs-fill"), this.fluid(!1)) : this.removeClass("vjs-fill");
  }, t.aspectRatio = function(n) {
    if (n === void 0)
      return this.aspectRatio_;
    if (!/^\d+\:\d+$/.test(n))
      throw new Error("Improper value supplied for aspect ratio. The format should be width:height, for example 16:9.");
    this.aspectRatio_ = n, this.fluid(!0), this.updateStyleEl_();
  }, t.updateStyleEl_ = function() {
    if (window_1.VIDEOJS_NO_DYNAMIC_STYLE === !0) {
      var n = typeof this.width_ == "number" ? this.width_ : this.options_.width, s = typeof this.height_ == "number" ? this.height_ : this.options_.height, o = this.tech_ && this.tech_.el();
      o && (n >= 0 && (o.width = n), s >= 0 && (o.height = s));
      return;
    }
    var u, l, f, d;
    this.aspectRatio_ !== void 0 && this.aspectRatio_ !== "auto" ? f = this.aspectRatio_ : this.videoWidth() > 0 ? f = this.videoWidth() + ":" + this.videoHeight() : f = "16:9";
    var h = f.split(":"), p = h[1] / h[0];
    this.width_ !== void 0 ? u = this.width_ : this.height_ !== void 0 ? u = this.height_ / p : u = this.videoWidth() || 300, this.height_ !== void 0 ? l = this.height_ : l = u * p, /^[^a-zA-Z]/.test(this.id()) ? d = "dimensions-" + this.id() : d = this.id() + "-dimensions", this.addClass(d), setTextContent(this.styleEl_, `
      .` + d + ` {
        width: ` + u + `px;
        height: ` + l + `px;
      }

      .` + d + `.vjs-fluid:not(.vjs-audio-only-mode) {
        padding-top: ` + p * 100 + `%;
      }
    `);
  }, t.loadTech_ = function(n, s) {
    var o = this;
    this.tech_ && this.unloadTech_();
    var u = toTitleCase$1(n), l = n.charAt(0).toLowerCase() + n.slice(1);
    u !== "Html5" && this.tag && (Tech.getTech("Html5").disposeMediaElement(this.tag), this.tag.player = null, this.tag = null), this.techName_ = u, this.isReady_ = !1;
    var f = this.autoplay();
    (typeof this.autoplay() == "string" || this.autoplay() === !0 && this.options_.normalizeAutoplay) && (f = !1);
    var d = {
      source: s,
      autoplay: f,
      nativeControlsForTouch: this.options_.nativeControlsForTouch,
      playerId: this.id(),
      techId: this.id() + "_" + l + "_api",
      playsinline: this.options_.playsinline,
      preload: this.options_.preload,
      loop: this.options_.loop,
      disablePictureInPicture: this.options_.disablePictureInPicture,
      muted: this.options_.muted,
      poster: this.poster(),
      language: this.language(),
      playerElIngest: this.playerElIngest_ || !1,
      "vtt.js": this.options_["vtt.js"],
      canOverridePoster: !!this.options_.techCanOverridePoster,
      enableSourceset: this.options_.enableSourceset,
      Promise: this.options_.Promise
    };
    ALL.names.forEach(function(p) {
      var m = ALL[p];
      d[m.getterName] = o[m.privateName];
    }), assign(d, this.options_[u]), assign(d, this.options_[l]), assign(d, this.options_[n.toLowerCase()]), this.tag && (d.tag = this.tag), s && s.src === this.cache_.src && this.cache_.currentTime > 0 && (d.startTime = this.cache_.currentTime);
    var h = Tech.getTech(n);
    if (!h)
      throw new Error("No Tech named '" + u + "' exists! '" + u + "' should be registered using videojs.registerTech()'");
    this.tech_ = new h(d), this.tech_.ready(bind(this, this.handleTechReady_), !0), textTrackConverter.jsonToTextTracks(this.textTracksJson_ || [], this.tech_), TECH_EVENTS_RETRIGGER.forEach(function(p) {
      o.on(o.tech_, p, function(m) {
        return o["handleTech" + toTitleCase$1(p) + "_"](m);
      });
    }), Object.keys(TECH_EVENTS_QUEUE).forEach(function(p) {
      o.on(o.tech_, p, function(m) {
        if (o.tech_.playbackRate() === 0 && o.tech_.seeking()) {
          o.queuedCallbacks_.push({
            callback: o["handleTech" + TECH_EVENTS_QUEUE[p] + "_"].bind(o),
            event: m
          });
          return;
        }
        o["handleTech" + TECH_EVENTS_QUEUE[p] + "_"](m);
      });
    }), this.on(this.tech_, "loadstart", function(p) {
      return o.handleTechLoadStart_(p);
    }), this.on(this.tech_, "sourceset", function(p) {
      return o.handleTechSourceset_(p);
    }), this.on(this.tech_, "waiting", function(p) {
      return o.handleTechWaiting_(p);
    }), this.on(this.tech_, "ended", function(p) {
      return o.handleTechEnded_(p);
    }), this.on(this.tech_, "seeking", function(p) {
      return o.handleTechSeeking_(p);
    }), this.on(this.tech_, "play", function(p) {
      return o.handleTechPlay_(p);
    }), this.on(this.tech_, "firstplay", function(p) {
      return o.handleTechFirstPlay_(p);
    }), this.on(this.tech_, "pause", function(p) {
      return o.handleTechPause_(p);
    }), this.on(this.tech_, "durationchange", function(p) {
      return o.handleTechDurationChange_(p);
    }), this.on(this.tech_, "fullscreenchange", function(p, m) {
      return o.handleTechFullscreenChange_(p, m);
    }), this.on(this.tech_, "fullscreenerror", function(p, m) {
      return o.handleTechFullscreenError_(p, m);
    }), this.on(this.tech_, "enterpictureinpicture", function(p) {
      return o.handleTechEnterPictureInPicture_(p);
    }), this.on(this.tech_, "leavepictureinpicture", function(p) {
      return o.handleTechLeavePictureInPicture_(p);
    }), this.on(this.tech_, "error", function(p) {
      return o.handleTechError_(p);
    }), this.on(this.tech_, "posterchange", function(p) {
      return o.handleTechPosterChange_(p);
    }), this.on(this.tech_, "textdata", function(p) {
      return o.handleTechTextData_(p);
    }), this.on(this.tech_, "ratechange", function(p) {
      return o.handleTechRateChange_(p);
    }), this.on(this.tech_, "loadedmetadata", this.boundUpdateStyleEl_), this.usingNativeControls(this.techGet_("controls")), this.controls() && !this.usingNativeControls() && this.addTechControlsListeners_(), this.tech_.el().parentNode !== this.el() && (u !== "Html5" || !this.tag) && prependTo(this.tech_.el(), this.el()), this.tag && (this.tag.player = null, this.tag = null);
  }, t.unloadTech_ = function() {
    var n = this;
    ALL.names.forEach(function(s) {
      var o = ALL[s];
      n[o.privateName] = n[o.getterName]();
    }), this.textTracksJson_ = textTrackConverter.textTracksToJson(this.tech_), this.isReady_ = !1, this.tech_.dispose(), this.tech_ = !1, this.isPosterFromTech_ && (this.poster_ = "", this.trigger("posterchange")), this.isPosterFromTech_ = !1;
  }, t.tech = function(n) {
    return n === void 0 && log$1.warn(`Using the tech directly can be dangerous. I hope you know what you're doing.
See https://github.com/videojs/video.js/issues/2617 for more info.
`), this.tech_;
  }, t.addTechControlsListeners_ = function() {
    this.removeTechControlsListeners_(), this.on(this.tech_, "click", this.boundHandleTechClick_), this.on(this.tech_, "dblclick", this.boundHandleTechDoubleClick_), this.on(this.tech_, "touchstart", this.boundHandleTechTouchStart_), this.on(this.tech_, "touchmove", this.boundHandleTechTouchMove_), this.on(this.tech_, "touchend", this.boundHandleTechTouchEnd_), this.on(this.tech_, "tap", this.boundHandleTechTap_);
  }, t.removeTechControlsListeners_ = function() {
    this.off(this.tech_, "tap", this.boundHandleTechTap_), this.off(this.tech_, "touchstart", this.boundHandleTechTouchStart_), this.off(this.tech_, "touchmove", this.boundHandleTechTouchMove_), this.off(this.tech_, "touchend", this.boundHandleTechTouchEnd_), this.off(this.tech_, "click", this.boundHandleTechClick_), this.off(this.tech_, "dblclick", this.boundHandleTechDoubleClick_);
  }, t.handleTechReady_ = function() {
    this.triggerReady(), this.cache_.volume && this.techCall_("setVolume", this.cache_.volume), this.handleTechPosterChange_(), this.handleTechDurationChange_();
  }, t.handleTechLoadStart_ = function() {
    this.removeClass("vjs-ended"), this.removeClass("vjs-seeking"), this.error(null), this.handleTechDurationChange_(), this.paused() ? (this.hasStarted(!1), this.trigger("loadstart")) : (this.trigger("loadstart"), this.trigger("firstplay")), this.manualAutoplay_(this.autoplay() === !0 && this.options_.normalizeAutoplay ? "play" : this.autoplay());
  }, t.manualAutoplay_ = function(n) {
    var s = this;
    if (!(!this.tech_ || typeof n != "string")) {
      var o = function() {
        var f = s.muted();
        s.muted(!0);
        var d = function() {
          s.muted(f);
        };
        s.playTerminatedQueue_.push(d);
        var h = s.play();
        if (!!isPromise(h))
          return h.catch(function(p) {
            throw d(), new Error("Rejection at manualAutoplay. Restoring muted value. " + (p || ""));
          });
      }, u;
      if (n === "any" && !this.muted() ? (u = this.play(), isPromise(u) && (u = u.catch(o))) : n === "muted" && !this.muted() ? u = o() : u = this.play(), !!isPromise(u))
        return u.then(function() {
          s.trigger({
            type: "autoplay-success",
            autoplay: n
          });
        }).catch(function() {
          s.trigger({
            type: "autoplay-failure",
            autoplay: n
          });
        });
    }
  }, t.updateSourceCaches_ = function(n) {
    n === void 0 && (n = "");
    var s = n, o = "";
    typeof s != "string" && (s = n.src, o = n.type), this.cache_.source = this.cache_.source || {}, this.cache_.sources = this.cache_.sources || [], s && !o && (o = findMimetype(this, s)), this.cache_.source = mergeOptions$3({}, n, {
      src: s,
      type: o
    });
    for (var u = this.cache_.sources.filter(function(m) {
      return m.src && m.src === s;
    }), l = [], f = this.$$("source"), d = [], h = 0; h < f.length; h++) {
      var p = getAttributes(f[h]);
      l.push(p), p.src && p.src === s && d.push(p.src);
    }
    d.length && !u.length ? this.cache_.sources = l : u.length || (this.cache_.sources = [this.cache_.source]), this.cache_.src = s;
  }, t.handleTechSourceset_ = function(n) {
    var s = this;
    if (!this.changingSrc_) {
      var o = function(d) {
        return s.updateSourceCaches_(d);
      }, u = this.currentSource().src, l = n.src;
      u && !/^blob:/.test(u) && /^blob:/.test(l) && (!this.lastSource_ || this.lastSource_.tech !== l && this.lastSource_.player !== u) && (o = function() {
      }), o(l), n.src || this.tech_.any(["sourceset", "loadstart"], function(f) {
        if (f.type !== "sourceset") {
          var d = s.techGet("currentSrc");
          s.lastSource_.tech = d, s.updateSourceCaches_(d);
        }
      });
    }
    this.lastSource_ = {
      player: this.currentSource().src,
      tech: n.src
    }, this.trigger({
      src: n.src,
      type: "sourceset"
    });
  }, t.hasStarted = function(n) {
    if (n === void 0)
      return this.hasStarted_;
    n !== this.hasStarted_ && (this.hasStarted_ = n, this.hasStarted_ ? (this.addClass("vjs-has-started"), this.trigger("firstplay")) : this.removeClass("vjs-has-started"));
  }, t.handleTechPlay_ = function() {
    this.removeClass("vjs-ended"), this.removeClass("vjs-paused"), this.addClass("vjs-playing"), this.hasStarted(!0), this.trigger("play");
  }, t.handleTechRateChange_ = function() {
    this.tech_.playbackRate() > 0 && this.cache_.lastPlaybackRate === 0 && (this.queuedCallbacks_.forEach(function(n) {
      return n.callback(n.event);
    }), this.queuedCallbacks_ = []), this.cache_.lastPlaybackRate = this.tech_.playbackRate(), this.trigger("ratechange");
  }, t.handleTechWaiting_ = function() {
    var n = this;
    this.addClass("vjs-waiting"), this.trigger("waiting");
    var s = this.currentTime(), o = function u() {
      s !== n.currentTime() && (n.removeClass("vjs-waiting"), n.off("timeupdate", u));
    };
    this.on("timeupdate", o);
  }, t.handleTechCanPlay_ = function() {
    this.removeClass("vjs-waiting"), this.trigger("canplay");
  }, t.handleTechCanPlayThrough_ = function() {
    this.removeClass("vjs-waiting"), this.trigger("canplaythrough");
  }, t.handleTechPlaying_ = function() {
    this.removeClass("vjs-waiting"), this.trigger("playing");
  }, t.handleTechSeeking_ = function() {
    this.addClass("vjs-seeking"), this.trigger("seeking");
  }, t.handleTechSeeked_ = function() {
    this.removeClass("vjs-seeking"), this.removeClass("vjs-ended"), this.trigger("seeked");
  }, t.handleTechFirstPlay_ = function() {
    this.options_.starttime && (log$1.warn("Passing the `starttime` option to the player will be deprecated in 6.0"), this.currentTime(this.options_.starttime)), this.addClass("vjs-has-started"), this.trigger("firstplay");
  }, t.handleTechPause_ = function() {
    this.removeClass("vjs-playing"), this.addClass("vjs-paused"), this.trigger("pause");
  }, t.handleTechEnded_ = function() {
    this.addClass("vjs-ended"), this.removeClass("vjs-waiting"), this.options_.loop ? (this.currentTime(0), this.play()) : this.paused() || this.pause(), this.trigger("ended");
  }, t.handleTechDurationChange_ = function() {
    this.duration(this.techGet_("duration"));
  }, t.handleTechClick_ = function(n) {
    !this.controls_ || (this.options_ === void 0 || this.options_.userActions === void 0 || this.options_.userActions.click === void 0 || this.options_.userActions.click !== !1) && (this.options_ !== void 0 && this.options_.userActions !== void 0 && typeof this.options_.userActions.click == "function" ? this.options_.userActions.click.call(this, n) : this.paused() ? silencePromise(this.play()) : this.pause());
  }, t.handleTechDoubleClick_ = function(n) {
    if (!!this.controls_) {
      var s = Array.prototype.some.call(this.$$(".vjs-control-bar, .vjs-modal-dialog"), function(o) {
        return o.contains(n.target);
      });
      s || (this.options_ === void 0 || this.options_.userActions === void 0 || this.options_.userActions.doubleClick === void 0 || this.options_.userActions.doubleClick !== !1) && (this.options_ !== void 0 && this.options_.userActions !== void 0 && typeof this.options_.userActions.doubleClick == "function" ? this.options_.userActions.doubleClick.call(this, n) : this.isFullscreen() ? this.exitFullscreen() : this.requestFullscreen());
    }
  }, t.handleTechTap_ = function() {
    this.userActive(!this.userActive());
  }, t.handleTechTouchStart_ = function() {
    this.userWasActive = this.userActive();
  }, t.handleTechTouchMove_ = function() {
    this.userWasActive && this.reportUserActivity();
  }, t.handleTechTouchEnd_ = function(n) {
    n.cancelable && n.preventDefault();
  }, t.handleStageClick_ = function() {
    this.reportUserActivity();
  }, t.toggleFullscreenClass_ = function() {
    this.isFullscreen() ? this.addClass("vjs-fullscreen") : this.removeClass("vjs-fullscreen");
  }, t.documentFullscreenChange_ = function(n) {
    var s = n.target.player;
    if (!(s && s !== this)) {
      var o = this.el(), u = document_1[this.fsApi_.fullscreenElement] === o;
      !u && o.matches ? u = o.matches(":" + this.fsApi_.fullscreen) : !u && o.msMatchesSelector && (u = o.msMatchesSelector(":" + this.fsApi_.fullscreen)), this.isFullscreen(u);
    }
  }, t.handleTechFullscreenChange_ = function(n, s) {
    var o = this;
    s && (s.nativeIOSFullscreen && (this.addClass("vjs-ios-native-fs"), this.tech_.one("webkitendfullscreen", function() {
      o.removeClass("vjs-ios-native-fs");
    })), this.isFullscreen(s.isFullscreen));
  }, t.handleTechFullscreenError_ = function(n, s) {
    this.trigger("fullscreenerror", s);
  }, t.togglePictureInPictureClass_ = function() {
    this.isInPictureInPicture() ? this.addClass("vjs-picture-in-picture") : this.removeClass("vjs-picture-in-picture");
  }, t.handleTechEnterPictureInPicture_ = function(n) {
    this.isInPictureInPicture(!0);
  }, t.handleTechLeavePictureInPicture_ = function(n) {
    this.isInPictureInPicture(!1);
  }, t.handleTechError_ = function() {
    var n = this.tech_.error();
    this.error(n);
  }, t.handleTechTextData_ = function() {
    var n = null;
    arguments.length > 1 && (n = arguments[1]), this.trigger("textdata", n);
  }, t.getCache = function() {
    return this.cache_;
  }, t.resetCache_ = function() {
    this.cache_ = {
      currentTime: 0,
      initTime: 0,
      inactivityTimeout: this.options_.inactivityTimeout,
      duration: NaN,
      lastVolume: 1,
      lastPlaybackRate: this.defaultPlaybackRate(),
      media: null,
      src: "",
      source: {},
      sources: [],
      playbackRates: [],
      volume: 1
    };
  }, t.techCall_ = function(n, s) {
    this.ready(function() {
      if (n in allowedSetters)
        return set(this.middleware_, this.tech_, n, s);
      if (n in allowedMediators)
        return mediate(this.middleware_, this.tech_, n, s);
      try {
        this.tech_ && this.tech_[n](s);
      } catch (o) {
        throw log$1(o), o;
      }
    }, !0);
  }, t.techGet_ = function(n) {
    if (!(!this.tech_ || !this.tech_.isReady_)) {
      if (n in allowedGetters)
        return get(this.middleware_, this.tech_, n);
      if (n in allowedMediators)
        return mediate(this.middleware_, this.tech_, n);
      try {
        return this.tech_[n]();
      } catch (s) {
        throw this.tech_[n] === void 0 ? (log$1("Video.js: " + n + " method not defined for " + this.techName_ + " playback technology.", s), s) : s.name === "TypeError" ? (log$1("Video.js: " + n + " unavailable on " + this.techName_ + " playback technology element.", s), this.tech_.isReady_ = !1, s) : (log$1(s), s);
      }
    }
  }, t.play = function() {
    var n = this, s = this.options_.Promise || window_1.Promise;
    return s ? new s(function(o) {
      n.play_(o);
    }) : this.play_();
  }, t.play_ = function(n) {
    var s = this;
    n === void 0 && (n = silencePromise), this.playCallbacks_.push(n);
    var o = Boolean(!this.changingSrc_ && (this.src() || this.currentSrc()));
    if (this.waitToPlay_ && (this.off(["ready", "loadstart"], this.waitToPlay_), this.waitToPlay_ = null), !this.isReady_ || !o) {
      this.waitToPlay_ = function(l) {
        s.play_();
      }, this.one(["ready", "loadstart"], this.waitToPlay_), !o && (IS_ANY_SAFARI || IS_IOS) && this.load();
      return;
    }
    var u = this.techGet_("play");
    u === null ? this.runPlayTerminatedQueue_() : this.runPlayCallbacks_(u);
  }, t.runPlayTerminatedQueue_ = function() {
    var n = this.playTerminatedQueue_.slice(0);
    this.playTerminatedQueue_ = [], n.forEach(function(s) {
      s();
    });
  }, t.runPlayCallbacks_ = function(n) {
    var s = this.playCallbacks_.slice(0);
    this.playCallbacks_ = [], this.playTerminatedQueue_ = [], s.forEach(function(o) {
      o(n);
    });
  }, t.pause = function() {
    this.techCall_("pause");
  }, t.paused = function() {
    return this.techGet_("paused") !== !1;
  }, t.played = function() {
    return this.techGet_("played") || createTimeRanges(0, 0);
  }, t.scrubbing = function(n) {
    if (typeof n > "u")
      return this.scrubbing_;
    this.scrubbing_ = !!n, this.techCall_("setScrubbing", this.scrubbing_), n ? this.addClass("vjs-scrubbing") : this.removeClass("vjs-scrubbing");
  }, t.currentTime = function(n) {
    if (typeof n < "u") {
      if (n < 0 && (n = 0), !this.isReady_ || this.changingSrc_ || !this.tech_ || !this.tech_.isReady_) {
        this.cache_.initTime = n, this.off("canplay", this.boundApplyInitTime_), this.one("canplay", this.boundApplyInitTime_);
        return;
      }
      this.techCall_("setCurrentTime", n), this.cache_.initTime = 0;
      return;
    }
    return this.cache_.currentTime = this.techGet_("currentTime") || 0, this.cache_.currentTime;
  }, t.applyInitTime_ = function() {
    this.currentTime(this.cache_.initTime);
  }, t.duration = function(n) {
    if (n === void 0)
      return this.cache_.duration !== void 0 ? this.cache_.duration : NaN;
    n = parseFloat(n), n < 0 && (n = 1 / 0), n !== this.cache_.duration && (this.cache_.duration = n, n === 1 / 0 ? this.addClass("vjs-live") : this.removeClass("vjs-live"), isNaN(n) || this.trigger("durationchange"));
  }, t.remainingTime = function() {
    return this.duration() - this.currentTime();
  }, t.remainingTimeDisplay = function() {
    return Math.floor(this.duration()) - Math.floor(this.currentTime());
  }, t.buffered = function() {
    var n = this.techGet_("buffered");
    return (!n || !n.length) && (n = createTimeRanges(0, 0)), n;
  }, t.bufferedPercent = function() {
    return bufferedPercent(this.buffered(), this.duration());
  }, t.bufferedEnd = function() {
    var n = this.buffered(), s = this.duration(), o = n.end(n.length - 1);
    return o > s && (o = s), o;
  }, t.volume = function(n) {
    var s;
    if (n !== void 0) {
      s = Math.max(0, Math.min(1, parseFloat(n))), this.cache_.volume = s, this.techCall_("setVolume", s), s > 0 && this.lastVolume_(s);
      return;
    }
    return s = parseFloat(this.techGet_("volume")), isNaN(s) ? 1 : s;
  }, t.muted = function(n) {
    if (n !== void 0) {
      this.techCall_("setMuted", n);
      return;
    }
    return this.techGet_("muted") || !1;
  }, t.defaultMuted = function(n) {
    return n !== void 0 ? this.techCall_("setDefaultMuted", n) : this.techGet_("defaultMuted") || !1;
  }, t.lastVolume_ = function(n) {
    if (n !== void 0 && n !== 0) {
      this.cache_.lastVolume = n;
      return;
    }
    return this.cache_.lastVolume;
  }, t.supportsFullScreen = function() {
    return this.techGet_("supportsFullScreen") || !1;
  }, t.isFullscreen = function(n) {
    if (n !== void 0) {
      var s = this.isFullscreen_;
      this.isFullscreen_ = Boolean(n), this.isFullscreen_ !== s && this.fsApi_.prefixed && this.trigger("fullscreenchange"), this.toggleFullscreenClass_();
      return;
    }
    return this.isFullscreen_;
  }, t.requestFullscreen = function(n) {
    var s = this.options_.Promise || window_1.Promise;
    if (s) {
      var o = this;
      return new s(function(u, l) {
        function f() {
          o.off("fullscreenerror", h), o.off("fullscreenchange", d);
        }
        function d() {
          f(), u();
        }
        function h(m, _) {
          f(), l(_);
        }
        o.one("fullscreenchange", d), o.one("fullscreenerror", h);
        var p = o.requestFullscreenHelper_(n);
        p && (p.then(f, f), p.then(u, l));
      });
    }
    return this.requestFullscreenHelper_();
  }, t.requestFullscreenHelper_ = function(n) {
    var s = this, o;
    if (this.fsApi_.prefixed || (o = this.options_.fullscreen && this.options_.fullscreen.options || {}, n !== void 0 && (o = n)), this.fsApi_.requestFullscreen) {
      var u = this.el_[this.fsApi_.requestFullscreen](o);
      return u && u.then(function() {
        return s.isFullscreen(!0);
      }, function() {
        return s.isFullscreen(!1);
      }), u;
    } else
      this.tech_.supportsFullScreen() && !this.options_.preferFullWindow ? this.techCall_("enterFullScreen") : this.enterFullWindow();
  }, t.exitFullscreen = function() {
    var n = this.options_.Promise || window_1.Promise;
    if (n) {
      var s = this;
      return new n(function(o, u) {
        function l() {
          s.off("fullscreenerror", d), s.off("fullscreenchange", f);
        }
        function f() {
          l(), o();
        }
        function d(p, m) {
          l(), u(m);
        }
        s.one("fullscreenchange", f), s.one("fullscreenerror", d);
        var h = s.exitFullscreenHelper_();
        h && (h.then(l, l), h.then(o, u));
      });
    }
    return this.exitFullscreenHelper_();
  }, t.exitFullscreenHelper_ = function() {
    var n = this;
    if (this.fsApi_.requestFullscreen) {
      var s = document_1[this.fsApi_.exitFullscreen]();
      return s && silencePromise(s.then(function() {
        return n.isFullscreen(!1);
      })), s;
    } else
      this.tech_.supportsFullScreen() && !this.options_.preferFullWindow ? this.techCall_("exitFullScreen") : this.exitFullWindow();
  }, t.enterFullWindow = function() {
    this.isFullscreen(!0), this.isFullWindow = !0, this.docOrigOverflow = document_1.documentElement.style.overflow, on(document_1, "keydown", this.boundFullWindowOnEscKey_), document_1.documentElement.style.overflow = "hidden", addClass(document_1.body, "vjs-full-window"), this.trigger("enterFullWindow");
  }, t.fullWindowOnEscKey = function(n) {
    keycode.isEventKey(n, "Esc") && this.isFullscreen() === !0 && (this.isFullWindow ? this.exitFullWindow() : this.exitFullscreen());
  }, t.exitFullWindow = function() {
    this.isFullscreen(!1), this.isFullWindow = !1, off(document_1, "keydown", this.boundFullWindowOnEscKey_), document_1.documentElement.style.overflow = this.docOrigOverflow, removeClass(document_1.body, "vjs-full-window"), this.trigger("exitFullWindow");
  }, t.disablePictureInPicture = function(n) {
    if (n === void 0)
      return this.techGet_("disablePictureInPicture");
    this.techCall_("setDisablePictureInPicture", n), this.options_.disablePictureInPicture = n, this.trigger("disablepictureinpicturechanged");
  }, t.isInPictureInPicture = function(n) {
    if (n !== void 0) {
      this.isInPictureInPicture_ = !!n, this.togglePictureInPictureClass_();
      return;
    }
    return !!this.isInPictureInPicture_;
  }, t.requestPictureInPicture = function() {
    if ("pictureInPictureEnabled" in document_1 && this.disablePictureInPicture() === !1)
      return this.techGet_("requestPictureInPicture");
  }, t.exitPictureInPicture = function() {
    if ("pictureInPictureEnabled" in document_1)
      return document_1.exitPictureInPicture();
  }, t.handleKeyDown = function(n) {
    var s = this.options_.userActions;
    if (!(!s || !s.hotkeys)) {
      var o = function(l) {
        var f = l.tagName.toLowerCase();
        if (l.isContentEditable)
          return !0;
        var d = ["button", "checkbox", "hidden", "radio", "reset", "submit"];
        if (f === "input")
          return d.indexOf(l.type) === -1;
        var h = ["textarea"];
        return h.indexOf(f) !== -1;
      };
      o(this.el_.ownerDocument.activeElement) || (typeof s.hotkeys == "function" ? s.hotkeys.call(this, n) : this.handleHotkeys(n));
    }
  }, t.handleHotkeys = function(n) {
    var s = this.options_.userActions ? this.options_.userActions.hotkeys : {}, o = s.fullscreenKey, u = o === void 0 ? function(w) {
      return keycode.isEventKey(w, "f");
    } : o, l = s.muteKey, f = l === void 0 ? function(w) {
      return keycode.isEventKey(w, "m");
    } : l, d = s.playPauseKey, h = d === void 0 ? function(w) {
      return keycode.isEventKey(w, "k") || keycode.isEventKey(w, "Space");
    } : d;
    if (u.call(this, n)) {
      n.preventDefault(), n.stopPropagation();
      var p = Component$1.getComponent("FullscreenToggle");
      document_1[this.fsApi_.fullscreenEnabled] !== !1 && p.prototype.handleClick.call(this, n);
    } else if (f.call(this, n)) {
      n.preventDefault(), n.stopPropagation();
      var m = Component$1.getComponent("MuteToggle");
      m.prototype.handleClick.call(this, n);
    } else if (h.call(this, n)) {
      n.preventDefault(), n.stopPropagation();
      var _ = Component$1.getComponent("PlayToggle");
      _.prototype.handleClick.call(this, n);
    }
  }, t.canPlayType = function(n) {
    for (var s, o = 0, u = this.options_.techOrder; o < u.length; o++) {
      var l = u[o], f = Tech.getTech(l);
      if (f || (f = Component$1.getComponent(l)), !f) {
        log$1.error('The "' + l + '" tech is undefined. Skipped browser support check for that tech.');
        continue;
      }
      if (f.isSupported() && (s = f.canPlayType(n), s))
        return s;
    }
    return "";
  }, t.selectSource = function(n) {
    var s = this, o = this.options_.techOrder.map(function(h) {
      return [h, Tech.getTech(h)];
    }).filter(function(h) {
      var p = h[0], m = h[1];
      return m ? m.isSupported() : (log$1.error('The "' + p + '" tech is undefined. Skipped browser support check for that tech.'), !1);
    }), u = function(p, m, _) {
      var w;
      return p.some(function(S) {
        return m.some(function(O) {
          if (w = _(S, O), w)
            return !0;
        });
      }), w;
    }, l, f = function(p) {
      return function(m, _) {
        return p(_, m);
      };
    }, d = function(p, m) {
      var _ = p[0], w = p[1];
      if (w.canPlaySource(m, s.options_[_.toLowerCase()]))
        return {
          source: m,
          tech: _
        };
    };
    return this.options_.sourceOrder ? l = u(n, o, f(d)) : l = u(o, n, d), l || !1;
  }, t.handleSrc_ = function(n, s) {
    var o = this;
    if (typeof n > "u")
      return this.cache_.src || "";
    this.resetRetryOnError_ && this.resetRetryOnError_();
    var u = filterSource(n);
    if (!u.length) {
      this.setTimeout(function() {
        this.error({
          code: 4,
          message: this.options_.notSupportedMessage
        });
      }, 0);
      return;
    }
    if (this.changingSrc_ = !0, s || (this.cache_.sources = u), this.updateSourceCaches_(u[0]), setSource(this, u[0], function(d, h) {
      o.middleware_ = h, s || (o.cache_.sources = u), o.updateSourceCaches_(d);
      var p = o.src_(d);
      if (p) {
        if (u.length > 1)
          return o.handleSrc_(u.slice(1));
        o.changingSrc_ = !1, o.setTimeout(function() {
          this.error({
            code: 4,
            message: this.options_.notSupportedMessage
          });
        }, 0), o.triggerReady();
        return;
      }
      setTech(h, o.tech_);
    }), this.options_.retryOnError && u.length > 1) {
      var l = function() {
        o.error(null), o.handleSrc_(u.slice(1), !0);
      }, f = function() {
        o.off("error", l);
      };
      this.one("error", l), this.one("playing", f), this.resetRetryOnError_ = function() {
        o.off("error", l), o.off("playing", f);
      };
    }
  }, t.src = function(n) {
    return this.handleSrc_(n, !1);
  }, t.src_ = function(n) {
    var s = this, o = this.selectSource([n]);
    return o ? titleCaseEquals(o.tech, this.techName_) ? (this.ready(function() {
      this.tech_.constructor.prototype.hasOwnProperty("setSource") ? this.techCall_("setSource", n) : this.techCall_("src", n.src), this.changingSrc_ = !1;
    }, !0), !1) : (this.changingSrc_ = !0, this.loadTech_(o.tech, o.source), this.tech_.ready(function() {
      s.changingSrc_ = !1;
    }), !1) : !0;
  }, t.load = function() {
    this.techCall_("load");
  }, t.reset = function() {
    var n = this, s = this.options_.Promise || window_1.Promise;
    if (this.paused() || !s)
      this.doReset_();
    else {
      var o = this.play();
      silencePromise(o.then(function() {
        return n.doReset_();
      }));
    }
  }, t.doReset_ = function() {
    this.tech_ && this.tech_.clearTracks("text"), this.resetCache_(), this.poster(""), this.loadTech_(this.options_.techOrder[0], null), this.techCall_("reset"), this.resetControlBarUI_(), isEvented(this) && this.trigger("playerreset");
  }, t.resetControlBarUI_ = function() {
    this.resetProgressBar_(), this.resetPlaybackRate_(), this.resetVolumeBar_();
  }, t.resetProgressBar_ = function() {
    this.currentTime(0);
    var n = this.controlBar || {}, s = n.durationDisplay, o = n.remainingTimeDisplay;
    s && s.updateContent(), o && o.updateContent();
  }, t.resetPlaybackRate_ = function() {
    this.playbackRate(this.defaultPlaybackRate()), this.handleTechRateChange_();
  }, t.resetVolumeBar_ = function() {
    this.volume(1), this.trigger("volumechange");
  }, t.currentSources = function() {
    var n = this.currentSource(), s = [];
    return Object.keys(n).length !== 0 && s.push(n), this.cache_.sources || s;
  }, t.currentSource = function() {
    return this.cache_.source || {};
  }, t.currentSrc = function() {
    return this.currentSource() && this.currentSource().src || "";
  }, t.currentType = function() {
    return this.currentSource() && this.currentSource().type || "";
  }, t.preload = function(n) {
    if (n !== void 0) {
      this.techCall_("setPreload", n), this.options_.preload = n;
      return;
    }
    return this.techGet_("preload");
  }, t.autoplay = function(n) {
    if (n === void 0)
      return this.options_.autoplay || !1;
    var s;
    typeof n == "string" && /(any|play|muted)/.test(n) || n === !0 && this.options_.normalizeAutoplay ? (this.options_.autoplay = n, this.manualAutoplay_(typeof n == "string" ? n : "play"), s = !1) : n ? this.options_.autoplay = !0 : this.options_.autoplay = !1, s = typeof s > "u" ? this.options_.autoplay : s, this.tech_ && this.techCall_("setAutoplay", s);
  }, t.playsinline = function(n) {
    return n !== void 0 ? (this.techCall_("setPlaysinline", n), this.options_.playsinline = n, this) : this.techGet_("playsinline");
  }, t.loop = function(n) {
    if (n !== void 0) {
      this.techCall_("setLoop", n), this.options_.loop = n;
      return;
    }
    return this.techGet_("loop");
  }, t.poster = function(n) {
    if (n === void 0)
      return this.poster_;
    n || (n = ""), n !== this.poster_ && (this.poster_ = n, this.techCall_("setPoster", n), this.isPosterFromTech_ = !1, this.trigger("posterchange"));
  }, t.handleTechPosterChange_ = function() {
    if ((!this.poster_ || this.options_.techCanOverridePoster) && this.tech_ && this.tech_.poster) {
      var n = this.tech_.poster() || "";
      n !== this.poster_ && (this.poster_ = n, this.isPosterFromTech_ = !0, this.trigger("posterchange"));
    }
  }, t.controls = function(n) {
    if (n === void 0)
      return !!this.controls_;
    n = !!n, this.controls_ !== n && (this.controls_ = n, this.usingNativeControls() && this.techCall_("setControls", n), this.controls_ ? (this.removeClass("vjs-controls-disabled"), this.addClass("vjs-controls-enabled"), this.trigger("controlsenabled"), this.usingNativeControls() || this.addTechControlsListeners_()) : (this.removeClass("vjs-controls-enabled"), this.addClass("vjs-controls-disabled"), this.trigger("controlsdisabled"), this.usingNativeControls() || this.removeTechControlsListeners_()));
  }, t.usingNativeControls = function(n) {
    if (n === void 0)
      return !!this.usingNativeControls_;
    n = !!n, this.usingNativeControls_ !== n && (this.usingNativeControls_ = n, this.usingNativeControls_ ? (this.addClass("vjs-using-native-controls"), this.trigger("usingnativecontrols")) : (this.removeClass("vjs-using-native-controls"), this.trigger("usingcustomcontrols")));
  }, t.error = function(n) {
    var s = this;
    if (n === void 0)
      return this.error_ || null;
    if (hooks("beforeerror").forEach(function(u) {
      var l = u(s, n);
      if (!(isObject(l) && !Array.isArray(l) || typeof l == "string" || typeof l == "number" || l === null)) {
        s.log.error("please return a value that MediaError expects in beforeerror hooks");
        return;
      }
      n = l;
    }), this.options_.suppressNotSupportedError && n && n.code === 4) {
      var o = function() {
        this.error(n);
      };
      this.options_.suppressNotSupportedError = !1, this.any(["click", "touchstart"], o), this.one("loadstart", function() {
        this.off(["click", "touchstart"], o);
      });
      return;
    }
    if (n === null) {
      this.error_ = n, this.removeClass("vjs-error"), this.errorDisplay && this.errorDisplay.close();
      return;
    }
    this.error_ = new MediaError(n), this.addClass("vjs-error"), log$1.error("(CODE:" + this.error_.code + " " + MediaError.errorTypes[this.error_.code] + ")", this.error_.message, this.error_), this.trigger("error"), hooks("error").forEach(function(u) {
      return u(s, s.error_);
    });
  }, t.reportUserActivity = function(n) {
    this.userActivity_ = !0;
  }, t.userActive = function(n) {
    if (n === void 0)
      return this.userActive_;
    if (n = !!n, n !== this.userActive_) {
      if (this.userActive_ = n, this.userActive_) {
        this.userActivity_ = !0, this.removeClass("vjs-user-inactive"), this.addClass("vjs-user-active"), this.trigger("useractive");
        return;
      }
      this.tech_ && this.tech_.one("mousemove", function(s) {
        s.stopPropagation(), s.preventDefault();
      }), this.userActivity_ = !1, this.removeClass("vjs-user-active"), this.addClass("vjs-user-inactive"), this.trigger("userinactive");
    }
  }, t.listenForUserActivity_ = function() {
    var n, s, o, u = bind(this, this.reportUserActivity), l = function(_) {
      (_.screenX !== s || _.screenY !== o) && (s = _.screenX, o = _.screenY, u());
    }, f = function() {
      u(), this.clearInterval(n), n = this.setInterval(u, 250);
    }, d = function(_) {
      u(), this.clearInterval(n);
    };
    this.on("mousedown", f), this.on("mousemove", l), this.on("mouseup", d), this.on("mouseleave", d);
    var h = this.getChild("controlBar");
    h && !IS_IOS && !IS_ANDROID && (h.on("mouseenter", function(m) {
      this.player().options_.inactivityTimeout !== 0 && (this.player().cache_.inactivityTimeout = this.player().options_.inactivityTimeout), this.player().options_.inactivityTimeout = 0;
    }), h.on("mouseleave", function(m) {
      this.player().options_.inactivityTimeout = this.player().cache_.inactivityTimeout;
    })), this.on("keydown", u), this.on("keyup", u);
    var p;
    this.setInterval(function() {
      if (!!this.userActivity_) {
        this.userActivity_ = !1, this.userActive(!0), this.clearTimeout(p);
        var m = this.options_.inactivityTimeout;
        m <= 0 || (p = this.setTimeout(function() {
          this.userActivity_ || this.userActive(!1);
        }, m));
      }
    }, 250);
  }, t.playbackRate = function(n) {
    if (n !== void 0) {
      this.techCall_("setPlaybackRate", n);
      return;
    }
    return this.tech_ && this.tech_.featuresPlaybackRate ? this.cache_.lastPlaybackRate || this.techGet_("playbackRate") : 1;
  }, t.defaultPlaybackRate = function(n) {
    return n !== void 0 ? this.techCall_("setDefaultPlaybackRate", n) : this.tech_ && this.tech_.featuresPlaybackRate ? this.techGet_("defaultPlaybackRate") : 1;
  }, t.isAudio = function(n) {
    if (n !== void 0) {
      this.isAudio_ = !!n;
      return;
    }
    return !!this.isAudio_;
  }, t.enableAudioOnlyUI_ = function() {
    var n = this;
    this.addClass("vjs-audio-only-mode");
    var s = this.children(), o = this.getChild("ControlBar"), u = o && o.currentHeight();
    s.forEach(function(l) {
      l !== o && l.el_ && !l.hasClass("vjs-hidden") && (l.hide(), n.audioOnlyCache_.hiddenChildren.push(l));
    }), this.audioOnlyCache_.playerHeight = this.currentHeight(), this.height(u), this.trigger("audioonlymodechange");
  }, t.disableAudioOnlyUI_ = function() {
    this.removeClass("vjs-audio-only-mode"), this.audioOnlyCache_.hiddenChildren.forEach(function(n) {
      return n.show();
    }), this.height(this.audioOnlyCache_.playerHeight), this.trigger("audioonlymodechange");
  }, t.audioOnlyMode = function(n) {
    var s = this;
    if (typeof n != "boolean" || n === this.audioOnlyMode_)
      return this.audioOnlyMode_;
    this.audioOnlyMode_ = n;
    var o = this.options_.Promise || window_1.Promise;
    if (o) {
      if (n) {
        var u = [];
        return this.isInPictureInPicture() && u.push(this.exitPictureInPicture()), this.isFullscreen() && u.push(this.exitFullscreen()), this.audioPosterMode() && u.push(this.audioPosterMode(!1)), o.all(u).then(function() {
          return s.enableAudioOnlyUI_();
        });
      }
      return o.resolve().then(function() {
        return s.disableAudioOnlyUI_();
      });
    }
    n ? (this.isInPictureInPicture() && this.exitPictureInPicture(), this.isFullscreen() && this.exitFullscreen(), this.enableAudioOnlyUI_()) : this.disableAudioOnlyUI_();
  }, t.enablePosterModeUI_ = function() {
    var n = this.tech_ && this.tech_;
    n.hide(), this.addClass("vjs-audio-poster-mode"), this.trigger("audiopostermodechange");
  }, t.disablePosterModeUI_ = function() {
    var n = this.tech_ && this.tech_;
    n.show(), this.removeClass("vjs-audio-poster-mode"), this.trigger("audiopostermodechange");
  }, t.audioPosterMode = function(n) {
    var s = this;
    if (typeof n != "boolean" || n === this.audioPosterMode_)
      return this.audioPosterMode_;
    this.audioPosterMode_ = n;
    var o = this.options_.Promise || window_1.Promise;
    if (o) {
      if (n) {
        if (this.audioOnlyMode()) {
          var u = this.audioOnlyMode(!1);
          return u.then(function() {
            s.enablePosterModeUI_();
          });
        }
        return o.resolve().then(function() {
          s.enablePosterModeUI_();
        });
      }
      return o.resolve().then(function() {
        s.disablePosterModeUI_();
      });
    }
    if (n) {
      this.audioOnlyMode() && this.audioOnlyMode(!1), this.enablePosterModeUI_();
      return;
    }
    this.disablePosterModeUI_();
  }, t.addTextTrack = function(n, s, o) {
    if (this.tech_)
      return this.tech_.addTextTrack(n, s, o);
  }, t.addRemoteTextTrack = function(n, s) {
    if (this.tech_)
      return this.tech_.addRemoteTextTrack(n, s);
  }, t.removeRemoteTextTrack = function(n) {
    n === void 0 && (n = {});
    var s = n, o = s.track;
    if (o || (o = n), this.tech_)
      return this.tech_.removeRemoteTextTrack(o);
  }, t.getVideoPlaybackQuality = function() {
    return this.techGet_("getVideoPlaybackQuality");
  }, t.videoWidth = function() {
    return this.tech_ && this.tech_.videoWidth && this.tech_.videoWidth() || 0;
  }, t.videoHeight = function() {
    return this.tech_ && this.tech_.videoHeight && this.tech_.videoHeight() || 0;
  }, t.language = function(n) {
    if (n === void 0)
      return this.language_;
    this.language_ !== String(n).toLowerCase() && (this.language_ = String(n).toLowerCase(), isEvented(this) && this.trigger("languagechange"));
  }, t.languages = function() {
    return mergeOptions$3(e.prototype.options_.languages, this.languages_);
  }, t.toJSON = function() {
    var n = mergeOptions$3(this.options_), s = n.tracks;
    n.tracks = [];
    for (var o = 0; o < s.length; o++) {
      var u = s[o];
      u = mergeOptions$3(u), u.player = void 0, n.tracks[o] = u;
    }
    return n;
  }, t.createModal = function(n, s) {
    var o = this;
    s = s || {}, s.content = n || "";
    var u = new ModalDialog(this, s);
    return this.addChild(u), u.on("dispose", function() {
      o.removeChild(u);
    }), u.open(), u;
  }, t.updateCurrentBreakpoint_ = function() {
    if (!!this.responsive())
      for (var n = this.currentBreakpoint(), s = this.currentWidth(), o = 0; o < BREAKPOINT_ORDER.length; o++) {
        var u = BREAKPOINT_ORDER[o], l = this.breakpoints_[u];
        if (s <= l) {
          if (n === u)
            return;
          n && this.removeClass(BREAKPOINT_CLASSES[n]), this.addClass(BREAKPOINT_CLASSES[u]), this.breakpoint_ = u;
          break;
        }
      }
  }, t.removeCurrentBreakpoint_ = function() {
    var n = this.currentBreakpointClass();
    this.breakpoint_ = "", n && this.removeClass(n);
  }, t.breakpoints = function(n) {
    return n === void 0 ? assign(this.breakpoints_) : (this.breakpoint_ = "", this.breakpoints_ = assign({}, DEFAULT_BREAKPOINTS, n), this.updateCurrentBreakpoint_(), assign(this.breakpoints_));
  }, t.responsive = function(n) {
    if (n === void 0)
      return this.responsive_;
    n = Boolean(n);
    var s = this.responsive_;
    if (n !== s)
      return this.responsive_ = n, n ? (this.on("playerresize", this.boundUpdateCurrentBreakpoint_), this.updateCurrentBreakpoint_()) : (this.off("playerresize", this.boundUpdateCurrentBreakpoint_), this.removeCurrentBreakpoint_()), n;
  }, t.currentBreakpoint = function() {
    return this.breakpoint_;
  }, t.currentBreakpointClass = function() {
    return BREAKPOINT_CLASSES[this.breakpoint_] || "";
  }, t.loadMedia = function(n, s) {
    var o = this;
    if (!(!n || typeof n != "object")) {
      this.reset(), this.cache_.media = mergeOptions$3(n);
      var u = this.cache_.media, l = u.artwork, f = u.poster, d = u.src, h = u.textTracks;
      !l && f && (this.cache_.media.artwork = [{
        src: f,
        type: getMimetype(f)
      }]), d && this.src(d), f && this.poster(f), Array.isArray(h) && h.forEach(function(p) {
        return o.addRemoteTextTrack(p, !1);
      }), this.ready(s);
    }
  }, t.getMedia = function() {
    if (!this.cache_.media) {
      var n = this.poster(), s = this.currentSources(), o = Array.prototype.map.call(this.remoteTextTracks(), function(l) {
        return {
          kind: l.kind,
          label: l.label,
          language: l.language,
          src: l.src
        };
      }), u = {
        src: s,
        textTracks: o
      };
      return n && (u.poster = n, u.artwork = [{
        src: u.poster,
        type: getMimetype(u.poster)
      }]), u;
    }
    return mergeOptions$3(this.cache_.media);
  }, e.getTagSettings = function(n) {
    var s = {
      sources: [],
      tracks: []
    }, o = getAttributes(n), u = o["data-setup"];
    if (hasClass(n, "vjs-fill") && (o.fill = !0), hasClass(n, "vjs-fluid") && (o.fluid = !0), u !== null) {
      var l = tuple(u || "{}"), f = l[0], d = l[1];
      f && log$1.error(f), assign(o, d);
    }
    if (assign(s, o), n.hasChildNodes())
      for (var h = n.childNodes, p = 0, m = h.length; p < m; p++) {
        var _ = h[p], w = _.nodeName.toLowerCase();
        w === "source" ? s.sources.push(getAttributes(_)) : w === "track" && s.tracks.push(getAttributes(_));
      }
    return s;
  }, t.flexNotSupported_ = function() {
    var n = document_1.createElement("i");
    return !("flexBasis" in n.style || "webkitFlexBasis" in n.style || "mozFlexBasis" in n.style || "msFlexBasis" in n.style || "msFlexOrder" in n.style);
  }, t.debug = function(n) {
    if (n === void 0)
      return this.debugEnabled_;
    n ? (this.trigger("debugon"), this.previousLogLevel_ = this.log.level, this.log.level("debug"), this.debugEnabled_ = !0) : (this.trigger("debugoff"), this.log.level(this.previousLogLevel_), this.previousLogLevel_ = void 0, this.debugEnabled_ = !1);
  }, t.playbackRates = function(n) {
    if (n === void 0)
      return this.cache_.playbackRates;
    !Array.isArray(n) || !n.every(function(s) {
      return typeof s == "number";
    }) || (this.cache_.playbackRates = n, this.trigger("playbackrateschange"));
  }, e;
}(Component$1);
ALL.names.forEach(function(r) {
  var e = ALL[r];
  Player.prototype[e.getterName] = function() {
    return this.tech_ ? this.tech_[e.getterName]() : (this[e.privateName] = this[e.privateName] || new e.ListClass(), this[e.privateName]);
  };
});
Player.prototype.crossorigin = Player.prototype.crossOrigin;
Player.players = {};
var navigator$1 = window_1.navigator;
Player.prototype.options_ = {
  techOrder: Tech.defaultTechOrder_,
  html5: {},
  inactivityTimeout: 2e3,
  playbackRates: [],
  liveui: !1,
  children: ["mediaLoader", "posterImage", "textTrackDisplay", "loadingSpinner", "bigPlayButton", "liveTracker", "controlBar", "errorDisplay", "textTrackSettings", "resizeManager"],
  language: navigator$1 && (navigator$1.languages && navigator$1.languages[0] || navigator$1.userLanguage || navigator$1.language) || "en",
  languages: {},
  notSupportedMessage: "No compatible source was found for this media.",
  normalizeAutoplay: !1,
  fullscreen: {
    options: {
      navigationUI: "hide"
    }
  },
  breakpoints: {},
  responsive: !1,
  audioOnlyMode: !1,
  audioPosterMode: !1
};
[
  "ended",
  "seeking",
  "seekable",
  "networkState",
  "readyState"
].forEach(function(r) {
  Player.prototype[r] = function() {
    return this.techGet_(r);
  };
});
TECH_EVENTS_RETRIGGER.forEach(function(r) {
  Player.prototype["handleTech" + toTitleCase$1(r) + "_"] = function() {
    return this.trigger(r);
  };
});
Component$1.registerComponent("Player", Player);
var BASE_PLUGIN_NAME = "plugin", PLUGIN_CACHE_KEY = "activePlugins_", pluginStorage = {}, pluginExists = function r(e) {
  return pluginStorage.hasOwnProperty(e);
}, getPlugin = function r(e) {
  return pluginExists(e) ? pluginStorage[e] : void 0;
}, markPluginAsActive = function r(e, t) {
  e[PLUGIN_CACHE_KEY] = e[PLUGIN_CACHE_KEY] || {}, e[PLUGIN_CACHE_KEY][t] = !0;
}, triggerSetupEvent = function r(e, t, a) {
  var n = (a ? "before" : "") + "pluginsetup";
  e.trigger(n, t), e.trigger(n + ":" + t.name, t);
}, createBasicPlugin = function r(e, t) {
  var a = function() {
    triggerSetupEvent(this, {
      name: e,
      plugin: t,
      instance: null
    }, !0);
    var s = t.apply(this, arguments);
    return markPluginAsActive(this, e), triggerSetupEvent(this, {
      name: e,
      plugin: t,
      instance: s
    }), s;
  };
  return Object.keys(t).forEach(function(n) {
    a[n] = t[n];
  }), a;
}, createPluginFactory = function r(e, t) {
  return t.prototype.name = e, function() {
    triggerSetupEvent(this, {
      name: e,
      plugin: t,
      instance: null
    }, !0);
    for (var a = arguments.length, n = new Array(a), s = 0; s < a; s++)
      n[s] = arguments[s];
    var o = _construct(t, [this].concat(n));
    return this[e] = function() {
      return o;
    }, triggerSetupEvent(this, o.getEventHash()), o;
  };
}, Plugin = /* @__PURE__ */ function() {
  function r(t) {
    if (this.constructor === r)
      throw new Error("Plugin must be sub-classed; not directly instantiated.");
    this.player = t, this.log || (this.log = this.player.log.createLogger(this.name)), evented(this), delete this.trigger, stateful(this, this.constructor.defaultState), markPluginAsActive(t, this.name), this.dispose = this.dispose.bind(this), t.on("dispose", this.dispose);
  }
  var e = r.prototype;
  return e.version = function() {
    return this.constructor.VERSION;
  }, e.getEventHash = function(a) {
    return a === void 0 && (a = {}), a.name = this.name, a.plugin = this.constructor, a.instance = this, a;
  }, e.trigger = function(a, n) {
    return n === void 0 && (n = {}), trigger(this.eventBusEl_, a, this.getEventHash(n));
  }, e.handleStateChanged = function(a) {
  }, e.dispose = function() {
    var a = this.name, n = this.player;
    this.trigger("dispose"), this.off(), n.off("dispose", this.dispose), n[PLUGIN_CACHE_KEY][a] = !1, this.player = this.state = null, n[a] = createPluginFactory(a, pluginStorage[a]);
  }, r.isBasic = function(a) {
    var n = typeof a == "string" ? getPlugin(a) : a;
    return typeof n == "function" && !r.prototype.isPrototypeOf(n.prototype);
  }, r.registerPlugin = function(a, n) {
    if (typeof a != "string")
      throw new Error('Illegal plugin name, "' + a + '", must be a string, was ' + typeof a + ".");
    if (pluginExists(a))
      log$1.warn('A plugin named "' + a + '" already exists. You may want to avoid re-registering plugins!');
    else if (Player.prototype.hasOwnProperty(a))
      throw new Error('Illegal plugin name, "' + a + '", cannot share a name with an existing player method!');
    if (typeof n != "function")
      throw new Error('Illegal plugin for "' + a + '", must be a function, was ' + typeof n + ".");
    return pluginStorage[a] = n, a !== BASE_PLUGIN_NAME && (r.isBasic(n) ? Player.prototype[a] = createBasicPlugin(a, n) : Player.prototype[a] = createPluginFactory(a, n)), n;
  }, r.deregisterPlugin = function(a) {
    if (a === BASE_PLUGIN_NAME)
      throw new Error("Cannot de-register base plugin.");
    pluginExists(a) && (delete pluginStorage[a], delete Player.prototype[a]);
  }, r.getPlugins = function(a) {
    a === void 0 && (a = Object.keys(pluginStorage));
    var n;
    return a.forEach(function(s) {
      var o = getPlugin(s);
      o && (n = n || {}, n[s] = o);
    }), n;
  }, r.getPluginVersion = function(a) {
    var n = getPlugin(a);
    return n && n.VERSION || "";
  }, r;
}();
Plugin.getPlugin = getPlugin;
Plugin.BASE_PLUGIN_NAME = BASE_PLUGIN_NAME;
Plugin.registerPlugin(BASE_PLUGIN_NAME, Plugin);
Player.prototype.usingPlugin = function(r) {
  return !!this[PLUGIN_CACHE_KEY] && this[PLUGIN_CACHE_KEY][r] === !0;
};
Player.prototype.hasPlugin = function(r) {
  return !!pluginExists(r);
};
var extend = function r(e, t) {
  t === void 0 && (t = {});
  var a = function() {
    e.apply(this, arguments);
  }, n = {};
  typeof t == "object" ? (t.constructor !== Object.prototype.constructor && (a = t.constructor), n = t) : typeof t == "function" && (a = t), _inherits(a, e), e && (a.super_ = e);
  for (var s in n)
    n.hasOwnProperty(s) && (a.prototype[s] = n[s]);
  return a;
}, normalizeId = function r(e) {
  return e.indexOf("#") === 0 ? e.slice(1) : e;
};
function videojs(r, e, t) {
  var a = videojs.getPlayer(r);
  if (a)
    return e && log$1.warn('Player "' + r + '" is already initialised. Options will not be applied.'), t && a.ready(t), a;
  var n = typeof r == "string" ? $("#" + normalizeId(r)) : r;
  if (!isEl(n))
    throw new TypeError("The element or ID supplied is not valid. (videojs)");
  (!n.ownerDocument.defaultView || !n.ownerDocument.body.contains(n)) && log$1.warn("The element supplied is not included in the DOM"), e = e || {}, e.restoreEl === !0 && (e.restoreEl = (n.parentNode && n.parentNode.hasAttribute("data-vjs-player") ? n.parentNode : n).cloneNode(!0)), hooks("beforesetup").forEach(function(o) {
    var u = o(n, mergeOptions$3(e));
    if (!isObject(u) || Array.isArray(u)) {
      log$1.error("please return an object in beforesetup hooks");
      return;
    }
    e = mergeOptions$3(e, u);
  });
  var s = Component$1.getComponent("Player");
  return a = new s(n, e, t), hooks("setup").forEach(function(o) {
    return o(a);
  }), a;
}
videojs.hooks_ = hooks_;
videojs.hooks = hooks;
videojs.hook = hook;
videojs.hookOnce = hookOnce;
videojs.removeHook = removeHook;
if (window_1.VIDEOJS_NO_DYNAMIC_STYLE !== !0 && isReal()) {
  var style = $(".vjs-styles-defaults");
  if (!style) {
    style = createStyleElement("vjs-styles-defaults");
    var head = $("head");
    head && head.insertBefore(style, head.firstChild), setTextContent(style, `
      .video-js {
        width: 300px;
        height: 150px;
      }

      .vjs-fluid:not(.vjs-audio-only-mode) {
        padding-top: 56.25%
      }
    `);
  }
}
autoSetupTimeout(1, videojs);
videojs.VERSION = version$5;
videojs.options = Player.prototype.options_;
videojs.getPlayers = function() {
  return Player.players;
};
videojs.getPlayer = function(r) {
  var e = Player.players, t;
  if (typeof r == "string") {
    var a = normalizeId(r), n = e[a];
    if (n)
      return n;
    t = $("#" + a);
  } else
    t = r;
  if (isEl(t)) {
    var s = t, o = s.player, u = s.playerId;
    if (o || e[u])
      return o || e[u];
  }
};
videojs.getAllPlayers = function() {
  return Object.keys(Player.players).map(function(r) {
    return Player.players[r];
  }).filter(Boolean);
};
videojs.players = Player.players;
videojs.getComponent = Component$1.getComponent;
videojs.registerComponent = function(r, e) {
  Tech.isTech(e) && log$1.warn("The " + r + " tech was registered as a component. It should instead be registered using videojs.registerTech(name, tech)"), Component$1.registerComponent.call(Component$1, r, e);
};
videojs.getTech = Tech.getTech;
videojs.registerTech = Tech.registerTech;
videojs.use = use;
Object.defineProperty(videojs, "middleware", {
  value: {},
  writeable: !1,
  enumerable: !0
});
Object.defineProperty(videojs.middleware, "TERMINATOR", {
  value: TERMINATOR,
  writeable: !1,
  enumerable: !0
});
videojs.browser = browser;
videojs.TOUCH_ENABLED = TOUCH_ENABLED;
videojs.extend = extend;
videojs.mergeOptions = mergeOptions$3;
videojs.bind = bind;
videojs.registerPlugin = Plugin.registerPlugin;
videojs.deregisterPlugin = Plugin.deregisterPlugin;
videojs.plugin = function(r, e) {
  return log$1.warn("videojs.plugin() is deprecated; use videojs.registerPlugin() instead"), Plugin.registerPlugin(r, e);
};
videojs.getPlugins = Plugin.getPlugins;
videojs.getPlugin = Plugin.getPlugin;
videojs.getPluginVersion = Plugin.getPluginVersion;
videojs.addLanguage = function(r, e) {
  var t;
  return r = ("" + r).toLowerCase(), videojs.options.languages = mergeOptions$3(videojs.options.languages, (t = {}, t[r] = e, t)), videojs.options.languages[r];
};
videojs.log = log$1;
videojs.createLogger = createLogger;
videojs.createTimeRange = videojs.createTimeRanges = createTimeRanges;
videojs.formatTime = formatTime;
videojs.setFormatTime = setFormatTime;
videojs.resetFormatTime = resetFormatTime;
videojs.parseUrl = parseUrl;
videojs.isCrossOrigin = isCrossOrigin;
videojs.EventTarget = EventTarget$2;
videojs.on = on;
videojs.one = one;
videojs.off = off;
videojs.trigger = trigger;
videojs.xhr = lib.exports;
videojs.TextTrack = TextTrack;
videojs.AudioTrack = AudioTrack;
videojs.VideoTrack = VideoTrack;
["isEl", "isTextNode", "createEl", "hasClass", "addClass", "removeClass", "toggleClass", "setAttributes", "getAttributes", "emptyEl", "appendContent", "insertContent"].forEach(function(r) {
  videojs[r] = function() {
    return log$1.warn("videojs." + r + "() is deprecated; use videojs.dom." + r + "() instead"), Dom[r].apply(null, arguments);
  };
});
videojs.computedStyle = computedStyle;
videojs.dom = Dom;
videojs.url = Url;
videojs.defineLazyProperty = defineLazyProperty;
videojs.addLanguage("en", {
  "Non-Fullscreen": "Exit Fullscreen"
});
/*! @name @videojs/http-streaming @version 2.14.2 @license Apache-2.0 */
var resolveUrl = resolveUrl$1, resolveManifestRedirect = function r(e, t, a) {
  return e && a && a.responseURL && t !== a.responseURL ? a.responseURL : t;
}, logger = function r(e) {
  return videojs.log.debug ? videojs.log.debug.bind(videojs, "VHS:", e + " >") : function() {
  };
}, TIME_FUDGE_FACTOR = 1 / 30, SAFE_TIME_DELTA = TIME_FUDGE_FACTOR * 3, filterRanges = function r(e, t) {
  var a = [], n;
  if (e && e.length)
    for (n = 0; n < e.length; n++)
      t(e.start(n), e.end(n)) && a.push([e.start(n), e.end(n)]);
  return videojs.createTimeRanges(a);
}, findRange = function r(e, t) {
  return filterRanges(e, function(a, n) {
    return a - SAFE_TIME_DELTA <= t && n + SAFE_TIME_DELTA >= t;
  });
}, findNextRange = function r(e, t) {
  return filterRanges(e, function(a) {
    return a - TIME_FUDGE_FACTOR >= t;
  });
}, findGaps = function r(e) {
  if (e.length < 2)
    return videojs.createTimeRanges();
  for (var t = [], a = 1; a < e.length; a++) {
    var n = e.end(a - 1), s = e.start(a);
    t.push([n, s]);
  }
  return videojs.createTimeRanges(t);
}, bufferIntersection = function r(e, t) {
  var a = null, n = null, s = 0, o = [], u = [];
  if (!e || !e.length || !t || !t.length)
    return videojs.createTimeRange();
  for (var l = e.length; l--; )
    o.push({
      time: e.start(l),
      type: "start"
    }), o.push({
      time: e.end(l),
      type: "end"
    });
  for (l = t.length; l--; )
    o.push({
      time: t.start(l),
      type: "start"
    }), o.push({
      time: t.end(l),
      type: "end"
    });
  for (o.sort(function(f, d) {
    return f.time - d.time;
  }), l = 0; l < o.length; l++)
    o[l].type === "start" ? (s++, s === 2 && (a = o[l].time)) : o[l].type === "end" && (s--, s === 1 && (n = o[l].time)), a !== null && n !== null && (u.push([a, n]), a = null, n = null);
  return videojs.createTimeRanges(u);
}, printableRange = function r(e) {
  var t = [];
  if (!e || !e.length)
    return "";
  for (var a = 0; a < e.length; a++)
    t.push(e.start(a) + " => " + e.end(a));
  return t.join(", ");
}, timeUntilRebuffer = function r(e, t, a) {
  a === void 0 && (a = 1);
  var n = e.length ? e.end(e.length - 1) : 0;
  return (n - t) / a;
}, timeRangesToArray = function r(e) {
  for (var t = [], a = 0; a < e.length; a++)
    t.push({
      start: e.start(a),
      end: e.end(a)
    });
  return t;
}, isRangeDifferent = function r(e, t) {
  if (e === t)
    return !1;
  if (!e && t || !t && e || e.length !== t.length)
    return !0;
  for (var a = 0; a < e.length; a++)
    if (e.start(a) !== t.start(a) || e.end(a) !== t.end(a))
      return !0;
  return !1;
}, lastBufferedEnd = function r(e) {
  if (!(!e || !e.length || !e.end))
    return e.end(e.length - 1);
}, timeAheadOf = function r(e, t) {
  var a = 0;
  if (!e || !e.length)
    return a;
  for (var n = 0; n < e.length; n++) {
    var s = e.start(n), o = e.end(n);
    if (!(t > o)) {
      if (t > s && t <= o) {
        a += o - t;
        continue;
      }
      a += o - s;
    }
  }
  return a;
}, createTimeRange = videojs.createTimeRange, segmentDurationWithParts = function r(e, t) {
  if (!t.preload)
    return t.duration;
  var a = 0;
  return (t.parts || []).forEach(function(n) {
    a += n.duration;
  }), (t.preloadHints || []).forEach(function(n) {
    n.type === "PART" && (a += e.partTargetDuration);
  }), a;
}, getPartsAndSegments = function r(e) {
  return (e.segments || []).reduce(function(t, a, n) {
    return a.parts ? a.parts.forEach(function(s, o) {
      t.push({
        duration: s.duration,
        segmentIndex: n,
        partIndex: o,
        part: s,
        segment: a
      });
    }) : t.push({
      duration: a.duration,
      segmentIndex: n,
      partIndex: null,
      segment: a,
      part: null
    }), t;
  }, []);
}, getLastParts = function r(e) {
  var t = e.segments && e.segments.length && e.segments[e.segments.length - 1];
  return t && t.parts || [];
}, getKnownPartCount = function r(e) {
  var t = e.preloadSegment;
  if (!!t) {
    var a = t.parts, n = t.preloadHints, s = (n || []).reduce(function(o, u) {
      return o + (u.type === "PART" ? 1 : 0);
    }, 0);
    return s += a && a.length ? a.length : 0, s;
  }
}, liveEdgeDelay = function r(e, t) {
  if (t.endList)
    return 0;
  if (e && e.suggestedPresentationDelay)
    return e.suggestedPresentationDelay;
  var a = getLastParts(t).length > 0;
  return a && t.serverControl && t.serverControl.partHoldBack ? t.serverControl.partHoldBack : a && t.partTargetDuration ? t.partTargetDuration * 3 : t.serverControl && t.serverControl.holdBack ? t.serverControl.holdBack : t.targetDuration ? t.targetDuration * 3 : 0;
}, backwardDuration = function r(e, t) {
  var a = 0, n = t - e.mediaSequence, s = e.segments[n];
  if (s) {
    if (typeof s.start < "u")
      return {
        result: s.start,
        precise: !0
      };
    if (typeof s.end < "u")
      return {
        result: s.end - s.duration,
        precise: !0
      };
  }
  for (; n--; ) {
    if (s = e.segments[n], typeof s.end < "u")
      return {
        result: a + s.end,
        precise: !0
      };
    if (a += segmentDurationWithParts(e, s), typeof s.start < "u")
      return {
        result: a + s.start,
        precise: !0
      };
  }
  return {
    result: a,
    precise: !1
  };
}, forwardDuration = function r(e, t) {
  for (var a = 0, n, s = t - e.mediaSequence; s < e.segments.length; s++) {
    if (n = e.segments[s], typeof n.start < "u")
      return {
        result: n.start - a,
        precise: !0
      };
    if (a += segmentDurationWithParts(e, n), typeof n.end < "u")
      return {
        result: n.end - a,
        precise: !0
      };
  }
  return {
    result: -1,
    precise: !1
  };
}, intervalDuration = function r(e, t, a) {
  if (typeof t > "u" && (t = e.mediaSequence + e.segments.length), t < e.mediaSequence)
    return 0;
  var n = backwardDuration(e, t);
  if (n.precise)
    return n.result;
  var s = forwardDuration(e, t);
  return s.precise ? s.result : n.result + a;
}, duration = function r(e, t, a) {
  if (!e)
    return 0;
  if (typeof a != "number" && (a = 0), typeof t > "u") {
    if (e.totalDuration)
      return e.totalDuration;
    if (!e.endList)
      return window_1.Infinity;
  }
  return intervalDuration(e, t, a);
}, sumDurations = function r(e) {
  var t = e.defaultDuration, a = e.durationList, n = e.startIndex, s = e.endIndex, o = 0;
  if (n > s) {
    var u = [s, n];
    n = u[0], s = u[1];
  }
  if (n < 0) {
    for (var l = n; l < Math.min(0, s); l++)
      o += t;
    n = 0;
  }
  for (var f = n; f < s; f++)
    o += a[f].duration;
  return o;
}, playlistEnd = function r(e, t, a, n) {
  if (!e || !e.segments)
    return null;
  if (e.endList)
    return duration(e);
  if (t === null)
    return null;
  t = t || 0;
  var s = intervalDuration(e, e.mediaSequence + e.segments.length, t);
  return a && (n = typeof n == "number" ? n : liveEdgeDelay(null, e), s -= n), Math.max(0, s);
}, seekable = function r(e, t, a) {
  var n = !0, s = t || 0, o = playlistEnd(e, t, n, a);
  return o === null ? createTimeRange() : createTimeRange(s, o);
}, getMediaInfoForTime = function r(e) {
  for (var t = e.playlist, a = e.currentTime, n = e.startingSegmentIndex, s = e.startingPartIndex, o = e.startTime, u = e.experimentalExactManifestTimings, l = a - o, f = getPartsAndSegments(t), d = 0, h = 0; h < f.length; h++) {
    var p = f[h];
    if (n === p.segmentIndex && !(typeof s == "number" && typeof p.partIndex == "number" && s !== p.partIndex)) {
      d = h;
      break;
    }
  }
  if (l < 0) {
    if (d > 0)
      for (var m = d - 1; m >= 0; m--) {
        var _ = f[m];
        if (l += _.duration, u) {
          if (l < 0)
            continue;
        } else if (l + TIME_FUDGE_FACTOR <= 0)
          continue;
        return {
          partIndex: _.partIndex,
          segmentIndex: _.segmentIndex,
          startTime: o - sumDurations({
            defaultDuration: t.targetDuration,
            durationList: f,
            startIndex: d,
            endIndex: m
          })
        };
      }
    return {
      partIndex: f[0] && f[0].partIndex || null,
      segmentIndex: f[0] && f[0].segmentIndex || 0,
      startTime: a
    };
  }
  if (d < 0) {
    for (var w = d; w < 0; w++)
      if (l -= t.targetDuration, l < 0)
        return {
          partIndex: f[0] && f[0].partIndex || null,
          segmentIndex: f[0] && f[0].segmentIndex || 0,
          startTime: a
        };
    d = 0;
  }
  for (var S = d; S < f.length; S++) {
    var O = f[S];
    if (l -= O.duration, u) {
      if (l > 0)
        continue;
    } else if (l - TIME_FUDGE_FACTOR >= 0)
      continue;
    return {
      partIndex: O.partIndex,
      segmentIndex: O.segmentIndex,
      startTime: o + sumDurations({
        defaultDuration: t.targetDuration,
        durationList: f,
        startIndex: d,
        endIndex: S
      })
    };
  }
  return {
    segmentIndex: f[f.length - 1].segmentIndex,
    partIndex: f[f.length - 1].partIndex,
    startTime: a
  };
}, isBlacklisted = function r(e) {
  return e.excludeUntil && e.excludeUntil > Date.now();
}, isIncompatible = function r(e) {
  return e.excludeUntil && e.excludeUntil === 1 / 0;
}, isEnabled = function r(e) {
  var t = isBlacklisted(e);
  return !e.disabled && !t;
}, isDisabled = function r(e) {
  return e.disabled;
}, isAes = function r(e) {
  for (var t = 0; t < e.segments.length; t++)
    if (e.segments[t].key)
      return !0;
  return !1;
}, hasAttribute = function r(e, t) {
  return t.attributes && t.attributes[e];
}, estimateSegmentRequestTime = function r(e, t, a, n) {
  if (n === void 0 && (n = 0), !hasAttribute("BANDWIDTH", a))
    return NaN;
  var s = e * a.attributes.BANDWIDTH;
  return (s - n * 8) / t;
}, isLowestEnabledRendition = function r(e, t) {
  if (e.playlists.length === 1)
    return !0;
  var a = t.attributes.BANDWIDTH || Number.MAX_VALUE;
  return e.playlists.filter(function(n) {
    return isEnabled(n) ? (n.attributes.BANDWIDTH || 0) < a : !1;
  }).length === 0;
}, playlistMatch = function r(e, t) {
  return !e && !t || !e && t || e && !t ? !1 : !!(e === t || e.id && t.id && e.id === t.id || e.resolvedUri && t.resolvedUri && e.resolvedUri === t.resolvedUri || e.uri && t.uri && e.uri === t.uri);
}, someAudioVariant = function r(e, t) {
  var a = e && e.mediaGroups && e.mediaGroups.AUDIO || {}, n = !1;
  for (var s in a) {
    for (var o in a[s])
      if (n = t(a[s][o]), n)
        break;
    if (n)
      break;
  }
  return !!n;
}, isAudioOnly = function r(e) {
  if (!e || !e.playlists || !e.playlists.length) {
    var t = someAudioVariant(e, function(o) {
      return o.playlists && o.playlists.length || o.uri;
    });
    return t;
  }
  for (var a = function(u) {
    var l = e.playlists[u], f = l.attributes && l.attributes.CODECS;
    if (f && f.split(",").every(function(h) {
      return isAudioCodec(h);
    }))
      return "continue";
    var d = someAudioVariant(e, function(h) {
      return playlistMatch(l, h);
    });
    return d ? "continue" : {
      v: !1
    };
  }, n = 0; n < e.playlists.length; n++) {
    var s = a(n);
    if (s !== "continue" && typeof s == "object")
      return s.v;
  }
  return !0;
}, Playlist = {
  liveEdgeDelay,
  duration,
  seekable,
  getMediaInfoForTime,
  isEnabled,
  isDisabled,
  isBlacklisted,
  isIncompatible,
  playlistEnd,
  isAes,
  hasAttribute,
  estimateSegmentRequestTime,
  isLowestEnabledRendition,
  isAudioOnly,
  playlistMatch,
  segmentDurationWithParts
}, log = videojs.log, createPlaylistID = function r(e, t) {
  return e + "-" + t;
}, parseManifest = function r(e) {
  var t = e.onwarn, a = e.oninfo, n = e.manifestString, s = e.customTagParsers, o = s === void 0 ? [] : s, u = e.customTagMappers, l = u === void 0 ? [] : u, f = e.experimentalLLHLS, d = new Parser();
  t && d.on("warn", t), a && d.on("info", a), o.forEach(function(w) {
    return d.addParser(w);
  }), l.forEach(function(w) {
    return d.addTagMapper(w);
  }), d.push(n), d.end();
  var h = d.manifest;
  if (f || (["preloadSegment", "skip", "serverControl", "renditionReports", "partInf", "partTargetDuration"].forEach(function(w) {
    h.hasOwnProperty(w) && delete h[w];
  }), h.segments && h.segments.forEach(function(w) {
    ["parts", "preloadHints"].forEach(function(S) {
      w.hasOwnProperty(S) && delete w[S];
    });
  })), !h.targetDuration) {
    var p = 10;
    h.segments && h.segments.length && (p = h.segments.reduce(function(w, S) {
      return Math.max(w, S.duration);
    }, 0)), t && t("manifest has no targetDuration defaulting to " + p), h.targetDuration = p;
  }
  var m = getLastParts(h);
  if (m.length && !h.partTargetDuration) {
    var _ = m.reduce(function(w, S) {
      return Math.max(w, S.duration);
    }, 0);
    t && (t("manifest has no partTargetDuration defaulting to " + _), log.error("LL-HLS manifest has parts but lacks required #EXT-X-PART-INF:PART-TARGET value. See https://datatracker.ietf.org/doc/html/draft-pantos-hls-rfc8216bis-09#section-4.4.3.7. Playback is not guaranteed.")), h.partTargetDuration = _;
  }
  return h;
}, forEachMediaGroup = function r(e, t) {
  !e.mediaGroups || ["AUDIO", "SUBTITLES"].forEach(function(a) {
    if (!!e.mediaGroups[a])
      for (var n in e.mediaGroups[a])
        for (var s in e.mediaGroups[a][n]) {
          var o = e.mediaGroups[a][n][s];
          t(o, a, n, s);
        }
  });
}, setupMediaPlaylist = function r(e) {
  var t = e.playlist, a = e.uri, n = e.id;
  t.id = n, t.playlistErrors_ = 0, a && (t.uri = a), t.attributes = t.attributes || {};
}, setupMediaPlaylists = function r(e) {
  for (var t = e.playlists.length; t--; ) {
    var a = e.playlists[t];
    setupMediaPlaylist({
      playlist: a,
      id: createPlaylistID(t, a.uri)
    }), a.resolvedUri = resolveUrl(e.uri, a.uri), e.playlists[a.id] = a, e.playlists[a.uri] = a, a.attributes.BANDWIDTH || log.warn("Invalid playlist STREAM-INF detected. Missing BANDWIDTH attribute.");
  }
}, resolveMediaGroupUris = function r(e) {
  forEachMediaGroup(e, function(t) {
    t.uri && (t.resolvedUri = resolveUrl(e.uri, t.uri));
  });
}, masterForMedia = function r(e, t) {
  var a = createPlaylistID(0, t), n = {
    mediaGroups: {
      AUDIO: {},
      VIDEO: {},
      "CLOSED-CAPTIONS": {},
      SUBTITLES: {}
    },
    uri: window_1.location.href,
    resolvedUri: window_1.location.href,
    playlists: [{
      uri: t,
      id: a,
      resolvedUri: t,
      attributes: {}
    }]
  };
  return n.playlists[a] = n.playlists[0], n.playlists[t] = n.playlists[0], n;
}, addPropertiesToMaster = function r(e, t) {
  e.uri = t;
  for (var a = 0; a < e.playlists.length; a++)
    if (!e.playlists[a].uri) {
      var n = "placeholder-uri-" + a;
      e.playlists[a].uri = n;
    }
  var s = isAudioOnly(e);
  forEachMediaGroup(e, function(o, u, l, f) {
    var d = "placeholder-uri-" + u + "-" + l + "-" + f;
    if (!o.playlists || !o.playlists.length) {
      if (s && u === "AUDIO" && !o.uri)
        for (var h = 0; h < e.playlists.length; h++) {
          var p = e.playlists[h];
          if (p.attributes && p.attributes.AUDIO && p.attributes.AUDIO === l)
            return;
        }
      o.playlists = [_extends$2({}, o)];
    }
    o.playlists.forEach(function(m, _) {
      var w = createPlaylistID(_, d);
      m.uri ? m.resolvedUri = m.resolvedUri || resolveUrl(e.uri, m.uri) : (m.uri = _ === 0 ? d : w, m.resolvedUri = m.uri), m.id = m.id || w, m.attributes = m.attributes || {}, e.playlists[m.id] = m, e.playlists[m.uri] = m;
    });
  }), setupMediaPlaylists(e), resolveMediaGroupUris(e);
}, mergeOptions$2 = videojs.mergeOptions, EventTarget$1 = videojs.EventTarget, addLLHLSQueryDirectives = function r(e, t) {
  if (t.endList || !t.serverControl)
    return e;
  var a = {};
  if (t.serverControl.canBlockReload) {
    var n = t.preloadSegment, s = t.mediaSequence + t.segments.length;
    if (n) {
      var o = n.parts || [], u = getKnownPartCount(t) - 1;
      u > -1 && u !== o.length - 1 && (a._HLS_part = u), (u > -1 || o.length) && s--;
    }
    a._HLS_msn = s;
  }
  if (t.serverControl && t.serverControl.canSkipUntil && (a._HLS_skip = t.serverControl.canSkipDateranges ? "v2" : "YES"), Object.keys(a).length) {
    var l = new window_1.URL(e);
    ["_HLS_skip", "_HLS_msn", "_HLS_part"].forEach(function(f) {
      !a.hasOwnProperty(f) || l.searchParams.set(f, a[f]);
    }), e = l.toString();
  }
  return e;
}, updateSegment = function r(e, t) {
  if (!e)
    return t;
  var a = mergeOptions$2(e, t);
  if (e.preloadHints && !t.preloadHints && delete a.preloadHints, e.parts && !t.parts)
    delete a.parts;
  else if (e.parts && t.parts)
    for (var n = 0; n < t.parts.length; n++)
      e.parts && e.parts[n] && (a.parts[n] = mergeOptions$2(e.parts[n], t.parts[n]));
  return !e.skipped && t.skipped && (a.skipped = !1), e.preload && !t.preload && (a.preload = !1), a;
}, updateSegments = function r(e, t, a) {
  var n = e.slice(), s = t.slice();
  a = a || 0;
  for (var o = [], u, l = 0; l < s.length; l++) {
    var f = n[l + a], d = s[l];
    f ? (u = f.map || u, o.push(updateSegment(f, d))) : (u && !d.map && (d.map = u), o.push(d));
  }
  return o;
}, resolveSegmentUris = function r(e, t) {
  !e.resolvedUri && e.uri && (e.resolvedUri = resolveUrl(t, e.uri)), e.key && !e.key.resolvedUri && (e.key.resolvedUri = resolveUrl(t, e.key.uri)), e.map && !e.map.resolvedUri && (e.map.resolvedUri = resolveUrl(t, e.map.uri)), e.map && e.map.key && !e.map.key.resolvedUri && (e.map.key.resolvedUri = resolveUrl(t, e.map.key.uri)), e.parts && e.parts.length && e.parts.forEach(function(a) {
    a.resolvedUri || (a.resolvedUri = resolveUrl(t, a.uri));
  }), e.preloadHints && e.preloadHints.length && e.preloadHints.forEach(function(a) {
    a.resolvedUri || (a.resolvedUri = resolveUrl(t, a.uri));
  });
}, getAllSegments = function r(e) {
  var t = e.segments || [], a = e.preloadSegment;
  if (a && a.parts && a.parts.length) {
    if (a.preloadHints) {
      for (var n = 0; n < a.preloadHints.length; n++)
        if (a.preloadHints[n].type === "MAP")
          return t;
    }
    a.duration = e.targetDuration, a.preload = !0, t.push(a);
  }
  return t;
}, isPlaylistUnchanged = function r(e, t) {
  return e === t || e.segments && t.segments && e.segments.length === t.segments.length && e.endList === t.endList && e.mediaSequence === t.mediaSequence && e.preloadSegment === t.preloadSegment;
}, updateMaster$1 = function r(e, t, a) {
  a === void 0 && (a = isPlaylistUnchanged);
  var n = mergeOptions$2(e, {}), s = n.playlists[t.id];
  if (!s || a(s, t))
    return null;
  t.segments = getAllSegments(t);
  var o = mergeOptions$2(s, t);
  if (o.preloadSegment && !t.preloadSegment && delete o.preloadSegment, s.segments) {
    if (t.skip) {
      t.segments = t.segments || [];
      for (var u = 0; u < t.skip.skippedSegments; u++)
        t.segments.unshift({
          skipped: !0
        });
    }
    o.segments = updateSegments(s.segments, t.segments, t.mediaSequence - s.mediaSequence);
  }
  o.segments.forEach(function(f) {
    resolveSegmentUris(f, o.resolvedUri);
  });
  for (var l = 0; l < n.playlists.length; l++)
    n.playlists[l].id === t.id && (n.playlists[l] = o);
  return n.playlists[t.id] = o, n.playlists[t.uri] = o, forEachMediaGroup(e, function(f, d, h, p) {
    if (!!f.playlists)
      for (var m = 0; m < f.playlists.length; m++)
        t.id === f.playlists[m].id && (f.playlists[m] = o);
  }), n;
}, refreshDelay = function r(e, t) {
  var a = e.segments || [], n = a[a.length - 1], s = n && n.parts && n.parts[n.parts.length - 1], o = s && s.duration || n && n.duration;
  return t && o ? o * 1e3 : (e.partTargetDuration || e.targetDuration || 10) * 500;
}, PlaylistLoader = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    var o;
    if (s === void 0 && (s = {}), o = r.call(this) || this, !a)
      throw new Error("A non-empty playlist URL or object is required");
    o.logger_ = logger("PlaylistLoader");
    var u = s, l = u.withCredentials, f = l === void 0 ? !1 : l, d = u.handleManifestRedirects, h = d === void 0 ? !1 : d;
    o.src = a, o.vhs_ = n, o.withCredentials = f, o.handleManifestRedirects = h;
    var p = n.options_;
    return o.customTagParsers = p && p.customTagParsers || [], o.customTagMappers = p && p.customTagMappers || [], o.experimentalLLHLS = p && p.experimentalLLHLS || !1, videojs.browser.IE_VERSION && (o.experimentalLLHLS = !1), o.state = "HAVE_NOTHING", o.handleMediaupdatetimeout_ = o.handleMediaupdatetimeout_.bind(_assertThisInitialized$1(o)), o.on("mediaupdatetimeout", o.handleMediaupdatetimeout_), o;
  }
  var t = e.prototype;
  return t.handleMediaupdatetimeout_ = function() {
    var n = this;
    if (this.state === "HAVE_METADATA") {
      var s = this.media(), o = resolveUrl(this.master.uri, s.uri);
      this.experimentalLLHLS && (o = addLLHLSQueryDirectives(o, s)), this.state = "HAVE_CURRENT_METADATA", this.request = this.vhs_.xhr({
        uri: o,
        withCredentials: this.withCredentials
      }, function(u, l) {
        if (!!n.request) {
          if (u)
            return n.playlistRequestError(n.request, n.media(), "HAVE_METADATA");
          n.haveMetadata({
            playlistString: n.request.responseText,
            url: n.media().uri,
            id: n.media().id
          });
        }
      });
    }
  }, t.playlistRequestError = function(n, s, o) {
    var u = s.uri, l = s.id;
    this.request = null, o && (this.state = o), this.error = {
      playlist: this.master.playlists[l],
      status: n.status,
      message: "HLS playlist request error at URL: " + u + ".",
      responseText: n.responseText,
      code: n.status >= 500 ? 4 : 2
    }, this.trigger("error");
  }, t.parseManifest_ = function(n) {
    var s = this, o = n.url, u = n.manifestString;
    return parseManifest({
      onwarn: function(f) {
        var d = f.message;
        return s.logger_("m3u8-parser warn for " + o + ": " + d);
      },
      oninfo: function(f) {
        var d = f.message;
        return s.logger_("m3u8-parser info for " + o + ": " + d);
      },
      manifestString: u,
      customTagParsers: this.customTagParsers,
      customTagMappers: this.customTagMappers,
      experimentalLLHLS: this.experimentalLLHLS
    });
  }, t.haveMetadata = function(n) {
    var s = n.playlistString, o = n.playlistObject, u = n.url, l = n.id;
    this.request = null, this.state = "HAVE_METADATA";
    var f = o || this.parseManifest_({
      url: u,
      manifestString: s
    });
    f.lastRequest = Date.now(), setupMediaPlaylist({
      playlist: f,
      uri: u,
      id: l
    });
    var d = updateMaster$1(this.master, f);
    this.targetDuration = f.partTargetDuration || f.targetDuration, this.pendingMedia_ = null, d ? (this.master = d, this.media_ = this.master.playlists[l]) : this.trigger("playlistunchanged"), this.updateMediaUpdateTimeout_(refreshDelay(this.media(), !!d)), this.trigger("loadedplaylist");
  }, t.dispose = function() {
    this.trigger("dispose"), this.stopRequest(), window_1.clearTimeout(this.mediaUpdateTimeout), window_1.clearTimeout(this.finalRenditionTimeout), this.off();
  }, t.stopRequest = function() {
    if (this.request) {
      var n = this.request;
      this.request = null, n.onreadystatechange = null, n.abort();
    }
  }, t.media = function(n, s) {
    var o = this;
    if (!n)
      return this.media_;
    if (this.state === "HAVE_NOTHING")
      throw new Error("Cannot switch media playlist from " + this.state);
    if (typeof n == "string") {
      if (!this.master.playlists[n])
        throw new Error("Unknown playlist URI: " + n);
      n = this.master.playlists[n];
    }
    if (window_1.clearTimeout(this.finalRenditionTimeout), s) {
      var u = (n.partTargetDuration || n.targetDuration) / 2 * 1e3 || 5e3;
      this.finalRenditionTimeout = window_1.setTimeout(this.media.bind(this, n, !1), u);
      return;
    }
    var l = this.state, f = !this.media_ || n.id !== this.media_.id, d = this.master.playlists[n.id];
    if (d && d.endList || n.endList && n.segments.length) {
      this.request && (this.request.onreadystatechange = null, this.request.abort(), this.request = null), this.state = "HAVE_METADATA", this.media_ = n, f && (this.trigger("mediachanging"), l === "HAVE_MASTER" ? this.trigger("loadedmetadata") : this.trigger("mediachange"));
      return;
    }
    if (this.updateMediaUpdateTimeout_(refreshDelay(n, !0)), !!f) {
      if (this.state = "SWITCHING_MEDIA", this.request) {
        if (n.resolvedUri === this.request.url)
          return;
        this.request.onreadystatechange = null, this.request.abort(), this.request = null;
      }
      this.media_ && this.trigger("mediachanging"), this.pendingMedia_ = n, this.request = this.vhs_.xhr({
        uri: n.resolvedUri,
        withCredentials: this.withCredentials
      }, function(h, p) {
        if (!!o.request) {
          if (n.lastRequest = Date.now(), n.resolvedUri = resolveManifestRedirect(o.handleManifestRedirects, n.resolvedUri, p), h)
            return o.playlistRequestError(o.request, n, l);
          o.haveMetadata({
            playlistString: p.responseText,
            url: n.uri,
            id: n.id
          }), l === "HAVE_MASTER" ? o.trigger("loadedmetadata") : o.trigger("mediachange");
        }
      });
    }
  }, t.pause = function() {
    this.mediaUpdateTimeout && (window_1.clearTimeout(this.mediaUpdateTimeout), this.mediaUpdateTimeout = null), this.stopRequest(), this.state === "HAVE_NOTHING" && (this.started = !1), this.state === "SWITCHING_MEDIA" ? this.media_ ? this.state = "HAVE_METADATA" : this.state = "HAVE_MASTER" : this.state === "HAVE_CURRENT_METADATA" && (this.state = "HAVE_METADATA");
  }, t.load = function(n) {
    var s = this;
    this.mediaUpdateTimeout && (window_1.clearTimeout(this.mediaUpdateTimeout), this.mediaUpdateTimeout = null);
    var o = this.media();
    if (n) {
      var u = o ? (o.partTargetDuration || o.targetDuration) / 2 * 1e3 : 5e3;
      this.mediaUpdateTimeout = window_1.setTimeout(function() {
        s.mediaUpdateTimeout = null, s.load();
      }, u);
      return;
    }
    if (!this.started) {
      this.start();
      return;
    }
    o && !o.endList ? this.trigger("mediaupdatetimeout") : this.trigger("loadedplaylist");
  }, t.updateMediaUpdateTimeout_ = function(n) {
    var s = this;
    this.mediaUpdateTimeout && (window_1.clearTimeout(this.mediaUpdateTimeout), this.mediaUpdateTimeout = null), !(!this.media() || this.media().endList) && (this.mediaUpdateTimeout = window_1.setTimeout(function() {
      s.mediaUpdateTimeout = null, s.trigger("mediaupdatetimeout"), s.updateMediaUpdateTimeout_(n);
    }, n));
  }, t.start = function() {
    var n = this;
    if (this.started = !0, typeof this.src == "object") {
      this.src.uri || (this.src.uri = window_1.location.href), this.src.resolvedUri = this.src.uri, setTimeout(function() {
        n.setupInitialPlaylist(n.src);
      }, 0);
      return;
    }
    this.request = this.vhs_.xhr({
      uri: this.src,
      withCredentials: this.withCredentials
    }, function(s, o) {
      if (!!n.request) {
        if (n.request = null, s)
          return n.error = {
            status: o.status,
            message: "HLS playlist request error at URL: " + n.src + ".",
            responseText: o.responseText,
            code: 2
          }, n.state === "HAVE_NOTHING" && (n.started = !1), n.trigger("error");
        n.src = resolveManifestRedirect(n.handleManifestRedirects, n.src, o);
        var u = n.parseManifest_({
          manifestString: o.responseText,
          url: n.src
        });
        n.setupInitialPlaylist(u);
      }
    });
  }, t.srcUri = function() {
    return typeof this.src == "string" ? this.src : this.src.uri;
  }, t.setupInitialPlaylist = function(n) {
    if (this.state = "HAVE_MASTER", n.playlists) {
      this.master = n, addPropertiesToMaster(this.master, this.srcUri()), n.playlists.forEach(function(o) {
        o.segments = getAllSegments(o), o.segments.forEach(function(u) {
          resolveSegmentUris(u, o.resolvedUri);
        });
      }), this.trigger("loadedplaylist"), this.request || this.media(this.master.playlists[0]);
      return;
    }
    var s = this.srcUri() || window_1.location.href;
    this.master = masterForMedia(n, s), this.haveMetadata({
      playlistObject: n,
      url: s,
      id: this.master.playlists[0].id
    }), this.trigger("loadedmetadata");
  }, e;
}(EventTarget$1), videojsXHR = videojs.xhr, mergeOptions$1 = videojs.mergeOptions, callbackWrapper = function r(e, t, a, n) {
  var s = e.responseType === "arraybuffer" ? e.response : e.responseText;
  !t && s && (e.responseTime = Date.now(), e.roundTripTime = e.responseTime - e.requestTime, e.bytesReceived = s.byteLength || s.length, e.bandwidth || (e.bandwidth = Math.floor(e.bytesReceived / e.roundTripTime * 8 * 1e3))), a.headers && (e.responseHeaders = a.headers), t && t.code === "ETIMEDOUT" && (e.timedout = !0), !t && !e.aborted && a.statusCode !== 200 && a.statusCode !== 206 && a.statusCode !== 0 && (t = new Error("XHR Failed with a response of: " + (e && (s || e.responseText)))), n(t, e);
}, xhrFactory = function r() {
  var e = function t(a, n) {
    a = mergeOptions$1({
      timeout: 45e3
    }, a);
    var s = t.beforeRequest || videojs.Vhs.xhr.beforeRequest;
    if (s && typeof s == "function") {
      var o = s(a);
      o && (a = o);
    }
    var u = videojs.Vhs.xhr.original === !0 ? videojsXHR : videojs.Vhs.xhr, l = u(a, function(d, h) {
      return callbackWrapper(l, d, h, n);
    }), f = l.abort;
    return l.abort = function() {
      return l.aborted = !0, f.apply(l, arguments);
    }, l.uri = a.uri, l.requestTime = Date.now(), l;
  };
  return e.original = !0, e;
}, byterangeStr = function r(e) {
  var t, a = e.offset;
  return typeof e.offset == "bigint" || typeof e.length == "bigint" ? t = window_1.BigInt(e.offset) + window_1.BigInt(e.length) - window_1.BigInt(1) : t = e.offset + e.length - 1, "bytes=" + a + "-" + t;
}, segmentXhrHeaders = function r(e) {
  var t = {};
  return e.byterange && (t.Range = byterangeStr(e.byterange)), t;
}, textRange = function r(e, t) {
  return e.start(t) + "-" + e.end(t);
}, formatHexString = function r(e, t) {
  var a = e.toString(16);
  return "00".substring(0, 2 - a.length) + a + (t % 2 ? " " : "");
}, formatAsciiString = function r(e) {
  return e >= 32 && e < 126 ? String.fromCharCode(e) : ".";
}, createTransferableMessage = function r(e) {
  var t = {};
  return Object.keys(e).forEach(function(a) {
    var n = e[a];
    isArrayBufferView(n) ? t[a] = {
      bytes: n.buffer,
      byteOffset: n.byteOffset,
      byteLength: n.byteLength
    } : t[a] = n;
  }), t;
}, initSegmentId = function r(e) {
  var t = e.byterange || {
    length: 1 / 0,
    offset: 0
  };
  return [t.length, t.offset, e.resolvedUri].join(",");
}, segmentKeyId = function r(e) {
  return e.resolvedUri;
}, hexDump = function r(e) {
  for (var t = Array.prototype.slice.call(e), a = 16, n = "", s, o, u = 0; u < t.length / a; u++)
    s = t.slice(u * a, u * a + a).map(formatHexString).join(""), o = t.slice(u * a, u * a + a).map(formatAsciiString).join(""), n += s + " " + o + `
`;
  return n;
}, tagDump = function r(e) {
  var t = e.bytes;
  return hexDump(t);
}, textRanges = function r(e) {
  var t = "", a;
  for (a = 0; a < e.length; a++)
    t += textRange(e, a) + " ";
  return t;
}, utils = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  createTransferableMessage,
  initSegmentId,
  segmentKeyId,
  hexDump,
  tagDump,
  textRanges
}), SEGMENT_END_FUDGE_PERCENT = 0.25, playerTimeToProgramTime = function r(e, t) {
  if (!t.dateTimeObject)
    return null;
  var a = t.videoTimingInfo.transmuxerPrependedSeconds, n = t.videoTimingInfo.transmuxedPresentationStart, s = n + a, o = e - s;
  return new Date(t.dateTimeObject.getTime() + o * 1e3);
}, originalSegmentVideoDuration = function r(e) {
  return e.transmuxedPresentationEnd - e.transmuxedPresentationStart - e.transmuxerPrependedSeconds;
}, findSegmentForProgramTime = function r(e, t) {
  var a;
  try {
    a = new Date(e);
  } catch {
    return null;
  }
  if (!t || !t.segments || t.segments.length === 0)
    return null;
  var n = t.segments[0];
  if (a < n.dateTimeObject)
    return null;
  for (var s = 0; s < t.segments.length - 1; s++) {
    n = t.segments[s];
    var o = t.segments[s + 1].dateTimeObject;
    if (a < o)
      break;
  }
  var u = t.segments[t.segments.length - 1], l = u.dateTimeObject, f = u.videoTimingInfo ? originalSegmentVideoDuration(u.videoTimingInfo) : u.duration + u.duration * SEGMENT_END_FUDGE_PERCENT, d = new Date(l.getTime() + f * 1e3);
  return a > d ? null : (a > l && (n = u), {
    segment: n,
    estimatedStart: n.videoTimingInfo ? n.videoTimingInfo.transmuxedPresentationStart : Playlist.duration(t, t.mediaSequence + t.segments.indexOf(n)),
    type: n.videoTimingInfo ? "accurate" : "estimate"
  });
}, findSegmentForPlayerTime = function r(e, t) {
  if (!t || !t.segments || t.segments.length === 0)
    return null;
  for (var a = 0, n, s = 0; s < t.segments.length && (n = t.segments[s], a = n.videoTimingInfo ? n.videoTimingInfo.transmuxedPresentationEnd : a + n.duration, !(e <= a)); s++)
    ;
  var o = t.segments[t.segments.length - 1];
  if (o.videoTimingInfo && o.videoTimingInfo.transmuxedPresentationEnd < e)
    return null;
  if (e > a) {
    if (e > a + o.duration * SEGMENT_END_FUDGE_PERCENT)
      return null;
    n = o;
  }
  return {
    segment: n,
    estimatedStart: n.videoTimingInfo ? n.videoTimingInfo.transmuxedPresentationStart : a - n.duration,
    type: n.videoTimingInfo ? "accurate" : "estimate"
  };
}, getOffsetFromTimestamp = function r(e, t) {
  var a, n;
  try {
    a = new Date(e), n = new Date(t);
  } catch {
  }
  var s = a.getTime(), o = n.getTime();
  return (o - s) / 1e3;
}, verifyProgramDateTimeTags = function r(e) {
  if (!e.segments || e.segments.length === 0)
    return !1;
  for (var t = 0; t < e.segments.length; t++) {
    var a = e.segments[t];
    if (!a.dateTimeObject)
      return !1;
  }
  return !0;
}, getProgramTime = function r(e) {
  var t = e.playlist, a = e.time, n = a === void 0 ? void 0 : a, s = e.callback;
  if (!s)
    throw new Error("getProgramTime: callback must be provided");
  if (!t || n === void 0)
    return s({
      message: "getProgramTime: playlist and time must be provided"
    });
  var o = findSegmentForPlayerTime(n, t);
  if (!o)
    return s({
      message: "valid programTime was not found"
    });
  if (o.type === "estimate")
    return s({
      message: "Accurate programTime could not be determined. Please seek to e.seekTime and try again",
      seekTime: o.estimatedStart
    });
  var u = {
    mediaSeconds: n
  }, l = playerTimeToProgramTime(n, o.segment);
  return l && (u.programDateTime = l.toISOString()), s(null, u);
}, seekToProgramTime = function r(e) {
  var t = e.programTime, a = e.playlist, n = e.retryCount, s = n === void 0 ? 2 : n, o = e.seekTo, u = e.pauseAfterSeek, l = u === void 0 ? !0 : u, f = e.tech, d = e.callback;
  if (!d)
    throw new Error("seekToProgramTime: callback must be provided");
  if (typeof t > "u" || !a || !o)
    return d({
      message: "seekToProgramTime: programTime, seekTo and playlist must be provided"
    });
  if (!a.endList && !f.hasStarted_)
    return d({
      message: "player must be playing a live stream to start buffering"
    });
  if (!verifyProgramDateTimeTags(a))
    return d({
      message: "programDateTime tags must be provided in the manifest " + a.resolvedUri
    });
  var h = findSegmentForProgramTime(t, a);
  if (!h)
    return d({
      message: t + " was not found in the stream"
    });
  var p = h.segment, m = getOffsetFromTimestamp(p.dateTimeObject, t);
  if (h.type === "estimate") {
    if (s === 0)
      return d({
        message: t + " is not buffered yet. Try again"
      });
    o(h.estimatedStart + m), f.one("seeked", function() {
      r({
        programTime: t,
        playlist: a,
        retryCount: s - 1,
        seekTo: o,
        pauseAfterSeek: l,
        tech: f,
        callback: d
      });
    });
    return;
  }
  var _ = p.start + m, w = function() {
    return d(null, f.currentTime());
  };
  f.one("seeked", w), l && f.pause(), o(_);
}, callbackOnCompleted = function r(e, t) {
  if (e.readyState === 4)
    return t();
}, containerRequest = function r(e, t, a) {
  var n = [], s, o = !1, u = function(p, m, _, w) {
    return m.abort(), o = !0, a(p, m, _, w);
  }, l = function(p, m) {
    if (!o) {
      if (p)
        return u(p, m, "", n);
      var _ = m.responseText.substring(n && n.byteLength || 0, m.responseText.length);
      if (n = concatTypedArrays(n, stringToBytes(_, !0)), s = s || getId3Offset(n), n.length < 10 || s && n.length < s + 2)
        return callbackOnCompleted(m, function() {
          return u(p, m, "", n);
        });
      var w = detectContainerForBytes(n);
      return w === "ts" && n.length < 188 ? callbackOnCompleted(m, function() {
        return u(p, m, "", n);
      }) : !w && n.length < 376 ? callbackOnCompleted(m, function() {
        return u(p, m, "", n);
      }) : u(null, m, w, n);
    }
  }, f = {
    uri: e,
    beforeSend: function(p) {
      p.overrideMimeType("text/plain; charset=x-user-defined"), p.addEventListener("progress", function(m) {
        return m.total, m.loaded, callbackWrapper(p, null, {
          statusCode: p.status
        }, l);
      });
    }
  }, d = t(f, function(h, p) {
    return callbackWrapper(d, h, p, l);
  });
  return d;
}, EventTarget = videojs.EventTarget, mergeOptions = videojs.mergeOptions, dashPlaylistUnchanged = function r(e, t) {
  if (!isPlaylistUnchanged(e, t) || e.sidx && t.sidx && (e.sidx.offset !== t.sidx.offset || e.sidx.length !== t.sidx.length))
    return !1;
  if (!e.sidx && t.sidx || e.sidx && !t.sidx || e.segments && !t.segments || !e.segments && t.segments)
    return !1;
  if (!e.segments && !t.segments)
    return !0;
  for (var a = 0; a < e.segments.length; a++) {
    var n = e.segments[a], s = t.segments[a];
    if (n.uri !== s.uri)
      return !1;
    if (!(!n.byterange && !s.byterange)) {
      var o = n.byterange, u = s.byterange;
      if (o && !u || !o && u || o.offset !== u.offset || o.length !== u.length)
        return !1;
    }
  }
  return !0;
}, parseMasterXml = function r(e) {
  var t = e.masterXml, a = e.srcUrl, n = e.clientOffset, s = e.sidxMapping, o = e.previousManifest, u = parse(t, {
    manifestUri: a,
    clientOffset: n,
    sidxMapping: s,
    previousManifest: o
  });
  return addPropertiesToMaster(u, a), u;
}, updateMaster = function r(e, t, a) {
  for (var n = !0, s = mergeOptions(e, {
    duration: t.duration,
    minimumUpdatePeriod: t.minimumUpdatePeriod,
    timelineStarts: t.timelineStarts
  }), o = 0; o < t.playlists.length; o++) {
    var u = t.playlists[o];
    if (u.sidx) {
      var l = generateSidxKey(u.sidx);
      a && a[l] && a[l].sidx && addSidxSegmentsToPlaylist$1(u, a[l].sidx, u.sidx.resolvedUri);
    }
    var f = updateMaster$1(s, u, dashPlaylistUnchanged);
    f && (s = f, n = !1);
  }
  return forEachMediaGroup(t, function(d, h, p, m) {
    if (d.playlists && d.playlists.length) {
      var _ = d.playlists[0].id, w = updateMaster$1(s, d.playlists[0], dashPlaylistUnchanged);
      w && (s = w, s.mediaGroups[h][p][m].playlists[0] = s.playlists[_], n = !1);
    }
  }), t.minimumUpdatePeriod !== e.minimumUpdatePeriod && (n = !1), n ? null : s;
}, equivalentSidx = function r(e, t) {
  var a = Boolean(!e.map && !t.map), n = a || Boolean(e.map && t.map && e.map.byterange.offset === t.map.byterange.offset && e.map.byterange.length === t.map.byterange.length);
  return n && e.uri === t.uri && e.byterange.offset === t.byterange.offset && e.byterange.length === t.byterange.length;
}, compareSidxEntry = function r(e, t) {
  var a = {};
  for (var n in e) {
    var s = e[n], o = s.sidx;
    if (o) {
      var u = generateSidxKey(o);
      if (!t[u])
        break;
      var l = t[u].sidxInfo;
      equivalentSidx(l, o) && (a[u] = t[u]);
    }
  }
  return a;
}, filterChangedSidxMappings = function r(e, t) {
  var a = compareSidxEntry(e.playlists, t), n = a;
  return forEachMediaGroup(e, function(s, o, u, l) {
    if (s.playlists && s.playlists.length) {
      var f = s.playlists;
      n = mergeOptions(n, compareSidxEntry(f, t));
    }
  }), n;
}, DashPlaylistLoader = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s, o) {
    var u;
    s === void 0 && (s = {}), u = r.call(this) || this, u.masterPlaylistLoader_ = o || _assertThisInitialized$1(u), o || (u.isMaster_ = !0);
    var l = s, f = l.withCredentials, d = f === void 0 ? !1 : f, h = l.handleManifestRedirects, p = h === void 0 ? !1 : h;
    if (u.vhs_ = n, u.withCredentials = d, u.handleManifestRedirects = p, !a)
      throw new Error("A non-empty playlist URL or object is required");
    return u.on("minimumUpdatePeriod", function() {
      u.refreshXml_();
    }), u.on("mediaupdatetimeout", function() {
      u.refreshMedia_(u.media().id);
    }), u.state = "HAVE_NOTHING", u.loadedPlaylists_ = {}, u.logger_ = logger("DashPlaylistLoader"), u.isMaster_ ? (u.masterPlaylistLoader_.srcUrl = a, u.masterPlaylistLoader_.sidxMapping_ = {}) : u.childPlaylist_ = a, u;
  }
  var t = e.prototype;
  return t.requestErrored_ = function(n, s, o) {
    if (!this.request)
      return !0;
    if (this.request = null, n)
      return this.error = typeof n == "object" && !(n instanceof Error) ? n : {
        status: s.status,
        message: "DASH request error at URL: " + s.uri,
        response: s.response,
        code: 2
      }, o && (this.state = o), this.trigger("error"), !0;
  }, t.addSidxSegments_ = function(n, s, o) {
    var u = this, l = n.sidx && generateSidxKey(n.sidx);
    if (!n.sidx || !l || this.masterPlaylistLoader_.sidxMapping_[l]) {
      this.mediaRequest_ = window_1.setTimeout(function() {
        return o(!1);
      }, 0);
      return;
    }
    var f = resolveManifestRedirect(this.handleManifestRedirects, n.sidx.resolvedUri), d = function(p, m) {
      if (!u.requestErrored_(p, m, s)) {
        var _ = u.masterPlaylistLoader_.sidxMapping_, w;
        try {
          w = parseSidx_1(toUint8(m.response).subarray(8));
        } catch (S) {
          u.requestErrored_(S, m, s);
          return;
        }
        return _[l] = {
          sidxInfo: n.sidx,
          sidx: w
        }, addSidxSegmentsToPlaylist$1(n, w, n.sidx.resolvedUri), o(!0);
      }
    };
    this.request = containerRequest(f, this.vhs_.xhr, function(h, p, m, _) {
      if (h)
        return d(h, p);
      if (!m || m !== "mp4")
        return d({
          status: p.status,
          message: "Unsupported " + (m || "unknown") + " container type for sidx segment at URL: " + f,
          response: "",
          playlist: n,
          internal: !0,
          blacklistDuration: 1 / 0,
          code: 2
        }, p);
      var w = n.sidx.byterange, S = w.offset, O = w.length;
      if (_.length >= O + S)
        return d(h, {
          response: _.subarray(S, S + O),
          status: p.status,
          uri: p.uri
        });
      u.request = u.vhs_.xhr({
        uri: f,
        responseType: "arraybuffer",
        headers: segmentXhrHeaders({
          byterange: n.sidx.byterange
        })
      }, d);
    });
  }, t.dispose = function() {
    this.trigger("dispose"), this.stopRequest(), this.loadedPlaylists_ = {}, window_1.clearTimeout(this.minimumUpdatePeriodTimeout_), window_1.clearTimeout(this.mediaRequest_), window_1.clearTimeout(this.mediaUpdateTimeout), this.mediaUpdateTimeout = null, this.mediaRequest_ = null, this.minimumUpdatePeriodTimeout_ = null, this.masterPlaylistLoader_.createMupOnMedia_ && (this.off("loadedmetadata", this.masterPlaylistLoader_.createMupOnMedia_), this.masterPlaylistLoader_.createMupOnMedia_ = null), this.off();
  }, t.hasPendingRequest = function() {
    return this.request || this.mediaRequest_;
  }, t.stopRequest = function() {
    if (this.request) {
      var n = this.request;
      this.request = null, n.onreadystatechange = null, n.abort();
    }
  }, t.media = function(n) {
    var s = this;
    if (!n)
      return this.media_;
    if (this.state === "HAVE_NOTHING")
      throw new Error("Cannot switch media playlist from " + this.state);
    var o = this.state;
    if (typeof n == "string") {
      if (!this.masterPlaylistLoader_.master.playlists[n])
        throw new Error("Unknown playlist URI: " + n);
      n = this.masterPlaylistLoader_.master.playlists[n];
    }
    var u = !this.media_ || n.id !== this.media_.id;
    if (u && this.loadedPlaylists_[n.id] && this.loadedPlaylists_[n.id].endList) {
      this.state = "HAVE_METADATA", this.media_ = n, u && (this.trigger("mediachanging"), this.trigger("mediachange"));
      return;
    }
    !u || (this.media_ && this.trigger("mediachanging"), this.addSidxSegments_(n, o, function(l) {
      s.haveMetadata({
        startingState: o,
        playlist: n
      });
    }));
  }, t.haveMetadata = function(n) {
    var s = n.startingState, o = n.playlist;
    this.state = "HAVE_METADATA", this.loadedPlaylists_[o.id] = o, this.mediaRequest_ = null, this.refreshMedia_(o.id), s === "HAVE_MASTER" ? this.trigger("loadedmetadata") : this.trigger("mediachange");
  }, t.pause = function() {
    this.masterPlaylistLoader_.createMupOnMedia_ && (this.off("loadedmetadata", this.masterPlaylistLoader_.createMupOnMedia_), this.masterPlaylistLoader_.createMupOnMedia_ = null), this.stopRequest(), window_1.clearTimeout(this.mediaUpdateTimeout), this.mediaUpdateTimeout = null, this.isMaster_ && (window_1.clearTimeout(this.masterPlaylistLoader_.minimumUpdatePeriodTimeout_), this.masterPlaylistLoader_.minimumUpdatePeriodTimeout_ = null), this.state === "HAVE_NOTHING" && (this.started = !1);
  }, t.load = function(n) {
    var s = this;
    window_1.clearTimeout(this.mediaUpdateTimeout), this.mediaUpdateTimeout = null;
    var o = this.media();
    if (n) {
      var u = o ? o.targetDuration / 2 * 1e3 : 5e3;
      this.mediaUpdateTimeout = window_1.setTimeout(function() {
        return s.load();
      }, u);
      return;
    }
    if (!this.started) {
      this.start();
      return;
    }
    o && !o.endList ? (this.isMaster_ && !this.minimumUpdatePeriodTimeout_ && (this.trigger("minimumUpdatePeriod"), this.updateMinimumUpdatePeriodTimeout_()), this.trigger("mediaupdatetimeout")) : this.trigger("loadedplaylist");
  }, t.start = function() {
    var n = this;
    if (this.started = !0, !this.isMaster_) {
      this.mediaRequest_ = window_1.setTimeout(function() {
        return n.haveMaster_();
      }, 0);
      return;
    }
    this.requestMaster_(function(s, o) {
      n.haveMaster_(), !n.hasPendingRequest() && !n.media_ && n.media(n.masterPlaylistLoader_.master.playlists[0]);
    });
  }, t.requestMaster_ = function(n) {
    var s = this;
    this.request = this.vhs_.xhr({
      uri: this.masterPlaylistLoader_.srcUrl,
      withCredentials: this.withCredentials
    }, function(o, u) {
      if (s.requestErrored_(o, u)) {
        s.state === "HAVE_NOTHING" && (s.started = !1);
        return;
      }
      var l = u.responseText !== s.masterPlaylistLoader_.masterXml_;
      if (s.masterPlaylistLoader_.masterXml_ = u.responseText, u.responseHeaders && u.responseHeaders.date ? s.masterLoaded_ = Date.parse(u.responseHeaders.date) : s.masterLoaded_ = Date.now(), s.masterPlaylistLoader_.srcUrl = resolveManifestRedirect(s.handleManifestRedirects, s.masterPlaylistLoader_.srcUrl, u), l) {
        s.handleMaster_(), s.syncClientServerClock_(function() {
          return n(u, l);
        });
        return;
      }
      return n(u, l);
    });
  }, t.syncClientServerClock_ = function(n) {
    var s = this, o = parseUTCTiming(this.masterPlaylistLoader_.masterXml_);
    if (o === null)
      return this.masterPlaylistLoader_.clientOffset_ = this.masterLoaded_ - Date.now(), n();
    if (o.method === "DIRECT")
      return this.masterPlaylistLoader_.clientOffset_ = o.value - Date.now(), n();
    this.request = this.vhs_.xhr({
      uri: resolveUrl(this.masterPlaylistLoader_.srcUrl, o.value),
      method: o.method,
      withCredentials: this.withCredentials
    }, function(u, l) {
      if (!!s.request) {
        if (u)
          return s.masterPlaylistLoader_.clientOffset_ = s.masterLoaded_ - Date.now(), n();
        var f;
        o.method === "HEAD" ? !l.responseHeaders || !l.responseHeaders.date ? f = s.masterLoaded_ : f = Date.parse(l.responseHeaders.date) : f = Date.parse(l.responseText), s.masterPlaylistLoader_.clientOffset_ = f - Date.now(), n();
      }
    });
  }, t.haveMaster_ = function() {
    this.state = "HAVE_MASTER", this.isMaster_ ? this.trigger("loadedplaylist") : this.media_ || this.media(this.childPlaylist_);
  }, t.handleMaster_ = function() {
    this.mediaRequest_ = null;
    var n = this.masterPlaylistLoader_.master, s = parseMasterXml({
      masterXml: this.masterPlaylistLoader_.masterXml_,
      srcUrl: this.masterPlaylistLoader_.srcUrl,
      clientOffset: this.masterPlaylistLoader_.clientOffset_,
      sidxMapping: this.masterPlaylistLoader_.sidxMapping_,
      previousManifest: n
    });
    n && (s = updateMaster(n, s, this.masterPlaylistLoader_.sidxMapping_)), this.masterPlaylistLoader_.master = s || n;
    var o = this.masterPlaylistLoader_.master.locations && this.masterPlaylistLoader_.master.locations[0];
    return o && o !== this.masterPlaylistLoader_.srcUrl && (this.masterPlaylistLoader_.srcUrl = o), (!n || s && s.minimumUpdatePeriod !== n.minimumUpdatePeriod) && this.updateMinimumUpdatePeriodTimeout_(), Boolean(s);
  }, t.updateMinimumUpdatePeriodTimeout_ = function() {
    var n = this.masterPlaylistLoader_;
    n.createMupOnMedia_ && (n.off("loadedmetadata", n.createMupOnMedia_), n.createMupOnMedia_ = null), n.minimumUpdatePeriodTimeout_ && (window_1.clearTimeout(n.minimumUpdatePeriodTimeout_), n.minimumUpdatePeriodTimeout_ = null);
    var s = n.master && n.master.minimumUpdatePeriod;
    if (s === 0 && (n.media() ? s = n.media().targetDuration * 1e3 : (n.createMupOnMedia_ = n.updateMinimumUpdatePeriodTimeout_, n.one("loadedmetadata", n.createMupOnMedia_))), typeof s != "number" || s <= 0) {
      s < 0 && this.logger_("found invalid minimumUpdatePeriod of " + s + ", not setting a timeout");
      return;
    }
    this.createMUPTimeout_(s);
  }, t.createMUPTimeout_ = function(n) {
    var s = this.masterPlaylistLoader_;
    s.minimumUpdatePeriodTimeout_ = window_1.setTimeout(function() {
      s.minimumUpdatePeriodTimeout_ = null, s.trigger("minimumUpdatePeriod"), s.createMUPTimeout_(n);
    }, n);
  }, t.refreshXml_ = function() {
    var n = this;
    this.requestMaster_(function(s, o) {
      !o || (n.media_ && (n.media_ = n.masterPlaylistLoader_.master.playlists[n.media_.id]), n.masterPlaylistLoader_.sidxMapping_ = filterChangedSidxMappings(n.masterPlaylistLoader_.master, n.masterPlaylistLoader_.sidxMapping_), n.addSidxSegments_(n.media(), n.state, function(u) {
        n.refreshMedia_(n.media().id);
      }));
    });
  }, t.refreshMedia_ = function(n) {
    var s = this;
    if (!n)
      throw new Error("refreshMedia_ must take a media id");
    this.media_ && this.isMaster_ && this.handleMaster_();
    var o = this.masterPlaylistLoader_.master.playlists, u = !this.media_ || this.media_ !== o[n];
    if (u ? this.media_ = o[n] : this.trigger("playlistunchanged"), !this.mediaUpdateTimeout) {
      var l = function f() {
        s.media().endList || (s.mediaUpdateTimeout = window_1.setTimeout(function() {
          s.trigger("mediaupdatetimeout"), f();
        }, refreshDelay(s.media(), Boolean(u))));
      };
      l();
    }
    this.trigger("loadedplaylist");
  }, e;
}(EventTarget), Config = {
  GOAL_BUFFER_LENGTH: 30,
  MAX_GOAL_BUFFER_LENGTH: 60,
  BACK_BUFFER_LENGTH: 30,
  GOAL_BUFFER_LENGTH_RATE: 1,
  INITIAL_BANDWIDTH: 4194304,
  BANDWIDTH_VARIANCE: 1.2,
  BUFFER_LOW_WATER_LINE: 0,
  MAX_BUFFER_LOW_WATER_LINE: 30,
  EXPERIMENTAL_MAX_BUFFER_LOW_WATER_LINE: 16,
  BUFFER_LOW_WATER_LINE_RATE: 1,
  BUFFER_HIGH_WATER_LINE: 30
}, stringToArrayBuffer = function r(e) {
  for (var t = new Uint8Array(new ArrayBuffer(e.length)), a = 0; a < e.length; a++)
    t[a] = e.charCodeAt(a);
  return t.buffer;
}, browserWorkerPolyFill = function r(e) {
  return e.on = e.addEventListener, e.off = e.removeEventListener, e;
}, createObjectURL = function r(e) {
  try {
    return URL.createObjectURL(new Blob([e], {
      type: "application/javascript"
    }));
  } catch {
    var t = new BlobBuilder();
    return t.append(e), URL.createObjectURL(t.getBlob());
  }
}, factory = function r(e) {
  return function() {
    var t = createObjectURL(e), a = browserWorkerPolyFill(new Worker(t));
    a.objURL = t;
    var n = a.terminate;
    return a.on = a.addEventListener, a.off = a.removeEventListener, a.terminate = function() {
      return URL.revokeObjectURL(t), n.call(this);
    }, a;
  };
}, transform = function r(e) {
  return "var browserWorkerPolyFill = " + browserWorkerPolyFill.toString() + `;
browserWorkerPolyFill(self);
` + e;
}, getWorkerString = function r(e) {
  return e.toString().replace(/^function.+?{/, "").slice(0, -1);
}, workerCode$1 = transform(getWorkerString(function() {
  var r = function() {
    this.init = function() {
      var g = {};
      this.on = function(y, v) {
        g[y] || (g[y] = []), g[y] = g[y].concat(v);
      }, this.off = function(y, v) {
        var E;
        return g[y] ? (E = g[y].indexOf(v), g[y] = g[y].slice(), g[y].splice(E, 1), E > -1) : !1;
      }, this.trigger = function(y) {
        var v, E, C, A;
        if (v = g[y], !!v)
          if (arguments.length === 2)
            for (C = v.length, E = 0; E < C; ++E)
              v[E].call(this, arguments[1]);
          else {
            for (A = [], E = arguments.length, E = 1; E < arguments.length; ++E)
              A.push(arguments[E]);
            for (C = v.length, E = 0; E < C; ++E)
              v[E].apply(this, A);
          }
      }, this.dispose = function() {
        g = {};
      };
    };
  };
  r.prototype.pipe = function(I) {
    return this.on("data", function(g) {
      I.push(g);
    }), this.on("done", function(g) {
      I.flush(g);
    }), this.on("partialdone", function(g) {
      I.partialFlush(g);
    }), this.on("endedtimeline", function(g) {
      I.endTimeline(g);
    }), this.on("reset", function(g) {
      I.reset(g);
    }), I;
  }, r.prototype.push = function(I) {
    this.trigger("data", I);
  }, r.prototype.flush = function(I) {
    this.trigger("done", I);
  }, r.prototype.partialFlush = function(I) {
    this.trigger("partialdone", I);
  }, r.prototype.endTimeline = function(I) {
    this.trigger("endedtimeline", I);
  }, r.prototype.reset = function(I) {
    this.trigger("reset", I);
  };
  var e = r, t = Math.pow(2, 32), a = function(g) {
    var y = new DataView(g.buffer, g.byteOffset, g.byteLength), v;
    return y.getBigUint64 ? (v = y.getBigUint64(0), v < Number.MAX_SAFE_INTEGER ? Number(v) : v) : y.getUint32(0) * t + y.getUint32(4);
  }, n = {
    getUint64: a,
    MAX_UINT32: t
  }, s = n.MAX_UINT32, o, u, l, f, d, h, p, m, _, w, S, O, k, B, L, G, _r, ga, _n, Fa, N, _t, Y, _a, X, J, ea, wa, _s, _d, _o, _p, _f, _g, f0, y0;
  (function() {
    var I;
    if (Y = {
      avc1: [],
      avcC: [],
      btrt: [],
      dinf: [],
      dref: [],
      esds: [],
      ftyp: [],
      hdlr: [],
      mdat: [],
      mdhd: [],
      mdia: [],
      mfhd: [],
      minf: [],
      moof: [],
      moov: [],
      mp4a: [],
      mvex: [],
      mvhd: [],
      pasp: [],
      sdtp: [],
      smhd: [],
      stbl: [],
      stco: [],
      stsc: [],
      stsd: [],
      stsz: [],
      stts: [],
      styp: [],
      tfdt: [],
      tfhd: [],
      traf: [],
      trak: [],
      trun: [],
      trex: [],
      tkhd: [],
      vmhd: []
    }, !(typeof Uint8Array > "u")) {
      for (I in Y)
        Y.hasOwnProperty(I) && (Y[I] = [I.charCodeAt(0), I.charCodeAt(1), I.charCodeAt(2), I.charCodeAt(3)]);
      _a = new Uint8Array(["i".charCodeAt(0), "s".charCodeAt(0), "o".charCodeAt(0), "m".charCodeAt(0)]), J = new Uint8Array(["a".charCodeAt(0), "v".charCodeAt(0), "c".charCodeAt(0), "1".charCodeAt(0)]), X = new Uint8Array([0, 0, 0, 1]), ea = new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        118,
        105,
        100,
        101,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        86,
        105,
        100,
        101,
        111,
        72,
        97,
        110,
        100,
        108,
        101,
        114,
        0
      ]), wa = new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        115,
        111,
        117,
        110,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        83,
        111,
        117,
        110,
        100,
        72,
        97,
        110,
        100,
        108,
        101,
        114,
        0
      ]), _s = {
        video: ea,
        audio: wa
      }, _p = new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        12,
        117,
        114,
        108,
        32,
        0,
        0,
        0,
        1
      ]), _o = new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
      ]), _f = new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
      ]), _g = _f, f0 = new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
      ]), y0 = _f, _d = new Uint8Array([
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0
      ]);
    }
  })(), o = function(g) {
    var y = [], v = 0, E, C, A;
    for (E = 1; E < arguments.length; E++)
      y.push(arguments[E]);
    for (E = y.length; E--; )
      v += y[E].byteLength;
    for (C = new Uint8Array(v + 8), A = new DataView(C.buffer, C.byteOffset, C.byteLength), A.setUint32(0, C.byteLength), C.set(g, 4), E = 0, v = 8; E < y.length; E++)
      C.set(y[E], v), v += y[E].byteLength;
    return C;
  }, u = function() {
    return o(Y.dinf, o(Y.dref, _p));
  }, l = function(g) {
    return o(Y.esds, new Uint8Array([
      0,
      0,
      0,
      0,
      3,
      25,
      0,
      0,
      0,
      4,
      17,
      64,
      21,
      0,
      6,
      0,
      0,
      0,
      218,
      192,
      0,
      0,
      218,
      192,
      5,
      2,
      g.audioobjecttype << 3 | g.samplingfrequencyindex >>> 1,
      g.samplingfrequencyindex << 7 | g.channelcount << 3,
      6,
      1,
      2
    ]));
  }, f = function() {
    return o(Y.ftyp, _a, X, _a, J);
  }, G = function(g) {
    return o(Y.hdlr, _s[g]);
  }, d = function(g) {
    return o(Y.mdat, g);
  }, L = function(g) {
    var y = new Uint8Array([
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      2,
      0,
      0,
      0,
      3,
      0,
      1,
      95,
      144,
      g.duration >>> 24 & 255,
      g.duration >>> 16 & 255,
      g.duration >>> 8 & 255,
      g.duration & 255,
      85,
      196,
      0,
      0
    ]);
    return g.samplerate && (y[12] = g.samplerate >>> 24 & 255, y[13] = g.samplerate >>> 16 & 255, y[14] = g.samplerate >>> 8 & 255, y[15] = g.samplerate & 255), o(Y.mdhd, y);
  }, B = function(g) {
    return o(Y.mdia, L(g), G(g.type), p(g));
  }, h = function(g) {
    return o(Y.mfhd, new Uint8Array([
      0,
      0,
      0,
      0,
      (g & 4278190080) >> 24,
      (g & 16711680) >> 16,
      (g & 65280) >> 8,
      g & 255
    ]));
  }, p = function(g) {
    return o(Y.minf, g.type === "video" ? o(Y.vmhd, _d) : o(Y.smhd, _o), u(), ga(g));
  }, m = function(g, y) {
    for (var v = [], E = y.length; E--; )
      v[E] = Fa(y[E]);
    return o.apply(null, [Y.moof, h(g)].concat(v));
  }, _ = function(g) {
    for (var y = g.length, v = []; y--; )
      v[y] = O(g[y]);
    return o.apply(null, [Y.moov, S(4294967295)].concat(v).concat(w(g)));
  }, w = function(g) {
    for (var y = g.length, v = []; y--; )
      v[y] = N(g[y]);
    return o.apply(null, [Y.mvex].concat(v));
  }, S = function(g) {
    var y = new Uint8Array([
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      2,
      0,
      1,
      95,
      144,
      (g & 4278190080) >> 24,
      (g & 16711680) >> 16,
      (g & 65280) >> 8,
      g & 255,
      0,
      1,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      64,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      255,
      255,
      255,
      255
    ]);
    return o(Y.mvhd, y);
  }, _r = function(g) {
    var y = g.samples || [], v = new Uint8Array(4 + y.length), E, C;
    for (C = 0; C < y.length; C++)
      E = y[C].flags, v[C + 4] = E.dependsOn << 4 | E.isDependedOn << 2 | E.hasRedundancy;
    return o(Y.sdtp, v);
  }, ga = function(g) {
    return o(Y.stbl, _n(g), o(Y.stts, y0), o(Y.stsc, _g), o(Y.stsz, f0), o(Y.stco, _f));
  }, function() {
    var I, g;
    _n = function(v) {
      return o(Y.stsd, new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1
      ]), v.type === "video" ? I(v) : g(v));
    }, I = function(v) {
      var E = v.sps || [], C = v.pps || [], A = [], P = [], j, V;
      for (j = 0; j < E.length; j++)
        A.push((E[j].byteLength & 65280) >>> 8), A.push(E[j].byteLength & 255), A = A.concat(Array.prototype.slice.call(E[j]));
      for (j = 0; j < C.length; j++)
        P.push((C[j].byteLength & 65280) >>> 8), P.push(C[j].byteLength & 255), P = P.concat(Array.prototype.slice.call(C[j]));
      if (V = [Y.avc1, new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        (v.width & 65280) >> 8,
        v.width & 255,
        (v.height & 65280) >> 8,
        v.height & 255,
        0,
        72,
        0,
        0,
        0,
        72,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1,
        19,
        118,
        105,
        100,
        101,
        111,
        106,
        115,
        45,
        99,
        111,
        110,
        116,
        114,
        105,
        98,
        45,
        104,
        108,
        115,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        24,
        17,
        17
      ]), o(Y.avcC, new Uint8Array([
        1,
        v.profileIdc,
        v.profileCompatibility,
        v.levelIdc,
        255
      ].concat(
        [E.length],
        A,
        [C.length],
        P
      ))), o(Y.btrt, new Uint8Array([
        0,
        28,
        156,
        128,
        0,
        45,
        198,
        192,
        0,
        45,
        198,
        192
      ]))], v.sarRatio) {
        var q = v.sarRatio[0], _e = v.sarRatio[1];
        V.push(o(Y.pasp, new Uint8Array([(q & 4278190080) >> 24, (q & 16711680) >> 16, (q & 65280) >> 8, q & 255, (_e & 4278190080) >> 24, (_e & 16711680) >> 16, (_e & 65280) >> 8, _e & 255])));
      }
      return o.apply(null, V);
    }, g = function(v) {
      return o(Y.mp4a, new Uint8Array([
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        0,
        (v.channelcount & 65280) >> 8,
        v.channelcount & 255,
        (v.samplesize & 65280) >> 8,
        v.samplesize & 255,
        0,
        0,
        0,
        0,
        (v.samplerate & 65280) >> 8,
        v.samplerate & 255,
        0,
        0
      ]), l(v));
    };
  }(), k = function(g) {
    var y = new Uint8Array([
      0,
      0,
      0,
      7,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      (g.id & 4278190080) >> 24,
      (g.id & 16711680) >> 16,
      (g.id & 65280) >> 8,
      g.id & 255,
      0,
      0,
      0,
      0,
      (g.duration & 4278190080) >> 24,
      (g.duration & 16711680) >> 16,
      (g.duration & 65280) >> 8,
      g.duration & 255,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      64,
      0,
      0,
      0,
      (g.width & 65280) >> 8,
      g.width & 255,
      0,
      0,
      (g.height & 65280) >> 8,
      g.height & 255,
      0,
      0
    ]);
    return o(Y.tkhd, y);
  }, Fa = function(g) {
    var y, v, E, C, A, P, j;
    return y = o(Y.tfhd, new Uint8Array([
      0,
      0,
      0,
      58,
      (g.id & 4278190080) >> 24,
      (g.id & 16711680) >> 16,
      (g.id & 65280) >> 8,
      g.id & 255,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0
    ])), P = Math.floor(g.baseMediaDecodeTime / s), j = Math.floor(g.baseMediaDecodeTime % s), v = o(Y.tfdt, new Uint8Array([
      1,
      0,
      0,
      0,
      P >>> 24 & 255,
      P >>> 16 & 255,
      P >>> 8 & 255,
      P & 255,
      j >>> 24 & 255,
      j >>> 16 & 255,
      j >>> 8 & 255,
      j & 255
    ])), A = 32 + 20 + 8 + 16 + 8 + 8, g.type === "audio" ? (E = _t(g, A), o(Y.traf, y, v, E)) : (C = _r(g), E = _t(g, C.length + A), o(Y.traf, y, v, E, C));
  }, O = function(g) {
    return g.duration = g.duration || 4294967295, o(Y.trak, k(g), B(g));
  }, N = function(g) {
    var y = new Uint8Array([
      0,
      0,
      0,
      0,
      (g.id & 4278190080) >> 24,
      (g.id & 16711680) >> 16,
      (g.id & 65280) >> 8,
      g.id & 255,
      0,
      0,
      0,
      1,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      0,
      1
    ]);
    return g.type !== "video" && (y[y.length - 1] = 0), o(Y.trex, y);
  }, function() {
    var I, g, y;
    y = function(E, C) {
      var A = 0, P = 0, j = 0, V = 0;
      return E.length && (E[0].duration !== void 0 && (A = 1), E[0].size !== void 0 && (P = 2), E[0].flags !== void 0 && (j = 4), E[0].compositionTimeOffset !== void 0 && (V = 8)), [
        0,
        0,
        A | P | j | V,
        1,
        (E.length & 4278190080) >>> 24,
        (E.length & 16711680) >>> 16,
        (E.length & 65280) >>> 8,
        E.length & 255,
        (C & 4278190080) >>> 24,
        (C & 16711680) >>> 16,
        (C & 65280) >>> 8,
        C & 255
      ];
    }, g = function(E, C) {
      var A, P, j, V, q, _e;
      for (V = E.samples || [], C += 8 + 12 + 16 * V.length, j = y(V, C), P = new Uint8Array(j.length + V.length * 16), P.set(j), A = j.length, _e = 0; _e < V.length; _e++)
        q = V[_e], P[A++] = (q.duration & 4278190080) >>> 24, P[A++] = (q.duration & 16711680) >>> 16, P[A++] = (q.duration & 65280) >>> 8, P[A++] = q.duration & 255, P[A++] = (q.size & 4278190080) >>> 24, P[A++] = (q.size & 16711680) >>> 16, P[A++] = (q.size & 65280) >>> 8, P[A++] = q.size & 255, P[A++] = q.flags.isLeading << 2 | q.flags.dependsOn, P[A++] = q.flags.isDependedOn << 6 | q.flags.hasRedundancy << 4 | q.flags.paddingValue << 1 | q.flags.isNonSyncSample, P[A++] = q.flags.degradationPriority & 240 << 8, P[A++] = q.flags.degradationPriority & 15, P[A++] = (q.compositionTimeOffset & 4278190080) >>> 24, P[A++] = (q.compositionTimeOffset & 16711680) >>> 16, P[A++] = (q.compositionTimeOffset & 65280) >>> 8, P[A++] = q.compositionTimeOffset & 255;
      return o(Y.trun, P);
    }, I = function(E, C) {
      var A, P, j, V, q, _e;
      for (V = E.samples || [], C += 8 + 12 + 8 * V.length, j = y(V, C), A = new Uint8Array(j.length + V.length * 8), A.set(j), P = j.length, _e = 0; _e < V.length; _e++)
        q = V[_e], A[P++] = (q.duration & 4278190080) >>> 24, A[P++] = (q.duration & 16711680) >>> 16, A[P++] = (q.duration & 65280) >>> 8, A[P++] = q.duration & 255, A[P++] = (q.size & 4278190080) >>> 24, A[P++] = (q.size & 16711680) >>> 16, A[P++] = (q.size & 65280) >>> 8, A[P++] = q.size & 255;
      return o(Y.trun, A);
    }, _t = function(E, C) {
      return E.type === "audio" ? I(E, C) : g(E, C);
    };
  }();
  var h0 = {
    ftyp: f,
    mdat: d,
    moof: m,
    moov: _,
    initSegment: function(g) {
      var y = f(), v = _(g), E;
      return E = new Uint8Array(y.byteLength + v.byteLength), E.set(y), E.set(v, y.byteLength), E;
    }
  }, x0 = function(g) {
    var y, v, E = [], C = [];
    for (C.byteLength = 0, C.nalCount = 0, C.duration = 0, E.byteLength = 0, y = 0; y < g.length; y++)
      v = g[y], v.nalUnitType === "access_unit_delimiter_rbsp" ? (E.length && (E.duration = v.dts - E.dts, C.byteLength += E.byteLength, C.nalCount += E.length, C.duration += E.duration, C.push(E)), E = [v], E.byteLength = v.data.byteLength, E.pts = v.pts, E.dts = v.dts) : (v.nalUnitType === "slice_layer_without_partitioning_rbsp_idr" && (E.keyFrame = !0), E.duration = v.dts - E.dts, E.byteLength += v.data.byteLength, E.push(v));
    return C.length && (!E.duration || E.duration <= 0) && (E.duration = C[C.length - 1].duration), C.byteLength += E.byteLength, C.nalCount += E.length, C.duration += E.duration, C.push(E), C;
  }, C0 = function(g) {
    var y, v, E = [], C = [];
    for (E.byteLength = 0, E.nalCount = 0, E.duration = 0, E.pts = g[0].pts, E.dts = g[0].dts, C.byteLength = 0, C.nalCount = 0, C.duration = 0, C.pts = g[0].pts, C.dts = g[0].dts, y = 0; y < g.length; y++)
      v = g[y], v.keyFrame ? (E.length && (C.push(E), C.byteLength += E.byteLength, C.nalCount += E.nalCount, C.duration += E.duration), E = [v], E.nalCount = v.length, E.byteLength = v.byteLength, E.pts = v.pts, E.dts = v.dts, E.duration = v.duration) : (E.duration += v.duration, E.nalCount += v.length, E.byteLength += v.byteLength, E.push(v));
    return C.length && E.duration <= 0 && (E.duration = C[C.length - 1].duration), C.byteLength += E.byteLength, C.nalCount += E.nalCount, C.duration += E.duration, C.push(E), C;
  }, A0 = function(g) {
    var y;
    return !g[0][0].keyFrame && g.length > 1 && (y = g.shift(), g.byteLength -= y.byteLength, g.nalCount -= y.nalCount, g[0][0].dts = y.dts, g[0][0].pts = y.pts, g[0][0].duration += y.duration), g;
  }, rT = function() {
    return {
      size: 0,
      flags: {
        isLeading: 0,
        dependsOn: 1,
        isDependedOn: 0,
        hasRedundancy: 0,
        degradationPriority: 0,
        isNonSyncSample: 1
      }
    };
  }, T_ = function(g, y) {
    var v = rT();
    return v.dataOffset = y, v.compositionTimeOffset = g.pts - g.dts, v.duration = g.duration, v.size = 4 * g.length, v.size += g.byteLength, g.keyFrame && (v.flags.dependsOn = 2, v.flags.isNonSyncSample = 0), v;
  }, nT = function(g, y) {
    var v, E, C, A, P, j = y || 0, V = [];
    for (v = 0; v < g.length; v++)
      for (A = g[v], E = 0; E < A.length; E++)
        P = A[E], C = T_(P, j), j += C.size, V.push(C);
    return V;
  }, iT = function(g) {
    var y, v, E, C, A, P, j = 0, V = g.byteLength, q = g.nalCount, _e = V + 4 * q, ka = new Uint8Array(_e), _c = new DataView(ka.buffer);
    for (y = 0; y < g.length; y++)
      for (C = g[y], v = 0; v < C.length; v++)
        for (A = C[v], E = 0; E < A.length; E++)
          P = A[E], _c.setUint32(j, P.data.byteLength), j += 4, ka.set(P.data, j), j += P.data.byteLength;
    return ka;
  }, aT = function(g, y) {
    var v, E = y || 0, C = [];
    return v = T_(g, E), C.push(v), C;
  }, sT = function(g) {
    var y, v, E = 0, C = g.byteLength, A = g.length, P = C + 4 * A, j = new Uint8Array(P), V = new DataView(j.buffer);
    for (y = 0; y < g.length; y++)
      v = g[y], V.setUint32(E, v.data.byteLength), E += 4, j.set(v.data, E), E += v.data.byteLength;
    return j;
  }, R0 = {
    groupNalsIntoFrames: x0,
    groupFramesIntoGops: C0,
    extendFirstKeyFrame: A0,
    generateSampleTable: nT,
    concatenateNalData: iT,
    generateSampleTableForFrame: aT,
    concatenateNalDataForFrame: sT
  }, v0 = [33, 16, 5, 32, 164, 27], a_ = [33, 65, 108, 84, 1, 2, 4, 8, 168, 2, 4, 8, 17, 191, 252], _v = function(g) {
    for (var y = []; g--; )
      y.push(0);
    return y;
  }, oT = function(g) {
    return Object.keys(g).reduce(function(y, v) {
      return y[v] = new Uint8Array(g[v].reduce(function(E, C) {
        return E.concat(C);
      }, [])), y;
    }, {});
  }, s_, uT = function() {
    if (!s_) {
      var g = {
        96e3: [v0, [227, 64], _v(154), [56]],
        88200: [v0, [231], _v(170), [56]],
        64e3: [v0, [248, 192], _v(240), [56]],
        48e3: [v0, [255, 192], _v(268), [55, 148, 128], _v(54), [112]],
        44100: [v0, [255, 192], _v(268), [55, 163, 128], _v(84), [112]],
        32e3: [v0, [255, 192], _v(268), [55, 234], _v(226), [112]],
        24e3: [v0, [255, 192], _v(268), [55, 255, 128], _v(268), [111, 112], _v(126), [224]],
        16e3: [v0, [255, 192], _v(268), [55, 255, 128], _v(268), [111, 255], _v(269), [223, 108], _v(195), [1, 192]],
        12e3: [a_, _v(268), [3, 127, 248], _v(268), [6, 255, 240], _v(268), [13, 255, 224], _v(268), [27, 253, 128], _v(259), [56]],
        11025: [a_, _v(268), [3, 127, 248], _v(268), [6, 255, 240], _v(268), [13, 255, 224], _v(268), [27, 255, 192], _v(268), [55, 175, 128], _v(108), [112]],
        8e3: [a_, _v(268), [3, 121, 16], _v(47), [7]]
      };
      s_ = oT(g);
    }
    return s_;
  }, o_ = 9e4, u_, c_, j0, l_, E_, S_, w_;
  u_ = function(g) {
    return g * o_;
  }, c_ = function(g, y) {
    return g * y;
  }, j0 = function(g) {
    return g / o_;
  }, l_ = function(g, y) {
    return g / y;
  }, E_ = function(g, y) {
    return u_(l_(g, y));
  }, S_ = function(g, y) {
    return c_(j0(g), y);
  }, w_ = function(g, y, v) {
    return j0(v ? g : g - y);
  };
  var _m = {
    ONE_SECOND_IN_TS: o_,
    secondsToVideoTs: u_,
    secondsToAudioTs: c_,
    videoTsToSeconds: j0,
    audioTsToSeconds: l_,
    audioTsToVideoTs: E_,
    videoTsToAudioTs: S_,
    metadataTsToSeconds: w_
  }, cT = function(g) {
    var y, v, E = 0;
    for (y = 0; y < g.length; y++)
      v = g[y], E += v.data.byteLength;
    return E;
  }, lT = function(g, y, v, E) {
    var C, A = 0, P = 0, j = 0, V = 0, q, _e, ka;
    if (!!y.length && (C = _m.audioTsToVideoTs(g.baseMediaDecodeTime, g.samplerate), A = Math.ceil(_m.ONE_SECOND_IN_TS / (g.samplerate / 1024)), v && E && (P = C - Math.max(v, E), j = Math.floor(P / A), V = j * A), !(j < 1 || V > _m.ONE_SECOND_IN_TS / 2))) {
      for (q = uT()[g.samplerate], q || (q = y[0].data), _e = 0; _e < j; _e++)
        ka = y[0], y.splice(0, 0, {
          data: q,
          dts: ka.dts - A,
          pts: ka.pts - A
        });
      return g.baseMediaDecodeTime -= Math.floor(_m.videoTsToAudioTs(V, g.samplerate)), V;
    }
  }, fT = function(g, y, v) {
    return y.minSegmentDts >= v ? g : (y.minSegmentDts = 1 / 0, g.filter(function(E) {
      return E.dts >= v ? (y.minSegmentDts = Math.min(y.minSegmentDts, E.dts), y.minSegmentPts = y.minSegmentDts, !0) : !1;
    }));
  }, dT = function(g) {
    var y, v, E = [];
    for (y = 0; y < g.length; y++)
      v = g[y], E.push({
        size: v.data.byteLength,
        duration: 1024
      });
    return E;
  }, hT = function(g) {
    var y, v, E = 0, C = new Uint8Array(cT(g));
    for (y = 0; y < g.length; y++)
      v = g[y], C.set(v.data, E), E += v.data.byteLength;
    return C;
  }, B0 = {
    prefixWithSilence: lT,
    trimAdtsFramesByEarliestDts: fT,
    generateSampleTable: dT,
    concatenateFrameData: hT
  }, pT = _m.ONE_SECOND_IN_TS, gT = function(g, y) {
    typeof y.pts == "number" && (g.timelineStartInfo.pts === void 0 && (g.timelineStartInfo.pts = y.pts), g.minSegmentPts === void 0 ? g.minSegmentPts = y.pts : g.minSegmentPts = Math.min(g.minSegmentPts, y.pts), g.maxSegmentPts === void 0 ? g.maxSegmentPts = y.pts : g.maxSegmentPts = Math.max(g.maxSegmentPts, y.pts)), typeof y.dts == "number" && (g.timelineStartInfo.dts === void 0 && (g.timelineStartInfo.dts = y.dts), g.minSegmentDts === void 0 ? g.minSegmentDts = y.dts : g.minSegmentDts = Math.min(g.minSegmentDts, y.dts), g.maxSegmentDts === void 0 ? g.maxSegmentDts = y.dts : g.maxSegmentDts = Math.max(g.maxSegmentDts, y.dts));
  }, mT = function(g) {
    delete g.minSegmentDts, delete g.maxSegmentDts, delete g.minSegmentPts, delete g.maxSegmentPts;
  }, vT = function(g, y) {
    var v, E, C = g.minSegmentDts;
    return y || (C -= g.timelineStartInfo.dts), v = g.timelineStartInfo.baseMediaDecodeTime, v += C, v = Math.max(0, v), g.type === "audio" && (E = g.samplerate / pT, v *= E, v = Math.floor(v)), v;
  }, d0 = {
    clearDtsInfo: mT,
    calculateTrackBaseMediaDecodeTime: vT,
    collectDtsInfo: gT
  }, x_ = 4, yT = 128, _T = function(g) {
    for (var y = 0, v = {
      payloadType: -1,
      payloadSize: 0
    }, E = 0, C = 0; y < g.byteLength && g[y] !== yT; ) {
      for (; g[y] === 255; )
        E += 255, y++;
      for (E += g[y++]; g[y] === 255; )
        C += 255, y++;
      if (C += g[y++], !v.payload && E === x_) {
        var A = String.fromCharCode(g[y + 3], g[y + 4], g[y + 5], g[y + 6]);
        if (A === "GA94") {
          v.payloadType = E, v.payloadSize = C, v.payload = g.subarray(y, y + C);
          break;
        } else
          v.payload = void 0;
      }
      y += C, E = 0, C = 0;
    }
    return v;
  }, bT = function(g) {
    return g.payload[0] !== 181 || (g.payload[1] << 8 | g.payload[2]) !== 49 || String.fromCharCode(g.payload[3], g.payload[4], g.payload[5], g.payload[6]) !== "GA94" || g.payload[7] !== 3 ? null : g.payload.subarray(8, g.payload.length - 1);
  }, TT = function(g, y) {
    var v = [], E, C, A, P;
    if (!(y[0] & 64))
      return v;
    for (C = y[0] & 31, E = 0; E < C; E++)
      A = E * 3, P = {
        type: y[A + 2] & 3,
        pts: g
      }, y[A + 2] & 4 && (P.ccData = y[A + 3] << 8 | y[A + 4], v.push(P));
    return v;
  }, ET = function(g) {
    for (var y = g.byteLength, v = [], E = 1, C, A; E < y - 2; )
      g[E] === 0 && g[E + 1] === 0 && g[E + 2] === 3 ? (v.push(E + 2), E += 2) : E++;
    if (v.length === 0)
      return g;
    C = y - v.length, A = new Uint8Array(C);
    var P = 0;
    for (E = 0; E < C; P++, E++)
      P === v[0] && (P++, v.shift()), A[E] = g[P];
    return A;
  }, P0 = {
    parseSei: _T,
    parseUserData: bT,
    parseCaptionPackets: TT,
    discardEmulationPreventionBytes: ET,
    USER_DATA_REGISTERED_ITU_T_T35: x_
  }, l0 = function I(g) {
    g = g || {}, I.prototype.init.call(this), this.parse708captions_ = typeof g.parse708captions == "boolean" ? g.parse708captions : !0, this.captionPackets_ = [], this.ccStreams_ = [
      new i0(0, 0),
      new i0(0, 1),
      new i0(1, 0),
      new i0(1, 1)
    ], this.parse708captions_ && (this.cc708Stream_ = new r0({
      captionServices: g.captionServices
    })), this.reset(), this.ccStreams_.forEach(function(y) {
      y.on("data", this.trigger.bind(this, "data")), y.on("partialdone", this.trigger.bind(this, "partialdone")), y.on("done", this.trigger.bind(this, "done"));
    }, this), this.parse708captions_ && (this.cc708Stream_.on("data", this.trigger.bind(this, "data")), this.cc708Stream_.on("partialdone", this.trigger.bind(this, "partialdone")), this.cc708Stream_.on("done", this.trigger.bind(this, "done")));
  };
  l0.prototype = new e(), l0.prototype.push = function(I) {
    var g, y, v;
    if (I.nalUnitType === "sei_rbsp" && (g = P0.parseSei(I.escapedRBSP), !!g.payload && g.payloadType === P0.USER_DATA_REGISTERED_ITU_T_T35 && (y = P0.parseUserData(g), !!y))) {
      if (I.dts < this.latestDts_) {
        this.ignoreNextEqualDts_ = !0;
        return;
      } else if (I.dts === this.latestDts_ && this.ignoreNextEqualDts_) {
        this.numSameDts_--, this.numSameDts_ || (this.ignoreNextEqualDts_ = !1);
        return;
      }
      v = P0.parseCaptionPackets(I.pts, y), this.captionPackets_ = this.captionPackets_.concat(v), this.latestDts_ !== I.dts && (this.numSameDts_ = 0), this.numSameDts_++, this.latestDts_ = I.dts;
    }
  }, l0.prototype.flushCCStreams = function(I) {
    this.ccStreams_.forEach(function(g) {
      return I === "flush" ? g.flush() : g.partialFlush();
    }, this);
  }, l0.prototype.flushStream = function(I) {
    if (!this.captionPackets_.length) {
      this.flushCCStreams(I);
      return;
    }
    this.captionPackets_.forEach(function(g, y) {
      g.presortIndex = y;
    }), this.captionPackets_.sort(function(g, y) {
      return g.pts === y.pts ? g.presortIndex - y.presortIndex : g.pts - y.pts;
    }), this.captionPackets_.forEach(function(g) {
      g.type < 2 ? this.dispatchCea608Packet(g) : this.dispatchCea708Packet(g);
    }, this), this.captionPackets_.length = 0, this.flushCCStreams(I);
  }, l0.prototype.flush = function() {
    return this.flushStream("flush");
  }, l0.prototype.partialFlush = function() {
    return this.flushStream("partialFlush");
  }, l0.prototype.reset = function() {
    this.latestDts_ = null, this.ignoreNextEqualDts_ = !1, this.numSameDts_ = 0, this.activeCea608Channel_ = [null, null], this.ccStreams_.forEach(function(I) {
      I.reset();
    });
  }, l0.prototype.dispatchCea608Packet = function(I) {
    this.setsTextOrXDSActive(I) ? this.activeCea608Channel_[I.type] = null : this.setsChannel1Active(I) ? this.activeCea608Channel_[I.type] = 0 : this.setsChannel2Active(I) && (this.activeCea608Channel_[I.type] = 1), this.activeCea608Channel_[I.type] !== null && this.ccStreams_[(I.type << 1) + this.activeCea608Channel_[I.type]].push(I);
  }, l0.prototype.setsChannel1Active = function(I) {
    return (I.ccData & 30720) === 4096;
  }, l0.prototype.setsChannel2Active = function(I) {
    return (I.ccData & 30720) === 6144;
  }, l0.prototype.setsTextOrXDSActive = function(I) {
    return (I.ccData & 28928) === 256 || (I.ccData & 30974) === 4138 || (I.ccData & 30974) === 6186;
  }, l0.prototype.dispatchCea708Packet = function(I) {
    this.parse708captions_ && this.cc708Stream_.push(I);
  };
  var ST = {
    127: 9834,
    4128: 32,
    4129: 160,
    4133: 8230,
    4138: 352,
    4140: 338,
    4144: 9608,
    4145: 8216,
    4146: 8217,
    4147: 8220,
    4148: 8221,
    4149: 8226,
    4153: 8482,
    4154: 353,
    4156: 339,
    4157: 8480,
    4159: 376,
    4214: 8539,
    4215: 8540,
    4216: 8541,
    4217: 8542,
    4218: 9168,
    4219: 9124,
    4220: 9123,
    4221: 9135,
    4222: 9126,
    4223: 9121,
    4256: 12600
  }, wT = function(g) {
    var y = ST[g] || g;
    return g & 4096 && g === y ? "" : String.fromCharCode(y);
  }, q0 = function(g) {
    return 32 <= g && g <= 127 || 160 <= g && g <= 255;
  }, g0 = function(g) {
    this.windowNum = g, this.reset();
  };
  g0.prototype.reset = function() {
    this.clearText(), this.pendingNewLine = !1, this.winAttr = {}, this.penAttr = {}, this.penLoc = {}, this.penColor = {}, this.visible = 0, this.rowLock = 0, this.columnLock = 0, this.priority = 0, this.relativePositioning = 0, this.anchorVertical = 0, this.anchorHorizontal = 0, this.anchorPoint = 0, this.rowCount = 1, this.virtualRowCount = this.rowCount + 1, this.columnCount = 41, this.windowStyle = 0, this.penStyle = 0;
  }, g0.prototype.getText = function() {
    return this.rows.join(`
`);
  }, g0.prototype.clearText = function() {
    this.rows = [""], this.rowIdx = 0;
  }, g0.prototype.newLine = function(I) {
    for (this.rows.length >= this.virtualRowCount && typeof this.beforeRowOverflow == "function" && this.beforeRowOverflow(I), this.rows.length > 0 && (this.rows.push(""), this.rowIdx++); this.rows.length > this.virtualRowCount; )
      this.rows.shift(), this.rowIdx--;
  }, g0.prototype.isEmpty = function() {
    return this.rows.length === 0 ? !0 : this.rows.length === 1 ? this.rows[0] === "" : !1;
  }, g0.prototype.addText = function(I) {
    this.rows[this.rowIdx] += I;
  }, g0.prototype.backspace = function() {
    if (!this.isEmpty()) {
      var I = this.rows[this.rowIdx];
      this.rows[this.rowIdx] = I.substr(0, I.length - 1);
    }
  };
  var G0 = function(g, y, v) {
    this.serviceNum = g, this.text = "", this.currentWindow = new g0(-1), this.windows = [], this.stream = v, typeof y == "string" && this.createTextDecoder(y);
  };
  G0.prototype.init = function(I, g) {
    this.startPts = I;
    for (var y = 0; y < 8; y++)
      this.windows[y] = new g0(y), typeof g == "function" && (this.windows[y].beforeRowOverflow = g);
  }, G0.prototype.setCurrentWindow = function(I) {
    this.currentWindow = this.windows[I];
  }, G0.prototype.createTextDecoder = function(I) {
    if (typeof TextDecoder > "u")
      this.stream.trigger("log", {
        level: "warn",
        message: "The `encoding` option is unsupported without TextDecoder support"
      });
    else
      try {
        this.textDecoder_ = new TextDecoder(I);
      } catch (g) {
        this.stream.trigger("log", {
          level: "warn",
          message: "TextDecoder could not be created with " + I + " encoding. " + g
        });
      }
  };
  var r0 = function I(g) {
    g = g || {}, I.prototype.init.call(this);
    var y = this, v = g.captionServices || {}, E = {}, C;
    Object.keys(v).forEach(function(A) {
      C = v[A], /^SERVICE/.test(A) && (E[A] = C.encoding);
    }), this.serviceEncodings = E, this.current708Packet = null, this.services = {}, this.push = function(A) {
      A.type === 3 ? (y.new708Packet(), y.add708Bytes(A)) : (y.current708Packet === null && y.new708Packet(), y.add708Bytes(A));
    };
  };
  r0.prototype = new e(), r0.prototype.new708Packet = function() {
    this.current708Packet !== null && this.push708Packet(), this.current708Packet = {
      data: [],
      ptsVals: []
    };
  }, r0.prototype.add708Bytes = function(I) {
    var g = I.ccData, y = g >>> 8, v = g & 255;
    this.current708Packet.ptsVals.push(I.pts), this.current708Packet.data.push(y), this.current708Packet.data.push(v);
  }, r0.prototype.push708Packet = function() {
    var I = this.current708Packet, g = I.data, y = null, v = null, E = 0, C = g[E++];
    for (I.seq = C >> 6, I.sizeCode = C & 63; E < g.length; E++)
      C = g[E++], y = C >> 5, v = C & 31, y === 7 && v > 0 && (C = g[E++], y = C), this.pushServiceBlock(y, E, v), v > 0 && (E += v - 1);
  }, r0.prototype.pushServiceBlock = function(I, g, y) {
    var v, E = g, C = this.current708Packet.data, A = this.services[I];
    for (A || (A = this.initService(I, E)); E < g + y && E < C.length; E++)
      v = C[E], q0(v) ? E = this.handleText(E, A) : v === 24 ? E = this.multiByteCharacter(E, A) : v === 16 ? E = this.extendedCommands(E, A) : 128 <= v && v <= 135 ? E = this.setCurrentWindow(E, A) : 152 <= v && v <= 159 ? E = this.defineWindow(E, A) : v === 136 ? E = this.clearWindows(E, A) : v === 140 ? E = this.deleteWindows(E, A) : v === 137 ? E = this.displayWindows(E, A) : v === 138 ? E = this.hideWindows(E, A) : v === 139 ? E = this.toggleWindows(E, A) : v === 151 ? E = this.setWindowAttributes(E, A) : v === 144 ? E = this.setPenAttributes(E, A) : v === 145 ? E = this.setPenColor(E, A) : v === 146 ? E = this.setPenLocation(E, A) : v === 143 ? A = this.reset(E, A) : v === 8 ? A.currentWindow.backspace() : v === 12 ? A.currentWindow.clearText() : v === 13 ? A.currentWindow.pendingNewLine = !0 : v === 14 ? A.currentWindow.clearText() : v === 141 && E++;
  }, r0.prototype.extendedCommands = function(I, g) {
    var y = this.current708Packet.data, v = y[++I];
    return q0(v) && (I = this.handleText(I, g, {
      isExtended: !0
    })), I;
  }, r0.prototype.getPts = function(I) {
    return this.current708Packet.ptsVals[Math.floor(I / 2)];
  }, r0.prototype.initService = function(I, g) {
    var v = "SERVICE" + I, y = this, v, E;
    return v in this.serviceEncodings && (E = this.serviceEncodings[v]), this.services[I] = new G0(I, E, y), this.services[I].init(this.getPts(g), function(C) {
      y.flushDisplayed(C, y.services[I]);
    }), this.services[I];
  }, r0.prototype.handleText = function(I, g, y) {
    var v = y && y.isExtended, E = y && y.isMultiByte, C = this.current708Packet.data, A = v ? 4096 : 0, P = C[I], j = C[I + 1], V = g.currentWindow, q, _e;
    return g.textDecoder_ && !v ? (E ? (_e = [P, j], I++) : _e = [P], q = g.textDecoder_.decode(new Uint8Array(_e))) : q = wT(A | P), V.pendingNewLine && !V.isEmpty() && V.newLine(this.getPts(I)), V.pendingNewLine = !1, V.addText(q), I;
  }, r0.prototype.multiByteCharacter = function(I, g) {
    var y = this.current708Packet.data, v = y[I + 1], E = y[I + 2];
    return q0(v) && q0(E) && (I = this.handleText(++I, g, {
      isMultiByte: !0
    })), I;
  }, r0.prototype.setCurrentWindow = function(I, g) {
    var y = this.current708Packet.data, v = y[I], E = v & 7;
    return g.setCurrentWindow(E), I;
  }, r0.prototype.defineWindow = function(I, g) {
    var y = this.current708Packet.data, v = y[I], E = v & 7;
    g.setCurrentWindow(E);
    var C = g.currentWindow;
    return v = y[++I], C.visible = (v & 32) >> 5, C.rowLock = (v & 16) >> 4, C.columnLock = (v & 8) >> 3, C.priority = v & 7, v = y[++I], C.relativePositioning = (v & 128) >> 7, C.anchorVertical = v & 127, v = y[++I], C.anchorHorizontal = v, v = y[++I], C.anchorPoint = (v & 240) >> 4, C.rowCount = v & 15, v = y[++I], C.columnCount = v & 63, v = y[++I], C.windowStyle = (v & 56) >> 3, C.penStyle = v & 7, C.virtualRowCount = C.rowCount + 1, I;
  }, r0.prototype.setWindowAttributes = function(I, g) {
    var y = this.current708Packet.data, v = y[I], E = g.currentWindow.winAttr;
    return v = y[++I], E.fillOpacity = (v & 192) >> 6, E.fillRed = (v & 48) >> 4, E.fillGreen = (v & 12) >> 2, E.fillBlue = v & 3, v = y[++I], E.borderType = (v & 192) >> 6, E.borderRed = (v & 48) >> 4, E.borderGreen = (v & 12) >> 2, E.borderBlue = v & 3, v = y[++I], E.borderType += (v & 128) >> 5, E.wordWrap = (v & 64) >> 6, E.printDirection = (v & 48) >> 4, E.scrollDirection = (v & 12) >> 2, E.justify = v & 3, v = y[++I], E.effectSpeed = (v & 240) >> 4, E.effectDirection = (v & 12) >> 2, E.displayEffect = v & 3, I;
  }, r0.prototype.flushDisplayed = function(I, g) {
    for (var y = [], v = 0; v < 8; v++)
      g.windows[v].visible && !g.windows[v].isEmpty() && y.push(g.windows[v].getText());
    g.endPts = I, g.text = y.join(`

`), this.pushCaption(g), g.startPts = I;
  }, r0.prototype.pushCaption = function(I) {
    I.text !== "" && (this.trigger("data", {
      startPts: I.startPts,
      endPts: I.endPts,
      text: I.text,
      stream: "cc708_" + I.serviceNum
    }), I.text = "", I.startPts = I.endPts);
  }, r0.prototype.displayWindows = function(I, g) {
    var y = this.current708Packet.data, v = y[++I], E = this.getPts(I);
    this.flushDisplayed(E, g);
    for (var C = 0; C < 8; C++)
      v & 1 << C && (g.windows[C].visible = 1);
    return I;
  }, r0.prototype.hideWindows = function(I, g) {
    var y = this.current708Packet.data, v = y[++I], E = this.getPts(I);
    this.flushDisplayed(E, g);
    for (var C = 0; C < 8; C++)
      v & 1 << C && (g.windows[C].visible = 0);
    return I;
  }, r0.prototype.toggleWindows = function(I, g) {
    var y = this.current708Packet.data, v = y[++I], E = this.getPts(I);
    this.flushDisplayed(E, g);
    for (var C = 0; C < 8; C++)
      v & 1 << C && (g.windows[C].visible ^= 1);
    return I;
  }, r0.prototype.clearWindows = function(I, g) {
    var y = this.current708Packet.data, v = y[++I], E = this.getPts(I);
    this.flushDisplayed(E, g);
    for (var C = 0; C < 8; C++)
      v & 1 << C && g.windows[C].clearText();
    return I;
  }, r0.prototype.deleteWindows = function(I, g) {
    var y = this.current708Packet.data, v = y[++I], E = this.getPts(I);
    this.flushDisplayed(E, g);
    for (var C = 0; C < 8; C++)
      v & 1 << C && g.windows[C].reset();
    return I;
  }, r0.prototype.setPenAttributes = function(I, g) {
    var y = this.current708Packet.data, v = y[I], E = g.currentWindow.penAttr;
    return v = y[++I], E.textTag = (v & 240) >> 4, E.offset = (v & 12) >> 2, E.penSize = v & 3, v = y[++I], E.italics = (v & 128) >> 7, E.underline = (v & 64) >> 6, E.edgeType = (v & 56) >> 3, E.fontStyle = v & 7, I;
  }, r0.prototype.setPenColor = function(I, g) {
    var y = this.current708Packet.data, v = y[I], E = g.currentWindow.penColor;
    return v = y[++I], E.fgOpacity = (v & 192) >> 6, E.fgRed = (v & 48) >> 4, E.fgGreen = (v & 12) >> 2, E.fgBlue = v & 3, v = y[++I], E.bgOpacity = (v & 192) >> 6, E.bgRed = (v & 48) >> 4, E.bgGreen = (v & 12) >> 2, E.bgBlue = v & 3, v = y[++I], E.edgeRed = (v & 48) >> 4, E.edgeGreen = (v & 12) >> 2, E.edgeBlue = v & 3, I;
  }, r0.prototype.setPenLocation = function(I, g) {
    var y = this.current708Packet.data, v = y[I], E = g.currentWindow.penLoc;
    return g.currentWindow.pendingNewLine = !0, v = y[++I], E.row = v & 15, v = y[++I], E.column = v & 63, I;
  }, r0.prototype.reset = function(I, g) {
    var y = this.getPts(I);
    return this.flushDisplayed(y, g), this.initService(g.serviceNum, I);
  };
  var xT = {
    42: 225,
    92: 233,
    94: 237,
    95: 243,
    96: 250,
    123: 231,
    124: 247,
    125: 209,
    126: 241,
    127: 9608,
    304: 174,
    305: 176,
    306: 189,
    307: 191,
    308: 8482,
    309: 162,
    310: 163,
    311: 9834,
    312: 224,
    313: 160,
    314: 232,
    315: 226,
    316: 234,
    317: 238,
    318: 244,
    319: 251,
    544: 193,
    545: 201,
    546: 211,
    547: 218,
    548: 220,
    549: 252,
    550: 8216,
    551: 161,
    552: 42,
    553: 39,
    554: 8212,
    555: 169,
    556: 8480,
    557: 8226,
    558: 8220,
    559: 8221,
    560: 192,
    561: 194,
    562: 199,
    563: 200,
    564: 202,
    565: 203,
    566: 235,
    567: 206,
    568: 207,
    569: 239,
    570: 212,
    571: 217,
    572: 249,
    573: 219,
    574: 171,
    575: 187,
    800: 195,
    801: 227,
    802: 205,
    803: 204,
    804: 236,
    805: 210,
    806: 242,
    807: 213,
    808: 245,
    809: 123,
    810: 125,
    811: 92,
    812: 94,
    813: 95,
    814: 124,
    815: 126,
    816: 196,
    817: 228,
    818: 214,
    819: 246,
    820: 223,
    821: 165,
    822: 164,
    823: 9474,
    824: 197,
    825: 229,
    826: 216,
    827: 248,
    828: 9484,
    829: 9488,
    830: 9492,
    831: 9496
  }, H0 = function(g) {
    return g === null ? "" : (g = xT[g] || g, String.fromCharCode(g));
  }, V0 = 14, CT = [4352, 4384, 4608, 4640, 5376, 5408, 5632, 5664, 5888, 5920, 4096, 4864, 4896, 5120, 5152], _0 = function() {
    for (var g = [], y = V0 + 1; y--; )
      g.push("");
    return g;
  }, i0 = function I(g, y) {
    I.prototype.init.call(this), this.field_ = g || 0, this.dataChannel_ = y || 0, this.name_ = "CC" + ((this.field_ << 1 | this.dataChannel_) + 1), this.setConstants(), this.reset(), this.push = function(v) {
      var E, C, A, P, j;
      if (E = v.ccData & 32639, E === this.lastControlCode_) {
        this.lastControlCode_ = null;
        return;
      }
      if ((E & 61440) === 4096 ? this.lastControlCode_ = E : E !== this.PADDING_ && (this.lastControlCode_ = null), A = E >>> 8, P = E & 255, E !== this.PADDING_)
        if (E === this.RESUME_CAPTION_LOADING_)
          this.mode_ = "popOn";
        else if (E === this.END_OF_CAPTION_)
          this.mode_ = "popOn", this.clearFormatting(v.pts), this.flushDisplayed(v.pts), C = this.displayed_, this.displayed_ = this.nonDisplayed_, this.nonDisplayed_ = C, this.startPts_ = v.pts;
        else if (E === this.ROLL_UP_2_ROWS_)
          this.rollUpRows_ = 2, this.setRollUp(v.pts);
        else if (E === this.ROLL_UP_3_ROWS_)
          this.rollUpRows_ = 3, this.setRollUp(v.pts);
        else if (E === this.ROLL_UP_4_ROWS_)
          this.rollUpRows_ = 4, this.setRollUp(v.pts);
        else if (E === this.CARRIAGE_RETURN_)
          this.clearFormatting(v.pts), this.flushDisplayed(v.pts), this.shiftRowsUp_(), this.startPts_ = v.pts;
        else if (E === this.BACKSPACE_)
          this.mode_ === "popOn" ? this.nonDisplayed_[this.row_] = this.nonDisplayed_[this.row_].slice(0, -1) : this.displayed_[this.row_] = this.displayed_[this.row_].slice(0, -1);
        else if (E === this.ERASE_DISPLAYED_MEMORY_)
          this.flushDisplayed(v.pts), this.displayed_ = _0();
        else if (E === this.ERASE_NON_DISPLAYED_MEMORY_)
          this.nonDisplayed_ = _0();
        else if (E === this.RESUME_DIRECT_CAPTIONING_)
          this.mode_ !== "paintOn" && (this.flushDisplayed(v.pts), this.displayed_ = _0()), this.mode_ = "paintOn", this.startPts_ = v.pts;
        else if (this.isSpecialCharacter(A, P))
          A = (A & 3) << 8, j = H0(A | P), this[this.mode_](v.pts, j), this.column_++;
        else if (this.isExtCharacter(A, P))
          this.mode_ === "popOn" ? this.nonDisplayed_[this.row_] = this.nonDisplayed_[this.row_].slice(0, -1) : this.displayed_[this.row_] = this.displayed_[this.row_].slice(0, -1), A = (A & 3) << 8, j = H0(A | P), this[this.mode_](v.pts, j), this.column_++;
        else if (this.isMidRowCode(A, P))
          this.clearFormatting(v.pts), this[this.mode_](v.pts, " "), this.column_++, (P & 14) === 14 && this.addFormatting(v.pts, ["i"]), (P & 1) === 1 && this.addFormatting(v.pts, ["u"]);
        else if (this.isOffsetControlCode(A, P))
          this.column_ += P & 3;
        else if (this.isPAC(A, P)) {
          var V = CT.indexOf(E & 7968);
          this.mode_ === "rollUp" && (V - this.rollUpRows_ + 1 < 0 && (V = this.rollUpRows_ - 1), this.setRollUp(v.pts, V)), V !== this.row_ && (this.clearFormatting(v.pts), this.row_ = V), P & 1 && this.formatting_.indexOf("u") === -1 && this.addFormatting(v.pts, ["u"]), (E & 16) === 16 && (this.column_ = ((E & 14) >> 1) * 4), this.isColorPAC(P) && (P & 14) === 14 && this.addFormatting(v.pts, ["i"]);
        } else
          this.isNormalChar(A) && (P === 0 && (P = null), j = H0(A), j += H0(P), this[this.mode_](v.pts, j), this.column_ += j.length);
    };
  };
  i0.prototype = new e(), i0.prototype.flushDisplayed = function(I) {
    var g = this.displayed_.map(function(y, v) {
      try {
        return y.trim();
      } catch {
        return this.trigger("log", {
          level: "warn",
          message: "Skipping a malformed 608 caption at index " + v + "."
        }), "";
      }
    }, this).join(`
`).replace(/^\n+|\n+$/g, "");
    g.length && this.trigger("data", {
      startPts: this.startPts_,
      endPts: I,
      text: g,
      stream: this.name_
    });
  }, i0.prototype.reset = function() {
    this.mode_ = "popOn", this.topRow_ = 0, this.startPts_ = 0, this.displayed_ = _0(), this.nonDisplayed_ = _0(), this.lastControlCode_ = null, this.column_ = 0, this.row_ = V0, this.rollUpRows_ = 2, this.formatting_ = [];
  }, i0.prototype.setConstants = function() {
    this.dataChannel_ === 0 ? (this.BASE_ = 16, this.EXT_ = 17, this.CONTROL_ = (20 | this.field_) << 8, this.OFFSET_ = 23) : this.dataChannel_ === 1 && (this.BASE_ = 24, this.EXT_ = 25, this.CONTROL_ = (28 | this.field_) << 8, this.OFFSET_ = 31), this.PADDING_ = 0, this.RESUME_CAPTION_LOADING_ = this.CONTROL_ | 32, this.END_OF_CAPTION_ = this.CONTROL_ | 47, this.ROLL_UP_2_ROWS_ = this.CONTROL_ | 37, this.ROLL_UP_3_ROWS_ = this.CONTROL_ | 38, this.ROLL_UP_4_ROWS_ = this.CONTROL_ | 39, this.CARRIAGE_RETURN_ = this.CONTROL_ | 45, this.RESUME_DIRECT_CAPTIONING_ = this.CONTROL_ | 41, this.BACKSPACE_ = this.CONTROL_ | 33, this.ERASE_DISPLAYED_MEMORY_ = this.CONTROL_ | 44, this.ERASE_NON_DISPLAYED_MEMORY_ = this.CONTROL_ | 46;
  }, i0.prototype.isSpecialCharacter = function(I, g) {
    return I === this.EXT_ && g >= 48 && g <= 63;
  }, i0.prototype.isExtCharacter = function(I, g) {
    return (I === this.EXT_ + 1 || I === this.EXT_ + 2) && g >= 32 && g <= 63;
  }, i0.prototype.isMidRowCode = function(I, g) {
    return I === this.EXT_ && g >= 32 && g <= 47;
  }, i0.prototype.isOffsetControlCode = function(I, g) {
    return I === this.OFFSET_ && g >= 33 && g <= 35;
  }, i0.prototype.isPAC = function(I, g) {
    return I >= this.BASE_ && I < this.BASE_ + 8 && g >= 64 && g <= 127;
  }, i0.prototype.isColorPAC = function(I) {
    return I >= 64 && I <= 79 || I >= 96 && I <= 127;
  }, i0.prototype.isNormalChar = function(I) {
    return I >= 32 && I <= 127;
  }, i0.prototype.setRollUp = function(I, g) {
    if (this.mode_ !== "rollUp" && (this.row_ = V0, this.mode_ = "rollUp", this.flushDisplayed(I), this.nonDisplayed_ = _0(), this.displayed_ = _0()), g !== void 0 && g !== this.row_)
      for (var y = 0; y < this.rollUpRows_; y++)
        this.displayed_[g - y] = this.displayed_[this.row_ - y], this.displayed_[this.row_ - y] = "";
    g === void 0 && (g = this.row_), this.topRow_ = g - this.rollUpRows_ + 1;
  }, i0.prototype.addFormatting = function(I, g) {
    this.formatting_ = this.formatting_.concat(g);
    var y = g.reduce(function(v, E) {
      return v + "<" + E + ">";
    }, "");
    this[this.mode_](I, y);
  }, i0.prototype.clearFormatting = function(I) {
    if (!!this.formatting_.length) {
      var g = this.formatting_.reverse().reduce(function(y, v) {
        return y + "</" + v + ">";
      }, "");
      this.formatting_ = [], this[this.mode_](I, g);
    }
  }, i0.prototype.popOn = function(I, g) {
    var y = this.nonDisplayed_[this.row_];
    y += g, this.nonDisplayed_[this.row_] = y;
  }, i0.prototype.rollUp = function(I, g) {
    var y = this.displayed_[this.row_];
    y += g, this.displayed_[this.row_] = y;
  }, i0.prototype.shiftRowsUp_ = function() {
    var I;
    for (I = 0; I < this.topRow_; I++)
      this.displayed_[I] = "";
    for (I = this.row_ + 1; I < V0 + 1; I++)
      this.displayed_[I] = "";
    for (I = this.topRow_; I < this.row_; I++)
      this.displayed_[I] = this.displayed_[I + 1];
    this.displayed_[this.row_] = "";
  }, i0.prototype.paintOn = function(I, g) {
    var y = this.displayed_[this.row_];
    y += g, this.displayed_[this.row_] = y;
  };
  var $0 = {
    CaptionStream: l0,
    Cea608Stream: i0,
    Cea708Stream: r0
  }, o0 = {
    H264_STREAM_TYPE: 27,
    ADTS_STREAM_TYPE: 15,
    METADATA_STREAM_TYPE: 21
  }, AT = 8589934592, OT = 4294967296, C_ = "shared", f_ = function(g, y) {
    var v = 1;
    for (g > y && (v = -1); Math.abs(y - g) > OT; )
      g += v * AT;
    return g;
  }, A_ = function I(g) {
    var y, v;
    I.prototype.init.call(this), this.type_ = g || C_, this.push = function(E) {
      this.type_ !== C_ && E.type !== this.type_ || (v === void 0 && (v = E.dts), E.dts = f_(E.dts, v), E.pts = f_(E.pts, v), y = E.dts, this.trigger("data", E));
    }, this.flush = function() {
      v = y, this.trigger("done");
    }, this.endTimeline = function() {
      this.flush(), this.trigger("endedtimeline");
    }, this.discontinuity = function() {
      v = void 0, y = void 0;
    }, this.reset = function() {
      this.discontinuity(), this.trigger("reset");
    };
  };
  A_.prototype = new e();
  var O_ = {
    TimestampRolloverStream: A_,
    handleRollover: f_
  }, I_ = function(g, y, v) {
    var E, C = "";
    for (E = y; E < v; E++)
      C += "%" + ("00" + g[E].toString(16)).slice(-2);
    return C;
  }, z0 = function(g, y, v) {
    return decodeURIComponent(I_(g, y, v));
  }, IT = function(g, y, v) {
    return unescape(I_(g, y, v));
  }, K0 = function(g) {
    return g[0] << 21 | g[1] << 14 | g[2] << 7 | g[3];
  }, k_ = {
    TXXX: function(g) {
      var y;
      if (g.data[0] === 3) {
        for (y = 1; y < g.data.length; y++)
          if (g.data[y] === 0) {
            g.description = z0(g.data, 1, y), g.value = z0(g.data, y + 1, g.data.length).replace(/\0*$/, "");
            break;
          }
        g.data = g.value;
      }
    },
    WXXX: function(g) {
      var y;
      if (g.data[0] === 3) {
        for (y = 1; y < g.data.length; y++)
          if (g.data[y] === 0) {
            g.description = z0(g.data, 1, y), g.url = z0(g.data, y + 1, g.data.length);
            break;
          }
      }
    },
    PRIV: function(g) {
      var y;
      for (y = 0; y < g.data.length; y++)
        if (g.data[y] === 0) {
          g.owner = IT(g.data, 0, y);
          break;
        }
      g.privateData = g.data.subarray(y + 1), g.data = g.privateData;
    }
  }, W0;
  W0 = function(g) {
    var y = {
      descriptor: g && g.descriptor
    }, v = 0, E = [], C = 0, A;
    if (W0.prototype.init.call(this), this.dispatchType = o0.METADATA_STREAM_TYPE.toString(16), y.descriptor)
      for (A = 0; A < y.descriptor.length; A++)
        this.dispatchType += ("00" + y.descriptor[A].toString(16)).slice(-2);
    this.push = function(P) {
      var j, V, q, _e, ka, _c;
      if (P.type === "timed-metadata") {
        if (P.dataAlignmentIndicator && (C = 0, E.length = 0), E.length === 0 && (P.data.length < 10 || P.data[0] !== "I".charCodeAt(0) || P.data[1] !== "D".charCodeAt(0) || P.data[2] !== "3".charCodeAt(0))) {
          this.trigger("log", {
            level: "warn",
            message: "Skipping unrecognized metadata packet"
          });
          return;
        }
        if (E.push(P), C += P.data.byteLength, E.length === 1 && (v = K0(P.data.subarray(6, 10)), v += 10), !(C < v)) {
          for (j = {
            data: new Uint8Array(v),
            frames: [],
            pts: E[0].pts,
            dts: E[0].dts
          }, ka = 0; ka < v; )
            j.data.set(E[0].data.subarray(0, v - ka), ka), ka += E[0].data.byteLength, C -= E[0].data.byteLength, E.shift();
          V = 10, j.data[5] & 64 && (V += 4, V += K0(j.data.subarray(10, 14)), v -= K0(j.data.subarray(16, 20)));
          do {
            if (q = K0(j.data.subarray(V + 4, V + 8)), q < 1) {
              this.trigger("log", {
                level: "warn",
                message: "Malformed ID3 frame encountered. Skipping metadata parsing."
              });
              return;
            }
            if (_c = String.fromCharCode(j.data[V], j.data[V + 1], j.data[V + 2], j.data[V + 3]), _e = {
              id: _c,
              data: j.data.subarray(V + 10, V + q + 10)
            }, _e.key = _e.id, k_[_e.id] && (k_[_e.id](_e), _e.owner === "com.apple.streaming.transportStreamTimestamp")) {
              var _l = _e.data, _u = (_l[3] & 1) << 30 | _l[4] << 22 | _l[5] << 14 | _l[6] << 6 | _l[7] >>> 2;
              _u *= 4, _u += _l[7] & 3, _e.timeStamp = _u, j.pts === void 0 && j.dts === void 0 && (j.pts = _e.timeStamp, j.dts = _e.timeStamp), this.trigger("timestamp", _e);
            }
            j.frames.push(_e), V += 10, V += q;
          } while (V < v);
          this.trigger("data", j);
        }
      }
    };
  }, W0.prototype = new e();
  var kT = W0, RT = O_.TimestampRolloverStream, X0, N0, Y0, O0 = 188, d_ = 71;
  X0 = function() {
    var g = new Uint8Array(O0), y = 0;
    X0.prototype.init.call(this), this.push = function(v) {
      var E = 0, C = O0, A;
      for (y ? (A = new Uint8Array(v.byteLength + y), A.set(g.subarray(0, y)), A.set(v, y), y = 0) : A = v; C < A.byteLength; ) {
        if (A[E] === d_ && A[C] === d_) {
          this.trigger("data", A.subarray(E, C)), E += O0, C += O0;
          continue;
        }
        E++, C++;
      }
      E < A.byteLength && (g.set(A.subarray(E), 0), y = A.byteLength - E);
    }, this.flush = function() {
      y === O0 && g[0] === d_ && (this.trigger("data", g), y = 0), this.trigger("done");
    }, this.endTimeline = function() {
      this.flush(), this.trigger("endedtimeline");
    }, this.reset = function() {
      y = 0, this.trigger("reset");
    };
  }, X0.prototype = new e(), N0 = function() {
    var g, y, v, E;
    N0.prototype.init.call(this), E = this, this.packetsWaitingForPmt = [], this.programMapTable = void 0, g = function(A, P) {
      var j = 0;
      P.payloadUnitStartIndicator && (j += A[j] + 1), P.type === "pat" ? y(A.subarray(j), P) : v(A.subarray(j), P);
    }, y = function(A, P) {
      P.section_number = A[7], P.last_section_number = A[8], E.pmtPid = (A[10] & 31) << 8 | A[11], P.pmtPid = E.pmtPid;
    }, v = function(A, P) {
      var j, V, q, _e;
      if (!!(A[5] & 1)) {
        for (E.programMapTable = {
          video: null,
          audio: null,
          "timed-metadata": {}
        }, j = (A[1] & 15) << 8 | A[2], V = 3 + j - 4, q = (A[10] & 15) << 8 | A[11], _e = 12 + q; _e < V; ) {
          var ka = A[_e], _c = (A[_e + 1] & 31) << 8 | A[_e + 2];
          ka === o0.H264_STREAM_TYPE && E.programMapTable.video === null ? E.programMapTable.video = _c : ka === o0.ADTS_STREAM_TYPE && E.programMapTable.audio === null ? E.programMapTable.audio = _c : ka === o0.METADATA_STREAM_TYPE && (E.programMapTable["timed-metadata"][_c] = ka), _e += ((A[_e + 3] & 15) << 8 | A[_e + 4]) + 5;
        }
        P.programMapTable = E.programMapTable;
      }
    }, this.push = function(C) {
      var A = {}, P = 4;
      if (A.payloadUnitStartIndicator = !!(C[1] & 64), A.pid = C[1] & 31, A.pid <<= 8, A.pid |= C[2], (C[3] & 48) >>> 4 > 1 && (P += C[P] + 1), A.pid === 0)
        A.type = "pat", g(C.subarray(P), A), this.trigger("data", A);
      else if (A.pid === this.pmtPid)
        for (A.type = "pmt", g(C.subarray(P), A), this.trigger("data", A); this.packetsWaitingForPmt.length; )
          this.processPes_.apply(this, this.packetsWaitingForPmt.shift());
      else
        this.programMapTable === void 0 ? this.packetsWaitingForPmt.push([C, P, A]) : this.processPes_(C, P, A);
    }, this.processPes_ = function(C, A, P) {
      P.pid === this.programMapTable.video ? P.streamType = o0.H264_STREAM_TYPE : P.pid === this.programMapTable.audio ? P.streamType = o0.ADTS_STREAM_TYPE : P.streamType = this.programMapTable["timed-metadata"][P.pid], P.type = "pes", P.data = C.subarray(A), this.trigger("data", P);
    };
  }, N0.prototype = new e(), N0.STREAM_TYPES = {
    h264: 27,
    adts: 15
  }, Y0 = function() {
    var g = this, y = !1, v = {
      data: [],
      size: 0
    }, E = {
      data: [],
      size: 0
    }, C = {
      data: [],
      size: 0
    }, A, P = function(q, _e) {
      var ka, _c = q[0] << 16 | q[1] << 8 | q[2];
      _e.data = new Uint8Array(), _c === 1 && (_e.packetLength = 6 + (q[4] << 8 | q[5]), _e.dataAlignmentIndicator = (q[6] & 4) !== 0, ka = q[7], ka & 192 && (_e.pts = (q[9] & 14) << 27 | (q[10] & 255) << 20 | (q[11] & 254) << 12 | (q[12] & 255) << 5 | (q[13] & 254) >>> 3, _e.pts *= 4, _e.pts += (q[13] & 6) >>> 1, _e.dts = _e.pts, ka & 64 && (_e.dts = (q[14] & 14) << 27 | (q[15] & 255) << 20 | (q[16] & 254) << 12 | (q[17] & 255) << 5 | (q[18] & 254) >>> 3, _e.dts *= 4, _e.dts += (q[18] & 6) >>> 1)), _e.data = q.subarray(9 + q[8]));
    }, j = function(q, _e, ka) {
      var _c = new Uint8Array(q.size), _l = {
        type: _e
      }, _u = 0, _h = 0, s0 = !1, c0;
      if (!(!q.data.length || q.size < 9)) {
        for (_l.trackId = q.data[0].pid, _u = 0; _u < q.data.length; _u++)
          c0 = q.data[_u], _c.set(c0.data, _h), _h += c0.data.byteLength;
        P(_c, _l), s0 = _e === "video" || _l.packetLength <= q.size, (ka || s0) && (q.size = 0, q.data.length = 0), s0 && g.trigger("data", _l);
      }
    };
    Y0.prototype.init.call(this), this.push = function(V) {
      ({
        pat: function() {
        },
        pes: function() {
          var _e, ka;
          switch (V.streamType) {
            case o0.H264_STREAM_TYPE:
              _e = v, ka = "video";
              break;
            case o0.ADTS_STREAM_TYPE:
              _e = E, ka = "audio";
              break;
            case o0.METADATA_STREAM_TYPE:
              _e = C, ka = "timed-metadata";
              break;
            default:
              return;
          }
          V.payloadUnitStartIndicator && j(_e, ka, !0), _e.data.push(V), _e.size += V.data.byteLength;
        },
        pmt: function() {
          var _e = {
            type: "metadata",
            tracks: []
          };
          A = V.programMapTable, A.video !== null && _e.tracks.push({
            timelineStartInfo: {
              baseMediaDecodeTime: 0
            },
            id: +A.video,
            codec: "avc",
            type: "video"
          }), A.audio !== null && _e.tracks.push({
            timelineStartInfo: {
              baseMediaDecodeTime: 0
            },
            id: +A.audio,
            codec: "adts",
            type: "audio"
          }), y = !0, g.trigger("data", _e);
        }
      })[V.type]();
    }, this.reset = function() {
      v.size = 0, v.data.length = 0, E.size = 0, E.data.length = 0, this.trigger("reset");
    }, this.flushStreams_ = function() {
      j(v, "video"), j(E, "audio"), j(C, "timed-metadata");
    }, this.flush = function() {
      if (!y && A) {
        var V = {
          type: "metadata",
          tracks: []
        };
        A.video !== null && V.tracks.push({
          timelineStartInfo: {
            baseMediaDecodeTime: 0
          },
          id: +A.video,
          codec: "avc",
          type: "video"
        }), A.audio !== null && V.tracks.push({
          timelineStartInfo: {
            baseMediaDecodeTime: 0
          },
          id: +A.audio,
          codec: "adts",
          type: "audio"
        }), g.trigger("data", V);
      }
      y = !1, this.flushStreams_(), this.trigger("done");
    };
  }, Y0.prototype = new e();
  var R_ = {
    PAT_PID: 0,
    MP2T_PACKET_LENGTH: O0,
    TransportPacketStream: X0,
    TransportParseStream: N0,
    ElementaryStream: Y0,
    TimestampRolloverStream: RT,
    CaptionStream: $0.CaptionStream,
    Cea608Stream: $0.Cea608Stream,
    Cea708Stream: $0.Cea708Stream,
    MetadataStream: kT
  };
  for (var h_ in o0)
    o0.hasOwnProperty(h_) && (R_[h_] = o0[h_]);
  var m0 = R_, PT = _m.ONE_SECOND_IN_TS, Q0, P_ = [96e3, 88200, 64e3, 48e3, 44100, 32e3, 24e3, 22050, 16e3, 12e3, 11025, 8e3, 7350];
  Q0 = function(g) {
    var y, v = 0;
    Q0.prototype.init.call(this), this.skipWarn_ = function(E, C) {
      this.trigger("log", {
        level: "warn",
        message: "adts skiping bytes " + E + " to " + C + " in frame " + v + " outside syncword"
      });
    }, this.push = function(E) {
      var C = 0, A, P, j, V, q;
      if (g || (v = 0), E.type === "audio") {
        y && y.length ? (j = y, y = new Uint8Array(j.byteLength + E.data.byteLength), y.set(j), y.set(E.data, j.byteLength)) : y = E.data;
        for (var _e; C + 7 < y.length; ) {
          if (y[C] !== 255 || (y[C + 1] & 246) !== 240) {
            typeof _e != "number" && (_e = C), C++;
            continue;
          }
          if (typeof _e == "number" && (this.skipWarn_(_e, C), _e = null), P = (~y[C + 1] & 1) * 2, A = (y[C + 3] & 3) << 11 | y[C + 4] << 3 | (y[C + 5] & 224) >> 5, V = ((y[C + 6] & 3) + 1) * 1024, q = V * PT / P_[(y[C + 2] & 60) >>> 2], y.byteLength - C < A)
            break;
          this.trigger("data", {
            pts: E.pts + v * q,
            dts: E.dts + v * q,
            sampleCount: V,
            audioobjecttype: (y[C + 2] >>> 6 & 3) + 1,
            channelcount: (y[C + 2] & 1) << 2 | (y[C + 3] & 192) >>> 6,
            samplerate: P_[(y[C + 2] & 60) >>> 2],
            samplingfrequencyindex: (y[C + 2] & 60) >>> 2,
            samplesize: 16,
            data: y.subarray(C + 7 + P, C + A)
          }), v++, C += A;
        }
        typeof _e == "number" && (this.skipWarn_(_e, C), _e = null), y = y.subarray(C);
      }
    }, this.flush = function() {
      v = 0, this.trigger("done");
    }, this.reset = function() {
      y = void 0, this.trigger("reset");
    }, this.endTimeline = function() {
      y = void 0, this.trigger("endedtimeline");
    };
  }, Q0.prototype = new e();
  var N_ = Q0, L_;
  L_ = function(g) {
    var y = g.byteLength, v = 0, E = 0;
    this.length = function() {
      return 8 * y;
    }, this.bitsAvailable = function() {
      return 8 * y + E;
    }, this.loadWord = function() {
      var C = g.byteLength - y, A = new Uint8Array(4), P = Math.min(4, y);
      if (P === 0)
        throw new Error("no bytes available");
      A.set(g.subarray(C, C + P)), v = new DataView(A.buffer).getUint32(0), E = P * 8, y -= P;
    }, this.skipBits = function(C) {
      var A;
      E > C ? (v <<= C, E -= C) : (C -= E, A = Math.floor(C / 8), C -= A * 8, y -= A, this.loadWord(), v <<= C, E -= C);
    }, this.readBits = function(C) {
      var A = Math.min(E, C), P = v >>> 32 - A;
      return E -= A, E > 0 ? v <<= A : y > 0 && this.loadWord(), A = C - A, A > 0 ? P << A | this.readBits(A) : P;
    }, this.skipLeadingZeros = function() {
      var C;
      for (C = 0; C < E; ++C)
        if ((v & 2147483648 >>> C) !== 0)
          return v <<= C, E -= C, C;
      return this.loadWord(), C + this.skipLeadingZeros();
    }, this.skipUnsignedExpGolomb = function() {
      this.skipBits(1 + this.skipLeadingZeros());
    }, this.skipExpGolomb = function() {
      this.skipBits(1 + this.skipLeadingZeros());
    }, this.readUnsignedExpGolomb = function() {
      var C = this.skipLeadingZeros();
      return this.readBits(C + 1) - 1;
    }, this.readExpGolomb = function() {
      var C = this.readUnsignedExpGolomb();
      return 1 & C ? 1 + C >>> 1 : -1 * (C >>> 1);
    }, this.readBoolean = function() {
      return this.readBits(1) === 1;
    }, this.readUnsignedByte = function() {
      return this.readBits(8);
    }, this.loadWord();
  };
  var NT = L_, J0, L0, D_;
  L0 = function() {
    var g = 0, y, v;
    L0.prototype.init.call(this), this.push = function(E) {
      var C;
      v ? (C = new Uint8Array(v.byteLength + E.data.byteLength), C.set(v), C.set(E.data, v.byteLength), v = C) : v = E.data;
      for (var A = v.byteLength; g < A - 3; g++)
        if (v[g + 2] === 1) {
          y = g + 5;
          break;
        }
      for (; y < A; )
        switch (v[y]) {
          case 0:
            if (v[y - 1] !== 0) {
              y += 2;
              break;
            } else if (v[y - 2] !== 0) {
              y++;
              break;
            }
            g + 3 !== y - 2 && this.trigger("data", v.subarray(g + 3, y - 2));
            do
              y++;
            while (v[y] !== 1 && y < A);
            g = y - 2, y += 3;
            break;
          case 1:
            if (v[y - 1] !== 0 || v[y - 2] !== 0) {
              y += 3;
              break;
            }
            this.trigger("data", v.subarray(g + 3, y - 2)), g = y - 2, y += 3;
            break;
          default:
            y += 3;
            break;
        }
      v = v.subarray(g), y -= g, g = 0;
    }, this.reset = function() {
      v = null, g = 0, this.trigger("reset");
    }, this.flush = function() {
      v && v.byteLength > 3 && this.trigger("data", v.subarray(g + 3)), v = null, g = 0, this.trigger("done");
    }, this.endTimeline = function() {
      this.flush(), this.trigger("endedtimeline");
    };
  }, L0.prototype = new e(), D_ = {
    100: !0,
    110: !0,
    122: !0,
    244: !0,
    44: !0,
    83: !0,
    86: !0,
    118: !0,
    128: !0,
    138: !0,
    139: !0,
    134: !0
  }, J0 = function() {
    var g = new L0(), y, v, E, C, A, P, j;
    J0.prototype.init.call(this), y = this, this.push = function(V) {
      V.type === "video" && (v = V.trackId, E = V.pts, C = V.dts, g.push(V));
    }, g.on("data", function(V) {
      var q = {
        trackId: v,
        pts: E,
        dts: C,
        data: V,
        nalUnitTypeCode: V[0] & 31
      };
      switch (q.nalUnitTypeCode) {
        case 5:
          q.nalUnitType = "slice_layer_without_partitioning_rbsp_idr";
          break;
        case 6:
          q.nalUnitType = "sei_rbsp", q.escapedRBSP = A(V.subarray(1));
          break;
        case 7:
          q.nalUnitType = "seq_parameter_set_rbsp", q.escapedRBSP = A(V.subarray(1)), q.config = P(q.escapedRBSP);
          break;
        case 8:
          q.nalUnitType = "pic_parameter_set_rbsp";
          break;
        case 9:
          q.nalUnitType = "access_unit_delimiter_rbsp";
          break;
      }
      y.trigger("data", q);
    }), g.on("done", function() {
      y.trigger("done");
    }), g.on("partialdone", function() {
      y.trigger("partialdone");
    }), g.on("reset", function() {
      y.trigger("reset");
    }), g.on("endedtimeline", function() {
      y.trigger("endedtimeline");
    }), this.flush = function() {
      g.flush();
    }, this.partialFlush = function() {
      g.partialFlush();
    }, this.reset = function() {
      g.reset();
    }, this.endTimeline = function() {
      g.endTimeline();
    }, j = function(q, _e) {
      var ka = 8, _c = 8, _l, _u;
      for (_l = 0; _l < q; _l++)
        _c !== 0 && (_u = _e.readExpGolomb(), _c = (ka + _u + 256) % 256), ka = _c === 0 ? ka : _c;
    }, A = function(q) {
      for (var _e = q.byteLength, ka = [], _c = 1, _l, _u; _c < _e - 2; )
        q[_c] === 0 && q[_c + 1] === 0 && q[_c + 2] === 3 ? (ka.push(_c + 2), _c += 2) : _c++;
      if (ka.length === 0)
        return q;
      _l = _e - ka.length, _u = new Uint8Array(_l);
      var _h = 0;
      for (_c = 0; _c < _l; _h++, _c++)
        _h === ka[0] && (_h++, ka.shift()), _u[_c] = q[_h];
      return _u;
    }, P = function(q) {
      var _e = 0, ka = 0, _c = 0, _l = 0, _u, _h, s0, c0, S0, __, hb, _b, zb, b_, eT, a0 = [1, 1], tT, w0;
      if (_u = new NT(q), _h = _u.readUnsignedByte(), c0 = _u.readUnsignedByte(), s0 = _u.readUnsignedByte(), _u.skipUnsignedExpGolomb(), D_[_h] && (S0 = _u.readUnsignedExpGolomb(), S0 === 3 && _u.skipBits(1), _u.skipUnsignedExpGolomb(), _u.skipUnsignedExpGolomb(), _u.skipBits(1), _u.readBoolean()))
        for (eT = S0 !== 3 ? 8 : 12, w0 = 0; w0 < eT; w0++)
          _u.readBoolean() && (w0 < 6 ? j(16, _u) : j(64, _u));
      if (_u.skipUnsignedExpGolomb(), __ = _u.readUnsignedExpGolomb(), __ === 0)
        _u.readUnsignedExpGolomb();
      else if (__ === 1)
        for (_u.skipBits(1), _u.skipExpGolomb(), _u.skipExpGolomb(), hb = _u.readUnsignedExpGolomb(), w0 = 0; w0 < hb; w0++)
          _u.skipExpGolomb();
      if (_u.skipUnsignedExpGolomb(), _u.skipBits(1), _b = _u.readUnsignedExpGolomb(), zb = _u.readUnsignedExpGolomb(), b_ = _u.readBits(1), b_ === 0 && _u.skipBits(1), _u.skipBits(1), _u.readBoolean() && (_e = _u.readUnsignedExpGolomb(), ka = _u.readUnsignedExpGolomb(), _c = _u.readUnsignedExpGolomb(), _l = _u.readUnsignedExpGolomb()), _u.readBoolean() && _u.readBoolean()) {
        switch (tT = _u.readUnsignedByte(), tT) {
          case 1:
            a0 = [1, 1];
            break;
          case 2:
            a0 = [12, 11];
            break;
          case 3:
            a0 = [10, 11];
            break;
          case 4:
            a0 = [16, 11];
            break;
          case 5:
            a0 = [40, 33];
            break;
          case 6:
            a0 = [24, 11];
            break;
          case 7:
            a0 = [20, 11];
            break;
          case 8:
            a0 = [32, 11];
            break;
          case 9:
            a0 = [80, 33];
            break;
          case 10:
            a0 = [18, 11];
            break;
          case 11:
            a0 = [15, 11];
            break;
          case 12:
            a0 = [64, 33];
            break;
          case 13:
            a0 = [160, 99];
            break;
          case 14:
            a0 = [4, 3];
            break;
          case 15:
            a0 = [3, 2];
            break;
          case 16:
            a0 = [2, 1];
            break;
          case 255: {
            a0 = [_u.readUnsignedByte() << 8 | _u.readUnsignedByte(), _u.readUnsignedByte() << 8 | _u.readUnsignedByte()];
            break;
          }
        }
        a0 && a0[0] / a0[1];
      }
      return {
        profileIdc: _h,
        levelIdc: s0,
        profileCompatibility: c0,
        width: (_b + 1) * 16 - _e * 2 - ka * 2,
        height: (2 - b_) * (zb + 1) * 16 - _c * 2 - _l * 2,
        sarRatio: a0
      };
    };
  }, J0.prototype = new e();
  var LT = {
    H264Stream: J0,
    NalByteStream: L0
  }, DT = [96e3, 88200, 64e3, 48e3, 44100, 32e3, 24e3, 22050, 16e3, 12e3, 11025, 8e3, 7350], M_ = function(g, y) {
    var v = g[y + 6] << 21 | g[y + 7] << 14 | g[y + 8] << 7 | g[y + 9], E = g[y + 5], C = (E & 16) >> 4;
    return v = v >= 0 ? v : 0, C ? v + 20 : v + 10;
  }, MT = function I(g, y) {
    return g.length - y < 10 || g[y] !== "I".charCodeAt(0) || g[y + 1] !== "D".charCodeAt(0) || g[y + 2] !== "3".charCodeAt(0) ? y : (y += M_(g, y), I(g, y));
  }, UT = function(g) {
    var y = MT(g, 0);
    return g.length >= y + 2 && (g[y] & 255) === 255 && (g[y + 1] & 240) === 240 && (g[y + 1] & 22) === 16;
  }, U_ = function(g) {
    return g[0] << 21 | g[1] << 14 | g[2] << 7 | g[3];
  }, FT = function(g, y, v) {
    var E, C = "";
    for (E = y; E < v; E++)
      C += "%" + ("00" + g[E].toString(16)).slice(-2);
    return C;
  }, jT = function(g, y, v) {
    return unescape(FT(g, y, v));
  }, BT = function(g, y) {
    var v = (g[y + 5] & 224) >> 5, E = g[y + 4] << 3, C = g[y + 3] & 3 << 11;
    return C | E | v;
  }, qT = function(g, y) {
    return g[y] === "I".charCodeAt(0) && g[y + 1] === "D".charCodeAt(0) && g[y + 2] === "3".charCodeAt(0) ? "timed-metadata" : g[y] & !0 && (g[y + 1] & 240) === 240 ? "audio" : null;
  }, GT = function(g) {
    for (var y = 0; y + 5 < g.length; ) {
      if (g[y] !== 255 || (g[y + 1] & 246) !== 240) {
        y++;
        continue;
      }
      return DT[(g[y + 2] & 60) >>> 2];
    }
    return null;
  }, HT = function(g) {
    var y, v, E, C;
    y = 10, g[5] & 64 && (y += 4, y += U_(g.subarray(10, 14)));
    do {
      if (v = U_(g.subarray(y + 4, y + 8)), v < 1)
        return null;
      if (C = String.fromCharCode(g[y], g[y + 1], g[y + 2], g[y + 3]), C === "PRIV") {
        E = g.subarray(y + 10, y + v + 10);
        for (var A = 0; A < E.byteLength; A++)
          if (E[A] === 0) {
            var P = jT(E, 0, A);
            if (P === "com.apple.streaming.transportStreamTimestamp") {
              var j = E.subarray(A + 1), V = (j[3] & 1) << 30 | j[4] << 22 | j[5] << 14 | j[6] << 6 | j[7] >>> 2;
              return V *= 4, V += j[7] & 3, V;
            }
            break;
          }
      }
      y += 10, y += v;
    } while (y < g.byteLength);
    return null;
  }, Z0 = {
    isLikelyAacData: UT,
    parseId3TagSize: M_,
    parseAdtsSize: BT,
    parseType: qT,
    parseSampleRate: GT,
    parseAacTimestamp: HT
  }, _y;
  _y = function() {
    var g = new Uint8Array(), y = 0;
    _y.prototype.init.call(this), this.setTimestamp = function(v) {
      y = v;
    }, this.push = function(v) {
      var E = 0, C = 0, A, P, j, V;
      for (g.length ? (V = g.length, g = new Uint8Array(v.byteLength + V), g.set(g.subarray(0, V)), g.set(v, V)) : g = v; g.length - C >= 3; ) {
        if (g[C] === "I".charCodeAt(0) && g[C + 1] === "D".charCodeAt(0) && g[C + 2] === "3".charCodeAt(0)) {
          if (g.length - C < 10 || (E = Z0.parseId3TagSize(g, C), C + E > g.length))
            break;
          P = {
            type: "timed-metadata",
            data: g.subarray(C, C + E)
          }, this.trigger("data", P), C += E;
          continue;
        } else if ((g[C] & 255) === 255 && (g[C + 1] & 240) === 240) {
          if (g.length - C < 7 || (E = Z0.parseAdtsSize(g, C), C + E > g.length))
            break;
          j = {
            type: "audio",
            data: g.subarray(C, C + E),
            pts: y,
            dts: y
          }, this.trigger("data", j), C += E;
          continue;
        }
        C++;
      }
      A = g.length - C, A > 0 ? g = g.subarray(C) : g = new Uint8Array();
    }, this.reset = function() {
      g = new Uint8Array(), this.trigger("reset");
    }, this.endTimeline = function() {
      g = new Uint8Array(), this.trigger("endedtimeline");
    };
  }, _y.prototype = new e();
  var VT = _y, $T = ["audioobjecttype", "channelcount", "samplerate", "samplingfrequencyindex", "samplesize"], p_ = $T, zT = ["width", "height", "profileIdc", "levelIdc", "profileCompatibility", "sarRatio"], g_ = zT, KT = LT.H264Stream, WT = Z0.isLikelyAacData, XT = _m.ONE_SECOND_IN_TS, D0, I0, e_, b0, YT = function(g, y) {
    y.stream = g, this.trigger("log", y);
  }, F_ = function(g, y) {
    for (var v = Object.keys(y), E = 0; E < v.length; E++) {
      var C = v[E];
      C === "headOfPipeline" || !y[C].on || y[C].on("log", YT.bind(g, C));
    }
  }, j_ = function(g, y) {
    var v;
    if (g.length !== y.length)
      return !1;
    for (v = 0; v < g.length; v++)
      if (g[v] !== y[v])
        return !1;
    return !0;
  }, m_ = function(g, y, v, E, C, A) {
    var P = v - y, j = E - y, V = C - v;
    return {
      start: {
        dts: g,
        pts: g + P
      },
      end: {
        dts: g + j,
        pts: g + V
      },
      prependedContentDuration: A,
      baseMediaDecodeTime: g
    };
  };
  I0 = function(g, y) {
    var v = [], E, C = 0, A = 0, P = 1 / 0;
    y = y || {}, E = y.firstSequenceNumber || 0, I0.prototype.init.call(this), this.push = function(j) {
      d0.collectDtsInfo(g, j), g && p_.forEach(function(V) {
        g[V] = j[V];
      }), v.push(j);
    }, this.setEarliestDts = function(j) {
      C = j;
    }, this.setVideoBaseMediaDecodeTime = function(j) {
      P = j;
    }, this.setAudioAppendStart = function(j) {
      A = j;
    }, this.flush = function() {
      var j, V, q, _e, ka, _c, _l;
      if (v.length === 0) {
        this.trigger("done", "AudioSegmentStream");
        return;
      }
      j = B0.trimAdtsFramesByEarliestDts(v, g, C), g.baseMediaDecodeTime = d0.calculateTrackBaseMediaDecodeTime(g, y.keepOriginalTimestamps), _l = B0.prefixWithSilence(g, j, A, P), g.samples = B0.generateSampleTable(j), q = h0.mdat(B0.concatenateFrameData(j)), v = [], V = h0.moof(E, [g]), _e = new Uint8Array(V.byteLength + q.byteLength), E++, _e.set(V), _e.set(q, V.byteLength), d0.clearDtsInfo(g), ka = Math.ceil(XT * 1024 / g.samplerate), j.length && (_c = j.length * ka, this.trigger("segmentTimingInfo", m_(
        _m.audioTsToVideoTs(g.baseMediaDecodeTime, g.samplerate),
        j[0].dts,
        j[0].pts,
        j[0].dts + _c,
        j[0].pts + _c,
        _l || 0
      )), this.trigger("timingInfo", {
        start: j[0].pts,
        end: j[0].pts + _c
      })), this.trigger("data", {
        track: g,
        boxes: _e
      }), this.trigger("done", "AudioSegmentStream");
    }, this.reset = function() {
      d0.clearDtsInfo(g), v = [], this.trigger("reset");
    };
  }, I0.prototype = new e(), D0 = function(g, y) {
    var v, E = [], C = [], A, P;
    y = y || {}, v = y.firstSequenceNumber || 0, D0.prototype.init.call(this), delete g.minPTS, this.gopCache_ = [], this.push = function(j) {
      d0.collectDtsInfo(g, j), j.nalUnitType === "seq_parameter_set_rbsp" && !A && (A = j.config, g.sps = [j.data], g_.forEach(function(V) {
        g[V] = A[V];
      }, this)), j.nalUnitType === "pic_parameter_set_rbsp" && !P && (P = j.data, g.pps = [j.data]), E.push(j);
    }, this.flush = function() {
      for (var j, V, q, _e, ka, _c, _l = 0, _u, _h; E.length && E[0].nalUnitType !== "access_unit_delimiter_rbsp"; )
        E.shift();
      if (E.length === 0) {
        this.resetStream_(), this.trigger("done", "VideoSegmentStream");
        return;
      }
      if (j = R0.groupNalsIntoFrames(E), q = R0.groupFramesIntoGops(j), q[0][0].keyFrame || (V = this.getGopForFusion_(E[0], g), V ? (_l = V.duration, q.unshift(V), q.byteLength += V.byteLength, q.nalCount += V.nalCount, q.pts = V.pts, q.dts = V.dts, q.duration += V.duration) : q = R0.extendFirstKeyFrame(q)), C.length) {
        var s0;
        if (y.alignGopsAtEnd ? s0 = this.alignGopsAtEnd_(q) : s0 = this.alignGopsAtStart_(q), !s0) {
          this.gopCache_.unshift({
            gop: q.pop(),
            pps: g.pps,
            sps: g.sps
          }), this.gopCache_.length = Math.min(6, this.gopCache_.length), E = [], this.resetStream_(), this.trigger("done", "VideoSegmentStream");
          return;
        }
        d0.clearDtsInfo(g), q = s0;
      }
      d0.collectDtsInfo(g, q), g.samples = R0.generateSampleTable(q), ka = h0.mdat(R0.concatenateNalData(q)), g.baseMediaDecodeTime = d0.calculateTrackBaseMediaDecodeTime(g, y.keepOriginalTimestamps), this.trigger("processedGopsInfo", q.map(function(c0) {
        return {
          pts: c0.pts,
          dts: c0.dts,
          byteLength: c0.byteLength
        };
      })), _u = q[0], _h = q[q.length - 1], this.trigger("segmentTimingInfo", m_(g.baseMediaDecodeTime, _u.dts, _u.pts, _h.dts + _h.duration, _h.pts + _h.duration, _l)), this.trigger("timingInfo", {
        start: q[0].pts,
        end: q[q.length - 1].pts + q[q.length - 1].duration
      }), this.gopCache_.unshift({
        gop: q.pop(),
        pps: g.pps,
        sps: g.sps
      }), this.gopCache_.length = Math.min(6, this.gopCache_.length), E = [], this.trigger("baseMediaDecodeTime", g.baseMediaDecodeTime), this.trigger("timelineStartInfo", g.timelineStartInfo), _e = h0.moof(v, [g]), _c = new Uint8Array(_e.byteLength + ka.byteLength), v++, _c.set(_e), _c.set(ka, _e.byteLength), this.trigger("data", {
        track: g,
        boxes: _c
      }), this.resetStream_(), this.trigger("done", "VideoSegmentStream");
    }, this.reset = function() {
      this.resetStream_(), E = [], this.gopCache_.length = 0, C.length = 0, this.trigger("reset");
    }, this.resetStream_ = function() {
      d0.clearDtsInfo(g), A = void 0, P = void 0;
    }, this.getGopForFusion_ = function(j) {
      var V = 45e3, q = 1e4, _e = 1 / 0, ka, _c, _l, _u, _h;
      for (_h = 0; _h < this.gopCache_.length; _h++)
        _u = this.gopCache_[_h], _l = _u.gop, !(!(g.pps && j_(g.pps[0], _u.pps[0])) || !(g.sps && j_(g.sps[0], _u.sps[0]))) && (_l.dts < g.timelineStartInfo.dts || (ka = j.dts - _l.dts - _l.duration, ka >= -q && ka <= V && (!_c || _e > ka) && (_c = _u, _e = ka)));
      return _c ? _c.gop : null;
    }, this.alignGopsAtStart_ = function(j) {
      var V, q, _e, ka, _c, _l, _u, _h;
      for (_c = j.byteLength, _l = j.nalCount, _u = j.duration, V = q = 0; V < C.length && q < j.length && (_e = C[V], ka = j[q], _e.pts !== ka.pts); ) {
        if (ka.pts > _e.pts) {
          V++;
          continue;
        }
        q++, _c -= ka.byteLength, _l -= ka.nalCount, _u -= ka.duration;
      }
      return q === 0 ? j : q === j.length ? null : (_h = j.slice(q), _h.byteLength = _c, _h.duration = _u, _h.nalCount = _l, _h.pts = _h[0].pts, _h.dts = _h[0].dts, _h);
    }, this.alignGopsAtEnd_ = function(j) {
      var V, q, _e, ka, _c, _l;
      for (V = C.length - 1, q = j.length - 1, _c = null, _l = !1; V >= 0 && q >= 0; ) {
        if (_e = C[V], ka = j[q], _e.pts === ka.pts) {
          _l = !0;
          break;
        }
        if (_e.pts > ka.pts) {
          V--;
          continue;
        }
        V === C.length - 1 && (_c = q), q--;
      }
      if (!_l && _c === null)
        return null;
      var _u;
      if (_l ? _u = q : _u = _c, _u === 0)
        return j;
      var _h = j.slice(_u), s0 = _h.reduce(function(c0, S0) {
        return c0.byteLength += S0.byteLength, c0.duration += S0.duration, c0.nalCount += S0.nalCount, c0;
      }, {
        byteLength: 0,
        duration: 0,
        nalCount: 0
      });
      return _h.byteLength = s0.byteLength, _h.duration = s0.duration, _h.nalCount = s0.nalCount, _h.pts = _h[0].pts, _h.dts = _h[0].dts, _h;
    }, this.alignGopsWith = function(j) {
      C = j;
    };
  }, D0.prototype = new e(), b0 = function(g, y) {
    this.numberOfTracks = 0, this.metadataStream = y, g = g || {}, typeof g.remux < "u" ? this.remuxTracks = !!g.remux : this.remuxTracks = !0, typeof g.keepOriginalTimestamps == "boolean" ? this.keepOriginalTimestamps = g.keepOriginalTimestamps : this.keepOriginalTimestamps = !1, this.pendingTracks = [], this.videoTrack = null, this.pendingBoxes = [], this.pendingCaptions = [], this.pendingMetadata = [], this.pendingBytes = 0, this.emittedTracks = 0, b0.prototype.init.call(this), this.push = function(v) {
      if (v.text)
        return this.pendingCaptions.push(v);
      if (v.frames)
        return this.pendingMetadata.push(v);
      this.pendingTracks.push(v.track), this.pendingBytes += v.boxes.byteLength, v.track.type === "video" && (this.videoTrack = v.track, this.pendingBoxes.push(v.boxes)), v.track.type === "audio" && (this.audioTrack = v.track, this.pendingBoxes.unshift(v.boxes));
    };
  }, b0.prototype = new e(), b0.prototype.flush = function(I) {
    var g = 0, y = {
      captions: [],
      captionStreams: {},
      metadata: [],
      info: {}
    }, v, E, C, A = 0, P;
    if (this.pendingTracks.length < this.numberOfTracks) {
      if (I !== "VideoSegmentStream" && I !== "AudioSegmentStream")
        return;
      if (this.remuxTracks)
        return;
      if (this.pendingTracks.length === 0) {
        this.emittedTracks++, this.emittedTracks >= this.numberOfTracks && (this.trigger("done"), this.emittedTracks = 0);
        return;
      }
    }
    if (this.videoTrack ? (A = this.videoTrack.timelineStartInfo.pts, g_.forEach(function(j) {
      y.info[j] = this.videoTrack[j];
    }, this)) : this.audioTrack && (A = this.audioTrack.timelineStartInfo.pts, p_.forEach(function(j) {
      y.info[j] = this.audioTrack[j];
    }, this)), this.videoTrack || this.audioTrack) {
      for (this.pendingTracks.length === 1 ? y.type = this.pendingTracks[0].type : y.type = "combined", this.emittedTracks += this.pendingTracks.length, C = h0.initSegment(this.pendingTracks), y.initSegment = new Uint8Array(C.byteLength), y.initSegment.set(C), y.data = new Uint8Array(this.pendingBytes), P = 0; P < this.pendingBoxes.length; P++)
        y.data.set(this.pendingBoxes[P], g), g += this.pendingBoxes[P].byteLength;
      for (P = 0; P < this.pendingCaptions.length; P++)
        v = this.pendingCaptions[P], v.startTime = _m.metadataTsToSeconds(v.startPts, A, this.keepOriginalTimestamps), v.endTime = _m.metadataTsToSeconds(v.endPts, A, this.keepOriginalTimestamps), y.captionStreams[v.stream] = !0, y.captions.push(v);
      for (P = 0; P < this.pendingMetadata.length; P++)
        E = this.pendingMetadata[P], E.cueTime = _m.metadataTsToSeconds(E.pts, A, this.keepOriginalTimestamps), y.metadata.push(E);
      for (y.metadata.dispatchType = this.metadataStream.dispatchType, this.pendingTracks.length = 0, this.videoTrack = null, this.pendingBoxes.length = 0, this.pendingCaptions.length = 0, this.pendingBytes = 0, this.pendingMetadata.length = 0, this.trigger("data", y), P = 0; P < y.captions.length; P++)
        v = y.captions[P], this.trigger("caption", v);
      for (P = 0; P < y.metadata.length; P++)
        E = y.metadata[P], this.trigger("id3Frame", E);
    }
    this.emittedTracks >= this.numberOfTracks && (this.trigger("done"), this.emittedTracks = 0);
  }, b0.prototype.setRemux = function(I) {
    this.remuxTracks = I;
  }, e_ = function(g) {
    var y = this, v = !0, E, C;
    e_.prototype.init.call(this), g = g || {}, this.baseMediaDecodeTime = g.baseMediaDecodeTime || 0, this.transmuxPipeline_ = {}, this.setupAacPipeline = function() {
      var A = {};
      this.transmuxPipeline_ = A, A.type = "aac", A.metadataStream = new m0.MetadataStream(), A.aacStream = new VT(), A.audioTimestampRolloverStream = new m0.TimestampRolloverStream("audio"), A.timedMetadataTimestampRolloverStream = new m0.TimestampRolloverStream("timed-metadata"), A.adtsStream = new N_(), A.coalesceStream = new b0(g, A.metadataStream), A.headOfPipeline = A.aacStream, A.aacStream.pipe(A.audioTimestampRolloverStream).pipe(A.adtsStream), A.aacStream.pipe(A.timedMetadataTimestampRolloverStream).pipe(A.metadataStream).pipe(A.coalesceStream), A.metadataStream.on("timestamp", function(P) {
        A.aacStream.setTimestamp(P.timeStamp);
      }), A.aacStream.on("data", function(P) {
        P.type !== "timed-metadata" && P.type !== "audio" || A.audioSegmentStream || (C = C || {
          timelineStartInfo: {
            baseMediaDecodeTime: y.baseMediaDecodeTime
          },
          codec: "adts",
          type: "audio"
        }, A.coalesceStream.numberOfTracks++, A.audioSegmentStream = new I0(C, g), A.audioSegmentStream.on("log", y.getLogTrigger_("audioSegmentStream")), A.audioSegmentStream.on("timingInfo", y.trigger.bind(y, "audioTimingInfo")), A.adtsStream.pipe(A.audioSegmentStream).pipe(A.coalesceStream), y.trigger("trackinfo", {
          hasAudio: !!C,
          hasVideo: !!E
        }));
      }), A.coalesceStream.on("data", this.trigger.bind(this, "data")), A.coalesceStream.on("done", this.trigger.bind(this, "done")), F_(this, A);
    }, this.setupTsPipeline = function() {
      var A = {};
      this.transmuxPipeline_ = A, A.type = "ts", A.metadataStream = new m0.MetadataStream(), A.packetStream = new m0.TransportPacketStream(), A.parseStream = new m0.TransportParseStream(), A.elementaryStream = new m0.ElementaryStream(), A.timestampRolloverStream = new m0.TimestampRolloverStream(), A.adtsStream = new N_(), A.h264Stream = new KT(), A.captionStream = new m0.CaptionStream(g), A.coalesceStream = new b0(g, A.metadataStream), A.headOfPipeline = A.packetStream, A.packetStream.pipe(A.parseStream).pipe(A.elementaryStream).pipe(A.timestampRolloverStream), A.timestampRolloverStream.pipe(A.h264Stream), A.timestampRolloverStream.pipe(A.adtsStream), A.timestampRolloverStream.pipe(A.metadataStream).pipe(A.coalesceStream), A.h264Stream.pipe(A.captionStream).pipe(A.coalesceStream), A.elementaryStream.on("data", function(P) {
        var j;
        if (P.type === "metadata") {
          for (j = P.tracks.length; j--; )
            !E && P.tracks[j].type === "video" ? (E = P.tracks[j], E.timelineStartInfo.baseMediaDecodeTime = y.baseMediaDecodeTime) : !C && P.tracks[j].type === "audio" && (C = P.tracks[j], C.timelineStartInfo.baseMediaDecodeTime = y.baseMediaDecodeTime);
          E && !A.videoSegmentStream && (A.coalesceStream.numberOfTracks++, A.videoSegmentStream = new D0(E, g), A.videoSegmentStream.on("log", y.getLogTrigger_("videoSegmentStream")), A.videoSegmentStream.on("timelineStartInfo", function(V) {
            C && !g.keepOriginalTimestamps && (C.timelineStartInfo = V, A.audioSegmentStream.setEarliestDts(V.dts - y.baseMediaDecodeTime));
          }), A.videoSegmentStream.on("processedGopsInfo", y.trigger.bind(y, "gopInfo")), A.videoSegmentStream.on("segmentTimingInfo", y.trigger.bind(y, "videoSegmentTimingInfo")), A.videoSegmentStream.on("baseMediaDecodeTime", function(V) {
            C && A.audioSegmentStream.setVideoBaseMediaDecodeTime(V);
          }), A.videoSegmentStream.on("timingInfo", y.trigger.bind(y, "videoTimingInfo")), A.h264Stream.pipe(A.videoSegmentStream).pipe(A.coalesceStream)), C && !A.audioSegmentStream && (A.coalesceStream.numberOfTracks++, A.audioSegmentStream = new I0(C, g), A.audioSegmentStream.on("log", y.getLogTrigger_("audioSegmentStream")), A.audioSegmentStream.on("timingInfo", y.trigger.bind(y, "audioTimingInfo")), A.audioSegmentStream.on("segmentTimingInfo", y.trigger.bind(y, "audioSegmentTimingInfo")), A.adtsStream.pipe(A.audioSegmentStream).pipe(A.coalesceStream)), y.trigger("trackinfo", {
            hasAudio: !!C,
            hasVideo: !!E
          });
        }
      }), A.coalesceStream.on("data", this.trigger.bind(this, "data")), A.coalesceStream.on("id3Frame", function(P) {
        P.dispatchType = A.metadataStream.dispatchType, y.trigger("id3Frame", P);
      }), A.coalesceStream.on("caption", this.trigger.bind(this, "caption")), A.coalesceStream.on("done", this.trigger.bind(this, "done")), F_(this, A);
    }, this.setBaseMediaDecodeTime = function(A) {
      var P = this.transmuxPipeline_;
      g.keepOriginalTimestamps || (this.baseMediaDecodeTime = A), C && (C.timelineStartInfo.dts = void 0, C.timelineStartInfo.pts = void 0, d0.clearDtsInfo(C), P.audioTimestampRolloverStream && P.audioTimestampRolloverStream.discontinuity()), E && (P.videoSegmentStream && (P.videoSegmentStream.gopCache_ = []), E.timelineStartInfo.dts = void 0, E.timelineStartInfo.pts = void 0, d0.clearDtsInfo(E), P.captionStream.reset()), P.timestampRolloverStream && P.timestampRolloverStream.discontinuity();
    }, this.setAudioAppendStart = function(A) {
      C && this.transmuxPipeline_.audioSegmentStream.setAudioAppendStart(A);
    }, this.setRemux = function(A) {
      var P = this.transmuxPipeline_;
      g.remux = A, P && P.coalesceStream && P.coalesceStream.setRemux(A);
    }, this.alignGopsWith = function(A) {
      E && this.transmuxPipeline_.videoSegmentStream && this.transmuxPipeline_.videoSegmentStream.alignGopsWith(A);
    }, this.getLogTrigger_ = function(A) {
      var P = this;
      return function(j) {
        j.stream = A, P.trigger("log", j);
      };
    }, this.push = function(A) {
      if (v) {
        var P = WT(A);
        P && this.transmuxPipeline_.type !== "aac" ? this.setupAacPipeline() : !P && this.transmuxPipeline_.type !== "ts" && this.setupTsPipeline(), v = !1;
      }
      this.transmuxPipeline_.headOfPipeline.push(A);
    }, this.flush = function() {
      v = !0, this.transmuxPipeline_.headOfPipeline.flush();
    }, this.endTimeline = function() {
      this.transmuxPipeline_.headOfPipeline.endTimeline();
    }, this.reset = function() {
      this.transmuxPipeline_.headOfPipeline && this.transmuxPipeline_.headOfPipeline.reset();
    }, this.resetCaptions = function() {
      this.transmuxPipeline_.captionStream && this.transmuxPipeline_.captionStream.reset();
    };
  }, e_.prototype = new e();
  var QT = {
    Transmuxer: e_,
    VideoSegmentStream: D0,
    AudioSegmentStream: I0,
    AUDIO_PROPERTIES: p_,
    VIDEO_PROPERTIES: g_,
    generateSegmentTimingInfo: m_
  }, JT = function(g) {
    return g >>> 0;
  }, ZT = function(g) {
    return ("00" + g.toString(16)).slice(-2);
  }, t_ = {
    toUnsigned: JT,
    toHexString: ZT
  }, _E = function(g) {
    var y = "";
    return y += String.fromCharCode(g[0]), y += String.fromCharCode(g[1]), y += String.fromCharCode(g[2]), y += String.fromCharCode(g[3]), y;
  }, T0 = _E, eS = t_.toUnsigned, tS = function I(g, y) {
    var v = [], E, C, A, P, j;
    if (!y.length)
      return null;
    for (E = 0; E < g.byteLength; )
      C = eS(g[E] << 24 | g[E + 1] << 16 | g[E + 2] << 8 | g[E + 3]), A = T0(g.subarray(E + 4, E + 8)), P = C > 1 ? E + C : g.byteLength, A === y[0] && (y.length === 1 ? v.push(g.subarray(E + 8, P)) : (j = I(g.subarray(E + 8, P), y.slice(1)), j.length && (v = v.concat(j)))), E = P;
    return v;
  }, n0 = tS, rS = t_.toUnsigned, nS = n.getUint64, iS = function(g) {
    var y = {
      version: g[0],
      flags: new Uint8Array(g.subarray(1, 4))
    };
    return y.version === 1 ? y.baseMediaDecodeTime = nS(g.subarray(4)) : y.baseMediaDecodeTime = rS(g[4] << 24 | g[5] << 16 | g[6] << 8 | g[7]), y;
  }, B_ = iS, aS = function(g) {
    return {
      isLeading: (g[0] & 12) >>> 2,
      dependsOn: g[0] & 3,
      isDependedOn: (g[1] & 192) >>> 6,
      hasRedundancy: (g[1] & 48) >>> 4,
      paddingValue: (g[1] & 14) >>> 1,
      isNonSyncSample: g[1] & 1,
      degradationPriority: g[2] << 8 | g[3]
    };
  }, q_ = aS, sS = function(g) {
    var y = {
      version: g[0],
      flags: new Uint8Array(g.subarray(1, 4)),
      samples: []
    }, v = new DataView(g.buffer, g.byteOffset, g.byteLength), E = y.flags[2] & 1, C = y.flags[2] & 4, A = y.flags[1] & 1, P = y.flags[1] & 2, j = y.flags[1] & 4, V = y.flags[1] & 8, q = v.getUint32(4), _e = 8, ka;
    for (E && (y.dataOffset = v.getInt32(_e), _e += 4), C && q && (ka = {
      flags: q_(g.subarray(_e, _e + 4))
    }, _e += 4, A && (ka.duration = v.getUint32(_e), _e += 4), P && (ka.size = v.getUint32(_e), _e += 4), V && (y.version === 1 ? ka.compositionTimeOffset = v.getInt32(_e) : ka.compositionTimeOffset = v.getUint32(_e), _e += 4), y.samples.push(ka), q--); q--; )
      ka = {}, A && (ka.duration = v.getUint32(_e), _e += 4), P && (ka.size = v.getUint32(_e), _e += 4), j && (ka.flags = q_(g.subarray(_e, _e + 4)), _e += 4), V && (y.version === 1 ? ka.compositionTimeOffset = v.getInt32(_e) : ka.compositionTimeOffset = v.getUint32(_e), _e += 4), y.samples.push(ka);
    return y;
  }, G_ = sS, oS = function(g) {
    var y = new DataView(g.buffer, g.byteOffset, g.byteLength), v = {
      version: g[0],
      flags: new Uint8Array(g.subarray(1, 4)),
      trackId: y.getUint32(4)
    }, E = v.flags[2] & 1, C = v.flags[2] & 2, A = v.flags[2] & 8, P = v.flags[2] & 16, j = v.flags[2] & 32, V = v.flags[0] & 65536, q = v.flags[0] & 131072, _e;
    return _e = 8, E && (_e += 4, v.baseDataOffset = y.getUint32(12), _e += 4), C && (v.sampleDescriptionIndex = y.getUint32(_e), _e += 4), A && (v.defaultSampleDuration = y.getUint32(_e), _e += 4), P && (v.defaultSampleSize = y.getUint32(_e), _e += 4), j && (v.defaultSampleFlags = y.getUint32(_e)), V && (v.durationIsEmpty = !0), !E && q && (v.baseDataOffsetIsMoof = !0), v;
  }, H_ = oS, V_ = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, M0;
  typeof window < "u" ? M0 = window : typeof V_ < "u" ? M0 = V_ : typeof self < "u" ? M0 = self : M0 = {};
  var U0 = M0, uS = P0.discardEmulationPreventionBytes, cS = $0.CaptionStream, lS = function(g, y) {
    for (var v = g, E = 0; E < y.length; E++) {
      var C = y[E];
      if (v < C.size)
        return C;
      v -= C.size;
    }
    return null;
  }, fS = function(g, y, v) {
    var E = new DataView(g.buffer, g.byteOffset, g.byteLength), C = {
      logs: [],
      seiNals: []
    }, A, P, j, V;
    for (P = 0; P + 4 < g.length; P += j)
      if (j = E.getUint32(P), P += 4, !(j <= 0))
        switch (g[P] & 31) {
          case 6:
            var q = g.subarray(P + 1, P + 1 + j), _e = lS(P, y);
            if (A = {
              nalUnitType: "sei_rbsp",
              size: j,
              data: q,
              escapedRBSP: uS(q),
              trackId: v
            }, _e)
              A.pts = _e.pts, A.dts = _e.dts, V = _e;
            else if (V)
              A.pts = V.pts, A.dts = V.dts;
            else {
              C.logs.push({
                level: "warn",
                message: "We've encountered a nal unit without data at " + P + " for trackId " + v + ". See mux.js#223."
              });
              break;
            }
            C.seiNals.push(A);
            break;
        }
    return C;
  }, dS = function(g, y, v) {
    var E = y, C = v.defaultSampleDuration || 0, A = v.defaultSampleSize || 0, P = v.trackId, j = [];
    return g.forEach(function(V) {
      var q = G_(V), _e = q.samples;
      _e.forEach(function(ka) {
        ka.duration === void 0 && (ka.duration = C), ka.size === void 0 && (ka.size = A), ka.trackId = P, ka.dts = E, ka.compositionTimeOffset === void 0 && (ka.compositionTimeOffset = 0), typeof E == "bigint" ? (ka.pts = E + U0.BigInt(ka.compositionTimeOffset), E += U0.BigInt(ka.duration)) : (ka.pts = E + ka.compositionTimeOffset, E += ka.duration);
      }), j = j.concat(_e);
    }), j;
  }, hS = function(g, y) {
    var v = n0(g, ["moof", "traf"]), E = n0(g, ["mdat"]), C = {}, A = [];
    return E.forEach(function(P, j) {
      var V = v[j];
      A.push({
        mdat: P,
        traf: V
      });
    }), A.forEach(function(P) {
      var j = P.mdat, V = P.traf, q = n0(V, ["tfhd"]), _e = H_(q[0]), ka = _e.trackId, _c = n0(V, ["tfdt"]), _l = _c.length > 0 ? B_(_c[0]).baseMediaDecodeTime : 0, _u = n0(V, ["trun"]), _h, s0;
      y === ka && _u.length > 0 && (_h = dS(_u, _l, _e), s0 = fS(j, _h, ka), C[ka] || (C[ka] = {
        seiNals: [],
        logs: []
      }), C[ka].seiNals = C[ka].seiNals.concat(s0.seiNals), C[ka].logs = C[ka].logs.concat(s0.logs));
    }), C;
  }, pS = function(g, y, v) {
    var E;
    if (y === null)
      return null;
    E = hS(g, y);
    var C = E[y] || {};
    return {
      seiNals: C.seiNals,
      logs: C.logs,
      timescale: v
    };
  }, gS = function() {
    var g = !1, y, v, E, C, A, P;
    this.isInitialized = function() {
      return g;
    }, this.init = function(j) {
      y = new cS(), g = !0, P = j ? j.isPartial : !1, y.on("data", function(V) {
        V.startTime = V.startPts / C, V.endTime = V.endPts / C, A.captions.push(V), A.captionStreams[V.stream] = !0;
      }), y.on("log", function(V) {
        A.logs.push(V);
      });
    }, this.isNewInit = function(j, V) {
      return j && j.length === 0 || V && typeof V == "object" && Object.keys(V).length === 0 ? !1 : E !== j[0] || C !== V[E];
    }, this.parse = function(j, V, q) {
      var _e;
      if (this.isInitialized()) {
        if (!V || !q)
          return null;
        if (this.isNewInit(V, q))
          E = V[0], C = q[E];
        else if (E === null || !C)
          return v.push(j), null;
      } else
        return null;
      for (; v.length > 0; ) {
        var ka = v.shift();
        this.parse(ka, V, q);
      }
      return _e = pS(j, E, C), _e && _e.logs && (A.logs = A.logs.concat(_e.logs)), _e === null || !_e.seiNals ? A.logs.length ? {
        logs: A.logs,
        captions: [],
        captionStreams: []
      } : null : (this.pushNals(_e.seiNals), this.flushStream(), A);
    }, this.pushNals = function(j) {
      if (!this.isInitialized() || !j || j.length === 0)
        return null;
      j.forEach(function(V) {
        y.push(V);
      });
    }, this.flushStream = function() {
      if (!this.isInitialized())
        return null;
      P ? y.partialFlush() : y.flush();
    }, this.clearParsedCaptions = function() {
      A.captions = [], A.captionStreams = {}, A.logs = [];
    }, this.resetCaptionStream = function() {
      if (!this.isInitialized())
        return null;
      y.reset();
    }, this.clearAllCaptions = function() {
      this.clearParsedCaptions(), this.resetCaptionStream();
    }, this.reset = function() {
      v = [], E = null, C = null, A ? this.clearParsedCaptions() : A = {
        captions: [],
        captionStreams: {},
        logs: []
      }, this.resetCaptionStream();
    }, this.reset();
  }, mS = gS, r_ = t_.toUnsigned, F0 = t_.toHexString, vS = n.getUint64, $_, z_, K_, W_, X_, v_;
  $_ = function(g) {
    var y = {}, v = n0(g, ["moov", "trak"]);
    return v.reduce(function(E, C) {
      var A, P, j, V, q;
      return A = n0(C, ["tkhd"])[0], !A || (P = A[0], j = P === 0 ? 12 : 20, V = r_(A[j] << 24 | A[j + 1] << 16 | A[j + 2] << 8 | A[j + 3]), q = n0(C, ["mdia", "mdhd"])[0], !q) ? null : (P = q[0], j = P === 0 ? 12 : 20, E[V] = r_(q[j] << 24 | q[j + 1] << 16 | q[j + 2] << 8 | q[j + 3]), E);
    }, y);
  }, z_ = function(g, y) {
    var v;
    v = n0(y, ["moof", "traf"]);
    var E = v.reduce(function(C, A) {
      var P = n0(A, ["tfhd"])[0], j = r_(P[4] << 24 | P[5] << 16 | P[6] << 8 | P[7]), V = g[j] || 9e4, q = n0(A, ["tfdt"])[0], _e = new DataView(q.buffer, q.byteOffset, q.byteLength), ka;
      q[0] === 1 ? ka = vS(q.subarray(4, 12)) : ka = _e.getUint32(4);
      var _c;
      return typeof ka == "bigint" ? _c = ka / U0.BigInt(V) : typeof ka == "number" && !isNaN(ka) && (_c = ka / V), _c < Number.MAX_SAFE_INTEGER && (_c = Number(_c)), _c < C && (C = _c), C;
    }, 1 / 0);
    return typeof E == "bigint" || isFinite(E) ? E : 0;
  }, K_ = function(g, y) {
    var v = n0(y, ["moof", "traf"]), E = 0, C = 0, A;
    if (v && v.length) {
      var P = n0(v[0], ["tfhd"])[0], j = n0(v[0], ["trun"])[0], V = n0(v[0], ["tfdt"])[0];
      if (P) {
        var q = H_(P);
        A = q.trackId;
      }
      if (V) {
        var _e = B_(V);
        E = _e.baseMediaDecodeTime;
      }
      if (j) {
        var ka = G_(j);
        ka.samples && ka.samples.length && (C = ka.samples[0].compositionTimeOffset || 0);
      }
    }
    var _c = g[A] || 9e4;
    typeof E == "bigint" && (C = U0.BigInt(C), _c = U0.BigInt(_c));
    var _l = (E + C) / _c;
    return typeof _l == "bigint" && _l < Number.MAX_SAFE_INTEGER && (_l = Number(_l)), _l;
  }, W_ = function(g) {
    var y = n0(g, ["moov", "trak"]), v = [];
    return y.forEach(function(E) {
      var C = n0(E, ["mdia", "hdlr"]), A = n0(E, ["tkhd"]);
      C.forEach(function(P, j) {
        var V = T0(P.subarray(8, 12)), q = A[j], _e, ka, _c;
        V === "vide" && (_e = new DataView(q.buffer, q.byteOffset, q.byteLength), ka = _e.getUint8(0), _c = ka === 0 ? _e.getUint32(12) : _e.getUint32(20), v.push(_c));
      });
    }), v;
  }, v_ = function(g) {
    var y = g[0], v = y === 0 ? 12 : 20;
    return r_(g[v] << 24 | g[v + 1] << 16 | g[v + 2] << 8 | g[v + 3]);
  }, X_ = function(g) {
    var y = n0(g, ["moov", "trak"]), v = [];
    return y.forEach(function(E) {
      var C = {}, A = n0(E, ["tkhd"])[0], P, j;
      A && (P = new DataView(A.buffer, A.byteOffset, A.byteLength), j = P.getUint8(0), C.id = j === 0 ? P.getUint32(12) : P.getUint32(20));
      var V = n0(E, ["mdia", "hdlr"])[0];
      if (V) {
        var q = T0(V.subarray(8, 12));
        q === "vide" ? C.type = "video" : q === "soun" ? C.type = "audio" : C.type = q;
      }
      var _e = n0(E, ["mdia", "minf", "stbl", "stsd"])[0];
      if (_e) {
        var ka = _e.subarray(8);
        C.codec = T0(ka.subarray(4, 8));
        var _c = n0(ka, [C.codec])[0], _l, _u;
        _c && (/^[asm]vc[1-9]$/i.test(C.codec) ? (_l = _c.subarray(78), _u = T0(_l.subarray(4, 8)), _u === "avcC" && _l.length > 11 ? (C.codec += ".", C.codec += F0(_l[9]), C.codec += F0(_l[10]), C.codec += F0(_l[11])) : C.codec = "avc1.4d400d") : /^mp4[a,v]$/i.test(C.codec) ? (_l = _c.subarray(28), _u = T0(_l.subarray(4, 8)), _u === "esds" && _l.length > 20 && _l[19] !== 0 ? (C.codec += "." + F0(_l[19]), C.codec += "." + F0(_l[20] >>> 2 & 63).replace(/^0/, "")) : C.codec = "mp4a.40.2") : C.codec = C.codec.toLowerCase());
      }
      var _h = n0(E, ["mdia", "mdhd"])[0];
      _h && (C.timescale = v_(_h)), v.push(C);
    }), v;
  };
  var Y_ = {
    findBox: n0,
    parseType: T0,
    timescale: $_,
    startTime: z_,
    compositionStartTime: K_,
    videoTrackIds: W_,
    tracks: X_,
    getTimescaleFromMediaHeader: v_
  }, Q_ = function(g) {
    var y = g[1] & 31;
    return y <<= 8, y |= g[2], y;
  }, n_ = function(g) {
    return !!(g[1] & 64);
  }, i_ = function(g) {
    var y = 0;
    return (g[3] & 48) >>> 4 > 1 && (y += g[4] + 1), y;
  }, yS = function(g, y) {
    var v = Q_(g);
    return v === 0 ? "pat" : v === y ? "pmt" : y ? "pes" : null;
  }, _S = function(g) {
    var y = n_(g), v = 4 + i_(g);
    return y && (v += g[v] + 1), (g[v + 10] & 31) << 8 | g[v + 11];
  }, bS = function(g) {
    var y = {}, v = n_(g), E = 4 + i_(g);
    if (v && (E += g[E] + 1), !!(g[E + 5] & 1)) {
      var C, A, P;
      C = (g[E + 1] & 15) << 8 | g[E + 2], A = 3 + C - 4, P = (g[E + 10] & 15) << 8 | g[E + 11];
      for (var j = 12 + P; j < A; ) {
        var V = E + j;
        y[(g[V + 1] & 31) << 8 | g[V + 2]] = g[V], j += ((g[V + 3] & 15) << 8 | g[V + 4]) + 5;
      }
      return y;
    }
  }, TS = function(g, y) {
    var v = Q_(g), E = y[v];
    switch (E) {
      case o0.H264_STREAM_TYPE:
        return "video";
      case o0.ADTS_STREAM_TYPE:
        return "audio";
      case o0.METADATA_STREAM_TYPE:
        return "timed-metadata";
      default:
        return null;
    }
  }, ES = function(g) {
    var y = n_(g);
    if (!y)
      return null;
    var v = 4 + i_(g);
    if (v >= g.byteLength)
      return null;
    var E = null, C;
    return C = g[v + 7], C & 192 && (E = {}, E.pts = (g[v + 9] & 14) << 27 | (g[v + 10] & 255) << 20 | (g[v + 11] & 254) << 12 | (g[v + 12] & 255) << 5 | (g[v + 13] & 254) >>> 3, E.pts *= 4, E.pts += (g[v + 13] & 6) >>> 1, E.dts = E.pts, C & 64 && (E.dts = (g[v + 14] & 14) << 27 | (g[v + 15] & 255) << 20 | (g[v + 16] & 254) << 12 | (g[v + 17] & 255) << 5 | (g[v + 18] & 254) >>> 3, E.dts *= 4, E.dts += (g[v + 18] & 6) >>> 1)), E;
  }, y_ = function(g) {
    switch (g) {
      case 5:
        return "slice_layer_without_partitioning_rbsp_idr";
      case 6:
        return "sei_rbsp";
      case 7:
        return "seq_parameter_set_rbsp";
      case 8:
        return "pic_parameter_set_rbsp";
      case 9:
        return "access_unit_delimiter_rbsp";
      default:
        return null;
    }
  }, SS = function(g) {
    for (var y = 4 + i_(g), v = g.subarray(y), E = 0, C = 0, A = !1, P; C < v.byteLength - 3; C++)
      if (v[C + 2] === 1) {
        E = C + 5;
        break;
      }
    for (; E < v.byteLength; )
      switch (v[E]) {
        case 0:
          if (v[E - 1] !== 0) {
            E += 2;
            break;
          } else if (v[E - 2] !== 0) {
            E++;
            break;
          }
          C + 3 !== E - 2 && (P = y_(v[C + 3] & 31), P === "slice_layer_without_partitioning_rbsp_idr" && (A = !0));
          do
            E++;
          while (v[E] !== 1 && E < v.length);
          C = E - 2, E += 3;
          break;
        case 1:
          if (v[E - 1] !== 0 || v[E - 2] !== 0) {
            E += 3;
            break;
          }
          P = y_(v[C + 3] & 31), P === "slice_layer_without_partitioning_rbsp_idr" && (A = !0), C = E - 2, E += 3;
          break;
        default:
          E += 3;
          break;
      }
    return v = v.subarray(C), E -= C, C = 0, v && v.byteLength > 3 && (P = y_(v[C + 3] & 31), P === "slice_layer_without_partitioning_rbsp_idr" && (A = !0)), A;
  }, wS = {
    parseType: yS,
    parsePat: _S,
    parsePmt: bS,
    parsePayloadUnitStartIndicator: n_,
    parsePesType: TS,
    parsePesTime: ES,
    videoPacketContainsKeyFrame: SS
  }, k0 = O_.handleRollover, e0 = {};
  e0.ts = wS, e0.aac = Z0;
  var E0 = _m.ONE_SECOND_IN_TS, u0 = 188, p0 = 71, xS = function(g, y) {
    for (var v = 0, E = u0, C, A; E < g.byteLength; ) {
      if (g[v] === p0 && g[E] === p0) {
        switch (C = g.subarray(v, E), A = e0.ts.parseType(C, y.pid), A) {
          case "pat":
            y.pid = e0.ts.parsePat(C);
            break;
          case "pmt":
            var P = e0.ts.parsePmt(C);
            y.table = y.table || {}, Object.keys(P).forEach(function(j) {
              y.table[j] = P[j];
            });
            break;
        }
        v += u0, E += u0;
        continue;
      }
      v++, E++;
    }
  }, J_ = function(g, y, v) {
    for (var E = 0, C = u0, A, P, j, V, q, _e = !1; C <= g.byteLength; ) {
      if (g[E] === p0 && (g[C] === p0 || C === g.byteLength)) {
        switch (A = g.subarray(E, C), P = e0.ts.parseType(A, y.pid), P) {
          case "pes":
            j = e0.ts.parsePesType(A, y.table), V = e0.ts.parsePayloadUnitStartIndicator(A), j === "audio" && V && (q = e0.ts.parsePesTime(A), q && (q.type = "audio", v.audio.push(q), _e = !0));
            break;
        }
        if (_e)
          break;
        E += u0, C += u0;
        continue;
      }
      E++, C++;
    }
    for (C = g.byteLength, E = C - u0, _e = !1; E >= 0; ) {
      if (g[E] === p0 && (g[C] === p0 || C === g.byteLength)) {
        switch (A = g.subarray(E, C), P = e0.ts.parseType(A, y.pid), P) {
          case "pes":
            j = e0.ts.parsePesType(A, y.table), V = e0.ts.parsePayloadUnitStartIndicator(A), j === "audio" && V && (q = e0.ts.parsePesTime(A), q && (q.type = "audio", v.audio.push(q), _e = !0));
            break;
        }
        if (_e)
          break;
        E -= u0, C -= u0;
        continue;
      }
      E--, C--;
    }
  }, CS = function(g, y, v) {
    for (var E = 0, C = u0, A, P, j, V, q, _e, ka, _c, _l = !1, _u = {
      data: [],
      size: 0
    }; C < g.byteLength; ) {
      if (g[E] === p0 && g[C] === p0) {
        switch (A = g.subarray(E, C), P = e0.ts.parseType(A, y.pid), P) {
          case "pes":
            if (j = e0.ts.parsePesType(A, y.table), V = e0.ts.parsePayloadUnitStartIndicator(A), j === "video" && (V && !_l && (q = e0.ts.parsePesTime(A), q && (q.type = "video", v.video.push(q), _l = !0)), !v.firstKeyFrame)) {
              if (V && _u.size !== 0) {
                for (_e = new Uint8Array(_u.size), ka = 0; _u.data.length; )
                  _c = _u.data.shift(), _e.set(_c, ka), ka += _c.byteLength;
                if (e0.ts.videoPacketContainsKeyFrame(_e)) {
                  var _h = e0.ts.parsePesTime(_e);
                  _h ? (v.firstKeyFrame = _h, v.firstKeyFrame.type = "video") : console.warn("Failed to extract PTS/DTS from PES at first keyframe. This could be an unusual TS segment, or else mux.js did not parse your TS segment correctly. If you know your TS segments do contain PTS/DTS on keyframes please file a bug report! You can try ffprobe to double check for yourself.");
                }
                _u.size = 0;
              }
              _u.data.push(A), _u.size += A.byteLength;
            }
            break;
        }
        if (_l && v.firstKeyFrame)
          break;
        E += u0, C += u0;
        continue;
      }
      E++, C++;
    }
    for (C = g.byteLength, E = C - u0, _l = !1; E >= 0; ) {
      if (g[E] === p0 && g[C] === p0) {
        switch (A = g.subarray(E, C), P = e0.ts.parseType(A, y.pid), P) {
          case "pes":
            j = e0.ts.parsePesType(A, y.table), V = e0.ts.parsePayloadUnitStartIndicator(A), j === "video" && V && (q = e0.ts.parsePesTime(A), q && (q.type = "video", v.video.push(q), _l = !0));
            break;
        }
        if (_l)
          break;
        E -= u0, C -= u0;
        continue;
      }
      E--, C--;
    }
  }, AS = function(g, y) {
    if (g.audio && g.audio.length) {
      var v = y;
      (typeof v > "u" || isNaN(v)) && (v = g.audio[0].dts), g.audio.forEach(function(A) {
        A.dts = k0(A.dts, v), A.pts = k0(A.pts, v), A.dtsTime = A.dts / E0, A.ptsTime = A.pts / E0;
      });
    }
    if (g.video && g.video.length) {
      var E = y;
      if ((typeof E > "u" || isNaN(E)) && (E = g.video[0].dts), g.video.forEach(function(A) {
        A.dts = k0(A.dts, E), A.pts = k0(A.pts, E), A.dtsTime = A.dts / E0, A.ptsTime = A.pts / E0;
      }), g.firstKeyFrame) {
        var C = g.firstKeyFrame;
        C.dts = k0(C.dts, E), C.pts = k0(C.pts, E), C.dtsTime = C.dts / E0, C.ptsTime = C.pts / E0;
      }
    }
  }, OS = function(g) {
    for (var y = !1, v = 0, E = null, C = null, A = 0, P = 0, j; g.length - P >= 3; ) {
      var V = e0.aac.parseType(g, P);
      switch (V) {
        case "timed-metadata":
          if (g.length - P < 10) {
            y = !0;
            break;
          }
          if (A = e0.aac.parseId3TagSize(g, P), A > g.length) {
            y = !0;
            break;
          }
          C === null && (j = g.subarray(P, P + A), C = e0.aac.parseAacTimestamp(j)), P += A;
          break;
        case "audio":
          if (g.length - P < 7) {
            y = !0;
            break;
          }
          if (A = e0.aac.parseAdtsSize(g, P), A > g.length) {
            y = !0;
            break;
          }
          E === null && (j = g.subarray(P, P + A), E = e0.aac.parseSampleRate(j)), v++, P += A;
          break;
        default:
          P++;
          break;
      }
      if (y)
        return null;
    }
    if (E === null || C === null)
      return null;
    var q = E0 / E, _e = {
      audio: [{
        type: "audio",
        dts: C,
        pts: C
      }, {
        type: "audio",
        dts: C + v * 1024 * q,
        pts: C + v * 1024 * q
      }]
    };
    return _e;
  }, IS = function(g) {
    var y = {
      pid: null,
      table: null
    }, v = {};
    xS(g, y);
    for (var E in y.table)
      if (y.table.hasOwnProperty(E)) {
        var C = y.table[E];
        switch (C) {
          case o0.H264_STREAM_TYPE:
            v.video = [], CS(g, y, v), v.video.length === 0 && delete v.video;
            break;
          case o0.ADTS_STREAM_TYPE:
            v.audio = [], J_(g, y, v), v.audio.length === 0 && delete v.audio;
            break;
        }
      }
    return v;
  }, kS = function(g, y) {
    var v = e0.aac.isLikelyAacData(g), E;
    return v ? E = OS(g) : E = IS(g), !E || !E.audio && !E.video ? null : (AS(E, y), E);
  }, RS = {
    inspect: kS,
    parseAudioPes_: J_
  }, PS = function(g, y) {
    y.on("data", function(v) {
      var E = v.initSegment;
      v.initSegment = {
        data: E.buffer,
        byteOffset: E.byteOffset,
        byteLength: E.byteLength
      };
      var C = v.data;
      v.data = C.buffer, g.postMessage({
        action: "data",
        segment: v,
        byteOffset: C.byteOffset,
        byteLength: C.byteLength
      }, [v.data]);
    }), y.on("done", function(v) {
      g.postMessage({
        action: "done"
      });
    }), y.on("gopInfo", function(v) {
      g.postMessage({
        action: "gopInfo",
        gopInfo: v
      });
    }), y.on("videoSegmentTimingInfo", function(v) {
      var E = {
        start: {
          decode: _m.videoTsToSeconds(v.start.dts),
          presentation: _m.videoTsToSeconds(v.start.pts)
        },
        end: {
          decode: _m.videoTsToSeconds(v.end.dts),
          presentation: _m.videoTsToSeconds(v.end.pts)
        },
        baseMediaDecodeTime: _m.videoTsToSeconds(v.baseMediaDecodeTime)
      };
      v.prependedContentDuration && (E.prependedContentDuration = _m.videoTsToSeconds(v.prependedContentDuration)), g.postMessage({
        action: "videoSegmentTimingInfo",
        videoSegmentTimingInfo: E
      });
    }), y.on("audioSegmentTimingInfo", function(v) {
      var E = {
        start: {
          decode: _m.videoTsToSeconds(v.start.dts),
          presentation: _m.videoTsToSeconds(v.start.pts)
        },
        end: {
          decode: _m.videoTsToSeconds(v.end.dts),
          presentation: _m.videoTsToSeconds(v.end.pts)
        },
        baseMediaDecodeTime: _m.videoTsToSeconds(v.baseMediaDecodeTime)
      };
      v.prependedContentDuration && (E.prependedContentDuration = _m.videoTsToSeconds(v.prependedContentDuration)), g.postMessage({
        action: "audioSegmentTimingInfo",
        audioSegmentTimingInfo: E
      });
    }), y.on("id3Frame", function(v) {
      g.postMessage({
        action: "id3Frame",
        id3Frame: v
      });
    }), y.on("caption", function(v) {
      g.postMessage({
        action: "caption",
        caption: v
      });
    }), y.on("trackinfo", function(v) {
      g.postMessage({
        action: "trackinfo",
        trackInfo: v
      });
    }), y.on("audioTimingInfo", function(v) {
      g.postMessage({
        action: "audioTimingInfo",
        audioTimingInfo: {
          start: _m.videoTsToSeconds(v.start),
          end: _m.videoTsToSeconds(v.end)
        }
      });
    }), y.on("videoTimingInfo", function(v) {
      g.postMessage({
        action: "videoTimingInfo",
        videoTimingInfo: {
          start: _m.videoTsToSeconds(v.start),
          end: _m.videoTsToSeconds(v.end)
        }
      });
    }), y.on("log", function(v) {
      g.postMessage({
        action: "log",
        log: v
      });
    });
  }, Z_ = /* @__PURE__ */ function() {
    function I(y, v) {
      this.options = v || {}, this.self = y, this.init();
    }
    var g = I.prototype;
    return g.init = function() {
      this.transmuxer && this.transmuxer.dispose(), this.transmuxer = new QT.Transmuxer(this.options), PS(this.self, this.transmuxer);
    }, g.pushMp4Captions = function(v) {
      this.captionParser || (this.captionParser = new mS(), this.captionParser.init());
      var E = new Uint8Array(v.data, v.byteOffset, v.byteLength), C = this.captionParser.parse(E, v.trackIds, v.timescales);
      this.self.postMessage({
        action: "mp4Captions",
        captions: C && C.captions || [],
        logs: C && C.logs || [],
        data: E.buffer
      }, [E.buffer]);
    }, g.probeMp4StartTime = function(v) {
      var E = v.timescales, C = v.data, A = Y_.startTime(E, C);
      this.self.postMessage({
        action: "probeMp4StartTime",
        startTime: A,
        data: C
      }, [C.buffer]);
    }, g.probeMp4Tracks = function(v) {
      var E = v.data, C = Y_.tracks(E);
      this.self.postMessage({
        action: "probeMp4Tracks",
        tracks: C,
        data: E
      }, [E.buffer]);
    }, g.probeTs = function(v) {
      var E = v.data, C = v.baseStartTime, A = typeof C == "number" && !isNaN(C) ? C * _m.ONE_SECOND_IN_TS : void 0, P = RS.inspect(E, A), j = null;
      P && (j = {
        hasVideo: P.video && P.video.length === 2 || !1,
        hasAudio: P.audio && P.audio.length === 2 || !1
      }, j.hasVideo && (j.videoStart = P.video[0].ptsTime), j.hasAudio && (j.audioStart = P.audio[0].ptsTime)), this.self.postMessage({
        action: "probeTs",
        result: j,
        data: E
      }, [E.buffer]);
    }, g.clearAllMp4Captions = function() {
      this.captionParser && this.captionParser.clearAllCaptions();
    }, g.clearParsedMp4Captions = function() {
      this.captionParser && this.captionParser.clearParsedCaptions();
    }, g.push = function(v) {
      var E = new Uint8Array(v.data, v.byteOffset, v.byteLength);
      this.transmuxer.push(E);
    }, g.reset = function() {
      this.transmuxer.reset();
    }, g.setTimestampOffset = function(v) {
      var E = v.timestampOffset || 0;
      this.transmuxer.setBaseMediaDecodeTime(Math.round(_m.secondsToVideoTs(E)));
    }, g.setAudioAppendStart = function(v) {
      this.transmuxer.setAudioAppendStart(Math.ceil(_m.secondsToVideoTs(v.appendStart)));
    }, g.setRemux = function(v) {
      this.transmuxer.setRemux(v.remux);
    }, g.flush = function(v) {
      this.transmuxer.flush(), self.postMessage({
        action: "done",
        type: "transmuxed"
      });
    }, g.endTimeline = function() {
      this.transmuxer.endTimeline(), self.postMessage({
        action: "endedtimeline",
        type: "transmuxed"
      });
    }, g.alignGopsWith = function(v) {
      this.transmuxer.alignGopsWith(v.gopsToAlignWith.slice());
    }, I;
  }();
  self.onmessage = function(I) {
    if (I.data.action === "init" && I.data.options) {
      this.messageHandlers = new Z_(self, I.data.options);
      return;
    }
    this.messageHandlers || (this.messageHandlers = new Z_(self)), I.data && I.data.action && I.data.action !== "init" && this.messageHandlers[I.data.action] && this.messageHandlers[I.data.action](I.data);
  };
})), TransmuxWorker = factory(workerCode$1), handleData_ = function r(e, t, a) {
  var n = e.data.segment, s = n.type, o = n.initSegment, u = n.captions, l = n.captionStreams, f = n.metadata, d = n.videoFrameDtsTime, h = n.videoFramePtsTime;
  t.buffer.push({
    captions: u,
    captionStreams: l,
    metadata: f
  });
  var p = e.data.segment.boxes || {
    data: e.data.segment.data
  }, m = {
    type: s,
    data: new Uint8Array(p.data, p.data.byteOffset, p.data.byteLength),
    initSegment: new Uint8Array(o.data, o.byteOffset, o.byteLength)
  };
  typeof d < "u" && (m.videoFrameDtsTime = d), typeof h < "u" && (m.videoFramePtsTime = h), a(m);
}, handleDone_ = function r(e) {
  var t = e.transmuxedData, a = e.callback;
  t.buffer = [], a(t);
}, handleGopInfo_ = function r(e, t) {
  t.gopInfo = e.data.gopInfo;
}, processTransmux = function r(e) {
  var t = e.transmuxer, a = e.bytes, n = e.audioAppendStart, s = e.gopsToAlignWith, o = e.remux, u = e.onData, l = e.onTrackInfo, f = e.onAudioTimingInfo, d = e.onVideoTimingInfo, h = e.onVideoSegmentTimingInfo, p = e.onAudioSegmentTimingInfo, m = e.onId3, _ = e.onCaptions, w = e.onDone, S = e.onEndedTimeline, O = e.onTransmuxerLog, k = e.isEndOfTimeline, B = {
    buffer: []
  }, L = k, G = function(Fa) {
    t.currentTransmux === e && (Fa.data.action === "data" && handleData_(Fa, B, u), Fa.data.action === "trackinfo" && l(Fa.data.trackInfo), Fa.data.action === "gopInfo" && handleGopInfo_(Fa, B), Fa.data.action === "audioTimingInfo" && f(Fa.data.audioTimingInfo), Fa.data.action === "videoTimingInfo" && d(Fa.data.videoTimingInfo), Fa.data.action === "videoSegmentTimingInfo" && h(Fa.data.videoSegmentTimingInfo), Fa.data.action === "audioSegmentTimingInfo" && p(Fa.data.audioSegmentTimingInfo), Fa.data.action === "id3Frame" && m([Fa.data.id3Frame], Fa.data.id3Frame.dispatchType), Fa.data.action === "caption" && _(Fa.data.caption), Fa.data.action === "endedtimeline" && (L = !1, S()), Fa.data.action === "log" && O(Fa.data.log), Fa.data.type === "transmuxed" && (L || (t.onmessage = null, handleDone_({
      transmuxedData: B,
      callback: w
    }), dequeue(t))));
  };
  if (t.onmessage = G, n && t.postMessage({
    action: "setAudioAppendStart",
    appendStart: n
  }), Array.isArray(s) && t.postMessage({
    action: "alignGopsWith",
    gopsToAlignWith: s
  }), typeof o < "u" && t.postMessage({
    action: "setRemux",
    remux: o
  }), a.byteLength) {
    var _r = a instanceof ArrayBuffer ? a : a.buffer, ga = a instanceof ArrayBuffer ? 0 : a.byteOffset;
    t.postMessage({
      action: "push",
      data: _r,
      byteOffset: ga,
      byteLength: a.byteLength
    }, [_r]);
  }
  k && t.postMessage({
    action: "endTimeline"
  }), t.postMessage({
    action: "flush"
  });
}, dequeue = function r(e) {
  e.currentTransmux = null, e.transmuxQueue.length && (e.currentTransmux = e.transmuxQueue.shift(), typeof e.currentTransmux == "function" ? e.currentTransmux() : processTransmux(e.currentTransmux));
}, processAction = function r(e, t) {
  e.postMessage({
    action: t
  }), dequeue(e);
}, enqueueAction = function r(e, t) {
  if (!t.currentTransmux) {
    t.currentTransmux = e, processAction(t, e);
    return;
  }
  t.transmuxQueue.push(processAction.bind(null, t, e));
}, reset = function r(e) {
  enqueueAction("reset", e);
}, endTimeline = function r(e) {
  enqueueAction("endTimeline", e);
}, transmux = function r(e) {
  if (!e.transmuxer.currentTransmux) {
    e.transmuxer.currentTransmux = e, processTransmux(e);
    return;
  }
  e.transmuxer.transmuxQueue.push(e);
}, createTransmuxer = function r(e) {
  var t = new TransmuxWorker();
  t.currentTransmux = null, t.transmuxQueue = [];
  var a = t.terminate;
  return t.terminate = function() {
    return t.currentTransmux = null, t.transmuxQueue.length = 0, a.call(t);
  }, t.postMessage({
    action: "init",
    options: e
  }), t;
}, segmentTransmuxer = {
  reset,
  endTimeline,
  transmux,
  createTransmuxer
}, workerCallback = function r(e) {
  var t = e.transmuxer, a = e.endAction || e.action, n = e.callback, s = _extends$2({}, e, {
    endAction: null,
    transmuxer: null,
    callback: null
  }), o = function f(d) {
    d.data.action === a && (t.removeEventListener("message", f), d.data.data && (d.data.data = new Uint8Array(d.data.data, e.byteOffset || 0, e.byteLength || d.data.data.byteLength), e.data && (e.data = d.data.data)), n(d.data));
  };
  if (t.addEventListener("message", o), e.data) {
    var u = e.data instanceof ArrayBuffer;
    s.byteOffset = u ? 0 : e.data.byteOffset, s.byteLength = e.data.byteLength;
    var l = [u ? e.data : e.data.buffer];
    t.postMessage(s, l);
  } else
    t.postMessage(s);
}, REQUEST_ERRORS = {
  FAILURE: 2,
  TIMEOUT: -101,
  ABORTED: -102
}, abortAll = function r(e) {
  e.forEach(function(t) {
    t.abort();
  });
}, getRequestStats = function r(e) {
  return {
    bandwidth: e.bandwidth,
    bytesReceived: e.bytesReceived || 0,
    roundTripTime: e.roundTripTime || 0
  };
}, getProgressStats = function r(e) {
  var t = e.target, a = Date.now() - t.requestTime, n = {
    bandwidth: 1 / 0,
    bytesReceived: 0,
    roundTripTime: a || 0
  };
  return n.bytesReceived = e.loaded, n.bandwidth = Math.floor(n.bytesReceived / n.roundTripTime * 8 * 1e3), n;
}, handleErrors = function r(e, t) {
  return t.timedout ? {
    status: t.status,
    message: "HLS request timed-out at URL: " + t.uri,
    code: REQUEST_ERRORS.TIMEOUT,
    xhr: t
  } : t.aborted ? {
    status: t.status,
    message: "HLS request aborted at URL: " + t.uri,
    code: REQUEST_ERRORS.ABORTED,
    xhr: t
  } : e ? {
    status: t.status,
    message: "HLS request errored at URL: " + t.uri,
    code: REQUEST_ERRORS.FAILURE,
    xhr: t
  } : t.responseType === "arraybuffer" && t.response.byteLength === 0 ? {
    status: t.status,
    message: "Empty HLS response at URL: " + t.uri,
    code: REQUEST_ERRORS.FAILURE,
    xhr: t
  } : null;
}, handleKeyResponse = function r(e, t, a) {
  return function(n, s) {
    var o = s.response, u = handleErrors(n, s);
    if (u)
      return a(u, e);
    if (o.byteLength !== 16)
      return a({
        status: s.status,
        message: "Invalid HLS key at URL: " + s.uri,
        code: REQUEST_ERRORS.FAILURE,
        xhr: s
      }, e);
    for (var l = new DataView(o), f = new Uint32Array([l.getUint32(0), l.getUint32(4), l.getUint32(8), l.getUint32(12)]), d = 0; d < t.length; d++)
      t[d].bytes = f;
    return a(null, e);
  };
}, parseInitSegment = function r(e, t) {
  var a = detectContainerForBytes(e.map.bytes);
  if (a !== "mp4") {
    var n = e.map.resolvedUri || e.map.uri;
    return t({
      internal: !0,
      message: "Found unsupported " + (a || "unknown") + " container for initialization segment at URL: " + n,
      code: REQUEST_ERRORS.FAILURE
    });
  }
  workerCallback({
    action: "probeMp4Tracks",
    data: e.map.bytes,
    transmuxer: e.transmuxer,
    callback: function(o) {
      var u = o.tracks, l = o.data;
      return e.map.bytes = l, u.forEach(function(f) {
        e.map.tracks = e.map.tracks || {}, !e.map.tracks[f.type] && (e.map.tracks[f.type] = f, typeof f.id == "number" && f.timescale && (e.map.timescales = e.map.timescales || {}, e.map.timescales[f.id] = f.timescale));
      }), t(null);
    }
  });
}, handleInitSegmentResponse = function r(e) {
  var t = e.segment, a = e.finishProcessingFn;
  return function(n, s) {
    var o = handleErrors(n, s);
    if (o)
      return a(o, t);
    var u = new Uint8Array(s.response);
    if (t.map.key)
      return t.map.encryptedBytes = u, a(null, t);
    t.map.bytes = u, parseInitSegment(t, function(l) {
      if (l)
        return l.xhr = s, l.status = s.status, a(l, t);
      a(null, t);
    });
  };
}, handleSegmentResponse = function r(e) {
  var t = e.segment, a = e.finishProcessingFn, n = e.responseType;
  return function(s, o) {
    var u = handleErrors(s, o);
    if (u)
      return a(u, t);
    var l = n === "arraybuffer" || !o.responseText ? o.response : stringToArrayBuffer(o.responseText.substring(t.lastReachedChar || 0));
    return t.stats = getRequestStats(o), t.key ? t.encryptedBytes = new Uint8Array(l) : t.bytes = new Uint8Array(l), a(null, t);
  };
}, transmuxAndNotify = function r(e) {
  var t = e.segment, a = e.bytes, n = e.trackInfoFn, s = e.timingInfoFn, o = e.videoSegmentTimingInfoFn, u = e.audioSegmentTimingInfoFn, l = e.id3Fn, f = e.captionsFn, d = e.isEndOfTimeline, h = e.endedTimelineFn, p = e.dataFn, m = e.doneFn, _ = e.onTransmuxerLog, w = t.map && t.map.tracks || {}, S = Boolean(w.audio && w.video), O = s.bind(null, t, "audio", "start"), k = s.bind(null, t, "audio", "end"), B = s.bind(null, t, "video", "start"), L = s.bind(null, t, "video", "end"), G = function() {
    return transmux({
      bytes: a,
      transmuxer: t.transmuxer,
      audioAppendStart: t.audioAppendStart,
      gopsToAlignWith: t.gopsToAlignWith,
      remux: S,
      onData: function(_n) {
        _n.type = _n.type === "combined" ? "video" : _n.type, p(t, _n);
      },
      onTrackInfo: function(_n) {
        n && (S && (_n.isMuxed = !0), n(t, _n));
      },
      onAudioTimingInfo: function(_n) {
        O && typeof _n.start < "u" && (O(_n.start), O = null), k && typeof _n.end < "u" && k(_n.end);
      },
      onVideoTimingInfo: function(_n) {
        B && typeof _n.start < "u" && (B(_n.start), B = null), L && typeof _n.end < "u" && L(_n.end);
      },
      onVideoSegmentTimingInfo: function(_n) {
        o(_n);
      },
      onAudioSegmentTimingInfo: function(_n) {
        u(_n);
      },
      onId3: function(_n, Fa) {
        l(t, _n, Fa);
      },
      onCaptions: function(_n) {
        f(t, [_n]);
      },
      isEndOfTimeline: d,
      onEndedTimeline: function() {
        h();
      },
      onTransmuxerLog: _,
      onDone: function(_n) {
        !m || (_n.type = _n.type === "combined" ? "video" : _n.type, m(null, t, _n));
      }
    });
  };
  workerCallback({
    action: "probeTs",
    transmuxer: t.transmuxer,
    data: a,
    baseStartTime: t.baseStartTime,
    callback: function(ga) {
      t.bytes = a = ga.data;
      var _n = ga.result;
      _n && (n(t, {
        hasAudio: _n.hasAudio,
        hasVideo: _n.hasVideo,
        isMuxed: S
      }), n = null, _n.hasAudio && !S && O(_n.audioStart), _n.hasVideo && B(_n.videoStart), O = null, B = null), G();
    }
  });
}, handleSegmentBytes = function r(e) {
  var t = e.segment, a = e.bytes, n = e.trackInfoFn, s = e.timingInfoFn, o = e.videoSegmentTimingInfoFn, u = e.audioSegmentTimingInfoFn, l = e.id3Fn, f = e.captionsFn, d = e.isEndOfTimeline, h = e.endedTimelineFn, p = e.dataFn, m = e.doneFn, _ = e.onTransmuxerLog, w = new Uint8Array(a);
  if (isLikelyFmp4MediaSegment(w)) {
    t.isFmp4 = !0;
    var S = t.map.tracks, O = {
      isFmp4: !0,
      hasVideo: !!S.video,
      hasAudio: !!S.audio
    };
    S.audio && S.audio.codec && S.audio.codec !== "enca" && (O.audioCodec = S.audio.codec), S.video && S.video.codec && S.video.codec !== "encv" && (O.videoCodec = S.video.codec), S.video && S.audio && (O.isMuxed = !0), n(t, O);
    var k = function(L) {
      p(t, {
        data: w,
        type: O.hasAudio && !O.isMuxed ? "audio" : "video"
      }), L && L.length && f(t, L), m(null, t, {});
    };
    workerCallback({
      action: "probeMp4StartTime",
      timescales: t.map.timescales,
      data: w,
      transmuxer: t.transmuxer,
      callback: function(L) {
        var G = L.data, _r = L.startTime;
        if (a = G.buffer, t.bytes = w = G, O.hasAudio && !O.isMuxed && s(t, "audio", "start", _r), O.hasVideo && s(t, "video", "start", _r), !S.video || !G.byteLength || !t.transmuxer) {
          k();
          return;
        }
        workerCallback({
          action: "pushMp4Captions",
          endAction: "mp4Captions",
          transmuxer: t.transmuxer,
          data: w,
          timescales: t.map.timescales,
          trackIds: [S.video.id],
          callback: function(_n) {
            a = _n.data.buffer, t.bytes = w = _n.data, _n.logs.forEach(function(Fa) {
              _(videojs.mergeOptions(Fa, {
                stream: "mp4CaptionParser"
              }));
            }), k(_n.captions);
          }
        });
      }
    });
    return;
  }
  if (!t.transmuxer) {
    m(null, t, {});
    return;
  }
  if (typeof t.container > "u" && (t.container = detectContainerForBytes(w)), t.container !== "ts" && t.container !== "aac") {
    n(t, {
      hasAudio: !1,
      hasVideo: !1
    }), m(null, t, {});
    return;
  }
  transmuxAndNotify({
    segment: t,
    bytes: a,
    trackInfoFn: n,
    timingInfoFn: s,
    videoSegmentTimingInfoFn: o,
    audioSegmentTimingInfoFn: u,
    id3Fn: l,
    captionsFn: f,
    isEndOfTimeline: d,
    endedTimelineFn: h,
    dataFn: p,
    doneFn: m,
    onTransmuxerLog: _
  });
}, decrypt = function r(e, t) {
  var a = e.id, n = e.key, s = e.encryptedBytes, o = e.decryptionWorker, u = function f(d) {
    if (d.data.source === a) {
      o.removeEventListener("message", f);
      var h = d.data.decrypted;
      t(new Uint8Array(h.bytes, h.byteOffset, h.byteLength));
    }
  };
  o.addEventListener("message", u);
  var l;
  n.bytes.slice ? l = n.bytes.slice() : l = new Uint32Array(Array.prototype.slice.call(n.bytes)), o.postMessage(createTransferableMessage({
    source: a,
    encrypted: s,
    key: l,
    iv: n.iv
  }), [s.buffer, l.buffer]);
}, decryptSegment = function r(e) {
  var t = e.decryptionWorker, a = e.segment, n = e.trackInfoFn, s = e.timingInfoFn, o = e.videoSegmentTimingInfoFn, u = e.audioSegmentTimingInfoFn, l = e.id3Fn, f = e.captionsFn, d = e.isEndOfTimeline, h = e.endedTimelineFn, p = e.dataFn, m = e.doneFn, _ = e.onTransmuxerLog;
  decrypt({
    id: a.requestId,
    key: a.key,
    encryptedBytes: a.encryptedBytes,
    decryptionWorker: t
  }, function(w) {
    a.bytes = w, handleSegmentBytes({
      segment: a,
      bytes: a.bytes,
      trackInfoFn: n,
      timingInfoFn: s,
      videoSegmentTimingInfoFn: o,
      audioSegmentTimingInfoFn: u,
      id3Fn: l,
      captionsFn: f,
      isEndOfTimeline: d,
      endedTimelineFn: h,
      dataFn: p,
      doneFn: m,
      onTransmuxerLog: _
    });
  });
}, waitForCompletion = function r(e) {
  var t = e.activeXhrs, a = e.decryptionWorker, n = e.trackInfoFn, s = e.timingInfoFn, o = e.videoSegmentTimingInfoFn, u = e.audioSegmentTimingInfoFn, l = e.id3Fn, f = e.captionsFn, d = e.isEndOfTimeline, h = e.endedTimelineFn, p = e.dataFn, m = e.doneFn, _ = e.onTransmuxerLog, w = 0, S = !1;
  return function(O, k) {
    if (!S) {
      if (O)
        return S = !0, abortAll(t), m(O, k);
      if (w += 1, w === t.length) {
        var B = function() {
          if (k.encryptedBytes)
            return decryptSegment({
              decryptionWorker: a,
              segment: k,
              trackInfoFn: n,
              timingInfoFn: s,
              videoSegmentTimingInfoFn: o,
              audioSegmentTimingInfoFn: u,
              id3Fn: l,
              captionsFn: f,
              isEndOfTimeline: d,
              endedTimelineFn: h,
              dataFn: p,
              doneFn: m,
              onTransmuxerLog: _
            });
          handleSegmentBytes({
            segment: k,
            bytes: k.bytes,
            trackInfoFn: n,
            timingInfoFn: s,
            videoSegmentTimingInfoFn: o,
            audioSegmentTimingInfoFn: u,
            id3Fn: l,
            captionsFn: f,
            isEndOfTimeline: d,
            endedTimelineFn: h,
            dataFn: p,
            doneFn: m,
            onTransmuxerLog: _
          });
        };
        if (k.endOfAllRequests = Date.now(), k.map && k.map.encryptedBytes && !k.map.bytes)
          return decrypt({
            decryptionWorker: a,
            id: k.requestId + "-init",
            encryptedBytes: k.map.encryptedBytes,
            key: k.map.key
          }, function(L) {
            k.map.bytes = L, parseInitSegment(k, function(G) {
              if (G)
                return abortAll(t), m(G, k);
              B();
            });
          });
        B();
      }
    }
  };
}, handleLoadEnd = function r(e) {
  var t = e.loadendState, a = e.abortFn;
  return function(n) {
    var s = n.target;
    s.aborted && a && !t.calledAbortFn && (a(), t.calledAbortFn = !0);
  };
}, handleProgress = function r(e) {
  var t = e.segment, a = e.progressFn;
  return e.trackInfoFn, e.timingInfoFn, e.videoSegmentTimingInfoFn, e.audioSegmentTimingInfoFn, e.id3Fn, e.captionsFn, e.isEndOfTimeline, e.endedTimelineFn, e.dataFn, function(n) {
    var s = n.target;
    if (!s.aborted)
      return t.stats = videojs.mergeOptions(t.stats, getProgressStats(n)), !t.stats.firstBytesReceivedAt && t.stats.bytesReceived && (t.stats.firstBytesReceivedAt = Date.now()), a(n, t);
  };
}, mediaSegmentRequest = function r(e) {
  var t = e.xhr, a = e.xhrOptions, n = e.decryptionWorker, s = e.segment, o = e.abortFn, u = e.progressFn, l = e.trackInfoFn, f = e.timingInfoFn, d = e.videoSegmentTimingInfoFn, h = e.audioSegmentTimingInfoFn, p = e.id3Fn, m = e.captionsFn, _ = e.isEndOfTimeline, w = e.endedTimelineFn, S = e.dataFn, O = e.doneFn, k = e.onTransmuxerLog, B = [], L = waitForCompletion({
    activeXhrs: B,
    decryptionWorker: n,
    trackInfoFn: l,
    timingInfoFn: f,
    videoSegmentTimingInfoFn: d,
    audioSegmentTimingInfoFn: h,
    id3Fn: p,
    captionsFn: m,
    isEndOfTimeline: _,
    endedTimelineFn: w,
    dataFn: S,
    doneFn: O,
    onTransmuxerLog: k
  });
  if (s.key && !s.key.bytes) {
    var G = [s.key];
    s.map && !s.map.bytes && s.map.key && s.map.key.resolvedUri === s.key.resolvedUri && G.push(s.map.key);
    var _r = videojs.mergeOptions(a, {
      uri: s.key.resolvedUri,
      responseType: "arraybuffer"
    }), ga = handleKeyResponse(s, G, L), _n = t(_r, ga);
    B.push(_n);
  }
  if (s.map && !s.map.bytes) {
    var Fa = s.map.key && (!s.key || s.key.resolvedUri !== s.map.key.resolvedUri);
    if (Fa) {
      var N = videojs.mergeOptions(a, {
        uri: s.map.key.resolvedUri,
        responseType: "arraybuffer"
      }), _t = handleKeyResponse(s, [s.map.key], L), Y = t(N, _t);
      B.push(Y);
    }
    var _a = videojs.mergeOptions(a, {
      uri: s.map.resolvedUri,
      responseType: "arraybuffer",
      headers: segmentXhrHeaders(s.map)
    }), X = handleInitSegmentResponse({
      segment: s,
      finishProcessingFn: L
    }), J = t(_a, X);
    B.push(J);
  }
  var ea = videojs.mergeOptions(a, {
    uri: s.part && s.part.resolvedUri || s.resolvedUri,
    responseType: "arraybuffer",
    headers: segmentXhrHeaders(s)
  }), wa = handleSegmentResponse({
    segment: s,
    finishProcessingFn: L,
    responseType: ea.responseType
  }), _s = t(ea, wa);
  _s.addEventListener("progress", handleProgress({
    segment: s,
    progressFn: u,
    trackInfoFn: l,
    timingInfoFn: f,
    videoSegmentTimingInfoFn: d,
    audioSegmentTimingInfoFn: h,
    id3Fn: p,
    captionsFn: m,
    isEndOfTimeline: _,
    endedTimelineFn: w,
    dataFn: S
  })), B.push(_s);
  var _d = {};
  return B.forEach(function(_o) {
    _o.addEventListener("loadend", handleLoadEnd({
      loadendState: _d,
      abortFn: o
    }));
  }), function() {
    return abortAll(B);
  };
}, logFn$1 = logger("CodecUtils"), getCodecs = function r(e) {
  var t = e.attributes || {};
  if (t.CODECS)
    return parseCodecs(t.CODECS);
}, isMaat = function r(e, t) {
  var a = t.attributes || {};
  return e && e.mediaGroups && e.mediaGroups.AUDIO && a.AUDIO && e.mediaGroups.AUDIO[a.AUDIO];
}, isMuxed = function r(e, t) {
  if (!isMaat(e, t))
    return !0;
  var a = t.attributes || {}, n = e.mediaGroups.AUDIO[a.AUDIO];
  for (var s in n)
    if (!n[s].uri && !n[s].playlists)
      return !0;
  return !1;
}, unwrapCodecList = function r(e) {
  var t = {};
  return e.forEach(function(a) {
    var n = a.mediaType, s = a.type, o = a.details;
    t[n] = t[n] || [], t[n].push(translateLegacyCodec("" + s + o));
  }), Object.keys(t).forEach(function(a) {
    if (t[a].length > 1) {
      logFn$1("multiple " + a + " codecs found as attributes: " + t[a].join(", ") + ". Setting playlist codecs to null so that we wait for mux.js to probe segments for real codecs."), t[a] = null;
      return;
    }
    t[a] = t[a][0];
  }), t;
}, codecCount = function r(e) {
  var t = 0;
  return e.audio && t++, e.video && t++, t;
}, codecsForPlaylist = function r(e, t) {
  var a = t.attributes || {}, n = unwrapCodecList(getCodecs(t) || []);
  if (isMaat(e, t) && !n.audio && !isMuxed(e, t)) {
    var s = unwrapCodecList(codecsFromDefault(e, a.AUDIO) || []);
    s.audio && (n.audio = s.audio);
  }
  return n;
}, logFn = logger("PlaylistSelector"), representationToString = function r(e) {
  if (!(!e || !e.playlist)) {
    var t = e.playlist;
    return JSON.stringify({
      id: t.id,
      bandwidth: e.bandwidth,
      width: e.width,
      height: e.height,
      codecs: t.attributes && t.attributes.CODECS || ""
    });
  }
}, safeGetComputedStyle = function r(e, t) {
  if (!e)
    return "";
  var a = window_1.getComputedStyle(e);
  return a ? a[t] : "";
}, stableSort = function r(e, t) {
  var a = e.slice();
  e.sort(function(n, s) {
    var o = t(n, s);
    return o === 0 ? a.indexOf(n) - a.indexOf(s) : o;
  });
}, comparePlaylistBandwidth = function r(e, t) {
  var a, n;
  return e.attributes.BANDWIDTH && (a = e.attributes.BANDWIDTH), a = a || window_1.Number.MAX_VALUE, t.attributes.BANDWIDTH && (n = t.attributes.BANDWIDTH), n = n || window_1.Number.MAX_VALUE, a - n;
}, comparePlaylistResolution = function r(e, t) {
  var a, n;
  return e.attributes.RESOLUTION && e.attributes.RESOLUTION.width && (a = e.attributes.RESOLUTION.width), a = a || window_1.Number.MAX_VALUE, t.attributes.RESOLUTION && t.attributes.RESOLUTION.width && (n = t.attributes.RESOLUTION.width), n = n || window_1.Number.MAX_VALUE, a === n && e.attributes.BANDWIDTH && t.attributes.BANDWIDTH ? e.attributes.BANDWIDTH - t.attributes.BANDWIDTH : a - n;
}, simpleSelector = function r(e, t, a, n, s, o) {
  if (!!e) {
    var u = {
      bandwidth: t,
      width: a,
      height: n,
      limitRenditionByPlayerDimensions: s
    }, l = e.playlists;
    Playlist.isAudioOnly(e) && (l = o.getAudioTrackPlaylists_(), u.audioOnly = !0);
    var f = l.map(function(N) {
      var _t, Y = N.attributes && N.attributes.RESOLUTION && N.attributes.RESOLUTION.width, _a = N.attributes && N.attributes.RESOLUTION && N.attributes.RESOLUTION.height;
      return _t = N.attributes && N.attributes.BANDWIDTH, _t = _t || window_1.Number.MAX_VALUE, {
        bandwidth: _t,
        width: Y,
        height: _a,
        playlist: N
      };
    });
    stableSort(f, function(N, _t) {
      return N.bandwidth - _t.bandwidth;
    }), f = f.filter(function(N) {
      return !Playlist.isIncompatible(N.playlist);
    });
    var d = f.filter(function(N) {
      return Playlist.isEnabled(N.playlist);
    });
    d.length || (d = f.filter(function(N) {
      return !Playlist.isDisabled(N.playlist);
    }));
    var h = d.filter(function(N) {
      return N.bandwidth * Config.BANDWIDTH_VARIANCE < t;
    }), p = h[h.length - 1], m = h.filter(function(N) {
      return N.bandwidth === p.bandwidth;
    })[0];
    if (s === !1) {
      var _ = m || d[0] || f[0];
      if (_ && _.playlist) {
        var w = "sortedPlaylistReps";
        return m && (w = "bandwidthBestRep"), d[0] && (w = "enabledPlaylistReps"), logFn("choosing " + representationToString(_) + " using " + w + " with options", u), _.playlist;
      }
      return logFn("could not choose a playlist with options", u), null;
    }
    var S = h.filter(function(N) {
      return N.width && N.height;
    });
    stableSort(S, function(N, _t) {
      return N.width - _t.width;
    });
    var O = S.filter(function(N) {
      return N.width === a && N.height === n;
    });
    p = O[O.length - 1];
    var k = O.filter(function(N) {
      return N.bandwidth === p.bandwidth;
    })[0], B, L, G;
    k || (B = S.filter(function(N) {
      return N.width > a || N.height > n;
    }), L = B.filter(function(N) {
      return N.width === B[0].width && N.height === B[0].height;
    }), p = L[L.length - 1], G = L.filter(function(N) {
      return N.bandwidth === p.bandwidth;
    })[0]);
    var _r;
    if (o.experimentalLeastPixelDiffSelector) {
      var ga = S.map(function(N) {
        return N.pixelDiff = Math.abs(N.width - a) + Math.abs(N.height - n), N;
      });
      stableSort(ga, function(N, _t) {
        return N.pixelDiff === _t.pixelDiff ? _t.bandwidth - N.bandwidth : N.pixelDiff - _t.pixelDiff;
      }), _r = ga[0];
    }
    var _n = _r || G || k || m || d[0] || f[0];
    if (_n && _n.playlist) {
      var Fa = "sortedPlaylistReps";
      return _r ? Fa = "leastPixelDiffRep" : G ? Fa = "resolutionPlusOneRep" : k ? Fa = "resolutionBestRep" : m ? Fa = "bandwidthBestRep" : d[0] && (Fa = "enabledPlaylistReps"), logFn("choosing " + representationToString(_n) + " using " + Fa + " with options", u), _n.playlist;
    }
    return logFn("could not choose a playlist with options", u), null;
  }
}, lastBandwidthSelector = function r() {
  var e = this.useDevicePixelRatio && window_1.devicePixelRatio || 1;
  return simpleSelector(this.playlists.master, this.systemBandwidth, parseInt(safeGetComputedStyle(this.tech_.el(), "width"), 10) * e, parseInt(safeGetComputedStyle(this.tech_.el(), "height"), 10) * e, this.limitRenditionByPlayerDimensions, this.masterPlaylistController_);
}, movingAverageBandwidthSelector = function r(e) {
  var t = -1, a = -1;
  if (e < 0 || e > 1)
    throw new Error("Moving average bandwidth decay must be between 0 and 1.");
  return function() {
    var n = this.useDevicePixelRatio && window_1.devicePixelRatio || 1;
    return t < 0 && (t = this.systemBandwidth, a = this.systemBandwidth), this.systemBandwidth > 0 && this.systemBandwidth !== a && (t = e * this.systemBandwidth + (1 - e) * t, a = this.systemBandwidth), simpleSelector(this.playlists.master, t, parseInt(safeGetComputedStyle(this.tech_.el(), "width"), 10) * n, parseInt(safeGetComputedStyle(this.tech_.el(), "height"), 10) * n, this.limitRenditionByPlayerDimensions, this.masterPlaylistController_);
  };
}, minRebufferMaxBandwidthSelector = function r(e) {
  var t = e.master, a = e.currentTime, n = e.bandwidth, s = e.duration, o = e.segmentDuration, u = e.timeUntilRebuffer, l = e.currentTimeline, f = e.syncController, d = t.playlists.filter(function(w) {
    return !Playlist.isIncompatible(w);
  }), h = d.filter(Playlist.isEnabled);
  h.length || (h = d.filter(function(w) {
    return !Playlist.isDisabled(w);
  }));
  var p = h.filter(Playlist.hasAttribute.bind(null, "BANDWIDTH")), m = p.map(function(w) {
    var S = f.getSyncPoint(w, s, l, a), O = S ? 1 : 2, k = Playlist.estimateSegmentRequestTime(o, n, w), B = k * O - u;
    return {
      playlist: w,
      rebufferingImpact: B
    };
  }), _ = m.filter(function(w) {
    return w.rebufferingImpact <= 0;
  });
  return stableSort(_, function(w, S) {
    return comparePlaylistBandwidth(S.playlist, w.playlist);
  }), _.length ? _[0] : (stableSort(m, function(w, S) {
    return w.rebufferingImpact - S.rebufferingImpact;
  }), m[0] || null);
}, lowestBitrateCompatibleVariantSelector = function r() {
  var e = this, t = this.playlists.master.playlists.filter(Playlist.isEnabled);
  stableSort(t, function(n, s) {
    return comparePlaylistBandwidth(n, s);
  });
  var a = t.filter(function(n) {
    return !!codecsForPlaylist(e.playlists.master, n).video;
  });
  return a[0] || null;
}, concatSegments = function r(e) {
  var t = 0, a;
  return e.bytes && (a = new Uint8Array(e.bytes), e.segments.forEach(function(n) {
    a.set(n, t), t += n.byteLength;
  })), a;
}, createCaptionsTrackIfNotExists = function r(e, t, a) {
  if (!e[a]) {
    t.trigger({
      type: "usage",
      name: "vhs-608"
    }), t.trigger({
      type: "usage",
      name: "hls-608"
    });
    var n = a;
    /^cc708_/.test(a) && (n = "SERVICE" + a.split("_")[1]);
    var s = t.textTracks().getTrackById(n);
    if (s)
      e[a] = s;
    else {
      var o = t.options_.vhs && t.options_.vhs.captionServices || {}, u = a, l = a, f = !1, d = o[n];
      d && (u = d.label, l = d.language, f = d.default), e[a] = t.addRemoteTextTrack({
        kind: "captions",
        id: n,
        default: f,
        label: u,
        language: l
      }, !1).track;
    }
  }
}, addCaptionData = function r(e) {
  var t = e.inbandTextTracks, a = e.captionArray, n = e.timestampOffset;
  if (!!a) {
    var s = window_1.WebKitDataCue || window_1.VTTCue;
    a.forEach(function(o) {
      var u = o.stream;
      t[u].addCue(new s(o.startTime + n, o.endTime + n, o.text));
    });
  }
}, deprecateOldCue = function r(e) {
  Object.defineProperties(e.frame, {
    id: {
      get: function() {
        return videojs.log.warn("cue.frame.id is deprecated. Use cue.value.key instead."), e.value.key;
      }
    },
    value: {
      get: function() {
        return videojs.log.warn("cue.frame.value is deprecated. Use cue.value.data instead."), e.value.data;
      }
    },
    privateData: {
      get: function() {
        return videojs.log.warn("cue.frame.privateData is deprecated. Use cue.value.data instead."), e.value.data;
      }
    }
  });
}, addMetadata = function r(e) {
  var t = e.inbandTextTracks, a = e.metadataArray, n = e.timestampOffset, s = e.videoDuration;
  if (!!a) {
    var o = window_1.WebKitDataCue || window_1.VTTCue, u = t.metadataTrack_;
    if (!!u && (a.forEach(function(m) {
      var _ = m.cueTime + n;
      typeof _ != "number" || window_1.isNaN(_) || _ < 0 || !(_ < 1 / 0) || m.frames.forEach(function(w) {
        var S = new o(_, _, w.value || w.url || w.data || "");
        S.frame = w, S.value = w, deprecateOldCue(S), u.addCue(S);
      });
    }), !(!u.cues || !u.cues.length))) {
      for (var l = u.cues, f = [], d = 0; d < l.length; d++)
        l[d] && f.push(l[d]);
      var h = f.reduce(function(m, _) {
        var w = m[_.startTime] || [];
        return w.push(_), m[_.startTime] = w, m;
      }, {}), p = Object.keys(h).sort(function(m, _) {
        return Number(m) - Number(_);
      });
      p.forEach(function(m, _) {
        var w = h[m], S = Number(p[_ + 1]) || s;
        w.forEach(function(O) {
          O.endTime = S;
        });
      });
    }
  }
}, createMetadataTrackIfNotExists = function r(e, t, a) {
  e.metadataTrack_ || (e.metadataTrack_ = a.addRemoteTextTrack({
    kind: "metadata",
    label: "Timed Metadata"
  }, !1).track, e.metadataTrack_.inBandMetadataTrackDispatchType = t);
}, removeCuesFromTrack = function r(e, t, a) {
  var n, s;
  if (!!a && !!a.cues)
    for (n = a.cues.length; n--; )
      s = a.cues[n], s.startTime >= e && s.endTime <= t && a.removeCue(s);
}, removeDuplicateCuesFromTrack = function r(e) {
  var t = e.cues;
  if (!!t)
    for (var a = 0; a < t.length; a++) {
      for (var n = [], s = 0, o = 0; o < t.length; o++)
        t[a].startTime === t[o].startTime && t[a].endTime === t[o].endTime && t[a].text === t[o].text && (s++, s > 1 && n.push(t[o]));
      n.length && n.forEach(function(u) {
        return e.removeCue(u);
      });
    }
}, gopsSafeToAlignWith = function r(e, t, a) {
  if (typeof t > "u" || t === null || !e.length)
    return [];
  var n = Math.ceil((t - a + 3) * clock.ONE_SECOND_IN_TS), s;
  for (s = 0; s < e.length && !(e[s].pts > n); s++)
    ;
  return e.slice(s);
}, updateGopBuffer = function r(e, t, a) {
  if (!t.length)
    return e;
  if (a)
    return t.slice();
  var n = t[0].pts, s = 0;
  for (s; s < e.length && !(e[s].pts >= n); s++)
    ;
  return e.slice(0, s).concat(t);
}, removeGopBuffer = function r(e, t, a, n) {
  for (var s = Math.ceil((t - n) * clock.ONE_SECOND_IN_TS), o = Math.ceil((a - n) * clock.ONE_SECOND_IN_TS), u = e.slice(), l = e.length; l-- && !(e[l].pts <= o); )
    ;
  if (l === -1)
    return u;
  for (var f = l + 1; f-- && !(e[f].pts <= s); )
    ;
  return f = Math.max(f, 0), u.splice(f, l - f + 1), u;
}, shallowEqual = function r(e, t) {
  if (!e && !t || !e && t || e && !t)
    return !1;
  if (e === t)
    return !0;
  var a = Object.keys(e).sort(), n = Object.keys(t).sort();
  if (a.length !== n.length)
    return !1;
  for (var s = 0; s < a.length; s++) {
    var o = a[s];
    if (o !== n[s] || e[o] !== t[o])
      return !1;
  }
  return !0;
}, QUOTA_EXCEEDED_ERR = 22, getSyncSegmentCandidate = function r(e, t, a) {
  t = t || [];
  for (var n = [], s = 0, o = 0; o < t.length; o++) {
    var u = t[o];
    if (e === u.timeline && (n.push(o), s += u.duration, s > a))
      return o;
  }
  return n.length === 0 ? 0 : n[n.length - 1];
}, MIN_BACK_BUFFER = 1, CHECK_BUFFER_DELAY = 500, finite = function r(e) {
  return typeof e == "number" && isFinite(e);
}, MIN_SEGMENT_DURATION_TO_SAVE_STATS = 1 / 60, illegalMediaSwitch = function r(e, t, a) {
  return e !== "main" || !t || !a ? null : !a.hasAudio && !a.hasVideo ? "Neither audio nor video found in segment." : t.hasVideo && !a.hasVideo ? "Only audio found in segment when we expected video. We can't switch to audio only from a stream that had video. To get rid of this message, please add codec information to the manifest." : !t.hasVideo && a.hasVideo ? "Video found in segment when we expected only audio. We can't switch to a stream with video from an audio only stream. To get rid of this message, please add codec information to the manifest." : null;
}, safeBackBufferTrimTime = function r(e, t, a) {
  var n = t - Config.BACK_BUFFER_LENGTH;
  e.length && (n = Math.max(n, e.start(0)));
  var s = t - a;
  return Math.min(s, n);
}, segmentInfoString = function r(e) {
  var t = e.startOfSegment, a = e.duration, n = e.segment, s = e.part, o = e.playlist, u = o.mediaSequence, l = o.id, f = o.segments, d = f === void 0 ? [] : f, h = e.mediaIndex, p = e.partIndex, m = e.timeline, _ = d.length - 1, w = "mediaIndex/partIndex increment";
  e.getMediaInfoForTime ? w = "getMediaInfoForTime (" + e.getMediaInfoForTime + ")" : e.isSyncRequest && (w = "getSyncSegmentCandidate (isSyncRequest)"), e.independent && (w += " with independent " + e.independent);
  var S = typeof p == "number", O = e.segment.uri ? "segment" : "pre-segment", k = S ? getKnownPartCount({
    preloadSegment: n
  }) - 1 : 0;
  return O + " [" + (u + h) + "/" + (u + _) + "]" + (S ? " part [" + p + "/" + k + "]" : "") + (" segment start/end [" + n.start + " => " + n.end + "]") + (S ? " part start/end [" + s.start + " => " + s.end + "]" : "") + (" startOfSegment [" + t + "]") + (" duration [" + a + "]") + (" timeline [" + m + "]") + (" selected by [" + w + "]") + (" playlist [" + l + "]");
}, timingInfoPropertyForMedia = function r(e) {
  return e + "TimingInfo";
}, timestampOffsetForSegment = function r(e) {
  var t = e.segmentTimeline, a = e.currentTimeline, n = e.startOfSegment, s = e.buffered, o = e.overrideCheck;
  return !o && t === a ? null : t < a ? n : s.length ? s.end(s.length - 1) : n;
}, shouldWaitForTimelineChange = function r(e) {
  var t = e.timelineChangeController, a = e.currentTimeline, n = e.segmentTimeline, s = e.loaderType, o = e.audioDisabled;
  if (a === n)
    return !1;
  if (s === "audio") {
    var u = t.lastTimelineChange({
      type: "main"
    });
    return !u || u.to !== n;
  }
  if (s === "main" && o) {
    var l = t.pendingTimelineChange({
      type: "audio"
    });
    return !(l && l.to === n);
  }
  return !1;
}, mediaDuration = function r(e) {
  var t = 0;
  return ["video", "audio"].forEach(function(a) {
    var n = e[a + "TimingInfo"];
    if (!!n) {
      var s = n.start, o = n.end, u;
      typeof s == "bigint" || typeof o == "bigint" ? u = window_1.BigInt(o) - window_1.BigInt(s) : typeof s == "number" && typeof o == "number" && (u = o - s), typeof u < "u" && u > t && (t = u);
    }
  }), typeof t == "bigint" && t < Number.MAX_SAFE_INTEGER && (t = Number(t)), t;
}, segmentTooLong = function r(e) {
  var t = e.segmentDuration, a = e.maxDuration;
  return t ? Math.round(t) > a + TIME_FUDGE_FACTOR : !1;
}, getTroublesomeSegmentDurationMessage = function r(e, t) {
  if (t !== "hls")
    return null;
  var a = mediaDuration({
    audioTimingInfo: e.audioTimingInfo,
    videoTimingInfo: e.videoTimingInfo
  });
  if (!a)
    return null;
  var n = e.playlist.targetDuration, s = segmentTooLong({
    segmentDuration: a,
    maxDuration: n * 2
  }), o = segmentTooLong({
    segmentDuration: a,
    maxDuration: n
  }), u = "Segment with index " + e.mediaIndex + " " + ("from playlist " + e.playlist.id + " ") + ("has a duration of " + a + " ") + ("when the reported duration is " + e.duration + " ") + ("and the target duration is " + n + ". ") + "For HLS content, a duration in excess of the target duration may result in playback issues. See the HLS specification section on EXT-X-TARGETDURATION for more details: https://tools.ietf.org/html/draft-pantos-http-live-streaming-23#section-4.3.3.1";
  return s || o ? {
    severity: s ? "warn" : "info",
    message: u
  } : null;
}, SegmentLoader = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    if (s = r.call(this) || this, !a)
      throw new TypeError("Initialization settings are required");
    if (typeof a.currentTime != "function")
      throw new TypeError("No currentTime getter specified");
    if (!a.mediaSource)
      throw new TypeError("No MediaSource specified");
    return s.bandwidth = a.bandwidth, s.throughput = {
      rate: 0,
      count: 0
    }, s.roundTrip = NaN, s.resetStats_(), s.mediaIndex = null, s.partIndex = null, s.hasPlayed_ = a.hasPlayed, s.currentTime_ = a.currentTime, s.seekable_ = a.seekable, s.seeking_ = a.seeking, s.duration_ = a.duration, s.mediaSource_ = a.mediaSource, s.vhs_ = a.vhs, s.loaderType_ = a.loaderType, s.currentMediaInfo_ = void 0, s.startingMediaInfo_ = void 0, s.segmentMetadataTrack_ = a.segmentMetadataTrack, s.goalBufferLength_ = a.goalBufferLength, s.sourceType_ = a.sourceType, s.sourceUpdater_ = a.sourceUpdater, s.inbandTextTracks_ = a.inbandTextTracks, s.state_ = "INIT", s.timelineChangeController_ = a.timelineChangeController, s.shouldSaveSegmentTimingInfo_ = !0, s.parse708captions_ = a.parse708captions, s.useDtsForTimestampOffset_ = a.useDtsForTimestampOffset, s.captionServices_ = a.captionServices, s.experimentalExactManifestTimings = a.experimentalExactManifestTimings, s.checkBufferTimeout_ = null, s.error_ = void 0, s.currentTimeline_ = -1, s.pendingSegment_ = null, s.xhrOptions_ = null, s.pendingSegments_ = [], s.audioDisabled_ = !1, s.isPendingTimestampOffset_ = !1, s.gopBuffer_ = [], s.timeMapping_ = 0, s.safeAppend_ = videojs.browser.IE_VERSION >= 11, s.appendInitSegment_ = {
      audio: !0,
      video: !0
    }, s.playlistOfLastInitSegment_ = {
      audio: null,
      video: null
    }, s.callQueue_ = [], s.loadQueue_ = [], s.metadataQueue_ = {
      id3: [],
      caption: []
    }, s.waitingOnRemove_ = !1, s.quotaExceededErrorRetryTimeout_ = null, s.activeInitSegmentId_ = null, s.initSegments_ = {}, s.cacheEncryptionKeys_ = a.cacheEncryptionKeys, s.keyCache_ = {}, s.decrypter_ = a.decrypter, s.syncController_ = a.syncController, s.syncPoint_ = {
      segmentIndex: 0,
      time: 0
    }, s.transmuxer_ = s.createTransmuxer_(), s.triggerSyncInfoUpdate_ = function() {
      return s.trigger("syncinfoupdate");
    }, s.syncController_.on("syncinfoupdate", s.triggerSyncInfoUpdate_), s.mediaSource_.addEventListener("sourceopen", function() {
      s.isEndOfStream_() || (s.ended_ = !1);
    }), s.fetchAtBuffer_ = !1, s.logger_ = logger("SegmentLoader[" + s.loaderType_ + "]"), Object.defineProperty(_assertThisInitialized$1(s), "state", {
      get: function() {
        return this.state_;
      },
      set: function(u) {
        u !== this.state_ && (this.logger_(this.state_ + " -> " + u), this.state_ = u, this.trigger("statechange"));
      }
    }), s.sourceUpdater_.on("ready", function() {
      s.hasEnoughInfoToAppend_() && s.processCallQueue_();
    }), s.loaderType_ === "main" && s.timelineChangeController_.on("pendingtimelinechange", function() {
      s.hasEnoughInfoToAppend_() && s.processCallQueue_();
    }), s.loaderType_ === "audio" && s.timelineChangeController_.on("timelinechange", function() {
      s.hasEnoughInfoToLoad_() && s.processLoadQueue_(), s.hasEnoughInfoToAppend_() && s.processCallQueue_();
    }), s;
  }
  var t = e.prototype;
  return t.createTransmuxer_ = function() {
    return segmentTransmuxer.createTransmuxer({
      remux: !1,
      alignGopsAtEnd: this.safeAppend_,
      keepOriginalTimestamps: !0,
      parse708captions: this.parse708captions_,
      captionServices: this.captionServices_
    });
  }, t.resetStats_ = function() {
    this.mediaBytesTransferred = 0, this.mediaRequests = 0, this.mediaRequestsAborted = 0, this.mediaRequestsTimedout = 0, this.mediaRequestsErrored = 0, this.mediaTransferDuration = 0, this.mediaSecondsLoaded = 0, this.mediaAppends = 0;
  }, t.dispose = function() {
    this.trigger("dispose"), this.state = "DISPOSED", this.pause(), this.abort_(), this.transmuxer_ && this.transmuxer_.terminate(), this.resetStats_(), this.checkBufferTimeout_ && window_1.clearTimeout(this.checkBufferTimeout_), this.syncController_ && this.triggerSyncInfoUpdate_ && this.syncController_.off("syncinfoupdate", this.triggerSyncInfoUpdate_), this.off();
  }, t.setAudio = function(n) {
    this.audioDisabled_ = !n, n ? this.appendInitSegment_.audio = !0 : this.sourceUpdater_.removeAudio(0, this.duration_());
  }, t.abort = function() {
    if (this.state !== "WAITING") {
      this.pendingSegment_ && (this.pendingSegment_ = null);
      return;
    }
    this.abort_(), this.state = "READY", this.paused() || this.monitorBuffer_();
  }, t.abort_ = function() {
    this.pendingSegment_ && this.pendingSegment_.abortRequests && this.pendingSegment_.abortRequests(), this.pendingSegment_ = null, this.callQueue_ = [], this.loadQueue_ = [], this.metadataQueue_.id3 = [], this.metadataQueue_.caption = [], this.timelineChangeController_.clearPendingTimelineChange(this.loaderType_), this.waitingOnRemove_ = !1, window_1.clearTimeout(this.quotaExceededErrorRetryTimeout_), this.quotaExceededErrorRetryTimeout_ = null;
  }, t.checkForAbort_ = function(n) {
    return this.state === "APPENDING" && !this.pendingSegment_ ? (this.state = "READY", !0) : !this.pendingSegment_ || this.pendingSegment_.requestId !== n;
  }, t.error = function(n) {
    return typeof n < "u" && (this.logger_("error occurred:", n), this.error_ = n), this.pendingSegment_ = null, this.error_;
  }, t.endOfStream = function() {
    this.ended_ = !0, this.transmuxer_ && segmentTransmuxer.reset(this.transmuxer_), this.gopBuffer_.length = 0, this.pause(), this.trigger("ended");
  }, t.buffered_ = function() {
    var n = this.getMediaInfo_();
    if (!this.sourceUpdater_ || !n)
      return videojs.createTimeRanges();
    if (this.loaderType_ === "main") {
      var s = n.hasAudio, o = n.hasVideo, u = n.isMuxed;
      if (o && s && !this.audioDisabled_ && !u)
        return this.sourceUpdater_.buffered();
      if (o)
        return this.sourceUpdater_.videoBuffered();
    }
    return this.sourceUpdater_.audioBuffered();
  }, t.initSegmentForMap = function(n, s) {
    if (s === void 0 && (s = !1), !n)
      return null;
    var o = initSegmentId(n), u = this.initSegments_[o];
    return s && !u && n.bytes && (this.initSegments_[o] = u = {
      resolvedUri: n.resolvedUri,
      byterange: n.byterange,
      bytes: n.bytes,
      tracks: n.tracks,
      timescales: n.timescales
    }), u || n;
  }, t.segmentKey = function(n, s) {
    if (s === void 0 && (s = !1), !n)
      return null;
    var o = segmentKeyId(n), u = this.keyCache_[o];
    this.cacheEncryptionKeys_ && s && !u && n.bytes && (this.keyCache_[o] = u = {
      resolvedUri: n.resolvedUri,
      bytes: n.bytes
    });
    var l = {
      resolvedUri: (u || n).resolvedUri
    };
    return u && (l.bytes = u.bytes), l;
  }, t.couldBeginLoading_ = function() {
    return this.playlist_ && !this.paused();
  }, t.load = function() {
    if (this.monitorBuffer_(), !!this.playlist_) {
      if (this.state === "INIT" && this.couldBeginLoading_())
        return this.init_();
      !this.couldBeginLoading_() || this.state !== "READY" && this.state !== "INIT" || (this.state = "READY");
    }
  }, t.init_ = function() {
    return this.state = "READY", this.resetEverything(), this.monitorBuffer_();
  }, t.playlist = function(n, s) {
    if (s === void 0 && (s = {}), !!n) {
      var o = this.playlist_, u = this.pendingSegment_;
      this.playlist_ = n, this.xhrOptions_ = s, this.state === "INIT" && (n.syncInfo = {
        mediaSequence: n.mediaSequence,
        time: 0
      }, this.loaderType_ === "main" && this.syncController_.setDateTimeMappingForStart(n));
      var l = null;
      if (o && (o.id ? l = o.id : o.uri && (l = o.uri)), this.logger_("playlist update [" + l + " => " + (n.id || n.uri) + "]"), this.trigger("syncinfoupdate"), this.state === "INIT" && this.couldBeginLoading_())
        return this.init_();
      if (!o || o.uri !== n.uri) {
        this.mediaIndex !== null && (n.endList ? this.resyncLoader() : this.resetLoader()), this.currentMediaInfo_ = void 0, this.trigger("playlistupdate");
        return;
      }
      var f = n.mediaSequence - o.mediaSequence;
      if (this.logger_("live window shift [" + f + "]"), this.mediaIndex !== null)
        if (this.mediaIndex -= f, this.mediaIndex < 0)
          this.mediaIndex = null, this.partIndex = null;
        else {
          var d = this.playlist_.segments[this.mediaIndex];
          if (this.partIndex && (!d.parts || !d.parts.length || !d.parts[this.partIndex])) {
            var h = this.mediaIndex;
            this.logger_("currently processing part (index " + this.partIndex + ") no longer exists."), this.resetLoader(), this.mediaIndex = h;
          }
        }
      u && (u.mediaIndex -= f, u.mediaIndex < 0 ? (u.mediaIndex = null, u.partIndex = null) : (u.mediaIndex >= 0 && (u.segment = n.segments[u.mediaIndex]), u.partIndex >= 0 && u.segment.parts && (u.part = u.segment.parts[u.partIndex]))), this.syncController_.saveExpiredSegmentInfo(o, n);
    }
  }, t.pause = function() {
    this.checkBufferTimeout_ && (window_1.clearTimeout(this.checkBufferTimeout_), this.checkBufferTimeout_ = null);
  }, t.paused = function() {
    return this.checkBufferTimeout_ === null;
  }, t.resetEverything = function(n) {
    this.ended_ = !1, this.appendInitSegment_ = {
      audio: !0,
      video: !0
    }, this.resetLoader(), this.remove(0, 1 / 0, n), this.transmuxer_ && (this.transmuxer_.postMessage({
      action: "clearAllMp4Captions"
    }), this.transmuxer_.postMessage({
      action: "reset"
    }));
  }, t.resetLoader = function() {
    this.fetchAtBuffer_ = !1, this.resyncLoader();
  }, t.resyncLoader = function() {
    this.transmuxer_ && segmentTransmuxer.reset(this.transmuxer_), this.mediaIndex = null, this.partIndex = null, this.syncPoint_ = null, this.isPendingTimestampOffset_ = !1, this.callQueue_ = [], this.loadQueue_ = [], this.metadataQueue_.id3 = [], this.metadataQueue_.caption = [], this.abort(), this.transmuxer_ && this.transmuxer_.postMessage({
      action: "clearParsedMp4Captions"
    });
  }, t.remove = function(n, s, o, u) {
    if (o === void 0 && (o = function() {
    }), u === void 0 && (u = !1), s === 1 / 0 && (s = this.duration_()), s <= n) {
      this.logger_("skipping remove because end ${end} is <= start ${start}");
      return;
    }
    if (!this.sourceUpdater_ || !this.getMediaInfo_()) {
      this.logger_("skipping remove because no source updater or starting media info");
      return;
    }
    var l = 1, f = function() {
      l--, l === 0 && o();
    };
    (u || !this.audioDisabled_) && (l++, this.sourceUpdater_.removeAudio(n, s, f)), (u || this.loaderType_ === "main") && (this.gopBuffer_ = removeGopBuffer(this.gopBuffer_, n, s, this.timeMapping_), l++, this.sourceUpdater_.removeVideo(n, s, f));
    for (var d in this.inbandTextTracks_)
      removeCuesFromTrack(n, s, this.inbandTextTracks_[d]);
    removeCuesFromTrack(n, s, this.segmentMetadataTrack_), f();
  }, t.monitorBuffer_ = function() {
    this.checkBufferTimeout_ && window_1.clearTimeout(this.checkBufferTimeout_), this.checkBufferTimeout_ = window_1.setTimeout(this.monitorBufferTick_.bind(this), 1);
  }, t.monitorBufferTick_ = function() {
    this.state === "READY" && this.fillBuffer_(), this.checkBufferTimeout_ && window_1.clearTimeout(this.checkBufferTimeout_), this.checkBufferTimeout_ = window_1.setTimeout(this.monitorBufferTick_.bind(this), CHECK_BUFFER_DELAY);
  }, t.fillBuffer_ = function() {
    if (!this.sourceUpdater_.updating()) {
      var n = this.chooseNextRequest_();
      !n || (typeof n.timestampOffset == "number" && (this.isPendingTimestampOffset_ = !1, this.timelineChangeController_.pendingTimelineChange({
        type: this.loaderType_,
        from: this.currentTimeline_,
        to: n.timeline
      })), this.loadSegment_(n));
    }
  }, t.isEndOfStream_ = function(n, s, o) {
    if (n === void 0 && (n = this.mediaIndex), s === void 0 && (s = this.playlist_), o === void 0 && (o = this.partIndex), !s || !this.mediaSource_)
      return !1;
    var u = typeof n == "number" && s.segments[n], l = n + 1 === s.segments.length, f = !u || !u.parts || o + 1 === u.parts.length;
    return s.endList && this.mediaSource_.readyState === "open" && l && f;
  }, t.chooseNextRequest_ = function() {
    var n = this.buffered_(), s = lastBufferedEnd(n) || 0, o = timeAheadOf(n, this.currentTime_()), u = !this.hasPlayed_() && o >= 1, l = o >= this.goalBufferLength_(), f = this.playlist_.segments;
    if (!f.length || u || l)
      return null;
    this.syncPoint_ = this.syncPoint_ || this.syncController_.getSyncPoint(this.playlist_, this.duration_(), this.currentTimeline_, this.currentTime_());
    var d = {
      partIndex: null,
      mediaIndex: null,
      startOfSegment: null,
      playlist: this.playlist_,
      isSyncRequest: Boolean(!this.syncPoint_)
    };
    if (d.isSyncRequest)
      d.mediaIndex = getSyncSegmentCandidate(this.currentTimeline_, f, s);
    else if (this.mediaIndex !== null) {
      var h = f[this.mediaIndex], p = typeof this.partIndex == "number" ? this.partIndex : -1;
      d.startOfSegment = h.end ? h.end : s, h.parts && h.parts[p + 1] ? (d.mediaIndex = this.mediaIndex, d.partIndex = p + 1) : d.mediaIndex = this.mediaIndex + 1;
    } else {
      var m = Playlist.getMediaInfoForTime({
        experimentalExactManifestTimings: this.experimentalExactManifestTimings,
        playlist: this.playlist_,
        currentTime: this.fetchAtBuffer_ ? s : this.currentTime_(),
        startingPartIndex: this.syncPoint_.partIndex,
        startingSegmentIndex: this.syncPoint_.segmentIndex,
        startTime: this.syncPoint_.time
      }), _ = m.segmentIndex, w = m.startTime, S = m.partIndex;
      d.getMediaInfoForTime = this.fetchAtBuffer_ ? "bufferedEnd " + s : "currentTime " + this.currentTime_(), d.mediaIndex = _, d.startOfSegment = w, d.partIndex = S;
    }
    var O = f[d.mediaIndex], k = O && typeof d.partIndex == "number" && O.parts && O.parts[d.partIndex];
    if (!O || typeof d.partIndex == "number" && !k)
      return null;
    if (typeof d.partIndex != "number" && O.parts && (d.partIndex = 0, k = O.parts[0]), !o && k && !k.independent)
      if (d.partIndex === 0) {
        var B = f[d.mediaIndex - 1], L = B.parts && B.parts.length && B.parts[B.parts.length - 1];
        L && L.independent && (d.mediaIndex -= 1, d.partIndex = B.parts.length - 1, d.independent = "previous segment");
      } else
        O.parts[d.partIndex - 1].independent && (d.partIndex -= 1, d.independent = "previous part");
    var G = this.mediaSource_ && this.mediaSource_.readyState === "ended";
    return d.mediaIndex >= f.length - 1 && G && !this.seeking_() ? null : this.generateSegmentInfo_(d);
  }, t.generateSegmentInfo_ = function(n) {
    var s = n.independent, o = n.playlist, u = n.mediaIndex, l = n.startOfSegment, f = n.isSyncRequest, d = n.partIndex, h = n.forceTimestampOffset, p = n.getMediaInfoForTime, m = o.segments[u], _ = typeof d == "number" && m.parts[d], w = {
      requestId: "segment-loader-" + Math.random(),
      uri: _ && _.resolvedUri || m.resolvedUri,
      mediaIndex: u,
      partIndex: _ ? d : null,
      isSyncRequest: f,
      startOfSegment: l,
      playlist: o,
      bytes: null,
      encryptedBytes: null,
      timestampOffset: null,
      timeline: m.timeline,
      duration: _ && _.duration || m.duration,
      segment: m,
      part: _,
      byteLength: 0,
      transmuxer: this.transmuxer_,
      getMediaInfoForTime: p,
      independent: s
    }, S = typeof h < "u" ? h : this.isPendingTimestampOffset_;
    w.timestampOffset = this.timestampOffsetForSegment_({
      segmentTimeline: m.timeline,
      currentTimeline: this.currentTimeline_,
      startOfSegment: l,
      buffered: this.buffered_(),
      overrideCheck: S
    });
    var O = lastBufferedEnd(this.sourceUpdater_.audioBuffered());
    return typeof O == "number" && (w.audioAppendStart = O - this.sourceUpdater_.audioTimestampOffset()), this.sourceUpdater_.videoBuffered().length && (w.gopsToAlignWith = gopsSafeToAlignWith(
      this.gopBuffer_,
      this.currentTime_() - this.sourceUpdater_.videoTimestampOffset(),
      this.timeMapping_
    )), w;
  }, t.timestampOffsetForSegment_ = function(n) {
    return timestampOffsetForSegment(n);
  }, t.earlyAbortWhenNeeded_ = function(n) {
    if (!(this.vhs_.tech_.paused() || !this.xhrOptions_.timeout || !this.playlist_.attributes.BANDWIDTH) && !(Date.now() - (n.firstBytesReceivedAt || Date.now()) < 1e3)) {
      var s = this.currentTime_(), o = n.bandwidth, u = this.pendingSegment_.duration, l = Playlist.estimateSegmentRequestTime(u, o, this.playlist_, n.bytesReceived), f = timeUntilRebuffer(this.buffered_(), s, this.vhs_.tech_.playbackRate()) - 1;
      if (!(l <= f)) {
        var d = minRebufferMaxBandwidthSelector({
          master: this.vhs_.playlists.master,
          currentTime: s,
          bandwidth: o,
          duration: this.duration_(),
          segmentDuration: u,
          timeUntilRebuffer: f,
          currentTimeline: this.currentTimeline_,
          syncController: this.syncController_
        });
        if (!!d) {
          var h = l - f, p = h - d.rebufferingImpact, m = 0.5;
          f <= TIME_FUDGE_FACTOR && (m = 1), !(!d.playlist || d.playlist.uri === this.playlist_.uri || p < m) && (this.bandwidth = d.playlist.attributes.BANDWIDTH * Config.BANDWIDTH_VARIANCE + 1, this.trigger("earlyabort"));
        }
      }
    }
  }, t.handleAbort_ = function(n) {
    this.logger_("Aborting " + segmentInfoString(n)), this.mediaRequestsAborted += 1;
  }, t.handleProgress_ = function(n, s) {
    this.earlyAbortWhenNeeded_(s.stats), !this.checkForAbort_(s.requestId) && this.trigger("progress");
  }, t.handleTrackInfo_ = function(n, s) {
    this.earlyAbortWhenNeeded_(n.stats), !this.checkForAbort_(n.requestId) && (this.checkForIllegalMediaSwitch(s) || (s = s || {}, shallowEqual(this.currentMediaInfo_, s) || (this.appendInitSegment_ = {
      audio: !0,
      video: !0
    }, this.startingMediaInfo_ = s, this.currentMediaInfo_ = s, this.logger_("trackinfo update", s), this.trigger("trackinfo")), !this.checkForAbort_(n.requestId) && (this.pendingSegment_.trackInfo = s, this.hasEnoughInfoToAppend_() && this.processCallQueue_())));
  }, t.handleTimingInfo_ = function(n, s, o, u) {
    if (this.earlyAbortWhenNeeded_(n.stats), !this.checkForAbort_(n.requestId)) {
      var l = this.pendingSegment_, f = timingInfoPropertyForMedia(s);
      l[f] = l[f] || {}, l[f][o] = u, this.logger_("timinginfo: " + s + " - " + o + " - " + u), this.hasEnoughInfoToAppend_() && this.processCallQueue_();
    }
  }, t.handleCaptions_ = function(n, s) {
    var o = this;
    if (this.earlyAbortWhenNeeded_(n.stats), !this.checkForAbort_(n.requestId)) {
      if (s.length === 0) {
        this.logger_("SegmentLoader received no captions from a caption event");
        return;
      }
      var u = this.pendingSegment_;
      if (!u.hasAppendedData_) {
        this.metadataQueue_.caption.push(this.handleCaptions_.bind(this, n, s));
        return;
      }
      var l = this.sourceUpdater_.videoTimestampOffset() === null ? this.sourceUpdater_.audioTimestampOffset() : this.sourceUpdater_.videoTimestampOffset(), f = {};
      s.forEach(function(d) {
        f[d.stream] = f[d.stream] || {
          startTime: 1 / 0,
          captions: [],
          endTime: 0
        };
        var h = f[d.stream];
        h.startTime = Math.min(h.startTime, d.startTime + l), h.endTime = Math.max(h.endTime, d.endTime + l), h.captions.push(d);
      }), Object.keys(f).forEach(function(d) {
        var h = f[d], p = h.startTime, m = h.endTime, _ = h.captions, w = o.inbandTextTracks_;
        o.logger_("adding cues from " + p + " -> " + m + " for " + d), createCaptionsTrackIfNotExists(w, o.vhs_.tech_, d), removeCuesFromTrack(p, m, w[d]), addCaptionData({
          captionArray: _,
          inbandTextTracks: w,
          timestampOffset: l
        });
      }), this.transmuxer_ && this.transmuxer_.postMessage({
        action: "clearParsedMp4Captions"
      });
    }
  }, t.handleId3_ = function(n, s, o) {
    if (this.earlyAbortWhenNeeded_(n.stats), !this.checkForAbort_(n.requestId)) {
      var u = this.pendingSegment_;
      if (!u.hasAppendedData_) {
        this.metadataQueue_.id3.push(this.handleId3_.bind(this, n, s, o));
        return;
      }
      var l = this.sourceUpdater_.videoTimestampOffset() === null ? this.sourceUpdater_.audioTimestampOffset() : this.sourceUpdater_.videoTimestampOffset();
      createMetadataTrackIfNotExists(this.inbandTextTracks_, o, this.vhs_.tech_), addMetadata({
        inbandTextTracks: this.inbandTextTracks_,
        metadataArray: s,
        timestampOffset: l,
        videoDuration: this.duration_()
      });
    }
  }, t.processMetadataQueue_ = function() {
    this.metadataQueue_.id3.forEach(function(n) {
      return n();
    }), this.metadataQueue_.caption.forEach(function(n) {
      return n();
    }), this.metadataQueue_.id3 = [], this.metadataQueue_.caption = [];
  }, t.processCallQueue_ = function() {
    var n = this.callQueue_;
    this.callQueue_ = [], n.forEach(function(s) {
      return s();
    });
  }, t.processLoadQueue_ = function() {
    var n = this.loadQueue_;
    this.loadQueue_ = [], n.forEach(function(s) {
      return s();
    });
  }, t.hasEnoughInfoToLoad_ = function() {
    if (this.loaderType_ !== "audio")
      return !0;
    var n = this.pendingSegment_;
    return n ? this.getCurrentMediaInfo_() ? !shouldWaitForTimelineChange({
      timelineChangeController: this.timelineChangeController_,
      currentTimeline: this.currentTimeline_,
      segmentTimeline: n.timeline,
      loaderType: this.loaderType_,
      audioDisabled: this.audioDisabled_
    }) : !0 : !1;
  }, t.getCurrentMediaInfo_ = function(n) {
    return n === void 0 && (n = this.pendingSegment_), n && n.trackInfo || this.currentMediaInfo_;
  }, t.getMediaInfo_ = function(n) {
    return n === void 0 && (n = this.pendingSegment_), this.getCurrentMediaInfo_(n) || this.startingMediaInfo_;
  }, t.hasEnoughInfoToAppend_ = function() {
    if (!this.sourceUpdater_.ready() || this.waitingOnRemove_ || this.quotaExceededErrorRetryTimeout_)
      return !1;
    var n = this.pendingSegment_, s = this.getCurrentMediaInfo_();
    if (!n || !s)
      return !1;
    var o = s.hasAudio, u = s.hasVideo, l = s.isMuxed;
    return !(u && !n.videoTimingInfo || o && !this.audioDisabled_ && !l && !n.audioTimingInfo || shouldWaitForTimelineChange({
      timelineChangeController: this.timelineChangeController_,
      currentTimeline: this.currentTimeline_,
      segmentTimeline: n.timeline,
      loaderType: this.loaderType_,
      audioDisabled: this.audioDisabled_
    }));
  }, t.handleData_ = function(n, s) {
    if (this.earlyAbortWhenNeeded_(n.stats), !this.checkForAbort_(n.requestId)) {
      if (this.callQueue_.length || !this.hasEnoughInfoToAppend_()) {
        this.callQueue_.push(this.handleData_.bind(this, n, s));
        return;
      }
      var o = this.pendingSegment_;
      if (this.setTimeMapping_(o.timeline), this.updateMediaSecondsLoaded_(o.part || o.segment), this.mediaSource_.readyState !== "closed") {
        if (n.map && (n.map = this.initSegmentForMap(n.map, !0), o.segment.map = n.map), n.key && this.segmentKey(n.key, !0), o.isFmp4 = n.isFmp4, o.timingInfo = o.timingInfo || {}, o.isFmp4)
          this.trigger("fmp4"), o.timingInfo.start = o[timingInfoPropertyForMedia(s.type)].start;
        else {
          var u = this.getCurrentMediaInfo_(), l = this.loaderType_ === "main" && u && u.hasVideo, f;
          l && (f = o.videoTimingInfo.start), o.timingInfo.start = this.trueSegmentStart_({
            currentStart: o.timingInfo.start,
            playlist: o.playlist,
            mediaIndex: o.mediaIndex,
            currentVideoTimestampOffset: this.sourceUpdater_.videoTimestampOffset(),
            useVideoTimingInfo: l,
            firstVideoFrameTimeForData: f,
            videoTimingInfo: o.videoTimingInfo,
            audioTimingInfo: o.audioTimingInfo
          });
        }
        if (this.updateAppendInitSegmentStatus(o, s.type), this.updateSourceBufferTimestampOffset_(o), o.isSyncRequest) {
          this.updateTimingInfoEnd_(o), this.syncController_.saveSegmentTimingInfo({
            segmentInfo: o,
            shouldSaveTimelineMapping: this.loaderType_ === "main"
          });
          var d = this.chooseNextRequest_();
          if (d.mediaIndex !== o.mediaIndex || d.partIndex !== o.partIndex) {
            this.logger_("sync segment was incorrect, not appending");
            return;
          }
          this.logger_("sync segment was correct, appending");
        }
        o.hasAppendedData_ = !0, this.processMetadataQueue_(), this.appendData_(o, s);
      }
    }
  }, t.updateAppendInitSegmentStatus = function(n, s) {
    this.loaderType_ === "main" && typeof n.timestampOffset == "number" && !n.changedTimestampOffset && (this.appendInitSegment_ = {
      audio: !0,
      video: !0
    }), this.playlistOfLastInitSegment_[s] !== n.playlist && (this.appendInitSegment_[s] = !0);
  }, t.getInitSegmentAndUpdateState_ = function(n) {
    var s = n.type, o = n.initSegment, u = n.map, l = n.playlist;
    if (u) {
      var f = initSegmentId(u);
      if (this.activeInitSegmentId_ === f)
        return null;
      o = this.initSegmentForMap(u, !0).bytes, this.activeInitSegmentId_ = f;
    }
    return o && this.appendInitSegment_[s] ? (this.playlistOfLastInitSegment_[s] = l, this.appendInitSegment_[s] = !1, this.activeInitSegmentId_ = null, o) : null;
  }, t.handleQuotaExceededError_ = function(n, s) {
    var o = this, u = n.segmentInfo, l = n.type, f = n.bytes, d = this.sourceUpdater_.audioBuffered(), h = this.sourceUpdater_.videoBuffered();
    d.length > 1 && this.logger_("On QUOTA_EXCEEDED_ERR, found gaps in the audio buffer: " + timeRangesToArray(d).join(", ")), h.length > 1 && this.logger_("On QUOTA_EXCEEDED_ERR, found gaps in the video buffer: " + timeRangesToArray(h).join(", "));
    var p = d.length ? d.start(0) : 0, m = d.length ? d.end(d.length - 1) : 0, _ = h.length ? h.start(0) : 0, w = h.length ? h.end(h.length - 1) : 0;
    if (m - p <= MIN_BACK_BUFFER && w - _ <= MIN_BACK_BUFFER) {
      this.logger_("On QUOTA_EXCEEDED_ERR, single segment too large to append to buffer, triggering an error. " + ("Appended byte length: " + f.byteLength + ", ") + ("audio buffer: " + timeRangesToArray(d).join(", ") + ", ") + ("video buffer: " + timeRangesToArray(h).join(", ") + ", ")), this.error({
        message: "Quota exceeded error with append of a single segment of content",
        excludeUntil: 1 / 0
      }), this.trigger("error");
      return;
    }
    this.waitingOnRemove_ = !0, this.callQueue_.push(this.appendToSourceBuffer_.bind(this, {
      segmentInfo: u,
      type: l,
      bytes: f
    }));
    var S = this.currentTime_(), O = S - MIN_BACK_BUFFER;
    this.logger_("On QUOTA_EXCEEDED_ERR, removing audio/video from 0 to " + O), this.remove(0, O, function() {
      o.logger_("On QUOTA_EXCEEDED_ERR, retrying append in " + MIN_BACK_BUFFER + "s"), o.waitingOnRemove_ = !1, o.quotaExceededErrorRetryTimeout_ = window_1.setTimeout(function() {
        o.logger_("On QUOTA_EXCEEDED_ERR, re-processing call queue"), o.quotaExceededErrorRetryTimeout_ = null, o.processCallQueue_();
      }, MIN_BACK_BUFFER * 1e3);
    }, !0);
  }, t.handleAppendError_ = function(n, s) {
    var o = n.segmentInfo, u = n.type, l = n.bytes;
    if (!!s) {
      if (s.code === QUOTA_EXCEEDED_ERR) {
        this.handleQuotaExceededError_({
          segmentInfo: o,
          type: u,
          bytes: l
        });
        return;
      }
      this.logger_("Received non QUOTA_EXCEEDED_ERR on append", s), this.error(u + " append of " + l.length + "b failed for segment " + ("#" + o.mediaIndex + " in playlist " + o.playlist.id)), this.trigger("appenderror");
    }
  }, t.appendToSourceBuffer_ = function(n) {
    var s = n.segmentInfo, o = n.type, u = n.initSegment, l = n.data, f = n.bytes;
    if (!f) {
      var d = [l], h = l.byteLength;
      u && (d.unshift(u), h += u.byteLength), f = concatSegments({
        bytes: h,
        segments: d
      });
    }
    this.sourceUpdater_.appendBuffer({
      segmentInfo: s,
      type: o,
      bytes: f
    }, this.handleAppendError_.bind(this, {
      segmentInfo: s,
      type: o,
      bytes: f
    }));
  }, t.handleSegmentTimingInfo_ = function(n, s, o) {
    if (!(!this.pendingSegment_ || s !== this.pendingSegment_.requestId)) {
      var u = this.pendingSegment_.segment, l = n + "TimingInfo";
      u[l] || (u[l] = {}), u[l].transmuxerPrependedSeconds = o.prependedContentDuration || 0, u[l].transmuxedPresentationStart = o.start.presentation, u[l].transmuxedDecodeStart = o.start.decode, u[l].transmuxedPresentationEnd = o.end.presentation, u[l].transmuxedDecodeEnd = o.end.decode, u[l].baseMediaDecodeTime = o.baseMediaDecodeTime;
    }
  }, t.appendData_ = function(n, s) {
    var o = s.type, u = s.data;
    if (!(!u || !u.byteLength) && !(o === "audio" && this.audioDisabled_)) {
      var l = this.getInitSegmentAndUpdateState_({
        type: o,
        initSegment: s.initSegment,
        playlist: n.playlist,
        map: n.isFmp4 ? n.segment.map : null
      });
      this.appendToSourceBuffer_({
        segmentInfo: n,
        type: o,
        initSegment: l,
        data: u
      });
    }
  }, t.loadSegment_ = function(n) {
    var s = this;
    if (this.state = "WAITING", this.pendingSegment_ = n, this.trimBackBuffer_(n), typeof n.timestampOffset == "number" && this.transmuxer_ && this.transmuxer_.postMessage({
      action: "clearAllMp4Captions"
    }), !this.hasEnoughInfoToLoad_()) {
      this.loadQueue_.push(function() {
        var o = _extends$2({}, n, {
          forceTimestampOffset: !0
        });
        _extends$2(n, s.generateSegmentInfo_(o)), s.isPendingTimestampOffset_ = !1, s.updateTransmuxerAndRequestSegment_(n);
      });
      return;
    }
    this.updateTransmuxerAndRequestSegment_(n);
  }, t.updateTransmuxerAndRequestSegment_ = function(n) {
    var s = this;
    this.shouldUpdateTransmuxerTimestampOffset_(n.timestampOffset) && (this.gopBuffer_.length = 0, n.gopsToAlignWith = [], this.timeMapping_ = 0, this.transmuxer_.postMessage({
      action: "reset"
    }), this.transmuxer_.postMessage({
      action: "setTimestampOffset",
      timestampOffset: n.timestampOffset
    }));
    var o = this.createSimplifiedSegmentObj_(n), u = this.isEndOfStream_(n.mediaIndex, n.playlist, n.partIndex), l = this.mediaIndex !== null, f = n.timeline !== this.currentTimeline_ && n.timeline > 0, d = u || l && f;
    this.logger_("Requesting " + segmentInfoString(n)), o.map && !o.map.bytes && (this.logger_("going to request init segment."), this.appendInitSegment_ = {
      video: !0,
      audio: !0
    }), n.abortRequests = mediaSegmentRequest({
      xhr: this.vhs_.xhr,
      xhrOptions: this.xhrOptions_,
      decryptionWorker: this.decrypter_,
      segment: o,
      abortFn: this.handleAbort_.bind(this, n),
      progressFn: this.handleProgress_.bind(this),
      trackInfoFn: this.handleTrackInfo_.bind(this),
      timingInfoFn: this.handleTimingInfo_.bind(this),
      videoSegmentTimingInfoFn: this.handleSegmentTimingInfo_.bind(this, "video", n.requestId),
      audioSegmentTimingInfoFn: this.handleSegmentTimingInfo_.bind(this, "audio", n.requestId),
      captionsFn: this.handleCaptions_.bind(this),
      isEndOfTimeline: d,
      endedTimelineFn: function() {
        s.logger_("received endedtimeline callback");
      },
      id3Fn: this.handleId3_.bind(this),
      dataFn: this.handleData_.bind(this),
      doneFn: this.segmentRequestFinished_.bind(this),
      onTransmuxerLog: function(p) {
        var m = p.message, _ = p.level, w = p.stream;
        s.logger_(segmentInfoString(n) + " logged from transmuxer stream " + w + " as a " + _ + ": " + m);
      }
    });
  }, t.trimBackBuffer_ = function(n) {
    var s = safeBackBufferTrimTime(this.seekable_(), this.currentTime_(), this.playlist_.targetDuration || 10);
    s > 0 && this.remove(0, s);
  }, t.createSimplifiedSegmentObj_ = function(n) {
    var s = n.segment, o = n.part, u = {
      resolvedUri: o ? o.resolvedUri : s.resolvedUri,
      byterange: o ? o.byterange : s.byterange,
      requestId: n.requestId,
      transmuxer: n.transmuxer,
      audioAppendStart: n.audioAppendStart,
      gopsToAlignWith: n.gopsToAlignWith,
      part: n.part
    }, l = n.playlist.segments[n.mediaIndex - 1];
    if (l && l.timeline === s.timeline && (l.videoTimingInfo ? u.baseStartTime = l.videoTimingInfo.transmuxedDecodeEnd : l.audioTimingInfo && (u.baseStartTime = l.audioTimingInfo.transmuxedDecodeEnd)), s.key) {
      var f = s.key.iv || new Uint32Array([0, 0, 0, n.mediaIndex + n.playlist.mediaSequence]);
      u.key = this.segmentKey(s.key), u.key.iv = f;
    }
    return s.map && (u.map = this.initSegmentForMap(s.map)), u;
  }, t.saveTransferStats_ = function(n) {
    this.mediaRequests += 1, n && (this.mediaBytesTransferred += n.bytesReceived, this.mediaTransferDuration += n.roundTripTime);
  }, t.saveBandwidthRelatedStats_ = function(n, s) {
    if (this.pendingSegment_.byteLength = s.bytesReceived, n < MIN_SEGMENT_DURATION_TO_SAVE_STATS) {
      this.logger_("Ignoring segment's bandwidth because its duration of " + n + (" is less than the min to record " + MIN_SEGMENT_DURATION_TO_SAVE_STATS));
      return;
    }
    this.bandwidth = s.bandwidth, this.roundTrip = s.roundTripTime;
  }, t.handleTimeout_ = function() {
    this.mediaRequestsTimedout += 1, this.bandwidth = 1, this.roundTrip = NaN, this.trigger("bandwidthupdate");
  }, t.segmentRequestFinished_ = function(n, s, o) {
    if (this.callQueue_.length) {
      this.callQueue_.push(this.segmentRequestFinished_.bind(this, n, s, o));
      return;
    }
    if (this.saveTransferStats_(s.stats), !!this.pendingSegment_ && s.requestId === this.pendingSegment_.requestId) {
      if (n) {
        if (this.pendingSegment_ = null, this.state = "READY", n.code === REQUEST_ERRORS.ABORTED)
          return;
        if (this.pause(), n.code === REQUEST_ERRORS.TIMEOUT) {
          this.handleTimeout_();
          return;
        }
        this.mediaRequestsErrored += 1, this.error(n), this.trigger("error");
        return;
      }
      var u = this.pendingSegment_;
      this.saveBandwidthRelatedStats_(u.duration, s.stats), u.endOfAllRequests = s.endOfAllRequests, o.gopInfo && (this.gopBuffer_ = updateGopBuffer(this.gopBuffer_, o.gopInfo, this.safeAppend_)), this.state = "APPENDING", this.trigger("appending"), this.waitForAppendsToComplete_(u);
    }
  }, t.setTimeMapping_ = function(n) {
    var s = this.syncController_.mappingForTimeline(n);
    s !== null && (this.timeMapping_ = s);
  }, t.updateMediaSecondsLoaded_ = function(n) {
    typeof n.start == "number" && typeof n.end == "number" ? this.mediaSecondsLoaded += n.end - n.start : this.mediaSecondsLoaded += n.duration;
  }, t.shouldUpdateTransmuxerTimestampOffset_ = function(n) {
    return n === null ? !1 : this.loaderType_ === "main" && n !== this.sourceUpdater_.videoTimestampOffset() || !this.audioDisabled_ && n !== this.sourceUpdater_.audioTimestampOffset();
  }, t.trueSegmentStart_ = function(n) {
    var s = n.currentStart, o = n.playlist, u = n.mediaIndex, l = n.firstVideoFrameTimeForData, f = n.currentVideoTimestampOffset, d = n.useVideoTimingInfo, h = n.videoTimingInfo, p = n.audioTimingInfo;
    if (typeof s < "u")
      return s;
    if (!d)
      return p.start;
    var m = o.segments[u - 1];
    return u === 0 || !m || typeof m.start > "u" || m.end !== l + f ? l : h.start;
  }, t.waitForAppendsToComplete_ = function(n) {
    var s = this.getCurrentMediaInfo_(n);
    if (!s) {
      this.error({
        message: "No starting media returned, likely due to an unsupported media format.",
        blacklistDuration: 1 / 0
      }), this.trigger("error");
      return;
    }
    var o = s.hasAudio, u = s.hasVideo, l = s.isMuxed, f = this.loaderType_ === "main" && u, d = !this.audioDisabled_ && o && !l;
    if (n.waitingOnAppends = 0, !n.hasAppendedData_) {
      !n.timingInfo && typeof n.timestampOffset == "number" && (this.isPendingTimestampOffset_ = !0), n.timingInfo = {
        start: 0
      }, n.waitingOnAppends++, this.isPendingTimestampOffset_ || (this.updateSourceBufferTimestampOffset_(n), this.processMetadataQueue_()), this.checkAppendsDone_(n);
      return;
    }
    f && n.waitingOnAppends++, d && n.waitingOnAppends++, f && this.sourceUpdater_.videoQueueCallback(this.checkAppendsDone_.bind(this, n)), d && this.sourceUpdater_.audioQueueCallback(this.checkAppendsDone_.bind(this, n));
  }, t.checkAppendsDone_ = function(n) {
    this.checkForAbort_(n.requestId) || (n.waitingOnAppends--, n.waitingOnAppends === 0 && this.handleAppendsDone_());
  }, t.checkForIllegalMediaSwitch = function(n) {
    var s = illegalMediaSwitch(this.loaderType_, this.getCurrentMediaInfo_(), n);
    return s ? (this.error({
      message: s,
      blacklistDuration: 1 / 0
    }), this.trigger("error"), !0) : !1;
  }, t.updateSourceBufferTimestampOffset_ = function(n) {
    if (!(n.timestampOffset === null || typeof n.timingInfo.start != "number" || n.changedTimestampOffset || this.loaderType_ !== "main")) {
      var s = !1;
      n.timestampOffset -= this.getSegmentStartTimeForTimestampOffsetCalculation_({
        videoTimingInfo: n.segment.videoTimingInfo,
        audioTimingInfo: n.segment.audioTimingInfo,
        timingInfo: n.timingInfo
      }), n.changedTimestampOffset = !0, n.timestampOffset !== this.sourceUpdater_.videoTimestampOffset() && (this.sourceUpdater_.videoTimestampOffset(n.timestampOffset), s = !0), n.timestampOffset !== this.sourceUpdater_.audioTimestampOffset() && (this.sourceUpdater_.audioTimestampOffset(n.timestampOffset), s = !0), s && this.trigger("timestampoffset");
    }
  }, t.getSegmentStartTimeForTimestampOffsetCalculation_ = function(n) {
    var s = n.videoTimingInfo, o = n.audioTimingInfo, u = n.timingInfo;
    return this.useDtsForTimestampOffset_ ? s && typeof s.transmuxedDecodeStart == "number" ? s.transmuxedDecodeStart : o && typeof o.transmuxedDecodeStart == "number" ? o.transmuxedDecodeStart : u.start : u.start;
  }, t.updateTimingInfoEnd_ = function(n) {
    n.timingInfo = n.timingInfo || {};
    var s = this.getMediaInfo_(), o = this.loaderType_ === "main" && s && s.hasVideo, u = o && n.videoTimingInfo ? n.videoTimingInfo : n.audioTimingInfo;
    !u || (n.timingInfo.end = typeof u.end == "number" ? u.end : u.start + n.duration);
  }, t.handleAppendsDone_ = function() {
    if (this.pendingSegment_ && this.trigger("appendsdone"), !this.pendingSegment_) {
      this.state = "READY", this.paused() || this.monitorBuffer_();
      return;
    }
    var n = this.pendingSegment_;
    this.updateTimingInfoEnd_(n), this.shouldSaveSegmentTimingInfo_ && this.syncController_.saveSegmentTimingInfo({
      segmentInfo: n,
      shouldSaveTimelineMapping: this.loaderType_ === "main"
    });
    var s = getTroublesomeSegmentDurationMessage(n, this.sourceType_);
    if (s && (s.severity === "warn" ? videojs.log.warn(s.message) : this.logger_(s.message)), this.recordThroughput_(n), this.pendingSegment_ = null, this.state = "READY", n.isSyncRequest && (this.trigger("syncinfoupdate"), !n.hasAppendedData_)) {
      this.logger_("Throwing away un-appended sync request " + segmentInfoString(n));
      return;
    }
    this.logger_("Appended " + segmentInfoString(n)), this.addSegmentMetadataCue_(n), this.fetchAtBuffer_ = !0, this.currentTimeline_ !== n.timeline && (this.timelineChangeController_.lastTimelineChange({
      type: this.loaderType_,
      from: this.currentTimeline_,
      to: n.timeline
    }), this.loaderType_ === "main" && !this.audioDisabled_ && this.timelineChangeController_.lastTimelineChange({
      type: "audio",
      from: this.currentTimeline_,
      to: n.timeline
    })), this.currentTimeline_ = n.timeline, this.trigger("syncinfoupdate");
    var o = n.segment, u = n.part, l = o.end && this.currentTime_() - o.end > n.playlist.targetDuration * 3, f = u && u.end && this.currentTime_() - u.end > n.playlist.partTargetDuration * 3;
    if (l || f) {
      this.logger_("bad " + (l ? "segment" : "part") + " " + segmentInfoString(n)), this.resetEverything();
      return;
    }
    var d = this.mediaIndex !== null;
    d && this.trigger("bandwidthupdate"), this.trigger("progress"), this.mediaIndex = n.mediaIndex, this.partIndex = n.partIndex, this.isEndOfStream_(n.mediaIndex, n.playlist, n.partIndex) && this.endOfStream(), this.trigger("appended"), n.hasAppendedData_ && this.mediaAppends++, this.paused() || this.monitorBuffer_();
  }, t.recordThroughput_ = function(n) {
    if (n.duration < MIN_SEGMENT_DURATION_TO_SAVE_STATS) {
      this.logger_("Ignoring segment's throughput because its duration of " + n.duration + (" is less than the min to record " + MIN_SEGMENT_DURATION_TO_SAVE_STATS));
      return;
    }
    var s = this.throughput.rate, o = Date.now() - n.endOfAllRequests + 1, u = Math.floor(n.byteLength / o * 8 * 1e3);
    this.throughput.rate += (u - s) / ++this.throughput.count;
  }, t.addSegmentMetadataCue_ = function(n) {
    if (!!this.segmentMetadataTrack_) {
      var s = n.segment, o = s.start, u = s.end;
      if (!(!finite(o) || !finite(u))) {
        removeCuesFromTrack(o, u, this.segmentMetadataTrack_);
        var l = window_1.WebKitDataCue || window_1.VTTCue, f = {
          custom: s.custom,
          dateTimeObject: s.dateTimeObject,
          dateTimeString: s.dateTimeString,
          bandwidth: n.playlist.attributes.BANDWIDTH,
          resolution: n.playlist.attributes.RESOLUTION,
          codecs: n.playlist.attributes.CODECS,
          byteLength: n.byteLength,
          uri: n.uri,
          timeline: n.timeline,
          playlist: n.playlist.id,
          start: o,
          end: u
        }, d = JSON.stringify(f), h = new l(o, u, d);
        h.value = f, this.segmentMetadataTrack_.addCue(h);
      }
    }
  }, e;
}(videojs.EventTarget);
function noop() {
}
var toTitleCase = function r(e) {
  return typeof e != "string" ? e : e.replace(/./, function(t) {
    return t.toUpperCase();
  });
}, bufferTypes = ["video", "audio"], _updating = function r(e, t) {
  var a = t[e + "Buffer"];
  return a && a.updating || t.queuePending[e];
}, nextQueueIndexOfType = function r(e, t) {
  for (var a = 0; a < t.length; a++) {
    var n = t[a];
    if (n.type === "mediaSource")
      return null;
    if (n.type === e)
      return a;
  }
  return null;
}, shiftQueue = function r(e, t) {
  if (t.queue.length !== 0) {
    var a = 0, n = t.queue[a];
    if (n.type === "mediaSource") {
      !t.updating() && t.mediaSource.readyState !== "closed" && (t.queue.shift(), n.action(t), n.doneFn && n.doneFn(), r("audio", t), r("video", t));
      return;
    }
    if (e !== "mediaSource" && !(!t.ready() || t.mediaSource.readyState === "closed" || _updating(e, t))) {
      if (n.type !== e) {
        if (a = nextQueueIndexOfType(e, t.queue), a === null)
          return;
        n = t.queue[a];
      }
      if (t.queue.splice(a, 1), t.queuePending[e] = n, n.action(e, t), !n.doneFn) {
        t.queuePending[e] = null, r(e, t);
        return;
      }
    }
  }
}, cleanupBuffer = function r(e, t) {
  var a = t[e + "Buffer"], n = toTitleCase(e);
  !a || (a.removeEventListener("updateend", t["on" + n + "UpdateEnd_"]), a.removeEventListener("error", t["on" + n + "Error_"]), t.codecs[e] = null, t[e + "Buffer"] = null);
}, inSourceBuffers = function r(e, t) {
  return e && t && Array.prototype.indexOf.call(e.sourceBuffers, t) !== -1;
}, actions = {
  appendBuffer: function r(e, t, a) {
    return function(n, s) {
      var o = s[n + "Buffer"];
      if (!!inSourceBuffers(s.mediaSource, o)) {
        s.logger_("Appending segment " + t.mediaIndex + "'s " + e.length + " bytes to " + n + "Buffer");
        try {
          o.appendBuffer(e);
        } catch (u) {
          s.logger_("Error with code " + u.code + " " + (u.code === QUOTA_EXCEEDED_ERR ? "(QUOTA_EXCEEDED_ERR) " : "") + ("when appending segment " + t.mediaIndex + " to " + n + "Buffer")), s.queuePending[n] = null, a(u);
        }
      }
    };
  },
  remove: function r(e, t) {
    return function(a, n) {
      var s = n[a + "Buffer"];
      if (!!inSourceBuffers(n.mediaSource, s)) {
        n.logger_("Removing " + e + " to " + t + " from " + a + "Buffer");
        try {
          s.remove(e, t);
        } catch {
          n.logger_("Remove " + e + " to " + t + " from " + a + "Buffer failed");
        }
      }
    };
  },
  timestampOffset: function r(e) {
    return function(t, a) {
      var n = a[t + "Buffer"];
      !inSourceBuffers(a.mediaSource, n) || (a.logger_("Setting " + t + "timestampOffset to " + e), n.timestampOffset = e);
    };
  },
  callback: function r(e) {
    return function(t, a) {
      e();
    };
  },
  endOfStream: function r(e) {
    return function(t) {
      if (t.mediaSource.readyState === "open") {
        t.logger_("Calling mediaSource endOfStream(" + (e || "") + ")");
        try {
          t.mediaSource.endOfStream(e);
        } catch (a) {
          videojs.log.warn("Failed to call media source endOfStream", a);
        }
      }
    };
  },
  duration: function r(e) {
    return function(t) {
      t.logger_("Setting mediaSource duration to " + e);
      try {
        t.mediaSource.duration = e;
      } catch (a) {
        videojs.log.warn("Failed to set media source duration", a);
      }
    };
  },
  abort: function r() {
    return function(e, t) {
      if (t.mediaSource.readyState === "open") {
        var a = t[e + "Buffer"];
        if (!!inSourceBuffers(t.mediaSource, a)) {
          t.logger_("calling abort on " + e + "Buffer");
          try {
            a.abort();
          } catch (n) {
            videojs.log.warn("Failed to abort on " + e + "Buffer", n);
          }
        }
      }
    };
  },
  addSourceBuffer: function r(e, t) {
    return function(a) {
      var n = toTitleCase(e), s = getMimeForCodec(t);
      a.logger_("Adding " + e + "Buffer with codec " + t + " to mediaSource");
      var o = a.mediaSource.addSourceBuffer(s);
      o.addEventListener("updateend", a["on" + n + "UpdateEnd_"]), o.addEventListener("error", a["on" + n + "Error_"]), a.codecs[e] = t, a[e + "Buffer"] = o;
    };
  },
  removeSourceBuffer: function r(e) {
    return function(t) {
      var a = t[e + "Buffer"];
      if (cleanupBuffer(e, t), !!inSourceBuffers(t.mediaSource, a)) {
        t.logger_("Removing " + e + "Buffer with codec " + t.codecs[e] + " from mediaSource");
        try {
          t.mediaSource.removeSourceBuffer(a);
        } catch (n) {
          videojs.log.warn("Failed to removeSourceBuffer " + e + "Buffer", n);
        }
      }
    };
  },
  changeType: function r(e) {
    return function(t, a) {
      var n = a[t + "Buffer"], s = getMimeForCodec(e);
      !inSourceBuffers(a.mediaSource, n) || a.codecs[t] !== e && (a.logger_("changing " + t + "Buffer codec from " + a.codecs[t] + " to " + e), n.changeType(s), a.codecs[t] = e);
    };
  }
}, pushQueue = function r(e) {
  var t = e.type, a = e.sourceUpdater, n = e.action, s = e.doneFn, o = e.name;
  a.queue.push({
    type: t,
    action: n,
    doneFn: s,
    name: o
  }), shiftQueue(t, a);
}, onUpdateend = function r(e, t) {
  return function(a) {
    if (t.queuePending[e]) {
      var n = t.queuePending[e].doneFn;
      t.queuePending[e] = null, n && n(t[e + "Error_"]);
    }
    shiftQueue(e, t);
  };
}, SourceUpdater = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    return n = r.call(this) || this, n.mediaSource = a, n.sourceopenListener_ = function() {
      return shiftQueue("mediaSource", _assertThisInitialized$1(n));
    }, n.mediaSource.addEventListener("sourceopen", n.sourceopenListener_), n.logger_ = logger("SourceUpdater"), n.audioTimestampOffset_ = 0, n.videoTimestampOffset_ = 0, n.queue = [], n.queuePending = {
      audio: null,
      video: null
    }, n.delayedAudioAppendQueue_ = [], n.videoAppendQueued_ = !1, n.codecs = {}, n.onVideoUpdateEnd_ = onUpdateend("video", _assertThisInitialized$1(n)), n.onAudioUpdateEnd_ = onUpdateend("audio", _assertThisInitialized$1(n)), n.onVideoError_ = function(s) {
      n.videoError_ = s;
    }, n.onAudioError_ = function(s) {
      n.audioError_ = s;
    }, n.createdSourceBuffers_ = !1, n.initializedEme_ = !1, n.triggeredReady_ = !1, n;
  }
  var t = e.prototype;
  return t.initializedEme = function() {
    this.initializedEme_ = !0, this.triggerReady();
  }, t.hasCreatedSourceBuffers = function() {
    return this.createdSourceBuffers_;
  }, t.hasInitializedAnyEme = function() {
    return this.initializedEme_;
  }, t.ready = function() {
    return this.hasCreatedSourceBuffers() && this.hasInitializedAnyEme();
  }, t.createSourceBuffers = function(n) {
    this.hasCreatedSourceBuffers() || (this.addOrChangeSourceBuffers(n), this.createdSourceBuffers_ = !0, this.trigger("createdsourcebuffers"), this.triggerReady());
  }, t.triggerReady = function() {
    this.ready() && !this.triggeredReady_ && (this.triggeredReady_ = !0, this.trigger("ready"));
  }, t.addSourceBuffer = function(n, s) {
    pushQueue({
      type: "mediaSource",
      sourceUpdater: this,
      action: actions.addSourceBuffer(n, s),
      name: "addSourceBuffer"
    });
  }, t.abort = function(n) {
    pushQueue({
      type: n,
      sourceUpdater: this,
      action: actions.abort(n),
      name: "abort"
    });
  }, t.removeSourceBuffer = function(n) {
    if (!this.canRemoveSourceBuffer()) {
      videojs.log.error("removeSourceBuffer is not supported!");
      return;
    }
    pushQueue({
      type: "mediaSource",
      sourceUpdater: this,
      action: actions.removeSourceBuffer(n),
      name: "removeSourceBuffer"
    });
  }, t.canRemoveSourceBuffer = function() {
    return !videojs.browser.IE_VERSION && !videojs.browser.IS_FIREFOX && window_1.MediaSource && window_1.MediaSource.prototype && typeof window_1.MediaSource.prototype.removeSourceBuffer == "function";
  }, e.canChangeType = function() {
    return window_1.SourceBuffer && window_1.SourceBuffer.prototype && typeof window_1.SourceBuffer.prototype.changeType == "function";
  }, t.canChangeType = function() {
    return this.constructor.canChangeType();
  }, t.changeType = function(n, s) {
    if (!this.canChangeType()) {
      videojs.log.error("changeType is not supported!");
      return;
    }
    pushQueue({
      type: n,
      sourceUpdater: this,
      action: actions.changeType(s),
      name: "changeType"
    });
  }, t.addOrChangeSourceBuffers = function(n) {
    var s = this;
    if (!n || typeof n != "object" || Object.keys(n).length === 0)
      throw new Error("Cannot addOrChangeSourceBuffers to undefined codecs");
    Object.keys(n).forEach(function(o) {
      var u = n[o];
      if (!s.hasCreatedSourceBuffers())
        return s.addSourceBuffer(o, u);
      s.canChangeType() && s.changeType(o, u);
    });
  }, t.appendBuffer = function(n, s) {
    var o = this, u = n.segmentInfo, l = n.type, f = n.bytes;
    if (this.processedAppend_ = !0, l === "audio" && this.videoBuffer && !this.videoAppendQueued_) {
      this.delayedAudioAppendQueue_.push([n, s]), this.logger_("delayed audio append of " + f.length + " until video append");
      return;
    }
    var d = s;
    if (pushQueue({
      type: l,
      sourceUpdater: this,
      action: actions.appendBuffer(f, u || {
        mediaIndex: -1
      }, d),
      doneFn: s,
      name: "appendBuffer"
    }), l === "video") {
      if (this.videoAppendQueued_ = !0, !this.delayedAudioAppendQueue_.length)
        return;
      var h = this.delayedAudioAppendQueue_.slice();
      this.logger_("queuing delayed audio " + h.length + " appendBuffers"), this.delayedAudioAppendQueue_.length = 0, h.forEach(function(p) {
        o.appendBuffer.apply(o, p);
      });
    }
  }, t.audioBuffered = function() {
    return inSourceBuffers(this.mediaSource, this.audioBuffer) && this.audioBuffer.buffered ? this.audioBuffer.buffered : videojs.createTimeRange();
  }, t.videoBuffered = function() {
    return inSourceBuffers(this.mediaSource, this.videoBuffer) && this.videoBuffer.buffered ? this.videoBuffer.buffered : videojs.createTimeRange();
  }, t.buffered = function() {
    var n = inSourceBuffers(this.mediaSource, this.videoBuffer) ? this.videoBuffer : null, s = inSourceBuffers(this.mediaSource, this.audioBuffer) ? this.audioBuffer : null;
    return s && !n ? this.audioBuffered() : n && !s ? this.videoBuffered() : bufferIntersection(this.audioBuffered(), this.videoBuffered());
  }, t.setDuration = function(n, s) {
    s === void 0 && (s = noop), pushQueue({
      type: "mediaSource",
      sourceUpdater: this,
      action: actions.duration(n),
      name: "duration",
      doneFn: s
    });
  }, t.endOfStream = function(n, s) {
    n === void 0 && (n = null), s === void 0 && (s = noop), typeof n != "string" && (n = void 0), pushQueue({
      type: "mediaSource",
      sourceUpdater: this,
      action: actions.endOfStream(n),
      name: "endOfStream",
      doneFn: s
    });
  }, t.removeAudio = function(n, s, o) {
    if (o === void 0 && (o = noop), !this.audioBuffered().length || this.audioBuffered().end(0) === 0) {
      o();
      return;
    }
    pushQueue({
      type: "audio",
      sourceUpdater: this,
      action: actions.remove(n, s),
      doneFn: o,
      name: "remove"
    });
  }, t.removeVideo = function(n, s, o) {
    if (o === void 0 && (o = noop), !this.videoBuffered().length || this.videoBuffered().end(0) === 0) {
      o();
      return;
    }
    pushQueue({
      type: "video",
      sourceUpdater: this,
      action: actions.remove(n, s),
      doneFn: o,
      name: "remove"
    });
  }, t.updating = function() {
    return !!(_updating("audio", this) || _updating("video", this));
  }, t.audioTimestampOffset = function(n) {
    return typeof n < "u" && this.audioBuffer && this.audioTimestampOffset_ !== n && (pushQueue({
      type: "audio",
      sourceUpdater: this,
      action: actions.timestampOffset(n),
      name: "timestampOffset"
    }), this.audioTimestampOffset_ = n), this.audioTimestampOffset_;
  }, t.videoTimestampOffset = function(n) {
    return typeof n < "u" && this.videoBuffer && this.videoTimestampOffset !== n && (pushQueue({
      type: "video",
      sourceUpdater: this,
      action: actions.timestampOffset(n),
      name: "timestampOffset"
    }), this.videoTimestampOffset_ = n), this.videoTimestampOffset_;
  }, t.audioQueueCallback = function(n) {
    !this.audioBuffer || pushQueue({
      type: "audio",
      sourceUpdater: this,
      action: actions.callback(n),
      name: "callback"
    });
  }, t.videoQueueCallback = function(n) {
    !this.videoBuffer || pushQueue({
      type: "video",
      sourceUpdater: this,
      action: actions.callback(n),
      name: "callback"
    });
  }, t.dispose = function() {
    var n = this;
    this.trigger("dispose"), bufferTypes.forEach(function(s) {
      n.abort(s), n.canRemoveSourceBuffer() ? n.removeSourceBuffer(s) : n[s + "QueueCallback"](function() {
        return cleanupBuffer(s, n);
      });
    }), this.videoAppendQueued_ = !1, this.delayedAudioAppendQueue_.length = 0, this.sourceopenListener_ && this.mediaSource.removeEventListener("sourceopen", this.sourceopenListener_), this.off();
  }, e;
}(videojs.EventTarget), uint8ToUtf8 = function r(e) {
  return decodeURIComponent(escape(String.fromCharCode.apply(null, e)));
}, VTT_LINE_TERMINATORS = new Uint8Array(`

`.split("").map(function(r) {
  return r.charCodeAt(0);
})), VTTSegmentLoader = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n) {
    var s;
    return n === void 0 && (n = {}), s = r.call(this, a, n) || this, s.mediaSource_ = null, s.subtitlesTrack_ = null, s.loaderType_ = "subtitle", s.featuresNativeTextTracks_ = a.featuresNativeTextTracks, s.shouldSaveSegmentTimingInfo_ = !1, s;
  }
  var t = e.prototype;
  return t.createTransmuxer_ = function() {
    return null;
  }, t.buffered_ = function() {
    if (!this.subtitlesTrack_ || !this.subtitlesTrack_.cues || !this.subtitlesTrack_.cues.length)
      return videojs.createTimeRanges();
    var n = this.subtitlesTrack_.cues, s = n[0].startTime, o = n[n.length - 1].startTime;
    return videojs.createTimeRanges([[s, o]]);
  }, t.initSegmentForMap = function(n, s) {
    if (s === void 0 && (s = !1), !n)
      return null;
    var o = initSegmentId(n), u = this.initSegments_[o];
    if (s && !u && n.bytes) {
      var l = VTT_LINE_TERMINATORS.byteLength + n.bytes.byteLength, f = new Uint8Array(l);
      f.set(n.bytes), f.set(VTT_LINE_TERMINATORS, n.bytes.byteLength), this.initSegments_[o] = u = {
        resolvedUri: n.resolvedUri,
        byterange: n.byterange,
        bytes: f
      };
    }
    return u || n;
  }, t.couldBeginLoading_ = function() {
    return this.playlist_ && this.subtitlesTrack_ && !this.paused();
  }, t.init_ = function() {
    return this.state = "READY", this.resetEverything(), this.monitorBuffer_();
  }, t.track = function(n) {
    return typeof n > "u" ? this.subtitlesTrack_ : (this.subtitlesTrack_ = n, this.state === "INIT" && this.couldBeginLoading_() && this.init_(), this.subtitlesTrack_);
  }, t.remove = function(n, s) {
    removeCuesFromTrack(n, s, this.subtitlesTrack_);
  }, t.fillBuffer_ = function() {
    var n = this, s = this.chooseNextRequest_();
    if (!!s) {
      if (this.syncController_.timestampOffsetForTimeline(s.timeline) === null) {
        var o = function() {
          n.state = "READY", n.paused() || n.monitorBuffer_();
        };
        this.syncController_.one("timestampoffset", o), this.state = "WAITING_ON_TIMELINE";
        return;
      }
      this.loadSegment_(s);
    }
  }, t.timestampOffsetForSegment_ = function() {
    return null;
  }, t.chooseNextRequest_ = function() {
    return this.skipEmptySegments_(r.prototype.chooseNextRequest_.call(this));
  }, t.skipEmptySegments_ = function(n) {
    for (; n && n.segment.empty; ) {
      if (n.mediaIndex + 1 >= n.playlist.segments.length) {
        n = null;
        break;
      }
      n = this.generateSegmentInfo_({
        playlist: n.playlist,
        mediaIndex: n.mediaIndex + 1,
        startOfSegment: n.startOfSegment + n.duration,
        isSyncRequest: n.isSyncRequest
      });
    }
    return n;
  }, t.stopForError = function(n) {
    this.error(n), this.state = "READY", this.pause(), this.trigger("error");
  }, t.segmentRequestFinished_ = function(n, s, o) {
    var u = this;
    if (!this.subtitlesTrack_) {
      this.state = "READY";
      return;
    }
    if (this.saveTransferStats_(s.stats), !this.pendingSegment_) {
      this.state = "READY", this.mediaRequestsAborted += 1;
      return;
    }
    if (n) {
      n.code === REQUEST_ERRORS.TIMEOUT && this.handleTimeout_(), n.code === REQUEST_ERRORS.ABORTED ? this.mediaRequestsAborted += 1 : this.mediaRequestsErrored += 1, this.stopForError(n);
      return;
    }
    var l = this.pendingSegment_;
    this.saveBandwidthRelatedStats_(l.duration, s.stats), this.state = "APPENDING", this.trigger("appending");
    var f = l.segment;
    if (f.map && (f.map.bytes = s.map.bytes), l.bytes = s.bytes, typeof window_1.WebVTT != "function" && this.subtitlesTrack_ && this.subtitlesTrack_.tech_) {
      var d, h = function() {
        u.subtitlesTrack_.tech_.off("vttjsloaded", d), u.stopForError({
          message: "Error loading vtt.js"
        });
      };
      d = function() {
        u.subtitlesTrack_.tech_.off("vttjserror", h), u.segmentRequestFinished_(n, s, o);
      }, this.state = "WAITING_ON_VTTJS", this.subtitlesTrack_.tech_.one("vttjsloaded", d), this.subtitlesTrack_.tech_.one("vttjserror", h);
      return;
    }
    f.requested = !0;
    try {
      this.parseVTTCues_(l);
    } catch (p) {
      this.stopForError({
        message: p.message
      });
      return;
    }
    if (this.updateTimeMapping_(l, this.syncController_.timelines[l.timeline], this.playlist_), l.cues.length ? l.timingInfo = {
      start: l.cues[0].startTime,
      end: l.cues[l.cues.length - 1].endTime
    } : l.timingInfo = {
      start: l.startOfSegment,
      end: l.startOfSegment + l.duration
    }, l.isSyncRequest) {
      this.trigger("syncinfoupdate"), this.pendingSegment_ = null, this.state = "READY";
      return;
    }
    l.byteLength = l.bytes.byteLength, this.mediaSecondsLoaded += f.duration, l.cues.forEach(function(p) {
      u.subtitlesTrack_.addCue(u.featuresNativeTextTracks_ ? new window_1.VTTCue(p.startTime, p.endTime, p.text) : p);
    }), removeDuplicateCuesFromTrack(this.subtitlesTrack_), this.handleAppendsDone_();
  }, t.handleData_ = function() {
  }, t.updateTimingInfoEnd_ = function() {
  }, t.parseVTTCues_ = function(n) {
    var s, o = !1;
    typeof window_1.TextDecoder == "function" ? s = new window_1.TextDecoder("utf8") : (s = window_1.WebVTT.StringDecoder(), o = !0);
    var u = new window_1.WebVTT.Parser(window_1, window_1.vttjs, s);
    if (n.cues = [], n.timestampmap = {
      MPEGTS: 0,
      LOCAL: 0
    }, u.oncue = n.cues.push.bind(n.cues), u.ontimestampmap = function(d) {
      n.timestampmap = d;
    }, u.onparsingerror = function(d) {
      videojs.log.warn("Error encountered when parsing cues: " + d.message);
    }, n.segment.map) {
      var l = n.segment.map.bytes;
      o && (l = uint8ToUtf8(l)), u.parse(l);
    }
    var f = n.bytes;
    o && (f = uint8ToUtf8(f)), u.parse(f), u.flush();
  }, t.updateTimeMapping_ = function(n, s, o) {
    var u = n.segment;
    if (!!s) {
      if (!n.cues.length) {
        u.empty = !0;
        return;
      }
      var l = n.timestampmap, f = l.MPEGTS / clock.ONE_SECOND_IN_TS - l.LOCAL + s.mapping;
      if (n.cues.forEach(function(p) {
        p.startTime += f, p.endTime += f;
      }), !o.syncInfo) {
        var d = n.cues[0].startTime, h = n.cues[n.cues.length - 1].startTime;
        o.syncInfo = {
          mediaSequence: o.mediaSequence + n.mediaIndex,
          time: Math.min(d, h - u.duration)
        };
      }
    }
  }, e;
}(SegmentLoader), findAdCue = function r(e, t) {
  for (var a = e.cues, n = 0; n < a.length; n++) {
    var s = a[n];
    if (t >= s.adStartTime && t <= s.adEndTime)
      return s;
  }
  return null;
}, updateAdCues = function r(e, t, a) {
  if (a === void 0 && (a = 0), !!e.segments)
    for (var n = a, s, o = 0; o < e.segments.length; o++) {
      var u = e.segments[o];
      if (s || (s = findAdCue(t, n + u.duration / 2)), s) {
        if ("cueIn" in u) {
          s.endTime = n, s.adEndTime = n, n += u.duration, s = null;
          continue;
        }
        if (n < s.endTime) {
          n += u.duration;
          continue;
        }
        s.endTime += u.duration;
      } else if ("cueOut" in u && (s = new window_1.VTTCue(n, n + u.duration, u.cueOut), s.adStartTime = n, s.adEndTime = n + parseFloat(u.cueOut), t.addCue(s)), "cueOutCont" in u) {
        var l = u.cueOutCont.split("/").map(parseFloat), f = l[0], d = l[1];
        s = new window_1.VTTCue(n, n + u.duration, ""), s.adStartTime = n - f, s.adEndTime = s.adStartTime + d, t.addCue(s);
      }
      n += u.duration;
    }
}, MAX_MEDIA_SEQUENCE_DIFF_FOR_SYNC = 86400, syncPointStrategies = [
  {
    name: "VOD",
    run: function r(e, t, a, n, s) {
      if (a !== 1 / 0) {
        var o = {
          time: 0,
          segmentIndex: 0,
          partIndex: null
        };
        return o;
      }
      return null;
    }
  },
  {
    name: "ProgramDateTime",
    run: function r(e, t, a, n, s) {
      if (!Object.keys(e.timelineToDatetimeMappings).length)
        return null;
      var o = null, u = null, l = getPartsAndSegments(t);
      s = s || 0;
      for (var f = 0; f < l.length; f++) {
        var d = t.endList || s === 0 ? f : l.length - (f + 1), h = l[d], p = h.segment, m = e.timelineToDatetimeMappings[p.timeline];
        if (!(!m || !p.dateTimeObject)) {
          var _ = p.dateTimeObject.getTime() / 1e3, w = _ + m;
          if (p.parts && typeof h.partIndex == "number")
            for (var S = 0; S < h.partIndex; S++)
              w += p.parts[S].duration;
          var O = Math.abs(s - w);
          if (u !== null && (O === 0 || u < O))
            break;
          u = O, o = {
            time: w,
            segmentIndex: h.segmentIndex,
            partIndex: h.partIndex
          };
        }
      }
      return o;
    }
  },
  {
    name: "Segment",
    run: function r(e, t, a, n, s) {
      var o = null, u = null;
      s = s || 0;
      for (var l = getPartsAndSegments(t), f = 0; f < l.length; f++) {
        var d = t.endList || s === 0 ? f : l.length - (f + 1), h = l[d], p = h.segment, m = h.part && h.part.start || p && p.start;
        if (p.timeline === n && typeof m < "u") {
          var _ = Math.abs(s - m);
          if (u !== null && u < _)
            break;
          (!o || u === null || u >= _) && (u = _, o = {
            time: m,
            segmentIndex: h.segmentIndex,
            partIndex: h.partIndex
          });
        }
      }
      return o;
    }
  },
  {
    name: "Discontinuity",
    run: function r(e, t, a, n, s) {
      var o = null;
      if (s = s || 0, t.discontinuityStarts && t.discontinuityStarts.length)
        for (var u = null, l = 0; l < t.discontinuityStarts.length; l++) {
          var f = t.discontinuityStarts[l], d = t.discontinuitySequence + l + 1, h = e.discontinuities[d];
          if (h) {
            var p = Math.abs(s - h.time);
            if (u !== null && u < p)
              break;
            (!o || u === null || u >= p) && (u = p, o = {
              time: h.time,
              segmentIndex: f,
              partIndex: null
            });
          }
        }
      return o;
    }
  },
  {
    name: "Playlist",
    run: function r(e, t, a, n, s) {
      if (t.syncInfo) {
        var o = {
          time: t.syncInfo.time,
          segmentIndex: t.syncInfo.mediaSequence - t.mediaSequence,
          partIndex: null
        };
        return o;
      }
      return null;
    }
  }
], SyncController = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    return n = r.call(this) || this, n.timelines = [], n.discontinuities = [], n.timelineToDatetimeMappings = {}, n.logger_ = logger("SyncController"), n;
  }
  var t = e.prototype;
  return t.getSyncPoint = function(n, s, o, u) {
    var l = this.runStrategies_(n, s, o, u);
    return l.length ? this.selectSyncPoint_(l, {
      key: "time",
      value: u
    }) : null;
  }, t.getExpiredTime = function(n, s) {
    if (!n || !n.segments)
      return null;
    var o = this.runStrategies_(n, s, n.discontinuitySequence, 0);
    if (!o.length)
      return null;
    var u = this.selectSyncPoint_(o, {
      key: "segmentIndex",
      value: 0
    });
    return u.segmentIndex > 0 && (u.time *= -1), Math.abs(u.time + sumDurations({
      defaultDuration: n.targetDuration,
      durationList: n.segments,
      startIndex: u.segmentIndex,
      endIndex: 0
    }));
  }, t.runStrategies_ = function(n, s, o, u) {
    for (var l = [], f = 0; f < syncPointStrategies.length; f++) {
      var d = syncPointStrategies[f], h = d.run(this, n, s, o, u);
      h && (h.strategy = d.name, l.push({
        strategy: d.name,
        syncPoint: h
      }));
    }
    return l;
  }, t.selectSyncPoint_ = function(n, s) {
    for (var o = n[0].syncPoint, u = Math.abs(n[0].syncPoint[s.key] - s.value), l = n[0].strategy, f = 1; f < n.length; f++) {
      var d = Math.abs(n[f].syncPoint[s.key] - s.value);
      d < u && (u = d, o = n[f].syncPoint, l = n[f].strategy);
    }
    return this.logger_("syncPoint for [" + s.key + ": " + s.value + "] chosen with strategy" + (" [" + l + "]: [time:" + o.time + ",") + (" segmentIndex:" + o.segmentIndex) + (typeof o.partIndex == "number" ? ",partIndex:" + o.partIndex : "") + "]"), o;
  }, t.saveExpiredSegmentInfo = function(n, s) {
    var o = s.mediaSequence - n.mediaSequence;
    if (o > MAX_MEDIA_SEQUENCE_DIFF_FOR_SYNC) {
      videojs.log.warn("Not saving expired segment info. Media sequence gap " + o + " is too large.");
      return;
    }
    for (var u = o - 1; u >= 0; u--) {
      var l = n.segments[u];
      if (l && typeof l.start < "u") {
        s.syncInfo = {
          mediaSequence: n.mediaSequence + u,
          time: l.start
        }, this.logger_("playlist refresh sync: [time:" + s.syncInfo.time + "," + (" mediaSequence: " + s.syncInfo.mediaSequence + "]")), this.trigger("syncinfoupdate");
        break;
      }
    }
  }, t.setDateTimeMappingForStart = function(n) {
    if (this.timelineToDatetimeMappings = {}, n.segments && n.segments.length && n.segments[0].dateTimeObject) {
      var s = n.segments[0], o = s.dateTimeObject.getTime() / 1e3;
      this.timelineToDatetimeMappings[s.timeline] = -o;
    }
  }, t.saveSegmentTimingInfo = function(n) {
    var s = n.segmentInfo, o = n.shouldSaveTimelineMapping, u = this.calculateSegmentTimeMapping_(s, s.timingInfo, o), l = s.segment;
    u && (this.saveDiscontinuitySyncInfo_(s), s.playlist.syncInfo || (s.playlist.syncInfo = {
      mediaSequence: s.playlist.mediaSequence + s.mediaIndex,
      time: l.start
    }));
    var f = l.dateTimeObject;
    l.discontinuity && o && f && (this.timelineToDatetimeMappings[l.timeline] = -(f.getTime() / 1e3));
  }, t.timestampOffsetForTimeline = function(n) {
    return typeof this.timelines[n] > "u" ? null : this.timelines[n].time;
  }, t.mappingForTimeline = function(n) {
    return typeof this.timelines[n] > "u" ? null : this.timelines[n].mapping;
  }, t.calculateSegmentTimeMapping_ = function(n, s, o) {
    var u = n.segment, l = n.part, f = this.timelines[n.timeline], d, h;
    if (typeof n.timestampOffset == "number")
      f = {
        time: n.startOfSegment,
        mapping: n.startOfSegment - s.start
      }, o && (this.timelines[n.timeline] = f, this.trigger("timestampoffset"), this.logger_("time mapping for timeline " + n.timeline + ": " + ("[time: " + f.time + "] [mapping: " + f.mapping + "]"))), d = n.startOfSegment, h = s.end + f.mapping;
    else if (f)
      d = s.start + f.mapping, h = s.end + f.mapping;
    else
      return !1;
    return l && (l.start = d, l.end = h), (!u.start || d < u.start) && (u.start = d), u.end = h, !0;
  }, t.saveDiscontinuitySyncInfo_ = function(n) {
    var s = n.playlist, o = n.segment;
    if (o.discontinuity)
      this.discontinuities[o.timeline] = {
        time: o.start,
        accuracy: 0
      };
    else if (s.discontinuityStarts && s.discontinuityStarts.length)
      for (var u = 0; u < s.discontinuityStarts.length; u++) {
        var l = s.discontinuityStarts[u], f = s.discontinuitySequence + u + 1, d = l - n.mediaIndex, h = Math.abs(d);
        if (!this.discontinuities[f] || this.discontinuities[f].accuracy > h) {
          var p = void 0;
          d < 0 ? p = o.start - sumDurations({
            defaultDuration: s.targetDuration,
            durationList: s.segments,
            startIndex: n.mediaIndex,
            endIndex: l
          }) : p = o.end + sumDurations({
            defaultDuration: s.targetDuration,
            durationList: s.segments,
            startIndex: n.mediaIndex + 1,
            endIndex: l
          }), this.discontinuities[f] = {
            time: p,
            accuracy: h
          };
        }
      }
  }, t.dispose = function() {
    this.trigger("dispose"), this.off();
  }, e;
}(videojs.EventTarget), TimelineChangeController = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e() {
    var a;
    return a = r.call(this) || this, a.pendingTimelineChanges_ = {}, a.lastTimelineChanges_ = {}, a;
  }
  var t = e.prototype;
  return t.clearPendingTimelineChange = function(n) {
    this.pendingTimelineChanges_[n] = null, this.trigger("pendingtimelinechange");
  }, t.pendingTimelineChange = function(n) {
    var s = n.type, o = n.from, u = n.to;
    return typeof o == "number" && typeof u == "number" && (this.pendingTimelineChanges_[s] = {
      type: s,
      from: o,
      to: u
    }, this.trigger("pendingtimelinechange")), this.pendingTimelineChanges_[s];
  }, t.lastTimelineChange = function(n) {
    var s = n.type, o = n.from, u = n.to;
    return typeof o == "number" && typeof u == "number" && (this.lastTimelineChanges_[s] = {
      type: s,
      from: o,
      to: u
    }, delete this.pendingTimelineChanges_[s], this.trigger("timelinechange")), this.lastTimelineChanges_[s];
  }, t.dispose = function() {
    this.trigger("dispose"), this.pendingTimelineChanges_ = {}, this.lastTimelineChanges_ = {}, this.off();
  }, e;
}(videojs.EventTarget), workerCode = transform(getWorkerString(function() {
  var r = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
  function e(L, G, _r) {
    return _r = {
      path: G,
      exports: {},
      require: function(_n, Fa) {
        return t(_n, Fa == null ? _r.path : Fa);
      }
    }, L(_r, _r.exports), _r.exports;
  }
  function t() {
    throw new Error("Dynamic requires are not currently supported by @rollup/plugin-commonjs");
  }
  var a = e(function(L) {
    function G(ga, _n) {
      for (var Fa = 0; Fa < _n.length; Fa++) {
        var N = _n[Fa];
        N.enumerable = N.enumerable || !1, N.configurable = !0, "value" in N && (N.writable = !0), Object.defineProperty(ga, N.key, N);
      }
    }
    function _r(ga, _n, Fa) {
      return _n && G(ga.prototype, _n), Fa && G(ga, Fa), ga;
    }
    L.exports = _r, L.exports.default = L.exports, L.exports.__esModule = !0;
  }), n = e(function(L) {
    function G(_r, ga) {
      return L.exports = G = Object.setPrototypeOf || function(Fa, N) {
        return Fa.__proto__ = N, Fa;
      }, L.exports.default = L.exports, L.exports.__esModule = !0, G(_r, ga);
    }
    L.exports = G, L.exports.default = L.exports, L.exports.__esModule = !0;
  }), s = e(function(L) {
    function G(_r, ga) {
      _r.prototype = Object.create(ga.prototype), _r.prototype.constructor = _r, n(_r, ga);
    }
    L.exports = G, L.exports.default = L.exports, L.exports.__esModule = !0;
  }), o = /* @__PURE__ */ function() {
    function L() {
      this.listeners = {};
    }
    var G = L.prototype;
    return G.on = function(ga, _n) {
      this.listeners[ga] || (this.listeners[ga] = []), this.listeners[ga].push(_n);
    }, G.off = function(ga, _n) {
      if (!this.listeners[ga])
        return !1;
      var Fa = this.listeners[ga].indexOf(_n);
      return this.listeners[ga] = this.listeners[ga].slice(0), this.listeners[ga].splice(Fa, 1), Fa > -1;
    }, G.trigger = function(ga) {
      var _n = this.listeners[ga];
      if (!!_n)
        if (arguments.length === 2)
          for (var Fa = _n.length, N = 0; N < Fa; ++N)
            _n[N].call(this, arguments[1]);
        else
          for (var _t = Array.prototype.slice.call(arguments, 1), Y = _n.length, _a = 0; _a < Y; ++_a)
            _n[_a].apply(this, _t);
    }, G.dispose = function() {
      this.listeners = {};
    }, G.pipe = function(ga) {
      this.on("data", function(_n) {
        ga.push(_n);
      });
    }, L;
  }();
  /*! @name pkcs7 @version 1.0.4 @license Apache-2.0 */
  function u(L) {
    return L.subarray(0, L.byteLength - L[L.byteLength - 1]);
  }
  /*! @name aes-decrypter @version 3.1.3 @license Apache-2.0 */
  var l = function() {
    var G = [[[], [], [], [], []], [[], [], [], [], []]], _r = G[0], ga = G[1], _n = _r[4], Fa = ga[4], N, _t, Y, _a = [], X = [], J, ea, wa, _s, _d, _o;
    for (N = 0; N < 256; N++)
      X[(_a[N] = N << 1 ^ (N >> 7) * 283) ^ N] = N;
    for (_t = Y = 0; !_n[_t]; _t ^= J || 1, Y = X[Y] || 1)
      for (_s = Y ^ Y << 1 ^ Y << 2 ^ Y << 3 ^ Y << 4, _s = _s >> 8 ^ _s & 255 ^ 99, _n[_t] = _s, Fa[_s] = _t, wa = _a[ea = _a[J = _a[_t]]], _o = wa * 16843009 ^ ea * 65537 ^ J * 257 ^ _t * 16843008, _d = _a[_s] * 257 ^ _s * 16843008, N = 0; N < 4; N++)
        _r[N][_t] = _d = _d << 24 ^ _d >>> 8, ga[N][_s] = _o = _o << 24 ^ _o >>> 8;
    for (N = 0; N < 5; N++)
      _r[N] = _r[N].slice(0), ga[N] = ga[N].slice(0);
    return G;
  }, f = null, d = /* @__PURE__ */ function() {
    function L(_r) {
      f || (f = l()), this._tables = [[f[0][0].slice(), f[0][1].slice(), f[0][2].slice(), f[0][3].slice(), f[0][4].slice()], [f[1][0].slice(), f[1][1].slice(), f[1][2].slice(), f[1][3].slice(), f[1][4].slice()]];
      var ga, _n, Fa, N = this._tables[0][4], _t = this._tables[1], Y = _r.length, _a = 1;
      if (Y !== 4 && Y !== 6 && Y !== 8)
        throw new Error("Invalid aes key size");
      var X = _r.slice(0), J = [];
      for (this._key = [X, J], ga = Y; ga < 4 * Y + 28; ga++)
        Fa = X[ga - 1], (ga % Y === 0 || Y === 8 && ga % Y === 4) && (Fa = N[Fa >>> 24] << 24 ^ N[Fa >> 16 & 255] << 16 ^ N[Fa >> 8 & 255] << 8 ^ N[Fa & 255], ga % Y === 0 && (Fa = Fa << 8 ^ Fa >>> 24 ^ _a << 24, _a = _a << 1 ^ (_a >> 7) * 283)), X[ga] = X[ga - Y] ^ Fa;
      for (_n = 0; ga; _n++, ga--)
        Fa = X[_n & 3 ? ga : ga - 4], ga <= 4 || _n < 4 ? J[_n] = Fa : J[_n] = _t[0][N[Fa >>> 24]] ^ _t[1][N[Fa >> 16 & 255]] ^ _t[2][N[Fa >> 8 & 255]] ^ _t[3][N[Fa & 255]];
    }
    var G = L.prototype;
    return G.decrypt = function(ga, _n, Fa, N, _t, Y) {
      var _a = this._key[1], X = ga ^ _a[0], J = N ^ _a[1], ea = Fa ^ _a[2], wa = _n ^ _a[3], _s, _d, _o, _p = _a.length / 4 - 2, _f, _g = 4, f0 = this._tables[1], y0 = f0[0], h0 = f0[1], x0 = f0[2], C0 = f0[3], A0 = f0[4];
      for (_f = 0; _f < _p; _f++)
        _s = y0[X >>> 24] ^ h0[J >> 16 & 255] ^ x0[ea >> 8 & 255] ^ C0[wa & 255] ^ _a[_g], _d = y0[J >>> 24] ^ h0[ea >> 16 & 255] ^ x0[wa >> 8 & 255] ^ C0[X & 255] ^ _a[_g + 1], _o = y0[ea >>> 24] ^ h0[wa >> 16 & 255] ^ x0[X >> 8 & 255] ^ C0[J & 255] ^ _a[_g + 2], wa = y0[wa >>> 24] ^ h0[X >> 16 & 255] ^ x0[J >> 8 & 255] ^ C0[ea & 255] ^ _a[_g + 3], _g += 4, X = _s, J = _d, ea = _o;
      for (_f = 0; _f < 4; _f++)
        _t[(3 & -_f) + Y] = A0[X >>> 24] << 24 ^ A0[J >> 16 & 255] << 16 ^ A0[ea >> 8 & 255] << 8 ^ A0[wa & 255] ^ _a[_g++], _s = X, X = J, J = ea, ea = wa, wa = _s;
    }, L;
  }(), h = /* @__PURE__ */ function(L) {
    s(G, L);
    function G() {
      var ga;
      return ga = L.call(this, o) || this, ga.jobs = [], ga.delay = 1, ga.timeout_ = null, ga;
    }
    var _r = G.prototype;
    return _r.processJob_ = function() {
      this.jobs.shift()(), this.jobs.length ? this.timeout_ = setTimeout(this.processJob_.bind(this), this.delay) : this.timeout_ = null;
    }, _r.push = function(_n) {
      this.jobs.push(_n), this.timeout_ || (this.timeout_ = setTimeout(this.processJob_.bind(this), this.delay));
    }, G;
  }(o), p = function(G) {
    return G << 24 | (G & 65280) << 8 | (G & 16711680) >> 8 | G >>> 24;
  }, m = function(G, _r, ga) {
    var _n = new Int32Array(G.buffer, G.byteOffset, G.byteLength >> 2), Fa = new d(Array.prototype.slice.call(_r)), N = new Uint8Array(G.byteLength), _t = new Int32Array(N.buffer), Y, _a, X, J, ea, wa, _s, _d, _o;
    for (Y = ga[0], _a = ga[1], X = ga[2], J = ga[3], _o = 0; _o < _n.length; _o += 4)
      ea = p(_n[_o]), wa = p(_n[_o + 1]), _s = p(_n[_o + 2]), _d = p(_n[_o + 3]), Fa.decrypt(ea, wa, _s, _d, _t, _o), _t[_o] = p(_t[_o] ^ Y), _t[_o + 1] = p(_t[_o + 1] ^ _a), _t[_o + 2] = p(_t[_o + 2] ^ X), _t[_o + 3] = p(_t[_o + 3] ^ J), Y = ea, _a = wa, X = _s, J = _d;
    return N;
  }, _ = /* @__PURE__ */ function() {
    function L(_r, ga, _n, Fa) {
      var N = L.STEP, _t = new Int32Array(_r.buffer), Y = new Uint8Array(_r.byteLength), _a = 0;
      for (this.asyncStream_ = new h(), this.asyncStream_.push(this.decryptChunk_(_t.subarray(_a, _a + N), ga, _n, Y)), _a = N; _a < _t.length; _a += N)
        _n = new Uint32Array([p(_t[_a - 4]), p(_t[_a - 3]), p(_t[_a - 2]), p(_t[_a - 1])]), this.asyncStream_.push(this.decryptChunk_(_t.subarray(_a, _a + N), ga, _n, Y));
      this.asyncStream_.push(function() {
        Fa(null, u(Y));
      });
    }
    var G = L.prototype;
    return G.decryptChunk_ = function(ga, _n, Fa, N) {
      return function() {
        var _t = m(ga, _n, Fa);
        N.set(_t, ga.byteOffset);
      };
    }, a(L, null, [{
      key: "STEP",
      get: function() {
        return 32e3;
      }
    }]), L;
  }(), w;
  typeof window < "u" ? w = window : typeof r < "u" ? w = r : typeof self < "u" ? w = self : w = {};
  var S = w, O = function(G) {
    return ArrayBuffer.isView === "function" ? ArrayBuffer.isView(G) : G && G.buffer instanceof ArrayBuffer;
  }, k = S.BigInt || Number;
  k("0x1"), k("0x100"), k("0x10000"), k("0x1000000"), k("0x100000000"), k("0x10000000000"), k("0x1000000000000"), k("0x100000000000000"), k("0x10000000000000000");
  var B = function(G) {
    var _r = {};
    return Object.keys(G).forEach(function(ga) {
      var _n = G[ga];
      O(_n) ? _r[ga] = {
        bytes: _n.buffer,
        byteOffset: _n.byteOffset,
        byteLength: _n.byteLength
      } : _r[ga] = _n;
    }), _r;
  };
  self.onmessage = function(L) {
    var G = L.data, _r = new Uint8Array(G.encrypted.bytes, G.encrypted.byteOffset, G.encrypted.byteLength), ga = new Uint32Array(G.key.bytes, G.key.byteOffset, G.key.byteLength / 4), _n = new Uint32Array(G.iv.bytes, G.iv.byteOffset, G.iv.byteLength / 4);
    new _(_r, ga, _n, function(Fa, N) {
      self.postMessage(B({
        source: G.source,
        decrypted: N
      }), [N.buffer]);
    });
  };
})), Decrypter = factory(workerCode), audioTrackKind_ = function r(e) {
  var t = e.default ? "main" : "alternative";
  return e.characteristics && e.characteristics.indexOf("public.accessibility.describes-video") >= 0 && (t = "main-desc"), t;
}, stopLoaders = function r(e, t) {
  e.abort(), e.pause(), t && t.activePlaylistLoader && (t.activePlaylistLoader.pause(), t.activePlaylistLoader = null);
}, startLoaders = function r(e, t) {
  t.activePlaylistLoader = e, e.load();
}, onGroupChanged = function r(e, t) {
  return function() {
    var a = t.segmentLoaders, n = a[e], s = a.main, o = t.mediaTypes[e], u = o.activeTrack(), l = o.getActiveGroup(), f = o.activePlaylistLoader, d = o.lastGroup_;
    if (!(l && d && l.id === d.id) && (o.lastGroup_ = l, o.lastTrack_ = u, stopLoaders(n, o), !(!l || l.isMasterPlaylist))) {
      if (!l.playlistLoader) {
        f && s.resetEverything();
        return;
      }
      n.resyncLoader(), startLoaders(l.playlistLoader, o);
    }
  };
}, onGroupChanging = function r(e, t) {
  return function() {
    var a = t.segmentLoaders[e], n = t.mediaTypes[e];
    n.lastGroup_ = null, a.abort(), a.pause();
  };
}, onTrackChanged = function r(e, t) {
  return function() {
    var a = t.masterPlaylistLoader, n = t.segmentLoaders, s = n[e], o = n.main, u = t.mediaTypes[e], l = u.activeTrack(), f = u.getActiveGroup(), d = u.activePlaylistLoader, h = u.lastTrack_;
    if (!(h && l && h.id === l.id) && (u.lastGroup_ = f, u.lastTrack_ = l, stopLoaders(s, u), !!f)) {
      if (f.isMasterPlaylist) {
        if (!l || !h || l.id === h.id)
          return;
        var p = t.vhs.masterPlaylistController_, m = p.selectPlaylist();
        if (p.media() === m)
          return;
        u.logger_("track change. Switching master audio from " + h.id + " to " + l.id), a.pause(), o.resetEverything(), p.fastQualityChange_(m);
        return;
      }
      if (e === "AUDIO") {
        if (!f.playlistLoader) {
          o.setAudio(!0), o.resetEverything();
          return;
        }
        s.setAudio(!0), o.setAudio(!1);
      }
      if (d === f.playlistLoader) {
        startLoaders(f.playlistLoader, u);
        return;
      }
      s.track && s.track(l), s.resetEverything(), startLoaders(f.playlistLoader, u);
    }
  };
}, onError = {
  AUDIO: function r(e, t) {
    return function() {
      var a = t.segmentLoaders[e], n = t.mediaTypes[e], s = t.blacklistCurrentPlaylist;
      stopLoaders(a, n);
      var o = n.activeTrack(), u = n.activeGroup(), l = (u.filter(function(h) {
        return h.default;
      })[0] || u[0]).id, f = n.tracks[l];
      if (o === f) {
        s({
          message: "Problem encountered loading the default audio track."
        });
        return;
      }
      videojs.log.warn("Problem encountered loading the alternate audio track.Switching back to default.");
      for (var d in n.tracks)
        n.tracks[d].enabled = n.tracks[d] === f;
      n.onTrackChanged();
    };
  },
  SUBTITLES: function r(e, t) {
    return function() {
      var a = t.segmentLoaders[e], n = t.mediaTypes[e];
      videojs.log.warn("Problem encountered loading the subtitle track.Disabling subtitle track."), stopLoaders(a, n);
      var s = n.activeTrack();
      s && (s.mode = "disabled"), n.onTrackChanged();
    };
  }
}, setupListeners = {
  AUDIO: function r(e, t, a) {
    if (!!t) {
      var n = a.tech, s = a.requestOptions, o = a.segmentLoaders[e];
      t.on("loadedmetadata", function() {
        var u = t.media();
        o.playlist(u, s), (!n.paused() || u.endList && n.preload() !== "none") && o.load();
      }), t.on("loadedplaylist", function() {
        o.playlist(t.media(), s), n.paused() || o.load();
      }), t.on("error", onError[e](e, a));
    }
  },
  SUBTITLES: function r(e, t, a) {
    var n = a.tech, s = a.requestOptions, o = a.segmentLoaders[e], u = a.mediaTypes[e];
    t.on("loadedmetadata", function() {
      var l = t.media();
      o.playlist(l, s), o.track(u.activeTrack()), (!n.paused() || l.endList && n.preload() !== "none") && o.load();
    }), t.on("loadedplaylist", function() {
      o.playlist(t.media(), s), n.paused() || o.load();
    }), t.on("error", onError[e](e, a));
  }
}, initialize = {
  AUDIO: function r(e, t) {
    var a = t.vhs, n = t.sourceType, s = t.segmentLoaders[e], o = t.requestOptions, u = t.master.mediaGroups, l = t.mediaTypes[e], f = l.groups, d = l.tracks, h = l.logger_, p = t.masterPlaylistLoader, m = isAudioOnly(p.master);
    (!u[e] || Object.keys(u[e]).length === 0) && (u[e] = {
      main: {
        default: {
          default: !0
        }
      }
    }, m && (u[e].main.default.playlists = p.master.playlists));
    for (var _ in u[e]) {
      f[_] || (f[_] = []);
      for (var w in u[e][_]) {
        var S = u[e][_][w], O = void 0;
        if (m ? (h("AUDIO group '" + _ + "' label '" + w + "' is a master playlist"), S.isMasterPlaylist = !0, O = null) : n === "vhs-json" && S.playlists ? O = new PlaylistLoader(S.playlists[0], a, o) : S.resolvedUri ? O = new PlaylistLoader(S.resolvedUri, a, o) : S.playlists && n === "dash" ? O = new DashPlaylistLoader(S.playlists[0], a, o, p) : O = null, S = videojs.mergeOptions({
          id: w,
          playlistLoader: O
        }, S), setupListeners[e](e, S.playlistLoader, t), f[_].push(S), typeof d[w] > "u") {
          var k = new videojs.AudioTrack({
            id: w,
            kind: audioTrackKind_(S),
            enabled: !1,
            language: S.language,
            default: S.default,
            label: w
          });
          d[w] = k;
        }
      }
    }
    s.on("error", onError[e](e, t));
  },
  SUBTITLES: function r(e, t) {
    var a = t.tech, n = t.vhs, s = t.sourceType, o = t.segmentLoaders[e], u = t.requestOptions, l = t.master.mediaGroups, f = t.mediaTypes[e], d = f.groups, h = f.tracks, p = t.masterPlaylistLoader;
    for (var m in l[e]) {
      d[m] || (d[m] = []);
      for (var _ in l[e][m])
        if (!l[e][m][_].forced) {
          var w = l[e][m][_], S = void 0;
          if (s === "hls")
            S = new PlaylistLoader(w.resolvedUri, n, u);
          else if (s === "dash") {
            var O = w.playlists.filter(function(B) {
              return B.excludeUntil !== 1 / 0;
            });
            if (!O.length)
              return;
            S = new DashPlaylistLoader(w.playlists[0], n, u, p);
          } else
            s === "vhs-json" && (S = new PlaylistLoader(
              w.playlists ? w.playlists[0] : w.resolvedUri,
              n,
              u
            ));
          if (w = videojs.mergeOptions({
            id: _,
            playlistLoader: S
          }, w), setupListeners[e](e, w.playlistLoader, t), d[m].push(w), typeof h[_] > "u") {
            var k = a.addRemoteTextTrack({
              id: _,
              kind: "subtitles",
              default: w.default && w.autoselect,
              language: w.language,
              label: _
            }, !1).track;
            h[_] = k;
          }
        }
    }
    o.on("error", onError[e](e, t));
  },
  "CLOSED-CAPTIONS": function r(e, t) {
    var a = t.tech, n = t.master.mediaGroups, s = t.mediaTypes[e], o = s.groups, u = s.tracks;
    for (var l in n[e]) {
      o[l] || (o[l] = []);
      for (var f in n[e][l]) {
        var d = n[e][l][f];
        if (!!/^(?:CC|SERVICE)/.test(d.instreamId)) {
          var h = a.options_.vhs && a.options_.vhs.captionServices || {}, p = {
            label: f,
            language: d.language,
            instreamId: d.instreamId,
            default: d.default && d.autoselect
          };
          if (h[p.instreamId] && (p = videojs.mergeOptions(p, h[p.instreamId])), p.default === void 0 && delete p.default, o[l].push(videojs.mergeOptions({
            id: f
          }, d)), typeof u[f] > "u") {
            var m = a.addRemoteTextTrack({
              id: p.instreamId,
              kind: "captions",
              default: p.default,
              language: p.language,
              label: p.label
            }, !1).track;
            u[f] = m;
          }
        }
      }
    }
  }
}, groupMatch = function r(e, t) {
  for (var a = 0; a < e.length; a++)
    if (playlistMatch(t, e[a]) || e[a].playlists && r(e[a].playlists, t))
      return !0;
  return !1;
}, activeGroup = function r(e, t) {
  return function(a) {
    var n = t.masterPlaylistLoader, s = t.mediaTypes[e].groups, o = n.media();
    if (!o)
      return null;
    var u = null;
    o.attributes[e] && (u = s[o.attributes[e]]);
    var l = Object.keys(s);
    if (!u)
      if (e === "AUDIO" && l.length > 1 && isAudioOnly(t.master))
        for (var f = 0; f < l.length; f++) {
          var d = s[l[f]];
          if (groupMatch(d, o)) {
            u = d;
            break;
          }
        }
      else
        s.main ? u = s.main : l.length === 1 && (u = s[l[0]]);
    return typeof a > "u" ? u : a === null || !u ? null : u.filter(function(h) {
      return h.id === a.id;
    })[0] || null;
  };
}, activeTrack = {
  AUDIO: function r(e, t) {
    return function() {
      var a = t.mediaTypes[e].tracks;
      for (var n in a)
        if (a[n].enabled)
          return a[n];
      return null;
    };
  },
  SUBTITLES: function r(e, t) {
    return function() {
      var a = t.mediaTypes[e].tracks;
      for (var n in a)
        if (a[n].mode === "showing" || a[n].mode === "hidden")
          return a[n];
      return null;
    };
  }
}, getActiveGroup = function r(e, t) {
  var a = t.mediaTypes;
  return function() {
    var n = a[e].activeTrack();
    return n ? a[e].activeGroup(n) : null;
  };
}, setupMediaGroups = function r(e) {
  ["AUDIO", "SUBTITLES", "CLOSED-CAPTIONS"].forEach(function(_) {
    initialize[_](_, e);
  });
  var t = e.mediaTypes, a = e.masterPlaylistLoader, n = e.tech, s = e.vhs, o = e.segmentLoaders, u = o.AUDIO, l = o.main;
  ["AUDIO", "SUBTITLES"].forEach(function(_) {
    t[_].activeGroup = activeGroup(_, e), t[_].activeTrack = activeTrack[_](_, e), t[_].onGroupChanged = onGroupChanged(_, e), t[_].onGroupChanging = onGroupChanging(_, e), t[_].onTrackChanged = onTrackChanged(_, e), t[_].getActiveGroup = getActiveGroup(_, e);
  });
  var f = t.AUDIO.activeGroup();
  if (f) {
    var d = (f.filter(function(_) {
      return _.default;
    })[0] || f[0]).id;
    t.AUDIO.tracks[d].enabled = !0, t.AUDIO.onGroupChanged(), t.AUDIO.onTrackChanged();
    var h = t.AUDIO.getActiveGroup();
    h.playlistLoader ? (l.setAudio(!1), u.setAudio(!0)) : l.setAudio(!0);
  }
  a.on("mediachange", function() {
    ["AUDIO", "SUBTITLES"].forEach(function(_) {
      return t[_].onGroupChanged();
    });
  }), a.on("mediachanging", function() {
    ["AUDIO", "SUBTITLES"].forEach(function(_) {
      return t[_].onGroupChanging();
    });
  });
  var p = function() {
    t.AUDIO.onTrackChanged(), n.trigger({
      type: "usage",
      name: "vhs-audio-change"
    }), n.trigger({
      type: "usage",
      name: "hls-audio-change"
    });
  };
  n.audioTracks().addEventListener("change", p), n.remoteTextTracks().addEventListener("change", t.SUBTITLES.onTrackChanged), s.on("dispose", function() {
    n.audioTracks().removeEventListener("change", p), n.remoteTextTracks().removeEventListener("change", t.SUBTITLES.onTrackChanged);
  }), n.clearTracks("audio");
  for (var m in t.AUDIO.tracks)
    n.audioTracks().addTrack(t.AUDIO.tracks[m]);
}, createMediaTypes = function r() {
  var e = {};
  return ["AUDIO", "SUBTITLES", "CLOSED-CAPTIONS"].forEach(function(t) {
    e[t] = {
      groups: {},
      tracks: {},
      activePlaylistLoader: null,
      activeGroup: noop,
      activeTrack: noop,
      getActiveGroup: noop,
      onGroupChanged: noop,
      onTrackChanged: noop,
      lastTrack_: null,
      logger_: logger("MediaGroups[" + t + "]")
    };
  }), e;
}, ABORT_EARLY_BLACKLIST_SECONDS = 60 * 2, Vhs$1, loaderStats = ["mediaRequests", "mediaRequestsAborted", "mediaRequestsTimedout", "mediaRequestsErrored", "mediaTransferDuration", "mediaBytesTransferred", "mediaAppends"], sumLoaderStat = function r(e) {
  return this.audioSegmentLoader_[e] + this.mainSegmentLoader_[e];
}, shouldSwitchToMedia = function r(e) {
  var t = e.currentPlaylist, a = e.buffered, n = e.currentTime, s = e.nextPlaylist, o = e.bufferLowWaterLine, u = e.bufferHighWaterLine, l = e.duration, f = e.experimentalBufferBasedABR, d = e.log;
  if (!s)
    return videojs.log.warn("We received no playlist to switch to. Please check your stream."), !1;
  var h = "allowing switch " + (t && t.id || "null") + " -> " + s.id;
  if (!t)
    return d(h + " as current playlist is not set"), !0;
  if (s.id === t.id)
    return !1;
  var p = Boolean(findRange(a, n).length);
  if (!t.endList)
    return !p && typeof t.partTargetDuration == "number" ? (d("not " + h + " as current playlist is live llhls, but currentTime isn't in buffered."), !1) : (d(h + " as current playlist is live"), !0);
  var m = timeAheadOf(a, n), _ = f ? Config.EXPERIMENTAL_MAX_BUFFER_LOW_WATER_LINE : Config.MAX_BUFFER_LOW_WATER_LINE;
  if (l < _)
    return d(h + " as duration < max low water line (" + l + " < " + _ + ")"), !0;
  var w = s.attributes.BANDWIDTH, S = t.attributes.BANDWIDTH;
  if (w < S && (!f || m < u)) {
    var O = h + " as next bandwidth < current bandwidth (" + w + " < " + S + ")";
    return f && (O += " and forwardBuffer < bufferHighWaterLine (" + m + " < " + u + ")"), d(O), !0;
  }
  if ((!f || w > S) && m >= o) {
    var k = h + " as forwardBuffer >= bufferLowWaterLine (" + m + " >= " + o + ")";
    return f && (k += " and next bandwidth > current bandwidth (" + w + " > " + S + ")"), d(k), !0;
  }
  return d("not " + h + " as no switching criteria met"), !1;
}, MasterPlaylistController = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a) {
    var n;
    n = r.call(this) || this;
    var s = a.src, o = a.handleManifestRedirects, u = a.withCredentials, l = a.tech, f = a.bandwidth, d = a.externVhs, h = a.useCueTags, p = a.blacklistDuration, m = a.enableLowInitialPlaylist, _ = a.sourceType, w = a.cacheEncryptionKeys, S = a.experimentalBufferBasedABR, O = a.experimentalLeastPixelDiffSelector, k = a.captionServices;
    if (!s)
      throw new Error("A non-empty playlist URL or JSON manifest string is required");
    var B = a.maxPlaylistRetries;
    (B === null || typeof B > "u") && (B = 1 / 0), Vhs$1 = d, n.experimentalBufferBasedABR = Boolean(S), n.experimentalLeastPixelDiffSelector = Boolean(O), n.withCredentials = u, n.tech_ = l, n.vhs_ = l.vhs, n.sourceType_ = _, n.useCueTags_ = h, n.blacklistDuration = p, n.maxPlaylistRetries = B, n.enableLowInitialPlaylist = m, n.useCueTags_ && (n.cueTagsTrack_ = n.tech_.addTextTrack("metadata", "ad-cues"), n.cueTagsTrack_.inBandMetadataTrackDispatchType = ""), n.requestOptions_ = {
      withCredentials: u,
      handleManifestRedirects: o,
      maxPlaylistRetries: B,
      timeout: null
    }, n.on("error", n.pauseLoading), n.mediaTypes_ = createMediaTypes(), n.mediaSource = new window_1.MediaSource(), n.handleDurationChange_ = n.handleDurationChange_.bind(_assertThisInitialized$1(n)), n.handleSourceOpen_ = n.handleSourceOpen_.bind(_assertThisInitialized$1(n)), n.handleSourceEnded_ = n.handleSourceEnded_.bind(_assertThisInitialized$1(n)), n.mediaSource.addEventListener("durationchange", n.handleDurationChange_), n.mediaSource.addEventListener("sourceopen", n.handleSourceOpen_), n.mediaSource.addEventListener("sourceended", n.handleSourceEnded_), n.seekable_ = videojs.createTimeRanges(), n.hasPlayed_ = !1, n.syncController_ = new SyncController(a), n.segmentMetadataTrack_ = l.addRemoteTextTrack({
      kind: "metadata",
      label: "segment-metadata"
    }, !1).track, n.decrypter_ = new Decrypter(), n.sourceUpdater_ = new SourceUpdater(n.mediaSource), n.inbandTextTracks_ = {}, n.timelineChangeController_ = new TimelineChangeController();
    var L = {
      vhs: n.vhs_,
      parse708captions: a.parse708captions,
      useDtsForTimestampOffset: a.useDtsForTimestampOffset,
      captionServices: k,
      mediaSource: n.mediaSource,
      currentTime: n.tech_.currentTime.bind(n.tech_),
      seekable: function() {
        return n.seekable();
      },
      seeking: function() {
        return n.tech_.seeking();
      },
      duration: function() {
        return n.duration();
      },
      hasPlayed: function() {
        return n.hasPlayed_;
      },
      goalBufferLength: function() {
        return n.goalBufferLength();
      },
      bandwidth: f,
      syncController: n.syncController_,
      decrypter: n.decrypter_,
      sourceType: n.sourceType_,
      inbandTextTracks: n.inbandTextTracks_,
      cacheEncryptionKeys: w,
      sourceUpdater: n.sourceUpdater_,
      timelineChangeController: n.timelineChangeController_,
      experimentalExactManifestTimings: a.experimentalExactManifestTimings
    };
    n.masterPlaylistLoader_ = n.sourceType_ === "dash" ? new DashPlaylistLoader(s, n.vhs_, n.requestOptions_) : new PlaylistLoader(s, n.vhs_, n.requestOptions_), n.setupMasterPlaylistLoaderListeners_(), n.mainSegmentLoader_ = new SegmentLoader(videojs.mergeOptions(L, {
      segmentMetadataTrack: n.segmentMetadataTrack_,
      loaderType: "main"
    }), a), n.audioSegmentLoader_ = new SegmentLoader(videojs.mergeOptions(L, {
      loaderType: "audio"
    }), a), n.subtitleSegmentLoader_ = new VTTSegmentLoader(videojs.mergeOptions(L, {
      loaderType: "vtt",
      featuresNativeTextTracks: n.tech_.featuresNativeTextTracks
    }), a), n.setupSegmentLoaderListeners_(), n.experimentalBufferBasedABR && (n.masterPlaylistLoader_.one("loadedplaylist", function() {
      return n.startABRTimer_();
    }), n.tech_.on("pause", function() {
      return n.stopABRTimer_();
    }), n.tech_.on("play", function() {
      return n.startABRTimer_();
    })), loaderStats.forEach(function(_r) {
      n[_r + "_"] = sumLoaderStat.bind(_assertThisInitialized$1(n), _r);
    }), n.logger_ = logger("MPC"), n.triggeredFmp4Usage = !1, n.tech_.preload() === "none" ? (n.loadOnPlay_ = function() {
      n.loadOnPlay_ = null, n.masterPlaylistLoader_.load();
    }, n.tech_.one("play", n.loadOnPlay_)) : n.masterPlaylistLoader_.load(), n.timeToLoadedData__ = -1, n.mainAppendsToLoadedData__ = -1, n.audioAppendsToLoadedData__ = -1;
    var G = n.tech_.preload() === "none" ? "play" : "loadstart";
    return n.tech_.one(G, function() {
      var _r = Date.now();
      n.tech_.one("loadeddata", function() {
        n.timeToLoadedData__ = Date.now() - _r, n.mainAppendsToLoadedData__ = n.mainSegmentLoader_.mediaAppends, n.audioAppendsToLoadedData__ = n.audioSegmentLoader_.mediaAppends;
      });
    }), n;
  }
  var t = e.prototype;
  return t.mainAppendsToLoadedData_ = function() {
    return this.mainAppendsToLoadedData__;
  }, t.audioAppendsToLoadedData_ = function() {
    return this.audioAppendsToLoadedData__;
  }, t.appendsToLoadedData_ = function() {
    var n = this.mainAppendsToLoadedData_(), s = this.audioAppendsToLoadedData_();
    return n === -1 || s === -1 ? -1 : n + s;
  }, t.timeToLoadedData_ = function() {
    return this.timeToLoadedData__;
  }, t.checkABR_ = function() {
    var n = this.selectPlaylist();
    n && this.shouldSwitchToMedia_(n) && this.switchMedia_(n, "abr");
  }, t.switchMedia_ = function(n, s, o) {
    var u = this.media(), l = u && (u.id || u.uri), f = n.id || n.uri;
    l && l !== f && (this.logger_("switch media " + l + " -> " + f + " from " + s), this.tech_.trigger({
      type: "usage",
      name: "vhs-rendition-change-" + s
    })), this.masterPlaylistLoader_.media(n, o);
  }, t.startABRTimer_ = function() {
    var n = this;
    this.stopABRTimer_(), this.abrTimer_ = window_1.setInterval(function() {
      return n.checkABR_();
    }, 250);
  }, t.stopABRTimer_ = function() {
    this.tech_.scrubbing && this.tech_.scrubbing() || (window_1.clearInterval(this.abrTimer_), this.abrTimer_ = null);
  }, t.getAudioTrackPlaylists_ = function() {
    var n = this.master(), s = n && n.playlists || [];
    if (!n || !n.mediaGroups || !n.mediaGroups.AUDIO)
      return s;
    var o = n.mediaGroups.AUDIO, u = Object.keys(o), l;
    if (Object.keys(this.mediaTypes_.AUDIO.groups).length)
      l = this.mediaTypes_.AUDIO.activeTrack();
    else {
      var f = o.main || u.length && o[u[0]];
      for (var d in f)
        if (f[d].default) {
          l = {
            label: d
          };
          break;
        }
    }
    if (!l)
      return s;
    var h = [];
    for (var p in o)
      if (o[p][l.label]) {
        var m = o[p][l.label];
        if (m.playlists && m.playlists.length)
          h.push.apply(h, m.playlists);
        else if (m.uri)
          h.push(m);
        else if (n.playlists.length)
          for (var _ = 0; _ < n.playlists.length; _++) {
            var w = n.playlists[_];
            w.attributes && w.attributes.AUDIO && w.attributes.AUDIO === p && h.push(w);
          }
      }
    return h.length ? h : s;
  }, t.setupMasterPlaylistLoaderListeners_ = function() {
    var n = this;
    this.masterPlaylistLoader_.on("loadedmetadata", function() {
      var s = n.masterPlaylistLoader_.media(), o = s.targetDuration * 1.5 * 1e3;
      isLowestEnabledRendition(n.masterPlaylistLoader_.master, n.masterPlaylistLoader_.media()) ? n.requestOptions_.timeout = 0 : n.requestOptions_.timeout = o, s.endList && n.tech_.preload() !== "none" && (n.mainSegmentLoader_.playlist(s, n.requestOptions_), n.mainSegmentLoader_.load()), setupMediaGroups({
        sourceType: n.sourceType_,
        segmentLoaders: {
          AUDIO: n.audioSegmentLoader_,
          SUBTITLES: n.subtitleSegmentLoader_,
          main: n.mainSegmentLoader_
        },
        tech: n.tech_,
        requestOptions: n.requestOptions_,
        masterPlaylistLoader: n.masterPlaylistLoader_,
        vhs: n.vhs_,
        master: n.master(),
        mediaTypes: n.mediaTypes_,
        blacklistCurrentPlaylist: n.blacklistCurrentPlaylist.bind(n)
      }), n.triggerPresenceUsage_(n.master(), s), n.setupFirstPlay(), !n.mediaTypes_.AUDIO.activePlaylistLoader || n.mediaTypes_.AUDIO.activePlaylistLoader.media() ? n.trigger("selectedinitialmedia") : n.mediaTypes_.AUDIO.activePlaylistLoader.one("loadedmetadata", function() {
        n.trigger("selectedinitialmedia");
      });
    }), this.masterPlaylistLoader_.on("loadedplaylist", function() {
      n.loadOnPlay_ && n.tech_.off("play", n.loadOnPlay_);
      var s = n.masterPlaylistLoader_.media();
      if (!s) {
        n.excludeUnsupportedVariants_();
        var o;
        if (n.enableLowInitialPlaylist && (o = n.selectInitialPlaylist()), o || (o = n.selectPlaylist()), !o || !n.shouldSwitchToMedia_(o))
          return;
        n.initialMedia_ = o, n.switchMedia_(n.initialMedia_, "initial");
        var u = n.sourceType_ === "vhs-json" && n.initialMedia_.segments;
        if (!u)
          return;
        s = n.initialMedia_;
      }
      n.handleUpdatedMediaPlaylist(s);
    }), this.masterPlaylistLoader_.on("error", function() {
      n.blacklistCurrentPlaylist(n.masterPlaylistLoader_.error);
    }), this.masterPlaylistLoader_.on("mediachanging", function() {
      n.mainSegmentLoader_.abort(), n.mainSegmentLoader_.pause();
    }), this.masterPlaylistLoader_.on("mediachange", function() {
      var s = n.masterPlaylistLoader_.media(), o = s.targetDuration * 1.5 * 1e3;
      isLowestEnabledRendition(n.masterPlaylistLoader_.master, n.masterPlaylistLoader_.media()) ? n.requestOptions_.timeout = 0 : n.requestOptions_.timeout = o, n.mainSegmentLoader_.playlist(s, n.requestOptions_), n.mainSegmentLoader_.load(), n.tech_.trigger({
        type: "mediachange",
        bubbles: !0
      });
    }), this.masterPlaylistLoader_.on("playlistunchanged", function() {
      var s = n.masterPlaylistLoader_.media();
      if (s.lastExcludeReason_ !== "playlist-unchanged") {
        var o = n.stuckAtPlaylistEnd_(s);
        o && (n.blacklistCurrentPlaylist({
          message: "Playlist no longer updating.",
          reason: "playlist-unchanged"
        }), n.tech_.trigger("playliststuck"));
      }
    }), this.masterPlaylistLoader_.on("renditiondisabled", function() {
      n.tech_.trigger({
        type: "usage",
        name: "vhs-rendition-disabled"
      }), n.tech_.trigger({
        type: "usage",
        name: "hls-rendition-disabled"
      });
    }), this.masterPlaylistLoader_.on("renditionenabled", function() {
      n.tech_.trigger({
        type: "usage",
        name: "vhs-rendition-enabled"
      }), n.tech_.trigger({
        type: "usage",
        name: "hls-rendition-enabled"
      });
    });
  }, t.handleUpdatedMediaPlaylist = function(n) {
    this.useCueTags_ && this.updateAdCues_(n), this.mainSegmentLoader_.playlist(n, this.requestOptions_), this.updateDuration(!n.endList), this.tech_.paused() || (this.mainSegmentLoader_.load(), this.audioSegmentLoader_ && this.audioSegmentLoader_.load());
  }, t.triggerPresenceUsage_ = function(n, s) {
    var o = n.mediaGroups || {}, u = !0, l = Object.keys(o.AUDIO);
    for (var f in o.AUDIO)
      for (var d in o.AUDIO[f]) {
        var h = o.AUDIO[f][d];
        h.uri || (u = !1);
      }
    u && (this.tech_.trigger({
      type: "usage",
      name: "vhs-demuxed"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-demuxed"
    })), Object.keys(o.SUBTITLES).length && (this.tech_.trigger({
      type: "usage",
      name: "vhs-webvtt"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-webvtt"
    })), Vhs$1.Playlist.isAes(s) && (this.tech_.trigger({
      type: "usage",
      name: "vhs-aes"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-aes"
    })), l.length && Object.keys(o.AUDIO[l[0]]).length > 1 && (this.tech_.trigger({
      type: "usage",
      name: "vhs-alternate-audio"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-alternate-audio"
    })), this.useCueTags_ && (this.tech_.trigger({
      type: "usage",
      name: "vhs-playlist-cue-tags"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-playlist-cue-tags"
    }));
  }, t.shouldSwitchToMedia_ = function(n) {
    var s = this.masterPlaylistLoader_.media() || this.masterPlaylistLoader_.pendingMedia_, o = this.tech_.currentTime(), u = this.bufferLowWaterLine(), l = this.bufferHighWaterLine(), f = this.tech_.buffered();
    return shouldSwitchToMedia({
      buffered: f,
      currentTime: o,
      currentPlaylist: s,
      nextPlaylist: n,
      bufferLowWaterLine: u,
      bufferHighWaterLine: l,
      duration: this.duration(),
      experimentalBufferBasedABR: this.experimentalBufferBasedABR,
      log: this.logger_
    });
  }, t.setupSegmentLoaderListeners_ = function() {
    var n = this;
    this.experimentalBufferBasedABR || (this.mainSegmentLoader_.on("bandwidthupdate", function() {
      var o = n.selectPlaylist();
      n.shouldSwitchToMedia_(o) && n.switchMedia_(o, "bandwidthupdate"), n.tech_.trigger("bandwidthupdate");
    }), this.mainSegmentLoader_.on("progress", function() {
      n.trigger("progress");
    })), this.mainSegmentLoader_.on("error", function() {
      n.blacklistCurrentPlaylist(n.mainSegmentLoader_.error());
    }), this.mainSegmentLoader_.on("appenderror", function() {
      n.error = n.mainSegmentLoader_.error_, n.trigger("error");
    }), this.mainSegmentLoader_.on("syncinfoupdate", function() {
      n.onSyncInfoUpdate_();
    }), this.mainSegmentLoader_.on("timestampoffset", function() {
      n.tech_.trigger({
        type: "usage",
        name: "vhs-timestamp-offset"
      }), n.tech_.trigger({
        type: "usage",
        name: "hls-timestamp-offset"
      });
    }), this.audioSegmentLoader_.on("syncinfoupdate", function() {
      n.onSyncInfoUpdate_();
    }), this.audioSegmentLoader_.on("appenderror", function() {
      n.error = n.audioSegmentLoader_.error_, n.trigger("error");
    }), this.mainSegmentLoader_.on("ended", function() {
      n.logger_("main segment loader ended"), n.onEndOfStream();
    }), this.mainSegmentLoader_.on("earlyabort", function(o) {
      n.experimentalBufferBasedABR || (n.delegateLoaders_("all", ["abort"]), n.blacklistCurrentPlaylist({
        message: "Aborted early because there isn't enough bandwidth to complete the request without rebuffering."
      }, ABORT_EARLY_BLACKLIST_SECONDS));
    });
    var s = function() {
      if (!n.sourceUpdater_.hasCreatedSourceBuffers())
        return n.tryToCreateSourceBuffers_();
      var u = n.getCodecsOrExclude_();
      !u || n.sourceUpdater_.addOrChangeSourceBuffers(u);
    };
    this.mainSegmentLoader_.on("trackinfo", s), this.audioSegmentLoader_.on("trackinfo", s), this.mainSegmentLoader_.on("fmp4", function() {
      n.triggeredFmp4Usage || (n.tech_.trigger({
        type: "usage",
        name: "vhs-fmp4"
      }), n.tech_.trigger({
        type: "usage",
        name: "hls-fmp4"
      }), n.triggeredFmp4Usage = !0);
    }), this.audioSegmentLoader_.on("fmp4", function() {
      n.triggeredFmp4Usage || (n.tech_.trigger({
        type: "usage",
        name: "vhs-fmp4"
      }), n.tech_.trigger({
        type: "usage",
        name: "hls-fmp4"
      }), n.triggeredFmp4Usage = !0);
    }), this.audioSegmentLoader_.on("ended", function() {
      n.logger_("audioSegmentLoader ended"), n.onEndOfStream();
    });
  }, t.mediaSecondsLoaded_ = function() {
    return Math.max(this.audioSegmentLoader_.mediaSecondsLoaded + this.mainSegmentLoader_.mediaSecondsLoaded);
  }, t.load = function() {
    this.mainSegmentLoader_.load(), this.mediaTypes_.AUDIO.activePlaylistLoader && this.audioSegmentLoader_.load(), this.mediaTypes_.SUBTITLES.activePlaylistLoader && this.subtitleSegmentLoader_.load();
  }, t.smoothQualityChange_ = function(n) {
    n === void 0 && (n = this.selectPlaylist()), this.fastQualityChange_(n);
  }, t.fastQualityChange_ = function(n) {
    var s = this;
    if (n === void 0 && (n = this.selectPlaylist()), n === this.masterPlaylistLoader_.media()) {
      this.logger_("skipping fastQualityChange because new media is same as old");
      return;
    }
    this.switchMedia_(n, "fast-quality"), this.mainSegmentLoader_.resetEverything(function() {
      videojs.browser.IE_VERSION || videojs.browser.IS_EDGE ? s.tech_.setCurrentTime(s.tech_.currentTime() + 0.04) : s.tech_.setCurrentTime(s.tech_.currentTime());
    });
  }, t.play = function() {
    if (!this.setupFirstPlay()) {
      this.tech_.ended() && this.tech_.setCurrentTime(0), this.hasPlayed_ && this.load();
      var n = this.tech_.seekable();
      if (this.tech_.duration() === 1 / 0 && this.tech_.currentTime() < n.start(0))
        return this.tech_.setCurrentTime(n.end(n.length - 1));
    }
  }, t.setupFirstPlay = function() {
    var n = this, s = this.masterPlaylistLoader_.media();
    if (!s || this.tech_.paused() || this.hasPlayed_)
      return !1;
    if (!s.endList) {
      var o = this.seekable();
      if (!o.length)
        return !1;
      if (videojs.browser.IE_VERSION && this.tech_.readyState() === 0)
        return this.tech_.one("loadedmetadata", function() {
          n.trigger("firstplay"), n.tech_.setCurrentTime(o.end(0)), n.hasPlayed_ = !0;
        }), !1;
      this.trigger("firstplay"), this.tech_.setCurrentTime(o.end(0));
    }
    return this.hasPlayed_ = !0, this.load(), !0;
  }, t.handleSourceOpen_ = function() {
    if (this.tryToCreateSourceBuffers_(), this.tech_.autoplay()) {
      var n = this.tech_.play();
      typeof n < "u" && typeof n.then == "function" && n.then(null, function(s) {
      });
    }
    this.trigger("sourceopen");
  }, t.handleSourceEnded_ = function() {
    if (!!this.inbandTextTracks_.metadataTrack_) {
      var n = this.inbandTextTracks_.metadataTrack_.cues;
      if (!(!n || !n.length)) {
        var s = this.duration();
        n[n.length - 1].endTime = isNaN(s) || Math.abs(s) === 1 / 0 ? Number.MAX_VALUE : s;
      }
    }
  }, t.handleDurationChange_ = function() {
    this.tech_.trigger("durationchange");
  }, t.onEndOfStream = function() {
    var n = this.mainSegmentLoader_.ended_;
    if (this.mediaTypes_.AUDIO.activePlaylistLoader) {
      var s = this.mainSegmentLoader_.getCurrentMediaInfo_();
      !s || s.hasVideo ? n = n && this.audioSegmentLoader_.ended_ : n = this.audioSegmentLoader_.ended_;
    }
    !n || (this.stopABRTimer_(), this.sourceUpdater_.endOfStream());
  }, t.stuckAtPlaylistEnd_ = function(n) {
    var s = this.seekable();
    if (!s.length)
      return !1;
    var o = this.syncController_.getExpiredTime(n, this.duration());
    if (o === null)
      return !1;
    var u = Vhs$1.Playlist.playlistEnd(n, o), l = this.tech_.currentTime(), f = this.tech_.buffered();
    if (!f.length)
      return u - l <= SAFE_TIME_DELTA;
    var d = f.end(f.length - 1);
    return d - l <= SAFE_TIME_DELTA && u - d <= SAFE_TIME_DELTA;
  }, t.blacklistCurrentPlaylist = function(n, s) {
    n === void 0 && (n = {});
    var o = n.playlist || this.masterPlaylistLoader_.media();
    if (s = s || n.blacklistDuration || this.blacklistDuration, !o) {
      this.error = n, this.mediaSource.readyState !== "open" ? this.trigger("error") : this.sourceUpdater_.endOfStream("network");
      return;
    }
    o.playlistErrors_++;
    var u = this.masterPlaylistLoader_.master.playlists, l = u.filter(isEnabled), f = l.length === 1 && l[0] === o;
    if (u.length === 1 && s !== 1 / 0)
      return videojs.log.warn("Problem encountered with playlist " + o.id + ". Trying again since it is the only playlist."), this.tech_.trigger("retryplaylist"), this.masterPlaylistLoader_.load(f);
    if (f) {
      var d = !1;
      u.forEach(function(O) {
        if (O !== o) {
          var k = O.excludeUntil;
          typeof k < "u" && k !== 1 / 0 && (d = !0, delete O.excludeUntil);
        }
      }), d && (videojs.log.warn("Removing other playlists from the exclusion list because the last rendition is about to be excluded."), this.tech_.trigger("retryplaylist"));
    }
    var h;
    o.playlistErrors_ > this.maxPlaylistRetries ? h = 1 / 0 : h = Date.now() + s * 1e3, o.excludeUntil = h, n.reason && (o.lastExcludeReason_ = n.reason), this.tech_.trigger("blacklistplaylist"), this.tech_.trigger({
      type: "usage",
      name: "vhs-rendition-blacklisted"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-rendition-blacklisted"
    });
    var p = this.selectPlaylist();
    if (!p) {
      this.error = "Playback cannot continue. No available working or supported playlists.", this.trigger("error");
      return;
    }
    var m = n.internal ? this.logger_ : videojs.log.warn, _ = n.message ? " " + n.message : "";
    m((n.internal ? "Internal problem" : "Problem") + " encountered with playlist " + o.id + "." + (_ + " Switching to playlist " + p.id + ".")), p.attributes.AUDIO !== o.attributes.AUDIO && this.delegateLoaders_("audio", ["abort", "pause"]), p.attributes.SUBTITLES !== o.attributes.SUBTITLES && this.delegateLoaders_("subtitle", ["abort", "pause"]), this.delegateLoaders_("main", ["abort", "pause"]);
    var w = p.targetDuration / 2 * 1e3 || 5 * 1e3, S = typeof p.lastRequest == "number" && Date.now() - p.lastRequest <= w;
    return this.switchMedia_(p, "exclude", f || S);
  }, t.pauseLoading = function() {
    this.delegateLoaders_("all", ["abort", "pause"]), this.stopABRTimer_();
  }, t.delegateLoaders_ = function(n, s) {
    var o = this, u = [], l = n === "all";
    (l || n === "main") && u.push(this.masterPlaylistLoader_);
    var f = [];
    (l || n === "audio") && f.push("AUDIO"), (l || n === "subtitle") && (f.push("CLOSED-CAPTIONS"), f.push("SUBTITLES")), f.forEach(function(d) {
      var h = o.mediaTypes_[d] && o.mediaTypes_[d].activePlaylistLoader;
      h && u.push(h);
    }), ["main", "audio", "subtitle"].forEach(function(d) {
      var h = o[d + "SegmentLoader_"];
      h && (n === d || n === "all") && u.push(h);
    }), u.forEach(function(d) {
      return s.forEach(function(h) {
        typeof d[h] == "function" && d[h]();
      });
    });
  }, t.setCurrentTime = function(n) {
    var s = findRange(this.tech_.buffered(), n);
    if (!(this.masterPlaylistLoader_ && this.masterPlaylistLoader_.media()) || !this.masterPlaylistLoader_.media().segments)
      return 0;
    if (s && s.length)
      return n;
    this.mainSegmentLoader_.resetEverything(), this.mainSegmentLoader_.abort(), this.mediaTypes_.AUDIO.activePlaylistLoader && (this.audioSegmentLoader_.resetEverything(), this.audioSegmentLoader_.abort()), this.mediaTypes_.SUBTITLES.activePlaylistLoader && (this.subtitleSegmentLoader_.resetEverything(), this.subtitleSegmentLoader_.abort()), this.load();
  }, t.duration = function() {
    if (!this.masterPlaylistLoader_)
      return 0;
    var n = this.masterPlaylistLoader_.media();
    return n ? n.endList ? this.mediaSource ? this.mediaSource.duration : Vhs$1.Playlist.duration(n) : 1 / 0 : 0;
  }, t.seekable = function() {
    return this.seekable_;
  }, t.onSyncInfoUpdate_ = function() {
    var n;
    if (!!this.masterPlaylistLoader_) {
      var s = this.masterPlaylistLoader_.media();
      if (!!s) {
        var o = this.syncController_.getExpiredTime(s, this.duration());
        if (o !== null) {
          var u = this.masterPlaylistLoader_.master, l = Vhs$1.Playlist.seekable(s, o, Vhs$1.Playlist.liveEdgeDelay(u, s));
          if (l.length !== 0 && !(this.mediaTypes_.AUDIO.activePlaylistLoader && (s = this.mediaTypes_.AUDIO.activePlaylistLoader.media(), o = this.syncController_.getExpiredTime(s, this.duration()), o === null || (n = Vhs$1.Playlist.seekable(s, o, Vhs$1.Playlist.liveEdgeDelay(u, s)), n.length === 0)))) {
            var f, d;
            this.seekable_ && this.seekable_.length && (f = this.seekable_.end(0), d = this.seekable_.start(0)), n ? n.start(0) > l.end(0) || l.start(0) > n.end(0) ? this.seekable_ = l : this.seekable_ = videojs.createTimeRanges([[n.start(0) > l.start(0) ? n.start(0) : l.start(0), n.end(0) < l.end(0) ? n.end(0) : l.end(0)]]) : this.seekable_ = l, !(this.seekable_ && this.seekable_.length && this.seekable_.end(0) === f && this.seekable_.start(0) === d) && (this.logger_("seekable updated [" + printableRange(this.seekable_) + "]"), this.tech_.trigger("seekablechanged"));
          }
        }
      }
    }
  }, t.updateDuration = function(n) {
    if (this.updateDuration_ && (this.mediaSource.removeEventListener("sourceopen", this.updateDuration_), this.updateDuration_ = null), this.mediaSource.readyState !== "open") {
      this.updateDuration_ = this.updateDuration.bind(this, n), this.mediaSource.addEventListener("sourceopen", this.updateDuration_);
      return;
    }
    if (n) {
      var s = this.seekable();
      if (!s.length)
        return;
      (isNaN(this.mediaSource.duration) || this.mediaSource.duration < s.end(s.length - 1)) && this.sourceUpdater_.setDuration(s.end(s.length - 1));
      return;
    }
    var o = this.tech_.buffered(), u = Vhs$1.Playlist.duration(this.masterPlaylistLoader_.media());
    o.length > 0 && (u = Math.max(u, o.end(o.length - 1))), this.mediaSource.duration !== u && this.sourceUpdater_.setDuration(u);
  }, t.dispose = function() {
    var n = this;
    this.trigger("dispose"), this.decrypter_.terminate(), this.masterPlaylistLoader_.dispose(), this.mainSegmentLoader_.dispose(), this.loadOnPlay_ && this.tech_.off("play", this.loadOnPlay_), ["AUDIO", "SUBTITLES"].forEach(function(s) {
      var o = n.mediaTypes_[s].groups;
      for (var u in o)
        o[u].forEach(function(l) {
          l.playlistLoader && l.playlistLoader.dispose();
        });
    }), this.audioSegmentLoader_.dispose(), this.subtitleSegmentLoader_.dispose(), this.sourceUpdater_.dispose(), this.timelineChangeController_.dispose(), this.stopABRTimer_(), this.updateDuration_ && this.mediaSource.removeEventListener("sourceopen", this.updateDuration_), this.mediaSource.removeEventListener("durationchange", this.handleDurationChange_), this.mediaSource.removeEventListener("sourceopen", this.handleSourceOpen_), this.mediaSource.removeEventListener("sourceended", this.handleSourceEnded_), this.off();
  }, t.master = function() {
    return this.masterPlaylistLoader_.master;
  }, t.media = function() {
    return this.masterPlaylistLoader_.media() || this.initialMedia_;
  }, t.areMediaTypesKnown_ = function() {
    var n = !!this.mediaTypes_.AUDIO.activePlaylistLoader, s = !!this.mainSegmentLoader_.getCurrentMediaInfo_(), o = n ? !!this.audioSegmentLoader_.getCurrentMediaInfo_() : !0;
    return !(!s || !o);
  }, t.getCodecsOrExclude_ = function() {
    var n = this, s = {
      main: this.mainSegmentLoader_.getCurrentMediaInfo_() || {},
      audio: this.audioSegmentLoader_.getCurrentMediaInfo_() || {}
    };
    s.video = s.main;
    var o = codecsForPlaylist(this.master(), this.media()), u = {}, l = !!this.mediaTypes_.AUDIO.activePlaylistLoader;
    if (s.main.hasVideo && (u.video = o.video || s.main.videoCodec || DEFAULT_VIDEO_CODEC), s.main.isMuxed && (u.video += "," + (o.audio || s.main.audioCodec || DEFAULT_AUDIO_CODEC)), (s.main.hasAudio && !s.main.isMuxed || s.audio.hasAudio || l) && (u.audio = o.audio || s.main.audioCodec || s.audio.audioCodec || DEFAULT_AUDIO_CODEC, s.audio.isFmp4 = s.main.hasAudio && !s.main.isMuxed ? s.main.isFmp4 : s.audio.isFmp4), !u.audio && !u.video) {
      this.blacklistCurrentPlaylist({
        playlist: this.media(),
        message: "Could not determine codecs for playlist.",
        blacklistDuration: 1 / 0
      });
      return;
    }
    var f = function(S, O) {
      return S ? browserSupportsCodec(O) : muxerSupportsCodec(O);
    }, d = {}, h;
    if (["video", "audio"].forEach(function(w) {
      if (u.hasOwnProperty(w) && !f(s[w].isFmp4, u[w])) {
        var S = s[w].isFmp4 ? "browser" : "muxer";
        d[S] = d[S] || [], d[S].push(u[w]), w === "audio" && (h = S);
      }
    }), l && h && this.media().attributes.AUDIO) {
      var p = this.media().attributes.AUDIO;
      this.master().playlists.forEach(function(w) {
        var S = w.attributes && w.attributes.AUDIO;
        S === p && w !== n.media() && (w.excludeUntil = 1 / 0);
      }), this.logger_("excluding audio group " + p + " as " + h + ' does not support codec(s): "' + u.audio + '"');
    }
    if (Object.keys(d).length) {
      var m = Object.keys(d).reduce(function(w, S) {
        return w && (w += ", "), w += S + ' does not support codec(s): "' + d[S].join(",") + '"', w;
      }, "") + ".";
      this.blacklistCurrentPlaylist({
        playlist: this.media(),
        internal: !0,
        message: m,
        blacklistDuration: 1 / 0
      });
      return;
    }
    if (this.sourceUpdater_.hasCreatedSourceBuffers() && !this.sourceUpdater_.canChangeType()) {
      var _ = [];
      if (["video", "audio"].forEach(function(w) {
        var S = (parseCodecs(n.sourceUpdater_.codecs[w] || "")[0] || {}).type, O = (parseCodecs(u[w] || "")[0] || {}).type;
        S && O && S.toLowerCase() !== O.toLowerCase() && _.push('"' + n.sourceUpdater_.codecs[w] + '" -> "' + u[w] + '"');
      }), _.length) {
        this.blacklistCurrentPlaylist({
          playlist: this.media(),
          message: "Codec switching not supported: " + _.join(", ") + ".",
          blacklistDuration: 1 / 0,
          internal: !0
        });
        return;
      }
    }
    return u;
  }, t.tryToCreateSourceBuffers_ = function() {
    if (!(this.mediaSource.readyState !== "open" || this.sourceUpdater_.hasCreatedSourceBuffers()) && !!this.areMediaTypesKnown_()) {
      var n = this.getCodecsOrExclude_();
      if (!!n) {
        this.sourceUpdater_.createSourceBuffers(n);
        var s = [n.video, n.audio].filter(Boolean).join(",");
        this.excludeIncompatibleVariants_(s);
      }
    }
  }, t.excludeUnsupportedVariants_ = function() {
    var n = this, s = this.master().playlists, o = [];
    Object.keys(s).forEach(function(u) {
      var l = s[u];
      if (o.indexOf(l.id) === -1) {
        o.push(l.id);
        var f = codecsForPlaylist(n.master, l), d = [];
        f.audio && !muxerSupportsCodec(f.audio) && !browserSupportsCodec(f.audio) && d.push("audio codec " + f.audio), f.video && !muxerSupportsCodec(f.video) && !browserSupportsCodec(f.video) && d.push("video codec " + f.video), f.text && f.text === "stpp.ttml.im1t" && d.push("text codec " + f.text), d.length && (l.excludeUntil = 1 / 0, n.logger_("excluding " + l.id + " for unsupported: " + d.join(", ")));
      }
    });
  }, t.excludeIncompatibleVariants_ = function(n) {
    var s = this, o = [], u = this.master().playlists, l = unwrapCodecList(parseCodecs(n)), f = codecCount(l), d = l.video && parseCodecs(l.video)[0] || null, h = l.audio && parseCodecs(l.audio)[0] || null;
    Object.keys(u).forEach(function(p) {
      var m = u[p];
      if (!(o.indexOf(m.id) !== -1 || m.excludeUntil === 1 / 0)) {
        o.push(m.id);
        var _ = [], w = codecsForPlaylist(s.masterPlaylistLoader_.master, m), S = codecCount(w);
        if (!(!w.audio && !w.video)) {
          if (S !== f && _.push('codec count "' + S + '" !== "' + f + '"'), !s.sourceUpdater_.canChangeType()) {
            var O = w.video && parseCodecs(w.video)[0] || null, k = w.audio && parseCodecs(w.audio)[0] || null;
            O && d && O.type.toLowerCase() !== d.type.toLowerCase() && _.push('video codec "' + O.type + '" !== "' + d.type + '"'), k && h && k.type.toLowerCase() !== h.type.toLowerCase() && _.push('audio codec "' + k.type + '" !== "' + h.type + '"');
          }
          _.length && (m.excludeUntil = 1 / 0, s.logger_("blacklisting " + m.id + ": " + _.join(" && ")));
        }
      }
    });
  }, t.updateAdCues_ = function(n) {
    var s = 0, o = this.seekable();
    o.length && (s = o.start(0)), updateAdCues(n, this.cueTagsTrack_, s);
  }, t.goalBufferLength = function() {
    var n = this.tech_.currentTime(), s = Config.GOAL_BUFFER_LENGTH, o = Config.GOAL_BUFFER_LENGTH_RATE, u = Math.max(s, Config.MAX_GOAL_BUFFER_LENGTH);
    return Math.min(s + n * o, u);
  }, t.bufferLowWaterLine = function() {
    var n = this.tech_.currentTime(), s = Config.BUFFER_LOW_WATER_LINE, o = Config.BUFFER_LOW_WATER_LINE_RATE, u = Math.max(s, Config.MAX_BUFFER_LOW_WATER_LINE), l = Math.max(s, Config.EXPERIMENTAL_MAX_BUFFER_LOW_WATER_LINE);
    return Math.min(s + n * o, this.experimentalBufferBasedABR ? l : u);
  }, t.bufferHighWaterLine = function() {
    return Config.BUFFER_HIGH_WATER_LINE;
  }, e;
}(videojs.EventTarget), enableFunction = function r(e, t, a) {
  return function(n) {
    var s = e.master.playlists[t], o = isIncompatible(s), u = isEnabled(s);
    return typeof n > "u" ? u : (n ? delete s.disabled : s.disabled = !0, n !== u && !o && (a(), n ? e.trigger("renditionenabled") : e.trigger("renditiondisabled")), n);
  };
}, Representation = function r(e, t, a) {
  var n = e.masterPlaylistController_, s = e.options_.smoothQualityChange, o = s ? "smooth" : "fast", u = n[o + "QualityChange_"].bind(n);
  if (t.attributes) {
    var l = t.attributes.RESOLUTION;
    this.width = l && l.width, this.height = l && l.height, this.bandwidth = t.attributes.BANDWIDTH;
  }
  this.codecs = codecsForPlaylist(n.master(), t), this.playlist = t, this.id = a, this.enabled = enableFunction(e.playlists, t.id, u);
}, renditionSelectionMixin = function r(e) {
  e.representations = function() {
    var t = e.masterPlaylistController_.master(), a = isAudioOnly(t) ? e.masterPlaylistController_.getAudioTrackPlaylists_() : t.playlists;
    return a ? a.filter(function(n) {
      return !isIncompatible(n);
    }).map(function(n, s) {
      return new Representation(e, n, n.id);
    }) : [];
  };
}, timerCancelEvents = ["seeking", "seeked", "pause", "playing", "error"], PlaybackWatcher = /* @__PURE__ */ function() {
  function r(t) {
    var a = this;
    this.masterPlaylistController_ = t.masterPlaylistController, this.tech_ = t.tech, this.seekable = t.seekable, this.allowSeeksWithinUnsafeLiveWindow = t.allowSeeksWithinUnsafeLiveWindow, this.liveRangeSafeTimeDelta = t.liveRangeSafeTimeDelta, this.media = t.media, this.consecutiveUpdates = 0, this.lastRecordedTime = null, this.timer_ = null, this.checkCurrentTimeTimeout_ = null, this.logger_ = logger("PlaybackWatcher"), this.logger_("initialize");
    var n = function() {
      return a.monitorCurrentTime_();
    }, s = function() {
      return a.monitorCurrentTime_();
    }, o = function() {
      return a.techWaiting_();
    }, u = function() {
      return a.cancelTimer_();
    }, l = this.masterPlaylistController_, f = ["main", "subtitle", "audio"], d = {};
    f.forEach(function(p) {
      d[p] = {
        reset: function() {
          return a.resetSegmentDownloads_(p);
        },
        updateend: function() {
          return a.checkSegmentDownloads_(p);
        }
      }, l[p + "SegmentLoader_"].on("appendsdone", d[p].updateend), l[p + "SegmentLoader_"].on("playlistupdate", d[p].reset), a.tech_.on(["seeked", "seeking"], d[p].reset);
    });
    var h = function(m) {
      ["main", "audio"].forEach(function(_) {
        l[_ + "SegmentLoader_"][m]("appended", a.seekingAppendCheck_);
      });
    };
    this.seekingAppendCheck_ = function() {
      a.fixesBadSeeks_() && (a.consecutiveUpdates = 0, a.lastRecordedTime = a.tech_.currentTime(), h("off"));
    }, this.clearSeekingAppendCheck_ = function() {
      return h("off");
    }, this.watchForBadSeeking_ = function() {
      a.clearSeekingAppendCheck_(), h("on");
    }, this.tech_.on("seeked", this.clearSeekingAppendCheck_), this.tech_.on("seeking", this.watchForBadSeeking_), this.tech_.on("waiting", o), this.tech_.on(timerCancelEvents, u), this.tech_.on("canplay", s), this.tech_.one("play", n), this.dispose = function() {
      a.clearSeekingAppendCheck_(), a.logger_("dispose"), a.tech_.off("waiting", o), a.tech_.off(timerCancelEvents, u), a.tech_.off("canplay", s), a.tech_.off("play", n), a.tech_.off("seeking", a.watchForBadSeeking_), a.tech_.off("seeked", a.clearSeekingAppendCheck_), f.forEach(function(p) {
        l[p + "SegmentLoader_"].off("appendsdone", d[p].updateend), l[p + "SegmentLoader_"].off("playlistupdate", d[p].reset), a.tech_.off(["seeked", "seeking"], d[p].reset);
      }), a.checkCurrentTimeTimeout_ && window_1.clearTimeout(a.checkCurrentTimeTimeout_), a.cancelTimer_();
    };
  }
  var e = r.prototype;
  return e.monitorCurrentTime_ = function() {
    this.checkCurrentTime_(), this.checkCurrentTimeTimeout_ && window_1.clearTimeout(this.checkCurrentTimeTimeout_), this.checkCurrentTimeTimeout_ = window_1.setTimeout(this.monitorCurrentTime_.bind(this), 250);
  }, e.resetSegmentDownloads_ = function(a) {
    var n = this.masterPlaylistController_[a + "SegmentLoader_"];
    this[a + "StalledDownloads_"] > 0 && this.logger_("resetting possible stalled download count for " + a + " loader"), this[a + "StalledDownloads_"] = 0, this[a + "Buffered_"] = n.buffered_();
  }, e.checkSegmentDownloads_ = function(a) {
    var n = this.masterPlaylistController_, s = n[a + "SegmentLoader_"], o = s.buffered_(), u = isRangeDifferent(this[a + "Buffered_"], o);
    if (this[a + "Buffered_"] = o, u) {
      this.resetSegmentDownloads_(a);
      return;
    }
    this[a + "StalledDownloads_"]++, this.logger_("found #" + this[a + "StalledDownloads_"] + " " + a + " appends that did not increase buffer (possible stalled download)", {
      playlistId: s.playlist_ && s.playlist_.id,
      buffered: timeRangesToArray(o)
    }), !(this[a + "StalledDownloads_"] < 10) && (this.logger_(a + " loader stalled download exclusion"), this.resetSegmentDownloads_(a), this.tech_.trigger({
      type: "usage",
      name: "vhs-" + a + "-download-exclusion"
    }), a !== "subtitle" && n.blacklistCurrentPlaylist({
      message: "Excessive " + a + " segment downloading detected."
    }, 1 / 0));
  }, e.checkCurrentTime_ = function() {
    if (!(this.tech_.paused() || this.tech_.seeking())) {
      var a = this.tech_.currentTime(), n = this.tech_.buffered();
      if (this.lastRecordedTime === a && (!n.length || a + SAFE_TIME_DELTA >= n.end(n.length - 1)))
        return this.techWaiting_();
      this.consecutiveUpdates >= 5 && a === this.lastRecordedTime ? (this.consecutiveUpdates++, this.waiting_()) : a === this.lastRecordedTime ? this.consecutiveUpdates++ : (this.consecutiveUpdates = 0, this.lastRecordedTime = a);
    }
  }, e.cancelTimer_ = function() {
    this.consecutiveUpdates = 0, this.timer_ && (this.logger_("cancelTimer_"), clearTimeout(this.timer_)), this.timer_ = null;
  }, e.fixesBadSeeks_ = function() {
    var a = this.tech_.seeking();
    if (!a)
      return !1;
    var n = this.seekable(), s = this.tech_.currentTime(), o = this.afterSeekableWindow_(n, s, this.media(), this.allowSeeksWithinUnsafeLiveWindow), u;
    if (o) {
      var l = n.end(n.length - 1);
      u = l;
    }
    if (this.beforeSeekableWindow_(n, s)) {
      var f = n.start(0);
      u = f + (f === n.end(0) ? 0 : SAFE_TIME_DELTA);
    }
    if (typeof u < "u")
      return this.logger_("Trying to seek outside of seekable at time " + s + " with " + ("seekable range " + printableRange(n) + ". Seeking to ") + (u + ".")), this.tech_.setCurrentTime(u), !0;
    for (var d = this.masterPlaylistController_.sourceUpdater_, h = this.tech_.buffered(), p = d.audioBuffer ? d.audioBuffered() : null, m = d.videoBuffer ? d.videoBuffered() : null, _ = this.media(), w = _.partTargetDuration ? _.partTargetDuration : (_.targetDuration - TIME_FUDGE_FACTOR) * 2, S = [p, m], O = 0; O < S.length; O++)
      if (!!S[O]) {
        var k = timeAheadOf(S[O], s);
        if (k < w)
          return !1;
      }
    var B = findNextRange(h, s);
    return B.length === 0 ? !1 : (u = B.start(0) + SAFE_TIME_DELTA, this.logger_("Buffered region starts (" + B.start(0) + ") " + (" just beyond seek point (" + s + "). Seeking to " + u + ".")), this.tech_.setCurrentTime(u), !0);
  }, e.waiting_ = function() {
    if (!this.techWaiting_()) {
      var a = this.tech_.currentTime(), n = this.tech_.buffered(), s = findRange(n, a);
      if (s.length && a + 3 <= s.end(0)) {
        this.cancelTimer_(), this.tech_.setCurrentTime(a), this.logger_("Stopped at " + a + " while inside a buffered region " + ("[" + s.start(0) + " -> " + s.end(0) + "]. Attempting to resume ") + "playback by seeking to the current time."), this.tech_.trigger({
          type: "usage",
          name: "vhs-unknown-waiting"
        }), this.tech_.trigger({
          type: "usage",
          name: "hls-unknown-waiting"
        });
        return;
      }
    }
  }, e.techWaiting_ = function() {
    var a = this.seekable(), n = this.tech_.currentTime();
    if (this.tech_.seeking() || this.timer_ !== null)
      return !0;
    if (this.beforeSeekableWindow_(a, n)) {
      var s = a.end(a.length - 1);
      return this.logger_("Fell out of live window at time " + n + ". Seeking to " + ("live point (seekable end) " + s)), this.cancelTimer_(), this.tech_.setCurrentTime(s), this.tech_.trigger({
        type: "usage",
        name: "vhs-live-resync"
      }), this.tech_.trigger({
        type: "usage",
        name: "hls-live-resync"
      }), !0;
    }
    var o = this.tech_.vhs.masterPlaylistController_.sourceUpdater_, u = this.tech_.buffered(), l = this.videoUnderflow_({
      audioBuffered: o.audioBuffered(),
      videoBuffered: o.videoBuffered(),
      currentTime: n
    });
    if (l)
      return this.cancelTimer_(), this.tech_.setCurrentTime(n), this.tech_.trigger({
        type: "usage",
        name: "vhs-video-underflow"
      }), this.tech_.trigger({
        type: "usage",
        name: "hls-video-underflow"
      }), !0;
    var f = findNextRange(u, n);
    if (f.length > 0) {
      var d = f.start(0) - n;
      return this.logger_("Stopped at " + n + ", setting timer for " + d + ", seeking " + ("to " + f.start(0))), this.cancelTimer_(), this.timer_ = setTimeout(this.skipTheGap_.bind(this), d * 1e3, n), !0;
    }
    return !1;
  }, e.afterSeekableWindow_ = function(a, n, s, o) {
    if (o === void 0 && (o = !1), !a.length)
      return !1;
    var u = a.end(a.length - 1) + SAFE_TIME_DELTA, l = !s.endList;
    return l && o && (u = a.end(a.length - 1) + s.targetDuration * 3), n > u;
  }, e.beforeSeekableWindow_ = function(a, n) {
    return !!(a.length && a.start(0) > 0 && n < a.start(0) - this.liveRangeSafeTimeDelta);
  }, e.videoUnderflow_ = function(a) {
    var n = a.videoBuffered, s = a.audioBuffered, o = a.currentTime;
    if (!!n) {
      var u;
      if (n.length && s.length) {
        var l = findRange(n, o - 3), f = findRange(n, o), d = findRange(s, o);
        d.length && !f.length && l.length && (u = {
          start: l.end(0),
          end: d.end(0)
        });
      } else {
        var h = findNextRange(n, o);
        h.length || (u = this.gapFromVideoUnderflow_(n, o));
      }
      return u ? (this.logger_("Encountered a gap in video from " + u.start + " to " + u.end + ". " + ("Seeking to current time " + o)), !0) : !1;
    }
  }, e.skipTheGap_ = function(a) {
    var n = this.tech_.buffered(), s = this.tech_.currentTime(), o = findNextRange(n, s);
    this.cancelTimer_(), !(o.length === 0 || s !== a) && (this.logger_("skipTheGap_:", "currentTime:", s, "scheduled currentTime:", a, "nextRange start:", o.start(0)), this.tech_.setCurrentTime(o.start(0) + TIME_FUDGE_FACTOR), this.tech_.trigger({
      type: "usage",
      name: "vhs-gap-skip"
    }), this.tech_.trigger({
      type: "usage",
      name: "hls-gap-skip"
    }));
  }, e.gapFromVideoUnderflow_ = function(a, n) {
    for (var s = findGaps(a), o = 0; o < s.length; o++) {
      var u = s.start(o), l = s.end(o);
      if (n - u < 4 && n - u > 2)
        return {
          start: u,
          end: l
        };
    }
    return null;
  }, r;
}(), defaultOptions = {
  errorInterval: 30,
  getSource: function r(e) {
    var t = this.tech({
      IWillNotUseThisInPlugins: !0
    }), a = t.currentSource_ || this.currentSource();
    return e(a);
  }
}, initPlugin$1 = function r(e, t) {
  var a = 0, n = 0, s = videojs.mergeOptions(defaultOptions, t);
  e.ready(function() {
    e.trigger({
      type: "usage",
      name: "vhs-error-reload-initialized"
    }), e.trigger({
      type: "usage",
      name: "hls-error-reload-initialized"
    });
  });
  var o = function() {
    n && e.currentTime(n);
  }, u = function(p) {
    p != null && (n = e.duration() !== 1 / 0 && e.currentTime() || 0, e.one("loadedmetadata", o), e.src(p), e.trigger({
      type: "usage",
      name: "vhs-error-reload"
    }), e.trigger({
      type: "usage",
      name: "hls-error-reload"
    }), e.play());
  }, l = function() {
    if (Date.now() - a < s.errorInterval * 1e3) {
      e.trigger({
        type: "usage",
        name: "vhs-error-reload-canceled"
      }), e.trigger({
        type: "usage",
        name: "hls-error-reload-canceled"
      });
      return;
    }
    if (!s.getSource || typeof s.getSource != "function") {
      videojs.log.error("ERROR: reloadSourceOnError - The option getSource must be a function!");
      return;
    }
    return a = Date.now(), s.getSource.call(e, u);
  }, f = function h() {
    e.off("loadedmetadata", o), e.off("error", l), e.off("dispose", h);
  }, d = function(p) {
    f(), r(e, p);
  };
  e.on("error", l), e.on("dispose", f), e.reloadSourceOnError = d;
}, reloadSourceOnError = function r(e) {
  initPlugin$1(this, e);
}, version$4 = "2.14.2", version$3 = "6.0.1", version$2 = "0.21.1", version$1 = "4.7.1", version$6 = "3.1.3", Vhs = {
  PlaylistLoader,
  Playlist,
  utils,
  STANDARD_PLAYLIST_SELECTOR: lastBandwidthSelector,
  INITIAL_PLAYLIST_SELECTOR: lowestBitrateCompatibleVariantSelector,
  lastBandwidthSelector,
  movingAverageBandwidthSelector,
  comparePlaylistBandwidth,
  comparePlaylistResolution,
  xhr: xhrFactory()
};
Object.keys(Config).forEach(function(r) {
  Object.defineProperty(Vhs, r, {
    get: function() {
      return videojs.log.warn("using Vhs." + r + " is UNSAFE be sure you know what you are doing"), Config[r];
    },
    set: function(t) {
      if (videojs.log.warn("using Vhs." + r + " is UNSAFE be sure you know what you are doing"), typeof t != "number" || t < 0) {
        videojs.log.warn("value of Vhs." + r + " must be greater than or equal to 0");
        return;
      }
      Config[r] = t;
    }
  });
});
var LOCAL_STORAGE_KEY = "videojs-vhs", handleVhsMediaChange = function r(e, t) {
  for (var a = t.media(), n = -1, s = 0; s < e.length; s++)
    if (e[s].id === a.id) {
      n = s;
      break;
    }
  e.selectedIndex_ = n, e.trigger({
    selectedIndex: n,
    type: "change"
  });
}, handleVhsLoadedMetadata = function r(e, t) {
  t.representations().forEach(function(a) {
    e.addQualityLevel(a);
  }), handleVhsMediaChange(e, t.playlists);
};
Vhs.canPlaySource = function() {
  return videojs.log.warn("HLS is no longer a tech. Please remove it from your player's techOrder.");
};
var emeKeySystems = function r(e, t, a) {
  if (!e)
    return e;
  var n = {};
  t && t.attributes && t.attributes.CODECS && (n = unwrapCodecList(parseCodecs(t.attributes.CODECS))), a && a.attributes && a.attributes.CODECS && (n.audio = a.attributes.CODECS);
  var s = getMimeForCodec(n.video), o = getMimeForCodec(n.audio), u = {};
  for (var l in e)
    u[l] = {}, o && (u[l].audioContentType = o), s && (u[l].videoContentType = s), t.contentProtection && t.contentProtection[l] && t.contentProtection[l].pssh && (u[l].pssh = t.contentProtection[l].pssh), typeof e[l] == "string" && (u[l].url = e[l]);
  return videojs.mergeOptions(e, u);
}, getAllPsshKeySystemsOptions = function r(e, t) {
  return e.reduce(function(a, n) {
    if (!n.contentProtection)
      return a;
    var s = t.reduce(function(o, u) {
      var l = n.contentProtection[u];
      return l && l.pssh && (o[u] = {
        pssh: l.pssh
      }), o;
    }, {});
    return Object.keys(s).length && a.push(s), a;
  }, []);
}, waitForKeySessionCreation = function r(e) {
  var t = e.player, a = e.sourceKeySystems, n = e.audioMedia, s = e.mainPlaylists;
  if (!t.eme.initializeMediaKeys)
    return Promise.resolve();
  var o = n ? s.concat([n]) : s, u = getAllPsshKeySystemsOptions(o, Object.keys(a)), l = [], f = [];
  return u.forEach(function(d) {
    f.push(new Promise(function(h, p) {
      t.tech_.one("keysessioncreated", h);
    })), l.push(new Promise(function(h, p) {
      t.eme.initializeMediaKeys({
        keySystems: d
      }, function(m) {
        if (m) {
          p(m);
          return;
        }
        h();
      });
    }));
  }), Promise.race([
    Promise.all(l),
    Promise.race(f)
  ]);
}, setupEmeOptions = function r(e) {
  var t = e.player, a = e.sourceKeySystems, n = e.media, s = e.audioMedia, o = emeKeySystems(a, n, s);
  return o ? (t.currentSource().keySystems = o, o && !t.eme ? (videojs.log.warn("DRM encrypted source cannot be decrypted without a DRM plugin"), !1) : !0) : !1;
}, getVhsLocalStorage = function r() {
  if (!window_1.localStorage)
    return null;
  var e = window_1.localStorage.getItem(LOCAL_STORAGE_KEY);
  if (!e)
    return null;
  try {
    return JSON.parse(e);
  } catch {
    return null;
  }
}, updateVhsLocalStorage = function r(e) {
  if (!window_1.localStorage)
    return !1;
  var t = getVhsLocalStorage();
  t = t ? videojs.mergeOptions(t, e) : e;
  try {
    window_1.localStorage.setItem(LOCAL_STORAGE_KEY, JSON.stringify(t));
  } catch {
    return !1;
  }
  return t;
}, expandDataUri = function r(e) {
  return e.toLowerCase().indexOf("data:application/vnd.videojs.vhs+json,") === 0 ? JSON.parse(e.substring(e.indexOf(",") + 1)) : e;
};
Vhs.supportsNativeHls = function() {
  if (!document_1 || !document_1.createElement)
    return !1;
  var r = document_1.createElement("video");
  if (!videojs.getTech("Html5").isSupported())
    return !1;
  var e = [
    "application/vnd.apple.mpegurl",
    "audio/mpegurl",
    "audio/x-mpegurl",
    "application/x-mpegurl",
    "video/x-mpegurl",
    "video/mpegurl",
    "application/mpegurl"
  ];
  return e.some(function(t) {
    return /maybe|probably/i.test(r.canPlayType(t));
  });
}();
Vhs.supportsNativeDash = function() {
  return !document_1 || !document_1.createElement || !videojs.getTech("Html5").isSupported() ? !1 : /maybe|probably/i.test(document_1.createElement("video").canPlayType("application/dash+xml"));
}();
Vhs.supportsTypeNatively = function(r) {
  return r === "hls" ? Vhs.supportsNativeHls : r === "dash" ? Vhs.supportsNativeDash : !1;
};
Vhs.isSupported = function() {
  return videojs.log.warn("HLS is no longer a tech. Please remove it from your player's techOrder.");
};
var Component = videojs.getComponent("Component"), VhsHandler = /* @__PURE__ */ function(r) {
  _inheritsLoose$1(e, r);
  function e(a, n, s) {
    var o;
    if (o = r.call(this, n, videojs.mergeOptions(s.hls, s.vhs)) || this, s.hls && Object.keys(s.hls).length && videojs.log.warn("Using hls options is deprecated. Please rename `hls` to `vhs` in your options object."), typeof s.initialBandwidth == "number" && (o.options_.bandwidth = s.initialBandwidth), o.logger_ = logger("VhsHandler"), n.options_ && n.options_.playerId) {
      var u = videojs(n.options_.playerId);
      u.hasOwnProperty("hls") || Object.defineProperty(u, "hls", {
        get: function() {
          return videojs.log.warn("player.hls is deprecated. Use player.tech().vhs instead."), n.trigger({
            type: "usage",
            name: "hls-player-access"
          }), _assertThisInitialized$1(o);
        },
        configurable: !0
      }), u.hasOwnProperty("vhs") || Object.defineProperty(u, "vhs", {
        get: function() {
          return videojs.log.warn("player.vhs is deprecated. Use player.tech().vhs instead."), n.trigger({
            type: "usage",
            name: "vhs-player-access"
          }), _assertThisInitialized$1(o);
        },
        configurable: !0
      }), u.hasOwnProperty("dash") || Object.defineProperty(u, "dash", {
        get: function() {
          return videojs.log.warn("player.dash is deprecated. Use player.tech().vhs instead."), _assertThisInitialized$1(o);
        },
        configurable: !0
      }), o.player_ = u;
    }
    if (o.tech_ = n, o.source_ = a, o.stats = {}, o.ignoreNextSeekingEvent_ = !1, o.setOptions_(), o.options_.overrideNative && n.overrideNativeAudioTracks && n.overrideNativeVideoTracks)
      n.overrideNativeAudioTracks(!0), n.overrideNativeVideoTracks(!0);
    else if (o.options_.overrideNative && (n.featuresNativeVideoTracks || n.featuresNativeAudioTracks))
      throw new Error("Overriding native HLS requires emulated tracks. See https://git.io/vMpjB");
    return o.on(document_1, ["fullscreenchange", "webkitfullscreenchange", "mozfullscreenchange", "MSFullscreenChange"], function(l) {
      var f = document_1.fullscreenElement || document_1.webkitFullscreenElement || document_1.mozFullScreenElement || document_1.msFullscreenElement;
      f && f.contains(o.tech_.el()) ? o.masterPlaylistController_.fastQualityChange_() : o.masterPlaylistController_.checkABR_();
    }), o.on(o.tech_, "seeking", function() {
      if (this.ignoreNextSeekingEvent_) {
        this.ignoreNextSeekingEvent_ = !1;
        return;
      }
      this.setCurrentTime(this.tech_.currentTime());
    }), o.on(o.tech_, "error", function() {
      this.tech_.error() && this.masterPlaylistController_ && this.masterPlaylistController_.pauseLoading();
    }), o.on(o.tech_, "play", o.play), o;
  }
  var t = e.prototype;
  return t.setOptions_ = function() {
    var n = this;
    if (this.options_.withCredentials = this.options_.withCredentials || !1, this.options_.handleManifestRedirects = this.options_.handleManifestRedirects !== !1, this.options_.limitRenditionByPlayerDimensions = this.options_.limitRenditionByPlayerDimensions !== !1, this.options_.useDevicePixelRatio = this.options_.useDevicePixelRatio || !1, this.options_.smoothQualityChange = this.options_.smoothQualityChange || !1, this.options_.useBandwidthFromLocalStorage = typeof this.source_.useBandwidthFromLocalStorage < "u" ? this.source_.useBandwidthFromLocalStorage : this.options_.useBandwidthFromLocalStorage || !1, this.options_.useNetworkInformationApi = this.options_.useNetworkInformationApi || !1, this.options_.useDtsForTimestampOffset = this.options_.useDtsForTimestampOffset || !1, this.options_.customTagParsers = this.options_.customTagParsers || [], this.options_.customTagMappers = this.options_.customTagMappers || [], this.options_.cacheEncryptionKeys = this.options_.cacheEncryptionKeys || !1, typeof this.options_.blacklistDuration != "number" && (this.options_.blacklistDuration = 5 * 60), typeof this.options_.bandwidth != "number" && this.options_.useBandwidthFromLocalStorage) {
      var s = getVhsLocalStorage();
      s && s.bandwidth && (this.options_.bandwidth = s.bandwidth, this.tech_.trigger({
        type: "usage",
        name: "vhs-bandwidth-from-local-storage"
      }), this.tech_.trigger({
        type: "usage",
        name: "hls-bandwidth-from-local-storage"
      })), s && s.throughput && (this.options_.throughput = s.throughput, this.tech_.trigger({
        type: "usage",
        name: "vhs-throughput-from-local-storage"
      }), this.tech_.trigger({
        type: "usage",
        name: "hls-throughput-from-local-storage"
      }));
    }
    typeof this.options_.bandwidth != "number" && (this.options_.bandwidth = Config.INITIAL_BANDWIDTH), this.options_.enableLowInitialPlaylist = this.options_.enableLowInitialPlaylist && this.options_.bandwidth === Config.INITIAL_BANDWIDTH, ["withCredentials", "useDevicePixelRatio", "limitRenditionByPlayerDimensions", "bandwidth", "smoothQualityChange", "customTagParsers", "customTagMappers", "handleManifestRedirects", "cacheEncryptionKeys", "playlistSelector", "initialPlaylistSelector", "experimentalBufferBasedABR", "liveRangeSafeTimeDelta", "experimentalLLHLS", "useNetworkInformationApi", "useDtsForTimestampOffset", "experimentalExactManifestTimings", "experimentalLeastPixelDiffSelector"].forEach(function(o) {
      typeof n.source_[o] < "u" && (n.options_[o] = n.source_[o]);
    }), this.limitRenditionByPlayerDimensions = this.options_.limitRenditionByPlayerDimensions, this.useDevicePixelRatio = this.options_.useDevicePixelRatio;
  }, t.src = function(n, s) {
    var o = this;
    if (!!n) {
      this.setOptions_(), this.options_.src = expandDataUri(this.source_.src), this.options_.tech = this.tech_, this.options_.externVhs = Vhs, this.options_.sourceType = simpleTypeFromSourceType(s), this.options_.seekTo = function(f) {
        o.tech_.setCurrentTime(f);
      }, this.options_.smoothQualityChange && videojs.log.warn("smoothQualityChange is deprecated and will be removed in the next major version"), this.masterPlaylistController_ = new MasterPlaylistController(this.options_);
      var u = videojs.mergeOptions({
        liveRangeSafeTimeDelta: SAFE_TIME_DELTA
      }, this.options_, {
        seekable: function() {
          return o.seekable();
        },
        media: function() {
          return o.masterPlaylistController_.media();
        },
        masterPlaylistController: this.masterPlaylistController_
      });
      this.playbackWatcher_ = new PlaybackWatcher(u), this.masterPlaylistController_.on("error", function() {
        var f = videojs.players[o.tech_.options_.playerId], d = o.masterPlaylistController_.error;
        typeof d == "object" && !d.code ? d.code = 3 : typeof d == "string" && (d = {
          message: d,
          code: 3
        }), f.error(d);
      });
      var l = this.options_.experimentalBufferBasedABR ? Vhs.movingAverageBandwidthSelector(0.55) : Vhs.STANDARD_PLAYLIST_SELECTOR;
      this.masterPlaylistController_.selectPlaylist = this.selectPlaylist ? this.selectPlaylist.bind(this) : l.bind(this), this.masterPlaylistController_.selectInitialPlaylist = Vhs.INITIAL_PLAYLIST_SELECTOR.bind(this), this.playlists = this.masterPlaylistController_.masterPlaylistLoader_, this.mediaSource = this.masterPlaylistController_.mediaSource, Object.defineProperties(this, {
        selectPlaylist: {
          get: function() {
            return this.masterPlaylistController_.selectPlaylist;
          },
          set: function(d) {
            this.masterPlaylistController_.selectPlaylist = d.bind(this);
          }
        },
        throughput: {
          get: function() {
            return this.masterPlaylistController_.mainSegmentLoader_.throughput.rate;
          },
          set: function(d) {
            this.masterPlaylistController_.mainSegmentLoader_.throughput.rate = d, this.masterPlaylistController_.mainSegmentLoader_.throughput.count = 1;
          }
        },
        bandwidth: {
          get: function() {
            var d = this.masterPlaylistController_.mainSegmentLoader_.bandwidth, h = window_1.navigator.connection || window_1.navigator.mozConnection || window_1.navigator.webkitConnection, p = 1e7;
            if (this.options_.useNetworkInformationApi && h) {
              var m = h.downlink * 1e3 * 1e3;
              m >= p && d >= p ? d = Math.max(d, m) : d = m;
            }
            return d;
          },
          set: function(d) {
            this.masterPlaylistController_.mainSegmentLoader_.bandwidth = d, this.masterPlaylistController_.mainSegmentLoader_.throughput = {
              rate: 0,
              count: 0
            };
          }
        },
        systemBandwidth: {
          get: function() {
            var d = 1 / (this.bandwidth || 1), h;
            this.throughput > 0 ? h = 1 / this.throughput : h = 0;
            var p = Math.floor(1 / (d + h));
            return p;
          },
          set: function() {
            videojs.log.error('The "systemBandwidth" property is read-only');
          }
        }
      }), this.options_.bandwidth && (this.bandwidth = this.options_.bandwidth), this.options_.throughput && (this.throughput = this.options_.throughput), Object.defineProperties(this.stats, {
        bandwidth: {
          get: function() {
            return o.bandwidth || 0;
          },
          enumerable: !0
        },
        mediaRequests: {
          get: function() {
            return o.masterPlaylistController_.mediaRequests_() || 0;
          },
          enumerable: !0
        },
        mediaRequestsAborted: {
          get: function() {
            return o.masterPlaylistController_.mediaRequestsAborted_() || 0;
          },
          enumerable: !0
        },
        mediaRequestsTimedout: {
          get: function() {
            return o.masterPlaylistController_.mediaRequestsTimedout_() || 0;
          },
          enumerable: !0
        },
        mediaRequestsErrored: {
          get: function() {
            return o.masterPlaylistController_.mediaRequestsErrored_() || 0;
          },
          enumerable: !0
        },
        mediaTransferDuration: {
          get: function() {
            return o.masterPlaylistController_.mediaTransferDuration_() || 0;
          },
          enumerable: !0
        },
        mediaBytesTransferred: {
          get: function() {
            return o.masterPlaylistController_.mediaBytesTransferred_() || 0;
          },
          enumerable: !0
        },
        mediaSecondsLoaded: {
          get: function() {
            return o.masterPlaylistController_.mediaSecondsLoaded_() || 0;
          },
          enumerable: !0
        },
        mediaAppends: {
          get: function() {
            return o.masterPlaylistController_.mediaAppends_() || 0;
          },
          enumerable: !0
        },
        mainAppendsToLoadedData: {
          get: function() {
            return o.masterPlaylistController_.mainAppendsToLoadedData_() || 0;
          },
          enumerable: !0
        },
        audioAppendsToLoadedData: {
          get: function() {
            return o.masterPlaylistController_.audioAppendsToLoadedData_() || 0;
          },
          enumerable: !0
        },
        appendsToLoadedData: {
          get: function() {
            return o.masterPlaylistController_.appendsToLoadedData_() || 0;
          },
          enumerable: !0
        },
        timeToLoadedData: {
          get: function() {
            return o.masterPlaylistController_.timeToLoadedData_() || 0;
          },
          enumerable: !0
        },
        buffered: {
          get: function() {
            return timeRangesToArray(o.tech_.buffered());
          },
          enumerable: !0
        },
        currentTime: {
          get: function() {
            return o.tech_.currentTime();
          },
          enumerable: !0
        },
        currentSource: {
          get: function() {
            return o.tech_.currentSource_;
          },
          enumerable: !0
        },
        currentTech: {
          get: function() {
            return o.tech_.name_;
          },
          enumerable: !0
        },
        duration: {
          get: function() {
            return o.tech_.duration();
          },
          enumerable: !0
        },
        master: {
          get: function() {
            return o.playlists.master;
          },
          enumerable: !0
        },
        playerDimensions: {
          get: function() {
            return o.tech_.currentDimensions();
          },
          enumerable: !0
        },
        seekable: {
          get: function() {
            return timeRangesToArray(o.tech_.seekable());
          },
          enumerable: !0
        },
        timestamp: {
          get: function() {
            return Date.now();
          },
          enumerable: !0
        },
        videoPlaybackQuality: {
          get: function() {
            return o.tech_.getVideoPlaybackQuality();
          },
          enumerable: !0
        }
      }), this.tech_.one("canplay", this.masterPlaylistController_.setupFirstPlay.bind(this.masterPlaylistController_)), this.tech_.on("bandwidthupdate", function() {
        o.options_.useBandwidthFromLocalStorage && updateVhsLocalStorage({
          bandwidth: o.bandwidth,
          throughput: Math.round(o.throughput)
        });
      }), this.masterPlaylistController_.on("selectedinitialmedia", function() {
        renditionSelectionMixin(o);
      }), this.masterPlaylistController_.sourceUpdater_.on("createdsourcebuffers", function() {
        o.setupEme_();
      }), this.on(this.masterPlaylistController_, "progress", function() {
        this.tech_.trigger("progress");
      }), this.on(this.masterPlaylistController_, "firstplay", function() {
        this.ignoreNextSeekingEvent_ = !0;
      }), this.setupQualityLevels_(), this.tech_.el() && (this.mediaSourceUrl_ = window_1.URL.createObjectURL(this.masterPlaylistController_.mediaSource), this.tech_.src(this.mediaSourceUrl_));
    }
  }, t.createKeySessions_ = function() {
    var n = this, s = this.masterPlaylistController_.mediaTypes_.AUDIO.activePlaylistLoader;
    this.logger_("waiting for EME key session creation"), waitForKeySessionCreation({
      player: this.player_,
      sourceKeySystems: this.source_.keySystems,
      audioMedia: s && s.media(),
      mainPlaylists: this.playlists.master.playlists
    }).then(function() {
      n.logger_("created EME key session"), n.masterPlaylistController_.sourceUpdater_.initializedEme();
    }).catch(function(o) {
      n.logger_("error while creating EME key session", o), n.player_.error({
        message: "Failed to initialize media keys for EME",
        code: 3
      });
    });
  }, t.handleWaitingForKey_ = function() {
    this.logger_("waitingforkey fired, attempting to create any new key sessions"), this.createKeySessions_();
  }, t.setupEme_ = function() {
    var n = this, s = this.masterPlaylistController_.mediaTypes_.AUDIO.activePlaylistLoader, o = setupEmeOptions({
      player: this.player_,
      sourceKeySystems: this.source_.keySystems,
      media: this.playlists.media(),
      audioMedia: s && s.media()
    });
    if (this.player_.tech_.on("keystatuschange", function(u) {
      u.status === "output-restricted" && n.masterPlaylistController_.blacklistCurrentPlaylist({
        playlist: n.masterPlaylistController_.media(),
        message: "DRM keystatus changed to " + u.status + ". Playlist will fail to play. Check for HDCP content.",
        blacklistDuration: 1 / 0
      });
    }), this.handleWaitingForKey_ = this.handleWaitingForKey_.bind(this), this.player_.tech_.on("waitingforkey", this.handleWaitingForKey_), videojs.browser.IE_VERSION === 11 || !o) {
      this.masterPlaylistController_.sourceUpdater_.initializedEme();
      return;
    }
    this.createKeySessions_();
  }, t.setupQualityLevels_ = function() {
    var n = this, s = videojs.players[this.tech_.options_.playerId];
    !s || !s.qualityLevels || this.qualityLevels_ || (this.qualityLevels_ = s.qualityLevels(), this.masterPlaylistController_.on("selectedinitialmedia", function() {
      handleVhsLoadedMetadata(n.qualityLevels_, n);
    }), this.playlists.on("mediachange", function() {
      handleVhsMediaChange(n.qualityLevels_, n.playlists);
    }));
  }, e.version = function() {
    return {
      "@videojs/http-streaming": version$4,
      "mux.js": version$3,
      "mpd-parser": version$2,
      "m3u8-parser": version$1,
      "aes-decrypter": version$6
    };
  }, t.version = function() {
    return this.constructor.version();
  }, t.canChangeType = function() {
    return SourceUpdater.canChangeType();
  }, t.play = function() {
    this.masterPlaylistController_.play();
  }, t.setCurrentTime = function(n) {
    this.masterPlaylistController_.setCurrentTime(n);
  }, t.duration = function() {
    return this.masterPlaylistController_.duration();
  }, t.seekable = function() {
    return this.masterPlaylistController_.seekable();
  }, t.dispose = function() {
    this.playbackWatcher_ && this.playbackWatcher_.dispose(), this.masterPlaylistController_ && this.masterPlaylistController_.dispose(), this.qualityLevels_ && this.qualityLevels_.dispose(), this.player_ && (delete this.player_.vhs, delete this.player_.dash, delete this.player_.hls), this.tech_ && this.tech_.vhs && delete this.tech_.vhs, this.tech_ && delete this.tech_.hls, this.mediaSourceUrl_ && window_1.URL.revokeObjectURL && (window_1.URL.revokeObjectURL(this.mediaSourceUrl_), this.mediaSourceUrl_ = null), this.tech_ && this.tech_.off("waitingforkey", this.handleWaitingForKey_), r.prototype.dispose.call(this);
  }, t.convertToProgramTime = function(n, s) {
    return getProgramTime({
      playlist: this.masterPlaylistController_.media(),
      time: n,
      callback: s
    });
  }, t.seekToProgramTime = function(n, s, o, u) {
    return o === void 0 && (o = !0), u === void 0 && (u = 2), seekToProgramTime({
      programTime: n,
      playlist: this.masterPlaylistController_.media(),
      retryCount: u,
      pauseAfterSeek: o,
      seekTo: this.options_.seekTo,
      tech: this.options_.tech,
      callback: s
    });
  }, e;
}(Component), VhsSourceHandler = {
  name: "videojs-http-streaming",
  VERSION: version$4,
  canHandleSource: function r(e, t) {
    t === void 0 && (t = {});
    var a = videojs.mergeOptions(videojs.options, t);
    return VhsSourceHandler.canPlayType(e.type, a);
  },
  handleSource: function r(e, t, a) {
    a === void 0 && (a = {});
    var n = videojs.mergeOptions(videojs.options, a);
    return t.vhs = new VhsHandler(e, t, n), videojs.hasOwnProperty("hls") || Object.defineProperty(t, "hls", {
      get: function() {
        return videojs.log.warn("player.tech().hls is deprecated. Use player.tech().vhs instead."), t.vhs;
      },
      configurable: !0
    }), t.vhs.xhr = xhrFactory(), t.vhs.src(e.src, e.type), t.vhs;
  },
  canPlayType: function r(e, t) {
    t === void 0 && (t = {});
    var a = videojs.mergeOptions(videojs.options, t), n = a.vhs;
    n = n === void 0 ? {} : n;
    var s = n.overrideNative, o = s === void 0 ? !videojs.browser.IS_ANY_SAFARI : s, u = a.hls;
    u = u === void 0 ? {} : u;
    var l = u.overrideNative, f = l === void 0 ? !1 : l, d = simpleTypeFromSourceType(e), h = d && (!Vhs.supportsTypeNatively(d) || f || o);
    return h ? "maybe" : "";
  }
}, supportsNativeMediaSources = function r() {
  return browserSupportsCodec("avc1.4d400d,mp4a.40.2");
};
supportsNativeMediaSources() && videojs.getTech("Html5").registerSourceHandler(VhsSourceHandler, 0);
videojs.VhsHandler = VhsHandler;
Object.defineProperty(videojs, "HlsHandler", {
  get: function r() {
    return videojs.log.warn("videojs.HlsHandler is deprecated. Use videojs.VhsHandler instead."), VhsHandler;
  },
  configurable: !0
});
videojs.VhsSourceHandler = VhsSourceHandler;
Object.defineProperty(videojs, "HlsSourceHandler", {
  get: function r() {
    return videojs.log.warn("videojs.HlsSourceHandler is deprecated. Use videojs.VhsSourceHandler instead."), VhsSourceHandler;
  },
  configurable: !0
});
videojs.Vhs = Vhs;
Object.defineProperty(videojs, "Hls", {
  get: function r() {
    return videojs.log.warn("videojs.Hls is deprecated. Use videojs.Vhs instead."), Vhs;
  },
  configurable: !0
});
videojs.use || (videojs.registerComponent("Hls", Vhs), videojs.registerComponent("Vhs", Vhs));
videojs.options.vhs = videojs.options.vhs || {};
videojs.options.hls = videojs.options.hls || {};
if (!videojs.getPlugin || !videojs.getPlugin("reloadSourceOnError")) {
  var registerPlugin$1 = videojs.registerPlugin || videojs.plugin;
  registerPlugin$1("reloadSourceOnError", reloadSourceOnError);
}
const PLAYER_DEFAULT_OPTIONS = {
  errorInterval: 5e3,
  enableHighestQuality: !1
}, videoJs_min = "";
/*! @name videojs-contrib-quality-levels @version 2.1.0 @license Apache-2.0 */
function _inheritsLoose(r, e) {
  r.prototype = Object.create(e.prototype), r.prototype.constructor = r, r.__proto__ = e;
}
function _assertThisInitialized(r) {
  if (r === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return r;
}
var QualityLevel = function r(e) {
  var t = this;
  if (videojs.browser.IS_IE8) {
    t = document_1.createElement("custom");
    for (var a in r.prototype)
      a !== "constructor" && (t[a] = r.prototype[a]);
  }
  return t.id = e.id, t.label = t.id, t.width = e.width, t.height = e.height, t.bitrate = e.bandwidth, t.enabled_ = e.enabled, Object.defineProperty(t, "enabled", {
    get: function() {
      return t.enabled_();
    },
    set: function(s) {
      t.enabled_(s);
    }
  }), t;
}, QualityLevelList = /* @__PURE__ */ function(r) {
  _inheritsLoose(e, r);
  function e() {
    var a;
    a = r.call(this) || this;
    var n = _assertThisInitialized(_assertThisInitialized(a));
    if (videojs.browser.IS_IE8) {
      n = document_1.createElement("custom");
      for (var s in e.prototype)
        s !== "constructor" && (n[s] = e.prototype[s]);
    }
    return n.levels_ = [], n.selectedIndex_ = -1, Object.defineProperty(n, "selectedIndex", {
      get: function() {
        return n.selectedIndex_;
      }
    }), Object.defineProperty(n, "length", {
      get: function() {
        return n.levels_.length;
      }
    }), n || _assertThisInitialized(a);
  }
  var t = e.prototype;
  return t.addQualityLevel = function(n) {
    var s = this.getQualityLevelById(n.id);
    if (s)
      return s;
    var o = this.levels_.length;
    return s = new QualityLevel(n), "" + o in this || Object.defineProperty(this, o, {
      get: function() {
        return this.levels_[o];
      }
    }), this.levels_.push(s), this.trigger({
      qualityLevel: s,
      type: "addqualitylevel"
    }), s;
  }, t.removeQualityLevel = function(n) {
    for (var s = null, o = 0, u = this.length; o < u; o++)
      if (this[o] === n) {
        s = this.levels_.splice(o, 1)[0], this.selectedIndex_ === o ? this.selectedIndex_ = -1 : this.selectedIndex_ > o && this.selectedIndex_--;
        break;
      }
    return s && this.trigger({
      qualityLevel: n,
      type: "removequalitylevel"
    }), s;
  }, t.getQualityLevelById = function(n) {
    for (var s = 0, o = this.length; s < o; s++) {
      var u = this[s];
      if (u.id === n)
        return u;
    }
    return null;
  }, t.dispose = function() {
    this.selectedIndex_ = -1, this.levels_.length = 0;
  }, e;
}(videojs.EventTarget);
QualityLevelList.prototype.allowedEvents_ = {
  change: "change",
  addqualitylevel: "addqualitylevel",
  removequalitylevel: "removequalitylevel"
};
for (var event in QualityLevelList.prototype.allowedEvents_)
  QualityLevelList.prototype["on" + event] = null;
var version = "2.1.0", registerPlugin = videojs.registerPlugin || videojs.plugin, initPlugin = function r(e, t) {
  var a = e.qualityLevels, n = new QualityLevelList(), s = function o() {
    n.dispose(), e.qualityLevels = a, e.off("dispose", o);
  };
  return e.on("dispose", s), e.qualityLevels = function() {
    return n;
  }, e.qualityLevels.VERSION = version, n;
}, qualityLevels = function r(e) {
  return initPlugin(this, videojs.mergeOptions({}, e));
};
registerPlugin("qualityLevels", qualityLevels);
qualityLevels.VERSION = version;
class VideoJsPlayer extends EventEmitter {
  constructor(t, a, n) {
    super();
    t0(this, "player");
    t0(this, "intervalReload", null);
    t0(this, "options");
    t0(this, "qualityLevels");
    t0(this, "currentQualityLevel");
    t0(this, "playerOptions");
    t0(this, "playerState", {
      isPlaying: !1,
      isPaused: !1,
      isMuted: !1,
      isWaiting: !1,
      isLive: !1,
      volume: 0,
      aspectRatio: 0
    });
    this.options = {
      autoplay: !0,
      muted: !0,
      preload: "auto",
      controls: !0,
      liveui: !0,
      bigPlayButton: !1,
      ...a,
      controlBar: {
        volumePanel: !1,
        playToggle: !0,
        captionsButton: !1,
        chaptersButton: !1,
        subtitlesButton: !1,
        remainingTimeDisplay: !1,
        progressControl: {
          seekBar: !0
        },
        fullscreenToggle: !1,
        playbackRateMenuButton: !1,
        pictureInPictureToggle: !1,
        ...a == null ? void 0 : a.controlBar
      },
      html5: {
        vhs: {
          overrideNative: !videojs.browser.IS_SAFARI
        },
        nativeAudioTracks: !1,
        nativeVideoTracks: !1,
        nativeTextTracks: !1,
        ...a == null ? void 0 : a.html5
      }
    }, this.playerOptions = {
      ...PLAYER_DEFAULT_OPTIONS,
      ...n
    }, this.player = videojs(t, a), this.qualityLevels = this.player.qualityLevels(), this.handleVideoJsEvents(), this.playerOptions.enableHighestQuality && this.playHighestQuality();
  }
  load(t) {
    this.player.src(t || this.options.src), this.player.load();
  }
  getQualities() {
    return this.qualityLevels;
  }
  getQuality() {
    return this.currentQualityLevel;
  }
  setQuality(t) {
    for (var a = 0; a < this.qualityLevels.length; a++) {
      let n = this.qualityLevels[a];
      n.height === t.height && n.width === t.width ? (n.enabled = !0, this.currentQualityLevel = { ...n }) : n.enabled = !1;
    }
  }
  setPlayerState(t) {
    this.playerState = {
      ...this.playerState,
      ...t
    }, this.emit(PlayerEventType.STATE_CHANGED, { ...this.playerState });
  }
  setVolume(t) {
    this.player.volume(t);
  }
  setMuted(t) {
    this.player.muted(t);
  }
  pause() {
    this.player.pause();
  }
  async play() {
    await this.player.play();
  }
  seekTo(t) {
    this.player.currentTime(t);
  }
  createIntervalReload() {
    var t;
    this.intervalReload || (this.intervalReload = setInterval(() => {
      this.player.src(this.options.src), this.player.load(), this.player.play();
    }, ((t = this.playerOptions) == null ? void 0 : t.errorInterval) * 1e3));
  }
  clearIntervalReload() {
    clearInterval(this.intervalReload), this.intervalReload = null;
  }
  playHighestQuality() {
    var a;
    for (var t = 0; t < this.qualityLevels.length; t++) {
      let n = this.qualityLevels[t];
      n.height >= ((a = this.currentQualityLevel) == null ? void 0 : a.height) ? (n.enabled = !0, this.currentQualityLevel = { ...n }) : n.enabled = !1;
    }
  }
  handleVideoJsEvents() {
    var a, n;
    (a = this.qualityLevels) == null || a.on("addqualitylevel", (s) => {
      this.currentQualityLevel || (this.currentQualityLevel = { ...s.qualityLevel }), this.playHighestQuality();
    }), (n = this.qualityLevels) == null || n.on("change", () => {
      const s = this.qualityLevels[this.qualityLevels.selectedIndex];
      s && (this.currentQualityLevel = { ...s }, this.emit(PlayerEventType.QUALITY_CHANGED, this.currentQualityLevel));
    });
    let t = !1;
    this.player.one("canplay", () => {
      this.options.autoplay || this.player.pause(), this.setPlayerState({
        isWaiting: !1,
        isPaused: this.player.paused(),
        isMuted: this.player.muted(),
        volume: this.player.volume()
      }), t || (t = !0, this.setPlayerState({
        isLive: this.player.duration() === 1 / 0
      })), this.emit(PlayerEventType.DURATION_CHANGED, this.player.duration()), this.emit(PlayerEventType.CAN_PLAY);
    }), this.player.one("loadeddata", () => {
      this.playerState.aspectRatio || (this.setPlayerState({
        aspectRatio: this.player.videoWidth() / this.player.videoHeight()
      }), this.emit(PlayerEventType.LOADED));
    }), this.player.on("ready", () => {
      this.player.addClass("vjs-waiting"), this.player.pause(), this.player.src(this.options.src), this.options.autoplay && (this.player.load(), this.player.play()), this.emit(PlayerEventType.READY);
    }), this.player.one("playing", () => {
      this.player.muted() && this.options.autoplay && (this.player.muted(!1), this.player.paused() && (this.player.muted(!0), this.player.play())), this.setPlayerState({
        isMuted: this.player.muted()
      });
    }), this.player.on("playing", () => {
      this.clearIntervalReload(), this.setPlayerState({
        isPaused: this.player.paused(),
        isWaiting: !1,
        isPlaying: !0
      });
    }), this.player.on("waiting", () => {
      this.setPlayerState({
        isWaiting: !0
      });
    }), this.player.on("pause", () => {
      this.setPlayerState({
        isPlaying: !1
      }), setTimeout(() => {
        (!this.playerState.isWaiting || !this.playerState.isPlaying) && this.setPlayerState({
          isPaused: this.player.paused()
        });
      }, 100);
    }), this.player.on("volumechange", () => {
      this.player.muted() !== this.playerState.isMuted && this.setPlayerState({
        isMuted: this.player.muted()
      }), this.setPlayerState({
        volume: this.player.volume()
      });
    }), this.player.on("timeupdate", () => {
      let s = this.player.currentTime();
      this.emit(PlayerEventType.TIME_UPDATE, s);
    }), this.player.on("error", () => {
      const s = this.player.error();
      console.log("Internal player error: ", s), this.handleVideoError();
    }), this.player.reloadSourceOnError({
      getSource: (s) => {
        s({
          src: this.player.currentSrc()
        });
      },
      errorInterval: this.playerOptions.errorInterval
    }), this.player.on("ended", () => {
      this.playerState.isLive ? (this.clearIntervalReload(), this.handleVideoError()) : this.emit(PlayerEventType.ENDED);
    });
  }
  handleVideoError() {
    this.setPlayerState({
      isWaiting: !0
    }), this.createIntervalReload();
  }
  destroy() {
    this.player.dispose(), this.removeAllListeners();
  }
}
export {
  AgoraRtmClient,
  PlayerEventType,
  RtmChannelEventType,
  RtmClientEventType,
  RtmEventType,
  VideoJsPlayer
};
